/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(ie){for(var t=[],A=0,P=ie.length;A<P;A++)t[A]=be[ie[A]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ut,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Ct,construct:Pt}=typeof Reflect<"u"&&Reflect;Ct||(Ct=function(t,A,P){return t.apply(A,P)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Pt||(Pt=function(t,A){return new t(...A)});const oi=ct(Array.prototype.forEach),jt=ct(Array.prototype.pop),$t=ct(Array.prototype.push),yt=ct(String.prototype.toLowerCase),Tt=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),pt=ui(TypeError);function ct(ie){return function(t){for(var A=arguments.length,P=new Array(A>1?A-1:0),s=1;s<A;s++)P[s-1]=arguments[s];return Ct(ie,t,P)}}function ui(ie){return function(){for(var t=arguments.length,A=new Array(t),P=0;P<t;P++)A[P]=arguments[P];return Pt(ie,A)}}function He(ie,t,A){var P;A=(P=A)!==null&&P!==void 0?P:yt,Ut&&Ut(ie,null);let s=t.length;for(;s--;){let U=t[s];if(typeof U=="string"){const E=A(U);E!==U&&(ii(t)||(t[s]=E),U=E)}ie[U]=!0}return ie}function mt(ie){const t=ri(null);for(const[A,P]of zt(ie))t[A]=P;return t}function Et(ie,t){for(;ie!==null;){const P=si(ie,t);if(P){if(P.get)return ct(P.get);if(typeof P.value=="function")return ct(P.value)}ie=ni(ie)}function A(P){return console.warn("fallback value for",P),null}return A}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Qt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),_t=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:_t});const vi=()=>typeof window>"u"?null:window,Di=function(t,A){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let P=null;const s="data-tt-policy-suffix";A&&A.hasAttribute(s)&&(P=A.getAttribute(s));const U="dompurify"+(P?"#"+P:"");try{return t.createPolicy(U,{createHTML(E){return E},createScriptURL(E){return E}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function xt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=ze=>xt(ze);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const A=ie.document,P=A.currentScript;let{document:s}=ie;const{DocumentFragment:U,HTMLTemplateElement:E,Node:k,Element:b,NodeFilter:w,NamedNodeMap:y=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:I,DOMParser:o,trustedTypes:a}=ie,e=b.prototype,r=Et(e,"cloneNode"),d=Et(e,"nextSibling"),$=Et(e,"childNodes"),u=Et(e,"parentNode");if(typeof E=="function"){const ze=s.createElement("template");ze.content&&ze.content.ownerDocument&&(s=ze.content.ownerDocument)}let p,c="";const{implementation:f,createNodeIterator:h,createDocumentFragment:F,getElementsByTagName:M}=s,{importNode:R}=A;let O={};t.isSupported=typeof zt=="function"&&typeof u=="function"&&f&&f.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:C,TMPLIT_EXPR:q,DATA_ATTR:j,ARIA_ATTR:N,IS_SCRIPT_OR_DATA:L,ATTR_WHITESPACE:B}=Kt;let{IS_ALLOWED_URI:Y}=Kt,X=null;const de=He({},[...Ht,...Rt,...Lt,...It,...Wt]);let oe=null;const ee=He({},[...qt,...Mt,...Vt,...At]);let me=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Te=null,Ne=null,Me=!0,re=!0,J=!1,le=!0,K=!1,W=!1,Z=!1,ce=!1,we=!1,Ae=!1,ke=!1,Le=!0,_=!1;const g="user-content-";let m=!0,i=!1,n={},l=null;const D=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let S=null;const z=He({},["audio","video","img","source","image","track"]);let T=null;const H=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),G="http://www.w3.org/1998/Math/MathML",ne="http://www.w3.org/2000/svg",he="http://www.w3.org/1999/xhtml";let ve=he,$e=!1,ue=null;const Fe=He({},[G,ne,he],Tt);let ye;const Oe=["application/xhtml+xml","text/html"],Be="text/html";let Ie,Je=null;const et=s.createElement("form"),Qe=function(ae){return ae instanceof RegExp||ae instanceof Function},x=function(ae){if(!(Je&&Je===ae)){if((!ae||typeof ae!="object")&&(ae={}),ae=mt(ae),ye=Oe.indexOf(ae.PARSER_MEDIA_TYPE)===-1?ye=Be:ye=ae.PARSER_MEDIA_TYPE,Ie=ye==="application/xhtml+xml"?Tt:yt,X="ALLOWED_TAGS"in ae?He({},ae.ALLOWED_TAGS,Ie):de,oe="ALLOWED_ATTR"in ae?He({},ae.ALLOWED_ATTR,Ie):ee,ue="ALLOWED_NAMESPACES"in ae?He({},ae.ALLOWED_NAMESPACES,Tt):Fe,T="ADD_URI_SAFE_ATTR"in ae?He(mt(H),ae.ADD_URI_SAFE_ATTR,Ie):H,S="ADD_DATA_URI_TAGS"in ae?He(mt(z),ae.ADD_DATA_URI_TAGS,Ie):z,l="FORBID_CONTENTS"in ae?He({},ae.FORBID_CONTENTS,Ie):D,Te="FORBID_TAGS"in ae?He({},ae.FORBID_TAGS,Ie):{},Ne="FORBID_ATTR"in ae?He({},ae.FORBID_ATTR,Ie):{},n="USE_PROFILES"in ae?ae.USE_PROFILES:!1,Me=ae.ALLOW_ARIA_ATTR!==!1,re=ae.ALLOW_DATA_ATTR!==!1,J=ae.ALLOW_UNKNOWN_PROTOCOLS||!1,le=ae.ALLOW_SELF_CLOSE_IN_ATTR!==!1,K=ae.SAFE_FOR_TEMPLATES||!1,W=ae.WHOLE_DOCUMENT||!1,we=ae.RETURN_DOM||!1,Ae=ae.RETURN_DOM_FRAGMENT||!1,ke=ae.RETURN_TRUSTED_TYPE||!1,ce=ae.FORCE_BODY||!1,Le=ae.SANITIZE_DOM!==!1,_=ae.SANITIZE_NAMED_PROPS||!1,m=ae.KEEP_CONTENT!==!1,i=ae.IN_PLACE||!1,Y=ae.ALLOWED_URI_REGEXP||Qt,ve=ae.NAMESPACE||he,me=ae.CUSTOM_ELEMENT_HANDLING||{},ae.CUSTOM_ELEMENT_HANDLING&&Qe(ae.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(me.tagNameCheck=ae.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ae.CUSTOM_ELEMENT_HANDLING&&Qe(ae.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(me.attributeNameCheck=ae.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ae.CUSTOM_ELEMENT_HANDLING&&typeof ae.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(me.allowCustomizedBuiltInElements=ae.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),K&&(re=!1),Ae&&(we=!0),n&&(X=He({},[...Wt]),oe=[],n.html===!0&&(He(X,Ht),He(oe,qt)),n.svg===!0&&(He(X,Rt),He(oe,Mt),He(oe,At)),n.svgFilters===!0&&(He(X,Lt),He(oe,Mt),He(oe,At)),n.mathMl===!0&&(He(X,It),He(oe,Vt),He(oe,At))),ae.ADD_TAGS&&(X===de&&(X=mt(X)),He(X,ae.ADD_TAGS,Ie)),ae.ADD_ATTR&&(oe===ee&&(oe=mt(oe)),He(oe,ae.ADD_ATTR,Ie)),ae.ADD_URI_SAFE_ATTR&&He(T,ae.ADD_URI_SAFE_ATTR,Ie),ae.FORBID_CONTENTS&&(l===D&&(l=mt(l)),He(l,ae.FORBID_CONTENTS,Ie)),m&&(X["#text"]=!0),W&&He(X,["html","head","body"]),X.table&&(He(X,["tbody"]),delete Te.tbody),ae.TRUSTED_TYPES_POLICY){if(typeof ae.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ae.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');p=ae.TRUSTED_TYPES_POLICY,c=p.createHTML("")}else p===void 0&&(p=Di(a,P)),p!==null&&typeof c=="string"&&(c=p.createHTML(""));ot&&ot(ae),Je=ae}},se=He({},["mi","mo","mn","ms","mtext"]),ge=He({},["foreignobject","desc","title","annotation-xml"]),Ee=He({},["title","style","font","a","script"]),Ce=He({},Rt);He(Ce,Lt),He(Ce,ci);const Ue=He({},It);He(Ue,fi);const qe=function(ae){let Se=u(ae);(!Se||!Se.tagName)&&(Se={namespaceURI:ve,tagName:"template"});const Pe=yt(ae.tagName),We=yt(Se.tagName);return ue[ae.namespaceURI]?ae.namespaceURI===ne?Se.namespaceURI===he?Pe==="svg":Se.namespaceURI===G?Pe==="svg"&&(We==="annotation-xml"||se[We]):!!Ce[Pe]:ae.namespaceURI===G?Se.namespaceURI===he?Pe==="math":Se.namespaceURI===ne?Pe==="math"&&ge[We]:!!Ue[Pe]:ae.namespaceURI===he?Se.namespaceURI===ne&&!ge[We]||Se.namespaceURI===G&&!se[We]?!1:!Ue[Pe]&&(Ee[Pe]||!Ce[Pe]):!!(ye==="application/xhtml+xml"&&ue[ae.namespaceURI]):!1},_e=function(ae){$t(t.removed,{element:ae});try{ae.parentNode.removeChild(ae)}catch{ae.remove()}},Ze=function(ae,Se){try{$t(t.removed,{attribute:Se.getAttributeNode(ae),from:Se})}catch{$t(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(ae),ae==="is"&&!oe[ae])if(we||Ae)try{_e(Se)}catch{}else try{Se.setAttribute(ae,"")}catch{}},tt=function(ae){let Se,Pe;if(ce)ae="<remove></remove>"+ae;else{const at=li(ae,/^[\r\n\t ]+/);Pe=at&&at[0]}ye==="application/xhtml+xml"&&ve===he&&(ae='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ae+"</body></html>");const We=p?p.createHTML(ae):ae;if(ve===he)try{Se=new o().parseFromString(We,ye)}catch{}if(!Se||!Se.documentElement){Se=f.createDocument(ve,"template",null);try{Se.documentElement.innerHTML=$e?c:We}catch{}}const it=Se.body||Se.documentElement;return ae&&Pe&&it.insertBefore(s.createTextNode(Pe),it.childNodes[0]||null),ve===he?M.call(Se,W?"html":"body")[0]:W?Se.documentElement:it},Xe=function(ae){return h.call(ae.ownerDocument||ae,ae,w.SHOW_ELEMENT|w.SHOW_COMMENT|w.SHOW_TEXT,null,!1)},nt=function(ae){return ae instanceof I&&(typeof ae.nodeName!="string"||typeof ae.textContent!="string"||typeof ae.removeChild!="function"||!(ae.attributes instanceof y)||typeof ae.removeAttribute!="function"||typeof ae.setAttribute!="function"||typeof ae.namespaceURI!="string"||typeof ae.insertBefore!="function"||typeof ae.hasChildNodes!="function")},st=function(ae){return typeof k=="object"?ae instanceof k:ae&&typeof ae=="object"&&typeof ae.nodeType=="number"&&typeof ae.nodeName=="string"},rt=function(ae,Se,Pe){O[ae]&&oi(O[ae],We=>{We.call(t,Se,Pe,Je)})},gt=function(ae){let Se;if(rt("beforeSanitizeElements",ae,null),nt(ae))return _e(ae),!0;const Pe=Ie(ae.nodeName);if(rt("uponSanitizeElement",ae,{tagName:Pe,allowedTags:X}),ae.hasChildNodes()&&!st(ae.firstElementChild)&&(!st(ae.content)||!st(ae.content.firstElementChild))&&ht(/<[/\w]/g,ae.innerHTML)&&ht(/<[/\w]/g,ae.textContent))return _e(ae),!0;if(!X[Pe]||Te[Pe]){if(!Te[Pe]&&St(Pe)&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,Pe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Pe)))return!1;if(m&&!l[Pe]){const We=u(ae)||ae.parentNode,it=$(ae)||ae.childNodes;if(it&&We){const at=it.length;for(let Ke=at-1;Ke>=0;--Ke)We.insertBefore(r(it[Ke],!0),d(ae))}}return _e(ae),!0}return ae instanceof b&&!qe(ae)||(Pe==="noscript"||Pe==="noembed"||Pe==="noframes")&&ht(/<\/no(script|embed|frames)/i,ae.innerHTML)?(_e(ae),!0):(K&&ae.nodeType===3&&(Se=ae.textContent,Se=dt(Se,v," "),Se=dt(Se,C," "),Se=dt(Se,q," "),ae.textContent!==Se&&($t(t.removed,{element:ae.cloneNode()}),ae.textContent=Se)),rt("afterSanitizeElements",ae,null),!1)},kt=function(ae,Se,Pe){if(Le&&(Se==="id"||Se==="name")&&(Pe in s||Pe in et))return!1;if(!(re&&!Ne[Se]&&ht(j,Se))){if(!(Me&&ht(N,Se))){if(!oe[Se]||Ne[Se]){if(!(St(ae)&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,ae)||me.tagNameCheck instanceof Function&&me.tagNameCheck(ae))&&(me.attributeNameCheck instanceof RegExp&&ht(me.attributeNameCheck,Se)||me.attributeNameCheck instanceof Function&&me.attributeNameCheck(Se))||Se==="is"&&me.allowCustomizedBuiltInElements&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,Pe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Pe))))return!1}else if(!T[Se]){if(!ht(Y,dt(Pe,B,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&ae!=="script"&&ai(Pe,"data:")===0&&S[ae])){if(!(J&&!ht(L,dt(Pe,B,"")))){if(Pe)return!1}}}}}}return!0},St=function(ae){return ae.indexOf("-")>0},wt=function(ae){let Se,Pe,We,it;rt("beforeSanitizeAttributes",ae,null);const{attributes:at}=ae;if(!at)return;const Ke={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:oe};for(it=at.length;it--;){Se=at[it];const{name:ut,namespaceURI:vt}=Se;if(Pe=ut==="value"?Se.value:hi(Se.value),We=Ie(ut),Ke.attrName=We,Ke.attrValue=Pe,Ke.keepAttr=!0,Ke.forceKeepAttr=void 0,rt("uponSanitizeAttribute",ae,Ke),Pe=Ke.attrValue,Ke.forceKeepAttr||(Ze(ut,ae),!Ke.keepAttr))continue;if(!le&&ht(/\/>/i,Pe)){Ze(ut,ae);continue}K&&(Pe=dt(Pe,v," "),Pe=dt(Pe,C," "),Pe=dt(Pe,q," "));const Ft=Ie(ae.nodeName);if(kt(Ft,We,Pe)){if(_&&(We==="id"||We==="name")&&(Ze(ut,ae),Pe=g+Pe),p&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!vt)switch(a.getAttributeType(Ft,We)){case"TrustedHTML":{Pe=p.createHTML(Pe);break}case"TrustedScriptURL":{Pe=p.createScriptURL(Pe);break}}try{vt?ae.setAttributeNS(vt,ut,Pe):ae.setAttribute(ut,Pe),jt(t.removed)}catch{}}}rt("afterSanitizeAttributes",ae,null)},Ot=function ze(ae){let Se;const Pe=Xe(ae);for(rt("beforeSanitizeShadowDOM",ae,null);Se=Pe.nextNode();)rt("uponSanitizeShadowNode",Se,null),!gt(Se)&&(Se.content instanceof U&&ze(Se.content),wt(Se));rt("afterSanitizeShadowDOM",ae,null)};return t.sanitize=function(ze){let ae=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Se,Pe,We,it;if($e=!ze,$e&&(ze="<!-->"),typeof ze!="string"&&!st(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return ze;if(Z||x(ae),t.removed=[],typeof ze=="string"&&(i=!1),i){if(ze.nodeName){const ut=Ie(ze.nodeName);if(!X[ut]||Te[ut])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof k)Se=tt("<!---->"),Pe=Se.ownerDocument.importNode(ze,!0),Pe.nodeType===1&&Pe.nodeName==="BODY"||Pe.nodeName==="HTML"?Se=Pe:Se.appendChild(Pe);else{if(!we&&!K&&!W&&ze.indexOf("<")===-1)return p&&ke?p.createHTML(ze):ze;if(Se=tt(ze),!Se)return we?null:ke?c:""}Se&&ce&&_e(Se.firstChild);const at=Xe(i?ze:Se);for(;We=at.nextNode();)gt(We)||(We.content instanceof U&&Ot(We.content),wt(We));if(i)return ze;if(we){if(Ae)for(it=F.call(Se.ownerDocument);Se.firstChild;)it.appendChild(Se.firstChild);else it=Se;return(oe.shadowroot||oe.shadowrootmode)&&(it=R.call(A,it,!0)),it}let Ke=W?Se.outerHTML:Se.innerHTML;return W&&X["!doctype"]&&Se.ownerDocument&&Se.ownerDocument.doctype&&Se.ownerDocument.doctype.name&&ht(_t,Se.ownerDocument.doctype.name)&&(Ke="<!DOCTYPE "+Se.ownerDocument.doctype.name+`>
`+Ke),K&&(Ke=dt(Ke,v," "),Ke=dt(Ke,C," "),Ke=dt(Ke,q," ")),p&&ke?p.createHTML(Ke):Ke},t.setConfig=function(ze){x(ze),Z=!0},t.clearConfig=function(){Je=null,Z=!1},t.isValidAttribute=function(ze,ae,Se){Je||x({});const Pe=Ie(ze),We=Ie(ae);return kt(Pe,We,Se)},t.addHook=function(ze,ae){typeof ae=="function"&&(O[ze]=O[ze]||[],$t(O[ze],ae))},t.removeHook=function(ze){if(O[ze])return jt(O[ze])},t.removeHooks=function(ze){O[ze]&&(O[ze]=[])},t.removeAllHooks=function(){O={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[41],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=t.$0Q=void 0;class A{constructor(E){this.domNode=E,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(E){const k=P(E);this.a!==k&&(this.a=k,this.domNode.style.maxWidth=this.a)}setWidth(E){const k=P(E);this.b!==k&&(this.b=k,this.domNode.style.width=this.b)}setHeight(E){const k=P(E);this.c!==k&&(this.c=k,this.domNode.style.height=this.c)}setTop(E){const k=P(E);this.d!==k&&(this.d=k,this.domNode.style.top=this.d)}setLeft(E){const k=P(E);this.e!==k&&(this.e=k,this.domNode.style.left=this.e)}setBottom(E){const k=P(E);this.f!==k&&(this.f=k,this.domNode.style.bottom=this.f)}setRight(E){const k=P(E);this.g!==k&&(this.g=k,this.domNode.style.right=this.g)}setPaddingTop(E){const k=P(E);this.h!==k&&(this.h=k,this.domNode.style.paddingTop=this.h)}setPaddingLeft(E){const k=P(E);this.i!==k&&(this.i=k,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(E){const k=P(E);this.j!==k&&(this.j=k,this.domNode.style.paddingBottom=this.j)}setPaddingRight(E){const k=P(E);this.k!==k&&(this.k=k,this.domNode.style.paddingRight=this.k)}setFontFamily(E){this.l!==E&&(this.l=E,this.domNode.style.fontFamily=this.l)}setFontWeight(E){this.m!==E&&(this.m=E,this.domNode.style.fontWeight=this.m)}setFontSize(E){const k=P(E);this.n!==k&&(this.n=k,this.domNode.style.fontSize=this.n)}setFontStyle(E){this.o!==E&&(this.o=E,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(E){this.p!==E&&(this.p=E,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(E){this.q!==E&&(this.q=E,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(E){this.r!==E&&(this.r=E,this.domNode.style.textDecoration=this.r)}setLineHeight(E){const k=P(E);this.s!==k&&(this.s=k,this.domNode.style.lineHeight=this.s)}setLetterSpacing(E){const k=P(E);this.t!==k&&(this.t=k,this.domNode.style.letterSpacing=this.t)}setClassName(E){this.u!==E&&(this.u=E,this.domNode.className=this.u)}toggleClassName(E,k){this.domNode.classList.toggle(E,k),this.u=this.domNode.className}setDisplay(E){this.v!==E&&(this.v=E,this.domNode.style.display=this.v)}setPosition(E){this.w!==E&&(this.w=E,this.domNode.style.position=this.w)}setVisibility(E){this.x!==E&&(this.x=E,this.domNode.style.visibility=this.x)}setColor(E){this.y!==E&&(this.y=E,this.domNode.style.color=this.y)}setBackgroundColor(E){this.z!==E&&(this.z=E,this.domNode.style.backgroundColor=this.z)}setLayerHinting(E){this.A!==E&&(this.A=E,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this.C!==E&&(this.C=E,this.domNode.style.boxShadow=E)}setContain(E){this.B!==E&&(this.B=E,this.domNode.style.contain=this.B)}setAttribute(E,k){this.domNode.setAttribute(E,k)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.$0Q=A;function P(U){return typeof U=="number"?`${U}px`:U}function s(U){return new A(U)}t.$$Q=s}),define(be[69],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qP=t.$pP=void 0;const A=new WeakMap;function P(k){if(!k.parent||k.parent===k)return null;try{const b=k.location,w=k.parent.location;if(b.origin!=="null"&&w.origin!=="null"&&b.origin!==w.origin)return null}catch{return null}return k.parent}class s{static a(b){let w=A.get(b);if(!w){w=[],A.set(b,w);let y=b,I;do I=P(y),I?w.push({window:new WeakRef(y),iframeElement:y.frameElement||null}):w.push({window:new WeakRef(y),iframeElement:null}),y=I;while(y)}return w.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,w){if(!w||b===w)return{top:0,left:0};let y=0,I=0;const o=this.a(b);for(const a of o){const e=a.window.deref();if(y+=e?.scrollY??0,I+=e?.scrollX??0,e===w||!a.iframeElement)break;const r=a.iframeElement.getBoundingClientRect();y+=r.top,I+=r.left}return{top:y,left:I}}}t.$pP=s;async function U(k,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const w=JSON.stringify({parentOrigin:k,salt:b}),I=new TextEncoder().encode(w),o=await crypto.subtle.digest("sha-256",I);return E(o)}t.$qP=U;function E(k){const w=Array.from(new Uint8Array(k)).map(y=>y.toString(16).padStart(2,"0")).join("");return BigInt(`0x${w}`).toString(32).padStart(52,"0")}}),define(be[70],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QR=t.$PR=t.$OR=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var A;(function(E){E[E.Copy=0]="Copy",E[E.Move=1]="Move"})(A||(t.ListDragOverEffectType=A={}));var P;(function(E){E.Over="drop-target",E.Before="drop-target-before",E.After="drop-target-after"})(P||(t.ListDragOverEffectPosition=P={})),t.$OR={reject(){return{accept:!1}},accept(){return{accept:!0}}};class s extends Error{constructor(k,b){super(`ListError [${k}] ${b}`)}}t.$PR=s;class U{constructor(){this.c=new WeakMap}getHeight(k){return this.c.get(k)??this.d(k)}setDynamicHeight(k,b){b>0&&this.c.set(k,b)}}t.$QR=U}),define(be[71],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ER=void 0;class A{constructor(s){this.a=s}splice(s,U,E){this.a.forEach(k=>k.splice(s,U,E))}}t.$ER=A}),define(be[42],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=void 0;const A=20;class P{constructor(U,E,k,b,w,y){this.a=Math.round(E),this.b=Math.round(k),this.c=Math.round(U),this.d=b,this.e=w,this.f=y,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new P(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const E=Math.round(U);return this.d!==E?(this.d=E,this.m(),!0):!1}setScrollSize(U){const E=Math.round(U);return this.e!==E?(this.e=E,this.m(),!0):!1}setScrollPosition(U){const E=Math.round(U);return this.f!==E?(this.f=E,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,E,k,b,w){const y=Math.max(0,k-U),I=Math.max(0,y-2*E),o=b>0&&b>k;if(!o)return{computedAvailableSize:Math.round(y),computedIsNeeded:o,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(A,Math.floor(k*I/b))),e=(I-a)/(b-k),r=w*e;return{computedAvailableSize:Math.round(y),computedIsNeeded:o,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(r)}}m(){const U=P.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const E=U-this.c-this.i/2;return Math.round(E/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const E=U-this.c;let k=this.f;return E<this.k?k-=this.d:k+=this.d,k}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const E=this.k+U;return Math.round(E/this.j)}}t.$dR=P}),define(be[26],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HT=t.$GT=t.$FT=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var A;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(A||(t.TreeVisibility=A={}));var P;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(P||(t.ObjectTreeElementCollapseState=P={}));var s;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(s||(t.TreeMouseEventTarget=s={}));var U;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$FT={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:b}}};class E extends Error{constructor(w,y){super(`TreeError [${w}] ${y}`)}}t.$GT=E;class k{constructor(w){this.a=w,this.b=new WeakMap}map(w){let y=this.b.get(w);return y||(y=this.a(w),this.b.set(w,y)),y}}t.$HT=k}),define(be[21],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6O=t.$window=t.$4O=t.$3O=void 0;function A(s,U){const E=s;typeof E.vscodeWindowId!="number"&&Object.defineProperty(E,"vscodeWindowId",{get:()=>U})}t.$3O=A,t.$4O=window,t.$window=t.$4O;function P(s){return s===t.$4O?!1:typeof s?.vscodeWindowId=="number"}t.$6O=P}),define(be[72],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function A(r,d,$){const u=P(r,d);if(u!==-1)return r[u]}t.$fb=A;function P(r,d,$=r.length-1){for(let u=$;u>=0;u--){const p=r[u];if(d(p))return u}return-1}t.$gb=P;function s(r,d){const $=U(r,d);return $===-1?void 0:r[$]}t.$hb=s;function U(r,d,$=0,u=r.length){let p=$,c=u;for(;p<c;){const f=Math.floor((p+c)/2);d(r[f])?p=f+1:c=f}return p-1}t.$ib=U;function E(r,d){const $=k(r,d);return $===r.length?void 0:r[$]}t.$jb=E;function k(r,d,$=0,u=r.length){let p=$,c=u;for(;p<c;){const f=Math.floor((p+c)/2);d(r[f])?c=f:p=f+1}return p}t.$kb=k;function b(r,d,$=0,u=r.length){const p=k(r,d,$,u);return p===r.length?-1:p}t.$lb=b;class w{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(w.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!d(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const $=U(this.e,d,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}t.$mb=w;function y(r,d){if(r.length===0)return;let $=r[0];for(let u=1;u<r.length;u++){const p=r[u];d(p,$)>0&&($=p)}return $}t.$nb=y;function I(r,d){if(r.length===0)return;let $=r[0];for(let u=1;u<r.length;u++){const p=r[u];d(p,$)>=0&&($=p)}return $}t.$ob=I;function o(r,d){return y(r,($,u)=>-d($,u))}t.$pb=o;function a(r,d){if(r.length===0)return-1;let $=0;for(let u=1;u<r.length;u++){const p=r[u];d(p,r[$])>0&&($=u)}return $}t.$qb=a;function e(r,d){for(const $ of r){const u=d($);if(u!==void 0)return u}}t.$rb=e}),define(be[73],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function A(E,k){const b=Object.create(null);for(const w of E){const y=k(w);let I=b[y];I||(I=b[y]=[]),I.push(w)}return b}t.$K=A;function P(E,k){const b=[],w=[];for(const y of E)k.has(y)||b.push(y);for(const y of k)E.has(y)||w.push(y);return{removed:b,added:w}}t.$L=P;function s(E,k){const b=[],w=[];for(const[y,I]of E)k.has(y)||b.push(I);for(const[y,I]of k)E.has(y)||w.push(I);return{removed:b,added:w}}t.$M=s;function U(E,k){const b=new Set;for(const w of k)E.has(w)&&b.add(w);return b}t.$N=U}),define(be[74],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lt=t.$kt=t.$jt=t.$it=void 0;function A(k,b){const w=Math.pow(10,b);return Math.round(k*w)/w}class P{constructor(b,w,y,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=A(Math.max(Math.min(1,I),0),3)}static equals(b,w){return b.r===w.r&&b.g===w.g&&b.b===w.b&&b.a===w.a}}t.$it=P;class s{constructor(b,w,y,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=A(Math.max(Math.min(1,w),0),3),this.l=A(Math.max(Math.min(1,y),0),3),this.a=A(Math.max(Math.min(1,I),0),3)}static equals(b,w){return b.h===w.h&&b.s===w.s&&b.l===w.l&&b.a===w.a}static fromRGBA(b){const w=b.r/255,y=b.g/255,I=b.b/255,o=b.a,a=Math.max(w,y,I),e=Math.min(w,y,I);let r=0,d=0;const $=(e+a)/2,u=a-e;if(u>0){switch(d=Math.min($<=.5?u/(2*$):u/(2-2*$),1),a){case w:r=(y-I)/u+(y<I?6:0);break;case y:r=(I-w)/u+2;break;case I:r=(w-y)/u+4;break}r*=60,r=Math.round(r)}return new s(r,d,$,o)}static i(b,w,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?b+(w-b)*6*y:y<1/2?w:y<2/3?b+(w-b)*(2/3-y)*6:b}static toRGBA(b){const w=b.h/360,{s:y,l:I,a:o}=b;let a,e,r;if(y===0)a=e=r=I;else{const d=I<.5?I*(1+y):I+y-I*y,$=2*I-d;a=s.i($,d,w+1/3),e=s.i($,d,w),r=s.i($,d,w-1/3)}return new P(Math.round(a*255),Math.round(e*255),Math.round(r*255),o)}}t.$jt=s;class U{constructor(b,w,y,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=A(Math.max(Math.min(1,w),0),3),this.v=A(Math.max(Math.min(1,y),0),3),this.a=A(Math.max(Math.min(1,I),0),3)}static equals(b,w){return b.h===w.h&&b.s===w.s&&b.v===w.v&&b.a===w.a}static fromRGBA(b){const w=b.r/255,y=b.g/255,I=b.b/255,o=Math.max(w,y,I),a=Math.min(w,y,I),e=o-a,r=o===0?0:e/o;let d;return e===0?d=0:o===w?d=((y-I)/e%6+6)%6:o===y?d=(I-w)/e+2:d=(w-y)/e+4,new U(Math.round(d*60),r,o,b.a)}static toRGBA(b){const{h:w,s:y,v:I,a:o}=b,a=I*y,e=a*(1-Math.abs(w/60%2-1)),r=I-a;let[d,$,u]=[0,0,0];return w<60?(d=a,$=e):w<120?(d=e,$=a):w<180?($=a,u=e):w<240?($=e,u=a):w<300?(d=e,u=a):w<=360&&(d=a,u=e),d=Math.round((d+r)*255),$=Math.round(($+r)*255),u=Math.round((u+r)*255),new P(d,$,u,o)}}t.$kt=U;class E{static fromHex(b){return E.Format.CSS.parseHex(b)||E.red}static equals(b,w){return!b&&!w?!0:!b||!w?!1:b.equals(w)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof P)this.rgba=b;else if(b instanceof s)this.i=b,this.rgba=s.toRGBA(b);else if(b instanceof U)this.j=b,this.rgba=U.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&P.equals(this.rgba,b.rgba)&&s.equals(this.hsla,b.hsla)&&U.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=E.k(this.rgba.r),w=E.k(this.rgba.g),y=E.k(this.rgba.b),I=.2126*b+.7152*w+.0722*y;return A(I,4)}static k(b){const w=b/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w>y?(w+.05)/(y+.05):(y+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w>y}isDarkerThan(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w<y}lighten(b){return new E(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new E(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:w,g:y,b:I,a:o}=this.rgba;return new E(new P(w,y,I,o*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const w=b.rgba,y=this.rgba.a,I=w.a,o=y+I*(1-y);if(o<1e-6)return E.transparent;const a=this.rgba.r*y/o+w.r*I*(1-y)/o,e=this.rgba.g*y/o+w.g*I*(1-y)/o,r=this.rgba.b*y/o+w.b*I*(1-y)/o;return new E(new P(a,e,r,o))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:w,g:y,b:I,a:o}=this.rgba;return new E(new P(b.rgba.r-o*(b.rgba.r-w),b.rgba.g-o*(b.rgba.g-y),b.rgba.b-o*(b.rgba.b-I),1))}flatten(...b){const w=b.reduceRight((y,I)=>E.o(I,y));return E.o(this,w)}static o(b,w){const y=1-b.rgba.a;return new E(new P(y*w.rgba.r+b.rgba.a*b.rgba.r,y*w.rgba.g+b.rgba.a*b.rgba.g,y*w.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(b,w,y){if(b.isLighterThan(w))return b;y=y||.5;const I=b.getRelativeLuminance(),o=w.getRelativeLuminance();return y=y*(o-I)/o,b.lighten(y)}static getDarkerColor(b,w,y){if(b.isDarkerThan(w))return b;y=y||.5;const I=b.getRelativeLuminance(),o=w.getRelativeLuminance();return y=y*(I-o)/I,b.darken(y)}static{this.white=new E(new P(255,255,255,1))}static{this.black=new E(new P(0,0,0,1))}static{this.red=new E(new P(255,0,0,1))}static{this.blue=new E(new P(0,0,255,1))}static{this.green=new E(new P(0,255,0,1))}static{this.cyan=new E(new P(0,255,255,1))}static{this.lightgrey=new E(new P(211,211,211,1))}static{this.transparent=new E(new P(0,0,0,0))}}t.$lt=E,function(k){let b;(function(w){let y;(function(I){function o(h){return h.rgba.a===1?`rgb(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b})`:k.Format.CSS.formatRGBA(h)}I.formatRGB=o;function a(h){return`rgba(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b}, ${+h.rgba.a.toFixed(2)})`}I.formatRGBA=a;function e(h){return h.hsla.a===1?`hsl(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(h)}I.formatHSL=e;function r(h){return`hsla(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%, ${h.hsla.a.toFixed(2)})`}I.formatHSLA=r;function d(h){const F=h.toString(16);return F.length!==2?"0"+F:F}function $(h){return`#${d(h.rgba.r)}${d(h.rgba.g)}${d(h.rgba.b)}`}I.formatHex=$;function u(h,F=!1){return F&&h.rgba.a===1?k.Format.CSS.formatHex(h):`#${d(h.rgba.r)}${d(h.rgba.g)}${d(h.rgba.b)}${d(Math.round(h.rgba.a*255))}`}I.formatHexA=u;function p(h){return h.isOpaque()?k.Format.CSS.formatHex(h):k.Format.CSS.formatRGBA(h)}I.format=p;function c(h){const F=h.length;if(F===0||h.charCodeAt(0)!==35)return null;if(F===7){const M=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),R=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),O=16*f(h.charCodeAt(5))+f(h.charCodeAt(6));return new k(new P(M,R,O,1))}if(F===9){const M=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),R=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),O=16*f(h.charCodeAt(5))+f(h.charCodeAt(6)),v=16*f(h.charCodeAt(7))+f(h.charCodeAt(8));return new k(new P(M,R,O,v/255))}if(F===4){const M=f(h.charCodeAt(1)),R=f(h.charCodeAt(2)),O=f(h.charCodeAt(3));return new k(new P(16*M+M,16*R+R,16*O+O))}if(F===5){const M=f(h.charCodeAt(1)),R=f(h.charCodeAt(2)),O=f(h.charCodeAt(3)),v=f(h.charCodeAt(4));return new k(new P(16*M+M,16*R+R,16*O+O,(16*v+v)/255))}return null}I.parseHex=c;function f(h){switch(h){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=w.CSS||(w.CSS={}))})(b=k.Format||(k.Format={}))}(E||(t.$lt=E={}))}),define(be[27],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yh=t.$xh=t.$wh=void 0;function A(E){return(k,b,w)=>{let y=null,I=null;if(typeof w.value=="function"?(y="value",I=w.value):typeof w.get=="function"&&(y="get",I=w.get),!I)throw new Error("not supported");w[y]=E(I,b)}}function P(E,k,b){let w=null,y=null;if(typeof b.value=="function"?(w="value",y=b.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(w="get",y=b.get),!y)throw new Error("not supported");const I=`$memoize$${k}`;b[w]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,o)}),this[I]}}t.$wh=P;function s(E,k,b){return A((w,y)=>{const I=`$debounce$${y}`,o=`$debounce$result$${y}`;return function(...a){this[o]||(this[o]=b?b():void 0),clearTimeout(this[I]),k&&(this[o]=k(this[o],...a),a=[this[o]]),this[I]=setTimeout(()=>{w.apply(this,a),this[o]=b?b():void 0},E)}})}t.$xh=s;function U(E,k,b){return A((w,y)=>{const I=`$throttle$timer$${y}`,o=`$throttle$result$${y}`,a=`$throttle$lastRun$${y}`,e=`$throttle$pending$${y}`;return function(...r){if(this[o]||(this[o]=b?b():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),k&&(this[o]=k(this[o],...r)),this[e])return;const d=this[a]+E;d<=Date.now()?(this[a]=Date.now(),w.apply(this,[this[o]]),this[o]=b?b():void 0):(this[e]=!0,this[I]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),w.apply(this,[this[o]]),this[o]=b?b():void 0},d-Date.now()))}})}t.$yh=U}),define(be[75],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=void 0;class A{constructor(s,U,E,k){this.originalStart=s,this.originalLength=U,this.modifiedStart=E,this.modifiedLength=k}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Ws=A}),define(be[6],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class A{constructor(){this.b=[],this.a=function(h){setTimeout(()=>{throw h.stack?p.isErrorNoTelemetry(h)?new p(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.b.push(h),()=>{this.d(h)}}c(h){this.b.forEach(F=>{F(h)})}d(h){this.b.splice(this.b.indexOf(h),1)}setUnexpectedErrorHandler(h){this.a=h}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(h){this.a(h),this.c(h)}onUnexpectedExternalError(h){this.a(h)}}t.$W=A,t.$X=new A;function P(f){t.$X.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=P;function s(f){if(!f||typeof f!="object")return!1;const h=f;return h.code==="EPIPE"&&h.syscall?.toUpperCase()==="WRITE"}t.$Z=s;function U(f){w(f)||t.$X.onUnexpectedError(f)}t.$1=U;function E(f){w(f)||t.$X.onUnexpectedExternalError(f)}t.$2=E;function k(f){if(f instanceof Error){const{name:h,message:F}=f,M=f.stacktrace||f.stack;return{$isError:!0,name:h,message:F,stack:M,noTelemetry:p.isErrorNoTelemetry(f)}}return f}t.$3=k;const b="Canceled";function w(f){return f instanceof y?!0:f instanceof Error&&f.name===b&&f.message===b}t.$4=w;class y extends Error{constructor(){super(b),this.name=this.message}}t.$5=y;function I(){const f=new Error(b);return f.name=f.message,f}t.$6=I;function o(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$7=o;function a(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$8=a;class e extends TypeError{constructor(h){super(h?`${h} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function r(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$0=r;class d extends Error{constructor(h){super("NotImplemented"),h&&(this.message=h)}}t.$$=d;class $ extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}t.$_=$;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=u;class p extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof p)return h;const F=new p;return F.message=h.message,F.stack=h.stack,F}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}t.$bb=p;class c extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.$cb=c}),define(be[12],pe([1,0,6,72]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function s(_,g=0){return _[_.length-(1+g)]}t.$sb=s;function U(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}t.$tb=U;function E(_,g,m=(i,n)=>i===n){if(_===g)return!0;if(!_||!g||_.length!==g.length)return!1;for(let i=0,n=_.length;i<n;i++)if(!m(_[i],g[i]))return!1;return!0}t.$ub=E;function k(_,g){const m=_.length-1;g<m&&(_[g]=_[m]),_.pop()}t.$vb=k;function b(_,g,m){return w(_.length,i=>m(_[i],g))}t.$wb=b;function w(_,g){let m=0,i=_-1;for(;m<=i;){const n=(m+i)/2|0,l=g(n);if(l<0)m=n+1;else if(l>0)i=n-1;else return n}return-(m+1)}t.$xb=w;function y(_,g,m){if(_=_|0,_>=g.length)throw new TypeError("invalid index");const i=g[Math.floor(g.length*Math.random())],n=[],l=[],D=[];for(const S of g){const z=m(S,i);z<0?n.push(S):z>0?l.push(S):D.push(S)}return _<n.length?y(_,n,m):_<n.length+D.length?D[0]:y(_-(n.length+D.length),l,m)}t.$yb=y;function I(_,g){const m=[];let i;for(const n of _.slice(0).sort(g))!i||g(i[0],n)!==0?(i=[n],m.push(i)):i.push(n);return m}t.$zb=I;function*o(_,g){let m,i;for(const n of _)i!==void 0&&g(i,n)?m.push(n):(m&&(yield m),m=[n]),i=n;m&&(yield m)}t.$Ab=o;function a(_,g){for(let m=0;m<=_.length;m++)g(m===0?void 0:_[m-1],m===_.length?void 0:_[m])}t.$Bb=a;function e(_,g){for(let m=0;m<_.length;m++)g(m===0?void 0:_[m-1],_[m],m+1===_.length?void 0:_[m+1])}t.$Cb=e;function r(_,g,m){const i=[];function n(S,z,T){if(z===0&&T.length===0)return;const H=i[i.length-1];H&&H.start+H.deleteCount===S?(H.deleteCount+=z,H.toInsert.push(...T)):i.push({start:S,deleteCount:z,toInsert:T})}let l=0,D=0;for(;;){if(l===_.length){n(l,0,g.slice(D));break}if(D===g.length){n(l,_.length-l,[]);break}const S=_[l],z=g[D],T=m(S,z);T===0?(l+=1,D+=1):T<0?(n(l,1,[]),l+=1):T>0&&(n(l,0,[z]),D+=1)}return i}t.$Db=r;function d(_,g,m){const i=r(_,g,m),n=[],l=[];for(const D of i)n.push(..._.slice(D.start,D.start+D.deleteCount)),l.push(...D.toInsert);return{removed:n,added:l}}t.$Eb=d;function $(_,g,m){if(m===0)return[];const i=_.slice(0,m).sort(g);return p(_,g,i,m,_.length),i}t.top=$;function u(_,g,m,i,n){return m===0?Promise.resolve([]):new Promise((l,D)=>{(async()=>{const S=_.length,z=_.slice(0,m).sort(g);for(let T=m,H=Math.min(m+i,S);T<S;T=H,H=Math.min(H+i,S)){if(T>m&&await new Promise(G=>setTimeout(G)),n&&n.isCancellationRequested)throw new A.$5;p(_,g,z,T,H)}return z})().then(l,D)})}t.$Gb=u;function p(_,g,m,i,n){for(const l=m.length;i<n;i++){const D=_[i];if(g(D,m[l-1])<0){m.pop();const S=(0,P.$kb)(m,z=>g(D,z)<0);m.splice(S,0,D)}}}function c(_){return _.filter(g=>!!g)}t.$Hb=c;function f(_){let g=0;for(let m=0;m<_.length;m++)_[m]&&(_[g]=_[m],g+=1);_.length=g}t.$Ib=f;function h(_,g,m){_.splice(m,0,_.splice(g,1)[0])}t.$Jb=h;function F(_){return!Array.isArray(_)||_.length===0}t.$Kb=F;function M(_){return Array.isArray(_)&&_.length>0}t.$Lb=M;function R(_,g=m=>m){const m=new Set;return _.filter(i=>{const n=g(i);return m.has(n)?!1:(m.add(n),!0)})}t.$Mb=R;function O(_){const g=new Set;return m=>{const i=_(m);return g.has(i)?!1:(g.add(i),!0)}}t.$Nb=O;function v(_,g){return _.length>0?_[0]:g}t.$Ob=v;function C(_,g){return _.length>0?_[_.length-1]:g}t.$Pb=C;function q(_,g,m=(i,n)=>i===n){let i=0;for(let n=0,l=Math.min(_.length,g.length);n<l&&m(_[n],g[n]);n++)i++;return i}t.$Qb=q;function j(_){return[].concat(..._)}t.$Rb=j;function N(_,g){let m=typeof g=="number"?_:0;typeof g=="number"?m=_:(m=0,g=_);const i=[];if(m<=g)for(let n=m;n<g;n++)i.push(n);else for(let n=m;n>g;n--)i.push(n);return i}t.$Sb=N;function L(_,g,m){return _.reduce((i,n)=>(i[g(n)]=m?m(n):n,i),Object.create(null))}t.$Tb=L;function B(_,g){return _.push(g),()=>Y(_,g)}t.$Ub=B;function Y(_,g){const m=_.indexOf(g);if(m>-1)return _.splice(m,1),g}t.$Vb=Y;function X(_,g,m){const i=_.slice(0,g),n=_.slice(g);return i.concat(m,n)}t.$Wb=X;function de(_,g){let m;if(typeof g=="number"){let i=g;m=()=>{const n=Math.sin(i++)*179426549;return n-Math.floor(n)}}else m=Math.random;for(let i=_.length-1;i>0;i-=1){const n=Math.floor(m()*(i+1)),l=_[i];_[i]=_[n],_[n]=l}}t.$Xb=de;function oe(_,g){const m=_.indexOf(g);m>-1&&(_.splice(m,1),_.unshift(g))}t.$Yb=oe;function ee(_,g){const m=_.indexOf(g);m>-1&&(_.splice(m,1),_.push(g))}t.$Zb=ee;function me(_,g){for(const m of g)_.push(m)}t.$1b=me;function Te(_,g){return Array.isArray(_)?_.map(g):g(_)}t.$2b=Te;function Ne(_){return Array.isArray(_)?_:[_]}t.$3b=Ne;function Me(_){return _[Math.floor(Math.random()*_.length)]}t.$4b=Me;function re(_,g,m){const i=le(_,g),n=_.length,l=m.length;_.length=n+l;for(let D=n-1;D>=i;D--)_[D+l]=_[D];for(let D=0;D<l;D++)_[D+i]=m[D]}t.$5b=re;function J(_,g,m,i){const n=le(_,g);let l=_.splice(n,m);return l===void 0&&(l=[]),re(_,n,i),l}t.$6b=J;function le(_,g){return g<0?Math.max(g+_.length,0):Math.min(g,_.length)}var K;(function(_){function g(l){return l<0}_.isLessThan=g;function m(l){return l<=0}_.isLessThanOrEqual=m;function i(l){return l>0}_.isGreaterThan=i;function n(l){return l===0}_.isNeitherLessOrGreaterThan=n,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(K||(t.CompareResult=K={}));function W(_,g){return(m,i)=>g(_(m),_(i))}t.$7b=W;function Z(..._){return(g,m)=>{for(const i of _){const n=i(g,m);if(!K.isNeitherLessOrGreaterThan(n))return n}return K.neitherLessOrGreaterThan}}t.$8b=Z;const ce=(_,g)=>_-g;t.$9b=ce;const we=(_,g)=>(0,t.$9b)(_?1:0,g?1:0);t.$0b=we;function Ae(_){return(g,m)=>-_(g,m)}t.$$b=Ae;class ke{constructor(g){this.g=g,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(g){let m=this.c;for(;m<this.g.length&&g(this.g[m]);)m++;const i=m===this.c?null:this.g.slice(this.c,m);return this.c=m,i}takeFromEndWhile(g){let m=this.d;for(;m>=0&&g(this.g[m]);)m--;const i=m===this.d?null:this.g.slice(m+1,this.d+1);return this.d=m,i}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const g=this.g[this.c];return this.c++,g}removeLast(){const g=this.g[this.d];return this.d--,g}takeCount(g){const m=this.g.slice(this.c,this.c+g);return this.c+=g,m}}t.$_b=ke;class Le{static{this.empty=new Le(g=>{})}constructor(g){this.iterate=g}forEach(g){this.iterate(m=>(g(m),!0))}toArray(){const g=[];return this.iterate(m=>(g.push(m),!0)),g}filter(g){return new Le(m=>this.iterate(i=>g(i)?m(i):!0))}map(g){return new Le(m=>this.iterate(i=>m(g(i))))}some(g){let m=!1;return this.iterate(i=>(m=g(i),!m)),m}findFirst(g){let m;return this.iterate(i=>g(i)?(m=i,!1):!0),m}findLast(g){let m;return this.iterate(i=>(g(i)&&(m=i),!0)),m}findLastMaxBy(g){let m,i=!0;return this.iterate(n=>((i||K.isGreaterThan(g(n,m)))&&(i=!1,m=n),!0)),m}}t.$ac=Le}),define(be[76],pe([1,0,6]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function P(b,w){if(!b)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=P;function s(b,w="Unreachable"){throw new Error(w)}t.$6c=s;function U(b){if(!b)throw new A.$cb("Assertion Failed")}t.$7c=U;function E(b){if(!b()){debugger;b(),(0,A.$1)(new A.$cb("Assertion Failed"))}}t.$8c=E;function k(b,w){let y=0;for(;y<b.length-1;){const I=b[y],o=b[y+1];if(!w(I,o))return!1;y++}return!0}t.$9c=k}),define(be[43],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function A(P,s){const U=this;let E=!1,k;return function(){if(E)return k;if(E=!0,s)try{k=P.apply(U,arguments)}finally{s()}else k=P.apply(U,arguments);return k}}t.$db=A}),define(be[77],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bN=t.$aN=void 0;class A{constructor(s){this.a=s,this.b=0}nextId(){return this.a+ ++this.b}}t.$aN=A,t.$bN=new A("id#")}),define(be[28],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var A;(function(P){function s(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}P.is=s;const U=Object.freeze([]);function E(){return U}P.empty=E;function*k(h){yield h}P.single=k;function b(h){return s(h)?h:k(h)}P.wrap=b;function w(h){return h||U}P.from=w;function*y(h){for(let F=h.length-1;F>=0;F--)yield h[F]}P.reverse=y;function I(h){return!h||h[Symbol.iterator]().next().done===!0}P.isEmpty=I;function o(h){return h[Symbol.iterator]().next().value}P.first=o;function a(h,F){for(const M of h)if(F(M))return!0;return!1}P.some=a;function e(h,F){for(const M of h)if(F(M))return M}P.find=e;function*r(h,F){for(const M of h)F(M)&&(yield M)}P.filter=r;function*d(h,F){let M=0;for(const R of h)yield F(R,M++)}P.map=d;function*$(...h){for(const F of h)yield*F}P.concat=$;function u(h,F,M){let R=M;for(const O of h)R=F(R,O);return R}P.reduce=u;function*p(h,F,M=h.length){for(F<0&&(F+=h.length),M<0?M+=h.length:M>h.length&&(M=h.length);F<M;F++)yield h[F]}P.slice=p;function c(h,F=Number.POSITIVE_INFINITY){const M=[];if(F===0)return[M,h];const R=h[Symbol.iterator]();for(let O=0;O<F;O++){const v=R.next();if(v.done)return[M,P.empty()];M.push(v.value)}return[M,{[Symbol.iterator](){return R}}]}P.consume=c;async function f(h){const F=[];for await(const M of h)F.push(M);return Promise.resolve(F)}P.asyncToArray=f})(A||(t.Iterable=A={}))}),define(be[44],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6q=t.KeyMod=t.KeyCodeUtils=t.$5q=t.$4q=t.$3q=t.$2q=t.$1q=t.ScanCode=t.KeyCode=void 0;var A;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(A||(t.KeyCode=A={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class s{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(r,d){this._keyCodeToStr[r]=d,this._strToKeyCode[d.toLowerCase()]=r}keyCodeToStr(r){return this._keyCodeToStr[r]}strToKeyCode(r){return this._strToKeyCode[r.toLowerCase()]||0}}const U=new s,E=new s,k=new s;t.$1q=new Array(230),t.$2q={};const b=[],w=Object.create(null),y=Object.create(null);t.$3q={lowerCaseToEnum:e=>y[e]||0,toEnum:e=>w[e]||0,toString:e=>b[e]||"None"},t.$4q=[],t.$5q=[];for(let e=0;e<=193;e++)t.$4q[e]=-1;for(let e=0;e<=132;e++)t.$5q[e]=-1;(function(){const e="",r=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],d=[],$=[];for(const u of r){const[p,c,f,h,F,M,R,O,v]=u;if($[c]||($[c]=!0,b[c]=f,w[f]=c,y[f.toLowerCase()]=c,p&&(t.$4q[c]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(t.$5q[h]=c))),!d[h]){if(d[h]=!0,!F)throw new Error(`String representation missing for key code ${h} around scan code ${f}`);U.define(h,F),E.define(h,O||F),k.define(h,v||O||F)}M&&(t.$1q[M]=h),R&&(t.$2q[R]=h)}t.$5q[3]=46})();var I;(function(e){function r(f){return U.keyCodeToStr(f)}e.toString=r;function d(f){return U.strToKeyCode(f)}e.fromString=d;function $(f){return E.keyCodeToStr(f)}e.toUserSettingsUS=$;function u(f){return k.keyCodeToStr(f)}e.toUserSettingsGeneral=u;function p(f){return E.strToKeyCode(f)||k.strToKeyCode(f)}e.fromUserSettings=p;function c(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(f)}e.toElectronAccelerator=c})(I||(t.KeyCodeUtils=I={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o||(t.KeyMod=o={}));function a(e,r){const d=(r&65535)<<16>>>0;return(e|d)>>>0}t.$6q=a}),define(be[78],pe([1,0,6]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ar=t.$_q=t.$$q=t.$0q=t.$9q=t.$8q=t.$7q=void 0;var P;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(P||(P={}));function s(I,o){if(typeof I=="number"){if(I===0)return null;const a=(I&65535)>>>0,e=(I&4294901760)>>>16;return e!==0?new b([U(a,o),U(e,o)]):new b([U(a,o)])}else{const a=[];for(let e=0;e<I.length;e++)a.push(U(I[e],o));return new b(a)}}t.$7q=s;function U(I,o){const a=!!(I&2048),e=!!(I&256),r=o===2?e:a,d=!!(I&1024),$=!!(I&512),u=o===2?a:e,p=I&255;return new E(r,d,$,u,p)}t.$8q=U;class E{constructor(o,a,e,r,d){this.ctrlKey=o,this.shiftKey=a,this.altKey=e,this.metaKey=r,this.keyCode=d}equals(o){return o instanceof E&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",r=this.metaKey?"1":"0";return`K${o}${a}${e}${r}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$9q=E;class k{constructor(o,a,e,r,d){this.ctrlKey=o,this.shiftKey=a,this.altKey=e,this.metaKey=r,this.scanCode=d}equals(o){return o instanceof k&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}getHashCode(){const o=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",r=this.metaKey?"1":"0";return`S${o}${a}${e}${r}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$0q=k;class b{constructor(o){if(o.length===0)throw(0,A.$7)("chords");this.chords=o}getHashCode(){let o="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(o+=";"),o+=this.chords[a].getHashCode();return o}equals(o){if(o===null||this.chords.length!==o.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(o.chords[a]))return!1;return!0}}t.$$q=b;class w{constructor(o,a,e,r,d,$){this.ctrlKey=o,this.shiftKey=a,this.altKey=e,this.metaKey=r,this.keyLabel=d,this.keyAriaLabel=$}}t.$_q=w;class y{}t.$ar=y}),define(be[23],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class A{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=A}),define(be[45],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class A{static{this.Undefined=new A(void 0)}constructor(U){this.element=U,this.next=A.Undefined,this.prev=A.Undefined}}class P{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let U=this.a;for(;U!==A.Undefined;){const E=U.next;U.prev=A.Undefined,U.next=A.Undefined,U=E}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,E){const k=new A(U);if(this.a===A.Undefined)this.a=k,this.b=k;else if(E){const w=this.b;this.b=k,k.prev=w,w.next=k}else{const w=this.a;this.a=k,k.next=w,w.prev=k}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(k))}}shift(){if(this.a!==A.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==A.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==A.Undefined&&U.next!==A.Undefined){const E=U.prev;E.next=U.next,U.next.prev=E}else U.prev===A.Undefined&&U.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):U.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):U.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==A.Undefined;)yield U.element,U=U.next}}t.$4c=P}),define(be[32],pe([1,0]),function(ie,t){"use strict";var A,P,s;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function U(p,c,f){let h=p.get(c);return h===void 0&&(h=f,p.set(c,h)),h}t.$xc=U;function E(p){const c=[];return p.forEach((f,h)=>{c.push(`${h} => ${f}`)}),`Map(${p.size}) {${c.join(", ")}}`}t.$yc=E;function k(p){const c=[];return p.forEach(f=>{c.push(f)}),`Set(${p.size}) {${c.join(", ")}}`}t.$zc=k;class b{constructor(c,f){this.uri=c,this.value=f}}function w(p){return Array.isArray(p)}class y{static{this.c=c=>c.toString()}constructor(c,f){if(this[A]="ResourceMap",c instanceof y)this.d=new Map(c.d),this.e=f??y.c;else if(w(c)){this.d=new Map,this.e=f??y.c;for(const[h,F]of c)this.set(h,F)}else this.d=new Map,this.e=c??y.c}set(c,f){return this.d.set(this.e(c),new b(c,f)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,f){typeof f<"u"&&(c=c.bind(f));for(const[h,F]of this.d)c(F.value,F.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}t.$Ac=y;class I{constructor(c,f){this[P]="ResourceSet",!c||typeof c=="function"?this.c=new y(c):(this.c=new y(f),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,f){this.c.forEach((h,F)=>c.call(f,F,F,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=I;var o;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(o||(t.Touch=o={}));class a{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,f=0){const h=this.c.get(c);if(h)return f!==0&&this.l(h,f),h.value}set(c,f,h=0){let F=this.c.get(c);if(F)F.value=f,h!==0&&this.l(F,h);else{switch(F={key:c,value:f,next:void 0,previous:void 0},h){case 0:this.j(F);break;case 1:this.i(F);break;case 2:this.j(F);break;default:this.j(F);break}this.c.set(c,F),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const f=this.c.get(c);if(f)return this.c.delete(c),this.k(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,f){const h=this.g;let F=this.d;for(;F;){if(f?c.bind(f)(F.value,F.key,this):c(F.value,F.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");F=F.next}}keys(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.key,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return F}values(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.value,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return F}entries(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:[h.key,h.value],done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return F}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let f=this.d,h=this.size;for(;f&&h>c;)this.c.delete(f.key),f=f.next,h--;this.d=f,this.f=h,f&&(f.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const f=c.next,h=c.previous;if(!f||!h)throw new Error("Invalid list");f.previous=h,h.next=f}c.next=void 0,c.previous=void 0,this.g++}l(c,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(c===this.d)return;const h=c.next,F=c.previous;c===this.e?(F.next=void 0,this.e=F):(h.previous=F,F.next=h),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(f===2){if(c===this.e)return;const h=c.next,F=c.previous;c===this.d?(h.previous=void 0,this.d=h):(h.previous=F,F.next=h),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((f,h)=>{c.push([h,f])}),c}fromJSON(c){this.clear();for(const[f,h]of c)this.set(f,h)}}t.$Cc=a;class e extends a{constructor(c,f=1){super(),this.m=c,this.n=Math.min(Math.max(0,f),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,f=2){return super.get(c,f)}peek(c){return super.get(c,0)}set(c,f){return super.set(c,f,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class r{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let f=this.c.get(c)||0;return f===0?!1:(f--,f===0?this.c.delete(c):this.c.set(c,f),!0)}has(c){return this.c.has(c)}}t.$Ec=r;class d{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[f,h]of c)this.set(f,h)}clear(){this.c.clear(),this.d.clear()}set(c,f){this.c.set(c,f),this.d.set(f,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const f=this.c.get(c);return f===void 0?!1:(this.c.delete(c),this.d.delete(f),!0)}forEach(c,f){this.c.forEach((h,F)=>{c.call(f,h,F,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=d;class ${constructor(){this.c=new Map}add(c,f){let h=this.c.get(c);h||(h=new Set,this.c.set(c,h)),h.add(f)}delete(c,f){const h=this.c.get(c);h&&(h.delete(f),h.size===0&&this.c.delete(c))}forEach(c,f){const h=this.c.get(c);h&&h.forEach(f)}get(c){const f=this.c.get(c);return f||new Set}}t.$Gc=$;function u(p,c){if(p===c)return!0;if(p.size!==c.size)return!1;for(const[f,h]of p)if(!c.has(f)||c.get(f)!==h)return!1;for(const[f]of c)if(!p.has(f))return!1;return!0}t.$Hc=u}),define(be[2],pe([1,0,12,73,32,43,28]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const k=!1;let b=null;class w{constructor(){this.b=new Map}static{this.a=0}c(B){let Y=this.b.get(B);return Y||(Y={parent:null,source:null,isSingleton:!1,value:B,idx:w.a++},this.b.set(B,Y)),Y}trackDisposable(B){const Y=this.c(B);Y.source||(Y.source=new Error().stack)}setParent(B,Y){const X=this.c(B);X.parent=Y}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,Y){const X=Y.get(B);if(X)return X;const de=B.parent?this.f(this.c(B.parent),Y):B;return Y.set(B,de),de}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,X])=>X.source!==null&&!this.f(X,B).isSingleton).flatMap(([X])=>X)}computeLeakingDisposables(B=10,Y){let X;if(Y)X=Y;else{const Te=new Map,Ne=[...this.b.values()].filter(re=>re.source!==null&&!this.f(re,Te).isSingleton);if(Ne.length===0)return;const Me=new Set(Ne.map(re=>re.value));if(X=Ne.filter(re=>!(re.parent&&Me.has(re.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function de(Te){function Ne(re,J){for(;re.length>0&&J.some(le=>typeof le=="string"?le===re[0]:re[0].match(le));)re.shift()}const Me=Te.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Ne(Me,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Me.reverse()}const oe=new s.$Gc;for(const Te of X){const Ne=de(Te);for(let Me=0;Me<=Ne.length;Me++)oe.add(Ne.slice(0,Me).join(`
`),Te)}X.sort((0,A.$7b)(Te=>Te.idx,A.$9b));let ee="",me=0;for(const Te of X.slice(0,B)){me++;const Ne=de(Te),Me=[];for(let re=0;re<Ne.length;re++){let J=Ne[re];J=`(shared with ${oe.get(Ne.slice(0,re+1).join(`
`)).size}/${X.length} leaks) at ${J}`;const K=oe.get(Ne.slice(0,re).join(`
`)),W=(0,P.$K)([...K].map(Z=>de(Z)[re]),Z=>Z);delete W[Ne[re]];for(const[Z,ce]of Object.entries(W))Me.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${Z}`);Me.unshift(J)}ee+=`


==================== Leaking disposable ${me}/${X.length}: ${Te.value.constructor.name} ====================
${Me.join(`
`)}
============================================================

`}return X.length>B&&(ee+=`


... and ${X.length-B} more leaking disposables

`),{leaks:X,details:ee}}}t.$Ic=w;function y(L){b=L}if(t.$Jc=y,k){const L="__is_disposable_tracked__";y(new class{trackDisposable(B){const Y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[L]||console.log(Y)},3e3)}setParent(B,Y){if(B&&B!==h.None)try{B[L]=!0}catch{}}markAsDisposed(B){if(B&&B!==h.None)try{B[L]=!0}catch{}}markAsSingleton(B){}})}function I(L){return b?.trackDisposable(L),L}t.$Kc=I;function o(L){b?.markAsDisposed(L)}t.$Lc=o;function a(L,B){b?.setParent(L,B)}function e(L,B){if(b)for(const Y of L)b.setParent(Y,B)}function r(L){return b?.markAsSingleton(L),L}t.$Mc=r;function d(L){return typeof L.dispose=="function"&&L.dispose.length===0}t.$Nc=d;function $(L){if(E.Iterable.is(L)){const B=[];for(const Y of L)if(Y)try{Y.dispose()}catch(X){B.push(X)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}t.$Oc=$;function u(L){for(const B of L)d(B)&&B.dispose();return[]}t.$Pc=u;function p(...L){const B=c(()=>$(L));return e(L,B),B}t.$Qc=p;function c(L){const B=I({dispose:(0,U.$db)(()=>{o(B),L()})});return B}t.$Rc=c;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(o(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return a(B,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),a(B,null))}}t.$Sc=f;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,I(this),a(this.q,this)}dispose(){o(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}t.$Tc=h;class F{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&a(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,o(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&a(B,null),B}}t.$Uc=F;class M{constructor(B){this.a=new F,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=M;class R{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=R;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(B){let Y=B;return this.unset=()=>Y=void 0,this.isset=()=>Y!==void 0,this.dispose=()=>{Y&&(Y(),Y=void 0,o(this))},this}}t.$Xc=O;class v{constructor(){this.a=new Map}acquire(B,...Y){let X=this.a.get(B);X||(X={counter:0,object:this.b(B,...Y)},this.a.set(B,X));const{object:de}=X,oe=(0,U.$db)(()=>{--X.counter===0&&(this.c(B,X.object),this.a.delete(B))});return X.counter++,{object:de,dispose:oe}}}t.$Yc=v;class C{constructor(B){this.a=B}async acquire(B,...Y){const X=this.a.acquire(B,...Y);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(de){throw X.dispose(),de}}}t.$Zc=C;class q{constructor(B){this.object=B}dispose(){}}t.$1c=q;function j(L){const B=new f;try{L(B)}finally{B.dispose()}}t.$2c=j;class N{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,Y,X=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this.a.get(B)?.dispose(),this.a.set(B,Y)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=N}),function(ie,t){typeof define=="function"&&define.amd?define(be[79],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(g,m){for(var i=0;i<m.length;i++){var n=m[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(g,n.key,n)}}function A(g,m,i){return m&&t(g.prototype,m),i&&t(g,i),Object.defineProperty(g,"prototype",{writable:!1}),g}function P(g,m){if(g){if(typeof g=="string")return s(g,m);var i=Object.prototype.toString.call(g).slice(8,-1);if(i==="Object"&&g.constructor&&(i=g.constructor.name),i==="Map"||i==="Set")return Array.from(g);if(i==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return s(g,m)}}function s(g,m){(m==null||m>g.length)&&(m=g.length);for(var i=0,n=new Array(m);i<m;i++)n[i]=g[i];return n}function U(g,m){var i=typeof Symbol<"u"&&g[Symbol.iterator]||g["@@iterator"];if(i)return(i=i.call(g)).next.bind(i);if(Array.isArray(g)||(i=P(g))||m&&g&&typeof g.length=="number"){i&&(g=i);var n=0;return function(){return n>=g.length?{done:!0}:{done:!1,value:g[n++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=E();function k(g){ie.defaults=g}var b=/[&<>"']/,w=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(m){return o[m]};function e(g,m){if(m){if(b.test(g))return g.replace(w,a)}else if(y.test(g))return g.replace(I,a);return g}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(g){return g.replace(r,function(m,i){return i=i.toLowerCase(),i==="colon"?":":i.charAt(0)==="#"?i.charAt(1)==="x"?String.fromCharCode(parseInt(i.substring(2),16)):String.fromCharCode(+i.substring(1)):""})}var $=/(^|[^\[])\^/g;function u(g,m){g=typeof g=="string"?g:g.source,m=m||"";var i={replace:function(l,D){return D=D.source||D,D=D.replace($,"$1"),g=g.replace(l,D),i},getRegex:function(){return new RegExp(g,m)}};return i}var p=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(g,m,i){if(g){var n;try{n=decodeURIComponent(d(i)).replace(p,"").toLowerCase()}catch{return null}if(n.indexOf("javascript:")===0||n.indexOf("vbscript:")===0||n.indexOf("data:")===0)return null}m&&!c.test(i)&&(i=O(m,i));try{i=encodeURI(i).replace(/%25/g,"%")}catch{return null}return i}var h={},F=/^[^:]+:\/*[^/]*$/,M=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function O(g,m){h[" "+g]||(F.test(g)?h[" "+g]=g+"/":h[" "+g]=j(g,"/",!0)),g=h[" "+g];var i=g.indexOf(":")===-1;return m.substring(0,2)==="//"?i?m:g.replace(M,"$1")+m:m.charAt(0)==="/"?i?m:g.replace(R,"$1")+m:g+m}var v={exec:function(){}};function C(g){for(var m=1,i,n;m<arguments.length;m++){i=arguments[m];for(n in i)Object.prototype.hasOwnProperty.call(i,n)&&(g[n]=i[n])}return g}function q(g,m){var i=g.replace(/\|/g,function(D,S,z){for(var T=!1,H=S;--H>=0&&z[H]==="\\";)T=!T;return T?"|":" |"}),n=i.split(/ \|/),l=0;if(n[0].trim()||n.shift(),n.length>0&&!n[n.length-1].trim()&&n.pop(),n.length>m)n.splice(m);else for(;n.length<m;)n.push("");for(;l<n.length;l++)n[l]=n[l].trim().replace(/\\\|/g,"|");return n}function j(g,m,i){var n=g.length;if(n===0)return"";for(var l=0;l<n;){var D=g.charAt(n-l-1);if(D===m&&!i)l++;else if(D!==m&&i)l++;else break}return g.slice(0,n-l)}function N(g,m){if(g.indexOf(m[1])===-1)return-1;for(var i=g.length,n=0,l=0;l<i;l++)if(g[l]==="\\")l++;else if(g[l]===m[0])n++;else if(g[l]===m[1]&&(n--,n<0))return l;return-1}function L(g){g&&g.sanitize&&!g.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(g,m){if(m<1)return"";for(var i="";m>1;)m&1&&(i+=g),m>>=1,g+=g;return i+g}function Y(g,m,i,n){var l=m.href,D=m.title?e(m.title):null,S=g[1].replace(/\\([\[\]])/g,"$1");if(g[0].charAt(0)!=="!"){n.state.inLink=!0;var z={type:"link",raw:i,href:l,title:D,text:S,tokens:n.inlineTokens(S)};return n.state.inLink=!1,z}return{type:"image",raw:i,href:l,title:D,text:e(S)}}function X(g,m){var i=g.match(/^(\s+)(?:```)/);if(i===null)return m;var n=i[1];return m.split(`
`).map(function(l){var D=l.match(/^\s+/);if(D===null)return l;var S=D[0];return S.length>=n.length?l.slice(n.length):l}).join(`
`)}var de=function(){function g(i){this.options=i||ie.defaults}var m=g.prototype;return m.space=function(n){var l=this.rules.block.newline.exec(n);if(l&&l[0].length>0)return{type:"space",raw:l[0]}},m.code=function(n){var l=this.rules.block.code.exec(n);if(l){var D=l[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:l[0],codeBlockStyle:"indented",text:this.options.pedantic?D:j(D,`
`)}}},m.fences=function(n){var l=this.rules.block.fences.exec(n);if(l){var D=l[0],S=X(D,l[3]||"");return{type:"code",raw:D,lang:l[2]?l[2].trim():l[2],text:S}}},m.heading=function(n){var l=this.rules.block.heading.exec(n);if(l){var D=l[2].trim();if(/#$/.test(D)){var S=j(D,"#");(this.options.pedantic||!S||/ $/.test(S))&&(D=S.trim())}return{type:"heading",raw:l[0],depth:l[1].length,text:D,tokens:this.lexer.inline(D)}}},m.hr=function(n){var l=this.rules.block.hr.exec(n);if(l)return{type:"hr",raw:l[0]}},m.blockquote=function(n){var l=this.rules.block.blockquote.exec(n);if(l){var D=l[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:l[0],tokens:this.lexer.blockTokens(D,[]),text:D}}},m.list=function(n){var l=this.rules.block.list.exec(n);if(l){var D,S,z,T,H,G,ne,he,ve,$e,ue,Fe,ye=l[1].trim(),Oe=ye.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Oe?"\\d{1,9}\\"+ye.slice(-1):"\\"+ye,this.options.pedantic&&(ye=Oe?ye:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+ye+")((?:[	 ][^\\n]*)?(?:\\n|$))");n&&(Fe=!1,!(!(l=Ie.exec(n))||this.rules.block.hr.test(n)));){if(D=l[0],n=n.substring(D.length),he=l[2].split(`
`,1)[0],ve=n.split(`
`,1)[0],this.options.pedantic?(T=2,ue=he.trimLeft()):(T=l[2].search(/[^ ]/),T=T>4?1:T,ue=he.slice(T),T+=l[1].length),G=!1,!he&&/^ *$/.test(ve)&&(D+=ve+`
`,n=n.substring(ve.length+1),Fe=!0),!Fe)for(var Je=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,T-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Qe=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:```|~~~)"),x=new RegExp("^ {0,"+Math.min(3,T-1)+"}#");n&&($e=n.split(`
`,1)[0],he=$e,this.options.pedantic&&(he=he.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(he)||x.test(he)||Je.test(he)||et.test(n)));){if(he.search(/[^ ]/)>=T||!he.trim())ue+=`
`+he.slice(T);else if(!G)ue+=`
`+he;else break;!G&&!he.trim()&&(G=!0),D+=$e+`
`,n=n.substring($e.length+1)}Be.loose||(ne?Be.loose=!0:/\n *\n *$/.test(D)&&(ne=!0)),this.options.gfm&&(S=/^\[[ xX]\] /.exec(ue),S&&(z=S[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:D,task:!!S,checked:z,loose:!1,text:ue}),Be.raw+=D}Be.items[Be.items.length-1].raw=D.trimRight(),Be.items[Be.items.length-1].text=ue.trimRight(),Be.raw=Be.raw.trimRight();var se=Be.items.length;for(H=0;H<se;H++){this.lexer.state.top=!1,Be.items[H].tokens=this.lexer.blockTokens(Be.items[H].text,[]);var ge=Be.items[H].tokens.filter(function(Ce){return Ce.type==="space"}),Ee=ge.every(function(Ce){for(var Ue=Ce.raw.split(""),qe=0,_e=U(Ue),Ze;!(Ze=_e()).done;){var tt=Ze.value;if(tt===`
`&&(qe+=1),qe>1)return!0}return!1});!Be.loose&&ge.length&&Ee&&(Be.loose=!0,Be.items[H].loose=!0)}return Be}},m.html=function(n){var l=this.rules.block.html.exec(n);if(l){var D={type:"html",raw:l[0],pre:!this.options.sanitizer&&(l[1]==="pre"||l[1]==="script"||l[1]==="style"),text:l[0]};if(this.options.sanitize){var S=this.options.sanitizer?this.options.sanitizer(l[0]):e(l[0]);D.type="paragraph",D.text=S,D.tokens=this.lexer.inline(S)}return D}},m.def=function(n){var l=this.rules.block.def.exec(n);if(l){l[3]&&(l[3]=l[3].substring(1,l[3].length-1));var D=l[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:D,raw:l[0],href:l[2],title:l[3]}}},m.table=function(n){var l=this.rules.block.table.exec(n);if(l){var D={type:"table",header:q(l[1]).map(function(ne){return{text:ne}}),align:l[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:l[3]&&l[3].trim()?l[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(D.header.length===D.align.length){D.raw=l[0];var S=D.align.length,z,T,H,G;for(z=0;z<S;z++)/^ *-+: *$/.test(D.align[z])?D.align[z]="right":/^ *:-+: *$/.test(D.align[z])?D.align[z]="center":/^ *:-+ *$/.test(D.align[z])?D.align[z]="left":D.align[z]=null;for(S=D.rows.length,z=0;z<S;z++)D.rows[z]=q(D.rows[z],D.header.length).map(function(ne){return{text:ne}});for(S=D.header.length,T=0;T<S;T++)D.header[T].tokens=this.lexer.inline(D.header[T].text);for(S=D.rows.length,T=0;T<S;T++)for(G=D.rows[T],H=0;H<G.length;H++)G[H].tokens=this.lexer.inline(G[H].text);return D}}},m.lheading=function(n){var l=this.rules.block.lheading.exec(n);if(l)return{type:"heading",raw:l[0],depth:l[2].charAt(0)==="="?1:2,text:l[1],tokens:this.lexer.inline(l[1])}},m.paragraph=function(n){var l=this.rules.block.paragraph.exec(n);if(l){var D=l[1].charAt(l[1].length-1)===`
`?l[1].slice(0,-1):l[1];return{type:"paragraph",raw:l[0],text:D,tokens:this.lexer.inline(D)}}},m.text=function(n){var l=this.rules.block.text.exec(n);if(l)return{type:"text",raw:l[0],text:l[0],tokens:this.lexer.inline(l[0])}},m.escape=function(n){var l=this.rules.inline.escape.exec(n);if(l)return{type:"escape",raw:l[0],text:e(l[1])}},m.tag=function(n){var l=this.rules.inline.tag.exec(n);if(l)return!this.lexer.state.inLink&&/^<a /i.test(l[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(l[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(l[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(l[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:l[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(l[0]):e(l[0]):l[0]}},m.link=function(n){var l=this.rules.inline.link.exec(n);if(l){var D=l[2].trim();if(!this.options.pedantic&&/^</.test(D)){if(!/>$/.test(D))return;var S=j(D.slice(0,-1),"\\");if((D.length-S.length)%2===0)return}else{var z=N(l[2],"()");if(z>-1){var T=l[0].indexOf("!")===0?5:4,H=T+l[1].length+z;l[2]=l[2].substring(0,z),l[0]=l[0].substring(0,H).trim(),l[3]=""}}var G=l[2],ne="";if(this.options.pedantic){var he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);he&&(G=he[1],ne=he[3])}else ne=l[3]?l[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(D)?G=G.slice(1):G=G.slice(1,-1)),Y(l,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:ne&&ne.replace(this.rules.inline._escapes,"$1")},l[0],this.lexer)}},m.reflink=function(n,l){var D;if((D=this.rules.inline.reflink.exec(n))||(D=this.rules.inline.nolink.exec(n))){var S=(D[2]||D[1]).replace(/\s+/g," ");if(S=l[S.toLowerCase()],!S||!S.href){var z=D[0].charAt(0);return{type:"text",raw:z,text:z}}return Y(D,S,D[0],this.lexer)}},m.emStrong=function(n,l,D){D===void 0&&(D="");var S=this.rules.inline.emStrong.lDelim.exec(n);if(S&&!(S[3]&&D.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=S[1]||S[2]||"";if(!z||z&&(D===""||this.rules.inline.punctuation.exec(D))){var T=S[0].length-1,H,G,ne=T,he=0,ve=S[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ve.lastIndex=0,l=l.slice(-1*n.length+T);(S=ve.exec(l))!=null;)if(H=S[1]||S[2]||S[3]||S[4]||S[5]||S[6],!!H){if(G=H.length,S[3]||S[4]){ne+=G;continue}else if((S[5]||S[6])&&T%3&&!((T+G)%3)){he+=G;continue}if(ne-=G,!(ne>0)){if(G=Math.min(G,G+ne+he),Math.min(T,G)%2){var $e=n.slice(1,T+S.index+G);return{type:"em",raw:n.slice(0,T+S.index+G+1),text:$e,tokens:this.lexer.inlineTokens($e)}}var ue=n.slice(2,T+S.index+G-1);return{type:"strong",raw:n.slice(0,T+S.index+G+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},m.codespan=function(n){var l=this.rules.inline.code.exec(n);if(l){var D=l[2].replace(/\n/g," "),S=/[^ ]/.test(D),z=/^ /.test(D)&&/ $/.test(D);return S&&z&&(D=D.substring(1,D.length-1)),D=e(D,!0),{type:"codespan",raw:l[0],text:D}}},m.br=function(n){var l=this.rules.inline.br.exec(n);if(l)return{type:"br",raw:l[0]}},m.del=function(n){var l=this.rules.inline.del.exec(n);if(l)return{type:"del",raw:l[0],text:l[2],tokens:this.lexer.inlineTokens(l[2])}},m.autolink=function(n,l){var D=this.rules.inline.autolink.exec(n);if(D){var S,z;return D[2]==="@"?(S=e(this.options.mangle?l(D[1]):D[1]),z="mailto:"+S):(S=e(D[1]),z=S),{type:"link",raw:D[0],text:S,href:z,tokens:[{type:"text",raw:S,text:S}]}}},m.url=function(n,l){var D;if(D=this.rules.inline.url.exec(n)){var S,z;if(D[2]==="@")S=e(this.options.mangle?l(D[0]):D[0]),z="mailto:"+S;else{var T;do T=D[0],D[0]=this.rules.inline._backpedal.exec(D[0])[0];while(T!==D[0]);S=e(D[0]),D[1]==="www."?z="http://"+S:z=S}return{type:"link",raw:D[0],text:S,href:z,tokens:[{type:"text",raw:S,text:S}]}}},m.inlineText=function(n,l){var D=this.rules.inline.text.exec(n);if(D){var S;return this.lexer.state.inRawBlock?S=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(D[0]):e(D[0]):D[0]:S=e(this.options.smartypants?l(D[0]):D[0]),{type:"text",raw:D[0],text:S}}},g}(),oe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=u(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.listItemStart=u(/^( *)(bull) */).replace("bull",oe.bullet).getRegex(),oe.list=u(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=u(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=u(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=u(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=C({},oe),oe.gfm=C({},oe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.table=u(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.paragraph=u(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",oe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=C({},oe.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:u(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=u(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=u(oe._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=u(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=u(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=u(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=u(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=u(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=u(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=u(ee.reflink).replace("label",ee._label).replace("ref",oe._label).getRegex(),ee.nolink=u(ee.nolink).replace("ref",oe._label).getRegex(),ee.reflinkSearch=u(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=C({},ee),ee.pedantic=C({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=C({},ee.normal,{escape:u(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=u(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=C({},ee.gfm,{br:u(ee.br).replace("{2,}","*").getRegex(),text:u(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(g){return g.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Te(g){var m="",i,n,l=g.length;for(i=0;i<l;i++)n=g.charCodeAt(i),Math.random()>.5&&(n="x"+n.toString(16)),m+="&#"+n+";";return m}var Ne=function(){function g(i){this.tokens=[],this.tokens.links=Object.create(null),this.options=i||ie.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var n={block:oe.normal,inline:ee.normal};this.options.pedantic?(n.block=oe.pedantic,n.inline=ee.pedantic):this.options.gfm&&(n.block=oe.gfm,this.options.breaks?n.inline=ee.breaks:n.inline=ee.gfm),this.tokenizer.rules=n}g.lex=function(n,l){var D=new g(l);return D.lex(n)},g.lexInline=function(n,l){var D=new g(l);return D.inlineTokens(n)};var m=g.prototype;return m.lex=function(n){n=n.replace(/\r\n|\r/g,`
`),this.blockTokens(n,this.tokens);for(var l;l=this.inlineQueue.shift();)this.inlineTokens(l.src,l.tokens);return this.tokens},m.blockTokens=function(n,l){var D=this;l===void 0&&(l=[]),this.options.pedantic?n=n.replace(/\t/g,"    ").replace(/^ +$/gm,""):n=n.replace(/^( *)(\t+)/gm,function(ne,he,ve){return he+"    ".repeat(ve.length)});for(var S,z,T,H;n;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ne){return(S=ne.call({lexer:D},n,l))?(n=n.substring(S.raw.length),l.push(S),!0):!1}))){if(S=this.tokenizer.space(n)){n=n.substring(S.raw.length),S.raw.length===1&&l.length>0?l[l.length-1].raw+=`
`:l.push(S);continue}if(S=this.tokenizer.code(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+S.raw,z.text+=`
`+S.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):l.push(S);continue}if(S=this.tokenizer.fences(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.heading(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.hr(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.blockquote(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.list(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.html(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.def(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+S.raw,z.text+=`
`+S.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[S.tag]||(this.tokens.links[S.tag]={href:S.href,title:S.title});continue}if(S=this.tokenizer.table(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.lheading(n)){n=n.substring(S.raw.length),l.push(S);continue}if(T=n,this.options.extensions&&this.options.extensions.startBlock&&function(){var ne=1/0,he=n.slice(1),ve=void 0;D.options.extensions.startBlock.forEach(function($e){ve=$e.call({lexer:this},he),typeof ve=="number"&&ve>=0&&(ne=Math.min(ne,ve))}),ne<1/0&&ne>=0&&(T=n.substring(0,ne+1))}(),this.state.top&&(S=this.tokenizer.paragraph(T))){z=l[l.length-1],H&&z.type==="paragraph"?(z.raw+=`
`+S.raw,z.text+=`
`+S.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):l.push(S),H=T.length!==n.length,n=n.substring(S.raw.length);continue}if(S=this.tokenizer.text(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&z.type==="text"?(z.raw+=`
`+S.raw,z.text+=`
`+S.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):l.push(S);continue}if(n){var G="Infinite loop on byte: "+n.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,l},m.inline=function(n,l){return l===void 0&&(l=[]),this.inlineQueue.push({src:n,tokens:l}),l},m.inlineTokens=function(n,l){var D=this;l===void 0&&(l=[]);var S,z,T,H=n,G,ne,he;if(this.tokens.links){var ve=Object.keys(this.tokens.links);if(ve.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)ve.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,G.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;n;)if(ne||(he=""),ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(S=ue.call({lexer:D},n,l))?(n=n.substring(S.raw.length),l.push(S),!0):!1}))){if(S=this.tokenizer.escape(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.tag(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&S.type==="text"&&z.type==="text"?(z.raw+=S.raw,z.text+=S.text):l.push(S);continue}if(S=this.tokenizer.link(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.reflink(n,this.tokens.links)){n=n.substring(S.raw.length),z=l[l.length-1],z&&S.type==="text"&&z.type==="text"?(z.raw+=S.raw,z.text+=S.text):l.push(S);continue}if(S=this.tokenizer.emStrong(n,H,he)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.codespan(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.br(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.del(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.autolink(n,Te)){n=n.substring(S.raw.length),l.push(S);continue}if(!this.state.inLink&&(S=this.tokenizer.url(n,Te))){n=n.substring(S.raw.length),l.push(S);continue}if(T=n,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Fe=n.slice(1),ye=void 0;D.options.extensions.startInline.forEach(function(Oe){ye=Oe.call({lexer:this},Fe),typeof ye=="number"&&ye>=0&&(ue=Math.min(ue,ye))}),ue<1/0&&ue>=0&&(T=n.substring(0,ue+1))}(),S=this.tokenizer.inlineText(T,me)){n=n.substring(S.raw.length),S.raw.slice(-1)!=="_"&&(he=S.raw.slice(-1)),ne=!0,z=l[l.length-1],z&&z.type==="text"?(z.raw+=S.raw,z.text+=S.text):l.push(S);continue}if(n){var $e="Infinite loop on byte: "+n.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return l},A(g,null,[{key:"rules",get:function(){return{block:oe,inline:ee}}}]),g}(),Me=function(){function g(i){this.options=i||ie.defaults}var m=g.prototype;return m.code=function(n,l,D){var S=(l||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(n,S);z!=null&&z!==n&&(D=!0,n=z)}return n=n.replace(/\n$/,"")+`
`,S?'<pre><code class="'+this.options.langPrefix+e(S,!0)+'">'+(D?n:e(n,!0))+`</code></pre>
`:"<pre><code>"+(D?n:e(n,!0))+`</code></pre>
`},m.blockquote=function(n){return`<blockquote>
`+n+`</blockquote>
`},m.html=function(n){return n},m.heading=function(n,l,D,S){if(this.options.headerIds){var z=this.options.headerPrefix+S.slug(D);return"<h"+l+' id="'+z+'">'+n+"</h"+l+`>
`}return"<h"+l+">"+n+"</h"+l+`>
`},m.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},m.list=function(n,l,D){var S=l?"ol":"ul",z=l&&D!==1?' start="'+D+'"':"";return"<"+S+z+`>
`+n+"</"+S+`>
`},m.listitem=function(n){return"<li>"+n+`</li>
`},m.checkbox=function(n){return"<input "+(n?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},m.paragraph=function(n){return"<p>"+n+`</p>
`},m.table=function(n,l){return l&&(l="<tbody>"+l+"</tbody>"),`<table>
<thead>
`+n+`</thead>
`+l+`</table>
`},m.tablerow=function(n){return`<tr>
`+n+`</tr>
`},m.tablecell=function(n,l){var D=l.header?"th":"td",S=l.align?"<"+D+' align="'+l.align+'">':"<"+D+">";return S+n+("</"+D+`>
`)},m.strong=function(n){return"<strong>"+n+"</strong>"},m.em=function(n){return"<em>"+n+"</em>"},m.codespan=function(n){return"<code>"+n+"</code>"},m.br=function(){return this.options.xhtml?"<br/>":"<br>"},m.del=function(n){return"<del>"+n+"</del>"},m.link=function(n,l,D){if(n=f(this.options.sanitize,this.options.baseUrl,n),n===null)return D;var S='<a href="'+e(n)+'"';return l&&(S+=' title="'+l+'"'),S+=">"+D+"</a>",S},m.image=function(n,l,D){if(n=f(this.options.sanitize,this.options.baseUrl,n),n===null)return D;var S='<img src="'+n+'" alt="'+D+'"';return l&&(S+=' title="'+l+'"'),S+=this.options.xhtml?"/>":">",S},m.text=function(n){return n},g}(),re=function(){function g(){}var m=g.prototype;return m.strong=function(n){return n},m.em=function(n){return n},m.codespan=function(n){return n},m.del=function(n){return n},m.html=function(n){return n},m.text=function(n){return n},m.link=function(n,l,D){return""+D},m.image=function(n,l,D){return""+D},m.br=function(){return""},g}(),J=function(){function g(){this.seen={}}var m=g.prototype;return m.serialize=function(n){return n.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},m.getNextSafeSlug=function(n,l){var D=n,S=0;if(this.seen.hasOwnProperty(D)){S=this.seen[n];do S++,D=n+"-"+S;while(this.seen.hasOwnProperty(D))}return l||(this.seen[n]=S,this.seen[D]=0),D},m.slug=function(n,l){l===void 0&&(l={});var D=this.serialize(n);return this.getNextSafeSlug(D,l.dryrun)},g}(),le=function(){function g(i){this.options=i||ie.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new J}g.parse=function(n,l){var D=new g(l);return D.parse(n)},g.parseInline=function(n,l){var D=new g(l);return D.parseInline(n)};var m=g.prototype;return m.parse=function(n,l){l===void 0&&(l=!0);var D="",S,z,T,H,G,ne,he,ve,$e,ue,Fe,ye,Oe,Be,Ie,Je,et,Qe,x,se=n.length;for(S=0;S<se;S++){if(ue=n[S],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(x=this.options.extensions.renderers[ue.type].call({parser:this},ue),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){D+=x||"";continue}switch(ue.type){case"space":continue;case"hr":{D+=this.renderer.hr();continue}case"heading":{D+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,d(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{D+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(ve="",he="",H=ue.header.length,z=0;z<H;z++)he+=this.renderer.tablecell(this.parseInline(ue.header[z].tokens),{header:!0,align:ue.align[z]});for(ve+=this.renderer.tablerow(he),$e="",H=ue.rows.length,z=0;z<H;z++){for(ne=ue.rows[z],he="",G=ne.length,T=0;T<G;T++)he+=this.renderer.tablecell(this.parseInline(ne[T].tokens),{header:!1,align:ue.align[T]});$e+=this.renderer.tablerow(he)}D+=this.renderer.table(ve,$e);continue}case"blockquote":{$e=this.parse(ue.tokens),D+=this.renderer.blockquote($e);continue}case"list":{for(Fe=ue.ordered,ye=ue.start,Oe=ue.loose,H=ue.items.length,$e="",z=0;z<H;z++)Ie=ue.items[z],Je=Ie.checked,et=Ie.task,Be="",Ie.task&&(Qe=this.renderer.checkbox(Je),Oe?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=Qe+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=Qe+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:Qe}):Be+=Qe),Be+=this.parse(Ie.tokens,Oe),$e+=this.renderer.listitem(Be,et,Je);D+=this.renderer.list($e,Fe,ye);continue}case"html":{D+=this.renderer.html(ue.text);continue}case"paragraph":{D+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for($e=ue.tokens?this.parseInline(ue.tokens):ue.text;S+1<se&&n[S+1].type==="text";)ue=n[++S],$e+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);D+=l?this.renderer.paragraph($e):$e;continue}default:{var ge='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(ge);return}else throw new Error(ge)}}}return D},m.parseInline=function(n,l){l=l||this.renderer;var D="",S,z,T,H=n.length;for(S=0;S<H;S++){if(z=n[S],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(T=this.options.extensions.renderers[z.type].call({parser:this},z),T!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){D+=T||"";continue}switch(z.type){case"escape":{D+=l.text(z.text);break}case"html":{D+=l.html(z.text);break}case"link":{D+=l.link(z.href,z.title,this.parseInline(z.tokens,l));break}case"image":{D+=l.image(z.href,z.title,z.text);break}case"strong":{D+=l.strong(this.parseInline(z.tokens,l));break}case"em":{D+=l.em(this.parseInline(z.tokens,l));break}case"codespan":{D+=l.codespan(z.text);break}case"br":{D+=l.br();break}case"del":{D+=l.del(this.parseInline(z.tokens,l));break}case"text":{D+=l.text(z.text);break}default:{var G='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return D},g}();function K(g,m,i){if(typeof g>"u"||g===null)throw new Error("marked(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");if(typeof m=="function"&&(i=m,m=null),m=C({},K.defaults,m||{}),L(m),i){var n=m.highlight,l;try{l=Ne.lex(g,m)}catch(H){return i(H)}var D=function(G){var ne;if(!G)try{m.walkTokens&&K.walkTokens(l,m.walkTokens),ne=le.parse(l,m)}catch(he){G=he}return m.highlight=n,G?i(G):i(null,ne)};if(!n||n.length<3||(delete m.highlight,!l.length))return D();var S=0;K.walkTokens(l,function(H){H.type==="code"&&(S++,setTimeout(function(){n(H.text,H.lang,function(G,ne){if(G)return D(G);ne!=null&&ne!==H.text&&(H.text=ne,H.escaped=!0),S--,S===0&&D()})},0))}),S===0&&D();return}function z(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,m.silent)return"<p>An error occurred:</p><pre>"+e(H.message+"",!0)+"</pre>";throw H}try{var T=Ne.lex(g,m);if(m.walkTokens){if(m.async)return Promise.all(K.walkTokens(T,m.walkTokens)).then(function(){return le.parse(T,m)}).catch(z);K.walkTokens(T,m.walkTokens)}return le.parse(T,m)}catch(H){z(H)}}K.options=K.setOptions=function(g){return C(K.defaults,g),k(K.defaults),K},K.getDefaults=E,K.defaults=ie.defaults,K.use=function(){for(var g=arguments.length,m=new Array(g),i=0;i<g;i++)m[i]=arguments[i];var n=C.apply(void 0,[{}].concat(m)),l=K.defaults.extensions||{renderers:{},childTokens:{}},D;m.forEach(function(S){if(S.extensions&&(D=!0,S.extensions.forEach(function(T){if(!T.name)throw new Error("extension name required");if(T.renderer){var H=l.renderers?l.renderers[T.name]:null;H?l.renderers[T.name]=function(){for(var G=arguments.length,ne=new Array(G),he=0;he<G;he++)ne[he]=arguments[he];var ve=T.renderer.apply(this,ne);return ve===!1&&(ve=H.apply(this,ne)),ve}:l.renderers[T.name]=T.renderer}if(T.tokenizer){if(!T.level||T.level!=="block"&&T.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");l[T.level]?l[T.level].unshift(T.tokenizer):l[T.level]=[T.tokenizer],T.start&&(T.level==="block"?l.startBlock?l.startBlock.push(T.start):l.startBlock=[T.start]:T.level==="inline"&&(l.startInline?l.startInline.push(T.start):l.startInline=[T.start]))}T.childTokens&&(l.childTokens[T.name]=T.childTokens)})),S.renderer&&function(){var T=K.defaults.renderer||new Me,H=function(he){var ve=T[he];T[he]=function(){for(var $e=arguments.length,ue=new Array($e),Fe=0;Fe<$e;Fe++)ue[Fe]=arguments[Fe];var ye=S.renderer[he].apply(T,ue);return ye===!1&&(ye=ve.apply(T,ue)),ye}};for(var G in S.renderer)H(G);n.renderer=T}(),S.tokenizer&&function(){var T=K.defaults.tokenizer||new de,H=function(he){var ve=T[he];T[he]=function(){for(var $e=arguments.length,ue=new Array($e),Fe=0;Fe<$e;Fe++)ue[Fe]=arguments[Fe];var ye=S.tokenizer[he].apply(T,ue);return ye===!1&&(ye=ve.apply(T,ue)),ye}};for(var G in S.tokenizer)H(G);n.tokenizer=T}(),S.walkTokens){var z=K.defaults.walkTokens;n.walkTokens=function(T){var H=[];return H.push(S.walkTokens.call(this,T)),z&&(H=H.concat(z.call(this,T))),H}}D&&(n.extensions=l),K.setOptions(n)})},K.walkTokens=function(g,m){for(var i=[],n=function(){var z=D.value;switch(i=i.concat(m.call(K,z)),z.type){case"table":{for(var T=U(z.header),H;!(H=T()).done;){var G=H.value;i=i.concat(K.walkTokens(G.tokens,m))}for(var ne=U(z.rows),he;!(he=ne()).done;)for(var ve=he.value,$e=U(ve),ue;!(ue=$e()).done;){var Fe=ue.value;i=i.concat(K.walkTokens(Fe.tokens,m))}break}case"list":{i=i.concat(K.walkTokens(z.items,m));break}default:K.defaults.extensions&&K.defaults.extensions.childTokens&&K.defaults.extensions.childTokens[z.type]?K.defaults.extensions.childTokens[z.type].forEach(function(ye){i=i.concat(K.walkTokens(z[ye],m))}):z.tokens&&(i=i.concat(K.walkTokens(z.tokens,m)))}},l=U(g),D;!(D=l()).done;)n();return i},K.parseInline=function(g,m){if(typeof g>"u"||g===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");m=C({},K.defaults,m||{}),L(m);try{var i=Ne.lexInline(g,m);return m.walkTokens&&K.walkTokens(i,m.walkTokens),le.parseInline(i,m)}catch(n){if(n.message+=`
Please report this to https://github.com/markedjs/marked.`,m.silent)return"<p>An error occurred:</p><pre>"+e(n.message+"",!0)+"</pre>";throw n}},K.Parser=le,K.parser=le.parse,K.Renderer=Me,K.TextRenderer=re,K.Lexer=Ne,K.lexer=Ne.lex,K.Tokenizer=de,K.Slugger=J,K.parse=K;var W=K.options,Z=K.setOptions,ce=K.use,we=K.walkTokens,Ae=K.parseInline,ke=K,Le=le.parse,_=Ne.lex;ie.Lexer=Ne,ie.Parser=le,ie.Renderer=Me,ie.Slugger=J,ie.TextRenderer=re,ie.Tokenizer=de,ie.getDefaults=E,ie.lexer=_,ie.marked=K,ie.options=W,ie.parse=ke,ie.parseInline=Ae,ie.parser=Le,ie.setOptions=Z,ie.use=ce,ie.walkTokens=we,Object.defineProperty(ie,"__esModule",{value:!0})}),define(be[80],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qj=void 0;function A(r){const d=U(r);if(d&&d.length>0)return new Uint32Array(d)}t.$Qj=A;let P=0;const s=new Uint32Array(10);function U(r){if(P=0,E(r,I,4352),P>0||(E(r,o,4449),P>0)||(E(r,a,4520),P>0)||(E(r,e,12593),P))return s.subarray(0,P);if(r>=44032&&r<=55203){const d=r-44032,$=d%588,u=Math.floor(d/588),p=Math.floor($/28),c=$%28-1;if(u<I.length?E(u,I,0):4352+u-12593<e.length&&E(4352+u,e,12593),p<o.length?E(p,o,0):4449+p-12593<e.length&&E(4449+p-12593,e,12593),c>=0&&(c<a.length?E(c,a,0):4520+c-12593<e.length&&E(4520+c-12593,e,12593)),P>0)return s.subarray(0,P)}}function E(r,d,$){r>=$&&r<$+d.length&&k(d[r-$])}function k(r){r!==0&&(s[P++]=r&255,r>>8&&(s[P++]=r>>8&255),r>>16&&(s[P++]=r>>16&255))}var b;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var w;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(w||(w={}));var y;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(y||(y={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),o=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),a=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[81],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YS=void 0;class A{constructor(s,U=0,E=s.length,k=U-1){this.a=s,this.b=U,this.c=E,this.d=k}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$YS=A}),define(be[82],pe([1,0,81]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=t.$ZS=void 0;class P{constructor(E=[],k=10){this.h(E),this.b=k,this.d()}getHistory(){return this.j}add(E){this.a.delete(E),this.a.add(E),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(E){return this.a.has(E)}clear(){this.h([]),this.d()}d(){this.f();const E=this.j;this.c=new A.$YS(E,0,E.length,E.length)}f(){const E=this.j;E.length>this.b&&this.h(E.slice(E.length-this.b))}g(){const E=this.c.current();return E?this.j.indexOf(E):-1}h(E){this.a=new Set;for(const k of E)this.a.add(k)}get j(){const E=[];return this.a.forEach(k=>E.push(k)),E}}t.$ZS=P;class s{get size(){return this.f}constructor(E,k=10){if(this.g=k,E.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:E[0],previous:void 0,next:void 0},this.a=new Set([E[0]]);for(let b=1;b<E.length;b++)this.add(E[b])}add(E){const k={value:E,previous:this.c,next:void 0};for(this.c.next=k,this.c=k,this.d=this.c,this.f++,this.a.has(E)?this.h(E):this.a.add(E);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(E){if(this.c.value===E)return E;const k=this.c.value;return this.a.delete(k),this.c.value=E,this.a.has(E)?this.h(E):this.a.add(E),k}prepend(E){if(this.f===this.g||this.a.has(E))return;const k={value:E,previous:void 0,next:this.b};this.b.previous=k,this.b=k,this.f++,this.a.add(E)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(E){return this.a.has(E)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let E=this.b;for(;E;)yield E.value,E=E.next}h(E){let k=this.b;for(;k!==this.c;)k.value===E&&(k===this.b?(this.b=this.b.next,this.b.previous=void 0):(k.previous.next=k.next,k.next.previous=k.previous),this.f--),k=k.next}}t.$1S=s}),define(be[46],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0l=t.$9l=t.$8l=t.rot=t.$6l=void 0;function A(k,b,w){return Math.min(Math.max(k,b),w)}t.$6l=A;function P(k,b){return(b+k%b)%b}t.rot=P;class s{constructor(){this.a=0}getNext(){return this.a++}}t.$8l=s;class U{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$9l=U;class E{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const w=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$0l=E}),define(be[47],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var A;(function(P){function s(b,w){if(b.start>=w.end||w.start>=b.end)return{start:0,end:0};const y=Math.max(b.start,w.start),I=Math.min(b.end,w.end);return I-y<=0?{start:0,end:0}:{start:y,end:I}}P.intersect=s;function U(b){return b.end-b.start<=0}P.isEmpty=U;function E(b,w){return!U(s(b,w))}P.intersects=E;function k(b,w){const y=[],I={start:b.start,end:Math.min(w.start,b.end)},o={start:Math.max(w.end,b.start),end:b.end};return U(I)||y.push(I),U(o)||y.push(o),y}P.relativeComplement=k})(A||(t.Range=A={}))}),define(be[83],pe([1,0,47]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IR=t.$HR=t.$GR=t.$FR=void 0;function P(b,w){const y=[];for(const I of w){if(b.start>=I.range.end)continue;if(b.end<I.range.start)break;const o=A.Range.intersect(b,I.range);A.Range.isEmpty(o)||y.push({range:o,size:I.size})}return y}t.$FR=P;function s({start:b,end:w},y){return{start:b+y,end:w+y}}t.$GR=s;function U(b){const w=[];let y=null;for(const I of b){const o=I.range.start,a=I.range.end,e=I.size;if(y&&e===y.size){y.range.end=a;continue}y={range:{start:o,end:a},size:e},w.push(y)}return w}t.$HR=U;function E(...b){return U(b.reduce((w,y)=>w.concat(y),[]))}class k{get paddingTop(){return this.c}set paddingTop(w){this.b=this.b+w-this.c,this.c=w}constructor(w){this.a=[],this.b=0,this.c=0,this.c=w??0,this.b=this.c}splice(w,y,I=[]){const o=I.length-y,a=P({start:0,end:w},this.a),e=P({start:w+y,end:Number.POSITIVE_INFINITY},this.a).map(d=>({range:s(d.range,o),size:d.size})),r=I.map((d,$)=>({range:{start:w+$,end:w+$+1},size:d.size}));this.a=E(a,r,e),this.b=this.c+this.a.reduce((d,$)=>d+$.size*($.range.end-$.range.start),0)}get count(){const w=this.a.length;return w?this.a[w-1].range.end:0}get size(){return this.b}indexAt(w){if(w<0)return-1;if(w<this.c)return 0;let y=0,I=this.c;for(const o of this.a){const a=o.range.end-o.range.start,e=I+a*o.size;if(w<e)return y+Math.floor((w-I)/o.size);y+=a,I=e}return y}indexAfter(w){return Math.min(this.indexAt(w)+1,this.count)}positionAt(w){if(w<0)return-1;let y=0,I=0;for(const o of this.a){const a=o.range.end-o.range.start,e=I+a;if(w<e)return this.c+y+(w-I)*o.size;y+=a*o.size,I=e}return-1}}t.$IR=k}),define(be[84],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qd=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(U){return new P(U)}constructor(U){this.c=A&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Qd=P}),define(be[4],pe([1,0,6,43,2,45,84]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.Event=void 0;const k=!1,b=!1;var w;(function(j){j.None=()=>s.$Tc.None;function N(l){if(b){const{onDidAddListener:D}=l,S=e.create();let z=0;l.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),S.print()),D?.()}}}function L(l,D){return Me(l,()=>{},0,void 0,!0,void 0,D)}j.defer=L;function B(l){return(D,S=null,z)=>{let T=!1,H;return H=l(G=>{if(!T)return H?H.dispose():T=!0,D.call(S,G)},null,z),T&&H.dispose(),H}}j.once=B;function Y(l,D,S){return Te((z,T=null,H)=>l(G=>z.call(T,D(G)),null,H),S)}j.map=Y;function X(l,D,S){return Te((z,T=null,H)=>l(G=>{D(G),z.call(T,G)},null,H),S)}j.forEach=X;function de(l,D,S){return Te((z,T=null,H)=>l(G=>D(G)&&z.call(T,G),null,H),S)}j.filter=de;function oe(l){return l}j.signal=oe;function ee(...l){return(D,S=null,z)=>{const T=(0,s.$Qc)(...l.map(H=>H(G=>D.call(S,G))));return Ne(T,z)}}j.any=ee;function me(l,D,S,z){let T=S;return Y(l,H=>(T=D(T,H),T),z)}j.reduce=me;function Te(l,D){let S;const z={onWillAddFirstListener(){S=l(T.fire,T)},onDidRemoveLastListener(){S?.dispose()}};D||N(z);const T=new p(z);return D?.add(T),T.event}function Ne(l,D){return D instanceof Array?D.push(l):D&&D.add(l),l}function Me(l,D,S=100,z=!1,T=!1,H,G){let ne,he,ve,$e=0,ue;const Fe={leakWarningThreshold:H,onWillAddFirstListener(){ne=l(Oe=>{$e++,he=D(he,Oe),z&&!ve&&(ye.fire(he),he=void 0),ue=()=>{const Be=he;he=void 0,ve=void 0,(!z||$e>1)&&ye.fire(Be),$e=0},typeof S=="number"?(clearTimeout(ve),ve=setTimeout(ue,S)):ve===void 0&&(ve=0,queueMicrotask(ue))})},onWillRemoveListener(){T&&$e>0&&ue?.()},onDidRemoveLastListener(){ue=void 0,ne.dispose()}};G||N(Fe);const ye=new p(Fe);return G?.add(ye),ye.event}j.debounce=Me;function re(l,D=0,S){return j.debounce(l,(z,T)=>z?(z.push(T),z):[T],D,void 0,!0,void 0,S)}j.accumulate=re;function J(l,D=(z,T)=>z===T,S){let z=!0,T;return de(l,H=>{const G=z||!D(H,T);return z=!1,T=H,G},S)}j.latch=J;function le(l,D,S){return[j.filter(l,D,S),j.filter(l,z=>!D(z),S)]}j.split=le;function K(l,D=!1,S=[],z){let T=S.slice(),H=l(he=>{T?T.push(he):ne.fire(he)});z&&z.add(H);const G=()=>{T?.forEach(he=>ne.fire(he)),T=null},ne=new p({onWillAddFirstListener(){H||(H=l(he=>ne.fire(he)),z&&z.add(H))},onDidAddFirstListener(){T&&(D?setTimeout(G):G())},onDidRemoveLastListener(){H&&H.dispose(),H=null}});return z&&z.add(ne),ne.event}j.buffer=K;function W(l,D){return(z,T,H)=>{const G=D(new ce);return l(function(ne){const he=G.evaluate(ne);he!==Z&&z.call(T,he)},void 0,H)}}j.chain=W;const Z=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(D){return this.f.push(D),this}forEach(D){return this.f.push(S=>(D(S),S)),this}filter(D){return this.f.push(S=>D(S)?S:Z),this}reduce(D,S){let z=S;return this.f.push(T=>(z=D(z,T),z)),this}latch(D=(S,z)=>S===z){let S=!0,z;return this.f.push(T=>{const H=S||!D(T,z);return S=!1,z=T,H?T:Z}),this}evaluate(D){for(const S of this.f)if(D=S(D),D===Z)break;return D}}function we(l,D,S=z=>z){const z=(...ne)=>G.fire(S(...ne)),T=()=>l.on(D,z),H=()=>l.removeListener(D,z),G=new p({onWillAddFirstListener:T,onDidRemoveLastListener:H});return G.event}j.fromNodeEventEmitter=we;function Ae(l,D,S=z=>z){const z=(...ne)=>G.fire(S(...ne)),T=()=>l.addEventListener(D,z),H=()=>l.removeEventListener(D,z),G=new p({onWillAddFirstListener:T,onDidRemoveLastListener:H});return G.event}j.fromDOMEventEmitter=Ae;function ke(l){return new Promise(D=>B(l)(D))}j.toPromise=ke;function Le(l){const D=new p;return l.then(S=>{D.fire(S)},()=>{D.fire(void 0)}).finally(()=>{D.dispose()}),D.event}j.fromPromise=Le;function _(l,D,S){return D(S),l(z=>D(z))}j.runAndSubscribe=_;function g(l,D){let S=null;function z(H){S?.dispose(),S=new s.$Sc,D(H,S)}z(void 0);const T=l(H=>z(H));return(0,s.$Rc)(()=>{T.dispose(),S?.dispose()})}j.runAndSubscribeWithStore=g;class m{constructor(D,S){this._observable=D,this.f=0,this.g=!1;const z={onWillAddFirstListener:()=>{D.addObserver(this)},onDidRemoveLastListener:()=>{D.removeObserver(this)}};S||N(z),this.emitter=new p(z),S&&S.add(this.emitter)}beginUpdate(D){this.f++}handlePossibleChange(D){}handleChange(D,S){this.g=!0}endUpdate(D){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function i(l,D){return new m(l,D).emitter.event}j.fromObservable=i;function n(l){return(D,S,z)=>{let T=0,H=!1;const G={beginUpdate(){T++},endUpdate(){T--,T===0&&(l.reportChanges(),H&&(H=!1,D.call(S)))},handlePossibleChange(){},handleChange(){H=!0}};l.addObserver(G),l.reportChanges();const ne={dispose(){l.removeObserver(G)}};return z instanceof s.$Sc?z.add(ne):Array.isArray(z)&&z.push(ne),ne}}j.fromObservableLight=n})(w||(t.Event=w={}));class y{static{this.all=new Set}static{this.f=0}constructor(N){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${N}_${y.f++}`,y.all.add(this)}start(N){this.g=new E.$Qd,this.listenerCount=N}stop(){if(this.g){const N=this.g.elapsed();this.durations.push(N),this.elapsedOverall+=N,this.invocationCount+=1,this.g=void 0}}}t.$Sd=y;let I=-1;function o(j){const N=I;return I=j,{dispose(){I=N}}}t.$Td=o;class a{constructor(N,L=Math.random().toString(18).slice(2,5)){this.threshold=N,this.name=L,this.g=0}dispose(){this.f?.clear()}check(N,L){const B=this.threshold;if(B<=0||L<B)return;this.f||(this.f=new Map);const Y=this.f.get(N.value)||0;if(this.f.set(N.value,Y+1),this.g-=1,this.g<=0){this.g=B*.5;let X,de=0;for(const[oe,ee]of this.f)(!X||de<ee)&&(X=oe,de=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${de}):`),console.warn(X)}return()=>{const X=this.f.get(N.value)||0;this.f.set(N.value,X-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(N){this.value=N}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let r=0;class d{constructor(N){this.value=N,this.id=r++}}const $=2,u=(j,N)=>{if(j instanceof d)N(j);else for(let L=0;L<j.length;L++){const B=j[L];B&&N(B)}};class p{constructor(N){this.w=0,this.f=N,this.g=I>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(k){const N=this.t;queueMicrotask(()=>{u(N,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(N,L,B)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;L&&(N=N.bind(L));const Y=new d(N);let X,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=e.create(),X=this.g.check(Y.stack,this.w+1)),k&&(Y.stack=de??e.create()),this.t?this.t instanceof d?(this.u??=new f,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const oe=(0,s.$Rc)(()=>{X?.(),this.x(Y)});return B instanceof s.$Sc?B.add(oe):Array.isArray(B)&&B.push(oe),oe},this.q}x(N){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,B=L.indexOf(N);if(B===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[B]=void 0;const Y=this.u.current===this;if(this.w*$<=L.length){let X=0;for(let de=0;de<L.length;de++)L[de]?L[X++]=L[de]:Y&&(this.u.end--,X<this.u.i&&this.u.i--);L.length=X}}y(N,L){if(!N)return;const B=this.f?.onListenerError||A.$1;if(!B){N.value(L);return}try{N.value(L)}catch(Y){B(Y)}}z(N){const L=N.current.t;for(;N.i<N.end;)this.y(L[N.i++],N.value);N.reset()}fire(N){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,N);else{const L=this.u;L.enqueue(this,N,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Ud=p;const c=()=>new f;t.$Vd=c;class f{constructor(){this.i=-1,this.end=0}enqueue(N,L,B){this.i=0,this.end=B,this.current=N,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends p{async fireAsync(N,L,B){if(this.t)for(this.h||(this.h=new U.$4c),u(this.t,Y=>this.h.push([Y.value,N]));this.h.size>0&&!L.isCancellationRequested;){const[Y,X]=this.h.shift(),de=[],oe={...X,token:L,waitUntil:ee=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");B&&(ee=B(ee,Y)),de.push(ee)}};try{Y(oe)}catch(ee){(0,A.$1)(ee);continue}Object.freeze(de),await Promise.allSettled(de).then(ee=>{for(const me of ee)me.status==="rejected"&&(0,A.$1)(me.reason)})}}}t.$Wd=h;class F extends p{get isPaused(){return this.h!==0}constructor(N){super(N),this.h=0,this.s=new U.$4c,this.A=N?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const N=Array.from(this.s);this.s.clear(),super.fire(this.A(N))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(N){this.w&&(this.h!==0?this.s.push(N):super.fire(N))}}t.$Xd=F;class M extends F{constructor(N){super(N),this.k=N.delay??100}fire(N){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(N)}}t.$Yd=M;class R extends p{constructor(N){super(N),this.h=[],this.k=N?.merge}fire(N){this.hasListeners()&&(this.h.push(N),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}t.$Zd=R;class O{constructor(){this.g=!1,this.h=[],this.f=new p({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(N){const L={event:N,listener:null};this.h.push(L),this.g&&this.m(L);const B=()=>{this.g&&this.o(L);const Y=this.h.indexOf(L);this.h.splice(Y,1)};return(0,s.$Rc)((0,P.$db)(B))}j(){this.g=!0,this.h.forEach(N=>this.m(N))}k(){this.g=!1,this.h.forEach(N=>this.o(N))}m(N){N.listener=N.event(L=>this.f.fire(L))}o(N){N.listener&&N.listener.dispose(),N.listener=null}dispose(){this.f.dispose()}}t.$1d=O;class v{constructor(N,L,B,Y){this.f=new s.$Sc;const X=this.f.add(new O),de=this.f.add(new s.$3c);function oe(ee){de.set(ee,X.add(Y(ee)))}for(const ee of N)oe(ee);this.f.add(L(ee=>{oe(ee)})),this.f.add(B(ee=>{de.deleteAndDispose(ee)})),this.event=X.event}dispose(){this.f.dispose()}}t.$2d=v;class C{constructor(){this.f=[]}wrapEvent(N){return(L,B,Y)=>N(X=>{const de=this.f[this.f.length-1];de?de.push(()=>L.call(B,X)):L.call(B,X)},void 0,Y)}bufferEvents(N){const L=[];this.f.push(L);const B=N();return this.f.pop(),L.forEach(Y=>Y()),B}}t.$3d=C;class q{constructor(){this.f=!1,this.g=w.None,this.h=s.$Tc.None,this.j=new p({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(N){this.g=N,this.f&&(this.h.dispose(),this.h=N(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$4d=q}),define(be[16],pe([1,0,21,4,2]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=void 0;class U{constructor(){this.a=new Map,this.b=new P.$Ud,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new P.$Ud,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new U}getZoomLevel(f){return this.a.get(this.f(f))??0}setZoomLevel(f,h){if(this.getZoomLevel(h)===f)return;const F=this.f(h);this.a.set(F,f),this.b.fire(F)}getZoomFactor(f){return this.c.get(this.f(f))??1}setZoomFactor(f,h){this.c.set(this.f(h),f)}setFullscreen(f,h){if(this.isFullscreen(h)===f)return;const F=this.f(h);this.e.set(F,f),this.d.fire(F)}isFullscreen(f){return!!this.e.get(this.f(f))}f(f){return f.vscodeWindowId}}class E extends s.$Tc{constructor(){super(),this.a=this.B(new P.$Ud),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(f){this.c?.removeEventListener("change",this.b),this.c=A.$window.matchMedia(`(resolution: ${A.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),f&&this.a.fire()}}class k extends s.$Tc{get value(){return this.b}constructor(){super(),this.a=this.B(new P.$Ud),this.onDidChange=this.a.event,this.b=this.c();const f=this.B(new E);this.B(f.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const f=document.createElement("canvas").getContext("2d"),h=A.$window.devicePixelRatio||1,F=f.webkitBackingStorePixelRatio||f.mozBackingStorePixelRatio||f.msBackingStorePixelRatio||f.oBackingStorePixelRatio||f.backingStorePixelRatio||1;return h/F}}class b{constructor(){this.a=null}b(){return this.a||(this.a=(0,s.$Mc)(new k)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function w(c,f,h){typeof f=="string"&&(f=c.matchMedia(f)),f.addEventListener("change",h)}t.$8O=w,t.$9O=new b;function y(c,f){U.INSTANCE.setZoomLevel(c,f)}t.$0O=y;function I(c){return U.INSTANCE.getZoomLevel(c)}t.$$O=I,t.$_O=U.INSTANCE.onDidChangeZoomLevel;function o(c){return U.INSTANCE.getZoomFactor(c)}t.$aP=o;function a(c,f){U.INSTANCE.setZoomFactor(c,f)}t.$bP=a;function e(c,f){U.INSTANCE.setFullscreen(c,f)}t.$cP=e;function r(c){return U.INSTANCE.isFullscreen(c)}t.$dP=r,t.$eP=U.INSTANCE.onDidChangeFullscreen;const d=navigator.userAgent;t.$fP=d.indexOf("Firefox")>=0,t.$gP=d.indexOf("AppleWebKit")>=0,t.$hP=d.indexOf("Chrome")>=0,t.$iP=!t.$hP&&d.indexOf("Safari")>=0,t.$jP=!t.$hP&&!t.$iP&&t.$gP,t.$kP=d.indexOf("Electron/")>=0,t.$lP=d.indexOf("Android")>=0;let $=!1;if(typeof A.$4O.matchMedia=="function"){const c=A.$4O.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),f=A.$4O.matchMedia("(display-mode: fullscreen)");$=c.matches,w(A.$4O,c,({matches:h})=>{$&&f.matches||($=h)})}function u(){return $}t.$mP=u;function p(){return navigator?.windowControlsOverlay?.visible}t.$nP=p}),define(be[22],pe([1,0,4]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=void 0;class P{get event(){return this.a.event}constructor(U,E,k){const b=w=>this.a.fire(w);this.a=new A.$Ud({onWillAddFirstListener:()=>U.addEventListener(E,b,k),onDidRemoveLastListener:()=>U.removeEventListener(E,b,k)})}dispose(){this.a.dispose()}}t.$AR=P}),define(be[29],pe([1,0,4]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5d=t.CancellationToken=void 0;const P=Object.freeze(function(k,b){const w=setTimeout(k.bind(b),0);return{dispose(){clearTimeout(w)}}});var s;(function(k){function b(w){return w===k.None||w===k.Cancelled||w instanceof U?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}k.isCancellationToken=b,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(s||(t.CancellationToken=s={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new A.$Ud),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=s.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=s.None}}t.$5d=E}),define(be[85],pe([1,0,29]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fe=t.$Ee=t.$De=void 0;class P{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new A.$5d,b=this.b(k.token);return this.a={promise:b,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}t.$De=P;class s{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const b=JSON.stringify(k);return this.b!==b&&(this.b=b,this.a=this.c(k)),this.a}}t.$Ee=s;class U{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const b=this.b(k);return this.a.set(k,b),b}}t.$Fe=U}),define(be[48],pe([1,0,4,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ms=t.$ls=t.$ks=t.$js=t.ScrollbarVisibility=void 0;var s;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(s||(t.ScrollbarVisibility=s={}));class U{constructor(e,r,d,$,u,p,c){this.c=e,this._scrollStateBrand=void 0,this.c&&(r=r|0,d=d|0,$=$|0,u=u|0,p=p|0,c=c|0),this.rawScrollLeft=$,this.rawScrollTop=c,r<0&&(r=0),$+r>d&&($=d-r),$<0&&($=0),u<0&&(u=0),c+u>p&&(c=p-u),c<0&&(c=0),this.width=r,this.scrollWidth=d,this.scrollLeft=$,this.height=u,this.scrollHeight=p,this.scrollTop=c}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,r){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,r){const d=this.width!==e.width,$=this.scrollWidth!==e.scrollWidth,u=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,c=this.scrollHeight!==e.scrollHeight,f=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:r,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:d,scrollWidthChanged:$,scrollLeftChanged:u,heightChanged:p,scrollHeightChanged:c,scrollTopChanged:f}}}t.$js=U;class E extends P.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new A.$Ud),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,r){const d=this.g.withScrollDimensions(e,r);this.n(d,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const r=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(e,r){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const d=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===d.scrollLeft&&this.h.to.scrollTop===d.scrollTop)return;let $;r?$=new y(this.h.from,d,this.h.startTime,this.h.duration):$=this.h.combine(this.g,d,this.c),this.h.dispose(),this.h=$}else{const d=this.g.withScrollPosition(e);this.h=y.start(this.g,d,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),r=this.g.withScrollPosition(e);if(this.n(r,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,r){const d=this.g;d.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(d,r)))}}t.$ks=E;class k{constructor(e,r,d){this.scrollLeft=e,this.scrollTop=r,this.isDone=d}}t.$ls=k;function b(a,e){const r=e-a;return function(d){return a+r*o(d)}}function w(a,e,r){return function(d){return d<r?a(d/r):e((d-r)/(1-r))}}class y{constructor(e,r,d,$){this.from=e,this.to=r,this.duration=$,this.startTime=d,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,r,d){if(Math.abs(e-r)>2.5*d){let u,p;return e<r?(u=e+.75*d,p=r-.75*d):(u=e-.75*d,p=r+.75*d),w(b(e,u),b(p,r),.33)}return b(e,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const r=(e-this.startTime)/this.duration;if(r<1){const d=this.c(r),$=this.d(r);return new k(d,$,!1)}return new k(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,r,d){return y.start(e,r,d)}static start(e,r,d){d=d+10;const $=Date.now()-10;return new y(e,r,$,d)}}t.$ms=y;function I(a){return Math.pow(a,3)}function o(a){return 1-I(1-a)}}),define(be[86],pe([1,0,6,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=void 0;function s(c){const f=c;return f?typeof f.read=="function":!1}t.$6d=s;function U(c){const f=c;return f?[f.on,f.pause,f.resume,f.destroy].every(h=>typeof h=="function"):!1}t.$7d=U;function E(c){const f=c;return f?U(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}t.$8d=E;function k(c,f){return new b(c,f)}t.$9d=k;class b{constructor(f,h){this.e=f,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(h=>h(f))}h(f){this.c.error.length===0?(0,A.$1)(f):this.c.error.slice(0).forEach(h=>h(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,h){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(f,h){if(this.a.destroyed)return;let F;switch(f){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const M=F.indexOf(h);M>=0&&F.splice(M,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,f){const h=[];let F;for(;(F=c.read())!==null;)h.push(F);return f(h)}t.$0d=w;function y(c,f,h){const F=[];let M;for(;(M=c.read())!==null&&F.length<h;)F.push(M);return M===null&&F.length>0?f(F):{read:()=>{if(F.length>0)return F.shift();if(typeof M<"u"){const R=M;return M=void 0,R}return c.read()}}}t.$$d=y;function I(c,f){return new Promise((h,F)=>{const M=[];o(c,{onData:R=>{f&&M.push(R)},onError:R=>{f?F(R):h(void 0)},onEnd:()=>{h(f?f(M):void 0)}})})}t.$_d=I;function o(c,f,h){c.on("error",F=>{h?.isCancellationRequested||f.onError(F)}),c.on("end",()=>{h?.isCancellationRequested||f.onEnd()}),c.on("data",F=>{h?.isCancellationRequested||f.onData(F)})}t.$ae=o;function a(c,f){return new Promise((h,F)=>{const M=new P.$Sc,R=[],O=q=>{if(R.push(q),R.length>f)return M.dispose(),c.pause(),h({stream:c,buffer:R,ended:!1})},v=q=>(M.dispose(),F(q)),C=()=>(M.dispose(),h({stream:c,buffer:R,ended:!0}));M.add((0,P.$Rc)(()=>c.removeListener("error",v))),c.on("error",v),M.add((0,P.$Rc)(()=>c.removeListener("end",C))),c.on("end",C),M.add((0,P.$Rc)(()=>c.removeListener("data",O))),c.on("data",O)})}t.$be=a;function e(c,f){const h=k(f);return h.end(c),h}t.$ce=e;function r(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}t.$de=r;function d(c){let f=!1;return{read:()=>f?null:(f=!0,c)}}t.$ee=d;function $(c,f,h){const F=k(h);return o(c,{onData:M=>F.write(f.data(M)),onError:M=>F.error(f.error?f.error(M):M),onEnd:()=>F.end()}),F}t.$fe=$;function u(c,f,h){let F=!1;return{read:()=>{const M=f.read();return F?M:(F=!0,M!==null?h([c,M]):c)}}}t.$ge=u;function p(c,f,h){let F=!1;const M=k(h);return o(f,{onData:R=>F?M.write(R):(F=!0,M.write(h([c,R]))),onError:R=>M.error(R),onEnd:()=>{F||(F=!0,M.write(c)),M.end()}}),M}t.$he=p}),define(be[33],pe([1,0,23,86]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=void 0;const s=typeof Buffer<"u",U=new A.$V(()=>new Uint8Array(256));let E,k;class b{static alloc(L){return s?new b(Buffer.allocUnsafe(L)):new b(new Uint8Array(L))}static wrap(L){return s&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new b(L)}static fromString(L,B){return!(B?.dontUseNodeBuffer||!1)&&s?new b(Buffer.from(L)):(E||(E=new TextEncoder),new b(E.encode(L)))}static fromByteArray(L){const B=b.alloc(L.length);for(let Y=0,X=L.length;Y<X;Y++)B.buffer[Y]=L[Y];return B}static concat(L,B){if(typeof B>"u"){B=0;for(let de=0,oe=L.length;de<oe;de++)B+=L[de].byteLength}const Y=b.alloc(B);let X=0;for(let de=0,oe=L.length;de<oe;de++){const ee=L[de];Y.set(ee,X),X+=ee.byteLength}return Y}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=b.alloc(this.byteLength);return L.set(this),L}toString(){return s?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(L,B){return new b(this.buffer.subarray(L,B))}set(L,B){if(L instanceof b)this.buffer.set(L.buffer,B);else if(L instanceof Uint8Array)this.buffer.set(L,B);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),B);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return o(this.buffer,L)}writeUInt32BE(L,B){a(this.buffer,L,B)}readUInt32LE(L){return e(this.buffer,L)}writeUInt32LE(L,B){r(this.buffer,L,B)}readUInt8(L){return d(this.buffer,L)}writeUInt8(L,B){$(this.buffer,L,B)}indexOf(L,B=0){return w(this.buffer,L instanceof b?L.buffer:L,B)}}t.$ie=b;function w(N,L,B=0){const Y=L.byteLength,X=N.byteLength;if(Y===0)return 0;if(Y===1)return N.indexOf(L[0]);if(Y>X-B)return-1;const de=U.value;de.fill(L.length);for(let Te=0;Te<L.length;Te++)de[L[Te]]=L.length-Te-1;let oe=B+L.length-1,ee=oe,me=-1;for(;oe<X;)if(N[oe]===L[ee]){if(ee===0){me=oe;break}oe--,ee--}else oe+=Math.max(L.length-ee,de[N[oe]]),ee=L.length-1;return me}t.$je=w;function y(N,L){return N[L+0]<<0>>>0|N[L+1]<<8>>>0}t.$ke=y;function I(N,L,B){N[B+0]=L&255,L=L>>>8,N[B+1]=L&255}t.$le=I;function o(N,L){return N[L]*2**24+N[L+1]*2**16+N[L+2]*2**8+N[L+3]}t.$me=o;function a(N,L,B){N[B+3]=L,L=L>>>8,N[B+2]=L,L=L>>>8,N[B+1]=L,L=L>>>8,N[B]=L}t.$ne=a;function e(N,L){return N[L+0]<<0>>>0|N[L+1]<<8>>>0|N[L+2]<<16>>>0|N[L+3]<<24>>>0}t.$oe=e;function r(N,L,B){N[B+0]=L&255,L=L>>>8,N[B+1]=L&255,L=L>>>8,N[B+2]=L&255,L=L>>>8,N[B+3]=L&255}t.$pe=r;function d(N,L){return N[L]}t.$qe=d;function $(N,L,B){N[B]=L}t.$re=$;function u(N){return P.$0d(N,L=>b.concat(L))}t.$se=u;function p(N){return P.$ee(N)}t.$te=p;function c(N){return P.$_d(N,L=>b.concat(L))}t.$ue=c;async function f(N){return N.ended?b.concat(N.buffer):b.concat([...N.buffer,await c(N.stream)])}t.$ve=f;function h(N){return P.$ce(N,L=>b.concat(L))}t.$we=h;function F(N){return P.$fe(N,{data:L=>typeof L=="string"?b.fromString(L):b.wrap(L)},L=>b.concat(L))}t.$xe=F;function M(N){return P.$9d(L=>b.concat(L),N)}t.$ye=M;function R(N,L){return P.$ge(N,L,B=>b.concat(B))}t.$ze=R;function O(N,L){return P.$he(N,L,B=>b.concat(B))}t.$Ae=O;function v(N){let L=0,B=0,Y=0;const X=new Uint8Array(Math.floor(N.length/4*3)),de=ee=>{switch(B){case 3:X[Y++]=L|ee,B=0;break;case 2:X[Y++]=L|ee>>>2,L=ee<<6,B=3;break;case 1:X[Y++]=L|ee>>>4,L=ee<<4,B=2;break;default:L=ee<<2,B=1}};for(let ee=0;ee<N.length;ee++){const me=N.charCodeAt(ee);if(me>=65&&me<=90)de(me-65);else if(me>=97&&me<=122)de(me-97+26);else if(me>=48&&me<=57)de(me-48+52);else if(me===43||me===45)de(62);else if(me===47||me===95)de(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ee]}`)}}const oe=Y;for(;B>0;)de(0);return b.wrap(X).slice(0,oe)}t.$Be=v;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",q="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:N},L=!0,B=!1){const Y=B?q:C;let X="";const de=N.byteLength%3;let oe=0;for(;oe<N.byteLength-de;oe+=3){const ee=N[oe+0],me=N[oe+1],Te=N[oe+2];X+=Y[ee>>>2],X+=Y[(ee<<4|me>>>4)&63],X+=Y[(me<<2|Te>>>6)&63],X+=Y[Te&63]}if(de===1){const ee=N[oe+0];X+=Y[ee>>>2],X+=Y[ee<<4&63],L&&(X+="==")}else if(de===2){const ee=N[oe+0],me=N[oe+1];X+=Y[ee>>>2],X+=Y[(ee<<4|me>>>4)&63],X+=Y[me<<2&63],L&&(X+="=")}return X}t.$Ce=j}),define(be[10],pe([1,0,85,23]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gf=t.$Ff=t.$Ef=t.$Df=t.GraphemeBreakType=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=void 0;function s(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.$Ie=s;const U=/{(\d+)}/g;function E(x,...se){return se.length===0?x:x.replace(U,function(ge,Ee){const Ce=parseInt(Ee,10);return isNaN(Ce)||Ce<0||Ce>=se.length?ge:se[Ce]})}t.$Je=E;const k=/{([^}]+)}/g;function b(x,se){return Object.keys(se).length===0?x:x.replace(k,(ge,Ee)=>se[Ee]??ge)}t.$Ke=b;function w(x){return x.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}t.$Le=w;function y(x){return x.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}t.$Me=y;function I(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ne=I;function o(x,se){let ge=0;const Ee=se.charCodeAt(0);for(let Ce=x.length-1;Ce>=0;Ce--)x.charCodeAt(Ce)===Ee&&ge++;return ge}t.$Oe=o;function a(x,se,ge="\u2026"){return x.length<=se?x:`${x.substr(0,se)}${ge}`}t.$Pe=a;function e(x,se,ge="\u2026"){if(x.length<=se)return x;const Ee=Math.ceil(se/2)-ge.length/2,Ce=Math.floor(se/2)-ge.length/2;return`${x.substr(0,Ee)}${ge}${x.substr(x.length-Ce)}`}t.$Qe=e;function r(x,se=" "){const ge=d(x,se);return $(ge,se)}t.$Re=r;function d(x,se){if(!x||!se)return x;const ge=se.length;if(ge===0||x.length===0)return x;let Ee=0;for(;x.indexOf(se,Ee)===Ee;)Ee=Ee+ge;return x.substring(Ee)}t.$Se=d;function $(x,se){if(!x||!se)return x;const ge=se.length,Ee=x.length;if(ge===0||Ee===0)return x;let Ce=Ee,Ue=-1;for(;Ue=x.lastIndexOf(se,Ce-1),!(Ue===-1||Ue+ge!==Ce);){if(Ue===0)return"";Ce=Ue}return x.substring(0,Ce)}t.$Te=$;function u(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Ue=u;function p(x){return x.replace(/\*/g,"")}t.$Ve=p;function c(x,se,ge={}){if(!x)throw new Error("Cannot create regex from empty string");se||(x=I(x)),ge.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ee="";return ge.global&&(Ee+="g"),ge.matchCase||(Ee+="i"),ge.multiline&&(Ee+="m"),ge.unicode&&(Ee+="u"),new RegExp(x,Ee)}t.$We=c;function f(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.$Xe=f;function h(x){return x.split(/\r\n|\r|\n/)}t.$Ye=h;function F(x){for(let se=0,ge=x.length;se<ge;se++){const Ee=x.charCodeAt(se);if(Ee!==32&&Ee!==9)return se}return-1}t.$Ze=F;function M(x,se=0,ge=x.length){for(let Ee=se;Ee<ge;Ee++){const Ce=x.charCodeAt(Ee);if(Ce!==32&&Ce!==9)return x.substring(se,Ee)}return x.substring(se,ge)}t.$1e=M;function R(x,se=x.length-1){for(let ge=se;ge>=0;ge--){const Ee=x.charCodeAt(ge);if(Ee!==32&&Ee!==9)return ge}return-1}t.$2e=R;function O(x,se,ge){const Ee=[];let Ce=0;for(const Ue of x.matchAll(se)){if(Ee.push(x.slice(Ce,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Ce=Ue.index+Ue[0].length,Ee.push(ge(Ue[0],...Ue.slice(1),Ue.index,x,Ue.groups))}return Ee.push(x.slice(Ce)),Promise.all(Ee).then(Ue=>Ue.join(""))}t.$3e=O;function v(x,se){return x<se?-1:x>se?1:0}t.$4e=v;function C(x,se,ge=0,Ee=x.length,Ce=0,Ue=se.length){for(;ge<Ee&&Ce<Ue;ge++,Ce++){const Ze=x.charCodeAt(ge),tt=se.charCodeAt(Ce);if(Ze<tt)return-1;if(Ze>tt)return 1}const qe=Ee-ge,_e=Ue-Ce;return qe<_e?-1:qe>_e?1:0}t.$5e=C;function q(x,se){return j(x,se,0,x.length,0,se.length)}t.$6e=q;function j(x,se,ge=0,Ee=x.length,Ce=0,Ue=se.length){for(;ge<Ee&&Ce<Ue;ge++,Ce++){let Ze=x.charCodeAt(ge),tt=se.charCodeAt(Ce);if(Ze===tt)continue;if(Ze>=128||tt>=128)return C(x.toLowerCase(),se.toLowerCase(),ge,Ee,Ce,Ue);L(Ze)&&(Ze-=32),L(tt)&&(tt-=32);const Xe=Ze-tt;if(Xe!==0)return Xe}const qe=Ee-ge,_e=Ue-Ce;return qe<_e?-1:qe>_e?1:0}t.$7e=j;function N(x){return x>=48&&x<=57}t.$8e=N;function L(x){return x>=97&&x<=122}t.$9e=L;function B(x){return x>=65&&x<=90}t.$0e=B;function Y(x,se){return x.length===se.length&&j(x,se)===0}t.$$e=Y;function X(x,se){const ge=se.length;return se.length>x.length?!1:j(x,se,0,ge)===0}t.$_e=X;function de(x,se){const ge=Math.min(x.length,se.length);let Ee;for(Ee=0;Ee<ge;Ee++)if(x.charCodeAt(Ee)!==se.charCodeAt(Ee))return Ee;return ge}t.$af=de;function oe(x,se){const ge=Math.min(x.length,se.length);let Ee;const Ce=x.length-1,Ue=se.length-1;for(Ee=0;Ee<ge;Ee++)if(x.charCodeAt(Ce-Ee)!==se.charCodeAt(Ue-Ee))return Ee;return ge}t.$bf=oe;function ee(x){return 55296<=x&&x<=56319}t.$cf=ee;function me(x){return 56320<=x&&x<=57343}t.$df=me;function Te(x,se){return(x-55296<<10)+(se-56320)+65536}t.$ef=Te;function Ne(x,se,ge){const Ee=x.charCodeAt(ge);if(ee(Ee)&&ge+1<se){const Ce=x.charCodeAt(ge+1);if(me(Ce))return Te(Ee,Ce)}return Ee}t.$ff=Ne;function Me(x,se){const ge=x.charCodeAt(se-1);if(me(ge)&&se>1){const Ee=x.charCodeAt(se-2);if(ee(Ee))return Te(Ee,ge)}return ge}class re{get offset(){return this.e}constructor(se,ge=0){this.c=se,this.d=se.length,this.e=ge}setOffset(se){this.e=se}prevCodePoint(){const se=Me(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=Ne(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}t.$gf=re;class J{get offset(){return this.c.offset}constructor(se,ge=0){this.c=new re(se,ge)}nextGraphemeLength(){const se=Fe.getInstance(),ge=this.c,Ee=ge.offset;let Ce=se.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ue=ge.offset,qe=se.getGraphemeBreakType(ge.nextCodePoint());if($e(Ce,qe)){ge.setOffset(Ue);break}Ce=qe}return ge.offset-Ee}prevGraphemeLength(){const se=Fe.getInstance(),ge=this.c,Ee=ge.offset;let Ce=se.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ue=ge.offset,qe=se.getGraphemeBreakType(ge.prevCodePoint());if($e(qe,Ce)){ge.setOffset(Ue);break}Ce=qe}return Ee-ge.offset}eol(){return this.c.eol()}}t.$hf=J;function le(x,se){return new J(x,se).nextGraphemeLength()}t.$if=le;function K(x,se){return new J(x,se).prevGraphemeLength()}t.$jf=K;function W(x,se){se>0&&me(x.charCodeAt(se))&&se--;const ge=se+le(x,se);return[ge-K(x,ge),ge]}t.$kf=W;function Z(x){const se=new J(x);let ge=0;for(;!se.eol();)ge++,se.nextGraphemeLength();return ge}t.$lf=Z;let ce;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ae(x){return ce||(ce=we()),ce.test(x)}t.$mf=Ae;const ke=/^[\t\n\r\x20-\x7E]*$/;function Le(x){return ke.test(x)}t.$nf=Le,t.$of=/[\u2028\u2029]/;function _(x){return t.$of.test(x)}t.$pf=_;function g(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.$qf=g;function m(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.$rf=m;function i(x,se,ge=""){const Ee=x.trimStart();if(Ee.length<se)return Ee;const Ce=/\b/g;let Ue=0;for(;Ce.test(Ee)&&!(Ee.length-Ce.lastIndex<se);)Ue=Ce.lastIndex,Ce.lastIndex+=1;return Ue===0?Ee:ge+Ee.substring(Ue).trimStart()}t.$sf=i;const n=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,l=/\x1b\].*?\x07/g;function D(x){return x&&(x=x.replace(n,"").replace(l,"")),x}t.$tf=D,t.$uf=String.fromCharCode(65279);function S(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.$vf=S;function z(x){return S(x)?x.substr(1):x}t.$wf=z;function T(x,se){if(!x||!se||x.length<se.length)return!1;const ge=se.length,Ee=x.toLowerCase();let Ce=0,Ue=-1;for(;Ce<ge;){const qe=Ee.indexOf(se[Ce],Ue+1);if(qe<0)return!1;Ue=qe,Ce++}return!0}t.$xf=T;function H(x,se=!1){return x?(se&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.$yf=H;function G(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.$zf=G;function ne(x,se=1){if(se===0)return"";let ge=-1;do ge=x.indexOf(`
`,ge+1),se--;while(se>0&&ge>=0);return ge===-1?x:(x[ge-1]==="\r"&&ge--,x.substr(0,ge))}t.$Af=ne;function he(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.$Bf=he;function ve(x){return Fe.getInstance().getGraphemeBreakType(x)}t.$Cf=ve;function $e(x,se){return x===0?se!==5&&se!==7:x===2&&se===3?!1:x===4||x===2||x===3||se===4||se===2||se===3?!0:!(x===8&&(se===8||se===9||se===11||se===12)||(x===11||x===9)&&(se===9||se===10)||(x===12||x===10)&&se===10||se===5||se===13||se===7||x===1||x===13&&se===14||x===6&&se===6)}var ue;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(ue||(t.GraphemeBreakType=ue={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=ye()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ge=this.d,Ee=ge.length/3;let Ce=1;for(;Ce<=Ee;)if(se<ge[3*Ce])Ce=2*Ce;else if(se>ge[3*Ce+1])Ce=2*Ce+1;else return ge[3*Ce+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(x,se){if(x===0)return 0;const ge=Be(x,se);if(ge!==void 0)return ge;const Ee=new re(se,x);return Ee.prevCodePoint(),Ee.offset}t.$Df=Oe;function Be(x,se){const ge=new re(se,x);let Ee=ge.prevCodePoint();for(;Ie(Ee)||Ee===65039||Ee===8419;){if(ge.offset===0)return;Ee=ge.prevCodePoint()}if(!m(Ee))return;let Ce=ge.offset;return Ce>0&&ge.prevCodePoint()===8205&&(Ce=ge.offset),Ce}function Ie(x){return 127995<=x&&x<=127999}var Je;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),t.$Ef="\xA0";class et{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$Ee(se=>{function ge(Xe){const nt=new Map;for(let st=0;st<Xe.length;st+=2)nt.set(Xe[st],Xe[st+1]);return nt}function Ee(Xe,nt){const st=new Map(Xe);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Ce(Xe,nt){if(!Xe)return nt;const st=new Map;for(const[rt,gt]of Xe)nt.has(rt)&&st.set(rt,gt);return st}const Ue=this.c.value;let qe=se.filter(Xe=>!Xe.startsWith("_")&&Xe in Ue);qe.length===0&&(qe=["_default"]);let _e;for(const Xe of qe){const nt=ge(Ue[Xe]);_e=Ce(_e,nt)}const Ze=ge(Ue._common),tt=Ee(Ze,_e);return new et(tt)})}static getInstance(se){return et.d.get(Array.from(se))}static{this.e=new P.$V(()=>Object.keys(et.c.value).filter(se=>!se.startsWith("_")))}static getLocales(){return et.e.value}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Ff=et;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(se){return Qe.e().has(se)}static get codePoints(){return Qe.e()}}t.$Gf=Qe}),define(be[34],pe([1,0,32,80,10]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8j=t.$7j=t.$6j=t.$5j=t.FuzzyScore=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.or=void 0;function U(...T){return function(H,G){for(let ne=0,he=T.length;ne<he;ne++){const ve=T[ne](H,G);if(ve)return ve}return null}}t.or=U,t.$Sj=E.bind(void 0,!1),t.$Tj=E.bind(void 0,!0);function E(T,H,G){if(!G||G.length<H.length)return null;let ne;return T?ne=s.$_e(G,H):ne=G.indexOf(H)===0,ne?H.length>0?[{start:0,end:H.length}]:[]:null}function k(T,H){const G=H.toLowerCase().indexOf(T.toLowerCase());return G===-1?null:[{start:G,end:G+T.length}]}t.$Uj=k;function b(T,H){return w(T.toLowerCase(),H.toLowerCase(),0,0)}t.$Vj=b;function w(T,H,G,ne){if(G===T.length)return[];if(ne===H.length)return null;if(T[G]===H[ne]){let he=null;return(he=w(T,H,G+1,ne+1))?c({start:ne,end:ne+1},he):null}return w(T,H,G,ne+1)}function y(T){return 97<=T&&T<=122}function I(T){return 65<=T&&T<=90}t.$Wj=I;function o(T){return 48<=T&&T<=57}function a(T){return T===32||T===9||T===10||T===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>e.add(T.charCodeAt(0)));function r(T){return a(T)||e.has(T)}function d(T,H){return T===H||r(T)&&r(H)}const $=new Map;function u(T){if($.has(T))return $.get(T);let H;const G=(0,P.$Qj)(T);return G&&(H=G),$.set(T,H),H}function p(T){return y(T)||I(T)||o(T)}function c(T,H){return H.length===0?H=[T]:T.end===H[0].start?H[0].start=T.start:H.unshift(T),H}function f(T,H){for(let G=H;G<T.length;G++){const ne=T.charCodeAt(G);if(I(ne)||o(ne)||G>0&&!p(T.charCodeAt(G-1)))return G}return T.length}function h(T,H,G,ne){if(G===T.length)return[];if(ne===H.length)return null;if(T[G]!==H[ne].toLowerCase())return null;{let he=null,ve=ne+1;for(he=h(T,H,G+1,ne+1);!he&&(ve=f(H,ve))<H.length;)he=h(T,H,G+1,ve),ve++;return he===null?null:c({start:ne,end:ne+1},he)}}function F(T){let H=0,G=0,ne=0,he=0,ve=0;for(let Oe=0;Oe<T.length;Oe++)ve=T.charCodeAt(Oe),I(ve)&&H++,y(ve)&&G++,p(ve)&&ne++,o(ve)&&he++;const $e=H/T.length,ue=G/T.length,Fe=ne/T.length,ye=he/T.length;return{upperPercent:$e,lowerPercent:ue,alphaPercent:Fe,numericPercent:ye}}function M(T){const{upperPercent:H,lowerPercent:G}=T;return G===0&&H>.6}function R(T){const{upperPercent:H,lowerPercent:G,alphaPercent:ne,numericPercent:he}=T;return G>.2&&H<.8&&ne>.6&&he<.2}function O(T){let H=0,G=0,ne=0,he=0;for(let ve=0;ve<T.length;ve++)ne=T.charCodeAt(ve),I(ne)&&H++,y(ne)&&G++,a(ne)&&he++;return(H===0||G===0)&&he===0?T.length<=30:H<=5}function v(T,H){if(!H||(H=H.trim(),H.length===0)||!O(T)||H.length>60)return null;const G=F(H);if(!R(G)){if(!M(G))return null;H=H.toLowerCase()}let ne=null,he=0;for(T=T.toLowerCase();he<H.length&&(ne=h(T,H,0,he))===null;)he=f(H,he+1);return ne}t.$Xj=v;function C(T,H,G=!1){if(!H||H.length===0)return null;let ne=null,he=0;for(T=T.toLowerCase(),H=H.toLowerCase();he<H.length&&(ne=q(T,H,0,he,G),ne===null);)he=j(H,he+1);return ne}t.$Yj=C;function q(T,H,G,ne,he){let ve=0;if(G===T.length)return[];if(ne===H.length)return null;if(!d(T.charCodeAt(G),H.charCodeAt(ne))){const Fe=u(T.charCodeAt(G));if(!Fe)return null;for(let ye=0;ye<Fe.length;ye++)if(!d(Fe[ye],H.charCodeAt(ne+ye)))return null;ve+=Fe.length-1}let $e=null,ue=ne+ve+1;if($e=q(T,H,G+1,ue,he),!he)for(;!$e&&(ue=j(H,ue))<H.length;)$e=q(T,H,G+1,ue,he),ue++;if(!$e)return null;if(T.charCodeAt(G)!==H.charCodeAt(ne)){const Fe=u(T.charCodeAt(G));if(!Fe)return $e;for(let ye=0;ye<Fe.length;ye++)if(Fe[ye]!==H.charCodeAt(ne+ye))return $e}return c({start:ne,end:ne+ve+1},$e)}function j(T,H){for(let G=H;G<T.length;G++)if(r(T.charCodeAt(G))||G>0&&r(T.charCodeAt(G-1)))return G;return T.length}const N=U(t.$Tj,v,k),L=U(t.$Tj,v,b),B=new A.$Dc(1e4);function Y(T,H,G=!1){if(typeof T!="string"||typeof H!="string")return null;let ne=B.get(T);ne||(ne=new RegExp(s.$Ue(T),"i"),B.set(T,ne));const he=ne.exec(H);return he?[{start:he.index,end:he.index+he[0].length}]:G?L(T,H):N(T,H)}t.$Zj=Y;function X(T,H){const G=m(T,T.toLowerCase(),0,H,H.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?oe(G):null}t.$1j=X;function de(T,H,G,ne,he,ve){const $e=Math.min(13,T.length);for(;G<$e;G++){const ue=m(T,H,G,ne,he,ve,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ue)return ue}return[0,ve]}t.$2j=de;function oe(T){if(typeof T>"u")return[];const H=[],G=T[1];for(let ne=T.length-1;ne>1;ne--){const he=T[ne]+G,ve=H[H.length-1];ve&&ve.end===he?ve.end=he+1:H.push({start:he,end:he+1})}return H}t.$3j=oe;const ee=128;function me(){const T=[],H=[];for(let G=0;G<=ee;G++)H[G]=0;for(let G=0;G<=ee;G++)T.push(H.slice(0));return T}function Te(T){const H=[];for(let G=0;G<=T;G++)H[G]=0;return H}const Ne=Te(2*ee),Me=Te(2*ee),re=me(),J=me(),le=me(),K=!1;function W(T,H,G,ne,he){function ve(ue,Fe,ye=" "){for(;ue.length<Fe;)ue=ye+ue;return ue}let $e=` |   |${ne.split("").map(ue=>ve(ue,3)).join("|")}
`;for(let ue=0;ue<=G;ue++)ue===0?$e+=" |":$e+=`${H[ue-1]}|`,$e+=T[ue].slice(0,he+1).map(Fe=>ve(Fe.toString(),3)).join("|")+`
`;return $e}function Z(T,H,G,ne){T=T.substr(H),G=G.substr(ne),console.log(W(J,T,T.length,G,G.length)),console.log(W(le,T,T.length,G,G.length)),console.log(W(re,T,T.length,G,G.length))}function ce(T,H){if(H<0||H>=T.length)return!1;const G=T.codePointAt(H);switch(G){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!s.$rf(G)}}function we(T,H){if(H<0||H>=T.length)return!1;switch(T.charCodeAt(H)){case 32:case 9:return!0;default:return!1}}function Ae(T,H,G){return H[T]!==G[T]}function ke(T,H,G,ne,he,ve,$e=!1){for(;H<G&&he<ve;)T[H]===ne[he]&&($e&&(Ne[H]=he),H+=1),he+=1;return H===G}t.$4j=ke;var Le;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(Le||(Le={}));var _;(function(T){T.Default=[-100,0];function H(G){return!G||G.length===2&&G[0]===-100&&G[1]===0}T.isDefault=H})(_||(t.FuzzyScore=_={}));class g{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(H,G){this.firstMatchCanBeWeak=H,this.boostFullMatch=G}}t.$5j=g;function m(T,H,G,ne,he,ve,$e=g.default){const ue=T.length>ee?ee:T.length,Fe=ne.length>ee?ee:ne.length;if(G>=ue||ve>=Fe||ue-G>Fe-ve||!ke(H,G,ue,he,ve,Fe,!0))return;i(ue,Fe,G,ve,H,he);let ye=1,Oe=1,Be=G,Ie=ve;const Je=[!1];for(ye=1,Be=G;Be<ue;ye++,Be++){const ge=Ne[Be],Ee=Me[Be],Ce=Be+1<ue?Me[Be+1]:Fe;for(Oe=ge-ve+1,Ie=ge;Ie<Ce;Oe++,Ie++){let Ue=Number.MIN_SAFE_INTEGER,qe=!1;Ie<=Ee&&(Ue=n(T,H,Be,G,ne,he,Ie,Fe,ve,re[ye-1][Oe-1]===0,Je));let _e=0;Ue!==Number.MAX_SAFE_INTEGER&&(qe=!0,_e=Ue+J[ye-1][Oe-1]);const Ze=Ie>ge,tt=Ze?J[ye][Oe-1]+(re[ye][Oe-1]>0?-5:0):0,Xe=Ie>ge+1&&re[ye][Oe-1]>0,nt=Xe?J[ye][Oe-2]+(re[ye][Oe-2]>0?-5:0):0;if(Xe&&(!Ze||nt>=tt)&&(!qe||nt>=_e))J[ye][Oe]=nt,le[ye][Oe]=3,re[ye][Oe]=0;else if(Ze&&(!qe||tt>=_e))J[ye][Oe]=tt,le[ye][Oe]=2,re[ye][Oe]=0;else if(qe)J[ye][Oe]=_e,le[ye][Oe]=1,re[ye][Oe]=re[ye-1][Oe-1]+1;else throw new Error("not possible")}}if(K&&Z(T,G,ne,ve),!Je[0]&&!$e.firstMatchCanBeWeak)return;ye--,Oe--;const et=[J[ye][Oe],ve];let Qe=0,x=0;for(;ye>=1;){let ge=Oe;do{const Ee=le[ye][ge];if(Ee===3)ge=ge-2;else if(Ee===2)ge=ge-1;else break}while(ge>=1);Qe>1&&H[G+ye-1]===he[ve+Oe-1]&&!Ae(ge+ve-1,ne,he)&&Qe+1>re[ye][ge]&&(ge=Oe),ge===Oe?Qe++:Qe=1,x||(x=ge),ye--,Oe=ge-1,et.push(Oe)}Fe===ue&&$e.boostFullMatch&&(et[0]+=2);const se=x-ue;return et[0]-=se,et}t.$6j=m;function i(T,H,G,ne,he,ve){let $e=T-1,ue=H-1;for(;$e>=G&&ue>=ne;)he[$e]===ve[ue]&&(Me[$e]=ue,$e--),ue--}function n(T,H,G,ne,he,ve,$e,ue,Fe,ye,Oe){if(H[G]!==ve[$e])return Number.MIN_SAFE_INTEGER;let Be=1,Ie=!1;return $e===G-ne?Be=T[G]===he[$e]?7:5:Ae($e,he,ve)&&($e===0||!Ae($e-1,he,ve))?(Be=T[G]===he[$e]?7:5,Ie=!0):ce(ve,$e)&&($e===0||!ce(ve,$e-1))?Be=5:(ce(ve,$e-1)||we(ve,$e-1))&&(Be=5,Ie=!0),Be>1&&G===ne&&(Oe[0]=!0),Ie||(Ie=Ae($e,he,ve)||ce(ve,$e-1)||we(ve,$e-1)),G===ne?$e>Fe&&(Be-=Ie?3:5):ye?Be+=Ie?2:0:Be+=Ie?0:1,$e+1===ue&&(Be-=Ie?3:5),Be}function l(T,H,G,ne,he,ve,$e){return S(T,H,G,ne,he,ve,!0,$e)}t.$7j=l;function D(T,H,G,ne,he,ve,$e){return S(T,H,G,ne,he,ve,!1,$e)}t.$8j=D;function S(T,H,G,ne,he,ve,$e,ue){let Fe=m(T,H,G,ne,he,ve,ue);if(Fe&&!$e)return Fe;if(T.length>=3){const ye=Math.min(7,T.length-1);for(let Oe=G+1;Oe<ye;Oe++){const Be=z(T,Oe);if(Be){const Ie=m(Be,Be.toLowerCase(),G,ne,he,ve,ue);Ie&&(Ie[0]-=3,(!Fe||Ie[0]>Fe[0])&&(Fe=Ie))}}}return Fe}function z(T,H){if(H+1>=T.length)return;const G=T[H],ne=T[H+1];if(G!==ne)return T.slice(0,H)+ne+G+T.slice(H+2)}}),define(be[49],pe([1,0,10]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yi=t.$Xi=t.$Wi=t.$Vi=t.$Ui=t.$Ti=t.$Si=void 0;function P($){return s($,0)}t.$Si=P;function s($,u){switch(typeof $){case"object":return $===null?U(349,u):Array.isArray($)?b($,u):w($,u);case"string":return k($,u);case"boolean":return E($,u);case"number":return U($,u);case"undefined":return U(937,u);default:return U(617,u)}}t.$Ti=s;function U($,u){return(u<<5)-u+$|0}t.$Ui=U;function E($,u){return U($?433:863,u)}function k($,u){u=U(149417,u);for(let p=0,c=$.length;p<c;p++)u=U($.charCodeAt(p),u);return u}t.$Vi=k;function b($,u){return u=U(104579,u),$.reduce((p,c)=>s(c,p),u)}function w($,u){return u=U(181387,u),Object.keys($).sort().reduce((p,c)=>(p=k(c,p),s($[c],p)),u)}class y{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=s(u,this.g),this.g}}t.$Wi=y;var I;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o($,u,p=32){const c=p-u,f=~((1<<c)-1);return($<<u|(f&$)>>>c)>>>0}function a($,u=0,p=$.byteLength,c=0){for(let f=0;f<p;f++)$[u+f]=c}function e($,u,p="0"){for(;$.length<u;)$=p+$;return $}function r($,u=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(p=>p.toString(16).padStart(2,"0")).join(""):e(($>>>0).toString(16),u/4)}t.$Xi=r;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const p=u.length;if(p===0)return;const c=this.p;let f=this.r,h=this.u,F,M;for(h!==0?(F=h,M=-1,h=0):(F=u.charCodeAt(0),M=0);;){let R=F;if(A.$cf(F))if(M+1<p){const O=u.charCodeAt(M+1);A.$df(O)?(M++,R=A.$ef(F,O)):R=65533}else{h=F;break}else A.$df(F)&&(R=65533);if(f=this.w(c,f,R),M++,M<p)F=u.charCodeAt(M);else break}this.r=f,this.u=h}w(u,p,c){return c<128?u[p++]=c:c<2048?(u[p++]=192|(c&1984)>>>6,u[p++]=128|(c&63)>>>0):c<65536?(u[p++]=224|(c&61440)>>>12,u[p++]=128|(c&4032)>>>6,u[p++]=128|(c&63)>>>0):(u[p++]=240|(c&1835008)>>>18,u[p++]=128|(c&258048)>>>12,u[p++]=128|(c&4032)>>>6,u[p++]=128|(c&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),r(this.h)+r(this.l)+r(this.m)+r(this.n)+r(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=d.g,p=this.q;for(let C=0;C<64;C+=4)u.setUint32(C,p.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)u.setUint32(C,o(u.getUint32(C-12,!1)^u.getUint32(C-32,!1)^u.getUint32(C-56,!1)^u.getUint32(C-64,!1),1),!1);let c=this.h,f=this.l,h=this.m,F=this.n,M=this.o,R,O,v;for(let C=0;C<80;C++)C<20?(R=f&h|~f&F,O=1518500249):C<40?(R=f^h^F,O=1859775393):C<60?(R=f&h|f&F|h&F,O=2400959708):(R=f^h^F,O=3395469782),v=o(c,5)+R+M+O+u.getUint32(C*4,!1)&4294967295,M=F,F=h,h=o(f,30),f=c,c=v;this.h=this.h+c&4294967295,this.l=this.l+f&4294967295,this.m=this.m+h&4294967295,this.n=this.n+F&4294967295,this.o=this.o+M&4294967295}}t.$Yi=d}),define(be[87],pe([1,0,75,49]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zs=t.$Ys=t.$Xs=void 0;class s{constructor(o){this.a=o}getElements(){const o=this.a,a=new Int32Array(o.length);for(let e=0,r=o.length;e<r;e++)a[e]=o.charCodeAt(e);return a}}t.$Xs=s;function U(I,o,a){return new y(new s(I),new s(o)).ComputeDiff(a).changes}t.$Ys=U;class E{static Assert(o,a){if(!o)throw new Error(a)}}class k{static Copy(o,a,e,r,d){for(let $=0;$<d;$++)e[r+$]=o[a+$]}static Copy2(o,a,e,r,d){for(let $=0;$<d;$++)e[r+$]=o[a+$]}}var b;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class w{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.$Ws(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,a){this.b=Math.min(this.b,o),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(o,a){this.b=Math.min(this.b,o),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(o,a,e=null){this.a=e,this.b=o,this.c=a;const[r,d,$]=y.o(o),[u,p,c]=y.o(a);this.d=$&&c,this.e=r,this.f=d,this.g=u,this.h=p,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const a=o.getElements();if(y.n(a)){const e=new Int32Array(a.length);for(let r=0,d=a.length;r<d;r++)e[r]=(0,P.$Vi)(a[r],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(o,a){return this.f[o]!==this.h[a]?!1:this.d?this.e[o]===this.g[a]:!0}q(o,a){if(!this.p(o,a))return!1;const e=y.r(this.b,o),r=y.r(this.c,a);return e===r}static r(o,a){return typeof o.getStrictElement=="function"?o.getStrictElement(a):null}s(o,a){return this.f[o]!==this.f[a]?!1:this.d?this.e[o]===this.e[a]:!0}u(o,a){return this.h[o]!==this.h[a]?!1:this.d?this.g[o]===this.g[a]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,a,e,r,d){const $=[!1];let u=this.w(o,a,e,r,$);return d&&(u=this.z(u)),{quitEarly:$[0],changes:u}}w(o,a,e,r,d){for(d[0]=!1;o<=a&&e<=r&&this.p(o,e);)o++,e++;for(;a>=o&&r>=e&&this.p(a,r);)a--,r--;if(o>a||e>r){let h;return e<=r?(E.Assert(o===a+1,"originalStart should only be one more than originalEnd"),h=[new A.$Ws(o,0,e,r-e+1)]):o<=a?(E.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),h=[new A.$Ws(o,a-o+1,e,0)]):(E.Assert(o===a+1,"originalStart should only be one more than originalEnd"),E.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const $=[0],u=[0],p=this.y(o,a,e,r,$,u,d),c=$[0],f=u[0];if(p!==null)return p;if(!d[0]){const h=this.w(o,c,e,f,d);let F=[];return d[0]?F=[new A.$Ws(c+1,a-(c+1)+1,f+1,r-(f+1)+1)]:F=this.w(c+1,a,f+1,r,d),this.H(h,F)}return[new A.$Ws(o,a-o+1,e,r-e+1)]}x(o,a,e,r,d,$,u,p,c,f,h,F,M,R,O,v,C,q){let j=null,N=null,L=new w,B=a,Y=e,X=M[0]-v[0]-r,de=-1073741824,oe=this.k.length-1;do{const ee=X+o;ee===B||ee<Y&&c[ee-1]<c[ee+1]?(h=c[ee+1],R=h-X-r,h<de&&L.MarkNextChange(),de=h,L.AddModifiedElement(h+1,R),X=ee+1-o):(h=c[ee-1]+1,R=h-X-r,h<de&&L.MarkNextChange(),de=h-1,L.AddOriginalElement(h,R+1),X=ee-1-o),oe>=0&&(c=this.k[oe],o=c[0],B=1,Y=c.length-1)}while(--oe>=-1);if(j=L.getReverseChanges(),q[0]){let ee=M[0]+1,me=v[0]+1;if(j!==null&&j.length>0){const Te=j[j.length-1];ee=Math.max(ee,Te.getOriginalEnd()),me=Math.max(me,Te.getModifiedEnd())}N=[new A.$Ws(ee,F-ee+1,me,O-me+1)]}else{L=new w,B=$,Y=u,X=M[0]-v[0]-p,de=1073741824,oe=C?this.m.length-1:this.m.length-2;do{const ee=X+d;ee===B||ee<Y&&f[ee-1]>=f[ee+1]?(h=f[ee+1]-1,R=h-X-p,h>de&&L.MarkNextChange(),de=h+1,L.AddOriginalElement(h+1,R+1),X=ee+1-d):(h=f[ee-1],R=h-X-p,h>de&&L.MarkNextChange(),de=h,L.AddModifiedElement(h+1,R+1),X=ee-1-d),oe>=0&&(f=this.m[oe],d=f[0],B=1,Y=f.length-1)}while(--oe>=-1);N=L.getChanges()}return this.H(j,N)}y(o,a,e,r,d,$,u){let p=0,c=0,f=0,h=0,F=0,M=0;o--,e--,d[0]=0,$[0]=0,this.k=[],this.m=[];const R=a-o+(r-e),O=R+1,v=new Int32Array(O),C=new Int32Array(O),q=r-e,j=a-o,N=o-e,L=a-r,Y=(j-q)%2===0;v[q]=o,C[j]=a,u[0]=!1;for(let X=1;X<=R/2+1;X++){let de=0,oe=0;f=this.J(q-X,X,q,O),h=this.J(q+X,X,q,O);for(let me=f;me<=h;me+=2){me===f||me<h&&v[me-1]<v[me+1]?p=v[me+1]:p=v[me-1]+1,c=p-(me-q)-N;const Te=p;for(;p<a&&c<r&&this.p(p+1,c+1);)p++,c++;if(v[me]=p,p+c>de+oe&&(de=p,oe=c),!Y&&Math.abs(me-j)<=X-1&&p>=C[me])return d[0]=p,$[0]=c,Te<=C[me]&&1447>0&&X<=1447+1?this.x(q,f,h,N,j,F,M,L,v,C,p,a,d,c,r,$,Y,u):null}const ee=(de-o+(oe-e)-X)/2;if(this.a!==null&&!this.a(de,ee))return u[0]=!0,d[0]=de,$[0]=oe,ee>0&&1447>0&&X<=1447+1?this.x(q,f,h,N,j,F,M,L,v,C,p,a,d,c,r,$,Y,u):(o++,e++,[new A.$Ws(o,a-o+1,e,r-e+1)]);F=this.J(j-X,X,j,O),M=this.J(j+X,X,j,O);for(let me=F;me<=M;me+=2){me===F||me<M&&C[me-1]>=C[me+1]?p=C[me+1]-1:p=C[me-1],c=p-(me-j)-L;const Te=p;for(;p>o&&c>e&&this.p(p,c);)p--,c--;if(C[me]=p,Y&&Math.abs(me-q)<=X&&p<=v[me])return d[0]=p,$[0]=c,Te>=v[me]&&1447>0&&X<=1447+1?this.x(q,f,h,N,j,F,M,L,v,C,p,a,d,c,r,$,Y,u):null}if(X<=1447){let me=new Int32Array(h-f+2);me[0]=q-f+1,k.Copy2(v,f,me,1,h-f+1),this.k.push(me),me=new Int32Array(M-F+2),me[0]=j-F+1,k.Copy2(C,F,me,1,M-F+1),this.m.push(me)}}return this.x(q,f,h,N,j,F,M,L,v,C,p,a,d,c,r,$,Y,u)}z(o){for(let a=0;a<o.length;a++){const e=o[a],r=a<o.length-1?o[a+1].originalStart:this.f.length,d=a<o.length-1?o[a+1].modifiedStart:this.h.length,$=e.originalLength>0,u=e.modifiedLength>0;for(;e.originalStart+e.originalLength<r&&e.modifiedStart+e.modifiedLength<d&&(!$||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!u||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const c=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!c)break;e.originalStart++,e.modifiedStart++}const p=[null];if(a<o.length-1&&this.I(o[a],o[a+1],p)){o[a]=p[0],o.splice(a+1,1),a--;continue}}for(let a=o.length-1;a>=0;a--){const e=o[a];let r=0,d=0;if(a>0){const h=o[a-1];r=h.originalStart+h.originalLength,d=h.modifiedStart+h.modifiedLength}const $=e.originalLength>0,u=e.modifiedLength>0;let p=0,c=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let h=1;;h++){const F=e.originalStart-h,M=e.modifiedStart-h;if(F<r||M<d||$&&!this.s(F,F+e.originalLength)||u&&!this.u(M,M+e.modifiedLength))break;const O=(F===r&&M===d?5:0)+this.G(F,e.originalLength,M,e.modifiedLength);O>c&&(c=O,p=h)}e.originalStart-=p,e.modifiedStart-=p;const f=[null];if(a>0&&this.I(o[a-1],o[a],f)){o[a-1]=f[0],o.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=o.length;a<e;a++){const r=o[a-1],d=o[a],$=d.originalStart-r.originalStart-r.originalLength,u=r.originalStart,p=d.originalStart+d.originalLength,c=p-u,f=r.modifiedStart,h=d.modifiedStart+d.modifiedLength,F=h-f;if($<5&&c<20&&F<20){const M=this.A(u,c,f,F,$);if(M){const[R,O]=M;(R!==r.originalStart+r.originalLength||O!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=R-r.originalStart,r.modifiedLength=O-r.modifiedStart,d.originalStart=R+$,d.modifiedStart=O+$,d.originalLength=p-d.originalStart,d.modifiedLength=h-d.modifiedStart)}}}return o}A(o,a,e,r,d){if(a<d||r<d)return null;const $=o+a-d+1,u=e+r-d+1;let p=0,c=0,f=0;for(let h=o;h<$;h++)for(let F=e;F<u;F++){const M=this.B(h,F,d);M>0&&M>p&&(p=M,c=h,f=F)}return p>0?[c,f]:null}B(o,a,e){let r=0;for(let d=0;d<e;d++){if(!this.p(o+d,a+d))return 0;r+=this.e[o+d].length}return r}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,a){if(this.C(o)||this.C(o-1))return!0;if(a>0){const e=o+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,a){if(this.E(o)||this.E(o-1))return!0;if(a>0){const e=o+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,a,e,r){const d=this.D(o,a)?1:0,$=this.F(e,r)?1:0;return d+$}H(o,a){const e=[];if(o.length===0||a.length===0)return a.length>0?a:o;if(this.I(o[o.length-1],a[0],e)){const r=new Array(o.length+a.length-1);return k.Copy(o,0,r,0,o.length-1),r[o.length-1]=e[0],k.Copy(a,1,r,o.length,a.length-1),r}else{const r=new Array(o.length+a.length);return k.Copy(o,0,r,0,o.length),k.Copy(a,0,r,o.length,a.length),r}}I(o,a,e){if(E.Assert(o.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),E.Assert(o.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=a.originalStart||o.modifiedStart+o.modifiedLength>=a.modifiedStart){const r=o.originalStart;let d=o.originalLength;const $=o.modifiedStart;let u=o.modifiedLength;return o.originalStart+o.originalLength>=a.originalStart&&(d=a.originalStart+a.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=a.modifiedStart&&(u=a.modifiedStart+a.modifiedLength-o.modifiedStart),e[0]=new A.$Ws(r,d,$,u),!0}else return e[0]=null,!1}J(o,a,e,r){if(o>=0&&o<r)return o;const d=e,$=r-e-1,u=a%2===0;if(o<0){const p=d%2===0;return u===p?0:1}else{const p=$%2===0;return u===p?r-1:r-2}}}t.$Zs=y}),define(be[50],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rd=void 0,t.$Rd=Symbol("MicrotaskDelay")}),define(be[88],pe([1,0,12,10]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$h=t.$0h=t.$9h=t.$8h=t.$7h=void 0;class s{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),r=this.b.charCodeAt(this.c);return e-r}value(){return this.b[this.c]}}t.$7h=s;class U{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,P.$5e)(a,this.b,0,a.length,this.c,this.d):(0,P.$7e)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$8h=U;class E{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const r=this.b.charCodeAt(e);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,P.$5e)(a,this.b,0,a.length,this.d,this.e):(0,P.$7e)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$9h=E;var k;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(k||(k={}));class b{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,P.$6e)(a,this.c.scheme);if(this.d[this.e]===2)return(0,P.$6e)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,P.$4e)(a,this.c.query);if(this.d[this.e]===5)return(0,P.$4e)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$0h=b;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(y||(y={}));class I{static forUris(a=()=>!1,e=()=>!1){return new I(new b(a,e))}static forPaths(a=!1){return new I(new E(void 0,!a))}static forStrings(){return new I(new s)}static forConfigKeys(){return new I(new U)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const r=e.slice(0);(0,A.$Xb)(r);for(const d of r)this.set(d,a)}else{const r=a.slice(0);(0,A.$Xb)(r);for(const d of r)this.set(d[0],d[1])}}set(a,e){const r=this.b.reset(a);let d;this.c||(this.c=new w,this.c.segment=r.value());const $=[];for(d=this.c;;){const p=r.cmp(d.segment);if(p>0)d.left||(d.left=new w,d.left.segment=r.value()),$.push([-1,d]),d=d.left;else if(p<0)d.right||(d.right=new w,d.right.segment=r.value()),$.push([1,d]),d=d.right;else if(r.hasNext())r.next(),d.mid||(d.mid=new w,d.mid.segment=r.value()),$.push([0,d]),d=d.mid;else break}const u=d.value;d.value=e,d.key=a;for(let p=$.length-1;p>=0;p--){const c=$[p][1];c.updateHeight();const f=c.balanceFactor();if(f<-1||f>1){const h=$[p][0],F=$[p+1][0];if(h===1&&F===1)$[p][1]=c.rotateLeft();else if(h===-1&&F===-1)$[p][1]=c.rotateRight();else if(h===1&&F===-1)c.right=$[p+1][1]=$[p+1][1].rotateRight(),$[p][1]=c.rotateLeft();else if(h===-1&&F===1)c.left=$[p+1][1]=$[p+1][1].rotateLeft(),$[p][1]=c.rotateRight();else throw new Error;if(p>0)switch($[p-1][0]){case-1:$[p-1][1].left=$[p][1];break;case 1:$[p-1][1].right=$[p][1];break;case 0:$[p-1][1].mid=$[p][1];break}else this.c=$[0][1]}}return u}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let r=this.c;for(;r;){const d=e.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(e.hasNext())e.next(),r=r.mid;else break}return r}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const r=this.b.reset(a),d=[];let $=this.c;for(;$;){const u=r.cmp($.segment);if(u>0)d.push([-1,$]),$=$.left;else if(u<0)d.push([1,$]),$=$.right;else if(r.hasNext())r.next(),d.push([0,$]),$=$.mid;else break}if($){if(e?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const u=this.f($.right);if(u.key){const{key:p,value:c,segment:f}=u;this.e(u.key,!1),$.key=p,$.value=c,$.segment=f}}else{const u=$.left??$.right;if(d.length>0){const[p,c]=d[d.length-1];switch(p){case-1:c.left=u;break;case 0:c.mid=u;break;case 1:c.right=u;break}}else this.c=u}for(let u=d.length-1;u>=0;u--){const p=d[u][1];p.updateHeight();const c=p.balanceFactor();if(c>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),d[u][1]=p.rotateLeft()):c<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),d[u][1]=p.rotateRight()),u>0)switch(d[u-1][0]){case-1:d[u-1][1].left=d[u][1];break;case 1:d[u-1][1].right=d[u][1];break;case 0:d[u-1][1].mid=d[u][1];break}else this.c=d[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let r=this.c,d;for(;r;){const $=e.cmp(r.segment);if($>0)r=r.left;else if($<0)r=r.right;else if(e.hasNext())e.next(),d=r.value||d,r=r.mid;else break}return r&&r.value||d}findSuperstr(a){return this.g(a,!1)}g(a,e){const r=this.b.reset(a);let d=this.c;for(;d;){const $=r.cmp(d.segment);if($>0)d=d.left;else if($<0)d=d.right;else if(r.hasNext())r.next(),d=d.mid;else return d.mid?this.h(d.mid):e?d.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,r]of this)a(r,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const r=e.balanceFactor();return r<-1||r>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$$h=I}),define(be[7],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=void 0;function A(f){return typeof f=="string"}t.$Hf=A;function P(f){return Array.isArray(f)&&f.every(h=>A(h))}t.$If=P;function s(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$Jf=s;function U(f){const h=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof h}t.$Kf=U;function E(f){return typeof f=="number"&&!isNaN(f)}t.$Lf=E;function k(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$Mf=k;function b(f){return f===!0||f===!1}t.$Nf=b;function w(f){return typeof f>"u"}t.$Of=w;function y(f){return!I(f)}t.$Pf=y;function I(f){return w(f)||f===null}t.$Qf=I;function o(f,h){if(!f)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}t.$Rf=o;function a(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$Sf=a;function e(...f){const h=[];for(let F=0;F<f.length;F++){const M=f[F];if(I(M))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);h.push(M)}return h}t.$Tf=e;const r=Object.prototype.hasOwnProperty;function d(f){if(!s(f))return!1;for(const h in f)if(r.call(f,h))return!1;return!0}t.$Uf=d;function $(f){return typeof f=="function"}t.$Vf=$;function u(...f){return f.length>0&&f.every($)}t.$Wf=u;function p(f,h){const F=Math.min(f.length,h.length);for(let M=0;M<F;M++)c(f[M],h[M])}t.$Xf=p;function c(f,h){if(A(h)){if(typeof f!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if($(h)){try{if(f instanceof h)return}catch{}if(!I(f)&&f.constructor===h||h.length===1&&h.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Yf=c}),define(be[17],pe([1,0,7]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$j=t.$0j=t.$9j=void 0;const P=Object.create(null);function s(k,b){if((0,A.$Hf)(b)){const w=P[b];if(w===void 0)throw new Error(`${k} references an unknown codicon: ${b}`);b=w}return P[k]=b,{id:k}}function U(){return P}t.$9j=U;function E(){return Object.values(t.$$j)}t.$0j=E,t.$$j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(be[51],pe([1,0,7]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fn=t.$En=t.$Dn=t.$Cn=t.$Bn=t.$An=t.$zn=t.$yn=t.$xn=t.$wn=t.$vn=t.$un=void 0;function P($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const u=Array.isArray($)?[]:{};return Object.entries($).forEach(([p,c])=>{u[p]=c&&typeof c=="object"?P(c):c}),u}t.$un=P;function s($){if(!$||typeof $!="object")return $;const u=[$];for(;u.length>0;){const p=u.shift();Object.freeze(p);for(const c in p)if(U.call(p,c)){const f=p[c];typeof f=="object"&&!Object.isFrozen(f)&&!(0,A.$Kf)(f)&&u.push(f)}}return $}t.$vn=s;const U=Object.prototype.hasOwnProperty;function E($,u){return k($,u,new Set)}t.$wn=E;function k($,u,p){if((0,A.$Qf)($))return $;const c=u($);if(typeof c<"u")return c;if(Array.isArray($)){const f=[];for(const h of $)f.push(k(h,u,p));return f}if((0,A.$Jf)($)){if(p.has($))throw new Error("Cannot clone recursive data-structure");p.add($);const f={};for(const h in $)U.call($,h)&&(f[h]=k($[h],u,p));return p.delete($),f}return $}function b($,u,p=!0){return(0,A.$Jf)($)?((0,A.$Jf)(u)&&Object.keys(u).forEach(c=>{c in $?p&&((0,A.$Jf)($[c])&&(0,A.$Jf)(u[c])?b($[c],u[c],p):$[c]=u[c]):$[c]=u[c]}),$):u}t.$xn=b;function w($,u){if($===u)return!0;if($==null||u===null||u===void 0||typeof $!=typeof u||typeof $!="object"||Array.isArray($)!==Array.isArray(u))return!1;let p,c;if(Array.isArray($)){if($.length!==u.length)return!1;for(p=0;p<$.length;p++)if(!w($[p],u[p]))return!1}else{const f=[];for(c in $)f.push(c);f.sort();const h=[];for(c in u)h.push(c);if(h.sort(),!w(f,h))return!1;for(p=0;p<f.length;p++)if(!w($[f[p]],u[f[p]]))return!1}return!0}t.$yn=w;function y($){const u=new Set;return JSON.stringify($,(p,c)=>{if((0,A.$Jf)(c)||Array.isArray(c)){if(u.has(c))return"[Circular]";u.add(c)}return c})}t.$zn=y;function I($,u){const p=Object.create(null);return!$||!u||Object.keys(u).forEach(f=>{const h=$[f],F=u[f];w(h,F)||(p[f]=F)}),p}t.$An=I;function o($,u){const p=u.toLowerCase(),c=Object.keys($).find(f=>f.toLowerCase()===p);return c?$[c]:$[u]}t.$Bn=o;function a($,u){const p=Object.create(null);for(const[c,f]of Object.entries($))u(c,f)&&(p[c]=f);return p}t.$Cn=a;function e($){let u=[];for(;Object.prototype!==$;)u=u.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return u}t.$Dn=e;function r($){const u=[];for(const p of e($))typeof $[p]=="function"&&u.push(p);return u}t.$En=r;function d($,u){const p=f=>function(){const h=Array.prototype.slice.call(arguments,0);return u(f,h)},c={};for(const f of $)c[f]=p(f);return c}t.$Fn=d}),define(be[18],pe([1,0,17]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$_j=t.ThemeColor=void 0;var P;(function(E){function k(b){return b&&typeof b=="object"&&typeof b.id=="string"}E.isThemeColor=k})(P||(t.ThemeColor=P={}));function s(E){return{id:E}}t.$_j=s;var U;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function b(u){const p=k.exec(u.id);if(!p)return b(A.$$j.error);const[,c,f]=p,h=["codicon","codicon-"+c];return f&&h.push("codicon-modifier-"+f.substring(1)),h}E.asClassNameArray=b;function w(u){return b(u).join(" ")}E.asClassName=w;function y(u){return"."+b(u).join(".")}E.asCSSSelector=y;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||P.isThemeColor(u.color))}E.isThemeIcon=I;const o=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function a(u){const p=o.exec(u);if(!p)return;const[,c]=p;return{id:c}}E.fromString=a;function e(u){return{id:u}}E.fromId=e;function r(u,p){let c=u.id;const f=c.lastIndexOf("~");return f!==-1&&(c=c.substring(0,f)),p&&(c=`${c}~${p}`),{id:c}}E.modify=r;function d(u){const p=u.id.lastIndexOf("~");if(p!==-1)return u.id.substring(p+1)}E.getModifier=d;function $(u,p){return u.id===p.id&&u.color?.id===p.color?.id}E.isEqual=$})(U||(t.ThemeIcon=U={}))}),define(be[35],pe([1,0,34,10,18]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=void 0;const U="$(",E=new RegExp(`\\$\\(${s.ThemeIcon.iconNameExpression}(?:${s.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function b($){return $.replace(k,(u,p)=>p?u:`\\${u}`)}t.$ak=b;const w=new RegExp(`\\\\${E.source}`,"g");function y($){return $.replace(w,u=>`\\${u}`)}t.$bk=y;const I=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function o($){return $.indexOf(U)===-1?$:$.replace(I,(u,p,c,f)=>c?u:p||f||"")}t.$ck=o;function a($){return $?$.replace(/\$\((.*?)\)/g,(u,p)=>` ${p} `).trim():""}t.$dk=a;const e=new RegExp(`\\$\\(${s.ThemeIcon.iconNameCharacter}+\\)`,"g");function r($){e.lastIndex=0;let u="";const p=[];let c=0;for(;;){const f=e.lastIndex,h=e.exec($),F=$.substring(f,h?.index);if(F.length>0){u+=F;for(let M=0;M<F.length;M++)p.push(c)}if(!h)break;c+=h[0].length}return{text:u,iconOffsets:p}}t.$ek=r;function d($,u,p=!1){const{text:c,iconOffsets:f}=u;if(!f||f.length===0)return(0,A.$Zj)($,c,p);const h=(0,P.$Se)(c," "),F=c.length-h.length,M=(0,A.$Zj)($,h,p);if(M)for(const R of M){const O=f[R.start+F]+F;R.start+=O,R.end+=O}return M}t.$fk=d}),define(be[89],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oU=t.$nU=void 0,t.$nU="vscode:contextmenu",t.$oU="vscode:onCloseContextMenu"}),define(be[90],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vU=void 0;class A{constructor(s,U){this.a=s,this.onMessage=U}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$vU=A}),define(be[30],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const A=globalThis.vscode;t.$O=A.ipcRenderer,t.$P=A.ipcMessagePort,t.$Q=A.webFrame,t.$R=A.process,t.$S=A.context}),define(be[91],pe([1,0,89,30]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rU=void 0;let s=0;function U(k,b,w){const y=[],I=s++,o=`vscode:onContextMenu${I}`,a=(e,r,d)=>{y[r].click?.(d)};P.$O.once(o,a),P.$O.once(A.$oU,(e,r)=>{r===I&&(P.$O.removeListener(o,a),w?.())}),P.$O.send(A.$nU,I,k.map(e=>E(e,y)),o,b)}t.$rU=U;function E(k,b){const w={id:b.length,label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:typeof k.enabled=="boolean"?k.enabled:!0,visible:typeof k.visible=="boolean"?k.visible:!0};return b.push(k),Array.isArray(k.submenu)&&(w.submenu=k.submenu.map(y=>E(y,b))),w}}),define(be[52],pe([8]),{}),define(be[92],pe([8]),{}),define(be[93],pe([8]),{}),define(be[94],pe([8]),{}),define(be[95],pe([1,0,93,94]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[96],pe([8]),{}),define(be[97],pe([8]),{}),define(be[98],pe([8]),{}),define(be[99],pe([8]),{}),define(be[100],pe([8]),{}),define(be[101],pe([8]),{}),define(be[102],pe([8]),{}),define(be[103],pe([8]),{}),define(be[104],pe([8]),{}),define(be[105],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[106],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[107],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[108],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[109],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[110],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[111],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[112],pe([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(be[36],pe([1,0,4,2,112]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oi=t.$Ni=t.$Mi=t.$Li=t.$Ki=t.$Ji=void 0;class U extends P.$Tc{constructor(o,a="",e="",r=!0,d){super(),this.h=this.B(new A.$Ud),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=a,this.u=e,this.w=r,this.C=d}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,a){this.C&&await this.C(o)}}t.$Ji=U;class E extends P.$Tc{constructor(){super(...arguments),this.f=this.B(new A.$Ud),this.onWillRun=this.f.event,this.m=this.B(new A.$Ud),this.onDidRun=this.m.event}async run(o,a){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.u(o,a)}catch(r){e=r}this.m.fire({action:o,error:e})}async u(o,a){await o.run(a)}}t.$Ki=E;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let a=[];for(const e of o)e.length&&(a.length?a=[...a,new k,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$Li=k;class b{get actions(){return this.a}constructor(o,a,e,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=a,this.class=r,this.a=e}async run(){}}t.$Mi=b;class w extends U{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,s.localize(0,null),void 0,!1)}}t.$Ni=w;function y(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...o)=>I.run(...o),tooltip:I.label}}t.$Oi=y}),define(be[113],pe([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(be[5],pe([1,0,113]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let P=!1,s=!1,U=!1,E=!1,k=!1,b=!1,w=!1,y=!1,I=!1,o=!1,a,e=t.$g,r=t.$g,d,$;const u=globalThis;let p;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?p=u.vscode.process:typeof process<"u"&&(p=process);const c=typeof p?.versions?.electron=="string",f=c&&p?.type==="renderer";if(typeof p=="object"){P=p.platform==="win32",s=p.platform==="darwin",U=p.platform==="linux",E=U&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,w=c,I=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const N=p.env.VSCODE_NLS_CONFIG;if(N)try{const L=JSON.parse(N),B=L.availableLanguages["*"];a=L.locale,r=L.osLocale,e=B||t.$g,d=L._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!f?($=navigator.userAgent,P=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,y=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=$.indexOf("Linux")>=0,o=$?.indexOf("Mobi")>=0,b=!0,a=A.getConfiguredDefaultLocale(A.localize(0,null))||t.$g,e=a,r=navigator.language):console.error("Unable to resolve platform.");var h;(function(N){N[N.Web=0]="Web",N[N.Mac=1]="Mac",N[N.Linux=2]="Linux",N[N.Windows=3]="Windows"})(h||(t.Platform=h={}));function F(N){switch(N){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=F;let M=0;s?M=1:P?M=3:U&&(M=2),t.$i=P,t.$j=s,t.$k=U,t.$l=E,t.$m=k,t.$n=w,t.$o=b,t.$p=b&&typeof u.importScripts=="function",t.$q=t.$p?u.origin:void 0,t.$r=y,t.$s=o,t.$t=I,t.$u=M,t.$v=$,t.$w=e;var R;(function(N){function L(){return t.$w}N.value=L;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}N.isDefaultVariant=B;function Y(){return t.$w==="en"}N.isDefault=Y})(R||(t.Language=R={})),t.$x=a,t.$y=r,t.$z=d,t.$A=typeof u.postMessage=="function"&&!u.importScripts,t.$B=(()=>{if(t.$A){const N=[];u.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let Y=0,X=N.length;Y<X;Y++){const de=N[Y];if(de.id===B.data.vscodeScheduleAsyncWork){N.splice(Y,1),de.callback();return}}});let L=0;return B=>{const Y=++L;N.push({id:Y,callback:B}),u.postMessage({vscodeScheduleAsyncWork:Y},"*")}}return N=>setTimeout(N)})();var O;(function(N){N[N.Windows=1]="Windows",N[N.Macintosh=2]="Macintosh",N[N.Linux=3]="Linux"})(O||(t.OperatingSystem=O={})),t.OS=s||y?2:P?1:3;let v=!0,C=!1;function q(){if(!C){C=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,v=new Uint16Array(N.buffer)[0]===(2<<8)+1}return v}t.$D=q,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function j(N){return parseFloat(N)>=20}t.$J=j}),define(be[114],pe([1,0,16,21,5]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oP=t.KeyboardSupport=void 0;var U;(function(E){E[E.Always=0]="Always",E[E.FullScreen=1]="FullScreen",E[E.None=2]="None"})(U||(t.KeyboardSupport=U={})),t.$oP={clipboard:{writeText:s.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:s.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>s.$m||A.$mP()?0:navigator.keyboard||A.$iP?1:2)(),touch:"ontouchstart"in P.$4O||navigator.maxTouchPoints>0,pointerEvents:P.$4O.PointerEvent&&("ontouchstart"in P.$4O||navigator.maxTouchPoints>0)}}),define(be[14],pe([1,0,16,44,78,5]),function(ie,t,A,P,s,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wP=t.$vP=t.$uP=void 0;function E(e){if(e.charCode){const d=String.fromCharCode(e.charCode).toUpperCase();return P.KeyCodeUtils.fromString(d)}const r=e.keyCode;if(r===3)return 7;if(A.$fP)switch(r){case 59:return 85;case 60:if(U.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$j)return 57;break}else if(A.$gP){if(U.$j&&r===93)return 57;if(!U.$j&&r===92)return 57}return P.$1q[r]||0}const k=U.$j?256:2048,b=512,w=1024,y=U.$j?2048:256;function I(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$uP=I;function o(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${P.KeyCodeUtils.toString(e.keyCode)}')`}t.$vP=o;class a{constructor(r){this._standardKeyboardEventBrand=!0;const d=r;this.browserEvent=d,this.target=d.target,this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,this.altGraphKey=d.getModifierState("AltGraph"),this.keyCode=E(d),this.code=d.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(r){return this.a===r}c(){let r=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode);let d=0;return this.ctrlKey&&(d|=k),this.altKey&&(d|=b),this.shiftKey&&(d|=w),this.metaKey&&(d|=y),d|=r,d}d(){let r=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode),new s.$9q(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,r)}}t.$wP=a}),define(be[19],pe([1,0,16,69,5]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tP=t.$sP=t.$rP=void 0;class U{constructor(w,y){this.timestamp=Date.now(),this.browserEvent=y,this.leftButton=y.button===0,this.middleButton=y.button===1,this.rightButton=y.button===2,this.buttons=y.buttons,this.target=y.target,this.detail=y.detail||1,y.type==="dblclick"&&(this.detail=2),this.ctrlKey=y.ctrlKey,this.shiftKey=y.shiftKey,this.altKey=y.altKey,this.metaKey=y.metaKey,typeof y.pageX=="number"?(this.posx=y.pageX,this.posy=y.pageY):(this.posx=y.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=y.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const I=P.$pP.getPositionOfChildWindowRelativeToAncestorWindow(w,y.view);this.posx-=I.left,this.posy-=I.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$rP=U;class E extends U{constructor(w,y){super(w,y),this.dataTransfer=y.dataTransfer}}t.$sP=E;class k{constructor(w,y=0,I=0){if(this.browserEvent=w||null,this.target=w?w.target||w.targetNode||w.srcElement:null,this.deltaY=I,this.deltaX=y,w){const o=w,a=w;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(w.type==="wheel"){const e=w;e.deltaMode===e.DOM_DELTA_LINE?A.$fP&&!s.$j?this.deltaY=-w.deltaY/3:this.deltaY=-w.deltaY:this.deltaY=-w.deltaY/40}if(typeof o.wheelDeltaX<"u")A.$iP&&s.$i?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-w.detail/3;else if(w.type==="wheel"){const e=w;e.deltaMode===e.DOM_DELTA_LINE?A.$fP&&!s.$j?this.deltaX=-w.deltaX/3:this.deltaX=-w.deltaX:this.deltaX=-w.deltaX/40}this.deltaY===0&&this.deltaX===0&&w.wheelDelta&&(this.deltaY=w.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$tP=k}),define(be[115],pe([1,0,5]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let P;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const U=s.process;P={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return A.$i?"win32":A.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$dc=P.platform,t.$ec=P.arch}),define(be[24],pe([1,0,115]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const P=65,s=97,U=90,E=122,k=46,b=47,w=92,y=58,I=63;class o extends Error{constructor(F,M,R){let O;typeof M=="string"&&M.indexOf("not ")===0?(O="must not be",M=M.replace(/^not /,"")):O="must be";const v=F.indexOf(".")!==-1?"property":"argument";let C=`The "${F}" ${v} ${O} of type ${M}`;C+=`. Received type ${typeof R}`,super(C),this.code="ERR_INVALID_ARG_TYPE"}}function a(h,F){if(h===null||typeof h!="object")throw new o(F,"Object",h)}function e(h,F){if(typeof h!="string")throw new o(F,"string",h)}const r=A.$dc==="win32";function d(h){return h===b||h===w}function $(h){return h===b}function u(h){return h>=P&&h<=U||h>=s&&h<=E}function p(h,F,M,R){let O="",v=0,C=-1,q=0,j=0;for(let N=0;N<=h.length;++N){if(N<h.length)j=h.charCodeAt(N);else{if(R(j))break;j=b}if(R(j)){if(!(C===N-1||q===1))if(q===2){if(O.length<2||v!==2||O.charCodeAt(O.length-1)!==k||O.charCodeAt(O.length-2)!==k){if(O.length>2){const L=O.lastIndexOf(M);L===-1?(O="",v=0):(O=O.slice(0,L),v=O.length-1-O.lastIndexOf(M)),C=N,q=0;continue}else if(O.length!==0){O="",v=0,C=N,q=0;continue}}F&&(O+=O.length>0?`${M}..`:"..",v=2)}else O.length>0?O+=`${M}${h.slice(C+1,N)}`:O=h.slice(C+1,N),v=N-C-1;C=N,q=0}else j===k&&q!==-1?++q:q=-1}return O}function c(h,F){a(F,"pathObject");const M=F.dir||F.root,R=F.base||`${F.name||""}${F.ext||""}`;return M?M===F.root?`${M}${R}`:`${M}${h}${R}`:R}t.$fc={resolve(...h){let F="",M="",R=!1;for(let O=h.length-1;O>=-1;O--){let v;if(O>=0){if(v=h[O],e(v,"path"),v.length===0)continue}else F.length===0?v=A.cwd():(v=A.env[`=${F}`]||A.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==F.toLowerCase()&&v.charCodeAt(2)===w)&&(v=`${F}\\`));const C=v.length;let q=0,j="",N=!1;const L=v.charCodeAt(0);if(C===1)d(L)&&(q=1,N=!0);else if(d(L))if(N=!0,d(v.charCodeAt(1))){let B=2,Y=B;for(;B<C&&!d(v.charCodeAt(B));)B++;if(B<C&&B!==Y){const X=v.slice(Y,B);for(Y=B;B<C&&d(v.charCodeAt(B));)B++;if(B<C&&B!==Y){for(Y=B;B<C&&!d(v.charCodeAt(B));)B++;(B===C||B!==Y)&&(j=`\\\\${X}\\${v.slice(Y,B)}`,q=B)}}}else q=1;else u(L)&&v.charCodeAt(1)===y&&(j=v.slice(0,2),q=2,C>2&&d(v.charCodeAt(2))&&(N=!0,q=3));if(j.length>0)if(F.length>0){if(j.toLowerCase()!==F.toLowerCase())continue}else F=j;if(R){if(F.length>0)break}else if(M=`${v.slice(q)}\\${M}`,R=N,N&&F.length>0)break}return M=p(M,!R,"\\",d),R?`${F}\\${M}`:`${F}${M}`||"."},normalize(h){e(h,"path");const F=h.length;if(F===0)return".";let M=0,R,O=!1;const v=h.charCodeAt(0);if(F===1)return $(v)?"\\":h;if(d(v))if(O=!0,d(h.charCodeAt(1))){let q=2,j=q;for(;q<F&&!d(h.charCodeAt(q));)q++;if(q<F&&q!==j){const N=h.slice(j,q);for(j=q;q<F&&d(h.charCodeAt(q));)q++;if(q<F&&q!==j){for(j=q;q<F&&!d(h.charCodeAt(q));)q++;if(q===F)return`\\\\${N}\\${h.slice(j)}\\`;q!==j&&(R=`\\\\${N}\\${h.slice(j,q)}`,M=q)}}}else M=1;else u(v)&&h.charCodeAt(1)===y&&(R=h.slice(0,2),M=2,F>2&&d(h.charCodeAt(2))&&(O=!0,M=3));let C=M<F?p(h.slice(M),!O,"\\",d):"";return C.length===0&&!O&&(C="."),C.length>0&&d(h.charCodeAt(F-1))&&(C+="\\"),R===void 0?O?`\\${C}`:C:O?`${R}\\${C}`:`${R}${C}`},isAbsolute(h){e(h,"path");const F=h.length;if(F===0)return!1;const M=h.charCodeAt(0);return d(M)||F>2&&u(M)&&h.charCodeAt(1)===y&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let F,M;for(let v=0;v<h.length;++v){const C=h[v];e(C,"path"),C.length>0&&(F===void 0?F=M=C:F+=`\\${C}`)}if(F===void 0)return".";let R=!0,O=0;if(typeof M=="string"&&d(M.charCodeAt(0))){++O;const v=M.length;v>1&&d(M.charCodeAt(1))&&(++O,v>2&&(d(M.charCodeAt(2))?++O:R=!1))}if(R){for(;O<F.length&&d(F.charCodeAt(O));)O++;O>=2&&(F=`\\${F.slice(O)}`)}return t.$fc.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F)return"";const M=t.$fc.resolve(h),R=t.$fc.resolve(F);if(M===R||(h=M.toLowerCase(),F=R.toLowerCase(),h===F))return"";let O=0;for(;O<h.length&&h.charCodeAt(O)===w;)O++;let v=h.length;for(;v-1>O&&h.charCodeAt(v-1)===w;)v--;const C=v-O;let q=0;for(;q<F.length&&F.charCodeAt(q)===w;)q++;let j=F.length;for(;j-1>q&&F.charCodeAt(j-1)===w;)j--;const N=j-q,L=C<N?C:N;let B=-1,Y=0;for(;Y<L;Y++){const de=h.charCodeAt(O+Y);if(de!==F.charCodeAt(q+Y))break;de===w&&(B=Y)}if(Y!==L){if(B===-1)return R}else{if(N>L){if(F.charCodeAt(q+Y)===w)return R.slice(q+Y+1);if(Y===2)return R.slice(q+Y)}C>L&&(h.charCodeAt(O+Y)===w?B=Y:Y===2&&(B=3)),B===-1&&(B=0)}let X="";for(Y=O+B+1;Y<=v;++Y)(Y===v||h.charCodeAt(Y)===w)&&(X+=X.length===0?"..":"\\..");return q+=B,X.length>0?`${X}${R.slice(q,j)}`:(R.charCodeAt(q)===w&&++q,R.slice(q,j))},toNamespacedPath(h){if(typeof h!="string"||h.length===0)return h;const F=t.$fc.resolve(h);if(F.length<=2)return h;if(F.charCodeAt(0)===w){if(F.charCodeAt(1)===w){const M=F.charCodeAt(2);if(M!==I&&M!==k)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(u(F.charCodeAt(0))&&F.charCodeAt(1)===y&&F.charCodeAt(2)===w)return`\\\\?\\${F}`;return h},dirname(h){e(h,"path");const F=h.length;if(F===0)return".";let M=-1,R=0;const O=h.charCodeAt(0);if(F===1)return d(O)?h:".";if(d(O)){if(M=R=1,d(h.charCodeAt(1))){let q=2,j=q;for(;q<F&&!d(h.charCodeAt(q));)q++;if(q<F&&q!==j){for(j=q;q<F&&d(h.charCodeAt(q));)q++;if(q<F&&q!==j){for(j=q;q<F&&!d(h.charCodeAt(q));)q++;if(q===F)return h;q!==j&&(M=R=q+1)}}}}else u(O)&&h.charCodeAt(1)===y&&(M=F>2&&d(h.charCodeAt(2))?3:2,R=M);let v=-1,C=!0;for(let q=F-1;q>=R;--q)if(d(h.charCodeAt(q))){if(!C){v=q;break}}else C=!1;if(v===-1){if(M===-1)return".";v=M}return h.slice(0,v)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let M=0,R=-1,O=!0,v;if(h.length>=2&&u(h.charCodeAt(0))&&h.charCodeAt(1)===y&&(M=2),F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let C=F.length-1,q=-1;for(v=h.length-1;v>=M;--v){const j=h.charCodeAt(v);if(d(j)){if(!O){M=v+1;break}}else q===-1&&(O=!1,q=v+1),C>=0&&(j===F.charCodeAt(C)?--C===-1&&(R=v):(C=-1,R=q))}return M===R?R=q:R===-1&&(R=h.length),h.slice(M,R)}for(v=h.length-1;v>=M;--v)if(d(h.charCodeAt(v))){if(!O){M=v+1;break}}else R===-1&&(O=!1,R=v+1);return R===-1?"":h.slice(M,R)},extname(h){e(h,"path");let F=0,M=-1,R=0,O=-1,v=!0,C=0;h.length>=2&&h.charCodeAt(1)===y&&u(h.charCodeAt(0))&&(F=R=2);for(let q=h.length-1;q>=F;--q){const j=h.charCodeAt(q);if(d(j)){if(!v){R=q+1;break}continue}O===-1&&(v=!1,O=q+1),j===k?M===-1?M=q:C!==1&&(C=1):M!==-1&&(C=-1)}return M===-1||O===-1||C===0||C===1&&M===O-1&&M===R+1?"":h.slice(M,O)},format:c.bind(null,"\\"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const M=h.length;let R=0,O=h.charCodeAt(0);if(M===1)return d(O)?(F.root=F.dir=h,F):(F.base=F.name=h,F);if(d(O)){if(R=1,d(h.charCodeAt(1))){let B=2,Y=B;for(;B<M&&!d(h.charCodeAt(B));)B++;if(B<M&&B!==Y){for(Y=B;B<M&&d(h.charCodeAt(B));)B++;if(B<M&&B!==Y){for(Y=B;B<M&&!d(h.charCodeAt(B));)B++;B===M?R=B:B!==Y&&(R=B+1)}}}}else if(u(O)&&h.charCodeAt(1)===y){if(M<=2)return F.root=F.dir=h,F;if(R=2,d(h.charCodeAt(2))){if(M===3)return F.root=F.dir=h,F;R=3}}R>0&&(F.root=h.slice(0,R));let v=-1,C=R,q=-1,j=!0,N=h.length-1,L=0;for(;N>=R;--N){if(O=h.charCodeAt(N),d(O)){if(!j){C=N+1;break}continue}q===-1&&(j=!1,q=N+1),O===k?v===-1?v=N:L!==1&&(L=1):v!==-1&&(L=-1)}return q!==-1&&(v===-1||L===0||L===1&&v===q-1&&v===C+1?F.base=F.name=h.slice(C,q):(F.name=h.slice(C,v),F.base=h.slice(C,q),F.ext=h.slice(v,q))),C>0&&C!==R?F.dir=h.slice(0,C-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(r){const h=/\\/g;return()=>{const F=A.cwd().replace(h,"/");return F.slice(F.indexOf("/"))}}return()=>A.cwd()})();t.$gc={resolve(...h){let F="",M=!1;for(let R=h.length-1;R>=-1&&!M;R--){const O=R>=0?h[R]:f();e(O,"path"),O.length!==0&&(F=`${O}/${F}`,M=O.charCodeAt(0)===b)}return F=p(F,!M,"/",$),M?`/${F}`:F.length>0?F:"."},normalize(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===b,M=h.charCodeAt(h.length-1)===b;return h=p(h,!F,"/",$),h.length===0?F?"/":M?"./":".":(M&&(h+="/"),F?`/${h}`:h)},isAbsolute(h){return e(h,"path"),h.length>0&&h.charCodeAt(0)===b},join(...h){if(h.length===0)return".";let F;for(let M=0;M<h.length;++M){const R=h[M];e(R,"path"),R.length>0&&(F===void 0?F=R:F+=`/${R}`)}return F===void 0?".":t.$gc.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F||(h=t.$gc.resolve(h),F=t.$gc.resolve(F),h===F))return"";const M=1,R=h.length,O=R-M,v=1,C=F.length-v,q=O<C?O:C;let j=-1,N=0;for(;N<q;N++){const B=h.charCodeAt(M+N);if(B!==F.charCodeAt(v+N))break;B===b&&(j=N)}if(N===q)if(C>q){if(F.charCodeAt(v+N)===b)return F.slice(v+N+1);if(N===0)return F.slice(v+N)}else O>q&&(h.charCodeAt(M+N)===b?j=N:N===0&&(j=0));let L="";for(N=M+j+1;N<=R;++N)(N===R||h.charCodeAt(N)===b)&&(L+=L.length===0?"..":"/..");return`${L}${F.slice(v+j)}`},toNamespacedPath(h){return h},dirname(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===b;let M=-1,R=!0;for(let O=h.length-1;O>=1;--O)if(h.charCodeAt(O)===b){if(!R){M=O;break}}else R=!1;return M===-1?F?"/":".":F&&M===1?"//":h.slice(0,M)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let M=0,R=-1,O=!0,v;if(F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let C=F.length-1,q=-1;for(v=h.length-1;v>=0;--v){const j=h.charCodeAt(v);if(j===b){if(!O){M=v+1;break}}else q===-1&&(O=!1,q=v+1),C>=0&&(j===F.charCodeAt(C)?--C===-1&&(R=v):(C=-1,R=q))}return M===R?R=q:R===-1&&(R=h.length),h.slice(M,R)}for(v=h.length-1;v>=0;--v)if(h.charCodeAt(v)===b){if(!O){M=v+1;break}}else R===-1&&(O=!1,R=v+1);return R===-1?"":h.slice(M,R)},extname(h){e(h,"path");let F=-1,M=0,R=-1,O=!0,v=0;for(let C=h.length-1;C>=0;--C){const q=h.charCodeAt(C);if(q===b){if(!O){M=C+1;break}continue}R===-1&&(O=!1,R=C+1),q===k?F===-1?F=C:v!==1&&(v=1):F!==-1&&(v=-1)}return F===-1||R===-1||v===0||v===1&&F===R-1&&F===M+1?"":h.slice(F,R)},format:c.bind(null,"/"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const M=h.charCodeAt(0)===b;let R;M?(F.root="/",R=1):R=0;let O=-1,v=0,C=-1,q=!0,j=h.length-1,N=0;for(;j>=R;--j){const L=h.charCodeAt(j);if(L===b){if(!q){v=j+1;break}continue}C===-1&&(q=!1,C=j+1),L===k?O===-1?O=j:N!==1&&(N=1):O!==-1&&(N=-1)}if(C!==-1){const L=v===0&&M?1:v;O===-1||N===0||N===1&&O===C-1&&O===v+1?F.base=F.name=h.slice(L,C):(F.name=h.slice(L,O),F.base=h.slice(L,C),F.ext=h.slice(O,C))}return v>0?F.dir=h.slice(0,v-1):M&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=r?t.$fc.normalize:t.$gc.normalize,t.$ic=r?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=r?t.$fc.join:t.$gc.join,t.$kc=r?t.$fc.resolve:t.$gc.resolve,t.$lc=r?t.$fc.relative:t.$gc.relative,t.$mc=r?t.$fc.dirname:t.$gc.dirname,t.$nc=r?t.$fc.basename:t.$gc.basename,t.$oc=r?t.$fc.extname:t.$gc.extname,t.$pc=r?t.$fc.format:t.$gc.format,t.$qc=r?t.$fc.parse:t.$gc.parse,t.$rc=r?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=r?t.$fc.sep:t.$gc.sep,t.$tc=r?t.$fc.delimiter:t.$gc.delimiter}),define(be[116],pe([1,0,24,5,10,7]),function(ie,t,A,P,s,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=void 0;function E(v){return v===47||v===92}t.$Zf=E;function k(v){return v.replace(/[\\/]/g,A.$gc.sep)}t.$1f=k;function b(v){return v.indexOf("/")===-1&&(v=k(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$2f=b;function w(v,C=A.$gc.sep){if(!v)return"";const q=v.length,j=v.charCodeAt(0);if(E(j)){if(E(v.charCodeAt(1))&&!E(v.charCodeAt(2))){let L=3;const B=L;for(;L<q&&!E(v.charCodeAt(L));L++);if(B!==L&&!E(v.charCodeAt(L+1))){for(L+=1;L<q;L++)if(E(v.charCodeAt(L)))return v.slice(0,L+1).replace(/[\\/]/g,C)}}return C}else if($(j)&&v.charCodeAt(1)===58)return E(v.charCodeAt(2))?v.slice(0,2)+C:v.slice(0,2);let N=v.indexOf("://");if(N!==-1){for(N+=3;N<q;N++)if(E(v.charCodeAt(N)))return v.slice(0,N+1)}return""}t.$3f=w;function y(v){if(!P.$i||!v||v.length<5)return!1;let C=v.charCodeAt(0);if(C!==92||(C=v.charCodeAt(1),C!==92))return!1;let q=2;const j=q;for(;q<v.length&&(C=v.charCodeAt(q),C!==92);q++);return!(j===q||(C=v.charCodeAt(q+1),isNaN(C)||C===92))}t.$4f=y;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,C=P.$i){const q=C?I:o;return!(!v||v.length===0||/^\s+$/.test(v)||(q.lastIndex=0,q.test(v))||C&&a.test(v)||v==="."||v===".."||C&&v[v.length-1]==="."||C&&v.length!==v.trim().length||v.length>255)}t.$5f=e;function r(v,C,q){const j=v===C;return!q||j?j:!v||!C?!1:(0,s.$$e)(v,C)}t.$6f=r;function d(v,C,q,j=A.sep){if(v===C)return!0;if(!v||!C||C.length>v.length)return!1;if(q){if(!(0,s.$_e)(v,C))return!1;if(C.length===v.length)return!0;let L=C.length;return C.charAt(C.length-1)===j&&L--,v.charAt(L)===j}return C.charAt(C.length-1)!==j&&(C+=j),v.indexOf(C)===0}t.$7f=d;function $(v){return v>=65&&v<=90||v>=97&&v<=122}t.$8f=$;function u(v,C){return P.$i&&v.endsWith(":")&&(v+=A.sep),(0,A.$ic)(v)||(v=(0,A.$jc)(C,v)),v=(0,A.$hc)(v),P.$i?(v=(0,s.$Te)(v,A.sep),v.endsWith(":")&&(v+=A.sep)):(v=(0,s.$Te)(v,A.sep),v||(v=A.sep)),v}t.$9f=u;function p(v){const C=(0,A.$hc)(v);return P.$i?v.length>3?!1:c(C)&&(v.length===2||C.charCodeAt(2)===92):C===A.$gc.sep}t.$0f=p;function c(v,C=P.$i){return C?$(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$$f=c;function f(v,C=P.$i){return c(v,C)?v[0]:void 0}t.$_f=f;function h(v,C,q){return C.length>v.length?-1:v===C?0:(q&&(v=v.toLowerCase(),C=C.toLowerCase()),v.indexOf(C))}t.$ag=h;function F(v){const C=v.split(":");let q,j,N;for(const L of C){const B=Number(L);(0,U.$Lf)(B)?j===void 0?j=B:N===void 0&&(N=B):q=q?[q,L].join(":"):L}if(!q)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:q,line:j!==void 0?j:void 0,column:N!==void 0?N:j!==void 0?1:void 0}}t.$bg=F;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function O(v,C,q=8){let j="";for(let L=0;L<q;L++){let B;L===0&&P.$i&&!C&&(q===3||q===4)?B=R:B=M,j+=B.charAt(Math.floor(Math.random()*B.length))}let N;return C?N=`${C}-${j}`:N=j,v?(0,A.$jc)(v,N):N}t.$cg=O}),define(be[117],pe([1,0,24]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$is=t.$hs=t.$gs=t.$fs=t.$es=void 0,t.$es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(y){const I=(0,A.$oc)(y),o=P[I.toLowerCase()];return o!==void 0?o:E(y)}t.$fs=U;function E(y){const I=(0,A.$oc)(y);return s[I.toLowerCase()]}t.$gs=E;function k(y){for(const I in s)if(s[I]===y)return I}t.$hs=k;const b=/^(.+)\/(.+?)(;.+)?$/;function w(y,I){const o=b.exec(y);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:I?void 0:y}t.$is=w}),define(be[15],pe([1,0,24,5]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const s=/^\w[\w\d+.-]*$/,U=/^\//,E=/^\/\//;function k(R,O){if(!R.scheme&&O)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!s.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!U.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(R,O){return!R&&!O?"file":R}function w(R,O){switch(R){case"https":case"http":case"file":O?O[0]!==I&&(O=I+O):O=I;break}return O}const y="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(O){return O instanceof a?!0:O?typeof O.authority=="string"&&typeof O.fragment=="string"&&typeof O.path=="string"&&typeof O.query=="string"&&typeof O.scheme=="string"&&typeof O.fsPath=="string"&&typeof O.with=="function"&&typeof O.toString=="function":!1}constructor(O,v,C,q,j,N=!1){typeof O=="object"?(this.scheme=O.scheme||y,this.authority=O.authority||y,this.path=O.path||y,this.query=O.query||y,this.fragment=O.fragment||y):(this.scheme=b(O,N),this.authority=v||y,this.path=w(this.scheme,C||y),this.query=q||y,this.fragment=j||y,k(this,N))}get fsPath(){return c(this,!1)}with(O){if(!O)return this;let{scheme:v,authority:C,path:q,query:j,fragment:N}=O;return v===void 0?v=this.scheme:v===null&&(v=y),C===void 0?C=this.authority:C===null&&(C=y),q===void 0?q=this.path:q===null&&(q=y),j===void 0?j=this.query:j===null&&(j=y),N===void 0?N=this.fragment:N===null&&(N=y),v===this.scheme&&C===this.authority&&q===this.path&&j===this.query&&N===this.fragment?this:new d(v,C,q,j,N)}static parse(O,v=!1){const C=o.exec(O);return C?new d(C[2]||y,M(C[4]||y),M(C[5]||y),M(C[7]||y),M(C[9]||y),v):new d(y,y,y,y,y)}static file(O){let v=y;if(P.$i&&(O=O.replace(/\\/g,I)),O[0]===I&&O[1]===I){const C=O.indexOf(I,2);C===-1?(v=O.substring(2),O=I):(v=O.substring(2,C),O=O.substring(C)||I)}return new d("file",v,O,y,y)}static from(O,v){return new d(O.scheme,O.authority,O.path,O.query,O.fragment,v)}static joinPath(O,...v){if(!O.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return P.$i&&O.scheme==="file"?C=a.file(A.$fc.join(c(O,!0),...v)).path:C=A.$gc.join(O.path,...v),O.with({path:C})}toString(O=!1){return f(this,O)}toJSON(){return this}static revive(O){if(O){if(O instanceof a)return O;{const v=new d(O);return v._formatted=O.external??null,v._fsPath=O._sep===r?O.fsPath??null:null,v}}else return O}}t.URI=a;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$vc=e;const r=P.$i?1:void 0;class d extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(O=!1){return O?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const O={$mid:1};return this._fsPath&&(O.fsPath=this._fsPath,O._sep=r),this._formatted&&(O.external=this._formatted),this.path&&(O.path=this.path),this.scheme&&(O.scheme=this.scheme),this.authority&&(O.authority=this.authority),this.query&&(O.query=this.query),this.fragment&&(O.fragment=this.fragment),O}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(R,O,v){let C,q=-1;for(let j=0;j<R.length;j++){const N=R.charCodeAt(j);if(N>=97&&N<=122||N>=65&&N<=90||N>=48&&N<=57||N===45||N===46||N===95||N===126||O&&N===47||v&&N===91||v&&N===93||v&&N===58)q!==-1&&(C+=encodeURIComponent(R.substring(q,j)),q=-1),C!==void 0&&(C+=R.charAt(j));else{C===void 0&&(C=R.substr(0,j));const L=$[N];L!==void 0?(q!==-1&&(C+=encodeURIComponent(R.substring(q,j)),q=-1),C+=L):q===-1&&(q=j)}}return q!==-1&&(C+=encodeURIComponent(R.substring(q))),C!==void 0?C:R}function p(R){let O;for(let v=0;v<R.length;v++){const C=R.charCodeAt(v);C===35||C===63?(O===void 0&&(O=R.substr(0,v)),O+=$[C]):O!==void 0&&(O+=R[v])}return O!==void 0?O:R}function c(R,O){let v;return R.authority&&R.path.length>1&&R.scheme==="file"?v=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?O?v=R.path.substr(1):v=R.path[1].toLowerCase()+R.path.substr(2):v=R.path,P.$i&&(v=v.replace(/\//g,"\\")),v}t.$wc=c;function f(R,O){const v=O?p:u;let C="",{scheme:q,authority:j,path:N,query:L,fragment:B}=R;if(q&&(C+=q,C+=":"),(j||q==="file")&&(C+=I,C+=I),j){let Y=j.indexOf("@");if(Y!==-1){const X=j.substr(0,Y);j=j.substr(Y+1),Y=X.lastIndexOf(":"),Y===-1?C+=v(X,!1,!1):(C+=v(X.substr(0,Y),!1,!1),C+=":",C+=v(X.substr(Y+1),!1,!0)),C+="@"}j=j.toLowerCase(),Y=j.lastIndexOf(":"),Y===-1?C+=v(j,!1,!0):(C+=v(j.substr(0,Y),!1,!0),C+=j.substr(Y))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const Y=N.charCodeAt(1);Y>=65&&Y<=90&&(N=`/${String.fromCharCode(Y+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const Y=N.charCodeAt(0);Y>=65&&Y<=90&&(N=`${String.fromCharCode(Y+32)}:${N.substr(2)}`)}C+=v(N,!0,!1)}return L&&(C+="?",C+=v(L,!1,!1)),B&&(C+="#",C+=O?B:u(B,!1,!1)),C}function h(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+h(R.substr(3)):R}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function M(R){return R.match(F)?R.replace(F,O=>h(O)):R}}),define(be[53],pe([1,0,33,15]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bh=t.$Ah=t.$zh=void 0;function s(b){return JSON.stringify(b,E)}t.$zh=s;function U(b){let w=JSON.parse(b);return w=k(w),w}t.$Ah=U;function E(b,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function k(b,w=0){if(!b||w>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return P.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof A.$ie||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=k(b[y],w+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=k(b[y],w+1))}return b}t.$Bh=k}),define(be[31],pe([1,0,6,5,10,15]),function(ie,t,A,P,s,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.Schemas=void 0;var E;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm"})(E||(t.Schemas=E={}));function k(o,a){return U.URI.isUri(o)?(0,s.$$e)(o.scheme,a):(0,s.$_e)(o,a+":")}t.$dg=k;function b(o,...a){return a.some(e=>k(o,e))}t.$eg=b,t.$fg="vscode-tkn",t.$gg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${E.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${E.vscodeRemoteResource}`}set(a,e,r){this.a[a]=e,this.b[a]=r}setConnectionToken(a,e){this.c[a]=e}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(p){return A.$1(p),a}const e=a.authority;let r=this.a[e];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const d=this.b[e],$=this.c[e];let u=`path=${encodeURIComponent(a.path)}`;return typeof $=="string"&&(u+=`&${t.$gg}=${encodeURIComponent($)}`),U.URI.from({scheme:P.$o?this.d:E.vscodeRemoteResource,authority:`${r}:${d}`,path:this.f,query:u})}}t.$hg=new w,t.$ig="vs/../../extensions",t.$jg="vs/../../node_modules",t.$kg="vs/../../node_modules.asar",t.$lg="vs/../../node_modules.asar.unpacked",t.$mg="vscode-app";class y{static{this.a=t.$mg}asBrowserUri(a){const e=this.b(a,ie);return this.uriToBrowserUri(e)}uriToBrowserUri(a){return a.scheme===E.vscodeRemote?t.$hg.rewrite(a):a.scheme===E.file&&(P.$m||P.$q===`${E.vscodeFileResource}://${y.a}`)?a.with({scheme:E.vscodeFileResource,authority:a.authority||y.a,query:null,fragment:null}):a}asFileUri(a){const e=this.b(a,ie);return this.uriToFileUri(e)}uriToFileUri(a){return a.scheme===E.vscodeFileResource?a.with({scheme:E.file,authority:a.authority!==y.a?a.authority:null,query:null,fragment:null}):a}b(a,e){return U.URI.isUri(a)?a:U.URI.parse(e.toUrl(a))}}t.$ng=new y;var I;(function(o){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(a.get("3"));const e="vscode-coi";function r($){let u;typeof $=="string"?u=new URL($).searchParams:$ instanceof URL?u=$.searchParams:U.URI.isUri($)&&(u=new URL($.toString(!0)).searchParams);const p=u?.get(e);if(p)return a.get(p)}o.getHeadersFromQuery=r;function d($,u,p){if(!globalThis.crossOriginIsolated)return;const c=u&&p?"3":p?"2":"1";$ instanceof URLSearchParams?$.set(e,c):$[e]=c}o.addSearchParam=d})(I||(t.COI=I={}))}),define(be[37],pe([1,0,116,31,24,5,10,15]),function(ie,t,A,P,s,U,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qg=t.DataUri=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=void 0;function b(a){return(0,k.$wc)(a,!0)}t.$ug=b;class w{constructor(e){this.a=e}compare(e,r,d=!1){return e===r?0:(0,E.$4e)(this.getComparisonKey(e,d),this.getComparisonKey(r,d))}isEqual(e,r,d=!1){return e===r?!0:!e||!r?!1:this.getComparisonKey(e,d)===this.getComparisonKey(r,d)}getComparisonKey(e,r=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,r,d=!1){if(e.scheme===r.scheme){if(e.scheme===P.Schemas.file)return A.$7f(b(e),b(r),this.a(e))&&e.query===r.query&&(d||e.fragment===r.fragment);if((0,t.$Lg)(e.authority,r.authority))return A.$7f(e.path,r.path,this.a(e),"/")&&e.query===r.query&&(d||e.fragment===r.fragment)}return!1}joinPath(e,...r){return k.URI.joinPath(e,...r)}basenameOrAuthority(e){return(0,t.$Dg)(e)||e.authority}basename(e){return s.$gc.basename(e.path)}extname(e){return s.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let r;return e.scheme===P.Schemas.file?r=k.URI.file(s.$mc(b(e))).path:(r=s.$gc.dirname(e.path),e.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),r="/")),e.with({path:r})}normalizePath(e){if(!e.path.length)return e;let r;return e.scheme===P.Schemas.file?r=k.URI.file(s.$hc(b(e))).path:r=s.$gc.normalize(e.path),e.with({path:r})}relativePath(e,r){if(e.scheme!==r.scheme||!(0,t.$Lg)(e.authority,r.authority))return;if(e.scheme===P.Schemas.file){const u=s.$lc(b(e),b(r));return U.$i?A.$1f(u):u}let d=e.path||"/";const $=r.path||"/";if(this.a(e)){let u=0;for(const p=Math.min(d.length,$.length);u<p&&!(d.charCodeAt(u)!==$.charCodeAt(u)&&d.charAt(u).toLowerCase()!==$.charAt(u).toLowerCase());u++);d=$.substr(0,u)+d.substr(u)}return s.$gc.relative(d,$)}resolvePath(e,r){if(e.scheme===P.Schemas.file){const d=k.URI.file(s.$kc(b(e),r));return e.with({authority:d.authority,path:d.path})}return r=A.$2f(r),e.with({path:s.$gc.resolve(e.path,r)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,r){return e===r||e!==void 0&&r!==void 0&&(0,E.$$e)(e,r)}hasTrailingPathSeparator(e,r=s.sep){if(e.scheme===P.Schemas.file){const d=b(e);return d.length>A.$3f(d).length&&d[d.length-1]===r}else{const d=e.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,r=s.sep){return(0,t.$Mg)(e,r)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,r=s.sep){let d=!1;if(e.scheme===P.Schemas.file){const $=b(e);d=$!==void 0&&$.length===A.$3f($).length&&$[$.length-1]===r}else{r="/";const $=e.path;d=$.length===1&&$.charCodeAt($.length-1)===47}return!d&&!(0,t.$Mg)(e,r)?e.with({path:e.path+"/"}):e}}t.$vg=w,t.$wg=new w(()=>!1),t.$xg=new w(a=>a.scheme===P.Schemas.file?!U.$k:!0),t.$yg=new w(a=>!0),t.$zg=t.$wg.isEqual.bind(t.$wg),t.$Ag=t.$wg.isEqualOrParent.bind(t.$wg),t.$Bg=t.$wg.getComparisonKey.bind(t.$wg),t.$Cg=t.$wg.basenameOrAuthority.bind(t.$wg),t.$Dg=t.$wg.basename.bind(t.$wg),t.$Eg=t.$wg.extname.bind(t.$wg),t.$Fg=t.$wg.dirname.bind(t.$wg),t.$Gg=t.$wg.joinPath.bind(t.$wg),t.$Hg=t.$wg.normalizePath.bind(t.$wg),t.$Ig=t.$wg.relativePath.bind(t.$wg),t.$Jg=t.$wg.resolvePath.bind(t.$wg),t.$Kg=t.$wg.isAbsolutePath.bind(t.$wg),t.$Lg=t.$wg.isEqualAuthority.bind(t.$wg),t.$Mg=t.$wg.hasTrailingPathSeparator.bind(t.$wg),t.$Ng=t.$wg.removeTrailingPathSeparator.bind(t.$wg),t.$Og=t.$wg.addTrailingPathSeparator.bind(t.$wg);function y(a,e){const r=[];for(let d=0;d<a.length;d++){const $=e(a[d]);a.some((u,p)=>p===d?!1:(0,t.$Ag)($,e(u)))||r.push(a[d])}return r}t.$Pg=y;var I;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(r){const d=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(p=>{const[c,f]=p.split(":");c&&f&&d.set(c,f)});const u=r.path.substring(0,r.path.indexOf(";"));return u&&d.set(a.META_DATA_MIME,u),d}a.parseMetaData=e})(I||(t.DataUri=I={}));function o(a,e,r){if(e){let d=a.path;return d&&d[0]!==s.$gc.sep&&(d=s.$gc.sep+d),a.with({scheme:r,authority:e,path:d})}return a.with({scheme:r})}t.$Qg=o}),define(be[9],pe([1,0,29,6,4,2,37,5,50,23]),function(ie,t,A,P,s,U,E,k,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.Promises=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=void 0;function y(m){return!!m&&typeof m.then=="function"}t.$Rg=y;function I(m){const i=new A.$5d,n=m(i.token),l=new Promise((D,S)=>{const z=i.token.onCancellationRequested(()=>{z.dispose(),S(new P.$5)});Promise.resolve(n).then(T=>{z.dispose(),i.dispose(),D(T)},T=>{z.dispose(),i.dispose(),S(T)})});return new class{cancel(){i.cancel(),i.dispose()}then(D,S){return l.then(D,S)}catch(D){return this.then(void 0,D)}finally(D){return l.finally(D)}}}t.$Sg=I;function o(m,i,n){return new Promise((l,D)=>{const S=i.onCancellationRequested(()=>{S.dispose(),l(n)});m.then(l,D).finally(()=>S.dispose())})}t.$Tg=o;function a(m,i){return new Promise((n,l)=>{const D=i.onCancellationRequested(()=>{D.dispose(),l(new P.$5)});m.then(n,l).finally(()=>D.dispose())})}t.$Ug=a;async function e(m){let i=-1;const n=m.map((l,D)=>l.then(S=>(i=D,S)));try{return await Promise.race(n)}finally{m.forEach((l,D)=>{D!==i&&l.cancel()})}}t.$Vg=e;function r(m,i,n){let l;const D=setTimeout(()=>{l?.(void 0),n?.()},i);return Promise.race([m.finally(()=>clearTimeout(D)),new Promise(S=>l=S)])}t.$Wg=r;function d(m){return new Promise((i,n)=>{const l=m();y(l)?l.then(i,n):i(l)})}t.$Xg=d;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(i){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=i,!this.b){const n=()=>{if(this.b=null,this.f)return;const l=this.queue(this.d);return this.d=null,l};this.b=new Promise(l=>{this.a.then(n,n).then(l)})}return new Promise((n,l)=>{this.b.then(n,l)})}return this.a=i(),new Promise((n,l)=>{this.a.then(D=>{this.a=null,n(D)},D=>{this.a=null,l(D)})})}dispose(){this.f=!0}}t.$Yg=$;class u{constructor(){this.a=Promise.resolve(null)}queue(i){return this.a=this.a.then(()=>i(),()=>i())}}t.$Zg=u;class p{constructor(){this.a=new Map}queue(i,n){const D=(this.a.get(i)??Promise.resolve()).catch(()=>{}).then(n).finally(()=>{this.a.get(i)===D&&this.a.delete(i)});return this.a.set(i,D),D}}t.$1g=p;const c=(m,i)=>{let n=!0;const l=setTimeout(()=>{n=!1,i()},m);return{isTriggered:()=>n,dispose:()=>{clearTimeout(l),n=!1}}},f=m=>{let i=!0;return queueMicrotask(()=>{i&&(i=!1,m())}),{isTriggered:()=>i,dispose:()=>{i=!1}}};class h{constructor(i){this.defaultDelay=i,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(i,n=this.defaultDelay){this.g=i,this.h(),this.b||(this.b=new Promise((D,S)=>{this.d=D,this.f=S}).then(()=>{if(this.b=null,this.d=null,this.g){const D=this.g;return this.g=null,D()}}));const l=()=>{this.a=null,this.d?.(null)};return this.a=n===b.$Rd?f(l):c(n,l),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$2g=h;class F{constructor(i){this.a=new h(i),this.b=new $}trigger(i,n){return this.a.trigger(()=>this.b.queue(i),n)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$3g=F;class M{constructor(){this.a=!1,this.b=new Promise((i,n)=>{this.d=i})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$4g=M;class R extends M{constructor(i){super(),this.f=setTimeout(()=>this.open(),i)}open(){clearTimeout(this.f),super.open()}}t.$5g=R;function O(m,i){return i?new Promise((n,l)=>{const D=setTimeout(()=>{S.dispose(),n()},m),S=i.onCancellationRequested(()=>{clearTimeout(D),S.dispose(),l(new P.$5)})}):I(n=>O(m,n))}t.$6g=O;function v(m,i=0,n){const l=setTimeout(()=>{m(),n&&D.dispose()},i),D=(0,U.$Rc)(()=>{clearTimeout(l),n?.deleteAndLeak(D)});return n?.add(D),D}t.$7g=v;function C(m){const i=[];let n=0;const l=m.length;function D(){return n<l?m[n++]():null}function S(z){z!=null&&i.push(z);const T=D();return T?T.then(S):Promise.resolve(i)}return Promise.resolve(null).then(S)}t.$8g=C;function q(m,i=l=>!!l,n=null){let l=0;const D=m.length,S=()=>{if(l>=D)return Promise.resolve(n);const z=m[l++];return Promise.resolve(z()).then(H=>i(H)?Promise.resolve(H):S())};return S()}t.$9g=q;function j(m,i=l=>!!l,n=null){if(m.length===0)return Promise.resolve(n);let l=m.length;const D=()=>{l=-1;for(const S of m)S.cancel?.()};return new Promise((S,z)=>{for(const T of m)T.then(H=>{--l>=0&&i(H)?(D(),S(H)):l===0&&S(n)}).catch(H=>{--l>=0&&(D(),z(H))})})}t.$0g=j;class N{constructor(i){this.a=0,this.b=!1,this.f=i,this.g=[],this.d=0,this.h=new s.$Ud}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(i){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((n,l)=>{this.g.push({factory:i,c:n,e:l}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const i=this.g.shift();this.d++;const n=i.factory();n.then(i.c,i.e),n.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.h.dispose()}}t.$$g=N;class L extends N{constructor(){super(1)}}t.$_g=L;class B{constructor(){this.a=new J,this.b=0}queue(i){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,i())):this.a.run(this.b++,i())}}t.$ah=B;class Y{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const i=new W;return this.b.add(i),i.p}g(){for(const[,i]of this.a)if(i.size>0)return!1;return!0}queueFor(i,n=E.$wg){const l=n.getComparisonKey(i);let D=this.a.get(l);if(!D){D=new L;const S=this.f++,z=s.Event.once(D.onDrained)(()=>{D?.dispose(),this.a.delete(l),this.h(),this.d?.deleteAndDispose(S),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$3c),this.d.set(S,z),this.a.set(l,D)}return D}h(){this.g()&&this.j()}j(){for(const i of this.b)i.complete();this.b.clear()}dispose(){for(const[,i]of this.a)i.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$bh=Y;class X{constructor(i,n){this.a=-1,typeof i=="function"&&typeof n=="number"&&this.setIfNotSet(i,n)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(i,n){this.cancel(),this.a=setTimeout(()=>{this.a=-1,i()},n)}setIfNotSet(i,n){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,i()},n))}}t.$ch=X;class de{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(i,n,l=globalThis){this.cancel();const D=l.setInterval(()=>{i()},n);this.d=(0,U.$Rc)(()=>{l.clearInterval(D),this.d=void 0})}dispose(){this.cancel()}}t.$dh=de;class oe{constructor(i,n){this.b=-1,this.a=i,this.d=n,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(i=this.d){this.cancel(),this.b=setTimeout(this.f,i)}get delay(){return this.d}set delay(i){this.d=i}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$eh=oe;class ee{constructor(i,n){n%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${n}ms is not a multiple of 1000ms.`),this.a=i,this.b=n,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(i=this.b){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(i/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$fh=ee;class me extends oe{constructor(i,n){super(i,n),this.j=[]}work(i){this.j.push(i),this.isScheduled()||this.schedule()}h(){const i=this.j;this.j=[],this.a?.(i)}dispose(){this.j=[],super.dispose()}}t.$gh=me;class Te extends U.$Tc{constructor(i,n){super(),this.g=i,this.h=n,this.a=[],this.b=this.B(new U.$Uc),this.f=!1}get pending(){return this.a.length}work(i){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+i.length>this.g.maxBufferedWork)return!1}else if(this.pending+i.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const n of i)this.a.push(n);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new oe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$hh=Te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$jh=(m,i)=>{(0,k.$B)(()=>{if(n)return;const l=Date.now()+15;i(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,l-Date.now())}}))});let n=!1;return{dispose(){n||(n=!0)}}}:t.$jh=(m,i,n)=>{const l=m.requestIdleCallback(i,typeof n=="number"?{timeout:n}:void 0);let D=!1;return{dispose(){D||(D=!0,m.cancelIdleCallback(l))}}},t.$ih=m=>(0,t.$jh)(globalThis,m)}();class Ne{constructor(i,n){this.g=!1,this.d=()=>{try{this.j=n()}catch(l){this.l=l}finally{this.g=!0}},this.f=(0,t.$jh)(i,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$kh=Ne;class Me extends Ne{constructor(i){super(globalThis,i)}}t.$lh=Me;async function re(m,i,n){let l;for(let D=0;D<n;D++)try{return await m()}catch(S){l=S,await O(i)}throw l}t.$mh=re;class J{isRunning(i){return typeof i=="number"?this.a?.taskId===i:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(i,n,l){return this.a={taskId:i,cancel:()=>l?.(),promise:n},n.then(()=>this.d(i),()=>this.d(i)),n}d(i){this.a&&i===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const i=this.b;this.b=void 0,i.run().then(i.promiseResolve,i.promiseReject)}}queue(i){if(this.b)this.b.run=i;else{let n,l;const D=new Promise((S,z)=>{n=S,l=z});this.b={run:i,promise:D,promiseResolve:n,promiseReject:l}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$nh=J;class le{constructor(i,n=()=>Date.now()){this.d=i,this.f=n,this.a=0,this.b=0}increment(){const i=this.f();return i-this.a>this.d&&(this.a=i,this.b=0),this.b++,this.b}}t.$oh=le;var K;(function(m){m[m.Resolved=0]="Resolved",m[m.Rejected=1]="Rejected"})(K||(K={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((i,n)=>{this.a=i,this.b=n})}complete(i){return new Promise(n=>{this.a(i),this.d={outcome:0,value:i},n()})}error(i){return new Promise(n=>{this.b(i),this.d={outcome:1,value:i},n()})}cancel(){return this.error(new P.$5)}}t.$ph=W;var Z;(function(m){async function i(l){let D;const S=await Promise.all(l.map(z=>z.then(T=>T,T=>{D||(D=T)})));if(typeof D<"u")throw D;return S}m.settled=i;function n(l){return new Promise(async(D,S)=>{try{await l(D,S)}catch(z){S(z)}})}m.withAsyncBody=n})(Z||(t.Promises=Z={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(i){this.a=void 0,this.b=void 0,this.d=!1,this.promise=i.then(n=>(this.a=n,this.d=!0,n),n=>{throw this.b=n,this.d=!0,n})}requireValue(){if(!this.d)throw new P.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$qh=ce;class we{constructor(i){this.b=i,this.a=new w.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}t.$rh=we;var Ae;(function(m){m[m.Initial=0]="Initial",m[m.DoneOK=1]="DoneOK",m[m.DoneError=2]="DoneError"})(Ae||(Ae={}));class ke{static fromArray(i){return new ke(n=>{n.emitMany(i)})}static fromPromise(i){return new ke(async n=>{n.emitMany(await i)})}static fromPromises(i){return new ke(async n=>{await Promise.all(i.map(async l=>n.emitOne(await l)))})}static merge(i){return new ke(async n=>{await Promise.all(i.map(async l=>{for await(const D of l)n.emitOne(D)}))})}static{this.EMPTY=ke.fromArray([])}constructor(i){this.a=0,this.b=[],this.d=null,this.f=new s.$Ud,queueMicrotask(async()=>{const n={emitOne:l=>this.g(l),emitMany:l=>this.h(l),reject:l=>this.k(l)};try{await Promise.resolve(i(n)),this.j()}catch(l){this.k(l)}finally{n.emitOne=void 0,n.emitMany=void 0,n.reject=void 0}})}[Symbol.asyncIterator](){let i=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(i<this.b.length)return{done:!1,value:this.b[i++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(i,n){return new ke(async l=>{for await(const D of i)l.emitOne(n(D))})}map(i){return ke.map(this,i)}static filter(i,n){return new ke(async l=>{for await(const D of i)n(D)&&l.emitOne(D)})}filter(i){return ke.filter(this,i)}static coalesce(i){return ke.filter(i,n=>!!n)}coalesce(){return ke.coalesce(this)}static async toPromise(i){const n=[];for await(const l of i)n.push(l);return n}toPromise(){return ke.toPromise(this)}g(i){this.a===0&&(this.b.push(i),this.f.fire())}h(i){this.a===0&&(this.b=this.b.concat(i),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(i){this.a===0&&(this.a=2,this.d=i,this.f.fire())}}t.$sh=ke;class Le extends ke{constructor(i,n){super(n),this.l=i}cancel(){this.l.cancel()}}t.$th=Le;function _(m){const i=new A.$5d,n=m(i.token);return new Le(i,async l=>{const D=i.token.onCancellationRequested(()=>{D.dispose(),i.dispose(),l.reject(new P.$5)});try{for await(const S of n){if(i.token.isCancellationRequested)return;l.emitOne(S)}D.dispose(),i.dispose()}catch(S){D.dispose(),i.dispose(),l.reject(S)}})}t.$uh=_;class g{constructor(){this.a=new W,this.b=new ke(l=>{if(i){l.reject(i);return}return n&&l.emitMany(n),this.d=D=>l.reject(D),this.f=D=>l.emitOne(D),this.a.p});let i,n;this.f=l=>{n||(n=[]),n.push(l)},this.d=l=>{i||(i=l)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(i){this.d(i),this.a.complete()}emitOne(i){this.f(i)}}t.$vh=g}),define(be[3],pe([1,0,16,114,14,19,9,6,4,118,2,31,5,15,49,21]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o,a,e,r){"use strict";var d;Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=t.$4Q=t.h=t.$2Q=t.$1Q=t.$ZQ=t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=t.DetectedFullscreenMode=t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$=t.Namespace=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,d=function(){const V=new Map;(0,r.$3O)(r.$4O,1),V.set(r.$4O.vscodeWindowId,{window:r.$4O,disposables:new y.$Sc});const Q=new b.$Ud,te=new b.$Ud,fe=new b.$Ud;return{onDidRegisterWindow:Q.event,onWillUnregisterWindow:fe.event,onDidUnregisterWindow:te.event,registerWindow(De){if(V.has(De.vscodeWindowId))return y.$Tc.None;const Re=new y.$Sc,je={window:De,disposables:Re.add(new y.$Sc)};return V.set(De.vscodeWindowId,je),Re.add((0,y.$Rc)(()=>{V.delete(De.vscodeWindowId),te.fire(De)})),Re.add(p(De,t.$sQ.BEFORE_UNLOAD,()=>{fe.fire(De)})),Q.fire(je),Re},getWindows(){return V.values()},getWindowsCount(){return V.size},getWindowId(De){return De.vscodeWindowId},hasWindow(De){return V.has(De)},getWindowById(De){return V.get(De)},getWindow(De){const Re=De;if(Re?.ownerDocument?.defaultView)return Re.ownerDocument.defaultView.window;const je=De;return je?.view?je.view.window:r.$4O},getDocument(De){const Re=De;return(0,t.getWindow)(Re).document}}}(),t.registerWindow=d.registerWindow,t.getWindow=d.getWindow,t.getDocument=d.getDocument,t.getWindows=d.getWindows,t.getWindowsCount=d.getWindowsCount,t.getWindowId=d.getWindowId,t.getWindowById=d.getWindowById,t.hasWindow=d.hasWindow,t.onDidRegisterWindow=d.onDidRegisterWindow,t.onWillUnregisterWindow=d.onWillUnregisterWindow,t.onDidUnregisterWindow=d.onDidUnregisterWindow;function $(V){for(;V.firstChild;)V.firstChild.remove()}t.$yP=$;class u{constructor(Q,te,fe,De){this.f=Q,this.g=te,this.d=fe,this.j=De||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function p(V,Q,te,fe){return new u(V,Q,te,fe)}t.$zP=p;function c(V,Q){return function(te){return Q(new U.$rP(V,te))}}function f(V){return function(Q){return V(new s.$wP(Q))}}const h=function(Q,te,fe,De){let Re=fe;return te==="click"||te==="mousedown"?Re=c((0,t.getWindow)(Q),fe):(te==="keydown"||te==="keypress"||te==="keyup")&&(Re=f(fe)),p(Q,te,Re,De)};t.$AP=h;const F=function(Q,te,fe){const De=c((0,t.getWindow)(Q),te);return R(Q,De,fe)};t.$BP=F;const M=function(Q,te,fe){const De=c((0,t.getWindow)(Q),te);return v(Q,De,fe)};t.$CP=M;function R(V,Q,te){return p(V,o.$r&&P.$oP.pointerEvents?t.$sQ.POINTER_DOWN:t.$sQ.MOUSE_DOWN,Q,te)}t.$DP=R;function O(V,Q,te){return p(V,o.$r&&P.$oP.pointerEvents?t.$sQ.POINTER_MOVE:t.$sQ.MOUSE_MOVE,Q,te)}t.$EP=O;function v(V,Q,te){return p(V,o.$r&&P.$oP.pointerEvents?t.$sQ.POINTER_UP:t.$sQ.MOUSE_UP,Q,te)}t.$FP=v;function C(V,Q,te){return(0,E.$jh)(V,Q,te)}t.$GP=C;class q extends E.$kh{constructor(Q,te){super(Q,te)}}t.$HP=q;function j(V,Q,te,fe){let De=0;const Re=V.setInterval(()=>{De++,(typeof fe=="number"&&De>=fe||Q()===!0)&&je.dispose()},te),je=(0,y.$Rc)(()=>{V.clearInterval(Re)});return je}t.$KP=j;class N extends E.$dh{constructor(Q){super(),this.f=Q&&(0,t.getWindow)(Q)}cancelAndSet(Q,te,fe){return super.cancelAndSet(Q,te,fe??this.f)}}t.$LP=N;class L{constructor(Q,te=0){this.d=Q,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,k.$1)(Q)}}static sort(Q,te){return te.priority-Q.priority}}(function(){const V=new Map,Q=new Map,te=new Map,fe=new Map,De=Re=>{te.set(Re,!1);const je=V.get(Re)??[];for(Q.set(Re,je),V.set(Re,[]),fe.set(Re,!0);je.length>0;)je.sort(L.sort),je.shift().execute();fe.set(Re,!1)};t.$JP=(Re,je,xe=0)=>{const Ge=(0,t.getWindowId)(Re),Ve=new L(je,xe);let lt=V.get(Ge);return lt||(lt=[],V.set(Ge,lt)),lt.push(Ve),te.get(Ge)||(te.set(Ge,!0),Re.requestAnimationFrame(()=>De(Ge))),Ve},t.$IP=(Re,je,xe)=>{const Ge=(0,t.getWindowId)(Re);if(fe.get(Ge)){const Ve=new L(je,xe);let lt=Q.get(Ge);return lt||(lt=[],Q.set(Ge,lt)),lt.push(Ve),Ve}else return(0,t.$JP)(Re,je,xe)}})();function B(V,Q){return(0,t.$JP)(V,Q,1e4)}t.$MP=B;function Y(V,Q){return(0,t.$JP)(V,Q,-1e4)}t.$NP=Y;const X=8,de=function(V,Q){return Q};class oe extends y.$Tc{constructor(Q,te,fe,De=de,Re=X){super();let je=null,xe=0;const Ge=this.B(new E.$ch),Ve=()=>{xe=new Date().getTime(),fe(je),je=null};this.B(p(Q,te,lt=>{je=De(je,lt);const Nt=new Date().getTime()-xe;Nt>=Re?(Ge.cancel(),Ve()):Ge.setIfNotSet(Ve,Re-Nt)}))}}function ee(V,Q,te,fe,De){return new oe(V,Q,te,fe,De)}t.$OP=ee;function me(V){return(0,t.getWindow)(V).getComputedStyle(V,null)}t.$PP=me;function Te(V,Q){const te=(0,t.getWindow)(V),fe=te.document;if(V!==fe.body)return new Me(V.clientWidth,V.clientHeight);if(o.$r&&te?.visualViewport)return new Me(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Me(te.innerWidth,te.innerHeight);if(fe.body&&fe.body.clientWidth&&fe.body.clientHeight)return new Me(fe.body.clientWidth,fe.body.clientHeight);if(fe.documentElement&&fe.documentElement.clientWidth&&fe.documentElement.clientHeight)return new Me(fe.documentElement.clientWidth,fe.documentElement.clientHeight);if(Q)return Te(Q);throw new Error("Unable to figure out browser width and height")}t.$QP=Te;class Ne{static d(Q,te){return parseFloat(te)||0}static f(Q,te,fe){const De=me(Q),Re=De?De.getPropertyValue(te):"0";return Ne.d(Q,Re)}static getBorderLeftWidth(Q){return Ne.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Ne.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Ne.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Ne.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Ne.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Ne.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Ne.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Ne.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Ne.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Ne.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Ne.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Ne.f(Q,"margin-bottom","marginBottom")}}class Me{static{this.None=new Me(0,0)}constructor(Q,te){this.width=Q,this.height=te}with(Q=this.width,te=this.height){return Q!==this.width||te!==this.height?new Me(Q,te):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Me?Q:new Me(Q.width,Q.height)}static equals(Q,te){return Q===te?!0:!Q||!te?!1:Q.width===te.width&&Q.height===te.height}}t.$RP=Me;function re(V){let Q=V.offsetParent,te=V.offsetTop,fe=V.offsetLeft;for(;(V=V.parentNode)!==null&&V!==V.ownerDocument.body&&V!==V.ownerDocument.documentElement;){te-=V.scrollTop;const De=z(V)?null:me(V);De&&(fe-=De.direction!=="rtl"?V.scrollLeft:-V.scrollLeft),V===Q&&(fe+=Ne.getBorderLeftWidth(V),te+=Ne.getBorderTopWidth(V),te+=V.offsetTop,fe+=V.offsetLeft,Q=V.offsetParent)}return{left:fe,top:te}}t.$SP=re;function J(V,Q,te){typeof Q=="number"&&(V.style.width=`${Q}px`),typeof te=="number"&&(V.style.height=`${te}px`)}t.$TP=J;function le(V,Q,te,fe,De,Re="absolute"){typeof Q=="number"&&(V.style.top=`${Q}px`),typeof te=="number"&&(V.style.right=`${te}px`),typeof fe=="number"&&(V.style.bottom=`${fe}px`),typeof De=="number"&&(V.style.left=`${De}px`),V.style.position=Re}t.$UP=le;function K(V){const Q=V.getBoundingClientRect(),te=(0,t.getWindow)(V);return{left:Q.left+te.scrollX,top:Q.top+te.scrollY,width:Q.width,height:Q.height}}t.$VP=K;function W(V){let Q=V,te=1;do{const fe=me(Q).zoom;fe!=null&&fe!=="1"&&(te*=fe),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return te}t.$WP=W;function Z(V){const Q=Ne.getMarginLeft(V)+Ne.getMarginRight(V);return V.offsetWidth+Q}t.$XP=Z;function ce(V){const Q=Ne.getBorderLeftWidth(V)+Ne.getBorderRightWidth(V),te=Ne.getPaddingLeft(V)+Ne.getPaddingRight(V);return V.offsetWidth-Q-te}t.$YP=ce;function we(V){const Q=Ne.getMarginLeft(V)+Ne.getMarginRight(V);return V.scrollWidth+Q}t.$ZP=we;function Ae(V){const Q=Ne.getBorderTopWidth(V)+Ne.getBorderBottomWidth(V),te=Ne.getPaddingTop(V)+Ne.getPaddingBottom(V);return V.offsetHeight-Q-te}t.$1P=Ae;function ke(V){const Q=Ne.getMarginTop(V)+Ne.getMarginBottom(V);return V.offsetHeight+Q}t.$2P=ke;function Le(V,Q){if(V===null)return 0;const te=re(V),fe=re(Q);return te.left-fe.left}function _(V,Q){const te=Q.map(De=>Math.max(we(De),Z(De))+Le(De,V)||0);return Math.max(...te)}t.$3P=_;function g(V,Q){return!!Q?.contains(V)}t.$4P=g;const m="parentFlowToElementId";function i(V,Q){V.dataset[m]=Q.id}t.$5P=i;function n(V){const Q=V.dataset[m];return typeof Q=="string"?V.ownerDocument.getElementById(Q):null}function l(V,Q){let te=V;for(;te;){if(te===Q)return!0;if(te instanceof HTMLElement){const fe=n(te);if(fe){te=fe;continue}}te=te.parentNode}return!1}t.$6P=l;function D(V,Q,te){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V.classList.contains(Q))return V;if(te){if(typeof te=="string"){if(V.classList.contains(te))return null}else if(V===te)return null}V=V.parentNode}return null}t.$7P=D;function S(V,Q,te){return!!D(V,Q,te)}t.$8P=S;function z(V){return V&&!!V.host&&!!V.mode}t.$9P=z;function T(V){return!!H(V)}t.$0P=T;function H(V){for(;V.parentNode;){if(V===V.ownerDocument?.body)return null;V=V.parentNode}return z(V)?V:null}t.$$P=H;function G(){let V=$e().activeElement;for(;V?.shadowRoot;)V=V.shadowRoot.activeElement;return V}t.$_P=G;function ne(V){return G()===V}t.$aQ=ne;function he(V){return g(G(),V)}t.$bQ=he;function ve(V){return V.ownerDocument===$e()}t.$cQ=ve;function $e(){return(0,t.getWindowsCount)()<=1?r.$4O.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??r.$4O.document}t.$dQ=$e;function ue(){return $e().defaultView?.window??r.$4O}t.$eQ=ue;function Fe(V){const Q=(0,t.getWindow)(V);Q.document.hasFocus()||Q.focus()}t.$fQ=Fe;const ye=new Map;function Oe(V){return ye.has(V)}t.$gQ=Oe;function Be(V=r.$4O.document.head,Q,te){const fe=document.createElement("style");if(fe.type="text/css",fe.media="screen",Q?.(fe),V.appendChild(fe),te&&te.add((0,y.$Rc)(()=>V.removeChild(fe))),V===r.$4O.document.head){const De=new Set;ye.set(fe,De);for(const{window:Re,disposables:je}of(0,t.getWindows)()){if(Re===r.$4O)continue;const xe=je.add(Je(fe,De,Re));te?.add(xe)}}return fe}t.$hQ=Be;function Ie(V){const Q=new y.$Sc;for(const[te,fe]of ye)Q.add(Je(te,fe,V));return Q}t.$iQ=Ie;function Je(V,Q,te){const fe=new y.$Sc,De=V.cloneNode(!0);te.document.head.appendChild(De),fe.add((0,y.$Rc)(()=>te.document.head.removeChild(De)));for(const Re of Ee(V))De.sheet?.insertRule(Re.cssText,De.sheet?.cssRules.length);return fe.add(t.$jQ.observe(V,fe,{childList:!0})(()=>{De.textContent=V.textContent})),Q.add(De),fe.add((0,y.$Rc)(()=>Q.delete(De))),fe}t.$jQ=new class{constructor(){this.mutationObservers=new Map}observe(V,Q,te){let fe=this.mutationObservers.get(V);fe||(fe=new Map,this.mutationObservers.set(V,fe));const De=(0,e.$Si)(te);let Re=fe.get(De);if(Re)Re.users+=1;else{const je=new b.$Ud,xe=new MutationObserver(Ve=>je.fire(Ve));xe.observe(V,te);const Ge=Re={users:1,observer:xe,onDidMutate:je.event};Q.add((0,y.$Rc)(()=>{Ge.users-=1,Ge.users===0&&(je.dispose(),xe.disconnect(),fe?.delete(De),fe?.size===0&&this.mutationObservers.delete(V))})),fe.set(De,Re)}return Re.onDidMutate}};function et(V=r.$4O.document.head){return x("meta",V)}t.$kQ=et;function Qe(V=r.$4O.document.head){return x("link",V)}t.$lQ=Qe;function x(V,Q=r.$4O.document.head){const te=document.createElement(V);return Q.appendChild(te),te}let se=null;function ge(){return se||(se=Be()),se}function Ee(V){return V?.sheet?.rules?V.sheet.rules:V?.sheet?.cssRules?V.sheet.cssRules:[]}function Ce(V,Q,te=ge()){if(!(!te||!Q)){te.sheet?.insertRule(`${V} {${Q}}`,0);for(const fe of ye.get(te)??[])Ce(V,Q,fe)}}t.$mQ=Ce;function Ue(V,Q=ge()){if(!Q)return;const te=Ee(Q),fe=[];for(let De=0;De<te.length;De++){const Re=te[De];qe(Re)&&Re.selectorText.indexOf(V)!==-1&&fe.push(De)}for(let De=fe.length-1;De>=0;De--)Q.sheet?.deleteRule(fe[De]);for(const De of ye.get(Q)??[])Ue(V,De)}t.$nQ=Ue;function qe(V){return typeof V.selectorText=="string"}function _e(V){return V instanceof MouseEvent||V instanceof(0,t.getWindow)(V).MouseEvent}t.$oQ=_e;function Ze(V){return V instanceof KeyboardEvent||V instanceof(0,t.getWindow)(V).KeyboardEvent}t.$pQ=Ze;function tt(V){return V instanceof PointerEvent||V instanceof(0,t.getWindow)(V).PointerEvent}t.$qQ=tt;function Xe(V){return V instanceof DragEvent||V instanceof(0,t.getWindow)(V).DragEvent}t.$rQ=Xe,t.$sQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:A.$gP?"webkitAnimationStart":"animationstart",ANIMATION_END:A.$gP?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:A.$gP?"webkitAnimationIteration":"animationiteration"};function nt(V){const Q=V;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$tQ=nt,t.$uQ={stop:(V,Q)=>(V.preventDefault(),Q&&V.stopPropagation(),V)};function st(V){const Q=[];for(let te=0;V&&V.nodeType===V.ELEMENT_NODE;te++)Q[te]=V.scrollTop,V=V.parentNode;return Q}t.$vQ=st;function rt(V,Q){for(let te=0;V&&V.nodeType===V.ELEMENT_NODE;te++)V.scrollTop!==Q[te]&&(V.scrollTop=Q[te]),V=V.parentNode}t.$wQ=rt;class gt extends y.$Tc{static m(Q){if(Q instanceof HTMLElement){const te=H(Q),fe=te?te.activeElement:Q.ownerDocument.activeElement;return g(fe,Q)}else{const te=Q;return g(te.document.activeElement,te.document)}}constructor(Q){super(),this.f=this.B(new b.$Ud),this.onDidFocus=this.f.event,this.g=this.B(new b.$Ud),this.onDidBlur=this.g.event;let te=gt.m(Q),fe=!1;const De=()=>{fe=!1,te||(te=!0,this.f.fire())},Re=()=>{te&&(fe=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{fe&&(fe=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(Q)!==te&&(te?Re():De())},this.B(p(Q,t.$sQ.FOCUS,De,!0)),this.B(p(Q,t.$sQ.BLUR,Re,!0)),Q instanceof HTMLElement&&(this.B(p(Q,t.$sQ.FOCUS_IN,()=>this.j())),this.B(p(Q,t.$sQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(V){return new gt(V)}t.$xQ=kt;function St(V,Q){return V.after(Q),Q}t.$yQ=St;function wt(V,...Q){if(V.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$zQ=wt;function Ot(V,Q){return V.insertBefore(Q,V.firstChild),Q}t.$AQ=Ot;function ze(V,...Q){V.innerText="",wt(V,...Q)}t.$BQ=ze;const ae=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Se;(function(V){V.HTML="http://www.w3.org/1999/xhtml",V.SVG="http://www.w3.org/2000/svg"})(Se||(t.Namespace=Se={}));function Pe(V,Q,te,...fe){const De=ae.exec(Q);if(!De)throw new Error("Bad use of emmet");const Re=De[1]||"div";let je;return V!==Se.HTML?je=document.createElementNS(V,Re):je=document.createElement(Re),De[3]&&(je.id=De[3]),De[4]&&(je.className=De[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([xe,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(xe)?je[xe]=Ge:xe==="selected"?Ge&&je.setAttribute(xe,"true"):je.setAttribute(xe,Ge))}),je.append(...fe),je}function We(V,Q,...te){return Pe(Se.HTML,V,Q,...te)}t.$=We,We.SVG=function(V,Q,...te){return Pe(Se.SVG,V,Q,...te)};function it(V,Q){const te=[];return V.forEach((fe,De)=>{De>0&&(Q instanceof Node?te.push(Q.cloneNode()):te.push(document.createTextNode(Q))),te.push(fe)}),te}t.$DQ=it;function at(V,...Q){V?Ke(...Q):ut(...Q)}t.$EQ=at;function Ke(...V){for(const Q of V)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$FQ=Ke;function ut(...V){for(const Q of V)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$GQ=ut;function vt(V,Q){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V instanceof HTMLElement&&V.hasAttribute(Q))return V;V=V.parentNode}return null}function Ft(V){!V||!V.hasAttribute("tabIndex")||(V.ownerDocument.activeElement===V&&vt(V.parentElement,"tabIndex")?.focus(),V.removeAttribute("tabindex"))}t.$HQ=Ft;function Gt(V){return Q=>{Q.preventDefault(),Q.stopPropagation(),V(Q)}}t.$IQ=Gt;function Ai(V){return new Promise(Q=>{if(V.document.readyState==="complete"||V.document&&V.document.body!==null)Q(void 0);else{const fe=()=>{V.window.removeEventListener("DOMContentLoaded",fe,!1),Q()};V.window.addEventListener("DOMContentLoaded",fe,!1)}})}t.$JQ=Ai;function ki(V,Q){const te=V.devicePixelRatio*Q;return Math.max(1,Math.floor(te))/V.devicePixelRatio}t.$KQ=ki;function Si(V){r.$4O.open(V,"_blank","noopener")}t.$LQ=Si;const Yt=780,Xt=640;function Fi(V){const Q=Math.floor(r.$4O.screenLeft+r.$4O.innerWidth/2-Yt/2),te=Math.floor(r.$4O.screenTop+r.$4O.innerHeight/2-Xt/2);r.$4O.open(V,"_blank",`width=${Yt},height=${Xt},top=${te},left=${Q}`)}t.$MQ=Fi;function Ni(V,Q=!0){const te=r.$4O.open();return te?(Q&&(te.opener=null),te.location.href=V,!0):!1}t.$NQ=Ni;function Ci(V,Q){const te=()=>{Q(),fe=(0,t.$JP)(V,te)};let fe=(0,t.$JP)(V,te);return(0,y.$Rc)(()=>fe.dispose())}t.$OQ=Ci,I.$hg.setPreferredWebSchema(/^https:/.test(r.$4O.location.href)?"https":"http");function Pi(V){return V?`url('${I.$ng.uriToBrowserUri(V).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$PQ=Pi;function Ti(V){return`'${V.replace(/'/g,"%27")}'`}t.$QQ=Ti;function Jt(V,Q){if(V!==void 0){const te=V.match(/^\s*var\((.+)\)$/);if(te){const fe=te[1].split(",",2);return fe.length===2&&(Q=Jt(fe[1].trim(),Q)),`var(${fe[0]}, ${Q})`}return V}return Q}t.$RQ=Jt;function Ri(V,Q){let te;if(a.URI.isUri(V))te=V.toString(!0);else{const Re=new Blob([V]);te=URL.createObjectURL(Re),setTimeout(()=>URL.revokeObjectURL(te))}const fe=ue(),De=document.createElement("a");fe.document.body.appendChild(De),De.download=Q,De.href=te,De.click(),setTimeout(()=>fe.document.body.removeChild(De))}t.$SQ=Ri;function Li(){return new Promise(V=>{const Q=ue(),te=document.createElement("input");Q.document.body.appendChild(te),te.type="file",te.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(te,"input"))(()=>{V(te.files??void 0)}),te.click(),setTimeout(()=>Q.document.body.removeChild(te))})}t.$TQ=Li;var Dt;(function(V){V[V.DOCUMENT=1]="DOCUMENT",V[V.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Ii(V){return V.document.fullscreenElement||V.document.webkitFullscreenElement||V.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:V.innerHeight===V.screen.height?{mode:Dt.BROWSER,guess:!1}:(o.$j||o.$k)&&V.outerHeight===V.screen.height&&V.outerWidth===V.screen.width?{mode:Dt.BROWSER,guess:!0}:null}t.$UQ=Ii;function Zt(V,Q=!1){const te=document.createElement("a");return w.addHook("afterSanitizeAttributes",fe=>{for(const De of["href","src"])if(fe.hasAttribute(De)){const Re=fe.getAttribute(De);if(De==="href"&&Re.startsWith("#"))continue;if(te.href=Re,!V.includes(te.protocol.replace(/:$/,""))){if(Q&&De==="src"&&te.href.startsWith("data:"))continue;fe.removeAttribute(De)}}}),(0,y.$Rc)(()=>{w.removeHook("afterSanitizeAttributes")})}t.$VQ=Zt;const Mi=[I.Schemas.http,I.Schemas.https,I.Schemas.command];t.$WQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Oi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(V,Q){const te=Zt(Mi);try{const fe=w.sanitize(Q,Oi);V.innerHTML=fe}finally{te.dispose()}}t.$XQ=Bi;function zi(V){const Q=new Uint16Array(V.length);for(let De=0;De<Q.length;De++)Q[De]=V.charCodeAt(De);let te="";const fe=new Uint8Array(Q.buffer);for(let De=0;De<fe.length;De++)te+=String.fromCharCode(fe[De]);return te}function Ui(V){return btoa(zi(V))}t.$YQ=Ui;class bt extends b.$Ud{constructor(){super(),this.o=new y.$Sc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:te})=>this.B(Q,te),{window:r.$4O,disposables:this.o}))}B(Q,te){te.add(p(Q,"keydown",fe=>{if(fe.defaultPrevented)return;const De=new s.$wP(fe);if(!(De.keyCode===6&&fe.repeat)){if(fe.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(fe.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(fe.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(fe.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(De.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=fe.altKey,this.s.ctrlKey=fe.ctrlKey,this.s.metaKey=fe.metaKey,this.s.shiftKey=fe.shiftKey,this.s.lastKeyPressed&&(this.s.event=fe,this.fire(this.s))}},!0)),te.add(p(Q,"keyup",fe=>{fe.defaultPrevented||(!fe.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!fe.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!fe.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!fe.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=fe.altKey,this.s.ctrlKey=fe.ctrlKey,this.s.metaKey=fe.metaKey,this.s.shiftKey=fe.shiftKey,this.s.lastKeyReleased&&(this.s.event=fe,this.fire(this.s)))},!0)),te.add(p(Q.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),te.add(p(Q.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),te.add(p(Q.document.body,"mousemove",fe=>{fe.buttons&&(this.s.lastKeyPressed=void 0)},!0)),te.add(p(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$ZQ=bt;function ji(V){const Q=document.cookie.match("(^|[^;]+)\\s*"+V+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$1Q=ji;class Hi extends y.$Tc{constructor(Q,te){super(),this.j=Q,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(p(this.j,t.$sQ.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B(p(this.j,t.$sQ.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B(p(this.j,t.$sQ.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B(p(this.j,t.$sQ.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(p(this.j,t.$sQ.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B(p(this.j,t.$sQ.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B(p(this.j,t.$sQ.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$2Q=Hi;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(V,...Q){let te,fe;Array.isArray(Q[0])?(te={},fe=Q[0]):(te=Q[0]||{},fe=Q[1]);const De=Wi.exec(V);if(!De||!De.groups)throw new Error("Bad use of h");const Re=De.groups.tag||"div",je=document.createElement(Re);De.groups.id&&(je.id=De.groups.id);const xe=[];if(De.groups.class)for(const Ve of De.groups.class.split("."))Ve!==""&&xe.push(Ve);if(te.className!==void 0)for(const Ve of te.className.split("."))Ve!==""&&xe.push(Ve);xe.length>0&&(je.className=xe.join(" "));const Ge={};if(De.groups.name&&(Ge[De.groups.name]=je),fe)for(const Ve of fe)Ve instanceof HTMLElement?je.appendChild(Ve):typeof Ve=="string"?je.append(Ve):"root"in Ve&&(Object.assign(Ge,Ve),je.appendChild(Ve.root));for(const[Ve,lt]of Object.entries(te))if(Ve!=="className")if(Ve==="style")for(const[Nt,Bt]of Object.entries(lt))je.style.setProperty(ei(Nt),typeof Bt=="number"?Bt+"px":""+Bt);else Ve==="tabIndex"?je.tabIndex=lt:je.setAttribute(ei(Ve),lt.toString());return Ge.root=je,Ge}t.h=qi;function ei(V){return V.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(V,Q){for(const{name:te,value:fe}of V.attributes)Q.setAttribute(te,fe)}t.$4Q=ti;function Vi(V,Q,te){const fe=V.getAttribute(te);fe?Q.setAttribute(te,fe):Q.removeAttribute(te)}function Qi(V,Q,te){ti(V,Q);const fe=new y.$Sc;return fe.add(t.$jQ.observe(V,fe,{attributes:!0,attributeFilter:te})(De=>{for(const Re of De)Re.type==="attributes"&&Re.attributeName&&Vi(V,Q,Re.attributeName)})),fe}t.$5Q=Qi}),define(be[54],pe([1,0,3,2,117]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Q=t.$7Q=t.$6Q=void 0;class U extends P.$Tc{constructor(b,w){super(),this.B((0,A.$zP)(b,"dragover",y=>{y.preventDefault(),this.a||(this.a=setTimeout(()=>{w(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(y=>{this.B((0,A.$zP)(b,y,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$6Q=U,t.$7Q={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:s.$es.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function E(k,b,w,y,I){const o=document.createElement("div");if(o.className=w,o.textContent=b,I&&(o.style.color=I),y&&(o.style.background=y),k.dataTransfer){const a=(0,A.getWindow)(k).document;a.body.appendChild(o),k.dataTransfer.setDragImage(o,-10,-10),setTimeout(()=>a.body.removeChild(o),0)}}t.$8Q=E}),define(be[55],pe([1,0,3]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=t.$yR=t.$xR=void 0;function P(o,a={}){const e=U(a);return e.textContent=o,e}t.$xR=P;function s(o,a={}){const e=U(a);return b(e,w(o,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$yR=s;function U(o){const a=o.inline?"span":"div",e=document.createElement(a);return o.className&&(e.className=o.className),e}t.$zR=U;class E{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var k;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(k||(k={}));function b(o,a,e,r){let d;if(a.type===2)d=document.createTextNode(a.content||"");else if(a.type===3)d=document.createElement("b");else if(a.type===4)d=document.createElement("i");else if(a.type===7&&r)d=document.createElement("code");else if(a.type===5&&e){const $=document.createElement("a");e.disposables.add(A.$AP($,"click",u=>{e.callback(String(a.index),u)})),d=$}else a.type===8?d=document.createElement("br"):a.type===1&&(d=o);d&&o!==d&&o.appendChild(d),d&&Array.isArray(a.children)&&a.children.forEach($=>{b(d,$,e,r)})}function w(o,a){const e={type:1,children:[]};let r=0,d=e;const $=[],u=new E(o);for(;!u.eos();){let p=u.next();const c=p==="\\"&&I(u.peek(),a)!==0;if(c&&(p=u.next()),!c&&y(p,a)&&p===u.peek()){u.advance(),d.type===2&&(d=$.pop());const f=I(p,a);if(d.type===f||d.type===5&&f===6)d=$.pop();else{const h={type:f,children:[]};f===5&&(h.index=r,r++),d.children.push(h),$.push(d),d=h}}else if(p===`
`)d.type===2&&(d=$.pop()),d.children.push({type:8});else if(d.type!==2){const f={type:2,content:p};d.children.push(f),$.push(d),d=f}else d.content+=p}return d.type===2&&(d=$.pop()),$.length,e}function y(o,a){return I(o,a)!==0}function I(o,a){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[56],pe([1,0,3,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=void 0;class s{constructor(){this.a=new P.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(E,k){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,E&&b&&b(k)}isMonitoring(){return!!this.b}startMonitoring(E,k,b,w,y){this.isMonitoring()&&this.stopMonitoring(!1),this.b=w,this.c=y;let I=E;try{E.setPointerCapture(k),this.a.add((0,P.$Rc)(()=>{try{E.releasePointerCapture(k)}catch{}}))}catch{I=A.getWindow(E)}this.a.add(A.$zP(I,A.$sQ.POINTER_MOVE,o=>{if(o.buttons!==b){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(A.$zP(I,A.$sQ.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.$_Q=s});var Ye=this&&this.__decorate||function(ie,t,A,P){var s=arguments.length,U=s<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,A):P,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(ie,t,A,P);else for(var k=ie.length-1;k>=0;k--)(E=ie[k])&&(U=(s<3?E(U):s>3?E(t,A,U):E(t,A))||U);return s>3&&U&&Object.defineProperty(t,A,U),U};define(be[25],pe([1,0,3,21,12,27,4,2,45]),function(ie,t,A,P,s,U,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=t.EventType=void 0;var w;(function(I){I.Tap="-monaco-gesturetap",I.Change="-monaco-gesturechange",I.Start="-monaco-gesturestart",I.End="-monaco-gesturesend",I.Contextmenu="-monaco-gesturecontextmenu"})(w||(t.EventType=w={}));class y extends k.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$4c,this.h=new b.$4c,this.m={},this.j=null,this.n=0,this.B(E.Event.runAndSubscribe(A.onDidRegisterWindow,({window:o,disposables:a})=>{a.add(A.$zP(o.document,"touchstart",e=>this.s(e),{passive:!1})),a.add(A.$zP(o.document,"touchend",e=>this.u(o,e))),a.add(A.$zP(o.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:P.$4O,disposables:this.q}))}static addTarget(o){if(!y.isTouchDevice())return k.$Tc.None;y.b||(y.b=(0,k.$Mc)(new y));const a=y.b.g.push(o);return(0,k.$Rc)(a)}static ignoreTarget(o){if(!y.isTouchDevice())return k.$Tc.None;y.b||(y.b=(0,k.$Mc)(new y));const a=y.b.h.push(o);return(0,k.$Rc)(a)}static isTouchDevice(){return"ontouchstart"in P.$4O||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(o){const a=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,r=o.targetTouches.length;e<r;e++){const d=o.targetTouches.item(e);this.m[d.identifier]={id:d.identifier,initialTarget:d.target,initialTimeStamp:a,initialPageX:d.pageX,initialPageY:d.pageY,rollingTimestamps:[a],rollingPageX:[d.pageX],rollingPageY:[d.pageY]};const $=this.w(w.Start,d.target);$.pageX=d.pageX,$.pageY=d.pageY,this.z($)}this.f&&(o.preventDefault(),o.stopPropagation(),this.f=!1)}u(o,a){const e=Date.now(),r=Object.keys(this.m).length;for(let d=0,$=a.changedTouches.length;d<$;d++){const u=a.changedTouches.item(d);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const p=this.m[u.identifier],c=Date.now()-p.initialTimeStamp;if(c<y.c&&Math.abs(p.initialPageX-s.$sb(p.rollingPageX))<30&&Math.abs(p.initialPageY-s.$sb(p.rollingPageY))<30){const f=this.w(w.Tap,p.initialTarget);f.pageX=s.$sb(p.rollingPageX),f.pageY=s.$sb(p.rollingPageY),this.z(f)}else if(c>=y.c&&Math.abs(p.initialPageX-s.$sb(p.rollingPageX))<30&&Math.abs(p.initialPageY-s.$sb(p.rollingPageY))<30){const f=this.w(w.Contextmenu,p.initialTarget);f.pageX=s.$sb(p.rollingPageX),f.pageY=s.$sb(p.rollingPageY),this.z(f)}else if(r===1){const f=s.$sb(p.rollingPageX),h=s.$sb(p.rollingPageY),F=s.$sb(p.rollingTimestamps)-p.rollingTimestamps[0],M=f-p.rollingPageX[0],R=h-p.rollingPageY[0],O=[...this.g].filter(v=>p.initialTarget instanceof Node&&v.contains(p.initialTarget));this.C(o,O,e,Math.abs(M)/F,M>0?1:-1,f,Math.abs(R)/F,R>0?1:-1,h)}this.z(this.w(w.End,p.initialTarget)),delete this.m[u.identifier]}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}w(o,a){const e=document.createEvent("CustomEvent");return e.initEvent(o,!1,!0),e.initialTarget=a,e.tapCount=0,e}z(o){if(o.type===w.Tap){const a=new Date().getTime();let e=0;a-this.n>y.r?e=1:e=2,this.n=a,o.tapCount=e}else(o.type===w.Change||o.type===w.Contextmenu)&&(this.n=0);if(o.initialTarget instanceof Node){for(const a of this.h)if(a.contains(o.initialTarget))return;for(const a of this.g)a.contains(o.initialTarget)&&(a.dispatchEvent(o),this.f=!0)}}C(o,a,e,r,d,$,u,p,c){this.j=A.$JP(o,()=>{const f=Date.now(),h=f-e;let F=0,M=0,R=!0;r+=y.a*h,u+=y.a*h,r>0&&(R=!1,F=d*r*h),u>0&&(R=!1,M=p*u*h);const O=this.w(w.Change);O.translationX=F,O.translationY=M,a.forEach(v=>v.dispatchEvent(O)),R||this.C(o,a,f,r,d,$+F,u,p,c+M)})}D(o){const a=Date.now();for(let e=0,r=o.changedTouches.length;e<r;e++){const d=o.changedTouches.item(e);if(!this.m.hasOwnProperty(String(d.identifier))){console.warn("end of an UNKNOWN touch",d);continue}const $=this.m[d.identifier],u=this.w(w.Change,$.initialTarget);u.translationX=d.pageX-s.$sb($.rollingPageX),u.translationY=d.pageY-s.$sb($.rollingPageY),u.pageX=d.pageX,u.pageY=d.pageY,this.z(u),$.rollingPageX.length>3&&($.rollingPageX.shift(),$.rollingPageY.shift(),$.rollingTimestamps.shift()),$.rollingPageX.push(d.pageX),$.rollingPageY.push(d.pageY),$.rollingTimestamps.push(a)}this.f&&(o.preventDefault(),o.stopPropagation(),this.f=!1)}}t.$9Q=y,Ye([U.$wh],y,"isTouchDevice",null)}),define(be[57],pe([1,0,3,92]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=t.$CR=t.$BR=void 0;const P=2e4;let s,U,E,k,b;function w(a){s=document.createElement("div"),s.className="monaco-aria-container";const e=()=>{const d=document.createElement("div");return d.className="monaco-alert",d.setAttribute("role","alert"),d.setAttribute("aria-atomic","true"),s.appendChild(d),d};U=e(),E=e();const r=()=>{const d=document.createElement("div");return d.className="monaco-status",d.setAttribute("aria-live","polite"),d.setAttribute("aria-atomic","true"),s.appendChild(d),d};k=r(),b=r(),a.appendChild(s)}t.$BR=w;function y(a){s&&(U.textContent!==a?(A.$yP(E),o(U,a)):(A.$yP(U),o(E,a)))}t.$CR=y;function I(a){s&&(k.textContent!==a?(A.$yP(b),o(k,a)):(A.$yP(k),o(b,a)))}t.$DR=I;function o(a,e){A.$yP(a),e.length>P&&(e=e.substr(0,P)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[119],pe([1,0,3,18]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8R=t.$7R=void 0;const s=new RegExp(`(\\\\)?\\$\\((${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(k){const b=new Array;let w,y=0,I=0;for(;(w=s.exec(k))!==null;){I=w.index||0,y<I&&b.push(k.substring(y,I)),y=(w.index||0)+w[0].length;const[,o,a]=w;b.push(o?`$(${a})`:E({id:a}))}return y<k.length&&b.push(k.substring(y)),b}t.$7R=U;function E(k){const b=A.$("span");return b.classList.add(...P.ThemeIcon.asClassNameArray(k)),b}t.$8R=E}),define(be[120],pe([1,0,3]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=void 0;function P(U){try{U.parentElement?.removeChild(U)}catch{}}class s{constructor(E){this.d=E,this.a=new Map,this.b=new Set,this.c=!1}alloc(E){let k=this.h(E).pop(),b=!1;if(k)b=this.b.has(k.domNode),b&&this.b.delete(k.domNode);else{const w=(0,A.$)(".monaco-list-row"),I=this.i(E).renderTemplate(w);k={domNode:w,templateId:E,templateData:I}}return{row:k,isReusingConnectedDomNode:b}}release(E){E&&this.f(E)}transact(E){if(this.c)throw new Error("Already in transaction");this.c=!0;try{E()}finally{for(const k of this.b)this.g(k);this.b.clear(),this.c=!1}}f(E){const{domNode:k,templateId:b}=E;k&&(this.c?this.b.add(k):this.g(k)),this.h(b).push(E)}g(E){E.classList.remove("scrolling"),P(E)}h(E){let k=this.a.get(E);return k||(k=[],this.a.set(E,k)),k}dispose(){this.a.forEach((E,k)=>{for(const b of E)this.i(k).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(E){const k=this.d.get(E);if(!k)throw new Error(`No renderer found for ${E}`);return k}}t.$JR=s}),define(be[121],pe([1,0,9,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=void 0;class s extends P.$Tc{constructor(E,k,b){super(),this.a=E,this.b=k,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new A.$ch)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$eR=s}),define(be[122],pe([1,0,3,25,12,4,2,5]),function(ie,t,A,P,s,U,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cS=void 0;class b extends E.$Tc{constructor(y,I,o,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Ud),this.h=o,this.j(),this.setOptions(y,I)}j(){this.B(P.$9Q.addTarget(this.a)),[P.EventType.Tap].forEach(y=>{this.B(A.$zP(this.a,y,I=>{this.a.focus()}))}),this.B(A.$AP(this.a,"click",y=>{A.$uQ.stop(y,!0)})),this.B(A.$AP(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(A.$AP(this.a,"keydown",y=>{let I=!1;k.$j?(y.keyCode===18||y.keyCode===16||y.keyCode===10)&&(I=!0):(y.keyCode===18&&y.altKey||y.keyCode===10||y.keyCode===3)&&(I=!0),I&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,I){(!this.c||!s.$ub(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((o,a)=>{this.a.add(this.m(o.text,a,o.isDisabled))})),I!==void 0&&this.select(I)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,I,o){const a=document.createElement("option");return a.value=y,a.text=y,a.disabled=!!o,a}}t.$cS=b}),define(be[58],pe([1,0,26,12,9,50,87,4,28]),function(ie,t,A,P,s,U,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KT=t.$JT=t.$IT=void 0;function w(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$IT=w;function y(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$JT=y;function I(a){return typeof a.collapsible=="boolean"}class o{constructor(e,r,d,$={}){this.o=e,this.p=r,this.rootRef=[],this.d=new k.$3d,this.f=new k.$Ud,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new k.$Ud,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new k.$Ud,this.onDidSplice=this.l.event,this.m=new s.$2g(U.$Rd),this.h=typeof $.collapseByDefault>"u"?!1:$.collapseByDefault,this.j=$.filter,this.k=typeof $.autoExpandSingleChildren>"u"?!1:$.autoExpandSingleChildren,this.c={parent:void 0,element:d,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,r,d=b.Iterable.empty(),$={}){if(e.length===0)throw new A.$GT(this.o,"Invalid tree location");$.diffIdentityProvider?this.q($.diffIdentityProvider,e,r,d,$):this.s(e,r,d,$)}q(e,r,d,$=b.Iterable.empty(),u,p=u.diffDepth??0){const{parentNode:c}=this.G(r);if(!c.lastDiffIds)return this.s(r,d,$,u);const f=[...$],h=r[r.length-1],F=new E.$Zs({getElements:()=>c.lastDiffIds},{getElements:()=>[...c.children.slice(0,h),...f,...c.children.slice(h+d)].map(C=>e.getId(C.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return c.lastDiffIds=void 0,this.s(r,d,f,u);const M=r.slice(0,-1),R=(C,q,j)=>{if(p>0)for(let N=0;N<j;N++)C--,q--,this.q(e,[...M,C,0],Number.MAX_SAFE_INTEGER,f[q].children,u,p-1)};let O=Math.min(c.children.length,h+d),v=f.length;for(const C of F.changes.sort((q,j)=>j.originalStart-q.originalStart))R(O,v,O-(C.originalStart+C.originalLength)),O=C.originalStart,v=C.modifiedStart-h,this.s([...M,O],C.originalLength,b.Iterable.slice(f,v,v+C.modifiedLength),u);R(O,v,O)}s(e,r,d=b.Iterable.empty(),{onDidCreateNode:$,onDidDeleteNode:u,diffIdentityProvider:p}){const{parentNode:c,listIndex:f,revealed:h,visible:F}=this.G(e),M=[],R=b.Iterable.map(d,Y=>this.w(Y,c,c.visible?1:0,h,M,$)),O=e[e.length-1];let v=0;for(let Y=O;Y>=0&&Y<c.children.length;Y--){const X=c.children[Y];if(X.visible){v=X.visibleChildIndex;break}}const C=[];let q=0,j=0;for(const Y of R)C.push(Y),j+=Y.renderNodeCount,Y.visible&&(Y.visibleChildIndex=v+q++);const N=(0,P.$6b)(c.children,O,r,C);p?c.lastDiffIds?(0,P.$6b)(c.lastDiffIds,O,r,C.map(Y=>p.getId(Y.element).toString())):c.lastDiffIds=c.children.map(Y=>p.getId(Y.element).toString()):c.lastDiffIds=void 0;let L=0;for(const Y of N)Y.visible&&L++;if(L!==0)for(let Y=O+C.length;Y<c.children.length;Y++){const X=c.children[Y];X.visible&&(X.visibleChildIndex-=L)}if(c.visibleChildrenCount+=q-L,h&&F){const Y=N.reduce((X,de)=>X+(de.visible?de.renderNodeCount:0),0);this.B(c,j-Y),this.p.splice(f,Y,M)}if(N.length>0&&u){const Y=X=>{u(X),X.children.forEach(Y)};N.forEach(Y)}this.l.fire({insertedNodes:C,deletedNodes:N});let B=c;for(;B;){if(B.visibility===2){this.m.trigger(()=>this.refilter());break}B=B.parent}}rerender(e){if(e.length===0)throw new A.$GT(this.o,"Invalid tree location");const{node:r,listIndex:d,revealed:$}=this.F(e);r.visible&&$&&this.p.splice(d,1,[r])}updateElementHeight(e,r){if(e.length===0)throw new A.$GT(this.o,"Invalid tree location");const{listIndex:d}=this.F(e);this.p.updateElementHeight(d,r)}has(e){return this.D(e)}getListIndex(e){const{listIndex:r,visible:d,revealed:$}=this.F(e);return d&&$?r:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,r){const d=this.E(e);typeof r>"u"&&(r=!d.collapsible);const $={collapsible:r};return this.d.bufferEvents(()=>this.t(e,$))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,r,d){const $=this.E(e);typeof r>"u"&&(r=!$.collapsed);const u={collapsed:r,recursive:d||!1};return this.d.bufferEvents(()=>this.t(e,u))}t(e,r){const{node:d,listIndex:$,revealed:u}=this.F(e),p=this.u(d,$,u,r);if(d!==this.c&&this.k&&p&&!I(r)&&d.collapsible&&!d.collapsed&&!r.recursive){let c=-1;for(let f=0;f<d.children.length;f++)if(d.children[f].visible)if(c>-1){c=-1;break}else c=f;c>-1&&this.t([...e,c],r)}return p}u(e,r,d,$){const u=this.v(e,$,!1);if(!d||!e.visible||!u)return u;const p=e.renderNodeCount,c=this.x(e),f=p-(r===-1?0:1);return this.p.splice(r+1,f,c.slice(1)),u}v(e,r,d){let $;if(e===this.c?$=!1:(I(r)?($=e.collapsible!==r.collapsible,e.collapsible=r.collapsible):e.collapsible?($=e.collapsed!==r.collapsed,e.collapsed=r.collapsed):$=!1,$&&this.f.fire({node:e,deep:d})),!I(r)&&r.recursive)for(const u of e.children)$=this.v(u,r,!0)||$;return $}expandTo(e){this.d.bufferEvents(()=>{let r=this.E(e);for(;r.parent;)r=r.parent,e=e.slice(0,e.length-1),r.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,r=this.z(this.c);this.p.splice(0,e,r),this.m.cancel()}w(e,r,d,$,u,p){const c={parent:r,element:e.element,children:[],depth:r.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},f=this.C(c,d);c.visibility=f,$&&u.push(c);const h=e.children||b.Iterable.empty(),F=$&&f!==0&&!c.collapsed;let M=0,R=1;for(const O of h){const v=this.w(O,c,f,F,u,p);c.children.push(v),R+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=M++)}return c.collapsible=c.collapsible||c.children.length>0,c.visibleChildrenCount=M,c.visible=f===2?M>0:f===1,c.visible?c.collapsed||(c.renderNodeCount=R):(c.renderNodeCount=0,$&&u.pop()),p?.(c),c}x(e){const r=e.renderNodeCount,d=[];return this.y(e,d),this.B(e.parent,d.length-r),d}y(e,r){if(e.visible===!1)return 0;if(r.push(e),e.renderNodeCount=1,!e.collapsed)for(const d of e.children)e.renderNodeCount+=this.y(d,r);return this.g.fire(e),e.renderNodeCount}z(e){const r=e.renderNodeCount,d=[];return this.A(e,e.visible?1:0,d),this.B(e.parent,d.length-r),d}A(e,r,d,$=!0){let u;if(e!==this.c){if(u=this.C(e,r),u===0)return e.visible=!1,e.renderNodeCount=0,!1;$&&d.push(e)}const p=d.length;e.renderNodeCount=e===this.c?0:1;let c=!1;if(!e.collapsed||u!==0){let f=0;for(const h of e.children)c=this.A(h,u,d,$&&!e.collapsed)||c,h.visible&&(h.visibleChildIndex=f++);e.visibleChildrenCount=f}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=u===2?c:u===1,e.visibility=u),e.visible?e.collapsed||(e.renderNodeCount+=d.length-p):(e.renderNodeCount=0,$&&d.pop()),this.g.fire(e),e.visible}B(e,r){if(r!==0)for(;e;)e.renderNodeCount+=r,this.g.fire(e),e=e.parent}C(e,r){const d=this.j?this.j.filter(e.element,r):1;return typeof d=="boolean"?(e.filterData=void 0,d?1:0):w(d)?(e.filterData=d.data,y(d.visibility)):(e.filterData=void 0,y(d))}D(e,r=this.c){if(!e||e.length===0)return!0;const[d,...$]=e;return d<0||d>r.children.length?!1:this.D($,r.children[d])}E(e,r=this.c){if(!e||e.length===0)return r;const[d,...$]=e;if(d<0||d>r.children.length)throw new A.$GT(this.o,"Invalid tree location");return this.E($,r.children[d])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:r,listIndex:d,revealed:$,visible:u}=this.G(e),p=e[e.length-1];if(p<0||p>r.children.length)throw new A.$GT(this.o,"Invalid tree location");const c=r.children[p];return{node:c,listIndex:d,revealed:$,visible:u&&c.visible}}G(e,r=this.c,d=0,$=!0,u=!0){const[p,...c]=e;if(p<0||p>r.children.length)throw new A.$GT(this.o,"Invalid tree location");for(let f=0;f<p;f++)d+=r.children[f].renderNodeCount;return $=$&&!r.collapsed,u=u&&r.visible,c.length===0?{parentNode:r,listIndex:d,revealed:$,visible:u}:this.G(c,r.children[p],d+1,$,u)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const r=[];let d=e;for(;d.parent;)r.push(d.parent.children.indexOf(d)),d=d.parent;return r.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,P.$tb)(e)[0]}getFirstElementChild(e){const r=this.E(e);if(r.children.length!==0)return r.children[0].element}getLastElementAncestor(e=[]){const r=this.E(e);if(r.children.length!==0)return this.H(r)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$KT=o}),define(be[123],pe([1,0,58,26,28]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=void 0;class U{get size(){return this.d.size}constructor(k,b,w={}){this.k=k,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new A.$KT(k,b,null,w),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,w.sorter&&(this.j={compare(y,I){return w.sorter.compare(y.element,I.element)}}),this.h=w.identityProvider}setChildren(k,b=s.Iterable.empty(),w={}){const y=this.o(k);this.l(y,this.m(b),w)}l(k,b=s.Iterable.empty(),w){const y=new Set,I=new Set,o=e=>{if(e.element===null)return;const r=e;if(y.add(r.element),this.d.set(r.element,r),this.h){const d=this.h.getId(r.element).toString();I.add(d),this.f.set(d,r)}w.onDidCreateNode?.(r)},a=e=>{if(e.element===null)return;const r=e;if(y.has(r.element)||this.d.delete(r.element),this.h){const d=this.h.getId(r.element).toString();I.has(d)||this.f.delete(d)}w.onDidDeleteNode?.(r)};this.c.splice([...k,0],Number.MAX_VALUE,b,{...w,onDidCreateNode:o,onDidDeleteNode:a})}m(k=s.Iterable.empty()){return this.j&&(k=[...k].sort(this.j.compare.bind(this.j))),s.Iterable.map(k,b=>{let w=this.d.get(b.element);if(!w&&this.h){const o=this.h.getId(b.element).toString();w=this.f.get(o)}if(!w){let o;return typeof b.collapsed>"u"?o=void 0:b.collapsed===P.ObjectTreeElementCollapseState.Collapsed||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed?o=!0:b.collapsed===P.ObjectTreeElementCollapseState.Expanded||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?o=!1:o=!!b.collapsed,{...b,children:this.m(b.children),collapsed:o}}const y=typeof b.collapsible=="boolean"?b.collapsible:w.collapsible;let I;return typeof b.collapsed>"u"||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?I=w.collapsed:b.collapsed===P.ObjectTreeElementCollapseState.Collapsed?I=!0:b.collapsed===P.ObjectTreeElementCollapseState.Expanded?I=!1:I=!!b.collapsed,{...b,collapsible:y,collapsed:I,children:this.m(b.children)}})}rerender(k){const b=this.o(k);this.c.rerender(b)}updateElementHeight(k,b){const w=this.o(k);this.c.updateElementHeight(w,b)}resort(k=null,b=!0){if(!this.j)return;const w=this.o(k),y=this.c.getNode(w);this.l(w,this.n(y,b),{})}n(k,b,w=!0){let y=[...k.children];return(b||w)&&(y=y.sort(this.j.compare.bind(this.j))),s.Iterable.map(y,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.n(I,b,!1)}))}getFirstElementChild(k=null){const b=this.o(k);return this.c.getFirstElementChild(b)}getLastElementAncestor(k=null){const b=this.o(k);return this.c.getLastElementAncestor(b)}has(k){return this.d.has(k)}getListIndex(k){const b=this.o(k);return this.c.getListIndex(b)}getListRenderCount(k){const b=this.o(k);return this.c.getListRenderCount(b)}isCollapsible(k){const b=this.o(k);return this.c.isCollapsible(b)}setCollapsible(k,b){const w=this.o(k);return this.c.setCollapsible(w,b)}isCollapsed(k){const b=this.o(k);return this.c.isCollapsed(b)}setCollapsed(k,b,w){const y=this.o(k);return this.c.setCollapsed(y,b,w)}expandTo(k){const b=this.o(k);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(k=null){if(k===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(k);if(!b)throw new P.$GT(this.k,`Tree element not found: ${k}`);return b}getNodeLocation(k){return k.element}getParentNodeLocation(k){if(k===null)throw new P.$GT(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(k);if(!b)throw new P.$GT(this.k,`Tree element not found: ${k}`);const w=this.c.getNodeLocation(b),y=this.c.getParentNodeLocation(w);return this.c.getNode(y).element}o(k){if(k===null)return[];const b=this.d.get(k);if(!b)throw new P.$GT(this.k,`Tree element not found: ${k}`);return this.c.getNodeLocation(b)}}t.$RT=U}),define(be[20],pe([1,0,3,14,19,25,2]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=void 0;class k extends E.$Tc{f(w,y){this.B(A.$zP(w,A.$sQ.CLICK,I=>y(new s.$rP(A.getWindow(w),I))))}j(w,y){this.B(A.$zP(w,A.$sQ.MOUSE_DOWN,I=>y(new s.$rP(A.getWindow(w),I))))}m(w,y){this.B(A.$zP(w,A.$sQ.MOUSE_OVER,I=>y(new s.$rP(A.getWindow(w),I))))}u(w,y){this.B(A.$zP(w,A.$sQ.MOUSE_LEAVE,I=>y(new s.$rP(A.getWindow(w),I))))}z(w,y){this.B(A.$zP(w,A.$sQ.KEY_DOWN,I=>y(new P.$wP(I))))}C(w,y){this.B(A.$zP(w,A.$sQ.KEY_UP,I=>y(new P.$wP(I))))}D(w,y){this.B(A.$zP(w,A.$sQ.INPUT,y))}F(w,y){this.B(A.$zP(w,A.$sQ.BLUR,y))}G(w,y){this.B(A.$zP(w,A.$sQ.FOCUS,y))}H(w,y){this.B(A.$zP(w,A.$sQ.CHANGE,y))}I(w){return U.$9Q.ignoreTarget(w)}}t.$aR=k}),define(be[38],pe([1,0,56,20,9,18,3]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=t.$bR=void 0,t.$bR=11;class k extends P.$aR{constructor(w){super(),this.a=w.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=w.bgWidth+"px",this.bgDomNode.style.height=w.bgHeight+"px",typeof w.top<"u"&&(this.bgDomNode.style.top="0px"),typeof w.left<"u"&&(this.bgDomNode.style.left="0px"),typeof w.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof w.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=w.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(w.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$bR+"px",this.domNode.style.height=t.$bR+"px",typeof w.top<"u"&&(this.domNode.style.top=w.top+"px"),typeof w.left<"u"&&(this.domNode.style.left=w.left+"px"),typeof w.bottom<"u"&&(this.domNode.style.bottom=w.bottom+"px"),typeof w.right<"u"&&(this.domNode.style.right=w.right+"px"),this.g=this.B(new A.$_Q),this.B(E.$AP(this.bgDomNode,E.$sQ.POINTER_DOWN,y=>this.h(y))),this.B(E.$AP(this.domNode,E.$sQ.POINTER_DOWN,y=>this.h(y))),this.b=this.B(new E.$LP),this.c=this.B(new s.$ch)}h(w){if(!w.target||!(w.target instanceof Element))return;const y=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,E.getWindow(w))};this.a(),this.b.cancel(),this.c.cancelAndSet(y,200),this.g.startMonitoring(w.target,w.pointerId,w.buttons,I=>{},()=>{this.b.cancel(),this.c.cancel()}),w.preventDefault()}}t.$cR=k}),define(be[59],pe([1,0,3,41,56,38,121,20,5]),function(ie,t,A,P,s,U,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=void 0;const w=140;class y extends k.$aR{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.n=this.B(new E.$eR(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new s.$_Q),this.s=!0,this.domNode=(0,P.$$Q)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(A.$zP(this.domNode.domNode,A.$sQ.POINTER_DOWN,a=>this.M(a)))}t(o){const a=this.B(new U.$cR(o));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(o,a,e,r){this.slider=(0,P.$$Q)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof r=="number"&&this.slider.setHeight(r),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(A.$zP(this.slider.domNode,A.$sQ.POINTER_DOWN,d=>{d.button===0&&(d.preventDefault(),this.O(d))})),this.f(this.slider.domNode,d=>{d.leftButton&&d.stopPropagation()})}y(o){return this.h.setVisibleSize(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(o){return this.h.setScrollSize(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(o){return this.h.setScrollPosition(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(o){o.target===this.domNode.domNode&&this.N(o)}delegatePointerDown(o){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),r=a+this.h.getSliderPosition()+this.h.getSliderSize(),d=this.U(o);e<=d&&d<=r?o.button===0&&(o.preventDefault(),this.O(o)):this.N(o)}N(o){let a,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")a=o.offsetX,e=o.offsetY;else{const d=A.$VP(this.domNode.domNode);a=o.pageX-d.left,e=o.pageY-d.top}const r=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(r):this.h.getDesiredScrollPositionFromOffset(r)),o.button===0&&(o.preventDefault(),this.O(o))}O(o){if(!o.target||!(o.target instanceof Element))return;const a=this.U(o),e=this.W(o),r=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(o.target,o.pointerId,o.buttons,d=>{const $=this.W(d),u=Math.abs($-e);if(b.$i&&u>w){this.P(r.getScrollPosition());return}const c=this.U(d)-a;this.P(r.getDesiredScrollPositionFromDelta(c))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(o){const a={};this.writeScrollPosition(a,o),this.b.setScrollPositionNow(a)}updateScrollbarSize(o){this.X(o),this.h.setScrollbarSize(o),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$fR=y}),define(be[124],pe([1,0,19,59,38,42,17]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=void 0;class k extends P.$fR{constructor(w,y,I){const o=w.getScrollDimensions(),a=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:I,scrollbarState:new U.$dR(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===2?0:y.horizontalScrollbarSize,y.vertical===2?0:y.verticalScrollbarSize,o.width,o.scrollWidth,a.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:w,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const e=(y.arrowSize-s.$bR)/2,r=(y.horizontalScrollbarSize-s.$bR)/2;this.t({className:"scra",icon:E.$$j.scrollbarButtonLeft,top:r,left:e,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$tP(null,1,0))}),this.t({className:"scra",icon:E.$$j.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:e,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$tP(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(w,y){this.slider.setWidth(w),this.slider.setLeft(y)}Q(w,y){this.domNode.setWidth(w),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(w){return this.s=this.J(w.scrollWidth)||this.s,this.s=this.L(w.scrollLeft)||this.s,this.s=this.y(w.width)||this.s,this.s}S(w,y){return w}U(w){return w.pageX}W(w){return w.pageY}X(w){this.slider.setHeight(w)}writeScrollPosition(w,y){w.scrollLeft=y}updateOptions(w){this.updateScrollbarSize(w.horizontal===2?0:w.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.n.setVisibility(w.horizontal),this.c=w.scrollByPage}}t.$gR=k}),define(be[125],pe([1,0,19,59,38,42,17]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=void 0;class k extends P.$fR{constructor(w,y,I){const o=w.getScrollDimensions(),a=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:I,scrollbarState:new U.$dR(y.verticalHasArrows?y.arrowSize:0,y.vertical===2?0:y.verticalScrollbarSize,0,o.height,o.scrollHeight,a.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:w,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const e=(y.arrowSize-s.$bR)/2,r=(y.verticalScrollbarSize-s.$bR)/2;this.t({className:"scra",icon:E.$$j.scrollbarButtonUp,top:e,left:r,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$tP(null,0,1))}),this.t({className:"scra",icon:E.$$j.scrollbarButtonDown,top:void 0,left:r,bottom:e,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$tP(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(w,y){this.slider.setHeight(w),this.slider.setTop(y)}Q(w,y){this.domNode.setWidth(y),this.domNode.setHeight(w),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(w){return this.s=this.J(w.scrollHeight)||this.s,this.s=this.L(w.scrollTop)||this.s,this.s=this.y(w.height)||this.s,this.s}S(w,y){return y}U(w){return w.pageY}W(w){return w.pageX}X(w){this.slider.setWidth(w)}writeScrollPosition(w,y){w.scrollTop=y}updateOptions(w){this.updateScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(w.vertical),this.c=w.scrollByPage}}t.$hR=k}),define(be[60],pe([1,0,16,3,41,19,124,125,20,9,4,2,5,48,99]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=t.$lR=t.$kR=t.$jR=t.$iR=void 0;const e=500,r=50,d=!0;class ${constructor(R,O,v){this.timestamp=R,this.deltaX=O,this.deltaY=v,this.score=0}}class u{static{this.INSTANCE=new u}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,O=0,v=1,C=this.d;do{const q=C===this.c?R:Math.pow(2,-v);if(R-=q,O+=this.b[C].score*q,C===this.c)break;C=(this.a+C-1)%this.a,v++}while(!0);return O<=.5}acceptStandardWheelEvent(R){const O=P.getWindow(R.browserEvent),v=O.devicePixelRatio/(0,A.$aP)(O);o.$i||o.$k?this.accept(Date.now(),R.deltaX/v,R.deltaY/v):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,O,v){const C=new $(R,O,v);C.score=this.f(C),this.c===-1&&this.d===-1?(this.b[0]=C,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=C)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let O=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(O+=.25),Math.min(Math.max(O,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$iR=u;class p extends b.$aR{get options(){return this.a}constructor(R,O,v){super(),this.O=this.B(new y.$Ud),this.onScroll=this.O.event,this.P=this.B(new y.$Ud),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=F(O),this.b=v,this.B(this.b.onScroll(q=>{this.P.fire(q),this.S(q),this.O.fire(q)}));const C={onMouseWheel:q=>this.R(q),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new k.$hR(this.b,this.a,C)),this.g=this.B(new E.$gR(this.b,this.a,C)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,s.$$Q)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,s.$$Q)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,s.$$Q)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,q=>this.Z(q)),this.u(this.t,q=>this.Y(q)),this.L=this.B(new w.$ch),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,I.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,o.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new U.$tP(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,I.$Oc)(this.w),R)){const v=C=>{this.R(new U.$tP(C))};this.w.push(P.$zP(this.t,P.$sQ.MOUSE_WHEEL,v,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const O=u.INSTANCE;d&&O.acceptStandardWheelEvent(R);let v=!1;if(R.deltaY||R.deltaX){let q=R.deltaY*this.a.mouseWheelScrollSensitivity,j=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&j+q===0?j=q=0:Math.abs(q)>=Math.abs(j)?j=0:q=0),this.a.flipAxes&&([q,j]=[j,q]);const N=!o.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||N)&&!j&&(j=q,q=0),R.browserEvent&&R.browserEvent.altKey&&(j=j*this.a.fastScrollSensitivity,q=q*this.a.fastScrollSensitivity);const L=this.b.getFutureScrollPosition();let B={};if(q){const Y=r*q,X=L.scrollTop-(Y<0?Math.floor(Y):Math.ceil(Y));this.c.writeScrollPosition(B,X)}if(j){const Y=r*j,X=L.scrollLeft-(Y<0?Math.floor(Y):Math.ceil(Y));this.g.writeScrollPosition(B,X)}B=this.b.validateScrollPosition(B),(L.scrollLeft!==B.scrollLeft||L.scrollTop!==B.scrollTop)&&(d&&this.a.mouseWheelSmoothScroll&&O.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(B):this.b.setScrollPositionNow(B),v=!0)}let C=v;!C&&this.a.alwaysConsumeMouseWheel&&(C=!0),!C&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(C=!0),C&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),O=R.scrollTop>0,v=R.scrollLeft>0,C=v?" left":"",q=O?" top":"",j=v||O?" top-left-corner":"";this.n.setClassName(`shadow${C}`),this.r.setClassName(`shadow${q}`),this.s.setClassName(`shadow${j}${q}${C}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$jR=p;class c extends p{constructor(R,O){O=O||{},O.mouseWheelSmoothScroll=!1;const v=new a.$ks({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>P.$JP(P.getWindow(R),C)});super(R,O,v),this.B(v)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$kR=c;class f extends p{constructor(R,O,v){super(R,O,v)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$lR=f;class h extends p{constructor(R,O){O=O||{},O.mouseWheelSmoothScroll=!1;const v=new a.$ks({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>P.$JP(P.getWindow(R),C)});super(R,O,v),this.B(v),this.cb=R,this.B(this.onScroll(C=>{C.scrollTopChanged&&(this.cb.scrollTop=C.scrollTop),C.scrollLeftChanged&&(this.cb.scrollLeft=C.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$mR=h;function F(M){const R={lazyRender:typeof M.lazyRender<"u"?M.lazyRender:!1,className:typeof M.className<"u"?M.className:"",useShadows:typeof M.useShadows<"u"?M.useShadows:!0,handleMouseWheel:typeof M.handleMouseWheel<"u"?M.handleMouseWheel:!0,flipAxes:typeof M.flipAxes<"u"?M.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof M.consumeMouseWheelIfScrollbarIsNeeded<"u"?M.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof M.alwaysConsumeMouseWheel<"u"?M.alwaysConsumeMouseWheel:!1,scrollYToX:typeof M.scrollYToX<"u"?M.scrollYToX:!1,mouseWheelScrollSensitivity:typeof M.mouseWheelScrollSensitivity<"u"?M.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof M.fastScrollSensitivity<"u"?M.fastScrollSensitivity:5,scrollPredominantAxis:typeof M.scrollPredominantAxis<"u"?M.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof M.mouseWheelSmoothScroll<"u"?M.mouseWheelSmoothScroll:!0,arrowSize:typeof M.arrowSize<"u"?M.arrowSize:11,listenOnDomNode:typeof M.listenOnDomNode<"u"?M.listenOnDomNode:null,horizontal:typeof M.horizontal<"u"?M.horizontal:1,horizontalScrollbarSize:typeof M.horizontalScrollbarSize<"u"?M.horizontalScrollbarSize:10,horizontalSliderSize:typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:0,horizontalHasArrows:typeof M.horizontalHasArrows<"u"?M.horizontalHasArrows:!1,vertical:typeof M.vertical<"u"?M.vertical:1,verticalScrollbarSize:typeof M.verticalScrollbarSize<"u"?M.verticalScrollbarSize:10,verticalHasArrows:typeof M.verticalHasArrows<"u"?M.verticalHasArrows:!1,verticalSliderSize:typeof M.verticalSliderSize<"u"?M.verticalSliderSize:0,scrollByPage:typeof M.scrollByPage<"u"?M.scrollByPage:!1};return R.horizontalSliderSize=typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof M.verticalSliderSize<"u"?M.verticalSliderSize:R.verticalScrollbarSize,o.$j&&(R.className+=" mac"),R}}),define(be[61],pe([1,0,54,3,22,25,60,12,9,27,4,2,47,48,83,120,6]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o,a,e,r,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NR=t.$MR=t.$LR=t.$KR=t.ListViewTargetSector=void 0;const $={CurrentDragAndDropData:void 0};var u;(function(O){O[O.TOP=0]="TOP",O[O.CENTER_TOP=1]="CENTER_TOP",O[O.CENTER_BOTTOM=2]="CENTER_BOTTOM",O[O.BOTTOM=3]="BOTTOM"})(u||(t.ListViewTargetSector=u={}));const p={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(O){return[O]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class c{get context(){return this.d}set context(v){this.d=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$KR=c;class f{constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$LR=f;class h{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let C=0;C<v.files.length;C++){const q=v.files.item(C);q&&(q.size||q.type)&&this.files.push(q)}}}getData(){return{types:this.types,files:this.files}}}t.$MR=h;function F(O,v){return Array.isArray(O)&&Array.isArray(v)?(0,k.$ub)(O,v):O===v}class M{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(C,q,j)=>j,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(C,q)=>q+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=C=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=C=>{}}}class R{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(v){if(v!==this.P){if(v&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=v,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const C of this.d)this.Z(C);this.W(),this.q.setScrollDimensions({width:(0,P.$YP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(v,C,q,j=p){if(this.R=C,this.domId=`list_id_${++R.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$2g(50),this.v=!1,this.x=I.$Tc.None,this.y=0,this.G=!1,this.K=I.$Tc.None,this.L=I.$Tc.None,this.M=new I.$Sc,this.N=new y.$Ud,this.O=new y.$Ud,this.onDidChangeContentHeight=y.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=y.Event.latch(this.O.event,void 0,this.M),this.P=!1,j.horizontalScrolling&&j.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$IR(j.paddingTop??0);for(const L of q)this.j.set(L.templateId,L);this.h=this.M.add(new r.$JR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof j.mouseSupport=="boolean"?j.mouseSupport:!0),this.P=j.horizontalScrolling??p.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof j.paddingBottom>"u"?0:j.paddingBottom,this.D=new M(j.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(j.transformOptimization??p.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(U.$9Q.addTarget(this.o)),this.p=this.M.add(new a.$ks({forceIntegerValues:!0,smoothScrollDuration:j.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,P.$JP)((0,P.getWindow)(this.domNode),L)})),this.q=this.M.add(new E.$lR(this.o,{alwaysConsumeMouseWheel:j.alwaysConsumeMouseWheel??p.alwaysConsumeMouseWheel,horizontal:1,vertical:j.verticalScrollMode??p.verticalScrollMode,useShadows:j.useShadows??p.useShadows,mouseWheelScrollSensitivity:j.mouseWheelScrollSensitivity,fastScrollSensitivity:j.fastScrollSensitivity,scrollByPage:j.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),v.appendChild(this.domNode),this.q.onScroll(this.hb,this,this.M),this.M.add((0,P.$zP)(this.o,U.EventType.Change,L=>this.ib(L))),this.M.add((0,P.$zP)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.M.add((0,P.$zP)(this.domNode,"dragover",L=>this.kb(this.gb(L)))),this.M.add((0,P.$zP)(this.domNode,"drop",L=>this.mb(this.gb(L)))),this.M.add((0,P.$zP)(this.domNode,"dragleave",L=>this.lb(this.gb(L)))),this.M.add((0,P.$zP)(this.domNode,"dragend",L=>this.nb(L))),this.z=j.setRowLineHeight??p.setRowLineHeight,this.A=j.setRowHeight??p.setRowHeight,this.B=j.supportDynamicHeights??p.supportDynamicHeights,this.F=j.dnd??this.M.add(p.dnd),this.layout(j.initialSize?.height,j.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.C=v.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.Q=v.horizontalScrolling);let C;if(v.scrollByPage!==void 0&&(C={...C??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(C={...C??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(C={...C??{},fastScrollSensitivity:v.fastScrollSensitivity}),C&&this.q.updateOptions(C),v.paddingTop!==void 0&&v.paddingTop!==this.g.paddingTop){const q=this.ub(this.k,this.m),j=v.paddingTop-this.g.paddingTop;this.g.paddingTop=v.paddingTop,this.X(q,Math.max(0,this.k+j),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(v){this.q.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.q.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,C,q){if(v<0||v>=this.d.length)return;const j=this.d[v].size;if(typeof C>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[v].lastDynamicHeightWidth=void 0,C=j+this.wb(v)}if(j===C)return;const N=this.ub(this.k,this.m);let L=0;v<N.start||q!==null&&q>v&&q<N.end?L=C-j:L=0,this.g.splice(v,1,[{size:C}]),this.d[v].size=C,this.X(N,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}splice(v,C,q=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.S(v,C,q)}finally{this.v=!1,this.N.fire(this.contentHeight)}}S(v,C,q=[]){const j=this.ub(this.k,this.m),N={start:v,end:v+C},L=o.Range.intersect(j,N),B=new Map;for(let Z=L.end-1;Z>=L.start;Z--){const ce=this.d[Z];if(ce.dragStartDisposable.dispose(),ce.checkedDisposable.dispose(),ce.row){let we=B.get(ce.templateId);we||(we=[],B.set(ce.templateId,we));const Ae=this.j.get(ce.templateId);Ae&&Ae.disposeElement&&Ae.disposeElement(ce.element,Z,ce.row.templateData,ce.size),we.push(ce.row)}ce.row=null}const Y={start:v+C,end:this.d.length},X=o.Range.intersect(Y,j),de=o.Range.relativeComplement(Y,j),oe=q.map(Z=>({id:String(this.f++),element:Z,templateId:this.R.getTemplateId(Z),size:this.R.getHeight(Z),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(Z),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.$Tc.None,checkedDisposable:I.$Tc.None}));let ee;v===0&&C>=this.d.length?(this.g=new e.$IR(this.g.paddingTop),this.g.splice(0,0,oe),ee=this.d,this.d=oe):(this.g.splice(v,C,oe),ee=this.d.splice(v,C,...oe));const me=q.length-C,Te=this.ub(this.k,this.m),Ne=(0,e.$GR)(X,me),Me=o.Range.intersect(Te,Ne);for(let Z=Me.start;Z<Me.end;Z++)this.ab(this.d[Z],Z);const re=o.Range.relativeComplement(Ne,Te);for(const Z of re)for(let ce=Z.start;ce<Z.end;ce++)this.bb(ce);const J=de.map(Z=>(0,e.$GR)(Z,me)),K=[{start:v,end:v+q.length},...J].map(Z=>o.Range.intersect(Te,Z)),W=this.xb(K);for(const Z of K)for(let ce=Z.start;ce<Z.end;ce++){const we=this.d[ce],ke=B.get(we.templateId)?.pop();this.Y(ce,W,ke)}for(const Z of B.values())for(const ce of Z)this.h.release(ce);return this.U(),this.B&&this.vb(this.scrollTop,this.renderHeight),ee.map(Z=>Z.element)}U(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,P.$JP)((0,P.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.W(),this.t=null}))}V(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.W())}W(){if(!this.Q)return;let v=0;for(const C of this.d)typeof C.width<"u"&&(v=Math.max(v,C.width));this.E=v,this.q.setScrollDimensions({scrollWidth:v===0?0:v+10}),this.O.fire(this.E)}updateWidth(v){if(!this.Q||typeof this.E>"u")return;const C=this.d[v];this.Z(C),typeof C.width<"u"&&C.width>this.E&&(this.E=C.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const v of this.d)v.lastDynamicHeightWidth=void 0;this.vb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.ub(this.k,this.m).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,C=this.g.positionAt(v),q=this.g.positionAt(v+1);return q!==-1&&(q-C)/2+C<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.ub(this.k,this.m).end-1}element(v){return this.d[v].element}indexOf(v){return this.d.findIndex(C=>C.element===v)}domElement(v){const C=this.d[v].row;return C&&C.domNode}elementHeight(v){return this.d[v].size}elementTop(v){return this.g.positionAt(v)}indexAt(v){return this.g.indexAt(v)}indexAfter(v){return this.g.indexAfter(v)}layout(v,C){const q={height:typeof v=="number"?v:(0,P.$1P)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,q.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(q),typeof C<"u"&&(this.n=C,this.B&&this.vb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof C=="number"?C:(0,P.$YP)(this.domNode)})}X(v,C,q,j,N,L=!1){const B=this.ub(C,q),Y=o.Range.relativeComplement(B,v),X=o.Range.relativeComplement(v,B),de=this.xb(Y);if(L){const oe=o.Range.intersect(v,B);for(let ee=oe.start;ee<oe.end;ee++)this.ab(this.d[ee],ee)}this.h.transact(()=>{for(const oe of X)for(let ee=oe.start;ee<oe.end;ee++)this.bb(ee);for(const oe of Y)for(let ee=oe.start;ee<oe.end;ee++)this.Y(ee,de)}),j!==void 0&&(this.o.style.left=`-${j}px`),this.o.style.top=`-${C}px`,this.Q&&N!==void 0&&(this.o.style.width=`${Math.max(N,this.n)}px`),this.k=C,this.m=q}Y(v,C,q){const j=this.d[v];let N=!1;if(!j.row)if(q)j.row=q;else{const de=this.h.alloc(j.templateId);j.row=de.row,N=de.isReusingConnectedDomNode}const L=this.D.getRole(j.element)||"listitem";j.row.domNode.setAttribute("role",L);const B=this.D.isChecked(j.element);if(typeof B=="boolean")j.row.domNode.setAttribute("aria-checked",String(!!B));else if(B){const de=oe=>j.row.domNode.setAttribute("aria-checked",String(!!oe));de(B.value),j.checkedDisposable=B.onDidChange(de)}(N||!j.row.domNode.parentElement)&&(C?this.o.insertBefore(j.row.domNode,C):this.o.appendChild(j.row.domNode)),this.ab(j,v);const Y=this.j.get(j.templateId);if(!Y)throw new Error(`No renderer found for template id ${j.templateId}`);Y?.renderElement(j.element,v,j.row.templateData,j.size);const X=this.F.getDragURI(j.element);j.dragStartDisposable.dispose(),j.row.domNode.draggable=!!X,X&&(j.dragStartDisposable=(0,P.$zP)(j.row.domNode,"dragstart",de=>this.jb(j.element,X,de))),this.Q&&(this.Z(j),this.V())}Z(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,P.$YP)(v.row.domNode);const C=(0,P.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);C.paddingLeft&&(v.width+=parseFloat(C.paddingLeft)),C.paddingRight&&(v.width+=parseFloat(C.paddingRight)),v.row.domNode.style.width=""}ab(v,C){v.row.domNode.style.top=`${this.elementTop(C)}px`,this.A&&(v.row.domNode.style.height=`${v.size}px`),this.z&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${C}`),v.row.domNode.setAttribute("data-last-element",C===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",C%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(v.element,C,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(v.element,C))),v.row.domNode.setAttribute("id",this.getElementDomId(C)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}bb(v){const C=this.d[v];if(C.dragStartDisposable.dispose(),C.checkedDisposable.dispose(),C.row){const q=this.j.get(C.templateId);q&&q.disposeElement&&q.disposeElement(C.element,v,C.row.templateData,C.size),this.h.release(C.row),C.row=null}this.Q&&this.V()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(v,C){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:v,reuseAnimation:C})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"click")).event,v=>this.db(v),this.M)}get onMouseDblClick(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"dblclick")).event,v=>this.db(v),this.M)}get onMouseMiddleClick(){return y.Event.filter(y.Event.map(this.M.add(new s.$AR(this.domNode,"auxclick")).event,v=>this.db(v),this.M),v=>v.browserEvent.button===1,this.M)}get onMouseUp(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"mouseup")).event,v=>this.db(v),this.M)}get onMouseDown(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"mousedown")).event,v=>this.db(v),this.M)}get onMouseOver(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"mouseover")).event,v=>this.db(v),this.M)}get onMouseMove(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"mousemove")).event,v=>this.db(v),this.M)}get onMouseOut(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"mouseout")).event,v=>this.db(v),this.M)}get onContextMenu(){return y.Event.any(y.Event.map(this.M.add(new s.$AR(this.domNode,"contextmenu")).event,v=>this.db(v),this.M),y.Event.map(this.M.add(new s.$AR(this.domNode,U.EventType.Contextmenu)).event,v=>this.fb(v),this.M))}get onTouchStart(){return y.Event.map(this.M.add(new s.$AR(this.domNode,"touchstart")).event,v=>this.eb(v),this.M)}get onTap(){return y.Event.map(this.M.add(new s.$AR(this.o,U.EventType.Tap)).event,v=>this.fb(v),this.M)}db(v){const C=this.tb(v.target||null),q=typeof C>"u"?void 0:this.d[C],j=q&&q.element;return{browserEvent:v,index:C,element:j}}eb(v){const C=this.tb(v.target||null),q=typeof C>"u"?void 0:this.d[C],j=q&&q.element;return{browserEvent:v,index:C,element:j}}fb(v){const C=this.tb(v.initialTarget||null),q=typeof C>"u"?void 0:this.d[C],j=q&&q.element;return{browserEvent:v,index:C,element:j}}gb(v){const C=this.tb(v.target||null),q=typeof C>"u"?void 0:this.d[C],j=q&&q.element,N=this.sb(v,C);return{browserEvent:v,index:C,element:j,sector:N}}hb(v){try{const C=this.ub(this.k,this.m);this.X(C,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.B&&this.vb(v.scrollTop,v.height,v.inSmoothScrolling)}catch(C){throw console.error("Got bad scroll event:",v),C}}ib(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}jb(v,C,q){if(!q.dataTransfer)return;const j=this.F.getDragElements(v);if(q.dataTransfer.effectAllowed="copyMove",q.dataTransfer.setData(A.$7Q.TEXT,C),q.dataTransfer.setDragImage){let N;this.F.getDragLabel&&(N=this.F.getDragLabel(j,q)),typeof N>"u"&&(N=String(j.length));const L=(0,P.$)(".monaco-drag-image");L.textContent=N;const Y=(X=>{for(;X&&!X.classList.contains("monaco-workbench");)X=X.parentElement;return X||this.domNode.ownerDocument})(this.domNode);Y.appendChild(L),q.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>Y.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new c(j),$.CurrentDragAndDropData=new f(j),this.F.onDragStart?.(this.H,q)}kb(v){if(v.browserEvent.preventDefault(),this.L.dispose(),$.CurrentDragAndDropData&&$.CurrentDragAndDropData.getData()==="vscode-ui"||(this.pb(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.H)if($.CurrentDragAndDropData)this.H=$.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.H=new h}const C=this.F.onDragOver(this.H,v.element,v.index,v.sector,v.browserEvent);if(this.G=typeof C=="boolean"?C:C.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof C!="boolean"&&C.effect?.type===0?"copy":"move";let q;typeof C!="boolean"&&C.feedback?q=C.feedback:typeof v.index>"u"?q=[-1]:q=[v.index],q=(0,k.$Mb)(q).filter(N=>N>=-1&&N<this.length).sort((N,L)=>N-L),q=q[0]===-1?[-1]:q;const j=typeof C!="boolean"&&C.effect&&C.effect.position?C.effect.position:"drop-target";if(F(this.I,q)&&this.J===j)return!0;if(this.I=q,this.J=j,this.K.dispose(),q[0]===-1)this.domNode.classList.add(j),this.o.classList.add(j),this.K=(0,I.$Rc)(()=>{this.domNode.classList.remove(j),this.o.classList.remove(j)});else{if(q.length>1&&j!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");for(const N of q){const L=this.d[N];L.dropTarget=!0,L.row?.domNode.classList.add(j)}this.K=(0,I.$Rc)(()=>{for(const N of q){const L=this.d[N];L.dropTarget=!1,L.row?.domNode.classList.remove(j)}})}return!0}lb(v){this.L.dispose(),this.L=(0,b.$7g)(()=>this.ob(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,v.element,v.index,v.browserEvent)}mb(v){if(!this.G)return;const C=this.H;this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,!(!C||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),C.update(v.browserEvent.dataTransfer),this.F.drop(C,v.element,v.index,v.sector,v.browserEvent))}nb(v){this.G=!1,this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(v)}ob(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=I.$Tc.None}pb(v){if(!this.w){const C=(0,P.$SP)(this.domNode).top;this.w=(0,P.$OQ)((0,P.getWindow)(this.domNode),this.qb.bind(this,C))}this.x.dispose(),this.x=(0,b.$7g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=v.pageY}qb(v){if(this.y===void 0)return;const C=this.y-v,q=this.renderHeight-35;C<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(C-35))):C>q&&(this.scrollTop+=Math.min(14,Math.floor(.3*(C-q))))}rb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}sb(v,C){if(C===void 0)return;const q=v.offsetY/this.d[C].size;return Math.floor(q/.25)}tb(v){const C=this.q.getDomNode();let q=v;for(;q instanceof HTMLElement&&q!==this.o&&C.contains(q);){const j=q.getAttribute("data-index");if(j){const N=Number(j);if(!isNaN(N))return N}q=q.parentElement}}ub(v,C){return{start:this.g.indexAt(v),end:this.g.indexAfter(v+C-1)}}vb(v,C,q){const j=this.ub(v,C);let N,L;v===this.elementTop(j.start)?(N=j.start,L=0):j.end-j.start>1&&(N=j.start+1,L=this.elementTop(N)-v);let B=0;for(;;){const Y=this.ub(v,C);let X=!1;for(let de=Y.start;de<Y.end;de++){const oe=this.wb(de);oe!==0&&this.g.splice(de,1,[this.d[de]]),B+=oe,X=X||oe!==0}if(!X){B!==0&&this.U();const de=o.Range.relativeComplement(j,Y);for(const ee of de)for(let me=ee.start;me<ee.end;me++)this.d[me].row&&this.bb(me);const oe=o.Range.relativeComplement(Y,j);for(const ee of oe)for(let me=ee.start;me<ee.end;me++){const Te=me+1,Ne=Te<this.d.length?this.d[Te].row:null,Me=Ne?Ne.domNode:null;this.Y(me,Me)}for(let ee=Y.start;ee<Y.end;ee++)this.d[ee].row&&this.ab(this.d[ee],ee);if(typeof N=="number"){const ee=this.p.getFutureScrollPosition().scrollTop-v,me=this.elementTop(N)-L+ee;this.setScrollTop(me,q)}this.N.fire(this.contentHeight);return}}}wb(v){const C=this.d[v];if(this.R.getDynamicHeight){const L=this.R.getDynamicHeight(C.element);if(L!==null){const B=C.size;return C.size=L,C.lastDynamicHeightWidth=this.n,L-B}}if(!C.hasDynamicHeight||C.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(C.element))return 0;const q=C.size;if(C.row)return C.row.domNode.style.height="",C.size=C.row.domNode.offsetHeight,C.lastDynamicHeightWidth=this.n,C.size-q;const{row:j}=this.h.alloc(C.templateId);j.domNode.style.height="",this.o.appendChild(j.domNode);const N=this.j.get(C.templateId);if(!N)throw new d.$cb("Missing renderer for templateId: "+C.templateId);return N.renderElement(C.element,v,j.templateData,void 0),C.size=j.domNode.offsetHeight,N.disposeElement?.(C.element,v,j.templateData,void 0),this.R.setDynamicHeight?.(C.element,C.size),C.lastDynamicHeightWidth=this.n,this.o.removeChild(j.domNode),this.h.release(j),C.size-q}xb(v){const C=v[v.length-1];if(!C)return null;const q=this.d[C.end];return!q||!q.row?null:q.row.domNode}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.d)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const C=this.j.get(v.row.templateId);C&&(C.disposeElement?.(v.element,-1,v.row.templateData,void 0),C.disposeTemplate(v.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$NR=R,Ye([w.$wh],R.prototype,"onMouseClick",null),Ye([w.$wh],R.prototype,"onMouseDblClick",null),Ye([w.$wh],R.prototype,"onMouseMiddleClick",null),Ye([w.$wh],R.prototype,"onMouseUp",null),Ye([w.$wh],R.prototype,"onMouseDown",null),Ye([w.$wh],R.prototype,"onMouseOver",null),Ye([w.$wh],R.prototype,"onMouseMove",null),Ye([w.$wh],R.prototype,"onMouseOut",null),Ye([w.$wh],R.prototype,"onContextMenu",null),Ye([w.$wh],R.prototype,"onTouchStart",null),Ye([w.$wh],R.prototype,"onTap",null)}),define(be[39],pe([1,0,3,22,14,25,57,71,12,9,74,27,4,34,2,46,5,7,70,61,19,98]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o,a,e,r,d,$,u,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6R=t.$5R=t.$4R=t.$3R=t.$2R=t.$1R=t.$ZR=t.TypeNavigationMode=t.$YR=t.$XR=t.$WR=t.$VR=t.$UR=t.$TR=t.$SR=t.$RR=void 0;class f{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,m,i){const n=this.c.findIndex(l=>l.templateData===i);if(n>=0){const l=this.c[n];this.d.unrender(i),l.index=m}else{const l={index:m,templateData:i};this.c.push(l)}this.d.renderIndex(m,i)}splice(g,m,i){const n=[];for(const l of this.c)l.index<g?n.push(l):l.index>=g+m&&n.push({index:l.index+i-m,templateData:l.templateData});this.c=n}renderIndexes(g){for(const{index:m,templateData:i}of this.c)g.indexOf(m)>-1&&this.d.renderIndex(m,i)}disposeTemplate(g){const m=this.c.findIndex(i=>i.templateData===g);m<0||this.c.splice(m,1)}}class h{get name(){return this.g}get renderer(){return new f(this)}constructor(g){this.g=g,this.c=[],this.d=[],this.f=new o.$Ud,this.onChange=this.f.event}splice(g,m,i){const n=i.length-m,l=g+m,D=[];let S=0;for(;S<this.d.length&&this.d[S]<g;)D.push(this.d[S++]);for(let z=0;z<i.length;z++)i[z]&&D.push(z+g);for(;S<this.d.length&&this.d[S]>=l;)D.push(this.d[S++]+n);this.renderer.splice(g,m,i.length),this.h(D,D)}renderIndex(g,m){m.classList.toggle(this.g,this.contains(g))}unrender(g){g.classList.remove(this.g)}set(g,m){return this.h(g,[...g].sort(ce),m)}h(g,m,i){const n=this.c,l=this.d;this.c=g,this.d=m;const D=W(l,g);return this.renderer.renderIndexes(D),this.f.fire({indexes:g,browserEvent:i}),n}get(){return this.c}contains(g){return(0,b.$wb)(this.d,g,ce)>=0}dispose(){(0,e.$Oc)(this.f)}}Ye([I.$wh],h.prototype,"renderer",null);class F extends h{constructor(g){super("selected"),this.k=g}renderIndex(g,m){super.renderIndex(g,m),this.k&&(this.contains(g)?m.setAttribute("aria-selected","true"):m.setAttribute("aria-selected","false"))}}class M{constructor(g,m,i){this.c=g,this.d=m,this.f=i}splice(g,m,i){if(!this.f)return this.c.splice(g,m,new Array(i.length).fill(!1));const n=this.c.get().map(S=>this.f.getId(this.d.element(S)).toString());if(n.length===0)return this.c.splice(g,m,new Array(i.length).fill(!1));const l=new Set(n),D=i.map(S=>l.has(this.f.getId(S).toString()));this.c.splice(g,m,D)}}function R(_){return _.tagName==="INPUT"||_.tagName==="TEXTAREA"}t.$RR=R;function O(_,g){return _.classList.contains(g)?!0:_.classList.contains("monaco-list")||!_.parentElement?!1:O(_.parentElement,g)}function v(_){return O(_,"monaco-editor")}t.$SR=v;function C(_){return O(_,"monaco-custom-toggle")}t.$TR=C;function q(_){return O(_,"action-item")}t.$UR=q;function j(_){return O(_,"monaco-tl-twistie")}t.$VR=j;function N(_){return O(_,"monaco-tree-sticky-row")}t.$WR=N;function L(_){return _.classList.contains("monaco-tree-sticky-container")}t.$XR=L;function B(_){return _.tagName==="A"&&_.classList.contains("monaco-button")||_.tagName==="DIV"&&_.classList.contains("monaco-button-dropdown")?!0:_.classList.contains("monaco-list")||!_.parentElement?!1:B(_.parentElement)}t.$YR=B;class Y{get g(){return o.Event.chain(this.c.add(new P.$AR(this.k.domNode,"keydown")).event,g=>g.filter(m=>!R(m.target)).map(m=>new s.$wP(m)))}constructor(g,m,i){this.h=g,this.k=m,this.c=new e.$Sc,this.d=new e.$Sc,this.f=i.multipleSelectionSupport,this.c.add(this.g(n=>{switch(n.keyCode){case 3:return this.l(n);case 16:return this.o(n);case 18:return this.p(n);case 11:return this.q(n);case 12:return this.s(n);case 9:return this.u(n);case 31:this.f&&(d.$j?n.metaKey:n.ctrlKey)&&this.t(n)}}))}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.f=g.multipleSelectionSupport)}l(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection(this.h.getFocus(),g.browserEvent)}o(g){g.preventDefault(),g.stopPropagation(),this.h.focusPrevious(1,!1,g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.h.focusNext(1,!1,g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.h.focusPreviousPage(g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.h.focusNextPage(g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}t(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(g){this.h.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.h.setSelection([],g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ye([I.$wh],Y.prototype,"g",null);var X;(function(_){_[_.Automatic=0]="Automatic",_[_.Trigger=1]="Trigger"})(X||(t.TypeNavigationMode=X={}));var de;(function(_){_[_.Idle=0]="Idle",_[_.Typing=1]="Typing"})(de||(de={})),t.$ZR=new class{mightProducePrintableCharacter(_){return _.ctrlKey||_.metaKey||_.altKey?!1:_.keyCode>=31&&_.keyCode<=56||_.keyCode>=21&&_.keyCode<=30||_.keyCode>=98&&_.keyCode<=107||_.keyCode>=85&&_.keyCode<=95}};class oe{constructor(g,m,i,n,l){this.o=g,this.p=m,this.q=i,this.s=n,this.t=l,this.c=!1,this.d=de.Idle,this.f=X.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??X.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const m=o.Event.chain(this.k.add(new P.$AR(this.p.domNode,"keydown")).event,l=>l.filter(D=>!R(D.target)).filter(()=>this.f===X.Automatic||this.g).map(D=>new s.$wP(D)).filter(D=>g||this.s(D)).filter(D=>this.t.mightProducePrintableCharacter(D)).forEach(D=>A.$uQ.stop(D,!0)).map(D=>D.browserEvent.key)),i=o.Event.debounce(m,()=>null,800,void 0,void 0,void 0,this.k);o.Event.reduce(o.Event.any(m,i),(l,D)=>D===null?null:(l||"")+D,void 0,this.k)(this.x,this,this.k),i(this.w,this,this.k),m(()=>g=!0,void 0,this.k),i(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const m=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));m&&(0,E.$CR)(m)}this.h=-1}x(g){if(!g){this.d=de.Idle,this.g=!1;return}const m=this.o.getFocus(),i=m.length>0?m[0]:0,n=this.d===de.Idle?1:0;this.d=de.Typing;for(let l=0;l<this.o.length;l++){const D=(i+l+n)%this.o.length,S=this.q.getKeyboardNavigationLabel(this.p.element(D)),z=S&&S.toString();if(this.o.options.typeNavigationEnabled){if(typeof z<"u"){if((0,a.$Tj)(g,z)){this.h=i,this.o.setFocus([D]),this.o.reveal(D);return}const T=(0,a.$1j)(g,z);if(T&&T[0].end-T[0].start>1&&T.length===1){this.h=i,this.o.setFocus([D]),this.o.reveal(D);return}}}else if(typeof z>"u"||(0,a.$Tj)(g,z)){this.h=i,this.o.setFocus([D]),this.o.reveal(D);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ee{constructor(g,m){this.d=g,this.f=m,this.c=new e.$Sc;const i=o.Event.chain(this.c.add(new P.$AR(m.domNode,"keydown")).event,l=>l.filter(D=>!R(D.target)).map(D=>new s.$wP(D)));o.Event.chain(i,l=>l.filter(D=>D.keyCode===2&&!D.ctrlKey&&!D.metaKey&&!D.shiftKey&&!D.altKey))(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const m=this.d.getFocus();if(m.length===0)return;const i=this.f.domElement(m[0]);if(!i)return;const n=i.querySelector("[tabIndex]");if(!n||!(n instanceof HTMLElement)||n.tabIndex===-1)return;const l=(0,A.getWindow)(n).getComputedStyle(n);l.visibility==="hidden"||l.display==="none"||(g.preventDefault(),g.stopPropagation(),n.focus())}dispose(){this.c.dispose()}}function me(_){return d.$j?_.browserEvent.metaKey:_.browserEvent.ctrlKey}t.$1R=me;function Te(_){return _.browserEvent.shiftKey}t.$2R=Te;function Ne(_){return(0,A.$oQ)(_)&&_.button===2}const Me={isSelectionSingleChangeEvent:me,isSelectionRangeChangeEvent:Te};class re{constructor(g){this.k=g,this.f=new e.$Sc,this.g=new o.$Ud,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Me),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(U.$9Q.addTarget(g.getHTMLElement()))),o.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Me))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){v(g.browserEvent.target)||(0,A.$_P)()!==g.browserEvent.target&&this.k.domFocus()}t(g){if(R(g.browserEvent.target)||v(g.browserEvent.target))return;const m=typeof g.index>"u"?[]:[g.index];this.k.setFocus(m,g.browserEvent)}u(g){if(!this.d||R(g.browserEvent.target)||v(g.browserEvent.target)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const m=g.index;if(typeof m>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.q(g))return this.w(g);this.k.setFocus([m],g.browserEvent),this.k.setAnchor(m),Ne(g.browserEvent)||this.k.setSelection([m],g.browserEvent),this.g.fire(g)}v(g){if(R(g.browserEvent.target)||v(g.browserEvent.target)||this.q(g)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const m=this.k.getFocus();this.k.setSelection(m,g.browserEvent)}w(g){const m=g.index;let i=this.k.getAnchor();if(this.p(g)){typeof i>"u"&&(i=this.k.getFocus()[0]??m,this.k.setAnchor(i));const n=Math.min(i,m),l=Math.max(i,m),D=(0,b.$Sb)(n,l+1),S=this.k.getSelection(),z=K(W(S,[i]),i);if(z.length===0)return;const T=W(D,Z(S,z));this.k.setSelection(T,g.browserEvent),this.k.setFocus([m],g.browserEvent)}else if(this.o(g)){const n=this.k.getSelection(),l=n.filter(D=>D!==m);this.k.setFocus([m]),this.k.setAnchor(m),n.length===l.length?this.k.setSelection([...l,m],g.browserEvent):this.k.setSelection(l,g.browserEvent)}}dispose(){this.f.dispose()}}t.$3R=re;class J{constructor(g,m){this.c=g,this.d=m}style(g){const m=this.d&&`.${this.d}`,i=[];g.listBackground&&i.push(`.monaco-list${m} .monaco-list-rows { background: ${g.listBackground}; }`),g.listFocusBackground&&(i.push(`.monaco-list${m}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),i.push(`.monaco-list${m}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&i.push(`.monaco-list${m}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(i.push(`.monaco-list${m}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),i.push(`.monaco-list${m}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&i.push(`.monaco-list${m}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&i.push(`.monaco-list${m}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionBackground&&i.push(`
				.monaco-drag-image,
				.monaco-list${m}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&i.push(`
				.monaco-drag-image,
				.monaco-list${m}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(i.push(`.monaco-list${m} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),i.push(`.monaco-list${m} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&i.push(`.monaco-list${m} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(i.push(`.monaco-list${m} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),i.push(`.monaco-list${m} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(i.push(`.monaco-list${m} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),i.push(`.monaco-list${m} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&i.push(`.monaco-list${m} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&i.push(`.monaco-list${m}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&i.push(`.monaco-list${m}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`);const n=(0,A.$RQ)(g.listFocusAndSelectionOutline,(0,A.$RQ)(g.listSelectionOutline,g.listFocusOutline??""));n&&i.push(`.monaco-list${m}:focus .monaco-list-row.focused.selected { outline: 1px solid ${n}; outline-offset: -1px;}`),g.listFocusOutline&&i.push(`
				.monaco-drag-image,
				.monaco-list${m}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${m}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`);const l=(0,A.$RQ)(g.listSelectionOutline,g.listInactiveFocusOutline??"");l&&i.push(`.monaco-list${m} .monaco-list-row.focused.selected { outline: 1px dotted ${l}; outline-offset: -1px; }`),g.listSelectionOutline&&i.push(`.monaco-list${m} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listInactiveFocusOutline&&i.push(`.monaco-list${m} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&i.push(`.monaco-list${m} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropOverBackground&&i.push(`
				.monaco-list${m}.drop-target,
				.monaco-list${m} .monaco-list-rows.drop-target,
				.monaco-list${m} .monaco-list-row.drop-target { background-color: ${g.listDropOverBackground} !important; color: inherit !important; }
			`),g.listDropBetweenBackground&&(i.push(`
			.monaco-list${m} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${m} .monaco-list-row.drop-target-after + .monaco-list-row::before,
			.monaco-list${m} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`),i.push(`
			.monaco-list${m} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${m} .monaco-list-row:last-child.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`)),g.tableColumnsBorder&&i.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&i.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=i.join(`
`)}}t.$4R=J,t.$5R={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:y.$lt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:y.$lt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:y.$lt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function K(_,g){const m=_.indexOf(g);if(m===-1)return[];const i=[];let n=m-1;for(;n>=0&&_[n]===g-(m-n);)i.push(_[n--]);for(i.reverse(),n=m;n<_.length&&_[n]===g+(n-m);)i.push(_[n++]);return i}function W(_,g){const m=[];let i=0,n=0;for(;i<_.length||n<g.length;)if(i>=_.length)m.push(g[n++]);else if(n>=g.length)m.push(_[i++]);else if(_[i]===g[n]){m.push(_[i]),i++,n++;continue}else _[i]<g[n]?m.push(_[i++]):m.push(g[n++]);return m}function Z(_,g){const m=[];let i=0,n=0;for(;i<_.length||n<g.length;)if(i>=_.length)m.push(g[n++]);else if(n>=g.length)m.push(_[i++]);else if(_[i]===g[n]){i++,n++;continue}else _[i]<g[n]?m.push(_[i++]):n++;return m}const ce=(_,g)=>_-g;class we{constructor(g,m){this.c=g,this.d=m}get templateId(){return this.c}renderTemplate(g){return this.d.map(m=>m.renderTemplate(g))}renderElement(g,m,i,n){let l=0;for(const D of this.d)D.renderElement(g,m,i[l++],n)}disposeElement(g,m,i,n){let l=0;for(const D of this.d)D.disposeElement?.(g,m,i[l],n),l+=1}disposeTemplate(g){let m=0;for(const i of this.d)i.disposeTemplate(g[m++])}}class Ae{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,m,i){const n=this.c.getAriaLabel(g);n?i.setAttribute("aria-label",n):i.removeAttribute("aria-label");const l=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof l=="number"?i.setAttribute("aria-level",`${l}`):i.removeAttribute("aria-level")}disposeTemplate(g){}}class ke{constructor(g,m){this.c=g,this.d=m}getDragElements(g){const m=this.c.getSelectedElements();return m.indexOf(g)>-1?m:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,m){if(this.d.getDragLabel)return this.d.getDragLabel(g,m)}onDragStart(g,m){this.d.onDragStart?.(g,m)}onDragOver(g,m,i,n,l){return this.d.onDragOver(g,m,i,n,l)}onDragLeave(g,m,i,n){this.d.onDragLeave?.(g,m,i,n)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,m,i,n,l){this.d.drop(g,m,i,n,l)}dispose(){this.d.dispose()}}class Le{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.G(g),this.y)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.G(g),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const m=o.Event.chain(this.y.add(new P.$AR(this.k.domNode,"keydown")).event,l=>l.map(D=>new s.$wP(D)).filter(D=>g=D.keyCode===58||D.shiftKey&&D.keyCode===68).map(D=>A.$uQ.stop(D,!0)).filter(()=>!1)),i=o.Event.chain(this.y.add(new P.$AR(this.k.domNode,"keyup")).event,l=>l.forEach(()=>g=!1).map(D=>new s.$wP(D)).filter(D=>D.keyCode===58||D.shiftKey&&D.keyCode===68).map(D=>A.$uQ.stop(D,!0)).map(({browserEvent:D})=>{const S=this.getFocus(),z=S.length?S[0]:void 0,T=typeof z<"u"?this.k.element(z):void 0,H=typeof z<"u"?this.k.domElement(z):this.k.domNode;return{index:z,element:T,anchor:H,browserEvent:D}})),n=o.Event.chain(this.k.onContextMenu,l=>l.filter(D=>!g).map(({element:D,index:S,browserEvent:z})=>({element:D,index:S,anchor:new c.$rP((0,A.getWindow)(this.k.domNode),z),browserEvent:z})));return o.Event.any(m,i,n)}get onKeyDown(){return this.y.add(new P.$AR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new P.$AR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new P.$AR(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.y.add(new P.$AR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.y.add(new P.$AR(this.k.domNode,"blur",!0)).event)}constructor(g,m,i,n,l=le){this.A=g,this.B=l,this.c=new h("focused"),this.f=new h("anchor"),this.g=new o.$3d,this.x="",this.y=new e.$Sc,this.z=new o.$Ud,this.onDidDispose=this.z.event;const D=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(D!=="listbox");const S=[this.c.renderer,this.d.renderer];this.u=l.accessibilityProvider,this.u&&(S.push(new Ae(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),n=n.map(T=>new we(T.templateId,[...S,T]));const z={...l,dnd:l.dnd&&new ke(this,l.dnd)};if(this.k=this.C(m,i,n,z),this.k.domNode.setAttribute("role",D),l.styleController)this.q=l.styleController(this.k.domId);else{const T=(0,A.$hQ)(this.k.domNode);this.q=new J(T,this.k.domId)}if(this.o=new k.$ER([new M(this.c,this.k,l.identityProvider),new M(this.d,this.k,l.identityProvider),new M(this.f,this.k,l.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ee(this,this.k)),(typeof l.keyboardSupport!="boolean"||l.keyboardSupport)&&(this.v=new Y(this,this.k,l),this.y.add(this.v)),l.keyboardNavigationLabelProvider){const T=l.keyboardNavigationDelegate||t.$ZR;this.t=new oe(this,this.k,l.keyboardNavigationLabelProvider,l.keyboardNavigationEventFilter??(()=>!0),T),this.y.add(this.t)}this.w=this.D(l),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(g,m,i,n){return new p.$NR(g,m,i,n)}D(g){return new re(this)}updateOptions(g={}){this.B={...this.B,...g},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.B}splice(g,m,i=[]){if(g<0||g>this.k.length)throw new u.$PR(this.A,`Invalid start index: ${g}`);if(m<0)throw new u.$PR(this.A,`Invalid delete count: ${m}`);m===0&&i.length===0||this.g.bufferEvents(()=>this.o.splice(g,m,i))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,m){this.k.updateElementHeight(g,m,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(g){this.x=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,m){this.k.layout(g,m)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,m){for(const i of g)if(i<0||i>=this.length)throw new u.$PR(this.A,`Invalid index ${i}`);this.d.set(g,m)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new u.$PR(this.A,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,m){for(const i of g)if(i<0||i>=this.length)throw new u.$PR(this.A,`Invalid index ${i}`);this.c.set(g,m)}focusNext(g=1,m=!1,i,n){if(this.length===0)return;const l=this.c.get(),D=this.E(l.length>0?l[0]+g:0,m,n);D>-1&&this.setFocus([D],i)}focusPrevious(g=1,m=!1,i,n){if(this.length===0)return;const l=this.c.get(),D=this.F(l.length>0?l[0]-g:0,m,n);D>-1&&this.setFocus([D],i)}async focusNextPage(g,m){let i=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);i=i===0?0:i-1;const n=this.getFocus()[0];if(n!==i&&(n===void 0||i>n)){const l=this.F(i,!1,m);l>-1&&n!==l?this.setFocus([l],g):this.setFocus([i],g)}else{const l=this.k.getScrollTop();let D=l+this.k.renderHeight;i>n&&(D-=this.k.elementHeight(i)),this.k.setScrollTop(D),this.k.getScrollTop()!==l&&(this.setFocus([]),await(0,w.$6g)(0),await this.focusNextPage(g,m))}}async focusPreviousPage(g,m){let i;const n=this.k.getScrollTop();n===0?i=this.k.indexAt(n):i=this.k.indexAfter(n-1);const l=this.getFocus()[0];if(l!==i&&(l===void 0||l>=i)){const D=this.E(i,!1,m);D>-1&&l!==D?this.setFocus([D],g):this.setFocus([i],g)}else{const D=n;this.k.setScrollTop(n-this.k.renderHeight),this.k.getScrollTop()!==D&&(this.setFocus([]),await(0,w.$6g)(0),await this.focusPreviousPage(g,m))}}focusLast(g,m){if(this.length===0)return;const i=this.F(this.length-1,!1,m);i>-1&&this.setFocus([i],g)}focusFirst(g,m){this.focusNth(0,g,m)}focusNth(g,m,i){if(this.length===0)return;const n=this.E(g,!1,i);n>-1&&this.setFocus([n],m)}E(g,m=!1,i){for(let n=0;n<this.length;n++){if(g>=this.length&&!m)return-1;if(g=g%this.length,!i||i(this.element(g)))return g;g++}return-1}F(g,m=!1,i){for(let n=0;n<this.length;n++){if(g<0&&!m)return-1;if(g=(this.length+g%this.length)%this.length,!i||i(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,m,i=0){if(g<0||g>=this.length)throw new u.$PR(this.A,`Invalid index ${g}`);const n=this.k.getScrollTop(),l=this.k.elementTop(g),D=this.k.elementHeight(g);if((0,$.$Lf)(m)){const S=D-this.k.renderHeight+i;this.k.setScrollTop(S*(0,r.$6l)(m,0,1)+l-i)}else{const S=l+D,z=n+this.k.renderHeight;l<n+i&&S>=z||(l<n+i||S>=z&&D>=this.k.renderHeight?this.k.setScrollTop(l-i):S>=z&&this.k.setScrollTop(S-this.k.renderHeight))}}getRelativeTop(g,m=0){if(g<0||g>=this.length)throw new u.$PR(this.A,`Invalid index ${g}`);const i=this.k.getScrollTop(),n=this.k.elementTop(g),l=this.k.elementHeight(g);if(n<i+m||n+l>i+this.k.renderHeight)return null;const D=l-this.k.renderHeight+m;return Math.abs((i+m-n)/D)}isDOMFocused(){return(0,A.$aQ)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(g){return this.k.getElementDomId(g)}getElementTop(g){return this.k.elementTop(g)}style(g){this.q.style(g)}G({indexes:g,browserEvent:m}){return{indexes:g,elements:g.map(i=>this.k.element(i)),browserEvent:m}}H(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.I()}I(){const g=this.c.get();if(g.length>0){let m;this.u?.getActiveDescendantId&&(m=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",m||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$6R=Le,Ye([I.$wh],Le.prototype,"onDidChangeFocus",null),Ye([I.$wh],Le.prototype,"onDidChangeSelection",null),Ye([I.$wh],Le.prototype,"onContextMenu",null),Ye([I.$wh],Le.prototype,"onKeyDown",null),Ye([I.$wh],Le.prototype,"onKeyUp",null),Ye([I.$wh],Le.prototype,"onKeyPress",null),Ye([I.$wh],Le.prototype,"onDidFocus",null),Ye([I.$wh],Le.prototype,"onDidBlur",null)}),define(be[62],pe([1,0,6,35,37,10,15]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.MarkdownStringTextNewlineStyle=void 0;var k;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(k||(t.MarkdownStringTextNewlineStyle=k={}));class b{constructor(u="",p=!1){if(this.value=u,typeof this.value!="string")throw(0,A.$7)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(u,p=0){return this.value+=o(this.supportThemeIcons?(0,P.$ak)(u):u).replace(/([ \t]+)/g,(c,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,p){return this.value+=`
${a(p,u)}
`,this}appendLink(u,p,c){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(u),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(u,p){const c=new RegExp((0,U.$Ne)(p),"g");return u.replace(c,(f,h)=>u.charAt(h-1)!=="\\"?`\\${f}`:f)}}t.$gk=b;function w($){return y($)?!$.value:Array.isArray($)?$.every(w):!0}t.$hk=w;function y($){return $ instanceof b?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}t.$ik=y;function I($,u){return $===u?!0:!$||!u?!1:$.value===u.value&&$.isTrusted===u.isTrusted&&$.supportThemeIcons===u.supportThemeIcons&&$.supportHtml===u.supportHtml&&($.baseUri===u.baseUri||!!$.baseUri&&!!u.baseUri&&(0,s.$zg)(E.URI.from($.baseUri),E.URI.from(u.baseUri)))}t.$jk=I;function o($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$kk=o;function a($,u){const p=$.match(/^`+/gm)?.reduce((f,h)=>f.length>h.length?f:h).length??0,c=p>=3?p+1:3;return[`${"`".repeat(c)}${u}`,$,`${"`".repeat(c)}`].join(`
`)}t.$lk=a;function e($){return $.replace(/"/g,"&quot;")}t.$mk=e;function r($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$nk=r;function d($){const u=[],p=$.split("|").map(f=>f.trim());$=p[0];const c=p[1];if(c){const f=/height=(\d+)/.exec(c),h=/width=(\d+)/.exec(c),F=f?f[1]:"",M=h?h[1]:"",R=isFinite(parseInt(M)),O=isFinite(parseInt(F));R&&u.push(`width="${M}"`),O&&u.push(`height="${F}"`)}return{href:$,dimensions:u}}t.$ok=d}),define(be[126],pe([1,0,3,118,22,55,14,19,119,6,4,62,35,77,23,2,79,53,31,51,37,10,15]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o,a,e,r,d,$,u,p,c,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aS=t.$_R=t.$$R=t.$0R=t.$9R=void 0;const F=Object.freeze({image:(K,W,Z)=>{let ce=[],we=[];return K&&({href:K,dimensions:ce}=(0,I.$ok)(K),we.push(`src="${(0,I.$mk)(K)}"`)),Z&&we.push(`alt="${(0,I.$mk)(Z)}"`),W&&we.push(`title="${(0,I.$mk)(W)}"`),ce.length&&(we=we.concat(ce)),"<img "+we.join(" ")+">"},paragraph:K=>`<p>${K}</p>`,link:(K,W,Z)=>typeof K!="string"?"":(K===Z&&(Z=(0,I.$nk)(Z)),W=typeof W=="string"?(0,I.$mk)((0,I.$nk)(W)):"",K=(0,I.$nk)(K),K=K.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${K}" title="${W||K}" draggable="false">${Z}</a>`)});function M(K,W={},Z={}){const ce=new r.$Sc;let we=!1;const Ae=(0,U.$zR)(W),ke=function(S){let z;try{z=(0,$.$Ah)(decodeURIComponent(S))}catch{}return z?(z=(0,p.$wn)(z,T=>{if(K.uris&&K.uris[T])return h.URI.revive(K.uris[T])}),encodeURIComponent(JSON.stringify(z))):S},Le=function(S,z){const T=K.uris&&K.uris[S];let H=h.URI.revive(T);return z?S.startsWith(u.Schemas.data+":")?S:(H||(H=h.URI.parse(S)),u.$ng.uriToBrowserUri(H).toString(!0)):!H||h.URI.parse(S).toString()===H.toString()?S:(H.query&&(H=H.with({query:ke(H.query)})),H.toString())},_=new d.marked.Renderer;_.image=F.image,_.link=F.link,_.paragraph=F.paragraph;const g=[],m=[];if(W.codeBlockRendererSync?_.code=(S,z)=>{const T=a.$bN.nextId(),H=W.codeBlockRendererSync(R(z),S);return m.push([T,H]),`<div class="code" data-code="${T}">${(0,f.$Me)(S)}</div>`}:W.codeBlockRenderer&&(_.code=(S,z)=>{const T=a.$bN.nextId(),H=W.codeBlockRenderer(R(z),S);return g.push(H.then(G=>[T,G])),`<div class="code" data-code="${T}">${(0,f.$Me)(S)}</div>`}),W.actionHandler){const S=function(H){let G=H.target;if(!(G.tagName!=="A"&&(G=G.parentElement,!G||G.tagName!=="A")))try{let ne=G.dataset.href;ne&&(K.baseUri&&(ne=O(h.URI.from(K.baseUri),ne)),W.actionHandler.callback(ne,H))}catch(ne){(0,w.$1)(ne)}finally{H.preventDefault()}},z=W.actionHandler.disposables.add(new s.$AR(Ae,"click")),T=W.actionHandler.disposables.add(new s.$AR(Ae,"auxclick"));W.actionHandler.disposables.add(y.Event.any(z.event,T.event)(H=>{const G=new k.$rP(A.getWindow(Ae),H);!G.leftButton&&!G.middleButton||S(G)})),W.actionHandler.disposables.add(A.$zP(Ae,"keydown",H=>{const G=new E.$wP(H);!G.equals(10)&&!G.equals(3)||S(G)}))}K.supportHtml||(Z.sanitizer=S=>(K.isTrusted?S.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?S:"",Z.sanitize=!0,Z.silent=!0),Z.renderer=_;let i=K.value??"";i.length>1e5&&(i=`${i.substr(0,1e5)}\u2026`),K.supportThemeIcons&&(i=(0,o.$bk)(i));let n;if(W.fillInIncompleteTokens){const S={...d.marked.defaults,...Z},z=d.marked.lexer(i,S),T=X(z);n=d.marked.parser(T,S)}else n=d.marked.parse(i,Z);K.supportThemeIcons&&(n=(0,b.$7R)(n).map(z=>typeof z=="string"?z:z.outerHTML).join(""));const D=new DOMParser().parseFromString(v(K,n),"text/html");if(D.body.querySelectorAll("img").forEach(S=>{const z=S.getAttribute("src");if(z){let T=z;try{K.baseUri&&(T=O(h.URI.from(K.baseUri),T))}catch{}S.src=Le(T,!0)}}),D.body.querySelectorAll("a").forEach(S=>{const z=S.getAttribute("href");if(S.setAttribute("href",""),!z||/^data:|javascript:/i.test(z)||/^command:/i.test(z)&&!K.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(z))S.replaceWith(...S.childNodes);else{let T=Le(z,!1);K.baseUri&&(T=O(h.URI.from(K.baseUri),z)),S.dataset.href=T}}),Ae.innerHTML=v(K,D.body.innerHTML),g.length>0)Promise.all(g).then(S=>{if(we)return;const z=new Map(S),T=Ae.querySelectorAll("div[data-code]");for(const H of T){const G=z.get(H.dataset.code??"");G&&A.$BQ(H,G)}W.asyncRenderCallback?.()});else if(m.length>0){const S=new Map(m),z=Ae.querySelectorAll("div[data-code]");for(const T of z){const H=S.get(T.dataset.code??"");H&&A.$BQ(T,H)}}if(W.asyncRenderCallback)for(const S of Ae.getElementsByTagName("img")){const z=ce.add(A.$zP(S,"load",()=>{z.dispose(),W.asyncRenderCallback()}))}return{element:Ae,dispose:()=>{we=!0,ce.dispose()}}}t.$9R=M;function R(K){if(!K)return"";const W=K.split(/[\s+|:|,|\{|\?]/,1);return W.length?W[0]:K}function O(K,W){return/^\w[\w\d+.-]*:/.test(W)?W:K.path.endsWith("/")?(0,c.$Jg)(K,W).toString():(0,c.$Jg)((0,c.$Fg)(K),W).toString()}function v(K,W){const{config:Z,allowedSchemes:ce}=C(K);P.addHook("uponSanitizeAttribute",(Ae,ke)=>{if(ke.attrName==="style"||ke.attrName==="class"){if(Ae.tagName==="SPAN"){if(ke.attrName==="style"){ke.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(ke.attrValue);return}else if(ke.attrName==="class"){ke.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(ke.attrValue);return}}ke.keepAttr=!1;return}else if(Ae.tagName==="INPUT"&&Ae.attributes.getNamedItem("type")?.value==="checkbox"){if(ke.attrName==="type"&&ke.attrValue==="checkbox"||ke.attrName==="disabled"||ke.attrName==="checked"){ke.keepAttr=!0;return}ke.keepAttr=!1}}),P.addHook("uponSanitizeElement",(Ae,ke)=>{ke.tagName==="input"&&(Ae.attributes.getNamedItem("type")?.value==="checkbox"?Ae.setAttribute("disabled",""):Ae.parentElement?.removeChild(Ae))});const we=A.$VQ(ce);try{return P.sanitize(W,{...Z,RETURN_TRUSTED_TYPE:!0})}finally{P.removeHook("uponSanitizeAttribute"),we.dispose()}}t.$0R=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function C(K){const W=[u.Schemas.http,u.Schemas.https,u.Schemas.mailto,u.Schemas.data,u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemote,u.Schemas.vscodeRemoteResource];return K.isTrusted&&W.push(u.Schemas.command),{config:{ALLOWED_TAGS:[...A.$WQ],ALLOWED_ATTR:t.$0R,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:W}}function q(K){return typeof K=="string"?K:j(K)}t.$$R=q;function j(K){let W=K.value??"";W.length>1e5&&(W=`${W.substr(0,1e5)}\u2026`);const Z=d.marked.parse(W,{renderer:L.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ce=>N.get(ce)??ce);return v({isTrusted:!1},Z).toString()}t.$_R=j;const N=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),L=new e.$V(()=>{const K=new d.marked.Renderer;return K.code=W=>W,K.blockquote=W=>W,K.html=W=>"",K.heading=(W,Z,ce)=>W+`
`,K.hr=()=>"",K.list=(W,Z)=>W,K.listitem=W=>W+`
`,K.paragraph=W=>W+`
`,K.table=(W,Z)=>W+Z+`
`,K.tablerow=W=>W,K.tablecell=(W,Z)=>W+" ",K.strong=W=>W,K.em=W=>W,K.codespan=W=>W,K.br=()=>`
`,K.del=W=>W,K.image=(W,Z,ce)=>"",K.text=W=>W,K.link=(W,Z,ce)=>ce,K});function B(K){let W="";return K.forEach(Z=>{W+=Z.raw}),W}function Y(K){for(const W of K.tokens)if(W.type==="text"){const Z=W.raw.split(`
`),ce=Z[Z.length-1];if(ce.includes("`"))return oe(K);if(ce.includes("**"))return Me(K);if(ce.match(/\*\w/))return ee(K);if(ce.match(/(^|\s)__\w/))return re(K);if(ce.match(/(^|\s)_\w/))return me(K);if(ce.match(/(^|\s)\[.*\]\(\w*/))return Te(K);if(ce.match(/(^|\s)\[\w/))return Ne(K)}}function X(K){let W,Z;for(W=0;W<K.length;W++){const ce=K[W];if(ce.type==="paragraph"&&ce.raw.match(/(\n|^)```/)){Z=de(K.slice(W));break}if(ce.type==="paragraph"&&ce.raw.match(/(\n|^)\|/)){Z=le(K.slice(W));break}if(W===K.length-1&&ce.type==="paragraph"){const we=Y(ce);if(we){Z=[we];break}}}if(Z){const ce=[...K.slice(0,W),...Z];return ce.links=K.links,ce}return K}t.$aS=X;function de(K){const W=B(K);return d.marked.lexer(W+"\n```")}function oe(K){return J(K,"`")}function ee(K){return J(K,"*")}function me(K){return J(K,"_")}function Te(K){return J(K,")")}function Ne(K){return J(K,"](about:blank)")}function Me(K){return J(K,"**")}function re(K){return J(K,"__")}function J(K,W){const Z=B(Array.isArray(K)?K:[K]);return d.marked.lexer(Z+W)[0]}function le(K){const W=B(K),Z=W.split(`
`);let ce,we=!1;for(let Ae=0;Ae<Z.length;Ae++){const ke=Z[Ae].trim();if(typeof ce>"u"&&ke.match(/^\s*\|/)){const Le=ke.match(/(\|[^\|]+)(?=\||$)/g);Le&&(ce=Le.length)}else if(typeof ce=="number")if(ke.match(/^\s*\|/)){if(Ae!==Z.length-1)return;we=!0}else return}if(typeof ce=="number"&&ce>0){const Ae=we?Z.slice(0,-1).join(`
`):W,ke=!!Ae.match(/\|\s*$/),Le=Ae+(ke?"":"|")+`
|${" --- |".repeat(ce)}`;return d.marked.lexer(Le)}}}),define(be[127],pe([1,0,3,9,29,62,35,2,7,108]),function(ie,t,A,P,s,U,E,k,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=t.$qR=void 0;function y(a,e){(0,b.$Hf)(e)?a.title=(0,E.$ck)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$qR=y;class I{constructor(e,r,d){this.c=e,this.d=r,this.f=d}async update(e,r,d){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let $;if(e===void 0||(0,b.$Hf)(e)||e instanceof HTMLElement)$=e;else if(!(0,b.$Vf)(e.markdown))$=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,w.localize)(0,null),r),this.b=new s.$5d;const u=this.b.token;if($=await e.markdown(u),$===void 0&&($=e.markdownNotSupportedFallback),this.isDisposed||u.isCancellationRequested)return}this.g($,r,d)}g(e,r,d){const $=this.a;if(this.h(e)){const u={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!$},position:{hoverPosition:2},...d};this.a=this.c.showHover(u,r)}$?.dispose()}h(e){return e?(0,U.$ik)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(a,e,r,d){let $,u;const p=(j,N)=>{const L=u!==void 0;j&&(u?.dispose(),u=void 0),N&&($?.dispose(),$=void 0),L&&a.onDidHideHover?.()},c=(j,N,L)=>new P.$ch(async()=>{(!u||u.isDisposed)&&(u=new I(a,L||e,j>0),await u.update(r,N,d))},j);let f=!1;const h=A.$zP(e,A.$sQ.MOUSE_DOWN,()=>{f=!0,p(!0,!0)},!0),F=A.$zP(e,A.$sQ.MOUSE_UP,()=>{f=!1},!0),M=A.$zP(e,A.$sQ.MOUSE_LEAVE,j=>{f=!1,p(!1,j.fromElement===e)},!0),R=()=>{if($)return;const j=new k.$Sc,N={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const L=B=>{N.x=B.x+10,B.target instanceof HTMLElement&&B.target.classList.contains("action-label")&&p(!0,!0)};j.add(A.$zP(e,A.$sQ.MOUSE_MOVE,L,!0))}j.add(c(a.delay,!1,N)),$=j},O=A.$zP(e,A.$sQ.MOUSE_OVER,R,!0),v=()=>{if(f||$)return;const j={targetElements:[e],dispose:()=>{}},N=new k.$Sc,L=()=>p(!0,!0);N.add(A.$zP(e,A.$sQ.BLUR,L,!0)),N.add(c(a.delay,!1,j)),$=N},C=A.$zP(e,A.$sQ.FOCUS,v,!0);return{show:j=>{p(!1,!0),c(0,j)},hide:()=>{p(!0,!0)},update:async(j,N)=>{r=j,await u?.update(r,void 0,N)},dispose:()=>{O.dispose(),M.dispose(),h.dispose(),F.dispose(),C.dispose(),p(!0,!0)}}}t.$rR=o}),define(be[128],pe([1,0,3,22,14,126,39,12,4,44,2,5,110,101]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bS=void 0;const a=A.$,e="selectOption.entry.template";class r{get templateId(){return e}renderTemplate(u){const p=Object.create(null);return p.root=u,p.text=A.$zQ(u,a(".option-text")),p.detail=A.$zQ(u,a(".option-detail")),p.decoratorRight=A.$zQ(u,a(".option-decorator-right")),p}renderElement(u,p,c){const f=c,h=u.text,F=u.detail,M=u.decoratorRight,R=u.isDisabled;f.text.textContent=h,f.detail.textContent=F||"",f.decoratorRight.innerText=M||"",R?f.root.classList.add("option-disabled"):f.root.classList.remove("option-disabled")}disposeTemplate(u){}}class d extends y.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(u,p,c,f,h){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=f,this.g=h||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=d.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new b.$Ud,this.B(this.r),this.O(),this.N(c),this.n=p||0,u&&this.setOptions(u,p),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(u){this.u=u,this.w=A.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=A.$zQ(this.w,a(".select-box-details-pane"));const p=A.$zQ(this.w,a(".select-box-dropdown-container-width-control")),c=A.$zQ(p,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",A.$zQ(c,this.D),this.G=0,this.y=A.$hQ(this.w),this.w.setAttribute("draggable","true"),this.B(A.$zP(this.w,A.$sQ.DRAG_START,f=>{A.$uQ.stop(f,!0)}))}O(){this.B(A.$AP(this.h,"change",p=>{this.n=p.target.selectedIndex,this.r.fire({index:p.target.selectedIndex,selected:p.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(A.$zP(this.h,A.$sQ.CLICK,p=>{A.$uQ.stop(p),this.f?this.X(!0):this.W()})),this.B(A.$zP(this.h,A.$sQ.MOUSE_DOWN,p=>{A.$uQ.stop(p)}));let u;this.B(A.$zP(this.h,"touchstart",p=>{u=this.f})),this.B(A.$zP(this.h,"touchend",p=>{A.$uQ.stop(p),u?this.X(!0):this.W()})),this.B(A.$zP(this.h,A.$sQ.KEY_DOWN,p=>{const c=new s.$wP(p);let f=!1;I.$j?(c.keyCode===18||c.keyCode===16||c.keyCode===10||c.keyCode===3)&&(f=!0):(c.keyCode===18&&c.altKey||c.keyCode===16&&c.altKey||c.keyCode===10||c.keyCode===3)&&(f=!0),f&&(this.W(),A.$uQ.stop(p,!0))}))}get onDidSelect(){return this.r.event}setOptions(u,p){k.$ub(this.m,u)||(this.m=u,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((c,f)=>{this.h.add(this.U(c.text,f,c.isDisabled)),typeof c.description=="string"&&(this.H=!0)})),p!==void 0&&(this.select(p),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(u){u>=0&&u<this.m.length?this.n=u:u>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(u){this.g.ariaLabel=u,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(u){this.h.tabIndex=u?0:-1}render(u){this.j=u,u.classList.add("select-container"),u.appendChild(this.h),this.R()}Q(){const u=[];this.s.listFocusBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(u.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=u.join(`
`)}R(){const u=this.s.selectBackground??"",p=this.s.selectForeground??"",c=this.s.selectBorder??"";this.h.style.backgroundColor=u,this.h.style.color=p,this.h.style.borderColor=c}S(){const u=this.s.selectBackground??"",p=A.$RQ(this.s.selectListBackground,u);this.C.style.backgroundColor=p,this.I.style.backgroundColor=p;const c=this.s.focusBorder??"";this.w.style.outlineColor=c,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(u,p,c){const f=document.createElement("option");return f.value=u,f.text=u,f.disabled=!!c,f}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:u=>this.Y(u,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:u=>this.Y(u),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(u){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),u&&this.h.focus(),this.u.hideContextView())}Y(u,p){return u.appendChild(this.w),this.ab(p),{dispose:()=>{try{u.removeChild(this.w)}catch{}}}}Z(){let u=0;return this.m.forEach((p,c)=>{this.hb(c),this.I.offsetHeight>u&&(u=this.I.offsetHeight)}),u}ab(u){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const p=A.getWindow(this.h),c=A.$VP(this.h),f=A.getWindow(this.h).getComputedStyle(this.h),h=parseFloat(f.getPropertyValue("--dropdown-padding-top"))+parseFloat(f.getPropertyValue("--dropdown-padding-bottom")),F=p.innerHeight-c.top-c.height-(this.g.minBottomMargin||0),M=c.top-d.b,R=this.h.offsetWidth,O=this.bb(this.D),v=Math.max(O,Math.round(R)).toString()+"px";this.w.style.width=v,this.z.getHTMLElement().style.height="",this.z.layout();let C=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const q=this.H?this.L:0,j=C+h+q,N=Math.floor((F-h-q)/this.getHeight()),L=Math.floor((M-h-q)/this.getHeight());if(u)return c.top+c.height>p.innerHeight-22||c.top<d.b||N<1&&L<1?!1:(N<d.c&&L>N&&this.m.length>N?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(c.top+c.height>p.innerHeight-22||c.top<d.b||this.G===0&&N<1||this.G===1&&L<1)return this.X(!0),!1;if(this.G===0){if(this.f&&N+L<1)return this.X(!0),!1;j>F&&(C=N*this.getHeight())}else j>M&&(C=L*this.getHeight());return this.z.layout(C),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=C+h+"px",this.w.style.height=""):this.w.style.height=C+h+"px",this.hb(this.n),this.w.style.width=v,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(u){let p=0;if(u){let c=0,f=0;this.m.forEach((h,F)=>{const M=h.detail?h.detail.length:0,R=h.decoratorRight?h.decoratorRight.length:0,O=h.text.length+M+R;O>f&&(c=F,f=O)}),u.textContent=this.m[c].text+(this.m[c].decoratorRight?this.m[c].decoratorRight+" ":""),p=A.$XP(u)}return p}cb(u){if(this.z)return;this.C=A.$zQ(u,a(".select-box-dropdown-list-container")),this.t=new r,this.z=new E.$6R("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:f=>{let h=f.text;return f.detail&&(h+=`. ${f.detail}`),f.decoratorRight&&(h+=`. ${f.decoratorRight}`),f.description&&(h+=`. ${f.description}`),h},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>I.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const p=this.B(new P.$AR(this.C,"keydown")),c=b.Event.chain(p.event,f=>f.filter(()=>this.z.length>0).map(h=>new s.$wP(h)));this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===3))(this.jb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===2))(this.jb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===9))(this.ib,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===16))(this.lb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===18))(this.kb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===12))(this.nb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===11))(this.mb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===14))(this.ob,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===13))(this.pb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode>=21&&h.keyCode<=56||h.keyCode>=85&&h.keyCode<=113))(this.qb,this)),this.B(A.$zP(this.z.getHTMLElement(),A.$sQ.POINTER_UP,f=>this.db(f))),this.B(this.z.onMouseOver(f=>typeof f.index<"u"&&this.z.setFocus([f.index]))),this.B(this.z.onDidChangeFocus(f=>this.gb(f))),this.B(A.$zP(this.w,A.$sQ.FOCUS_OUT,f=>{!this.f||A.$4P(f.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(u){if(!this.z.length)return;A.$uQ.stop(u);const p=u.target;if(!p||p.classList.contains("slider"))return;const c=p.closest(".monaco-list-row");if(!c)return;const f=Number(c.getAttribute("data-index")),h=c.classList.contains("option-disabled");f>=0&&f<this.m.length&&!h&&(this.n=f,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(u,p){const c=h=>{for(let F=0;F<h.childNodes.length;F++){const M=h.childNodes.item(F);(M.tagName&&M.tagName.toLowerCase())==="img"?h.removeChild(M):c(M)}},f=(0,U.$9R)({value:u,supportThemeIcons:!0},{actionHandler:p});return f.element.classList.add("select-box-description-markdown"),c(f.element),f.element}gb(u){!this.f||!this.H||this.hb(u.indexes[0])}hb(u){this.I.innerText="";const p=this.m[u],c=p?.description??"",f=p?.descriptionIsMarkdown??!1;if(c){if(f){const h=p.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(c,h))}else this.I.innerText=c;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(u){A.$uQ.stop(u),this.select(this.F),this.X(!0)}jb(u){A.$uQ.stop(u),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(u){if(this.n<this.m.length-1){A.$uQ.stop(u,!0);const p=this.m[this.n+1].isDisabled;if(p&&this.m.length>this.n+2)this.n+=2;else{if(p)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(u){this.n>0&&(A.$uQ.stop(u,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(u){A.$uQ.stop(u),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(u){A.$uQ.stop(u),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(u){A.$uQ.stop(u),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(u){A.$uQ.stop(u),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(u){const p=w.KeyCodeUtils.toString(u.keyCode);let c=-1;for(let f=0;f<this.m.length-1;f++)if(c=(f+this.n+1)%this.m.length,this.m[c].text.charAt(0).toUpperCase()===p&&!this.m[c].isDisabled){this.select(c),this.z.setFocus([c]),this.z.reveal(this.z.getFocus()[0]),A.$uQ.stop(u);break}}dispose(){this.X(!1),super.dispose()}}t.$bS=d}),define(be[129],pe([1,0,39,128,122,20,5,100]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eS=t.$dS=void 0,t.$dS={...A.$5R,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class k extends U.$aR{constructor(w,y,I,o,a){super(),E.$j&&!a?.useCustomDrawn?this.a=new s.$cS(w,y,o,a):this.a=new P.$bS(w,y,I,o,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(w,y){this.a.setOptions(w,y)}select(w){this.a.select(w)}setAriaLabel(w){this.a.setAriaLabel(w)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(w){this.a.setFocusable(w)}render(w){this.a.render(w)}}t.$eS=k}),define(be[63],pe([1,0,16,54,3,25,127,129,36,2,5,7,105,52]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mS=t.$lS=t.$kS=void 0;class a extends w.$Tc{get action(){return this._action}constructor($,u,p={}){super(),this.m=p,this._context=$||this,this._action=u,u instanceof b.$Ji&&this.B(u.onDidChange(c=>{this.element&&this.t(c)}))}t($){$.enabled!==void 0&&this.u(),$.checked!==void 0&&this.H(),$.class!==void 0&&this.G(),$.label!==void 0&&(this.w(),this.D()),$.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new b.$Ki)),this.j}set actionRunner($){this.j=$}isEnabled(){return this._action.enabled}setActionContext($){this._context=$}render($){const u=this.element=$;this.B(U.$9Q.addTarget($));const p=this.m&&this.m.draggable;p&&($.draggable=!0,A.$fP&&this.B((0,s.$zP)($,s.$sQ.DRAG_START,c=>c.dataTransfer?.setData(P.$7Q.TEXT,this._action.label)))),this.B((0,s.$zP)(u,U.EventType.Tap,c=>this.onClick(c,!0))),this.B((0,s.$zP)(u,s.$sQ.MOUSE_DOWN,c=>{p||s.$uQ.stop(c,!0),this._action.enabled&&c.button===0&&u.classList.add("active")})),y.$j&&this.B((0,s.$zP)(u,s.$sQ.CONTEXT_MENU,c=>{c.button===0&&c.ctrlKey===!0&&this.onClick(c)})),this.B((0,s.$zP)(u,s.$sQ.CLICK,c=>{s.$uQ.stop(c,!0),this.m&&this.m.isMenu||this.onClick(c)})),this.B((0,s.$zP)(u,s.$sQ.DBLCLICK,c=>{s.$uQ.stop(c,!0)})),[s.$sQ.MOUSE_UP,s.$sQ.MOUSE_OUT].forEach(c=>{this.B((0,s.$zP)(u,c,f=>{s.$uQ.stop(f),u.classList.remove("active")}))})}onClick($,u=!1){s.$uQ.stop($,!0);const p=I.$Qf(this._context)?this.m?.useEventAsContext?$:{preserveFocus:u}:this._context;this.actionRunner.run(this._action,p)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable($){this.element&&(this.element.tabIndex=$?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const $=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update($):(this.f=(0,E.$rR)(this.m.hoverDelegate,this.element,$),this.q.add(this.f))):this.element.title=$}F(){if(this.element){const $=this.C()??"";this.element.setAttribute("aria-label",$)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$kS=a;class e extends a{constructor($,u,p){super($,u,p),this.m=p,this.m.icon=p.icon!==void 0?p.icon:!1,this.m.label=p.label!==void 0?p.label:!0,this.L=""}render($){super.render($),I.$Rf(this.element);const u=document.createElement("a");if(u.classList.add("action-label"),u.setAttribute("role",this.M()),this.I=u,this.element.appendChild(u),this.m.label&&this.m.keybinding){const p=document.createElement("span");p.classList.add("keybinding"),p.textContent=this.m.keybinding,this.element.appendChild(p)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===b.$Li.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable($){this.I&&(this.I.tabIndex=$?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let $=null;return this.action.tooltip?$=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&($=this.action.label,this.m.keybinding&&($=o.localize(0,null,$,this.m.keybinding))),$??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const $=this.C()??"";this.I.setAttribute("aria-label",$)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$lS=e;class r extends a{constructor($,u,p,c,f,h,F){super($,u),this.b=new k.$eS(p,c,f,h,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions($,u){this.b.setOptions($,u)}select($){this.b.select($)}g(){this.B(this.b.onDidSelect($=>this.n($.selected,$.index)))}n($,u){this.actionRunner.run(this._action,this.r($,u))}r($,u){return $}setFocusable($){this.b.setFocusable($)}focus(){this.b?.focus()}blur(){this.b?.blur()}render($){this.b.render($)}}t.$mS=r}),define(be[64],pe([1,0,3,14,63,36,4,2,7,52]),function(ie,t,A,P,s,U,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=t.$sR=t.ActionsOrientation=void 0;var w;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class y extends k.$Tc{constructor(a,e={}){super(),this.g=this.B(new k.$Sc),this.r=this.B(new k.$3c),this.w=!1,this.y=!0,this.C=this.B(new E.$Ud),this.onDidBlur=this.C.event,this.D=this.B(new E.$Ud({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new E.$Ud),this.onDidRun=this.G.event,this.H=this.B(new E.$Ud),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$Ki,this.g.add(this.f)),this.g.add(this.f.onDidRun($=>this.G.fire($))),this.g.add(this.f.onWillRun($=>this.H.fire($))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let r,d;switch(this.m){case 0:r=[15],d=[17];break;case 1:r=[16],d=[18],this.domNode.className+=" vertical";break}this.B(A.$zP(this.domNode,A.$sQ.KEY_DOWN,$=>{const u=new P.$wP($);let p=!0;const c=typeof this.t=="number"?this.viewItems[this.t]:void 0;r&&(u.equals(r[0])||u.equals(r[1]))?p=this.P():d&&(u.equals(d[0])||u.equals(d[1]))?p=this.O():u.equals(9)&&this.F?this.D.fire():u.equals(14)?p=this.M():u.equals(13)?p=this.N():u.equals(2)&&c instanceof s.$kS&&c.trapsArrowNavigation?p=this.O():this.J(u)?this.n.keyDown?this.R(u):this.w=!0:p=!1,p&&(u.preventDefault(),u.stopPropagation())})),this.B(A.$zP(this.domNode,A.$sQ.KEY_UP,$=>{const u=new P.$wP($);this.J(u)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(u)),u.preventDefault(),u.stopPropagation()):(u.equals(2)||u.equals(1026)||u.equals(16)||u.equals(18)||u.equals(15)||u.equals(17))&&this.L()})),this.u=this.B(A.$xQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(A.$_P()===this.domNode||!A.$4P(A.$_P(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(r=>r instanceof s.$kS&&r.isEnabled());e instanceof s.$kS&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof s.$kS&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(r=>{e=e||a.equals(r)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(A.$4P(A.$_P(),e)){this.t=a,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const r=Array.isArray(a)?a:[a];let d=b.$Lf(e.index)?e.index:null;r.forEach($=>{const u=document.createElement("li");u.className="action-item",u.setAttribute("role","presentation");let p;const c={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(p=this.b.actionViewItemProvider($,c)),p||(p=new s.$lS(this.context,$,c)),this.b.allowContextMenu||this.r.set(p,A.$zP(u,A.$sQ.CONTEXT_MENU,f=>{A.$uQ.stop(f,!0)})),p.actionRunner=this.f,p.setActionContext(this.context),p.render(u),this.y&&p instanceof s.$kS&&this.viewItems.length===0&&p.setFocusable(!0),d===null||d<0||d>=this.z.children.length?(this.z.appendChild(u),this.viewItems.push(p)):(this.z.insertBefore(u,this.z.children[d]),this.viewItems.splice(d,0,p),d++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,k.$Oc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,k.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),A.$yP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,r;if(a===void 0?e=!0:typeof a=="number"?r=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const d=this.viewItems.findIndex($=>$.isEnabled());this.t=d===-1?void 0:d,this.Q(void 0,void 0,!0)}else r!==void 0&&(this.t=r),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let r;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,r=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===U.$Li.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let r;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}r=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===U.$Li.ID));return this.Q(!0),!0}Q(a,e,r=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const d=this.t!==void 0?this.viewItems[this.t]:void 0;if(d){let $=!0;b.$Vf(d.focus)||($=!1),this.b.focusOnlyEnabledItems&&b.$Vf(d.isEnabled)&&!d.isEnabled()&&($=!1),d.action.id===U.$Li.ID&&($=!1),$?(r||this.s!==this.t)&&(d.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),$&&d.showHover?.()}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof s.$kS){const r=e._context===null||e._context===void 0?a:e._context;this.run(e._action,r)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,k.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$sR=y;function I(o){if(!o.length)return o;let a=-1;for(let r=0;r<o.length;r++)if(o[r].id!==U.$Li.ID){a=r;break}if(a===-1)return[];o=o.slice(a);for(let r=o.length-1;r>=0&&o[r].id===U.$Li.ID;r--)o.splice(r,1);let e=!1;for(let r=o.length-1;r>=0;r--){const d=o[r].id===U.$Li.ID;d&&!e?o.splice(r,1):d?d&&(e=!1):e=!0}return o}t.$tR=I}),define(be[65],pe([1,0,3,22,55,64,57,60,20,4,82,51,109,97]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4S=t.$3S=t.$2S=t.MessageType=void 0;const a=A.$;var e;(function($){$[$.INFO=1]="INFO",$[$.WARNING=2]="WARNING",$[$.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$2S={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class r extends b.$aR{constructor(u,p,c){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new w.$Ud),this.onDidChange=this.O.event,this.P=this.B(new w.$Ud),this.onDidHeightChange=this.P.event,this.a=p,this.g=c,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=A.$zQ(u,a(".monaco-inputbox.idle"));const f=this.g.flexibleHeight?"textarea":"input",h=A.$zQ(this.element,a(".ibwrapper"));if(this.b=A.$zQ(h,a(f+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=A.$zQ(h,a("div.mirror")),this.y.innerText="\xA0",this.N=new k.$kR(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),A.$zQ(u,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const F=this.B(new P.$AR(u.ownerDocument,"selectionchange")),M=w.Event.filter(F.event,()=>u.ownerDocument.getSelection()?.anchorNode===h);this.B(M(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$sR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(u){this.n=u,this.b.setAttribute("placeholder",u)}setTooltip(u){this.r=u,this.b.title=u}setAriaLabel(u){this.s=u,u?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(u){this.b.value!==u&&(this.b.value=u,this.Y())}get step(){return this.b.step}set step(u){this.b.step=u}get height(){return typeof this.J=="number"?this.J:A.$2P(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return A.$aQ(this.b)}select(u=null){this.b.select(),u&&(this.b.setSelectionRange(u.start,u.end),u.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(u){u?this.enable():this.disable()}get width(){return A.$XP(this.b)}set width(u){if(this.g.flexibleHeight&&this.g.flexibleWidth){let p=0;if(this.y){const c=parseFloat(this.y.style.paddingLeft||"")||0,f=parseFloat(this.y.style.paddingRight||"")||0;p=c+f}this.b.style.width=u-p+"px"}else this.b.style.width=u+"px";this.y&&(this.y.style.width=u+"px")}set paddingRight(u){this.b.style.width=`calc(100% - ${u}px)`,this.y&&(this.y.style.paddingRight=u+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const u=this.L,p=this.J,c=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:u,height:p}),this.N.setScrollPosition({scrollTop:c})}showMessage(u,p){if(this.w==="open"&&(0,I.$yn)(this.h,u))return;this.h=u,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(u.type));const c=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${A.$RQ(c.border,"transparent")}`,this.h.content&&(this.hasFocus()||p)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let u=null;return this.t&&(u=this.t(this.value),u?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(u)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),u?.type}stylesForType(u){const p=this.g.inputBoxStyles;switch(u){case 1:return{border:p.inputValidationInfoBorder,background:p.inputValidationInfoBackground,foreground:p.inputValidationInfoForeground};case 2:return{border:p.inputValidationWarningBorder,background:p.inputValidationWarningBackground,foreground:p.inputValidationWarningForeground};default:return{border:p.inputValidationErrorBorder,background:p.inputValidationErrorBackground,foreground:p.inputValidationErrorForeground}}}U(u){switch(u){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let u;const p=()=>u.style.width=A.$XP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:f=>{if(!this.h)return null;u=A.$zQ(f,a(".monaco-inputbox-container")),p();const h={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,s.$yR)(this.h.content,h):(0,s.$xR)(this.h.content,h);F.classList.add(this.U(this.h.type));const M=this.stylesForType(this.h.type);return F.style.backgroundColor=M.background??"",F.style.color=M.foreground??"",F.style.border=M.border?`1px solid ${M.border}`:"",A.$zQ(u,F),null},onHide:()=>{this.w="closed"},layout:p});let c;this.h.type===3?c=o.localize(0,null,this.h.content):this.h.type===2?c=o.localize(1,null,this.h.content):c=o.localize(2,null,this.h.content),E.$CR(c),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const u=this.value,c=u.charCodeAt(u.length-1)===10?" ":"";(u+c).replace(/\u000c/g,"")?this.y.textContent=u+c:this.y.innerText="\xA0",this.layout()}ab(){const u=this.g.inputBoxStyles,p=u.inputBackground??"",c=u.inputForeground??"",f=u.inputBorder??"";this.element.style.backgroundColor=p,this.element.style.color=c,this.b.style.backgroundColor="inherit",this.b.style.color=c,this.element.style.border=`1px solid ${A.$RQ(f,"transparent")}`}layout(){if(!this.y)return;const u=this.L;this.L=A.$2P(this.y),u!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(u){const p=this.inputElement,c=p.selectionStart,f=p.selectionEnd,h=p.value;c!==null&&f!==null&&(this.value=h.substr(0,c)+u+h.substr(f),p.setSelectionRange(c+1,c+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$3S=r;class d extends r{constructor(u,p,c){const f=o.localize(3,null,"\u21C5"),h=o.localize(4,null,"\u21C5");super(u,p,c),this.db=this.B(new w.$Ud),this.onDidFocus=this.db.event,this.eb=this.B(new w.$Ud),this.onDidBlur=this.eb.event,this.bb=new y.$ZS(c.history,100);const F=()=>{if(c.showHistoryHint&&c.showHistoryHint()&&!this.n.endsWith(f)&&!this.n.endsWith(h)&&this.bb.getHistory().length){const M=this.n.endsWith(")")?f:h,R=this.n+M;c.showPlaceholderOnFocus&&!A.$aQ(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((M,R)=>{M.forEach(O=>{O.target.textContent||F()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const M=R=>{if(this.n.endsWith(R)){const O=this.n.slice(0,this.n.length-R.length);return c.showPlaceholderOnFocus?this.n=O:this.setPlaceHolder(O),!0}else return!1};M(h)||M(f)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(u){this.value&&(u||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(u){const p=this.getHistory();this.clearHistory(),u.forEach(c=>{this.bb.add(c)}),p.forEach(c=>{this.bb.add(c)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let u=this.jb();u&&(u=u===this.value?this.jb():u),this.value=u??"",E.$DR(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let u=this.ib();u&&(u=u===this.value?this.ib():u),u&&(this.value=u,E.$DR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(u){super.setPlaceHolder(u),this.setTooltip(u)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let u=this.bb.current();return u||(u=this.bb.last(),this.bb.next()),u}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$4S=d}),define(be[66],pe([1,0,63,20,17,18,4,3,102]),function(ie,t,A,P,s,U,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jS=t.$iS=t.$hS=t.$gS=t.$fS=void 0,t.$fS={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class b extends A.$kS{constructor(a,e,r){super(a,e,r),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:r.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:r.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:r.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(a){this.element=a,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(a){this.a.domNode.tabIndex=a?0:-1}}t.$gS=b;class w extends P.$aR{constructor(a){super(),this.a=this.B(new E.$Ud),this.onChange=this.a.event,this.b=this.B(new E.$Ud),this.onKeyDown=this.b.event,this.c=a,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,r=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),r.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,r=>{if(r.keyCode===10||r.keyCode===3){this.checked=!this.s,this.a.fire(!0),r.preventDefault(),r.stopPropagation();return}this.b.fire(r)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(a){this.s=a,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(a){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=a,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(a){this.domNode.title=a,this.domNode.setAttribute("aria-label",a)}}t.$hS=w;class y extends P.$aR{constructor(a,e,r){super(),this.g=a,this.h=e,this.a=this.B(new E.$Ud),this.onChange=this.a.event,this.b=new w({title:this.g,isChecked:this.h,icon:s.$$j.check,actionClassName:"monaco-checkbox",...t.$fS}),this.domNode=this.b.domNode,this.c=r,this.n(),this.B(this.b.onChange(d=>{this.n(),this.a.fire(d)}))}get checked(){return this.b.checked}set checked(a){this.b.checked=a,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,k.$aQ)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$iS=y;class I extends A.$kS{constructor(a,e,r){super(a,e,r),this.a=this.B(new y(this._action.label,!!this._action.checked,r.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(a){if(this.element=a,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,k.$)("span.checkbox-label",void 0,this._action.label));this.B((0,k.$zP)(e,k.$sQ.CLICK,r=>{this.a.checked=!this.a.checked,r.stopPropagation(),r.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(a){this.a.domNode.tabIndex=a?0:-1}}t.$jS=I}),define(be[130],pe([1,0,66,17,107]),function(ie,t,A,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=t.$dT=t.$cT=void 0;const U=s.localize(0,null),E=s.localize(1,null),k=s.localize(2,null);class b extends A.$hS{constructor(o){super({icon:P.$$j.caseSensitive,title:U+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$cT=b;class w extends A.$hS{constructor(o){super({icon:P.$$j.wholeWord,title:E+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$dT=w;class y extends A.$hS{constructor(o){super({icon:P.$$j.regex,title:k+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$eT=y}),define(be[131],pe([1,0,3,130,65,20,4,106,2,96]),function(ie,t,A,P,s,U,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fT=void 0;const w=k.localize(0,null);class y extends U.$aR{static{this.OPTION_CHANGE="optionChange"}constructor(o,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Uc),this.N=[],this.O=this.B(new E.$Ud),this.onDidOptionChange=this.O.event,this.P=this.B(new E.$Ud),this.onKeyDown=this.P.event,this.Q=this.B(new E.$Ud),this.onMouseDown=this.Q.event,this.R=this.B(new E.$Ud),this.onInput=this.R.event,this.S=this.B(new E.$Ud),this.onKeyUp=this.S.event,this.U=this.B(new E.$Ud),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new E.$Ud),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||w,this.h=!!e.showCommonFindToggles;const r=e.appendCaseSensitiveLabel||"",d=e.appendWholeWordsLabel||"",$=e.appendRegexLabel||"",u=e.history||[],p=!!e.flexibleHeight,c=!!e.flexibleWidth,f=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new s.$4S(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:u,showHistoryHint:e.showHistoryHint,flexibleHeight:p,flexibleWidth:c,flexibleMaxHeight:f,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new P.$eT({appendTitle:$,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new P.$dT({appendTitle:d,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new P.$cT({appendTitle:r,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const h=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const M=h.indexOf(this.domNode.ownerDocument.activeElement);if(M>=0){let R=-1;F.equals(17)?R=(M+1)%h.length:F.equals(15)&&(M===0?R=h.length-1:R=M-1),F.equals(9)?(h[M].blur(),this.inputBox.focus()):R>=0&&h[R].focus(),A.$uQ.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),o?.appendChild(this.domNode),this.B(A.$zP(this.inputBox.inputElement,"compositionstart",h=>{this.s=!0})),this.B(A.$zP(this.inputBox.inputElement,"compositionend",h=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,h=>this.P.fire(h)),this.C(this.inputBox.inputElement,h=>this.S.fire(h)),this.D(this.inputBox.inputElement,h=>this.R.fire()),this.j(this.inputBox.inputElement,h=>this.Q.fire(h))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(o){this.inputBox.layout(),this.X(o.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const o of this.N)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const o of this.N)o.disable()}setFocusInputOnOptionClick(o){this.n=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new b.$Sc;for(const a of o??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(o=!1){o?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(o){this.M&&(this.M.checked=o)}getWholeWords(){return this.L?.checked??!1}setWholeWords(o){this.L&&(this.L.checked=o)}getRegex(){return this.J?.checked??!1}setRegex(o){this.J&&(this.J.checked=o,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$fT=y}),define(be[132],pe([1,0,3,22,14,64,131,65,61,39,66,58,26,36,12,9,17,18,32,4,34,2,46,7,111,103]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o,a,e,r,d,$,u,p,c,f,h,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QT=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$PT=t.$OT=t.$NT=t.RenderIndentGuides=t.$MT=t.$LT=void 0;class R extends b.$KR{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(n=>n.element)),this.c=i}}function O(m){return m instanceof b.$KR?new R(m):m}class v{constructor(i,n){this.d=i,this.f=n,this.b=f.$Tc.None,this.c=new f.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,n){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(l=>l.element),n)}onDragStart(i,n){this.f.onDragStart?.(O(i),n)}onDragOver(i,n,l,D,S,z=!0){const T=this.f.onDragOver(O(i),n&&n.element,l,D,S),H=this.a!==n;if(H&&(this.b.dispose(),this.a=n),typeof n>"u")return T;if(H&&typeof T!="boolean"&&T.autoExpand&&(this.b=(0,r.$7g)(()=>{const $e=this.d(),ue=$e.getNodeLocation(n);$e.isCollapsed(ue)&&$e.setCollapsed(ue,!1),this.a=void 0},500,this.c)),typeof T=="boolean"||!T.accept||typeof T.bubble>"u"||T.feedback){if(!z){const $e=typeof T=="boolean"?T:T.accept,ue=typeof T=="boolean"?void 0:T.effect;return{accept:$e,effect:ue,feedback:[l]}}return T}if(T.bubble===1){const $e=this.d(),ue=$e.getNodeLocation(n),Fe=$e.getParentNodeLocation(ue),ye=$e.getNode(Fe),Oe=Fe&&$e.getListIndex(Fe);return this.onDragOver(i,ye,Oe,D,S,!1)}const G=this.d(),ne=G.getNodeLocation(n),he=G.getListIndex(ne),ve=G.getListRenderCount(ne);return{...T,feedback:(0,e.$Sb)(he,he+ve)}}drop(i,n,l,D,S){this.b.dispose(),this.a=void 0,this.f.drop(O(i),n&&n.element,l,D,S)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function C(m,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(n){return i.identityProvider.getId(n.element)}},dnd:i.dnd&&new v(m,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(n){return i.multipleSelectionController.isSelectionSingleChangeEvent({...n,element:n.element})},isSelectionRangeChangeEvent(n){return i.multipleSelectionController.isSelectionRangeChangeEvent({...n,element:n.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(n){const l=m(),D=l.getNodeLocation(n),S=l.getParentNodeLocation(D);return l.getNode(S).visibleChildrenCount},getPosInSet(n){return n.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?n=>i.accessibilityProvider.isChecked(n.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?n=>i.accessibilityProvider.getRole(n.element):()=>"treeitem",getAriaLabel(n){return i.accessibilityProvider.getAriaLabel(n.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?n=>i.accessibilityProvider.getAriaLevel(n.element):n=>n.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(n=>i.accessibilityProvider.getActiveDescendantId(n.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(n){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(n.element)}}}}class q{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,n){this.a.setDynamicHeight?.(i.element,n)}}t.$LT=q;class j{static lift(i){return i instanceof j?i:new j(i)}static empty(i=0){return new j({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const n of i.expanded)this.expanded[n]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$MT=j;var N;(function(m){m.None="none",m.OnHover="onHover",m.Always="always"})(N||(t.RenderIndentGuides=N={}));class L{get elements(){return this.b}constructor(i,n=[]){this.b=n,this.a=new f.$Sc,this.onDidChange=p.Event.forEach(i,l=>this.b=l,this.a)}dispose(){this.a.dispose()}}class B{static{this.a=8}constructor(i,n,l,D,S,z={}){this.o=i,this.p=n,this.q=D,this.s=S,this.b=new Map,this.c=new Map,this.d=B.a,this.f=!1,this.g=!1,this.j=new Set,this.k=f.$Tc.None,this.m=new f.$Sc,this.templateId=i.templateId,this.updateOptions(z),p.Event.map(l,T=>T.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const n=(0,h.$6l)(i.indent,0,40);if(n!==this.d){this.d=n;for(const[l,D]of this.c)this.v(l,D)}}if(typeof i.renderIndentGuides<"u"){const n=i.renderIndentGuides!==N.None;if(n!==this.g){this.g=n;for(const[l,D]of this.c)this.w(l,D);if(this.k.dispose(),n){const l=new f.$Sc;this.q.onDidChange(this.x,this,l),this.k=l,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const n=(0,A.$zQ)(i,(0,A.$)(".monaco-tl-row")),l=(0,A.$zQ)(n,(0,A.$)(".monaco-tl-indent")),D=(0,A.$zQ)(n,(0,A.$)(".monaco-tl-twistie")),S=(0,A.$zQ)(n,(0,A.$)(".monaco-tl-contents")),z=this.o.renderTemplate(S);return{container:i,indent:l,twistie:D,indentGuidesDisposable:f.$Tc.None,templateData:z}}renderElement(i,n,l,D){this.c.set(i,l),this.b.set(i.element,i),this.v(i,l),this.o.renderElement(i,n,l.templateData,D)}disposeElement(i,n,l,D){l.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,n,l.templateData,D),typeof D=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const n=this.b.get(i);n&&this.u(n)}u(i){const n=this.c.get(i);n&&(this.x(this.q.elements),this.v(i,n))}v(i,n){const l=B.a+(i.depth-1)*this.d;n.twistie.style.paddingLeft=`${l}px`,n.indent.style.width=`${l+this.d-16}px`,i.collapsible?n.container.setAttribute("aria-expanded",String(!i.collapsed)):n.container.removeAttribute("aria-expanded"),n.twistie.classList.remove(...$.ThemeIcon.asClassNameArray(d.$$j.treeItemExpanded));let D=!1;this.o.renderTwistie&&(D=this.o.renderTwistie(i.element,n.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(D||n.twistie.classList.add(...$.ThemeIcon.asClassNameArray(d.$$j.treeItemExpanded)),n.twistie.classList.add("collapsible"),n.twistie.classList.toggle("collapsed",i.collapsed)):n.twistie.classList.remove("collapsible","collapsed"),this.w(i,n)}w(i,n){if((0,A.$yP)(n.indent),n.indentGuidesDisposable.dispose(),!this.g)return;const l=new f.$Sc,D=this.p();for(;;){const S=D.getNodeLocation(i),z=D.getParentNodeLocation(S);if(!z)break;const T=D.getNode(z),H=(0,A.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(T)&&H.classList.add("active"),n.indent.childElementCount===0?n.indent.appendChild(H):n.indent.insertBefore(H,n.indent.firstElementChild),this.s.add(T,H),l.add((0,f.$Rc)(()=>this.s.delete(T,H))),i=T}n.indentGuidesDisposable=l}x(i){if(!this.g)return;const n=new Set,l=this.p();i.forEach(D=>{const S=l.getNodeLocation(D);try{const z=l.getParentNodeLocation(S);D.collapsible&&D.children.length>0&&!D.collapsed?n.add(D):z&&n.add(l.getNode(z))}catch{}}),this.j.forEach(D=>{n.has(D)||this.s.forEach(D,S=>S.classList.remove("active"))}),n.forEach(D=>{this.j.has(D)||this.s.forEach(D,S=>S.classList.add("active"))}),this.j=n}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,f.$Oc)(this.m)}}t.$NT=B;class Y{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,n,l){this.g=i,this.j=n,this.k=l,this.a=0,this.b=0,this.c="",this.d="",this.f=new f.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,n){let l=1;if(this.k){const z=this.k.filter(i,n);if(typeof z=="boolean"?l=z?1:0:(0,I.$IT)(z)?l=(0,I.$JT)(z.visibility):l=z,l===0)return!1}if(this.a++,!this.c)return this.b++,{data:c.FuzzyScore.Default,visibility:l};const D=this.j.getKeyboardNavigationLabel(i),S=Array.isArray(D)?D:[D];for(const z of S){const T=z&&z.toString();if(typeof T>"u")return{data:c.FuzzyScore.Default,visibility:l};let H;if(this.g.findMatchType===me.Contiguous){const G=T.toLowerCase().indexOf(this.d);if(G>-1){H=[Number.MAX_SAFE_INTEGER,0];for(let ne=this.d.length;ne>0;ne--)H.push(G+ne-1)}}else H=(0,c.$6j)(this.c,this.d,0,T,T.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return this.b++,S.length===1?{data:H,visibility:l}:{data:{label:T,score:H},visibility:l}}return this.g.findMode===ee.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:c.FuzzyScore.Default,visibility:l}}m(){this.a=0,this.b=0}dispose(){(0,f.$Oc)(this.f)}}class X extends y.$hS{constructor(i){super({icon:d.$$j.listFilter,title:(0,M.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$OT=X;class de extends y.$hS{constructor(i){super({icon:d.$$j.searchFuzzy,title:(0,M.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$PT=de;const oe={inputBoxStyles:k.$2S,toggleStyles:y.$fS,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ee;(function(m){m[m.Highlight=0]="Highlight",m[m.Filter=1]="Filter"})(ee||(t.TreeFindMode=ee={}));var me;(function(m){m[m.Fuzzy=0]="Fuzzy",m[m.Contiguous=1]="Contiguous"})(me||(t.TreeFindMatchType=me={}));class Te extends f.$Tc{set mode(i){this.b.checked=i===ee.Filter,this.f.inputBox.setPlaceHolder(i===ee.Filter?(0,M.localize)(2,null):(0,M.localize)(3,null))}set matchType(i){this.c.checked=i===me.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,n,l,D,S,z){super(),this.t=n,this.a=(0,A.h)(".monaco-tree-type-filter",[(0,A.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,A.h)(".monaco-tree-type-filter-input@findInput"),(0,A.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new p.$Ud,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,f.$Rc)(()=>i.removeChild(this.a.root)));const T=z?.styles??oe;T.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=T.listFilterWidgetBackground),T.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${T.listFilterWidgetShadow}`),this.b=this.B(new X({...T.toggleStyles,isChecked:D===ee.Filter})),this.c=this.B(new de({...T.toggleStyles,isChecked:S===me.Fuzzy})),this.onDidChangeMode=p.Event.map(this.b.onChange,()=>this.b.checked?ee.Filter:ee.Highlight,this.q),this.onDidChangeMatchType=p.Event.map(this.c.onChange,()=>this.c.checked?me.Fuzzy:me.Contiguous,this.q),this.f=this.B(new E.$fT(this.a.findInput,l,{label:(0,M.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:T.inputBoxStyles,toggleStyles:T.toggleStyles,history:z?.history})),this.g=this.B(new U.$sR(this.a.actionbar)),this.mode=D;const H=this.B(new P.$AR(this.f.inputBox.inputElement,"keydown")),G=p.Event.chain(H.event,$e=>$e.map(ue=>new s.$wP(ue)));this.B(G($e=>{if($e.equals(3)){$e.preventDefault(),$e.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if($e.equals(18)){$e.preventDefault(),$e.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if($e.equals(16)){$e.preventDefault(),$e.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const ne=this.B(new a.$Ji("close",(0,M.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(ne,{icon:!0,label:!1});const he=this.B(new P.$AR(this.a.grab,"mousedown"));this.B(he.event($e=>{const ue=new f.$Sc,Fe=ue.add(new P.$AR((0,A.getWindow)($e),"mousemove")),ye=ue.add(new P.$AR((0,A.getWindow)($e),"mouseup")),Oe=this.m,Be=$e.pageX,Ie=this.s,Je=$e.pageY;this.a.grab.classList.add("grabbing");const et=this.a.root.style.transition;this.a.root.style.transition="unset";const Qe=x=>{const se=x.pageX-Be;this.m=Oe-se;const ge=x.pageY-Je;this.s=Ie+ge,this.layout()};ue.add(Fe.event(Qe)),ue.add(ye.event(x=>{Qe(x),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=et,ue.dispose()}))}));const ve=p.Event.chain(this.B(new P.$AR(this.a.grab,"keydown")).event,$e=>$e.map(ue=>new s.$wP(ue)));this.B(ve($e=>{let ue,Fe;if($e.keyCode===15?ue=Number.POSITIVE_INFINITY:$e.keyCode===17?ue=0:$e.keyCode===10&&(ue=this.m===0?Number.POSITIVE_INFINITY:0),$e.keyCode===16?Fe=0:$e.keyCode===18&&(Fe=Number.POSITIVE_INFINITY),ue!==void 0&&($e.preventDefault(),$e.stopPropagation(),this.m=ue,this.layout()),Fe!==void 0){$e.preventDefault(),$e.stopPropagation(),this.s=Fe;const ye=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ye},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,h.$6l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,h.$6l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,r.$6g)(300),super.dispose()}}class Ne{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,n,l,D,S,z={}){this.t=i,this.u=l,this.v=D,this.w=S,this.x=z,this.b="",this.c="",this.j=0,this.k=new p.$Ud,this.onDidChangeMode=this.k.event,this.m=new p.$Ud,this.onDidChangeMatchType=this.m.event,this.o=new p.$Ud,this.onDidChangePattern=this.o.event,this.p=new p.$Ud,this.onDidChangeOpenState=this.p.event,this.q=new f.$Sc,this.s=new f.$Sc,this.d=i.options.defaultFindMode??ee.Highlight,this.f=i.options.defaultFindMatchType??me.Fuzzy,n.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Te(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,l=>!c.FuzzyScore.isDefault(l.filterData));const n=this.t.getFocus();if(n.length>0){const l=n[0];this.t.getRelativeTop(l)===null&&this.t.reveal(l,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,M.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!c.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Me(m,i){return m.position===i.position&&m.node.element===i.node.element&&m.startIndex===i.startIndex&&m.height===i.height&&m.endIndex===i.endIndex}class re extends f.$Tc{constructor(i=[]){super(),this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Me)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const n=this.stickyNodes[this.count-2];return n.position+n.height!==i.position}addDisposable(i){this.B(i)}}class J extends f.$Tc{get f(){const i=this.m.firstVisibleIndex;if(!(i<0||i>=this.m.length))return this.m.element(i)}constructor(i,n,l,D,S,z={}){super(),this.g=i,this.j=n,this.m=l,this.s=S,this.b=.4;const T=this.validateStickySettings(z);this.a=T.stickyScrollMaxItemCount,this.c=this.B(new le(l.getScrollableElement(),l,n,D,S,z.accessibilityProvider)),this.onDidChangeHasFocus=this.c.onDidChangeHasFocus,this.onContextMenu=this.c.onContextMenu,this.B(l.onDidScroll(()=>this.t())),this.B(l.onDidChangeContentHeight(()=>this.t())),this.B(i.onDidChangeCollapseState(()=>this.t())),this.t()}get height(){return this.c.height}get count(){return this.c.count}getNode(i){return this.c.getNode(i)}t(){const i=this.f;if(!i||this.g.scrollTop===0){this.c.setState(void 0);return}const n=this.u(i);this.c.setState(n)}u(i){const n=[],l=this.m.renderHeight*this.b;let D=i,S=0,z=this.y(D,void 0,S);for(;z&&S+z.height<l&&(n.push(z),S+=z.height,!(n.length>=this.a||(D=this.w(D),!D)));)z=this.y(D,z.node,S);return n.length?new re(n):void 0}w(i){const n=this.I(i);return n===-1||n===this.m.length-1?void 0:this.m.element(n+1)}y(i,n,l){const D=this.D(i,n);if(D&&!(D===i&&(!this.H(i)||this.z(i,l))))return this.C(D,l)}z(i,n){const l=this.I(i),D=this.m.getElementTop(l),S=n;return this.m.scrollTop===D-S}C(i,n){const l=this.s.getHeight(i),{startIndex:D,endIndex:S}=this.J(i),z=this.F(S,n);return{node:i,position:z,height:l,startIndex:D,endIndex:S}}D(i,n=void 0){let l=i,D=this.G(l);for(;D;){if(D===n)return l;l=D,D=this.G(l)}if(n===void 0)return l}F(i,n){let l=this.m.getRelativeTop(i);if(l===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const H=this.s.getHeight(this.m.element(i)),G=this.m.getRelativeTop(i+1);l=G?G-H/this.m.renderHeight:null}if(l===null)return n;const D=this.m.element(i),S=this.s.getHeight(D),z=l*this.m.renderHeight,T=z+S;return n>z&&n<=T?z:n}G(i){const n=this.j.getNodeLocation(i),l=this.j.getParentNodeLocation(n);return l?this.j.getNode(l):void 0}H(i){const n=this.j.getNodeLocation(i);return this.j.getListRenderCount(n)>1}I(i,n){return n===void 0&&(n=this.j.getNodeLocation(i)),this.j.getListIndex(n)}J(i){const n=this.j.getNodeLocation(i),l=this.j.getListIndex(n);if(l<0)throw new Error("Node not found in tree");const D=this.j.getListRenderCount(n),S=l+D-1;return{startIndex:l,endIndex:S}}nodePositionTopBelowWidget(i){const n=[];let l=this.G(i);for(;l;)n.push(l),l=this.G(l);let D=0;for(let S=0;S<n.length&&S<this.a;S++)D+=this.s.getHeight(n[S]);return D}getFocus(){return this.c.getFocus()}domFocus(){this.c.domFocus()}focusedLast(){return this.c.focusedLast()}updateOptions(i={}){const n=this.validateStickySettings(i);this.a!==n.stickyScrollMaxItemCount&&(this.a=n.stickyScrollMaxItemCount,this.t())}validateStickySettings(i){let n=5;return typeof i.stickyScrollMaxItemCount=="number"&&(n=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:n}}}class le{constructor(i,n,l,D,S,z){this.d=n,this.f=l,this.g=D,this.j=S,this.k=z,this.a=document.createElement("div"),this.a.classList.add("monaco-tree-sticky-container"),i.appendChild(this.a),this.c=new K(this.a,n),this.onDidChangeHasFocus=this.c.onDidChangeHasFocus,this.onContextMenu=this.c.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(n=>n.node===i)}setState(i){const n=!!this.b&&this.b.count>0,l=!!i&&i.count>0;if(!n&&!l||n&&l&&this.b.equal(i)||(n!==l&&this.p(l),this.b?.dispose(),this.b=i,!l))return;const D=Array(i.count);for(let T=i.count-1;T>=0;T--){const H=i.stickyNodes[T],{element:G,disposable:ne}=this.m(H,T,i.count);D[T]=G,this.a.appendChild(G),i.addDisposable(ne)}this.c.updateElements(D,i);const S=(0,A.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(S),i.addDisposable((0,f.$Rc)(()=>S.remove()));const z=i.stickyNodes[i.count-1];this.a.style.height=`${z.position+z.height}px`}m(i,n,l){const D=this.f.getNodeLocation(i.node),S=this.f.getListIndex(D),z=document.createElement("div");z.style.top=`${i.position}px`,z.style.height=`${i.height}px`,z.style.lineHeight=`${i.height}px`,z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${S}`),z.setAttribute("data-parity",S%2===0?"even":"odd"),z.setAttribute("id",this.d.getElementID(S)),this.o(z,i.node.element,n,l);const T=this.j.getTemplateId(i.node),H=this.g.find(ve=>ve.templateId===T);if(!H)throw new Error(`No renderer found for template id ${T}`);const G=new Proxy(i.node,{}),ne=H.renderTemplate(z);H.renderElement(G,i.startIndex,ne,i.height);const he=(0,f.$Rc)(()=>{H.disposeElement(G,i.startIndex,ne,i.height),H.disposeTemplate(ne),z.remove()});return{element:z,disposable:he}}o(i,n,l,D){if(!this.k)return;this.k.getSetSize&&i.setAttribute("aria-setsize",String(this.k.getSetSize(n,l,D))),this.k.getPosInSet&&i.setAttribute("aria-posinset",String(this.k.getPosInSet(n,l))),this.k.getRole&&i.setAttribute("role",this.k.getRole(n)??"treeitem");const S=this.k.getAriaLabel(n);S&&i.setAttribute("aria-label",S);const z=this.k.getAriaLevel&&this.k.getAriaLevel(n);typeof z=="number"&&i.setAttribute("aria-level",`${z}`),i.setAttribute("aria-selected",String(!1))}p(i){this.a.style.display=i?"block":"none",i||this.c.updateElements([],void 0)}getFocus(){return this.c.getFocus()}domFocus(){this.c.domFocus()}focusedLast(){return this.c.focusedLast()}dispose(){this.c.dispose(),this.b?.dispose(),this.a.remove()}}class K extends f.$Tc{get m(){return this.j}set m(i){this.j=i,this.f.fire(i)}constructor(i,n){super(),this.s=i,this.t=n,this.a=-1,this.b=[],this.f=new p.$Ud,this.onDidChangeHasFocus=this.f.event,this.g=new p.$Ud,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(l=>this.w(l))),this.B(this.t.onMouseDown(l=>this.y(l))),this.B(this.t.onContextMenu(l=>this.u(l)))}u(i){const n=i.browserEvent.target;if(!(0,w.$XR)(n)&&!(0,w.$WR)(n)){this.focusedLast()&&this.t.domFocus();return}if(!(0,A.$pQ)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const z=this.c.stickyNodes.findIndex(T=>T.node.element===i.element?.element);if(z===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(z);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const D=this.c.stickyNodes[this.a].node.element,S=this.b[this.a];this.g.fire({element:D,anchor:S,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const n=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([n]),this.C(n,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const n=i.browserEvent.target;!(0,w.$XR)(n)&&!(0,w.$WR)(n)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,n){if(n&&n.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(n&&n.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const l=this.a;if(this.D(),this.b=i,this.c=n,n){const D=(0,h.$6l)(l,0,n.count-1);this.F(D)}else this.m&&this.t.domFocus();this.s.tabIndex=n?0:-1}z(i){const n=this.c;if(!n)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<n.count-1)&&n.lastNodePartiallyVisible()){const l=n.stickyNodes[i];this.C(l.endIndex+1,n)}}C(i,n){const l=n.stickyNodes[n.count-1],D=n.count>1?n.stickyNodes[n.count-2]:void 0,S=this.t.getElementTop(i),z=D?D.position+D.height+l.height:l.height;this.t.scrollTop=S-z}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const n=this.a;n>=0&&this.G(this.b[n],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,n){i.classList.toggle("focused",n)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function W(m){let i=o.TreeMouseEventTarget.Unknown;return(0,A.$8P)(m.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=o.TreeMouseEventTarget.Twistie:(0,A.$8P)(m.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=o.TreeMouseEventTarget.Element:(0,A.$8P)(m.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=o.TreeMouseEventTarget.Filter),{browserEvent:m.browserEvent,element:m.element?m.element.element:null,target:i}}function Z(m){const i=(0,w.$XR)(m.browserEvent.target);return{element:m.element?m.element.element:null,browserEvent:m.browserEvent,anchor:m.anchor,isStickyScroll:i}}function ce(m,i){i(m),m.children.forEach(n=>ce(n,i))}class we{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,n){this.g=i,this.j=n,this.a=[],this.c=new p.$Ud,this.onDidChange=this.c.event}set(i,n){!n?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,n)}k(i,n,l){if(this.a=[...i],this.b=void 0,this.d=void 0,!n){const D=this;this.c.fire({get elements(){return D.get()},browserEvent:l})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:n}){if(!this.j){const H=this.m(),G=ne=>H.delete(ne);n.forEach(ne=>ce(ne,G)),this.set([...H.values()]);return}const l=new Set,D=H=>l.add(this.j.getId(H.element).toString());n.forEach(H=>ce(H,D));const S=new Map,z=H=>S.set(this.j.getId(H.element).toString(),H);i.forEach(H=>ce(H,z));const T=[];for(const H of this.a){const G=this.j.getId(H.element).toString();if(!l.has(G))T.push(H);else{const he=S.get(G);he&&he.visible&&T.push(he)}}if(this.a.length>0&&T.length===0){const H=this.g();H&&T.push(H)}this.k(T,!0)}m(){const i=new Set;for(const n of this.a)i.add(n);return i}}class Ae extends w.$3R{constructor(i,n,l){super(i),this.x=n,this.y=l}u(i){if((0,w.$YR)(i.browserEvent.target)||(0,w.$RR)(i.browserEvent.target)||(0,w.$SR)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const n=i.element;if(!n)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const l=i.browserEvent.target,D=l.classList.contains("monaco-tl-twistie")||l.classList.contains("monaco-icon-label")&&l.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,S=(0,w.$WR)(i.browserEvent.target);let z=!1;if(S?z=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?z=this.x.expandOnlyOnTwistieClick(n.element):z=!!this.x.expandOnlyOnTwistieClick,S)this.A(i,n);else{if(z&&!D&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(n.collapsible&&(!S||D)){const T=this.x.getNodeLocation(n),H=i.browserEvent.altKey;if(this.x.setFocus([T]),this.x.toggleCollapsed(T,H),z&&D){i.browserEvent.isHandledByList=!0;return}}S||super.u(i)}A(i,n){if((0,w.$TR)(i.browserEvent.target)||(0,w.$UR)(i.browserEvent.target))return;const l=this.y();if(!l)throw new Error("Sticky scroll controller not found");const D=this.k.indexOf(n),S=this.k.getElementTop(D),z=l.nodePositionTopBelowWidget(n);this.x.scrollTop=S-z,this.k.domFocus(),this.k.setFocus([D]),this.k.setSelection([D])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const n=i.browserEvent.target;if(!(0,w.$XR)(n)&&!(0,w.$WR)(n)){super.s(i);return}}t(i){const n=i.browserEvent.target;if(!(0,w.$XR)(n)&&!(0,w.$WR)(n)){super.t(i);return}}}class ke extends w.$6R{constructor(i,n,l,D,S,z,T,H){super(i,n,l,D,H),this.p=S,this.s=z,this.K=T}D(i){return new Ae(this,i.tree,i.stickyScrollProvider)}splice(i,n,l=[]){if(super.splice(i,n,l),l.length===0)return;const D=[],S=[];let z;l.forEach((T,H)=>{this.p.has(T)&&D.push(i+H),this.s.has(T)&&S.push(i+H),this.K.has(T)&&(z=i+H)}),D.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...D])),S.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...S])),typeof z=="number"&&super.setAnchor(z)}setFocus(i,n,l=!1){super.setFocus(i,n),l||this.p.set(i.map(D=>this.element(D)),n)}setSelection(i,n,l=!1){super.setSelection(i,n),l||this.s.set(i.map(D=>this.element(D)),n)}setAnchor(i,n=!1){super.setAnchor(i),n||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var Le;(function(m){m[m.Tree=0]="Tree",m[m.StickyScroll=1]="StickyScroll"})(Le||(t.AbstractTreePart=Le={}));class _{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return p.Event.map(this.j.onMouseClick,W)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.j.onMouseDblClick,W),i=>i.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return p.Event.any(p.Event.filter(p.Event.map(this.j.onContextMenu,Z),i=>!i.isStickyScroll),this.B?.onContextMenu??p.Event.None)}get onTap(){return p.Event.map(this.j.onTap,W)}get onPointer(){return p.Event.map(this.j.onPointer,W)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ee.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??me.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,n,l,D,S={}){this.G=i,this.H=S,this.y=new p.$3d,this.onDidChangeFindOpenState=p.Event.None,this.onDidChangeStickyScrollFocused=p.Event.None,this.D=new f.$Sc,this.E=new p.$Ud,this.onWillRefilter=this.E.event,this.F=new p.$Ud,this.onDidUpdateOptions=this.F.event,this.p=new q(l);const z=new p.$4d,T=new p.$4d,H=this.D.add(new L(T.event)),G=new u.$Gc;this.k=D.map(ue=>new B(ue,()=>this.o,z.event,H,G,S));for(const ue of this.k)this.D.add(ue);let ne;S.keyboardNavigationLabelProvider&&(ne=new Y(this,S.keyboardNavigationLabelProvider,S.filter),S={...S,filter:ne},this.D.add(ne)),this.q=new we(()=>this.j.getFocusedElements()[0],S.identityProvider),this.w=new we(()=>this.j.getSelectedElements()[0],S.identityProvider),this.x=new we(()=>this.j.getAnchorElement(),S.identityProvider),this.j=new ke(i,n,this.p,this.k,this.q,this.w,this.x,{...C(()=>this.o,S),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,S),z.input=this.o.onDidChangeCollapseState;const he=p.Event.forEach(this.o.onDidSplice,ue=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(ue),this.w.onDidModelSplice(ue)})},this.D);he(()=>null,null,this.D);const ve=this.D.add(new p.$Ud),$e=this.D.add(new r.$2g(0));if(this.D.add(p.Event.any(he,this.q.onDidChange,this.w.onDidChange)(()=>{$e.trigger(()=>{const ue=new Set;for(const Fe of this.q.getNodes())ue.add(Fe);for(const Fe of this.w.getNodes())ue.add(Fe);ve.fire([...ue.values()])})})),T.input=ve.event,S.keyboardSupport!==!1){const ue=p.Event.chain(this.j.onKeyDown,Fe=>Fe.filter(ye=>!(0,w.$RR)(ye.target)).map(ye=>new s.$wP(ye)));p.Event.chain(ue,Fe=>Fe.filter(ye=>ye.keyCode===15))(this.J,this,this.D),p.Event.chain(ue,Fe=>Fe.filter(ye=>ye.keyCode===17))(this.K,this,this.D),p.Event.chain(ue,Fe=>Fe.filter(ye=>ye.keyCode===10))(this.L,this,this.D)}if((S.findWidgetEnabled??!0)&&S.keyboardNavigationLabelProvider&&S.contextViewProvider){const ue=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Ne(this,this.o,this.j,ne,S.contextViewProvider,ue),this.A=Fe=>this.z.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;S.enableStickyScroll&&(this.B=new J(this,this.o,this.j,this.k,this.p,S),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,A.$hQ)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===N.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const n of this.k)n.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===N.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new J(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=p.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const n=this.o.getListIndex(i);n!==-1&&this.j.updateWidth(n)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,A.$aQ)(this.getHTMLElement())}layout(i,n){this.j.layout(i,n),(0,F.$Lf)(n)&&this.z?.layout(n)}style(i){const n=`.${this.j.domId}`,l=[];i.treeIndentGuidesStroke&&(l.push(`.monaco-list${n}:hover .monaco-tl-indent > .indent-guide, .monaco-list${n}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),l.push(`.monaco-list${n} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(l.push(`.monaco-list${n} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),l.push(`.monaco-list${n} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(l.push(`.monaco-list${n}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),l.push(`.monaco-list${n}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const D=(0,A.$RQ)(i.listFocusAndSelectionOutline,(0,A.$RQ)(i.listSelectionOutline,i.listFocusOutline??""));D&&(l.push(`.monaco-list${n}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${D}; outline-offset: -1px;}`),l.push(`.monaco-list${n}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(l.push(`.monaco-list${n}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),l.push(`.monaco-list${n}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),l.push(`.monaco-workbench.context-menu-visible .monaco-list${n}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),l.push(`.monaco-workbench.context-menu-visible .monaco-list${n}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=l.join(`
`),this.j.style(i)}getParentElement(i){const n=this.o.getParentNodeLocation(i);return this.o.getNode(n).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,n=!1){return this.o.setCollapsed(i,!0,n)}expand(i,n=!1){return this.o.setCollapsed(i,!1,n)}toggleCollapsed(i,n=!1){return this.o.setCollapsed(i,void 0,n)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,n){return this.o.setCollapsible(i,n)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const n=this.o.getNode(i);this.x.set([n]);const l=this.o.getListIndex(i);l>-1&&this.j.setAnchor(l,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,n){this.y.bufferEvents(()=>{const l=i.map(S=>this.o.getNode(S));this.w.set(l,n);const D=i.map(S=>this.o.getListIndex(S)).filter(S=>S>-1);this.j.setSelection(D,n,!0)})}getSelection(){return this.w.get()}setFocus(i,n){this.y.bufferEvents(()=>{const l=i.map(S=>this.o.getNode(S));this.q.set(l,n);const D=i.map(S=>this.o.getListIndex(S)).filter(S=>S>-1);this.j.setFocus(D,n,!0)})}focusNext(i=1,n=!1,l,D=(0,A.$pQ)(l)&&l.altKey?void 0:this.A){this.j.focusNext(i,n,l,D)}focusPrevious(i=1,n=!1,l,D=(0,A.$pQ)(l)&&l.altKey?void 0:this.A){this.j.focusPrevious(i,n,l,D)}focusNextPage(i,n=(0,A.$pQ)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,n)}focusPreviousPage(i,n=(0,A.$pQ)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,n)}focusLast(i,n=(0,A.$pQ)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,n)}focusFirst(i,n=(0,A.$pQ)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,n)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,n){this.o.expandTo(i);const l=this.o.getListIndex(i);if(l!==-1)if(!this.B)this.j.reveal(l,n);else{const D=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(l,n,D)}}getRelativeTop(i){const n=this.o.getListIndex(i);if(n===-1)return null;const l=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(n,l?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new o.$GT(this.G,"Can't get tree view state without an identity provider");const n=z=>i.getId(z).toString(),l=j.empty(this.scrollTop);for(const z of this.getFocus())l.focus.add(n(z));for(const z of this.getSelection())l.selection.add(n(z));const D=this.o.getNode(),S=[D];for(;S.length>0;){const z=S.shift();z!==D&&z.collapsible&&(l.expanded[n(z.element)]=z.collapsed?0:1),S.push(...z.children)}return l}J(i){i.preventDefault(),i.stopPropagation();const n=this.j.getFocusedElements();if(n.length===0)return;const l=n[0],D=this.o.getNodeLocation(l);if(!this.o.setCollapsed(D,!0)){const z=this.o.getParentNodeLocation(D);if(!z)return;const T=this.o.getListIndex(z);this.j.reveal(T),this.j.setFocus([T])}}K(i){i.preventDefault(),i.stopPropagation();const n=this.j.getFocusedElements();if(n.length===0)return;const l=n[0],D=this.o.getNodeLocation(l);if(!this.o.setCollapsed(D,!1)){if(!l.children.some(H=>H.visible))return;const[z]=this.j.getFocus(),T=z+1;this.j.reveal(T),this.j.setFocus([T])}}L(i){i.preventDefault(),i.stopPropagation();const n=this.j.getFocusedElements();if(n.length===0)return;const l=n[0],D=this.o.getNodeLocation(l),S=i.browserEvent.altKey;this.o.setCollapsed(D,void 0,S)}navigate(i){return new g(this.j,this.o,i)}dispose(){(0,f.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$QT=_;class g{constructor(i,n,l){this.b=i,this.c=n,l?this.a=this.c.getListIndex(l):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[133],pe([1,0,132,123,26,28]),function(ie,t,A,P,s,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2T=void 0;class E extends A.$QT{constructor(b,w,y,I,o,a={}){super(b,w,y,I,a),this.f=b,this.g=o,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(b,w){if(w&&!this.c)throw new s.$GT(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!w){this.m(b);return}const y=[],I=[],o=e=>{const r=this.c.getId(e).toString();return!w.expanded[r]},a=e=>{const r=this.c.getId(e.element).toString();w.focus.has(r)&&y.push(e.element),w.selection.has(r)&&I.push(e.element)};this.m(b,o,a),this.setFocus(y),this.setSelection(I),w&&typeof w.scrollTop=="number"&&(this.scrollTop=w.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new s.$GT(this.f,"Tree input not set");let w;this.c&&(w=y=>{const I=this.c.getId(y).toString(),o=this.d.get(I);if(o)return o.collapsed}),this.m(b,w)}resort(b=this.b,w=!0){this.o.resort(b===this.b?null:b,w)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,w,y){let I;if(this.c){const o=new Set,a=y;y=e=>{const r=this.c.getId(e.element).toString();o.add(r),this.d.set(r,e),a?.(e)},I=e=>{const r=this.c.getId(e.element).toString();o.has(r)||this.d.delete(r)}}this.o.setChildren(b===this.b?null:b,this.s(b,w).elements,{onDidCreateNode:y,onDidDeleteNode:I})}s(b,w){const y=[...this.g.getChildren(b)];return{elements:U.Iterable.map(y,o=>{const{elements:a,size:e}=this.s(o,w),r=this.g.hasChildren?this.g.hasChildren(o):void 0,d=e===0?void 0:w&&w(o);return{element:o,children:a,collapsible:r,collapsed:d}}),size:y.length}}M(b,w,y){return new P.$RT(b,w,y)}}t.$2T=E}),define(be[67],pe([1,0,12,9,33,29,27,6,4,2,53,10,7]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nh=t.ProxyChannel=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.RequestInitiator=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=void 0;var a;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(a||(a={}));function e(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var r;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(r||(r={}));function d(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})($||($={}));function u(re){let J=0;for(let le=0;;le+=7){const K=re.read(1);if(J|=(K.buffer[0]&127)<<le,!(K.buffer[0]&128))return J}}const p=M(0);function c(re,J){if(J===0){re.write(p);return}let le=0;for(let W=J;W!==0;W=W>>>7)le++;const K=s.$ie.alloc(le);for(let W=0;J!==0;W++)K.buffer[W]=J&127,J=J>>>7,J>0&&(K.buffer[W]|=128);re.write(K)}class f{constructor(J){this.b=J,this.a=0}read(J){const le=this.b.slice(this.a,this.a+J);return this.a+=le.byteLength,le}}t.$Ch=f;class h{constructor(){this.a=[]}get buffer(){return s.$ie.concat(this.a)}write(J){this.a.push(J)}}t.$Dh=h;var F;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(F||(F={}));function M(re){const J=s.$ie.alloc(1);return J.writeUInt8(re,0),J}const R={Undefined:M(F.Undefined),String:M(F.String),Buffer:M(F.Buffer),VSBuffer:M(F.VSBuffer),Array:M(F.Array),Object:M(F.Object),Uint:M(F.Int)},O=typeof Buffer<"u";function v(re,J){if(typeof J>"u")re.write(R.Undefined);else if(typeof J=="string"){const le=s.$ie.fromString(J);re.write(R.String),c(re,le.byteLength),re.write(le)}else if(O&&Buffer.isBuffer(J)){const le=s.$ie.wrap(J);re.write(R.Buffer),c(re,le.byteLength),re.write(le)}else if(J instanceof s.$ie)re.write(R.VSBuffer),c(re,J.byteLength),re.write(J);else if(Array.isArray(J)){re.write(R.Array),c(re,J.length);for(const le of J)v(re,le)}else if(typeof J=="number"&&(J|0)===J)re.write(R.Uint),c(re,J);else{const le=s.$ie.fromString(JSON.stringify(J));re.write(R.Object),c(re,le.byteLength),re.write(le)}}t.$Eh=v;function C(re){switch(re.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return re.read(u(re)).toString();case F.Buffer:return re.read(u(re)).buffer;case F.VSBuffer:return re.read(u(re));case F.Array:{const le=u(re),K=[];for(let W=0;W<le;W++)K.push(C(re));return K}case F.Object:return JSON.parse(re.read(u(re)).toString());case F.Int:return u(re)}}t.$Fh=C;class q{constructor(J,le,K=null,W=1e3){this.h=J,this.j=le,this.k=K,this.l=W,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:200})}registerChannel(J,le){this.b.set(J,le),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const le=this.o([J.type]);this.k?.logOutgoing(le,0,1,d(J.type));return}case 201:case 202:case 204:case 203:{const le=this.o([J.type,J.id],J.data);this.k?.logOutgoing(le,J.id,1,d(J.type),J.data);return}}}o(J,le=void 0){const K=new h;return v(K,J),v(K,le),this.p(K.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const le=new f(J),K=C(le),W=C(le),Z=K[0];switch(Z){case 100:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}: ${K[2]}.${K[3]}`,W),this.s({type:Z,id:K[1],channelName:K[2],name:K[3],arg:W});case 102:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}: ${K[2]}.${K[3]}`,W),this.t({type:Z,id:K[1],channelName:K[2],name:K[3],arg:W});case 101:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}`),this.u({type:Z,id:K[1]});case 103:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}`),this.u({type:Z,id:K[1]})}}s(J){const le=this.b.get(J.channelName);if(!le){this.v(J);return}const K=new U.$5d;let W;try{W=le.call(this.j,J.name,J.arg,K.token)}catch(we){W=Promise.reject(we)}const Z=J.id;W.then(we=>{this.m({id:Z,data:we,type:201})},we=>{we instanceof Error?this.m({id:Z,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.m({id:Z,data:we,type:203})}).finally(()=>{ce.dispose(),this.d.delete(J.id)});const ce=(0,w.$Rc)(()=>K.cancel());this.d.set(J.id,ce)}t(J){const le=this.b.get(J.channelName);if(!le){this.v(J);return}const K=J.id,Z=le.listen(this.j,J.name,J.arg)(ce=>this.m({id:K,data:ce,type:204}));this.d.set(J.id,Z)}u(J){const le=this.d.get(J.id);le&&(le.dispose(),this.d.delete(J.id))}v(J){let le=this.g.get(J.channelName);le||(le=[],this.g.set(J.channelName,le));const K=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);le.push({request:J,timeoutTimer:K})}w(J){const le=this.g.get(J);if(le){for(const K of le)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Gh=q;var j;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(j||(t.RequestInitiator=j={}));class N{constructor(J,le=null){this.l=J,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$Ud,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=le}getChannel(J){const le=this;return{call(K,W,Z){return le.a?Promise.reject(new k.$5):le.m(J,K,W,Z)},listen(K,W){return le.a?b.Event.None:le.o(J,K,W)}}}m(J,le,K,W=U.CancellationToken.None){const Z=this.g++,we={id:Z,type:100,channelName:J,name:le,arg:K};if(W.isCancellationRequested)return Promise.reject(new k.$5);let Ae;return new Promise((Le,_)=>{if(W.isCancellationRequested)return _(new k.$5);const g=()=>{const l=D=>{switch(D.type){case 201:this.f.delete(Z),Le(D.data);break;case 202:{this.f.delete(Z);const S=new Error(D.data.message);S.stack=Array.isArray(D.data.stack)?D.data.stack.join(`
`):D.data.stack,S.name=D.data.name,_(S);break}case 203:this.f.delete(Z),_(D.data);break}};this.f.set(Z,l),this.p(we)};let m=null;this.b===$.Idle?g():(m=(0,P.$Sg)(l=>this.u()),m.then(()=>{m=null,g()}));const i=()=>{m?(m.cancel(),m=null):this.p({id:Z,type:101}),_(new k.$5)},n=W.onCancellationRequested(i);Ae=(0,w.$Qc)((0,w.$Rc)(i),n),this.d.add(Ae)}).finally(()=>{Ae.dispose(),this.d.delete(Ae)})}o(J,le,K){const W=this.g++,ce={id:W,type:102,channelName:J,name:le,arg:K};let we=null;const Ae=new b.$Ud({onWillAddFirstListener:()=>{we=(0,P.$Sg)(Le=>this.u()),we.then(()=>{we=null,this.d.add(Ae),this.p(ce)})},onDidRemoveLastListener:()=>{we?(we.cancel(),we=null):(this.d.delete(Ae),this.p({id:W,type:103}))}}),ke=Le=>Ae.fire(Le.data);return this.f.set(W,ke),Ae.event}p(J){switch(J.type){case 100:case 102:{const le=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(le,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const le=this.q([J.type,J.id]);this.j?.logOutgoing(le,J.id,0,e(J.type));return}}}q(J,le=void 0){const K=new h;return v(K,J),v(K,le),this.r(K.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const le=new f(J),K=C(le),W=C(le),Z=K[0];switch(Z){case 200:return this.j?.logIncoming(J.byteLength,0,0,d(Z)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,K[1],0,d(Z),W),this.t({type:K[0],id:K[1],data:W})}}t(J){if(J.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Hh=N,Ye([E.$wh],N.prototype,"onDidInitializePromise",null);class L{get connections(){const J=[];return this.f.forEach(le=>J.push(le)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new b.$Ud,this.onDidAddConnection=this.g.event,this.h=new b.$Ud,this.onDidRemoveConnection=this.h.event,this.j=new w.$Sc,this.j.add(J(({protocol:le,onDidClientDisconnect:K})=>{const W=b.Event.once(le.onMessage);this.j.add(W(Z=>{const ce=new f(Z),we=C(ce),Ae=new q(le,we),ke=new N(le);this.a.forEach((_,g)=>Ae.registerChannel(g,_));const Le={channelServer:Ae,channelClient:ke,ctx:we};this.f.add(Le),this.g.fire(Le),this.j.add(K(()=>{Ae.dispose(),ke.dispose(),this.f.delete(Le),this.h.fire(Le)}))}))}))}getChannel(J,le){const K=this;return{call(W,Z,ce){let we;if((0,o.$Vf)(le)){const ke=(0,A.$4b)(K.connections.filter(le));we=ke?Promise.resolve(ke):b.Event.toPromise(b.Event.filter(K.onDidAddConnection,le))}else we=le.routeCall(K,W,Z);const Ae=we.then(ke=>ke.channelClient.getChannel(J));return Y(Ae).call(W,Z,ce)},listen(W,Z){if((0,o.$Vf)(le))return K.k(J,le,W,Z);const ce=le.routeEvent(K,W,Z).then(we=>we.channelClient.getChannel(J));return Y(ce).listen(W,Z)}}}k(J,le,K,W){const Z=this;let ce;const we=new b.$Ud({onWillAddFirstListener:()=>{ce=new w.$Sc;const Ae=new b.$1d,ke=new Map,Le=g=>{const i=g.channelClient.getChannel(J).listen(K,W),n=Ae.add(i);ke.set(g,n)},_=g=>{const m=ke.get(g);m&&(m.dispose(),ke.delete(g))};Z.connections.filter(le).forEach(Le),b.Event.filter(Z.onDidAddConnection,le)(Le,void 0,ce),Z.onDidRemoveConnection(_,void 0,ce),Ae.event(we.fire,we,ce),ce.add(Ae)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return we.event}registerChannel(J,le){this.a.set(J,le);for(const K of this.f)K.channelServer.registerChannel(J,le)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Ih=L;class B{constructor(J,le,K=null){const W=new h;v(W,le),J.send(W.buffer),this.a=new N(J,K),this.d=new q(J,le,K)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,le){this.d.registerChannel(J,le)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Jh=B;function Y(re){return{call(J,le,K){return re.then(W=>W.call(J,le,K))},listen(J,le){const K=new b.$4d;return re.then(W=>K.input=W.listen(J,le)),K.event}}}t.$Kh=Y;function X(re){let J=!1;return{call(le,K,W){return J?re.call(le,K,W):(0,P.$6g)(0).then(()=>J=!0).then(()=>re.call(le,K,W))},listen(le,K){if(J)return re.listen(le,K);const W=new b.$4d;return(0,P.$6g)(0).then(()=>J=!0).then(()=>W.input=re.listen(le,K)),W.event}}}t.$Lh=X;class de{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const le of J.connections)if(await Promise.resolve(this.a(le.ctx)))return Promise.resolve(le);return await b.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Mh=de;var oe;(function(re){function J(Z,ce,we){const Ae=Z,ke=we&&we.disableMarshalling,Le=new Map;for(const _ in Ae)K(_)&&Le.set(_,b.Event.buffer(Ae[_],!0,void 0,ce));return new class{listen(_,g,m){const i=Le.get(g);if(i)return i;if(W(g)){const n=Ae[g];if(typeof n=="function")return n.call(Ae,m)}throw new k.$bb(`Event not found: ${g}`)}call(_,g,m){const i=Ae[g];if(typeof i=="function"){if(!ke&&Array.isArray(m))for(let l=0;l<m.length;l++)m[l]=(0,y.$Bh)(m[l]);let n=i.apply(Ae,m);return n instanceof Promise||(n=Promise.resolve(n)),n}throw new k.$bb(`Method not found: ${g}`)}}}re.fromService=J;function le(Z,ce){const we=ce&&ce.disableMarshalling;return new Proxy({},{get(Ae,ke){if(typeof ke=="string")return ce?.properties?.has(ke)?ce.properties.get(ke):W(ke)?function(Le){return Z.listen(ke,Le)}:K(ke)?Z.listen(ke):async function(...Le){let _;ce&&!(0,o.$Qf)(ce.context)?_=[ce.context,...Le]:_=Le;const g=await Z.call(ke,_);return we?g:(0,y.$Bh)(g)};throw new k.$bb(`Property not found: ${String(ke)}`)}})}re.toService=le;function K(Z){return Z[0]==="o"&&Z[1]==="n"&&I.$0e(Z.charCodeAt(2))}function W(Z){return/^onDynamic/.test(Z)&&I.$0e(Z.charCodeAt(9))}})(oe||(t.ProxyChannel=oe={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const J=re.toString();if(J!=="[object Object]")return J}return re}function Te(re){return Array.isArray(re)?re.map(me):me(re)}function Ne(re,J,le,K,W,Z,ce){ce=Te(ce);const we=ee[W],Ae=we[K%we.length];let ke=[`%c[${re}]%c[${String(J).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(Z)?(ke=ke.concat(ce),ke.push(")")):ke.push(ce),console.log.apply(console,ke)}class Me{constructor(J,le){this.d=J,this.f=le,this.a=0,this.b=0}logOutgoing(J,le,K,W,Z){this.b+=J,Ne(this.d,this.b,J,le,K,W,Z)}logIncoming(J,le,K,W,Z){this.a+=J,Ne(this.f,this.a,J,le,K,W,Z)}}t.$Nh=Me}),define(be[134],pe([1,0,33,4,67,90,30]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zU=void 0;class k extends s.$Jh{static f(){const w=P.Event.fromNodeEventEmitter(E.$O,"vscode:message",(y,I)=>A.$ie.wrap(I));return E.$O.send("vscode:hello"),new U.$vU(E.$O,w)}constructor(w){const y=k.f();super(y,w),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}t.$zU=k}),define(be[135],pe([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(be[136],pe([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6h=t.$5h=t.$4h=t._util=void 0;var A;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function k(b){return b[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=k})(A||(t._util=A={})),t.$4h=s("instantiationService");function P(E,k,b){k[A.DI_TARGET]===k?k[A.DI_DEPENDENCIES].push({id:E,index:b}):(k[A.DI_DEPENDENCIES]=[{id:E,index:b}],k[A.DI_TARGET]=k)}function s(E){if(A.serviceIds.has(E))return A.serviceIds.get(E);const k=function(b,w,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(k,b,y)};return k.toString=()=>E,A.serviceIds.set(E,k),k}t.$5h=s;function U(E){return E}t.$6h=U}),define(be[137],pe([1,0,40]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jm=t.$Im=t.$Hm=t.ID=void 0,t.ID="diagnosticsService",t.$Hm=(0,A.$5h)(t.ID);function P(U){return!!U.hostName&&!!U.errorMessage}t.$Im=P;class s{async getPerformanceInfo(E,k){return{}}async getSystemInfo(E,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,k){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.$Jm=s}),define(be[138],pe([1,0,88,24,10,7,15,135,40,5,31,23]),function(ie,t,A,P,s,U,E,k,b,w,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yk=t.$Xk=t.$Wk=t.$Vk=t.$Uk=t.FileKind=t.$Tk=t.$Sk=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.$Nk=t.FileOperationResult=t.$Mk=t.$Lk=t.$Kk=t.$Jk=t.$Ik=t.FileChangeType=t.$Hk=t.FileOperation=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.FileSystemProviderErrorCode=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.FileSystemProviderCapabilities=t.$rk=t.FilePermission=t.FileType=t.$qk=t.$pk=void 0,t.$pk=(0,b.$5h)("fileService");function o(W){return W.create===!0}t.$qk=o;var a;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function r(W){const Z=W;return!!Z&&typeof Z.onDidChange=="function"}t.$rk=r;var d;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(d||(t.FileSystemProviderCapabilities=d={}));function $(W){return!!(W.capabilities&2)}t.$sk=$;function u(W){return!!(W.capabilities&8)}t.$tk=u;function p(W){return!!(W.capabilities&131072)}t.$uk=p;function c(W){return!!(W.capabilities&4)}t.$vk=c;function f(W){return!!(W.capabilities&16)}t.$wk=f;function h(W){return $(W)?!!(W.capabilities&16384):!1}t.$xk=h;function F(W){return $(W)?!!(W.capabilities&32768):!1}t.$yk=F;function M(W){return!!(W.capabilities&65536)}t.$zk=M;function R(W){return!!(W.capabilities&2048)}t.$Ak=R;var O;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(O||(t.FileSystemProviderErrorCode=O={}));class v extends Error{static create(Z,ce){const we=new v(Z.toString(),ce);return j(we,ce),we}constructor(Z,ce){super(Z),this.code=ce}}t.$Bk=v;function C(W,Z){return v.create(W,Z)}t.$Ck=C;function q(W){return W||C((0,k.localize)(0,null),O.Unknown)}t.$Dk=q;function j(W,Z){return W.name=Z?`${Z} (FileSystemError)`:"FileSystemError",W}t.$Ek=j;function N(W){if(!W)return O.Unknown;if(W instanceof v)return W.code;const Z=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Z)return O.Unknown;switch(Z[1]){case O.FileExists:return O.FileExists;case O.FileIsADirectory:return O.FileIsADirectory;case O.FileNotADirectory:return O.FileNotADirectory;case O.FileNotFound:return O.FileNotFound;case O.FileTooLarge:return O.FileTooLarge;case O.FileWriteLocked:return O.FileWriteLocked;case O.NoPermissions:return O.NoPermissions;case O.Unavailable:return O.Unavailable}return O.Unknown}t.$Fk=N;function L(W){if(W instanceof ee)return W.fileOperationResult;switch(N(W)){case O.FileNotFound:return 1;case O.FileIsADirectory:return 0;case O.FileNotADirectory:return 9;case O.FileWriteLocked:return 5;case O.NoPermissions:return 6;case O.FileExists:return 4;case O.FileTooLarge:return 7;default:return 10}}t.$Gk=L;var B;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(B||(t.FileOperation=B={}));class Y{constructor(Z,ce,we){this.resource=Z,this.operation=ce,this.target=we}isOperation(Z){return this.operation===Z}}t.$Hk=Y;var X;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(X||(t.FileChangeType=X={}));class de{static{this.a=null}constructor(Z,ce){this.c=ce,this.b=void 0,this.d=new I.$V(()=>{const we=A.$$h.forUris(()=>this.c);return we.fill(this.rawAdded.map(Ae=>[Ae,!0])),we}),this.f=new I.$V(()=>{const we=A.$$h.forUris(()=>this.c);return we.fill(this.rawUpdated.map(Ae=>[Ae,!0])),we}),this.g=new I.$V(()=>{const we=A.$$h.forUris(()=>this.c);return we.fill(this.rawDeleted.map(Ae=>[Ae,!0])),we}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const we of Z){switch(we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}this.b!==de.a&&(typeof we.cId=="number"?this.b===void 0?this.b=we.cId:this.b!==we.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(Z,...ce){return this.h(Z,{includeChildren:!1},...ce)}affects(Z,...ce){return this.h(Z,{includeChildren:!0},...ce)}h(Z,ce,...we){if(!Z)return!1;const Ae=we.length>0;return!!((!Ae||we.includes(1))&&(this.d.value.get(Z)||ce.includeChildren&&this.d.value.findSuperstr(Z))||(!Ae||we.includes(0))&&(this.f.value.get(Z)||ce.includeChildren&&this.f.value.findSuperstr(Z))||(!Ae||we.includes(2))&&(this.g.value.findSubstr(Z)||ce.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}t.$Ik=de;function oe(W,Z,ce){return!W||!Z||W===Z||Z.length>W.length?!1:(Z.charAt(Z.length-1)!==P.sep&&(Z+=P.sep),ce?(0,s.$_e)(W,Z):W.indexOf(Z)===0)}t.$Jk=oe;class ee extends Error{constructor(Z,ce,we){super(Z),this.fileOperationResult=ce,this.options=we}}t.$Kk=ee;class me extends ee{constructor(Z,ce,we,Ae){super(Z,ce,Ae),this.fileOperationResult=ce,this.size=we}}t.$Lk=me;class Te extends ee{constructor(Z,ce,we){super(Z,2,we),this.stat=ce}}t.$Mk=Te;var Ne;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ne||(t.FileOperationResult=Ne={})),t.$Nk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Ok={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Pk="files.associations",t.$Qk="files.exclude",t.$Rk="files.readonlyInclude",t.$Sk="files.readonlyExclude",t.$Tk="files.readonlyFromPermissions";var Me;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Me||(t.FileKind=Me={})),t.$Uk="";function re(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}t.$Vk=re;async function J(W,Z){if(!Z.hasProvider(E.URI.from({scheme:W.scheme})))return new Promise(ce=>{const we=Z.onDidChangeFileSystemProviderRegistrations(Ae=>{Ae.scheme===W.scheme&&Ae.added&&(we.dispose(),ce())})})}t.$Wk=J;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(Z){return(0,U.$Lf)(Z)||(Z=0),Z<le.KB?(0,k.localize)(1,null,Z.toFixed(0)):Z<le.MB?(0,k.localize)(2,null,(Z/le.KB).toFixed(2)):Z<le.GB?(0,k.localize)(3,null,(Z/le.MB).toFixed(2)):Z<le.TB?(0,k.localize)(4,null,(Z/le.GB).toFixed(2)):(0,k.localize)(5,null,(Z/le.TB).toFixed(2))}}t.$Xk=le;function K(W){const Z=typeof W=="string"||W?.scheme===y.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===y.Schemas.file?1024*le.MB:Z?10*le.MB:w.$o?50*le.MB:1024*le.MB}t.$Yk=K}),define(be[139],pe([1,0,40]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5$b=t.$4$b=void 0,t.$4$b=(0,A.$5h)("mainProcessService");class P{constructor(U,E){this.a=U,this.b=E}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,E){this.a.registerChannel(U,E)}}t.$5$b=P}),define(be[140],pe([1,0,2,134]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6$b=void 0;class s extends A.$Tc{constructor(E){super(),this.a=this.B(new P.$zU(`window:${E}`))}getChannel(E){return this.a.getChannel(E)}registerChannel(E,k){this.a.registerChannel(E,k)}}t.$6$b=s});var Ei=this&&this.__param||function(ie,t){return function(A,P){t(A,P,ie)}};define(be[141],pe([1,0,67,139]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0$b=void 0;let s=class{constructor(E,k){return this.windowId=E,A.ProxyChannel.toService(k.getChannel("nativeHost"),{context:E,properties:(()=>{const b=new Map;return b.set("windowId",E),b})()})}};t.$0$b=s,t.$0$b=s=Ye([Ei(1,P.$4$b)],s)}),define(be[68],pe([1,0,76,7]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gn=void 0;class s{constructor(){this.a=new Map}add(E,k){A.ok(P.$Hf(E)),A.ok(P.$Jf(k)),A.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,k)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}t.$Gn=new s}),define(be[142],pe([1,0,4,68]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hn=void 0,t.$Hn={JSONContribution:"base.contributions.json"};function s(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class U{constructor(){this.b=new A.$Ud,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,w){this.a[s(b)]=w,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const E=new U;P.$Gn.add(t.$Hn.JSONContribution,E)}),define(be[143],pe([1,0,9,17,18,4,7,15,136,142,68]),function(ie,t,A,P,s,U,E,k,b,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dw=t.$Cw=t.$Bw=t.$Aw=t.$zw=t.$yw=t.$xw=t.$ww=t.IconFontDefinition=t.IconContribution=t.$vw=void 0,t.$vw={IconContribution:"base.contributions.icons"};var I;(function(c){function f(h,F){let M=h.defaults;for(;s.ThemeIcon.isThemeIcon(M);){const R=e.getIcon(M.id);if(!R)return;M=R.defaults}return M}c.getDefinition=f})(I||(t.IconContribution=I={}));var o;(function(c){function f(F){return{weight:F.weight,style:F.style,src:F.src.map(M=>({format:M.format,location:M.location.toString()}))}}c.toJSONObject=f;function h(F){const M=R=>(0,E.$Hf)(R)?R:void 0;if(F&&Array.isArray(F.src)&&F.src.every(R=>(0,E.$Hf)(R.format)&&(0,E.$Hf)(R.location)))return{weight:M(F.weight),style:M(F.style),src:F.src.map(R=>({format:R.format,location:k.URI.parse(R.location)}))}}c.fromJSONObject=h})(o||(t.IconFontDefinition=o={}));class a{constructor(){this.a=new U.$Ud,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${s.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(f,h,F,M){const R=this.b[f];if(R){if(F&&!R.description){R.description=F,this.d.properties[f].markdownDescription=`${F} $(${f})`;const C=this.e.enum.indexOf(f);C!==-1&&(this.e.enumDescriptions[C]=F),this.a.fire()}return R}const O={id:f,description:F,defaults:h,deprecationMessage:M};this.b[f]=O;const v={$ref:"#/definitions/icons"};return M&&(v.deprecationMessage=M),F&&(v.markdownDescription=`${F}: $(${f})`),this.d.properties[f]=v,this.e.enum.push(f),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:f}}deregisterIcon(f){delete this.b[f],delete this.d.properties[f];const h=this.e.enum.indexOf(f);h!==-1&&(this.e.enum.splice(h,1),this.e.enumDescriptions.splice(h,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(f=>this.b[f])}getIcon(f){return this.b[f]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(f,h){const F=this.f[f];return F||(this.f[f]=h,this.a.fire(),h)}deregisterIconFont(f){delete this.f[f]}getIconFont(f){return this.f[f]}toString(){const f=(R,O)=>R.id.localeCompare(O.id),h=R=>{for(;s.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const M=Object.keys(this.b).map(R=>this.b[R]);for(const R of M.filter(O=>!!O.description).sort(f))F.push(`|<i class="${h(R)}"></i>|${R.id}|${s.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const R of M.filter(O=>!s.ThemeIcon.isThemeIcon(O.defaults)).sort(f))F.push(`|<i class="${h(R)}"></i>|${R.id}|`);return F.join(`
`)}}const e=new a;y.$Gn.add(t.$vw.IconContribution,e);function r(c,f,h,F){return e.registerIcon(c,f,h,F)}t.$ww=r;function d(){return e}t.$xw=d;function $(){const c=(0,P.$9j)();for(const f in c){const h="\\"+c[f].toString(16);e.registerIcon(f,{fontCharacter:h})}}$(),t.$yw="vscode://schemas/icons";const u=y.$Gn.as(w.$Hn.JSONContribution);u.registerSchema(t.$yw,e.getIconSchema());const p=new A.$eh(()=>u.notifySchemaChanged(t.$yw),200);e.onDidChange(()=>{p.isScheduled()||p.schedule()}),t.$zw=r("widget-close",P.$$j.close,(0,b.localize)(2,null)),t.$Aw=r("goto-previous-location",P.$$j.arrowUp,(0,b.localize)(3,null)),t.$Bw=r("goto-next-location",P.$$j.arrowDown,(0,b.localize)(4,null)),t.$Cw=s.ThemeIcon.modify(P.$$j.sync,"spin"),t.$Dw=s.ThemeIcon.modify(P.$$j.loading,"spin")}),define(be[144],pe([1,0,3,4,2,18,143]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LEb=t.$KEb=void 0;function k(w){const y=new s.$Sc,I=y.add(new P.$Ud),o=(0,E.$xw)();return y.add(o.onDidChange(()=>I.fire())),w&&y.add(w.onDidProductIconThemeChange(()=>I.fire())),{dispose:()=>y.dispose(),onDidChange:I.event,getCSS(){const a=w?w.getProductIconTheme():new b,e={},r=$=>{const u=a.getIcon($);if(!u)return;const p=u.font;return p?(e[p.id]=p.definition,`.codicon-${$.id}:before { content: '${u.fontCharacter}'; font-family: ${(0,A.$QQ)(p.id)}; }`):`.codicon-${$.id}:before { content: '${u.fontCharacter}'; }`},d=[];for(const $ of o.getIcons()){const u=r($);u&&d.push(u)}for(const $ in e){const u=e[$],p=u.weight?`font-weight: ${u.weight};`:"",c=u.style?`font-style: ${u.style};`:"",f=u.src.map(h=>`${(0,A.$PQ)(h.location)} format('${h.format}')`).join(", ");d.push(`@font-face { src: ${f}; font-family: ${(0,A.$QQ)($)};${p}${c} font-display: block; }`)}return d.join(`
`)}}}t.$KEb=k;class b{getIcon(y){const I=(0,E.$xw)();let o=y.defaults;for(;U.ThemeIcon.isThemeIcon(o);){const a=I.getIcon(o.id);if(!a)return;o=a.defaults}return o}}t.$LEb=b}),define(be[145],pe([1,0,5]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VC=t.$UC=t.$TC=t.$SC=t.$RC=t.$QC=t.$PC=t.$OC=t.$NC=t.$MC=void 0,t.$MC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function P(o){return typeof o.parentId=="number"}t.$NC=P;function s(o){return!!o.workspaceUri}t.$OC=s;function U(o){return!!o.folderUri}t.$PC=U;function E(o){return!!o.fileUri}t.$QC=E;function k(o){const a=b(o),e=o.getValue("window.menuBarVisibility");return e==="default"||a==="native"&&e==="compact"||A.$j&&A.$m?"classic":e}t.$RC=k;function b(o){if(A.$o)return"custom";const a=o.getValue("window");if(a){if(A.$j&&a.nativeTabs===!0||A.$j&&a.nativeFullScreen===!1)return"native";const d=a.titleBarStyle;if(d==="native"||d==="custom")return d}return A.$k?"native":"custom"}t.$SC=b;function w(o){return!(!A.$i||A.$o||b(o)==="native")}t.$TC=w;function y(o){const a=o.getValue("window");return!a||typeof a.nativeFullScreen!="boolean"||a.nativeTabs?!0:a.nativeFullScreen!==!1}t.$UC=y;function I(o=0){return Math.pow(1.2,o)}t.$VC=I}),define(be[146],pe([1,0,16,3,21,30,145]),function(ie,t,A,P,s,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$b_b=t.$a_b=t.$_$b=t.ApplyZoomTarget=void 0;var k;(function(o){o[o.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",o[o.ALL_WINDOWS=2]="ALL_WINDOWS"})(k||(t.ApplyZoomTarget=k={}));function b(o,a){const e=[];a===k.ACTIVE_WINDOW?e.push((0,P.$eQ)()):a===k.ALL_WINDOWS?e.push(...Array.from((0,P.getWindows)()).map(({window:r})=>r)):e.push(a);for(const r of e)w(r)?.webFrame?.setZoomLevel(o),(0,A.$bP)((0,E.$VC)(o),r),(0,A.$0O)(o,r)}t.$_$b=b;function w(o){if(o===s.$4O)return{ipcRenderer:U.$O,webFrame:U.$Q};{const a=o;if(a?.vscode?.ipcRenderer&&a?.vscode?.webFrame)return a.vscode}}function y(o){b((0,A.$$O)(typeof o=="number"?(0,P.$eQ)():o)+1,o)}t.$a_b=y;function I(o){b((0,A.$$O)(typeof o=="number"?(0,P.$eQ)():o)-1,o)}t.$b_b=I}),define(be[147],pe([1,0,11,3,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ie,t,A,P,s,U,E,k,b,w,y,I,o,a,e,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const d=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,$=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(N){return 22}getTemplateId(N){return O(N)?"process":M(N)?"machine":(0,b.$Im)(N)?"error":R(N)?"header":""}}class p{hasChildren(N){return(0,b.$Im)(N)?!1:O(N)?!!N.children?.length:!0}getChildren(N){return O(N)?N.children?N.children:[]:(0,b.$Im)(N)?[]:R(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:M(N)?[N.rootProcess]:[N.processes]}}class c{constructor(){this.templateId="header"}renderTemplate(N){const L=(0,P.$zQ)(N,(0,P.$)(".row")),B=(0,P.$zQ)(L,(0,P.$)(".nameLabel")),Y=(0,P.$zQ)(L,(0,P.$)(".cpu")),X=(0,P.$zQ)(L,(0,P.$)(".memory")),de=(0,P.$zQ)(L,(0,P.$)(".pid"));return{name:B,CPU:Y,memory:X,PID:de}}renderElement(N,L,B,Y){B.name.textContent=(0,A.localize)(0,null),B.CPU.textContent=(0,A.localize)(1,null),B.PID.textContent=(0,A.localize)(2,null),B.memory.textContent=(0,A.localize)(3,null)}disposeTemplate(N){}}class f{constructor(){this.templateId="machine"}renderTemplate(N){const L=Object.create(null),B=(0,P.$zQ)(N,(0,P.$)(".row"));return L.name=(0,P.$zQ)(B,(0,P.$)(".nameLabel")),L}renderElement(N,L,B,Y){B.name.textContent=N.element.name}disposeTemplate(N){}}class h{constructor(){this.templateId="error"}renderTemplate(N){const L=Object.create(null),B=(0,P.$zQ)(N,(0,P.$)(".row"));return L.name=(0,P.$zQ)(B,(0,P.$)(".nameLabel")),L}renderElement(N,L,B,Y){B.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class F{constructor(N,L,B){this.a=N,this.b=L,this.c=B,this.templateId="process"}renderTemplate(N){const L=(0,P.$zQ)(N,(0,P.$)(".row")),B=(0,P.$zQ)(L,(0,P.$)(".nameLabel")),Y=(0,P.$zQ)(L,(0,P.$)(".cpu")),X=(0,P.$zQ)(L,(0,P.$)(".memory")),de=(0,P.$zQ)(L,(0,P.$)(".pid"));return{name:B,CPU:Y,PID:de,memory:X}}renderElement(N,L,B,Y){const{element:X}=N,de=X.pid.toFixed(0);let oe=X.name;this.c.has(X.pid)&&(oe=this.c.get(X.pid)),B.name.textContent=oe,B.name.title=X.cmd,B.CPU.textContent=X.load.toFixed(0),B.PID.textContent=de,B.PID.parentElement.id=`pid-${de}`;const ee=this.a==="win32"?X.mem:this.b*(X.mem/100);B.memory.textContent=(ee/w.$Xk.MB).toFixed(0)}disposeTemplate(N){}}function M(j){return!!j.name&&!!j.rootProcess}function R(j){return!!j.processRoots}function O(j){return!!j.pid}class v{constructor(N,L){this.f=L,this.b=new Map;const B=new y.$6$b(N);this.c=new I.$0$b(N,B),this.k(L.styles),this.g(L),k.$O.on("vscode:pidToNameResponse",(Y,X)=>{this.b.clear();for(const[de,oe]of X)this.b.set(de,oe)}),k.$O.on("vscode:listProcessesResponse",async(Y,X)=>{X.forEach((de,oe)=>{O(de.rootProcess)&&(de.rootProcess.name=oe===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:X}}),this.d.layout(r.$4O.innerHeight,r.$4O.innerWidth)):await this.h(X),this.m(0)}),this.a=Date.now(),k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")}g(N){r.$4O.document.onkeydown=L=>{const B=N.platform==="darwin"?L.metaKey:L.ctrlKey;B&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),k.$O.send("vscode:closeProcessExplorer")),B&&L.keyCode===187&&(0,a.$a_b)(r.$4O),B&&L.keyCode===189&&(0,a.$b_b)(r.$4O)}}async h(N){const L=r.$4O.document.getElementById("process-list");if(!L)return;const{totalmem:B}=await this.c.getOSStatistics(),Y=[new F(this.f.platform,B,this.b),new c,new f,new h];this.d=new s.$2T("processExplorer",L,new u,Y,new p,{identityProvider:{getId:X=>O(X)?X.pid.toString():(0,b.$Im)(X)?X.hostName:R(X)?"processes":M(X)?X.name:"header"}}),this.d.setInput({processes:{processRoots:N}}),this.d.layout(r.$4O.innerHeight,r.$4O.innerWidth),this.d.onKeyDown(X=>{const de=new e.$wP(X);if(de.keyCode===35&&de.altKey){const oe=this.n();Promise.all(oe.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(X=>{O(X.element)&&this.l(X.element,!0)}),L.style.height=`${r.$4O.innerHeight}px`,r.$4O.addEventListener("resize",()=>{L.style.height=`${r.$4O.innerHeight}px`,this.d?.layout(r.$4O.innerHeight,r.$4O.innerWidth)})}i(N){const L=d.exec(N);return L&&L.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}j(N){const L={type:"node",request:"attach",name:`process ${N.pid}`};let B=d.exec(N.cmd);B?L.port=Number(B.groups.port):L.processId=String(N.pid),B=$.exec(N.cmd),B&&(L.port=Number(B.groups.port)),k.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}k(N){const L=(0,P.$hQ)(),B=[];N.listFocusBackground&&(B.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&B.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&(B.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&B.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&B.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&B.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&B.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=B.join(`
`),N.color&&(r.$4O.document.body.style.color=N.color)}l(N,L){const B=[],Y=Number(N.pid);L&&(B.push({accelerator:"Alt+E",label:(0,A.localize)(4,null),click:()=>{this.c.killProcess(Y,"SIGTERM")}}),B.push({label:(0,A.localize)(5,null),click:()=>{this.c.killProcess(Y,"SIGKILL")}}),B.push({type:"separator"})),B.push({label:(0,A.localize)(6,null),click:()=>{const X=this.n();X?.includes(Y)||(X.length=0,X.push(Y));const de=X?.map(oe=>r.$4O.document.getElementById(`pid-${oe}`)).filter(oe=>!!oe);if(de){const oe=de.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(oe.join(`
`))}}}),B.push({label:(0,A.localize)(7,null),click:()=>{const X=r.$4O.document.getElementById("process-list");X&&this.c.writeClipboardText(X.innerText)}}),N&&L&&this.i(N.cmd)&&(B.push({type:"separator"}),B.push({label:(0,A.localize)(8,null),click:()=>{this.j(N)}})),(0,E.$rU)(B)}m(N){setTimeout(()=>{const L=Date.now(),B=N+L-this.a;this.a=L,B>1e3?(k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")):this.m(B)},200)}n(){return this.d?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function C(){const j=(0,P.$hQ)();j.id="codiconStyles";const N=(0,o.$KEb)(void 0);function L(){j.textContent=N.getCSS()}const B=new U.$eh(L,0);N.onDidChange(()=>B.schedule()),B.schedule()}function q(j){const N=j.data.platform==="win32"?"windows":j.data.platform==="linux"?"linux":"mac";r.$4O.document.body.classList.add(N),C(),(0,a.$_$b)(j.data.zoomLevel,r.$4O),new v(j.windowId,j.data)}t.startup=q})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a45edfc415d19852fa3c3e1cd255a02de9e016d2/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
