/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],O=0,L=ne.length;O<L;O++)e[O]=le[ne[O]];return e};define(le[123],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const A=new Map,j=new Map,I=new Map,C=new Map;function k(l,d){l.has(d.detail)||l.set(d.detail,-d.timestamp)}function g(l,d){const y=l.get(d.detail);y&&(y>=0||l.set(d.detail,y+d.timestamp))}let P=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(P=ne.getStats().slice(0).sort((l,d)=>l.timestamp-d.timestamp));for(const l of P)switch(l.type){case 10:k(A,l);break;case 11:case 12:g(A,l);break;case 21:k(j,l);break;case 22:g(j,l);break;case 33:k(I,l);break;case 34:g(I,l);break;case 31:k(C,l);break;case 32:g(C,l);break}let S=0;I.forEach(l=>S+=l);function $(l){const d=[];return l.forEach((y,w)=>d.push([w,y])),d}return{amdLoad:$(A),amdInvoke:$(j),nodeRequire:$(I),nodeEval:$(C),nodeRequireTotal:S}}static toMarkdownTable(A,j){let I="";const C=[];return A.forEach((k,g)=>{C[g]=k.length}),j.forEach(k=>{k.forEach((g,P)=>{typeof g>"u"&&(g=k[P]="-");const S=g.toString().length;C[P]=Math.max(S,C[P])})}),A.forEach((k,g)=>{I+=`| ${k+" ".repeat(C[g]-k.toString().length)} `}),I+=`|
`,A.forEach((k,g)=>{I+=`| ${"-".repeat(C[g])} `}),I+=`|
`,j.forEach(k=>{k.forEach((g,P)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(C[P]-g.toString().length)} `)}),I+=`|
`}),I}}e.$U=O}),define(le[124],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function O(y,w,c){const f=L(y,w);if(f!==-1)return y[f]}e.$fb=O;function L(y,w,c=y.length-1){for(let f=c;f>=0;f--){const m=y[f];if(w(m))return f}return-1}e.$gb=L;function A(y,w){const c=j(y,w);return c===-1?void 0:y[c]}e.$hb=A;function j(y,w,c=0,f=y.length){let m=c,h=f;for(;m<h;){const v=Math.floor((m+h)/2);w(y[v])?m=v+1:h=v}return m-1}e.$ib=j;function I(y,w){const c=C(y,w);return c===y.length?void 0:y[c]}e.$jb=I;function C(y,w,c=0,f=y.length){let m=c,h=f;for(;m<h;){const v=Math.floor((m+h)/2);w(y[v])?h=v:m=v+1}return m}e.$kb=C;function k(y,w,c=0,f=y.length){const m=C(y,w,c,f);return m===y.length?-1:m}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!w(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const c=j(this.e,w,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=g;function P(y,w){if(y.length===0)return;let c=y[0];for(let f=1;f<y.length;f++){const m=y[f];w(m,c)>0&&(c=m)}return c}e.$nb=P;function S(y,w){if(y.length===0)return;let c=y[0];for(let f=1;f<y.length;f++){const m=y[f];w(m,c)>=0&&(c=m)}return c}e.$ob=S;function $(y,w){return P(y,(c,f)=>-w(c,f))}e.$pb=$;function l(y,w){if(y.length===0)return-1;let c=0;for(let f=1;f<y.length;f++){const m=y[f];w(m,y[c])>0&&(c=f)}return c}e.$qb=l;function d(y,w){for(const c of y){const f=w(c);if(f!==void 0)return f}}e.$rb=d}),define(le[125],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function O(I,C){const k=Object.create(null);for(const g of I){const P=C(g);let S=k[P];S||(S=k[P]=[]),S.push(g)}return k}e.$K=O;function L(I,C){const k=[],g=[];for(const P of I)C.has(P)||k.push(P);for(const P of C)I.has(P)||g.push(P);return{removed:k,added:g}}e.$L=L;function A(I,C){const k=[],g=[];for(const[P,S]of I)C.has(P)||k.push(S);for(const[P,S]of C)I.has(P)||g.push(S);return{removed:k,added:g}}e.$M=A;function j(I,C){const k=new Set;for(const g of C)I.has(g)&&k.add(g);return k}e.$N=j}),define(le[85],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function O(I){return(C,k,g)=>{let P=null,S=null;if(typeof g.value=="function"?(P="value",S=g.value):typeof g.get=="function"&&(P="get",S=g.get),!S)throw new Error("not supported");g[P]=I(S,k)}}function L(I,C,k){let g=null,P=null;if(typeof k.value=="function"?(g="value",P=k.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",P=k.get),!P)throw new Error("not supported");const S=`$memoize$${C}`;k[g]=function(...$){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,$)}),this[S]}}e.$wh=L;function A(I,C,k){return O((g,P)=>{const S=`$debounce$${P}`,$=`$debounce$result$${P}`;return function(...l){this[$]||(this[$]=k?k():void 0),clearTimeout(this[S]),C&&(this[$]=C(this[$],...l),l=[this[$]]),this[S]=setTimeout(()=>{g.apply(this,l),this[$]=k?k():void 0},I)}})}e.$xh=A;function j(I,C,k){return O((g,P)=>{const S=`$throttle$timer$${P}`,$=`$throttle$result$${P}`,l=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...y){if(this[$]||(this[$]=k?k():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),C&&(this[$]=C(this[$],...y)),this[d])return;const w=this[l]+I;w<=Date.now()?(this[l]=Date.now(),g.apply(this,[this[$]]),this[$]=k?k():void 0):(this[d]=!0,this[S]=setTimeout(()=>{this[d]=!1,this[l]=Date.now(),g.apply(this,[this[$]]),this[$]=k?k():void 0},w-Date.now()))}})}e.$yh=j}),define(le[7],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class O{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=O,e.$X=new O;function L(v){e.$X.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function A(v){if(!v||typeof v!="object")return!1;const i=v;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=A;function j(v){g(v)||e.$X.onUnexpectedError(v)}e.$1=j;function I(v){g(v)||e.$X.onUnexpectedExternalError(v)}e.$2=I;function C(v){if(v instanceof Error){const{name:i,message:o}=v,s=v.stacktrace||v.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:m.isErrorNoTelemetry(v)}}return v}e.$3=C;const k="Canceled";function g(v){return v instanceof P?!0:v instanceof Error&&v.name===k&&v.message===k}e.$4=g;class P extends Error{constructor(){super(k),this.name=this.message}}e.$5=P;function S(){const v=new Error(k);return v.name=v.message,v}e.$6=S;function $(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.$7=$;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.$8=l;class d extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function y(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.$0=y;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=w;class c extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=c;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const o=new m;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=m;class h extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}e.$cb=h}),define(le[17],he([0,1,7,124]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function A(U,_=0){return U[U.length-(1+_)]}e.$sb=A;function j(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.$tb=j;function I(U,_,H=(J,ie)=>J===ie){if(U===_)return!0;if(!U||!_||U.length!==_.length)return!1;for(let J=0,ie=U.length;J<ie;J++)if(!H(U[J],_[J]))return!1;return!0}e.$ub=I;function C(U,_){const H=U.length-1;_<H&&(U[_]=U[H]),U.pop()}e.$vb=C;function k(U,_,H){return g(U.length,J=>H(U[J],_))}e.$wb=k;function g(U,_){let H=0,J=U-1;for(;H<=J;){const ie=(H+J)/2|0,se=_(ie);if(se<0)H=ie+1;else if(se>0)J=ie-1;else return ie}return-(H+1)}e.$xb=g;function P(U,_,H){if(U=U|0,U>=_.length)throw new TypeError("invalid index");const J=_[Math.floor(_.length*Math.random())],ie=[],se=[],ce=[];for(const $e of _){const fe=H($e,J);fe<0?ie.push($e):fe>0?se.push($e):ce.push($e)}return U<ie.length?P(U,ie,H):U<ie.length+ce.length?ce[0]:P(U-(ie.length+ce.length),se,H)}e.$yb=P;function S(U,_){const H=[];let J;for(const ie of U.slice(0).sort(_))!J||_(J[0],ie)!==0?(J=[ie],H.push(J)):J.push(ie);return H}e.$zb=S;function*$(U,_){let H,J;for(const ie of U)J!==void 0&&_(J,ie)?H.push(ie):(H&&(yield H),H=[ie]),J=ie;H&&(yield H)}e.$Ab=$;function l(U,_){for(let H=0;H<=U.length;H++)_(H===0?void 0:U[H-1],H===U.length?void 0:U[H])}e.$Bb=l;function d(U,_){for(let H=0;H<U.length;H++)_(H===0?void 0:U[H-1],U[H],H+1===U.length?void 0:U[H+1])}e.$Cb=d;function y(U,_,H){const J=[];function ie($e,fe,ge){if(fe===0&&ge.length===0)return;const Ee=J[J.length-1];Ee&&Ee.start+Ee.deleteCount===$e?(Ee.deleteCount+=fe,Ee.toInsert.push(...ge)):J.push({start:$e,deleteCount:fe,toInsert:ge})}let se=0,ce=0;for(;;){if(se===U.length){ie(se,0,_.slice(ce));break}if(ce===_.length){ie(se,U.length-se,[]);break}const $e=U[se],fe=_[ce],ge=H($e,fe);ge===0?(se+=1,ce+=1):ge<0?(ie(se,1,[]),se+=1):ge>0&&(ie(se,0,[fe]),ce+=1)}return J}e.$Db=y;function w(U,_,H){const J=y(U,_,H),ie=[],se=[];for(const ce of J)ie.push(...U.slice(ce.start,ce.start+ce.deleteCount)),se.push(...ce.toInsert);return{removed:ie,added:se}}e.$Eb=w;function c(U,_,H){if(H===0)return[];const J=U.slice(0,H).sort(_);return m(U,_,J,H,U.length),J}e.top=c;function f(U,_,H,J,ie){return H===0?Promise.resolve([]):new Promise((se,ce)=>{(async()=>{const $e=U.length,fe=U.slice(0,H).sort(_);for(let ge=H,Ee=Math.min(H+J,$e);ge<$e;ge=Ee,Ee=Math.min(Ee+J,$e)){if(ge>H&&await new Promise(Ce=>setTimeout(Ce)),ie&&ie.isCancellationRequested)throw new O.$5;m(U,_,fe,ge,Ee)}return fe})().then(se,ce)})}e.$Gb=f;function m(U,_,H,J,ie){for(const se=H.length;J<ie;J++){const ce=U[J];if(_(ce,H[se-1])<0){H.pop();const $e=(0,L.$kb)(H,fe=>_(ce,fe)<0);H.splice($e,0,ce)}}}function h(U){return U.filter(_=>!!_)}e.$Hb=h;function v(U){let _=0;for(let H=0;H<U.length;H++)U[H]&&(U[_]=U[H],_+=1);U.length=_}e.$Ib=v;function i(U,_,H){U.splice(H,0,U.splice(_,1)[0])}e.$Jb=i;function o(U){return!Array.isArray(U)||U.length===0}e.$Kb=o;function s(U){return Array.isArray(U)&&U.length>0}e.$Lb=s;function n(U,_=H=>H){const H=new Set;return U.filter(J=>{const ie=_(J);return H.has(ie)?!1:(H.add(ie),!0)})}e.$Mb=n;function t(U){const _=new Set;return H=>{const J=U(H);return _.has(J)?!1:(_.add(J),!0)}}e.$Nb=t;function r(U,_){return U.length>0?U[0]:_}e.$Ob=r;function a(U,_){return U.length>0?U[U.length-1]:_}e.$Pb=a;function E(U,_,H=(J,ie)=>J===ie){let J=0;for(let ie=0,se=Math.min(U.length,_.length);ie<se&&H(U[ie],_[ie]);ie++)J++;return J}e.$Qb=E;function b(U){return[].concat(...U)}e.$Rb=b;function u(U,_){let H=typeof _=="number"?U:0;typeof _=="number"?H=U:(H=0,_=U);const J=[];if(H<=_)for(let ie=H;ie<_;ie++)J.push(ie);else for(let ie=H;ie>_;ie--)J.push(ie);return J}e.$Sb=u;function p(U,_,H){return U.reduce((J,ie)=>(J[_(ie)]=H?H(ie):ie,J),Object.create(null))}e.$Tb=p;function R(U,_){return U.push(_),()=>N(U,_)}e.$Ub=R;function N(U,_){const H=U.indexOf(_);if(H>-1)return U.splice(H,1),_}e.$Vb=N;function F(U,_,H){const J=U.slice(0,_),ie=U.slice(_);return J.concat(H,ie)}e.$Wb=F;function M(U,_){let H;if(typeof _=="number"){let J=_;H=()=>{const ie=Math.sin(J++)*179426549;return ie-Math.floor(ie)}}else H=Math.random;for(let J=U.length-1;J>0;J-=1){const ie=Math.floor(H()*(J+1)),se=U[J];U[J]=U[ie],U[ie]=se}}e.$Xb=M;function q(U,_){const H=U.indexOf(_);H>-1&&(U.splice(H,1),U.unshift(_))}e.$Yb=q;function Y(U,_){const H=U.indexOf(_);H>-1&&(U.splice(H,1),U.push(_))}e.$Zb=Y;function K(U,_){for(const H of _)U.push(H)}e.$1b=K;function x(U,_){return Array.isArray(U)?U.map(_):_(U)}e.$2b=x;function V(U){return Array.isArray(U)?U:[U]}e.$3b=V;function Q(U){return U[Math.floor(Math.random()*U.length)]}e.$4b=Q;function W(U,_,H){const J=te(U,_),ie=U.length,se=H.length;U.length=ie+se;for(let ce=ie-1;ce>=J;ce--)U[ce+se]=U[ce];for(let ce=0;ce<se;ce++)U[ce+J]=H[ce]}e.$5b=W;function G(U,_,H,J){const ie=te(U,_);let se=U.splice(ie,H);return se===void 0&&(se=[]),W(U,ie,J),se}e.$6b=G;function te(U,_){return _<0?Math.max(_+U.length,0):Math.min(_,U.length)}var re;(function(U){function _(se){return se<0}U.isLessThan=_;function H(se){return se<=0}U.isLessThanOrEqual=H;function J(se){return se>0}U.isGreaterThan=J;function ie(se){return se===0}U.isNeitherLessOrGreaterThan=ie,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ee(U,_){return(H,J)=>_(U(H),U(J))}e.$7b=ee;function ae(...U){return(_,H)=>{for(const J of U){const ie=J(_,H);if(!re.isNeitherLessOrGreaterThan(ie))return ie}return re.neitherLessOrGreaterThan}}e.$8b=ae;const Z=(U,_)=>U-_;e.$9b=Z;const z=(U,_)=>(0,e.$9b)(U?1:0,_?1:0);e.$0b=z;function D(U){return(_,H)=>-U(_,H)}e.$$b=D;class T{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let H=this.c;for(;H<this.g.length&&_(this.g[H]);)H++;const J=H===this.c?null:this.g.slice(this.c,H);return this.c=H,J}takeFromEndWhile(_){let H=this.d;for(;H>=0&&_(this.g[H]);)H--;const J=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const H=this.g.slice(this.c,this.c+_);return this.c+=_,H}}e.$_b=T;class B{static{this.empty=new B(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(H=>(_(H),!0))}toArray(){const _=[];return this.iterate(H=>(_.push(H),!0)),_}filter(_){return new B(H=>this.iterate(J=>_(J)?H(J):!0))}map(_){return new B(H=>this.iterate(J=>H(_(J))))}some(_){let H=!1;return this.iterate(J=>(H=_(J),!H)),H}findFirst(_){let H;return this.iterate(J=>_(J)?(H=J,!1):!0),H}findLast(_){let H;return this.iterate(J=>(_(J)&&(H=J),!0)),H}findLastMaxBy(_){let H,J=!0;return this.iterate(ie=>((J||re.isGreaterThan(_(ie,H)))&&(J=!1,H=ie),!0)),H}}e.$ac=B}),define(le[126],he([0,1,7]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function L(k,g){if(!k)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=L;function A(k,g="Unreachable"){throw new Error(g)}e.$6c=A;function j(k){if(!k)throw new O.$cb("Assertion Failed")}e.$7c=j;function I(k){if(!k()){debugger;k(),(0,O.$1)(new O.$cb("Assertion Failed"))}}e.$8c=I;function C(k,g){let P=0;for(;P<k.length-1;){const S=k[P],$=k[P+1];if(!g(S,$))return!1;P++}return!0}e.$9c=C}),define(le[86],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function O(L,A){const j=this;let I=!1,C;return function(){if(I)return C;if(I=!0,A)try{C=L.apply(j,arguments)}finally{A()}else C=L.apply(j,arguments);return C}}e.$db=O}),define(le[61],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(L){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}L.is=A;const j=Object.freeze([]);function I(){return j}L.empty=I;function*C(i){yield i}L.single=C;function k(i){return A(i)?i:C(i)}L.wrap=k;function g(i){return i||j}L.from=g;function*P(i){for(let o=i.length-1;o>=0;o--)yield i[o]}L.reverse=P;function S(i){return!i||i[Symbol.iterator]().next().done===!0}L.isEmpty=S;function $(i){return i[Symbol.iterator]().next().value}L.first=$;function l(i,o){for(const s of i)if(o(s))return!0;return!1}L.some=l;function d(i,o){for(const s of i)if(o(s))return s}L.find=d;function*y(i,o){for(const s of i)o(s)&&(yield s)}L.filter=y;function*w(i,o){let s=0;for(const n of i)yield o(n,s++)}L.map=w;function*c(...i){for(const o of i)yield*o}L.concat=c;function f(i,o,s){let n=s;for(const t of i)n=o(n,t);return n}L.reduce=f;function*m(i,o,s=i.length){for(o<0&&(o+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);o<s;o++)yield i[o]}L.slice=m;function h(i,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,i];const n=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=n.next();if(r.done)return[s,L.empty()];s.push(r.value)}return[s,{[Symbol.iterator](){return n}}]}L.consume=h;async function v(i){const o=[];for await(const s of i)o.push(s);return Promise.resolve(o)}L.asyncToArray=v})(O||(e.Iterable=O={}))}),define(le[34],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var j;(function(i){i.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function I(i,o=!1){let s=0;const n=i.length;let t="",r=0,a=16,E=0;function b(q){let Y=0,K=0;for(;Y<q;){const x=i.charCodeAt(s);if(x>=48&&x<=57)K=K*16+x-48;else if(x>=65&&x<=70)K=K*16+x-65+10;else if(x>=97&&x<=102)K=K*16+x-97+10;else break;s++,Y++}return Y<q&&(K=-1),K}function u(q){s=q,t="",r=0,a=16,E=0}function p(){const q=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&g(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&g(i.charCodeAt(s)))for(s++;s<i.length&&g(i.charCodeAt(s));)s++;else return E=3,i.substring(q,s);let Y=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&g(i.charCodeAt(s))){for(s++;s<i.length&&g(i.charCodeAt(s));)s++;Y=s}else E=3;return i.substring(q,Y)}function R(){let q="",Y=s;for(;;){if(s>=n){q+=i.substring(Y,s),E=2;break}const K=i.charCodeAt(s);if(K===34){q+=i.substring(Y,s),s++;break}if(K===92){if(q+=i.substring(Y,s),s++,s>=n){E=2;break}switch(i.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const V=b(4);V>=0?q+=String.fromCharCode(V):E=4;break}default:E=5}Y=s;continue}if(K>=0&&K<=31)if(k(K)){q+=i.substring(Y,s),E=2;break}else E=6;s++}return q}function N(){if(t="",E=0,r=s,s>=n)return r=n,a=17;let q=i.charCodeAt(s);if(C(q)){do s++,t+=String.fromCharCode(q),q=i.charCodeAt(s);while(C(q));return a=15}if(k(q))return s++,t+=String.fromCharCode(q),q===13&&i.charCodeAt(s)===10&&(s++,t+=`
`),a=14;switch(q){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,t=R(),a=10;case 47:{const Y=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<n&&!k(i.charCodeAt(s));)s++;return t=i.substring(Y,s),a=12}if(i.charCodeAt(s+1)===42){s+=2;const K=n-1;let x=!1;for(;s<K;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,x=!0;break}s++}return x||(s++,E=1),t=i.substring(Y,s),a=13}return t+=String.fromCharCode(q),s++,a=16}case 45:if(t+=String.fromCharCode(q),s++,s===n||!g(i.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;s<n&&F(q);)s++,q=i.charCodeAt(s);if(r!==s){switch(t=i.substring(r,s),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(q),s++,a=16}}function F(q){if(C(q)||k(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let q;do q=N();while(q>=12&&q<=15);return q}return{setPosition:u,getPosition:()=>s,scan:o?M:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>E}}e.$_m=I;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function k(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function S(i,o){const s=[],n=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function E(b,u,p,R){r.value=b,r.offset=u,r.length=p,r.type=R,r.colonOffset=void 0,t=r}try{m(i,{onObjectBegin:(b,u)=>{if(o<=b)throw n;t=void 0,a=o>b,s.push("")},onObjectProperty:(b,u,p)=>{if(o<u||(E(b,u,p,"property"),s[s.length-1]=b,o<=u+p))throw n},onObjectEnd:(b,u)=>{if(o<=b)throw n;t=void 0,s.pop()},onArrayBegin:(b,u)=>{if(o<=b)throw n;t=void 0,s.push(0)},onArrayEnd:(b,u)=>{if(o<=b)throw n;t=void 0,s.pop()},onLiteralValue:(b,u,p)=>{if(o<u||(E(b,u,p,v(b)),o<=u+p))throw n},onSeparator:(b,u,p)=>{if(o<=u)throw n;if(b===":"&&t&&t.type==="property")t.colonOffset=u,a=!1,t=void 0;else if(b===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(a=!0,s[s.length-1]=""),t=void 0}}})}catch(b){if(b!==n)throw b}return{path:s,previousNode:t,isAtPropertyKey:a,matches:b=>{let u=0;for(let p=0;u<b.length&&p<s.length;p++)if(b[u]===s[p]||b[u]==="*")u++;else if(b[u]!=="**")return!1;return u===b.length}}}e.$an=S;function $(i,o=[],s=j.DEFAULT){let n=null,t=[];const r=[];function a(b){Array.isArray(t)?t.push(b):n!==null&&(t[n]=b)}return m(i,{onObjectBegin:()=>{const b={};a(b),r.push(t),t=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const b=[];a(b),r.push(t),t=b,n=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(b,u,p)=>{o.push({error:b,offset:u,length:p})}},s),t[0]}e.$bn=$;function l(i,o=[],s=j.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(b){n.type==="property"&&(n.length=b-n.offset,n=n.parent)}function r(b){return n.children.push(b),b}m(i,{onObjectBegin:b=>{n=r({type:"object",offset:b,length:-1,parent:n,children:[]})},onObjectProperty:(b,u,p)=>{n=r({type:"property",offset:u,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:b,offset:u,length:p,parent:n})},onObjectEnd:(b,u)=>{n.length=b+u-n.offset,n=n.parent,t(b+u)},onArrayBegin:(b,u)=>{n=r({type:"array",offset:b,length:-1,parent:n,children:[]})},onArrayEnd:(b,u)=>{n.length=b+u-n.offset,n=n.parent,t(b+u)},onLiteralValue:(b,u,p)=>{r({type:v(b),offset:u,length:p,parent:n,value:b}),t(u+p)},onSeparator:(b,u,p)=>{n.type==="property"&&(b===":"?n.colonOffset=u:b===","&&t(u))},onError:(b,u,p)=>{o.push({error:b,offset:u,length:p})}},s);const E=n.children[0];return E&&delete E.parent,E}e.$cn=l;function d(i,o){if(!i)return;let s=i;for(const n of o)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let t=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===n){s=r.children[1],t=!0;break}if(!t)return}else{const t=n;if(s.type!=="array"||t<0||!Array.isArray(s.children)||t>=s.children.length)return;s=s.children[t]}return s}e.$dn=d;function y(i){if(!i.parent||!i.parent.children)return[];const o=y(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}e.$en=y;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const o=Object.create(null);for(const s of i.children){const n=s.children[1];n&&(o[s.children[0].value]=w(n))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$fn=w;function c(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}e.$gn=c;function f(i,o,s=!1){if(c(i,o,s)){const n=i.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=o;t++){const r=f(n[t],o,s);if(r)return r}return i}}e.$hn=f;function m(i,o,s=j.DEFAULT){const n=I(i,!1);function t(ee){return ee?()=>ee(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),E=r(o.onObjectProperty),b=t(o.onObjectEnd),u=t(o.onArrayBegin),p=t(o.onArrayEnd),R=r(o.onLiteralValue),N=r(o.onSeparator),F=t(o.onComment),M=r(o.onError),q=s&&s.disallowComments,Y=s&&s.allowTrailingComma;function K(){for(;;){const ee=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ee){case 12:case 13:q?x(10):F();break;case 16:x(1);break;case 15:case 14:break;default:return ee}}}function x(ee,ae=[],Z=[]){if(M(ee),ae.length+Z.length>0){let z=n.getToken();for(;z!==17;){if(ae.indexOf(z)!==-1){K();break}else if(Z.indexOf(z)!==-1)break;z=K()}}}function V(ee){const ae=n.getTokenValue();return ee?R(ae):E(ae),K(),!0}function Q(){switch(n.getToken()){case 11:{let ee=0;try{ee=JSON.parse(n.getTokenValue()),typeof ee!="number"&&(x(2),ee=0)}catch{x(2)}R(ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return K(),!0}function W(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(N(":"),K(),re()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function G(){a(),K();let ee=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ee||x(4,[],[]),N(","),K(),n.getToken()===2&&Y)break}else ee&&x(6,[],[]);W()||x(4,[],[2,5]),ee=!0}return b(),n.getToken()!==2?x(7,[2],[]):K(),!0}function te(){u(),K();let ee=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ee||x(4,[],[]),N(","),K(),n.getToken()===4&&Y)break}else ee&&x(6,[],[]);re()||x(4,[],[4,5]),ee=!0}return p(),n.getToken()!==4?x(8,[4],[]):K(),!0}function re(){switch(n.getToken()){case 3:return te();case 1:return G();case 10:return V(!0);default:return Q()}}return K(),n.getToken()===17?s.allowEmptyContent?!0:(x(4,[],[]),!1):re()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$in=m;function h(i,o){const s=I(i),n=[];let t,r=0,a;do switch(a=s.getPosition(),t=s.scan(),t){case 12:case 13:case 17:r!==a&&n.push(i.substring(r,a)),o!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,o)),r=s.getPosition();break}while(t!==17);return n.join("")}e.$jn=h;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$kn=v}),define(le[42],he([0,1,34]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=void 0;function L(g,P,S){let $,l,d,y,w;if(P){for(y=P.offset,w=y+P.length,d=y;d>0&&!k(g,d-1);)d--;let a=w;for(;a<g.length&&!k(g,a);)a++;l=g.substring(d,a),$=I(l,S)}else l=g,$=0,d=0,y=0,w=g.length;const c=C(S,g);let f=!1,m=0,h;S.insertSpaces?h=j(" ",S.tabSize||4):h="	";const v=(0,O.$_m)(l,!1);let i=!1;function o(){return c+j(h,$+m)}function s(){let a=v.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=v.scan();return i=a===16||v.getTokenError()!==0,a}const n=[];function t(a,E,b){!i&&E<w&&b>y&&g.substring(E,b)!==a&&n.push({offset:E,length:b-E,content:a})}let r=s();if(r!==17){const a=v.getTokenOffset()+d,E=j(h,$);t(E,d,a)}for(;r!==17;){let a=v.getTokenOffset()+v.getTokenLength()+d,E=s(),b="";for(;!f&&(E===12||E===13);){const p=v.getTokenOffset()+d;t(" ",a,p),a=v.getTokenOffset()+v.getTokenLength()+d,b=E===12?o():"",E=s()}if(E===2)r!==1&&(m--,b=o());else if(E===4)r!==3&&(m--,b=o());else{switch(r){case 3:case 1:m++,b=o();break;case 5:case 12:b=o();break;case 13:f?b=o():b=" ";break;case 6:b=" ";break;case 10:if(E===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?b=" ":E!==5&&E!==17&&(i=!0);break;case 16:i=!0;break}f&&(E===12||E===13)&&(b=o())}const u=v.getTokenOffset()+d;t(b,a,u),r=E}return n}e.$ln=L;function A(g,P){const S=JSON.stringify(g,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?S.replace(/\r\n|\r|\n/g,P.eol):S}e.$mn=A;function j(g,P){let S="";for(let $=0;$<P;$++)S+=g;return S}function I(g,P){let S=0,$=0;const l=P.tabSize||4;for(;S<g.length;){const d=g.charAt(S);if(d===" ")$++;else if(d==="	")$+=l;else break;S++}return Math.floor($/l)}function C(g,P){for(let S=0;S<P.length;S++){const $=P.charAt(S);if($==="\r")return S+1<P.length&&P.charAt(S+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return g&&g.eol||`
`}e.$nn=C;function k(g,P){return`\r
`.indexOf(g.charAt(P))!==-1}e.$on=k}),define(le[62],he([0,1,34,42]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function A(g,P,S){return j(g,P,void 0,S)}e.$pn=A;function j(g,P,S,$,l){const d=P.slice(),y=[],w=(0,O.$cn)(g,y);let c,f;for(;d.length>0&&(f=d.pop(),c=(0,O.$dn)(w,d),c===void 0&&S!==void 0);)typeof f=="string"?S={[f]:S}:S=[S];if(c)if(c.type==="object"&&typeof f=="string"&&Array.isArray(c.children)){const m=(0,O.$dn)(c,[f]);if(m!==void 0)if(S===void 0){if(!m.parent)throw new Error("Malformed AST");const h=c.children.indexOf(m.parent);let v,i=m.parent.offset+m.parent.length;if(h>0){const o=c.children[h-1];v=o.offset+o.length}else v=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return I(g,{offset:v,length:i-v,content:""},$)}else return I(g,{offset:m.offset,length:m.length,content:JSON.stringify(S)},$);else{if(S===void 0)return[];const h=`${JSON.stringify(f)}: ${JSON.stringify(S)}`,v=l?l(c.children.map(o=>o.children[0].value)):c.children.length;let i;if(v>0){const o=c.children[v-1];i={offset:o.offset+o.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return I(g,i,$)}}else if(c.type==="array"&&typeof f=="number"&&Array.isArray(c.children))if(S!==void 0){const m=`${JSON.stringify(S)}`;let h;if(c.children.length===0||f===0)h={offset:c.offset+1,length:0,content:c.children.length===0?m:m+","};else{const v=f===-1||f>c.children.length?c.children.length:f,i=c.children[v-1];h={offset:i.offset+i.length,length:0,content:","+m}}return I(g,h,$)}else{const m=f,h=c.children[m];let v;if(c.children.length===1)v={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===m){const i=c.children[m-1],o=i.offset+i.length,s=c.offset+c.length;v={offset:o,length:s-2-o,content:""}}else v={offset:h.offset,length:c.children[m+1].offset-h.offset,content:""};return I(g,v,$)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${c.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return I(g,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(S)},$)}}e.$qn=j;function I(g,P,S){let $=C(g,P),l=P.offset,d=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;l>0&&!(0,L.$on)($,l-1);)l--;for(;d<$.length&&!(0,L.$on)($,d);)d++}const y=(0,L.$ln)($,{offset:l,length:d-l},S);for(let c=y.length-1;c>=0;c--){const f=y[c];$=C($,f),l=Math.min(l,f.offset),d=Math.max(d,f.offset+f.length),d+=f.content.length-f.length}const w=g.length-($.length-d)-l;return[{offset:l,length:w,content:$.substring(l,d)}]}e.$rn=I;function C(g,P){return g.substring(0,P.offset)+P.content+g.substring(P.offset+P.length)}e.$sn=C;function k(g,P){const S=P.slice(0).sort((l,d)=>{const y=l.offset-d.offset;return y===0?l.length-d.length:y});let $=g.length;for(let l=S.length-1;l>=0;l--){const d=S[l];if(d.offset+d.length<=$)g=C(g,d);else throw new Error("Overlapping edit");$=d.offset}return g}e.$tn=k}),define(le[52],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class O{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=O}),define(le[87],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class O{static{this.Undefined=new O(void 0)}constructor(j){this.element=j,this.next=O.Undefined,this.prev=O.Undefined}}class L{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let j=this.a;for(;j!==O.Undefined;){const I=j.next;j.prev=O.Undefined,j.next=O.Undefined,j=I}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,I){const C=new O(j);if(this.a===O.Undefined)this.a=C,this.b=C;else if(I){const g=this.b;this.b=C,C.prev=g,g.next=C}else{const g=this.a;this.a=C,C.next=g,g.prev=C}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(C))}}shift(){if(this.a!==O.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==O.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==O.Undefined&&j.next!==O.Undefined){const I=j.prev;I.next=j.next,j.next.prev=I}else j.prev===O.Undefined&&j.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):j.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):j.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==O.Undefined;)yield j.element,j=j.next}}e.$4c=L}),define(le[35],he([0,1]),function(ne,e){"use strict";var O,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function j(m,h,v){let i=m.get(h);return i===void 0&&(i=v,m.set(h,i)),i}e.$xc=j;function I(m){const h=[];return m.forEach((v,i)=>{h.push(`${i} => ${v}`)}),`Map(${m.size}) {${h.join(", ")}}`}e.$yc=I;function C(m){const h=[];return m.forEach(v=>{h.push(v)}),`Set(${m.size}) {${h.join(", ")}}`}e.$zc=C;class k{constructor(h,v){this.uri=h,this.value=v}}function g(m){return Array.isArray(m)}class P{static{this.c=h=>h.toString()}constructor(h,v){if(this[O]="ResourceMap",h instanceof P)this.d=new Map(h.d),this.e=v??P.c;else if(g(h)){this.d=new Map,this.e=v??P.c;for(const[i,o]of h)this.set(i,o)}else this.d=new Map,this.e=h??P.c}set(h,v){return this.d.set(this.e(h),new k(h,v)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,v){typeof v<"u"&&(h=h.bind(v));for(const[i,o]of this.d)h(o.value,o.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Ac=P;class S{constructor(h,v){this[L]="ResourceSet",!h||typeof h=="function"?this.c=new P(h):(this.c=new P(v),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,v){this.c.forEach((i,o)=>h.call(v,o,o,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var $;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})($||(e.Touch=$={}));class l{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,v=0){const i=this.c.get(h);if(i)return v!==0&&this.l(i,v),i.value}set(h,v,i=0){let o=this.c.get(h);if(o)o.value=v,i!==0&&this.l(o,i);else{switch(o={key:h,value:v,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(h,o),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const v=this.c.get(h);if(v)return this.c.delete(h),this.k(v),this.f--,v.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.k(h),this.f--,h.value}forEach(h,v){const i=this.g;let o=this.d;for(;o;){if(v?h.bind(v)(o.value,o.key,this):h(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const h=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(h.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const s={value:i.key,done:!1};return i=i.next,s}else return{value:void 0,done:!0}}};return o}values(){const h=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(h.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const s={value:i.value,done:!1};return i=i.next,s}else return{value:void 0,done:!0}}};return o}entries(){const h=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(h.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const s={value:[i.key,i.value],done:!1};return i=i.next,s}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let v=this.d,i=this.size;for(;v&&i>h;)this.c.delete(v.key),v=v.next,i--;this.d=v,this.f=i,v&&(v.previous=void 0),this.g++}i(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}j(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}k(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const v=h.next,i=h.previous;if(!v||!i)throw new Error("Invalid list");v.previous=i,i.next=v}h.next=void 0,h.previous=void 0,this.g++}l(h,v){if(!this.d||!this.e)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(h===this.d)return;const i=h.next,o=h.previous;h===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(v===2){if(h===this.e)return;const i=h.next,o=h.previous;h===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((v,i)=>{h.push([i,v])}),h}fromJSON(h){this.clear();for(const[v,i]of h)this.set(v,i)}}e.$Cc=l;class d extends l{constructor(h,v=1){super(),this.m=h,this.n=Math.min(Math.max(0,v),1)}get limit(){return this.m}set limit(h){this.m=h,this.o()}get ratio(){return this.n}set ratio(h){this.n=Math.min(Math.max(0,h),1),this.o()}get(h,v=2){return super.get(h,v)}peek(h){return super.get(h,0)}set(h,v){return super.set(h,v,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=d;class y{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let v=this.c.get(h)||0;return v===0?!1:(v--,v===0?this.c.delete(h):this.c.set(h,v),!0)}has(h){return this.c.has(h)}}e.$Ec=y;class w{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[v,i]of h)this.set(v,i)}clear(){this.c.clear(),this.d.clear()}set(h,v){this.c.set(h,v),this.d.set(v,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const v=this.c.get(h);return v===void 0?!1:(this.c.delete(h),this.d.delete(v),!0)}forEach(h,v){this.c.forEach((i,o)=>{h.call(v,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class c{constructor(){this.c=new Map}add(h,v){let i=this.c.get(h);i||(i=new Set,this.c.set(h,i)),i.add(v)}delete(h,v){const i=this.c.get(h);i&&(i.delete(v),i.size===0&&this.c.delete(h))}forEach(h,v){const i=this.c.get(h);i&&i.forEach(v)}get(h){const v=this.c.get(h);return v||new Set}}e.$Gc=c;function f(m,h){if(m===h)return!0;if(m.size!==h.size)return!1;for(const[v,i]of m)if(!h.has(v)||h.get(v)!==i)return!1;for(const[v]of h)if(!m.has(v))return!1;return!0}e.$Hc=f}),define(le[2],he([0,1,17,125,35,86,61]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const C=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c(R){let N=this.b.get(R);return N||(N={parent:null,source:null,isSingleton:!1,value:R,idx:g.a++},this.b.set(R,N)),N}trackDisposable(R){const N=this.c(R);N.source||(N.source=new Error().stack)}setParent(R,N){const F=this.c(R);F.parent=N}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,N){const F=N.get(R);if(F)return F;const M=R.parent?this.f(this.c(R.parent),N):R;return N.set(R,M),M}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,R).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(R=10,N){let F;if(N)F=N;else{const x=new Map,V=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,x).isSingleton);if(V.length===0)return;const Q=new Set(V.map(W=>W.value));if(F=V.filter(W=>!(W.parent&&Q.has(W.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(x){function V(W,G){for(;W.length>0&&G.some(te=>typeof te=="string"?te===W[0]:W[0].match(te));)W.shift()}const Q=x.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return V(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const q=new A.$Gc;for(const x of F){const V=M(x);for(let Q=0;Q<=V.length;Q++)q.add(V.slice(0,Q).join(`
`),x)}F.sort((0,O.$7b)(x=>x.idx,O.$9b));let Y="",K=0;for(const x of F.slice(0,R)){K++;const V=M(x),Q=[];for(let W=0;W<V.length;W++){let G=V[W];G=`(shared with ${q.get(V.slice(0,W+1).join(`
`)).size}/${F.length} leaks) at ${G}`;const re=q.get(V.slice(0,W).join(`
`)),ee=(0,L.$K)([...re].map(ae=>M(ae)[W]),ae=>ae);delete ee[V[W]];for(const[ae,Z]of Object.entries(ee))Q.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${ae}`);Q.unshift(G)}Y+=`


==================== Leaking disposable ${K}/${F.length}: ${x.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return F.length>R&&(Y+=`


... and ${F.length-R} more leaking disposables

`),{leaks:F,details:Y}}}e.$Ic=g;function P(p){k=p}if(e.$Jc=P,C){const p="__is_disposable_tracked__";P(new class{trackDisposable(R){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[p]||console.log(N)},3e3)}setParent(R,N){if(R&&R!==i.None)try{R[p]=!0}catch{}}markAsDisposed(R){if(R&&R!==i.None)try{R[p]=!0}catch{}}markAsSingleton(R){}})}function S(p){return k?.trackDisposable(p),p}e.$Kc=S;function $(p){k?.markAsDisposed(p)}e.$Lc=$;function l(p,R){k?.setParent(p,R)}function d(p,R){if(k)for(const N of p)k.setParent(N,R)}function y(p){return k?.markAsSingleton(p),p}e.$Mc=y;function w(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.$Nc=w;function c(p){if(I.Iterable.is(p)){const R=[];for(const N of p)if(N)try{N.dispose()}catch(F){R.push(F)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.$Oc=c;function f(p){for(const R of p)w(R)&&R.dispose();return[]}e.$Pc=f;function m(...p){const R=h(()=>c(p));return d(p,R),R}e.$Qc=m;function h(p){const R=S({dispose:(0,j.$db)(()=>{$(R),p()})});return R}e.$Rc=h;class v{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return l(R,this),this.g?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),l(R,null))}}e.$Sc=v;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new v,S(this),l(this.q,this)}dispose(){$(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Tc=i;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&l(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&l(R,null),R}}e.$Uc=o;class s{constructor(R){this.a=new o,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class n{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=n;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(R){let N=R;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,$(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(R,...N){let F=this.a.get(R);F||(F={counter:0,object:this.b(R,...N)},this.a.set(R,F));const{object:M}=F,q=(0,j.$db)(()=>{--F.counter===0&&(this.c(R,F.object),this.a.delete(R))});return F.counter++,{object:M,dispose:q}}}e.$Yc=r;class a{constructor(R){this.a=R}async acquire(R,...N){const F=this.a.acquire(R,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.$Zc=a;class E{constructor(R){this.object=R}dispose(){}}e.$1c=E;function b(p){const R=new v;try{p(R)}finally{R.dispose()}}e.$2c=b;class u{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,N,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(R)?.dispose(),this.a.set(R,N)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=u}),define(le[88],he([0,1,35]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=e.$Fl=void 0;const L=new O.$Dc(1e4);function A(g){return k(g,"NFC",L)}e.$Fl=A;const j=new O.$Dc(1e4);function I(g){return k(g,"NFD",j)}e.$Gl=I;const C=/[^\u0000-\u0080]/;function k(g,P,S){if(!g)return g;const $=S.get(g);if($)return $;let l;return C.test(g)?l=g.normalize(P):l=g,S.set(g,l),l}e.$Hl=function(){const g=/[\u0300-\u036f]/g;return function(P){return I(P).replace(g,"")}}()}),function(){function ne(A){const j=[];typeof A=="number"&&j.push("code/timeOrigin",A);function I(k){j.push(k,Date.now())}function C(){const k=[];for(let g=0;g<j.length;g+=2)k.push({name:j[g],startTime:j[g+1]});return k}return{mark:I,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const I of performance.getEntriesByType("mark"))j.push({name:I.name,startTime:Math.round(A+I.startTime)});return j}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function O(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=O(L))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var L in O)(typeof exports=="object"?exports:ne)[L]=O[L]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function O(L){if(e[L])return e[L].exports;var A=e[L]={i:L,l:!1,exports:{}};return ne[L].call(A.exports,A,A.exports,O),A.l=!0,A.exports}return O.m=ne,O.c=e,O.d=function(L,A,j){O.o(L,A)||Object.defineProperty(L,A,{enumerable:!0,get:j})},O.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},O.t=function(L,A){if(1&A&&(L=O(L)),8&A||4&A&&typeof L=="object"&&L&&L.__esModule)return L;var j=Object.create(null);if(O.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:L}),2&A&&typeof L!="string")for(var I in L)O.d(j,I,function(C){return L[C]}.bind(null,I));return j},O.n=function(L){var A=L&&L.__esModule?function(){return L.default}:function(){return L};return O.d(A,"a",A),A},O.o=function(L,A){return Object.prototype.hasOwnProperty.call(L,A)},O.p="",O(O.s=0)}([function(ne,e,O){(function(L){var A;e=ne.exports=Z,A=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],k=e.src=[],g=0,P=g++;k[P]="0|[1-9]\\d*";var S=g++;k[S]="[0-9]+";var $=g++;k[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=g++;k[l]="("+k[P]+")\\.("+k[P]+")\\.("+k[P]+")";var d=g++;k[d]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var y=g++;k[y]="(?:"+k[P]+"|"+k[$]+")";var w=g++;k[w]="(?:"+k[S]+"|"+k[$]+")";var c=g++;k[c]="(?:-("+k[y]+"(?:\\."+k[y]+")*))";var f=g++;k[f]="(?:-?("+k[w]+"(?:\\."+k[w]+")*))";var m=g++;k[m]="[0-9A-Za-z-]+";var h=g++;k[h]="(?:\\+("+k[m]+"(?:\\."+k[m]+")*))";var v=g++,i="v?"+k[l]+k[c]+"?"+k[h]+"?";k[v]="^"+i+"$";var o="[v=\\s]*"+k[d]+k[f]+"?"+k[h]+"?",s=g++;k[s]="^"+o+"$";var n=g++;k[n]="((?:<|>)?=?)";var t=g++;k[t]=k[S]+"|x|X|\\*";var r=g++;k[r]=k[P]+"|x|X|\\*";var a=g++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[c]+")?"+k[h]+"?)?)?";var E=g++;k[E]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[f]+")?"+k[h]+"?)?)?";var b=g++;k[b]="^"+k[n]+"\\s*"+k[a]+"$";var u=g++;k[u]="^"+k[n]+"\\s*"+k[E]+"$";var p=g++;k[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;k[R]="(?:~>?)";var N=g++;k[N]="(\\s*)"+k[R]+"\\s+",C[N]=new RegExp(k[N],"g");var F=g++;k[F]="^"+k[R]+k[a]+"$";var M=g++;k[M]="^"+k[R]+k[E]+"$";var q=g++;k[q]="(?:\\^)";var Y=g++;k[Y]="(\\s*)"+k[q]+"\\s+",C[Y]=new RegExp(k[Y],"g");var K=g++;k[K]="^"+k[q]+k[a]+"$";var x=g++;k[x]="^"+k[q]+k[E]+"$";var V=g++;k[V]="^"+k[n]+"\\s*("+o+")$|^$";var Q=g++;k[Q]="^"+k[n]+"\\s*("+i+")$|^$";var W=g++;k[W]="(\\s*)"+k[n]+"\\s*("+o+"|"+k[a]+")",C[W]=new RegExp(k[W],"g");var G=g++;k[G]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var te=g++;k[te]="^\\s*("+k[E]+")\\s+-\\s+("+k[E]+")\\s*$";var re=g++;k[re]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)A(ee,k[ee]),C[ee]||(C[ee]=new RegExp(k[ee]));function ae(ue,me){if(ue instanceof Z)return ue;if(typeof ue!="string"||ue.length>j||!(me?C[s]:C[v]).test(ue))return null;try{return new Z(ue,me)}catch{return null}}function Z(ue,me){if(ue instanceof Z){if(ue.loose===me)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof Z))return new Z(ue,me);A("SemVer",ue,me),this.loose=me;var be=ue.trim().match(me?C[s]:C[v]);if(!be)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<I)return Re}return Pe}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,me){var be=ae(ue,me);return be?be.version:null},e.clean=function(ue,me){var be=ae(ue.trim().replace(/^[=v]+/,""),me);return be?be.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ue){return A("SemVer.compare",this.version,this.loose,ue),ue instanceof Z||(ue=new Z(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},Z.prototype.compareMain=function(ue){return ue instanceof Z||(ue=new Z(ue,this.loose)),D(this.major,ue.major)||D(this.minor,ue.minor)||D(this.patch,ue.patch)},Z.prototype.comparePre=function(ue){if(ue instanceof Z||(ue=new Z(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var me=0;do{var be=this.prerelease[me],Pe=ue.prerelease[me];if(A("prerelease compare",me,be,Pe),be===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(be===void 0)return-1;if(be!==Pe)return D(be,Pe)}while(++me)},Z.prototype.inc=function(ue,me){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,me,be,Pe){typeof be=="string"&&(Pe=be,be=void 0);try{return new Z(ue,be).inc(me,Pe).version}catch{return null}},e.diff=function(ue,me){if(_(ue,me))return null;var be=ae(ue),Pe=ae(me);if(be.prerelease.length||Pe.prerelease.length){for(var Re in be)if((Re==="major"||Re==="minor"||Re==="patch")&&be[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in be)if((Re==="major"||Re==="minor"||Re==="patch")&&be[Re]!==Pe[Re])return Re},e.compareIdentifiers=D;var z=/^[0-9]+$/;function D(ue,me){var be=z.test(ue),Pe=z.test(me);return be&&Pe&&(ue=+ue,me=+me),be&&!Pe?-1:Pe&&!be?1:ue<me?-1:ue>me?1:0}function T(ue,me,be){return new Z(ue,be).compare(new Z(me,be))}function B(ue,me,be){return T(ue,me,be)>0}function U(ue,me,be){return T(ue,me,be)<0}function _(ue,me,be){return T(ue,me,be)===0}function H(ue,me,be){return T(ue,me,be)!==0}function J(ue,me,be){return T(ue,me,be)>=0}function ie(ue,me,be){return T(ue,me,be)<=0}function se(ue,me,be,Pe){var Re;switch(me){case"===":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Re=ue===be;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Re=ue!==be;break;case"":case"=":case"==":Re=_(ue,be,Pe);break;case"!=":Re=H(ue,be,Pe);break;case">":Re=B(ue,be,Pe);break;case">=":Re=J(ue,be,Pe);break;case"<":Re=U(ue,be,Pe);break;case"<=":Re=ie(ue,be,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function ce(ue,me){if(ue instanceof ce){if(ue.loose===me)return ue;ue=ue.value}if(!(this instanceof ce))return new ce(ue,me);A("comparator",ue,me),this.loose=me,this.parse(ue),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ue,me){return D(me,ue)},e.major=function(ue,me){return new Z(ue,me).major},e.minor=function(ue,me){return new Z(ue,me).minor},e.patch=function(ue,me){return new Z(ue,me).patch},e.compare=T,e.compareLoose=function(ue,me){return T(ue,me,!0)},e.rcompare=function(ue,me,be){return T(me,ue,be)},e.sort=function(ue,me){return ue.sort(function(be,Pe){return e.compare(be,Pe,me)})},e.rsort=function(ue,me){return ue.sort(function(be,Pe){return e.rcompare(be,Pe,me)})},e.gt=B,e.lt=U,e.eq=_,e.neq=H,e.gte=J,e.lte=ie,e.cmp=se,e.Comparator=ce;var $e={};function fe(ue,me){if(ue instanceof fe)return ue.loose===me?ue:new fe(ue.raw,me);if(ue instanceof ce)return new fe(ue.value,me);if(!(this instanceof fe))return new fe(ue,me);if(this.loose=me,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function ge(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,me,be,Pe,Re,Me,De,ze,Te,Fe,qe,oe,de){return((me=ge(be)?"":ge(Pe)?">="+be+".0.0":ge(Re)?">="+be+"."+Pe+".0":">="+me)+" "+(ze=ge(Te)?"":ge(Fe)?"<"+(+Te+1)+".0.0":ge(qe)?"<"+Te+"."+(+Fe+1)+".0":oe?"<="+Te+"."+Fe+"."+qe+"-"+oe:"<="+ze)).trim()}function Ce(ue,me){for(var be=0;be<ue.length;be++)if(!ue[be].test(me))return!1;if(me.prerelease.length){for(be=0;be<ue.length;be++)if(A(ue[be].semver),ue[be].semver!==$e&&ue[be].semver.prerelease.length>0){var Pe=ue[be].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function Oe(ue,me,be){try{me=new fe(me,be)}catch{return!1}return me.test(ue)}function Ae(ue,me,be,Pe){var Re,Me,De,ze,Te;switch(ue=new Z(ue,Pe),me=new fe(me,Pe),be){case">":Re=B,Me=ie,De=U,ze=">",Te=">=";break;case"<":Re=U,Me=J,De=B,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,me,Pe))return!1;for(var Fe=0;Fe<me.set.length;++Fe){var qe=me.set[Fe],oe=null,de=null;if(qe.forEach(function(we){we.semver===$e&&(we=new ce(">=0.0.0")),oe=oe||we,de=de||we,Re(we.semver,oe.semver,Pe)?oe=we:De(we.semver,de.semver,Pe)&&(de=we)}),oe.operator===ze||oe.operator===Te||(!de.operator||de.operator===ze)&&Me(ue,de.semver)||de.operator===Te&&De(ue,de.semver))return!1}return!0}ce.prototype.parse=function(ue){var me=this.loose?C[V]:C[Q],be=ue.match(me);if(!be)throw new TypeError("Invalid comparator: "+ue);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Z(be[2],this.loose):this.semver=$e},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(ue){return A("Comparator.test",ue,this.loose),this.semver===$e||(typeof ue=="string"&&(ue=new Z(ue,this.loose)),se(ue,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(ue,me){if(!(ue instanceof ce))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new fe(ue.value,me),Oe(this.value,be,me);if(ue.operator==="")return be=new fe(this.value,me),Oe(ue.semver,be,me);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Me=this.semver.version===ue.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),ze=se(this.semver,"<",ue.semver,me)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Te=se(this.semver,">",ue.semver,me)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||Re||Me&&De||ze||Te},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(ue){var me=this.loose;ue=ue.trim(),A("range",ue,me);var be=me?C[te]:C[G];ue=ue.replace(be,Ee),A("hyphen replace",ue),ue=ue.replace(C[W],"$1$2$3"),A("comparator trim",ue,C[W]),ue=(ue=(ue=ue.replace(C[N],"$1~")).replace(C[Y],"$1^")).split(/\s+/).join(" ");var Pe=me?C[V]:C[Q],Re=ue.split(" ").map(function(Me){return function(De,ze){return A("comp",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(qe){return function(oe,de){A("caret",oe,de);var we=de?C[x]:C[K];return oe.replace(we,function(ve,pe,ke,Ie,Le){var Ne;return A("caret",oe,ve,pe,ke,Ie,Le),ge(pe)?Ne="":ge(ke)?Ne=">="+pe+".0.0 <"+(+pe+1)+".0.0":ge(Ie)?Ne=pe==="0"?">="+pe+"."+ke+".0 <"+pe+"."+(+ke+1)+".0":">="+pe+"."+ke+".0 <"+(+pe+1)+".0.0":Le?(A("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ne=pe==="0"?ke==="0"?">="+pe+"."+ke+"."+Ie+Le+" <"+pe+"."+ke+"."+(+Ie+1):">="+pe+"."+ke+"."+Ie+Le+" <"+pe+"."+(+ke+1)+".0":">="+pe+"."+ke+"."+Ie+Le+" <"+(+pe+1)+".0.0"):(A("no pr"),Ne=pe==="0"?ke==="0"?">="+pe+"."+ke+"."+Ie+" <"+pe+"."+ke+"."+(+Ie+1):">="+pe+"."+ke+"."+Ie+" <"+pe+"."+(+ke+1)+".0":">="+pe+"."+ke+"."+Ie+" <"+(+pe+1)+".0.0"),A("caret return",Ne),Ne})}(qe,Fe)}).join(" ")}(De,ze),A("caret",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(qe){return function(oe,de){var we=de?C[M]:C[F];return oe.replace(we,function(ve,pe,ke,Ie,Le){var Ne;return A("tilde",oe,ve,pe,ke,Ie,Le),ge(pe)?Ne="":ge(ke)?Ne=">="+pe+".0.0 <"+(+pe+1)+".0.0":ge(Ie)?Ne=">="+pe+"."+ke+".0 <"+pe+"."+(+ke+1)+".0":Le?(A("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ne=">="+pe+"."+ke+"."+Ie+Le+" <"+pe+"."+(+ke+1)+".0"):Ne=">="+pe+"."+ke+"."+Ie+" <"+pe+"."+(+ke+1)+".0",A("tilde return",Ne),Ne})}(qe,Fe)}).join(" ")}(De,ze),A("tildes",De),De=function(Te,Fe){return A("replaceXRanges",Te,Fe),Te.split(/\s+/).map(function(qe){return function(oe,de){oe=oe.trim();var we=de?C[u]:C[b];return oe.replace(we,function(ve,pe,ke,Ie,Le,Ne){A("xRange",oe,ve,pe,ke,Ie,Le,Ne);var Ge=ge(ke),Ue=Ge||ge(Ie),Be=Ue||ge(Le);return pe==="="&&Be&&(pe=""),Ge?ve=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Be?(Ue&&(Ie=0),Be&&(Le=0),pe===">"?(pe=">=",Ue?(ke=+ke+1,Ie=0,Le=0):Be&&(Ie=+Ie+1,Le=0)):pe==="<="&&(pe="<",Ue?ke=+ke+1:Ie=+Ie+1),ve=pe+ke+"."+Ie+"."+Le):Ue?ve=">="+ke+".0.0 <"+(+ke+1)+".0.0":Be&&(ve=">="+ke+"."+Ie+".0 <"+ke+"."+(+Ie+1)+".0"),A("xRange return",ve),ve})}(qe,Fe)}).join(" ")}(De,ze),A("xrange",De),De=function(Te,Fe){return A("replaceStars",Te,Fe),Te.trim().replace(C[re],"")}(De,ze),A("stars",De),De}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Me){return!!Me.match(Pe)})),Re=Re.map(function(Me){return new ce(Me,me)})},fe.prototype.intersects=function(ue,me){if(!(ue instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Pe){return ue.set.some(function(Re){return Re.every(function(Me){return Pe.intersects(Me,me)})})})})},e.toComparators=function(ue,me){return new fe(ue,me).set.map(function(be){return be.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new Z(ue,this.loose));for(var me=0;me<this.set.length;me++)if(Ce(this.set[me],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,me,be){var Pe=null,Re=null;try{var Me=new fe(me,be)}catch{return null}return ue.forEach(function(De){Me.test(De)&&(Pe&&Re.compare(De)!==-1||(Re=new Z(Pe=De,be)))}),Pe},e.minSatisfying=function(ue,me,be){var Pe=null,Re=null;try{var Me=new fe(me,be)}catch{return null}return ue.forEach(function(De){Me.test(De)&&(Pe&&Re.compare(De)!==1||(Re=new Z(Pe=De,be)))}),Pe},e.validRange=function(ue,me){try{return new fe(ue,me).range||"*"}catch{return null}},e.ltr=function(ue,me,be){return Ae(ue,me,"<",be)},e.gtr=function(ue,me,be){return Ae(ue,me,">",be)},e.outside=Ae,e.prerelease=function(ue,me){var be=ae(ue,me);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ue,me,be){return ue=new fe(ue,be),me=new fe(me,be),ue.intersects(me)},e.coerce=function(ue){if(ue instanceof Z)return ue;if(typeof ue!="string")return null;var me=ue.match(C[p]);return me==null?null:ae((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,O(1))},function(ne,e){var O,L,A=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function C(w){if(O===setTimeout)return setTimeout(w,0);if((O===j||!O)&&setTimeout)return O=setTimeout,setTimeout(w,0);try{return O(w,0)}catch{try{return O.call(null,w,0)}catch{return O.call(this,w,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:j}catch{O=j}try{L=typeof clearTimeout=="function"?clearTimeout:I}catch{L=I}})();var k,g=[],P=!1,S=-1;function $(){P&&k&&(P=!1,k.length?g=k.concat(g):S=-1,g.length&&l())}function l(){if(!P){var w=C($);P=!0;for(var c=g.length;c;){for(k=g,g=[];++S<c;)k&&k[S].run();S=-1,c=g.length}k=null,P=!1,function(f){if(L===clearTimeout)return clearTimeout(f);if((L===I||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(f);try{L(f)}catch{try{return L.call(null,f)}catch{return L.call(this,f)}}}(w)}}function d(w,c){this.fun=w,this.array=c}function y(){}A.nextTick=function(w){var c=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)c[f-1]=arguments[f];g.push(new d(w,c)),g.length!==1||P||C(l)},d.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=y,A.addListener=y,A.once=y,A.off=y,A.removeListener=y,A.removeAllListeners=y,A.emit=y,A.prependListener=y,A.prependOnceListener=y,A.listeners=function(w){return[]},A.binding=function(w){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(w){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[127],he([0,1]),function(ne,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;class L{constructor(C,k,g){this.level=C,this.key=k,this.value=g,this.forward=[]}}const A=void 0;class j{constructor(C,k=2**16){this.comparator=C,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new L(this.c,A,A)}get size(){return this.f}clear(){this.e=new L(this.c,A,A),this.f=0}has(C){return!!j.g(this,C,this.comparator)}get(C){return j.g(this,C,this.comparator)?.value}set(C,k){return j.h(this,C,k,this.comparator)&&(this.f+=1),this}delete(C){const k=j.k(this,C,this.comparator);return k&&(this.f-=1),k}forEach(C,k){let g=this.e.forward[0];for(;g;)C.call(k,g.value,g.key,this),g=g.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",k=this.e.forward[0];for(;k;)C+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return C}static g(C,k,g){let P=C.e;for(let S=C.d-1;S>=0;S--)for(;P.forward[S]&&g(P.forward[S].key,k)<0;)P=P.forward[S];if(P=P.forward[0],P&&g(P.key,k)===0)return P}static h(C,k,g,P){const S=[];let $=C.e;for(let l=C.d-1;l>=0;l--){for(;$.forward[l]&&P($.forward[l].key,k)<0;)$=$.forward[l];S[l]=$}if($=$.forward[0],$&&P($.key,k)===0)return $.value=g,!1;{const l=j.j(C);if(l>C.d){for(let d=C.d;d<l;d++)S[d]=C.e;C.d=l}$=new L(l,k,g);for(let d=0;d<l;d++)$.forward[d]=S[d].forward[d],S[d].forward[d]=$;return!0}}static j(C,k=.5){let g=1;for(;Math.random()<k&&g<C.c;)g+=1;return g}static k(C,k,g){const P=[];let S=C.e;for(let $=C.d-1;$>=0;$--){for(;S.forward[$]&&g(S.forward[$].key,k)<0;)S=S.forward[$];P[$]=S}if(S=S.forward[0],!S||g(S.key,k)!==0)return!1;for(let $=0;$<C.d&&P[$].forward[$]===S;$++)P[$].forward[$]=S.forward[$];for(;C.d>0&&C.e.forward[C.d-1]===A;)C.d-=1;return!0}}e.$Zr=j}),define(le[63],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qd=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(j){return new L(j)}constructor(j){this.c=O&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Qd=L}),define(le[3],he([0,1,7,86,2,87,63]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.Event=void 0;const C=!1,k=!1;var g;(function(b){b.None=()=>A.$Tc.None;function u(se){if(k){const{onDidAddListener:ce}=se,$e=d.create();let fe=0;se.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),ce?.()}}}function p(se,ce){return Q(se,()=>{},0,void 0,!0,void 0,ce)}b.defer=p;function R(se){return(ce,$e=null,fe)=>{let ge=!1,Ee;return Ee=se(Ce=>{if(!ge)return Ee?Ee.dispose():ge=!0,ce.call($e,Ce)},null,fe),ge&&Ee.dispose(),Ee}}b.once=R;function N(se,ce,$e){return x((fe,ge=null,Ee)=>se(Ce=>fe.call(ge,ce(Ce)),null,Ee),$e)}b.map=N;function F(se,ce,$e){return x((fe,ge=null,Ee)=>se(Ce=>{ce(Ce),fe.call(ge,Ce)},null,Ee),$e)}b.forEach=F;function M(se,ce,$e){return x((fe,ge=null,Ee)=>se(Ce=>ce(Ce)&&fe.call(ge,Ce),null,Ee),$e)}b.filter=M;function q(se){return se}b.signal=q;function Y(...se){return(ce,$e=null,fe)=>{const ge=(0,A.$Qc)(...se.map(Ee=>Ee(Ce=>ce.call($e,Ce))));return V(ge,fe)}}b.any=Y;function K(se,ce,$e,fe){let ge=$e;return N(se,Ee=>(ge=ce(ge,Ee),ge),fe)}b.reduce=K;function x(se,ce){let $e;const fe={onWillAddFirstListener(){$e=se(ge.fire,ge)},onDidRemoveLastListener(){$e?.dispose()}};ce||u(fe);const ge=new m(fe);return ce?.add(ge),ge.event}function V(se,ce){return ce instanceof Array?ce.push(se):ce&&ce.add(se),se}function Q(se,ce,$e=100,fe=!1,ge=!1,Ee,Ce){let Oe,Ae,ue,me=0,be;const Pe={leakWarningThreshold:Ee,onWillAddFirstListener(){Oe=se(Me=>{me++,Ae=ce(Ae,Me),fe&&!ue&&(Re.fire(Ae),Ae=void 0),be=()=>{const De=Ae;Ae=void 0,ue=void 0,(!fe||me>1)&&Re.fire(De),me=0},typeof $e=="number"?(clearTimeout(ue),ue=setTimeout(be,$e)):ue===void 0&&(ue=0,queueMicrotask(be))})},onWillRemoveListener(){ge&&me>0&&be?.()},onDidRemoveLastListener(){be=void 0,Oe.dispose()}};Ce||u(Pe);const Re=new m(Pe);return Ce?.add(Re),Re.event}b.debounce=Q;function W(se,ce=0,$e){return b.debounce(se,(fe,ge)=>fe?(fe.push(ge),fe):[ge],ce,void 0,!0,void 0,$e)}b.accumulate=W;function G(se,ce=(fe,ge)=>fe===ge,$e){let fe=!0,ge;return M(se,Ee=>{const Ce=fe||!ce(Ee,ge);return fe=!1,ge=Ee,Ce},$e)}b.latch=G;function te(se,ce,$e){return[b.filter(se,ce,$e),b.filter(se,fe=>!ce(fe),$e)]}b.split=te;function re(se,ce=!1,$e=[],fe){let ge=$e.slice(),Ee=se(Ae=>{ge?ge.push(Ae):Oe.fire(Ae)});fe&&fe.add(Ee);const Ce=()=>{ge?.forEach(Ae=>Oe.fire(Ae)),ge=null},Oe=new m({onWillAddFirstListener(){Ee||(Ee=se(Ae=>Oe.fire(Ae)),fe&&fe.add(Ee))},onDidAddFirstListener(){ge&&(ce?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return fe&&fe.add(Oe),Oe.event}b.buffer=re;function ee(se,ce){return(fe,ge,Ee)=>{const Ce=ce(new Z);return se(function(Oe){const Ae=Ce.evaluate(Oe);Ae!==ae&&fe.call(ge,Ae)},void 0,Ee)}}b.chain=ee;const ae=Symbol("HaltChainable");class Z{constructor(){this.f=[]}map(ce){return this.f.push(ce),this}forEach(ce){return this.f.push($e=>(ce($e),$e)),this}filter(ce){return this.f.push($e=>ce($e)?$e:ae),this}reduce(ce,$e){let fe=$e;return this.f.push(ge=>(fe=ce(fe,ge),fe)),this}latch(ce=($e,fe)=>$e===fe){let $e=!0,fe;return this.f.push(ge=>{const Ee=$e||!ce(ge,fe);return $e=!1,fe=ge,Ee?ge:ae}),this}evaluate(ce){for(const $e of this.f)if(ce=$e(ce),ce===ae)break;return ce}}function z(se,ce,$e=fe=>fe){const fe=(...Oe)=>Ce.fire($e(...Oe)),ge=()=>se.on(ce,fe),Ee=()=>se.removeListener(ce,fe),Ce=new m({onWillAddFirstListener:ge,onDidRemoveLastListener:Ee});return Ce.event}b.fromNodeEventEmitter=z;function D(se,ce,$e=fe=>fe){const fe=(...Oe)=>Ce.fire($e(...Oe)),ge=()=>se.addEventListener(ce,fe),Ee=()=>se.removeEventListener(ce,fe),Ce=new m({onWillAddFirstListener:ge,onDidRemoveLastListener:Ee});return Ce.event}b.fromDOMEventEmitter=D;function T(se){return new Promise(ce=>R(se)(ce))}b.toPromise=T;function B(se){const ce=new m;return se.then($e=>{ce.fire($e)},()=>{ce.fire(void 0)}).finally(()=>{ce.dispose()}),ce.event}b.fromPromise=B;function U(se,ce,$e){return ce($e),se(fe=>ce(fe))}b.runAndSubscribe=U;function _(se,ce){let $e=null;function fe(Ee){$e?.dispose(),$e=new A.$Sc,ce(Ee,$e)}fe(void 0);const ge=se(Ee=>fe(Ee));return(0,A.$Rc)(()=>{ge.dispose(),$e?.dispose()})}b.runAndSubscribeWithStore=_;class H{constructor(ce,$e){this._observable=ce,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{ce.addObserver(this)},onDidRemoveLastListener:()=>{ce.removeObserver(this)}};$e||u(fe),this.emitter=new m(fe),$e&&$e.add(this.emitter)}beginUpdate(ce){this.f++}handlePossibleChange(ce){}handleChange(ce,$e){this.g=!0}endUpdate(ce){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function J(se,ce){return new H(se,ce).emitter.event}b.fromObservable=J;function ie(se){return(ce,$e,fe)=>{let ge=0,Ee=!1;const Ce={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(se.reportChanges(),Ee&&(Ee=!1,ce.call($e)))},handlePossibleChange(){},handleChange(){Ee=!0}};se.addObserver(Ce),se.reportChanges();const Oe={dispose(){se.removeObserver(Ce)}};return fe instanceof A.$Sc?fe.add(Oe):Array.isArray(fe)&&fe.push(Oe),Oe}}b.fromObservableLight=ie})(g||(e.Event=g={}));class P{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${P.f++}`,P.all.add(this)}start(u){this.g=new I.$Qd,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$Sd=P;let S=-1;function $(b){const u=S;return S=b,{dispose(){S=u}}}e.$Td=$;class l{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.g=0}dispose(){this.f?.clear()}check(u,p){const R=this.threshold;if(R<=0||p<R)return;this.f||(this.f=new Map);const N=this.f.get(u.value)||0;if(this.f.set(u.value,N+1),this.g-=1,this.g<=0){this.g=R*.5;let F,M=0;for(const[q,Y]of this.f)(!F||M<Y)&&(F=q,M=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this.f.get(u.value)||0;this.f.set(u.value,F-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class w{constructor(u){this.value=u,this.id=y++}}const c=2,f=(b,u)=>{if(b instanceof w)u(b);else for(let p=0;p<b.length;p++){const R=b[p];R&&u(R)}};class m{constructor(u){this.w=0,this.f=u,this.g=S>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const u=this.t;queueMicrotask(()=>{f(u,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,p,R)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$Tc.None;if(this.m)return A.$Tc.None;p&&(u=u.bind(p));const N=new w(u);let F,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=d.create(),F=this.g.check(N.stack,this.w+1)),C&&(N.stack=M??d.create()),this.t?this.t instanceof w?(this.u??=new v,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,A.$Rc)(()=>{F?.(),this.x(N)});return R instanceof A.$Sc?R.add(q):Array.isArray(R)&&R.push(q),q},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,R=p.indexOf(u);if(R===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[R]=void 0;const N=this.u.current===this;if(this.w*c<=p.length){let F=0;for(let M=0;M<p.length;M++)p[M]?p[F++]=p[M]:N&&(this.u.end--,F<this.u.i&&this.u.i--);p.length=F}}y(u,p){if(!u)return;const R=this.f?.onListenerError||O.$1;if(!R){u.value(p);return}try{u.value(p)}catch(N){R(N)}}z(u){const p=u.current.t;for(;u.i<u.end;)this.y(p[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,u);else{const p=this.u;p.enqueue(this,u,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Ud=m;const h=()=>new v;e.$Vd=h;class v{constructor(){this.i=-1,this.end=0}enqueue(u,p,R){this.i=0,this.end=R,this.current=u,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends m{async fireAsync(u,p,R){if(this.t)for(this.h||(this.h=new j.$4c),f(this.t,N=>this.h.push([N.value,u]));this.h.size>0&&!p.isCancellationRequested;){const[N,F]=this.h.shift(),M=[],q={...F,token:p,waitUntil:Y=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");R&&(Y=R(Y,N)),M.push(Y)}};try{N(q)}catch(Y){(0,O.$1)(Y);continue}Object.freeze(M),await Promise.allSettled(M).then(Y=>{for(const K of Y)K.status==="rejected"&&(0,O.$1)(K.reason)})}}}e.$Wd=i;class o extends m{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new j.$4c,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$Xd=o;class s extends o{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$Yd=s;class n extends m{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$Zd=n;class t{constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const p={event:u,listener:null};this.h.push(p),this.g&&this.m(p);const R=()=>{this.g&&this.o(p);const N=this.h.indexOf(p);this.h.splice(N,1)};return(0,A.$Rc)((0,L.$db)(R))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(p=>this.f.fire(p))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$1d=t;class r{constructor(u,p,R,N){this.f=new A.$Sc;const F=this.f.add(new t),M=this.f.add(new A.$3c);function q(Y){M.set(Y,F.add(N(Y)))}for(const Y of u)q(Y);this.f.add(p(Y=>{q(Y)})),this.f.add(R(Y=>{M.deleteAndDispose(Y)})),this.event=F.event}dispose(){this.f.dispose()}}e.$2d=r;class a{constructor(){this.f=[]}wrapEvent(u){return(p,R,N)=>u(F=>{const M=this.f[this.f.length-1];M?M.push(()=>p.call(R,F)):p.call(R,F)},void 0,N)}bufferEvents(u){const p=[];this.f.push(p);const R=u();return this.f.pop(),p.forEach(N=>N()),R}}e.$3d=a;class E{constructor(){this.f=!1,this.g=g.None,this.h=A.$Tc.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$4d=E}),define(le[26],he([0,1,3]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.CancellationToken=void 0;const L=Object.freeze(function(C,k){const g=setTimeout(C.bind(k),0);return{dispose(){clearTimeout(g)}}});var A;(function(C){function k(g){return g===C.None||g===C.Cancelled||g instanceof j?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}C.isCancellationToken=k,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A||(e.CancellationToken=A={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new O.$Ud),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=A.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=A.None}}e.$5d=I}),define(le[128],he([0,1,26]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.$De=void 0;class L{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new O.$5d,k=this.b(C.token);return this.a={promise:k,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$De=L;class A{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const k=JSON.stringify(C);return this.b!==k&&(this.b=k,this.a=this.c(C)),this.a}}e.$Ee=A;class j{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const k=this.b(C);return this.a.set(C,k),k}}e.$Fe=j}),define(le[47],he([0,1,7,2]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=void 0;function A(h){const v=h;return v?typeof v.read=="function":!1}e.$6d=A;function j(h){const v=h;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.$7d=j;function I(h){const v=h;return v?j(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$8d=I;function C(h,v){return new k(h,v)}e.$9d=C;class k{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,O.$1)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let o;switch(v){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(h,v){const i=[];let o;for(;(o=h.read())!==null;)i.push(o);return v(i)}e.$0d=g;function P(h,v,i){const o=[];let s;for(;(s=h.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?v(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return h.read()}}}e.$$d=P;function S(h,v){return new Promise((i,o)=>{const s=[];$(h,{onData:n=>{v&&s.push(n)},onError:n=>{v?o(n):i(void 0)},onEnd:()=>{i(v?v(s):void 0)}})})}e.$_d=S;function $(h,v,i){h.on("error",o=>{i?.isCancellationRequested||v.onError(o)}),h.on("end",()=>{i?.isCancellationRequested||v.onEnd()}),h.on("data",o=>{i?.isCancellationRequested||v.onData(o)})}e.$ae=$;function l(h,v){return new Promise((i,o)=>{const s=new L.$Sc,n=[],t=E=>{if(n.push(E),n.length>v)return s.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},r=E=>(s.dispose(),o(E)),a=()=>(s.dispose(),i({stream:h,buffer:n,ended:!0}));s.add((0,L.$Rc)(()=>h.removeListener("error",r))),h.on("error",r),s.add((0,L.$Rc)(()=>h.removeListener("end",a))),h.on("end",a),s.add((0,L.$Rc)(()=>h.removeListener("data",t))),h.on("data",t)})}e.$be=l;function d(h,v){const i=C(v);return i.end(h),i}e.$ce=d;function y(){const h=C(()=>{throw new Error("not supported")});return h.end(),h}e.$de=y;function w(h){let v=!1;return{read:()=>v?null:(v=!0,h)}}e.$ee=w;function c(h,v,i){const o=C(i);return $(h,{onData:s=>o.write(v.data(s)),onError:s=>o.error(v.error?v.error(s):s),onEnd:()=>o.end()}),o}e.$fe=c;function f(h,v,i){let o=!1;return{read:()=>{const s=v.read();return o?s:(o=!0,s!==null?i([h,s]):h)}}}e.$ge=f;function m(h,v,i){let o=!1;const s=C(i);return $(v,{onData:n=>o?s.write(n):(o=!0,s.write(i([h,n]))),onError:n=>s.error(n),onEnd:()=>{o||(o=!0,s.write(h)),s.end()}}),s}e.$he=m}),define(le[14],he([0,1,52,47]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;const A=typeof Buffer<"u",j=new O.$V(()=>new Uint8Array(256));let I,C;class k{static alloc(p){return A?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,R){return!(R?.dontUseNodeBuffer||!1)&&A?new k(Buffer.from(p)):(I||(I=new TextEncoder),new k(I.encode(p)))}static fromByteArray(p){const R=k.alloc(p.length);for(let N=0,F=p.length;N<F;N++)R.buffer[N]=p[N];return R}static concat(p,R){if(typeof R>"u"){R=0;for(let M=0,q=p.length;M<q;M++)R+=p[M].byteLength}const N=k.alloc(R);let F=0;for(let M=0,q=p.length;M<q;M++){const Y=p[M];N.set(Y,F),F+=Y.byteLength}return N}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=k.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(p,R){return new k(this.buffer.subarray(p,R))}set(p,R){if(p instanceof k)this.buffer.set(p.buffer,R);else if(p instanceof Uint8Array)this.buffer.set(p,R);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),R);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return $(this.buffer,p)}writeUInt32BE(p,R){l(this.buffer,p,R)}readUInt32LE(p){return d(this.buffer,p)}writeUInt32LE(p,R){y(this.buffer,p,R)}readUInt8(p){return w(this.buffer,p)}writeUInt8(p,R){c(this.buffer,p,R)}indexOf(p,R=0){return g(this.buffer,p instanceof k?p.buffer:p,R)}}e.$ie=k;function g(u,p,R=0){const N=p.byteLength,F=u.byteLength;if(N===0)return 0;if(N===1)return u.indexOf(p[0]);if(N>F-R)return-1;const M=j.value;M.fill(p.length);for(let x=0;x<p.length;x++)M[p[x]]=p.length-x-1;let q=R+p.length-1,Y=q,K=-1;for(;q<F;)if(u[q]===p[Y]){if(Y===0){K=q;break}q--,Y--}else q+=Math.max(p.length-Y,M[u[q]]),Y=p.length-1;return K}e.$je=g;function P(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0}e.$ke=P;function S(u,p,R){u[R+0]=p&255,p=p>>>8,u[R+1]=p&255}e.$le=S;function $(u,p){return u[p]*2**24+u[p+1]*2**16+u[p+2]*2**8+u[p+3]}e.$me=$;function l(u,p,R){u[R+3]=p,p=p>>>8,u[R+2]=p,p=p>>>8,u[R+1]=p,p=p>>>8,u[R]=p}e.$ne=l;function d(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0|u[p+2]<<16>>>0|u[p+3]<<24>>>0}e.$oe=d;function y(u,p,R){u[R+0]=p&255,p=p>>>8,u[R+1]=p&255,p=p>>>8,u[R+2]=p&255,p=p>>>8,u[R+3]=p&255}e.$pe=y;function w(u,p){return u[p]}e.$qe=w;function c(u,p,R){u[R]=p}e.$re=c;function f(u){return L.$0d(u,p=>k.concat(p))}e.$se=f;function m(u){return L.$ee(u)}e.$te=m;function h(u){return L.$_d(u,p=>k.concat(p))}e.$ue=h;async function v(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await h(u.stream)])}e.$ve=v;function i(u){return L.$ce(u,p=>k.concat(p))}e.$we=i;function o(u){return L.$fe(u,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.$xe=o;function s(u){return L.$9d(p=>k.concat(p),u)}e.$ye=s;function n(u,p){return L.$ge(u,p,R=>k.concat(R))}e.$ze=n;function t(u,p){return L.$he(u,p,R=>k.concat(R))}e.$Ae=t;function r(u){let p=0,R=0,N=0;const F=new Uint8Array(Math.floor(u.length/4*3)),M=Y=>{switch(R){case 3:F[N++]=p|Y,R=0;break;case 2:F[N++]=p|Y>>>2,p=Y<<6,R=3;break;case 1:F[N++]=p|Y>>>4,p=Y<<4,R=2;break;default:p=Y<<2,R=1}};for(let Y=0;Y<u.length;Y++){const K=u.charCodeAt(Y);if(K>=65&&K<=90)M(K-65);else if(K>=97&&K<=122)M(K-97+26);else if(K>=48&&K<=57)M(K-48+52);else if(K===43||K===45)M(62);else if(K===47||K===95)M(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Y]}`)}}const q=N;for(;R>0;)M(0);return k.wrap(F).slice(0,q)}e.$Be=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:u},p=!0,R=!1){const N=R?E:a;let F="";const M=u.byteLength%3;let q=0;for(;q<u.byteLength-M;q+=3){const Y=u[q+0],K=u[q+1],x=u[q+2];F+=N[Y>>>2],F+=N[(Y<<4|K>>>4)&63],F+=N[(K<<2|x>>>6)&63],F+=N[x&63]}if(M===1){const Y=u[q+0];F+=N[Y>>>2],F+=N[Y<<4&63],p&&(F+="==")}else if(M===2){const Y=u[q+0],K=u[q+1];F+=N[Y>>>2],F+=N[(Y<<4|K>>>4)&63],F+=N[K<<2&63],p&&(F+="=")}return F}e.$Ce=b}),define(le[27],he([0,1,128,52]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gf=e.$Ff=e.$Ef=e.$Df=e.GraphemeBreakType=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=void 0;function A(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.$Ie=A;const j=/{(\d+)}/g;function I(oe,...de){return de.length===0?oe:oe.replace(j,function(we,ve){const pe=parseInt(ve,10);return isNaN(pe)||pe<0||pe>=de.length?we:de[pe]})}e.$Je=I;const C=/{([^}]+)}/g;function k(oe,de){return Object.keys(de).length===0?oe:oe.replace(C,(we,ve)=>de[ve]??we)}e.$Ke=k;function g(oe){return oe.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}e.$Le=g;function P(oe){return oe.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$Me=P;function S(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ne=S;function $(oe,de){let we=0;const ve=de.charCodeAt(0);for(let pe=oe.length-1;pe>=0;pe--)oe.charCodeAt(pe)===ve&&we++;return we}e.$Oe=$;function l(oe,de,we="\u2026"){return oe.length<=de?oe:`${oe.substr(0,de)}${we}`}e.$Pe=l;function d(oe,de,we="\u2026"){if(oe.length<=de)return oe;const ve=Math.ceil(de/2)-we.length/2,pe=Math.floor(de/2)-we.length/2;return`${oe.substr(0,ve)}${we}${oe.substr(oe.length-pe)}`}e.$Qe=d;function y(oe,de=" "){const we=w(oe,de);return c(we,de)}e.$Re=y;function w(oe,de){if(!oe||!de)return oe;const we=de.length;if(we===0||oe.length===0)return oe;let ve=0;for(;oe.indexOf(de,ve)===ve;)ve=ve+we;return oe.substring(ve)}e.$Se=w;function c(oe,de){if(!oe||!de)return oe;const we=de.length,ve=oe.length;if(we===0||ve===0)return oe;let pe=ve,ke=-1;for(;ke=oe.lastIndexOf(de,pe-1),!(ke===-1||ke+we!==pe);){if(ke===0)return"";pe=ke}return oe.substring(0,pe)}e.$Te=c;function f(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ue=f;function m(oe){return oe.replace(/\*/g,"")}e.$Ve=m;function h(oe,de,we={}){if(!oe)throw new Error("Cannot create regex from empty string");de||(oe=S(oe)),we.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let ve="";return we.global&&(ve+="g"),we.matchCase||(ve+="i"),we.multiline&&(ve+="m"),we.unicode&&(ve+="u"),new RegExp(oe,ve)}e.$We=h;function v(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.$Xe=v;function i(oe){return oe.split(/\r\n|\r|\n/)}e.$Ye=i;function o(oe){for(let de=0,we=oe.length;de<we;de++){const ve=oe.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}e.$Ze=o;function s(oe,de=0,we=oe.length){for(let ve=de;ve<we;ve++){const pe=oe.charCodeAt(ve);if(pe!==32&&pe!==9)return oe.substring(de,ve)}return oe.substring(de,we)}e.$1e=s;function n(oe,de=oe.length-1){for(let we=de;we>=0;we--){const ve=oe.charCodeAt(we);if(ve!==32&&ve!==9)return we}return-1}e.$2e=n;function t(oe,de,we){const ve=[];let pe=0;for(const ke of oe.matchAll(de)){if(ve.push(oe.slice(pe,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");pe=ke.index+ke[0].length,ve.push(we(ke[0],...ke.slice(1),ke.index,oe,ke.groups))}return ve.push(oe.slice(pe)),Promise.all(ve).then(ke=>ke.join(""))}e.$3e=t;function r(oe,de){return oe<de?-1:oe>de?1:0}e.$4e=r;function a(oe,de,we=0,ve=oe.length,pe=0,ke=de.length){for(;we<ve&&pe<ke;we++,pe++){const Ne=oe.charCodeAt(we),Ge=de.charCodeAt(pe);if(Ne<Ge)return-1;if(Ne>Ge)return 1}const Ie=ve-we,Le=ke-pe;return Ie<Le?-1:Ie>Le?1:0}e.$5e=a;function E(oe,de){return b(oe,de,0,oe.length,0,de.length)}e.$6e=E;function b(oe,de,we=0,ve=oe.length,pe=0,ke=de.length){for(;we<ve&&pe<ke;we++,pe++){let Ne=oe.charCodeAt(we),Ge=de.charCodeAt(pe);if(Ne===Ge)continue;if(Ne>=128||Ge>=128)return a(oe.toLowerCase(),de.toLowerCase(),we,ve,pe,ke);p(Ne)&&(Ne-=32),p(Ge)&&(Ge-=32);const Ue=Ne-Ge;if(Ue!==0)return Ue}const Ie=ve-we,Le=ke-pe;return Ie<Le?-1:Ie>Le?1:0}e.$7e=b;function u(oe){return oe>=48&&oe<=57}e.$8e=u;function p(oe){return oe>=97&&oe<=122}e.$9e=p;function R(oe){return oe>=65&&oe<=90}e.$0e=R;function N(oe,de){return oe.length===de.length&&b(oe,de)===0}e.$$e=N;function F(oe,de){const we=de.length;return de.length>oe.length?!1:b(oe,de,0,we)===0}e.$_e=F;function M(oe,de){const we=Math.min(oe.length,de.length);let ve;for(ve=0;ve<we;ve++)if(oe.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return we}e.$af=M;function q(oe,de){const we=Math.min(oe.length,de.length);let ve;const pe=oe.length-1,ke=de.length-1;for(ve=0;ve<we;ve++)if(oe.charCodeAt(pe-ve)!==de.charCodeAt(ke-ve))return ve;return we}e.$bf=q;function Y(oe){return 55296<=oe&&oe<=56319}e.$cf=Y;function K(oe){return 56320<=oe&&oe<=57343}e.$df=K;function x(oe,de){return(oe-55296<<10)+(de-56320)+65536}e.$ef=x;function V(oe,de,we){const ve=oe.charCodeAt(we);if(Y(ve)&&we+1<de){const pe=oe.charCodeAt(we+1);if(K(pe))return x(ve,pe)}return ve}e.$ff=V;function Q(oe,de){const we=oe.charCodeAt(de-1);if(K(we)&&de>1){const ve=oe.charCodeAt(de-2);if(Y(ve))return x(ve,we)}return we}class W{get offset(){return this.e}constructor(de,we=0){this.c=de,this.d=de.length,this.e=we}setOffset(de){this.e=de}prevCodePoint(){const de=Q(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=V(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$gf=W;class G{get offset(){return this.c.offset}constructor(de,we=0){this.c=new W(de,we)}nextGraphemeLength(){const de=Pe.getInstance(),we=this.c,ve=we.offset;let pe=de.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const ke=we.offset,Ie=de.getGraphemeBreakType(we.nextCodePoint());if(me(pe,Ie)){we.setOffset(ke);break}pe=Ie}return we.offset-ve}prevGraphemeLength(){const de=Pe.getInstance(),we=this.c,ve=we.offset;let pe=de.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const ke=we.offset,Ie=de.getGraphemeBreakType(we.prevCodePoint());if(me(Ie,pe)){we.setOffset(ke);break}pe=Ie}return ve-we.offset}eol(){return this.c.eol()}}e.$hf=G;function te(oe,de){return new G(oe,de).nextGraphemeLength()}e.$if=te;function re(oe,de){return new G(oe,de).prevGraphemeLength()}e.$jf=re;function ee(oe,de){de>0&&K(oe.charCodeAt(de))&&de--;const we=de+te(oe,de);return[we-re(oe,we),we]}e.$kf=ee;function ae(oe){const de=new G(oe);let we=0;for(;!de.eol();)we++,de.nextGraphemeLength();return we}e.$lf=ae;let Z;function z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function D(oe){return Z||(Z=z()),Z.test(oe)}e.$mf=D;const T=/^[\t\n\r\x20-\x7E]*$/;function B(oe){return T.test(oe)}e.$nf=B,e.$of=/[\u2028\u2029]/;function U(oe){return e.$of.test(oe)}e.$pf=U;function _(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.$qf=_;function H(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.$rf=H;function J(oe,de,we=""){const ve=oe.trimStart();if(ve.length<de)return ve;const pe=/\b/g;let ke=0;for(;pe.test(ve)&&!(ve.length-pe.lastIndex<de);)ke=pe.lastIndex,pe.lastIndex+=1;return ke===0?ve:we+ve.substring(ke).trimStart()}e.$sf=J;const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function ce(oe){return oe&&(oe=oe.replace(ie,"").replace(se,"")),oe}e.$tf=ce,e.$uf=String.fromCharCode(65279);function $e(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.$vf=$e;function fe(oe){return $e(oe)?oe.substr(1):oe}e.$wf=fe;function ge(oe,de){if(!oe||!de||oe.length<de.length)return!1;const we=de.length,ve=oe.toLowerCase();let pe=0,ke=-1;for(;pe<we;){const Ie=ve.indexOf(de[pe],ke+1);if(Ie<0)return!1;ke=Ie,pe++}return!0}e.$xf=ge;function Ee(oe,de=!1){return oe?(de&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.$yf=Ee;function Ce(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.$zf=Ce;function Oe(oe,de=1){if(de===0)return"";let we=-1;do we=oe.indexOf(`
`,we+1),de--;while(de>0&&we>=0);return we===-1?oe:(oe[we-1]==="\r"&&we--,oe.substr(0,we))}e.$Af=Oe;function Ae(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}e.$Bf=Ae;function ue(oe){return Pe.getInstance().getGraphemeBreakType(oe)}e.$Cf=ue;function me(oe,de){return oe===0?de!==5&&de!==7:oe===2&&de===3?!1:oe===4||oe===2||oe===3||de===4||de===2||de===3?!0:!(oe===8&&(de===8||de===9||de===11||de===12)||(oe===11||oe===9)&&(de===9||de===10)||(oe===12||oe===10)&&de===10||de===5||de===13||de===7||oe===1||oe===13&&de===14||oe===6&&de===6)}var be;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(be||(e.GraphemeBreakType=be={}));class Pe{static{this.c=null}static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Re()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const we=this.d,ve=we.length/3;let pe=1;for(;pe<=ve;)if(de<we[3*pe])pe=2*pe;else if(de>we[3*pe+1])pe=2*pe+1;else return we[3*pe+2];return 0}}function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(oe,de){if(oe===0)return 0;const we=De(oe,de);if(we!==void 0)return we;const ve=new W(de,oe);return ve.prevCodePoint(),ve.offset}e.$Df=Me;function De(oe,de){const we=new W(de,oe);let ve=we.prevCodePoint();for(;ze(ve)||ve===65039||ve===8419;){if(we.offset===0)return;ve=we.prevCodePoint()}if(!H(ve))return;let pe=we.offset;return pe>0&&we.prevCodePoint()===8205&&(pe=we.offset),pe}function ze(oe){return 127995<=oe&&oe<=127999}var Te;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.$Ef="\xA0";class Fe{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$Ee(de=>{function we(Ue){const Be=new Map;for(let We=0;We<Ue.length;We+=2)Be.set(Ue[We],Ue[We+1]);return Be}function ve(Ue,Be){const We=new Map(Ue);for(const[Xe,tt]of Be)We.set(Xe,tt);return We}function pe(Ue,Be){if(!Ue)return Be;const We=new Map;for(const[Xe,tt]of Ue)Be.has(Xe)&&We.set(Xe,tt);return We}const ke=this.c.value;let Ie=de.filter(Ue=>!Ue.startsWith("_")&&Ue in ke);Ie.length===0&&(Ie=["_default"]);let Le;for(const Ue of Ie){const Be=we(ke[Ue]);Le=pe(Le,Be)}const Ne=we(ke._common),Ge=ve(Ne,Le);return new Fe(Ge)})}static getInstance(de){return Fe.d.get(Array.from(de))}static{this.e=new L.$V(()=>Object.keys(Fe.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Fe.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Ff=Fe;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(de){return qe.e().has(de)}static get codePoints(){return qe.e()}}e.$Gf=qe}),define(le[53],he([0,1,27]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=void 0;function L(c){return A(c,0)}e.$Si=L;function A(c,f){switch(typeof c){case"object":return c===null?j(349,f):Array.isArray(c)?k(c,f):g(c,f);case"string":return C(c,f);case"boolean":return I(c,f);case"number":return j(c,f);case"undefined":return j(937,f);default:return j(617,f)}}e.$Ti=A;function j(c,f){return(f<<5)-f+c|0}e.$Ui=j;function I(c,f){return j(c?433:863,f)}function C(c,f){f=j(149417,f);for(let m=0,h=c.length;m<h;m++)f=j(c.charCodeAt(m),f);return f}e.$Vi=C;function k(c,f){return f=j(104579,f),c.reduce((m,h)=>A(h,m),f)}function g(c,f){return f=j(181387,f),Object.keys(c).sort().reduce((m,h)=>(m=C(h,m),A(c[h],m)),f)}class P{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=A(f,this.g),this.g}}e.$Wi=P;var S;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function $(c,f,m=32){const h=m-f,v=~((1<<h)-1);return(c<<f|(v&c)>>>h)>>>0}function l(c,f=0,m=c.byteLength,h=0){for(let v=0;v<m;v++)c[f+v]=h}function d(c,f,m="0"){for(;c.length<f;)c=m+c;return c}function y(c,f=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(m=>m.toString(16).padStart(2,"0")).join(""):d((c>>>0).toString(16),f/4)}e.$Xi=y;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const m=f.length;if(m===0)return;const h=this.p;let v=this.r,i=this.u,o,s;for(i!==0?(o=i,s=-1,i=0):(o=f.charCodeAt(0),s=0);;){let n=o;if(O.$cf(o))if(s+1<m){const t=f.charCodeAt(s+1);O.$df(t)?(s++,n=O.$ef(o,t)):n=65533}else{i=o;break}else O.$df(o)&&(n=65533);if(v=this.w(h,v,n),s++,s<m)o=f.charCodeAt(s);else break}this.r=v,this.u=i}w(f,m,h){return h<128?f[m++]=h:h<2048?(f[m++]=192|(h&1984)>>>6,f[m++]=128|(h&63)>>>0):h<65536?(f[m++]=224|(h&61440)>>>12,f[m++]=128|(h&4032)>>>6,f[m++]=128|(h&63)>>>0):(f[m++]=240|(h&1835008)>>>18,f[m++]=128|(h&258048)>>>12,f[m++]=128|(h&4032)>>>6,f[m++]=128|(h&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=w.g,m=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,$(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let h=this.h,v=this.l,i=this.m,o=this.n,s=this.o,n,t,r;for(let a=0;a<80;a++)a<20?(n=v&i|~v&o,t=1518500249):a<40?(n=v^i^o,t=1859775393):a<60?(n=v&i|v&o|i&o,t=2400959708):(n=v^i^o,t=3395469782),r=$(h,5)+n+s+t+f.getUint32(a*4,!1)&4294967295,s=o,o=i,i=$(v,30),v=h,h=r;this.h=this.h+h&4294967295,this.l=this.l+v&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}e.$Yi=w}),define(le[89],he([0,1,27]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(L||(L={})),function(A){const j="error",I="warning",C="warn",k="info",g="ignore";function P($){return $?O.$$e(j,$)?A.Error:O.$$e(I,$)||O.$$e(C,$)?A.Warning:O.$$e(k,$)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function S($){switch($){case A.Error:return j;case A.Warning:return I;case A.Info:return k;default:return g}}A.toString=S}(L||(L={})),e.default=L}),define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Rd=Symbol("MicrotaskDelay")}),define(le[48],he([0,1,17,27]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const d=l.charCodeAt(0),y=this.b.charCodeAt(this.c);return d-y}value(){return this.b[this.c]}}e.$7h=A;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,L.$5e)(l,this.b,0,l.length,this.c,this.d):(0,L.$7e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$8h=j;class I{constructor(l=!0,d=!0){this.f=l,this.g=d}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let d=l.length-1;d>=0;d--,this.c--){const y=this.b.charCodeAt(d);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,L.$5e)(l,this.b,0,l.length,this.d,this.e):(0,L.$7e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$9h=I;var C;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(C||(C={}));class k{constructor(l,d){this.f=l,this.g=d,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,L.$6e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,L.$6e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,L.$4e)(l,this.c.query);if(this.d[this.e]===5)return(0,L.$4e)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$0h=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(P||(P={}));class S{static forUris(l=()=>!1,d=()=>!1){return new S(new k(l,d))}static forPaths(l=!1){return new S(new I(void 0,!l))}static forStrings(){return new S(new A)}static forConfigKeys(){return new S(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,d){if(d){const y=d.slice(0);(0,O.$Xb)(y);for(const w of y)this.set(w,l)}else{const y=l.slice(0);(0,O.$Xb)(y);for(const w of y)this.set(w[0],w[1])}}set(l,d){const y=this.b.reset(l);let w;this.c||(this.c=new g,this.c.segment=y.value());const c=[];for(w=this.c;;){const m=y.cmp(w.segment);if(m>0)w.left||(w.left=new g,w.left.segment=y.value()),c.push([-1,w]),w=w.left;else if(m<0)w.right||(w.right=new g,w.right.segment=y.value()),c.push([1,w]),w=w.right;else if(y.hasNext())y.next(),w.mid||(w.mid=new g,w.mid.segment=y.value()),c.push([0,w]),w=w.mid;else break}const f=w.value;w.value=d,w.key=l;for(let m=c.length-1;m>=0;m--){const h=c[m][1];h.updateHeight();const v=h.balanceFactor();if(v<-1||v>1){const i=c[m][0],o=c[m+1][0];if(i===1&&o===1)c[m][1]=h.rotateLeft();else if(i===-1&&o===-1)c[m][1]=h.rotateRight();else if(i===1&&o===-1)h.right=c[m+1][1]=c[m+1][1].rotateRight(),c[m][1]=h.rotateLeft();else if(i===-1&&o===1)h.left=c[m+1][1]=c[m+1][1].rotateLeft(),c[m][1]=h.rotateRight();else throw new Error;if(m>0)switch(c[m-1][0]){case-1:c[m-1][1].left=c[m][1];break;case 1:c[m-1][1].right=c[m][1];break;case 0:c[m-1][1].mid=c[m][1];break}else this.c=c[0][1]}}return f}get(l){return this.d(l)?.value}d(l){const d=this.b.reset(l);let y=this.c;for(;y;){const w=d.cmp(y.segment);if(w>0)y=y.left;else if(w<0)y=y.right;else if(d.hasNext())d.next(),y=y.mid;else break}return y}has(l){const d=this.d(l);return!(d?.value===void 0&&d?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,d){const y=this.b.reset(l),w=[];let c=this.c;for(;c;){const f=y.cmp(c.segment);if(f>0)w.push([-1,c]),c=c.left;else if(f<0)w.push([1,c]),c=c.right;else if(y.hasNext())y.next(),w.push([0,c]),c=c.mid;else break}if(c){if(d?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const f=this.f(c.right);if(f.key){const{key:m,value:h,segment:v}=f;this.e(f.key,!1),c.key=m,c.value=h,c.segment=v}}else{const f=c.left??c.right;if(w.length>0){const[m,h]=w[w.length-1];switch(m){case-1:h.left=f;break;case 0:h.mid=f;break;case 1:h.right=f;break}}else this.c=f}for(let f=w.length-1;f>=0;f--){const m=w[f][1];m.updateHeight();const h=m.balanceFactor();if(h>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),w[f][1]=m.rotateLeft()):h<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),w[f][1]=m.rotateRight()),f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const d=this.b.reset(l);let y=this.c,w;for(;y;){const c=d.cmp(y.segment);if(c>0)y=y.left;else if(c<0)y=y.right;else if(d.hasNext())d.next(),w=y.value||w,y=y.mid;else break}return y&&y.value||w}findSuperstr(l){return this.g(l,!1)}g(l,d){const y=this.b.reset(l);let w=this.c;for(;w;){const c=y.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else return w.mid?this.h(w.mid):d?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[d,y]of this)l(y,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const d=[];return this.j(l,d),d[Symbol.iterator]()}j(l,d){l&&(l.left&&this.j(l.left,d),l.value&&d.push([l.key,l.value]),l.mid&&this.j(l.mid,d),l.right&&this.j(l.right,d))}_isBalanced(){const l=d=>{if(!d)return!0;const y=d.balanceFactor();return y<-1||y>1?!1:l(d.left)&&l(d.right)};return l(this.c)}}e.$$h=S}),define(le[12],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=void 0;function O(v){return typeof v=="string"}e.$Hf=O;function L(v){return Array.isArray(v)&&v.every(i=>O(i))}e.$If=L;function A(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.$Jf=A;function j(v){const i=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof i}e.$Kf=j;function I(v){return typeof v=="number"&&!isNaN(v)}e.$Lf=I;function C(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.$Mf=C;function k(v){return v===!0||v===!1}e.$Nf=k;function g(v){return typeof v>"u"}e.$Of=g;function P(v){return!S(v)}e.$Pf=P;function S(v){return g(v)||v===null}e.$Qf=S;function $(v,i){if(!v)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Rf=$;function l(v){if(S(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.$Sf=l;function d(...v){const i=[];for(let o=0;o<v.length;o++){const s=v[o];if(S(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(s)}return i}e.$Tf=d;const y=Object.prototype.hasOwnProperty;function w(v){if(!A(v))return!1;for(const i in v)if(y.call(v,i))return!1;return!0}e.$Uf=w;function c(v){return typeof v=="function"}e.$Vf=c;function f(...v){return v.length>0&&v.every(c)}e.$Wf=f;function m(v,i){const o=Math.min(v.length,i.length);for(let s=0;s<o;s++)h(v[s],i[s])}e.$Xf=m;function h(v,i){if(O(i)){if(typeof v!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(c(i)){try{if(v instanceof i)return}catch{}if(!S(v)&&v.constructor===i||i.length===1&&i.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Yf=h}),define(le[30],he([0,1,12]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=void 0;function L(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const f=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([m,h])=>{f[m]=h&&typeof h=="object"?L(h):h}),f}e.$un=L;function A(c){if(!c||typeof c!="object")return c;const f=[c];for(;f.length>0;){const m=f.shift();Object.freeze(m);for(const h in m)if(j.call(m,h)){const v=m[h];typeof v=="object"&&!Object.isFrozen(v)&&!(0,O.$Kf)(v)&&f.push(v)}}return c}e.$vn=A;const j=Object.prototype.hasOwnProperty;function I(c,f){return C(c,f,new Set)}e.$wn=I;function C(c,f,m){if((0,O.$Qf)(c))return c;const h=f(c);if(typeof h<"u")return h;if(Array.isArray(c)){const v=[];for(const i of c)v.push(C(i,f,m));return v}if((0,O.$Jf)(c)){if(m.has(c))throw new Error("Cannot clone recursive data-structure");m.add(c);const v={};for(const i in c)j.call(c,i)&&(v[i]=C(c[i],f,m));return m.delete(c),v}return c}function k(c,f,m=!0){return(0,O.$Jf)(c)?((0,O.$Jf)(f)&&Object.keys(f).forEach(h=>{h in c?m&&((0,O.$Jf)(c[h])&&(0,O.$Jf)(f[h])?k(c[h],f[h],m):c[h]=f[h]):c[h]=f[h]}),c):f}e.$xn=k;function g(c,f){if(c===f)return!0;if(c==null||f===null||f===void 0||typeof c!=typeof f||typeof c!="object"||Array.isArray(c)!==Array.isArray(f))return!1;let m,h;if(Array.isArray(c)){if(c.length!==f.length)return!1;for(m=0;m<c.length;m++)if(!g(c[m],f[m]))return!1}else{const v=[];for(h in c)v.push(h);v.sort();const i=[];for(h in f)i.push(h);if(i.sort(),!g(v,i))return!1;for(m=0;m<v.length;m++)if(!g(c[v[m]],f[v[m]]))return!1}return!0}e.$yn=g;function P(c){const f=new Set;return JSON.stringify(c,(m,h)=>{if((0,O.$Jf)(h)||Array.isArray(h)){if(f.has(h))return"[Circular]";f.add(h)}return h})}e.$zn=P;function S(c,f){const m=Object.create(null);return!c||!f||Object.keys(f).forEach(v=>{const i=c[v],o=f[v];g(i,o)||(m[v]=o)}),m}e.$An=S;function $(c,f){const m=f.toLowerCase(),h=Object.keys(c).find(v=>v.toLowerCase()===m);return h?c[h]:c[f]}e.$Bn=$;function l(c,f){const m=Object.create(null);for(const[h,v]of Object.entries(c))f(h,v)&&(m[h]=v);return m}e.$Cn=l;function d(c){let f=[];for(;Object.prototype!==c;)f=f.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return f}e.$Dn=d;function y(c){const f=[];for(const m of d(c))typeof c[m]=="function"&&f.push(m);return f}e.$En=y;function w(c,f){const m=v=>function(){const i=Array.prototype.slice.call(arguments,0);return f(v,i)},h={};for(const v of c)h[v]=m(v);return h}e.$Fn=w}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(A){return O.test(A)}e.$og=L,e.$pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(C){for(let k=0;k<C.length;k++)C[k]=Math.floor(Math.random()*256);return C};const j=new Uint8Array(16),I=[];for(let C=0;C<256;C++)I.push(C.toString(16).padStart(2,"0"));return function(){A(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let k=0,g="";return g+=I[j[k++]],g+=I[j[k++]],g+=I[j[k++]],g+=I[j[k++]],g+="-",g+=I[j[k++]],g+=I[j[k++]],g+="-",g+=I[j[k++]],g+=I[j[k++]],g+="-",g+=I[j[k++]],g+=I[j[k++]],g+="-",g+=I[j[k++]],g+=I[j[k++]],g+=I[j[k++]],g+=I[j[k++]],g+=I[j[k++]],g+=I[j[k++]],g}}()}),define(le[130],he([0,1,36]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(I){const C=I.replace(/\-/g,":").toLowerCase();return!L.has(C)}function j(){const I=(0,O.networkInterfaces)();for(const C in I){const k=I[C];if(k){for(const{mac:g}of k)if(A(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$8m=j}),define(le[131],he([0,1,267,14]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lU=void 0;class A extends O.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const C=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=C.length===1?C[0]:C,this.c=C.length}}_transform(I,C,k){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let g=0;for(;g<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,L.$je)(this.a,this.b,g);if(P===-1)break;this.push(this.a.slice(g,P+this.c)),g=P+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(I){this.a&&this.push(this.a),I()}}e.$lU=A}),define(le[132],he([0,1,64]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tg=e.$sg=e.$rg=void 0;function L(C,k,g,P=1){let S=!1;return new Promise($=>{const l=setTimeout(()=>{if(!S)return S=!0,$(0)},g);A(C,k,P,d=>{if(!S)return S=!0,clearTimeout(l),$(d)})})}e.$rg=L;function A(C,k,g,P){if(k===0)return P(0);const S=new O.Socket;S.once("connect",()=>(I(S),A(C+g,k-1,g,P))),S.once("data",()=>{}),S.once("error",$=>(I(S),$.code!=="ECONNREFUSED"?A(C+g,k-1,g,P):P(C))),S.connect(C,"127.0.0.1")}e.$sg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(C,k,g,P="127.0.0.1"){let S=!1,$,l=1;const d=O.createServer({pauseOnConnect:!0});function y(w,c){S||(S=!0,d.removeAllListeners(),d.close(),$&&clearTimeout($),c(w))}return new Promise(w=>{$=setTimeout(()=>{y(0,w)},g),d.on("listening",()=>{y(C,w)}),d.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&l<k?(C++,l++,d.listen(C,P)):y(0,w)}),d.on("close",()=>{y(0,w)}),d.listen(C,P)})}e.$tg=j;function I(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(k){console.error(k)}}}),define(le[133],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BU=void 0;function O(L){return!!L.parentPort}e.$BU=O}),define(le[134],he([13,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[65],he([0,1,134]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0;const L=60,A=L*60,j=A*24,I=j*7,C=j*30,k=j*365;function g(S,$,l,d){typeof S!="number"&&(S=S.getTime());const y=Math.round((new Date().getTime()-S)/1e3);if(y<-30)return(0,O.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(!d&&y<30)return(0,O.localize)(1,null);let w;return y<L?(w=y,$?w===1?l?(0,O.localize)(2,null,w):(0,O.localize)(3,null,w):l?(0,O.localize)(4,null,w):(0,O.localize)(5,null,w):w===1?l?(0,O.localize)(6,null,w):(0,O.localize)(7,null,w):l?(0,O.localize)(8,null,w):(0,O.localize)(9,null,w)):y<A?(w=Math.floor(y/L),$?w===1?l?(0,O.localize)(10,null,w):(0,O.localize)(11,null,w):l?(0,O.localize)(12,null,w):(0,O.localize)(13,null,w):w===1?l?(0,O.localize)(14,null,w):(0,O.localize)(15,null,w):l?(0,O.localize)(16,null,w):(0,O.localize)(17,null,w)):y<j?(w=Math.floor(y/A),$?w===1?l?(0,O.localize)(18,null,w):(0,O.localize)(19,null,w):l?(0,O.localize)(20,null,w):(0,O.localize)(21,null,w):w===1?l?(0,O.localize)(22,null,w):(0,O.localize)(23,null,w):l?(0,O.localize)(24,null,w):(0,O.localize)(25,null,w)):y<I?(w=Math.floor(y/j),$?w===1?(0,O.localize)(26,null,w):(0,O.localize)(27,null,w):w===1?(0,O.localize)(28,null,w):(0,O.localize)(29,null,w)):y<C?(w=Math.floor(y/I),$?w===1?l?(0,O.localize)(30,null,w):(0,O.localize)(31,null,w):l?(0,O.localize)(32,null,w):(0,O.localize)(33,null,w):w===1?l?(0,O.localize)(34,null,w):(0,O.localize)(35,null,w):l?(0,O.localize)(36,null,w):(0,O.localize)(37,null,w)):y<k?(w=Math.floor(y/C),$?w===1?l?(0,O.localize)(38,null,w):(0,O.localize)(39,null,w):l?(0,O.localize)(40,null,w):(0,O.localize)(41,null,w):w===1?l?(0,O.localize)(42,null,w):(0,O.localize)(43,null,w):l?(0,O.localize)(44,null,w):(0,O.localize)(45,null,w)):(w=Math.floor(y/k),$?w===1?l?(0,O.localize)(46,null,w):(0,O.localize)(47,null,w):l?(0,O.localize)(48,null,w):(0,O.localize)(49,null,w):w===1?l?(0,O.localize)(50,null,w):(0,O.localize)(51,null,w):l?(0,O.localize)(52,null,w):(0,O.localize)(53,null,w))}e.$um=g;function P(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$vm=P}),define(le[135],he([13,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,12,135]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=void 0;function j(S,$){return $&&(S.stack||S.stacktrace)?A.localize(0,null,C(S),I(S.stack)||I(S.stacktrace)):C(S)}function I(S){return Array.isArray(S)?S.join(`
`):S}function C(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?A.localize(1,null,S.message):S.message||A.localize(2,null)}function k(S=null,$=!1){if(!S)return A.localize(3,null);if(Array.isArray(S)){const l=O.$Hb(S),d=k(l[0],$);return l.length>1?A.localize(4,null,d,l.length):d}if(L.$Hf(S))return S;if(S.detail){const l=S.detail;if(l.error)return j(l.error,$);if(l.exception)return j(l.exception,$)}return S.stack?j(S,$):S.message?S.message:A.localize(5,null)}e.$Pi=k;function g(S){const $=S;return $ instanceof Error&&Array.isArray($.actions)}e.$Qi=g;function P(S,$){let l;return typeof S=="string"?l=new Error(S):l=S,l.actions=$,l}e.$Ri=P}),define(le[136],he([13,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[137],he([0,1,136]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;function L(A){switch(A){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$Wp=L}),define(le[138],he([13,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,138]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let L=!1,A=!1,j=!1,I=!1,C=!1,k=!1,g=!1,P=!1,S=!1,$=!1,l,d=e.$g,y=e.$g,w,c;const f=globalThis;let m;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?m=f.vscode.process:typeof process<"u"&&(m=process);const h=typeof m?.versions?.electron=="string",v=h&&m?.type==="renderer";if(typeof m=="object"){L=m.platform==="win32",A=m.platform==="darwin",j=m.platform==="linux",I=j&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,g=h,S=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,d=e.$g;const u=m.env.VSCODE_NLS_CONFIG;if(u)try{const p=JSON.parse(u),R=p.availableLanguages["*"];l=p.locale,y=p.osLocale,d=R||e.$g,w=p._translationsConfigFile}catch{}C=!0}else typeof navigator=="object"&&!v?(c=navigator.userAgent,L=c.indexOf("Windows")>=0,A=c.indexOf("Macintosh")>=0,P=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=c.indexOf("Linux")>=0,$=c?.indexOf("Mobi")>=0,k=!0,l=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$g,d=l,y=navigator.language):console.error("Unable to resolve platform.");var i;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let s=0;A?s=1:L?s=3:j&&(s=2),e.$i=L,e.$j=A,e.$k=j,e.$l=I,e.$m=C,e.$n=g,e.$o=k,e.$p=k&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=P,e.$s=$,e.$t=S,e.$u=s,e.$v=c,e.$w=d;var n;(function(u){function p(){return e.$w}u.value=p;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}u.isDefaultVariant=R;function N(){return e.$w==="en"}u.isDefault=N})(n||(e.Language=n={})),e.$x=l,e.$y=y,e.$z=w,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const u=[];f.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let N=0,F=u.length;N<F;N++){const M=u[N];if(M.id===R.data.vscodeScheduleAsyncWork){u.splice(N,1),M.callback();return}}});let p=0;return R=>{const N=++p;u.push({id:N,callback:R}),f.postMessage({vscodeScheduleAsyncWork:N},"*")}}return u=>setTimeout(u)})();var t;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=A||P?2:L?1:3;let r=!0,a=!1;function E(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.$D=E,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(u){return parseFloat(u)>=20}e.$J=b}),define(le[37],he([0,1,5]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const j=A.process;L={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(le[16],he([0,1,37]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,A=97,j=90,I=122,C=46,k=47,g=92,P=58,S=63;class $ extends Error{constructor(o,s,n){let t;typeof s=="string"&&s.indexOf("not ")===0?(t="must not be",s=s.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${s}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(i,o){if(i===null||typeof i!="object")throw new $(o,"Object",i)}function d(i,o){if(typeof i!="string")throw new $(o,"string",i)}const y=O.$dc==="win32";function w(i){return i===k||i===g}function c(i){return i===k}function f(i){return i>=L&&i<=j||i>=A&&i<=I}function m(i,o,s,n){let t="",r=0,a=-1,E=0,b=0;for(let u=0;u<=i.length;++u){if(u<i.length)b=i.charCodeAt(u);else{if(n(b))break;b=k}if(n(b)){if(!(a===u-1||E===1))if(E===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==C||t.charCodeAt(t.length-2)!==C){if(t.length>2){const p=t.lastIndexOf(s);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(s)),a=u,E=0;continue}else if(t.length!==0){t="",r=0,a=u,E=0;continue}}o&&(t+=t.length>0?`${s}..`:"..",r=2)}else t.length>0?t+=`${s}${i.slice(a+1,u)}`:t=i.slice(a+1,u),r=u-a-1;a=u,E=0}else b===C&&E!==-1?++E:E=-1}return t}function h(i,o){l(o,"pathObject");const s=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${n}`:`${s}${i}${n}`:n}e.$fc={resolve(...i){let o="",s="",n=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],d(r,"path"),r.length===0)continue}else o.length===0?r=O.cwd():(r=O.env[`=${o}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let E=0,b="",u=!1;const p=r.charCodeAt(0);if(a===1)w(p)&&(E=1,u=!0);else if(w(p))if(u=!0,w(r.charCodeAt(1))){let R=2,N=R;for(;R<a&&!w(r.charCodeAt(R));)R++;if(R<a&&R!==N){const F=r.slice(N,R);for(N=R;R<a&&w(r.charCodeAt(R));)R++;if(R<a&&R!==N){for(N=R;R<a&&!w(r.charCodeAt(R));)R++;(R===a||R!==N)&&(b=`\\\\${F}\\${r.slice(N,R)}`,E=R)}}}else E=1;else f(p)&&r.charCodeAt(1)===P&&(b=r.slice(0,2),E=2,a>2&&w(r.charCodeAt(2))&&(u=!0,E=3));if(b.length>0)if(o.length>0){if(b.toLowerCase()!==o.toLowerCase())continue}else o=b;if(n){if(o.length>0)break}else if(s=`${r.slice(E)}\\${s}`,n=u,u&&o.length>0)break}return s=m(s,!n,"\\",w),n?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){d(i,"path");const o=i.length;if(o===0)return".";let s=0,n,t=!1;const r=i.charCodeAt(0);if(o===1)return c(r)?"\\":i;if(w(r))if(t=!0,w(i.charCodeAt(1))){let E=2,b=E;for(;E<o&&!w(i.charCodeAt(E));)E++;if(E<o&&E!==b){const u=i.slice(b,E);for(b=E;E<o&&w(i.charCodeAt(E));)E++;if(E<o&&E!==b){for(b=E;E<o&&!w(i.charCodeAt(E));)E++;if(E===o)return`\\\\${u}\\${i.slice(b)}\\`;E!==b&&(n=`\\\\${u}\\${i.slice(b,E)}`,s=E)}}}else s=1;else f(r)&&i.charCodeAt(1)===P&&(n=i.slice(0,2),s=2,o>2&&w(i.charCodeAt(2))&&(t=!0,s=3));let a=s<o?m(i.slice(s),!t,"\\",w):"";return a.length===0&&!t&&(a="."),a.length>0&&w(i.charCodeAt(o-1))&&(a+="\\"),n===void 0?t?`\\${a}`:a:t?`${n}\\${a}`:`${n}${a}`},isAbsolute(i){d(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return w(s)||o>2&&f(s)&&i.charCodeAt(1)===P&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let r=0;r<i.length;++r){const a=i[r];d(a,"path"),a.length>0&&(o===void 0?o=s=a:o+=`\\${a}`)}if(o===void 0)return".";let n=!0,t=0;if(typeof s=="string"&&w(s.charCodeAt(0))){++t;const r=s.length;r>1&&w(s.charCodeAt(1))&&(++t,r>2&&(w(s.charCodeAt(2))?++t:n=!1))}if(n){for(;t<o.length&&w(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(i,o){if(d(i,"from"),d(o,"to"),i===o)return"";const s=e.$fc.resolve(i),n=e.$fc.resolve(o);if(s===n||(i=s.toLowerCase(),o=n.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let E=0;for(;E<o.length&&o.charCodeAt(E)===g;)E++;let b=o.length;for(;b-1>E&&o.charCodeAt(b-1)===g;)b--;const u=b-E,p=a<u?a:u;let R=-1,N=0;for(;N<p;N++){const M=i.charCodeAt(t+N);if(M!==o.charCodeAt(E+N))break;M===g&&(R=N)}if(N!==p){if(R===-1)return n}else{if(u>p){if(o.charCodeAt(E+N)===g)return n.slice(E+N+1);if(N===2)return n.slice(E+N)}a>p&&(i.charCodeAt(t+N)===g?R=N:N===2&&(R=3)),R===-1&&(R=0)}let F="";for(N=t+R+1;N<=r;++N)(N===r||i.charCodeAt(N)===g)&&(F+=F.length===0?"..":"\\..");return E+=R,F.length>0?`${F}${n.slice(E,b)}`:(n.charCodeAt(E)===g&&++E,n.slice(E,b))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const s=o.charCodeAt(2);if(s!==S&&s!==C)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){d(i,"path");const o=i.length;if(o===0)return".";let s=-1,n=0;const t=i.charCodeAt(0);if(o===1)return w(t)?i:".";if(w(t)){if(s=n=1,w(i.charCodeAt(1))){let E=2,b=E;for(;E<o&&!w(i.charCodeAt(E));)E++;if(E<o&&E!==b){for(b=E;E<o&&w(i.charCodeAt(E));)E++;if(E<o&&E!==b){for(b=E;E<o&&!w(i.charCodeAt(E));)E++;if(E===o)return i;E!==b&&(s=n=E+1)}}}}else f(t)&&i.charCodeAt(1)===P&&(s=o>2&&w(i.charCodeAt(2))?3:2,n=s);let r=-1,a=!0;for(let E=o-1;E>=n;--E)if(w(i.charCodeAt(E))){if(!a){r=E;break}}else a=!1;if(r===-1){if(s===-1)return".";r=s}return i.slice(0,r)},basename(i,o){o!==void 0&&d(o,"ext"),d(i,"path");let s=0,n=-1,t=!0,r;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=s;--r){const b=i.charCodeAt(r);if(w(b)){if(!t){s=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(b===o.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=E))}return s===n?n=E:n===-1&&(n=i.length),i.slice(s,n)}for(r=i.length-1;r>=s;--r)if(w(i.charCodeAt(r))){if(!t){s=r+1;break}}else n===-1&&(t=!1,n=r+1);return n===-1?"":i.slice(s,n)},extname(i){d(i,"path");let o=0,s=-1,n=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===P&&f(i.charCodeAt(0))&&(o=n=2);for(let E=i.length-1;E>=o;--E){const b=i.charCodeAt(E);if(w(b)){if(!r){n=E+1;break}continue}t===-1&&(r=!1,t=E+1),b===C?s===-1?s=E:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||t===-1||a===0||a===1&&s===t-1&&s===n+1?"":i.slice(s,t)},format:h.bind(null,"\\"),parse(i){d(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let n=0,t=i.charCodeAt(0);if(s===1)return w(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(w(t)){if(n=1,w(i.charCodeAt(1))){let R=2,N=R;for(;R<s&&!w(i.charCodeAt(R));)R++;if(R<s&&R!==N){for(N=R;R<s&&w(i.charCodeAt(R));)R++;if(R<s&&R!==N){for(N=R;R<s&&!w(i.charCodeAt(R));)R++;R===s?n=R:R!==N&&(n=R+1)}}}}else if(f(t)&&i.charCodeAt(1)===P){if(s<=2)return o.root=o.dir=i,o;if(n=2,w(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;n=3}}n>0&&(o.root=i.slice(0,n));let r=-1,a=n,E=-1,b=!0,u=i.length-1,p=0;for(;u>=n;--u){if(t=i.charCodeAt(u),w(t)){if(!b){a=u+1;break}continue}E===-1&&(b=!1,E=u+1),t===C?r===-1?r=u:p!==1&&(p=1):r!==-1&&(p=-1)}return E!==-1&&(r===-1||p===0||p===1&&r===E-1&&r===a+1?o.base=o.name=i.slice(a,E):(o.name=i.slice(a,r),o.base=i.slice(a,E),o.ext=i.slice(r,E))),a>0&&a!==n?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(y){const i=/\\/g;return()=>{const o=O.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>O.cwd()})();e.$gc={resolve(...i){let o="",s=!1;for(let n=i.length-1;n>=-1&&!s;n--){const t=n>=0?i[n]:v();d(t,"path"),t.length!==0&&(o=`${t}/${o}`,s=t.charCodeAt(0)===k)}return o=m(o,!s,"/",c),s?`/${o}`:o.length>0?o:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k,s=i.charCodeAt(i.length-1)===k;return i=m(i,!o,"/",c),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const n=i[s];d(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if(d(i,"from"),d(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const s=1,n=i.length,t=n-s,r=1,a=o.length-r,E=t<a?t:a;let b=-1,u=0;for(;u<E;u++){const R=i.charCodeAt(s+u);if(R!==o.charCodeAt(r+u))break;R===k&&(b=u)}if(u===E)if(a>E){if(o.charCodeAt(r+u)===k)return o.slice(r+u+1);if(u===0)return o.slice(r+u)}else t>E&&(i.charCodeAt(s+u)===k?b=u:u===0&&(b=0));let p="";for(u=s+b+1;u<=n;++u)(u===n||i.charCodeAt(u)===k)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(r+b)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k;let s=-1,n=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===k){if(!n){s=t;break}}else n=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&d(o,"ext"),d(i,"path");let s=0,n=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=0;--r){const b=i.charCodeAt(r);if(b===k){if(!t){s=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(b===o.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=E))}return s===n?n=E:n===-1&&(n=i.length),i.slice(s,n)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===k){if(!t){s=r+1;break}}else n===-1&&(t=!1,n=r+1);return n===-1?"":i.slice(s,n)},extname(i){d(i,"path");let o=-1,s=0,n=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const E=i.charCodeAt(a);if(E===k){if(!t){s=a+1;break}continue}n===-1&&(t=!1,n=a+1),E===C?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||n===-1||r===0||r===1&&o===n-1&&o===s+1?"":i.slice(o,n)},format:h.bind(null,"/"),parse(i){d(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===k;let n;s?(o.root="/",n=1):n=0;let t=-1,r=0,a=-1,E=!0,b=i.length-1,u=0;for(;b>=n;--b){const p=i.charCodeAt(b);if(p===k){if(!E){r=b+1;break}continue}a===-1&&(E=!1,a=b+1),p===C?t===-1?t=b:u!==1&&(u=1):t!==-1&&(u=-1)}if(a!==-1){const p=r===0&&s?1:r;t===-1||u===0||u===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(p,a):(o.name=i.slice(p,t),o.base=i.slice(p,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=y?e.$fc.normalize:e.$gc.normalize,e.$ic=y?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=y?e.$fc.join:e.$gc.join,e.$kc=y?e.$fc.resolve:e.$gc.resolve,e.$lc=y?e.$fc.relative:e.$gc.relative,e.$mc=y?e.$fc.dirname:e.$gc.dirname,e.$nc=y?e.$fc.basename:e.$gc.basename,e.$oc=y?e.$fc.extname:e.$gc.extname,e.$pc=y?e.$fc.format:e.$gc.format,e.$qc=y?e.$fc.parse:e.$gc.parse,e.$rc=y?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=y?e.$fc.sep:e.$gc.sep,e.$tc=y?e.$fc.delimiter:e.$gc.delimiter}),define(le[49],he([0,1,16,5,27,12]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=void 0;function I(r){return r===47||r===92}e.$Zf=I;function C(r){return r.replace(/[\\/]/g,O.$gc.sep)}e.$1f=C;function k(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$2f=k;function g(r,a=O.$gc.sep){if(!r)return"";const E=r.length,b=r.charCodeAt(0);if(I(b)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let p=3;const R=p;for(;p<E&&!I(r.charCodeAt(p));p++);if(R!==p&&!I(r.charCodeAt(p+1))){for(p+=1;p<E;p++)if(I(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(c(b)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<E;u++)if(I(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$3f=g;function P(r){if(!L.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let E=2;const b=E;for(;E<r.length&&(a=r.charCodeAt(E),a!==92);E++);return!(b===E||(a=r.charCodeAt(E+1),isNaN(a)||a===92))}e.$4f=P;const S=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=L.$i){const E=a?S:$;return!(!r||r.length===0||/^\s+$/.test(r)||(E.lastIndex=0,E.test(r))||a&&l.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$5f=d;function y(r,a,E){const b=r===a;return!E||b?b:!r||!a?!1:(0,A.$$e)(r,a)}e.$6f=y;function w(r,a,E,b=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(E){if(!(0,A.$_e)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===b&&p--,r.charAt(p)===b}return a.charAt(a.length-1)!==b&&(a+=b),r.indexOf(a)===0}e.$7f=w;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.$8f=c;function f(r,a){return L.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$ic)(r)||(r=(0,O.$jc)(a,r)),r=(0,O.$hc)(r),L.$i?(r=(0,A.$Te)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,A.$Te)(r,O.sep),r||(r=O.sep)),r}e.$9f=f;function m(r){const a=(0,O.$hc)(r);return L.$i?r.length>3?!1:h(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$gc.sep}e.$0f=m;function h(r,a=L.$i){return a?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$$f=h;function v(r,a=L.$i){return h(r,a)?r[0]:void 0}e.$_f=v;function i(r,a,E){return a.length>r.length?-1:r===a?0:(E&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$ag=i;function o(r){const a=r.split(":");let E,b,u;for(const p of a){const R=Number(p);(0,j.$Lf)(R)?b===void 0?b=R:u===void 0&&(u=R):E=E?[E,p].join(":"):p}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:b!==void 0?b:void 0,column:u!==void 0?u:b!==void 0?1:void 0}}e.$bg=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,E=8){let b="";for(let p=0;p<E;p++){let R;p===0&&L.$i&&!a&&(E===3||E===4)?R=n:R=s,b+=R.charAt(Math.floor(Math.random()*R.length))}let u;return a?u=`${a}-${b}`:u=b,r?(0,O.$jc)(r,u):u}e.$cg=t}),define(le[139],he([0,1,16]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0,e.$es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(P){const S=(0,O.$oc)(P),$=L[S.toLowerCase()];return $!==void 0?$:I(P)}e.$fs=j;function I(P){const S=(0,O.$oc)(P);return A[S.toLowerCase()]}e.$gs=I;function C(P){for(const S in A)if(A[S]===P)return S}e.$hs=C;const k=/^(.+)\/(.+?)(;.+)?$/;function g(P,S){const $=k.exec(P);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:S?void 0:P}e.$is=g}),define(le[90],he([0,1,5]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.TerminateResponseCode=e.Source=void 0;var L;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(L||(e.Source=L={}));var A;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function j(C,...k){const g=k.reduce(($,l)=>($[l]=!0,$),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter($=>!g[$]).forEach($=>{for(let l=0;l<P.length;l++)if($.search(P[l])!==-1){delete C[$];break}})}e.$Ql=j;function I(C){C&&(delete C.DEBUG,O.$j&&delete C.DYLD_LIBRARY_PATH,O.$k&&delete C.LD_PRELOAD)}e.$Rl=I}),define(le[10],he([0,1,16,5]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,j=/^\//,I=/^\/\//;function C(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!j.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(n,t){return!n&&!t?"file":n}function g(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const P="",S="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,E,b,u=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=k(t,u),this.authority=r||P,this.path=g(this.scheme,a||P),this.query=E||P,this.fragment=b||P,C(this,u))}get fsPath(){return h(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:E,query:b,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),E===void 0?E=this.path:E===null&&(E=P),b===void 0?b=this.query:b===null&&(b=P),u===void 0?u=this.fragment:u===null&&(u=P),r===this.scheme&&a===this.authority&&E===this.path&&b===this.query&&u===this.fragment?this:new w(r,a,E,b,u)}static parse(t,r=!1){const a=$.exec(t);return a?new w(a[2]||P,s(a[4]||P),s(a[5]||P),s(a[7]||P),s(a[9]||P),r):new w(P,P,P,P,P)}static file(t){let r=P;if(L.$i&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new w("file",r,t,P,P)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return L.$i&&t.scheme==="file"?a=l.file(O.$fc.join(h(t,!0),...r)).path:a=O.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return v(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=l;function d(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$vc=d;const y=L.$i?1:void 0;class w extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(t=!1){return t?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(n,t,r){let a,E=-1;for(let b=0;b<n.length;b++){const u=n.charCodeAt(b);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)E!==-1&&(a+=encodeURIComponent(n.substring(E,b)),E=-1),a!==void 0&&(a+=n.charAt(b));else{a===void 0&&(a=n.substr(0,b));const p=c[u];p!==void 0?(E!==-1&&(a+=encodeURIComponent(n.substring(E,b)),E=-1),a+=p):E===-1&&(E=b)}}return E!==-1&&(a+=encodeURIComponent(n.substring(E))),a!==void 0?a:n}function m(n){let t;for(let r=0;r<n.length;r++){const a=n.charCodeAt(r);a===35||a===63?(t===void 0&&(t=n.substr(0,r)),t+=c[a]):t!==void 0&&(t+=n[r])}return t!==void 0?t:n}function h(n,t){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,L.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=h;function v(n,t){const r=t?m:f;let a="",{scheme:E,authority:b,path:u,query:p,fragment:R}=n;if(E&&(a+=E,a+=":"),(b||E==="file")&&(a+=S,a+=S),b){let N=b.indexOf("@");if(N!==-1){const F=b.substr(0,N);b=b.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,N),!1,!1),a+=":",a+=r(F.substr(N+1),!1,!0)),a+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?a+=r(b,!1,!0):(a+=r(b.substr(0,N),!1,!0),a+=b.substr(N))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const N=u.charCodeAt(1);N>=65&&N<=90&&(u=`/${String.fromCharCode(N+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const N=u.charCodeAt(0);N>=65&&N<=90&&(u=`${String.fromCharCode(N+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),R&&(a+="#",a+=t?R:f(R,!1,!1)),a}function i(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+i(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(o)?n.replace(o,t=>i(t)):n}}),define(le[140],he([0,1,10]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$nq=e.$mq=e.$lq=void 0;function L(g){const P=g;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$lq=L;function A(g){const P=[];let S;try{const $=JSON.parse(g.arguments),l=$[$.length-1];l&&l.__$stack&&($.pop(),S=l.__$stack),P.push(...$)}catch{P.push("Unable to log remote console arguments",g.arguments)}return{args:P,stack:S}}e.$mq=A;function j(g){if(typeof g!="string")return j(A(g).stack);const P=g;if(P){const S=I(P),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if($&&$.length===4)return{uri:O.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$nq=j;function I(g){if(!g)return g;const P=g.indexOf(`
`);return P===-1?g:g.substring(0,P)}function C(g,P){const{args:S,stack:$}=A(g),l=typeof S[0]=="string"&&S.length===1;let d=I($);d&&(d=`(${d.trim()})`);let y=[];if(typeof S[0]=="string"?d&&l?y=[`%c[${P}] %c${S[0]} %c${d}`,k("blue"),k(""),k("grey")]:y=[`%c[${P}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:y=[`%c[${P}]%`,k("blue"),...S],d&&!l&&y.push(d),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,y)}e.log=C;function k(g){return`color: ${g}`}}),define(le[66],he([0,1,14,10]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function A(k){return JSON.stringify(k,I)}e.$zh=A;function j(k){let g=JSON.parse(k);return g=C(g),g}e.$Ah=j;function I(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function C(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return L.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof O.$ie||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=C(k[P],g+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=C(k[P],g+1))}return k}e.$Bh=C}),define(le[23],he([0,1,7,5,27,10]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.Schemas=void 0;var I;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={}));function C($,l){return j.URI.isUri($)?(0,A.$$e)($.scheme,l):(0,A.$_e)($,l+":")}e.$dg=C;function k($,...l){return l.some(d=>C($,d))}e.$eg=k,e.$fg="vscode-tkn",e.$gg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${I.vscodeRemoteResource}`}set(l,d,y){this.a[l]=d,this.b[l]=y}setConnectionToken(l,d){this.c[l]=d}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(m){return O.$1(m),l}const d=l.authority;let y=this.a[d];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const w=this.b[d],c=this.c[d];let f=`path=${encodeURIComponent(l.path)}`;return typeof c=="string"&&(f+=`&${e.$gg}=${encodeURIComponent(c)}`),j.URI.from({scheme:L.$o?this.d:I.vscodeRemoteResource,authority:`${y}:${w}`,path:this.f,query:f})}}e.$hg=new g,e.$ig="vs/../../extensions",e.$jg="vs/../../node_modules",e.$kg="vs/../../node_modules.asar",e.$lg="vs/../../node_modules.asar.unpacked",e.$mg="vscode-app";class P{static{this.a=e.$mg}asBrowserUri(l){const d=this.b(l,ne);return this.uriToBrowserUri(d)}uriToBrowserUri(l){return l.scheme===I.vscodeRemote?e.$hg.rewrite(l):l.scheme===I.file&&(L.$m||L.$q===`${I.vscodeFileResource}://${P.a}`)?l.with({scheme:I.vscodeFileResource,authority:l.authority||P.a,query:null,fragment:null}):l}asFileUri(l){const d=this.b(l,ne);return this.uriToFileUri(d)}uriToFileUri(l){return l.scheme===I.vscodeFileResource?l.with({scheme:I.file,authority:l.authority!==P.a?l.authority:null,query:null,fragment:null}):l}b(l,d){return j.URI.isUri(l)?l:j.URI.parse(d.toUrl(l))}}e.$ng=new P;var S;(function($){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(l.get("3"));const d="vscode-coi";function y(c){let f;typeof c=="string"?f=new URL(c).searchParams:c instanceof URL?f=c.searchParams:j.URI.isUri(c)&&(f=new URL(c.toString(!0)).searchParams);const m=f?.get(d);if(m)return l.get(m)}$.getHeadersFromQuery=y;function w(c,f,m){if(!globalThis.crossOriginIsolated)return;const h=f&&m?"3":m?"2":"1";c instanceof URLSearchParams?c.set(d,h):c[d]=h}$.addSearchParam=w})(S||(e.COI=S={}))}),define(le[141],he([0,1,123,23,5,10]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=void 0;class I{constructor($,l,d){this.id=$,this.dependencies=l,this.callback=d}}class C{static{this.INSTANCE=new C}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,l,d)=>{typeof $!="string"&&(d=l,l=$,$=null),(typeof l!="object"||!Array.isArray(l))&&(d=l,l=null),this.c.push(new I($,l,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const l=await(this.a?this.i($):this.b?this.h($):this.j($));if(!l)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h($){return new Promise((l,d)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const w=()=>{y.removeEventListener("load",c),y.removeEventListener("error",f)},c=m=>{w(),l(this.c.pop())},f=m=>{w(),d(m)};y.addEventListener("load",c),y.addEventListener("error",f),this.f&&($=this.f.createScriptURL($)),y.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(y)})}i($){return new Promise((l,d)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),l(this.c.pop())}catch(y){d(y)}})}async j($){try{const l=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,w=j.URI.parse($).fsPath,c=l.readFileSync(w).toString(),f=y.wrap(c.replace(/^#!.*/,""));return new d.Script(f).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function P(S,$,l){if(O.$T){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[S]&&(S=g[S]);const d=`${S}/${$}`;if(k.has(d))return k.get(d);let y;if(/^\w[\w\d+.-]*:\/\//.test(d))y=d;else{const m=`${l&&!A.$o?L.$kg:L.$jg}/${d}`;y=L.$ng.asBrowserUri(m).toString(!0)}const w=C.INSTANCE.load(y);return k.set(d,w),w}else return await new Promise((d,y)=>{ne([S],d,y)})}e.$eD=P}),define(le[19],he([0,1,49,23,16,5,27,10]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.DataUri=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=void 0;function k(l){return(0,C.$wc)(l,!0)}e.$ug=k;class g{constructor(d){this.a=d}compare(d,y,w=!1){return d===y?0:(0,I.$4e)(this.getComparisonKey(d,w),this.getComparisonKey(y,w))}isEqual(d,y,w=!1){return d===y?!0:!d||!y?!1:this.getComparisonKey(d,w)===this.getComparisonKey(y,w)}getComparisonKey(d,y=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,y,w=!1){if(d.scheme===y.scheme){if(d.scheme===L.Schemas.file)return O.$7f(k(d),k(y),this.a(d))&&d.query===y.query&&(w||d.fragment===y.fragment);if((0,e.$Lg)(d.authority,y.authority))return O.$7f(d.path,y.path,this.a(d),"/")&&d.query===y.query&&(w||d.fragment===y.fragment)}return!1}joinPath(d,...y){return C.URI.joinPath(d,...y)}basenameOrAuthority(d){return(0,e.$Dg)(d)||d.authority}basename(d){return A.$gc.basename(d.path)}extname(d){return A.$gc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let y;return d.scheme===L.Schemas.file?y=C.URI.file(A.$mc(k(d))).path:(y=A.$gc.dirname(d.path),d.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),y="/")),d.with({path:y})}normalizePath(d){if(!d.path.length)return d;let y;return d.scheme===L.Schemas.file?y=C.URI.file(A.$hc(k(d))).path:y=A.$gc.normalize(d.path),d.with({path:y})}relativePath(d,y){if(d.scheme!==y.scheme||!(0,e.$Lg)(d.authority,y.authority))return;if(d.scheme===L.Schemas.file){const f=A.$lc(k(d),k(y));return j.$i?O.$1f(f):f}let w=d.path||"/";const c=y.path||"/";if(this.a(d)){let f=0;for(const m=Math.min(w.length,c.length);f<m&&!(w.charCodeAt(f)!==c.charCodeAt(f)&&w.charAt(f).toLowerCase()!==c.charAt(f).toLowerCase());f++);w=c.substr(0,f)+w.substr(f)}return A.$gc.relative(w,c)}resolvePath(d,y){if(d.scheme===L.Schemas.file){const w=C.URI.file(A.$kc(k(d),y));return d.with({authority:w.authority,path:w.path})}return y=O.$2f(y),d.with({path:A.$gc.resolve(d.path,y)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,y){return d===y||d!==void 0&&y!==void 0&&(0,I.$$e)(d,y)}hasTrailingPathSeparator(d,y=A.sep){if(d.scheme===L.Schemas.file){const w=k(d);return w.length>O.$3f(w).length&&w[w.length-1]===y}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,y=A.sep){return(0,e.$Mg)(d,y)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,y=A.sep){let w=!1;if(d.scheme===L.Schemas.file){const c=k(d);w=c!==void 0&&c.length===O.$3f(c).length&&c[c.length-1]===y}else{y="/";const c=d.path;w=c.length===1&&c.charCodeAt(c.length-1)===47}return!w&&!(0,e.$Mg)(d,y)?d.with({path:d.path+"/"}):d}}e.$vg=g,e.$wg=new g(()=>!1),e.$xg=new g(l=>l.scheme===L.Schemas.file?!j.$k:!0),e.$yg=new g(l=>!0),e.$zg=e.$wg.isEqual.bind(e.$wg),e.$Ag=e.$wg.isEqualOrParent.bind(e.$wg),e.$Bg=e.$wg.getComparisonKey.bind(e.$wg),e.$Cg=e.$wg.basenameOrAuthority.bind(e.$wg),e.$Dg=e.$wg.basename.bind(e.$wg),e.$Eg=e.$wg.extname.bind(e.$wg),e.$Fg=e.$wg.dirname.bind(e.$wg),e.$Gg=e.$wg.joinPath.bind(e.$wg),e.$Hg=e.$wg.normalizePath.bind(e.$wg),e.$Ig=e.$wg.relativePath.bind(e.$wg),e.$Jg=e.$wg.resolvePath.bind(e.$wg),e.$Kg=e.$wg.isAbsolutePath.bind(e.$wg),e.$Lg=e.$wg.isEqualAuthority.bind(e.$wg),e.$Mg=e.$wg.hasTrailingPathSeparator.bind(e.$wg),e.$Ng=e.$wg.removeTrailingPathSeparator.bind(e.$wg),e.$Og=e.$wg.addTrailingPathSeparator.bind(e.$wg);function P(l,d){const y=[];for(let w=0;w<l.length;w++){const c=d(l[w]);l.some((f,m)=>m===w?!1:(0,e.$Ag)(c,d(f)))||y.push(l[w])}return y}e.$Pg=P;var S;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function d(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[h,v]=m.split(":");h&&v&&w.set(h,v)});const f=y.path.substring(0,y.path.indexOf(";"));return f&&w.set(l.META_DATA_MIME,f),w}l.parseMetaData=d})(S||(e.DataUri=S={}));function $(l,d,y){if(d){let w=l.path;return w&&w[0]!==A.$gc.sep&&(w=A.$gc.sep+w),l.with({scheme:y,authority:d,path:w})}return l.with({scheme:y})}e.$Qg=$}),define(le[6],he([0,1,26,7,3,2,19,5,129,52]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.Promises=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=void 0;function P(H){return!!H&&typeof H.then=="function"}e.$Rg=P;function S(H){const J=new O.$5d,ie=H(J.token),se=new Promise((ce,$e)=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),$e(new L.$5)});Promise.resolve(ie).then(ge=>{fe.dispose(),J.dispose(),ce(ge)},ge=>{fe.dispose(),J.dispose(),$e(ge)})});return new class{cancel(){J.cancel(),J.dispose()}then(ce,$e){return se.then(ce,$e)}catch(ce){return this.then(void 0,ce)}finally(ce){return se.finally(ce)}}}e.$Sg=S;function $(H,J,ie){return new Promise((se,ce)=>{const $e=J.onCancellationRequested(()=>{$e.dispose(),se(ie)});H.then(se,ce).finally(()=>$e.dispose())})}e.$Tg=$;function l(H,J){return new Promise((ie,se)=>{const ce=J.onCancellationRequested(()=>{ce.dispose(),se(new L.$5)});H.then(ie,se).finally(()=>ce.dispose())})}e.$Ug=l;async function d(H){let J=-1;const ie=H.map((se,ce)=>se.then($e=>(J=ce,$e)));try{return await Promise.race(ie)}finally{H.forEach((se,ce)=>{ce!==J&&se.cancel()})}}e.$Vg=d;function y(H,J,ie){let se;const ce=setTimeout(()=>{se?.(void 0),ie?.()},J);return Promise.race([H.finally(()=>clearTimeout(ce)),new Promise($e=>se=$e)])}e.$Wg=y;function w(H){return new Promise((J,ie)=>{const se=H();P(se)?se.then(J,ie):J(se)})}e.$Xg=w;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ie=()=>{if(this.b=null,this.f)return;const se=this.queue(this.d);return this.d=null,se};this.b=new Promise(se=>{this.a.then(ie,ie).then(se)})}return new Promise((ie,se)=>{this.b.then(ie,se)})}return this.a=J(),new Promise((ie,se)=>{this.a.then(ce=>{this.a=null,ie(ce)},ce=>{this.a=null,se(ce)})})}dispose(){this.f=!0}}e.$Yg=c;class f{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$Zg=f;class m{constructor(){this.a=new Map}queue(J,ie){const ce=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(J)===ce&&this.a.delete(J)});return this.a.set(J,ce),ce}}e.$1g=m;const h=(H,J)=>{let ie=!0;const se=setTimeout(()=>{ie=!1,J()},H);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(se),ie=!1}}},v=H=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,H())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class i{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ie=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ce,$e)=>{this.d=ce,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const se=()=>{this.a=null,this.d?.(null)};return this.a=ie===k.$Rd?v(se):h(ie,se),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$2g=i;class o{constructor(J){this.a=new i(J),this.b=new c}trigger(J,ie){return this.a.trigger(()=>this.b.queue(J),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$3g=o;class s{constructor(){this.a=!1,this.b=new Promise((J,ie)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$4g=s;class n extends s{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$5g=n;function t(H,J){return J?new Promise((ie,se)=>{const ce=setTimeout(()=>{$e.dispose(),ie()},H),$e=J.onCancellationRequested(()=>{clearTimeout(ce),$e.dispose(),se(new L.$5)})}):S(ie=>t(H,ie))}e.$6g=t;function r(H,J=0,ie){const se=setTimeout(()=>{H(),ie&&ce.dispose()},J),ce=(0,j.$Rc)(()=>{clearTimeout(se),ie?.deleteAndLeak(ce)});return ie?.add(ce),ce}e.$7g=r;function a(H){const J=[];let ie=0;const se=H.length;function ce(){return ie<se?H[ie++]():null}function $e(fe){fe!=null&&J.push(fe);const ge=ce();return ge?ge.then($e):Promise.resolve(J)}return Promise.resolve(null).then($e)}e.$8g=a;function E(H,J=se=>!!se,ie=null){let se=0;const ce=H.length,$e=()=>{if(se>=ce)return Promise.resolve(ie);const fe=H[se++];return Promise.resolve(fe()).then(Ee=>J(Ee)?Promise.resolve(Ee):$e())};return $e()}e.$9g=E;function b(H,J=se=>!!se,ie=null){if(H.length===0)return Promise.resolve(ie);let se=H.length;const ce=()=>{se=-1;for(const $e of H)$e.cancel?.()};return new Promise(($e,fe)=>{for(const ge of H)ge.then(Ee=>{--se>=0&&J(Ee)?(ce(),$e(Ee)):se===0&&$e(ie)}).catch(Ee=>{--se>=0&&(ce(),fe(Ee))})})}e.$0g=b;class u{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new A.$Ud}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,se)=>{this.g.push({factory:J,c:ie,e:se}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const ie=J.factory();ie.then(J.c,J.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.h.dispose()}}e.$$g=u;class p extends u{constructor(){super(1)}}e.$_g=p;class R{constructor(){this.a=new G,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$ah=R;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ee;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,ie=I.$wg){const se=ie.getComparisonKey(J);let ce=this.a.get(se);if(!ce){ce=new p;const $e=this.f++,fe=A.Event.once(ce.onDrained)(()=>{ce?.dispose(),this.a.delete(se),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$3c),this.d.set($e,fe),this.a.set(se,ce)}return ce}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$bh=N;class F{constructor(J,ie){this.a=-1,typeof J=="function"&&typeof ie=="number"&&this.setIfNotSet(J,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ie)}setIfNotSet(J,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ie))}}e.$ch=F;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,ie,se=globalThis){this.cancel();const ce=se.setInterval(()=>{J()},ie);this.d=(0,j.$Rc)(()=>{se.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$dh=M;class q{constructor(J,ie){this.b=-1,this.a=J,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$eh=q;class Y{constructor(J,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=J,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$fh=Y;class K extends q{constructor(J,ie){super(J,ie),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$gh=K;class x extends j.$Tc{constructor(J,ie){super(),this.g=J,this.h=ie,this.a=[],this.b=this.B(new j.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of J)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$hh=x,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$jh=(H,J)=>{(0,C.$B)(()=>{if(ie)return;const se=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$jh=(H,J,ie)=>{const se=H.requestIdleCallback(J,typeof ie=="number"?{timeout:ie}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,H.cancelIdleCallback(se))}}},e.$ih=H=>(0,e.$jh)(globalThis,H)}();class V{constructor(J,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(se){this.l=se}finally{this.g=!0}},this.f=(0,e.$jh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$kh=V;class Q extends V{constructor(J){super(globalThis,J)}}e.$lh=Q;async function W(H,J,ie){let se;for(let ce=0;ce<ie;ce++)try{return await H()}catch($e){se=$e,await t(J)}throw se}e.$mh=W;class G{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ie,se){return this.a={taskId:J,cancel:()=>se?.(),promise:ie},ie.then(()=>this.d(J),()=>this.d(J)),ie}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{let ie,se;const ce=new Promise(($e,fe)=>{ie=$e,se=fe});this.b={run:J,promise:ce,promiseResolve:ie,promiseReject:se}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$nh=G;class te{constructor(J,ie=()=>Date.now()){this.d=J,this.f=ie,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$oh=te;var re;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(re||(re={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,ie)=>{this.a=J,this.b=ie})}complete(J){return new Promise(ie=>{this.a(J),this.d={outcome:0,value:J},ie()})}error(J){return new Promise(ie=>{this.b(J),this.d={outcome:1,value:J},ie()})}cancel(){return this.error(new L.$5)}}e.$ph=ee;var ae;(function(H){async function J(se){let ce;const $e=await Promise.all(se.map(fe=>fe.then(ge=>ge,ge=>{ce||(ce=ge)})));if(typeof ce<"u")throw ce;return $e}H.settled=J;function ie(se){return new Promise(async(ce,$e)=>{try{await se(ce,$e)}catch(fe){$e(fe)}})}H.withAsyncBody=ie})(ae||(e.Promises=ae={}));class Z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$qh=Z;class z{constructor(J){this.b=J,this.a=new g.$V(()=>new Z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$rh=z;var D;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(D||(D={}));class T{static fromArray(J){return new T(ie=>{ie.emitMany(J)})}static fromPromise(J){return new T(async ie=>{ie.emitMany(await J)})}static fromPromises(J){return new T(async ie=>{await Promise.all(J.map(async se=>ie.emitOne(await se)))})}static merge(J){return new T(async ie=>{await Promise.all(J.map(async se=>{for await(const ce of se)ie.emitOne(ce)}))})}static{this.EMPTY=T.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new A.$Ud,queueMicrotask(async()=>{const ie={emitOne:se=>this.g(se),emitMany:se=>this.h(se),reject:se=>this.k(se)};try{await Promise.resolve(J(ie)),this.j()}catch(se){this.k(se)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(J,ie){return new T(async se=>{for await(const ce of J)se.emitOne(ie(ce))})}map(J){return T.map(this,J)}static filter(J,ie){return new T(async se=>{for await(const ce of J)ie(ce)&&se.emitOne(ce)})}filter(J){return T.filter(this,J)}static coalesce(J){return T.filter(J,ie=>!!ie)}coalesce(){return T.coalesce(this)}static async toPromise(J){const ie=[];for await(const se of J)ie.push(se);return ie}toPromise(){return T.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$sh=T;class B extends T{constructor(J,ie){super(ie),this.l=J}cancel(){this.l.cancel()}}e.$th=B;function U(H){const J=new O.$5d,ie=H(J.token);return new B(J,async se=>{const ce=J.token.onCancellationRequested(()=>{ce.dispose(),J.dispose(),se.reject(new L.$5)});try{for await(const $e of ie){if(J.token.isCancellationRequested)return;se.emitOne($e)}ce.dispose(),J.dispose()}catch($e){ce.dispose(),J.dispose(),se.reject($e)}})}e.$uh=U;class _{constructor(){this.a=new ee,this.b=new T(se=>{if(J){se.reject(J);return}return ie&&se.emitMany(ie),this.d=ce=>se.reject(ce),this.f=ce=>se.emitOne(ce),this.a.p});let J,ie;this.f=se=>{ie||(ie=[]),ie.push(se)},this.d=se=>{J||(J=se)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$vh=_}),define(le[91],he([0,1,17,6,49,35,16,5,27]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=void 0;function g(){return Object.create(null)}e.$Gj=g,e.$Hj="**",e.$Ij="/";const P="[/\\\\]",S="[^/\\\\]",$=/\//g;function l(Q,W){switch(Q){case 0:return"";case 1:return`${S}*?`;default:return`(?:${P}|${S}+${P}${W?`|${P}${S}+`:""})*?`}}function d(Q,W){if(!Q)return[];const G=[];let te=!1,re=!1,ee="";for(const ae of Q){switch(ae){case W:if(!te&&!re){G.push(ee),ee="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":re=!0;break;case"]":re=!1;break}ee+=ae}return ee&&G.push(ee),G}e.$Jj=d;function y(Q){if(!Q)return"";let W="";const G=d(Q,e.$Ij);if(G.every(te=>te===e.$Hj))W=".*";else{let te=!1;G.forEach((re,ee)=>{if(re===e.$Hj){if(te)return;W+=l(2,ee===G.length-1)}else{let ae=!1,Z="",z=!1,D="";for(const T of re){if(T!=="}"&&ae){Z+=T;continue}if(z&&(T!=="]"||!D)){let B;T==="-"?B=T:(T==="^"||T==="!")&&!D?B="^":T===e.$Ij?B="":B=(0,k.$Ne)(T),D+=B;continue}switch(T){case"{":ae=!0;continue;case"[":z=!0;continue;case"}":{const U=`(?:${d(Z,",").map(_=>y(_)).join("|")})`;W+=U,ae=!1,Z="";break}case"]":{W+="["+D+"]",z=!1,D="";break}case"?":W+=S;continue;case"*":W+=l(1);continue;default:W+=(0,k.$Ne)(T)}}ee<G.length-1&&(G[ee+1]!==e.$Hj||ee+2<G.length)&&(W+=P)}te=re===e.$Hj})}return W}const w=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new j.$Dc(1e4),o=function(){return!1},s=function(){return null};function n(Q,W){if(!Q)return s;let G;typeof Q!="string"?G=Q.pattern:G=Q,G=G.trim();const te=`${G}_${!!W.trimForExclusions}`;let re=i.get(te);if(re)return t(re,Q);let ee;return w.test(G)?re=a(G.substr(4),G):(ee=c.exec(r(G,W)))?re=E(ee[1],G):(W.trimForExclusions?m:f).test(G)?re=b(G,W):(ee=h.exec(r(G,W)))?re=u(ee[1].substr(1),G,!0):(ee=v.exec(r(G,W)))?re=u(ee[1],G,!1):re=p(G),i.set(te,re),t(re,Q)}function t(Q,W){if(typeof W=="string")return Q;const G=function(te,re){return(0,A.$7f)(te,W.base,!C.$k)?Q((0,k.$Se)(te.substr(W.base.length),I.sep),re):null};return G.allBasenames=Q.allBasenames,G.allPaths=Q.allPaths,G.basenames=Q.basenames,G.patterns=Q.patterns,G}function r(Q,W){return W.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function a(Q,W){return function(G,te){return typeof G=="string"&&G.endsWith(Q)?W:null}}function E(Q,W){const G=`/${Q}`,te=`\\${Q}`,re=function(ae,Z){return typeof ae!="string"?null:Z?Z===Q?W:null:ae===Q||ae.endsWith(G)||ae.endsWith(te)?W:null},ee=[Q];return re.basenames=ee,re.patterns=[W],re.allBasenames=ee,re}function b(Q,W){const G=x(Q.slice(1,-1).split(",").map(Z=>n(Z,W)).filter(Z=>Z!==s),Q),te=G.length;if(!te)return s;if(te===1)return G[0];const re=function(Z,z){for(let D=0,T=G.length;D<T;D++)if(G[D](Z,z))return Q;return null},ee=G.find(Z=>!!Z.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=G.reduce((Z,z)=>z.allPaths?Z.concat(z.allPaths):Z,[]);return ae.length&&(re.allPaths=ae),re}function u(Q,W,G){const te=I.sep===I.$gc.sep,re=te?Q:Q.replace($,I.sep),ee=I.sep+re,ae=I.$gc.sep+Q;let Z;return G?Z=function(z,D){return typeof z=="string"&&(z===re||z.endsWith(ee)||!te&&(z===Q||z.endsWith(ae)))?W:null}:Z=function(z,D){return typeof z=="string"&&(z===re||!te&&z===Q)?W:null},Z.allPaths=[(G?"*/":"./")+Q],Z}function p(Q){try{const W=new RegExp(`^${y(Q)}$`);return function(G){return W.lastIndex=0,typeof G=="string"&&W.test(G)?Q:null}}catch{return s}}function R(Q,W,G){return!Q||typeof W!="string"?!1:N(Q)(W,void 0,G)}e.$Kj=R;function N(Q,W={}){if(!Q)return o;if(typeof Q=="string"||F(Q)){const G=n(Q,W);if(G===s)return o;const te=function(re,ee){return!!G(re,ee)};return G.allBasenames&&(te.allBasenames=G.allBasenames),G.allPaths&&(te.allPaths=G.allPaths),te}return Y(Q,W)}e.$Lj=N;function F(Q){const W=Q;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.$Mj=F;function M(Q){return Q.allBasenames||[]}e.$Nj=M;function q(Q){return Q.allPaths||[]}e.$Oj=q;function Y(Q,W){const G=x(Object.getOwnPropertyNames(Q).map(Z=>K(Z,Q[Z],W)).filter(Z=>Z!==s)),te=G.length;if(!te)return s;if(!G.some(Z=>!!Z.requiresSiblings)){if(te===1)return G[0];const Z=function(T,B){let U;for(let _=0,H=G.length;_<H;_++){const J=G[_](T,B);if(typeof J=="string")return J;(0,L.$Rg)(J)&&(U||(U=[]),U.push(J))}return U?(async()=>{for(const _ of U){const H=await _;if(typeof H=="string")return H}return null})():null},z=G.find(T=>!!T.allBasenames);z&&(Z.allBasenames=z.allBasenames);const D=G.reduce((T,B)=>B.allPaths?T.concat(B.allPaths):T,[]);return D.length&&(Z.allPaths=D),Z}const re=function(Z,z,D){let T,B;for(let U=0,_=G.length;U<_;U++){const H=G[U];H.requiresSiblings&&D&&(z||(z=(0,I.$nc)(Z)),T||(T=z.substr(0,z.length-(0,I.$oc)(Z).length)));const J=H(Z,z,T,D);if(typeof J=="string")return J;(0,L.$Rg)(J)&&(B||(B=[]),B.push(J))}return B?(async()=>{for(const U of B){const _=await U;if(typeof _=="string")return _}return null})():null},ee=G.find(Z=>!!Z.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=G.reduce((Z,z)=>z.allPaths?Z.concat(z.allPaths):Z,[]);return ae.length&&(re.allPaths=ae),re}function K(Q,W,G){if(W===!1)return s;const te=n(Q,G);if(te===s)return s;if(typeof W=="boolean")return te;if(W){const re=W.when;if(typeof re=="string"){const ee=(ae,Z,z,D)=>{if(!D||!te(ae,Z))return null;const T=re.replace("$(basename)",()=>z),B=D(T);return(0,L.$Rg)(B)?B.then(U=>U?Q:null):B?Q:null};return ee.requiresSiblings=!0,ee}}return te}function x(Q,W){const G=Q.filter(Z=>!!Z.basenames);if(G.length<2)return Q;const te=G.reduce((Z,z)=>{const D=z.basenames;return D?Z.concat(D):Z},[]);let re;if(W){re=[];for(let Z=0,z=te.length;Z<z;Z++)re.push(W)}else re=G.reduce((Z,z)=>{const D=z.patterns;return D?Z.concat(D):Z},[]);const ee=function(Z,z){if(typeof Z!="string")return null;if(!z){let T;for(T=Z.length;T>0;T--){const B=Z.charCodeAt(T-1);if(B===47||B===92)break}z=Z.substr(T)}const D=te.indexOf(z);return D!==-1?re[D]:null};ee.basenames=te,ee.patterns=re,ee.allBasenames=te;const ae=Q.filter(Z=>!Z.basenames);return ae.push(ee),ae}function V(Q,W){return(0,O.$ub)(Q,W,(G,te)=>typeof G=="string"&&typeof te=="string"?G===te:typeof G!="string"&&typeof te!="string"?G.base===te.base&&G.pattern===te.pattern:!1)}e.$Pj=V}),define(le[92],he([0,1,14,10]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function A(S){return S.toJSON()}class j{constructor($){this.a=$}transformIncoming($){const l=this.a.transformIncoming($);return l===$?$:A(L.URI.from(l))}transformOutgoing($){const l=this.a.transformOutgoing($);return l===$?$:A(L.URI.from(l))}transformOutgoingURI($){const l=this.a.transformOutgoing($);return l===$?$:L.URI.from(l)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$3m=j,e.$4m=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function I(S,$,l){if(!S||l>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return $.transformOutgoing(S);for(const d in S)if(Object.hasOwnProperty.call(S,d)){const y=I(S[d],$,l+1);y!==null&&(S[d]=y)}}return null}function C(S,$){const l=I(S,$,0);return l===null?S:l}e.$5m=C;function k(S,$,l,d){if(!S||d>200)return null;if(typeof S=="object"){if(S.$mid===1)return l?L.URI.revive($.transformIncoming(S)):$.transformIncoming(S);if(S instanceof O.$ie)return null;for(const y in S)if(Object.hasOwnProperty.call(S,y)){const w=k(S[y],$,l,d+1);w!==null&&(S[y]=w)}}return null}function g(S,$){const l=k(S,$,!1,0);return l===null?S:l}e.$6m=g;function P(S,$){const l=k(S,$,!0,0);return l===null?S:l}e.$7m=P}),define(le[142],he([0,1,36,48,32,130,5]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=void 0,e.$9m=new class{c($){return this.a||(this.a=L.$$h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,l=0;const d=(0,O.networkInterfaces)();for(const y in d){const w=d[y];if(w)for(const{mac:c,internal:f}of w)f||(l+=1,this.c(c.toUpperCase())&&($+=1))}this.b=l>0?$/l:0}return this.b}};let C;async function k($){return C||(C=(async()=>await g($)||A.$pg())()),C}e.$0m=k;async function g($){try{const l=await new Promise((y,w)=>{ne(["crypto"],y,w)}),d=(0,j.$8m)();return l.createHash("sha256").update(d,"utf8").digest("hex")}catch(l){$(l);return}}const P="Software\\Microsoft\\SQMClient";async function S($){if(I.$i){const l=await new Promise((d,y)=>{ne(["@vscode/windows-registry"],d,y)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(d){return $(d),""}}return""}e.$$m=S}),define(le[31],he([0,1,54,36,268,6,49,88,16,5,19,10]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function l(K,x=$.UNLINK,V){if((0,I.$0f)(K))throw new Error("rimraf - will refuse to recursively delete root");return x===$.UNLINK?y(K):d(K,V)}async function d(K,x=(0,I.$cg)((0,L.tmpdir)())){try{try{await O.promises.rename(K,x)}catch(V){return V.code==="ENOENT"?void 0:y(K)}y(x).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function y(K){return(0,A.promisify)(O.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function w(K){if((0,I.$0f)(K))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function c(K,x){return h(await(x?f(K):(0,A.promisify)(O.readdir)(K)))}async function f(K){try{return await(0,A.promisify)(O.readdir)(K,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],V=await c(K);for(const Q of V){let W=!1,G=!1,te=!1;try{const re=await e.Promises.lstat((0,k.$jc)(K,Q));W=re.isFile(),G=re.isDirectory(),te=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}x.push({name:Q,isFile:()=>W,isDirectory:()=>G,isSymbolicLink:()=>te})}return x}function m(K){return h(O.readdirSync(K))}e.readdirSync=m;function h(K){return K.map(x=>typeof x=="string"?g.$j?(0,C.$Fl)(x):x:(x.name=g.$j?(0,C.$Fl)(x.name):x.name,x))}async function v(K){const x=await c(K),V=[];for(const Q of x)await o.existsDirectory((0,k.$jc)(K,Q))&&V.push(Q);return V}function i(K,x=1e3){return new Promise(V=>{let Q=!1;const W=setInterval(()=>{Q||(Q=!0,O.access(K,G=>{Q=!1,G&&(clearInterval(W),V(void 0))}))},x)})}e.whenDeleted=i;var o;(function(K){async function x(W){let G;try{if(G=await e.Promises.lstat(W),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(g.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw re}throw te}}K.stat=x;async function V(W){try{const{stat:G,symbolicLink:te}=await K.stat(W);return G.isFile()&&te?.dangling!==!0}catch{}return!1}K.existsFile=V;async function Q(W){try{const{stat:G,symbolicLink:te}=await K.stat(W);return G.isDirectory()&&te?.dangling!==!0}catch{}return!1}K.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const s=new j.$bh;function n(K,x,V){return s.queueFor(S.URI.file(K),P.$xg).queue(()=>{const Q=b(V);return new Promise((W,G)=>a(K,x,Q,te=>te?G(te):W()))})}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function a(K,x,V,Q){if(!t)return O.writeFile(K,x,{mode:V.mode,flag:V.flag},Q);O.open(K,V.flag,V.mode,(W,G)=>{if(W)return Q(W);O.writeFile(G,x,te=>{if(te)return O.close(G,()=>Q(te));O.fdatasync(G,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r(!1)),O.close(G,ee=>Q(ee))))})})}function E(K,x,V){const Q=b(V);if(!t)return O.writeFileSync(K,x,{mode:Q.mode,flag:Q.flag});const W=O.openSync(K,Q.flag,Q.mode);try{O.writeFileSync(W,x);try{O.fdatasyncSync(W)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),r(!1)}}finally{O.closeSync(W)}}e.writeFileSync=E;function b(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function u(K,x,V=6e4){if(K!==x)try{g.$i&&typeof V=="number"?await p(K,x,Date.now(),V):await(0,A.promisify)(O.rename)(K,x)}catch(Q){if(K.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||K.endsWith("."))await R(K,x,{preserveSymlinks:!1}),await l(K,$.MOVE);else throw Q}}async function p(K,x,V,Q,W=0){try{return await(0,A.promisify)(O.rename)(K,x)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-V>=Q)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${G}`),G;if(W===0){let te=!1;try{const{stat:re}=await o.stat(x);re.isFile()||(te=!0)}catch{}if(te)throw G}return await(0,j.$6g)(Math.min(100,W*10)),p(K,x,V,Q,W+1)}}async function R(K,x,V){return F(K,x,{root:{source:K,target:x},options:V,handledSourcePaths:new Set})}const N=511;async function F(K,x,V){if(V.handledSourcePaths.has(K))return;V.handledSourcePaths.add(K);const{stat:Q,symbolicLink:W}=await o.stat(K);if(W){if(V.options.preserveSymlinks)try{return await Y(K,x,V)}catch{}if(W.dangling)return}return Q.isDirectory()?M(K,x,Q.mode&N,V):q(K,x,Q.mode&N)}async function M(K,x,V,Q){await e.Promises.mkdir(x,{recursive:!0,mode:V});const W=await c(K);for(const G of W)await F((0,k.$jc)(K,G),(0,k.$jc)(x,G),Q)}async function q(K,x,V){await e.Promises.copyFile(K,x),await e.Promises.chmod(x,V)}async function Y(K,x,V){let Q=await e.Promises.readlink(K);(0,I.$7f)(Q,V.root.source,!g.$k)&&(Q=(0,k.$jc)(V.root.target,Q.substr(V.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,A.promisify)(O.access)}get stat(){return(0,A.promisify)(O.stat)}get lstat(){return(0,A.promisify)(O.lstat)}get utimes(){return(0,A.promisify)(O.utimes)}get read(){return(K,x,V,Q,W)=>new Promise((G,te)=>{O.read(K,x,V,Q,W,(re,ee,ae)=>re?te(re):G({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,A.promisify)(O.readFile)}get write(){return(K,x,V,Q,W)=>new Promise((G,te)=>{O.write(K,x,V,Q,W,(re,ee,ae)=>re?te(re):G({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,A.promisify)(O.appendFile)}get fdatasync(){return(0,A.promisify)(O.fdatasync)}get truncate(){return(0,A.promisify)(O.truncate)}get copyFile(){return(0,A.promisify)(O.copyFile)}get open(){return(0,A.promisify)(O.open)}get close(){return(0,A.promisify)(O.close)}get symlink(){return(0,A.promisify)(O.symlink)}get readlink(){return(0,A.promisify)(O.readlink)}get chmod(){return(0,A.promisify)(O.chmod)}get mkdir(){return(0,A.promisify)(O.mkdir)}get unlink(){return(0,A.promisify)(O.unlink)}get rmdir(){return(0,A.promisify)(O.rmdir)}get realpath(){return(0,A.promisify)(O.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return v}get writeFile(){return n}get rm(){return l}get rename(){return u}get copy(){return R}}}),define(le[143],he([0,1,54,16,5,27,31]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=e.$sq=void 0;function C($){if(A.$k)return $;const l=(0,L.$mc)($);if($===l)return $;const d=((0,L.$nc)($)||$).toLowerCase();try{const w=(0,I.readdirSync)(l).filter(c=>c.toLowerCase()===d);if(w.length===1){const c=C(l);if(c)return(0,L.$jc)(c,w[0])}else if(w.length>1){const c=w.indexOf(d);if(c>=0){const f=C(l);if(f)return(0,L.$jc)(f,w[c])}}}catch{}return null}e.$sq=C;async function k($){if(A.$k)return $;const l=(0,L.$mc)($);if($===l)return $;const d=((0,L.$nc)($)||$).toLowerCase();try{const w=(await I.Promises.readdir(l)).filter(c=>c.toLowerCase()===d);if(w.length===1){const c=await k(l);if(c)return(0,L.$jc)(c,w[0])}else if(w.length>1){const c=w.indexOf(d);if(c>=0){const f=await k(l);if(f)return(0,L.$jc)(f,w[c])}}}catch{}return null}e.$tq=k;async function g($){try{return await I.Promises.realpath($)}catch{const d=S($);return await I.Promises.access(d,O.constants.R_OK),d}}e.$uq=g;function P($){try{return O.realpathSync($)}catch{const d=S($);return O.accessSync(d,O.constants.R_OK),d}}e.$vq=P;function S($){return(0,j.$Te)((0,L.$hc)($),L.sep)}}),define(le[144],he([0,1,16,5,37,90,12,31]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Tl=e.$Sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function k(S=A.env){return S.comspec||"cmd.exe"}e.$Sl=k;function g(S){let $=[],l=!1;const d=function(y){if(l){$.push(y);return}(!S.send(y,c=>{if(c&&console.error(c),l=!1,$.length>0){const f=$.slice(0);$=[],f.forEach(m=>d(m))}})||L.$i)&&(l=!0)};return{send:d}}e.$Tl=g;var P;(function(S){async function $(l,d,y){if(O.$ic(l))return l;if(d===void 0&&(d=A.cwd()),O.$mc(l)!=="."||(y===void 0&&I.$Hf(A.env.PATH)&&(y=A.env.PATH.split(O.$tc)),y===void 0||y.length===0))return O.$jc(d,l);async function c(f){if(await C.Promises.exists(f)){let m;try{m=await C.Promises.stat(f)}catch(h){h.message.startsWith("EACCES")&&(m=await C.Promises.lstat(f))}return m?!m.isDirectory():!1}return!1}for(const f of y){let m;if(O.$ic(f)?m=O.$jc(f,l):m=O.$jc(d,f,l),await c(m))return m;let h=m+".com";if(await c(h)||(h=m+".exe",await c(h)))return h}return O.$jc(d,l)}S.findExecutable=$})(P||(e.win32=P={}))}),define(le[145],he([0,1,67,23]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;function A(I){return new Promise((C,k)=>{let g;const P=new Map;function S(l,d,y,w,c){const f=P.get(d);if(l===I||f){const m={name:$(y),cmd:y,pid:l,ppid:d,load:w,mem:c};P.set(l,m),l===I&&(g=m),f&&(f.children||(f.children=[]),f.children.push(m),f.children.length>1&&(f.children=f.children.sort((h,v)=>h.pid-v.pid)))}}function $(l){const d=/--utility-sub-type=network/i,y=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(y.exec(l))return"electron-crash-reporter";if(w.exec(l))return"winpty-agent";if(c.exec(l))return"conpty-agent";let m=f.exec(l);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?d.exec(l)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const h=/[a-zA-Z-]+\.js/g;let v="";do m=h.exec(l),m&&(v+=m+" ");while(m);return v&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${v})`:l}if(process.platform==="win32"){const l=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,y)=>{ne(["@vscode/windows-process-tree"],d,y)}).then(d=>{d.getProcessList(I,y=>{if(!y){k(new Error(`Root process ${I} not found`));return}d.getProcessCpuUsage(y,w=>{const c=new Map;w.forEach(f=>{const m=l(f.commandLine||"");c.set(f.pid,{name:$(m),cmd:m,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),g=c.get(I),g?(c.forEach(f=>{const m=c.get(f.ppid);m&&(m.children||(m.children=[]),m.children.push(f))}),c.forEach(f=>{f.children&&(f.children=f.children.sort((m,h)=>m.pid-h.pid))}),C(g)):k(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let l=function(){let d=[g];const y=[];for(;d.length;){const c=d.shift();c&&(y.push(c.pid),c.children&&(d=d.concat(c.children)))}let w=JSON.stringify(L.$ng.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,O.exec)(w,{},(c,f,m)=>{if(c||m)k(c||new Error(m.toString()));else{const h=f.toString().split(`
`);for(let v=0;v<y.length;v++){const i=P.get(y[v]);i.load=parseFloat(h[v])}if(!g){k(new Error(`Root process ${I} not found`));return}C(g)}})};(0,O.exec)("which ps",{},(d,y,w)=>{if(d||w)if(process.platform!=="linux")k(d||new Error(w.toString()));else{const c=JSON.stringify(L.$ng.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(c,{},(f,m,h)=>{f||h?k(f||new Error(h.toString())):(j(m,S),l())})}else{const c=y.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,O.exec)(`${c} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,h,v)=>{m||v&&!v.includes("screen size is bogus")?k(m||new Error(v.toString())):(j(h,S),process.platform==="linux"?l():g?C(g):k(new Error(`Root process ${I} not found`)))})}})}})}e.$4r=A;function j(I,C){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const P of g){const S=k.exec(P.trim());S&&S.length===6&&C(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var ye=this&&this.__decorate||function(ne,e,O,L){var A=arguments.length,j=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,O):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,O,L);else for(var C=ne.length-1;C>=0;C--)(I=ne[C])&&(j=(A<3?I(j):A>3?I(e,O,j):I(e,O))||j);return A>3&&j&&Object.defineProperty(e,O,j),j};define(le[40],he([0,1,17,6,14,26,85,7,3,2,66,27,12]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.ProxyChannel=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.RequestInitiator=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;var l;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(l||(l={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(y||(y={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(c||(c={}));function f(W){let G=0;for(let te=0;;te+=7){const re=W.read(1);if(G|=(re.buffer[0]&127)<<te,!(re.buffer[0]&128))return G}}const m=s(0);function h(W,G){if(G===0){W.write(m);return}let te=0;for(let ee=G;ee!==0;ee=ee>>>7)te++;const re=A.$ie.alloc(te);for(let ee=0;G!==0;ee++)re.buffer[ee]=G&127,G=G>>>7,G>0&&(re.buffer[ee]|=128);W.write(re)}class v{constructor(G){this.b=G,this.a=0}read(G){const te=this.b.slice(this.a,this.a+G);return this.a+=te.byteLength,te}}e.$Ch=v;class i{constructor(){this.a=[]}get buffer(){return A.$ie.concat(this.a)}write(G){this.a.push(G)}}e.$Dh=i;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function s(W){const G=A.$ie.alloc(1);return G.writeUInt8(W,0),G}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},t=typeof Buffer<"u";function r(W,G){if(typeof G>"u")W.write(n.Undefined);else if(typeof G=="string"){const te=A.$ie.fromString(G);W.write(n.String),h(W,te.byteLength),W.write(te)}else if(t&&Buffer.isBuffer(G)){const te=A.$ie.wrap(G);W.write(n.Buffer),h(W,te.byteLength),W.write(te)}else if(G instanceof A.$ie)W.write(n.VSBuffer),h(W,G.byteLength),W.write(G);else if(Array.isArray(G)){W.write(n.Array),h(W,G.length);for(const te of G)r(W,te)}else if(typeof G=="number"&&(G|0)===G)W.write(n.Uint),h(W,G);else{const te=A.$ie.fromString(JSON.stringify(G));W.write(n.Object),h(W,te.byteLength),W.write(te)}}e.$Eh=r;function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(f(W)).toString();case o.Buffer:return W.read(f(W)).buffer;case o.VSBuffer:return W.read(f(W));case o.Array:{const te=f(W),re=[];for(let ee=0;ee<te;ee++)re.push(a(W));return re}case o.Object:return JSON.parse(W.read(f(W)).toString());case o.Int:return f(W)}}e.$Fh=a;class E{constructor(G,te,re=null,ee=1e3){this.h=G,this.j=te,this.k=re,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(G,te){this.b.set(G,te),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const te=this.o([G.type]);this.k?.logOutgoing(te,0,1,w(G.type));return}case 201:case 202:case 204:case 203:{const te=this.o([G.type,G.id],G.data);this.k?.logOutgoing(te,G.id,1,w(G.type),G.data);return}}}o(G,te=void 0){const re=new i;return r(re,G),r(re,te),this.p(re.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const te=new v(G),re=a(te),ee=a(te),ae=re[0];switch(ae){case 100:return this.k?.logIncoming(G.byteLength,re[1],1,`${d(ae)}: ${re[2]}.${re[3]}`,ee),this.s({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 102:return this.k?.logIncoming(G.byteLength,re[1],1,`${d(ae)}: ${re[2]}.${re[3]}`,ee),this.t({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 101:return this.k?.logIncoming(G.byteLength,re[1],1,`${d(ae)}`),this.u({type:ae,id:re[1]});case 103:return this.k?.logIncoming(G.byteLength,re[1],1,`${d(ae)}`),this.u({type:ae,id:re[1]})}}s(G){const te=this.b.get(G.channelName);if(!te){this.v(G);return}const re=new j.$5d;let ee;try{ee=te.call(this.j,G.name,G.arg,re.token)}catch(z){ee=Promise.reject(z)}const ae=G.id;ee.then(z=>{this.m({id:ae,data:z,type:201})},z=>{z instanceof Error?this.m({id:ae,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:ae,data:z,type:203})}).finally(()=>{Z.dispose(),this.d.delete(G.id)});const Z=(0,g.$Rc)(()=>re.cancel());this.d.set(G.id,Z)}t(G){const te=this.b.get(G.channelName);if(!te){this.v(G);return}const re=G.id,ae=te.listen(this.j,G.name,G.arg)(Z=>this.m({id:re,data:Z,type:204}));this.d.set(G.id,ae)}u(G){const te=this.d.get(G.id);te&&(te.dispose(),this.d.delete(G.id))}v(G){let te=this.g.get(G.channelName);te||(te=[],this.g.set(G.channelName,te));const re=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:G,timeoutTimer:re})}w(G){const te=this.g.get(G);if(te){for(const re of te)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Gh=E;var b;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class u{constructor(G,te=null){this.l=G,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Ud,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=te}getChannel(G){const te=this;return{call(re,ee,ae){return te.a?Promise.reject(new C.$5):te.m(G,re,ee,ae)},listen(re,ee){return te.a?k.Event.None:te.o(G,re,ee)}}}m(G,te,re,ee=j.CancellationToken.None){const ae=this.g++,z={id:ae,type:100,channelName:G,name:te,arg:re};if(ee.isCancellationRequested)return Promise.reject(new C.$5);let D;return new Promise((B,U)=>{if(ee.isCancellationRequested)return U(new C.$5);const _=()=>{const se=ce=>{switch(ce.type){case 201:this.f.delete(ae),B(ce.data);break;case 202:{this.f.delete(ae);const $e=new Error(ce.data.message);$e.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,$e.name=ce.data.name,U($e);break}case 203:this.f.delete(ae),U(ce.data);break}};this.f.set(ae,se),this.p(z)};let H=null;this.b===c.Idle?_():(H=(0,L.$Sg)(se=>this.u()),H.then(()=>{H=null,_()}));const J=()=>{H?(H.cancel(),H=null):this.p({id:ae,type:101}),U(new C.$5)},ie=ee.onCancellationRequested(J);D=(0,g.$Qc)((0,g.$Rc)(J),ie),this.d.add(D)}).finally(()=>{D.dispose(),this.d.delete(D)})}o(G,te,re){const ee=this.g++,Z={id:ee,type:102,channelName:G,name:te,arg:re};let z=null;const D=new k.$Ud({onWillAddFirstListener:()=>{z=(0,L.$Sg)(B=>this.u()),z.then(()=>{z=null,this.d.add(D),this.p(Z)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(D),this.p({id:ee,type:103}))}}),T=B=>D.fire(B.data);return this.f.set(ee,T),D.event}p(G){switch(G.type){case 100:case 102:{const te=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(te,G.id,0,`${d(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const te=this.q([G.type,G.id]);this.j?.logOutgoing(te,G.id,0,d(G.type));return}}}q(G,te=void 0){const re=new i;return r(re,G),r(re,te),this.r(re.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const te=new v(G),re=a(te),ee=a(te),ae=re[0];switch(ae){case 200:return this.j?.logIncoming(G.byteLength,0,0,w(ae)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,re[1],0,w(ae),ee),this.t({type:re[0],id:re[1],data:ee})}}t(G){if(G.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=u,ye([I.$wh],u.prototype,"onDidInitializePromise",null);class p{get connections(){const G=[];return this.f.forEach(te=>G.push(te)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new k.$Ud,this.onDidAddConnection=this.g.event,this.h=new k.$Ud,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(G(({protocol:te,onDidClientDisconnect:re})=>{const ee=k.Event.once(te.onMessage);this.j.add(ee(ae=>{const Z=new v(ae),z=a(Z),D=new E(te,z),T=new u(te);this.a.forEach((U,_)=>D.registerChannel(_,U));const B={channelServer:D,channelClient:T,ctx:z};this.f.add(B),this.g.fire(B),this.j.add(re(()=>{D.dispose(),T.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(G,te){const re=this;return{call(ee,ae,Z){let z;if((0,$.$Vf)(te)){const T=(0,O.$4b)(re.connections.filter(te));z=T?Promise.resolve(T):k.Event.toPromise(k.Event.filter(re.onDidAddConnection,te))}else z=te.routeCall(re,ee,ae);const D=z.then(T=>T.channelClient.getChannel(G));return N(D).call(ee,ae,Z)},listen(ee,ae){if((0,$.$Vf)(te))return re.k(G,te,ee,ae);const Z=te.routeEvent(re,ee,ae).then(z=>z.channelClient.getChannel(G));return N(Z).listen(ee,ae)}}}k(G,te,re,ee){const ae=this;let Z;const z=new k.$Ud({onWillAddFirstListener:()=>{Z=new g.$Sc;const D=new k.$1d,T=new Map,B=_=>{const J=_.channelClient.getChannel(G).listen(re,ee),ie=D.add(J);T.set(_,ie)},U=_=>{const H=T.get(_);H&&(H.dispose(),T.delete(_))};ae.connections.filter(te).forEach(B),k.Event.filter(ae.onDidAddConnection,te)(B,void 0,Z),ae.onDidRemoveConnection(U,void 0,Z),D.event(z.fire,z,Z),Z.add(D)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return z.event}registerChannel(G,te){this.a.set(G,te);for(const re of this.f)re.channelServer.registerChannel(G,te)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Ih=p;class R{constructor(G,te,re=null){const ee=new i;r(ee,te),G.send(ee.buffer),this.a=new u(G,re),this.d=new E(G,te,re)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,te){this.d.registerChannel(G,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Jh=R;function N(W){return{call(G,te,re){return W.then(ee=>ee.call(G,te,re))},listen(G,te){const re=new k.$4d;return W.then(ee=>re.input=ee.listen(G,te)),re.event}}}e.$Kh=N;function F(W){let G=!1;return{call(te,re,ee){return G?W.call(te,re,ee):(0,L.$6g)(0).then(()=>G=!0).then(()=>W.call(te,re,ee))},listen(te,re){if(G)return W.listen(te,re);const ee=new k.$4d;return(0,L.$6g)(0).then(()=>G=!0).then(()=>ee.input=W.listen(te,re)),ee.event}}}e.$Lh=F;class M{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const te of G.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await k.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$Mh=M;var q;(function(W){function G(ae,Z,z){const D=ae,T=z&&z.disableMarshalling,B=new Map;for(const U in D)re(U)&&B.set(U,k.Event.buffer(D[U],!0,void 0,Z));return new class{listen(U,_,H){const J=B.get(_);if(J)return J;if(ee(_)){const ie=D[_];if(typeof ie=="function")return ie.call(D,H)}throw new C.$bb(`Event not found: ${_}`)}call(U,_,H){const J=D[_];if(typeof J=="function"){if(!T&&Array.isArray(H))for(let se=0;se<H.length;se++)H[se]=(0,P.$Bh)(H[se]);let ie=J.apply(D,H);return ie instanceof Promise||(ie=Promise.resolve(ie)),ie}throw new C.$bb(`Method not found: ${_}`)}}}W.fromService=G;function te(ae,Z){const z=Z&&Z.disableMarshalling;return new Proxy({},{get(D,T){if(typeof T=="string")return Z?.properties?.has(T)?Z.properties.get(T):ee(T)?function(B){return ae.listen(T,B)}:re(T)?ae.listen(T):async function(...B){let U;Z&&!(0,$.$Qf)(Z.context)?U=[Z.context,...B]:U=B;const _=await ae.call(T,U);return z?_:(0,P.$Bh)(_)};throw new C.$bb(`Property not found: ${String(T)}`)}})}W.toService=te;function re(ae){return ae[0]==="o"&&ae[1]==="n"&&S.$0e(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&S.$0e(ae.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const G=W.toString();if(G!=="[object Object]")return G}return W}function x(W){return Array.isArray(W)?W.map(K):K(W)}function V(W,G,te,re,ee,ae,Z){Z=x(Z);const z=Y[ee],D=z[re%z.length];let T=[`%c[${W}]%c[${String(G).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(ae)?(T=T.concat(Z),T.push(")")):T.push(Z),console.log.apply(console,T)}class Q{constructor(G,te){this.d=G,this.f=te,this.a=0,this.b=0}logOutgoing(G,te,re,ee,ae){this.b+=G,V(this.d,this.b,G,te,re,ee,ae)}logIncoming(G,te,re,ee,ae){this.a+=G,V(this.f,this.a,G,te,re,ee,ae)}}e.$Nh=Q}),define(le[68],he([0,1,14,3,2,40]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.ProtocolConstants=e.$Oh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var C;(function(n){n.enableDiagnostics=!1,n.records=[];const t=new WeakMap;let r=0;function a(b,u){if(!t.has(b)){const p=String(++r);t.set(b,p)}return t.get(b)}function E(b,u,p,R){if(!n.enableDiagnostics)return;const N=a(b,u);if(R instanceof O.$ie||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const F=O.$ie.alloc(R.byteLength);F.set(R),n.records.push({timestamp:Date.now(),id:N,label:u,type:p,buff:F})}else n.records.push({timestamp:Date.now(),id:N,label:u,type:p,data:R})}n.traceSocketEvent=E})(C||(e.SocketDiagnostics=C={}));var k;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function P(){return g||(g=O.$ie.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return P();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const a=O.$ie.alloc(t);let E=0,b=0;for(;t>0;){const u=this.a[b];if(u.byteLength>t){const p=u.slice(0,t);a.set(p,E),E+=t,r&&(this.a[b]=u.slice(t),this.b-=t),t-=t}else a.set(u,E),E+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):b++,t-=u.byteLength}return a}}e.$Oh=S;var $;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})($||($={}));function l(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class y{constructor(t,r,a,E){this.type=t,this.id=r,this.ack=a,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends A.$Tc{constructor(t){super(),this.f=this.B(new L.$Ud),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,E=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(a,E,b,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$ie.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=O.$ie.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class f extends A.$Tc{constructor(t){super(),this.f=new L.$Ud,this.onMessage=this.f.event,this.g=new L.$Ud,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new c(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$Ph=f;class m extends j.$Jh{static fromSocket(t,r){return new m(new f(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Qh=m;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$Ud({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Rh=h;class v{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new v(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let E=0;E<o.a;E++)t-this.c[E]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new h,this.onControlMessage=this.u.event,this.v=new h,this.onMessage=this.v.event,this.w=new h,this.onDidDispose=this.w.event,this.x=new h,this.onSocketClose=this.x.event,this.y=new h,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Sc,this.o=t.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,P());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,P());this.p.write(t)}sendResume(){const t=new y(8,0,0,P());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new A.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,P());this.p.write(t);const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,P())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new y(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(r>=2e4&&a>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const b=Math.max(2e4-r,2e4-a,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,P());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,P());this.p.write(t)}}e.$Sh=s}),define(le[93],he([0,1,67,6,14,26,140,7,3,2,30,144,90,40]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class d extends l.$Gh{constructor(c){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",f=>A.$ie.wrap(Buffer.from(f,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$pq=d;class y{constructor(c,f){this.i=c,this.j=f,this.c=new Set,this.g=new Map,this.h=new k.$Ud,this.onDidProcessExit=this.h.event;const m=f&&f.timeout?f.timeout:6e4;this.b=new L.$2g(m),this.d=null,this.f=null}getChannel(c){const f=this;return{call(m,h,v){return f.k(c,m,h,v)},listen(m,h){return f.l(c,m,h)}}}k(c,f,m,h=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(C.$6());this.b.cancel();const v=this.n(c),i=(0,L.$Sg)(n=>v.call(f,m,n)),o=h.onCancellationRequested(()=>i.cancel()),s=(0,g.$Rc)(()=>i.cancel());return this.c.add(s),i.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,f,m){if(!this.b)return k.Event.None;this.b.cancel();let h;const v=new k.$Ud({onWillAddFirstListener:()=>{h=this.n(c).listen(f,m)(v.fire,v),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return v.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,P.$un)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,$.$Rl)(f.env),this.d=(0,O.fork)(this.i,c,f);const m=new k.$Ud;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$lq)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}m.fire(A.$ie.wrap(Buffer.from(t,"base64")))});const v=this.j.useQueue?(0,S.$Tl)(this.d):this.d,i=t=>this.d&&this.d.connected&&v.send(t.buffer.toString("base64")),o=m.event,s={send:i,onMessage:o};this.f=new l.$Hh(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(c){let f=this.g.get(c);return f||(f=this.m.getChannel(c),this.g.set(c,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qq=y}),define(le[146],he([0,1,133,14,40,3,12,17]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DU=e.$CU=void 0;class k{constructor($){this.a=$,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",l=>l.data?L.$ie.wrap(l.data):L.$ie.alloc(0)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class g extends A.$Ih{static b($){(0,I.$Rf)((0,O.$BU)(process),"Electron Utility Process");const l=new j.$Ud;return process.parentPort.on("message",d=>{if($?.handledClientConnection(d))return;const y=(0,C.$Ob)(d.ports);y&&l.fire(y)}),j.Event.map(l.event,d=>({protocol:new k(d),onDidClientDisconnect:j.Event.fromNodeEventEmitter(d,"close")}))}constructor($){super(g.b($))}}e.$CU=g;function P(S,$,l){const d=y=>{y.data===$&&(S.removeListener("message",d),l())};S.on("message",d)}e.$DU=P}),define(le[69],he([0,1,6,3,2,66,12]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.StorageState=e.$op=e.StorageHint=void 0;var C;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function k($){const l=$;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$op=k;var g;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(g||(e.StorageState=g={}));class P extends A.$Tc{static{this.a=100}constructor(l,d=Object.create(null)){super(),this.r=l,this.s=d,this.b=this.B(new L.$Xd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new O.$3g(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((d,y)=>this.w(y,d)),l.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(l,d){if(this.c===g.Closed)return;let y=!1;(0,I.$Qf)(d)?y=this.f.delete(l):this.f.get(l)!==d&&(this.f.set(l,d),y=!0),y&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,d){const y=this.f.get(l);return(0,I.$Qf)(y)?d:y}getBoolean(l,d){const y=this.get(l);return(0,I.$Qf)(y)?d:y==="true"}getNumber(l,d){const y=this.get(l);return(0,I.$Qf)(y)?d:parseInt(y,10)}getObject(l,d){const y=this.get(l);return(0,I.$Qf)(y)?d:(0,j.$Ah)(y)}async set(l,d,y=!1){if(this.c===g.Closed)return;if((0,I.$Qf)(d))return this.delete(l,y);const w=(0,I.$Jf)(d)||Array.isArray(d)?(0,j.$zh)(d):String(d);if(this.f.get(l)!==w)return this.f.set(l,w),this.j.set(l,w),this.h.delete(l),this.b.fire({key:l,external:y}),this.D()}async delete(l,d=!1){if(!(this.c===g.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:d}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$pp=P;class S{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((d,y)=>this.a.set(y,d)),l.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$qp=S}),define(le[147],he([13,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[70],he([0,1,54,6,16,12,31,147]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.zip=e.$Lp=e.$Kp=void 0,e.$Kp="end of central directory record signature not found";const k=new RegExp(e.$Kp);class g extends Error{constructor(v,i){let o=i.message;switch(v){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=v,this.cause=i}}e.$Lp=g;function P(h){const v=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>v&i).reduce((i,o)=>i+o,v&61440)}function S(h){if(h instanceof g)return h;let v;return k.test(h.message)&&(v="CorruptZip"),new g(v,h)}function $(h,v,i,o,s,n){const t=A.$mc(v),r=A.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(C.localize(0,null,v)));const a=A.$jc(o,v);let E;return n.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(I.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((b,u)=>{if(!n.isCancellationRequested)try{E=(0,O.createWriteStream)(a,{mode:i}),E.once("close",()=>b()),E.once("error",u),h.once("error",u),h.pipe(E)}catch(p){u(p)}}))}function l(h,v,i,o){let s=(0,L.$Sg)(()=>Promise.resolve()),n=0;const t=o.onCancellationRequested(()=>{s.cancel(),h.close()});return new Promise((r,a)=>{const E=new L.$Zg,b=u=>{u.isCancellationRequested||(n++,h.readEntry())};h.once("error",a),h.once("close",()=>s.then(()=>{o.isCancellationRequested||h.entryCount===n?r():a(new g("Incomplete",new Error(C.localize(1,null,n,h.entryCount))))},a)),h.readEntry(),h.on("entry",u=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(u.fileName)){b(o);return}const p=u.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(p)){const F=A.$jc(v,p);s=(0,L.$Sg)(M=>I.Promises.mkdir(F,{recursive:!0}).then(()=>b(M)).then(void 0,a));return}const R=y(h,u),N=P(u);s=(0,L.$Sg)(F=>E.queue(()=>R.then(M=>$(M,p,N,v,i,F).then(()=>b(F)))).then(null,a))})}).finally(()=>t.dispose())}async function d(h,v=!1){const{open:i}=await new Promise((o,s)=>{ne(["yauzl"],o,s)});return new Promise((o,s)=>{i(h,v?{lazyEntries:!0}:void 0,(n,t)=>{n?s(S(n)):o((0,j.$Sf)(t))})})}function y(h,v){return new Promise((i,o)=>{h.openReadStream(v,(s,n)=>{s?o(S(s)):i((0,j.$Sf)(n))})})}async function w(h,v){const{ZipFile:i}=await new Promise((o,s)=>{ne(["yazl"],o,s)});return new Promise((o,s)=>{const n=new i;v.forEach(r=>{r.contents?n.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&n.addFile(r.localPath,r.path)}),n.end();const t=(0,O.createWriteStream)(h);n.outputStream.pipe(t),n.outputStream.once("error",s),t.once("error",s),t.once("finish",()=>o(h))})}e.zip=w;function c(h,v,i={},o){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=d(h,!0);return i.overwrite&&(n=n.then(t=>I.Promises.rm(v).then(()=>t))),n.then(t=>l(t,v,{sourcePathRegex:s},o))}e.$Np=c;function f(h,v){return d(h).then(i=>new Promise((o,s)=>{i.on("entry",n=>{n.fileName===v&&y(i,n).then(t=>o(t),t=>s(t))}),i.once("close",()=>s(new Error(C.localize(2,null,v))))}))}function m(h,v){return f(h,v).then(i=>new Promise((o,s)=>{const n=[];i.once("error",s),i.on("data",t=>n.push(t)),i.on("end",()=>o(Buffer.concat(n)))}))}e.$Op=m}),define(le[148],he([13,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[149],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[150],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[151],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[152],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[153],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[154],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[155],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[156],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[157],he([13,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[158],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[159],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[160],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[161],he([13,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[162],he([13,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[163],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[164],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[165],he([13,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[166],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[167],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[168],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[169],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[170],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[171],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[172],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[173],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[174],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[175],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[176],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[177],he([13,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[178],he([0,1,7,150]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.TokenType=void 0;var A;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(A||(e.TokenType=A={}));function j(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,L.localize)(3,null),C=(0,L.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const S=this.d,$=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:$};this.g.push({offset:S,lexeme:$,additionalInfo:P}),this.f.push(l)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const S=this.c.substring(this.d,this.e),$=k.b.get(S);$?this.k($):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,S=!1,$=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(C);return}const d=this.c.charCodeAt(P);if(S)S=!1;else if(d===47&&!$){P++;break}else d===91?$=!0:d===92?S=!0:d===93&&($=!1);P++}for(;P<this.c.length&&k.a.has(this.c.charCodeAt(P));)P++;this.e=P;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Zi=k}),define(le[179],he([0,1,65,85,23,16,37,19,10]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$wm=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,j.$mc)(A.$ng.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,C.$Gg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.$Gg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,O.$vm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",l)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$Gg)(k.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$Gg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$Gg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$Gg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=I.env.VSCODE_PORTABLE;return l?k.URI.file((0,j.$jc)(l,"argv.json")):(0,C.$Gg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,j.$kc)(l):(0,j.$hc)((0,j.$jc)(A.$ng.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?k.URI.file((0,j.$kc)(l)):k.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,j.$kc)(l);const d=I.env.VSCODE_EXTENSIONS;if(d)return d;const y=I.env.VSCODE_PORTABLE;return y?(0,j.$jc)(y,"extensions"):(0,C.$Gg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(d=>/^[^:/?#]+?:\/\//.test(d)?k.URI.parse(d):k.URI.file((0,j.$hc)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?k.URI.parse(l):k.URI.file((0,j.$hc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$wm.test(l))}get extensionLogLevel(){const l=[];for(const d of this.args.log||[]){const y=e.$wm.exec(d);y&&y[1]&&y[2]&&l.push([y[1],y[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,C.$Gg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=I.env.VSCODE_PORTABLE;return l?k.URI.file((0,j.$jc)(l,"policy.json")):(0,C.$Gg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,d,y){this.a=l,this.b=d,this.c=y,this.editSessionId=this.args.editSessionId}}e.$xm=g,ye([L.$wh],g.prototype,"appRoot",null),ye([L.$wh],g.prototype,"userHome",null),ye([L.$wh],g.prototype,"userDataPath",null),ye([L.$wh],g.prototype,"appSettingsHome",null),ye([L.$wh],g.prototype,"tmpDir",null),ye([L.$wh],g.prototype,"cacheHome",null),ye([L.$wh],g.prototype,"stateResource",null),ye([L.$wh],g.prototype,"userRoamingDataHome",null),ye([L.$wh],g.prototype,"userDataSyncHome",null),ye([L.$wh],g.prototype,"sync",null),ye([L.$wh],g.prototype,"machineSettingsResource",null),ye([L.$wh],g.prototype,"workspaceStorageHome",null),ye([L.$wh],g.prototype,"localHistoryHome",null),ye([L.$wh],g.prototype,"keyboardLayoutResource",null),ye([L.$wh],g.prototype,"argvResource",null),ye([L.$wh],g.prototype,"isExtensionDevelopment",null),ye([L.$wh],g.prototype,"untitledWorkspacesHome",null),ye([L.$wh],g.prototype,"builtinExtensionsPath",null),ye([L.$wh],g.prototype,"extensionsPath",null),ye([L.$wh],g.prototype,"extensionDevelopmentLocationURI",null),ye([L.$wh],g.prototype,"extensionDevelopmentKind",null),ye([L.$wh],g.prototype,"extensionTestsLocationURI",null),ye([L.$wh],g.prototype,"debugExtensionHost",null),ye([L.$wh],g.prototype,"logLevel",null),ye([L.$wh],g.prototype,"extensionLogLevel",null),ye([L.$wh],g.prototype,"serviceMachineIdResource",null),ye([L.$wh],g.prototype,"disableTelemetry",null),ye([L.$wh],g.prototype,"disableWorkspaceTrust",null),ye([L.$wh],g.prototype,"useInMemorySecretStorage",null),ye([L.$wh],g.prototype,"policyFile",null);function P($,l){return S($["inspect-extensions"],$["inspect-brk-extensions"],5870,l,$.debugId,$.extensionEnvironment)}e.$ym=P;function S($,l,d,y,w,c){const m=Number(l||$)||(y?null:d),h=m?!!l:!1;let v;if(c)try{v=JSON.parse(c)}catch{}return{port:m,break:h,debugId:w,env:v}}e.$zm=S}),function(){"use strict";function ne(e,O,L){function A(I,C){const k=j(I,C),g=[k];return e.isAbsolute(k)||g.unshift(L),e.resolve(...g)}function j(I,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,C);const P=I["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(O.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,C)}return{getUserDataPath:A}}if(typeof define=="function")define(le[180],he([269,36,37]),function(e,O,L){return ne(e,O,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=ne(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[181],he([0,1,36,179,180]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0;class j extends L.$xm{constructor(g,P){super(g,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,A.getUserDataPath)(g,P.nameShort)},P)}}e.$Am=j;function I(k,g){return(0,L.$zm)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$Bm=I;function C(k,g){return(0,L.$zm)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$Cm=C}),define(le[182],he([0,1,12,153]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;function A(I,C,k,g){try{j(I,C,k,g)}catch(P){I.error(P?.message??P)}return C}e.$Xp=A;function j(I,C,k,g){const P=(S,$,l)=>{const d=S[$];if((0,O.$Hf)(d)){const y=d,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const c=y.substr(1,w-2);let f=k[c];f===void 0&&g&&(f=g[c]);const m=typeof f=="string"?f:f?.message,h=g?.[c],v=typeof h=="string"?h:h?.message;if(!m){v||I.warn(`[${C.name}]: ${(0,L.localize)(0,null,c)}`);return}if(l&&($==="title"||$==="category")&&v&&v!==m){const i={value:m,original:v};S[$]=i}else S[$]=m}}else if((0,O.$Jf)(d))for(const y in d)d.hasOwnProperty(y)&&(y==="commands"?P(d,y,!0):P(d,y,l));else if(Array.isArray(d))for(let y=0;y<d.length;y++)P(d,y,l)};for(const S in C)C.hasOwnProperty(S)&&P(C,S)}}),define(le[183],he([0,1,70,156]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=void 0;function A(j){return(0,O.$Op)(j,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.$6p=A}),define(le[184],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=void 0;class O{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$W_b=O;class L{constructor(j){this.a=j}listen(j,I){throw new Error(`Event not found: ${I}`)}call(j,I,C){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(C[0])}throw new Error(`Call not found: ${I}`)}}e.$X_b=L}),define(le[71],he([0,1,19,89,157,55]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function k(c){return c=c.trim(),c==="*"||I.test(c)}e.$_o=k;function g(c){if(!k(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=c.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$ap=g;function P(c){if(!c)return null;const f=c.majorBase,m=c.majorMustEqual,h=c.minorBase;let v=c.minorMustEqual;const i=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(f===0||(v=!1),o=!1);let s=0;if(c.preRelease){const n=C.exec(c.preRelease);if(n){const[,t,r,a]=n;s=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:f,majorMustEqual:m,minorBase:h,minorMustEqual:v,patchBase:i,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:s}}e.$bp=P;function S(c,f,m){let h;typeof c=="string"?h=P(g(c)):h=c;let v;f instanceof Date?v=f.getTime():typeof f=="string"&&(v=new Date(f).getTime());let i;if(typeof m=="string"?i=P(g(m)):i=m,!h||!i)return!1;const o=h.majorBase,s=h.minorBase,n=h.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const E=i.notBefore;let b=i.majorMustEqual,u=i.minorMustEqual,p=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:s>r?!0:s<r||v&&v<E?!1:n>=a:(o===1&&t===0&&(!b||!u||!p)&&(t=1,r=0,a=0,b=!0,u=!1,p=!1),o<t?!1:o>t?!b:s<r?!1:s>r?!u:n<a?!1:n>a?!p:!(v&&v<E))}e.$cp=S;function $(c,f,m,h,v){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([L.default.Error,A.localize(0,null)]),i;if(typeof h.name!="string")return i.push([L.default.Error,A.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([L.default.Error,A.localize(2,null,"version")]),i;if(!h.engines)return i.push([L.default.Error,A.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([L.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!w(h.extensionDependencies))return i.push([L.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!w(h.activationEvents))return i.push([L.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([L.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([L.default.Warning,A.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([L.default.Error,A.localize(9,null,"main")]),i;{const n=(0,O.$Gg)(m,h.main);(0,O.$Ag)(n,m)||i.push([L.default.Warning,A.localize(10,null,n.path,m.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([L.default.Error,A.localize(11,null,"browser")]),i;{const n=(0,O.$Gg)(m,h.browser);(0,O.$Ag)(n,m)||i.push([L.default.Warning,A.localize(12,null,n.path,m.path)])}}if(!j.valid(h.version))return i.push([L.default.Error,A.localize(13,null)]),i;const o=[];if(!l(c,f,h,v,o))for(const n of o)i.push([L.default.Error,n]);return i}e.$dp=$;function l(c,f,m,h,v){return h||typeof m.main>"u"&&typeof m.browser>"u"?!0:y(c,f,m.engines.vscode,v)}e.$ep=l;function d(c,f,m){return c==="*"||y(f,m,c)}e.$fp=d;function y(c,f,m,h=[]){const v=P(g(m));if(!v)return h.push(A.localize(14,null,m)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(A.localize(15,null,m)),!1}else if(!v.majorMustEqual)return h.push(A.localize(16,null,m)),!1;return S(c,f,v)?!0:(h.push(A.localize(17,null,c,m)),!1)}function w(c){if(!Array.isArray(c))return!1;for(let f=0,m=c.length;f<m;f++)if(typeof c[f]!="string")return!1;return!0}}),define(le[43],he([0,1,14,32]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;async function A(j,I,C){let k=C&&C.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const P=(await I.readFile(j.serviceMachineIdResource)).value.toString();k=(0,L.$og)(P)?P:null}catch{k=null}if(!k){k=(0,L.$pg)();try{await I.writeFile(j.serviceMachineIdResource,O.$ie.fromString(k))}catch{}}return C?.store("storage.serviceMachineId",k,-1,1),k}e.$zp=A}),define(le[72],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class O{constructor(A,j=[],I=!1){this.ctor=A,this.staticArguments=j,this.supportsDelayedInstantiation=I}}e.$2h=O}),define(le[185],he([0,1,72]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.InstantiationType=void 0;const L=[];var A;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function j(C,k,g){k instanceof O.$2h||(k=new O.$2h(k,[],!!g)),L.push([C,k])}e.$Xr=j;function I(){return L}e.$Yr=I}),define(le[186],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class O{constructor(j,I){this.key=j,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$Bq=O;class L{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const I of this.a.values())I.outgoing.size===0&&j.push(I);return j}insertEdge(j,I){const C=this.lookupOrInsertNode(j),k=this.lookupOrInsertNode(I);C.outgoing.set(k.key,k),k.incoming.set(C.key,C)}removeNode(j){const I=this.b(j);this.a.delete(I);for(const C of this.a.values())C.outgoing.delete(I),C.incoming.delete(I)}lookupOrInsertNode(j){const I=this.b(j);let C=this.a.get(I);return C||(C=new O(I,j),this.a.set(I,C)),C}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[I,C]of this.a)j.push(`${I}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,I]of this.a){const C=new Set([j]),k=this.c(I,C);if(k)return k}}c(j,I){for(const[C,k]of j.outgoing){if(I.has(C))return[...I,C].join(" -> ");I.add(C);const g=this.c(k,I);if(g)return g;I.delete(C)}}}e.$Cq=L}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e._util=void 0;var O;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function C(k){return k[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=C})(O||(e._util=O={})),e.$4h=A("instantiationService");function L(I,C,k){C[O.DI_TARGET]===C?C[O.DI_DEPENDENCIES].push({id:I,index:k}):(C[O.DI_DEPENDENCIES]=[{id:I,index:k}],C[O.DI_TARGET]=C)}function A(I){if(O.serviceIds.has(I))return O.serviceIds.get(I);const C=function(k,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(C,k,P)};return C.toString=()=>I,O.serviceIds.set(I,C),C}e.$5h=A;function j(I){return I}e.$6h=j}),define(le[187],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=void 0,e.$t_b=(0,O.$5h)("checksumService")}),define(le[20],he([0,1,12,10,4]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.ConfigurationTarget=e.$Ai=e.$zi=e.$yi=void 0,e.$yi=(0,A.$5h)("configurationService");function j(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof L.URI)}e.$zi=j;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof L.URI)}e.$Ai=I;var C;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function k(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Bi=k;function g(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Ci=g;function P(c,f){const m=Object.create(null);for(const h in c)S(m,h,c[h],f);return m}e.$Di=P;function S(c,f,m,h){const v=f.split("."),i=v.pop();let o=c;for(let s=0;s<v.length;s++){const n=v[s];let t=o[n];switch(typeof t){case"undefined":t=o[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${f} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=m}catch{h(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(o)}`)}else h(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(o)}`)}e.$Ei=S;function $(c,f){const m=f.split(".");l(c,m)}e.$Fi=$;function l(c,f){const m=f.shift();if(f.length===0){delete c[m];return}if(Object.keys(c).indexOf(m)!==-1){const h=c[m];typeof h=="object"&&!Array.isArray(h)&&(l(h,f),Object.keys(h).length===0&&delete c[m])}}function d(c,f,m){function h(o,s){let n=o;for(const t of s){if(typeof n!="object"||n===null)return;n=n[t]}return n}const v=f.split("."),i=h(c,v);return typeof i>"u"?m:i}e.$Gi=d;function y(c,f,m){Object.keys(f).forEach(h=>{h!=="__proto__"&&(h in c?O.$Jf(c[h])&&O.$Jf(f[h])?y(c[h],f[h],m):m&&(c[h]=f[h]):c[h]=f[h])})}e.$Hi=y;function w(c){return c.replace(/[\[\]]/g,"")}e.$Ii=w}),define(le[94],he([0,1,5,27,178,4,149,7]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.ContextKeyExprType=e.$1i=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",O.$j),k.set("isLinux",O.$k),k.set("isWindows",O.$i),k.set("isWeb",O.$o),k.set("isMacNative",O.$j&&!O.$o),k.set("isEdge",O.$H),k.set("isFirefox",O.$F),k.set("isChrome",O.$E),k.set("isSafari",O.$G);function g(z,D){if(k.get(z)!==void 0)throw(0,C.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(z,D)}e.$1i=g;const P=Object.prototype.hasOwnProperty;var S;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const $={regexParsingWithErrorRecovery:!0},l=(0,I.localize)(0,null),d=(0,I.localize)(1,null),y=(0,I.localize)(2,null),w=(0,I.localize)(3,null),c=(0,I.localize)(4,null),f=(0,I.localize)(5,null),m=(0,I.localize)(6,null),h=(0,I.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=$){this.k=D,this.d=new A.$Zi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const B=this.D(),U=B.type===17?f:void 0;throw this.h.push({message:c,offset:B.offset,lexeme:A.$Zi.getLexeme(B),additionalInfo:U}),v.c}return T}catch(T){if(T!==v.c)throw T;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(16);){const T=this.o();D.push(T)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(15);){const T=this.s();D.push(T)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(2)){const D=this.D();switch(D.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,w),T?.negate()}case 17:return this.z(),R.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const T=this.l();return this.A(1,w),T}case 17:{const T=D.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const _=U.lexeme,H=_.lastIndexOf("/"),J=H===_.length-1?void 0:this.w(_.substring(H+1));let ie;try{ie=new RegExp(_.substring(1,H),J)}catch{throw this.B("REGEX",U)}return K.create(T,ie)}switch(U.type){case 10:case 19:{const _=[U.lexeme];this.z();let H=this.D(),J=0;for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===40?J++:U.lexeme.charCodeAt(fe)===41&&J--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:J++;break;case 1:J--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?J++:U.lexeme.charCodeAt(fe)===41&&J--}if(J<0)break;_.push(A.$Zi.getLexeme(H)),this.z(),H=this.D()}const ie=_.join(""),se=ie.lastIndexOf("/"),ce=se===ie.length-1?void 0:this.w(ie.substring(se+1));let $e;try{$e=new RegExp(ie.substring(1,se),ce)}catch{throw this.B("REGEX",U)}return i.regex(T,$e)}case 18:{const _=U.lexeme;this.z();let H=null;if(!(0,L.$Ie)(_)){const J=_.indexOf("/"),ie=_.lastIndexOf("/");if(J!==ie&&J>=0){const se=_.slice(J+1,ie),ce=_[ie+1]==="i"?"i":"";try{H=new RegExp(se,ce)}catch{throw this.B("REGEX",U)}}}if(H===null)throw this.B("REGEX",U);return K.create(T,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const U=this.u();return i.notIn(T,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return i.equals(T,U);switch(U){case"true":return i.has(T);case"false":return i.not(T);default:return i.equals(T,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return i.notEquals(T,U);switch(U){case"true":return i.not(T);case"false":return i.has(T);default:return i.notEquals(T,U)}}case 5:return this.z(),q.create(T,this.u());case 6:return this.z(),Y.create(T,this.u());case 7:return this.z(),F.create(T,this.u());case 8:return this.z(),M.create(T,this.u());case 13:return this.z(),i.in(T,this.u());default:return i.has(T)}}case 20:throw this.h.push({message:m,offset:D.offset,lexeme:"",additionalInfo:h}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case 17:case 18:return this.z(),D.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,T){if(this.C(D))return this.z();throw this.B(T,this.D())}B(D,T,B){const U=(0,I.localize)(8,null,D,A.$Zi.getLexeme(T)),_=T.offset,H=A.$Zi.getLexeme(T);return this.h.push({message:U,offset:_,lexeme:H,additionalInfo:B}),v.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$2i=v;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(D){return a.create(D)}static equals(D,T){return E.create(D,T)}static notEquals(D,T){return p.create(D,T)}static regex(D,T){return K.create(D,T)}static in(D,T){return b.create(D,T)}static notIn(D,T){return u.create(D,T)}static not(D){return R.create(D)}static and(...D){return Q.create(D,null,!0)}static or(...D){return W.create(D,null,!0)}static greater(D,T){return F.create(D,T)}static greaterEquals(D,T){return M.create(D,T)}static smaller(D,T){return q.create(D,T)}static smallerEquals(D,T){return Y.create(D,T)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$3i=i;function o(z){const D=new v({regexParsingWithErrorRecovery:!1});return z.map(T=>(D.parse(T),D.lexingErrors.length>0?D.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,I.localize)(9,null,B.additionalInfo):(0,I.localize)(10,null),offset:B.offset,length:B.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$4i=o;function s(z,D){const T=z?z.substituteConstants():void 0,B=D?D.substituteConstants():void 0;return!T&&!B?!0:!T||!B?!1:T.equals(B)}e.$5i=s;function n(z,D){return z.cmp(D)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$6i=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return t.INSTANCE}}e.$7i=r;class a{static create(D,T=null){const B=k.get(D);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(D,T)}constructor(D,T){this.key=D,this.c=T,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:te(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=k.get(this.key);return typeof D=="boolean"?D?r.INSTANCE:t.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$8i=a;class E{static create(D,T,B=null){if(typeof T=="boolean")return T?a.create(D,B):R.create(D,B);const U=k.get(D);return typeof U=="boolean"?T===(U?"true":"false")?r.INSTANCE:t.INSTANCE:new E(D,T,B)}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=k.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$9i=E;class b{static create(D,T){return new b(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=10,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:re(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.f),B=D.getValue(this.d);return Array.isArray(T)?T.includes(B):typeof B=="string"&&typeof T=="object"&&T!==null?P.call(T,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$0i=b;class u{static create(D,T){return new u(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=11,this.c=b.create(D,T)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$$i=u;class p{static create(D,T,B=null){if(typeof T=="boolean")return T?R.create(D,B):a.create(D,B);const U=k.get(D);return typeof U=="boolean"?T===(U?"true":"false")?t.INSTANCE:r.INSTANCE:new p(D,T,B)}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=k.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$_i=p;class R{static create(D,T=null){const B=k.get(D);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new R(D,T)}constructor(D,T){this.c=D,this.d=T,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:te(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=k.get(this.c);return typeof D=="boolean"?D?t.INSTANCE:r.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$aj=R;function N(z,D){if(typeof z=="string"){const T=parseFloat(z);isNaN(T)||(z=T)}return typeof z=="string"||typeof z=="number"?D(z):t.INSTANCE}class F{static create(D,T,B=null){return N(T,U=>new F(D,U,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$bj=F;class M{static create(D,T,B=null){return N(T,U=>new M(D,U,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$cj=M;class q{static create(D,T,B=null){return N(T,U=>new q(D,U,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$dj=q;class Y{static create(D,T,B=null){return N(T,U=>new Y(D,U,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$ej=Y;class K{static create(D,T){return new K(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=7,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const T=this.f?this.f.source:"",B=D.f?D.f.source:"";return T<B?-1:T>B?1:0}equals(D){if(D.type===this.type){const T=this.f?this.f.source:"",B=D.f?D.f.source:"";return this.d===D.d&&T===B}return!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$fj=K;class x{static create(D){return new x(D)}constructor(D){this.c=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new x(this.c.map(D))}negate(){return this.c}}e.$gj=x;function V(z){let D=null;for(let T=0,B=z.length;T<B;T++){const U=z[T].substituteConstants();if(z[T]!==U&&D===null){D=[];for(let _=0;_<T;_++)D[_]=z[_]}D!==null&&(D[T]=U)}return D===null?z:D}class Q{static create(D,T,B){return Q.d(D,T,B)}constructor(D,T){this.expr=D,this.c=T,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const U=n(this.expr[T],D.expr[T]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=V(this.expr);return D===this.expr?this:Q.create(D,this.c,!1)}evaluate(D){for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].evaluate(D))return!1;return!0}static d(D,T,B){const U=[];let _=!1;for(const H of D)if(H){if(H.type===1){_=!0;continue}if(H.type===0)return t.INSTANCE;if(H.type===6){U.push(...H.expr);continue}U.push(H)}if(U.length===0&&_)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(n);for(let H=1;H<U.length;H++)U[H-1].equals(U[H])&&(U.splice(H,1),H--);if(U.length===1)return U[0];for(;U.length>1;){const H=U[U.length-1];if(H.type!==9)break;U.pop();const J=U.pop(),ie=U.length===0,se=W.create(H.expr.map(ce=>Q.create([ce,J],null,B)),null,ie);se&&(U.push(se),U.sort(n))}if(U.length===1)return U[0];if(B){for(let H=0;H<U.length;H++)for(let J=H+1;J<U.length;J++)if(U[H].negate().equals(U[J]))return t.INSTANCE;if(U.length===1)return U[0]}return new Q(U,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new Q(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());this.c=W.create(D,this,!0)}return this.c}}e.$hj=Q;class W{static create(D,T,B){return W.d(D,T,B)}constructor(D,T){this.expr=D,this.c=T,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const U=n(this.expr[T],D.expr[T]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=V(this.expr);return D===this.expr?this:W.create(D,this.c,!1)}evaluate(D){for(let T=0,B=this.expr.length;T<B;T++)if(this.expr[T].evaluate(D))return!0;return!1}static d(D,T,B){let U=[],_=!1;if(D){for(let H=0,J=D.length;H<J;H++){const ie=D[H];if(ie){if(ie.type===0){_=!0;continue}if(ie.type===1)return r.INSTANCE;if(ie.type===9){U=U.concat(ie.expr);continue}U.push(ie)}}if(U.length===0&&_)return t.INSTANCE;U.sort(n)}if(U.length!==0){if(U.length===1)return U[0];for(let H=1;H<U.length;H++)U[H-1].equals(U[H])&&(U.splice(H,1),H--);if(U.length===1)return U[0];if(B){for(let H=0;H<U.length;H++)for(let J=H+1;J<U.length;J++)if(U[H].negate().equals(U[J]))return r.INSTANCE;if(U.length===1)return U[0]}return new W(U,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new W(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());for(;D.length>1;){const T=D.shift(),B=D.shift(),U=[];for(const _ of Z(T))for(const H of Z(B))U.push(Q.create([_,H],null,!1));D.unshift(W.create(U,null,!1))}this.c=W.create(D,this,!0)}return this.c}}e.$ij=W;class G extends a{static{this.d=[]}static all(){return G.d.values()}constructor(D,T,B){super(D,null),this.f=T,typeof B=="object"?G.d.push({...B,key:D}):B!==!0&&G.d.push({key:D,description:B,type:T!=null?typeof T:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return E.create(this.key,D)}notEqualsTo(D){return p.create(this.key,D)}}e.$jj=G,e.$kj=(0,j.$5h)("contextKeyService");function te(z,D){return z<D?-1:z>D?1:0}function re(z,D,T,B){return z<T?-1:z>T?1:D<B?-1:D>B?1:0}function ee(z,D){if(z.type===0||D.type===1)return!0;if(z.type===9)return D.type===9?ae(z.expr,D.expr):!1;if(D.type===9){for(const T of D.expr)if(ee(z,T))return!0;return!1}if(z.type===6){if(D.type===6)return ae(D.expr,z.expr);for(const T of z.expr)if(ee(T,D))return!0;return!1}return z.equals(D)}e.$lj=ee;function ae(z,D){let T=0,B=0;for(;T<z.length&&B<D.length;){const U=z[T].cmp(D[B]);if(U<0)return!1;U===0&&T++,B++}return T===z.length}function Z(z){return z.type===9?z.expr:[z]}}),define(le[95],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=e.ID=void 0,e.ID="diagnosticsService",e.$Hm=(0,O.$5h)(e.ID);function L(j){return!!j.hostName&&!!j.errorMessage}e.$Im=L;class A{async getPerformanceInfo(I,C){return{}}async getSystemInfo(I,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,C){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$Jm=A}),define(le[96],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0,e.$co=(0,O.$5h)("downloadService")}),define(le[15],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=void 0,e.$_h=(0,O.$5h)("environmentService"),e.$ai=(0,O.$6h)(e.$_h)}),define(le[29],he([0,1,152,4]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$xo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=void 0,e.$lo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$mo=new RegExp(e.$lo),e.$no="__web_extension",e.$oo="skipWalkthrough",e.$po="extensionsSync",e.$qo="dependecyOrPackExtensionInstall";function A(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ro=A;function j(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$so=j;function I(c,f){switch(c){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$to=I;function C(c,f){return f==="web"&&!c.includes("web")}e.$uo=C;function k(c,f,m){return C(f,m)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===m}e.$vo=k;function g(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$wo=g;var P;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var S;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var $;(function(c){c.Install="install",c.Uninstall="uninstall"})($||(e.StatisticType=$={}));var l;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$xo=(0,L.$5h)("extensionGalleryService");var d;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var y;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class w extends Error{constructor(f,m){super(f),this.code=m,this.name=m}}e.$yo=w,e.$zo=(0,L.$5h)("extensionManagementService"),e.$Ao="extensionsIdentifiers/disabled",e.$Bo="extensionsIdentifiers/enabled",e.$Co=(0,L.$5h)("IGlobalExtensionEnablementService"),e.$Do=(0,L.$5h)("IExtensionTipsService"),e.$Eo=(0,O.localize)(0,null),e.$Fo={value:e.$Eo,original:"Extensions"},e.$Go=(0,O.localize2)(1,"Preferences")}),define(le[188],he([0,1,3,2,30,10,92,29]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=void 0;function k(w,c){return w?j.URI.revive(c?c.transformIncoming(w):w):void 0}function g(w,c){return c?c.transformOutgoingURI(w):w}function P(w,c){c=c||I.$4m;const f=w.manifest;return{...(0,I.$7m)({...w,manifest:void 0},c),manifest:f}}function S(w,c){return w?.profileLocation?(0,I.$7m)(w,c??I.$4m):w}function $(w,c){return c?(0,A.$wn)(w,f=>f instanceof j.URI?c.transformOutgoingURI(f):void 0):w}class l{constructor(c,f){this.a=c,this.b=f,this.onInstallExtension=O.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,f){const m=this.b(c);switch(f){case"onInstallExtension":return O.Event.map(this.onInstallExtension,h=>({...h,profileLocation:h.profileLocation?g(h.profileLocation,m):h.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,h=>h.map(v=>({...v,local:v.local?$(v.local,m):v.local,profileLocation:v.profileLocation?g(v.profileLocation,m):v.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,h=>({...h,profileLocation:h.profileLocation?g(h.profileLocation,m):h.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,h=>({...h,profileLocation:h.profileLocation?g(h.profileLocation,m):h.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,h=>$(h,m))}throw new Error("Invalid listen")}async call(c,f,m){const h=this.b(c);switch(f){case"zip":{const v=P(m[0],h),i=await this.a.zip(v);return g(i,h)}case"unzip":return this.a.unzip(k(m[0],h));case"install":return this.a.install(k(m[0],h),S(m[1],h));case"installFromLocation":return this.a.installFromLocation(k(m[0],h),k(m[1],h));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],k(m[1],h),k(m[2],h));case"getManifest":return this.a.getManifest(k(m[0],h));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],S(m[1],h));case"installGalleryExtensions":{const v=m[0];return this.a.installGalleryExtensions(v.map(({extension:i,options:o})=>({extension:i,options:S(o,h)??{}})))}case"uninstall":return this.a.uninstall(P(m[0],h),S(m[1],h));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(m[0],h));case"getInstalled":return(await this.a.getInstalled(m[0],k(m[1],h))).map(i=>$(i,h));case"toggleAppliationScope":{const v=await this.a.toggleAppliationScope(P(m[0],h),k(m[1],h));return $(v,h)}case"copyExtensions":return this.a.copyExtensions(k(m[0],h),k(m[1],h));case"updateMetadata":{const v=await this.a.updateMetadata(P(m[0],h),m[1],k(m[2],h));return $(v,h)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Hp=l;class d extends L.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new O.$Ud),this.f=this.B(new O.$Ud),this.g=this.B(new O.$Ud),this.h=this.B(new O.$Ud),this.j=this.B(new O.$Ud),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?j.URI.revive(f.source):f.source,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(m=>({...m,local:m.local?P(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(P(f,null))))}n(c,f){c.fire(f)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const f=await this.getTargetPlatform();return c.allTargetPlatforms.some(m=>(0,C.$vo)(m,c.allTargetPlatforms,f))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(f=>j.URI.revive(f)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,f){return Promise.resolve(this.m.call("install",[c,f])).then(m=>P(m,null))}installFromLocation(c,f){return Promise.resolve(this.m.call("installFromLocation",[c,f])).then(m=>P(m,null))}async installExtensionsFromProfile(c,f,m){return(await this.m.call("installExtensionsFromProfile",[c,f,m])).map(v=>P(v,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,f){return Promise.resolve(this.m.call("installFromGallery",[c,f])).then(m=>P(m,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map(m=>({...m,local:m.local?P(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))}uninstall(c,f){return Promise.resolve(this.m.call("uninstall",[c,f]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(f=>P(f,null))}getInstalled(c=null,f){return Promise.resolve(this.m.call("getInstalled",[c,f])).then(m=>m.map(h=>P(h,null)))}updateMetadata(c,f,m){return Promise.resolve(this.m.call("updateMetadata",[c,f,m])).then(h=>P(h,null))}toggleAppliationScope(c,f){return this.m.call("toggleAppliationScope",[c,f]).then(m=>P(m,null))}copyExtensions(c,f){return this.m.call("copyExtensions",[c,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,f,m){const h=await this.m.call("download",[c,f,m]);return j.URI.revive(h)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Ip=d;class y{constructor(c){this.a=c}listen(c,f){throw new Error("Invalid listen")}call(c,f,m){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Jp=y}),define(le[97],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bZb=e.RecommendationsNotificationResult=e.$aZb=e.RecommendationSource=void 0;var L;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(L||(e.RecommendationSource=L={}));function A(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$aZb=A;var j;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$bZb=(0,O.$5h)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,48,16,27,12,10,159,4,5,23,52]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileKind=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileOperationResult=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileChangeType=e.$Hk=e.FileOperation=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileSystemProviderErrorCode=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderCapabilities=e.$rk=e.FilePermission=e.FileType=e.$qk=e.$pk=void 0,e.$pk=(0,k.$5h)("fileService");function $(ee){return ee.create===!0}e.$qk=$;var l;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var d;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function y(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.$rk=y;var w;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function c(ee){return!!(ee.capabilities&2)}e.$sk=c;function f(ee){return!!(ee.capabilities&8)}e.$tk=f;function m(ee){return!!(ee.capabilities&131072)}e.$uk=m;function h(ee){return!!(ee.capabilities&4)}e.$vk=h;function v(ee){return!!(ee.capabilities&16)}e.$wk=v;function i(ee){return c(ee)?!!(ee.capabilities&16384):!1}e.$xk=i;function o(ee){return c(ee)?!!(ee.capabilities&32768):!1}e.$yk=o;function s(ee){return!!(ee.capabilities&65536)}e.$zk=s;function n(ee){return!!(ee.capabilities&2048)}e.$Ak=n;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,Z){const z=new r(ae.toString(),Z);return b(z,Z),z}constructor(ae,Z){super(ae),this.code=Z}}e.$Bk=r;function a(ee,ae){return r.create(ee,ae)}e.$Ck=a;function E(ee){return ee||a((0,C.localize)(0,null),t.Unknown)}e.$Dk=E;function b(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.$Ek=b;function u(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Fk=u;function p(ee){if(ee instanceof Y)return ee.fileOperationResult;switch(u(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Gk=p;var R;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class N{constructor(ae,Z,z){this.resource=ae,this.operation=Z,this.target=z}isOperation(ae){return this.operation===ae}}e.$Hk=N;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(ae,Z){this.c=Z,this.b=void 0,this.d=new S.$V(()=>{const z=O.$$h.forUris(()=>this.c);return z.fill(this.rawAdded.map(D=>[D,!0])),z}),this.f=new S.$V(()=>{const z=O.$$h.forUris(()=>this.c);return z.fill(this.rawUpdated.map(D=>[D,!0])),z}),this.g=new S.$V(()=>{const z=O.$$h.forUris(()=>this.c);return z.fill(this.rawDeleted.map(D=>[D,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of ae){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==M.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...Z){return this.h(ae,{includeChildren:!1},...Z)}affects(ae,...Z){return this.h(ae,{includeChildren:!0},...Z)}h(ae,Z,...z){if(!ae)return!1;const D=z.length>0;return!!((!D||z.includes(1))&&(this.d.value.get(ae)||Z.includeChildren&&this.d.value.findSuperstr(ae))||(!D||z.includes(0))&&(this.f.value.get(ae)||Z.includeChildren&&this.f.value.findSuperstr(ae))||(!D||z.includes(2))&&(this.g.value.findSubstr(ae)||Z.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$Ik=M;function q(ee,ae,Z){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==L.sep&&(ae+=L.sep),Z?(0,A.$_e)(ee,ae):ee.indexOf(ae)===0)}e.$Jk=q;class Y extends Error{constructor(ae,Z,z){super(ae),this.fileOperationResult=Z,this.options=z}}e.$Kk=Y;class K extends Y{constructor(ae,Z,z,D){super(ae,Z,D),this.fileOperationResult=Z,this.size=z}}e.$Lk=K;class x extends Y{constructor(ae,Z,z){super(ae,2,z),this.stat=Z}}e.$Mk=x;var V;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$Nk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ok={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Pk="files.associations",e.$Qk="files.exclude",e.$Rk="files.readonlyInclude",e.$Sk="files.readonlyExclude",e.$Tk="files.readonlyFromPermissions";var Q;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Uk="";function W(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$Vk=W;async function G(ee,ae){if(!ae.hasProvider(I.URI.from({scheme:ee.scheme})))return new Promise(Z=>{const z=ae.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(z.dispose(),Z())})})}e.$Wk=G;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ae){return(0,j.$Lf)(ae)||(ae=0),ae<te.KB?(0,C.localize)(1,null,ae.toFixed(0)):ae<te.MB?(0,C.localize)(2,null,(ae/te.KB).toFixed(2)):ae<te.GB?(0,C.localize)(3,null,(ae/te.MB).toFixed(2)):ae<te.TB?(0,C.localize)(4,null,(ae/te.GB).toFixed(2)):(0,C.localize)(5,null,(ae/te.TB).toFixed(2))}}e.$Xk=te;function re(ee){const ae=typeof ee=="string"||ee?.scheme===P.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===P.Schemas.file?1024*te.MB:ae?10*te.MB:g.$o?50*te.MB:1024*te.MB}e.$Yk=re});var X=this&&this.__param||function(ne,e){return function(O,L){e(O,L,ne)}};define(le[189],he([0,1,73,47,11]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u_b=void 0;let j=class{constructor(C){this.a=C}async checksum(C){const k=(await this.a.readFileStream(C)).value;return new Promise((g,P)=>{const S=(0,O.createHash)("sha256");(0,L.$ae)(k,{onData:$=>S.update($.buffer),onError:$=>P($),onEnd:()=>g(S.digest("base64").replace(/=+$/,""))})})}};e.$u_b=j,e.$u_b=j=ye([X(0,A.$pk)],j)}),define(le[98],he([0,1,14,7,160,11]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;async function I(P,S,$,l,d,y){let w;try{await C(P,S,$,l,d,y)}catch(c){w=c}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w<"u"&&$.error(w),$.end()}}e.$aq=I;async function C(P,S,$,l,d,y){k(y);const w=await P.open(S,{create:!1});try{k(y);let c=0,f=0,m=d&&typeof d.length=="number"?d.length:void 0,h=O.$ie.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),v=d&&typeof d.position=="number"?d.position:0,i=0;do f=await P.read(w,v,h.buffer,i,h.byteLength-i),v+=f,i+=f,c+=f,typeof m=="number"&&(m-=f),i===h.byteLength&&(await $.write(l(h)),h=O.$ie.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),i=0);while(f>0&&(typeof m!="number"||m>0)&&k(y)&&g(c,d));if(i>0){let o=i;typeof m=="number"&&(o=Math.min(i,m)),$.write(l(h.slice(0,o)))}}catch(c){throw(0,j.$Dk)(c)}finally{await P.close(w)}}function k(P){if(P.isCancellationRequested)throw(0,L.$6)();return!0}function g(P,S){if(typeof S?.limits?.size=="number"&&P>S.limits.size)throw(0,j.$Ck)((0,A.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[50],he([0,1,91,2,16,5,10,11]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=void 0;function k(c){return c.recursive===!0}e.$cq=k;class g extends L.$Tc{static{this.a=5}constructor(f,m,h,v){super(),this.h=f,this.j=m,this.m=h,this.n=v,this.c=this.B(new L.$Uc),this.f=void 0,this.g=0}s(){const f=new L.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(m=>this.h(m))),f.add(this.b.onDidLogMessage(m=>this.j(m))),f.add(this.b.onDidError(m=>this.t(m)))}t(f){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$dq=g;class P extends g{constructor(f,m,h){super(f,m,h,{type:"node.js",restartOnError:!1})}}e.$eq=P;class S extends g{constructor(f,m,h){super(f,m,h,{type:"universal",restartOnError:!0})}}e.$fq=S;function $(c){return c.map(f=>({type:f.type,resource:I.URI.revive(f.resource),cId:f.cId}))}e.$gq=$;function l(c){const f=new w;for(const m of c)f.processEvent(m);return f.coalesce()}e.$hq=l;function d(c,f){return typeof f=="string"&&!f.startsWith(O.$Hj)&&!(0,A.$ic)(f)?{base:c,pattern:f}:f}e.$iq=d;function y(c,f){const m=[];for(const h of f)m.push((0,O.$Lj)(d(c,h)));return m}e.$jq=y;class w{constructor(){this.a=new Set,this.b=new Map}c(f){return j.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const m=this.b.get(this.c(f));let h=!1;if(m){const v=m.type,i=f.type;m.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?h=!0:v===1&&i===2?(this.b.delete(this.c(f)),this.a.delete(m)):v===2&&i===1?m.type=0:v===1&&i===0||(m.type=i)}else h=!0;h&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],m=[];return Array.from(this.a).filter(h=>h.type!==2?(f.push(h),!1):!0).sort((h,v)=>h.resource.fsPath.length-v.resource.fsPath.length).filter(h=>m.some(v=>(0,C.$Jk)(h.resource.fsPath,v,!j.$k))?!1:(m.push(h.resource.fsPath),!0)).concat(f)}}}),define(le[190],he([0,1,14,38,7,3,2,47,32,11,50]),function(ne,e,O,L,A,j,I,C,k,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=void 0,e.$aO="localFilesystem";class S extends I.$Tc{constructor(l,d){super(),this.a=l,this.b=d,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Ud),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Ud),this.onDidWatchError=this.g.event,this.h=(0,k.$pg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,d){const{buffer:y}=await this.a.call("readFile",[l,d]);return y}readFileStream(l,d,y){const w=(0,C.$9d)(f=>O.$ie.concat(f.map(m=>O.$ie.wrap(m))).buffer),c=new I.$Sc;return c.add(this.a.listen("readFileStream",[l,d])(f=>{if(f instanceof O.$ie)w.write(f.buffer);else{if(f==="end")w.end();else{let m;if(f instanceof Error)m=f;else{const h=f;m=(0,g.$Ck)(h.message??(0,L.$Pi)(h),h.code??g.FileSystemProviderErrorCode.Unknown)}w.error(m),w.end()}c.dispose()}})),c.add(y.onCancellationRequested(()=>{w.error((0,A.$6)()),w.end(),c.dispose()})),w}writeFile(l,d,y){return this.a.call("writeFile",[l,O.$ie.wrap(d),y])}open(l,d){return this.a.call("open",[l,d])}close(l){return this.a.call("close",[l])}async read(l,d,y,w,c){const[f,m]=await this.a.call("read",[l,d,c]);return y.set(f.buffer.slice(0,m),w),m}write(l,d,y,w,c){return this.a.call("write",[l,d,O.$ie.wrap(y),w,c])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,d){return this.a.call("delete",[l,d])}rename(l,d,y){return this.a.call("rename",[l,d,y])}copy(l,d,y){return this.a.call("copy",[l,d,y])}cloneFile(l,d){return this.a.call("cloneFile",[l,d])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const d=l;this.f.fire((0,P.$gq)(d))}else{const d=l;this.g.fire(d)}}))}watch(l,d){const y=(0,k.$pg)();return this.a.call("watch",[this.h,y,l,d]),(0,I.$Rc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$bO=S}),define(le[191],he([0,1,54,6,26,49,2,88,16,5,19,10,143,31,50]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=void 0;class y extends I.$Tc{static{this.a=100}static{this.b=75}constructor(f,m,h,v){super(),this.m=f,this.n=m,this.r=h,this.s=v,this.c=this.B(new L.$hh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new L.$gh(i=>this.z(i),y.b)),this.g=(0,d.$jq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$jq)(this.m.path,this.m.includes):void 0,this.j=new A.$5d,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const m=await l.Promises.stat(f);this.B(await this.w(f,m.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let m=f.path;try{m=await l.Promises.realpath(f.path),f.path===m&&(m=await(0,$.$tq)(f.path)??f.path),f.path!==m&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${m})`)}catch{}return m}async w(f,m){if(g.$j&&(0,j.$7f)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Tc.None;const h=new A.$5d(this.j.token),v=new I.$Sc;try{const i=S.URI.file(this.m.path),o=(0,k.$nc)(f),s=(0,O.watch)(f);v.add((0,I.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${f}'`);const n=new Set;if(m)try{for(const r of await l.Promises.readdir(f))n.add(r)}catch(r){this.D(r)}const t=new Map;v.add((0,I.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),s.on("error",(r,a)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),s.on("change",(r,a)=>{if(h.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let E="";if(a&&(E=a.toString(),g.$j&&(E=(0,C.$Fl)(E))),!(!E||r!=="change"&&r!=="rename"))if(m)if(r==="rename"){t.get(E)?.dispose();const b=setTimeout(async()=>{if(t.delete(E),E===o&&!await l.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.C((0,k.$jc)(f,E));if(h.token.isCancellationRequested)return;let p;u?n.has(E)?p=0:(p=1,n.add(E)):(n.delete(E),p=2),this.y({resource:(0,P.$Gg)(i,E),type:p,cId:this.m.correlationId})},y.a);t.set(E,(0,I.$Rc)(()=>clearTimeout(b)))}else{let b;n.has(E)?b=0:(b=1,n.add(E)),this.y({resource:(0,P.$Gg)(i,E),type:b,cId:this.m.correlationId})}else if(r==="rename"||E!==o){const b=setTimeout(async()=>{const u=await l.Promises.exists(f);h.token.isCancellationRequested||(u?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),v.add(await this.w(f,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},y.a);v.clear(),v.add((0,I.$Rc)(()=>clearTimeout(b)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await l.Promises.exists(f)&&!h.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${i.toString()})`)}return(0,I.$Rc)(()=>{h.dispose(!0),v.dispose()})}y(f,m=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!m&&this.g.some(h=>h(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(h=>h(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const m=(0,d.$hq)(f);if(m.length>0){if(this.s)for(const v of m)this.G(` >> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`);this.c.work(m)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${m[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(g.$k)return l.Promises.exists(f);try{const m=(0,k.$nc)(f);return(await l.Promises.readdir((0,k.$mc)(f))).some(v=>v===m)}catch(m){return this.G(m),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$wq=y;async function w(c,f,m,h,v=512){const i=await l.Promises.open(c,"r"),o=Buffer.allocUnsafe(v),s=new A.$5d(h);let n,t=!1;const r={path:c,excludes:[],recursive:!1},a=new y(r,E=>{(async()=>{for(const{type:b}of E)if(b===0){if(t)return;t=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:u}=await l.Promises.read(i,o,0,v,null);if(!u||s.token.isCancellationRequested)break;f(o.slice(0,u))}}catch(u){n=new Error(u),s.dispose(!0)}finally{t=!1}}})()});return await a.ready,m(),new Promise((E,b)=>{s.token.onCancellationRequested(async()=>{a.dispose();try{await l.Promises.close(i)}catch(u){n=new Error(u)}n?b(n):E()})})}e.$xq=w}),define(le[192],he([0,1,3,91,2,5,191]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;class C extends A.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$Ud),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$Ud),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(g){const P=this.j(g),S=P.filter(l=>{const d=this.c.get(l.path);return d?!(0,L.$Pj)(d.request.excludes,l.excludes)||!(0,L.$Pj)(d.request.includes,l.includes):!0}),$=Array.from(this.c.values()).filter(({request:l})=>!P.find(d=>d.path===l.path&&(0,L.$Pj)(d.excludes,l.excludes)&&(0,L.$Pj)(d.includes,l.includes))).map(({request:l})=>l.path);S.length&&this.m(`Request to start watching: ${S.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const l of $)this.h(l);for(const l of S)this.g(l)}g(g){const P=new I.$wq(g,$=>this.a.fire($),$=>this.b.fire($),this.f),S={request:g,instance:P};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const P=this.c.get(g);P&&(this.c.delete(g),P.instance.dispose())}j(g){const P=new Map;for(const S of g){const $=j.$k?S.path:S.path.toLowerCase();let l=P.get(S.correlationId);l||(l=new Map,P.set(S.correlationId,l)),l.set($,S)}return Array.from(P.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,P]of this.c)P.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,P){return P?`[File Watcher (node.js)] ${g} (path: ${P.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$yq=C}),define(le[193],he([0,1,50,192]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class A extends O.$eq{constructor(I,C,k){super(I,C,k),this.s()}r(I){return I.add(new L.$yq)}}e.$zq=A}),define(le[194],he([0,1,23,40,93,50]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=void 0;class I extends j.$fq{constructor(k,g,P){super(k,g,P),this.s()}r(k){const g=k.add(new A.$qq(O.$ng.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:P,signal:S})=>this.t(`terminated by itself with code ${P}, signal: ${S}`))),L.ProxyChannel.toService((0,L.$Lh)(g.getChannel("watcher")))}}e.$rq=I}),define(le[74],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class O{constructor(...A){this.a=new Map;for(const[j,I]of A)this.set(j,I)}set(A,j){const I=this.a.get(A);return this.a.set(A,j),I}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$3h=O}),define(le[195],he([0,1,6,7,2,72,186,4,74,87]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;const P=!1;class S extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class ${constructor(w=new k.$3h,c=!1,f,m=P){this.f=w,this.g=c,this.h=f,this.i=m,this.o=new Set,this.f.set(C.$4h,this),this._globalGraph=m?f?._globalGraph??new I.$Cq(h=>h):void 0}createChild(w){return new $(w,this.g,this,this.i)}invokeFunction(w,...c){const f=d.traceInvocation(this.i,w);let m=!1;try{return w({get:v=>{if(m)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(v,f);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...c)}finally{m=!0,f.stop()}}createInstance(w,...c){let f,m;return w instanceof j.$2h?(f=d.traceCreation(this.i,w.ctor),m=this.j(w.ctor,w.staticArguments.concat(c),f)):(f=d.traceCreation(this.i,w),m=this.j(w,c,f)),f.stop(),m}j(w,c=[],f){const m=C._util.getServiceDependencies(w).sort((i,o)=>i.index-o.index),h=[];for(const i of m){const o=this.m(i.id,f);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(o)}const v=m.length>0?m[0].index:c.length;if(c.length!==v){console.trace(`[createInstance] First service dependency of ${w.name} at position ${v+1} conflicts with ${c.length} static arguments`);const i=v-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,v)}return Reflect.construct(w,c.concat(h))}k(w,c){if(this.f.get(w)instanceof j.$2h)this.f.set(w,c);else if(this.h)this.h.k(w,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const c=this.f.get(w);return!c&&this.h?this.h.l(w):c}m(w,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const f=this.l(w);return f instanceof j.$2h?this.q(w,f,c.branch(w,!0)):(c.branch(w,!1),f)}q(w,c,f){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,c,f)}finally{this.o.delete(w)}}r(w,c,f){const m=new I.$Cq(i=>i.id.toString());let h=0;const v=[{id:w,desc:c,_trace:f}];for(;v.length;){const i=v.pop();if(m.lookupOrInsertNode(i),h++>1e3)throw new S(m);for(const o of C._util.getServiceDependencies(i.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof j.$2h){const n={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};m.insertEdge(i,n),v.push(n)}}}for(;;){const i=m.roots();if(i.length===0){if(!m.isEmpty())throw new S(m);break}for(const{data:o}of i){if(this.l(o.id)instanceof j.$2h){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}m.removeNode(o)}}return this.l(w)}s(w,c,f=[],m,h){if(this.f.get(w)instanceof j.$2h)return this.t(w,c,f,m,h);if(this.h)return this.h.s(w,c,f,m,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(w,c,f=[],m,h){if(m){const v=new $(void 0,this.g,this,this.i);v.c=String(w);const i=new Map,o=new O.$lh(()=>{const s=v.j(c,f,h);for(const[n,t]of i){const r=s[n];if(typeof r=="function")for(const a of t)a.disposable=r.apply(s,a.listener)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=i.get(n);return a||(a=new g.$4c,i.set(n,a)),(b,u,p)=>{if(o.isInitialized)return o.value[n](b,u,p);{const R={listener:[b,u,p],disposable:void 0},N=a.push(R);return(0,A.$Rc)(()=>{N(),R.disposable?.dispose()})}}}if(n in s)return s[n];const t=o.value;let r=t[n];return typeof r!="function"||(r=r.bind(t),s[n]=r),r},set(s,n,t){return o.value[n]=t,!0},getPrototypeOf(s){return c.prototype}})}else return this.j(c,f,h)}u(w,c){if(c&&console.warn(w),this.g)throw new Error(w)}}e.$Dq=$;var l;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(l||(l={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,c){return w?new d(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(w,c){return w?new d(1,c.name):d.c}static{this.f=0}constructor(w,c){this.type=w,this.name=c,this.g=Date.now(),this.h=[]}branch(w,c){const f=new d(3,w.toString());return this.h.push([w,c,f]),f}stop(){const w=Date.now()-this.g;d.f+=w;let c=!1;function f(h,v){const i=[],o=new Array(h+1).join("	");for(const[s,n,t]of v.h)if(n&&t){c=!0,i.push(`${o}CREATES -> ${s}`);const r=f(h+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(w>2||c)&&d.all.add(m.join(`
`))}}e.$Eq=d}),define(le[56],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=e.$4$b=void 0,e.$4$b=(0,O.$5h)("mainProcessService");class L{constructor(j,I){this.a=j,this.b=I}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,I){this.a.registerChannel(j,I)}}e.$5$b=L}),define(le[75],he([0,1,26,2,5,162,29,4]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=void 0;function k(P){return P.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$fr=k,e.$gr=(0,C.$5h)("languagePackService");let g=class extends L.$Tc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new O.$5d;setTimeout(()=>S.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const d=$.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(w=>w.startsWith("lp-"))).map(y=>{const w=y.properties.localizedLanguages?.[0],c=k(y);return{...this.f(c,w,y),extensionId:y.identifier.id,galleryExtension:y}});return d.push(this.f("en","English")),d}f(S,$,l){const d=$??S;let y;if(d!==S&&(y=`(${S})`),S.toLowerCase()===A.$w.toLowerCase()&&(y??="",y+=(0,j.localize)(0,null)),l?.installCount){y??="";const w=l.installCount;let c;w>1e6?c=`${Math.floor(w/1e5)/10}M`:w>1e3?c=`${Math.floor(w/1e3)}K`:c=String(w),y+=` $(cloud-download) ${c}`}return{id:S,label:d,description:y}}};e.$hr=g,e.$hr=g=ye([X(0,I.$xo)],g)}),define(le[196],he([0,1,2,75]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=void 0;let A=class extends O.$Tc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$q_b=A,e.$q_b=A=ye([X(0,L.$gr)],A)}),define(le[8],he([0,1,38,3,53,2,35,5,19,12,10,94,4]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.log=e.$pj=e.LogLevel=e.$oj=e.$nj=e.$mj=void 0,e.$mj=(0,$.$5h)("logService"),e.$nj=(0,$.$5h)("loggerService");function l(){return new Date().toISOString()}function d(b){return(0,g.$Lf)(b)}e.$oj=d;var y;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$pj=y.Info;function w(b,u,p){switch(u){case y.Trace:b.trace(p);break;case y.Debug:b.debug(p);break;case y.Info:b.info(p);break;case y.Warning:b.warn(p);break;case y.Error:b.error(p);break;case y.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=w;function c(b,u=!1){let p="";for(let R=0;R<b.length;R++){let N=b[R];if(N instanceof Error&&(N=(0,O.$Pi)(N,u)),typeof N=="object")try{N=JSON.stringify(N)}catch{}p+=(R>0?" ":"")+N}return p}class f extends j.$Tc{constructor(){super(...arguments),this.b=e.$pj,this.c=this.B(new L.$Ud),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==y.Off&&this.b<=u}}e.$rj=f;class m extends f{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...p){this.f(y.Trace)&&this.g(y.Trace,c([u,...p],!0))}debug(u,...p){this.f(y.Debug)&&this.g(y.Debug,c([u,...p]))}info(u,...p){this.f(y.Info)&&this.g(y.Info,c([u,...p]))}warn(u,...p){this.f(y.Warning)&&this.g(y.Warning,c([u,...p]))}error(u,...p){if(this.f(y.Error))if(u instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=u.stack,this.g(y.Error,c(R))}else this.g(y.Error,c([u,...p]))}flush(){}}e.$sj=m;class h extends f{constructor(u=e.$pj){super(),this.setLevel(u),this.g=!C.$i}trace(u,...p){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}debug(u,...p){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}info(u,...p){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}warn(u,...p){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,u,...p):console.warn(`[main ${l()}]`,u,...p))}error(u,...p){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,u,...p):console.error(`[main ${l()}]`,u,...p))}flush(){}}e.$tj=h;class v extends f{constructor(u=e.$pj,p=!0){super(),this.g=p,this.setLevel(u)}trace(u,...p){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...p):console.log(u,...p))}debug(u,...p){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...p):console.log(u,...p))}info(u,...p){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...p):console.log(u,...p))}warn(u,...p){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...p):console.log(u,...p))}error(u,...p){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...p):console.error(u,...p))}flush(){}}e.$uj=v;class i extends f{constructor(u,p=e.$pj){super(),this.g=u,this.setLevel(p)}trace(u,...p){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(u),...p])}debug(u,...p){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(u),...p])}info(u,...p){this.f(y.Info)&&this.g.log(y.Info,[this.h(u),...p])}warn(u,...p){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(u),...p])}error(u,...p){this.f(y.Error)&&this.g.log(y.Error,[this.h(u),...p])}h(u){return typeof u=="string"?u:(0,O.$Pi)(u,this.f(y.Trace))}flush(){}}e.$vj=i;class o extends f{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const p of this.g)p.setLevel(u);super.setLevel(u)}trace(u,...p){for(const R of this.g)R.trace(u,...p)}debug(u,...p){for(const R of this.g)R.debug(u,...p)}info(u,...p){for(const R of this.g)R.info(u,...p)}warn(u,...p){for(const R of this.g)R.warn(u,...p)}error(u,...p){for(const R of this.g)R.error(u,...p)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose();super.dispose()}}e.$wj=o;class s extends j.$Tc{constructor(u,p,R){if(super(),this.h=u,this.j=p,this.b=new I.$Ac,this.c=this.B(new L.$Ud),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Ud),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Ud),this.onDidChangeVisibility=this.g.event,R)for(const N of R)this.b.set(N.resource,{logger:void 0,info:N})}m(u){return(0,g.$Hf)(u)?[...this.b.values()].find(p=>p.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,p){const R=this.n(u),N=(0,g.$Hf)(u)?u:p?.id??(0,A.$Si)(R.toString()).toString(16);let F=this.b.get(R)?.logger;const M=p?.logLevel==="always"?y.Trace:p?.logLevel;F||(F=this.s(R,M??this.getLogLevel(R)??this.h,{...p,id:N}));const q={logger:F,info:{resource:R,id:N,logLevel:M,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(q.info),this.b.set(R,q),F}n(u){return(0,g.$Hf)(u)?(0,k.$Gg)(this.j,`${u}.log`):u}setLogLevel(u,p){if(P.URI.isUri(u)){const R=u,N=p,F=this.b.get(R);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.h?void 0:N,F.logger?.setLevel(N),this.b.set(F.info.resource,F),this.f.fire([R,N]))}else{this.h=u;for(const[R,N]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,p){const R=this.m(u);R&&p!==!R.info.hidden&&(R.info.hidden=!p,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,p]))}getLogLevel(u){let p;return u&&(p=this.b.get(u)?.info.logLevel),p??this.h}registerLogger(u){const p=this.b.get(u.resource);p?p.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const p=this.b.get(u);p&&(p.logger&&p.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$xj=s;class n{constructor(){this.onDidChangeLogLevel=new L.$Ud().event}setLevel(u){}getLevel(){return y.Info}trace(u,...p){}debug(u,...p){}info(u,...p){}warn(u,...p){}error(u,...p){}critical(u,...p){}dispose(){}flush(){}}e.$yj=n;class t extends n{}e.$zj=t;function r(b){if(b.verbose)return y.Trace;if(typeof b.logLevel=="string"){const u=E(b.logLevel.toLowerCase());if(u!==void 0)return u}return e.$pj}e.$Aj=r;function a(b){switch(b){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$Bj=a;function E(b){switch(b){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$Cj=E,e.$Dj=new S.$jj("logLevel",a(y.Info))}),define(le[197],he([0,1,6,7,2,23,16,19,31,15,8]),function(ne,e,O,L,A,j,I,C,k,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r_b=void 0;let S=class extends A.$Tc{constructor(l,d){super(),this.a=l,this.b=d,this.B(new O.$eh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,C.$Dg)(this.a.logsHome),d=(0,C.$Fg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,c=(await k.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==l),f=c.slice(0,Math.max(0,c.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(m=>k.Promises.rm((0,I.$jc)(d,m)))))}catch(l){(0,L.$1)(l)}}};e.$r_b=S,e.$r_b=S=ye([X(0,g.$_h),X(1,P.$mj)],S)}),define(le[99],he([0,1,7,4,8]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0,e.$Ep=(0,L.$5h)("IExtensionSignatureVerificationService");let j=class{constructor(C){this.b=C}c(){return this.a||(this.a=new Promise((C,k)=>ne(["node-vsce-sign"],async g=>C(g),k))),this.a}async verify(C,k,g){let P;try{P=await this.c()}catch(S){return this.b.error("Could not load vsce-sign module",(0,O.$0)(S)),!1}return P.verify(C,k,g)}};e.$Fp=j,e.$Fp=j=ye([X(0,A.$mj)],j)}),define(le[198],he([0,1,17,6,7,3,2,16,50,8]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class P extends I.$Tc{constructor($,l){super(),this.a=$,this.b=l,this.c=this.B(new j.$Ud),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Ud),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$3g(0)),this.w=[],this.y=this.B(new L.$3g(0))}watch($,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n($,l):this.z($,l)}n($,l){const d={path:this.H($),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},y=(0,O.$Ub)(this.j,d);return this.r(),(0,I.$Rc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,A.$1)($))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,k.$gq)(l)),l=>this.G(l),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const l of this.j)(0,k.$cq)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const l of this.j)(0,k.$cq)(l)&&$.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,l){const d={path:this.H($),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},y=(0,O.$Ub)(this.w,d);return this.C(),(0,I.$Rc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,A.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,k.$gq)($)),$=>this.G($),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,C.$hc)($.fsPath)}}e.$kq=P}),define(le[199],he([0,1,17,6,14,26,3,53,61,2,48,23,100,19,47,158,11,98,8,7]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;let v=class extends g.$Tc{static{h=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new I.$Ud),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$Ud),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$Ud),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$Ud),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$Ud),this.Y=this.B(new I.$Ud),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$Ud),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new L.$bh)}registerProvider(o,s){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${o}`);const n=new g.$Sc;return this.h.set(o,s),this.c.fire({added:!0,scheme:o,provider:s}),n.add(s.onDidChangeFile(t=>{const r=new w.$Ik(t,!this.S(s));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof s.onDidWatchError=="function"&&n.add(s.onDidWatchError(t=>this.Z.fire(new Error(t)))),n.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:s}),this.h.delete(o),(0,g.$Oc)(n)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const s=[];this.f.fire({scheme:o,join(n){s.push(n)}}),!this.h.has(o)&&await L.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,s){const n=this.h.get(o.scheme);return!!(n&&n.capabilities&s)}listCapabilities(){return k.Iterable.map(this.h,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async j(o){if(!(0,l.$Kg)(o))throw new w.$Kk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const s=this.h.get(o.scheme);if(!s){const n=new m.$bb;throw n.message=(0,y.localize)(1,null,o.toString()),n}return s}async m(o){const s=await this.j(o);if((0,w.$vk)(s)||(0,w.$sk)(s)||(0,w.$wk)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const s=await this.j(o);if((0,w.$vk)(s)||(0,w.$sk)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.s(o,s)}catch(n){throw(0,w.$Fk)(n)===w.FileSystemProviderErrorCode.FileNotFound?new w.$Kk((0,y.localize)(2,null,this.sb(o)),1):(0,w.$Dk)(n)}}async s(o,s){const n=await this.j(o),t=this.S(n),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,E=s?.resolveMetadata,b=await n.stat(o);let u;return this.t(n,o,b,void 0,!!E,(p,R)=>(u||(u=P.$$h.forUris(()=>!t),u.set(o,!0),r&&u.fill(!0,r)),u.get(p.resource)||u.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?R===1:!1))}async t(o,s,n,t,r,a){const{providerExtUri:E}=this.R(o),b={resource:s,name:E.basename(s),isFile:(n.type&w.FileType.File)!==0,isDirectory:(n.type&w.FileType.Directory)!==0,isSymbolicLink:(n.type&w.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((n.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Vk)({mtime:n.mtime,size:n.size}),children:void 0};if(b.isDirectory&&a(b,t)){try{const u=await o.readdir(s),p=await L.Promises.settled(u.map(async([R,N])=>{try{const F=E.joinPath(s,R),M=r?await o.stat(F):{type:N};return await this.t(o,F,M,u.length,r,a)}catch(F){return this.b.trace(F),null}}));b.children=(0,O.$Hb)(p)}catch(u){this.b.trace(u),b.children=[]}return b}return b}async resolveAll(o){return L.Promises.settled(o.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.j(o),n=await s.stat(o);return this.t(s,o,n,void 0,!0,()=>!1)}async exists(o){const s=await this.j(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.u(o,s)}catch(n){return n}return!0}async u(o,s){if(!s?.overwrite&&await this.exists(o))throw new w.$Kk((0,y.localize)(3,null,this.sb(o)),3,s)}async createFile(o,s=A.$ie.fromString(""),n){await this.u(o,n);const t=await this.writeFile(o,s);return this.r.fire(new w.$Hk(o,0,t)),t}async writeFile(o,s,n){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=n;if((0,w.$yk)(t)&&!a?.atomic){const E=t.enforceAtomicWriteFile?.(o);E&&(a={...n,atomic:E})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let b;if((0,w.$sk)(t)&&!(s instanceof A.$ie))if((0,d.$7d)(s)){const u=await(0,d.$be)(s,3);u.ended?b=A.$ie.concat(u.buffer):b=u}else b=(0,d.$$d)(s,u=>A.$ie.concat(u),3);else b=s;!(0,w.$vk)(t)||(0,w.$sk)(t)&&b instanceof A.$ie||(0,w.$sk)(t)&&(0,w.$yk)(t)&&a?.atomic?await this.hb(t,o,a,b):await this.db(t,o,a,b instanceof A.$ie?(0,A.$te)(b):b),this.r.fire(new w.$Hk(o,4))}catch(E){throw new w.$Kk((0,y.localize)(4,null,this.sb(o),(0,w.$Dk)(E).toString()),(0,w.$Gk)(E),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,s,n){const t=!!n?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(s)));if(!!n?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(s)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(s)));if(t)throw new Error((0,y.localize)(8,null,this.sb(s)))}let a;try{a=await o.stat(s)}catch{return}if(a.type&w.FileType.Directory)throw new w.$Kk((0,y.localize)(9,null,this.sb(s)),0,n);if(this.rb(s,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==w.$Uk&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,w.$Vk)({mtime:n.mtime,size:a.size}))throw new w.$Kk((0,y.localize)(10,null),3,n);return a}async readFile(o,s,n){const t=await this.m(o);return s?.atomic?this.z(t,o,s,n):this.C(t,o,s,n)}async z(o,s,n,t){return new Promise((r,a)=>{this.cb.queueFor(s,this.R(o).providerExtUri).queue(async()=>{try{const E=await this.C(o,s,n,t);r(E)}catch(E){a(E)}})})}async C(o,s,n,t){const r=await this.D(o,s,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,A.$ue)(r.value)}}async readFileStream(o,s,n){const t=await this.m(o);return this.D(t,o,s,n)}async D(o,s,n,t){const r=new j.$5d(t);let a=n;(0,w.$xk)(o)&&o.enforceAtomicReadFile?.(s)&&(a={...n,atomic:!0});const E=this.J(s,a).then(u=>u,u=>{throw r.dispose(!0),u});let b;try{return typeof a?.etag=="string"&&a.etag!==w.$Uk&&await E,a?.atomic&&(0,w.$xk)(o)||!((0,w.$vk)(o)||(0,w.$wk)(o))||(0,w.$sk)(o)&&a?.preferUnbuffered?b=this.I(o,s,a):(0,w.$wk)(o)?b=this.G(o,s,r.token,a):b=this.H(o,s,r.token,a),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await E,value:b}}catch(u){throw b&&await(0,d.$_d)(b),this.F(u,s,a)}}F(o,s,n){const t=(0,y.localize)(11,null,this.sb(s),(0,w.$Dk)(o).toString());return o instanceof w.$Mk?new w.$Mk(t,o.stat,n):o instanceof w.$Lk?new w.$Lk(t,o.fileOperationResult,o.size,o.options):new w.$Kk(t,(0,w.$Gk)(o),n)}G(o,s,n,t=Object.create(null)){const r=o.readFileStream(s,t,n);return(0,d.$fe)(r,{data:a=>a instanceof A.$ie?a:A.$ie.wrap(a),error:a=>this.F(a,s,t)},a=>A.$ie.concat(a))}H(o,s,n,t=Object.create(null)){const r=(0,A.$ye)();return(0,c.$aq)(o,s,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,s,t)},n),r}I(o,s,n){const t=(0,d.$9d)(r=>A.$ie.concat(r));return(async()=>{try{let r;n?.atomic&&(0,w.$xk)(o)?r=await o.readFile(s,{atomic:!0}):r=await o.readFile(s),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.L(s,r.byteLength,n),t.end(A.$ie.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,s){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new w.$Kk((0,y.localize)(12,null,this.sb(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==w.$Uk&&s.etag===n.etag)throw new w.$Mk((0,y.localize)(13,null),n,s);return this.L(o,n.size,s),n}L(o,s,n){if(typeof n?.limits?.size=="number"&&s>n.limits.size)throw new w.$Lk((0,y.localize)(14,null,this.sb(o)),7,s,n)}async canMove(o,s,n){return this.M(o,s,"move",n)}async canCopy(o,s,n){return this.M(o,s,"copy",n)}async M(o,s,n,t){if(o.toString()!==s.toString())try{const r=n==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(s),s);await this.Q(r,o,a,s,n,t)}catch(r){return r}return!0}async move(o,s,n){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(s),s),a=await this.N(t,o,r,s,"move",!!n),E=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$Hk(o,a==="move"?2:3,E)),E}async copy(o,s,n){const t=await this.m(o),r=this.qb(await this.n(s),s),a=await this.N(t,o,r,s,"copy",!!n),E=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$Hk(o,a==="copy"?3:2,E)),E}async N(o,s,n,t,r,a){if(s.toString()===t.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:b}=await this.Q(o,s,n,t,r,a);if(E&&!b&&a&&await this.del(t,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(t)),r==="copy"){if(o===n&&(0,w.$tk)(o))await o.copy(s,t,{overwrite:a});else{const u=await this.resolve(s);u.isDirectory?await this.P(o,u,n,t):await this.O(o,s,n,t)}return r}else return o===n?(await o.rename(s,t,{overwrite:a}),r):(await this.N(o,s,n,t,"copy",a),await this.del(s,{recursive:!0}),"copy")}async O(o,s,n,t){if((0,w.$vk)(o)&&(0,w.$vk)(n))return this.jb(o,s,n,t);if((0,w.$vk)(o)&&(0,w.$sk)(n))return this.pb(o,s,n,t);if((0,w.$sk)(o)&&(0,w.$vk)(n))return this.nb(o,s,n,t);if((0,w.$sk)(o)&&(0,w.$sk)(n))return this.lb(o,s,n,t)}async P(o,s,n,t){await n.mkdir(t),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async r=>{const a=this.R(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),n,a):this.O(o,r.resource,n,a)}))}async Q(o,s,n,t,r,a){let E=!1;if(o===n){const{providerExtUri:u,isPathCaseSensitive:p}=this.R(o);if(p||(E=u.isEqual(s,t)),E&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(s),this.sb(t)));if(!E&&u.isEqualOrParent(t,s))throw new Error((0,y.localize)(16,null,this.sb(s),this.sb(t)))}const b=await this.exists(t);if(b&&!E){if(!a)throw new w.$Kk((0,y.localize)(17,null,this.sb(s),this.sb(t)),4);if(o===n){const{providerExtUri:u}=this.R(o);if(u.isEqualOrParent(s,t))throw new Error((0,y.localize)(18,null,this.sb(s),this.sb(t)))}}return{exists:b,isSameResourceWithDifferentPathCase:E}}R(o){const s=this.S(o);return{providerExtUri:s?l.$wg:l.$yg,isPathCaseSensitive:s}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.qb(await this.j(o),o);await this.U(s,o);const n=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$Hk(o,0,n)),n}async U(o,s){const n=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(s,t.dirname(s));)try{if(!((await o.stat(s)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(s)));break}catch(r){if((0,w.$Fk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(s)),s=t.dirname(s)}for(let r=n.length-1;r>=0;r--){s=t.joinPath(s,n[r]);try{await o.mkdir(s)}catch(a){if((0,w.$Fk)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,s){try{await this.W(o,s)}catch(n){return n}return!0}async W(o,s){const n=this.qb(await this.j(o),o),t=!!s?.useTrash;if(t&&!(n.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=s?.atomic;if(r&&!(n.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let a;try{a=await n.stat(o)}catch{}if(a)this.rb(o,a);else throw new w.$Kk((0,y.localize)(23,null,this.sb(o)),1);if(!!!s?.recursive){const b=await this.resolve(o);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return n}async del(o,s){const n=await this.W(o,s);let t=s;if((0,w.$zk)(n)&&!t?.atomic){const b=n.enforceAtomicDelete?.(o);b&&(t={...s,atomic:b})}const r=!!t?.useTrash,a=!!t?.recursive,E=t?.atomic??!1;await n.delete(o,{recursive:a,useTrash:r,atomic:E}),this.r.fire(new w.$Hk(o,1))}async cloneFile(o,s){const n=await this.j(o),t=this.qb(await this.n(s),s);if(n===t&&this.R(n).providerExtUri.isEqual(o,s))return;if(n===t&&(0,w.$uk)(n))return n.cloneFile(o,s);await this.U(t,this.R(t).providerExtUri.dirname(s));const r=this.cb.queueFor(o,this.R(n).providerExtUri);return n===t&&(0,w.$tk)(n)?r.queue(()=>n.copy(o,s,{overwrite:!0})):r.queue(()=>this.O(n,o,t,s))}static{this.ab=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:h.ab++})}watch(o,s={recursive:!1,excludes:[]}){const n=new g.$Sc;let t=!1,r=()=>{t=!0};n.add((0,g.$Rc)(()=>r())),(async()=>{try{const E=await this.bb(o,s);t?(0,g.$Oc)(E):r=()=>(0,g.$Oc)(E)}catch(E){this.b.error(E)}})();const a=s.correlationId;if(typeof a=="number"){const E=n.add(new I.$Ud);return n.add(this.X.event(u=>{u.correlates(a)&&E.fire(u)})),{onDidChange:E.event,dispose:()=>n.dispose()}}return n}async bb(o,s){const n=await this.j(o),t=(0,C.$Si)([this.R(n).providerExtUri.getComparisonKey(o),s]);let r=this.$.get(t);return r||(r={count:0,disposable:n.watch(o,s)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,s,n,t){return this.cb.queueFor(s,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(s,{create:!0,unlock:n?.unlock??!1});try{(0,d.$7d)(t)||(0,d.$8d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,w.$Dk)(a)}finally{await o.close(r)}})}async eb(o,s,n){let t=0,r;if((0,d.$8d)(n)){if(n.buffer.length>0){const a=A.$ie.concat(n.buffer);await this.gb(o,s,a,a.byteLength,t,0),t+=a.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((a,E)=>{(0,d.$ae)(r,{onData:async b=>{r.pause();try{await this.gb(o,s,b,b.byteLength,t,0)}catch(u){return E(u)}t+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>E(b),onEnd:()=>a()})})}async fb(o,s,n){let t=0,r;for(;(r=n.read())!==null;)await this.gb(o,s,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,s,n,t,r,a){let E=0;for(;E<t;){const b=await o.write(s,r+E,n.buffer,a+E,t-E);E+=b}}async hb(o,s,n,t){return this.cb.queueFor(s,this.R(o).providerExtUri).queue(()=>this.ib(o,s,n,t))}async ib(o,s,n,t){let r;t instanceof A.$ie?r=t:(0,d.$7d)(t)?r=await(0,A.$ue)(t):(0,d.$8d)(t)?r=await(0,A.$ve)(t):r=(0,A.$se)(t),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(o,s,n,t){return this.cb.queueFor(t,this.R(n).providerExtUri).queue(()=>this.kb(o,s,n,t))}async kb(o,s,n,t){let r,a;try{r=await o.open(s,{create:!1}),a=await n.open(t,{create:!0,unlock:!1});const E=A.$ie.alloc(this.a);let b=0,u=0,p=0;do p=await o.read(r,b,E.buffer,u,E.byteLength-u),await this.gb(n,a,E,p,b,u),b+=p,u+=p,u===E.byteLength&&(u=0);while(p>0)}catch(E){throw(0,w.$Dk)(E)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async lb(o,s,n,t){return this.cb.queueFor(t,this.R(n).providerExtUri).queue(()=>this.mb(o,s,n,t))}async mb(o,s,n,t){return n.writeFile(t,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,s,n,t){return this.cb.queueFor(t,this.R(n).providerExtUri).queue(()=>this.ob(o,s,n,t))}async ob(o,s,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(s);await this.gb(n,r,A.$ie.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.$Dk)(a)}finally{await n.close(r)}}async pb(o,s,n,t){const r=await(0,A.$ue)(this.H(o,s,j.CancellationToken.None));await this.hb(n,t,void 0,r)}qb(o,s){if(o.capabilities&2048)throw new w.$Kk((0,y.localize)(25,null,this.sb(s)),6);return o}rb(o,s){if((s.permissions??0)&w.FilePermission.Readonly)throw new w.$Kk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$bq=v,e.$bq=v=h=ye([X(0,f.$mj)],v)}),define(le[200],he([0,1,54,270,6,35,14,3,49,2,16,5,19,47,31,161,11,98,198,38,194,193]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0,(()=>{try{(0,L.gracefulify)(O)}catch(o){console.error(`Error enabling graceful-fs: ${(0,m.$Pi)(o)}`)}})();class i extends f.$kq{static{this.I=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=C.Event.None,this.N=new j.$Ac(t=>$.$xg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:n,symbolicLink:t}=await d.SymlinkSupport.stat(this.H(s));return{type:this.M(n,t),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:w.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await d.Promises.readdir(this.H(s),{withFileTypes:!0}),t=[];return await Promise.all(n.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,$.$Gg)(s,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(n){throw this.fb(n)}}M(s,n){let t;return n?.dangling?t=w.FileType.Unknown:s.isFile()?t=w.FileType.File:s.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,n&&(t|=w.FileType.SymbolicLink),t}async O(s){const n=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let t;for(;t=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await t.wait();const r=new A.$4g;return this.N.set(s,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(s)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(s,n){let t;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),t=await this.O(s));const r=this.H(s);return await d.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(s){i.I&&this.a.trace(s)}readFileStream(s,n,t){const r=(0,l.$9d)(a=>I.$ie.concat(a.map(E=>I.$ie.wrap(E))).buffer);return(0,c.$aq)(this,s,r,a=>a.buffer,{...n,bufferSize:256*1024},t),r}async writeFile(s,n,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,$.$Gg)((0,$.$Fg)(s),`${(0,$.$Dg)(s)}${t.atomic.postfix}`),n,t):this.S(s,n,t)}async Q(s){try{const n=this.H(s),{symbolicLink:t}=await d.SymlinkSupport.stat(n);if(t)return!1}catch{}return!0}async R(s,n,t,r){const a=new g.$Sc;try{a.add(await this.O(s)),a.add(await this.O(n)),await this.S(n,t,r,!0);try{await this.rename(n,s,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{a.dispose()}}async S(s,n,t,r){let a;try{const E=this.H(s);if(!t.create||!t.overwrite){if(await d.Promises.exists(E)){if(!t.overwrite)throw(0,w.$Ck)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$Ck)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:t.unlock},r),await this.write(a,0,n,0,n.byteLength)}catch(E){throw await this.gb(s,E)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(s){i.Y=s}async open(s,n,t){const r=this.H(s);let a;(0,w.$qk)(n)&&!t&&(a=await this.O(s));let E;try{if((0,w.$qk)(n)&&n.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(r);u.mode&128||await d.Promises.chmod(r,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let b;if((0,w.$qk)(n)){if(S.$i)try{await d.Promises.truncate(r,0),b="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}b||(b="w")}else b="r";E=await d.Promises.open(r,b)}catch(b){throw a?.dispose(),(0,w.$qk)(n)?await this.gb(s,b):this.fb(b)}if(this.U.set(E,0),(0,w.$qk)(n)&&this.X.set(E,s),a){const b=this.W.get(E);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.W.set(E,a),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),b.dispose())}return E}async close(s){const n=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&i.Y)try{await d.Promises.fdatasync(s)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await d.Promises.close(s)}catch(t){throw this.fb(t)}finally{n&&(this.W.get(s)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,t,r,a){const E=this.Z(s,n);let b=null;try{b=(await d.Promises.read(s,t,r,a,E)).bytesRead}catch(u){throw this.fb(u)}finally{this.$(s,E,b)}return b}Z(s,n){return n===this.U.get(s)?null:n}$(s,n,t){const r=this.U.get(s);typeof r=="number"&&(typeof n=="number"||(typeof t=="number"?this.U.set(s,r+t):this.U.delete(s)))}async write(s,n,t,r,a){return(0,A.$mh)(()=>this.ab(s,n,t,r,a),100,3)}async ab(s,n,t,r,a){const E=this.Z(s,n);let b=null;try{b=(await d.Promises.write(s,t,r,a,E)).bytesWritten}catch(u){throw await this.gb(this.X.get(s),u)}finally{this.$(s,E,b)}return b}async mkdir(s){try{await d.Promises.mkdir(this.H(s))}catch(n){throw this.fb(n)}}async delete(s,n){try{const t=this.H(s);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,P.$jc)((0,P.$mc)(t),`${(0,P.$nc)(t)}${n.atomic.postfix}`)),await d.Promises.rm(t,d.RimRafMode.MOVE,r)}else try{await d.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:E,symbolicLink:b}=await d.SymlinkSupport.stat(t);a=E.isDirectory()&&!b}catch{}if(a)await d.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(s,n,t){const r=this.H(s),a=this.H(n);if(r!==a)try{await this.bb(s,n,"move",t.overwrite),await d.Promises.rename(r,a)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(2,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(a)),E.toString()))),this.fb(E)}}async copy(s,n,t){const r=this.H(s),a=this.H(n);if(r!==a)try{await this.bb(s,n,"copy",t.overwrite),await d.Promises.copy(r,a,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(3,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(a)),E.toString()))),this.fb(E)}}async bb(s,n,t,r){const a=this.H(s),E=this.H(n);let b=!1;if(!!(this.capabilities&1024)||(b=(0,k.$6f)(a,E,!0)),b){if(t==="copy")throw(0,w.$Ck)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(s);if(!p)throw(0,w.$Ck)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const R=await this.L(n);if(R){if(!r)throw(0,w.$Ck)((0,y.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);p.type&w.FileType.File&&R.type&w.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.cb(s,n,!1)}async cb(s,n,t){const r=this.H(s),a=this.H(n),E=!!(this.capabilities&1024);if((0,k.$6f)(r,a,!E))return;const b=new g.$Sc;try{b.add(await this.O(s)),b.add(await this.O(n)),t&&await d.Promises.mkdir((0,P.$mc)(a),{recursive:!0}),await d.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!t)return this.cb(s,n,!0);throw this.fb(u)}finally{b.dispose()}}t(s,n,t){return new h.$rq(r=>s(r),r=>n(r),t)}F(s,n,t){return new v.$zq(r=>s(r),r=>n(r),t)}fb(s){if(s instanceof w.$Bk)return s;let n=s,t;switch(s.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$Ck)(n,t)}async gb(s,n){let t=this.fb(n);if(s&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.H(s));r.mode&128||(t=(0,w.$Ck)(n,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Aq=i}),define(le[101],he([0,1,3,2,4,8]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U_b=e.$T_b=void 0,e.$T_b=(0,A.$5h)("sharedProcessLifecycleService");let I=class extends L.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new O.$Ud),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$U_b=I,e.$U_b=I=ye([X(0,j.$mj)],I)}),define(le[201],he([0,1,10,3,8,2]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=void 0;class I extends A.$xj{constructor(S,$,l,d,y){super($,l,d),this.r=S,this.t=y,this.B(y.listen("onDidChangeLogLevel",S)(w=>{(0,A.$oj)(w)?super.setLogLevel(w):super.setLogLevel(O.URI.revive(w[0]),w[1])})),this.B(y.listen("onDidChangeVisibility",S)(([w,c])=>super.setVisibility(O.URI.revive(w),c))),this.B(y.listen("onDidChangeLoggers",S)(({added:w,removed:c})=>{for(const f of w)super.registerLogger({...f,resource:O.URI.revive(f.resource)});for(const f of c)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new A.$vj({log:(S,$)=>{this.t.call("consoleLog",[S,$])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,$){super.setLogLevel(S,$),this.t.call("setLogLevel",[S,$])}setVisibility(S,$){super.setVisibility(S,$),this.t.call("setVisibility",[this.n(S),$])}s(S,$,l){return new C(this.t,S,$,l,this.r)}static setLogLevel(S,$,l){return S.call("setLogLevel",[$,l])}}e.$zr=I;class C extends A.$sj{constructor(S,$,l,d,y){super(d?.logLevel==="always"),this.r=S,this.s=$,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[$,d,y]).then(()=>{this.u(this.n),this.m=!0})}g(S,$){const l=[[S,$]];this.m?this.u(l):this.n.push(...l)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,$){this.a=S,this.b=$}listen(S,$){const l=this.b(S);switch($){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(y=>this.c(y,l)),removed:[...d.removed].map(y=>this.c(y,l))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,d=>[l.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,d=>(0,A.$oj)(d)?d:[l.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${$}`)}async call(S,$,l){const d=this.b(S);switch($){case"setLogLevel":return(0,A.$oj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(O.URI.revive(d.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,d)))}throw new Error(`Call not found: ${$}`)}c(S,$){return{...S,resource:$.transformOutgoingURI(S.resource)}}}e.$Ar=k;class g extends j.$Tc{constructor(S,$){super(),$.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(l=>$.call("setLogLevel",[l]))),$.call("getRegisteredLoggers").then(l=>{for(const d of l)S.registerLogger({...d,resource:O.URI.revive(d.resource)})}),this.B($.listen("onDidChangeVisibility")(([l,d])=>S.setVisibility(O.URI.revive(l),d))),this.B($.listen("onDidChangeLoggers")(({added:l,removed:d})=>{for(const y of l)S.registerLogger({...y,resource:O.URI.revive(y.resource)});for(const y of d)S.deregisterLogger(y.resource)}))}}e.$Br=g}),define(le[202],he([0,1,2,8]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=void 0;class A extends O.$Tc{constructor(I,C=[]){super(),this.a=new L.$wj([I,...C]),this.B(I.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...C){this.a.trace(I,...C)}debug(I,...C){this.a.debug(I,...C)}info(I,...C){this.a.info(I,...C)}warn(I,...C){this.a.warn(I,...C)}error(I,...C){this.a.error(I,...C)}flush(){this.a.flush()}}e.$sO=A}),define(le[57],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P0b=void 0,e.$P0b=(0,O.$5h)("nativeHostService")}),define(le[203],he([0,1,40,56]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=void 0;let A=class{constructor(I,C){return this.windowId=I,O.ProxyChannel.toService(C.getChannel("nativeHost"),{context:I,properties:(()=>{const k=new Map;return k.set("windowId",I),k})()})}};e.$0$b=A,e.$0$b=A=ye([X(1,L.$4$b)],A)}),define(le[58],he([0,1,3,61,2,4]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=void 0,e.$In=(0,j.$5h)("policy");class I extends A.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$Ud),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const P=Object.keys(this.f).length;return this.f={...g,...this.f},P!==Object.keys(this.f).length&&await this.j(g),L.Iterable.reduce(this.g.entries(),(S,[$,l])=>({...S,[$]:l}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(g,[P,S])=>({...g,[P]:{definition:S,value:this.g.get(P)}}),{})}}e.$Jn=I;class C{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Kn=C}),define(le[204],he([0,1,3,2,58]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=e.$z$b=void 0;class j{constructor(k){this.b=k,this.a=new L.$Sc}listen(k,g){switch(g){case"onDidChange":return O.Event.map(this.b.onDidChange,P=>P.reduce((S,$)=>({...S,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,P){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$z$b=j;class I extends A.$Jn{constructor(k,g){super(),this.a=g;for(const P in k){const{definition:S,value:$}=k[P];this.f[P]=S,$!==void 0&&this.g.set(P,$)}this.a.listen("onDidChange")(P=>{for(const S in P){const $=P[S];$===null?this.g.delete(S):this.g.set(S,$)}this.h.fire(Object.keys(P))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const P in g)this.g.set(P,g[P])}}e.$A$b=I}),define(le[102],he([0,1,37]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const j=A.context.configuration();if(j)L=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:j.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(le[25],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=void 0,e.$Ej=(0,O.$5h)("productService"),e.$Fj="vscode://schemas/vscode-product"}),define(le[205],he([0,1,6,7,2,16,31,8,25]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=void 0;let g=class extends A.$Tc{constructor(S,$,l){super(),this.b=$,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new O.$eh(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),l=(0,j.$mc)(S),d=(0,j.$nc)(S),y=await I.Promises.readdir(l);await Promise.all(y.map(async w=>{if(w===d)return;const c=(0,j.$jc)(l,w),f=await I.Promises.stat(c);if(f.isDirectory()&&$-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),I.Promises.rm(c)}))}catch($){(0,L.$1)($)}}};e.$o_b=g,e.$o_b=g=ye([X(1,k.$Ej),X(2,C.$mj)],g)}),define(le[206],he([0,1,6,7,2,16,31,15,8,25]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=void 0;let P=class extends A.$Tc{constructor($,l,d){super(),this.b=$,this.c=l,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$eh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),l=JSON.parse(await I.Promises.readFile((0,j.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(l)){const m=l[f];$[`${m.hash}.${f}`]=!0}const d=(0,j.$jc)(this.b.userDataPath,"clp");if(!await I.Promises.exists(d))return;const w=await I.Promises.readdir(d);for(const f of w){if($[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await I.Promises.rm((0,j.$jc)(d,f))}const c=Date.now();for(const f of Object.keys($)){const m=(0,j.$jc)(d,f),h=await I.Promises.readdir(m);for(const v of h){if(v==="tcf.json")continue;const i=(0,j.$jc)(m,v),o=await I.Promises.stat(i);o.isDirectory()&&c-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$jc)(f,v)}`),await I.Promises.rm(i))}}}catch($){(0,L.$1)($)}}};e.$p_b=P,e.$p_b=P=ye([X(0,C.$ai),X(1,k.$mj),X(2,g.$Ej)],P)}),define(le[207],he([0,1,16,4]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$hF=void 0,e.$hF=(0,L.$5h)("IV8InspectProfilingService");var A;(function(j){function I(k){return!!(k.samples&&k.timeDeltas)}j.isValidProfile=I;function C(k,g="noAbsolutePaths"){for(const P of k.nodes)P.callFrame&&P.callFrame.url&&((0,O.$ic)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,O.$jc)(g,(0,O.$nc)(P.callFrame.url)));return k}j.rewriteAbsolutePaths=C})(A||(e.Utils=A={}))}),define(le[208],he([0,1,32]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;class L{constructor(){this.a=new Map}async startProfiling(j){const C=await(await new Promise((g,P)=>{ne(["v8-inspect-profiler"],g,P)})).startProfiling({port:j.port,checkForPaused:!0}),k=(0,O.$pg)();return this.a.set(k,C),k}async stopProfiling(j){const I=this.a.get(j);if(!I)throw new Error(`UNKNOWN session '${j}'`);const C=await I.stop();return this.a.delete(j),C.profile}}e.$J_b=L}),define(le[41],he([0,1,126,12]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class A{constructor(){this.a=new Map}add(I,C){O.ok(L.$Hf(I)),O.ok(L.$Jf(C)),O.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,C)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Gn=new A}),define(le[103],he([0,1,3,41]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0,e.$Hn={JSONContribution:"base.contributions.json"};function A(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class j{constructor(){this.b=new O.$Ud,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[A(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const I=new j;L.$Gn.add(e.$Hn.JSONContribution,I)}),define(le[44],he([0,1,17,3,12,148,20,103,41]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ConfigurationScope=e.$Ln=e.EditPresentationTypes=void 0;var g;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Ln={Configuration:"base.contributions.configuration"};var P;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Mn={properties:{},patternProperties:{}},e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn="vscode://schemas/settings/resourceLanguage",e.$Tn="vscode://schemas/settings/configurationDefaults";const S=k.$Gn.as(C.$Hn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new L.$Ud,this.onDidSchemaChange=this.i.event,this.j=new L.$Ud,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Sn,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.n(i,o,s),S.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.o(i,o),S.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.o(o,s),this.n(i,!1,s),S.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const s=[];for(const{overrides:n,source:t}of i)for(const r in n)if(o.add(r),e.$Vn.test(r)){const a=this.a.get(r),E=a?.valuesSources??new Map;if(t)for(const R of Object.keys(n[r]))E.set(R,t);const b={...a?.value||{},...n[r]};this.a.set(r,{source:t,value:b,valuesSources:E});const u=(0,I.$Ii)(r),p={type:"object",default:b,description:j.localize(1,null,u),$ref:e.$Sn,defaultDefaultValue:b,source:A.$Hf(t)?void 0:t,defaultValueSource:t};s.push(...y(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:n[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(s)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:s,source:n}of i)for(const t in s){const r=this.a.get(t),a=A.$Hf(n)?n:n?.id,E=A.$Hf(r?.source)?r?.source:r?.source?.id;if(a===E)if(o.add(t),this.a.delete(t),e.$Vn.test(t))delete this.d[t],delete this.b.properties[t];else{const b=this.d[t];b&&(this.w(t,b),this.r(t,b))}}this.u()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,s){i.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(i,o){const s=n=>{if(n.properties)for(const t in n.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,n.properties[t])}n.allOf?.forEach(t=>s(t))};for(const n of i){s(n);const t=this.c.indexOf(n);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,s,n,t=3,r){t=A.$Qf(i.scope)?t:i.scope;const a=i.properties;if(a)for(const b in a){const u=a[b];if(o&&m(b,u)){delete a[b];continue}if(u.source=s,u.defaultDefaultValue=a[b].default,this.w(b,u),e.$Vn.test(b)?u.scope=void 0:(u.scope=A.$Qf(u.scope)?t:u.scope,u.restricted=A.$Qf(u.restricted)?!!n?.includes(b):u.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.f[b]=a[b],delete a[b];continue}else this.d[b]=a[b],a[b].policy?.name&&this.e.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),r.add(b)}const E=i.allOf;if(E)for(const b of E)this.p(b,o,s,n,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=s=>{const n=s.properties;if(n)for(const r in n)this.r(r,n[r]);s.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$Mn.properties[i]=o,o.scope){case 1:e.$Nn.properties[i]=o;break;case 2:e.$On.properties[i]=o;break;case 6:e.$Pn.properties[i]=o;break;case 3:e.$Qn.properties[i]=o;break;case 4:e.$Rn.properties[i]=o;break;case 5:e.$Rn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$Mn.properties[i],o.scope){case 1:delete e.$Nn.properties[i];break;case 2:delete e.$On.properties[i];break;case 6:delete e.$Pn.properties[i];break;case 3:delete e.$Qn.properties[i];break;case 4:case 5:delete e.$Rn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,s={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$Sn};this.w(o,s),e.$Mn.properties[o]=s,e.$Nn.properties[o]=s,e.$On.properties[o]=s,e.$Pn.properties[o]=s,e.$Qn.properties[o]=s,e.$Rn.properties[o]=s}}v(){const i={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$Sn};e.$Mn.patternProperties[e.$Un]=i,e.$Nn.patternProperties[e.$Un]=i,e.$On.patternProperties[e.$Un]=i,e.$Pn.patternProperties[e.$Un]=i,e.$Qn.patternProperties[e.$Un]=i,e.$Rn.patternProperties[e.$Un]=i,this.i.fire()}w(i,o){const s=this.a.get(i);let n=s?.value,t=s?.source;A.$Of(n)&&(n=o.defaultDefaultValue,t=void 0),A.$Of(n)&&(n=c(o.type)),o.default=n,o.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",d=new RegExp(l,"g");e.$Un=`^(${l})+$`,e.$Vn=new RegExp(e.$Un);function y(v){const i=[];if(e.$Vn.test(v)){let o=d.exec(v);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=d.exec(v)}}return(0,O.$Mb)(i)}e.$Wn=y;function w(v){return v.reduce((i,o)=>`${i}[${o}]`,"")}e.$Xn=w;function c(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Yn=c;const f=new $;k.$Gn.add(e.$Ln.Configuration,f);function m(v,i){return v.trim()?e.$Vn.test(v)?j.localize(7,null,v):f.getConfigurationProperties()[v]!==void 0?j.localize(8,null,v):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?j.localize(9,null,v,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:j.localize(6,null)}e.$Zn=m;function h(){const v=[],i=f.getConfigurationProperties();for(const o of Object.keys(i))v.push([o,i[o].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$1n=h}),define(le[76],he([0,1,17,3,34,2,35,30,12,10,20,44,41]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;function l(o){return Object.isFrozen(o)?o:C.$vn(o)}class d{constructor(s={},n=[],t=[],r){this.b=s,this.c=n,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof d)return n;const t=new y("");return t.parseRaw(n),t.configurationModel});this.f=s.reduce((n,t)=>t===n?t:n.merge(t),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$Gi)(this.contents,s):this.contents}inspect(s,n){const t=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,a=n?this.rawConfiguration.override(n).getValue(s):t;return{value:t,override:r,merged:a}}getOverrideValue(s,n){const t=this.i(n);return t?s?(0,P.$Gi)(t,s):t:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const t of this.overrides)t.identifiers.includes(s)&&n.push(...t.keys);return O.$Mb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return O.$Mb(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=C.$un(this.contents),t=C.$un(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const E of s)if(a.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(n,E.contents);for(const b of E.overrides){const[u]=t.filter(p=>O.$ub(p.identifiers,b.identifiers));u?(this.h(u.contents,b.contents),u.keys.push(...b.keys),u.keys=O.$Mb(u.keys)):t.push(C.$un(b))}for(const b of E.keys)r.indexOf(b)===-1&&r.push(b)}return new d(n,r,t,a.every(E=>E instanceof d)?void 0:a)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const t={};for(const r of O.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r];const E=n[r];E&&(typeof a=="object"&&typeof E=="object"?(a=C.$un(a),this.h(a,E)):a=E),t[r]=a}return new d(t,this.keys,this.overrides)}h(s,n){for(const t of Object.keys(n)){if(t in s&&k.$Jf(s[t])&&k.$Jf(n[t])){this.h(s[t],n[t]);continue}s[t]=C.$un(n[t])}}i(s){let n=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=C.$un(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===s?n=a.contents:a.identifiers.includes(s)&&r(a.contents);return r(n),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,P.$Fi)(this.contents,s),S.$Vn.test(s)&&this.overrides.splice(this.overrides.findIndex(t=>O.$ub(t.identifiers,(0,S.$Wn)(s))),1))}j(s,n,t){(0,P.$Ei)(this.contents,s,n,r=>console.error(r)),t=t||this.keys.indexOf(s)===-1,t&&this.keys.push(s),S.$Vn.test(s)&&this.overrides.push({identifiers:(0,S.$Wn)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$Di)(this.contents[s],r=>console.error(r))})}}e.$2n=d;class y{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!k.$Qf(s)){const t=this.g(s);this.parseRaw(t,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:t,keys:r,overrides:a,restricted:E,hasExcludedProperties:b}=this.h(s,n);this.b=new d(t,r,a,b?[s]:void 0),this.c=E||[]}g(s){let n={},t=null,r=[];const a=[],E=[];function b(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const u={onObjectBegin:()=>{const p={};b(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];b(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:b,onError:(p,R,N)=>{E.push({error:p,offset:R,length:N})}};if(s)try{A.$in(s,u),n=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return n}h(s,n){const t=$.$Gn.as(S.$Ln.Configuration).getConfigurationProperties(),r=this.i(s,t,!0,n);s=r.raw;const a=(0,P.$Di)(s,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),E=Object.keys(s),b=this.j(s,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:E,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(s,n,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:a};const E={},b=[];for(const u in s)if(S.$Vn.test(u)&&t){const p=this.i(s[u],n,!1,r);E[u]=p.raw,a=a||p.hasExcludedProperties,b.push(...p.restricted)}else{const p=n[u],R=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&b.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&!(r.skipRestricted&&p?.restricted))?E[u]=s[u]:a=!0}return{raw:E,restricted:b,hasExcludedProperties:a}}j(s,n){const t=[];for(const r of Object.keys(s))if(S.$Vn.test(r)){const a={};for(const E in s[r])a[E]=s[r][E];t.push({identifiers:(0,S.$Wn)(r),keys:Object.keys(a),contents:(0,P.$Di)(a,n)})}return t}}e.$3n=y;class w extends j.$Tc{constructor(s,n,t,r){super(),this.c=s,this.f=n,this.g=r,this.b=this.B(new L.$Ud),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$4n=w;class c{constructor(s,n,t,r,a,E,b,u,p,R,N,F,M){this.a=s,this.b=n,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=E,this.g=b,this.h=u,this.i=p,this.j=R,this.k=N,this.l=F,this.m=M}get value(){return l(this.c)}n(s,n,t){const r=s.inspect(n,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(s,n,t,r,a=new d,E=new d,b=new I.$Ac,u=new d,p=new I.$Ac){this.c=s,this.d=n,this.f=t,this.g=r,this.h=a,this.i=E,this.j=b,this.l=u,this.m=p,this.a=null,this.b=new I.$Ac,this.n=null}getValue(s,n,t){return this.p(s,n,t).getValue(s)}updateValue(s,n,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new d,this.m.set(t.resource,r))):r=this.l,n===void 0?r.removeValue(s):r.setValue(s,n),t.resource||(this.a=null)}inspect(s,n,t){const r=this.p(s,n,t),a=this.t(n.resource,t),E=n.resource?this.m.get(n.resource)||this.l:this.l,b=new Set;for(const u of r.overrides)for(const p of u.identifiers)r.getOverrideValue(s,p)!==void 0&&b.add(p);return new c(s,n,r.getValue(s),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,E)}keys(s){const n=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const t=[];if(!n){const{added:r,updated:a,removed:E}=v(this.c,s);n=[...r,...a,...E]}for(const r of n)for(const a of(0,S.$Wn)(r)){const E=this.c.getKeysForOverrideIdentifier(a),b=s.getKeysForOverrideIdentifier(a),u=[...b.filter(p=>E.indexOf(p)===-1),...E.filter(p=>b.indexOf(p)===-1),...E.filter(p=>!C.$yn(this.c.override(a).getValue(p),s.override(a).getValue(p)))];t.push([a,u])}return this.updateDefaultConfiguration(s),{keys:n,overrides:t}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:t,removed:r}=v(this.d,s),a=[...n,...t,...r];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:t,removed:r,overrides:a}=v(this.applicationConfiguration,s),E=[...n,...t,...r];return E.length&&this.updateApplicationConfiguration(s),{keys:E,overrides:a}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:t,removed:r,overrides:a}=v(this.localUserConfiguration,s),E=[...n,...t,...r];return E.length&&this.updateLocalUserConfiguration(s),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:t,removed:r,overrides:a}=v(this.remoteUserConfiguration,s),E=[...n,...t,...r];return E.length&&this.updateRemoteUserConfiguration(s),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:t,removed:r,overrides:a}=v(this.workspaceConfiguration,s),E=[...n,...t,...r];return E.length&&this.updateWorkspaceConfiguration(s),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(s,n){const t=this.folderConfigurations.get(s),{added:r,updated:a,removed:E,overrides:b}=v(t,n),u=[...r,...a,...E];return(u.length||!t)&&this.updateFolderConfiguration(s,n),{keys:u,overrides:b}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:t,updated:r,removed:a,overrides:E}=v(n,void 0);return{keys:[...t,...r,...a],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,n,t){let r=this.q(n,t);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}q({resource:s},n){let t=this.r();if(n&&s){const r=n.getFolder(s);r&&(t=this.s(r.uri)||t);const a=this.m.get(s);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let n=this.b.get(s);if(!n){const t=this.r(),r=this.j.get(s);r?(n=t.merge(r),this.b.set(s,n)):n=t}return n}t(s,n){if(n&&s){const t=n.getFolder(s);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:t,overrides:r,keys:a}=this.j.get(n);return s.push([n,{contents:t,overrides:r,keys:a}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(t=>s.add(t))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(t=>s.add(t))),[...s.values()]}v(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(t=>n.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(t=>n.add(t)),this.i.getKeysForOverrideIdentifier(s).forEach(t=>n.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.w(s.defaults),t=this.w(s.policy),r=this.w(s.application),a=this.w(s.user),E=this.w(s.workspace),b=s.folders.reduce((u,p)=>(u.set(g.URI.revive(p[0]),this.w(p[1])),u),new I.$Ac);return new f(n,t,r,a,new d,E,b,new d,new I.$Ac)}static w(s){return new d(s.contents,s.keys,s.overrides)}}e.$5n=f;function m(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,n=new Map;for(const r of o)r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([a,E])=>{const b=(0,I.$xc)(n,a,new Set);E.forEach(u=>b.add(u))});const t=[];return n.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...s.values()],overrides:t}}e.$6n=m;class h{constructor(s,n,t,r){this.change=s,this.f=n,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of s.keys)this.affectedKeys.add(a);for(const[,a]of s.overrides)for(const E of a)this.affectedKeys.add(E);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(s,n){const t=this.a+s,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const E=this.d.charCodeAt(a);if(E!==this.b&&E!==this.c)return!1;if(n){const b=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,u=this.g.getValue(s,n,this.h);return!C.$yn(b,u)}return!0}}e.$7n=h;function v(o,s){const{added:n,removed:t,updated:r}=i(s?.rawConfiguration,o?.rawConfiguration),a=[],E=o?.getAllOverrideIdentifiers()||[],b=s?.getAllOverrideIdentifiers()||[];if(s){const u=b.filter(p=>!E.includes(p));for(const p of u)a.push([p,s.getKeysForOverrideIdentifier(p)])}if(o){const u=E.filter(p=>!b.includes(p));for(const p of u)a.push([p,o.getKeysForOverrideIdentifier(p)])}if(s&&o){for(const u of E)if(b.includes(u)){const p=i({contents:o.getOverrideValue(void 0,u)||{},keys:o.getKeysForOverrideIdentifier(u)},{contents:s.getOverrideValue(void 0,u)||{},keys:s.getKeysForOverrideIdentifier(u)});a.push([u,[...p.added,...p.removed,...p.updated]])}}return{added:n,removed:t,updated:r,overrides:a}}function i(o,s){const n=o?s?o.keys.filter(a=>s.keys.indexOf(a)===-1):[...o.keys]:[],t=s?o?s.keys.filter(a=>o.keys.indexOf(a)===-1):[...s.keys]:[],r=[];if(o&&s){for(const a of s.keys)if(o.keys.indexOf(a)!==-1){const E=(0,P.$Gi)(s.contents,a),b=(0,P.$Gi)(o.contents,a);C.$yn(E,b)||r.push(a)}}return{added:n,removed:t,updated:r}}}),define(le[209],he([0,1,17,3,2,30,12,76,44,8,58,41]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=void 0;class $ extends A.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$Ud),this.onDidChangeConfiguration=this.a.event,this.b=new C.$2n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$Gn.as(k.$Ln.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:c})=>this.c(Array.from(w),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,c){this.h(w,S.$Gn.as(k.$Ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new C.$2n;const w=S.$Gn.as(k.$Ln.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,c){const f=this.f();for(const m of w){const h=f[m],v=c[m];h!==void 0?this.b.addValue(m,h):v?this.b.addValue(m,v.default):this.b.removeValue(m)}}}e.$8n=$;class l{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new C.$2n}async initialize(){return this.configurationModel}}e.$9n=l;let d=class extends A.$Tc{get configurationModel(){return this.b}constructor(w,c,f){super(),this.c=w,this.f=c,this.g=f,this.a=this.B(new L.$Ud),this.onDidChangeConfiguration=this.a.event,this.b=new C.$2n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const c={},f=[],m=S.$Gn.as(k.$Ln.Configuration).getConfigurationProperties();for(const h of w){const v=m[h];if(!v){f.push(h);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.g.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}f.push(h),c[v.policy.name]={type:v.type}}}return(0,I.$Uf)(c)||await this.f.updatePolicyDefinitions(c),f}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const c=S.$Gn.as(k.$Ln.Configuration).getPolicyConfigurations(),f=(0,O.$Hb)(w.map(m=>c.get(m)));this.m(f,!0)}m(w,c){this.g.trace("PolicyConfiguration#update",w);const f=S.$Gn.as(k.$Ln.Configuration).getConfigurationProperties(),m=[],h=this.b.isEmpty();for(const v of w){const i=f[v]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(h?o!==void 0:!(0,j.$yn)(this.b.getValue(v),o))&&m.push([v,o])}else this.b.getValue(v)!==void 0&&m.push([v,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const v=this.b;this.b=new C.$2n;for(const i of v.keys)this.b.setValue(i,v.getValue(i));for(const[i,o]of m)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);c&&this.a.fire(this.b)}}};e.$0n=d,e.$0n=d=ye([X(1,P.$In),X(2,g.$mj)],d)}),define(le[210],he([0,1,17,6,14,3,34,62,2,30,5,19,20,76,44,209,58]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=void 0;class c extends k.$Tc{constructor(h,v,i,o){super(),this.m=h,this.h=this.B(new j.$Ud),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.$8n),this.c=i instanceof w.$Kn?new y.$9n:this.B(new y.$0n(this.b,i,o)),this.f=this.B(new l.$4n(this.m,{},S.$xg,v)),this.a=new l.$5n(this.b.configurationModel,this.c.configurationModel,new l.$2n,new l.$2n),this.j=new f(h,v,this),this.g=this.B(new L.$eh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:n})=>this.r(s,n))),this.B(this.c.onDidChangeConfiguration(s=>this.s(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,v,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$5n(h,v,new l.$2n,i)}getConfigurationData(){return this.a.toData()}getValue(h,v){const i=typeof h=="string"?h:void 0,o=(0,$.$zi)(h)?h:(0,$.$zi)(v)?v:{};return this.a.getValue(i,o,void 0)}async updateValue(h,v,i,o,s){const n=(0,$.$Ai)(i)?i:(0,$.$zi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=n?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${h} to target ${t}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,O.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const r=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,g.$yn)(v,r.defaultValue)&&(v=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const E=n.overrideIdentifiers.sort(),b=this.a.localUserConfiguration.overrides.find(u=>(0,O.$ub)([...u.identifiers].sort(),E));b&&(n.overrideIdentifiers=b.identifiers)}const a=n?.overrideIdentifiers?.length?[(0,d.$Xn)(n.overrideIdentifiers),h]:[h];await this.j.write(a,v),await this.reloadConfiguration()}inspect(h,v={}){return this.a.inspect(h,v,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const v=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,v,2)}r(h,v){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(h,v);this.t(o,i,7)}s(h){const v=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,v,7)}t(h,v,i){const o=new l.$7n(h,{data:v},this.a);o.source=i,o.sourceConfig=this.u(i),this.h.fire(o)}u(h){switch(h){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$$n=c;class f{constructor(h,v,i){this.b=h,this.c=v,this.d=i,this.a=new L.$_g}write(h,v){return this.a.queue(()=>this.e(h,v))}async e(h,v){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const o=[];if((0,I.$bn)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(i,h,v);i=(0,C.$tn)(i,s),await this.c.writeFile(this.b,A.$ie.fromString(i))}f(h,v,i){const{tabSize:o,insertSpaces:s,eol:n}=this.h;if(!v.length){const t=JSON.stringify(i,null,s?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,C.$qn)(h,v,i,{tabSize:o,insertSpaces:s,eol:n})}get h(){if(!this.g){let h=P.OS===3||P.OS===2?`
`:`\r
`;const v=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});v&&typeof v=="string"&&v!=="auto"&&(h=v),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[211],he([0,1,14,3,2,68]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrb=e.$mrb=e.$lrb=e.$krb=void 0;const I=(g,P,S)=>{const $=new Uint8Array(16);for(let y=0;y<16;y++)$[y]=Math.round(Math.random()*256);const l=(0,O.$Ce)(O.$ie.wrap($));return[`GET ws://localhost${g}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$krb=I,e.$lrb=O.$ie.fromString(`\r
\r
`);async function C(g,P,S,$,l){g.write(O.$ie.fromString((0,e.$krb)(P,S,$)));const d=new A.$Sc;try{return await new Promise((y,w)=>{let c;d.add(g.onData(f=>{c?c=O.$ie.concat([c,f],c.byteLength+f.byteLength):c=f;const m=c.indexOf(e.$lrb);if(m===-1)return;y(g),g.pauseData();const h=c.slice(m+e.$lrb.byteLength);h.byteLength&&l.onData.fire(h)})),d.add(g.onClose(f=>w(f??new Error("socket closed")))),d.add(g.onEnd(()=>w(new Error("socket ended"))))})}catch(y){throw g.dispose(),y}finally{d.dispose()}}e.$mrb=C;class k extends A.$Tc{constructor(P,S){super(),this.g=P,this.a=this.B(new L.$Xd),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new L.$Ud),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event($=>this.a.fire($))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,S){j.SocketDiagnostics.traceSocketEvent(this,this.g,P,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$nrb=k}),define(le[212],he([0,1,7,4]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.RemoteAuthorityResolverErrorCode=e.$9k=e.$8k=e.RemoteConnectionType=e.$7k=void 0,e.$7k=(0,L.$5h)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class j{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$8k=j;class I{constructor(S,$){this.host=S,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$9k=I;var C;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class k extends O.$bb{static isNotAvailable(S){return S instanceof k&&S._code===C.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===C.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===C.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===C.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,$=C.Unknown,l){super(S),this._message=S,this._code=$,this._detail=l,this.isHandled=$===C.NotAvailable&&l===!0,Object.setPrototypeOf(this,k.prototype)}}e.$0k=k;function g(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.$$k=g}),define(le[77],he([0,1,23]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0;function L(g){return g.scheme===O.Schemas.vscodeRemote?g.authority:void 0}e.$_k=L;function A(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$al=A;function j(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$bl=j;function I(g){const{host:P,port:S}=k(g);if(typeof S>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:P,port:S}}e.$cl=I;function C(g,P){let{host:S,port:$}=k(g);return typeof $>"u"&&($=P),{host:S,port:$}}e.$dl=C;function k(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const $=g.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:g,port:void 0}}}),define(le[45],he([0,1,27,4,77]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.TargetPlatform=e.ExtensionType=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em="extensions.user.cache",e.$fm="extensions.builtin.cache",e.$gm="undefined_publisher",e.$hm=["ui","workspace","web"];function j(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$im=j,e.$jm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(I||(e.ExtensionType=I={}));var C;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class k{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,c){if(typeof w>"u"||w===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof w=="string"||typeof c=="string"){const f=typeof w=="string"?w:w.value,m=typeof c=="string"?c:c.value;return O.$$e(f,m)}return w._lower===c._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$km=k;class g{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const c of w)this.add(c)}add(w){this.c.add(k.toKey(w))}delete(w){return this.c.delete(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}}e.$lm=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(k.toKey(w))}get(w){return this.c.get(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}set(w,c){this.c.set(k.toKey(w),c)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$mm=P;function S(y){return $(y)}e.$nm=S;function $(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$om=$;function l(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$pm=l;function d(y,w){if(w){const c=`onResolveRemoteAuthority:${(0,A.$al)(w)}`;return!!y.activationEvents?.includes(c)}return!1}e.$qm=d,e.$rm=(0,L.$5h)("IBuiltinExtensionsScannerService")}),define(le[213],he([0,1,2,45,11]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class j extends O.$Tc{constructor(C,k,g,P,S){super(),this.a=C,this.b=k,this.c=g,this.f=S,this.B(P.onDidInstallExtensions($=>this.g($))),this.B(P.onDidUninstallExtension($=>this.h($)))}g(C){for(const k of C)k.local&&this.invalidate(k.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,C)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,L.$em))}catch(k){(0,A.$Gk)(k)!==1&&this.f.error(k)}}}e.$7p=j}),define(le[214],he([0,1,6,14,26,7,3,2,100,63,32,68,212,77]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.PersistentConnectionEventType=e.$kl=e.$jl=e.$il=e.ConnectionType=void 0;const d=30*1e3;var y;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(z){const D=new A.$5d;return setTimeout(()=>D.cancel(),z),D.token}function f(z,D){if(z.isCancellationRequested||D.isCancellationRequested)return A.CancellationToken.Cancelled;const T=new A.$5d;return z.onCancellationRequested(()=>T.cancel()),D.onCancellationRequested(()=>T.cancel()),T.token}class m{get didTimeout(){return this.c==="timedout"}constructor(D){this.c="pending",this.d=new C.$Sc,this.promise=new Promise((T,B)=>{this.f=T,this.g=B}),D.isCancellationRequested?this.h():this.d.add(D.onCancellationRequested(()=>this.h()))}registerDisposable(D){this.c==="pending"?this.d.add(D):D.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(D))}reject(D){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(D))}}function h(z,D){const T=new m(D);return T.registerDisposable(z.onControlMessage(B=>{const U=JSON.parse(B.toString()),_=G(U);_?T.reject(_):T.resolve(U)})),T.promise}function v(z,D,T,B,U,_,H,J){const ie=new m(J),se=g.$Qd.create(!1);return z.info(`Creating a socket (${H})...`),k.mark(`code/willCreateSocket/${_}`),D.connect(T,B,U,H).then(ce=>{ie.didTimeout?(k.mark(`code/didCreateSocketError/${_}`),z.info(`Creating a socket (${H}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(k.mark(`code/didCreateSocketOK/${_}`),z.info(`Creating a socket (${H}) was successful after ${se.elapsed()} ms.`),ie.resolve(ce))},ce=>{k.mark(`code/didCreateSocketError/${_}`),z.info(`Creating a socket (${H}) returned an error after ${se.elapsed()} ms.`),z.error(ce),ie.reject(ce)}),ie.promise}function i(z,D){const T=new m(D);return z.then(B=>{T.didTimeout||T.resolve(B)},B=>{T.didTimeout||T.reject(B)}),T.promise}async function o(z,D,T,B){const U=ae(z,D);z.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let _;try{_=await v(z.logService,z.remoteSocketFactoryService,z.connectTo,(0,l.$bl)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,w(D),`renderer-${w(D)}-${z.reconnectionToken}`,B)}catch(ce){throw z.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let H,J;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(_,null),H=z.reconnectionProtocol,J=!1):(H=new S.$Sh({socket:_}),J=!0),z.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const ie=await i(z.signService.createNewMessage((0,P.$pg)()),B),se={type:"auth",auth:z.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(L.$ie.fromString(JSON.stringify(se)));try{const ce=await h(H,f(B,c(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(z.logService.trace(`${U} 4/6. received SignRequest control message.`),!await i(z.signService.validate(ie,ce.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const fe=await i(z.signService.sign(ce.data),B),ge={type:"connectionType",commit:z.commit,signedData:fe,desiredConnectionType:D};return T&&(ge.args=T),z.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(L.$ie.fromString(JSON.stringify(ge))),{protocol:H,ownsProtocol:J}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${U} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${U} received error control message when negotiating connection. Error:`),z.logService.error(ce)),J&&W(H),ce}}async function s(z,D,T,B){const U=Date.now(),_=ae(z,D),{protocol:H,ownsProtocol:J}=await o(z,D,T,B),ie=new m(B);return ie.registerDisposable(H.onControlMessage(se=>{const ce=JSON.parse(se.toString()),$e=G(ce);$e?(z.logService.error(`${_} received error control message when negotiating connection. Error:`),z.logService.error($e),J&&W(H),ie.reject($e)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${Z(U)}!`),ie.resolve({protocol:H,firstMessage:ce}))})),ie.promise}async function n(z,D){const{protocol:T}=await s(z,1,void 0,D);return{protocol:T}}async function t(z,D,T){const{protocol:B,firstMessage:U}=await s(z,2,D,T),_=U&&U.debugPort;return{protocol:B,debugPort:_}}async function r(z,D,T){const B=Date.now(),U=ae(z,3),{protocol:_}=await o(z,3,D,T);return z.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${Z(B)}!`),_}async function a(z,D,T){const{connectTo:B,connectionToken:U}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:B,connectionToken:U,reconnectionToken:D,reconnectionProtocol:T,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function E(z,D,T){return u(z,async B=>{const{protocol:U}=await n(B,A.CancellationToken.None);return new V(z,D,T,B.reconnectionToken,U)})}e.$il=E;async function b(z,D){return u(z,async T=>{const{protocol:B,debugPort:U}=await t(T,D,A.CancellationToken.None);return new Q(z,D,T.reconnectionToken,B,U)})}e.$jl=b;async function u(z,D){for(let B=1;;B++)try{const U=(0,P.$pg)(),_=await a(z,U,null);return await D(_)}catch(U){if(B<5)z.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(U);else throw z.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(U),x.triggerPermanentFailure(0,0,$.$0k.isHandled(U)),U}}async function p(z,D,T){const B=await a(z,(0,P.$pg)(),null);return await r(B,{host:D,port:T},A.CancellationToken.None)}e.$kl=p;function R(z){return(0,O.$Sg)(D=>new Promise((T,B)=>{const U=setTimeout(T,z*1e3);D.onCancellationRequested(()=>{clearTimeout(U),T()})}))}var N;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(D,T){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.type=0}}e.$ll=F;class M{constructor(D,T,B,U){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.durationSeconds=B,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.$ml=M;class q{constructor(D,T,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=2}}e.$nl=q;class Y{constructor(D,T,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=4}}e.$ol=Y;class K{constructor(D,T,B,U){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.handled=U,this.type=3}}e.$pl=K;class x extends C.$Tc{static triggerPermanentFailure(D,T,B){this._permanentFailure=!0,this.f=D,this.g=T,this.h=B,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(D=>D.y())}static debugPauseSocketWriting(){this.j.forEach(D=>D.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(D,T,B,U,_){super(),this.t=D,this.u=T,this.reconnectionToken=B,this.protocol=U,this.w=_,this.m=this.B(new I.$Ud),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(U.onSocketClose(H=>{const J=ee(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${J} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${J} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${J} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(H=>{const J=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,C.$Rc)(()=>{const H=x.j.indexOf(this);H>=0&&x.j.splice(H,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const D=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const U=B<T.length?T[B]:T[T.length-1];try{if(U>0){const H=R(U);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,H)),this.u.logService.info(`${D} waiting for ${U} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${D} resolving connection...`);const _=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${D} connecting to ${_.connectTo}...`),await this.G(_,c(d)),this.u.logService.info(`${D} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if($.$0k.isTemporarilyNotAvailable(_)){this.u.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,j.$4)(_)){this.u.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof $.$0k){this.u.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,$.$0k.isHandled(_));break}this.u.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(D,T,B){this.w?x.triggerPermanentFailure(D,T,B):this.D(D,T,B)}D(D,T,B){this.m.fire(new K(this.reconnectionToken,D,T,B)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ql=x;class V extends x{constructor(D,T,B,U,_){super(1,D,U,_,!0),this.client=this.B(new S.$Qh(_,{remoteAuthority:T,clientId:B},D.ipcLogger))}async G(D,T){await n(D,T)}}e.$rl=V;class Q extends x{constructor(D,T,B,U,_){super(2,D,B,U,!1),this.H=T,this.debugPort=_}async G(D,T){await t(D,this.H,T)}}e.$sl=Q;function W(z){try{z.acceptDisconnect();const D=z.getSocket();z.dispose(),D.dispose()}catch(D){(0,j.$1)(D)}}function G(z){if(z&&z.type==="error"){const D=new Error(`Connection error: ${z.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function te(z,D){for(;z.length<D;)z+=" ";return z}function re(z,D){return`[remote-connection][${te(w(z),13)}][${D.substr(0,5)}\u2026]`}function ee(z,D,T){return`${re(z,D)}[${T?"reconnect":"initial"}]`}function ae(z,D){return`${ee(D,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function Z(z){return`${Date.now()-z} ms`}}),define(le[104],he([0,1,2,4]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=void 0,e.$el=(0,L.$5h)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(I,C){return this.a[I]??=[],this.a[I].push(C),(0,O.$Rc)(()=>{const k=this.a[I]?.indexOf(C);typeof k=="number"&&k>=0&&this.a[I]?.splice(k,1)})}b(I){return(this.a[I.type]||[]).find(k=>k.supports(I))}connect(I,C,k,g){const P=this.b(I);if(!P)throw new Error(`No socket factory found for ${I}`);return P.connect(I,C,k,g)}}e.$fl=A}),define(le[215],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=e.$G_b=void 0,e.$G_b=(0,O.$5h)("sharedProcessTunnelService"),e.$H_b="sharedProcessTunnel"}),define(le[105],he([0,1,4,163]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=e.$Q_b=e.$P_b=e.$O_b=e.$N_b=e.TunnelStates=e.$M_b=e.$L_b=void 0,e.$L_b=(0,O.$5h)("IRemoteTunnelService"),e.$M_b={active:!1};var A;(function(j){j.disconnected=I=>({type:"disconnected",onTokenFailed:I}),j.connected=(I,C)=>({type:"connected",info:I,serviceInstallFailed:C}),j.connecting=I=>({type:"connecting",progress:I}),j.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$N_b="remote.tunnels.access",e.$O_b=e.$N_b+".hostNameOverride",e.$P_b=e.$N_b+".preventSleep",e.$Q_b="remoteTunnelService",e.$R_b=(0,L.localize)(0,null)}),define(le[59],he([0,1,14,7,2,165,44,4,8,41]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$gp=(0,C.$5h)("requestService");class P{constructor(v){this.b=v}toJSON(){if(!this.a){const v=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?v[i]="*****":v[i]=this.b[i];this.a=v}return this.a}}class S extends A.$Tc{constructor(v){super(),this.b=0,this.a=v.createLogger("network",{name:(0,j.localize)(0,null),when:k.$Dj.isEqualTo((0,k.$Bj)(k.LogLevel.Trace)).serialize()})}async c(v,i,o){const s=`${v} #${++this.b}: ${i.url}`;this.a.trace(`${s} - begin`,i.type,new P(i.headers??{}));try{const n=await o();return this.a.trace(`${s} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,i.type,(0,L.$0)(n)),n}}}e.$hp=S;function $(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.$ip=$;function l(h){return h.res.statusCode===204}e.$jp=l;async function d(h){return l(h)?null:(await(0,O.$ue)(h.stream)).toString()}e.$kp=d;async function y(h){if(!$(h))throw new Error("Server returned "+h.res.statusCode);return d(h)}e.$lp=y;async function w(h){if(!$(h))throw new Error("Server returned "+h.res.statusCode);if(l(h))return null;const i=(await(0,O.$ue)(h.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$mp=w;function c(h){m(h)}e.$np=c;let f;function m(h){const v=g.$Gn.as(I.$Ln.Configuration),i=f;f={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},v.updateConfigurations({add:[f],remove:i?[i]:[]})}m(1)}),define(le[216],he([0,1,26,23,11,59]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=void 0;let I=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,P=O.CancellationToken.None){if(k.scheme===L.Schemas.file||k.scheme===L.Schemas.vscodeRemote){await this.b.copy(k,g);return}const S={type:"GET",url:k.toString(!0)},$=await this.a.request(S,P);if($.res.statusCode===200)await this.b.writeFile(g,$.stream);else{const l=await(0,j.$lp)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${l}`)}}};e.$HO=I,e.$HO=I=ye([X(0,j.$gp),X(1,A.$pk)],I)}),define(le[217],he([0,1,14,26]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=void 0;class A{constructor(C){this.a=C}listen(C,k){throw new Error("Invalid listen")}call(C,k,g,P=L.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],P).then(async({res:S,stream:$})=>{const l=await(0,O.$ue)($);return[{statusCode:S.statusCode,headers:S.headers},l]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$jr=A;class j{constructor(C){this.a=C}async request(C,k){const[g,P]=await this.a.call("request",[C],k);return{res:g,stream:(0,O.$we)(P)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$kr=j}),define(le[218],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0b=e.$$0b=e.$00b=void 0,e.$00b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$$0b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$_0b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[219],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const j=await this.c();if(j){const I=String(O.a++);return this.b.set(I,j),{id:I,data:j.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,j){if(!A.id)return!0;const I=this.b.get(A.id);if(!I)return!1;this.b.delete(A.id);try{return I.validate(j)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$56b=O}),define(le[106],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=void 0,e.$gl="signService",e.$hl=(0,O.$5h)(e.$gl)}),define(le[220],he([0,1,219]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;class L extends O.$56b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(I=>new I.signer().sign(j))}h(){return new Promise((j,I)=>ne(["vsda"],j,I))}}e.$Z$b=L}),define(le[78],he([0,1,3,2]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pFb=e.$oFb=e.$nFb=e.$mFb=void 0;class A extends L.$Tc{constructor(S,$,l){super(),this.a=S,this.b=$,this.c=l}async getItems(){const S={profile:this.b,workspace:this.c},$=await this.a.call("getItems",S);return new Map($)}updateItems(S){const $={profile:this.b,workspace:this.c};return S.insert&&($.insert=Array.from(S.insert.entries())),S.delete&&($.delete=Array.from(S.delete.values())),this.a.call("updateItems",$)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class j extends A{constructor(S,$){super(S,$,void 0),this.f=this.B(new O.$Ud),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class I extends j{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$mFb=I;class C extends j{constructor(S,$){super(S,$)}async close(){this.dispose()}}e.$nFb=C;class k extends A{constructor(S,$){super(S,void 0,$),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$oFb=k;class g{constructor(S){this.a=S}isUsed(S){const $={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$pFb=g}),define(le[107],he([0,1,5,37,32]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=void 0;function j(k){if(O.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function I(k,g,P,S,$,l,d,y,w){const c=Object.create(null);c["common.machineId"]=l,c["common.sqmId"]=d,c.sessionID=(0,A.$pg)()+Date.now(),c.commitHash=S,c.version=$,c["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,O.$h)(O.$u),c["common.nodePlatform"]=L.$dc,c["common.nodeArch"]=P,c["common.product"]=w||"desktop",y&&(c["common.msftInternal"]=y);let f=0;const m=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),O.$l&&(c["common.snap"]="true");const h=j(g);return h&&(c["common.platformDetail"]=h),c}e.$Ho=I;function C(k){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return k.some(S=>P===S)}e.$Io=C}),define(le[22],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=void 0,e.$tl=(0,O.$5h)("telemetryService"),e.$ul=(0,O.$5h)("customEndpointTelemetryService"),e.$vl="telemetry.currentSessionDate",e.$wl="telemetry.firstSessionDate",e.$xl="telemetry.lastSessionDate",e.$yl="telemetry.machineId",e.$zl="telemetry.sqmId",e.$Al="telemetry",e.$Bl="telemetry.telemetryLevel",e.$Cl="telemetry.enableCrashReporter",e.$Dl="telemetry.enableTelemetry";var L;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var A;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[221],he([0,1,36,6,34,23,16,5,10,142,31,145,95,11,25,22]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=void 0;const w=new Map;async function c(i,o){const s=`${i}::${o.join(":")}`,n=w.get(s);if(n)return n;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,E=2e4;function b(p,R,N,F){const M=R.substring(p.length+1);return L.Promises.withAsyncBody(async q=>{let Y;try{Y=await P.Promises.readdir(R,{withFileTypes:!0})}catch{q();return}if(F.count>=E){F.count+=Y.length,F.maxReached=!0,q();return}let K=Y.length;if(K===0){q();return}let x=Y;F.count+Y.length>E&&(F.maxReached=!0,K=E-F.count,x=Y.slice(0,K)),F.count+=Y.length;for(const V of x)if(V.isDirectory()){if(N.includes(V.name)||await b(p,(0,I.$jc)(R,V.name),N,F),--K===0){q();return}}else{const Q=V.name.lastIndexOf(".");if(Q>=0){const W=V.name.substring(Q+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of t)W.relativePathPattern?.test(M)!==!1&&W.filePattern.test(V.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--K===0){q();return}}})}const u=L.Promises.withAsyncBody(async p=>{const R={count:0,maxReached:!1};await b(i,i,o,R);const N=await h(i);p({configFiles:f(a),fileTypes:f(r),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:N})});return w.set(s,u),u}e.$5r=c;function f(i){return Array.from(i.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function m(){const i={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/l.$Xk.GB).toFixed(2)}GB (${(O.freemem()/l.$Xk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$9m.value()*100)}%`},o=O.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$6r=m;async function h(i){try{const o=new Map,s=(0,I.$jc)(i,".vscode","launch.json"),n=await P.Promises.readFile(s),t=[],r=(0,A.$bn)(n.toString(),t);if(t.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$kn)(r)==="object"&&r.configurations)for(const a of r.configurations){const E=a.type;E&&(o.has(E)?o.set(E,o.get(E)+1):o.set(E,1))}return f(o)}catch{return[]}}e.$7r=h;let v=class{constructor(o,s){this.c=o,this.d=s}f(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}g(o){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const n=O.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(O.totalmem()/l.$Xk.GB).toFixed(2)}GB (${(O.freemem()/l.$Xk.GB).toFixed(2)}GB free)`),C.$i||s.push(`Load (avg):       ${O.loadavg().map(t=>Math.round(t)).join(", ")}`),s.push(`VM:               ${Math.round(g.$9m.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,S.$4r)(o.mainPID),this.k(o)]).then(async n=>{let[t,r]=n,a=this.m(o,t);return s.forEach(E=>{if((0,$.$Im)(E))a+=`
${E.errorMessage}`,r+=`
${E.errorMessage}`;else if(a+=`

Remote: ${E.hostName}`,E.processes&&(a+=`
${this.m(o,E.processes)}`),E.workspaceMetadata){r+=`
|  Remote: ${E.hostName}`;for(const b of Object.keys(E.workspaceMetadata)){const u=E.workspaceMetadata[b];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${b}): ${p}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,s){const{memory:n,vmHint:t,os:r,cpus:a}=m(),E={os:r,memory:n,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return C.$i||(E.load=`${O.loadavg().map(b=>Math.round(b)).join(", ")}`),C.$k&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(o,s){const n=[];return(0,S.$4r)(o.mainPID).then(async t=>(n.push(""),n.push(this.g(o)),n.push(""),n.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(o))),s.forEach(r=>{if((0,$.$Im)(r))n.push(`
${r.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${r.hostName}`),n.push(this.f(r.machineInfo)),r.processes&&n.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const E=r.workspaceMetadata[a];let b=`${E.fileCount} files`;E.maxFilesReached&&(b=`more than ${b}`),n.push(`Folder (${a}): ${b}`),n.push(this.h(E))}}),n.push(""),n.push(""),n.join(`
`)))}h(o){const s=[];let t=0;const r=(u,p)=>{const R=` ${u}(${p})`;t+R.length>60?(s.push(a),a="|                 ",t=a.length):t+=R.length,a+=R};let a="|      File types:";const E=10,b=o.fileTypes.length>E?E:o.fileTypes.length;for(let u=0;u<b;u++){const p=o.fileTypes[u];r(p.name,p.count)}if(s.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(u=>{r(u.name,u.count)}),s.push(a)),o.launchConfigFiles.length>0){let u="|      Launch Configs:";o.launchConfigFiles.forEach(p=>{const R=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;u+=R}),s.push(u)}return s.join(`
`)}j(o){const s=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${o[n]}`).join(`
                  `)}k(o){const s=[],n=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(s.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===j.Schemas.file){const E=a.fsPath;n.push(c(E,["node_modules",".git"]).then(b=>{let u=`${b.fileCount} files`;b.maxFilesReached&&(u=`more than ${u}`),s.push(`|    Folder (${(0,I.$nc)(E)}): ${u}`),s.push(this.h(b))}).catch(b=>{s.push(`|      Error: Unable to collect workspace stats for folder ${E} (${b.toString()})`)}))}else s.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(t=>s.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,s){const n=new Map;o.windows.forEach(r=>n.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>n.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),s&&this.n(o.mainPID,n,t,s,0),t.join(`
`)}n(o,s,n,t,r){const a=r===0;let E;a?E=t.pid===o?`${this.d.applicationName} main`:"remote agent":s.has(t.pid)?E=s.get(t.pid):E=`${"  ".repeat(r)} ${t.name}`;const b=process.platform==="win32"?t.mem:O.totalmem()*(t.mem/100);n.push(`${t.load.toFixed(0).padStart(5," ")}	${(b/l.$Xk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(o,s,n,u,r+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:n}of o.folders){const t=k.URI.revive(n);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await c(r,["node_modules",".git"])).fileTypes.forEach(E=>s.add(E.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const n=k.URI.revive(s);if(n.scheme!==j.Schemas.file)continue;const t=n.fsPath;try{const r=await c(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$8r=v,e.$8r=v=ye([X(0,y.$tl),X(1,d.$Ej)],v)}),define(le[108],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=e.$c$b=void 0;class O{constructor(j){this.b=j}listen(j,I){throw new Error(`Event not found: ${I}`)}call(j,I,{eventName:C,data:k}){return this.b.forEach(g=>g.log(C,k)),Promise.resolve(null)}}e.$c$b=O;class L{constructor(j){this.b=j}log(j,I){return this.b.call("log",{eventName:j,data:I}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$d$b=L}),define(le[46],he([0,1,30,12,3,20,77,107,22]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;class g{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$Jo=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ko=P,e.$Lo=new P;class S{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$Mo=S,e.$No="telemetry",e.$Oo="extensionTelemetryLog",e.$Po={log:()=>null,flush:()=>Promise.resolve(null)};function $(n,t){return A.Event.debounce(t.onDidChangeConfiguration,(a,E)=>{const b=a?new Set([...a.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:b}},1e3,!0)(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,j.$Bi)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$Qo=$;function l(n,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!n.enableTelemetry)}e.$Ro=l;function d(n,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$So=d;function y(n){const t=n.getValue(k.$Bl),r=n.getValue(k.$Cl);if(n.getValue(k.$Dl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$To=y;function w(n){const t={},r={},a={};m(n,a);for(let E in a){E=E.length>150?E.substr(E.length-149):E;const b=a[E];typeof b=="number"?r[E]=b:typeof b=="boolean"?r[E]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${b.length}`),t[E]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(t[E]=b)}return{properties:t,measurements:r}}e.$Uo=w;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(n){if(!n)return"none";const t=(0,I.$al)(n);return c.has(t)?t:"other"}e.$Vo=f;function m(n,t,r=0,a){if(n)for(const E of Object.getOwnPropertyNames(n)){const b=n[E],u=a?a+E:E;Array.isArray(b)?t[u]=(0,O.$zn)(b):b instanceof Date?t[u]=b.toISOString():(0,L.$Jf)(b)?r<2?m(b,t,r+1,u+"."):t[u]=(0,O.$zn)(b):t[u]=b}}function h(n,t){const r=n.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,C.$Io)(r)||a}e.$Wo=h;function v(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$Xo=v;function i(n,t){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const a=[];for(const p of t)for(;;){const R=p.exec(n);if(!R)break;a.push([R.index,p.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const p=b.exec(n);if(!p)break;const R=a.some(([N,F])=>p.index<F&&N<b.lastIndex);!E.test(p[0])&&!R&&(r+=n.substring(u,p.index)+"<REDACTED: user-file-path>",u=b.lastIndex)}return u<n.length&&(r+=n.substr(u)),r}function o(n){if(!n)return n;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function s(n,t){return(0,O.$wn)(n,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=i(a,t);for(const E of t)a=a.replace(E,"");return a=o(a),a}})}e.$Yo=s}),define(le[33],he([0,1,27,29,45,5,10,7,37,46]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;function P(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,O.$6e)(s.id,n.id)===0}e.$Zo=P;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(n){const t=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new $(n.identifier,t,r)}static parse(n){const t=S.exec(n);return t&&t[1]&&t[2]?new $({id:t[1]},t[2],t[4]||void 0):null}constructor(n,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof $?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$1o=$;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(s){const n=l.exec(s);return n&&n[1]?[w(n[1]),n[2]]:[w(s),void 0]}e.$2o=d;function y(s,n){return`${s}.${n}`}e.$3o=y;function w(s){return s.toLowerCase()}e.$4o=w;function c(s,n){return w(y(s??A.$gm,n))}e.$5o=c;function f(s,n){const t=[],r=a=>{for(const E of t)if(E.some(b=>P(n(b),n(a))))return E;return null};for(const a of s){const E=r(a);E?E.push(a):t.push([a])}return t}e.$6o=f;function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$7o=m;function h(s){return{id:new g.$Jo(s.identifier.id),name:new g.$Jo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$8o=h,e.$9o=new A.$km("pprice.better-merge");function v(s,n){const t=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(E=>!P(E.identifier,{id:a}))){const E=s.filter(b=>P(b.identifier,{id:a}));E.length===1&&(t.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$0o=v;async function i(s,n){if(!j.$k)return!1;let t;try{t=(await s.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await s.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,C.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,n){const t=await i(s,n),r=(0,L.$to)(t?"alpine":j.$u,k.$ec);return n.debug("ComputeTargetPlatform:",r),r}e.$$o=o}),define(le[222],he([0,1,17,2,19,10,11,25,6,3,16,5,37,33]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=e.$_8b=void 0;let d=class extends L.$Tc{constructor(m,h){super(),this.b=m,this.c=h,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,v])=>this.a.set(v.configPath,v))}getConfigBasedTips(m){return this.f(m)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(m){const h=[];for(const[v,i]of this.a)if(!(i.configScheme&&i.configScheme!==m.scheme))try{const o=(await this.b.readFile((0,A.$Gg)(m,v))).value.toString();for(const[s,n]of Object.entries(i.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(o))&&h.push({extensionId:s,extensionName:n.name,configName:i.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return h}};e.$_8b=d,e.$_8b=d=ye([X(0,I.$pk),X(1,C.$Ej)],d);const y="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class c extends d{constructor(m,h,v,i,o,s,n,t){super(n,t),this.r=m,this.s=h,this.t=v,this.u=i,this.w=o,this.z=s,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const E=[],b=[],u=[];Object.entries(a.recommendations).forEach(([p,R])=>{R.important?a.important?E.push({extensionId:p,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):b.push({extensionId:p,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):u.push({extensionId:p,extensionName:R.name,isExtensionPack:!!R.isExtensionPack})}),E.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),b.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),(0,k.$7g)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const m=await this.O(this.g),h=await this.O(this.h);return[...m,...h]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const m=await this.O(this.g),h=await this.O(this.h),v=await this.u.getInstalled();this.m=this.D(m,v),this.n=this.D(h,v)}D(m,h){const v=new Map;m.forEach(t=>v.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...v.keys()],h);for(const t of i){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const s=this.L(),n=new Map;for(const t of o){const r=v.get(t);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let a=n.get(r.exeName);a||(a=[],n.set(r.exeName,a)),a.push(r)}}return n}F(){if(this.m.size===0)return;const[m,h]=[...this.m.entries()][0];this.H(h).then(v=>{switch(v){case"reacted":this.M(h[0].exeName,h);break;case"ignored":this.m.delete(m);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new L.$Uc);i.value=(0,k.$7g)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const m=this.I(),h=Date.now()-m,v=7*24*60*60*1e3;if(h<v){const s=this.B(new L.$Uc);s.value=(0,k.$7g)(()=>{s.dispose(),this.G()},v-h);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(s=>{switch(s){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const n=this.B(new L.$Uc);n.value=(0,k.$7g)(()=>{n.dispose(),this.G()},v);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const n=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(n(()=>this.G()));break}case"toomany":{const n=this.B(new L.$Uc);n.value=(0,k.$7g)(()=>{n.dispose(),this.G()},60*60*1e3);break}}})}async H(m){const h=await this.u.getInstalled(1),v=m.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>h.every(s=>!(0,l.$Zo)(s.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:v,source:3,name:m[0].exeFriendlyName,searchValue:`@exe:"${m[0].exeName}"`})}I(){let m=this.w.getNumber(w,-1);return m||(m=Date.now(),this.J(m)),m}J(m){this.w.store(w,m,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(m,h){const v=this.L();v[m]=h.map(({extensionId:i})=>i.toLowerCase()),this.w.store(y,JSON.stringify(v),-1,0)}N(m,h){const v=[],i=[],o=h.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return m.forEach(s=>{o.has(s.toLowerCase())?v.push(s):i.push(s)}),{installed:v,uninstalled:i}}async O(m){const h=[],v=new Map;for(const i of m.keys()){const o=m.get(i);if(!o||!(0,O.$Lb)(o.recommendations))continue;const s=[];S.$i?o.windowsPath&&s.push(o.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(s.push((0,P.$jc)("/usr/local/bin",i)),s.push((0,P.$jc)("/usr/bin",i)),s.push((0,P.$jc)(this.r.fsPath,i)));for(const n of s){let t=v.get(n);if(t===void 0&&(t=await this.b.exists(j.URI.file(n)),v.set(n,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:E,whenNotInstalled:b}of o.recommendations)h.push({extensionId:r,extensionName:a,isExtensionPack:E,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:b})}}return h}}e.$a9b=c}),define(le[223],he([0,1,26,33]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rZb=void 0;async function A(j,I,C,k,g){try{const P=await j.getExtensionsControlManifest();if(!P.deprecated)return;const S=await j.getInstalled(1);for(const[$,l]of Object.entries(P.deprecated)){if(!l?.extension)continue;const{id:d,autoMigrate:y,preRelease:w}=l.extension;if(!y)continue;const c=S.find(m=>(0,L.$Zo)(m.identifier,{id:$}));if(!c)continue;const f=(await I.getExtensions([{id:d,preRelease:w}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!f){g.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{g.info(`Migrating '${c.identifier.id}' extension to '${d}' extension...`);const m=!k.getDisabledExtensions().some(v=>(0,L.$Zo)(v,c.identifier));await j.uninstall(c),g.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let h=S.find(v=>(0,L.$Zo)(v.identifier,{id:d}));(!h||!h.isPreReleaseVersion&&m)&&(h=await j.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${h.identifier.id}'`),m||(await k.disableExtension(h.identifier),g.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),y.storage&&(C.addToMigrationList((0,L.$3o)(c.manifest.publisher,c.manifest.name),(0,L.$3o)(h.manifest.publisher,h.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${c.identifier.id}' extension to '${d}' extension.`)}catch(m){g.error(m)}}}catch(P){g.error(P)}}e.$rZb=A}),define(le[224],he([0,1,6,7,2,23,19,55,12,32,31,70,20,15,29,33,99,11,8]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;let h=class extends A.$Tc{static{m=this}static{this.c=".sigzip"}constructor(i,o,s,n,t,r){super(),this.h=o,this.j=s,this.m=n,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,s){await this.g;const n=(0,I.$Gg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,r=>this.j.download(i,r,o))}catch(r){throw new d.$yo(r.message,d.ExtensionManagementErrorCode.Download)}let t=!1;if(s&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(a){const E=a;if(t=E.code,E.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${E.output}`),t===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(b){this.r.error(b)}throw new d.$yo(S.$Kp,d.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:n,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Nf)(o)?o:!0}async u(i){await this.g;const o=(0,I.$Gg)(this.extensionsDownloadDir,`${this.z(i)}${m.c}`);return await this.w(i,o,s=>this.j.downloadSignatureArchive(i,s)),o}async w(i,o,s){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await s(o);return}const n=(0,I.$Gg)(this.extensionsDownloadDir,`.${(0,g.$pg)()}`);await this.h.exists(n)||await s(n);try{await P.Promises.rename(n.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(n)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,L.$0)(t)}. Deleted the file from downloaded location`,n.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],s=[],n=[];for(const a of i.children)if(a.name.endsWith(m.c))n.push(a.resource);else{const E=y.$1o.parse(a.name);E&&s.push([E,a])}const t=(0,y.$6o)(s,([a])=>a),r=[];for(const a of t)a.sort((E,b)=>C.rcompare(E[0].version,b[0].version)),o.push(...a.slice(1).map(E=>E[1].resource)),r.push(a[0][1]);r.sort((a,E)=>a.mtime-E.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...n),await O.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?y.$1o.create(i).toString().toLowerCase():(0,g.$pg)()}};e.$4p=h,e.$4p=h=m=ye([X(0,l.$ai),X(1,c.$pk),X(2,d.$xo),X(3,$.$yi),X(4,w.$Ep),X(5,f.$mj)],h)}),define(le[225],he([0,1,3,2,35,33,45]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class C extends L.$Tc{constructor(g,P,S,$,l,d,y){super(),this.f=g,this.g=P,this.h=S,this.j=$,this.m=l,this.n=d,this.r=y,this.a=this.B(new O.$Ud),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$3c),this.s().then(null,w=>y.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(P=>(this.c.set(P.id,(0,L.$Qc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(g){for(const P of g.extensions)this.I(this.L(P.identifier,P.version),g.profileLocation)}async y(g){for(const P of g.extensions){const S=this.L(P.identifier,P.version);g.error?this.J(S,g.profileLocation):this.I(S,g.profileLocation)}}async z(g){for(const P of g.extensions)this.J(this.L(P.identifier,P.version),g.profileLocation)}async C(g){const P=[],S=[];for(const $ of g.extensions){const l=this.L($.identifier,$.version);g.error?this.I(l,g.profileLocation):(this.J(l,g.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),S.push(this.f.scanInstalledExtensionAtLocation($.location).then(d=>{d?P.push(d):this.r.info("Extension not found at the location",$.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(S),P.length&&await this.H(P)}catch($){this.r.error($)}}D(g){for(const P of this.h.profiles)g.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(g){const P=[],S=[],$=await this.j.scanProfileExtensions(g),l=new Set,d=new Set;for(const[y,w]of this.b)w.has(g)&&d.add(y);for(const y of $){const w=this.L(y.identifier,y.version);l.add(w),d.has(w)||(P.push(y.identifier),this.I(w,g))}for(const y of d)if(!l.has(y)){const w=this.M(y);w&&(S.push(w.identifier),this.J(y,g))}(P.length||S.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:g}:void 0,removed:S.length?{extensions:S,profileLocation:g}:void 0})}async G(g){const P=await this.j.scanProfileExtensions(g);for(const S of P)this.I(this.L(S.identifier,S.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,P){let S=this.b.get(g);S||this.b.set(g,S=new A.$Bc($=>this.m.extUri.getComparisonKey($))),S.add(P)}J(g,P){const S=this.b.get(g);S&&S.delete(P),S?.size||this.b.delete(g)}L(g,P){return`${I.$km.toKey(g.id)}@${P}`}M(g){const[P,S]=(0,j.$2o)(g);return S?{identifier:{id:P},version:S}:void 0}}e.$8p=C}),define(le[226],he([0,1,43,46]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function A(j,I,C,k,g,P,S){const $={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${I.nameShort})`};if((0,L.$Ro)(I,C)&&(0,L.$To)(k)===3){const l=await(0,O.$zp)(C,g,P);$["X-Market-User-Id"]=l,$["VSCode-SessionId"]=S.machineId||l}return $}e.$Ap=A}),define(le[227],he([0,1,73,17,6,2,23,16,31,15,29,33,8,75,10]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;let y=class extends l.$hr{constructor(m,h,v,i){super(v),this.h=m,this.j=i,this.g=this.B(new w(h,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(m,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const o=i.translations[m];return o?d.URI.file(o):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),h=Object.keys(m).map(v=>{const i=m[v];return{...this.f(v,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((v,i)=>v.label.localeCompare(i.label)),h}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const h=await this.g.getLanguagePacks();Object.keys(h).some(v=>h[v]&&h[v].extensions.some(i=>(0,S.$Zo)(i.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),v=await this.g.update(h);return!(0,L.$ub)(Object.keys(m),Object.keys(v))}};e.$ir=y,e.$ir=y=ye([X(0,P.$zo),X(1,g.$ai),X(2,P.$xo),X(3,$.$mj)],y);let w=class extends j.$Tc{constructor(m,h){super(),this.j=h,this.c={},this.f=(0,C.$jc)(m.userDataPath,"languagepacks.json"),this.g=new A.$_g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(h=>{Object.keys(h).forEach(v=>delete h[v]),this.m(h,...m)}).then(()=>this.c)}m(m,...h){for(const v of h)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.n(m,v);Object.keys(m).forEach(v=>this.r(m[v]))}n(m,h){const v=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const o of i)if(h.location.scheme===I.Schemas.file&&c(o)){let s=m[o.languageId];s||(s={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},m[o.languageId]=s);const n=s.extensions.filter(t=>(0,S.$Zo)(t.extensionIdentifier,v))[0];n?n.version=h.manifest.version:s.extensions.push({extensionIdentifier:v,version:h.manifest.version});for(const t of o.translations)s.translations[t.id]=(0,C.$jc)(h.location.fsPath,t.path)}}r(m){if(m){const h=(0,O.createHash)("md5");for(const v of m.extensions)h.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);m.hash=h.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let h=null;return k.Promises.readFile(this.f,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(h=m(v),v)).then(v=>{for(const o of Object.keys(v))v[o]||delete v[o];this.c=v,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),k.Promises.writeFile(this.f,i)}).then(()=>h,v=>this.j.error(v))})}};w=ye([X(0,g.$ai),X(1,$.$mj)],w);function c(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const m of f.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(le[228],he([0,1,141,7,30,46]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function k(P,S,$){const l=await(0,O.$eD)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,O.$eD)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new l.AppInsightsCore,w=new d.PostChannel,c={instrumentationKey:P,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if($){c.extensionConfig={};const f={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:$};c.extensionConfig[w.identifier]=f}return y.initialize(c,[]),y.addTelemetryInitializer(f=>{f.ext=f.ext??{},f.ext.web=f.ext.web??{},f.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',S&&(f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),y}class g{constructor(S,$,l,d,y){this.e=S,this.f=$,this.g=l,this.h=y,this.c=I,this.d=C,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then($=>{S($)},$=>{(0,L.$1)($),console.error($)})}}log(S,$){if(!this.a)return;$=(0,A.$xn)($,this.g),$=(0,j.$Uo)($);const l=this.f+"/"+S;try{this.i(d=>{d.pluginVersionString=$?.properties.version??"Unknown",d.track({name:l,baseData:{name:l,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$fO=g}),define(le[109],he([0,1,2,166,15,8,25,46]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=void 0;let k=class extends O.$Tc{constructor(P,S,$,l,d=""){super(),this.b=d;const y=S.getLogger(C.$No);if(y)this.a=this.B(y);else{const c=(0,C.$So)(l,$)?" (Not Sent)":"",f=()=>(0,C.$Ro)(l,$)&&P.getLevel()===j.LogLevel.Trace;this.a=this.B(S.createLogger(C.$No,{name:(0,L.localize)(0,null,c),hidden:!f()})),this.B(P.onDidChangeLogLevel(()=>S.setVisibility(C.$No,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,C.$Uo)(S))}};e.$z8b=k,e.$z8b=k=ye([X(0,j.$mj),X(1,j.$nj),X(2,A.$_h),X(3,I.$Ej)],k)}),define(le[110],he([0,1,2,30,5,27,167,20,44,102,25,41,22,46]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,f,m){this.k=f,this.l=m,this.d={},this.i=new O.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,j.$Ne)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Ne)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration($.$Bl)||h.affectsConfiguration($.$Dl)||h.affectsConfiguration($.$Cl))&&this.m()}))}setExperimentProperty(c,f){this.d[c]=f}m(){let c=(0,l.$To)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const m=f.usage?3:f.error?2:0;c=Math.min(c,m)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,f,m){this.g<f||(m=(0,L.$xn)(m,this.d),m=(0,l.$Yo)(m,this.j),m=(0,L.$xn)(m,this.c),this.b.forEach(h=>h.log(c,m)))}publicLog(c,f){this.n(c,3,f)}publicLog2(c,f){this.publicLog(c,f)}publicLogError(c,f){this.h&&this.n(c,2,f)}publicLogError2(c,f){this.publicLogError(c,f)}};e.$or=d,e.$or=d=ye([X(1,C.$yi),X(2,P.$Ej)],d);function y(){const w=(0,I.localize)(0,null,g.default.nameLong),c=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=A.$o?"":(0,I.localize)(3,null),m=(0,I.localize)(4,null),h=(0,I.localize)(5,null),v=(0,I.localize)(6,null),i=(0,I.localize)(7,null),o=`
|       | ${m} | ${h} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,I.localize)(8,null);return`
${w} ${c} ${f}

&nbsp;

${i}
${o}

&nbsp;

${s}
`}S.$Gn.as(k.$Ln.Configuration).registerConfiguration({id:$.$Al,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[$.$Bl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$Gn.as(k.$Ln.Configuration).registerConfiguration({id:$.$Al,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[$.$Dl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${$.$Bl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[229],he([0,1,14,26,271,228]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=void 0;async function I(P,S){const $=await S.request(P,L.CancellationToken.None),l=(await(0,O.$ue)($.stream)).toString(),d=$.res.statusCode??200;return{headers:$.res.headers,statusCode:d,responseData:l}}async function C(P){const S={method:P.type,headers:P.headers};return new Promise((l,d)=>{const y=A.request(P.url??"",S,w=>{w.on("data",function(c){l({headers:w.headers,statusCode:w.statusCode??200,responseData:c.toString()})}),w.on("error",function(c){d(c)})});y.write(P.data,w=>{w&&d(w)}),y.end()})}async function k(P,S,$){const l=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),d={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:l};try{const y=P?await I(d,P):await C(d);$(y.statusCode,y.headers,y.responseData)}catch{$(0,{})}}class g extends j.$fO{constructor(S,$,l,d,y){const w={sendPOST:(c,f)=>{k(S,c,f)}};super($,l,d,y,w)}}e.$gO=g}),define(le[230],he([0,1,23,93,20,15,8,25,22,108,109,110]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=void 0;let $=class{constructor(d,y,w,c,f,m){this.b=d,this.c=y,this.d=w,this.e=c,this.f=f,this.g=m,this.a=new Map}h(d){if(!this.a.has(d.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const w=[d.id,JSON.stringify(y),d.aiKey],f=new L.$qq(O.$ng.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),m=[new g.$d$b(f),new P.$z8b(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new S.$or({appenders:m,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,y,w){this.h(d).publicLog(y,w)}publicLogError(d,y,w){this.h(d).publicLogError(y,w)}};e.$v_b=$,e.$v_b=$=ye([X(0,A.$yi),X(1,k.$tl),X(2,I.$mj),X(3,I.$nj),X(4,j.$_h),X(5,C.$Ej)],$)}),define(le[79],he([0,1,3,20,4,8]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.ProvidedOnAutoForward=e.$Bv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Av=e.$zv=void 0,e.$zv=(0,A.$5h)("tunnelService"),e.$Av=(0,A.$5h)("sharedTunnelsService");var I;(function(w){w.Http="http",w.Https="https"})(I||(e.TunnelProtocol=I={}));var C;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(C||(e.TunnelPrivacyId=C={}));function k(w){return!!w.forwardPort}e.$Bv=k;var g;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(c)return{address:c[1],port:+c[2]}}e.$Cv=P,e.$Dv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(w){return e.$Dv.indexOf(w)>=0}e.$Ev=S,e.$Fv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(w){return e.$Fv.indexOf(w)>=0}e.$Gv=$;function l(w,c,f,m){if(f===1)return!1;if(f===2&&$(c)){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(h?.length===4&&parseInt(h[1])>=18)return!1}return w<1024}e.$Hv=l;class d{constructor(c,f,m){this.remoteAddress=c,this.localAddress=f,this.b=m,this.a=new O.$Ud,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Iv=d;let y=class{constructor(c,f){this.k=c,this.l=f,this.a=new O.$Ud,this.onTunnelOpened=this.a.event,this.b=new O.$Ud,this.onTunnelClosed=this.b.event,this.c=new O.$Ud,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const c=this.l.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.i=c.privacyOptions,this.h=c.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const c=[],f=Array.from(this.e.values());for(const m of f){const h=Array.from(m.values());for(const v of h){const i=await v.value;i&&typeof i!="string"&&c.push(i)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:f}of c.values())await f.then(m=>typeof m!="string"?m?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,f,m,h,v){this.q(c,f,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:f,localAddress:m,privacy:h,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,f){($(c)||S(c))&&(c=e.$Dv[0]);const m=this.s(c,f);if(m)return++m.refcount,m.value}openTunnel(c,f,m,h,v,i=!1,o,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${m} on local port ${v}.`);const n=this.f??c;if(!n)return;if(f||(f="localhost"),h||(h=this.m),this.f&&this.j.has(m)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.t(n,f,m,h,v,i,o,s);return t?t.then(r=>{if(r){if(typeof r=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,m),r}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,m);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.o(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==m)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}o(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const f=this.e.get(c.tunnelRemoteHost);if(f){const m=f.get(c.tunnelRemotePort);m&&(m.refcount--,await this.p(c.tunnelRemoteHost,c.tunnelRemotePort,m))}}}}async p(c,f,m){if(m.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${f}.`);const h=m.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(f),h}}async closeTunnel(c,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${f} `);const m=this.e.get(c);if(m&&m.has(f)){const h=m.get(f);h.refcount=0,await this.p(c,f,h)}}q(c,f,m){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(f,{refcount:1,value:m})}async r(c,f){const m=this.e.get(c);if(m){const h=m.get(f),v=h?await h.value:void 0;(!v||typeof v=="string")&&m.delete(f),m.size===0&&this.e.delete(c)}}s(c,f){const m=[c];S(c)?(m.push(...e.$Dv),m.push(...e.$Fv)):$(c)&&m.push(...e.$Fv);const h=m.map(v=>this.e.get(v));for(const v of h){const i=v?.get(f);if(i)return i}}canTunnel(c){return!!P(c)}u(c,f,m,h,v,i,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${m} on local port ${h}.`);const s=m;this.j.add(s);const n=h===void 0?m:h,t={elevationRequired:v?this.isPortPrivileged(n):!1},r={remoteAddress:{host:f,port:m},localAddressPort:h,privacy:i,public:i?i!==C.Private:void 0,protocol:o},a=c.forwardPort(r,t);return a?(this.q(f,m,a),a.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),a}};e.$Jv=y,e.$Jv=y=ye([X(0,j.$mj),X(1,L.$yi)],y)}),define(le[231],he([0,1,8,79,2,7,6]),function(ne,e,O,L,A,j,I){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;class k extends A.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$ph),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let g=class extends A.$Tc{static{C=this}static{this.a=0}constructor(S,$){super(),this.f=S,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++C.a)}}async startTunnel(S,$,l,d,y,w,c){const f=new k,m=await Promise.resolve(this.f.openTunnel(S,f,l,d,y,w,c));if(!m||typeof m=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${d} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),f.dispose(),await m.dispose(),(0,j.$6)();return f.setTunnel(m),this.b.set($,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${m.localAddress} (local) to ${l}:${d} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(S,$){const l=this.b.get(S);l&&l.setAddress($)}async destroyTunnel(S){const $=this.b.get(S);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await $.dispose();return}this.c.add(S)}};e.$I_b=g,e.$I_b=g=C=ye([X(0,L.$Av),X(1,O.$mj)],g)}),define(le[28],he([0,1,4]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=void 0,e.$Zk=(0,O.$5h)("IUriIdentityService")}),define(le[232],he([0,1,28,185,11,19,127,3,2]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0;class g{static{this._clock=0}constructor($){this.uri=$,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let P=class{constructor($){this.g=$,this.c=new k.$Sc,this.f=2**16;const l=new Map,d=y=>{let w=l.get(y.scheme);return w===void 0&&(w=$.hasProvider(y)&&!this.g.hasCapability(y,1024),l.set(y.scheme,w)),w};this.c.add(C.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(y=>{l.delete(y.scheme)})),this.extUri=new j.$vg(d),this.d=new I.$Zr((y,w)=>this.extUri.compare(y,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,j.$Hg)($));const l=this.d.get($);return l?l.touch().uri.with({fragment:$.fragment}):(this.d.set($,new g($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((d,y)=>d[1].time<y[1].time?1:d[1].time>y[1].time?-1:0);g._clock=0,this.d.clear();const l=this.f*.5;for(let d=0;d<l;d++)this.d.set($[d][0],$[d][1].touch())}};e.$1r=P,e.$1r=P=ye([X(0,A.$pk)],P),(0,L.$Xr)(O.$Zk,P,1)}),define(le[233],he([0,1,3,2,11,48,35]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0;class C extends L.$Tc{constructor(g,P,S,$,l,d){super(),this.f=g,this.g=P,this.h=S,this.j=$,this.m=l,this.n=d,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$Ud),this.onDidChangeFile=this.a.event,this.b=j.$$h.forUris(()=>!(this.capabilities&1024)),this.c=new I.$Bc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,P){return this.g.open(this.t(g),P)}close(g){return this.g.close(g)}read(g,P,S,$,l){return this.g.read(g,P,S,$,l)}write(g,P,S,$,l){return this.g.write(g,P,S,$,l)}watch(g,P){this.b.set(g,g);const S=this.g.watch(this.t(g),P);return(0,L.$Rc)(()=>{this.b.delete(g),S.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,P,S){return this.g.rename(this.t(g),this.t(P),S)}readFile(g,P){return this.g.readFile(this.t(g),P)}readFileStream(g,P,S){return this.g.readFileStream(this.t(g),P,S)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,P,S){return this.g.writeFile(this.t(g),P,S)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,P){return this.g.delete(this.t(g),P)}copy(g,P,S){if((0,A.$tk)(this.g))return this.g.copy(this.t(g),this.t(P),S);throw new Error("copy not supported")}cloneFile(g,P){if((0,A.$uk)(this.g))return this.g.cloneFile(this.t(g),this.t(P));throw new Error("clone not supported")}s(g){const P=[];for(const S of g){if(S.resource.scheme!==this.f)continue;const $=this.u(S.resource);this.b.findSubstr($)&&P.push({resource:$,type:S.type,cId:S.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$3$b=C}),define(le[80],he([0,1,62]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Eb=e.$5Eb=e.edit=void 0;function L(I,C,k,g){const P=(0,O.$qn)(I,C,k,g)[0];return P&&(I=I.substring(0,P.offset)+P.content+I.substring(P.offset+P.length)),I}e.edit=L;function A(I,C,k){let g=k;for(;g>=0;){if(I.charAt(g)===C.charAt(C.length-1)&&C.length===1)return g+1;if(g--,C.length===2&&g>=0&&I.charAt(g)===C.charAt(0))return g+2}return 0}e.$5Eb=A;function j(I,C,k){let g=k;for(;g>=0;)if(I.charAt(g)===C.charAt(C.length-1)&&C.length===1||(g++,C.length===2&&g>=0&&I.charAt(g)===C.charAt(1)))return g;return I.length-1}e.$6Eb=j}),define(le[234],he([0,1,30,55,12]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;function j(l,d,y,w,c,f){const m=[],h=[],v=[];if(!d){const q=l.filter(({identifier:Y})=>c.every(K=>K.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:m,removed:h,updated:v},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}l=l.map(S),d=d.map(S),y=y?y.map(S):null;const i=new Map,o=q=>{q.uuid&&i.set(q.id.toLowerCase(),q.uuid)};l.forEach(({identifier:q})=>o(q)),d.forEach(({identifier:q})=>o(q)),y?.forEach(({identifier:q})=>o(q)),w?.forEach(({identifier:q})=>o(q)),f?.forEach(q=>o(q));const s=q=>{const Y=q.identifier.uuid||i.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},n=(q,Y)=>(q.set(s(Y),Y),q),t=l.reduce(n,new Map),r=d.reduce(n,new Map),a=d.reduce((q,Y)=>n(q,(0,O.$un)(Y)),new Map),E=y?y.reduce(n,new Map):null,b=w.reduce(n,new Map),u=c.reduce((q,Y)=>{const K=i.get(Y.toLowerCase());return q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)},new Set),p=f?f.reduce((q,{id:Y,uuid:K})=>(K=K??i.get(Y.toLowerCase()),q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)),new Set):null,R=I(t,r,u,!1);if(R.added.size>0||R.removed.size>0||R.updated.size>0){const q=I(E,t,u,!1),Y=I(E,r,u,!0),K=(x,V,Q,W)=>{let G,te,re;return V.installed?(G=W.pinned,re=W.preRelease,G&&(te=W.version)):(G=Q.pinned,re=Q.preRelease,G&&(te=Q.version)),G===void 0&&(G=V.pinned,G&&(te=V.version)),re===void 0&&(re=V.preRelease),{...W,installed:V.installed||Q.installed,pinned:G,preRelease:re,version:te??(Q.version&&(!V.installed||L.gt(Q.version,V.version))?Q.version:V.version),state:k(V,Q,E?.get(x))}};for(const x of Y.removed.values()){const V=t.get(x);if(!V)continue;const Q=(0,A.$Sf)(E?.get(x)),W=p&&!p.has(x)&&Q.installed;V.installed&&W?h.push(V.identifier):a.set(x,V)}for(const x of Y.added.values()){const V=(0,A.$Sf)(r.get(x)),Q=t.get(x);if(Q){if(R.updated.has(x)){const W=K(x,Q,V,V);C(Q,V,!1,!1)||v.push($(W,x)),a.set(x,W)}}else V.installed&&m.push($(V,x))}for(const x of Y.updated.values()){const V=(0,A.$Sf)(r.get(x)),Q=(0,A.$Sf)(E?.get(x)),W=t.get(x);if(W)if(p&&!p.has(x)&&Q.installed&&W.installed&&!V.installed)h.push(W.identifier);else{const te=K(x,W,V,V);v.push($(te,x)),a.set(x,te)}else V.installed&&m.push($(V,x))}for(const x of q.added.values())Y.added.has(x)||a.set(x,(0,A.$Sf)(t.get(x)));for(const x of q.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const V=(0,A.$Sf)(t.get(x)),Q=(0,A.$Sf)(r.get(x));a.set(x,K(x,V,Q,V))}for(const x of q.removed.values())Y.updated.has(x)||Y.removed.has(x)||b.has(x)||(0,A.$Sf)(r.get(x)).installed&&p&&(p.has(x)||!(0,A.$Sf)(E?.get(x)).installed||a.delete(x))}const N=[],F=I(r,a,new Set,!0),M=F.added.size>0||F.updated.size>0||F.removed.size>0;return M&&a.forEach((q,Y)=>N.push($(q,Y))),{local:{added:m,removed:h,updated:v},remote:M?{added:[...F.added].map(q=>a.get(q)),updated:[...F.updated].map(q=>a.get(q)),removed:[...F.removed].map(q=>r.get(q)),all:N}:null}}e.$f7b=j;function I(l,d,y,w){const c=l?[...l.keys()].filter(i=>!y.has(i)):[],f=[...d.keys()].filter(i=>!y.has(i)),m=f.filter(i=>!c.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),h=c.filter(i=>!f.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),v=new Set;for(const i of c){if(h.has(i))continue;const o=l.get(i),s=d.get(i);(!s||!C(o,s,w,!0))&&v.add(i)}return{added:m,removed:h,updated:v}}function C(l,d,y,w){return!(l.disabled!==d.disabled||!!l.isApplicationScoped!=!!d.isApplicationScoped||w&&l.installed!==d.installed||l.installed&&d.installed&&(l.preRelease!==d.preRelease||l.pinned!==d.pinned||d.pinned&&l.version!==d.version)||!P(l.state,d.state)||y&&l.version!==d.version)}function k(l,d,y){const w=l.state,c=d.state,f=y?.state;if(!d.version||w&&L.gt(l.version,d.version))return w;if(c&&L.gt(d.version,l.version)||!w)return c;if(!c)return w;const m=(0,O.$un)(w),h=f?g(f,c):{added:Object.keys(c).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},v=f?g(f,w):{added:Object.keys(w).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...h.added.values(),...h.updated.values()])m[i]=c[i];for(const i of h.removed.values())v.updated.has(i)||delete m[i];return m}function g(l,d){const y=Object.keys(l),w=Object.keys(d),c=w.filter(h=>!y.includes(h)).reduce((h,v)=>(h.add(v),h),new Set),f=y.filter(h=>!w.includes(h)).reduce((h,v)=>(h.add(v),h),new Set),m=new Set;for(const h of y){if(f.has(h))continue;const v=l[h],i=d[h];(0,O.$yn)(v,i)||m.add(h)}return{added:c,removed:f,updated:m}}function P(l={},d={}){const{added:y,removed:w,updated:c}=g(l,d);return y.size===0&&w.size===0&&c.size===0}function S(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function $(l,d){const y={...l,identifier:{id:l.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete y.disabled,l.installed||delete y.installed,l.state||delete y.state,l.isApplicationScoped||delete y.isApplicationScoped,y}}),define(le[111],he([0,1,17,20,4]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Gb=e.$9Gb=void 0,e.$9Gb=(0,A.$5h)("IIgnoredExtensionsManagementService");let j=class{constructor(C){this.a=C}hasToNeverSyncExtension(C){return this.b().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.b().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return g=g.filter(P=>P!==C&&P!==`-${C}`),k&&g.push(C.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(C,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return g=g.filter(P=>P!==C&&P!==`-${C}`),k&&g.push(`-${C.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(C){const k=C.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),g=this.b().map($=>$.toLowerCase()),P=[],S=[];if(Array.isArray(g))for(const $ of g)$.startsWith("-")?S.push($.substring(1)):P.push($);return(0,O.$Mb)([...k,...P].filter($=>!S.includes($)))}b(){let C=this.a.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.a.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$0Gb=j,e.$0Gb=j=ye([X(0,L.$yi)],j)}),define(le[235],he([0,1,17,34,30,94,80]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=void 0;function C(h){return(0,L.$bn)(h)||[]}async function k(h,v,i,o,s){const n=C(h),t=C(v),r=i?C(i):null,a=[...n,...t,...r||[]].map(K=>K.key),E=await s.resolveUserBindings(a),b=P(n,t,r,E);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:h,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};const u=$(n),p=$(t),R=r?$(r):null,N=d(u,p,E),F=R?d(R,u,E):{added:[...u.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},M=R?d(R,p,E):{added:[...p.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},q=g(N,F,M);let Y=h;for(const K of q.removed.values())q.conflicts.has(K)||(Y=f(Y,K,o));for(const K of q.added.values()){if(q.conflicts.has(K))continue;const x=p.get(K);if(x.some(V=>V.command!==`-${K}`&&b.conflicts.has(E[V.key]))){q.conflicts.add(K);continue}Y=c(Y,x,o)}for(const K of q.updated.values()){if(q.conflicts.has(K))continue;const x=p.get(K);if(x.some(V=>V.command!==`-${K}`&&b.conflicts.has(E[V.key]))){q.conflicts.add(K);continue}Y=m(Y,K,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$l7b=k;function g(h,v,i){const o=new Set,s=new Set,n=new Set,t=new Set;for(const r of v.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(v.updated.has(r)?t.add(r):s.add(r));for(const r of v.added.values())t.has(r)||i.added.has(r)&&h.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(v.added.has(r)?h.updated.has(r)&&t.add(r):o.add(r));for(const r of v.updated.values())t.has(r)||i.updated.has(r)&&h.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(v.updated.has(r)?h.updated.has(r)&&t.add(r):n.add(r));return{added:o,removed:s,updated:n,conflicts:t}}function P(h,v,i,o){const s=new Set,n=S(h,o),t=S(v,o),r=i?S(i,o):null,a=l(n,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const E=r?l(r,n):{added:[...n.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const b=r?l(r,t):{added:[...t.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:u,removed:p,updated:R,conflicts:N}=g(a,E,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:p,updated:R,conflicts:N}}function S(h,v){const i=new Map;for(const o of h){const s=v[o.key];let n=i.get(s);n||(n=[],i.set(s,n)),n.push(o)}return i}function $(h){const v=new Map;for(const i of h){const o=i.command[0]==="-"?i.command.substring(1):i.command;let s=v.get(o);s||(s=[],v.set(o,s)),s.push(i)}return v}function l(h,v){const i=[...h.keys()],o=[...v.keys()],s=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),n=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(n.has(r))continue;const a=h.get(r).map(b=>({...b,key:r})),E=v.get(r).map(b=>({...b,key:r}));(0,O.$ub)(a,E,(b,u)=>w(b,u))||t.add(r)}return{added:s,removed:n,updated:t}}function d(h,v,i){const o=[...h.keys()],s=[...v.keys()],n=s.filter(a=>!o.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),t=o.filter(a=>!s.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const E=h.get(a).map(u=>({...u,key:i[u.key]})),b=v.get(a).map(u=>({...u,key:i[u.key]}));y(E,b)||r.add(a)}return{added:n,removed:t,updated:r}}function y(h,v){return!(!(0,O.$ub)(h.filter(({command:i})=>i[0]!=="-"),v.filter(({command:i})=>i[0]!=="-"),(i,o)=>w(i,o))||!(0,O.$ub)(h.filter(({command:i})=>i[0]==="-"),v.filter(({command:i})=>i[0]==="-"),(i,o)=>w(i,o)))}function w(h,v){if(h.command!==v.command||h.key!==v.key)return!1;const i=j.$3i.deserialize(h.when),o=j.$3i.deserialize(v.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!A.$yn(h.args,v.args))}function c(h,v,i){for(const o of v)h=I.edit(h,[-1],o,i);return h}function f(h,v,i){const o=C(h);for(let s=o.length-1;s>=0;s--)(o[s].command===v||o[s].command===`-${v}`)&&(h=I.edit(h,[s],void 0,i));return h}function m(h,v,i,o){const s=C(h),n=s.findIndex(t=>t.command===v||t.command===`-${v}`);for(let t=s.length-1;t>=0;t--)(s[t].command===v||s[t].command===`-${v}`)&&(h=I.edit(h,[t],void 0,o));for(let t=i.length-1;t>=0;t--)h=I.edit(h,[n],i[t],o);return h}}),define(le[236],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=e.$s7b=void 0;function O(j,I,C){const k={},g={},P=new Set;if(!I)return{local:{added:k,updated:g,removed:[...P.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const S=L(j,I);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:g,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=L(C,j),l=L(C,I),d={},y={},w=new Set,c=new Set;for(const f of $.removed.values())l.updated.has(f)?k[f]=I[f]:w.add(f);for(const f of l.removed.values())c.has(f)||($.updated.has(f)?c.add(f):P.add(f));for(const f of $.updated.values())c.has(f)||(l.updated.has(f)?S.updated.has(f)&&c.add(f):y[f]=j[f]);for(const f of l.updated.values())c.has(f)||($.updated.has(f)?S.updated.has(f)&&c.add(f):j[f]!==void 0&&(g[f]=I[f]));for(const f of $.added.values())c.has(f)||(l.added.has(f)?S.updated.has(f)&&c.add(f):d[f]=j[f]);for(const f of l.added.values())c.has(f)||($.added.has(f)?S.updated.has(f)&&c.add(f):k[f]=I[f]);return{local:{added:k,removed:[...P.values()],updated:g},remote:{added:d,removed:[...w.values()],updated:y},conflicts:[...c.values()]}}e.$s7b=O;function L(j,I){const C=j?Object.keys(j):[],k=I?Object.keys(I):[],g=k.filter($=>!C.includes($)).reduce(($,l)=>($.add(l),$),new Set),P=C.filter($=>!k.includes($)).reduce(($,l)=>($.add(l),$),new Set),S=new Set;for(const $ of C){if(P.has($))continue;const l=j[$],d=I[$];l!==d&&S.add($)}return{added:g,removed:P,updated:S}}function A(j,I){const{added:C,removed:k,updated:g}=L(j,I);return C.size===0&&k.size===0&&g.size===0}e.$t7b=A}),define(le[237],he([0,1,30]),function(ne,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d9b=void 0;function L(j,I,C,k){const g={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!I){const $=j.filter(({id:l})=>!k.includes(l));return $.length?P.added=$:P=null,{local:g,remote:P}}const S=A(j,I,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const $=A(C,j,k),l=A(C,I,k);for(const d of l.removed){const y=j.find(w=>w.id===d);y&&g.removed.push(y)}for(const d of l.added){const y=I.find(w=>w.id===d);$.added.includes(d)?S.updated.includes(d)&&g.updated.push(y):g.added.push(y)}for(const d of l.updated)g.updated.push(I.find(y=>y.id===d));for(const d of $.added)l.added.includes(d)||P.added.push(j.find(y=>y.id===d));for(const d of $.updated)l.removed.includes(d)||l.updated.includes(d)||P.updated.push(j.find(y=>y.id===d));for(const d of $.removed){const y=I.find(w=>w.id===d);y&&P.removed.push(y)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:g,remote:P}}e.$d9b=L;function A(j,I,C){j=j?j.filter(({id:l})=>!C.includes(l)):[],I=I.filter(({id:l})=>!C.includes(l));const k=j.map(({id:l})=>l),g=I.map(({id:l})=>l),P=g.filter(l=>!k.includes(l)),S=k.filter(l=>!g.includes(l)),$=[];for(const{id:l,name:d,shortName:y,icon:w,useDefaultFlags:c}of j){if(S.includes(l))continue;const f=I.find(m=>m.id===l);(!f||f.name!==d||f.shortName!==y||f.icon!==w||!(0,O.$yn)(f.useDefaultFlags,c))&&$.push(l)}return{added:P,removed:S,updated:$}}}),define(le[24],he([0,1,17,12,173,44,29,4,103,41]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inb=e.$hnb=e.$gnb=e.$fnb=e.$enb=e.$dnb=e.$cnb=e.$bnb=e.$anb=e.$_mb=e.$$mb=e.MergeState=e.Change=e.SyncStatus=e.$0mb=e.$9mb=e.$8mb=e.UserDataSyncErrorCode=e.$7mb=e.$6mb=e.$5mb=e.$4mb=e.$3mb=e.$2mb=e.$1mb=e.$Zmb=e.$Ymb=e.SyncResource=e.$Xmb=e.$Wmb=e.$Vmb=e.$Umb=e.$Tmb=e.$Smb=void 0;function P(){const t=g.$Gn.as(j.$Ln.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Smb=P;function S(){const t=g.$Gn.as(j.$Ln.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(b=>!!t[b].ignoreSync),a=Object.keys(t).filter(b=>t[b].scope===2||t[b].scope===6),E=P();return(0,O.$Mb)([...r,...a,...E])}e.$Tmb=S,e.$Umb="settingsSync",e.$Vmb="settingsSync.keybindingsPerPlatform";function $(){const t="vscode://schemas/ignoredSettings",r=g.$Gn.as(j.$Ln.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$Vmb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:I.$lo,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Gn.as(k.$Hn.JSONContribution),E=()=>{const b=P(),u=S(),p=Object.keys(j.$Mn.properties).filter(F=>!u.includes(F)),R=u.filter(F=>!b.includes(F)),N={items:{type:"string",enum:[...p,...R.map(F=>`-${F}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>E())}e.$Wmb=$;function l(t){return t&&(0,L.$Jf)(t)&&(0,L.$Hf)(t.id)&&Array.isArray(t.scopes)}e.$Xmb=l;var d;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.$Ymb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$Zmb=y;function w(t,r,a,E){return E.joinPath(a.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$1mb=w,e.$2mb=(0,C.$5h)("IUserDataSyncStoreManagementService"),e.$3mb=(0,C.$5h)("IUserDataSyncStoreService"),e.$4mb=(0,C.$5h)("IUserDataSyncLocalStoreService"),e.$5mb="x-operation-id",e.$6mb="X-Execution-Id";function c(t){const r={};return r[e.$6mb]=t,r}e.$7mb=c;var f;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class m extends Error{constructor(r,a,E,b){super(r),this.code=a,this.resource=E,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$8mb=m;class h extends m{constructor(r,a,E,b,u){super(r,E,void 0,u),this.url=a,this.serverCode=b}}e.$9mb=h;class v extends m{constructor(r,a){super(r,a)}}e.$0mb=v,function(t){function r(a){if(a instanceof t)return a;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(E&&E[1]){const b=E[2]==="unknown"?void 0:E[2],u=E[3]==="unknown"?void 0:E[3];return new t(a.message,E[1],b,u)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(m||(e.$8mb=m={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var s;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(s||(e.MergeState=s={})),e.$$mb="sync.store.url.type";function n(t){return`sync.enable.${t}`}e.$_mb=n,e.$anb=(0,C.$5h)("IUserDataSyncEnablementService"),e.$bnb=(0,C.$5h)("IUserDataSyncService"),e.$cnb=(0,C.$5h)("IUserDataSyncResourceProviderService"),e.$dnb=(0,C.$5h)("IUserDataAutoSyncService"),e.$enb=(0,C.$5h)("IUserDataSyncUtilService"),e.$fnb=(0,C.$5h)("IUserDataSyncLogService"),e.$gnb="userDataSync",e.$hnb="vscode-userdata-sync",e.$inb="preview"}),define(le[238],he([0,1,30,24]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sGb=void 0;function A(I,C,k,g,P){if(!C)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const S=j(I,C);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=k?j(k,C):{added:Object.keys(C).reduce((f,m)=>(f.add(m),f),new Set),removed:new Set,updated:new Set},l=k?j(k,I):{added:Object.keys(I).reduce((f,m)=>(f.add(m),f),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},y=O.$un(C),w=!k;for(const f of l.added.values())f!==L.$$mb&&w&&$.added.has(f)||(y[f]=I[f]);for(const f of l.updated.values())y[f]=I[f];for(const f of l.removed.values())g.unregistered.includes(f)||delete y[f];for(const f of $.added.values()){const m=C[f];if(g.machine.includes(f)){P.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(k&&l.added.has(f))continue;const h=I[f];h&&h.value===m.value||f===L.$$mb&&w&&l.added.has(f)||(h?d.updated[f]=m:d.added[f]=m)}for(const f of $.updated.values()){const m=C[f];if(g.machine.includes(f)){P.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(f)||l.removed.has(f))continue;const h=I[f];h&&h.value===m.value||(d.updated[f]=m)}for(const f of $.removed.values()){if(g.machine.includes(f)){P.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}l.updated.has(f)||l.removed.has(f)||d.removed.push(f)}const c=j(C,y);return{local:d,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:y}}}e.$sGb=A;function j(I,C){const k=Object.keys(I),g=Object.keys(C),P=g.filter(l=>!k.includes(l)).reduce((l,d)=>(l.add(d),l),new Set),S=k.filter(l=>!g.includes(l)).reduce((l,d)=>(l.add(d),l),new Set),$=new Set;for(const l of k){if(S.has(l))continue;const d=I[l],y=C[l];O.$yn(d,y)||$.add(l)}return{added:P,removed:S,updated:$}}}),define(le[239],he([0,1,17,34,62,42,30,80,24]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Eb=e.$$Eb=e.$0Eb=e.$9Eb=e.$8Eb=e.$7Eb=void 0;function g(a,E,b){let u=[];b?u=S(b):u=P(E);const p=[],R=[...(0,k.$Smb)()];if(Array.isArray(u))for(const N of u)N.startsWith("-")?R.push(N.substring(1)):p.push(N);return(0,O.$Mb)([...a,...p].filter(N=>!R.includes(N)))}e.$7Eb=g;function P(a){let E=a.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=a.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const E=(0,L.$bn)(a);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function $(a,E){const b=(0,L.$bn)(a)||{};let u="{}";for(const p of Object.keys(b)){const R=(0,A.$qn)(u,[p],b[p],E);u=(0,A.$tn)(u,R)}return u}e.$8Eb=$;function l(a,E,b,u){if(b.length){const p=r(E),R=(0,L.$bn)(E)||{},N=(0,L.$bn)(a);if(!N)return a;const F=[];for(const M of b){const q=R[M],Y=N[M];q===void 0?a=C.edit(a,[M],void 0,u):Y!==void 0?a=C.edit(a,[M],q,u):F.push(i(M,p))}F.sort((M,q)=>M.startOffset-q.startOffset),F.forEach(M=>a=f(M.setting.key,E,a,u))}return a}e.$9Eb=l;function d(a,E,b,u,p,R){const N=l(a,E,u,R),F=b!==N,M=b!==E;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:l(E,a,u,R),remoteContent:null,hasConflicts:!1};if(b===null&&w(a)){const T=y(a,E,u)?null:l(E,a,u,R);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let q=a,Y=E;const K=(0,L.$bn)(a),x=(0,L.$bn)(E),V=b?(0,L.$bn)(b):null,Q=u.reduce((T,B)=>(T.add(B),T),new Set),W=c(K,x,Q),G=c(V,K,Q),te=c(V,x,Q),re=new Map,ee=new Set,ae=T=>{ee.add(T);const B=p.filter(({key:U})=>U===T)[0];B?(q=C.edit(q,[T],B.value,R),Y=C.edit(Y,[T],B.value,R)):re.set(T,{key:T,localValue:K[T],remoteValue:x[T]})};for(const T of G.removed.values())te.updated.has(T)?ae(T):Y=C.edit(Y,[T],void 0,R);for(const T of te.removed.values())ee.has(T)||(G.updated.has(T)?ae(T):q=C.edit(q,[T],void 0,R));for(const T of G.updated.values())ee.has(T)||(te.updated.has(T)?W.updated.has(T)&&ae(T):Y=C.edit(Y,[T],K[T],R));for(const T of te.updated.values())ee.has(T)||(G.updated.has(T)?W.updated.has(T)&&ae(T):q=C.edit(q,[T],x[T],R));for(const T of G.added.values())ee.has(T)||(te.added.has(T)?W.updated.has(T)&&ae(T):Y=f(T,q,Y,R));for(const T of te.added.values())ee.has(T)||(G.added.has(T)?W.updated.has(T)&&ae(T):q=f(T,Y,q,R));const Z=re.size>0||!y(q,Y,u),z=Z||!y(q,a,[]),D=Z||!y(Y,E,[]);return{localContent:z?q:null,remoteContent:D?Y:null,conflictsSettings:[...re.values()],hasConflicts:Z}}e.$0Eb=d;function y(a,E,b){if(a===E)return!0;const u=(0,L.$bn)(a),p=(0,L.$bn)(E),R=b.reduce((M,q)=>(M.add(q),M),new Set),N=r(a).filter(M=>!(M.setting&&R.has(M.setting.key))),F=r(E).filter(M=>!(M.setting&&R.has(M.setting.key)));if(N.length!==F.length)return!1;for(let M=0;M<N.length;M++){const q=N[M],Y=F[M];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!I.$yn(u[q.setting.key],p[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function w(a){return a?r(a).length===0:!0}e.$$Eb=w;function c(a,E,b){const u=a?Object.keys(a).filter(M=>!b.has(M)):[],p=Object.keys(E).filter(M=>!b.has(M)),R=p.filter(M=>!u.includes(M)).reduce((M,q)=>(M.add(q),M),new Set),N=u.filter(M=>!p.includes(M)).reduce((M,q)=>(M.add(q),M),new Set),F=new Set;if(a)for(const M of u){if(N.has(M))continue;const q=a[M],Y=E[M];I.$yn(q,Y)||F.add(M)}return{added:R,removed:N,updated:F}}function f(a,E,b,u){const p=(0,L.$bn)(E),R=r(E),N=r(b),F=m(a,R,N);return h(b,a,p[a],F,N,u)}e.$_Eb=f;function m(a,E,b){const u=E.findIndex(R=>R.setting?.key===a),p=E[u-1];if(p){if(p.setting){const N=i(p.setting.key,b);if(N)return{index:b.indexOf(N),insertAfter:!0}}else{const N=o(u,E);if(N){const F=i(N.setting.key,b);if(F){const M=s(b.indexOf(F),b),q=n(E,N,E[u]);if(M){const Y=n(b,F,M),K=t(q,Y);return K?{index:b.indexOf(K),insertAfter:!0}:{index:b.indexOf(M),insertAfter:!1}}else{const Y=n(b,F,b[b.length-1]),K=t(q,Y);return K?{index:b.indexOf(K),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const R=E[u+1];if(R)if(R.setting){const N=i(R.setting.key,b);if(N)return{index:b.indexOf(N),insertAfter:!1}}else{const N=s(u,E);if(N){const F=i(N.setting.key,b);if(F){const M=o(b.indexOf(F),b),q=n(E,E[u],N);if(M){const Y=n(b,M,F),K=t(q.reverse(),Y.reverse());return K?{index:b.indexOf(K),insertAfter:!1}:{index:b.indexOf(M),insertAfter:!0}}else{const Y=n(b,b[0],F),K=t(q.reverse(),Y.reverse());return K?{index:b.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function h(a,E,b,u,p,R){let N;return u.index===-1?N=(0,A.$qn)(a,[E],b,R):N=v(a,E,b,u,p,R).map(F=>(0,A.$rn)(a,F,R)[0]),(0,A.$tn)(a,N)}function v(a,E,b,u,p,R){const N=`${JSON.stringify(E)}: ${JSON.stringify(b)}`,F=(0,j.$nn)(R,a),M=p[u.index];if(u.insertAfter){const q=[];if(M.setting)q.push({offset:M.endOffset,length:0,content:","+N});else{const Y=s(u.index,p),K=o(u.index,p),x=K?.setting?.commaOffset;K&&x===void 0&&q.push({offset:K.endOffset,length:0,content:","});const V=x!==void 0&&x>M.endOffset;q.push({offset:V?x+1:M.endOffset,length:0,content:Y?F+N+",":F+N})}return q}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const q=(p[u.index-1]&&!p[u.index-1].setting?F:"")+N+(s(u.index,p)?",":"")+F;return[{offset:M.startOffset,length:0,content:q}]}}function i(a,E){return E.filter(b=>b.setting?.key===a)[0]}function o(a,E){for(let b=a-1;b>=0;b--)if(E[b].setting)return E[b]}function s(a,E){for(let b=a+1;b<E.length;b++)if(E[b].setting)return E[b]}function n(a,E,b){const u=a.indexOf(E),p=a.indexOf(b);return a.filter((R,N)=>u<N&&N<p)}function t(a,E){if(a.length&&E.length){let b=0;for(;b<E.length&&b<a.length;b++)if(a[b].value!==E[b].value)return E[b-1];return E[b-1]}}function r(a){const E=[];let b=-1,u,p;const R={onObjectBegin:N=>{b++},onObjectProperty:(N,F,M)=>{b===0&&(u=F,p=N)},onObjectEnd:(N,F)=>{b--,b===0&&E.push({startOffset:u,endOffset:N+F,value:a.substring(u,N+F),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(N,F)=>{b++},onArrayEnd:(N,F)=>{b--,b===0&&E.push({startOffset:u,endOffset:N+F,value:a.substring(u,N+F),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(N,F,M)=>{b===0&&E.push({startOffset:u,endOffset:F+M,value:a.substring(u,F+M),setting:{key:p,commaOffset:void 0}})},onSeparator:(N,F,M)=>{if(b===0&&N===","){let q=E.length-1;for(;q>=0&&!E[q].setting;q--);const Y=E[q];Y&&E.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:F}})}},onComment:(N,F)=>{b===0&&E.push({startOffset:N,endOffset:N+F,value:a.substring(N,N+F)})}};return(0,L.$in)(a,R),E}}),define(le[81],he([0,1,3,2,4,24]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$REb=e.$QEb=void 0,e.$QEb=(0,A.$5h)("IUserDataSyncAccountService");let I=class extends L.$Tc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new O.$Ud),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$Ud),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$REb=I,e.$REb=I=ye([X(0,j.$3mb),X(1,j.$fnb)],I)}),define(le[240],he([0,1,2,10]),function(ne,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=e.$B_b=e.$A_b=e.$z_b=e.$y_b=e.$x_b=e.$w_b=void 0;class A{constructor($){this.a=$}listen($,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call($,l,d){switch(l){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.$w_b=A;class j{constructor($){this.a=$}listen($,l){throw new Error(`Event not found: ${l}`)}call($,l,d){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(L.URI.revive(d[0]))}throw new Error("Invalid call")}}e.$x_b=j;class I{constructor($){this.a=$}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings($){return this.a.call("resolveUserKeybindings",[$])}async resolveFormattingOptions($){return this.a.call("resolveFormattingOptions",[$])}}e.$y_b=I;class C{constructor($){this.a=$}listen($,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call($,l,d){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.$z_b=C;class k{constructor($){this.a=$}listen($,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call($,l,d){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$A_b=k;class g{constructor($){this.a=$}listen($,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call($,l,d){switch(l){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$B_b=g;class P extends O.$Tc{constructor($){super(),this.a=$,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch($){return this.a.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.a.call("getPreviousUserDataSyncStore");return this.b($)}b($){return{url:L.URI.revive($.url),type:$.type,defaultUrl:L.URI.revive($.defaultUrl),insidersUrl:L.URI.revive($.insidersUrl),stableUrl:L.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}}e.$C_b=P}),define(le[241],he([0,1,19,174,15,8,24]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Gb=void 0;let C=class extends j.$rj{constructor(g,P){super(),this.g=this.B(g.createLogger((0,O.$Gg)(P.logsHome,`${I.$gnb}.log`),{id:I.$gnb,name:(0,L.localize)(0,null)}))}trace(g,...P){this.g.trace(g,...P)}debug(g,...P){this.g.debug(g,...P)}info(g,...P){this.g.info(g,...P)}warn(g,...P){this.g.warn(g,...P)}error(g,...P){this.g.error(g,...P)}flush(){this.g.flush()}};e.$$Gb=C,e.$$Gb=C=ye([X(0,j.$nj),X(1,A.$_h)],C)}),define(le[242],he([0,1,6,3,2]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=void 0;class j extends A.$Tc{constructor({onDidOpenMainWindow:C,onDidFocusMainWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new A.$Sc),L.Event.latch(L.Event.any(C,k))(this.f,this,this.a),this.b=(0,O.$Sg)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(C){this.b&&(this.b.cancel(),this.b=void 0),this.c=C}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$x$b=j}),define(le[112],he([0,1,177,16,48,19,10,4,23]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.WorkbenchState=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0,e.$bi=(0,C.$5h)("contextService");function g(n){const t=n;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$ci=g;function P(n){return typeof n?.id=="string"&&!g(n)&&!$(n)}e.$di=P,e.$ei={id:"ext-dev"},e.$fi={id:"empty-window"};function S(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.$nc)(n)}:t?e.$ei:e.$fi;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$gi=S;function $(n){const t=n;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$hi=$;function l(n){const t=n;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$ii=l;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function y(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$ji=y;function w(n){const t=n;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$ki=w;class c{constructor(t,r,a,E,b){this.h=t,this.j=a,this.k=E,this.l=b,this.c=A.$$h.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=A.$$h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$li=c;class f{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Gg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$mi=f;function m(n){return new f({uri:n,index:0,name:(0,j.$Cg)(n)},{uri:n.toString()})}e.$ni=m,e.$oi="code-workspace",e.$pi=`.${e.$oi}`,e.$qi=[{name:(0,O.localize)(0,null),extensions:[e.$oi]}],e.$ri="workspace.json";function h(n,t){return j.$xg.isEqualOrParent(n,t.untitledWorkspacesHome)}e.$si=h;function v(n){let t;return I.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===k.Schemas.tmp}e.$ti=v,e.$ui="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$ui}e.$vi=i;function o(n,t){return!h(n,t)&&!v(n)}e.$wi=o;function s(n){return(typeof n=="string"?(0,L.$oc)(n):(0,j.$Eg)(n))===e.$pi}e.$xi=s}),define(le[18],he([0,1,53,3,2,19,10,168,15,11,4,8,112,35,28,6,32,27,12]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.ProfileResourceType=void 0;var m;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function h(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$1k=h,e.$2k=(0,P.$5h)("IUserDataProfilesService");function v(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:I.URI.revive(n.location).with({scheme:t}),globalStorageHome:I.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(n.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(n.cacheHome).with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$3k=v;function i(n,t,r,a,E,b){return{id:n,name:t,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:b&&E?.useDefaultFlags?.globalState?b.globalStorageHome:(0,j.$Gg)(r,"globalStorage"),settingsResource:b&&E?.useDefaultFlags?.settings?b.settingsResource:(0,j.$Gg)(r,"settings.json"),keybindingsResource:b&&E?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,j.$Gg)(r,"keybindings.json"),tasksResource:b&&E?.useDefaultFlags?.tasks?b.tasksResource:(0,j.$Gg)(r,"tasks.json"),snippetsHome:b&&E?.useDefaultFlags?.snippets?b.snippetsHome:(0,j.$Gg)(r,"snippets"),extensionsResource:b&&E?.useDefaultFlags?.extensions?b.extensionsResource:(0,j.$Gg)(r,"extensions.json"),cacheHome:(0,j.$Gg)(a,n),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}e.$4k=i;let o=class extends A.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,E){super(),this.t=t,this.u=r,this.w=a,this.y=E,this.f=!0,this.h=this.B(new L.$Ud),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$Ud),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$Ud),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$Ud),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$Gg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Gg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,f.$Hf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(i((0,j.$Dg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},t))}}catch(b){this.y.error(b)}const a=new l.$Ac,E=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[u,p]of Object.entries(b.workspaces)){const R=I.URI.parse(u),N=r.find(F=>F.id===p);N&&a.set(R,N)}if(b.emptyWindows)for(const[u,p]of Object.entries(b.emptyWindows)){const R=r.find(N=>N.id===p);R&&E.set(u,R)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:a,emptyWindows:E}}return this.z}D(){const t=i("__default__profile__",(0,C.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,c.$Ne)(r)}\\s(\\d+)`);let E=0;for(const u of this.profiles){const p=a.exec(u.name),R=p?parseInt(p[1]):0;E=R>E?R:E}const b=`${r} ${E+1}`;return this.createProfile((0,O.$Si)((0,w.$pg)()).toString(16),b,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,O.$Si)((0,w.$pg)()).toString(16),t,r,a)}async createProfile(t,r,a,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(t,r,a);return E&&await this.setProfileForWorkspace(E,b),b}async F(t,r,a){if(!(0,f.$Hf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{const b=this.profiles.find(R=>R.name===r||R.id===t);if(b)return b;const u=i(t,r,(0,j.$Gg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const p=[];return this.j.fire({profile:u,join(R){p.push(R)}}),await y.Promises.settled(p),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(E=>E.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(E){a.push(E)}});try{await Promise.allSettled(a)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,g.$Gk)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(E=>E.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,$.$ci)(t)?t.uri:(0,$.$hi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const E=[...this.profiles,...t],b=[];this.s.profiles=[];for(let u of E)u.isDefault||r.some(p=>u.id===p.id)||(u=a.find(p=>u.id===p.id)??u,u.isTransient?this.s.profiles.push(u):b.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(b),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const E=this.G(t),b=a?this.s:this.C;I.URI.isUri(E)?(b.workspaces.delete(E),r&&b.workspaces.set(E,r)):(b.emptyWindows.delete(E),r&&b.emptyWindows.set(E,r)),a||this.M()}M(){const t={};for(const[a,E]of this.C.workspaces.entries())t[a.toString()]=E.id;const r={};for(const[a,E]of this.C.emptyWindows.entries())r[a.toString()]=E.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[b,u]of Object.entries(t.workspaces)){const p=I.URI.parse(u);r[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const E={};if(t.emptyWindows)for(const[b,u]of Object.entries(t.emptyWindows)){const p=I.URI.parse(u);E[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$5k=o,e.$5k=o=ye([X(0,k.$_h),X(1,g.$pk),X(2,d.$Zk),X(3,S.$mj)],o);class s extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$6k=s}),define(le[243],he([0,1,6,2,18]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0;let j=class extends L.$Tc{constructor(C){super(),this.B(new O.$eh(()=>{C.cleanUp()},10*1e3)).schedule()}};e.$K_b=j,e.$K_b=j=ye([X(0,A.$2k)],j)}),define(le[244],he([0,1,17,6,26,7,3,2,5,12,10,151,29,33,45,8,25,22,28,18]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=void 0;let h=class extends C.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,E,b,u){super(),this.z=t,this.C=r,this.D=a,this.F=E,this.G=b,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$Ud),this.s=this.B(new I.$Ud),this.t=this.B(new I.$Ud),this.u=this.B(new I.$Ud),this.w=this.B(new I.$Ud),this.y=[],this.B((0,C.$Rc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,$.$vo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const E=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:b})=>(0,l.$Zo)(b,t.identifier));if(E?.local)return E?.local;throw E?.error?E.error:i(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new $.$yo(S.localize(0,null),$.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:E,options:b})=>{try{const u=await this.O(E,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);a.push({...u,options:b})}catch(u){r.push({identifier:E.identifier,operation:2,source:E,error:u})}})),a.length&&r.push(...await this.I(a));for(const E of r)E.error&&(this.F.error("Failed to install extension.",E.identifier.id),this.F.error(E.error),E.source&&!P.URI.isUri(E.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,l.$8o)(E.source),error:E.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,d.$nm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const E of this.H.profiles){const b=(await this.getInstalled(1,E.extensionsResource)).find(u=>(0,l.$Zo)(u.identifier,t.identifier));b?this.w.fire(b):this.u.fire({identifier:t.identifier,profileLocation:E.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const E=await this.J(a,(b,u)=>t.some(p=>(0,l.$4o)(u.identifier.id)===(0,l.$5o)(p.manifest.publisher,p.manifest.name))?!1:this.L(b,u));r.push(...E)}catch(E){r.push({identifier:{id:(0,l.$5o)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:E})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},E){const b=a.isApplicationScoped||a.isBuiltin||(0,d.$nm)(t),u={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:b,profileLocation:b?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},p=Y=>`${l.$1o.create(Y).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const Y=this.j.get(p(r));if(Y)return this.F.info("Extensions is already requested to install",r.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const R=[],N=[],F=[],M=this.Z(t,r,u);P.URI.isUri(r)||this.j.set(p(r),{task:M,waitingTasks:[]}),this.n.fire({identifier:M.identifier,source:r,profileLocation:u.profileLocation}),this.F.info("Installing extension:",M.identifier.id),R.push({task:M,manifest:t});let q=!1;try{if(u.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const K=await this.N(M.identifier,t,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),x=await this.getInstalled(void 0,u.profileLocation),V={...u,donotIncludePackAndDependencies:!0,context:{...u.context,[$.$qo]:!0}};for(const{gallery:Q,manifest:W}of(0,O.$Mb)(K,({gallery:G})=>G.identifier.id)){q=q||!!W.extensionDependencies?.some(re=>(0,l.$Zo)({id:re},M.identifier));const G=p(Q),te=this.j.get(G);if(te){if(E(M,te.task)){const re=te.task.identifier;this.F.info("Waiting for already requested installing extension",re.id,M.identifier.id),te.waitingTasks.push(M),N.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ae=>(0,l.$Zo)(ae.identifier,re)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",re.id,M.identifier.id),!ee.find(Z=>(0,l.$Zo)(Z.identifier,re))?.local)throw new Error(`Extension ${re.id} is not installed`)}))}}else if(!x.some(({identifier:re})=>(0,l.$Zo)(re,Q.identifier))){const re=this.Z(W,Q,V);this.j.set(G,{task:re,waitingTasks:[M]}),this.n.fire({identifier:re.identifier,source:Q,profileLocation:u.profileLocation}),this.F.info("Installing extension:",re.identifier.id,M.identifier.id),R.push({task:re,manifest:W})}}}catch(K){if(P.URI.isUri(M.source))(0,O.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",M.identifier.id,K.message),(0,O.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",M.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),K}const Y=R.reduce((K,{task:x,manifest:V})=>(K.set(x.identifier.id.toLowerCase(),{task:x,manifest:V}),K),new Map);for(;Y.size;){let K;const x=[...Y.values()].filter(({manifest:V})=>!V.extensionDependencies?.some(Q=>Y.has(Q.toLowerCase())));x.length?K=Y.size===1?x:x.filter(({task:V})=>!(V===M&&!q)):(this.F.info("Found extensions with circular dependencies",x.map(({task:V})=>V.identifier.id)),K=[...Y.values()]),await this.M(K.map(async({task:V})=>{const Q=new Date().getTime();try{const W=await V.run();if(await this.M(this.y.map(G=>G.postInstall(W,V.source,u,A.CancellationToken.None))),!P.URI.isUri(V.source)){const G=V.operation===3,te=G?void 0:(new Date().getTime()-V.source.lastUpdated)/1e3;if(o(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$8o)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:te}),k.$o&&V.operation!==3)try{await this.z.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}F.push({local:W,identifier:V.identifier,operation:V.operation,source:V.source,context:V.options.context,profileLocation:V.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw P.URI.isUri(V.source)||o(this.C,V.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$8o)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-Q,error:W}),this.F.error("Error while installing the extension",V.identifier.id,(0,j.$0)(W)),W}finally{Y.delete(V.identifier.id.toLowerCase())}}))}return N.length&&await this.M(N),F.forEach(({identifier:K})=>this.F.info("Extension installed successfully:",K.id)),F}catch(Y){if(R.forEach(({task:K})=>K.cancel()),F.length)try{const K=await Promise.allSettled(F.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let x=0;x<K.length;x++){const V=K[x],{identifier:Q}=F[x];V.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,j.$0)(V.reason))}}catch(K){this.F.warn("Error while rolling back extensions",(0,j.$0)(K),F.map(({identifier:x})=>x.id))}return R.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:u.context,profileLocation:u.profileLocation,error:Y}))}finally{for(const{task:Y}of R)Y.source&&!P.URI.isUri(Y.source)&&this.j.delete(p(Y.source))}}L(t,r){for(const[,{task:a,waitingTasks:E}]of this.j.entries())if(a===t&&(E.includes(r)||E.some(b=>this.L(b,r)))||a===r&&E[0]&&!this.L(t,E[0]))return!1;return!0}async M(t){const r=[],a=[],E=await Promise.allSettled(t);for(const b of E)b.status==="fulfilled"?r.push(b.value):a.push(b.reason);if(a.length)throw v(a);return r}async N(t,r,a,E,b){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,b),p=[],R=[],N=async(F,M)=>{p.push(F);const q=M.extensionDependencies||[],Y=[...q];if(M.extensionPack){const K=a?u.find(x=>(0,l.$Zo)(x.identifier,F)):void 0;for(const x of M.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(V=>(0,l.$Zo)({id:V},{id:x}))||Y.every(V=>!(0,l.$Zo)({id:V},{id:x}))&&Y.push(x)}if(Y.length){const K=Y.filter(x=>p.every(V=>!(0,l.$Zo)(V,{id:x})));if(K.length){const x=await this.z.getExtensions(K.map(V=>({id:V,preRelease:E})),A.CancellationToken.None);for(const V of x){if(p.find(G=>(0,l.$Zo)(G,V.identifier)))continue;const Q=q.some(G=>(0,l.$Zo)({id:G},V.identifier));let W;try{W=await this.O(V,!1,E)}catch(G){if(Q)throw G;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,j.$0)(G));continue}R.push({gallery:W.extension,manifest:W.manifest}),await N(W.extension.identifier,W.manifest)}}}};return await N(t,r),R}async O(t,r,a){let E;const b=await this.getExtensionsControlManifest();if(b.malicious.some(R=>(0,l.$Zo)(t.identifier,R)))throw new $.$yo(S.localize(1,null,t.identifier.id),$.ExtensionManagementErrorCode.Malicious);const u=b.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!E)throw new $.$yo(S.localize(2,null,t.identifier.id,u.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const R=await this.getTargetPlatform();throw new $.$yo(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,$.$ro)(R)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.P(t,r,a),!E)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],A.CancellationToken.None))[0]?new $.$yo(S.localize(4,null,t.displayName??t.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$yo(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const p=await this.z.getManifest(E,A.CancellationToken.None);if(p===null)throw new $.$yo(`Missing manifest for extension ${E.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(p.version!==E.version)throw new $.$yo(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:p}}async P(t,r,a){const E=await this.getTargetPlatform();let b=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(b=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:E,compatible:!0},A.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(t,a,E)&&(b=t),b||(r?b=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:E,compatible:!0},A.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(t,a,E)),b}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},E=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,b=this.m.get(E(t.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),b.waitUntilTaskIsFinished();const u=F=>{const M=this.$(F,a);return this.m.set(E(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},p=(F,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$7o)(F),error:M}),this.u.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},R=[],N=[];try{R.push(u(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.U(t,F);for(const q of M)this.m.has(E(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):R.push(u(q))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(R.map(M=>M.extension),F,t),await this.M(R.map(async M=>{try{if(await M.run(),await this.M(this.y.map(q=>q.postUninstall(M.extension,a,A.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}p(M.extension)}catch(q){const Y=q instanceof $.$yo?q:new $.$yo((0,j.$0)(q),$.ExtensionManagementErrorCode.Internal);throw p(M.extension,Y),Y}finally{N.push(M)}}))}catch(F){const M=F instanceof $.$yo?F:new $.$yo((0,j.$0)(F),$.ExtensionManagementErrorCode.Internal);for(const q of R){try{q.cancel()}catch{}N.includes(q)||p(q.extension,M)}throw M}finally{for(const F of R)this.m.delete(E(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}R(t,r,a){for(const E of t){const b=this.W(E,r);if(b.length){const u=b.filter(p=>!t.some(R=>(0,l.$Zo)(R.identifier,p.identifier)));if(u.length)throw new Error(this.S(E,u,a))}}}S(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const E=t.manifest.extensionPack?t.manifest.extensionPack:[];if(E.length){const b=r.filter(p=>!p.isBuiltin&&E.some(R=>(0,l.$Zo)({id:R},p.identifier))),u=[];for(const p of b)u.push(...this.U(p,r,a));return[...b,...u]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(E=>(0,l.$Zo)({id:E},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Pp=h,e.$Pp=h=ye([X(0,$.$xo),X(1,c.$tl),X(2,f.$Zk),X(3,y.$mj),X(4,w.$Ej),X(5,m.$2k)],h);function v(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$Qp=v;function i(n){if(n instanceof $.$yo)return n;const t=new $.$yo(n.message,$.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}e.$Rp=i;function o(n,t,{extensionData:r,verificationStatus:a,duration:E,error:b,durationSinceUpdate:u}){let p,R;(0,g.$Pf)(a)&&(a===!0?a="Verified":(a===!1||(p=$.ExtensionManagementErrorCode.Signature,R=a),a="Unverified")),b&&(b instanceof $.$yo?(p=b.code,b.code===$.ExtensionManagementErrorCode.Signature&&(R=b.message)):p=$.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,verificationStatus:a,success:!b,duration:E,errorcode:p,errorcodeDetail:R,durationSinceUpdate:u})}class s{constructor(){this.d=new L.$4g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.$Sg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.$Sg)(t=>new Promise((r,a)=>{const E=t.onCancellationRequested(()=>{E.dispose(),a(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$Sp=s}),define(le[51],he([0,1,6,14,2,3,35,10,29,33,11,4,8,18,28,12,7,22]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class m extends Error{constructor(s,n){super(s),this.code=n}}e.$Tp=m,e.$Up=(0,S.$5h)("IExtensionsProfileScannerService");let h=class extends A.$Tc{constructor(s,n,t,r,a,E){super(),this.j=s,this.m=n,this.n=t,this.r=r,this.s=a,this.t=E,this.b=this.B(new j.$Ud),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Ud),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Ud),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Ud),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Ac}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n){const t=[],r=[];try{return await this.u(n,a=>{const E=[];for(const b of a)s.some(([u])=>(0,g.$Zo)(u.identifier,b.identifier)&&u.manifest.version!==b.version)?t.push(b):E.push(b);for(const[b,u]of s){const p=E.findIndex(N=>(0,g.$Zo)(N.identifier,b.identifier)&&N.version===b.manifest.version),R={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:u};p===-1?(r.push(R),E.push(R)):E.splice(p,1,R)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),t.length&&this.f.fire({extensions:t,profileLocation:n}),E}),r.length&&this.c.fire({extensions:r,profileLocation:n}),t.length&&this.g.fire({extensions:t,profileLocation:n}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:n}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:n}),a}}async updateMetadata(s,n){const t=[];return await this.u(n,r=>{const a=[];for(const E of r){const b=s.find(([u])=>(0,g.$Zo)(u.identifier,E.identifier)&&u.manifest.version===E.version);b&&(E.metadata={...E.metadata,...b[1]},t.push(E)),a.push(E)}return a}),t}async removeExtensionFromProfile(s,n){const t=[];try{await this.u(n,r=>{const a=[];for(const E of r)(0,g.$Zo)(E.identifier,s.identifier)?t.push(E):a.push(E);return t.length&&this.f.fire({extensions:t,profileLocation:n}),a}),t.length&&this.g.fire({extensions:t,profileLocation:n})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:n}),r}}async u(s,n,t){return this.F(s).queue(async()=>{let r=[],a;try{const E=await this.m.readFile(s);a=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,P.$Gk)(E)!==1)throw E;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new m((0,w.$0)(E),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(s);let E=!1;for(const b of a){v(b)||this.w(s);let u;if((0,y.$Hf)(b.relativeLocation)&&b.relativeLocation)u=this.z(b.relativeLocation);else if((0,y.$Hf)(b.location))u=this.z(b.location),E=!0,b.relativeLocation=b.location,b.location=u.toJSON();else{u=C.URI.revive(b.location);const p=this.y(u);p&&(E=!0,b.relativeLocation=p)}r.push({identifier:b.identifier,location:u,version:b.version,metadata:b.metadata})}E&&await this.m.writeFile(s,L.$ie.fromString(JSON.stringify(a)))}if(n){r=n(r);const E=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(s,L.$ie.fromString(JSON.stringify(E)))}return r})}w(s){const n=new m(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(s)).value.toString()}catch(a){if((0,P.$Gk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(E=>v(E))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,L.$ie.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.$Gk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(s)}catch(a){(0,P.$Gk)(a)!==1&&this.t.error(a)}try{await this.m.del(n)}catch(a){(0,P.$Gk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(s){let n=this.h.get(s);return n||(n=new O.$_g,this.h.set(s,n)),n}};e.$Vp=h,e.$Vp=h=ye([X(1,P.$pk),X(2,l.$2k),X(3,d.$Zk),X(4,c.$tl),X(5,$.$mj)],h);function v(o){return(0,y.$Jf)(o)&&(0,k.$wo)(o.identifier)&&(i(o.location)||(0,y.$Hf)(o.location)&&o.location)&&((0,y.$Of)(o.relativeLocation)||(0,y.$Hf)(o.relativeLocation))&&o.version&&(0,y.$Hf)(o.version)}function i(o){return o?(0,y.$Hf)(o.path)&&(0,y.$Hf)(o.scheme):!1}}),define(le[82],he([0,1,17,6,30,14,7,34,137,2,23,16,5,19,55,89,12,10,154,15,33,45,71,11,4,8,25,3,66,51,18,28,182]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v,i,o,s,n,t,r,a,E,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.Translations=void 0;var R;(function(x){function V(Q,W){if(Q===W)return!0;const G=Object.keys(Q),te=new Set;for(const re of Object.keys(W))te.add(re);if(G.length!==te.size)return!1;for(const re of G){if(Q[re]!==W[re])return!1;te.delete(re)}return te.size===0}x.equals=V})(R||(e.Translations=R={})),e.$Yp=(0,s.$5h)("IExtensionsScannerService");let N=class extends g.$Tc{constructor(V,Q,W,G,te,re,ee,ae,Z,z,D,T){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Q,this.r=W,this.s=G,this.t=te,this.u=re,this.w=ee,this.y=ae,this.z=Z,this.C=z,this.D=D,this.F=T,this.g=this.B(new r.$Ud),this.onDidChangeCache=this.g.event,this.h=(0,l.$Gg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$$o)(this.w,this.y)),this.G}async scanAllExtensions(V,Q,W){const[G,te]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Q)]),re=W?await this.scanExtensionsUnderDevelopment(V,[...G,...te]):[];return this.L(G,te,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Q=[];Q.push(this.M(!!V.useCache,V.language)),Q.push(this.N(V.language,!!V.checkControlFile));const[W,G]=await Promise.all(Q);return this.J([...W,...G],0,V,!1)}async scanUserExtensions(V){const Q=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const W=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,G=await this.P(Q,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,W),te=V.useCache&&!G.devMode&&G.excludeObsolete?this.m:this.n;let re;try{re=await te.scanExtensions(G)}catch(ee){if(ee instanceof E.$Tp&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await te.scanExtensions(G);else throw ee}return re=await this.J(re,1,V,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(V,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(G=>G.scheme===P.Schemas.file).map(async G=>{const te=await this.P(G,!1,1,!0,V.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(ee=>(ee.type=Q.find(ae=>(0,h.$Zo)(ae.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,te)))}))).flat();return this.J(W,"development",V,!0)}return[]}async scanExistingExtension(V,Q,W){const G=await this.P(V,!1,Q,!0,W.language,!0,void 0),te=await this.n.scanExtension(G);return!te||!W.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(V,Q,W){const G=await this.P(V,!1,Q,!0,W.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(G);return this.J(te,Q,W,!0)}async scanMetadata(V){const Q=(0,l.$Gg)(V,"package.json"),W=(await this.w.readFile(Q)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(V,Q){const W=(0,l.$Gg)(V,"package.json"),G=(await this.w.readFile(W)).value.toString(),te=JSON.parse(G);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,te.__metadata={...te.__metadata,...Q},await this.w.writeFile((0,l.$Gg)(V,"package.json"),j.$ie.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof E.$Tp&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$ie.fromString(JSON.stringify([])))}catch(Q){(0,o.$Gk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Q,W,G){return W.includeAllVersions||(V=this.L(Q===0?V:void 0,Q===1?V:void 0,Q==="development"?V:void 0,await this.getTargetPlatform(),G)),W.includeInvalid||(V=V.filter(te=>te.isValid)),V.sort((te,re)=>{const ee=S.$nc(te.location.fsPath),ae=S.$nc(re.location.fsPath);return ee<ae?-1:ee>ae?1:0})}L(V,Q,W,G,te){const re=(ae,Z,z)=>{if(ae.isValid&&!Z.isValid)return!1;if(ae.isValid===Z.isValid){if(te&&d.gt(ae.manifest.version,Z.manifest.version))return this.y.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(d.eq(ae.manifest.version,Z.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${Z.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===G)return this.y.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${ae.location.path} with ${Z.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${Z.location.path}.`),!0},ee=new v.$mm;return V?.forEach(ae=>{const Z=ee.get(ae.identifier.id);(!Z||re(Z,ae,!1))&&ee.set(ae.identifier.id,ae)}),Q?.forEach(ae=>{const Z=ee.get(ae.identifier.id);if(!Z&&V&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!Z||re(Z,ae,!1))&&ee.set(ae.identifier.id,ae)}),W?.forEach(ae=>{const Z=ee.get(ae.identifier.id);(!Z||re(Z,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async M(V,Q){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),te=await(V&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",te.length),te}async N(V,Q){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const G=Q?await this.O():{},te=[],re=c.URI.file(S.$hc(S.$jc(P.$ng.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of W){const Z=G[ae.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":te.push((0,l.$Gg)(re,ae.name));break;default:te.push(c.URI.file(Z));break}}const ee=await Promise.all(te.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,V,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,O.$Hb)(ee)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Q,W,G,te,re,ee){const ae=await this.f(te??$.$w),Z=await this.Q(V),z=Q&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=z?await this.Q(z):void 0;return new F(V,Z,z,D,Q,ee,W,G,re,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,ae)}async Q(V){try{const Q=await this.w.stat(V);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Zp=N,e.$Zp=N=ye([X(4,b.$2k),X(5,E.$Up),X(6,o.$pk),X(7,n.$mj),X(8,m.$_h),X(9,t.$Ej),X(10,u.$Zk),X(11,s.$4h)],N);class F{constructor(V,Q,W,G,te,re,ee,ae,Z,z,D,T,B,U,_){this.location=V,this.mtime=Q,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=G,this.profile=te,this.profileScanOptions=re,this.type=ee,this.excludeObsolete=ae,this.validate=Z,this.productVersion=z,this.productDate=D,this.productCommit=T,this.devMode=B,this.language=U,this.translations=_}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Q){return(0,l.$zg)(V.location,Q.location)&&V.mtime===Q.mtime&&(0,l.$zg)(V.applicationExtensionslocation,Q.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&V.profile===Q.profile&&A.$yn(V.profileScanOptions,Q.profileScanOptions)&&V.type===Q.type&&V.excludeObsolete===Q.excludeObsolete&&V.validate===Q.validate&&V.productVersion===Q.productVersion&&V.productDate===Q.productDate&&V.productCommit===Q.productCommit&&V.devMode===Q.devMode&&V.language===Q.language&&R.equals(V.translations,Q.translations)}}e.$1p=F;let M=class extends g.$Tc{constructor(V,Q,W,G,te){super(),this.f=V,this.g=Q,this.h=W,this.j=G,this.m=te}async scanExtensions(V){const Q=V.profile?await this.r(V):await this.n(V);let W={};if(V.excludeObsolete&&V.type===1)try{const G=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(G)}catch{}return(0,w.$Uf)(W)?Q:Q.filter(G=>!W[h.$1o.create(G).toString()])}async n(V){const Q=await this.j.resolve(V.location);if(!Q.children?.length)return[];const W=await Promise.all(Q.children.map(async G=>{if(!G.isDirectory||V.type===1&&(0,l.$Dg)(G.resource).indexOf(".")===0)return null;const te=new F(G.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te)}));return(0,O.$Hb)(W).sort((G,te)=>G.location.path<te.location.path?-1:1)}async r(V){let Q=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Q=Q.filter(G=>!G.metadata?.isApplicationScoped);const W=await this.s(V.applicationExtensionslocation,G=>!!G.metadata?.isBuiltin||!!G.metadata?.isApplicationScoped,V);Q.push(...W)}return Q}async s(V,Q,W){const G=await this.g.scanProfileExtensions(V,W.profileScanOptions);if(!G.length)return[];const te=await Promise.all(G.map(async re=>{if(Q(re)){const ee=new F(re.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ee,re.metadata)}return null}));return(0,O.$Hb)(te)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,l.$Gg)(V.location,"package.json"))){const Q=await this.scanExtension(V);return Q?[Q]:[]}else return await this.scanExtensions(V)}catch(Q){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,I.$0)(Q)),[]}}async scanExtension(V,Q){try{let W=await this.scanExtensionManifest(V.location);if(W){W.publisher||(W.publisher=v.$gm),Q=Q??W.__metadata,delete W.__metadata;const G=(0,h.$5o)(W.publisher,W.name),te=Q?.id?{id:G,uuid:Q.id}:{id:G},re=Q?.isSystem?0:V.type,ee=re===0||!!Q?.isBuiltin;W=await this.t(V.location,W,F.createNlsConfiguration(V));const ae={type:re,identifier:te,manifest:W,location:V.location,isBuiltin:ee,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return V.validate?this.validate(ae,V):ae}}catch(W){V.type!==0&&this.m.error(W)}return null}validate(V,Q){let W=!0;const G=(0,i.$dp)(Q.productVersion,Q.productDate,Q.location,V.manifest,V.isBuiltin);for(const[te,re]of G)te===y.default.Error&&(W=!1,this.m.error(this.z(Q.location,re)));return V.isValid=W,V.validations=G,V}async scanExtensionManifest(V){const Q=(0,l.$Gg)(V,"package.json");let W;try{W=(await this.j.readFile(Q)).value.toString()}catch(te){return(0,o.$Gk)(te)!==1&&this.m.error(this.z(V,(0,f.localize)(0,null,Q.path,te.message))),null}let G;try{G=JSON.parse(W)}catch{const re=[];(0,C.$bn)(W,re);for(const ee of re)this.m.error(this.z(V,(0,f.localize)(1,null,Q.path,ee.offset,ee.length,(0,k.$Wp)(ee.error))));return null}return(0,C.$kn)(G)!=="object"?(this.m.error(this.z(V,(0,f.localize)(2,null,Q.path))),null):G}async t(V,Q,W){const G=await this.u(V,Q,W);if(G)try{const te=[],re=await this.w(G.default,te);if(te.length>0)return te.forEach(ae=>{this.m.error(this.z(V,(0,f.localize)(3,null,G.default?.path,(0,k.$Wp)(ae.error))))}),Q;if((0,C.$kn)(G)!=="object")return this.m.error(this.z(V,(0,f.localize)(4,null,G.default?.path))),Q;const ee=G.values||Object.create(null);return(0,p.$Xp)(this.m,Q,ee,re)}catch{}return Q}async u(V,Q,W){const G=(0,l.$Gg)(V,"package.nls.json"),te=(Z,z)=>{z.forEach(D=>{this.m.error(this.z(V,(0,f.localize)(5,null,Z?.path,(0,k.$Wp)(D.error))))})},re=Z=>{this.m.error(this.z(V,(0,f.localize)(6,null,Z?.path)))},ee=`${Q.publisher}.${Q.name}`,ae=W.translations[ee];if(ae)try{const Z=c.URI.file(ae),z=(await this.j.readFile(Z)).value.toString(),D=[],T=(0,C.$bn)(z,D);return D.length>0?(te(Z,D),{values:void 0,default:G}):(0,C.$kn)(T)!=="object"?(re(Z),{values:void 0,default:G}):{values:T.contents?T.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.j.exists(G))return;let z;try{z=await this.y(V,W)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const D=(await this.j.readFile(z.localized)).value.toString(),T=[],B=(0,C.$bn)(D,T);return T.length>0?(te(z.localized,T),{values:void 0,default:z.original}):(0,C.$kn)(B)!=="object"?(re(z.localized),{values:void 0,default:z.original}):{values:B,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(V,Q){if(V)try{const W=(await this.j.readFile(V)).value.toString();return(0,C.$bn)(W,Q)}catch{}}y(V,Q){return new Promise((W,G)=>{const te=re=>{const ee=(0,l.$Gg)(V,`package.nls.${re}.json`);this.j.exists(ee).then(ae=>{ae&&W({localized:ee,original:(0,l.$Gg)(V,"package.nls.json")});const Z=re.lastIndexOf("-");Z===-1?W({localized:(0,l.$Gg)(V,"package.nls.json"),original:null}):(re=re.substring(0,Z),te(re))})};if(Q.devMode||Q.pseudo||!Q.language)return W({localized:(0,l.$Gg)(V,"package.nls.json"),original:null});te(Q.language)})}z(V,Q){return`[${V.path}]: ${Q}`}};M=ye([X(1,E.$Up),X(2,u.$Zk),X(3,o.$pk),X(4,n.$mj)],M);let q=class extends M{constructor(V,Q,W,G,te,re,ee){super(Q,G,te,re,ee),this.G=V,this.H=W,this.D=this.B(new L.$3g(3e3)),this.F=this.B(new r.$Ud),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Q=this.M(V),W=await this.I(Q);if(this.C=V,W&&W.input&&F.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),W.result.map(te=>(te.location=c.URI.revive(te.location),te));const G=await super.scanExtensions(V);return await this.J(Q,{input:V,result:G}),G}async I(V){try{const Q=await this.j.readFile(V),W=JSON.parse(Q.value.toString());return{result:W.result,input:(0,a.$Bh)(W.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",V.path,(0,I.$0)(Q))}return null}async J(V,Q){try{await this.j.writeFile(V,j.$ie.fromString(JSON.stringify(Q)))}catch(W){this.m.debug("Error while writing the extension cache file:",V.path,(0,I.$0)(W))}}async L(){if(!this.C)return;const V=this.M(this.C),Q=await this.I(V);if(!Q)return;const W=Q.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$yn(G,W))try{this.m.info("Invalidating Cache",W,G),await this.j.del(V),this.F.fire()}catch(te){this.m.error(te)}}M(V){const Q=this.N(V);return this.h.extUri.joinPath(Q.cacheHome,V.type===0?v.$fm:v.$em)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(V.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=ye([X(2,b.$2k),X(3,E.$Up),X(4,u.$Zk),X(5,o.$pk),X(6,n.$mj)],q);function Y(x,V){const Q=(0,h.$3o)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new v.$km(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:V,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$2p=Y;class K extends N{constructor(V,Q,W,G,te,re,ee,ae,Z,z,D,T){super(V,Q,(0,l.$Gg)(W,".vscode-oss-dev","extensions","control.json"),G,te,re,ee,ae,Z,z,D,T),this.R=(async()=>{if($.$z)try{const B=await this.w.readFile(c.URI.file($.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(V){return this.R}}e.$3p=K}),define(le[245],he([0,1,67,6,38,3,2,23,16,31,8,18]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;let $=class extends I.$Tc{constructor(d,y){super(),this.b=d,this.f=y,this.a=new L.$$g(5)}async postUninstall(d){const y=this.g(d,"uninstall");y&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(w)}}));try{await g.Promises.rm(this.m(d))}catch(w){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(w)}}g(d,y){const w=`vscode:${y}`;if(d.location.scheme===C.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[w]=="string"){const c=d.manifest.scripts[w].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${w} should be a node script`),null):{script:(0,k.$jc)(d.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(d,y,w,c,f){return new Promise((m,h)=>{const v=this.j(d,y,w,f);let i;const o=s=>{i&&(clearTimeout(i),i=null),s?h(s):m(void 0)};v.on("error",s=>{o((0,A.$Pi)(s)||"Unknown")}),v.on("exit",(s,n)=>{o(s?`post-${y} process exited with code ${s}`:void 0)}),c&&(i=setTimeout(()=>{i=null,v.kill(),h("timed out")},5e3))})}j(d,y,w,c){const f={silent:!0,execArgv:void 0},m=(0,O.fork)(d,[`--type=extension-post-${y}`,...w],f);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const h=j.Event.fromNodeEventEmitter(m.stdout,"data"),v=j.Event.fromNodeEventEmitter(m.stderr,"data");h(s=>this.f.info(c.identifier.id,c.manifest.version,`post-${y}`,s)),v(s=>this.f.error(c.identifier.id,c.manifest.version,`post-${y}`,s));const i=j.Event.any(j.Event.map(h,s=>({data:`%c${s}`,format:[""]})),j.Event.map(v,s=>({data:`%c${s}`,format:["color: red"]})));return j.Event.debounce(i,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(c.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),m}m(d){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$5p=$,e.$5p=$=ye([X(0,S.$2k),X(1,P.$mj)],$)}),define(le[113],he([0,1,6,14,26,38,7,3,53,2,35,23,16,19,55,12,10,32,31,70,155,96,15,244,29,33,51,82,224,245,183,213,225,71,11,4,8,25,22,28,18]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v,i,o,s,n,t,r,a,E,b,u,p,R,N,F,M,q,Y,K,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0,e.$9p=(0,F.$6h)(s.$zo);const V=".vsctmp";let Q=class extends o.$Pp{constructor(Z,z,D,T,B,U,_,H,J,ie,se,ce){super(Z,z,se,D,ie,ce),this.fb=B,this.gb=U,this.hb=_,this.ib=J,this.eb=new Map,this.rb=new P.$Bc;const $e=this.B(H.createInstance(E.$5p));this.bb=this.B(H.createInstance(W,ge=>$e.postUninstall(ge))),this.cb=this.B(new u.$7p(ce,J,se,this,this.F)),this.db=this.B(H.createInstance(a.$4p));const fe=this.B(new p.$8p(this,this.fb,ce,U,se,J,D));this.B(fe.onDidChangeExtensionsByAnotherSource(ge=>this.qb(ge))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$$o)(this.ib,this.F)),this.jb}async zip(Z){this.F.trace("ExtensionManagementService#zip",Z.identifier.id);const z=await this.pb(Z),D=await(0,m.zip)((0,l.$Gg)(this.db.extensionsDownloadDir,(0,c.$pg)()).fsPath,z);return w.URI.file(D)}async unzip(Z){return this.F.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const{location:z,cleanup:D}=await this.lb(Z),T=$.$kc(z.fsPath);try{return await(0,b.$6p)(T)}finally{await D()}}getInstalled(Z,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Z??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Z){return this.bb.scanUserExtensionAtLocation(Z)}async install(Z,z={}){this.F.trace("ExtensionManagementService#install",Z.toString());const{location:D,cleanup:T}=await this.lb(Z);try{const B=await(0,b.$6p)($.$kc(D.fsPath)),U=(0,n.$5o)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,R.$fp)(B.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,U,this.G.version));const H=(await this.I([{manifest:B,extension:D,options:z}])).find(({identifier:J})=>(0,n.$Zo)(J,{id:U}));if(H?.local)return H.local;throw H?.error?H.error:(0,o.$Rp)(new Error(`Unknown error while installing extension ${U}`))}finally{await T()}}async installFromLocation(Z,z){this.F.trace("ExtensionManagementService#installFromLocation",Z.toString());const D=await this.bb.scanUserExtensionAtLocation(Z);if(!D)throw new Error(`Cannot find a valid extension from the location ${Z.toString()}`);return await this.ub([[D,void 0]],z),this.F.info("Successfully installed extension",D.identifier.id,z.toString()),D}async installExtensionsFromProfile(Z,z,D){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Z,z.toString(),D.toString());const T=(await this.bb.scanExtensions(1,z)).filter(B=>Z.some(U=>(0,n.$Zo)(U,B.identifier)));if(T.length){const B=await Promise.all(T.map(U=>this.bb.scanMetadata(U,z)));await this.ub(T.map((U,_)=>[U,B[_]]),D),this.F.info("Successfully installed extensions",T.map(U=>U.identifier.id),D.toString())}return T}async updateMetadata(Z,z,D=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Z.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),Z=await this.bb.updateMetadata(Z,z,D),this.cb.invalidate(D),this.w.fire(Z),Z}async reinstallFromGallery(Z){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Z.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const z=await this.getTargetPlatform(),[D]=await this.z.getExtensions([{...Z.identifier,preRelease:Z.preRelease}],{targetPlatform:z,compatible:!0},A.CancellationToken.None);if(!D)throw new Error(h.localize(2,null));await this.bb.setUninstalled(Z);try{await this.bb.removeUninstalledExtension(Z)}catch(T){throw new Error(h.localize(3,null,(0,j.$Pi)(T)))}return this.installFromGallery(D)}ab(Z,z,D,T){return this.bb.copyExtension(Z,z,D,T)}copyExtensions(Z,z){return this.bb.copyExtensions(Z,z)}markAsUninstalled(...Z){return this.bb.setUninstalled(...Z)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Z){this.F.error(Z)}}async download(Z,z,D){const{location:T}=await this.db.download(Z,z,!D);return T}async lb(Z){if(Z.scheme===S.Schemas.file)return{location:Z,async cleanup(){}};this.F.trace("Downloading extension from",Z.toString());const z=(0,l.$Gg)(this.db.extensionsDownloadDir,(0,c.$pg)());return await this.hb.download(Z,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(T){this.F.error(T)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Z,z,D){if(w.URI.isUri(z))return new re(Z,z,D,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const T=n.$1o.create(z).toString();let B=this.eb.get(T);return B||(this.eb.set(T,B=new te(Z,z,D,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.eb.delete(T))),B}$(Z,z){return new ee(Z,z.profileLocation,this.gb)}async pb(Z){const z=async T=>{let B=await f.Promises.readdir(T);B=B.map(H=>$.$jc(T,H));const U=await Promise.all(B.map(H=>f.Promises.stat(H)));let _=Promise.resolve([]);return U.forEach((H,J)=>{const ie=B[J];H.isFile()&&(_=_.then(se=>[...se,ie])),H.isDirectory()&&(_=_.then(se=>z(ie).then(ce=>[...se,...ce])))}),_};return(await z(Z.location.fsPath)).map(T=>({path:`extension/${$.$lc(Z.location.fsPath,T)}`,localPath:T}))}async qb({added:Z,removed:z}){if(z){const D=Z&&this.D.extUri.isEqual(z.profileLocation,Z.profileLocation)?z.extensions.filter(T=>Z.extensions.every(B=>!(0,n.$Zo)(B,T))):z.extensions;for(const T of D)this.F.info("Extensions removed from another source",T.id,z.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:z.profileLocation})}if(Z){const T=(await this.bb.scanExtensions(1,Z.profileLocation)).filter(B=>Z.extensions.some(U=>(0,n.$Zo)(U,B.identifier)));this.s.fire(T.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,Z.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:Z.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const Z=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of Z.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(Z){if(!Z.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const D of Z.rawAdded){if(this.rb.has(D)||!this.D.extUri.isEqual(this.D.extUri.dirname(D),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(D,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(D).startsWith(".")||!(await this.ib.stat(D)).isDirectory)continue;const T=await this.bb.scanUserExtensionAtLocation(D);T&&T.installedTimestamp===void 0&&(this.rb.add(D),z.push(T))}z.length&&(await this.ub(z.map(D=>[D,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(D=>D.identifier.id)))}async ub(Z,z){const D=Z.map(T=>T[0]);await this.vb(D),await this.gb.addExtensionsToProfile(Z,z),this.s.fire(D.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:z})))}async vb(Z){const z=await this.bb.getUninstalledExtensions();for(const D of Z){const T=n.$1o.create(D);z[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.bb.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$0p=Q,e.$0p=Q=ye([X(0,s.$xo),X(1,Y.$tl),X(2,M.$mj),X(3,i.$ai),X(4,r.$Yp),X(5,t.$Up),X(6,v.$co),X(7,F.$4h),X(8,N.$pk),X(9,q.$Ej),X(10,K.$Zk),X(11,x.$2k)],Q);let W=class extends g.$Tc{constructor(Z,z,D,T,B,U){super(),this.j=Z,this.m=z,this.n=D,this.s=T,this.t=B,this.u=U,this.h=this.B(new C.$Ud),this.onExtract=this.h.event,this.c=(0,l.$Gg)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$_g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Z,z){const D={includeInvalid:!0,profileLocation:z};let T=[];return Z===null||Z===0?T.push(...await this.n.scanAllExtensions({includeInvalid:!0},D,!1)):Z===1&&T.push(...await this.n.scanUserExtensions(D)),T=Z!==null?T.filter(B=>B.type===Z):T,Promise.all(T.map(B=>this.F(B)))}async scanAllUserExtensions(Z){const z=await this.n.scanUserExtensions({includeAllVersions:!Z,includeInvalid:!0});return Promise.all(z.map(D=>this.F(D)))}async scanUserExtensionAtLocation(Z){try{const z=await this.n.scanExistingExtension(Z,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(Z,z,D,T,B){const U=Z.toString(),_=w.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$pg)()}`)),H=w.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,U));let J=await this.m.exists(H);if(J&&T){try{await this.y(Z.id,H,"removeExisting")}catch{throw new s.$yo(h.localize(4,null,H.fsPath,Z.id),s.ExtensionManagementErrorCode.Delete)}J=!1}if(!J)try{try{this.u.trace(`Started extracting the extension from ${z} to ${H.fsPath}`),await(0,m.$Np)(z,_.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${H}:`,Z.id)}catch(ie){let se=s.ExtensionManagementErrorCode.Extract;throw ie instanceof m.$Lp&&(ie.type==="CorruptZip"?se=s.ExtensionManagementErrorCode.CorruptZip:ie.type==="Incomplete"&&(se=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$yo(ie.message,se)}await this.n.updateMetadata(_,D);try{this.u.trace(`Started renaming the extension from ${_.fsPath} to ${H.fsPath}`),await this.C(_.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(ie){if(ie.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Z.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(ie)}. Deleted from extracted location`,_),ie}this.h.fire(H)}catch(ie){try{await this.m.del(_,{recursive:!0})}catch{}throw ie}return this.D(H,1)}async scanMetadata(Z,z){return z?(await this.w(Z,z))?.metadata:this.n.scanMetadata(Z.location)}async w(Z,z){return(await this.s.scanProfileExtensions(z)).find(T=>(0,n.$Zo)(T.identifier,Z.identifier))}async updateMetadata(Z,z,D){return D?await this.s.updateMetadata([[Z,z]],D):await this.n.updateMetadata(Z.location,z),this.D(Z.location,Z.type,D)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Z){const z=Z.map(D=>n.$1o.create(D));await this.z(D=>z.forEach(T=>{D[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(Z){await this.z(z=>delete z[Z.toString()])}async removeExtension(Z,z){if(this.t.extUri.isEqualOrParent(Z.location,this.n.userExtensionsLocation))return this.y(Z.identifier.id,Z.location,z)}async removeUninstalledExtension(Z){await this.removeExtension(Z,"uninstalled"),await this.z(z=>delete z[n.$1o.create(Z).toString()])}async copyExtension(Z,z,D,T){const B=await this.w(Z,z),U=await this.w(Z,D);return T={...B?.metadata,...T},U?await this.s.updateMetadata([[Z,{...U.metadata,...T}]],D):await this.s.addExtensionsToProfile([[Z,T]],D),this.D(Z.location,Z.type,D)}async copyExtensions(Z,z){const D=await this.scanExtensions(1,Z),T=await Promise.all(D.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,Z)]));await this.s.addExtensionsToProfile(T,z)}async y(Z,z,D){this.u.trace(`Deleting ${D} extension from disk`,Z,z.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,k.$Si)((0,c.$pg)()).toString(16)}${V}`);await this.C(z.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${D} extension from disk`,Z,z.fsPath)}async z(Z){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,N.$Gk)(T)!==1)throw T}let D={};if(z)try{D=JSON.parse(z)}catch{}return Z&&(Z(D),Object.keys(D).length?await this.m.writeFile(this.c,L.$ie.fromString(JSON.stringify(D))):await this.m.del(this.c)),D})}async C(Z,z){try{await f.Promises.rename(Z,z,2*60*1e3)}catch(D){throw new s.$yo(D.message||h.localize(5,null,Z,z),D.code||s.ExtensionManagementErrorCode.Rename)}}async D(Z,z,D){if(D){const B=(await this.n.scanUserExtensions({profileLocation:D})).find(U=>this.t.extUri.isEqual(U.location,Z));if(B)return this.F(B)}else{const T=await this.n.scanExistingExtension(Z,z,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(h.localize(6,null,Z.path))}async F(Z){const z=await this.m.resolve(Z.location);let D,T;return z.children&&(D=z.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,T=z.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:Z.identifier,type:Z.type,isBuiltin:Z.isBuiltin||!!Z.metadata?.isBuiltin,location:Z.location,manifest:Z.manifest,targetPlatform:Z.targetPlatform,validations:Z.validations,isValid:Z.isValid,readmeUrl:D,changelogUrl:T,publisherDisplayName:Z.metadata?.publisherDisplayName||null,publisherId:Z.metadata?.publisherId||null,isApplicationScoped:!!Z.metadata?.isApplicationScoped,isMachineScoped:!!Z.metadata?.isMachineScoped,isPreReleaseVersion:!!Z.metadata?.isPreReleaseVersion,preRelease:!!Z.metadata?.preRelease,installedTimestamp:Z.metadata?.installedTimestamp,updated:!!Z.metadata?.updated,pinned:!!Z.metadata?.pinned}}async G(){const Z=await this.getUninstalledExtensions();if(Object.keys(Z).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Z));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),D=new Set;for(const B of z)Z[n.$1o.create(B).toString()]||D.add(B.identifier.id.toLowerCase());try{const B=(0,n.$6o)(z,U=>U.identifier);await O.Promises.settled(B.map(async U=>{const _=U.sort((H,J)=>d.rcompare(H.manifest.version,J.manifest.version))[0];D.has(_.identifier.id.toLowerCase())||await this.j(await this.F(_))}))}catch(B){this.u.error(B)}const T=z.filter(B=>B.metadata&&Z[n.$1o.create(B).toString()]);await Promise.allSettled(T.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Z;try{Z=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,N.$Gk)(z)!==1&&this.u.error(z);return}if(Z?.children)try{await Promise.allSettled(Z.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(D){(0,N.$Gk)(D)!==1&&this.u.error(D)}}}))}catch{}}};e.$$p=W,e.$$p=W=ye([X(1,N.$pk),X(2,r.$Yp),X(3,t.$Up),X(4,K.$Zk),X(5,M.$mj)],W);class G extends o.$Sp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Of)(this.options.operation)?this.l:this.options.operation}constructor(Z,z,D,T,B,U,_,H,J){super(),this.identifier=Z,this.source=z,this.options=D,this.m=T,this.n=B,this.o=U,this.p=_,this.q=H,this.s=J,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Z){const[z,D]=await this.x(Z);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,D]],this.j),z}async u({zipPath:Z,key:z,metadata:D},T,B){let U=await this.v(z);return U||(this.s.trace("Extracting extension...",z.id),U=await this.m.extractUserExtension(z,Z,D,T,B),this.s.info("Extracting extension completed.",z.id)),U}async v(Z){return await this.w(Z)?(this.s.trace("Removing the extension from uninstalled list:",Z.id),await this.m.setInstalled(Z),this.s.info("Removed the extension from uninstalled list:",Z.id),(await this.m.scanAllUserExtensions(!0)).find(T=>n.$1o.create(T).equals(Z))):void 0}async w(Z){return!!(await this.m.getUninstalledExtensions())[Z.toString()]}}class te extends G{constructor(Z,z,D,T,B,U,_,H,J,ie){super(z.identifier,z,D,B,U,_,H,J,ie),this.y=z,this.z=T}async x(Z){const D=(await this.m.scanExtensions(null,this.options.profileLocation)).find(_=>(0,n.$Zo)(_.identifier,this.y.identifier));D&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,isSystem:D?.type===0?!0:void 0,updated:!!D,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??D?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Nf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:D?.preRelease)};if(D?.manifest.version===this.y.version)return[await this.m.updateMetadata(D,T),T];const{location:B,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:n.$1o.create(this.y),metadata:T},!1,Z),T]}catch(_){try{await this.z.delete(B)}catch(H){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,I.$0)(H))}throw _}}async B(Z){try{await(0,b.$6p)(Z)}catch(z){throw new s.$yo((0,o.$Qp)(z).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$_p=te;class re extends G{constructor(Z,z,D,T,B,U,_,H,J,ie){super({id:(0,n.$5o)(Z.publisher,Z.name)},z,D,B,U,_,H,J,ie),this.y=Z,this.z=z,this.A=T}async h(Z){const z=await super.h(Z);return this.D(z,Z),z}async x(Z){const z=new n.$1o(this.identifier,this.y.version),T=(await this.m.scanExtensions(1,this.options.profileLocation)).find(_=>(0,n.$Zo)(this.identifier,_.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned};if(T)if(this.l=3,z.equals(new n.$1o(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(T.manifest.version,this.y.version)&&await this.m.setUninstalled(T);else{const _=await this.v(z);if(_)try{await this.m.removeExtension(_,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:$.$kc(this.z.fsPath),key:z,metadata:B},!0,Z),B]}async D(Z,z){try{let[D]=await this.A.getExtensions([{id:Z.identifier.id,version:Z.manifest.version}],z);if(D||([D]=await this.A.getExtensions([{id:Z.identifier.id}],z)),D){const T={id:D.identifier.uuid,publisherDisplayName:D.publisherDisplayName,publisherId:D.publisherId,isPreReleaseVersion:D.properties.isPreReleaseVersion,preRelease:D.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Z,T,this.options.profileLocation)}}catch{}}}class ee extends o.$Sp{constructor(Z,z,D){super(),this.extension=Z,this.j=z,this.k=D}async h(Z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,18,28,22,51,11,15,10]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=void 0;let P=class extends I.$Vp{constructor($,l,d,y,w,c){super(g.URI.file($.extensionsPath),l,d,y,w,c)}};e.$rO=P,e.$rO=P=ye([X(0,k.$ai),X(1,C.$pk),X(2,L.$2k),X(3,A.$Zk),X(4,j.$tl),X(5,O.$mj)],P)}),define(le[247],he([0,1,10,15,51,82,11,4,8,25,28,18]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=void 0;let $=class extends j.$3p{constructor(d,y,w,c,f,m,h,v){super(O.URI.file(f.builtinExtensionsPath),O.URI.file(f.extensionsPath),f.userHome,d.defaultProfile,d,y,w,c,f,m,h,v)}};e.$B$b=$,e.$B$b=$=ye([X(0,S.$2k),X(1,A.$Up),X(2,I.$pk),X(3,k.$mj),X(4,L.$ai),X(5,g.$Ej),X(6,P.$Zk),X(7,C.$4h)],$)}),define(le[21],he([0,1,6,3,2,100,12,69,4,18]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$tp=e.$sp=e.$rp=void 0,e.$rp="__$__isNewStorageMarker",e.$sp="__$__targetStorageMarker",e.$tp=(0,k.$5h)("storageService");var P;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var $;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function l(f){const m=f.get(e.$sp);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.$up=l;class d extends A.$Tc{static{this.a=60*1e3}constructor(m={flushInterval:d.a}){super(),this.m=m,this.b=this.B(new L.$Xd),this.c=this.B(new L.$Xd),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$Ud),this.onWillSaveState=this.f.event,this.h=this.B(new O.$eh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,h,v){return L.Event.filter(this.b.event,i=>i.scope===m&&(h===void 0||i.key===h),v)}n(){this.j.value=(0,O.$ih)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,h){const{key:v,external:i}=h;if(v===e.$sp){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:v,target:this.J(m)[v],external:i})}w(m){this.f.fire({reason:m})}get(m,h,v){return this.P(h)?.get(m,v)}getBoolean(m,h,v){return this.P(h)?.getBoolean(m,v)}getNumber(m,h,v){return this.P(h)?.getNumber(m,v)}getObject(m,h,v){return this.P(h)?.getObject(m,v)}storeAll(m,h){this.y(()=>{for(const v of m)this.store(v.key,v.value,v.scope,v.target,h)})}store(m,h,v,i,o=!1){if((0,I.$Qf)(h)){this.remove(m,v,o);return}this.y(()=>{this.z(m,v,i),this.P(v)?.set(m,h,o)})}remove(m,h,v=!1){this.y(()=>{this.z(m,h,void 0),this.P(h)?.delete(m,v)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,h){const v=[],i=this.J(m);for(const o of Object.keys(i))i[o]===h&&v.push(o);return v}z(m,h,v,i=!1){const o=this.J(h);typeof v=="number"?o[m]!==v&&(o[m]=v,this.P(h)?.set(e.$sp,JSON.stringify(o),i)):typeof o[m]=="number"&&(delete o[m],this.P(h)?.set(e.$sp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const h=this.P(m);return h?l(h):Object.create(null)}isNew(m){return this.getBoolean(e.$rp,m)===!0}async flush(m=P.NONE){this.f.fire({reason:m});const h=this.P(-1),v=this.P(0),i=this.P(1);switch(m){case P.NONE:await O.Promises.settled([h?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await O.Promises.settled([h?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,v=this.P(1)?.items??new Map;return c(m,h,v,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,h){return this.w(P.NONE),(0,g.$1k)(m)?this.R(m,h):this.S(m,h)}M(m,h){return!(m.id===h.id||y(h)&&y(m))}N(m,h,v){this.y(()=>{const i=new Set;for(const[o,s]of m)i.add(o),h.get(o)!==s&&this.u(v,{key:o,external:!0});for(const[o]of h.items)i.has(o)||this.u(v,{key:o,external:!0})})}}e.$vp=d;function y(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$wp=y;class w extends d{constructor(){super(),this.U=this.B(new C.$pp(new C.$qp,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$pp(new C.$qp,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$pp(new C.$qp,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$xp=w;async function c(f,m,h,v,i,o){const s=R=>{try{return JSON.parse(R)}catch{return R}},n=new Map,t=new Map;f.forEach((R,N)=>{n.set(N,R),t.set(N,s(R))});const r=new Map,a=new Map;m.forEach((R,N)=>{r.set(N,R),a.set(N,s(R))});const E=new Map,b=new Map;h.forEach((R,N)=>{E.set(N,R),b.set(N,s(R))}),console.group(v!==i?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const u=[];if(n.forEach((R,N)=>{u.push({key:N,value:R})}),console.table(u),console.groupEnd(),console.log(t),v!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const R=[];r.forEach((N,F)=>{R.push({key:F,value:N})}),console.table(R),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const p=[];E.forEach((R,N)=>{p.push({key:N,value:R})}),console.table(p),console.groupEnd(),console.log(b)}e.$yp=c}),define(le[114],he([0,1,3,2,12,29,33,21]),function(ne,e,O,L,A,j,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PEb=e.$OEb=void 0;let k=class extends L.$Tc{constructor(S,$){super(),this.a=new O.$Ud,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(S)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B($.onDidInstallExtensions(l=>l.forEach(({local:d,operation:y})=>{d&&y===4&&this.f(d.identifier)})))}async enableExtension(S,$){return this.f(S)?(this.a.fire({extensions:[S],source:$}),!0):!1}async disableExtension(S,$){return this.c(S)?(this.a.fire({extensions:[S],source:$}),!0):!1}getDisabledExtensions(){return this.h(j.$Ao)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const $=this.getDisabledExtensions();return $.every(l=>!(0,I.$Zo)(l,S))?($.push(S),this.g($),!0):!1}f(S){const $=this.getDisabledExtensions();for(let l=0;l<$.length;l++){const d=$[l];if((0,I.$Zo)(d,S))return $.splice(l,1),this.g($),!0}return!1}g(S){this.j(j.$Ao,S)}h(S){return this.b.get(S,0)}j(S,$){this.b.set(S,$,0)}};e.$OEb=k,e.$OEb=k=ye([X(0,C.$tp),X(1,j.$zo)],k);class g extends L.$Tc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new O.$Ud),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new L.$Sc))($=>this.f($)))}get(S,$){let l;return $===0?((0,A.$Qf)(this.a[S])&&(this.a[S]=this.g(S,$)),l=this.a[S]):l=this.g(S,$),JSON.parse(l)}set(S,$,l){const d=JSON.stringify($.map(({id:w,uuid:c})=>({id:w,uuid:c})));this.g(S,l)!==d&&(l===0&&($.length?this.a[S]=d:delete this.a[S]),this.h(S,$.length?d:void 0,l))}f(S){if(!(0,A.$Qf)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const l=this.get(S.key,S.scope);delete this.a[S.key];const d=this.get(S.key,S.scope),y=l.filter(c=>!d.some(f=>(0,I.$Zo)(c,f))),w=d.filter(c=>!l.some(f=>(0,I.$Zo)(f,c)));(y.length||w.length)&&this.b.fire([...y,...w])}}g(S,$){return this.c.get(S,$,"[]")}h(S,$,l){$?this.c.store(S,$,l,1):this.c.remove(S,l)}}e.$PEb=g}),define(le[248],he([0,1,17,26,7,5,37,12,10,20,15,29,33,71,11,8,25,59,226,21,22,63]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=void 0;const i=j.$o?"web":(0,S.$to)(j.$u,I.$ec),o="X-Market-Search-Activity-Id";var s;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...T){return String(T.reduce((B,U)=>B|U,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class u{constructor(B=b){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,U=this.d.pageSize){return new u({...this.d,pageNumber:B,pageSize:U})}withFilter(B,...U){const _=[...this.d.criteria,...U.length?U.map(H=>({filterType:B,value:H})):[{filterType:B}]];return new u({...this.d,criteria:_})}withSortBy(B){return new u({...this.d,sortBy:B})}withSortOrder(B){return new u({...this.d,sortOrder:B})}withFlags(...B){return new u({...this.d,flags:B.reduce((U,_)=>U|_,0)})}withAssetTypes(...B){return new u({...this.d,assetTypes:B})}withSource(B){return new u({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:U,pageSize:_,sortBy:H,sortOrder:J,flags:ie,assetTypes:se}=this.d;return{filters:[{criteria:B,pageNumber:U,pageSize:_,sortBy:H,sortOrder:J}],assetTypes:se,flags:ie}}get searchText(){const B=this.d.criteria.filter(U=>U.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(T,B){const U=(T||[]).filter(_=>_.statisticName===B)[0];return U?U.value:0}function R(T){const B="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(_=>_.assetType.indexOf(B)===0).reduce((_,H)=>{const J=M(T,H.assetType);return J&&_.push([H.assetType.substring(B.length),J]),_},[])}function N(T){if(T.properties){const B=T.properties.filter(H=>H.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=B.filter(H=>U.test(H.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return M(T,r.Repository)}function F(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function M(T,B){return T.files.filter(_=>_.assetType===B)[0]?{uri:`${T.assetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function q(T,B){const U=T.properties?T.properties.filter(H=>H.key===B):[],_=U.length>0&&U[0].value;return _?_.split(",").map(H=>(0,$.$4o)(H)):[]}function Y(T){const B=T.properties?T.properties.filter(U=>U.key===a.Engine):[];return B.length>0&&B[0].value||""}function K(T){const B=T.properties?T.properties.filter(U=>U.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function x(T){const B=T.properties?T.properties.filter(_=>_.key===a.LocalizedLanguages):[],U=B.length>0&&B[0].value||"";return U?U.split(","):[]}function V(T){return T.properties?.find(B=>B.key===a.SponsorLink)?.value}function Q(T){return T.properties?.find(B=>B.key===a.SupportLink)?.value}function W(T){return T.indexOf("preview")!==-1}function G(T){return T.targetPlatform?(0,S.$so)(T.targetPlatform):"undefined"}function te(T){const B=(0,O.$Mb)(T.versions.map(G)),U=!!T.tags?.includes(S.$no),_=B.indexOf("web");return U?_===-1&&B.push("web"):_!==-1&&B.splice(_,1),B}function re(T,B){for(let U=0;U<T.length;U++){const _=T[U];if(_.version===T[U-1]?.version){let H=U;if(G(_)===B)for(;H>0&&T[H-1].version===_.version;)H--;H!==U&&(T.splice(U,1),T.splice(H,0,_))}}return T}e.$Bp=re;function ee(T,B,U){T.telemetryData={index:B,querySource:U,queryActivityId:T.queryContext?.[o]}}function ae(T,B,U,_){const H=T.versions[0],J={manifest:M(B,r.Manifest),readme:M(B,r.Details),changelog:M(B,r.Changelog),license:M(B,r.License),repository:N(B),download:F(B),icon:M(B,r.Icon),signature:M(B,r.Signature),coreTranslations:R(B)};return{identifier:{id:(0,$.$5o)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:B.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(H),description:T.shortDescription||"",installCount:p(T.statistics,"install"),rating:p(T.statistics,"averagerating"),ratingCount:p(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:U,assets:J,properties:{dependencies:q(B,a.Dependency),extensionPack:q(B,a.ExtensionPack),engine:Y(B),localizedLanguages:x(B),targetPlatform:G(B),isPreReleaseVersion:K(B)},hasPreReleaseVersion:K(H),hasReleaseVersion:!0,preview:W(T.flags),isSigned:!!J.signature,queryContext:_,supportLink:Q(H)}}let Z=class{constructor(B,U,_,H,J,ie,se,ce){this.k=U,this.l=_,this.n=H,this.o=J,this.q=ie,this.u=se,this.w=ce;const $e=se.extensionsGallery,fe=$e?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=fe?$e.servicePPEUrl:$e?.serviceUrl,this.g=fe?void 0:$e?.searchUrl,this.h=$e?.controlUrl,this.j=(0,f.$Ap)(se.version,se,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,U,_){const H=L.CancellationToken.isCancellationToken(U)?{}:U,J=L.CancellationToken.isCancellationToken(U)?U:_,ie=[],se=[],ce=[],$e=[];let fe=!0;for(const Ce of B){Ce.uuid?se.push(Ce.uuid):ie.push(Ce.id);const Oe=!!(Ce.version||Ce.preRelease);ce.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Oe}),Ce.version&&$e.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),fe=fe&&!!Ce.hasPreRelease&&!Oe}if(!se.length&&!ie.length)return[];let ge=new u().withPage(1,B.length);se.length&&(ge=ge.withFilter(t.ExtensionId,...se)),ie.length&&(ge=ge.withFilter(t.ExtensionName,...ie)),(H.queryAllVersions||fe)&&(ge=ge.withFlags(ge.flags,s.IncludeVersions)),H.source&&(ge=ge.withSource(H.source));const{extensions:Ee}=await this.z(ge,{targetPlatform:H.targetPlatform??i,includePreRelease:ce,versions:$e,compatible:!!H.compatible},J);return H.source&&Ee.forEach((Ce,Oe)=>ee(Ce,Oe,H.source)),Ee}async getCompatibleExtension(B,U,_){if((0,S.$uo)(B.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(B,U,_))return B;const H=new u().withFlags(s.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:J}=await this.z(H,{targetPlatform:_,compatible:!0,includePreRelease:U},L.CancellationToken.None);return J[0]||null}async isExtensionCompatible(B,U,_){if(!(0,S.$vo)(B.properties.targetPlatform,B.allTargetPlatforms,_)||!U&&B.properties.isPreReleaseVersion)return!1;let H=B.properties.engine;if(!H){const J=await this.getManifest(B,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");H=J.engines.vscode}return(0,l.$fp)(H,this.u.version,this.u.date)}async y(B,U,_,H,J){if(!(0,S.$vo)(G(B),H,J)||U!=="any"&&K(B)!==(U==="prerelease"))return!1;if(_)try{const ie=await this.E(B);if(!(0,l.$fp)(ie,this.u.version,this.u.date))return!1}catch(ie){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,A.$0)(ie)),!1}return!0}async query(B,U){let _=B.text||"";const H=B.pageSize??50;let J=new u().withPage(1,H);_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ge,Ee)=>(J=J.withFilter(t.Category,Ee||ge),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ge,Ee)=>(J=J.withFilter(t.Tag,Ee||ge),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(t.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),J=J.withFilter(t.SearchText,_)),J=J.withSortBy(0)):B.ids?J=J.withFilter(t.ExtensionId,...B.ids):B.names?J=J.withFilter(t.ExtensionName,...B.names):J=J.withSortBy(4),typeof B.sortBy=="number"&&(J=J.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(J=J.withSortOrder(B.sortOrder)),B.source&&(J=J.withSource(B.source));const ie=async(fe,ge)=>{const{extensions:Ee,total:Ce}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease},ge);return Ee.forEach((Oe,Ae)=>ee(Oe,(fe.pageNumber-1)*fe.pageSize+Ae,B.source)),{extensions:Ee,total:Ce}},{extensions:se,total:ce}=await ie(J,U),$e=async(fe,ge)=>{if(ge.isCancellationRequested)throw new A.$5;const{extensions:Ee}=await ie(J.withPage(fe+1),ge);return Ee};return{firstPage:se,total:ce,pageSize:J.pageSize,getPage:$e}}async z(B,U,_){const H=B.flags;B.flags&s.IncludeLatestVersionOnly&&B.flags&s.IncludeVersions&&(B=B.withFlags(B.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(B.flags&s.IncludeLatestVersionOnly)&&!(B.flags&s.IncludeVersions)&&(B=B.withFlags(B.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(B=B.withFlags(B.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),B=B.withFlags(B.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:J,total:ie,context:se}=await this.B(B,_);if(!(B.flags&s.IncludeLatestVersionOnly)){const ge=[];for(const Ee of J){const Ce=await this.A(Ee,U,se);Ce&&ge.push(Ce)}return{extensions:ge,total:ie}}const $e=[],fe=new Map;for(let ge=0;ge<J.length;ge++){const Ee=J[ge],Ce={id:(0,$.$5o)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Oe=(0,C.$Nf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ue=>(0,$.$Zo)(ue,Ce))?.includePreRelease;if(U.compatible&&(0,S.$uo)(te(Ee),U.targetPlatform))continue;const Ae=await this.A(Ee,U,se);!Ae||Ae.properties.isPreReleaseVersion&&(!Oe||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==U.targetPlatform&&Ae.hasPreReleaseVersion?fe.set(Ee.extensionId,ge):$e.push([ge,Ae])}if(fe.size){const ge=new v.$Qd,Ee=new u().withFlags(H&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:Ce}=await this.z(Ee,U,_);this.o.publicLog2("galleryService:additionalQuery",{duration:ge.elapsed(),count:fe.size});for(const Oe of Ce){const Ae=fe.get(Oe.identifier.uuid);$e.push([Ae,Oe])}}return{extensions:$e.sort((ge,Ee)=>ge[0]-Ee[0]).map(([,ge])=>ge),total:ie}}async A(B,U,_){const H={id:(0,$.$5o)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},J=U.versions?.find($e=>(0,$.$Zo)($e,H))?.version,ie=(0,C.$Nf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find($e=>(0,$.$Zo)($e,H))?.includePreRelease,se=te(B),ce=re(B.versions,U.targetPlatform);if(U.compatible&&(0,S.$uo)(se,U.targetPlatform))return null;for(let $e=0;$e<ce.length;$e++){const fe=ce[$e];if(!(J&&fe.version!==J)){if(await this.y(fe,ie?"any":"release",U.compatible,se,U.targetPlatform))return ae(B,fe,se,_);if(J&&fe.version===J)return null}}return J||U.compatible?null:ae(B,B.versions[0],se)}async B(B,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,s.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(s.Unpublished));const _=await this.j,H=JSON.stringify(B.raw),J={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ie=new v.$Qd;let se,ce,$e=0;try{if(se=await this.k.request({type:"POST",url:this.g&&B.criteria.some(ge=>ge.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:J},U),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:$e};const fe=await(0,c.$mp)(se);if(fe){const ge=fe.results[0],Ee=ge.extensions,Ce=ge.resultMetadata&&ge.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return $e=Ce&&Ce.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:$e,context:{[o]:se.res.headers.activityid}}}return{galleryExtensions:[],total:$e}}catch(fe){throw ce=fe,fe}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(H.length),duration:ie.elapsed(),success:!!se&&(0,c.$ip)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ce?(0,A.$4)(ce)?"canceled":(0,A.$0)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String($e)})}}async reportStatistic(B,U,_,H){if(!this.isEnabled())return;const J=j.$o?this.x(`/itemName/${B}.${U}/version/${_}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${U}/${_}/stats?statType=${H}`),ie=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:ie};try{await this.k.request({type:"POST",url:J,headers:ce},L.CancellationToken.None)}catch{}}async download(B,U,_){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const H=(0,$.$8o)(B),J=new Date().getTime(),ie=ge=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:ge}),se=_===2?"install":_===3?"update":"",ce=se?{uri:`${B.assets.download.uri}${k.URI.parse(B.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${B.assets.download.fallbackUri}${k.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:B.assets.download,$e=B.queryContext?.[o]?{[o]:B.queryContext[o]}:void 0,fe=await this.D(ce,$e?{headers:$e}:void 0);await this.q.writeFile(U,fe.stream),ie(new Date().getTime()-J)}async downloadSignatureArchive(B,U){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const _=await this.D(B.assets.signature);await this.q.writeFile(U,_.stream)}async getReadme(B,U){if(B.assets.readme){const _=await this.D(B.assets.readme,{},U);return await(0,c.$lp)(_)||""}return""}async getManifest(B,U){if(B.assets.manifest){const _=await this.D(B.assets.manifest,{},U),H=await(0,c.$lp)(_);return H?JSON.parse(H):null}return null}async C(B,U){const _=M(B,r.Manifest);if(!_)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},J=await this.D(_,{headers:H});return await(0,c.$mp)(J)}async getCoreTranslation(B,U){const _=B.assets.coreTranslations.filter(H=>H[0]===U.toUpperCase())[0];if(_){const H=await this.D(_[1]),J=await(0,c.$lp)(H);return J?JSON.parse(J):null}return null}async getChangelog(B,U){if(B.assets.changelog){const _=await this.D(B.assets.changelog,{},U);return await(0,c.$lp)(_)||""}return""}async getAllCompatibleVersions(B,U,_){let H=new u().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?H=H.withFilter(t.ExtensionId,B.identifier.uuid):H=H.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:J}=await this.B(H,L.CancellationToken.None);if(!J.length)return[];const ie=te(J[0]);if((0,S.$uo)(ie,_))return[];const se=[];await Promise.all(J[0].versions.map(async fe=>{try{await this.y(fe,U?"any":"release",!0,ie,_)&&se.push(fe)}catch{}}));const ce=[],$e=new Set;for(const fe of re(se,_))$e.has(fe.version)||($e.add(fe.version),ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:K(fe)}));return ce}async D(B,U={},_=L.CancellationToken.None){const H=await this.j,J={type:"GET"},ie={...H,...U.headers||{}};U={...U,...J,headers:ie};const se=B.uri,ce=B.fallbackUri,$e={...U,url:se};try{const fe=await this.k.request($e,_);if(fe.res.statusCode===200)return fe;const ge=await(0,c.$lp)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ge}`)}catch(fe){if((0,A.$4)(fe))throw fe;const ge=(0,A.$0)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:se,message:ge});const Ee={...U,url:ce};return this.k.request(Ee,_)}}async E(B){let U=Y(B);if(!U){const _=await this.C(B,L.CancellationToken.None);if(!_)throw new Error("Manifest was not found");U=_.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,c.$mp)(B),_=[],H={},J=[];if(U){for(const ie of U.malicious)_.push({id:ie});if(U.migrateToPreRelease)for(const[ie,se]of Object.entries(U.migrateToPreRelease))(!se.engine||(0,l.$fp)(se.engine,this.u.version,this.u.date))&&(H[ie.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[ie,se]of Object.entries(U.deprecated))se&&(H[ie.toLowerCase()]=(0,C.$Nf)(se)?{}:se);if(U.search)for(const ie of U.search)J.push(ie)}return{malicious:_,deprecated:H,search:J}}};Z=ye([X(1,c.$gp),X(2,y.$mj),X(3,P.$_h),X(4,h.$tl),X(5,d.$pk),X(6,w.$Ej),X(7,g.$yi)],Z);let z=class extends Z{constructor(B,U,_,H,J,ie,se,ce){super(B,U,_,H,J,ie,se,ce)}};e.$Cp=z,e.$Cp=z=ye([X(0,m.$tp),X(1,c.$gp),X(2,y.$mj),X(3,P.$_h),X(4,h.$tl),X(5,d.$pk),X(6,w.$Ej),X(7,g.$yi)],z);let D=class extends Z{constructor(B,U,_,H,J,ie,se){super(void 0,B,U,_,H,J,ie,se)}};e.$Dp=D,e.$Dp=D=ye([X(0,c.$gp),X(1,y.$mj),X(2,P.$_h),X(3,h.$tl),X(4,d.$pk),X(5,w.$Ej),X(6,g.$yi)],D)}),define(le[83],he([0,1,4,3,2,21,33,25,17,8,12]),function(ne,e,O,L,A,j,I,C,k,g,P){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=void 0,e.$lv=(0,O.$5h)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends A.$Tc{static{S=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,I.$4o)(y.id)}@${y.version}`}static c(y){const w=$.exec(y);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(y,w){const c=await y.getInstalled(),f=[];for(const[m,h]of S.f(w)){const v=c.find(i=>(0,I.$Zo)(i.identifier,{id:m}))?.manifest.version;for(const i of h)v!==i&&f.push(S.b({id:m,version:i}))}for(const m of f)w.remove(m,0)}static f(y){const w=new Map,c=y.keys(0,1);for(const f of c){const m=S.c(f);if(m){let h=w.get(m.id.toLowerCase());h||w.set(m.id.toLowerCase(),h=[]),h.push(m.version)}}return w}constructor(y,w,c){super(),this.j=y,this.m=w,this.n=c,this.g=this.B(new L.$Ud),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$Sc))(f=>this.r(f)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const w=S.c(y.key);if(w){if(this.j.get(y.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let c=this.h.get(w.id.toLowerCase());c||this.h.set(w.id.toLowerCase(),c=[]),c.push(w.version),this.g.fire()}return}}s(y){if((0,P.$Hf)(y))return y;const w=y.manifest?y.manifest.publisher:y.publisher,c=y.manifest?y.manifest.name:y.name;return(0,I.$3o)(w,c)}getExtensionState(y,w){const c=this.s(y),f=this.getExtensionStateRaw(y,w);if(f)try{return JSON.parse(f)}catch(m){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${w}): ${m}`)}}getExtensionStateRaw(y,w){const c=this.s(y),f=this.j.get(c,w?0:1);return f&&f?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${w}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(y,w,c){const f=this.s(y);w===void 0?this.j.remove(f,c?0:1):this.j.store(f,JSON.stringify(w),c?0:1,1)}setKeysForSync(y,w){this.j.store(S.b(y),JSON.stringify(w),0,1)}getKeysForSync(y){const w=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],c=this.j.get(S.b(y),0),f=c?JSON.parse(c):void 0;return f&&w?(0,k.$Mb)([...f,...w]):f||w}addToMigrationList(y,w){if(y!==w){const c=this.t.filter(f=>!f.includes(y)&&!f.includes(w));c.push([y,w]),this.t=c}}getSourceExtensionToMigrate(y){const w=this.t.find(([,c])=>y===c);return w?w[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(y);if(Array.isArray(w))return w}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$mv=l,e.$mv=l=S=ye([X(0,j.$tp),X(1,C.$Ej),X(2,g.$mj)],l)}),define(le[249],he([0,1,2,29,83,223,113,8,21]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=void 0;let g=class extends O.$Tc{constructor(S,$,l,d,y,w){super(),S.cleanUp(),(0,j.$rZb)(S,$,l,d,w),A.$mv.removeOutdatedExtensionVersions(S,y)}};e.$S_b=g,e.$S_b=g=ye([X(0,I.$9p),X(1,L.$xo),X(2,A.$lv),X(3,L.$Co),X(4,k.$tp),X(5,C.$mj)],g)}),define(le[250],he([0,1,29,11,25,15,97,57,21,22,222]),function(ne,e,O,L,A,j,I,C,k,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;let S=class extends P.$a9b{constructor(l,d,y,w,c,f,m,h){super(l.userHome,c,d,y,w,f,m,h)}};e.$Z_b=S,e.$Z_b=S=ye([X(0,j.$ai),X(1,g.$tl),X(2,O.$zo),X(3,k.$tp),X(4,C.$P0b),X(5,I.$bZb),X(6,L.$pk),X(7,A.$Ej)],S)}),define(le[251],he([0,1,105,3,22,15,2,8,16,67,25,5,6,101,20,164,36,21,12,131,19]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=void 0;const v=[O.$O_b,O.$P_b],i="remoteTunnelSession",o="remoteTunnelIsService";let s=class extends I.$Tc{constructor(a,E,b,u,p,R,N){super(),this.y=a,this.z=E,this.C=b,this.D=R,this.F=N,this.f=new L.$Ud,this.onDidTokenFailed=this.f.event,this.g=new L.$Ud,this.onDidChangeTunnelStatus=this.g.event,this.h=new L.$Ud,this.onDidChangeMode=this.h.event,this.n=O.$M_b,this.w=!1,this.I=(F,M)=>{M?this.j.error(F):this.j.info(F)},this.j=this.B(u.createLogger((0,h.$Gg)(b.logsHome,`${O.$Q_b}.log`),{id:O.$Q_b,name:O.$R_b})),this.t=new $.$2g(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,C.$Bj)(F)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(R.onDidChangeConfiguration(F=>{v.some(M=>F.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}J(){if(!this.u){let a;S.$j?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(O.$M_b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(E){this.j.error(E)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",E=!1;const b=(M,q)=>{q?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,y.localize)(0,null)))},u=this.O("status",["status"],b);this.r=u;try{if(await u,this.r!==u)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(O.TunnelStates.disconnected());return}if(E=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(O.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const M=p.token;this.G(O.TunnelStates.connecting((0,y.localize)(1,null,p.accountLabel,p.providerId)));const q=(K,x)=>{K=K.replaceAll(M,"*".repeat(4)),b(K,x)},Y=this.O("login",["user","login","--provider",p.providerId,"--access-token",M,"--log",(0,C.$Bj)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(p),this.G(O.TunnelStates.disconnected(p));return}}const R=this.Q();R?this.G(O.TunnelStates.connecting((0,y.localize)(2,null,R))):this.G(O.TunnelStates.connecting((0,y.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,C.$Bj)(this.j.getLevel())];R?N.push("--name",R):N.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!E&&(F=await this.M(N)===!1),this.N(p,N,F)}async M(a){let E;try{E=await this.O("serviceInstall",["service","install",...a])}catch(b){this.j.error(b),E=1}if(E!==0){const b=(0,y.localize)(4,null);return this.j.warn(b),this.G(O.TunnelStates.connecting(b)),!1}return!0}async N(a,E,b){E.push("--parent-process-id",String(process.pid)),this.P()&&E.push("--no-sleep");let u=!1;const p=this.O("tunnel",E,(R,N)=>{N?this.j.error(R):this.j.info(R),R.includes("Connected to an existing tunnel process")&&(u=!0);const F=R.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:u};this.G(O.TunnelStates.connected(M,b))}else R.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$M_b,this.G(O.TunnelStates.disconnected()))})}O(a,E,b=this.I){return(0,$.$Sg)(u=>new Promise((p,R)=>{u.isCancellationRequested&&p(-1);let N;const F=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{N&&(this.j.info(`${a} terminating(${N.pid})`),N.kill())}),!this.C.isBuilt)b(`Building tunnel CLI from sources and run
`,!1),b(`${a} Spawning: cargo run -- tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)("cargo",["run","--","tunnel",...E],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:F});else{b(`Running tunnel CLI
`,!1);const M=this.J();b(`${a} Spawning: ${M} tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)(M,["tunnel",...E],{cwd:(0,w.homedir)(),stdio:F})}N.stdout.pipe(new m.$lU(`
`)).on("data",M=>{if(N){const q=M.toString();b(q,!1)}}),N.stderr.pipe(new m.$lU(`
`)).on("data",M=>{if(N){const q=M.toString();b(q,!0)}}),N.on("exit",M=>{N&&(b(`${a} exit(${N.pid}): + ${M} `,!1),N=void 0,p(M||0))}),N.on("error",M=>{N&&(b(`${a} error(${N.pid}): + ${M} `,!0),N=void 0,R())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$P_b)}Q(){let a=this.D.getValue(O.$O_b)||(0,w.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),E=this.F.getBoolean(o,-1,!1);if(a){const b=JSON.parse(a);if(b&&(0,f.$Hf)(b.accountLabel)&&(0,f.$Hf)(b.sessionId)&&(0,f.$Hf)(b.providerId))return{active:!0,session:b,asService:E};this.j.error("Problems restoring session from storage, invalid format",b)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$M_b}S(a){if(a.active){const E={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(E),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$V_b=s,e.$V_b=s=ye([X(0,A.$tl),X(1,P.$Ej),X(2,j.$ai),X(3,C.$nj),X(4,l.$T_b),X(5,d.$yi),X(6,c.$tp)],s);function n(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&n(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,19,69,21,78,18]),function(ne,e,O,L,A,j,I,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=void 0;class P extends C.$vp{constructor($,l,d,y){super(),this.bb=$,this.cb=l,this.db=d,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new L.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new L.$Sc),this.ab=this.hb(this.bb)}fb(){const $=this.B(new k.$mFb(this.db.getChannel("storage"))),l=this.B(new I.$pp($));return this.B(l.onDidChangeStorage(d=>this.u(-1,d))),l}gb($){this.X.clear(),this.W=$;let l;if((0,C.$wp)($))l=this.U;else{const d=this.X.add(new k.$nFb(this.db.getChannel("storage"),$));l=this.X.add(new I.$pp(d))}return this.X.add(l.onDidChangeStorage(d=>this.u(0,d))),l}hb($){this.$.clear(),this.Z=$?.id;let l;if($){const d=this.$.add(new k.$oFb(this.db.getChannel("storage"),$));l=this.$.add(new I.$pp(d)),this.$.add(l.onDidChangeStorage(y=>this.u(1,y)))}return l}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P($){switch($){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q($){switch($){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Gg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(C.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R($){if(!this.M(this.W,$))return;const l=this.Y,d=l.items;l!==this.U&&await l.close(),this.Y=this.gb($),await this.Y.init(),this.N(d,this.Y,0)}async S($,l){const d=this.ab,y=d?.items??new Map;await d?.close(),this.ab=this.hb($),await this.ab.init(),this.N(y,this.ab,1)}hasScope($){return(0,g.$1k)($)?this.W.id===$.id:this.Z===$.id}}e.$1_b=P}),define(le[253],he([0,1,3,2,18,92]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=e.$yO=void 0;class I{constructor(g,P){this.a=g,this.b=P}listen(g,P){const S=this.b(g);switch(P){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(l=>(0,j.$5m)({...l},S)),added:$.added.map(l=>(0,j.$5m)({...l},S)),removed:$.removed.map(l=>(0,j.$5m)({...l},S)),updated:$.updated.map(l=>(0,j.$5m)({...l},S))}))}throw new Error(`Invalid listen ${P}`)}async call(g,P,S){const $=this.b(g);switch(P){case"createProfile":{const l=await this.a.createProfile(S[0],S[1],S[2]);return(0,j.$5m)({...l},$)}case"updateProfile":{let l=(0,A.$3k)((0,j.$6m)(S[0],$),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,S[1]),(0,j.$5m)({...l},$)}case"removeProfile":{const l=(0,A.$3k)((0,j.$6m)(S[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${P}`)}}e.$yO=I;class C extends L.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,P,S){super(),this.profilesHome=P,this.f=S,this.a=[],this.b=this.B(new O.$Ud),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map($=>(0,A.$3k)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const l=$.added.map(w=>(0,A.$3k)(w,this.profilesHome.scheme)),d=$.removed.map(w=>(0,A.$3k)(w,this.profilesHome.scheme)),y=$.updated.map(w=>(0,A.$3k)(w,this.profilesHome.scheme));this.a=$.all.map(w=>(0,A.$3k)(w,this.profilesHome.scheme)),this.b.fire({added:l,removed:d,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,P,S){const $=await this.f.call("createNamedProfile",[g,P,S]);return(0,A.$3k)($,this.profilesHome.scheme)}async createProfile(g,P,S,$){const l=await this.f.call("createProfile",[g,P,S,$]);return(0,A.$3k)(l,this.profilesHome.scheme)}async createTransientProfile(g){const P=await this.f.call("createTransientProfile",[g]);return(0,A.$3k)(P,this.profilesHome.scheme)}async setProfileForWorkspace(g,P){await this.f.call("setProfileForWorkspace",[g,P])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,P){const S=await this.f.call("updateProfile",[g,P]);return(0,A.$3k)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$zO=C}),define(le[60],he([0,1,2,69,4,21,3,78,18]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sFb=e.$rFb=e.$qFb=void 0,e.$qFb=(0,A.$5h)("IUserDataProfileStorageService");let g=class extends O.$Tc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async d=>this.b(d))}async updateStorageData(l,d,y){return this.withProfileScopedStorageService(l,async w=>this.c(w,d,y))}async withProfileScopedStorageService(l,d){if(this.a.hasScope(l))return d(this.a);const y=await this.g(l),w=new S(y);try{await w.initialize();const c=await d(w);return await w.flush(),c}finally{w.dispose(),await this.f(y)}}b(l){const d=new Map,y=w=>{for(const c of l.keys(0,w))d.set(c,{value:l.get(c,0),target:w})};return y(0),y(1),d}c(l,d,y){l.storeAll(Array.from(d.entries()).map(([w,c])=>({key:w,value:c,scope:0,target:y})),!0)}async f(l){try{await l.close()}finally{(0,O.$Nc)(l)&&l.dispose()}}};e.$rFb=g,e.$rFb=g=ye([X(0,j.$tp)],g);class P extends g{constructor(l,d,y,w){super(y),this.j=l;const c=l.getChannel("profileStorageListener"),f=this.B(new O.$Uc);this.h=this.B(new I.$Ud({onWillAddFirstListener:()=>{f.value=c.listen("onDidChange")(m=>{w.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(h=>(0,k.$3k)(h,d.profilesHome.scheme)),valueChanges:m.valueChanges.map(h=>({...h,profile:(0,k.$3k)(h.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(l){const d=this.j.getChannel("storage");return(0,j.$wp)(l)?new C.$mFb(d):new C.$nFb(d,l)}}e.$sFb=P;class S extends j.$vp{constructor(l){super({flushInterval:100}),this.s=this.B(new L.$pp(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,21,8,18,56,60]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=void 0;let C=class extends I.$sFb{constructor(g,P,S,$){super(g,P,S,$)}};e.$F_b=C,e.$F_b=C=ye([X(0,j.$4$b),X(1,A.$2k),X(2,O.$tp),X(3,L.$mj)],C)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,12,169,20,15,11,8,43,21,22,28,24,18]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rGb=e.$qGb=e.$pGb=e.$oGb=e.$nGb=e.$mGb=e.$lGb=void 0;function i(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||o(E.syncData)))}e.$lGb=i;function o(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}e.$mGb=o;function s(E,b){return`${(0,g.$zf)(E)}${b.isDefault?"":` (${b.name})`}`}e.$nGb=s;let n=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(b,u,p,R,N,F,M,q,Y,K,x,V){super(),this.syncResource=b,this.collection=u,this.G=p,this.H=R,this.I=N,this.J=F,this.L=M,this.M=q,this.N=Y,this.O=K,this.P=x,this.c=null,this.m="idle",this.n=this.B(new I.$Ud),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$Ud),this.onDidChangeConflicts=this.t.event,this.u=this.B(new L.$3g(50)),this.w=this.B(new I.$Ud),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(b.syncResource,b.profile),this.h=V.extUri,this.f=this.h.joinPath(R.userDataSyncHome,...(0,h.$Zmb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,h.$inb),this.y=(0,h.$1mb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,R,this.h),this.j=(0,w.$zp)(R,p,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const u=await this.Y(b.remoteUserData,b.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.ub(b):!0)&&this.w.fire()}}S(b){this.m!==b&&(this.m=b,this.n.fire(b))}async sync(b,u={}){await this.U(b,!0,this.ob(),u)}async preview(b,u,p={}){return this.U(b,!1,u,p)}async apply(b,u={}){try{this.F={...u};const p=await this.ab(b);return this.S(p),this.c}finally{this.F={}}}async U(b,u,p,R){try{if(this.F={...R},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),M=await this.X(b,F);return N=await this.Y(M,F,u,p),N==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(b){const u=this.kb(b);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),R=await this.X(null,p),N=await this.W(R),F=await this.qb({ref:R.ref,syncData:u},p,N,this.ob(),j.CancellationToken.None),M=[];for(const q of F){const Y=await this.sb(q,q.remoteResource,void 0,j.CancellationToken.None),{remoteChange:K}=await this.sb(q,q.previewResource,q.remoteContent,j.CancellationToken.None);M.push([q,{...Y,remoteChange:K!==0?K:2}])}await this.tb(R,p,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(b){const u=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===u}async X(b,u){if(u){const p=b?b[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(b,u,p,R){if(b.syncData&&b.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new h.$8mb((0,S.localize)(0,null,this.resource,this.pb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(b,u,p,R)}catch(N){if(N instanceof h.$8mb)switch(N.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(b,u,p,R);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(b,u,p,R)}throw N}}async Z(b,u,p,R){try{const N=await this.W(b),F=!N&&u===null&&this.gb()!==void 0,M=p&&!F;this.c||(this.c=(0,L.$Sg)(Y=>this.eb(b,u,N,M,R,Y)));let q=await this.c;if(p&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(N){throw this.c=null,N}}async merge(b){return await this.$(b,async u=>{const p=await this.rb(u,j.CancellationToken.None);await this.G.writeFile(u.previewResource,A.$ie.fromString(p?.content||""));const R=p&&!p.hasConflicts?await this.sb(u,u.previewResource,void 0,j.CancellationToken.None):void 0;return u.acceptResult=R,u.mergeState=p.hasConflicts?"conflict":R?"accepted":"preview",u.localChange=R?R.localChange:p.localChange,u.remoteChange=R?R.remoteChange:p.remoteChange,u}),this.c}async accept(b,u){return await this.$(b,async p=>{const R=await this.sb(p,b,u,j.CancellationToken.None);return p.acceptResult=R,p.mergeState="accepted",p.localChange=R.localChange,p.remoteChange=R.remoteChange,p}),this.c}async discard(b){return await this.$(b,async u=>{const p=await this.rb(u,j.CancellationToken.None);return await this.G.writeFile(u.previewResource,A.$ie.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.c}async $(b,u){if(!this.c)return;let p=await this.c;const R=p.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:M})=>this.h.isEqual(N,b)||this.h.isEqual(F,b)||this.h.isEqual(M,b));R!==-1&&(this.c=(0,L.$Sg)(async N=>{const F=[...p.resourcePreviews];return F[R]=await u(F[R]),{...p,resourcePreviews:F}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(b){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),b),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(b){const u=b.filter(({mergeState:p})=>p==="conflict");(0,O.$ub)(this.s,u,(p,R)=>this.h.isEqual(p.previewResource,R.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async db(b){const u=this.c?await this.c:null;if(u)for(const p of u.resourcePreviews){if(this.h.isEqual(p.acceptedResource,b))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,b))return p.remoteContent;if(this.h.isEqual(p.localResource,b))return p.localContent;if(this.h.isEqual(p.baseResource,b))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(b){(0,d.$Gk)(b)!==1&&this.O.error(b)}}async eb(b,u,p,R,N,F){const M=await this.qb(b,u,p,N,F),q=[];for(const Y of M){const K=Y.previewResource.with({scheme:h.$hnb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=R?await this.rb(Y,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,A.$ie.fromString(x?.content||""));const V=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,F):void 0;q.push({...Y,acceptResult:V,mergeState:x?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:x?x.localChange:Y.localChange,remoteChange:V?V.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:u,resourcePreviews:q,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let b=this.gb();if(b||(b=await this.jb()),!b)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(b),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!p&&u.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let R,N=1;for(;R===void 0&&N++<6;)try{const F=await this.hb();F&&(F.ref===u.ref?R=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof d.$Kk&&F.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof h.$8mb)throw F;this.O.error(F,N)}}if(R===void 0)try{const F=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);R=F===null?null:this.kb(F),await this.ib({ref:u.ref,syncData:R})}catch(F){if(F instanceof h.$8mb&&F.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return R===void 0?null:{...u,syncData:R}}async fb(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),R={ref:b.ref,version:p,...u};this.I.store(this.z,JSON.stringify(R),-1,1),await this.ib(b)}gb(){return this.I.get(this.z,-1)}async hb(){const b=(await this.G.readFile(this.y)).value.toString();try{const u=b?JSON.parse(b):void 0;if(i(u))return u}catch(u){this.O.error(u)}}async ib(b){await this.G.writeFile(this.y,A.$ie.fromString(JSON.stringify(b)))}async jb(){try{const b=await this.G.readFile(this.y),u=JSON.parse(b.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(b){b instanceof d.$Kk&&b.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(b)}return this.I.get(this.z,-1)}async getRemoteUserData(b){const{ref:u,content:p}=await this.lb(b);let R=null;return p!==null&&(R=this.kb(p)),{ref:u,syncData:R}}kb(b){try{const u=JSON.parse(b);if(o(u))return u}catch(u){this.O.error(u)}throw new h.$8mb((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(b){const u=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(b,u){const p=await this.j,R={version:this.pb,machineId:p,content:b};try{return u=await this.J.writeResource(this.resource,JSON.stringify(R),u,this.collection,this.F),{ref:u,syncData:R}}catch(N){throw N instanceof h.$8mb&&N.code==="TooLarge"&&(N=new h.$8mb(N.message,N.code,this.resource)),N}}async nb(b){const u={version:this.pb,content:b};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(h.$Umb)}};e.$oGb=n,e.$oGb=n=ye([X(2,d.$pk),X(3,l.$_h),X(4,c.$tp),X(5,h.$3mb),X(6,h.$4mb),X(7,h.$anb),X(8,f.$tl),X(9,h.$fnb),X(10,$.$yi),X(11,m.$Zk)],n);let t=class extends n{constructor(b,u,p,R,N,F,M,q,Y,K,x,V,Q){super(u,p,R,N,F,M,q,Y,K,x,V,Q),this.r=b,this.B(this.G.watch(this.h.dirname(b))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(b,u,p){try{u?await this.G.writeFile(this.r,A.$ie.fromString(b),p?void 0:u):await this.G.createFile(this.r,A.$ie.fromString(b),{overwrite:p})}catch(R){throw R instanceof d.$Kk&&R.fileOperationResult===1||R instanceof d.$Kk&&R.fileOperationResult===3?new h.$8mb(R.message,"LocalPreconditionFailed"):R}}async xb(){try{await this.G.del(this.r)}catch(b){if(!(b instanceof d.$Kk&&b.fileOperationResult===1))throw b}}yb(b){b.contains(this.r)&&this.Q()}};e.$pGb=t,e.$pGb=t=ye([X(3,d.$pk),X(4,l.$_h),X(5,c.$tp),X(6,h.$3mb),X(7,h.$4mb),X(8,h.$anb),X(9,f.$tl),X(10,h.$fnb),X(11,$.$yi),X(12,m.$Zk)],t);let r=class extends t{constructor(b,u,p,R,N,F,M,q,Y,K,x,V,Q,W){super(b,u,p,R,N,F,M,q,Y,K,x,Q,W),this.zb=V,this.Bb=void 0}Ab(b,u){const p=[],R=(0,C.$bn)(b,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,P.$Of)(R)&&u!==Array.isArray(R)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$qGb=r,e.$qGb=r=ye([X(3,d.$pk),X(4,l.$_h),X(5,c.$tp),X(6,h.$3mb),X(7,h.$4mb),X(8,h.$anb),X(9,f.$tl),X(10,h.$fnb),X(11,h.$enb),X(12,$.$yi),X(13,m.$Zk)],r);let a=class{constructor(b,u,p,R,N,F,M){this.resource=b,this.g=u,this.h=p,this.j=R,this.k=N,this.l=F,this.d=M.extUri,this.f=(0,h.$1mb)(void 0,this.resource,p,this.d)}async initialize({ref:b,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(u);if(p)try{await this.o({ref:b,syncData:p})}catch(R){this.j.error(R)}}m(b){try{const u=JSON.parse(b);if(o(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p={ref:b.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,A.$ie.fromString(JSON.stringify(b)))}};e.$rGb=a,e.$rGb=a=ye([X(1,v.$2k),X(2,l.$_h),X(3,y.$mj),X(4,d.$pk),X(5,c.$tp),X(6,m.$Zk)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,20,15,114,29,33,83,45,11,4,74,8,21,22,28,18,39,234,111,24,60]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v,i,o,s,n,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=e.$j7b=e.$i7b=e.$h7b=e.$g7b=void 0;async function E(F,M){const q=JSON.parse(F.content);if(F.version===1||F.version===2){const Y=(await M.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of q)F.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),F.version===2&&Y.every(x=>!(0,l.$Zo)(x.identifier,K.identifier))&&(K.installed=!0)}return q}function b(F){return JSON.parse(F.content)}e.$g7b=b;function u(F,M){return F.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,k.$4e)(q.identifier.id,Y.identifier.id)),M?(0,I.$mn)(F,{}):JSON.stringify(F)}e.$h7b=u;let p=class extends s.$oGb{constructor(M,q,Y,K,x,V,Q,W,G,te,re,ee,ae,Z,z,D,T){super({syncResource:"extensions",profile:M},q,K,Y,x,V,Q,ee,ae,te,re,z),this.Cb=W,this.Db=G,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$hnb,authority:"base"}),this.yb=this.wb.with({scheme:r.$hnb,authority:"local"}),this.zb=this.wb.with({scheme:r.$hnb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$hnb,authority:"accepted"}),this.Bb=this.Eb.createInstance(R),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:U})=>!!U)),j.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),j.Event.filter(D.onDidChange,B=>B.valueChanges.some(({profile:U,changes:_})=>this.syncResource.profile.id===U.id&&_.some(H=>H.key===$.$Ao))),Z.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,q){const Y=M.syncData?await E(M.syncData,this.Cb):null,K=q?.skippedExtensions??[],x=q?.builtinExtensions??null,V=q?.syncData?await E(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:G,remote:te}=(0,n.$f7b)(Q,Y,V,K,W,x),re={local:G,remote:te,content:this.Hb(Q,G.added,G.updated,G.removed),localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:te!==null?2:0},ee=this.Ob(Q,!1);return[{skippedExtensions:K,builtinExtensions:x,baseResource:this.xb,baseContent:V?this.Ob(V,!1):ee,localResource:this.yb,localContent:ee,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(M){const q=M.syncData?await E(M.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,n.$f7b)(Y,q,q,M.skippedExtensions||[],K,M.builtinExtensions||[]);return x!==null}Hb(M,q,Y,K){const x=[...q,...Y],V=new Set,Q=W=>{V.add(W.id.toLowerCase()),W.uuid&&V.add(W.uuid)};x.forEach(({identifier:W})=>Q(W)),K.forEach(Q);for(const W of M)V.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&V.has(W.identifier.uuid)||x.push(W);return this.Ob(x,!1)}async rb(M,q){return{...M.previewResult,hasConflicts:!1}}async sb(M,q,Y,K){if(this.h.isEqual(q,this.yb))return this.Kb(M);if(this.h.isEqual(q,this.zb))return this.Lb(M);if(this.h.isEqual(q,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(M){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=(0,n.$f7b)(M.localExtensions,null,null,M.skippedExtensions,Y,M.builtinExtensions),{local:x,remote:V}=K;return{content:M.localContent,local:x,remote:V,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:V!==null?2:0}}async Lb(M){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=M.remoteContent?JSON.parse(M.remoteContent):null;if(K!==null){const x=(0,n.$f7b)(M.localExtensions,K,M.localExtensions,[],Y,M.builtinExtensions),{local:V,remote:Q}=x;return{content:M.remoteContent,local:V,remote:Q,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,q,Y,K){let{skippedExtensions:x,builtinExtensions:V,localExtensions:Q}=Y[0][0];const{local:W,remote:G,localChange:te,remoteChange:re}=Y[0][1];if(te===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,x,this.syncResource.profile)),G){this.O.trace(`${this.D}: Updating remote extensions...`);const ee=JSON.stringify(G.all);M=await this.mb(ee,K?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${G.added.length?` Added: ${JSON.stringify(G.added.map(ae=>ae.identifier.id))}.`:""}${G.updated.length?` Updated: ${JSON.stringify(G.updated.map(ae=>ae.identifier.id))}.`:""}${G.removed.length?` Removed: ${JSON.stringify(G.removed.map(ae=>ae.identifier.id))}.`:""}`)}q?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(Q,V),await this.fb(M,{skippedExtensions:x,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ee=>ee.identifier.id))}.`:""}`))}Nb(M,q){const Y=new Set,K=[];for(const x of M)Y.add(x.identifier.id.toLowerCase()),x.installed||K.push(x.identifier);if(q)for(const x of q)Y.has(x.id.toLowerCase())||K.push(x);return K}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const q=await this.db(M);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(M,q){return u(M,q)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$i7b=p,e.$i7b=p=ye([X(2,P.$_h),X(3,w.$pk),X(4,h.$tp),X(5,r.$3mb),X(6,r.$4mb),X(7,$.$zo),X(8,t.$9Gb),X(9,r.$fnb),X(10,g.$yi),X(11,r.$anb),X(12,v.$tl),X(13,d.$lv),X(14,i.$Zk),X(15,a.$qFb),X(16,c.$4h)],p);let R=class{constructor(M,q,Y,K,x,V){this.a=M,this.b=q,this.c=Y,this.d=K,this.f=x,this.g=V}async getLocalExtensions(M){const q=await this.a.getInstalled(void 0,M.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(M,async(x,V)=>{const Q=x.getDisabledExtensions();return q.map(W=>{const{identifier:G,isBuiltin:te,manifest:re,preRelease:ee,pinned:ae,isApplicationScoped:Z}=W,z={identifier:G,preRelease:ee,version:re.version,pinned:!!ae};Z&&!(0,y.$nm)(re)&&(z.isApplicationScoped=Z),Q.some(D=>(0,l.$Zo)(D,G))&&(z.disabled=!0),te||(z.installed=!0);try{const D=V.getKeysForSync({id:G.id,version:re.version});if(D){const T=V.getExtensionState(W,!0)||{};z.state=Object.keys(T).reduce((B,U)=>(D.includes(U)&&(B[U]=T[U]),B),{})}}catch(D){this.g.info(`${(0,s.$nGb)("extensions",M)}: Error while parsing extension state`,(0,A.$0)(D))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(M,q,Y,K,x){const V=(0,s.$nGb)("extensions",x),Q=[],W=new Map,G=[],te=[],re=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Y.length)&&await this.j(x,async(Z,z)=>{await O.Promises.settled([...M,...Y].map(async D=>{const T=re.find(_=>(0,l.$Zo)(_.identifier,D.identifier));if(T&&T.isBuiltin){D.state&&T.manifest.version===D.version&&this.h(D.state,T,T.manifest.version,z),Z.getDisabledExtensions().some(H=>(0,l.$Zo)(H,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${V}: Disabling extension...`,D.identifier.id),await Z.disableExtension(D.identifier),this.g.info(`${V}: Disabled extension`,D.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,D.identifier.id),await Z.enableExtension(D.identifier),this.g.info(`${V}: Enabled extension`,D.identifier.id))),G.push(D.identifier);return}const B=D.pinned?D.version:void 0,U=(await this.c.getExtensions([{...D.identifier,version:B,preRelease:B?void 0:D.preRelease}],L.CancellationToken.None))[0];if(D.state&&(T?T.manifest.version===D.version:U)&&this.h(D.state,T||U,T?.manifest.version,z),U)try{Z.getDisabledExtensions().some(H=>(0,l.$Zo)(H,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${V}: Disabling extension...`,D.identifier.id,U.version),await Z.disableExtension(U.identifier),this.g.info(`${V}: Disabled extension`,D.identifier.id,U.version)):(this.g.trace(`${V}: Enabling extension...`,D.identifier.id,U.version),await Z.enableExtension(U.identifier),this.g.info(`${V}: Enabled extension`,D.identifier.id,U.version))),(!T||T.preRelease!==D.preRelease||T.pinned!==D.pinned||B&&T.manifest.version!==B)&&(await this.a.canInstall(U)?(Q.push({extension:U,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:D.pinned&&!!D.version,installPreReleaseVersion:D.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:D.isApplicationScoped,context:{[$.$oo]:!0,[$.$po]:!0}}}),W.set(U.identifier.id.toLowerCase(),D)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),te.push(D)))}catch(_){te.push(D),this.g.error(_),this.g.info(`${V}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else te.push(D),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}))}),q.length){const Z=re.filter(({identifier:z,isBuiltin:D})=>!D&&q.some(T=>(0,l.$Zo)(z,T)));await O.Promises.settled(Z.map(async z=>{this.g.trace(`${V}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,z.identifier.id),G.push(z.identifier)}))}const ee=await this.a.installGalleryExtensions(Q);for(const{identifier:Z,local:z,error:D,source:T}of ee){const B=T;if(z)this.g.info(`${V}: Installed extension.`,Z.id,B.version),G.push(Z);else{const U=W.get(Z.id.toLowerCase());U&&(te.push(U),this.g.info(`${V}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),D instanceof $.$yo&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(D.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):D&&this.g.error(D)}}const ae=[];for(const Z of K)G.some(z=>(0,l.$Zo)(z,Z.identifier))||ae.push(Z);for(const Z of te)ae.some(z=>(0,l.$Zo)(z.identifier,Z.identifier))||ae.push(Z);return ae}h(M,q,Y,K){const x=K.getExtensionState(q,!0)||{},V=Y?K.getKeysForSync({id:q.identifier.id,version:Y}):void 0;V?V.forEach(Q=>{x[Q]=M[Q]}):Object.keys(M).forEach(Q=>x[Q]=M[Q]),K.setExtensionState(q,x,!0)}async j(M,q){return this.b.withProfileScopedStorageService(M,async Y=>{const K=new C.$Sc,x=this.f.createChild(new f.$3h([h.$tp,Y])),V=K.add(x.createInstance(S.$OEb)),Q=K.add(x.createInstance(d.$mv));try{return await q(V,Q)}finally{K.dispose()}})}};e.$j7b=R,e.$j7b=R=ye([X(0,$.$zo),X(1,a.$qFb),X(2,$.$xo),X(3,t.$9Gb),X(4,c.$4h),X(5,r.$fnb)],R);let N=class extends s.$rGb{constructor(M,q,Y,K,x,V,Q,W){super("extensions",K,x,V,Y,Q,W),this.p=M,this.q=q}async t(M){return M.syncData?await E(M.syncData,this.p):null}u(M,q){const Y=[],K=[],x=[];for(const V of M){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const Q=q.find(W=>(0,l.$Zo)(W.identifier,V.identifier));Q?(Y.push(Q),V.disabled&&x.push(V.identifier)):V.installed&&(K.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&x.push(V.identifier))}return{installedExtensions:Y,newExtensions:K,disabledExtensions:x,remoteExtensions:M}}};e.$k7b=N,e.$k7b=N=ye([X(0,$.$zo),X(1,t.$9Gb),X(2,w.$pk),X(3,o.$2k),X(4,P.$_h),X(5,m.$mj),X(6,h.$tp),X(7,i.$Zk)],N)}),define(le[116],he([0,1,14,7,3,34,42,5,32,20,15,11,8,43,21,22,28,39,80,238,24,18,60,4]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xGb=e.$wGb=e.$vGb=e.$uGb=e.$tGb=void 0;const s="globalState.argv.",n=["locale"];function t(p,R){const N=p.storage?Object.keys(p.storage).sort():[],F={};return N.forEach(M=>F[M]=p.storage[M]),p.storage=F,R?(0,I.$mn)(p,{}):JSON.stringify(p)}e.$tGb=t;const r=1;let a=class extends c.$oGb{constructor(R,N,F,M,q,Y,K,x,V,Q,W,G,te,re){super({syncResource:"globalState",profile:R},N,M,x,G,q,Y,V,Q,K,W,te),this.Bb=F,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:h.$hnb,authority:"base"}),this.xb=this.vb.with({scheme:h.$hnb,authority:"local"}),this.yb=this.vb.with({scheme:h.$hnb,authority:"remote"}),this.zb=this.vb.with({scheme:h.$hnb,authority:"accepted"}),this.Ab=re.createInstance(E),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(M.onDidFilesChange,ee=>ee.contains(this.H.argvResource)),A.Event.filter(F.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:Z})=>this.syncResource.profile.id===ae.id&&Z.some(z=>z.target===0)))))(()=>this.Q()))}async qb(R,N,F){const M=R.syncData?JSON.parse(R.syncData.content):null;N=N===null&&F?R:N;const q=N&&N.syncData?JSON.parse(N.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(q),{local:x,remote:V}=(0,m.$sGb)(Y.storage,M?M.storage:null,q?q.storage:null,K,this.O),Q={content:null,local:x,remote:V,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:V.all!==null?2:0},W=t(Y,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):W,localResource:this.xb,localContent:W,localUserData:Y,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(R){const N=R.syncData?JSON.parse(R.syncData.content):null;if(N===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(N),{remote:q}=(0,m.$sGb)(F.storage,N.storage,N.storage,M,this.O);return q.all!==null}async rb(R,N){return{...R.previewResult,hasConflicts:!1}}async sb(R,N,F,M){if(this.h.isEqual(N,this.xb))return this.Gb(R);if(this.h.isEqual(N,this.yb))return this.Hb(R);if(this.h.isEqual(N,this.vb))return R.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(R.localUserData.storage),removed:[],updated:[],all:R.localUserData.storage},localChange:0,remoteChange:2}}async Hb(R){if(R.remoteContent!==null){const N=JSON.parse(R.remoteContent),{local:F,remote:M}=(0,m.$sGb)(R.localUserData.storage,N.storage,null,R.storageKeys,this.O);return{content:R.remoteContent,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(R,N,F,M){const{localUserData:q}=F[0][0],{local:Y,remote:K,localChange:x,remoteChange:V}=F[0][1];if(x===0&&V===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:K.all});R=await this.mb(Q,M?null:R.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}N?.ref!==R.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(R),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(R){if(this.h.isEqual(this.yb,R)||this.h.isEqual(this.wb,R)||this.h.isEqual(this.xb,R)||this.h.isEqual(this.zb,R)){const N=await this.db(R);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:R}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(R).length>1||R[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(R){const N=await this.Bb.readStorageData(this.syncResource.profile),F=[],M=[];for(const[K,x]of N)x.target===0?F.push(K):x.target===1&&M.push(K);const q=[...F,...M],Y=R?.storage?Object.keys(R.storage).filter(K=>!K.startsWith(s)&&!q.includes(K)&&N.get(K)!==void 0):[];if(!C.$o){const K=[...h.$Ymb.map(x=>(0,h.$_mb)(x)),h.$$mb];Y.push(...K),M.push(...K)}return{user:F,machine:M,unregistered:Y}}};e.$uGb=a,e.$uGb=a=ye([X(2,i.$qFb),X(3,S.$pk),X(4,h.$3mb),X(5,h.$4mb),X(6,h.$fnb),X(7,P.$_h),X(8,h.$anb),X(9,y.$tl),X(10,g.$yi),X(11,d.$tp),X(12,w.$Zk),X(13,o.$4h)],a);let E=class{constructor(R,N,F,M){this.a=R,this.b=N,this.c=F,this.d=M}async getLocalGlobalState(R){const N={};if(R.isDefault){const M=await this.f(),q=(0,j.$bn)(M);for(const Y of n)q[Y]!==void 0&&(N[`${s}${Y}`]={version:1,value:q[Y]})}const F=await this.c.readStorageData(R);for(const[M,q]of F)q.value&&q.target===0&&(N[M]={version:1,value:q.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const R=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),R.value.toString()}catch(R){this.d.debug((0,L.$0)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:N,updated:F},M){const q=(0,c.$nGb)("globalState",M),Y={},K=new Map,x=await this.c.readStorageData(M),V=(Q,W)=>{for(const G of Q){if(G.startsWith(s)){Y[G.substring(s.length)]=W?W[G].value:void 0;continue}if(W){const te=W[G];te.value!==x.get(G)?.value&&K.set(G,te.value)}else x.get(G)!==void 0&&K.set(G,void 0)}};if(V(Object.keys(R),R),V(Object.keys(F),F),V(N),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let W=Q;for(const G of Object.keys(Y))W=(0,f.edit)(W,[G],Y[G],{});Q!==W&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$ie.fromString(W)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}K.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(M,K,0),this.d.info(`${q}: Updated global state`,[...K.keys()]))}};e.$vGb=E,e.$vGb=E=ye([X(0,S.$pk),X(1,P.$_h),X(2,i.$qFb),X(3,h.$fnb)],E);let b=class extends c.$rGb{constructor(R,N,F,M,q,Y){super("globalState",F,M,q,N,R,Y)}async o(R){const N=R.syncData?JSON.parse(R.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},M={};for(const q of Object.keys(N.storage))q.startsWith(s)?F[q.substring(s.length)]=N.storage[q].value:this.l.get(q,0)===void 0&&(M[q]=N.storage[q].value);if(Object.keys(F).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(F))q=(0,f.edit)(q,[Y],F[Y],{});await this.k.writeFile(this.h.argvResource,O.$ie.fromString(q))}if(Object.keys(M).length){const q=[];for(const Y of Object.keys(M))q.push({key:Y,value:M[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$wGb=b,e.$wGb=b=ye([X(0,d.$tp),X(1,S.$pk),X(2,v.$2k),X(3,P.$_h),X(4,h.$fnb),X(5,w.$Zk)],b);let u=class{constructor(R,N,F,M,q){this.a=R,this.b=N,this.c=F,this.d=M,this.f=q}getSyncStoreType(R){return this.h(R)?.storage[h.$$mb]?.value}async sync(R){const N=(0,h.$7mb)((0,k.$pg)());try{return await this.g(R,N)}catch(F){if(F instanceof h.$8mb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(R,N)}throw F}}async g(R,N){const F=await this.a.readResource("globalState",null,void 0,N),M=this.h(F)||{storage:{}};M.storage[h.$$mb]={value:R,version:r};const q=await(0,l.$zp)(this.c,this.d,this.b),Y={version:r,machineId:q,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),F.ref,void 0,N)}h({content:R}){if(!R)return null;const N=JSON.parse(R);if((0,c.$mGb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$xGb=u,e.$xGb=u=ye([X(1,d.$tp),X(2,P.$_h),X(3,S.$pk),X(4,$.$mj)],u)}),define(le[117],he([0,1,17,14,3,34,5,12,170,20,15,11,21,22,28,18,39,235,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=e.$n7b=e.$m7b=void 0;function m(i,o,s){try{const n=JSON.parse(i);if(!o)return(0,C.$Of)(n.all)?null:n.all;switch(I.OS){case 2:return(0,C.$Of)(n.mac)?null:n.mac;case 3:return(0,C.$Of)(n.linux)?null:n.linux;case 1:return(0,C.$Of)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.$m7b=m;let h=class extends w.$qGb{constructor(o,s,n,t,r,a,E,b,u,p,R,N,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},s,b,u,p,n,t,E,N,r,R,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$hnb,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$hnb,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$hnb,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$hnb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,s,n,t){const r=o.syncData?m(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&n?o:s;const a=s?this.Ob(s):null,E=await this.vb(),b=await this.Cb();let u=null,p=!1,R=!1,N=!1;if(r){let q=E?E.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new f.$8mb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,c.$l7b)(q,r,a,b,this.zb);Y.hasChanges&&(u=Y.mergeContent,N=Y.hasConflicts,p=N||Y.mergeContent!==q,R=N||Y.mergeContent!==r)}}else E&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=E.value.toString(),R=!0);const F={content:N?a:u,localChange:p?E?2:1:0,remoteChange:R?2:0,hasConflicts:N},M=E?E.value.toString():null;return[{fileContent:E,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:F.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(o){const s=this.Ob(o);if(s===null)return!0;const n=await this.vb(),t=n?n.value.toString():"",r=await this.Cb(),a=await(0,c.$l7b)(t||"[]",s,s,r,this.zb);return a.hasConflicts||a.mergeContent!==s}async rb(o,s){return o.previewResult}async sb(o,s,n,t){if(this.h.isEqual(s,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.Eb))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(o,s,n,t){const{fileContent:r}=n[0][0];let{content:a,localChange:E,remoteChange:b}=n[0][1];if(E===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new f.$8mb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),b!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(u,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const s=(0,j.$bn)(o.value.toString());if((0,O.$Lb)(s))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:m(o.syncData.content,this.Qb(),this.O)}Pb(o,s){let n={};try{n=JSON.parse(s||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete n.all:n.all=o,I.OS){case 2:n.mac=o;break;case 3:n.linux=o;break;case 1:n.windows=o;break}return JSON.stringify(n)}Qb(){return!!this.P.getValue(f.$Vmb)}};e.$n7b=h,e.$n7b=h=ye([X(2,f.$3mb),X(3,f.$4mb),X(4,f.$fnb),X(5,g.$yi),X(6,f.$anb),X(7,S.$pk),X(8,P.$_h),X(9,$.$tp),X(10,f.$enb),X(11,l.$tl),X(12,d.$Zk)],h);let v=class extends w.$rGb{constructor(o,s,n,t,r,a){super("keybindings",s,n,t,o,r,a)}async o(o){const s=o.syncData?this.p(o.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,L.$ie.fromString(s)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,j.$bn)(o.value.toString());return!(0,O.$Lb)(s)}catch(o){return o.fileOperationResult===1}}p(o){try{return m(o,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$o7b=v,e.$o7b=v=ye([X(0,S.$pk),X(1,y.$2k),X(2,P.$_h),X(3,f.$fnb),X(4,$.$tp),X(5,d.$Zk)],v)}),define(le[118],he([0,1,14,3,171,20,76,15,29,11,21,22,28,18,39,239,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=e.$q7b=e.$p7b=void 0;function c(v){return v&&v.settings&&typeof v.settings=="string"&&Object.keys(v).length===1}function f(v){const i=JSON.parse(v);return c(i)?i:{settings:v}}e.$p7b=f;let m=class extends d.$qGb{constructor(i,o,s,n,t,r,a,E,b,u,p,R,N,F){super(i.settingsResource,{syncResource:"settings",profile:i},o,s,n,t,r,a,p,R,E,b,u,F),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$hnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$hnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$hnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$hnb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),s=await this.X(i,o),n=this.Lb(s),t=new I.$3n(w.$Umb);return n?.settings&&t.parse(n.settings),t.configurationModel.getValue(w.$Umb)||{}}async qb(i,o,s){const n=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&s?i:o;const a=o?this.Lb(o):null,E=await this.Pb();let b=null,u=!1,p=!1,R=!1;if(r){let q=n?n.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,y.$0Eb)(q,r.settings,a?a.settings:null,E,[],t);b=Y.localContent||Y.remoteContent,u=Y.localContent!==null,p=Y.remoteContent!==null,R=Y.hasConflicts}else n&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),b=n.value.toString().trim()||"{}",this.Qb(b),p=!0);const N=n?n.value.toString():null,F=a?.settings??null,M={content:R?F:b,localChange:u?2:0,remoteChange:p?2:0,hasConflicts:R};return[{fileContent:n,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:N,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const s=await this.vb(),n=s?s.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$0Eb)(n||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const s=await this.Cb(),n=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,y.$9Eb)(i.previewResult.content,"{}",n,s):null}}async sb(i,o,s,n){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,y.$9Eb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,y.$9Eb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return s===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:s!==null?(0,y.$9Eb)(s,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,s,n){const{fileContent:t}=s[0][0];let{content:r,localChange:a,remoteChange:E}=s[0][1];if(a===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,n),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),E!==0){const b=await this.Cb(),u=this.Lb(i),p=await this.Pb(r);r=(0,y.$9Eb)(r,u?u.settings:"{}",p,b),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),n?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,y.$$Eb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const s=await this.Cb(),n=await this.Pb();o=(0,y.$9Eb)(o,"{}",n,s)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return f(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const s=this.B(L.Event.any(L.Event.filter(this.Eb.onDidInstallExtensions,n=>n.some(({local:t})=>!!t)),L.Event.filter(this.Eb.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,y.$7Eb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new w.$8mb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$q7b=m,e.$q7b=m=ye([X(2,g.$pk),X(3,C.$_h),X(4,P.$tp),X(5,w.$3mb),X(6,w.$4mb),X(7,w.$fnb),X(8,w.$enb),X(9,j.$yi),X(10,w.$anb),X(11,S.$tl),X(12,k.$zo),X(13,$.$Zk)],m);let h=class extends d.$rGb{constructor(i,o,s,n,t,r){super("settings",o,s,n,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$ie.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$$Eb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return f(i)}catch(o){this.j.error(o)}return null}};e.$r7b=h,e.$r7b=h=ye([X(0,g.$pk),X(1,l.$2k),X(2,C.$_h),X(3,w.$fnb),X(4,P.$tp),X(5,$.$Zk)],h)}),define(le[119],he([0,1,14,3,30,20,15,11,21,22,28,18,39,236,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.$v7b=e.$u7b=void 0;function y(f){return JSON.parse(f.content)}e.$u7b=y;let w=class extends $.$oGb{constructor(m,h,v,i,o,s,n,t,r,a,E,b){super({syncResource:"snippets",profile:m},h,i,v,o,s,n,a,E,t,r,b),this.pb=1,this.vb=m.snippetsHome,this.B(this.G.watch(v.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(L.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb(m,h,v){const i=await this.Hb(),o=this.Gb(i),s=m.syncData?this.Fb(m.syncData):null;h=h===null&&v?m:h;const n=h&&h.syncData?this.Fb(h.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$s7b)(o,s,n);return this.Bb(t,i,s||{},n||{})}async ub(m){const h=m.syncData?this.Fb(m.syncData):null;if(h===null)return!0;const v=await this.Hb(),i=this.Gb(v),o=(0,l.$s7b)(i,h,h);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(m,h){return m.previewResult}async sb(m,h,v,i){if(this.h.isEqualOrParent(h,this.g.with({scheme:d.$hnb,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(h,this.g.with({scheme:d.$hnb,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(h,this.g))return v===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:v,localChange:v===null?m.fileContent!==null?3:0:2,remoteChange:v===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async tb(m,h,v,i){const o=v.map(([s,n])=>({...s,acceptResult:n}));o.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:s})=>s!==0)&&(m=await this.Eb(o,m,i)),h?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.G.del(s)}catch{}}Bb(m,h,v,i){const o=new Map;for(const s of Object.keys(m.local.added)){const n={content:m.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:v[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}for(const s of Object.keys(m.local.updated)){const n={content:m.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:i[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:v[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}for(const s of m.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:i[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}for(const s of Object.keys(m.remote.added)){const n={content:m.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:i[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}for(const s of Object.keys(m.remote.updated)){const n={content:m.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:i[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:v[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}for(const s of m.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:i[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:v[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}for(const s of m.conflicts){const n={content:i[s]??null,hasConflicts:!0,localChange:h[s]?2:1,remoteChange:v[s]?2:1},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:i[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),fileContent:h[s]||null,localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:v[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}for(const s of Object.keys(h))if(!o.has(s)){const n={content:h[s]?h[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"base"}),baseContent:i[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"local"}),fileContent:h[s]||null,localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"remote"}),remoteContent:v[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$hnb,authority:"accepted"})})}return[...o.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:d.$hnb,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:d.$hnb,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:d.$hnb,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:d.$hnb,authority:"accepted"}))?this.db(m):null}async hasLocalData(){try{const m=await this.Hb();if(Object.keys(m).length)return!0}catch{}return!1}async Cb(m){const h={};for(const v of m)v.fileContent&&(h[this.h.basename(v.localResource)]=v.fileContent);await this.nb(JSON.stringify(this.Gb(h)))}async Db(m,h){for(const{fileContent:v,acceptResult:i,localResource:o,remoteResource:s,localChange:n}of m)if(n!==0){const t=s?this.h.basename(s):this.h.basename(o),r=this.h.joinPath(this.vb,t);n===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):n===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$ie.fromString(i.content),{overwrite:h}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$ie.fromString(i.content),h?void 0:v),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(m,h,v){const i=h.syncData?this.Fb(h.syncData):{},o=(0,A.$un)(i);for(const{acceptResult:s,localResource:n,remoteResource:t,remoteChange:r}of m)if(r!==0){const a=n?this.h.basename(n):this.h.basename(t);r===3?delete o[a]:o[a]=s.content}return(0,l.$t7b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),h=await this.mb(JSON.stringify(o),v?null:h.ref),this.O.info(`${this.D}: Updated remote snippets`)),h}Fb(m){return y(m)}Gb(m){const h={};for(const v of Object.keys(m))h[v]=m[v].value.toString();return h}async Hb(){const m={};let h;try{h=await this.G.resolve(this.vb)}catch(v){if(v instanceof C.$Kk&&v.fileOperationResult===1)return m;throw v}for(const v of h.children||[]){const i=v.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const s=this.h.relativePath(this.vb,i),n=await this.G.readFile(i);m[s]=n}}return m}};e.$v7b=w,e.$v7b=w=ye([X(2,I.$_h),X(3,C.$pk),X(4,k.$tp),X(5,d.$3mb),X(6,d.$4mb),X(7,d.$fnb),X(8,j.$yi),X(9,d.$anb),X(10,g.$tl),X(11,P.$Zk)],w);let c=class extends $.$rGb{constructor(m,h,v,i,o,s){super("snippets",h,v,i,m,o,s)}async o(m){const h=m.syncData?JSON.parse(m.syncData.content):null;if(!h){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(h)){const o=h[i];if(o){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(s,O.$ie.fromString(o)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(m)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};e.$w7b=c,e.$w7b=c=ye([X(0,C.$pk),X(1,S.$2k),X(2,I.$_h),X(3,d.$fnb),X(4,k.$tp),X(5,P.$Zk)],c)}),define(le[120],he([0,1,14,20,15,11,21,22,28,18,39,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=e.$y7b=e.$x7b=void 0;function $(w,c){try{return JSON.parse(w).tasks??null}catch(f){return c.error(f),null}}e.$x7b=$;let l=class extends P.$pGb{constructor(c,f,m,h,v,i,o,s,n,t,r,a){super(c.tasksResource,{syncResource:"tasks",profile:c},f,s,n,t,m,h,o,r,v,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$hnb,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$hnb,authority:"local"}),this.Db=this.Ab.with({scheme:S.$hnb,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$hnb,authority:"accepted"})}async qb(c,f,m,h){const v=c.syncData?$(c.syncData.content,this.O):null;f=f===null&&m?c:f;const i=f?.syncData?$(f.syncData.content,this.O):null,o=await this.vb();let s=null,n=!1,t=!1,r=!1;if(c.syncData){const b=o?o.value.toString():null;if(!i||i!==b||i!==v){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=y(b,v,i);s=u.content,r=u.hasConflicts,n=u.hasLocalChanged,t=u.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=o.value.toString(),t=!0);const a={content:r?i:s,localChange:n?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},E=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:E,localChange:a.localChange,remoteResource:this.Db,remoteContent:v,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(c){const f=c?.syncData?$(c.syncData.content,this.O):null;if(f===null)return!0;const m=await this.vb(),h=m?m.value.toString():null,v=y(h,f,f);return v.hasLocalChanged||v.hasRemoteChanged}async rb(c,f){return c.previewResult}async sb(c,f,m,h){if(this.h.isEqual(f,this.Cb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.Db))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.Ab))return m===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(c,f,m,h){const{fileContent:v}=m[0][0],{content:i,localChange:o,remoteChange:s}=m[0][1];if(o===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),v&&await this.nb(JSON.stringify(this.Kb(v.value.toString()))),i?await this.wb(i,v,h):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const n=JSON.stringify(this.Kb(i));c=await this.mb(n,h?null:c.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(c){return this.h.isEqual(this.Db,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Eb,c)?this.db(c):null}Kb(c){return c?{tasks:c}:{}}};e.$y7b=l,e.$y7b=l=ye([X(2,S.$3mb),X(3,S.$4mb),X(4,S.$fnb),X(5,L.$yi),X(6,S.$anb),X(7,j.$pk),X(8,A.$_h),X(9,I.$tp),X(10,C.$tl),X(11,k.$Zk)],l);let d=class extends P.$rGb{constructor(c,f,m,h,v,i){super("tasks",f,m,h,c,v,i),this.c=this.g.defaultProfile.tasksResource}async o(c){const f=c.syncData?$(c.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$ie.fromString(f)),await this.n(c)}async p(){return this.k.exists(this.c)}};e.$z7b=d,e.$z7b=d=ye([X(0,j.$pk),X(1,g.$2k),X(2,A.$_h),X(3,S.$fnb),X(4,I.$tp),X(5,k.$Zk)],d);function y(w,c,f){if(w===null&&c===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=f!==w,h=f!==c;return!m&&!h?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!h?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:h&&!m?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,20,15,11,21,22,28,18,39,237,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=e.$f9b=e.$e9b=void 0;let l=class extends P.$oGb{constructor(c,f,m,h,v,i,o,s,n,t,r,a,E){super({syncResource:"profiles",profile:c},f,h,v,i,o,s,r,a,n,t,E),this.vb=m,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$hnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$hnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$hnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$hnb,authority:"accepted"}),this.B(m.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?y(c.syncData):null}async getRemoteSyncedProfiles(c){const f=await this.getLastSyncUserData(),m=await this.X(c,f);return m?.syncData?y(m.syncData):null}async qb(c,f,m){if(!this.vb.isEnabled())throw new $.$8mb("Cannot sync profiles because they are disabled","LocalError");const h=c.syncData?y(c.syncData):null,v=f?.syncData?y(f.syncData):null,i=this.Db(),{local:o,remote:s}=(0,S.$d9b)(i,h,v,[]),n={local:o,remote:s,content:v?this.Eb(v):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:s!==null?2:0},t=d(i,!1);return[{baseResource:this.baseResource,baseContent:v?this.Eb(v):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:h?this.Eb(h):null,remoteProfiles:h,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async ub(c){const f=c?.syncData?y(c.syncData):null,m=this.Db(),{remote:h}=(0,S.$d9b)(m,f,f,[]);return!!h?.added.length||!!h?.removed.length||!!h?.updated.length}async rb(c,f){return{...c.previewResult,hasConflicts:!1}}async sb(c,f,m,h){if(this.h.isEqual(f,this.localResource))return this.Ab(c);if(this.h.isEqual(f,this.remoteResource))return this.Bb(c);if(this.h.isEqual(f,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(c){const f=this.Db(),m=(0,S.$d9b)(f,null,null,[]),{local:h,remote:v}=m;return{content:c.localContent,local:h,remote:v,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?2:0,remoteChange:v!==null?2:0}}async Bb(c){const f=c.remoteContent?JSON.parse(c.remoteContent):null,m=[],h=[];for(const v of this.Db()){const i=f?.find(o=>o.id===v.id);i&&(m.push({id:v.id,name:v.name,collection:i.collection}),h.push(v))}if(f!==null){const v=(0,S.$d9b)(h,f,m,[]),{local:i,remote:o}=v;return{content:c.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(c,f,m,h){const{local:v,remote:i,localChange:o,remoteChange:s}=m[0][1];o===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const n=m[0][0].remoteProfiles||[];if(n.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new $.$8mb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(d(this.Db(),!1));const t=[];for(const r of v.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of v.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of v.updated){const a=this.vb.profiles.find(E=>E.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(s!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=n.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const E=await this.J.createCollection(this.F);t.push(E),n.push({id:a.id,name:a.name,collection:E,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])n.splice(n.findIndex(({id:E})=>a.id===E),1);for(const a of i?.updated||[]){const E=n.find(({id:b})=>a.id===b);E&&n.splice(n.indexOf(E),1,{...E,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{c=await this.updateRemoteProfiles(n,h?null:c.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of t)await this.J.deleteCollection(E,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}f?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,f){return this.mb(this.Eb(c),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(c){if(this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.baseResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)){const f=await this.db(c);return f&&(0,O.$mn)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(c=>!c.isDefault&&!c.isTransient)}Eb(c){return JSON.stringify([...c].sort((f,m)=>f.name.localeCompare(m.name)))}};e.$e9b=l,e.$e9b=l=ye([X(2,g.$2k),X(3,j.$pk),X(4,A.$_h),X(5,I.$tp),X(6,$.$3mb),X(7,$.$4mb),X(8,$.$fnb),X(9,L.$yi),X(10,$.$anb),X(11,C.$tl),X(12,k.$Zk)],l);function d(w,c){const f=[...w].sort((m,h)=>m.name.localeCompare(h.name)).map(m=>({id:m.id,name:m.name}));return c?(0,O.$mn)(f,{}):JSON.stringify(f)}e.$f9b=d;function y(w){return JSON.parse(w.content)}e.$g9b=y}),define(le[255],he([0,1,3,2,5,15,21,22,24]),function(ne,e,O,L,A,j,I,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=void 0;const g="sync.enable";let P=class extends L.$Tc{constructor($,l,d,y){super(),this.c=$,this.f=l,this.g=d,this.h=y,this.a=new O.$Ud,this.onDidChangeEnablement=this.a.event,this.b=new O.$Ud,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(-1,void 0,this.B(new L.$Sc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:$}),this.c.store(g,$,-1,1))}isResourceEnabled($){return this.c.getBoolean((0,k.$_mb)($),-1,!0)}setResourceEnablement($,l){if(this.isResourceEnabled($)!==l){const d=(0,k.$_mb)($);this.j(d,l)}}getResourceSyncStateVersion($){}j($,l){this.c.store($,l,-1,A.$o?0:1)}m($){if(g===$.key){this.a.fire(this.isEnabled());return}const l=k.$Ymb.filter(d=>(0,k.$_mb)(d)===$.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$48b=P,e.$48b=P=ye([X(0,I.$tp),X(1,C.$tl),X(2,j.$_h),X(3,k.$2mb)],P)}),define(le[256],he([0,1,6,14,65,2,19,20,15,11,18,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9b=void 0;let $=class extends j.$Tc{constructor(d,y,w,c,f){super(),this.a=d,this.b=y,this.c=w,this.f=c,this.g=f,this.h()}async h(){for(const y of this.g.profiles)for(const w of S.$Ymb)try{await this.m(this.j(w,y.isDefault?void 0:y.id))}catch(c){this.f.error(c)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,g.$Gk)(y)!==1&&this.f.error(y);return}if(d.children){for(const y of d.children)if(y.isDirectory&&!this.g.profiles.some(w=>w.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(d,y,w){const c=this.j(d,y,w);try{const f=await this.b.resolve(c);if(f.children)return f.children.filter(h=>h.isFile&&!h.name.startsWith("lastSync")).sort().reverse().map(h=>({ref:h.name,created:this.n(h)}))}catch(f){if((0,g.$Gk)(f)!==1)throw f}return[]}async resolveResourceContent(d,y,w,c){const f=this.j(d,w,c),m=(0,I.$Gg)(f,y);try{return(await this.b.readFile(m)).value.toString()}catch(h){return this.f.error(h),null}}async writeResource(d,y,w,c,f){const m=this.j(d,c,f),h=(0,I.$Gg)(m,`${(0,A.$vm)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(h,L.$ie.fromString(y))}catch(v){this.f.error(v)}}j(d,y,w=this.a.userDataSyncHome){return(0,I.$Gg)(w,...y?[y,d]:[d])}async m(d){try{try{if(!await this.b.exists(d))return}catch{return}const y=await this.b.resolve(d);if(y.children){const w=y.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort(),c=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=w.filter(h=>Date.now()-this.n(h)>c);const m=w.length-f.length;m<10&&(f=f.slice(10-m)),await O.Promises.settled(f.map(async h=>{this.f.info("Deleting from backup",h.resource.path),await this.b.del(h.resource)}))}}catch(y){this.f.error(y)}}n(d){return new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.$c9b=$,e.$c9b=$=ye([X(0,k.$_h),X(1,g.$pk),X(2,C.$yi),X(3,S.$fnb),X(4,P.$2k)],$)}),define(le[84],he([0,1,3,2,5,27,175,15,11,4,25,43,21,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmb=e.$Qmb=e.$Pmb=void 0,e.$Pmb=(0,g.$5h)("IUserDataSyncMachinesService");const y="sync.currentMachineName",w="Safari",c="Chrome",f="Edge",m="Firefox",h="Android";function v(s){switch(s){case w:case c:case f:case m:case h:case(0,A.$h)(0):return!0}return!1}e.$Qmb=v;function i(){return A.$G?w:A.$E?c:A.$H?f:A.$F?m:A.$I?h:(0,A.$h)(A.$o?0:A.$u)}let o=class extends L.$Tc{static{d=this}static{this.a=1}static{this.b="machines"}constructor(n,t,r,a,E,b){super(),this.h=r,this.j=a,this.m=E,this.n=b,this.c=this.B(new O.$Ud),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$zp)(n,t,r)}async getMachines(n){const t=await this.f;return(await this.s(n)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(n){const t=await this.f,r=await this.s(n);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(n){const t=await this.f,r=await this.s(n),a=r.machines.filter(({id:E})=>E!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(n,t,r){const a=await this.s(r),E=a.machines.find(({id:b})=>b===n);if(E){E.name=t,await this.t(a);const b=await this.f;n===b&&this.h.store(y,t,-1,1)}}async setEnablements(n){const t=await this.s();for(const[r,a]of n){const E=t.machines.find(b=>b.id===r);E&&(E.disabled=a?void 0:!0)}await this.t(t)}r(n){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Ne)(r)}\\s#(\\d+)`);let E=0;for(const b of n){const u=a.exec(b.name),p=u?parseInt(u[1]):0;E=p>E?p:E}return`${r} #${E+1}`}async s(n){this.g=await this.u(n);const t=this.w(this.g);if(t.version!==d.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return t}async t(n){const t=JSON.stringify(n),r=await this.j.writeResource(d.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(n){if(this.g){const t=n&&n.latest?n.latest[d.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(d.b,this.g)}w(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(t){this.m.error(t)}return{version:d.a,machines:[]}}};e.$Rmb=o,e.$Rmb=o=d=ye([X(0,C.$_h),X(1,k.$pk),X(2,$.$tp),X(3,l.$3mb),X(4,l.$fnb),X(5,P.$Ej)],o)}),define(le[257],he([0,1,6,65,38,7,3,2,5,19,10,172,25,21,22,24,81,84]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i9b=void 0;const f="sync.disableMachineEventually",m="sync.sessionId",h="sync.storeUrl",v="sync.productQuality";let i=class extends C.$Tc{get n(){const n=this.H.get(h,-1);return n?P.URI.parse(n):void 0}set n(n){n?this.H.store(h,n.toString(),-1,1):this.H.remove(h,-1)}get s(){return this.H.get(v,-1)}set s(n){n?this.H.store(v,n,-1,1):this.H.remove(v,-1)}constructor(n,t,r,a,E,b,u,p,R,N){super(),this.u=t,this.w=r,this.y=a,this.z=E,this.C=b,this.D=u,this.F=p,this.G=R,this.H=N,this.a=this.B(new C.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$Ud),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$3g(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=n.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$zg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(E.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:n,message:t}=this.L();n?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.$vm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(n,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(m,-1),n?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(n){this.y.isEnabled()!==n&&(this.y.setEnablement(n),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(n){if(!n){this.b=0;return}const t=y.$8mb.toUserDataSyncError(n);t instanceof y.$0mb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(f,!0,-1,1),await(0,O.$6g)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,-1,!1)}R(){this.H.remove(f,-1)}async triggerSync(n,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...n),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$i9b=i,e.$i9b=i=ye([X(0,$.$Ej),X(1,y.$2mb),X(2,y.$3mb),X(3,y.$anb),X(4,y.$bnb),X(5,y.$fnb),X(6,w.$QEb),X(7,d.$tl),X(8,c.$Pmb),X(9,l.$tp)],i);class o extends C.$Tc{static{this.a="Interval"}constructor(n,t,r,a,E,b,u,p,R){super(),this.m=n,this.n=t,this.r=r,this.s=a,this.u=E,this.w=b,this.y=u,this.z=p,this.C=R,this.b=this.B(new C.$Uc),this.c=this.B(new I.$Ud),this.onDidStartSync=this.c.event,this.f=this.B(new I.$Ud),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,C.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,O.$7g)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(n,t){const r=(0,O.$Sg)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(E){if((0,j.$4)(E))return}return this.H(n,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$zg)(this.m,this.r.userDataSyncStore?.url)}async G(){const n=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!n&&(!(0,g.$zg)(t.defaultUrl,n.defaultUrl)||!(0,g.$zg)(t.insidersUrl,n.insidersUrl)||!(0,g.$zg)(t.stableUrl,n.stableUrl))}async H(n,t,r){this.y.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let a;try{await this.I(t,r)}catch(E){if(this.y.error(E),a=E,y.$8mb.toUserDataSyncError(E).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(b){this.y.error(b),a=b}}this.f.fire(a)}async I(n,t){if(this.h=await this.u.createSyncTask(this.g,n),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$0mb((0,S.localize)(0,null),"DefaultServiceChanged"):new y.$0mb((0,S.localize)(1,null),"ServiceChanged"):new y.$0mb((0,S.localize)(2,null),"TurnedOff");const r=this.C.get(m,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$0mb((0,S.localize)(3,null),"DefaultServiceChanged"):new y.$0mb((0,S.localize)(4,null),"ServiceChanged"):new y.$0mb((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const E=a.find(u=>u.isCurrent);if(E?.disabled)throw new y.$0mb((0,S.localize)(6,null),"TurnedOff");const b=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-b}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new y.$0mb((0,A.$Pi)(u),u instanceof y.$8mb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(m,this.g.session,-1,1),!t.isCancellationRequested&&(E||await this.w.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}}),define(le[258],he([0,1,10,176,15,11,43,21,28,24,18,39,119,118,117,20,120,115,116,4,121,42,27]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=void 0;let s=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,E,b,u,p,R,N,F){this.e=t,this.f=r,this.g=a,this.h=b,this.i=u,this.j=p,this.k=R,this.l=N,this.n=F,this.d=E.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,h.$g9b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const E=this.L(a,"profiles");return(0,h.$g9b)(E)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(b=>({...b,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:E,ref:b})=>({created:E,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:b,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:b,ref:u})=>({created:b,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(E=>E.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(E=>E.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,I.$zp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,E,b){if(t){const{content:u}=await this.M(r,E,a);return u}return this.f.resolveResourceContent(r,E,a,b)}q(t,r,a){const E=this.L(r,t);switch(t){case"settings":return this.t(E,a);case"keybindings":return this.v(E,a);case"tasks":return this.x(E,a);case"snippets":return this.z(E,a);case"globalState":return this.E(E,a);case"extensions":return this.B(E,a);case"profiles":return this.H(E,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(E=>E.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),E=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}t(t,r){switch(r){case"settings.json":return(0,l.$p7b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),E=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}v(t,r){switch(r){case"keybindings.json":return(0,d.$m7b)(t.content,!!this.l.getValue(g.$Vmb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),E=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}x(t,r){switch(r){case"tasks.json":return(0,w.$x7b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const E=this.L(a,"snippets");if(E){const b=(0,$.$u7b)(E),u=[];for(const p of Object.keys(b)){const R=this.d.joinPath(t,p),N=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,o.a);u.push({resource:R,comparableResource:N})}return u}}return[]}z(t,r){return(0,$.$u7b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),E=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}B(t,r){switch(r){case"extensions.json":return(0,c.$h7b)((0,c.$g7b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(c.$j7b).getLocalExtensions(t);return(0,c.$h7b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),E=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}E(t,r){switch(r){case"globalState.json":return(0,f.$tGb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(f.$vGb).getLocalGlobalState(t);return(0,f.$tGb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),E=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:E}]}H(t,r){switch(r){case"profiles.json":return(0,v.$mn)(JSON.parse(t.content),{})}return null}async I(t){return(0,h.$f9b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$Re)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(O.URI.from({scheme:g.$hnb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$hnb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let E,b;const u=[];let p,R,N,F,M;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?E=q.substring(7):q.startsWith("authority:")?b=q.substring(10):q.startsWith("syncResource:")?p=q.substring(13):q.startsWith("profile:")?R=q.substring(8):q.startsWith("collection:")?N=q.substring(11):q.startsWith("ref:")?F=q.substring(4):p?M=q:u.push(q)}return{remote:a,syncResource:p,profile:R,collection:N,ref:F,node:M,location:E&&b!==void 0?this.d.joinPath(O.URI.from({scheme:E,authority:b,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$mGb)(a))return a}catch(a){this.g.error(a)}throw new g.$8mb((0,L.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const E=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:E}}};e.$Q9b=s,e.$Q9b=s=o=ye([X(0,g.$3mb),X(1,g.$4mb),X(2,g.$fnb),X(3,k.$Zk),X(4,A.$_h),X(5,C.$tp),X(6,j.$pk),X(7,P.$2k),X(8,y.$yi),X(9,m.$4h)],s)}),define(le[259],he([0,1,17,6,26,38,3,2,19,12,32,20,29,11,4,21,22,18,115,116,117,118,119,120,121,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v,i,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=void 0;const t="sync.lastSyncTime";let r=class extends C.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,R,N,F,M,q,Y,K,x,V,Q){super(),this.C=p,this.D=R,this.F=N,this.G=F,this.H=M,this.I=q,this.J=Y,this.L=K,this.M=x,this.N=V,this.O=Q,this.f="uninitialized",this.g=this.B(new I.$Ud),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$Ud),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$Ud),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$Ud),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$Ud),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$Ud),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$Ud),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,C.$Rc)(()=>this.bb()))}async createSyncTask(p,R){this.cb(),this.H.info("Sync started.");const N=new Date().getTime(),F=(0,P.$pg)();try{const K=(0,n.$7mb)(F);R&&(K["Cache-Control"]="no-cache"),p=await this.D.manifest(p,K)}catch(K){const x=n.$8mb.toUserDataSyncError(K);throw b(x,F,this.F,this.I),x}const M=!1,q=this;let Y;return{manifest:p,async run(){if(M)throw new Error("Can run a task only once");Y=(0,L.$Sg)(K=>q.P(p,!1,F,K)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new n.$8mb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),R=(0,P.$pg)(),N=(0,n.$7mb)(R);let F;try{F=await this.D.manifest(null,N)}catch(Y){const K=n.$8mb.toUserDataSyncError(Y);throw b(K,R,this.F,this.I),K}await this.resetLocal();const M=this,q=new A.$5d;return{id:R,async merge(){return M.P(F,!0,R,q.token)},async apply(){try{try{await M.R(F,R,q.token)}catch(Y){if(n.$8mb.toUserDataSyncError(Y).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(F,R,q.token);else throw Y}}catch(Y){throw M.H.error(Y),Y}M.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),M.$()},async stop(){q.cancel(),await M.U(),await M.resetLocal()}}}async P(p,R,N,F){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,p,R,N,F));const q=M.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(Y,p,R,N,F)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(p,R,N,F,M){for(const q of p){if(M.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const K=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(K,R,N,F,M))}for(const[q,Y]of this.z.entries())this.M.profiles.some(K=>K.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(p,R,N){const F=this.ab();for(const x of F){if(N.isCancellationRequested)return;await x.apply(R,N)}const M=F.find(x=>x.profile.isDefault);if(!M)return;const q=M.enabled.find(x=>x.resource==="profiles");if(!q)return;const K=(await q.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(x=>F.every(V=>V.profile.id!==x.id));K.length&&await this.Q(K,p,!1,R,N)}async S(p,R,N,F,M){return(await p.sync(R,N,F,M)).map(([Y,K])=>({profile:p.profile,syncResource:Y,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const R=await this.N.resolveContent(p);if(R)return R;for(const N of this.ab())for(const F of N.enabled){const M=await F.resolveContent(p);if(M)return M}return null}async replace(p){this.cb();const R=this.N.resolveUserDataSyncResource(p);if(!R)return;const N=await this.resolveContent(p.uri);N&&await this.W(R.profile,async F=>{if(R.syncResource===F.resource)return await F.replace(N),!0})}async accept(p,R,N,F){this.cb(),await this.W(p.profile,async M=>{if(p.syncResource===M.resource)return await M.accept(R,N),F&&await M.apply((0,g.$Nf)(F)?!1:F.force,(0,n.$7mb)((0,P.$pg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async R=>{if(R.resource!=="globalState"&&await R.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async R=>{if(await R.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(R){this.H.error(R)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),R=p.map(q=>q.collection),N=await this.D.getAllCollections(),F=N.filter(q=>!R.includes(q));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const M=p.filter(q=>N.includes(q.collection));if(M.length!==p.length){const q=this.G.createInstance(s.$e9b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(p){this.cb();const R=await this.D.getActivityData();await this.C.writeFile(p,R)}async extractActivityData(p,R){const N=(await this.C.readFile(p)).value.toString(),F=JSON.parse(N);if(F.resources)for(const M in F.resources)for(const q of F.resources[M])await this.O.writeResource(M,q.content,new Date(q.created*1e3),void 0,R);if(F.collections)for(const M in F.collections)for(const q in F.collections[M].resources)for(const Y of F.collections[M].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),M,R)}async W(p,R){const N=new C.$Sc;try{const F=this.z.get(p.id);if(F){const x=await this.X(F[0],R,N);return(0,g.$Of)(x)?null:x}if(p.isDefault){const x=N.add(this.G.createInstance(a,p,void 0)),V=await this.X(x,R,N);return(0,g.$Of)(V)?null:V}if(this.M.isEnabled())return null;const M=N.add(this.G.createInstance(s.$e9b,p,void 0)),q=await this.D.manifest(null),K=(await M.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===p.id);if(K){const x=N.add(this.G.createInstance(a,p,K.collection)),V=await this.X(x,R,N);return(0,g.$Of)(V)?null:V}return null}finally{N.dispose()}}async X(p,R,N){const F=[...p.enabled,...p.disabled.reduce((M,q)=>(q!=="workspaceState"&&M.push(N.add(p.createSynchronizer(q))),M),[])];for(const M of F){const q=await R(M);if(!(0,g.$Of)(q))return q}}Y(p){const R=this.f;this.f!==p&&(this.f=p,this.g.fire(p),R==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(R=>R.conflicts).flat();(0,O.$ub)(this.j,p,(R,N)=>R.profile.id===N.profile.id&&R.syncResource===N.syncResource&&(0,O.$ub)(R.conflicts,N.conflicts,(F,M)=>(0,k.$zg)(F.previewResource,M.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,R){let N=this.z.get(p.id);if(N&&N[0].collection!==R?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(p.id)),!N){const F=new C.$Sc,M=F.add(this.G.createInstance(a,p,R?.collection));F.add(M.onDidChangeStatus(q=>this.Y(q))),F.add(M.onDidChangeConflicts(q=>this.Z())),F.add(M.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(p.id,N=[M,F])}return N[0]}ab(){const p=[];for(const[R]of this.z.values())p.push(R);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$h9b=r,e.$h9b=r=ye([X(0,l.$pk),X(1,n.$3mb),X(2,n.$2mb),X(3,d.$4h),X(4,n.$fnb),X(5,w.$tl),X(6,y.$tp),X(7,n.$anb),X(8,c.$2k),X(9,n.$cnb),X(10,n.$4mb)],r);let a=class extends C.$Tc{get enabled(){return this.f.sort((p,R)=>p[1]-R[1]).map(([p])=>p)}get disabled(){return n.$Ymb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,R,N,F,M,q,Y,K,x,V){super(),this.profile=p,this.collection=R,this.r=N,this.t=F,this.u=M,this.w=q,this.y=Y,this.z=K,this.C=x,this.D=V,this.f=[],this.g="idle",this.h=this.B(new I.$Ud),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$Ud),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$Ud),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([Q,W])=>this.F(Q,W))),this.B((0,C.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of n.$Ymb)N.isResourceEnabled(Q)&&this.G(Q)}F(p,R){R?this.G(p):this.H(p)}G(p){if(this.f.some(([M])=>M.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const R=new C.$Sc,N=R.add(this.createSynchronizer(p));R.add(N.onDidChangeStatus(()=>this.L())),R.add(N.onDidChangeConflicts(()=>this.M())),R.add(N.onDidChangeLocal(()=>this.j.fire(p)));const F=this.N(p);this.f.push([N,F,R])}H(p){const R=this.f.findIndex(([N])=>N.resource===p);if(R!==-1){const[[N,,F]]=this.f.splice(R,1);F.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(v.$q7b,this.profile,this.collection);case"keybindings":return this.t.createInstance(h.$n7b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$v7b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$y7b,this.profile,this.collection);case"globalState":return this.t.createInstance(m.$uGb,this.profile,this.collection);case"extensions":return this.t.createInstance(f.$i7b,this.profile,this.collection);case"profiles":return this.t.createInstance(s.$e9b,this.profile,this.collection)}}async sync(p,R,N,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const q=[],Y=(0,n.$7mb)(N),K=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,x=R?await this.I(K):{};for(const V of M){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(R){const Q=await V.preview(K,x,Y);if(Q)for(const W of Q.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await V.merge(W.previewResource)}else await V.sync(K,Y)}catch(Q){const W=n.$8mb.toUserDataSyncError(Q);if(b(W,N,this.w,this.y),E(Q))throw W;this.z.error(Q),this.z.error(`${V.resource}: ${(0,j.$Pi)(Q)}`),q.push([V.resource,W])}}return q}finally{this.L()}}async apply(p,R){const N=(0,n.$7mb)(p);for(const F of this.enabled){if(R.isCancellationRequested)return;try{await F.apply(!1,N)}catch(M){const q=n.$8mb.toUserDataSyncError(M);if(b(q,p,this.w,this.y),E(M))throw q;this.z.error(M),this.z.error(`${F.resource}: ${(0,j.$Pi)(M)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(R){this.z.error(R)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(R){this.z.error(`${p.resource}: ${(0,j.$Pi)(R)}`),this.z.error(R)}}async I(p){if(!this.profile.isDefault)return{};const R=this.D.getValue(n.$Umb),N=this.enabled.find(F=>F instanceof v.$q7b);if(N){const F=await N.getRemoteUserDataSyncConfiguration(p);return{...R,...F}}return R}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(R=>R.status==="hasConflicts").filter(R=>R.conflicts.conflicts.length>0).map(R=>R.conflicts);(0,O.$ub)(this.m,p,(R,N)=>R.syncResource===N.syncResource&&(0,O.$ub)(R.conflicts,N.conflicts,(F,M)=>(0,k.$zg)(F.previewResource,M.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([X(2,n.$anb),X(3,d.$4h),X(4,$.$xo),X(5,n.$2mb),X(6,w.$tl),X(7,n.$fnb),X(8,c.$2k),X(9,S.$yi)],a);function E(u){if(u instanceof n.$8mb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function b(u,p,R,N){N.publicLog2("sync/error",{code:u.code,serverCode:u instanceof n.$9mb?String(u.serverCode):void 0,url:u instanceof n.$9mb?u.url:void 0,resource:u.resource,executionId:p,service:R.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,10,18,24]),function(ne,e,O,L,A,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=e.$D_b=void 0;function C($,l){return{...$,profile:(0,j.$3k)($.profile,l.profilesHome.scheme)}}function k($){return{created:$.created,uri:A.URI.revive($.uri)}}class g{constructor(l,d,y){this.c=l,this.d=d,this.f=y,this.a=new Map,this.b=new O.$Ud}listen(l,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(l,d,y){try{return await this.g(l,d,y)}catch(w){throw this.f.error(w),w}}async g(l,d,y){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(y[0]));case"accept":return this.c.accept(C(y[0],this.d),A.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(k(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(y[0]),A.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const w=d.substring(11),c=y[0],f=this.h(c);switch(y=y.slice(1),w){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(l){const d=this.a.get(this.j(l));if(!d)throw new Error(`Manual sync taks not found: ${l}`);return d}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$D_b=g;let P=class extends L.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,d){super(),this.n=d,this.b="uninitialized",this.c=this.B(new O.$Ud),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$Ud),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$Ud),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$Ud),this.onSyncErrors=this.m.event,this.a={call(y,w,c){return l.call(y,w,c).then(null,f=>{throw I.$8mb.toUserDataSyncError(f)})},listen(y,w){return l.listen(y,w)}},this.a.call("_getInitialData").then(([y,w,c])=>{this.s(y),this.t(w),c&&this.u(c),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(w=>({...w,error:I.$8mb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),d=this;return new S(l,{async call(w,c,f){return d.a.call(`manualSync/${w}`,[l,...Array.isArray(c)?c:[c]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,d,y,w){return this.a.call("accept",[l,d,y,w])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,d){return this.a.call("extractActivityData",[l,d])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(d=>({syncResource:d.syncResource,profile:(0,j.$3k)(d.profile,this.n.profilesHome.scheme),conflicts:d.conflicts.map(y=>({...y,baseResource:A.URI.revive(y.baseResource),localResource:A.URI.revive(y.localResource),remoteResource:A.URI.revive(y.remoteResource),previewResource:A.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$E_b=P,e.$E_b=P=ye([X(1,j.$2k)],P);class S extends L.$Tc{constructor(l,d){super(),this.id=l,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[261],he([0,1,6,26,7,3,2,139,5,19,12,10,32,20,15,11,25,59,43,21,24]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kGb=e.$jGb=e.$iGb=e.$hGb=e.$gGb=void 0;const v="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends I.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(h.$$mb,-1)}set c(N){this.h.store(h.$$mb,N,-1,k.$o?0:1)}constructor(N,F,M){super(),this.f=N,this.g=F,this.h=M,this.a=this.B(new j.$Ud),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new I.$Sc);this.B(j.Event.filter(M.onDidChangeValue(-1,h.$$mb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[v]),this.a.fire()}m(N){if(N&&(N=k.$o&&N.web?{...N,...N.web}:N,(0,P.$Hf)(N.url)&&(0,P.$Jf)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,M=!!F.canSwitch,q=F.url===F.insidersUrl?"insiders":"stable",Y=(M?this.c:void 0)||q,K=Y==="insiders"?F.insidersUrl:Y==="stable"?F.stableUrl:F.url;return{url:S.URI.parse(K),type:Y,defaultType:q,defaultUrl:S.URI.parse(F.url),stableUrl:S.URI.parse(F.stableUrl),insidersUrl:S.URI.parse(F.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,V)=>(x.push({id:V,scopes:F.authenticationProviders[V].scopes}),x),[])}}}};e.$gGb=a,e.$gGb=a=ye([X(0,w.$Ej),X(1,l.$yi),X(2,m.$tp)],a);let E=class extends a{constructor(N,F,M){super(N,F,M);const q=this.h.get(i,-1);q&&(this.n=JSON.parse(q));const Y=this.f[v];Y?this.h.store(i,JSON.stringify(Y),-1,1):this.h.remove(i,-1)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$hGb=E,e.$hGb=E=ye([X(0,w.$Ej),X(1,l.$yi),X(2,m.$tp)],E);let b=class extends I.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(N,F,M,q,Y,K,x){super(),this.n=M,this.r=q,this.s=x,this.g=this.B(new j.$Ud),this.onTokenFailed=this.g.event,this.h=this.B(new j.$Ud),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$Ud),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,f.$zp)(Y,K,x).then(V=>{const Q={"X-Client-Name":`${F.applicationName}${k.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Q["X-Client-Commit"]=F.commit),Q}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,I.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}t(N){this.a=N?(0,g.$Gg)(N,"v1"):void 0}u(){const N=this.s.getNumber(o,-1);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,O.$Sg)(F=>(0,O.$6g)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Gg)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.D(F,{type:"GET",headers:N},[],L.CancellationToken.None);return(await(0,c.$mp)(M))?.map(({id:q})=>q)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Gg)(this.a,"collection").toString();N={...N},N["Content-Type"]=C.$es.text;const M=await this.D(F,{type:"POST",headers:N},[],L.CancellationToken.None),q=await(0,c.$lp)(M);if(!q)throw new h.$9mb("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[h.$5mb]);return q}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,g.$Gg)(this.a,"collection",N).toString():(0,g.$Gg)(this.a,"collection").toString();F={...F},await this.D(M,{type:"DELETE",headers:F},[],L.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,F,N),q={},Y=await this.D(M.toString(),{type:"GET",headers:q},[],L.CancellationToken.None);return(await(0,c.$mp)(Y)||[]).map(({url:x,created:V})=>({ref:(0,g.$Ig)(M,M.with({path:x})),created:V*1e3}))}async resolveResourceContent(N,F,M,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Gg)(this.z(this.a,M,N),F).toString();q={...q},q["Cache-Control"]="no-cache";const K=await this.D(Y,{type:"GET",headers:q},[],L.CancellationToken.None);return await(0,c.$lp)(K)}async deleteResource(N,F,M){if(!this.a)throw new Error("No settings sync store url configured.");const q=F!==null?(0,g.$Gg)(this.z(this.a,M,N),F).toString():this.z(this.a,M,N).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Gg)(this.a,"resource").toString(),F={"Content-Type":C.$es.text};await this.D(N,{type:"DELETE",headers:F},[],L.CancellationToken.None)}async readResource(N,F,M,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Gg)(this.z(this.a,M,N),"latest").toString();q={...q},q["Cache-Control"]="no-cache",F&&(q["If-None-Match"]=F.ref);const K=await this.D(Y,{type:"GET",headers:q},[304],L.CancellationToken.None);let x=null;if(K.res.statusCode===304&&(x=F),x===null){const V=K.res.headers.etag;if(!V)throw new h.$9mb("Server did not return the ref",Y,"NoRef",K.res.statusCode,K.res.headers[h.$5mb]);const Q=await(0,c.$lp)(K);if(!Q&&K.res.statusCode===304)throw new h.$9mb("Empty response",Y,"EmptyResponse",K.res.statusCode,K.res.headers[h.$5mb]);x={ref:V,content:Q}}return x}async writeResource(N,F,M,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,q,N).toString();Y={...Y},Y["Content-Type"]=C.$es.text,M&&(Y["If-Match"]=M);const x=await this.D(K,{type:"POST",data:F,headers:Y},[],L.CancellationToken.None),V=x.res.headers.etag;if(!V)throw new h.$9mb("Server did not return the ref",K,"NoRef",x.res.statusCode,x.res.headers[h.$5mb]);return V}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$Gg)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const q=await this.D(M,{type:"GET",headers:F},[304],L.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=N),!Y){const x=q.res.headers.etag;if(!x)throw new h.$9mb("Server did not return the ref",M,"NoRef",q.res.statusCode,q.res.headers[h.$5mb]);const V=await(0,c.$lp)(q);if(!V&&q.res.statusCode===304)throw new h.$9mb("Empty response",M,"EmptyResponse",q.res.statusCode,q.res.headers[h.$5mb]);V&&(Y={...JSON.parse(V),ref:x})}const K=this.s.get(s,-1);return K&&Y&&K!==Y.session&&this.C(),Y===null&&K&&this.C(),Y&&this.s.store(s,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Gg)(this.a,"download").toString(),F={},M=await this.D(N,{type:"GET",headers:F},[],L.CancellationToken.None);if(!(0,c.$ip)(M))throw new h.$9mb("Server returned "+M.res.statusCode,N,"EmptyResponse",M.res.statusCode,M.res.headers[h.$5mb]);if((0,c.$jp)(M))throw new h.$9mb("Empty response",N,"EmptyResponse",M.res.statusCode,M.res.headers[h.$5mb]);return M.stream}z(N,F,M){return F?(0,g.$Gg)(N,"collection",F,"resource",M):(0,g.$Gg)(N,"resource",M)}C(){this.s.remove(s,-1),this.s.remove(n,-1)}async D(N,F,M,q){if(!this.b)throw new h.$9mb("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new h.$9mb(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;F.headers={...F.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let K;try{K=await this.f.request(N,F,q)}catch(G){if(!(G instanceof h.$9mb)){let te="RequestFailed";const re=(0,A.$0)(G).toLowerCase();re.includes("xhr timeout")?te="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?te="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":re.includes("headers must be an object")?te="RequestHeadersNotObject":(0,A.$4)(G)&&(te="RequestCanceled"),G=new h.$9mb(`Connection refused for the request '${N}'.`,N,te,void 0,void 0)}throw this.r.info("Request failed",N),G}const x=K.res.headers[h.$5mb],V={url:N,status:K.res.statusCode,"execution-id":F.headers[h.$6mb],"operation-id":x},Q=(0,c.$ip)(K)||K.res.statusCode&&M.includes(K.res.statusCode);let W="";if(Q?this.r.trace("Request succeeded",V):(W=await(0,c.$kp)(K)||"",this.r.info("Request failed",V,W)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new h.$9mb(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",K.res.statusCode,x);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new h.$9mb(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",K.res.statusCode,x)}if(this.h.fire(),K.res.statusCode===404)throw new h.$9mb(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",K.res.statusCode,x);if(K.res.statusCode===405)throw new h.$9mb(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${W}`,N,"MethodNotFound",K.res.statusCode,x);if(K.res.statusCode===409)throw new h.$9mb(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",K.res.statusCode,x);if(K.res.statusCode===410)throw new h.$9mb(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",K.res.statusCode,x);if(K.res.statusCode===412)throw new h.$9mb(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",K.res.statusCode,x);if(K.res.statusCode===413)throw new h.$9mb(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",K.res.statusCode,x);if(K.res.statusCode===426)throw new h.$9mb(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",K.res.statusCode,x);if(K.res.statusCode===429){const G=K.res.headers["retry-after"];throw G?(this.y(new Date(Date.now()+parseInt(G)*1e3)),new h.$9mb(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",K.res.statusCode,x)):new h.$9mb(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",K.res.statusCode,x)}if(!Q)throw new h.$9mb("Server returned "+K.res.statusCode,N,"Unknown",K.res.statusCode,x);return K}F(N){let F=this.s.get(n,-1);F===void 0&&(F=(0,$.$pg)(),this.s.store(n,F,-1,1)),N["X-Machine-Session-Id"]=F;const M=this.s.get(s,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};e.$iGb=b,e.$iGb=b=ye([X(1,w.$Ej),X(2,c.$gp),X(3,h.$fnb),X(4,d.$_h),X(5,y.$pk),X(6,m.$tp)],b);let u=class extends b{constructor(N,F,M,q,Y,K,x){super(N.userDataSyncStore?.url,F,M,q,Y,K,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$jGb=u,e.$jGb=u=ye([X(0,h.$2mb),X(1,w.$Ej),X(2,c.$gp),X(3,h.$fnb),X(4,d.$_h),X(5,y.$pk),X(6,m.$tp)],u);class p{constructor(N,F,M,q){this.c=N,this.d=F,this.f=M,this.g=q,this.a=[],this.b=void 0}request(N,F,M){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new h.$9mb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$kGb=p}),define(le[262],he([0,1,3,57,25,21,22,257,24,81,84]),function(ne,e,O,L,A,j,I,C,k,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=void 0;let S=class extends C.$i9b{constructor(l,d,y,w,c,f,m,h,v,i,o){super(l,d,y,w,c,m,h,v,i,o),this.B(O.Event.debounce(O.Event.any(O.Event.map(f.onDidFocusMainWindow,()=>"windowFocus"),O.Event.map(f.onDidOpenMainWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$Y_b=S,e.$Y_b=S=ye([X(0,A.$Ej),X(1,k.$2mb),X(2,k.$3mb),X(3,k.$anb),X(4,k.$bnb),X(5,L.$P0b),X(6,k.$fnb),X(7,g.$QEb),X(8,I.$tl),X(9,P.$Pmb),X(10,j.$tp)],S)}),define(le[263],he([0,1,73,23,5,19]),function(ne,e,O,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g0b=e.$f0b=e.$e0b=e.$d0b=void 0,e.$d0b=128/4;function I(g){function P(){let S=g.scheme===L.Schemas.file?(0,j.$ug)(g):g.toString();return A.$k||(S=S.toLowerCase()),(0,O.createHash)("md5").update(S).digest("hex")}return{id:P(),configPath:g}}e.$e0b=I;function C(g,P){function S(){if(g.scheme!==L.Schemas.file)return(0,O.createHash)("md5").update(g.toString()).digest("hex");if(!P)return;let l;return A.$k?l=P.ino:A.$j?l=P.birthtime.getTime():A.$i&&(typeof P.birthtimeMs=="number"?l=Math.floor(P.birthtimeMs):l=P.birthtime.getTime()),(0,O.createHash)("md5").update(g.fsPath).update(l?String(l):"").digest("hex")}const $=S();if(typeof $=="string")return{id:$,uri:g}}e.$f0b=C;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$g0b=k}),define(le[264],he([0,1,6,7,2,16,31,15,8,78,112,263,57,56,23]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=void 0;let y=class extends A.$Tc{constructor(c,f,m,h){super(),this.a=c,this.b=f,this.c=m,this.f=h,this.B(new O.$eh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=this.a.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,f=await I.Promises.readdir(c),m=new g.$pFb(this.f.getChannel("storage"));await Promise.all(f.map(async h=>{const v=(0,j.$jc)(c,h);h.length===S.$d0b||h===P.$ei.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(s=>s.workspace?.id===h)||await m.isUsed(v)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${h} as it seems to be an unused empty workspace.`),await I.Promises.rm(v))}))}catch(c){(0,L.$1)(c)}}};e.$s_b=y,e.$s_b=y=ye([X(0,C.$ai),X(1,k.$mj),X(2,$.$P0b),X(3,l.$4$b)],y)}),define(le[122],he([0,1,73,64,36,272,14,7,3,2,16,5,32,40,68]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=void 0;class y{traceSocketEvent(u,p){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,p)}constructor(u,p=""){this.f=!0,this.debugLabel=p,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,C.$1)(R)}},this.socket.on("error",this.a),this.b=R=>{this.traceSocketEvent("close",{hadError:R}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const p=R=>{this.traceSocketEvent("read",R),u(I.$ie.wrap(R))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=R=>{u({type:0,hadError:R,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){const p=()=>{u()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,C.$1)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,C.$1)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.$Th=y;var w;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var c;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(c||(c={}));class f extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,p){this.socket.traceSocketEvent(u,p)}constructor(u,p,R,N){super(),this.f=this.B(new k.$Ud),this.g=this.B(new k.$Ud),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:R?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new m(this,p,R,N,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,C.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new d.$Oh,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let p=0;for(;p<u.byteLength;)this.a.writeMessage(u.slice(p,Math.min(p+262144,u.byteLength)),{compressed:!0,opcode:2}),p+=262144}m(u,{compressed:p,opcode:R}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let N=2;u.byteLength<126?N+=0:u.byteLength<2**16?N+=2:N+=8;const F=I.$ie.alloc(N),M=p?64:0,q=R&15;if(F.writeUInt8(128|M|q,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let Y=1;F.writeUInt8(u.byteLength>>>8&255,++Y),F.writeUInt8(u.byteLength>>>0&255,++Y)}else{F.writeUInt8(127,1);let Y=1;F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(u.byteLength>>>24&255,++Y),F.writeUInt8(u.byteLength>>>16&255,++Y),F.writeUInt8(u.byteLength>>>8&255,++Y),F.writeUInt8(u.byteLength>>>0&255,++Y)}this.socket.write(I.$ie.concat([F,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),R=p.readUInt8(0),N=(R&128)>>>7,F=(R&64)>>>6,M=R&15,q=p.readUInt8(1),Y=(q&128)>>>7,K=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),R=p.readUInt8(1),N=(R&128)>>>7;let F=R&127,M=1;F===126?F=p.readUInt8(++M)*2**8+p.readUInt8(++M):F===127&&(F=p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M));let q=0;N&&(q=p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),i(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(p,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(p,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Uh=f;class m extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$ie.alloc(0)}constructor(u,p,R,N,F,M){super(),this.n=u,this.r=F,this.s=M,this.a=this.B(new k.$Ud),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Ud),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Ud),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new h(this.n,N,R,{windowBits:15})),this.f=this.B(new v(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(u,p){this.g.push({data:u,options:p}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:u,options:p}=this.g.shift();if(this.f&&p.compressed){const R=await this.w(this.f,u);this.s(R,p)}else this.s(u,{...p,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,p){return new Promise((R,N)=>{u.write(p),u.flush(F=>R(F))})}acceptFrame(u,p,R){this.h.push({data:u,isCompressed:p,isLastFrameOfMessage:R}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const p=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,p,R){return new Promise((N,F)=>{u.write(p),R&&u.write(I.$ie.fromByteArray([0,0,255,255])),u.flush(M=>N(M))})}}class h extends g.$Tc{get recordedInflateBytes(){return this.j?I.$ie.concat(this.f):I.$ie.alloc(0)}constructor(u,p,R,N){super(),this.h=u,this.j=p,this.a=this.B(new k.$Ud),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(N),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(I.$ie.wrap(F))}),R&&(this.h.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this.b.write(R.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=I.$ie.concat(this.g);this.g.length=0,u(p)})}}class v extends g.$Tc{constructor(u,p){super(),this.g=u,this.a=this.B(new k.$Ud),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",R=>{this.g.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.g.traceSocketEvent("zlibDeflateData",R),this.f.push(I.$ie.wrap(R))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=I.$ie.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),u(p)})}}function i(b,u){if(u===0)return;const p=b.byteLength>>>2;for(let Y=0;Y<p;Y++){const K=b.readUInt32BE(Y*4);b.writeUInt32BE(K^u,Y*4)}const R=p*4,N=b.byteLength-R,F=u>>>24&255,M=u>>>16&255,q=u>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(R)^F,R),N>=2&&b.writeUInt8(b.readUInt8(R+1)^M,R+1),N>=3&&b.writeUInt8(b.readUInt8(R+2)^q,R+2)}e.$Vh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const b=(0,$.$pg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const u=process.platform!=="darwin"&&e.$Vh?e.$Vh:(0,A.tmpdir)(),p=(0,P.$jc)(u,`vscode-ipc-${b}.sock`);return t(p),p}e.$Wh=s;function n(b,u,p){const N=(0,O.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${p}-${u}-sock`;const F=p.substr(0,4),M=u.substr(0,6);let q;return process.platform!=="darwin"&&e.$Vh&&!process.env.VSCODE_PORTABLE?q=(0,P.$jc)(e.$Vh,`vscode-${N}-${F}-${M}.sock`):q=(0,P.$jc)(b,`${F}-${M}.sock`),t(q),q}e.$Xh=n;function t(b){const u=o[S.$u];typeof u=="number"&&b.length>=u&&console.warn(`WARNING: IPC handle "${b}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends l.$Ih{static b(u){const p=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(p,R=>({protocol:new d.$Ph(new y(R,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(R,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Yh=r;function a(b){return new Promise((u,p)=>{const R=(0,L.createServer)();R.on("error",p),R.listen(b,()=>{R.removeListener("error",p),u(new r(R))})})}e.$Zh=a;function E(b,u){return new Promise((p,R)=>{const N=(0,L.createConnection)(b,()=>{N.removeListener("error",R),p(d.$Qh.fromSocket(new y(N,`ipc-client${u}`),u))});N.once("error",R)})}e.$1h=E}),define(le[265],he([0,1,64,122,211]),function(ne,e,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2_b=void 0,e.$2_b=new class{supports(j){return!0}connect({host:j,port:I},C,k,g){return new Promise((P,S)=>{const $=O.createConnection({host:j,port:I},()=>{$.removeListener("error",S),$.write((0,A.$krb)(C,k,g));const l=d=>{d.toString().indexOf(`\r
\r
`)>=0&&($.off("data",l),P(new L.$Th($,g)))};$.on("data",l)});$.setNoDelay(!0),$.once("error",S)})}}}),define(le[266],he([0,1,64,36,132,122,6,2,5,20,8,25,214,104,106,79,14]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=e.$W$b=e.$V$b=e.$U$b=void 0;async function c(i,o,s,n,t){let r;for(let a=3;a&&(r?.dispose(),r=await new f(i,o,s,n,t).waitForReady(),!(t&&A.$sg[t]||!A.$sg[r.tunnelLocalPort]));a--);return r}class f extends C.$Tc{constructor(o,s,n,t,r){super(),this.m=s,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=O.createServer(),this.c=new I.$4g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,s=(0,y.$Gv)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,A.$tg)(o,2,1e3,s),t=null;return this.b.listen(n,this.m),await this.c.wait(),t=this.b.address(),t||(n=0,this.b.listen(n,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const s=(0,y.$Ev)(this.tunnelRemoteHost)||(0,y.$Gv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,$.$kl)(this.a,s,this.tunnelRemotePort),t=n.getSocket(),r=n.readEntireBuffer();n.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$Th?t.socket.destroy():t.end()}),t instanceof j.$Th?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(n=>o.write(n.buffer)),o.on("data",n=>s.write(w.$ie.wrap(n))),o.resume()}t(o,s){const n=s.socket;n.on("end",()=>o.end()),n.on("close",()=>o.end()),n.on("error",()=>{o.destroy()}),n.pipe(o),o.pipe(n)}}e.$U$b=f;let m=class extends y.$Jv{constructor(o,s,n,t,r){super(s,r),this.v=o,this.w=n,this.y=t}isPortPrivileged(o){return(0,y.$Hv)(o,this.m,k.OS,L.release())}t(o,s,n,t,r,a,E,b){const u=this.s(s,n);if(u)return++u.refcount,u.value;if((0,y.$Bv)(o))return this.u(o,s,n,r,a,E,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${r}.`);const p={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},R=c(p,t,s,n,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,n,R),R}}};e.$V$b=m,e.$V$b=m=ye([X(0,l.$el),X(1,P.$mj),X(2,d.$hl),X(3,S.$Ej),X(4,g.$yi)],m);let h=class extends m{constructor(o,s,n,t,r){super(o,s,n,t,r)}};e.$W$b=h,e.$W$b=h=ye([X(0,l.$el),X(1,P.$mj),X(2,d.$hl),X(3,S.$Ej),X(4,g.$yi)],h);let v=class extends C.$Tc{constructor(o,s,n,t,r){super(),this.b=o,this.c=s,this.f=n,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,s,n,t,r,a,E,b,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${t} on local port ${a}.`),!this.a.has(o)){const p=new h(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(o,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(s,n,t,r,a,E,b,u)}};e.$X$b=v,e.$X$b=v=ye([X(0,l.$el),X(1,P.$mj),X(2,S.$Ej),X(3,d.$hl),X(4,g.$yi)],v)}),define(le[273],he([0,1,36,38,7,2,23,10,17,3,40,146,205,206,196,197,264,187,189,20,210,95,221,96,216,15,114,248,29,99,188,113,97,11,199,200,72,4,195,74,75,227,8,201,102,25,59,21,107,22,108,109,110,46,230,83,111,24,81,256,240,241,84,255,259,260,261,60,254,242,106,220,79,266,215,231,28,232,5,233,190,208,207,82,247,18,51,204,58,253,229,243,105,258,249,9,202,101,251,246,217,184,57,203,262,250,56,252,104,265,181,218]),function(ne,e,O,L,A,j,I,C,k,g,P,S,$,l,d,y,w,c,f,m,h,v,i,o,s,n,t,r,a,E,b,u,p,R,N,F,M,q,Y,K,x,V,Q,W,G,te,re,ee,ae,Z,z,D,T,B,U,_,H,J,ie,se,ce,$e,fe,ge,Ee,Ce,Oe,Ae,ue,me,be,Pe,Re,Me,De,ze,Te,Fe,qe,oe,de,we,ve,pe,ke,Ie,Le,Ne,Ge,Ue,Be,We,Xe,tt,vt,Et,St,dt,kt,Pt,Ct,Rt,It,Ot,Dt,jt,$t,At,gt,Lt,Nt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends j.$Tc{constructor(Se){super(),this.f=Se,this.a=this.B(new S.$CU(this)),this.b=void 0,this.c=this.B(new g.$Ud),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,S.$DU)(process.parentPort,st.$00b.exit,je)}async init(){const Se=await this.h();(0,J.$Wmb)(),Se.invokeFunction(je=>{const Ke=je.get(Q.$mj),Ve=je.get(Z.$tl),Qe=je.get(Ie.$2k);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Ke),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe)))}),this.B((0,j.$Qc)(Se.createInstance($.$o_b,this.f.codeCachePath),Se.createInstance(l.$p_b),Se.createInstance(w.$s_b),Se.createInstance(y.$r_b),Se.createInstance(d.$q_b),Se.createInstance(vt.$S_b),Se.createInstance(We.$K_b)))}async h(){const Se=new K.$3h,je={_serviceBrand:void 0,...G.default};Se.set(te.$Ej,je);const Ke=new P.$Mh(He=>He==="main"),Ve=new $t.$5$b(this.a,Ke);Se.set($t.$4$b,Ve);const Qe=this.f.policiesData?new Ne.$A$b(this.f.policiesData,Ve.getChannel("policy")):new Ge.$Kn;Se.set(Ge.$In,Qe);const Je=new Nt.$Am(this.f.args,je);Se.set(n.$ai,Je);const et=new W.$zr(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(He=>({...He,resource:C.URI.revive(He.resource)})),Ve.getChannel("logger"));Se.set(Q.$nj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new Q.$uj(ot.getLevel())),Ze=this.B(new St.$sO(ot,[ht]));Se.set(Q.$mj,Ze),this.b=this.B(new dt.$U_b(Ze)),Se.set(dt.$T_b,this.b);const Ye=this.B(new N.$bq(Ze));Se.set(R.$pk,Ye);const ut=this.B(new F.$Aq(Ze));Ye.registerProvider(I.Schemas.file,ut);const at=new Fe.$1r(Ye);Se.set(Te.$Zk,at);const xe=this.B(new Ue.$zO(this.f.profiles.all,C.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Se.set(Ie.$2k,xe);const ft=this.B(new oe.$3$b(I.Schemas.file,this.B(new de.$bO(Ve.getChannel(de.$aO),{pathCaseSensitive:qe.$k})),I.Schemas.vscodeUserData,xe,at,Ze));Ye.registerProvider(I.Schemas.vscodeUserData,ft);const _e=this.B(new h.$$n(xe.defaultProfile.settingsResource,Ye,Qe,Ze));Se.set(m.$yi,_e);const it=new At.$1_b(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);Se.set(ee.$tp,it),this.B((0,j.$Rc)(()=>it.flush())),await Promise.all([_e.initialize(),it.initialize()]);const bt=new Ct.$kr(Ve.getChannel("request"));Se.set(re.$gp,bt),Se.set(c.$t_b,new M.$2h(f.$u_b,void 0,!1)),Se.set(ve.$hF,new M.$2h(we.$J_b,void 0,!1));const wt=new Ot.$0$b(-1,Ve);Se.set(It.$P0b,wt),Se.set(o.$co,new M.$2h(s.$HO,void 0,!0));const Ft=this.B(new me.$x$b(wt)),Mt=new P.$Mh(He=>Ft.getActiveClientId().then(lt=>He===lt));Se.set(p.$bZb,new Rt.$W_b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ct;const nt=[],pt=(0,B.$Wo)(je,_e);if((0,B.$Ro)(je,Je)){const He=new D.$z8b(Ze,et,Je,je);if(nt.push(He),!(0,B.$So)(je,Je)&&je.aiConfig?.ariaKey){const lt=new Be.$gO(bt,pt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,j.$Rc)(()=>lt.flush())),nt.push(lt)}ct=new T.$or({appenders:nt,commonProperties:(0,ae.$Ho)((0,O.release)(),(0,O.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,pt),sendErrorTelemetry:!0,piiPaths:(0,B.$Xo)(Je)},_e,je)}else{ct=B.$Lo;const He=B.$Po;nt.push(He)}this.a.registerChannel("telemetryAppender",new z.$c$b(nt)),Se.set(Z.$tl,ct);const Ut=new U.$v_b(_e,ct,Ze,et,Je,je);Se.set(Z.$ul,Ut),Se.set(Le.$Up,new M.$2h(Pt.$rO,void 0,!0)),Se.set(pe.$Yp,new M.$2h(ke.$B$b,void 0,!0)),Se.set(E.$Ep,new M.$2h(E.$Fp,void 0,!0)),Se.set(u.$9p,new M.$2h(u.$0p,void 0,!0)),Se.set(a.$xo,new M.$2h(r.$Cp,void 0,!0)),Se.set(a.$Do,new M.$2h(jt.$Z_b,void 0,!1)),Se.set(x.$gr,new M.$2h(V.$ir,void 0,!1)),Se.set(v.$Hm,new M.$2h(i.$8r,void 0,!1)),Se.set(ie.$QEb,new M.$2h(ie.$REb,void 0,!0)),Se.set(J.$fnb,new M.$2h($e.$$Gb,void 0,!0)),Se.set(J.$enb,new ce.$y_b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Se.set(a.$Co,new M.$2h(t.$OEb,void 0,!1)),Se.set(H.$9Gb,new M.$2h(H.$0Gb,void 0,!0)),Se.set(_.$lv,new M.$2h(_.$mv)),Se.set(J.$2mb,new M.$2h(Oe.$hGb,void 0,!0)),Se.set(J.$3mb,new M.$2h(Oe.$jGb,void 0,!0)),Se.set(fe.$Pmb,new M.$2h(fe.$Rmb,void 0,!0)),Se.set(J.$4mb,new M.$2h(se.$c9b,void 0,!1)),Se.set(J.$anb,new M.$2h(ge.$48b,void 0,!0)),Se.set(J.$bnb,new M.$2h(Ee.$h9b,void 0,!1)),Se.set(Ae.$qFb,new M.$2h(ue.$F_b,void 0,!0)),Se.set(J.$cnb,new M.$2h(tt.$Q9b,void 0,!0)),Se.set(be.$hl,new M.$2h(Pe.$Z$b,void 0,!1));const yt=new gt.$fl;return Se.set(gt.$el,yt),yt.register(0,Lt.$2_b),Se.set(Re.$Av,new M.$2h(Me.$X$b)),Se.set(De.$G_b,new M.$2h(ze.$I_b)),Se.set(Xe.$L_b,new M.$2h(kt.$V_b)),new Y.$Dq(Se)}j(Se){const je=this.B(new j.$Sc),Ke=new b.$Hp(Se.get(a.$zo),()=>null);this.a.registerChannel("extensions",Ke);const Ve=P.ProxyChannel.fromService(Se.get(x.$gr),je);this.a.registerChannel("languagePacks",Ve);const Qe=P.ProxyChannel.fromService(Se.get(v.$Hm),je);this.a.registerChannel("diagnostics",Qe);const Je=new b.$Jp(Se.get(a.$Do));this.a.registerChannel("extensionTipsService",Je);const et=P.ProxyChannel.fromService(Se.get(c.$t_b),je);this.a.registerChannel("checksum",et);const ot=P.ProxyChannel.fromService(Se.get(ve.$hF),je);this.a.registerChannel("v8InspectProfiling",ot);const ht=new ce.$z_b(Se.get(fe.$Pmb));this.a.registerChannel("userDataSyncMachines",ht);const Ze=P.ProxyChannel.fromService(Se.get(Z.$ul),je);this.a.registerChannel("customEndpointTelemetry",Ze);const Ye=new ce.$A_b(Se.get(ie.$QEb));this.a.registerChannel("userDataSyncAccount",Ye);const ut=new ce.$B_b(Se.get(J.$2mb));this.a.registerChannel("userDataSyncStoreManagement",ut);const at=new Ce.$D_b(Se.get(J.$bnb),Se.get(Ie.$2k),Se.get(Q.$mj));this.a.registerChannel("userDataSync",at);const xe=this.B(Se.get(q.$4h).createInstance(Dt.$Y_b)),ft=new ce.$w_b(xe);this.a.registerChannel("userDataAutoSync",ft),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Se.get(J.$cnb),je));const _e=P.ProxyChannel.fromService(Se.get(De.$G_b),je);this.a.registerChannel(De.$H_b,_e);const it=P.ProxyChannel.fromService(Se.get(Xe.$L_b),je);this.a.registerChannel("remoteTunnel",it)}m(Se){process.on("uncaughtException",je=>(0,A.$1)(je)),process.on("unhandledRejection",je=>(0,A.$1)(je)),(0,A.setUnexpectedErrorHandler)(je=>{const Ke=(0,L.$Pi)(je,!0);Ke&&Se.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}handledClientConnection(Se){if(Se.data!==st.$_0b.response)return!1;const je=(0,k.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function mt(rt){const Se=new Tt(rt);process.parentPort.postMessage(st.$00b.ipcReady),await Se.init(),process.parentPort.postMessage(st.$00b.initDone)}e.main=mt,process.parentPort.once("message",rt=>{mt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a45edfc415d19852fa3c3e1cd255a02de9e016d2/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
