/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],E=0,T=ge.length;E<T;E++)e[E]=Pe[ge[E]];return e};define(Pe[66],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function E(R){return($,g,w)=>{let A=null,k=null;if(typeof w.value=="function"?(A="value",k=w.value):typeof w.get=="function"&&(A="get",k=w.get),!k)throw new Error("not supported");w[A]=R(k,g)}}function T(R,$,g){let w=null,A=null;if(typeof g.value=="function"?(w="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",A=g.get),!A)throw new Error("not supported");const k=`$memoize$${$}`;g[w]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[k]}}e.$wh=T;function C(R,$,g){return E((w,A)=>{const k=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=g?g():void 0),clearTimeout(this[k]),$&&(this[l]=$(this[l],...p),p=[this[l]]),this[k]=setTimeout(()=>{w.apply(this,p),this[l]=g?g():void 0},R)}})}e.$xh=C;function M(R,$,g){return E((w,A)=>{const k=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,b=`$throttle$pending$${A}`;return function(...r){if(this[l]||(this[l]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...r)),this[b])return;const o=this[p]+R;o<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[b]=!0,this[k]=setTimeout(()=>{this[b]=!1,this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}e.$yh=M}),define(Pe[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=void 0;class E{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$aN=E,e.$bN=new E("id#")}),define(Pe[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(i,s=!1){let u=0;const d=i.length;let m="",f=0,S=16,L=0;function v(U){let P=0,I=0;for(;P<U;){const K=i.charCodeAt(u);if(K>=48&&K<=57)I=I*16+K-48;else if(K>=65&&K<=70)I=I*16+K-65+10;else if(K>=97&&K<=102)I=I*16+K-97+10;else break;u++,P++}return P<U&&(I=-1),I}function y(U){u=U,m="",f=0,S=16,L=0}function D(){const U=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return L=3,i.substring(U,u);let P=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;P=u}else L=3;return i.substring(U,P)}function N(){let U="",P=u;for(;;){if(u>=d){U+=i.substring(P,u),L=2;break}const I=i.charCodeAt(u);if(I===34){U+=i.substring(P,u),u++;break}if(I===92){if(U+=i.substring(P,u),u++,u>=d){L=2;break}switch(i.charCodeAt(u++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ae=v(4);ae>=0?U+=String.fromCharCode(ae):L=4;break}default:L=5}P=u;continue}if(I>=0&&I<=31)if(g(I)){U+=i.substring(P,u),L=2;break}else L=6;u++}return U}function O(){if(m="",L=0,f=u,u>=d)return f=d,S=17;let U=i.charCodeAt(u);if($(U)){do u++,m+=String.fromCharCode(U),U=i.charCodeAt(u);while($(U));return S=15}if(g(U))return u++,m+=String.fromCharCode(U),U===13&&i.charCodeAt(u)===10&&(u++,m+=`
`),S=14;switch(U){case 123:return u++,S=1;case 125:return u++,S=2;case 91:return u++,S=3;case 93:return u++,S=4;case 58:return u++,S=6;case 44:return u++,S=5;case 34:return u++,m=N(),S=10;case 47:{const P=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return m=i.substring(P,u),S=12}if(i.charCodeAt(u+1)===42){u+=2;const I=d-1;let K=!1;for(;u<I;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,K=!0;break}u++}return K||(u++,L=1),m=i.substring(P,u),S=13}return m+=String.fromCharCode(U),u++,S=16}case 45:if(m+=String.fromCharCode(U),u++,u===d||!w(i.charCodeAt(u)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=D(),S=11;default:for(;u<d&&G(U);)u++,U=i.charCodeAt(u);if(f!==u){switch(m=i.substring(f,u),m){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return m+=String.fromCharCode(U),u++,S=16}}function G(U){if($(U)||g(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>u,scan:s?W:O,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>L}}e.$_m=R;function $(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function k(i,s){const u=[],d=new Object;let m;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(v,y,D,N){f.value=v,f.offset=y,f.length=D,f.type=N,f.colonOffset=void 0,m=f}try{a(i,{onObjectBegin:(v,y)=>{if(s<=v)throw d;m=void 0,S=s>v,u.push("")},onObjectProperty:(v,y,D)=>{if(s<y||(L(v,y,D,"property"),u[u.length-1]=v,s<=y+D))throw d},onObjectEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onArrayBegin:(v,y)=>{if(s<=v)throw d;m=void 0,u.push(0)},onArrayEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onLiteralValue:(v,y,D)=>{if(s<y||(L(v,y,D,h(v)),s<=y+D))throw d},onSeparator:(v,y,D)=>{if(s<=y)throw d;if(v===":"&&m&&m.type==="property")m.colonOffset=y,S=!1,m=void 0;else if(v===","){const N=u[u.length-1];typeof N=="number"?u[u.length-1]=N+1:(S=!0,u[u.length-1]=""),m=void 0}}})}catch(v){if(v!==d)throw v}return{path:u,previousNode:m,isAtPropertyKey:S,matches:v=>{let y=0;for(let D=0;y<v.length&&D<u.length;D++)if(v[y]===u[D]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.$an=k;function l(i,s=[],u=M.DEFAULT){let d=null,m=[];const f=[];function S(v){Array.isArray(m)?m.push(v):d!==null&&(m[d]=v)}return a(i,{onObjectBegin:()=>{const v={};S(v),f.push(m),m=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{m=f.pop()},onArrayBegin:()=>{const v=[];S(v),f.push(m),m=v,d=null},onArrayEnd:()=>{m=f.pop()},onLiteralValue:S,onError:(v,y,D)=>{s.push({error:v,offset:y,length:D})}},u),m[0]}e.$bn=l;function p(i,s=[],u=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(v){d.type==="property"&&(d.length=v-d.offset,d=d.parent)}function f(v){return d.children.push(v),v}a(i,{onObjectBegin:v=>{d=f({type:"object",offset:v,length:-1,parent:d,children:[]})},onObjectProperty:(v,y,D)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:v,offset:y,length:D,parent:d})},onObjectEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onArrayBegin:(v,y)=>{d=f({type:"array",offset:v,length:-1,parent:d,children:[]})},onArrayEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onLiteralValue:(v,y,D)=>{f({type:h(v),offset:y,length:D,parent:d,value:v}),m(y+D)},onSeparator:(v,y,D)=>{d.type==="property"&&(v===":"?d.colonOffset=y:v===","&&m(y))},onError:(v,y,D)=>{s.push({error:v,offset:y,length:D})}},u);const L=d.children[0];return L&&delete L.parent,L}e.$cn=p;function b(i,s){if(!i)return;let u=i;for(const d of s)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],m=!0;break}if(!m)return}else{const m=d;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}e.$dn=b;function r(i){if(!i.parent||!i.parent.children)return[];const s=r(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.$en=r;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const s=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(s[u.children[0].value]=o(d))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$fn=o;function t(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.$gn=t;function n(i,s,u=!1){if(t(i,s,u)){const d=i.children;if(Array.isArray(d))for(let m=0;m<d.length&&d[m].offset<=s;m++){const f=n(d[m],s,u);if(f)return f}return i}}e.$hn=n;function a(i,s,u=M.DEFAULT){const d=R(i,!1);function m(se){return se?()=>se(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(se){return se?we=>se(we,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=m(s.onObjectBegin),L=f(s.onObjectProperty),v=m(s.onObjectEnd),y=m(s.onArrayBegin),D=m(s.onArrayEnd),N=f(s.onLiteralValue),O=f(s.onSeparator),G=m(s.onComment),W=f(s.onError),U=u&&u.disallowComments,P=u&&u.allowTrailingComma;function I(){for(;;){const se=d.scan();switch(d.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:U||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(se){case 12:case 13:U?K(10):G();break;case 16:K(1);break;case 15:case 14:break;default:return se}}}function K(se,we=[],ne=[]){if(W(se),we.length+ne.length>0){let Z=d.getToken();for(;Z!==17;){if(we.indexOf(Z)!==-1){I();break}else if(ne.indexOf(Z)!==-1)break;Z=I()}}}function ae(se){const we=d.getTokenValue();return se?N(we):L(we),I(),!0}function he(){switch(d.getToken()){case 11:{let se=0;try{se=JSON.parse(d.getTokenValue()),typeof se!="number"&&(K(2),se=0)}catch{K(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return I(),!0}function be(){return d.getToken()!==10?(K(3,[],[2,5]),!1):(ae(!1),d.getToken()===6?(O(":"),I(),ve()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function De(){S(),I();let se=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(se||K(4,[],[]),O(","),I(),d.getToken()===2&&P)break}else se&&K(6,[],[]);be()||K(4,[],[2,5]),se=!0}return v(),d.getToken()!==2?K(7,[2],[]):I(),!0}function le(){y(),I();let se=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(se||K(4,[],[]),O(","),I(),d.getToken()===4&&P)break}else se&&K(6,[],[]);ve()||K(4,[],[4,5]),se=!0}return D(),d.getToken()!==4?K(8,[4],[]):I(),!0}function ve(){switch(d.getToken()){case 3:return le();case 1:return De();case 10:return ae(!0);default:return he()}}return I(),d.getToken()===17?u.allowEmptyContent?!0:(K(4,[],[]),!1):ve()?(d.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.$in=a;function c(i,s){const u=R(i),d=[];let m,f=0,S;do switch(S=u.getPosition(),m=u.scan(),m){case 12:case 13:case 17:f!==S&&d.push(i.substring(f,S)),s!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,s)),f=u.getPosition();break}while(m!==17);return d.join("")}e.$jn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$kn=h}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ce,ce){for(var te=0;te<ce.length;te++){var Q=ce[te];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ce,Q.key,Q)}}function E(Ce,ce,te){return ce&&e(Ce.prototype,ce),te&&e(Ce,te),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,ce){if(Ce){if(typeof Ce=="string")return C(Ce,ce);var te=Object.prototype.toString.call(Ce).slice(8,-1);if(te==="Object"&&Ce.constructor&&(te=Ce.constructor.name),te==="Map"||te==="Set")return Array.from(Ce);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return C(Ce,ce)}}function C(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var te=0,Q=new Array(ce);te<ce;te++)Q[te]=Ce[te];return Q}function M(Ce,ce){var te=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(te)return(te=te.call(Ce)).next.bind(te);if(Array.isArray(Ce)||(te=T(Ce))||ce&&Ce&&typeof Ce.length=="number"){te&&(Ce=te);var Q=0;return function(){return Q>=Ce.length?{done:!0}:{done:!1,value:Ce[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function $(Ce){ge.defaults=Ce}var g=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return l[ce]};function b(Ce,ce){if(ce){if(g.test(Ce))return Ce.replace(w,p)}else if(A.test(Ce))return Ce.replace(k,p);return Ce}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(r,function(ce,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var te={replace:function(ee,me){return me=me.source||me,me=me.replace(t,"$1"),Ce=Ce.replace(ee,me),te},getRegex:function(){return new RegExp(Ce,ce)}};return te}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,te){if(Ce){var Q;try{Q=decodeURIComponent(o(te)).replace(a,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(te)&&(te=m(ce,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Ce,ce){i[" "+Ce]||(s.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=v(Ce,"/",!0)),Ce=i[" "+Ce];var te=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?te?ce:Ce.replace(u,"$1")+ce:ce.charAt(0)==="/"?te?ce:Ce.replace(d,"$1")+ce:Ce+ce}var f={exec:function(){}};function S(Ce){for(var ce=1,te,Q;ce<arguments.length;ce++){te=arguments[ce];for(Q in te)Object.prototype.hasOwnProperty.call(te,Q)&&(Ce[Q]=te[Q])}return Ce}function L(Ce,ce){var te=Ce.replace(/\|/g,function(me,pe,Le){for(var de=!1,ye=pe;--ye>=0&&Le[ye]==="\\";)de=!de;return de?"|":" |"}),Q=te.split(/ \|/),ee=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;ee<Q.length;ee++)Q[ee]=Q[ee].trim().replace(/\\\|/g,"|");return Q}function v(Ce,ce,te){var Q=Ce.length;if(Q===0)return"";for(var ee=0;ee<Q;){var me=Ce.charAt(Q-ee-1);if(me===ce&&!te)ee++;else if(me!==ce&&te)ee++;else break}return Ce.slice(0,Q-ee)}function y(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var te=Ce.length,Q=0,ee=0;ee<te;ee++)if(Ce[ee]==="\\")ee++;else if(Ce[ee]===ce[0])Q++;else if(Ce[ee]===ce[1]&&(Q--,Q<0))return ee;return-1}function D(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Ce,ce){if(ce<1)return"";for(var te="";ce>1;)ce&1&&(te+=Ce),ce>>=1,Ce+=Ce;return te+Ce}function O(Ce,ce,te,Q){var ee=ce.href,me=ce.title?b(ce.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){Q.state.inLink=!0;var Le={type:"link",raw:te,href:ee,title:me,text:pe,tokens:Q.inlineTokens(pe)};return Q.state.inLink=!1,Le}return{type:"image",raw:te,href:ee,title:me,text:b(pe)}}function G(Ce,ce){var te=Ce.match(/^(\s+)(?:```)/);if(te===null)return ce;var Q=te[1];return ce.split(`
`).map(function(ee){var me=ee.match(/^\s+/);if(me===null)return ee;var pe=me[0];return pe.length>=Q.length?ee.slice(Q.length):ee}).join(`
`)}var W=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.space=function(Q){var ee=this.rules.block.newline.exec(Q);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(Q){var ee=this.rules.block.code.exec(Q);if(ee){var me=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},ce.fences=function(Q){var ee=this.rules.block.fences.exec(Q);if(ee){var me=ee[0],pe=G(me,ee[3]||"");return{type:"code",raw:me,lang:ee[2]?ee[2].trim():ee[2],text:pe}}},ce.heading=function(Q){var ee=this.rules.block.heading.exec(Q);if(ee){var me=ee[2].trim();if(/#$/.test(me)){var pe=v(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:me,tokens:this.lexer.inline(me)}}},ce.hr=function(Q){var ee=this.rules.block.hr.exec(Q);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(Q){var ee=this.rules.block.blockquote.exec(Q);if(ee){var me=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ce.list=function(Q){var ee=this.rules.block.list.exec(Q);if(ee){var me,pe,Le,de,ye,F,q,H,z,X,x,Ee,Te=ee[1].trim(),Ve=Te.length>1,Ke={type:"list",raw:"",ordered:Ve,start:Ve?+Te.slice(0,-1):"",loose:!1,items:[]};Te=Ve?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=Ve?Te:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(Ee=!1,!(!(ee=Ze.exec(Q))||this.rules.block.hr.test(Q)));){if(me=ee[0],Q=Q.substring(me.length),H=ee[2].split(`
`,1)[0],z=Q.split(`
`,1)[0],this.options.pedantic?(de=2,x=H.trimLeft()):(de=ee[2].search(/[^ ]/),de=de>4?1:de,x=H.slice(de),de+=ee[1].length),F=!1,!H&&/^ *$/.test(z)&&(me+=z+`
`,Q=Q.substring(z.length+1),Ee=!0),!Ee)for(var st=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(X=Q.split(`
`,1)[0],H=X,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(H)||at.test(H)||st.test(H)||nt.test(Q)));){if(H.search(/[^ ]/)>=de||!H.trim())x+=`
`+H.slice(de);else if(!F)x+=`
`+H;else break;!F&&!H.trim()&&(F=!0),me+=X+`
`,Q=Q.substring(X.length+1)}Ke.loose||(q?Ke.loose=!0:/\n *\n *$/.test(me)&&(q=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(x),pe&&(Le=pe[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:me,task:!!pe,checked:Le,loose:!1,text:x}),Ke.raw+=me}Ke.items[Ke.items.length-1].raw=me.trimRight(),Ke.items[Ke.items.length-1].text=x.trimRight(),Ke.raw=Ke.raw.trimRight();var ct=Ke.items.length;for(ye=0;ye<ct;ye++){this.lexer.state.top=!1,Ke.items[ye].tokens=this.lexer.blockTokens(Ke.items[ye].text,[]);var je=Ke.items[ye].tokens.filter(function(Y){return Y.type==="space"}),vt=je.every(function(Y){for(var _=Y.raw.split(""),$e=0,Be=M(_),Qe;!(Qe=Be()).done;){var it=Qe.value;if(it===`
`&&($e+=1),$e>1)return!0}return!1});!Ke.loose&&je.length&&vt&&(Ke.loose=!0,Ke.items[ye].loose=!0)}return Ke}},ce.html=function(Q){var ee=this.rules.block.html.exec(Q);if(ee){var me={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},ce.def=function(Q){var ee=this.rules.block.def.exec(Q);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var me=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(Q){var ee=this.rules.block.table.exec(Q);if(ee){var me={type:"table",header:L(ee[1]).map(function(q){return{text:q}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ee[0];var pe=me.align.length,Le,de,ye,F;for(Le=0;Le<pe;Le++)/^ *-+: *$/.test(me.align[Le])?me.align[Le]="right":/^ *:-+: *$/.test(me.align[Le])?me.align[Le]="center":/^ *:-+ *$/.test(me.align[Le])?me.align[Le]="left":me.align[Le]=null;for(pe=me.rows.length,Le=0;Le<pe;Le++)me.rows[Le]=L(me.rows[Le],me.header.length).map(function(q){return{text:q}});for(pe=me.header.length,de=0;de<pe;de++)me.header[de].tokens=this.lexer.inline(me.header[de].text);for(pe=me.rows.length,de=0;de<pe;de++)for(F=me.rows[de],ye=0;ye<F.length;ye++)F[ye].tokens=this.lexer.inline(F[ye].text);return me}}},ce.lheading=function(Q){var ee=this.rules.block.lheading.exec(Q);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(Q){var ee=this.rules.block.paragraph.exec(Q);if(ee){var me=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:me,tokens:this.lexer.inline(me)}}},ce.text=function(Q){var ee=this.rules.block.text.exec(Q);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(Q){var ee=this.rules.inline.escape.exec(Q);if(ee)return{type:"escape",raw:ee[0],text:b(ee[1])}},ce.tag=function(Q){var ee=this.rules.inline.tag.exec(Q);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]):ee[0]}},ce.link=function(Q){var ee=this.rules.inline.link.exec(Q);if(ee){var me=ee[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=v(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Le=y(ee[2],"()");if(Le>-1){var de=ee[0].indexOf("!")===0?5:4,ye=de+ee[1].length+Le;ee[2]=ee[2].substring(0,Le),ee[0]=ee[0].substring(0,ye).trim(),ee[3]=""}}var F=ee[2],q="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);H&&(F=H[1],q=H[3])}else q=ee[3]?ee[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(me)?F=F.slice(1):F=F.slice(1,-1)),O(ee,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(Q,ee){var me;if((me=this.rules.inline.reflink.exec(Q))||(me=this.rules.inline.nolink.exec(Q))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=ee[pe.toLowerCase()],!pe||!pe.href){var Le=me[0].charAt(0);return{type:"text",raw:Le,text:Le}}return O(me,pe,me[0],this.lexer)}},ce.emStrong=function(Q,ee,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(Q);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=pe[1]||pe[2]||"";if(!Le||Le&&(me===""||this.rules.inline.punctuation.exec(me))){var de=pe[0].length-1,ye,F,q=de,H=0,z=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,ee=ee.slice(-1*Q.length+de);(pe=z.exec(ee))!=null;)if(ye=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ye){if(F=ye.length,pe[3]||pe[4]){q+=F;continue}else if((pe[5]||pe[6])&&de%3&&!((de+F)%3)){H+=F;continue}if(q-=F,!(q>0)){if(F=Math.min(F,F+q+H),Math.min(de,F)%2){var X=Q.slice(1,de+pe.index+F);return{type:"em",raw:Q.slice(0,de+pe.index+F+1),text:X,tokens:this.lexer.inlineTokens(X)}}var x=Q.slice(2,de+pe.index+F-1);return{type:"strong",raw:Q.slice(0,de+pe.index+F+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ce.codespan=function(Q){var ee=this.rules.inline.code.exec(Q);if(ee){var me=ee[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Le=/^ /.test(me)&&/ $/.test(me);return pe&&Le&&(me=me.substring(1,me.length-1)),me=b(me,!0),{type:"codespan",raw:ee[0],text:me}}},ce.br=function(Q){var ee=this.rules.inline.br.exec(Q);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(Q){var ee=this.rules.inline.del.exec(Q);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(Q,ee){var me=this.rules.inline.autolink.exec(Q);if(me){var pe,Le;return me[2]==="@"?(pe=b(this.options.mangle?ee(me[1]):me[1]),Le="mailto:"+pe):(pe=b(me[1]),Le=pe),{type:"link",raw:me[0],text:pe,href:Le,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.url=function(Q,ee){var me;if(me=this.rules.inline.url.exec(Q)){var pe,Le;if(me[2]==="@")pe=b(this.options.mangle?ee(me[0]):me[0]),Le="mailto:"+pe;else{var de;do de=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(de!==me[0]);pe=b(me[0]),me[1]==="www."?Le="http://"+pe:Le=pe}return{type:"link",raw:me[0],text:pe,href:Le,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.inlineText=function(Q,ee){var me=this.rules.inline.text.exec(Q);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):b(me[0]):me[0]:pe=b(this.options.smartypants?ee(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},Ce}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=n(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=n(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=n(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=n(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=n(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=S({},U),U.gfm=S({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=n(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=S({},U.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(U._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",U._label).getRegex(),P.nolink=n(P.nolink).replace("ref",U._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=S({},P),P.pedantic=S({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=S({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=S({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function I(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ce){var ce="",te,Q,ee=Ce.length;for(te=0;te<ee;te++)Q=Ce.charCodeAt(te),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Ce(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ge.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:U.normal,inline:P.normal};this.options.pedantic?(Q.block=U.pedantic,Q.inline=P.pedantic):this.options.gfm&&(Q.block=U.gfm,this.options.breaks?Q.inline=P.breaks:Q.inline=P.gfm),this.tokenizer.rules=Q}Ce.lex=function(Q,ee){var me=new Ce(ee);return me.lex(Q)},Ce.lexInline=function(Q,ee){var me=new Ce(ee);return me.inlineTokens(Q)};var ce=Ce.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(q,H,z){return H+"    ".repeat(z.length)});for(var pe,Le,de,ye;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(pe=q.call({lexer:me},Q,ee))?(Q=Q.substring(pe.raw.length),ee.push(pe),!0):!1}))){if(pe=this.tokenizer.space(Q)){Q=Q.substring(pe.raw.length),pe.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(pe);continue}if(pe=this.tokenizer.code(Q)){Q=Q.substring(pe.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+pe.raw,Le.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(pe);continue}if(pe=this.tokenizer.fences(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.heading(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.hr(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.blockquote(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.list(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.html(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.def(Q)){Q=Q.substring(pe.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+pe.raw,Le.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.lheading(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,H=Q.slice(1),z=void 0;me.options.extensions.startBlock.forEach(function(X){z=X.call({lexer:this},H),typeof z=="number"&&z>=0&&(q=Math.min(q,z))}),q<1/0&&q>=0&&(de=Q.substring(0,q+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(de))){Le=ee[ee.length-1],ye&&Le.type==="paragraph"?(Le.raw+=`
`+pe.raw,Le.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(pe),ye=de.length!==Q.length,Q=Q.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(Q)){Q=Q.substring(pe.raw.length),Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+pe.raw,Le.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(pe);continue}if(Q){var F="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,ee},ce.inline=function(Q,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:Q,tokens:ee}),ee},ce.inlineTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]);var pe,Le,de,ye=Q,F,q,H;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)z.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,F.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(q||(H=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(pe=x.call({lexer:me},Q,ee))?(Q=Q.substring(pe.raw.length),ee.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.tag(Q)){Q=Q.substring(pe.raw.length),Le=ee[ee.length-1],Le&&pe.type==="text"&&Le.type==="text"?(Le.raw+=pe.raw,Le.text+=pe.text):ee.push(pe);continue}if(pe=this.tokenizer.link(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(pe.raw.length),Le=ee[ee.length-1],Le&&pe.type==="text"&&Le.type==="text"?(Le.raw+=pe.raw,Le.text+=pe.text):ee.push(pe);continue}if(pe=this.tokenizer.emStrong(Q,ye,H)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.codespan(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.br(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.del(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.autolink(Q,K)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(Q,K))){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,Ee=Q.slice(1),Te=void 0;me.options.extensions.startInline.forEach(function(Ve){Te=Ve.call({lexer:this},Ee),typeof Te=="number"&&Te>=0&&(x=Math.min(x,Te))}),x<1/0&&x>=0&&(de=Q.substring(0,x+1))}(),pe=this.tokenizer.inlineText(de,I)){Q=Q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(H=pe.raw.slice(-1)),q=!0,Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=pe.raw,Le.text+=pe.text):ee.push(pe);continue}if(Q){var X="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ee},E(Ce,null,[{key:"rules",get:function(){return{block:U,inline:P}}}]),Ce}(),he=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.code=function(Q,ee,me){var pe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(Q,pe);Le!=null&&Le!==Q&&(me=!0,Q=Le)}return Q=Q.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+b(pe,!0)+'">'+(me?Q:b(Q,!0))+`</code></pre>
`:"<pre><code>"+(me?Q:b(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,ee,me,pe){if(this.options.headerIds){var Le=this.options.headerPrefix+pe.slug(me);return"<h"+ee+' id="'+Le+'">'+Q+"</h"+ee+`>
`}return"<h"+ee+">"+Q+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,ee,me){var pe=ee?"ol":"ul",Le=ee&&me!==1?' start="'+me+'"':"";return"<"+pe+Le+`>
`+Q+"</"+pe+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+ee+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,ee){var me=ee.header?"th":"td",pe=ee.align?"<"+me+' align="'+ee.align+'">':"<"+me+">";return pe+Q+("</"+me+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<a href="'+b(Q)+'"';return ee&&(pe+=' title="'+ee+'"'),pe+=">"+me+"</a>",pe},ce.image=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<img src="'+Q+'" alt="'+me+'"';return ee&&(pe+=' title="'+ee+'"'),pe+=this.options.xhtml?"/>":">",pe},ce.text=function(Q){return Q},Ce}(),be=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,ee,me){return""+me},ce.image=function(Q,ee,me){return""+me},ce.br=function(){return""},Ce}(),De=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,ee){var me=Q,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[Q];do pe++,me=Q+"-"+pe;while(this.seen.hasOwnProperty(me))}return ee||(this.seen[Q]=pe,this.seen[me]=0),me},ce.slug=function(Q,ee){ee===void 0&&(ee={});var me=this.serialize(Q);return this.getNextSafeSlug(me,ee.dryrun)},Ce}(),le=function(){function Ce(te){this.options=te||ge.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new De}Ce.parse=function(Q,ee){var me=new Ce(ee);return me.parse(Q)},Ce.parseInline=function(Q,ee){var me=new Ce(ee);return me.parseInline(Q)};var ce=Ce.prototype;return ce.parse=function(Q,ee){ee===void 0&&(ee=!0);var me="",pe,Le,de,ye,F,q,H,z,X,x,Ee,Te,Ve,Ke,Ze,st,nt,tt,at,ct=Q.length;for(pe=0;pe<ct;pe++){if(x=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(at=this.options.extensions.renderers[x.type].call({parser:this},x),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){me+=at||"";continue}switch(x.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(x.tokens),x.depth,o(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(z="",H="",ye=x.header.length,Le=0;Le<ye;Le++)H+=this.renderer.tablecell(this.parseInline(x.header[Le].tokens),{header:!0,align:x.align[Le]});for(z+=this.renderer.tablerow(H),X="",ye=x.rows.length,Le=0;Le<ye;Le++){for(q=x.rows[Le],H="",F=q.length,de=0;de<F;de++)H+=this.renderer.tablecell(this.parseInline(q[de].tokens),{header:!1,align:x.align[de]});X+=this.renderer.tablerow(H)}me+=this.renderer.table(z,X);continue}case"blockquote":{X=this.parse(x.tokens),me+=this.renderer.blockquote(X);continue}case"list":{for(Ee=x.ordered,Te=x.start,Ve=x.loose,ye=x.items.length,X="",Le=0;Le<ye;Le++)Ze=x.items[Le],st=Ze.checked,nt=Ze.task,Ke="",Ze.task&&(tt=this.renderer.checkbox(st),Ve?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=tt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=tt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:tt}):Ke+=tt),Ke+=this.parse(Ze.tokens,Ve),X+=this.renderer.listitem(Ke,nt,st);me+=this.renderer.list(X,Ee,Te);continue}case"html":{me+=this.renderer.html(x.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(X=x.tokens?this.parseInline(x.tokens):x.text;pe+1<ct&&Q[pe+1].type==="text";)x=Q[++pe],X+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);me+=ee?this.renderer.paragraph(X):X;continue}default:{var je='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return me},ce.parseInline=function(Q,ee){ee=ee||this.renderer;var me="",pe,Le,de,ye=Q.length;for(pe=0;pe<ye;pe++){if(Le=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(de=this.options.extensions.renderers[Le.type].call({parser:this},Le),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){me+=de||"";continue}switch(Le.type){case"escape":{me+=ee.text(Le.text);break}case"html":{me+=ee.html(Le.text);break}case"link":{me+=ee.link(Le.href,Le.title,this.parseInline(Le.tokens,ee));break}case"image":{me+=ee.image(Le.href,Le.title,Le.text);break}case"strong":{me+=ee.strong(this.parseInline(Le.tokens,ee));break}case"em":{me+=ee.em(this.parseInline(Le.tokens,ee));break}case"codespan":{me+=ee.codespan(Le.text);break}case"br":{me+=ee.br();break}case"del":{me+=ee.del(this.parseInline(Le.tokens,ee));break}case"text":{me+=ee.text(Le.text);break}default:{var F='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return me},Ce}();function ve(Ce,ce,te){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(te=ce,ce=null),ce=S({},ve.defaults,ce||{}),D(ce),te){var Q=ce.highlight,ee;try{ee=ae.lex(Ce,ce)}catch(ye){return te(ye)}var me=function(F){var q;if(!F)try{ce.walkTokens&&ve.walkTokens(ee,ce.walkTokens),q=le.parse(ee,ce)}catch(H){F=H}return ce.highlight=Q,F?te(F):te(null,q)};if(!Q||Q.length<3||(delete ce.highlight,!ee.length))return me();var pe=0;ve.walkTokens(ee,function(ye){ye.type==="code"&&(pe++,setTimeout(function(){Q(ye.text,ye.lang,function(F,q){if(F)return me(F);q!=null&&q!==ye.text&&(ye.text=q,ye.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Le(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(ye.message+"",!0)+"</pre>";throw ye}try{var de=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(de,ce.walkTokens)).then(function(){return le.parse(de,ce)}).catch(Le);ve.walkTokens(de,ce.walkTokens)}return le.parse(de,ce)}catch(ye){Le(ye)}}ve.options=ve.setOptions=function(Ce){return S(ve.defaults,Ce),$(ve.defaults),ve},ve.getDefaults=R,ve.defaults=ge.defaults,ve.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),te=0;te<Ce;te++)ce[te]=arguments[te];var Q=S.apply(void 0,[{}].concat(ce)),ee=ve.defaults.extensions||{renderers:{},childTokens:{}},me;ce.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var ye=ee.renderers?ee.renderers[de.name]:null;ye?ee.renderers[de.name]=function(){for(var F=arguments.length,q=new Array(F),H=0;H<F;H++)q[H]=arguments[H];var z=de.renderer.apply(this,q);return z===!1&&(z=ye.apply(this,q)),z}:ee.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[de.level]?ee[de.level].unshift(de.tokenizer):ee[de.level]=[de.tokenizer],de.start&&(de.level==="block"?ee.startBlock?ee.startBlock.push(de.start):ee.startBlock=[de.start]:de.level==="inline"&&(ee.startInline?ee.startInline.push(de.start):ee.startInline=[de.start]))}de.childTokens&&(ee.childTokens[de.name]=de.childTokens)})),pe.renderer&&function(){var de=ve.defaults.renderer||new he,ye=function(H){var z=de[H];de[H]=function(){for(var X=arguments.length,x=new Array(X),Ee=0;Ee<X;Ee++)x[Ee]=arguments[Ee];var Te=pe.renderer[H].apply(de,x);return Te===!1&&(Te=z.apply(de,x)),Te}};for(var F in pe.renderer)ye(F);Q.renderer=de}(),pe.tokenizer&&function(){var de=ve.defaults.tokenizer||new W,ye=function(H){var z=de[H];de[H]=function(){for(var X=arguments.length,x=new Array(X),Ee=0;Ee<X;Ee++)x[Ee]=arguments[Ee];var Te=pe.tokenizer[H].apply(de,x);return Te===!1&&(Te=z.apply(de,x)),Te}};for(var F in pe.tokenizer)ye(F);Q.tokenizer=de}(),pe.walkTokens){var Le=ve.defaults.walkTokens;Q.walkTokens=function(de){var ye=[];return ye.push(pe.walkTokens.call(this,de)),Le&&(ye=ye.concat(Le.call(this,de))),ye}}me&&(Q.extensions=ee),ve.setOptions(Q)})},ve.walkTokens=function(Ce,ce){for(var te=[],Q=function(){var Le=me.value;switch(te=te.concat(ce.call(ve,Le)),Le.type){case"table":{for(var de=M(Le.header),ye;!(ye=de()).done;){var F=ye.value;te=te.concat(ve.walkTokens(F.tokens,ce))}for(var q=M(Le.rows),H;!(H=q()).done;)for(var z=H.value,X=M(z),x;!(x=X()).done;){var Ee=x.value;te=te.concat(ve.walkTokens(Ee.tokens,ce))}break}case"list":{te=te.concat(ve.walkTokens(Le.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Le.type]?ve.defaults.extensions.childTokens[Le.type].forEach(function(Te){te=te.concat(ve.walkTokens(Le[Te],ce))}):Le.tokens&&(te=te.concat(ve.walkTokens(Le.tokens,ce)))}},ee=M(Ce),me;!(me=ee()).done;)Q();return te},ve.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=S({},ve.defaults,ce||{}),D(ce);try{var te=ae.lexInline(Ce,ce);return ce.walkTokens&&ve.walkTokens(te,ce.walkTokens),le.parseInline(te,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(Q.message+"",!0)+"</pre>";throw Q}},ve.Parser=le,ve.parser=le.parse,ve.Renderer=he,ve.TextRenderer=be,ve.Lexer=ae,ve.lexer=ae.lex,ve.Tokenizer=W,ve.Slugger=De,ve.parse=ve;var se=ve.options,we=ve.setOptions,ne=ve.use,Z=ve.walkTokens,V=ve.parseInline,ie=ve,Ie=le.parse,Ae=ae.lex;ge.Lexer=ae,ge.Parser=le,ge.Renderer=he,ge.Slugger=De,ge.TextRenderer=be,ge.Tokenizer=W,ge.getDefaults=R,ge.lexer=Ae,ge.marked=ve,ge.options=se,ge.parse=ie,ge.parseInline=V,ge.parser=Ie,ge.setOptions=we,ge.use=ne,ge.walkTokens=Z,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=void 0;function E(r){const o=M(r);if(o&&o.length>0)return new Uint32Array(o)}e.$Qj=E;let T=0;const C=new Uint32Array(10);function M(r){if(T=0,R(r,k,4352),T>0||(R(r,l,4449),T>0)||(R(r,p,4520),T>0)||(R(r,b,12593),T))return C.subarray(0,T);if(r>=44032&&r<=55203){const o=r-44032,t=o%588,n=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(n<k.length?R(n,k,0):4352+n-12593<b.length&&R(4352+n,b,12593),a<l.length?R(a,l,0):4449+a-12593<b.length&&R(4449+a-12593,b,12593),c>=0&&(c<p.length?R(c,p,0):4520+c-12593<b.length&&R(4520+c-12593,b,12593)),T>0)return C.subarray(0,T)}}function R(r,o,t){r>=t&&r<t+o.length&&$(o[r-t])}function $(r){r!==0&&(C[T++]=r&255,r>>8&&(C[T++]=r>>8&255),r>>16&&(C[T++]=r>>16&255))}var g;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var w;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(w||(w={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),b=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.rot=e.$6l=void 0;function E($,g,w){return Math.min(Math.max($,g),w)}e.$6l=E;function T($,g){return(g+$%g)%g}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$8l=C;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$9l=M;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$0l=R}),function(){function ge(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function R(g){M.push(g,Date.now())}function $(){const g=[];for(let w=0;w<M.length;w+=2)g.push({name:M[w],startTime:M[w+1]});return g}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(C+R.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:ge)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function E(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return ge[T].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=ge,E.c=e,E.d=function(T,C,M){E.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:M})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,C){if(1&C&&(T=E(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var R in T)E.d(M,R,function($){return T[$]}.bind(null,R));return M},E.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(C,"a",C),C},E.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},E.p="",E(E.s=0)}([function(ge,e,E){(function(T){var C;e=ge.exports=ne,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],g=e.src=[],w=0,A=w++;g[A]="0|[1-9]\\d*";var k=w++;g[k]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;g[p]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var b=w++;g[b]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var r=w++;g[r]="(?:"+g[A]+"|"+g[l]+")";var o=w++;g[o]="(?:"+g[k]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[r]+"(?:\\."+g[r]+")*))";var n=w++;g[n]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=w++;g[a]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=w++,i="v?"+g[p]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var s="[v=\\s]*"+g[b]+g[n]+"?"+g[c]+"?",u=w++;g[u]="^"+s+"$";var d=w++;g[d]="((?:<|>)?=?)";var m=w++;g[m]=g[k]+"|x|X|\\*";var f=w++;g[f]=g[A]+"|x|X|\\*";var S=w++;g[S]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var L=w++;g[L]="[v=\\s]*("+g[m]+")(?:\\.("+g[m]+")(?:\\.("+g[m]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var v=w++;g[v]="^"+g[d]+"\\s*"+g[S]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[L]+"$";var D=w++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=w++;g[N]="(?:~>?)";var O=w++;g[O]="(\\s*)"+g[N]+"\\s+",$[O]=new RegExp(g[O],"g");var G=w++;g[G]="^"+g[N]+g[S]+"$";var W=w++;g[W]="^"+g[N]+g[L]+"$";var U=w++;g[U]="(?:\\^)";var P=w++;g[P]="(\\s*)"+g[U]+"\\s+",$[P]=new RegExp(g[P],"g");var I=w++;g[I]="^"+g[U]+g[S]+"$";var K=w++;g[K]="^"+g[U]+g[L]+"$";var ae=w++;g[ae]="^"+g[d]+"\\s*("+s+")$|^$";var he=w++;g[he]="^"+g[d]+"\\s*("+i+")$|^$";var be=w++;g[be]="(\\s*)"+g[d]+"\\s*("+s+"|"+g[S]+")",$[be]=new RegExp(g[be],"g");var De=w++;g[De]="^\\s*("+g[S]+")\\s+-\\s+("+g[S]+")\\s*$";var le=w++;g[le]="^\\s*("+g[L]+")\\s+-\\s+("+g[L]+")\\s*$";var ve=w++;g[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)C(se,g[se]),$[se]||($[se]=new RegExp(g[se]));function we(z,X){if(z instanceof ne)return z;if(typeof z!="string"||z.length>M||!(X?$[u]:$[h]).test(z))return null;try{return new ne(z,X)}catch{return null}}function ne(z,X){if(z instanceof ne){if(z.loose===X)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ne))return new ne(z,X);C("SemVer",z,X),this.loose=X;var x=z.trim().match(X?$[u]:$[h]);if(!x)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Te=+Ee;if(Te>=0&&Te<R)return Te}return Ee}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=we,e.valid=function(z,X){var x=we(z,X);return x?x.version:null},e.clean=function(z,X){var x=we(z.trim().replace(/^[=v]+/,""),X);return x?x.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(z){return C("SemVer.compare",this.version,this.loose,z),z instanceof ne||(z=new ne(z,this.loose)),this.compareMain(z)||this.comparePre(z)},ne.prototype.compareMain=function(z){return z instanceof ne||(z=new ne(z,this.loose)),V(this.major,z.major)||V(this.minor,z.minor)||V(this.patch,z.patch)},ne.prototype.comparePre=function(z){if(z instanceof ne||(z=new ne(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var X=0;do{var x=this.prerelease[X],Ee=z.prerelease[X];if(C("prerelease compare",X,x,Ee),x===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(x===void 0)return-1;if(x!==Ee)return V(x,Ee)}while(++X)},ne.prototype.inc=function(z,X){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,X,x,Ee){typeof x=="string"&&(Ee=x,x=void 0);try{return new ne(z,x).inc(X,Ee).version}catch{return null}},e.diff=function(z,X){if(Ce(z,X))return null;var x=we(z),Ee=we(X);if(x.prerelease.length||Ee.prerelease.length){for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==Ee[Te])return"pre"+Te;return"prerelease"}for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==Ee[Te])return Te},e.compareIdentifiers=V;var Z=/^[0-9]+$/;function V(z,X){var x=Z.test(z),Ee=Z.test(X);return x&&Ee&&(z=+z,X=+X),x&&!Ee?-1:Ee&&!x?1:z<X?-1:z>X?1:0}function ie(z,X,x){return new ne(z,x).compare(new ne(X,x))}function Ie(z,X,x){return ie(z,X,x)>0}function Ae(z,X,x){return ie(z,X,x)<0}function Ce(z,X,x){return ie(z,X,x)===0}function ce(z,X,x){return ie(z,X,x)!==0}function te(z,X,x){return ie(z,X,x)>=0}function Q(z,X,x){return ie(z,X,x)<=0}function ee(z,X,x,Ee){var Te;switch(X){case"===":typeof z=="object"&&(z=z.version),typeof x=="object"&&(x=x.version),Te=z===x;break;case"!==":typeof z=="object"&&(z=z.version),typeof x=="object"&&(x=x.version),Te=z!==x;break;case"":case"=":case"==":Te=Ce(z,x,Ee);break;case"!=":Te=ce(z,x,Ee);break;case">":Te=Ie(z,x,Ee);break;case">=":Te=te(z,x,Ee);break;case"<":Te=Ae(z,x,Ee);break;case"<=":Te=Q(z,x,Ee);break;default:throw new TypeError("Invalid operator: "+X)}return Te}function me(z,X){if(z instanceof me){if(z.loose===X)return z;z=z.value}if(!(this instanceof me))return new me(z,X);C("comparator",z,X),this.loose=X,this.parse(z),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(z,X){return V(X,z)},e.major=function(z,X){return new ne(z,X).major},e.minor=function(z,X){return new ne(z,X).minor},e.patch=function(z,X){return new ne(z,X).patch},e.compare=ie,e.compareLoose=function(z,X){return ie(z,X,!0)},e.rcompare=function(z,X,x){return ie(X,z,x)},e.sort=function(z,X){return z.sort(function(x,Ee){return e.compare(x,Ee,X)})},e.rsort=function(z,X){return z.sort(function(x,Ee){return e.rcompare(x,Ee,X)})},e.gt=Ie,e.lt=Ae,e.eq=Ce,e.neq=ce,e.gte=te,e.lte=Q,e.cmp=ee,e.Comparator=me;var pe={};function Le(z,X){if(z instanceof Le)return z.loose===X?z:new Le(z.raw,X);if(z instanceof me)return new Le(z.value,X);if(!(this instanceof Le))return new Le(z,X);if(this.loose=X,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function de(z){return!z||z.toLowerCase()==="x"||z==="*"}function ye(z,X,x,Ee,Te,Ve,Ke,Ze,st,nt,tt,at,ct){return((X=de(x)?"":de(Ee)?">="+x+".0.0":de(Te)?">="+x+"."+Ee+".0":">="+X)+" "+(Ze=de(st)?"":de(nt)?"<"+(+st+1)+".0.0":de(tt)?"<"+st+"."+(+nt+1)+".0":at?"<="+st+"."+nt+"."+tt+"-"+at:"<="+Ze)).trim()}function F(z,X){for(var x=0;x<z.length;x++)if(!z[x].test(X))return!1;if(X.prerelease.length){for(x=0;x<z.length;x++)if(C(z[x].semver),z[x].semver!==pe&&z[x].semver.prerelease.length>0){var Ee=z[x].semver;if(Ee.major===X.major&&Ee.minor===X.minor&&Ee.patch===X.patch)return!0}return!1}return!0}function q(z,X,x){try{X=new Le(X,x)}catch{return!1}return X.test(z)}function H(z,X,x,Ee){var Te,Ve,Ke,Ze,st;switch(z=new ne(z,Ee),X=new Le(X,Ee),x){case">":Te=Ie,Ve=Q,Ke=Ae,Ze=">",st=">=";break;case"<":Te=Ae,Ve=te,Ke=Ie,Ze="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(z,X,Ee))return!1;for(var nt=0;nt<X.set.length;++nt){var tt=X.set[nt],at=null,ct=null;if(tt.forEach(function(je){je.semver===pe&&(je=new me(">=0.0.0")),at=at||je,ct=ct||je,Te(je.semver,at.semver,Ee)?at=je:Ke(je.semver,ct.semver,Ee)&&(ct=je)}),at.operator===Ze||at.operator===st||(!ct.operator||ct.operator===Ze)&&Ve(z,ct.semver)||ct.operator===st&&Ke(z,ct.semver))return!1}return!0}me.prototype.parse=function(z){var X=this.loose?$[ae]:$[he],x=z.match(X);if(!x)throw new TypeError("Invalid comparator: "+z);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ne(x[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(z){return C("Comparator.test",z,this.loose),this.semver===pe||(typeof z=="string"&&(z=new ne(z,this.loose)),ee(z,this.operator,this.semver,this.loose))},me.prototype.intersects=function(z,X){if(!(z instanceof me))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Le(z.value,X),q(this.value,x,X);if(z.operator==="")return x=new Le(this.value,X),q(z.semver,x,X);var Ee=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Ve=this.semver.version===z.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ze=ee(this.semver,"<",z.semver,X)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),st=ee(this.semver,">",z.semver,X)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return Ee||Te||Ve&&Ke||Ze||st},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(z){var X=this.loose;z=z.trim(),C("range",z,X);var x=X?$[le]:$[De];z=z.replace(x,ye),C("hyphen replace",z),z=z.replace($[be],"$1$2$3"),C("comparator trim",z,$[be]),z=(z=(z=z.replace($[O],"$1~")).replace($[P],"$1^")).split(/\s+/).join(" ");var Ee=X?$[ae]:$[he],Te=z.split(" ").map(function(Ve){return function(Ke,Ze){return C("comp",Ke),Ke=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){C("caret",at,ct);var je=ct?$[K]:$[I];return at.replace(je,function(vt,Y,_,$e,Be){var Qe;return C("caret",at,vt,Y,_,$e,Be),de(Y)?Qe="":de(_)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":de($e)?Qe=Y==="0"?">="+Y+"."+_+".0 <"+Y+"."+(+_+1)+".0":">="+Y+"."+_+".0 <"+(+Y+1)+".0.0":Be?(C("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=Y==="0"?_==="0"?">="+Y+"."+_+"."+$e+Be+" <"+Y+"."+_+"."+(+$e+1):">="+Y+"."+_+"."+$e+Be+" <"+Y+"."+(+_+1)+".0":">="+Y+"."+_+"."+$e+Be+" <"+(+Y+1)+".0.0"):(C("no pr"),Qe=Y==="0"?_==="0"?">="+Y+"."+_+"."+$e+" <"+Y+"."+_+"."+(+$e+1):">="+Y+"."+_+"."+$e+" <"+Y+"."+(+_+1)+".0":">="+Y+"."+_+"."+$e+" <"+(+Y+1)+".0.0"),C("caret return",Qe),Qe})}(tt,nt)}).join(" ")}(Ke,Ze),C("caret",Ke),Ke=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){var je=ct?$[W]:$[G];return at.replace(je,function(vt,Y,_,$e,Be){var Qe;return C("tilde",at,vt,Y,_,$e,Be),de(Y)?Qe="":de(_)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":de($e)?Qe=">="+Y+"."+_+".0 <"+Y+"."+(+_+1)+".0":Be?(C("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+Y+"."+_+"."+$e+Be+" <"+Y+"."+(+_+1)+".0"):Qe=">="+Y+"."+_+"."+$e+" <"+Y+"."+(+_+1)+".0",C("tilde return",Qe),Qe})}(tt,nt)}).join(" ")}(Ke,Ze),C("tildes",Ke),Ke=function(st,nt){return C("replaceXRanges",st,nt),st.split(/\s+/).map(function(tt){return function(at,ct){at=at.trim();var je=ct?$[y]:$[v];return at.replace(je,function(vt,Y,_,$e,Be,Qe){C("xRange",at,vt,Y,_,$e,Be,Qe);var it=de(_),rt=it||de($e),Ne=rt||de(Be);return Y==="="&&Ne&&(Y=""),it?vt=Y===">"||Y==="<"?"<0.0.0":"*":Y&&Ne?(rt&&($e=0),Ne&&(Be=0),Y===">"?(Y=">=",rt?(_=+_+1,$e=0,Be=0):Ne&&($e=+$e+1,Be=0)):Y==="<="&&(Y="<",rt?_=+_+1:$e=+$e+1),vt=Y+_+"."+$e+"."+Be):rt?vt=">="+_+".0.0 <"+(+_+1)+".0.0":Ne&&(vt=">="+_+"."+$e+".0 <"+_+"."+(+$e+1)+".0"),C("xRange return",vt),vt})}(tt,nt)}).join(" ")}(Ke,Ze),C("xrange",Ke),Ke=function(st,nt){return C("replaceStars",st,nt),st.trim().replace($[ve],"")}(Ke,Ze),C("stars",Ke),Ke}(Ve,X)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(Ve){return!!Ve.match(Ee)})),Te=Te.map(function(Ve){return new me(Ve,X)})},Le.prototype.intersects=function(z,X){if(!(z instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(Ee){return z.set.some(function(Te){return Te.every(function(Ve){return Ee.intersects(Ve,X)})})})})},e.toComparators=function(z,X){return new Le(z,X).set.map(function(x){return x.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new ne(z,this.loose));for(var X=0;X<this.set.length;X++)if(F(this.set[X],z))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(z,X,x){var Ee=null,Te=null;try{var Ve=new Le(X,x)}catch{return null}return z.forEach(function(Ke){Ve.test(Ke)&&(Ee&&Te.compare(Ke)!==-1||(Te=new ne(Ee=Ke,x)))}),Ee},e.minSatisfying=function(z,X,x){var Ee=null,Te=null;try{var Ve=new Le(X,x)}catch{return null}return z.forEach(function(Ke){Ve.test(Ke)&&(Ee&&Te.compare(Ke)!==1||(Te=new ne(Ee=Ke,x)))}),Ee},e.validRange=function(z,X){try{return new Le(z,X).range||"*"}catch{return null}},e.ltr=function(z,X,x){return H(z,X,"<",x)},e.gtr=function(z,X,x){return H(z,X,">",x)},e.outside=H,e.prerelease=function(z,X){var x=we(z,X);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(z,X,x){return z=new Le(z,x),X=new Le(X,x),z.intersects(X)},e.coerce=function(z){if(z instanceof ne)return z;if(typeof z!="string")return null;var X=z.match($[D]);return X==null?null:we((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,E(1))},function(ge,e){var E,T,C=ge.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(o){if(E===setTimeout)return setTimeout(o,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var g,w=[],A=!1,k=-1;function l(){A&&g&&(A=!1,g.length?w=g.concat(w):k=-1,w.length&&p())}function p(){if(!A){var o=$(l);A=!0;for(var t=w.length;t;){for(g=w,w=[];++k<t;)g&&g[k].run();k=-1,t=w.length}g=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(o)}}function b(o,t){this.fun=o,this.array=t}function r(){}C.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];w.push(new b(o,t)),w.length!==1||A||$(p)},b.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=r,C.addListener=r,C.once=r,C.off=r,C.removeListener=r,C.removeAllListeners=r,C.emit=r,C.prependListener=r,C.prependOnceListener=r,C.listeners=function(o){return[]},C.binding=function(o){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(o){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[123],Re([1,0,15,6]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=void 0;function C(c){const h=c;return h?typeof h.read=="function":!1}e.$6d=C;function M(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$7d=M;function R(c){const h=c;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$8d=R;function $(c,h){return new g(c,h)}e.$9d=$;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const u=s.indexOf(i);u>=0&&s.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return h(i)}e.$0d=w;function A(c,h,i){const s=[];let u;for(;(u=c.read())!==null&&s.length<i;)s.push(u);return u===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$$d=A;function k(c,h){return new Promise((i,s)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?s(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$_d=k;function l(c,h,i){c.on("error",s=>{i?.isCancellationRequested||h.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||h.onData(s)})}e.$ae=l;function p(c,h){return new Promise((i,s)=>{const u=new T.$Sc,d=[],m=L=>{if(d.push(L),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=L=>(u.dispose(),s(L)),S=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Rc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Rc)(()=>c.removeListener("end",S))),c.on("end",S),u.add((0,T.$Rc)(()=>c.removeListener("data",m))),c.on("data",m)})}e.$be=p;function b(c,h){const i=$(h);return i.end(c),i}e.$ce=b;function r(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$de=r;function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ee=o;function t(c,h,i){const s=$(i);return l(c,{onData:u=>s.write(h.data(u)),onError:u=>s.error(h.error?h.error(u):u),onEnd:()=>s.end()}),s}e.$fe=t;function n(c,h,i){let s=!1;return{read:()=>{const u=h.read();return s?u:(s=!0,u!==null?i([c,u]):c)}}}e.$ge=n;function a(c,h,i){let s=!1;const u=$(i);return l(h,{onData:d=>s?u.write(d):(s=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.$he=a}),define(Pe[24],Re([1,0,39,123]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;const C=typeof Buffer<"u",M=new E.$V(()=>new Uint8Array(256));let R,$;class g{static alloc(D){return C?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return C&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,N){return!(N?.dontUseNodeBuffer||!1)&&C?new g(Buffer.from(D)):(R||(R=new TextEncoder),new g(R.encode(D)))}static fromByteArray(D){const N=g.alloc(D.length);for(let O=0,G=D.length;O<G;O++)N.buffer[O]=D[O];return N}static concat(D,N){if(typeof N>"u"){N=0;for(let W=0,U=D.length;W<U;W++)N+=D[W].byteLength}const O=g.alloc(N);let G=0;for(let W=0,U=D.length;W<U;W++){const P=D[W];O.set(P,G),G+=P.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return C?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(D,N){return new g(this.buffer.subarray(D,N))}set(D,N){if(D instanceof g)this.buffer.set(D.buffer,N);else if(D instanceof Uint8Array)this.buffer.set(D,N);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),N);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,N){p(this.buffer,D,N)}readUInt32LE(D){return b(this.buffer,D)}writeUInt32LE(D,N){r(this.buffer,D,N)}readUInt8(D){return o(this.buffer,D)}writeUInt8(D,N){t(this.buffer,D,N)}indexOf(D,N=0){return w(this.buffer,D instanceof g?D.buffer:D,N)}}e.$ie=g;function w(y,D,N=0){const O=D.byteLength,G=y.byteLength;if(O===0)return 0;if(O===1)return y.indexOf(D[0]);if(O>G-N)return-1;const W=M.value;W.fill(D.length);for(let K=0;K<D.length;K++)W[D[K]]=D.length-K-1;let U=N+D.length-1,P=U,I=-1;for(;U<G;)if(y[U]===D[P]){if(P===0){I=U;break}U--,P--}else U+=Math.max(D.length-P,W[y[U]]),P=D.length-1;return I}e.$je=w;function A(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}e.$ke=A;function k(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255}e.$le=k;function l(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}e.$me=l;function p(y,D,N){y[N+3]=D,D=D>>>8,y[N+2]=D,D=D>>>8,y[N+1]=D,D=D>>>8,y[N]=D}e.$ne=p;function b(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}e.$oe=b;function r(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255,D=D>>>8,y[N+2]=D&255,D=D>>>8,y[N+3]=D&255}e.$pe=r;function o(y,D){return y[D]}e.$qe=o;function t(y,D,N){y[N]=D}e.$re=t;function n(y){return T.$0d(y,D=>g.concat(D))}e.$se=n;function a(y){return T.$ee(y)}e.$te=a;function c(y){return T.$_d(y,D=>g.concat(D))}e.$ue=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$ve=h;function i(y){return T.$ce(y,D=>g.concat(D))}e.$we=i;function s(y){return T.$fe(y,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}e.$xe=s;function u(y){return T.$9d(D=>g.concat(D),y)}e.$ye=u;function d(y,D){return T.$ge(y,D,N=>g.concat(N))}e.$ze=d;function m(y,D){return T.$he(y,D,N=>g.concat(N))}e.$Ae=m;function f(y){let D=0,N=0,O=0;const G=new Uint8Array(Math.floor(y.length/4*3)),W=P=>{switch(N){case 3:G[O++]=D|P,N=0;break;case 2:G[O++]=D|P>>>2,D=P<<6,N=3;break;case 1:G[O++]=D|P>>>4,D=P<<4,N=2;break;default:D=P<<2,N=1}};for(let P=0;P<y.length;P++){const I=y.charCodeAt(P);if(I>=65&&I<=90)W(I-65);else if(I>=97&&I<=122)W(I-97+26);else if(I>=48&&I<=57)W(I-48+52);else if(I===43||I===45)W(62);else if(I===47||I===95)W(63);else{if(I===61)break;throw new SyntaxError(`Unexpected base64 character ${y[P]}`)}}const U=O;for(;N>0;)W(0);return g.wrap(G).slice(0,U)}e.$Be=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:y},D=!0,N=!1){const O=N?L:S;let G="";const W=y.byteLength%3;let U=0;for(;U<y.byteLength-W;U+=3){const P=y[U+0],I=y[U+1],K=y[U+2];G+=O[P>>>2],G+=O[(P<<4|I>>>4)&63],G+=O[(I<<2|K>>>6)&63],G+=O[K&63]}if(W===1){const P=y[U+0];G+=O[P>>>2],G+=O[P<<4&63],D&&(G+="==")}else if(W===2){const P=y[U+0],I=y[U+1];G+=O[P>>>2],G+=O[(P<<4|I>>>4)&63],G+=O[I<<2&63],D&&(G+="=")}return G}e.$Ce=v}),define(Pe[124],Re([1,0,28,121,11]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.FuzzyScore=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.or=void 0;function M(...de){return function(ye,F){for(let q=0,H=de.length;q<H;q++){const z=de[q](ye,F);if(z)return z}return null}}e.or=M,e.$Sj=R.bind(void 0,!1),e.$Tj=R.bind(void 0,!0);function R(de,ye,F){if(!F||F.length<ye.length)return null;let q;return de?q=C.$_e(F,ye):q=F.indexOf(ye)===0,q?ye.length>0?[{start:0,end:ye.length}]:[]:null}function $(de,ye){const F=ye.toLowerCase().indexOf(de.toLowerCase());return F===-1?null:[{start:F,end:F+de.length}]}e.$Uj=$;function g(de,ye){return w(de.toLowerCase(),ye.toLowerCase(),0,0)}e.$Vj=g;function w(de,ye,F,q){if(F===de.length)return[];if(q===ye.length)return null;if(de[F]===ye[q]){let H=null;return(H=w(de,ye,F+1,q+1))?c({start:q,end:q+1},H):null}return w(de,ye,F,q+1)}function A(de){return 97<=de&&de<=122}function k(de){return 65<=de&&de<=90}e.$Wj=k;function l(de){return 48<=de&&de<=57}function p(de){return de===32||de===9||de===10||de===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>b.add(de.charCodeAt(0)));function r(de){return p(de)||b.has(de)}function o(de,ye){return de===ye||r(de)&&r(ye)}const t=new Map;function n(de){if(t.has(de))return t.get(de);let ye;const F=(0,T.$Qj)(de);return F&&(ye=F),t.set(de,ye),ye}function a(de){return A(de)||k(de)||l(de)}function c(de,ye){return ye.length===0?ye=[de]:de.end===ye[0].start?ye[0].start=de.start:ye.unshift(de),ye}function h(de,ye){for(let F=ye;F<de.length;F++){const q=de.charCodeAt(F);if(k(q)||l(q)||F>0&&!a(de.charCodeAt(F-1)))return F}return de.length}function i(de,ye,F,q){if(F===de.length)return[];if(q===ye.length)return null;if(de[F]!==ye[q].toLowerCase())return null;{let H=null,z=q+1;for(H=i(de,ye,F+1,q+1);!H&&(z=h(ye,z))<ye.length;)H=i(de,ye,F+1,z),z++;return H===null?null:c({start:q,end:q+1},H)}}function s(de){let ye=0,F=0,q=0,H=0,z=0;for(let Ve=0;Ve<de.length;Ve++)z=de.charCodeAt(Ve),k(z)&&ye++,A(z)&&F++,a(z)&&q++,l(z)&&H++;const X=ye/de.length,x=F/de.length,Ee=q/de.length,Te=H/de.length;return{upperPercent:X,lowerPercent:x,alphaPercent:Ee,numericPercent:Te}}function u(de){const{upperPercent:ye,lowerPercent:F}=de;return F===0&&ye>.6}function d(de){const{upperPercent:ye,lowerPercent:F,alphaPercent:q,numericPercent:H}=de;return F>.2&&ye<.8&&q>.6&&H<.2}function m(de){let ye=0,F=0,q=0,H=0;for(let z=0;z<de.length;z++)q=de.charCodeAt(z),k(q)&&ye++,A(q)&&F++,p(q)&&H++;return(ye===0||F===0)&&H===0?de.length<=30:ye<=5}function f(de,ye){if(!ye||(ye=ye.trim(),ye.length===0)||!m(de)||ye.length>60)return null;const F=s(ye);if(!d(F)){if(!u(F))return null;ye=ye.toLowerCase()}let q=null,H=0;for(de=de.toLowerCase();H<ye.length&&(q=i(de,ye,0,H))===null;)H=h(ye,H+1);return q}e.$Xj=f;function S(de,ye,F=!1){if(!ye||ye.length===0)return null;let q=null,H=0;for(de=de.toLowerCase(),ye=ye.toLowerCase();H<ye.length&&(q=L(de,ye,0,H,F),q===null);)H=v(ye,H+1);return q}e.$Yj=S;function L(de,ye,F,q,H){let z=0;if(F===de.length)return[];if(q===ye.length)return null;if(!o(de.charCodeAt(F),ye.charCodeAt(q))){const Ee=n(de.charCodeAt(F));if(!Ee)return null;for(let Te=0;Te<Ee.length;Te++)if(!o(Ee[Te],ye.charCodeAt(q+Te)))return null;z+=Ee.length-1}let X=null,x=q+z+1;if(X=L(de,ye,F+1,x,H),!H)for(;!X&&(x=v(ye,x))<ye.length;)X=L(de,ye,F+1,x,H),x++;if(!X)return null;if(de.charCodeAt(F)!==ye.charCodeAt(q)){const Ee=n(de.charCodeAt(F));if(!Ee)return X;for(let Te=0;Te<Ee.length;Te++)if(Ee[Te]!==ye.charCodeAt(q+Te))return X}return c({start:q,end:q+z+1},X)}function v(de,ye){for(let F=ye;F<de.length;F++)if(r(de.charCodeAt(F))||F>0&&r(de.charCodeAt(F-1)))return F;return de.length}const y=M(e.$Tj,f,$),D=M(e.$Tj,f,g),N=new E.$Dc(1e4);function O(de,ye,F=!1){if(typeof de!="string"||typeof ye!="string")return null;let q=N.get(de);q||(q=new RegExp(C.$Ue(de),"i"),N.set(de,q));const H=q.exec(ye);return H?[{start:H.index,end:H.index+H[0].length}]:F?D(de,ye):y(de,ye)}e.$Zj=O;function G(de,ye){const F=ce(de,de.toLowerCase(),0,ye,ye.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?U(F):null}e.$1j=G;function W(de,ye,F,q,H,z){const X=Math.min(13,de.length);for(;F<X;F++){const x=ce(de,ye,F,q,H,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(x)return x}return[0,z]}e.$2j=W;function U(de){if(typeof de>"u")return[];const ye=[],F=de[1];for(let q=de.length-1;q>1;q--){const H=de[q]+F,z=ye[ye.length-1];z&&z.end===H?z.end=H+1:ye.push({start:H,end:H+1})}return ye}e.$3j=U;const P=128;function I(){const de=[],ye=[];for(let F=0;F<=P;F++)ye[F]=0;for(let F=0;F<=P;F++)de.push(ye.slice(0));return de}function K(de){const ye=[];for(let F=0;F<=de;F++)ye[F]=0;return ye}const ae=K(2*P),he=K(2*P),be=I(),De=I(),le=I(),ve=!1;function se(de,ye,F,q,H){function z(x,Ee,Te=" "){for(;x.length<Ee;)x=Te+x;return x}let X=` |   |${q.split("").map(x=>z(x,3)).join("|")}
`;for(let x=0;x<=F;x++)x===0?X+=" |":X+=`${ye[x-1]}|`,X+=de[x].slice(0,H+1).map(Ee=>z(Ee.toString(),3)).join("|")+`
`;return X}function we(de,ye,F,q){de=de.substr(ye),F=F.substr(q),console.log(se(De,de,de.length,F,F.length)),console.log(se(le,de,de.length,F,F.length)),console.log(se(be,de,de.length,F,F.length))}function ne(de,ye){if(ye<0||ye>=de.length)return!1;const F=de.codePointAt(ye);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$rf(F)}}function Z(de,ye){if(ye<0||ye>=de.length)return!1;switch(de.charCodeAt(ye)){case 32:case 9:return!0;default:return!1}}function V(de,ye,F){return ye[de]!==F[de]}function ie(de,ye,F,q,H,z,X=!1){for(;ye<F&&H<z;)de[ye]===q[H]&&(X&&(ae[ye]=H),ye+=1),H+=1;return ye===F}e.$4j=ie;var Ie;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Ae;(function(de){de.Default=[-100,0];function ye(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}de.isDefault=ye})(Ae||(e.FuzzyScore=Ae={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ye,F){this.firstMatchCanBeWeak=ye,this.boostFullMatch=F}}e.$5j=Ce;function ce(de,ye,F,q,H,z,X=Ce.default){const x=de.length>P?P:de.length,Ee=q.length>P?P:q.length;if(F>=x||z>=Ee||x-F>Ee-z||!ie(ye,F,x,H,z,Ee,!0))return;te(x,Ee,F,z,ye,H);let Te=1,Ve=1,Ke=F,Ze=z;const st=[!1];for(Te=1,Ke=F;Ke<x;Te++,Ke++){const je=ae[Ke],vt=he[Ke],Y=Ke+1<x?he[Ke+1]:Ee;for(Ve=je-z+1,Ze=je;Ze<Y;Ve++,Ze++){let _=Number.MIN_SAFE_INTEGER,$e=!1;Ze<=vt&&(_=Q(de,ye,Ke,F,q,H,Ze,Ee,z,be[Te-1][Ve-1]===0,st));let Be=0;_!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=_+De[Te-1][Ve-1]);const Qe=Ze>je,it=Qe?De[Te][Ve-1]+(be[Te][Ve-1]>0?-5:0):0,rt=Ze>je+1&&be[Te][Ve-1]>0,Ne=rt?De[Te][Ve-2]+(be[Te][Ve-2]>0?-5:0):0;if(rt&&(!Qe||Ne>=it)&&(!$e||Ne>=Be))De[Te][Ve]=Ne,le[Te][Ve]=3,be[Te][Ve]=0;else if(Qe&&(!$e||it>=Be))De[Te][Ve]=it,le[Te][Ve]=2,be[Te][Ve]=0;else if($e)De[Te][Ve]=Be,le[Te][Ve]=1,be[Te][Ve]=be[Te-1][Ve-1]+1;else throw new Error("not possible")}}if(ve&&we(de,F,q,z),!st[0]&&!X.firstMatchCanBeWeak)return;Te--,Ve--;const nt=[De[Te][Ve],z];let tt=0,at=0;for(;Te>=1;){let je=Ve;do{const vt=le[Te][je];if(vt===3)je=je-2;else if(vt===2)je=je-1;else break}while(je>=1);tt>1&&ye[F+Te-1]===H[z+Ve-1]&&!V(je+z-1,q,H)&&tt+1>be[Te][je]&&(je=Ve),je===Ve?tt++:tt=1,at||(at=je),Te--,Ve=je-1,nt.push(Ve)}Ee===x&&X.boostFullMatch&&(nt[0]+=2);const ct=at-x;return nt[0]-=ct,nt}e.$6j=ce;function te(de,ye,F,q,H,z){let X=de-1,x=ye-1;for(;X>=F&&x>=q;)H[X]===z[x]&&(he[X]=x,X--),x--}function Q(de,ye,F,q,H,z,X,x,Ee,Te,Ve){if(ye[F]!==z[X])return Number.MIN_SAFE_INTEGER;let Ke=1,Ze=!1;return X===F-q?Ke=de[F]===H[X]?7:5:V(X,H,z)&&(X===0||!V(X-1,H,z))?(Ke=de[F]===H[X]?7:5,Ze=!0):ne(z,X)&&(X===0||!ne(z,X-1))?Ke=5:(ne(z,X-1)||Z(z,X-1))&&(Ke=5,Ze=!0),Ke>1&&F===q&&(Ve[0]=!0),Ze||(Ze=V(X,H,z)||ne(z,X-1)||Z(z,X-1)),F===q?X>Ee&&(Ke-=Ze?3:5):Te?Ke+=Ze?2:0:Ke+=Ze?0:1,X+1===x&&(Ke-=Ze?3:5),Ke}function ee(de,ye,F,q,H,z,X){return pe(de,ye,F,q,H,z,!0,X)}e.$7j=ee;function me(de,ye,F,q,H,z,X){return pe(de,ye,F,q,H,z,!1,X)}e.$8j=me;function pe(de,ye,F,q,H,z,X,x){let Ee=ce(de,ye,F,q,H,z,x);if(Ee&&!X)return Ee;if(de.length>=3){const Te=Math.min(7,de.length-1);for(let Ve=F+1;Ve<Te;Ve++){const Ke=Le(de,Ve);if(Ke){const Ze=ce(Ke,Ke.toLowerCase(),F,q,H,z,x);Ze&&(Ze[0]-=3,(!Ee||Ze[0]>Ee[0])&&(Ee=Ze))}}}return Ee}function Le(de,ye){if(ye+1>=de.length)return;const F=de[ye],q=de[ye+1];if(F!==q)return de.slice(0,ye)+q+F+de.slice(ye+2)}}),define(Pe[31],Re([1,0,11]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const M="error",R="warning",$="warn",g="info",w="ignore";function A(l){return l?E.$$e(M,l)?C.Error:E.$$e(R,l)||E.$$e($,l)?C.Warning:E.$$e(g,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function k(l){switch(l){case C.Error:return M;case C.Warning:return R;case C.Info:return g;default:return w}}C.toString=k}(T||(T={})),e.default=T}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Rd=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,11]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const b=p.charCodeAt(0),r=this.b.charCodeAt(this.c);return b-r}value(){return this.b[this.c]}}e.$7h=C;class M{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$5e)(p,this.b,0,p.length,this.c,this.d):(0,T.$7e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$8h=M;class R{constructor(p=!0,b=!0){this.f=p,this.g=b}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let b=p.length-1;b>=0;b--,this.c--){const r=this.b.charCodeAt(b);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$5e)(p,this.b,0,p.length,this.d,this.e):(0,T.$7e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$9h=R;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class g{constructor(p,b){this.f=p,this.g=b,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$6e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$6e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$4e)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$4e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$0h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class k{static forUris(p=()=>!1,b=()=>!1){return new k(new g(p,b))}static forPaths(p=!1){return new k(new R(void 0,!p))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new M)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,b){if(b){const r=b.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o,p)}else{const r=p.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(p,b){const r=this.b.reset(p);let o;this.c||(this.c=new w,this.c.segment=r.value());const t=[];for(o=this.c;;){const a=r.cmp(o.segment);if(a>0)o.left||(o.left=new w,o.left.segment=r.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new w,o.right.segment=r.value()),t.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new w,o.mid.segment=r.value()),t.push([0,o]),o=o.mid;else break}const n=o.value;o.value=b,o.key=p;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[a][0],s=t[a+1][0];if(i===1&&s===1)t[a][1]=c.rotateLeft();else if(i===-1&&s===-1)t[a][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const b=this.b.reset(p);let r=this.c;for(;r;){const o=b.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(b.hasNext())b.next(),r=r.mid;else break}return r}has(p){const b=this.d(p);return!(b?.value===void 0&&b?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,b){const r=this.b.reset(p),o=[];let t=this.c;for(;t;){const n=r.cmp(t.segment);if(n>0)o.push([-1,t]),t=t.left;else if(n<0)o.push([1,t]),t=t.right;else if(r.hasNext())r.next(),o.push([0,t]),t=t.mid;else break}if(t){if(b?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:a,value:c,segment:h}=n;this.e(n.key,!1),t.key=a,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const a=o[n][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[n][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[n][1]=a.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const b=this.b.reset(p);let r=this.c,o;for(;r;){const t=b.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(b.hasNext())b.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(p){return this.g(p,!1)}g(p,b){const r=this.b.reset(p);let o=this.c;for(;o;){const t=r.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):b?o.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[b,r]of this)p(r,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const b=[];return this.j(p,b),b[Symbol.iterator]()}j(p,b){p&&(p.left&&this.j(p.left,b),p.value&&b.push([p.key,p.value]),p.mid&&this.j(p.mid,b),p.right&&this.j(p.right,b))}_isBalanced(){const p=b=>{if(!b)return!0;const r=b.balanceFactor();return r<-1||r>1?!1:p(b.left)&&p(b.right)};return p(this.c)}}e.$$h=k}),define(Pe[45],Re([1,0,90]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$_j=e.ThemeColor=void 0;var T;(function(R){function $(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=$})(T||(e.ThemeColor=T={}));function C(R){return{id:R}}e.$_j=C;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(n){const a=$.exec(n.id);if(!a)return g(E.$$j.error);const[,c,h]=a,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=g;function w(n){return g(n).join(" ")}R.asClassName=w;function A(n){return"."+g(n).join(".")}R.asCSSSelector=A;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(n){const a=l.exec(n);if(!a)return;const[,c]=a;return{id:c}}R.fromString=p;function b(n){return{id:n}}R.fromId=b;function r(n,a){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),a&&(c=`${c}~${a}`),{id:c}}R.modify=r;function o(n){const a=n.id.lastIndexOf("~");if(a!==-1)return n.id.substring(a+1)}R.getModifier=o;function t(n,a){return n.id===a.id&&n.color?.id===a.color?.id}R.isEqual=t})(M||(e.ThemeIcon=M={}))}),define(Pe[126],Re([1,0,124,11,45]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=void 0;const M="$(",R=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function g(t){return t.replace($,(n,a)=>a?n:`\\${n}`)}e.$ak=g;const w=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(w,n=>`\\${n}`)}e.$bk=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(t){return t.indexOf(M)===-1?t:t.replace(k,(n,a,c,h)=>c?n:a||h||"")}e.$ck=l;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,a)=>` ${a} `).trim():""}e.$dk=p;const b=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(t){b.lastIndex=0;let n="";const a=[];let c=0;for(;;){const h=b.lastIndex,i=b.exec(t),s=t.substring(h,i?.index);if(s.length>0){n+=s;for(let u=0;u<s.length;u++)a.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:a}}e.$ek=r;function o(t,n,a=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$Zj)(t,c,a);const i=(0,T.$Se)(c," "),s=c.length-i.length,u=(0,E.$Zj)(t,i,a);if(u)for(const d of u){const m=h[d.start+s]+s;d.start+=m,d.end+=m}return u}e.$fk=o}),define(Pe[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return E.test(C)}e.$og=T,e.$pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function($){for(let g=0;g<$.length;g++)$[g]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,w="";return w+=R[M[g++]],w+=R[M[g++]],w+=R[M[g++]],w+=R[M[g++]],w+="-",w+=R[M[g++]],w+=R[M[g++]],w+="-",w+=R[M[g++]],w+=R[M[g++]],w+="-",w+=R[M[g++]],w+=R[M[g++]],w+="-",w+=R[M[g++]],w+=R[M[g++]],w+=R[M[g++]],w+=R[M[g++]],w+=R[M[g++]],w+=R[M[g++]],w}}()}),define(Pe[127],Re([1,0,18,67,33]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=e.$nt=e.$mt=void 0;function M(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$mt=M;function R(k,l,p){const b={id:(0,C.$pg)(),name:k,uri:l,data:p};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$nt=R;class ${constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return T.Iterable.some(this,([b,r])=>r.asFile())&&p.push("files"),A(g(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const b=this.a.get(l);b?b.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const b of p)yield[l,b]}b(l){return g(l)}}e.$ot=$;function g(k){return k.toLowerCase()}function w(k,l){return A(g(k),l.map(g))}e.$pt=w;function A(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[b,r,o]=p;return o==="*"?l.some(t=>t.startsWith(r+"/")):!1}e.$qt=Object.freeze({create:k=>(0,E.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$qt.split(k).filter(l=>!l.startsWith("#"))})}),define(Pe[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.StringEOL=void 0;var E;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(C){let M=0,R=0,$=0,g=0;for(let w=0,A=C.length;w<A;w++){const k=C.charCodeAt(w);k===13?(M===0&&(R=w),M++,w+1<A&&C.charCodeAt(w+1)===10?(g|=2,w++):g|=3,$=w+1):k===10&&(g|=1,M===0&&(R=w),M++,$=w+1)}return M===0&&(R=C.length),[M,R,C.length-$,g]}e.$tt=T}),define(Pe[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0,e.$rs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=e.$Qt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let g=0,w=$.notIn.length;g<w;g++)switch($.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,g){if($.getTokenCount()===0)return!0;const w=$.findTokenIndexAtOffset(g-2),A=$.getStandardTokenType(w);return this.isOK(A)}g($,g){for(let w=$;w<=g;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Qt=T;class C{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of $)M(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),M(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),M(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),M(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&M(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Rt=C;function M(R,$,g){R.has($)?R.get($).push(g):R.set($,[g])}}),define(Pe[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.$SB=e.NodeColor=e.$RB=void 0;class E{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$SB)return C(this.right);let o=this;for(;o.parent!==e.$SB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$SB?e.$SB:o.parent}prev(){if(this.left!==e.$SB)return M(this.left);let o=this;for(;o.parent!==e.$SB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$SB?e.$SB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$RB=E;var T;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$SB=new E(null,0),e.$SB.parent=e.$SB,e.$SB.left=e.$SB,e.$SB.right=e.$SB,e.$SB.color=0;function C(r){for(;r.left!==e.$SB;)r=r.left;return r}e.$TB=C;function M(r){for(;r.right!==e.$SB;)r=r.right;return r}e.$UB=M;function R(r){return r===e.$SB?0:r.size_left+r.piece.length+R(r.right)}function $(r){return r===e.$SB?0:r.lf_left+r.piece.lineFeedCnt+$(r.right)}function g(){e.$SB.parent=e.$SB}function w(r,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$SB&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$SB?r.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$VB=w;function A(r,o){const t=o.left;o.left=t.right,t.right!==e.$SB&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$SB?r.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$WB=A;function k(r,o){let t,n;if(o.left===e.$SB?(n=o,t=n.right):o.right===e.$SB?(n=o,t=n.left):(n=C(o.right),t=n.right),n===r.root){r.root=t,t.color=0,o.detach(),g(),r.root.parent=e.$SB;return}const a=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===o?(t.parent=n.parent,b(r,t)):(n.parent===o?t.parent=n:t.parent=n.parent,b(r,t),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$SB&&(n.left.parent=n),n.right!==e.$SB&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,b(r,n)),o.detach(),t.parent.left===t){const h=R(t),i=$(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const s=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,p(r,t.parent,s,u)}}if(b(r,t.parent),a){g();return}let c;for(;t!==r.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(r,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(r,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(r,t.parent),t=r.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(r,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(r,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(r,t.parent),t=r.root));t.color=0,g()}e.$XB=k;function l(r,o){for(b(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,w(r,o)),o.parent.color=0,o.parent.parent.color=1,A(r,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(r,o)),o.parent.color=0,o.parent.parent.color=1,w(r,o.parent.parent))}r.root.color=0}e.$YB=l;function p(r,o,t,n){for(;o!==r.root&&o!==e.$SB;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}e.$ZB=p;function b(r,o){let t=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,t=R(o.left)-o.size_left,n=$(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=n;o!==r.root&&(t!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}}e.$1B=b}),define(Pe[91],Re([1,0,92,29,93,131,94]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=void 0;const $=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class w{constructor(n,a,c,h,i){this.lineStarts=n,this.cr=a,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function A(t,n=!0){const a=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const s=t.charCodeAt(h);s===13?h+1<i&&t.charCodeAt(h+1)===10?(a[c++]=h+2,h++):a[c++]=h+1:s===10&&(a[c++]=h+1)}return n?g(a):a}e.$8B=A;function k(t,n){t.length=0,t[0]=0;let a=1,c=0,h=0,i=0,s=!0;for(let d=0,m=n.length;d<m;d++){const f=n.charCodeAt(d);f===13?d+1<m&&n.charCodeAt(d+1)===10?(i++,t[a++]=d+2,d++):(c++,t[a++]=d+1):f===10?(h++,t[a++]=d+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const u=new w(g(t),c,h,i,s);return t.length=0,u}e.$9B=k;class l{constructor(n,a,c,h,i){this.bufferIndex=n,this.start=a,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$0B=l;class p{constructor(n,a){this.buffer=n,this.lineStarts=a}}e.$$B=p;class b{constructor(n,a){this.a=[],this.c=n,this.d=a,this.b=0,n.root!==M.$SB&&n.iterate(n.root,c=>(c!==M.$SB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let a=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,a=!0;continue}}if(a){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(n,a,c){this.create(n,a,c)}create(n,a,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=M.$SB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=c;let h=null;for(let i=0,s=n.length;i<s;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const a=$,c=a-Math.floor(a/3),h=c*2;let i="",s=0;const u=[];if(this.iterate(this.root,d=>{const m=this.R(d),f=m.length;if(s<=c||s+f<h)return i+=m,s+=f,!0;const S=i.replace(/\r\n|\r|\n/g,n);return u.push(new p(S,A(S))),i=m,s=f,!0}),s>0){const d=i.replace(/\r\n|\r|\n/g,n);u.push(new p(d,A(d)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new b(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===M.$SB)return!0;const i=this.R(h),s=i.length,u=n.G(a),d=n.G(a+s),m=n.getValueInRange2(u,d);return a+=s,i===m})}getOffsetAt(n,a){let c=0,h=this.root;for(;h!==M.$SB;)if(h.left!==M.$SB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+a-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let a=this.root,c=0;const h=n;for(;a!==M.$SB;)if(a.size_left!==0&&a.size_left>=n)a=a.left;else if(a.size_left+a.piece.length>=n){const i=this.A(a,n-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),u=h-s;return new E.$Ss(c+1,u+1)}return new E.$Ss(c+1,i.remainder+1)}else if(n-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===M.$SB){const i=this.getOffsetAt(c+1,1),s=h-n-i;return new E.$Ss(c+1,s+1)}else a=a.right;return new E.$Ss(1,1)}getValueInRange(n,a){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return a?a!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(n,a){if(n.node===a.node){const u=n.node,d=this.a[u.piece.bufferIndex].buffer,m=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(m+n.remainder,m+a.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let s=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==M.$SB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===a.node){s+=u.substring(d,d+a.remainder);break}else s+=u.substr(d,c.piece.length);c=c.next()}return s}getLinesContent(){const n=[];let a=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===M.$SB)return!0;const s=i.piece;let u=s.length;if(u===0)return!0;const d=this.a[s.bufferIndex].buffer,m=this.a[s.bufferIndex].lineStarts,f=s.start.line,S=s.end.line;let L=m[f]+s.start.column;if(h&&(d.charCodeAt(L)===10&&(L++,u--),n[a++]=c,c="",h=!1,u===0))return!0;if(f===S)return!this.f&&d.charCodeAt(L+u-1)===13?(h=!0,c+=d.substr(L,u-1)):c+=d.substr(L,u),!0;c+=this.f?d.substring(L,Math.max(L,m[f+1]-this.e)):d.substring(L,m[f+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;for(let v=f+1;v<S;v++)c=this.f?d.substring(m[v],m[v+1]-this.e):d.substring(m[v],m[v+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;return!this.f&&d.charCodeAt(m[S]+s.end.column-1)===13?(h=!0,s.end.column===0?a--:c=d.substr(m[S],s.end.column-1)):c=d.substr(m[S],s.end.column),!0}),h&&(n[a++]=c,c=""),n[a++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const a=n.node.next();if(!a)return 0;const c=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(h)}else{const a=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(n,a){const c=this.H(n,a+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const a=this.getOffsetAt(n,1);return this.getLength()-a}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const a=this.G(n);return this.l(a)}findMatchesInNode(n,a,c,h,i,s,u,d,m,f,S){const L=this.a[n.piece.bufferIndex],v=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),D=this.u(n.piece.bufferIndex,s);let N;const O={line:0,column:0};let G,W;a._wordSeparators?(G=L.buffer.substring(y,D),W=U=>U+y,a.reset(0)):(G=L.buffer,W=U=>U,a.reset(y));do if(N=a.next(G),N){if(W(N.index)>=D)return f;this.s(n,W(N.index)-v,O);const U=this.t(n.piece.bufferIndex,i,O),P=O.line===i.line?O.column-i.column+h:O.column+1,I=P+N[0].length;if(S[f++]=(0,R.$4B)(new T.$Ts(c+U,P,c+U,I),N,d),W(N.index)+N[0].length>=D||f>=m)return f}while(N);return f}findMatchesLineByLine(n,a,c,h){const i=[];let s=0;const u=new R.$7B(a.wordSeparators,a.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const m=this.H(n.endLineNumber,n.endColumn);if(m===null)return[];let f=this.s(d.node,d.remainder);const S=this.s(m.node,m.remainder);if(d.node===m.node)return this.findMatchesInNode(d.node,u,n.startLineNumber,n.startColumn,f,S,a,c,h,s,i),i;let L=n.startLineNumber,v=d.node;for(;v!==m.node;){const D=this.t(v.piece.bufferIndex,f,v.piece.end);if(D>=1){const O=this.a[v.piece.bufferIndex].lineStarts,G=this.u(v.piece.bufferIndex,v.piece.start),W=O[f.line+D],U=L===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(v,u,L,U,f,this.s(v,W-G),a,c,h,s,i),s>=h)return i;L+=D}const N=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const O=this.getLineContent(L).substring(N,n.endColumn-1);return s=this.n(a,u,O,n.endLineNumber,N,s,i,c,h),i}if(s=this.n(a,u,this.getLineContent(L).substr(N),L,N,s,i,c,h),s>=h)return i;L++,d=this.H(L,1),v=d.node,f=this.s(d.node,d.remainder)}if(L===n.endLineNumber){const D=L===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(L).substring(D,n.endColumn-1);return s=this.n(a,u,N,n.endLineNumber,D,s,i,c,h),i}const y=L===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(m.node,u,L,y,f,S,a,c,h,s,i),i}n(n,a,c,h,i,s,u,d,m){const f=n.wordSeparators;if(!d&&n.simpleSearch){const L=n.simpleSearch,v=L.length,y=c.length;let D=-v;for(;(D=c.indexOf(L,D+v))!==-1;)if((!f||(0,R.$6B)(f,c,y,D,v))&&(u[s++]=new C.$_u(new T.$Ts(h,D+1+i,h,D+1+v+i),null),s>=m))return s;return s}let S;a.reset(0);do if(S=a.next(c),S&&(u[s++]=(0,R.$4B)(new T.$Ts(h,S.index+1+i,h,S.index+1+S[0].length+i),S,d),s>=m))return s;while(S);return s}insert(n,a,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$SB){const{node:h,remainder:i,nodeStartOffset:s}=this.G(n),u=h.piece,d=u.bufferIndex,m=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&s+u.length===n&&a.length<$){this.F(h,a),this.y();return}if(s===n)this.o(a,h),this.h.validate(n);else if(s+h.piece.length>n){const f=[];let S=new l(u.bufferIndex,m,u.end,this.t(u.bufferIndex,m,u.end),this.u(d,u.end)-this.u(d,m));if(this.K()&&this.M(a)&&this.I(h,i)===10){const D={line:S.start.line+1,column:0};S=new l(S.bufferIndex,D,S.end,this.t(S.bufferIndex,D,S.end),S.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,i-1)===13){const D=this.s(h,i-1);this.C(h,D),a="\r"+a,h.piece.length===0&&f.push(h)}else this.C(h,m);else this.C(h,m);const L=this.w(a);S.length>0&&this.S(h,S);let v=h;for(let y=0;y<L.length;y++)v=this.S(v,L[y]);this.v(f)}else this.q(a,h)}else{const h=this.w(a);let i=this.T(null,h[0]);for(let s=1;s<h.length;s++)i=this.S(i,h[s])}this.y()}delete(n,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===M.$SB)return;const c=this.G(n),h=this.G(n+a),i=c.node,s=h.node;if(i===s){const L=this.s(i,c.remainder),v=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(a===i.piece.length){const y=i.next();(0,M.$XB)(this,i),this.N(y),this.y();return}this.D(i,v),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+a){this.C(i,L),this.O(i),this.y();return}this.E(i,L,v),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&u.push(i);const m=this.s(s,h.remainder);this.D(s,m),s.piece.length===0&&u.push(s);const f=i.next();for(let L=f;L!==M.$SB&&L!==s;L=L.next())u.push(L);const S=i.piece.length===0?i.prev():i;this.v(u),this.O(S),this.y()}o(n,a){const c=[];if(this.K()&&this.M(n)&&this.L(a)){const s=a.piece,u={line:s.start.line+1,column:0},d=new l(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),s.length-1);a.piece=d,n+=`
`,(0,M.$ZB)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const h=this.w(n);let i=this.T(a,h[h.length-1]);for(let s=h.length-2;s>=0;s--)i=this.T(i,h[s]);this.N(i),this.v(c)}q(n,a){this.Q(n,a)&&(n+=`
`);const c=this.w(n),h=this.S(a,c[0]);let i=h;for(let s=1;s<c.length;s++)i=this.S(i,c[s]);this.N(h)}s(n,a,c){const h=n.piece,i=n.piece.bufferIndex,s=this.a[i].lineStarts,d=s[h.start.line]+h.start.column+a;let m=h.start.line,f=h.end.line,S=0,L=0,v=0;for(;m<=f&&(S=m+(f-m)/2|0,v=s[S],S!==f);)if(L=s[S+1],d<v)f=S-1;else if(d>=L)m=S+1;else break;return c?(c.line=S,c.column=d-v,null):{line:S,column:d-v}}t(n,a,c){if(c.column===0)return c.line-a.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-a.line;const i=h[c.line+1],s=h[c.line]+c.column;if(i>s+1)return c.line-a.line;const u=s-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-a.line+1:c.line-a.line}u(n,a){return this.a[n].lineStarts[a.line]+a.column}v(n){for(let a=0;a<n.length;a++)(0,M.$XB)(this,n[a])}w(n){if(n.length>$){const f=[];for(;n.length>$;){const L=n.charCodeAt($-1);let v;L===13||L>=55296&&L<=56319?(v=n.substring(0,$-1),n=n.substring($-1)):(v=n.substring(0,$),n=n.substring($));const y=A(v);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:v.length-y[y.length-1]},y.length-1,v.length)),this.a.push(new p(v,y))}const S=A(n);return f.push(new l(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),f}let a=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[s],d={line:s,column:u},m=new l(0,h,d,this.t(0,h,d),i-a);return this.g=d,[m]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,a=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const s=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(d+s,d+c.piece.length);else{const m=this.B(c,n-i.nodeStartLineNumber);return u.substring(d+s,d+m-a)}}else{let s=0;const u=n;for(;c!==M.$SB;)if(c.left!==M.$SB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),m=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this.h.set({node:c,nodeStartOffset:s,nodeStartLineNumber:u-(n-1-c.lf_left)}),f.substring(S+d,S+m-a)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),m=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=m.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$SB;){const s=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=s.substring(d,d+u-a),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=s.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,a=1,c=0;for(;n!==M.$SB;)a+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=a,this.c=c,this.h.validate(this.c)}A(n,a){const c=n.piece,h=this.s(n,a),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===a){const s=this.t(n.piece.bufferIndex,c.start,h);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:h.column}}B(n,a){if(a<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),s=a,u=this.u(c.bufferIndex,s),d=this.t(c.bufferIndex,c.start,s),m=d-h,f=u-i,S=c.length+f;n.piece=new l(c.bufferIndex,c.start,s,d,S),(0,M.$ZB)(this,n,f,m)}D(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),s=a,u=this.t(c.bufferIndex,s,c.end),d=this.u(c.bufferIndex,s),m=u-h,f=i-d,S=c.length+f;n.piece=new l(c.bufferIndex,s,c.end,u,S),(0,M.$ZB)(this,n,f,m)}E(n,a,c){const h=n.piece,i=h.start,s=h.end,u=h.length,d=h.lineFeedCnt,m=a,f=this.t(h.bufferIndex,h.start,m),S=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,m,f,S),(0,M.$ZB)(this,n,S-u,f-d);const L=new l(h.bufferIndex,c,s,this.t(h.bufferIndex,c,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,c)),v=this.S(n,L);this.N(v)}F(n,a){this.Q(a,n)&&(a+=`
`);const c=this.K()&&this.L(a)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=a;const i=A(a,!1);for(let v=0;v<i.length;v++)i[v]+=h;if(c){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const s=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:u},m=n.piece.length+a.length,f=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,d),L=S-f;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,S,m),this.g=d,(0,M.$ZB)(this,n,a.length,L)}G(n){let a=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;a!==M.$SB;)if(a.size_left>n)a=a.left;else if(a.size_left+a.piece.length>=n){h+=a.size_left;const i={node:a,remainder:n-a.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(n,a){let c=this.root,h=0;for(;c!==M.$SB;)if(c.left!==M.$SB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),s=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+a-1,s),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:h};a-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$SB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),s=this.J(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:s}}else if(c.piece.length>=a-1){const i=this.J(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}I(n,a){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+a;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let a=n.size_left;for(;n!==this.root;)n.parent.right===n&&(a+=n.parent.size_left+n.parent.piece.length),n=n.parent;return a}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$SB||n.piece.lineFeedCnt===0)return!1;const a=n.piece,c=this.a[a.bufferIndex].lineStarts,h=a.start.line,i=c[h]+a.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$SB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const a=n.prev();this.M(a)&&this.P(a,n)}}O(n){if(this.K()&&this.M(n)){const a=n.next();this.L(a)&&this.P(n,a)}}P(n,a){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,s),(0,M.$ZB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:a.piece.start.line+1,column:0},m=a.piece.length-1,f=this.t(a.piece.bufferIndex,d,a.piece.end);a.piece=new l(a.piece.bufferIndex,d,a.piece.end,f,m),(0,M.$ZB)(this,a,-1,-1),a.piece.length===0&&c.push(a);const S=this.w(`\r
`);this.S(n,S[0]);for(let L=0;L<c.length;L++)(0,M.$XB)(this,c[L])}Q(n,a){if(this.K()&&this.M(n)){const c=a.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,M.$XB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},s=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,s),(0,M.$ZB)(this,c,-1,-1)}return!0}}return!1}iterate(n,a){if(n===M.$SB)return a(M.$SB);const c=this.iterate(n.left,a);return c&&a(n)&&this.iterate(n.right,a)}R(n){if(n===M.$SB)return"";const a=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return a.buffer.substring(h,i)}getPieceContent(n){const a=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return a.buffer.substring(c,h)}S(n,a){const c=new M.$RB(a,1);if(c.left=M.$SB,c.right=M.$SB,c.parent=M.$SB,c.size_left=0,c.lf_left=0,this.root===M.$SB)this.root=c,c.color=0;else if(n.right===M.$SB)n.right=c,c.parent=n;else{const i=(0,M.$TB)(n.right);i.left=c,c.parent=i}return(0,M.$YB)(this,c),c}T(n,a){const c=new M.$RB(a,1);if(c.left=M.$SB,c.right=M.$SB,c.parent=M.$SB,c.size_left=0,c.lf_left=0,this.root===M.$SB)this.root=c,c.color=0;else if(n.left===M.$SB)n.left=c,c.parent=n;else{const h=(0,M.$UB)(n.left);h.right=c,c.parent=h}return(0,M.$YB)(this,c),c}U(n){let a="";return this.iterate(n,c=>(a+=this.R(c),!0)),a}}e.$_B=o}),define(Pe[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8=e.$f8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$f8=E;class T{constructor(M){this.identifier=M}}e.$g8=T}),define(Pe[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[134],Re([1,0,5,6,133]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;class M extends T.$Tc{constructor(l,p="",b="",r=!0,o){super(),this.h=this.B(new E.$Ud),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=b,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Ji=M;class R extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new E.$Ud),this.onWillRun=this.f.event,this.m=this.B(new E.$Ud),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,p)}catch(r){b=r}this.m.fire({action:l,error:b})}async u(l,p){await l.run(p)}}e.$Ki=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const b of l)b.length&&(p.length?p=[...p,new $,...b]:p=b);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Li=$;class g{get actions(){return this.a}constructor(l,p,b,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=r,this.a=b}async run(){}}e.$Mi=g;class w extends M{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,C.localize(0,null),void 0,!1)}}e.$Ni=w;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Oi=A}),define(Pe[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[136],Re([1,0,135]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0;const T=60,C=T*60,M=C*24,R=M*7,$=M*30,g=M*365;function w(k,l,p,b){typeof k!="number"&&(k=k.getTime());const r=Math.round((new Date().getTime()-k)/1e3);if(r<-30)return(0,E.localize)(0,null,w(new Date().getTime()+r*1e3,!1));if(!b&&r<30)return(0,E.localize)(1,null);let o;return r<T?(o=r,l?o===1?p?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):p?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?p?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):p?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):r<C?(o=Math.floor(r/T),l?o===1?p?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):p?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?p?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):p?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):r<M?(o=Math.floor(r/C),l?o===1?p?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):p?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?p?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):p?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):r<R?(o=Math.floor(r/M),l?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):r<$?(o=Math.floor(r/R),l?o===1?p?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):p?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?p?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):p?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):r<g?(o=Math.floor(r/$),l?o===1?p?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):p?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?p?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):p?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(r/g),l?o===1?p?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):p?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?p?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):p?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$um=w;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$vm=A}),define(Pe[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,137]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=void 0;function M(k,l){return l&&(k.stack||k.stacktrace)?C.localize(0,null,$(k),R(k.stack)||R(k.stacktrace)):$(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function $(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function g(k=null,l=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const p=E.$Hb(k),b=g(p[0],l);return p.length>1?C.localize(4,null,b,p.length):b}if(T.$Hf(k))return k;if(k.detail){const p=k.detail;if(p.error)return M(p.error,l);if(p.exception)return M(p.exception,l)}return k.stack?M(k,l):k.message?k.message:C.localize(5,null)}e.$Pi=g;function w(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Qi=w;function A(k,l){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=l,p}e.$Ri=A}),define(Pe[138],Re([1,0,39,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0;const C=new E.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),M=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(L,v,y=!1){const D=L||"",N=v||"",O=C.value.collator.compare(D,N);return C.value.collatorIsNumeric&&O===0&&D!==N?D<N?-1:1:O}e.$Hq=$;function g(L,v){const y=M.value.collator;return L=L||"",v=v||"",c(y,L,v)}e.$Iq=g;function w(L,v){const y=M.value.collator;return L=L||"",v=v||"",u(L,v)||c(y,L,v)}e.$Jq=w;function A(L,v){const y=M.value.collator;return L=L||"",v=v||"",s(L,v)||c(y,L,v)}e.$Kq=A;function k(L,v){return L=L||"",v=v||"",L===v?0:L<v?-1:1}e.$Lq=k;function l(L,v){const[y,D]=n(L),[N,O]=n(v);let G=C.value.collator.compare(D,O);if(G===0){if(C.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(G=C.value.collator.compare(y,N),C.value.collatorIsNumeric&&G===0&&y!==N)return y<N?-1:1}return G}e.$Mq=l;function p(L,v){L=L||"",v=v||"";const y=a(L),D=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,D)||c(N,L,v)}e.$Nq=p;function b(L,v){L=L||"",v=v||"";const y=a(L),D=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,D)||u(L,v)||c(N,L,v)}e.$Oq=b;function r(L,v){L=L||"",v=v||"";const y=a(L),D=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,D)||s(L,v)||c(N,L,v)}e.$Pq=r;function o(L,v){L=L||"",v=v||"";const y=a(L).toLowerCase(),D=a(v).toLowerCase();return y!==D?y<D?-1:1:L!==v?L<v?-1:1:0}e.$Qq=o;const t=/^(.*?)(\.([^.]*))?$/;function n(L,v=!1){const y=L?t.exec(L):[];let D=[y&&y[1]||"",y&&y[3]||""];return v&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function a(L){const v=L?t.exec(L):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(L,v,y){const D=L.compare(v,y);return D!==0?D:v.length!==y.length?v.length<y.length?-1:1:0}function h(L){const v=L.charAt(0);return v.toLocaleUpperCase()!==v}function i(L){const v=L.charAt(0);return v.toLocaleLowerCase()!==v}function s(L,v){return h(L)&&i(v)?-1:i(L)&&h(v)?1:0}function u(L,v){return i(L)&&h(v)?-1:h(L)&&i(v)?1:0}function d(L,v,y=!1){return y||(L=L&&L.toLowerCase(),v=v&&v.toLowerCase()),L===v?0:L<v?-1:1}function m(L,v,y=!1){const D=L.split(T.sep),N=v.split(T.sep),O=D.length-1,G=N.length-1;let W,U;for(let P=0;;P++){if(W=O===P,U=G===P,W&&U)return $(D[P],N[P],y);if(W)return-1;if(U)return 1;const I=d(D[P],N[P],y);if(I!==0)return I}}e.$Rq=m;function f(L,v,y){const D=L.toLowerCase(),N=v.toLowerCase(),O=S(L,v,y);if(O)return O;const G=D.endsWith(y),W=N.endsWith(y);if(G!==W)return G?-1:1;const U=$(D,N);return U!==0?U:D.localeCompare(N)}e.$Sq=f;function S(L,v,y){const D=L.toLowerCase(),N=v.toLowerCase(),O=D.startsWith(y),G=N.startsWith(y);if(O!==G)return O?-1:1;if(O&&G){if(D.length<N.length)return-1;if(D.length>N.length)return 1}return 0}e.$Tq=S}),define(Pe[46],Re([1,0,19,21,11,16]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=void 0;function R(f){return f===47||f===92}e.$Zf=R;function $(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$1f=$;function g(f){return f.indexOf("/")===-1&&(f=$(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$2f=g;function w(f,S=E.$gc.sep){if(!f)return"";const L=f.length,v=f.charCodeAt(0);if(R(v)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let D=3;const N=D;for(;D<L&&!R(f.charCodeAt(D));D++);if(N!==D&&!R(f.charCodeAt(D+1))){for(D+=1;D<L;D++)if(R(f.charCodeAt(D)))return f.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(t(v)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(R(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$3f=w;function A(f){if(!T.$i||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let L=2;const v=L;for(;L<f.length&&(S=f.charCodeAt(L),S!==92);L++);return!(v===L||(S=f.charCodeAt(L+1),isNaN(S)||S===92))}e.$4f=A;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,S=T.$i){const L=S?k:l;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||S&&p.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$5f=b;function r(f,S,L){const v=f===S;return!L||v?v:!f||!S?!1:(0,C.$$e)(f,S)}e.$6f=r;function o(f,S,L,v=E.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(L){if(!(0,C.$_e)(f,S))return!1;if(S.length===f.length)return!0;let D=S.length;return S.charAt(S.length-1)===v&&D--,f.charAt(D)===v}return S.charAt(S.length-1)!==v&&(S+=v),f.indexOf(S)===0}e.$7f=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$8f=t;function n(f,S){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(S,f)),f=(0,E.$hc)(f),T.$i?(f=(0,C.$Te)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,C.$Te)(f,E.sep),f||(f=E.sep)),f}e.$9f=n;function a(f){const S=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(S)&&(f.length===2||S.charCodeAt(2)===92):S===E.$gc.sep}e.$0f=a;function c(f,S=T.$i){return S?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$$f=c;function h(f,S=T.$i){return c(f,S)?f[0]:void 0}e.$_f=h;function i(f,S,L){return S.length>f.length?-1:f===S?0:(L&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$ag=i;function s(f){const S=f.split(":");let L,v,y;for(const D of S){const N=Number(D);(0,M.$Lf)(N)?v===void 0?v=N:y===void 0&&(y=N):L=L?[L,D].join(":"):D}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.$bg=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,S,L=8){let v="";for(let D=0;D<L;D++){let N;D===0&&T.$i&&!S&&(L===3||L===4)?N=d:N=u,v+=N.charAt(Math.floor(Math.random()*N.length))}let y;return S?y=`${S}-${v}`:y=v,f?(0,E.$jc)(f,y):y}e.$cg=m}),define(Pe[68],Re([1,0,19]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0,e.$es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const k=(0,E.$oc)(A),l=T[k.toLowerCase()];return l!==void 0?l:R(A)}e.$fs=M;function R(A){const k=(0,E.$oc)(A);return C[k.toLowerCase()]}e.$gs=R;function $(A){for(const k in C)if(C[k]===A)return k}e.$hs=$;const g=/^(.+)\/(.+?)(;.+)?$/;function w(A,k){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:A}e.$is=w}),define(Pe[51],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function C(g){return JSON.stringify(g,R)}e.$zh=C;function M(g){let w=JSON.parse(g);return w=$(w),w}e.$Ah=M;function R(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function $(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ie||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=$(g[A],w+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=$(g[A],w+1))}return g}e.$Bh=$}),define(Pe[12],Re([1,0,15,21,11,2]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function $(l,p){return M.URI.isUri(l)?(0,C.$$e)(l.scheme,p):(0,C.$_e)(l,p+":")}e.$dg=$;function g(l,...p){return p.some(b=>$(l,b))}e.$eg=g,e.$fg="vscode-tkn",e.$gg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,b,r){this.a[p]=b,this.b[p]=r}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(a){return E.$1(a),p}const b=p.authority;let r=this.a[b];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const o=this.b[b],t=this.c[b];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$gg}=${encodeURIComponent(t)}`),M.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${r}:${o}`,path:this.f,query:n})}}e.$hg=new w,e.$ig="vs/../../extensions",e.$jg="vs/../../node_modules",e.$kg="vs/../../node_modules.asar",e.$lg="vs/../../node_modules.asar.unpacked",e.$mg="vscode-app";class A{static{this.a=e.$mg}asBrowserUri(p){const b=this.b(p,ge);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$hg.rewrite(p):p.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${A.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,ge);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return M.URI.isUri(p)?p:M.URI.parse(b.toUrl(p))}}e.$ng=new A;var k;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function r(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:M.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const a=n?.get(b);if(a)return p.get(a)}l.getHeadersFromQuery=r;function o(t,n,a){if(!globalThis.crossOriginIsolated)return;const c=n&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(b,c):t[b]=c}l.addSearchParam=o})(k||(e.COI=k={}))}),define(Pe[25],Re([1,0,46,12,19,21,11,2]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.DataUri=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=void 0;function g(p){return(0,$.$wc)(p,!0)}e.$ug=g;class w{constructor(b){this.a=b}compare(b,r,o=!1){return b===r?0:(0,R.$4e)(this.getComparisonKey(b,o),this.getComparisonKey(r,o))}isEqual(b,r,o=!1){return b===r?!0:!b||!r?!1:this.getComparisonKey(b,o)===this.getComparisonKey(r,o)}getComparisonKey(b,r=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,r,o=!1){if(b.scheme===r.scheme){if(b.scheme===T.Schemas.file)return E.$7f(g(b),g(r),this.a(b))&&b.query===r.query&&(o||b.fragment===r.fragment);if((0,e.$Lg)(b.authority,r.authority))return E.$7f(b.path,r.path,this.a(b),"/")&&b.query===r.query&&(o||b.fragment===r.fragment)}return!1}joinPath(b,...r){return $.URI.joinPath(b,...r)}basenameOrAuthority(b){return(0,e.$Dg)(b)||b.authority}basename(b){return C.$gc.basename(b.path)}extname(b){return C.$gc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let r;return b.scheme===T.Schemas.file?r=$.URI.file(C.$mc(g(b))).path:(r=C.$gc.dirname(b.path),b.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),r="/")),b.with({path:r})}normalizePath(b){if(!b.path.length)return b;let r;return b.scheme===T.Schemas.file?r=$.URI.file(C.$hc(g(b))).path:r=C.$gc.normalize(b.path),b.with({path:r})}relativePath(b,r){if(b.scheme!==r.scheme||!(0,e.$Lg)(b.authority,r.authority))return;if(b.scheme===T.Schemas.file){const n=C.$lc(g(b),g(r));return M.$i?E.$1f(n):n}let o=b.path||"/";const t=r.path||"/";if(this.a(b)){let n=0;for(const a=Math.min(o.length,t.length);n<a&&!(o.charCodeAt(n)!==t.charCodeAt(n)&&o.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);o=t.substr(0,n)+o.substr(n)}return C.$gc.relative(o,t)}resolvePath(b,r){if(b.scheme===T.Schemas.file){const o=$.URI.file(C.$kc(g(b),r));return b.with({authority:o.authority,path:o.path})}return r=E.$2f(r),b.with({path:C.$gc.resolve(b.path,r)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,r){return b===r||b!==void 0&&r!==void 0&&(0,R.$$e)(b,r)}hasTrailingPathSeparator(b,r=C.sep){if(b.scheme===T.Schemas.file){const o=g(b);return o.length>E.$3f(o).length&&o[o.length-1]===r}else{const o=b.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,r=C.sep){return(0,e.$Mg)(b,r)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,r=C.sep){let o=!1;if(b.scheme===T.Schemas.file){const t=g(b);o=t!==void 0&&t.length===E.$3f(t).length&&t[t.length-1]===r}else{r="/";const t=b.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Mg)(b,r)?b.with({path:b.path+"/"}):b}}e.$vg=w,e.$wg=new w(()=>!1),e.$xg=new w(p=>p.scheme===T.Schemas.file?!M.$k:!0),e.$yg=new w(p=>!0),e.$zg=e.$wg.isEqual.bind(e.$wg),e.$Ag=e.$wg.isEqualOrParent.bind(e.$wg),e.$Bg=e.$wg.getComparisonKey.bind(e.$wg),e.$Cg=e.$wg.basenameOrAuthority.bind(e.$wg),e.$Dg=e.$wg.basename.bind(e.$wg),e.$Eg=e.$wg.extname.bind(e.$wg),e.$Fg=e.$wg.dirname.bind(e.$wg),e.$Gg=e.$wg.joinPath.bind(e.$wg),e.$Hg=e.$wg.normalizePath.bind(e.$wg),e.$Ig=e.$wg.relativePath.bind(e.$wg),e.$Jg=e.$wg.resolvePath.bind(e.$wg),e.$Kg=e.$wg.isAbsolutePath.bind(e.$wg),e.$Lg=e.$wg.isEqualAuthority.bind(e.$wg),e.$Mg=e.$wg.hasTrailingPathSeparator.bind(e.$wg),e.$Ng=e.$wg.removeTrailingPathSeparator.bind(e.$wg),e.$Og=e.$wg.addTrailingPathSeparator.bind(e.$wg);function A(p,b){const r=[];for(let o=0;o<p.length;o++){const t=b(p[o]);p.some((n,a)=>a===o?!1:(0,e.$Ag)(t,b(n)))||r.push(p[o])}return r}e.$Pg=A;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function b(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,h]=a.split(":");c&&h&&o.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(p.META_DATA_MIME,n),o}p.parseMetaData=b})(k||(e.DataUri=k={}));function l(p,b,r){if(b){let o=p.path;return o&&o[0]!==C.$gc.sep&&(o=C.$gc.sep+o),p.with({scheme:r,authority:b,path:o})}return p.with({scheme:r})}e.$Qg=l}),define(Pe[13],Re([1,0,20,15,5,6,25,21,125,39]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.Promises=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=void 0;function A(ce){return!!ce&&typeof ce.then=="function"}e.$Rg=A;function k(ce){const te=new E.$5d,Q=ce(te.token),ee=new Promise((me,pe)=>{const Le=te.token.onCancellationRequested(()=>{Le.dispose(),pe(new T.$5)});Promise.resolve(Q).then(de=>{Le.dispose(),te.dispose(),me(de)},de=>{Le.dispose(),te.dispose(),pe(de)})});return new class{cancel(){te.cancel(),te.dispose()}then(me,pe){return ee.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return ee.finally(me)}}}e.$Sg=k;function l(ce,te,Q){return new Promise((ee,me)=>{const pe=te.onCancellationRequested(()=>{pe.dispose(),ee(Q)});ce.then(ee,me).finally(()=>pe.dispose())})}e.$Tg=l;function p(ce,te){return new Promise((Q,ee)=>{const me=te.onCancellationRequested(()=>{me.dispose(),ee(new T.$5)});ce.then(Q,ee).finally(()=>me.dispose())})}e.$Ug=p;async function b(ce){let te=-1;const Q=ce.map((ee,me)=>ee.then(pe=>(te=me,pe)));try{return await Promise.race(Q)}finally{ce.forEach((ee,me)=>{me!==te&&ee.cancel()})}}e.$Vg=b;function r(ce,te,Q){let ee;const me=setTimeout(()=>{ee?.(void 0),Q?.()},te);return Promise.race([ce.finally(()=>clearTimeout(me)),new Promise(pe=>ee=pe)])}e.$Wg=r;function o(ce){return new Promise((te,Q)=>{const ee=ce();A(ee)?ee.then(te,Q):te(ee)})}e.$Xg=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const Q=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Q,Q).then(ee)})}return new Promise((Q,ee)=>{this.b.then(Q,ee)})}return this.a=te(),new Promise((Q,ee)=>{this.a.then(me=>{this.a=null,Q(me)},me=>{this.a=null,ee(me)})})}dispose(){this.f=!0}}e.$Yg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$Zg=n;class a{constructor(){this.a=new Map}queue(te,Q){const me=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(te)===me&&this.a.delete(te)});return this.a.set(te,me),me}}e.$1g=a;const c=(ce,te)=>{let Q=!0;const ee=setTimeout(()=>{Q=!1,te()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(ee),Q=!1}}},h=ce=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ce())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class i{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,Q=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Q===g.$Rd?h(ee):c(Q,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$2g=i;class s{constructor(te){this.a=new i(te),this.b=new t}trigger(te,Q){return this.a.trigger(()=>this.b.queue(te),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$3g=s;class u{constructor(){this.a=!1,this.b=new Promise((te,Q)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$4g=u;class d extends u{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$5g=d;function m(ce,te){return te?new Promise((Q,ee)=>{const me=setTimeout(()=>{pe.dispose(),Q()},ce),pe=te.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),ee(new T.$5)})}):k(Q=>m(ce,Q))}e.$6g=m;function f(ce,te=0,Q){const ee=setTimeout(()=>{ce(),Q&&me.dispose()},te),me=(0,M.$Rc)(()=>{clearTimeout(ee),Q?.deleteAndLeak(me)});return Q?.add(me),me}e.$7g=f;function S(ce){const te=[];let Q=0;const ee=ce.length;function me(){return Q<ee?ce[Q++]():null}function pe(Le){Le!=null&&te.push(Le);const de=me();return de?de.then(pe):Promise.resolve(te)}return Promise.resolve(null).then(pe)}e.$8g=S;function L(ce,te=ee=>!!ee,Q=null){let ee=0;const me=ce.length,pe=()=>{if(ee>=me)return Promise.resolve(Q);const Le=ce[ee++];return Promise.resolve(Le()).then(ye=>te(ye)?Promise.resolve(ye):pe())};return pe()}e.$9g=L;function v(ce,te=ee=>!!ee,Q=null){if(ce.length===0)return Promise.resolve(Q);let ee=ce.length;const me=()=>{ee=-1;for(const pe of ce)pe.cancel?.()};return new Promise((pe,Le)=>{for(const de of ce)de.then(ye=>{--ee>=0&&te(ye)?(me(),pe(ye)):ee===0&&pe(Q)}).catch(ye=>{--ee>=0&&(me(),Le(ye))})})}e.$0g=v;class y{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new C.$Ud}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Q,ee)=>{this.g.push({factory:te,c:Q,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const Q=te.factory();Q.then(te.c,te.e),Q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.h.dispose()}}e.$$g=y;class D extends y{constructor(){super(1)}}e.$_g=D;class N{constructor(){this.a=new De,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$ah=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new se;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueFor(te,Q=R.$wg){const ee=Q.getComparisonKey(te);let me=this.a.get(ee);if(!me){me=new D;const pe=this.f++,Le=C.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(pe,Le),this.a.set(ee,me)}return me}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$bh=O;class G{constructor(te,Q){this.a=-1,typeof te=="function"&&typeof Q=="number"&&this.setIfNotSet(te,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},Q)}setIfNotSet(te,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},Q))}}e.$ch=G;class W{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,Q,ee=globalThis){this.cancel();const me=ee.setInterval(()=>{te()},Q);this.d=(0,M.$Rc)(()=>{ee.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$dh=W;class U{constructor(te,Q){this.b=-1,this.a=te,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$eh=U;class P{constructor(te,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=te,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$fh=P;class I extends U{constructor(te,Q){super(te,Q),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$gh=I;class K extends M.$Tc{constructor(te,Q){super(),this.g=te,this.h=Q,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of te)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$hh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$jh=(ce,te)=>{(0,$.$B)(()=>{if(Q)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$jh=(ce,te,Q)=>{const ee=ce.requestIdleCallback(te,typeof Q=="number"?{timeout:Q}:void 0);let me=!1;return{dispose(){me||(me=!0,ce.cancelIdleCallback(ee))}}},e.$ih=ce=>(0,e.$jh)(globalThis,ce)}();class ae{constructor(te,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$jh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$kh=ae;class he extends ae{constructor(te){super(globalThis,te)}}e.$lh=he;async function be(ce,te,Q){let ee;for(let me=0;me<Q;me++)try{return await ce()}catch(pe){ee=pe,await m(te)}throw ee}e.$mh=be;class De{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,Q,ee){return this.a={taskId:te,cancel:()=>ee?.(),promise:Q},Q.then(()=>this.d(te),()=>this.d(te)),Q}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let Q,ee;const me=new Promise((pe,Le)=>{Q=pe,ee=Le});this.b={run:te,promise:me,promiseResolve:Q,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$nh=De;class le{constructor(te,Q=()=>Date.now()){this.d=te,this.f=Q,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$oh=le;var ve;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(ve||(ve={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,Q)=>{this.a=te,this.b=Q})}complete(te){return new Promise(Q=>{this.a(te),this.d={outcome:0,value:te},Q()})}error(te){return new Promise(Q=>{this.b(te),this.d={outcome:1,value:te},Q()})}cancel(){return this.error(new T.$5)}}e.$ph=se;var we;(function(ce){async function te(ee){let me;const pe=await Promise.all(ee.map(Le=>Le.then(de=>de,de=>{me||(me=de)})));if(typeof me<"u")throw me;return pe}ce.settled=te;function Q(ee){return new Promise(async(me,pe)=>{try{await ee(me,pe)}catch(Le){pe(Le)}})}ce.withAsyncBody=Q})(we||(e.Promises=we={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$qh=ne;class Z{constructor(te){this.b=te,this.a=new w.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$rh=Z;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ie{static fromArray(te){return new ie(Q=>{Q.emitMany(te)})}static fromPromise(te){return new ie(async Q=>{Q.emitMany(await te)})}static fromPromises(te){return new ie(async Q=>{await Promise.all(te.map(async ee=>Q.emitOne(await ee)))})}static merge(te){return new ie(async Q=>{await Promise.all(te.map(async ee=>{for await(const me of ee)Q.emitOne(me)}))})}static{this.EMPTY=ie.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new C.$Ud,queueMicrotask(async()=>{const Q={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(te(Q)),this.j()}catch(ee){this.k(ee)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(te,Q){return new ie(async ee=>{for await(const me of te)ee.emitOne(Q(me))})}map(te){return ie.map(this,te)}static filter(te,Q){return new ie(async ee=>{for await(const me of te)Q(me)&&ee.emitOne(me)})}filter(te){return ie.filter(this,te)}static coalesce(te){return ie.filter(te,Q=>!!Q)}coalesce(){return ie.coalesce(this)}static async toPromise(te){const Q=[];for await(const ee of te)Q.push(ee);return Q}toPromise(){return ie.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$sh=ie;class Ie extends ie{constructor(te,Q){super(Q),this.l=te}cancel(){this.l.cancel()}}e.$th=Ie;function Ae(ce){const te=new E.$5d,Q=ce(te.token);return new Ie(te,async ee=>{const me=te.token.onCancellationRequested(()=>{me.dispose(),te.dispose(),ee.reject(new T.$5)});try{for await(const pe of Q){if(te.token.isCancellationRequested)return;ee.emitOne(pe)}me.dispose(),te.dispose()}catch(pe){me.dispose(),te.dispose(),ee.reject(pe)}})}e.$uh=Ae;class Ce{constructor(){this.a=new se,this.b=new ie(ee=>{if(te){ee.reject(te);return}return Q&&ee.emitMany(Q),this.d=me=>ee.reject(me),this.f=me=>ee.emitOne(me),this.a.p});let te,Q;this.f=ee=>{Q||(Q=[]),Q.push(ee)},this.d=ee=>{te||(te=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$vh=Ce}),define(Pe[34],Re([1,0,18,13,46,28,19,21,11]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=void 0;function w(){return Object.create(null)}e.$Gj=w,e.$Hj="**",e.$Ij="/";const A="[/\\\\]",k="[^/\\\\]",l=/\//g;function p(he,be){switch(he){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${be?`|${A}${k}+`:""})*?`}}function b(he,be){if(!he)return[];const De=[];let le=!1,ve=!1,se="";for(const we of he){switch(we){case be:if(!le&&!ve){De.push(se),se="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=we}return se&&De.push(se),De}e.$Jj=b;function r(he){if(!he)return"";let be="";const De=b(he,e.$Ij);if(De.every(le=>le===e.$Hj))be=".*";else{let le=!1;De.forEach((ve,se)=>{if(ve===e.$Hj){if(le)return;be+=p(2,se===De.length-1)}else{let we=!1,ne="",Z=!1,V="";for(const ie of ve){if(ie!=="}"&&we){ne+=ie;continue}if(Z&&(ie!=="]"||!V)){let Ie;ie==="-"?Ie=ie:(ie==="^"||ie==="!")&&!V?Ie="^":ie===e.$Ij?Ie="":Ie=(0,g.$Ne)(ie),V+=Ie;continue}switch(ie){case"{":we=!0;continue;case"[":Z=!0;continue;case"}":{const Ae=`(?:${b(ne,",").map(Ce=>r(Ce)).join("|")})`;be+=Ae,we=!1,ne="";break}case"]":{be+="["+V+"]",Z=!1,V="";break}case"?":be+=k;continue;case"*":be+=p(1);continue;default:be+=(0,g.$Ne)(ie)}}se<De.length-1&&(De[se+1]!==e.$Hj||se+2<De.length)&&(be+=A)}le=ve===e.$Hj})}return be}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Dc(1e4),s=function(){return!1},u=function(){return null};function d(he,be){if(!he)return u;let De;typeof he!="string"?De=he.pattern:De=he,De=De.trim();const le=`${De}_${!!be.trimForExclusions}`;let ve=i.get(le);if(ve)return m(ve,he);let se;return o.test(De)?ve=S(De.substr(4),De):(se=t.exec(f(De,be)))?ve=L(se[1],De):(be.trimForExclusions?a:n).test(De)?ve=v(De,be):(se=c.exec(f(De,be)))?ve=y(se[1].substr(1),De,!0):(se=h.exec(f(De,be)))?ve=y(se[1],De,!1):ve=D(De),i.set(le,ve),m(ve,he)}function m(he,be){if(typeof be=="string")return he;const De=function(le,ve){return(0,C.$7f)(le,be.base,!$.$k)?he((0,g.$Se)(le.substr(be.base.length),R.sep),ve):null};return De.allBasenames=he.allBasenames,De.allPaths=he.allPaths,De.basenames=he.basenames,De.patterns=he.patterns,De}function f(he,be){return be.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function S(he,be){return function(De,le){return typeof De=="string"&&De.endsWith(he)?be:null}}function L(he,be){const De=`/${he}`,le=`\\${he}`,ve=function(we,ne){return typeof we!="string"?null:ne?ne===he?be:null:we===he||we.endsWith(De)||we.endsWith(le)?be:null},se=[he];return ve.basenames=se,ve.patterns=[be],ve.allBasenames=se,ve}function v(he,be){const De=K(he.slice(1,-1).split(",").map(ne=>d(ne,be)).filter(ne=>ne!==u),he),le=De.length;if(!le)return u;if(le===1)return De[0];const ve=function(ne,Z){for(let V=0,ie=De.length;V<ie;V++)if(De[V](ne,Z))return he;return null},se=De.find(ne=>!!ne.allBasenames);se&&(ve.allBasenames=se.allBasenames);const we=De.reduce((ne,Z)=>Z.allPaths?ne.concat(Z.allPaths):ne,[]);return we.length&&(ve.allPaths=we),ve}function y(he,be,De){const le=R.sep===R.$gc.sep,ve=le?he:he.replace(l,R.sep),se=R.sep+ve,we=R.$gc.sep+he;let ne;return De?ne=function(Z,V){return typeof Z=="string"&&(Z===ve||Z.endsWith(se)||!le&&(Z===he||Z.endsWith(we)))?be:null}:ne=function(Z,V){return typeof Z=="string"&&(Z===ve||!le&&Z===he)?be:null},ne.allPaths=[(De?"*/":"./")+he],ne}function D(he){try{const be=new RegExp(`^${r(he)}$`);return function(De){return be.lastIndex=0,typeof De=="string"&&be.test(De)?he:null}}catch{return u}}function N(he,be,De){return!he||typeof be!="string"?!1:O(he)(be,void 0,De)}e.$Kj=N;function O(he,be={}){if(!he)return s;if(typeof he=="string"||G(he)){const De=d(he,be);if(De===u)return s;const le=function(ve,se){return!!De(ve,se)};return De.allBasenames&&(le.allBasenames=De.allBasenames),De.allPaths&&(le.allPaths=De.allPaths),le}return P(he,be)}e.$Lj=O;function G(he){const be=he;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}e.$Mj=G;function W(he){return he.allBasenames||[]}e.$Nj=W;function U(he){return he.allPaths||[]}e.$Oj=U;function P(he,be){const De=K(Object.getOwnPropertyNames(he).map(ne=>I(ne,he[ne],be)).filter(ne=>ne!==u)),le=De.length;if(!le)return u;if(!De.some(ne=>!!ne.requiresSiblings)){if(le===1)return De[0];const ne=function(ie,Ie){let Ae;for(let Ce=0,ce=De.length;Ce<ce;Ce++){const te=De[Ce](ie,Ie);if(typeof te=="string")return te;(0,T.$Rg)(te)&&(Ae||(Ae=[]),Ae.push(te))}return Ae?(async()=>{for(const Ce of Ae){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},Z=De.find(ie=>!!ie.allBasenames);Z&&(ne.allBasenames=Z.allBasenames);const V=De.reduce((ie,Ie)=>Ie.allPaths?ie.concat(Ie.allPaths):ie,[]);return V.length&&(ne.allPaths=V),ne}const ve=function(ne,Z,V){let ie,Ie;for(let Ae=0,Ce=De.length;Ae<Ce;Ae++){const ce=De[Ae];ce.requiresSiblings&&V&&(Z||(Z=(0,R.$nc)(ne)),ie||(ie=Z.substr(0,Z.length-(0,R.$oc)(ne).length)));const te=ce(ne,Z,ie,V);if(typeof te=="string")return te;(0,T.$Rg)(te)&&(Ie||(Ie=[]),Ie.push(te))}return Ie?(async()=>{for(const Ae of Ie){const Ce=await Ae;if(typeof Ce=="string")return Ce}return null})():null},se=De.find(ne=>!!ne.allBasenames);se&&(ve.allBasenames=se.allBasenames);const we=De.reduce((ne,Z)=>Z.allPaths?ne.concat(Z.allPaths):ne,[]);return we.length&&(ve.allPaths=we),ve}function I(he,be,De){if(be===!1)return u;const le=d(he,De);if(le===u)return u;if(typeof be=="boolean")return le;if(be){const ve=be.when;if(typeof ve=="string"){const se=(we,ne,Z,V)=>{if(!V||!le(we,ne))return null;const ie=ve.replace("$(basename)",()=>Z),Ie=V(ie);return(0,T.$Rg)(Ie)?Ie.then(Ae=>Ae?he:null):Ie?he:null};return se.requiresSiblings=!0,se}}return le}function K(he,be){const De=he.filter(ne=>!!ne.basenames);if(De.length<2)return he;const le=De.reduce((ne,Z)=>{const V=Z.basenames;return V?ne.concat(V):ne},[]);let ve;if(be){ve=[];for(let ne=0,Z=le.length;ne<Z;ne++)ve.push(be)}else ve=De.reduce((ne,Z)=>{const V=Z.patterns;return V?ne.concat(V):ne},[]);const se=function(ne,Z){if(typeof ne!="string")return null;if(!Z){let ie;for(ie=ne.length;ie>0;ie--){const Ie=ne.charCodeAt(ie-1);if(Ie===47||Ie===92)break}Z=ne.substr(ie)}const V=le.indexOf(Z);return V!==-1?ve[V]:null};se.basenames=le,se.patterns=ve,se.allBasenames=le;const we=he.filter(ne=>!ne.basenames);return we.push(se),we}function ae(he,be){return(0,E.$ub)(he,be,(De,le)=>typeof De=="string"&&typeof le=="string"?De===le:typeof De!="string"&&typeof le!="string"?De.base===le.base&&De.pattern===le.pattern:!1)}e.$Pj=ae}),define(Pe[52],Re([1,0,15,126,25,11,2]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class g{constructor(n="",a=!1){if(this.value=n,typeof this.value!="string")throw(0,E.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(n,a=0){return this.value+=l(this.supportThemeIcons?(0,T.$ak)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,a){return this.value+=`
${p(a,n)}
`,this}appendLink(n,a,c){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,a){const c=new RegExp((0,M.$Ne)(a),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$gk=g;function w(t){return A(t)?!t.value:Array.isArray(t)?t.every(w):!0}e.$hk=w;function A(t){return t instanceof g?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$ik=A;function k(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,C.$zg)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$jk=k;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$kk=l;function p(t,n){const a=t.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=a>=3?a+1:3;return[`${"`".repeat(c)}${n}`,t,`${"`".repeat(c)}`].join(`
`)}e.$lk=p;function b(t){return t.replace(/"/g,"&quot;")}e.$mk=b;function r(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$nk=r;function o(t){const n=[],a=t.split("|").map(h=>h.trim());t=a[0];const c=a[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),s=h?h[1]:"",u=i?i[1]:"",d=isFinite(parseInt(u)),m=isFinite(parseInt(s));d&&n.push(`width="${u}"`),m&&n.push(`height="${s}"`)}return{href:t,dimensions:n}}e.$ok=o}),define(Pe[95],Re([1,0,18,46,19,21,25,11]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=void 0;function g(d,m){const{os:f,tildify:S,relative:L}=m;if(L){const D=w(d,L,f);if(typeof D=="string")return D}let v=d.fsPath;if(f===1&&!M.$i?v=v.replace(/\//g,"\\"):f!==1&&M.$i&&(v=v.replace(/\\/g,"/")),f!==1&&S?.userHome){const D=S.userHome.fsPath;let N;d.scheme!==S.userHome.scheme&&d.path[0]===C.$gc.sep&&d.path[1]!==C.$gc.sep?N=S.userHome.with({path:d.path}).fsPath:N=v,v=l(N,D,f)}return(f===1?C.$fc:C.$gc).normalize(A(v,f===1))}e.$Uv=g;function w(d,m,f){const S=f===1?C.$fc:C.$gc,L=f===3?R.$wg:R.$yg,v=m.getWorkspace(),y=(0,E.$Ob)(v.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===C.$gc.sep&&d.path[1]!==C.$gc.sep&&(d=y.uri.with({path:d.path}));const D=m.getWorkspaceFolder(d);if(!D)return;let N;if(L.isEqual(D.uri,d)?N="":N=L.relativePath(D.uri,d)??"",N&&(N=S.normalize(N)),v.folders.length>1&&!m.noPrefix){const O=D.name?D.name:L.basenameOrAuthority(D.uri);N=N?`${O} \u2022 ${N}`:O}return N}function A(d,m=M.$i){return(0,T.$$f)(d,m)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Vv=A;let k=Object.create(null);function l(d,m,f=M.OS){if(f===1||!d||!m)return d;let S=k.original===m?k.normalized:void 0;S||(S=m,M.$i&&(S=(0,T.$1f)(S)),S=`${(0,$.$Te)(S,C.$gc.sep)}${C.$gc.sep}`,k={original:m,normalized:S});let L=d;return M.$i&&(L=(0,T.$1f)(L)),(f===3?L.startsWith(S):(0,$.$_e)(L,S))?`~/${L.substr(S.length)}`:d}e.$Wv=l;function p(d,m){return d.replace(/^~($|\/|\\)/,`${m}$1`)}e.$Xv=p;const b="\u2026",r="\\\\",o="~";function t(d,m=C.sep){const f=new Array(d.length);let S=!1;for(let L=0;L<d.length;L++){const v=d[L];if(v===""){f[L]=`.${m}`;continue}if(!v){f[L]=v;continue}S=!0;let y="",D=v;D.indexOf(r)===0?(y=D.substr(0,D.indexOf(r)+r.length),D=D.substr(D.indexOf(r)+r.length)):D.indexOf(m)===0?(y=D.substr(0,D.indexOf(m)+m.length),D=D.substr(D.indexOf(m)+m.length)):D.indexOf(o)===0&&(y=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length));const N=D.split(m);for(let O=1;S&&O<=N.length;O++)for(let G=N.length-O;S&&G>=0;G--){S=!1;let W=N.slice(G,G+O).join(m);for(let U=0;!S&&U<d.length;U++)if(U!==L&&d[U]&&d[U].indexOf(W)>-1){const P=G+O===N.length,I=G>0&&d[U].indexOf(m)>-1?m+W:W,K=d[U].endsWith(I);S=!P||K}if(!S){let U="";(N[0].endsWith(":")||y!=="")&&(G===1&&(G=0,O++,W=N[0]+m+W),G>0&&(U=N[0]+m),U=y+U),G>0&&(U=U+b+m),U=U+W,G+O<N.length&&(U=U+m+b),f[L]=U}}S&&(f[L]=v)}return f}e.$Yv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function a(d,m=Object.create(null)){const f=[];let S=!1,L="";for(const v of d)if(v==="$"||S&&v==="{")L&&f.push({value:L,type:n.TEXT}),L="",S=!0;else if(v==="}"&&S){const y=m[L];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const D=f[f.length-1];(!D||D.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}L="",S=!1}else L+=v;return L&&!S&&f.push({value:L,type:n.TEXT}),f.filter((v,y)=>{if(v.type===n.SEPARATOR){const D=f[y-1],N=f[y+1];return[D,N].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$Zv=a;function c(d,m){return M.$j||m?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$1v=c;function h(d,m){return M.$j||m?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$2v=h;function i(d){return d.replace(/&/g,"&&")}e.$3v=i;function s(d){if(d.endsWith("]")){const m=d.lastIndexOf(" [",d.length-2);if(m!==-1){const f=u(d.substring(0,m)),S=d.substring(m);return{name:f.name+S,parentPath:f.parentPath}}}return u(d)}e.$4v=s;function u(d){const m=d.indexOf("/")!==-1?C.$gc:C.$fc,f=m.basename(d),S=m.dirname(d);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function C(k){return k.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:C(T.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:C(T.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:T.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$3m=M,e.$4m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof T.URI)return l.transformOutgoing(k);for(const b in k)if(Object.hasOwnProperty.call(k,b)){const r=R(k[b],l,p+1);r!==null&&(k[b]=r)}}return null}function $(k,l){const p=R(k,l,0);return p===null?k:p}e.$5m=$;function g(k,l,p,b){if(!k||b>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?T.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof E.$ie)return null;for(const r in k)if(Object.hasOwnProperty.call(k,r)){const o=g(k[r],l,p,b+1);o!==null&&(k[r]=o)}}return null}function w(k,l){const p=g(k,l,!1,0);return p===null?k:p}e.$6m=w;function A(k,l){const p=g(k,l,!0,0);return p===null?k:p}e.$7m=A}),define(Pe[140],Re([1,0,11,21,24]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.$at=e.$_s=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function g(){return $||($=new TextDecoder("UTF-16BE")),$}let w;function A(){return w||(w=T.$D()?R():g()),w}e.$_s=A;function k(b,r,o){const t=new Uint16Array(b.buffer,r,o);return o>0&&(t[0]===65279||t[0]===65534)?l(b,r,o):R().decode(t)}e.$at=k;function l(b,r,o){const t=[];let n=0;for(let a=0;a<o;a++){const c=C.$ke(b,r);r+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||E.$cf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let t=0;t<o;t++)this.b[this.d++]=r.charCodeAt(t)}}e.$bt=p}),define(Pe[141],Re([1,0,24,140]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=void 0;function C(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,k,l){this.oldPosition=w,this.oldText=A,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,A,k){const l=A.length;E.$ne(w,l,k),k+=4;for(let p=0;p<l;p++)E.$le(w,A.charCodeAt(p),k),k+=2;return k}static d(w,A){const k=E.$me(w,A);return A+=4,(0,T.$at)(w,A,k)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(w,A){return E.$ne(w,this.oldPosition,A),A+=4,E.$ne(w,this.newPosition,A),A+=4,A=M.c(w,this.oldText,A),A=M.c(w,this.newText,A),A}static read(w,A,k){const l=E.$me(w,A);A+=4;const p=E.$me(w,A);A+=4;const b=M.d(w,A);A+=M.a(b);const r=M.d(w,A);return A+=M.a(r),k.push(new M(l,b,p,r)),A}}e.$ct=M;function R(g,w){return g===null||g.length===0?w:new $(g,w).compress()}e.$dt=R;class ${constructor(w,A){this.a=w,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,A=0,k=this.n(w),l=this.l(A);for(;w<this.f||A<this.h;){if(k===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(k),k=this.n(++w);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++A);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++w);continue}if(l.oldPosition<k.newPosition){const[t,n]=$.r(l,k.newPosition-l.oldPosition);this.k(t),l=n;continue}if(k.newPosition<l.oldPosition){const[t,n]=$.q(k,l.oldPosition-k.newPosition);this.m(t),k=n;continue}let r,o;if(l.oldEnd===k.newEnd)r=k,o=l,k=this.n(++w),l=this.l(++A);else if(l.oldEnd<k.newEnd){const[t,n]=$.q(k,l.oldLength);r=t,o=l,k=n,l=this.l(++A)}else{const[t,n]=$.r(l,k.newLength);r=k,o=t,k=this.n(++w),l=n}this.d[this.e++]=new M(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const p=$.s(this.d);return $.t(p)}k(w){this.d[this.e++]=$.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=$.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,A){return new M(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static p(w,A){return new M(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static q(w,A){const k=w.newText.substr(0,A),l=w.newText.substr(A);return[new M(w.oldPosition,w.oldText,w.newPosition,k),new M(w.oldEnd,"",w.newPosition+A,l)]}static r(w,A){const k=w.oldText.substr(0,A),l=w.oldText.substr(A);return[new M(w.oldPosition,k,w.newPosition,w.newText),new M(w.oldPosition+A,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const A=[];let k=0,l=w[0];for(let p=1;p<w.length;p++){const b=w[p];l.oldEnd===b.oldPosition?l=new M(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(A[k++]=l,l=b)}return A[k++]=l,A}static t(w){if(w.length===0)return w;const A=[];let k=0;for(let l=0;l<w.length;l++){const p=w[l];p.oldText!==p.newText&&(A[k++]=p)}return A}}}),define(Pe[142],Re([1,0,34,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0;function C(M,R,$,g,w,A){if(Array.isArray(M)){let k=0;for(const l of M){const p=C(l,R,$,g,w,A);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof M=="string")return g?M==="*"?5:M===$?10:0:0;if(M){const{language:k,pattern:l,scheme:p,hasAccessToAllModels:b,notebookType:r}=M;if(!g&&!b)return 0;r&&w&&(R=w);let o=0;if(p)if(p===R.scheme)o=10;else if(p==="*")o=5;else return 0;if(k)if(k===$)o=10;else if(k==="*")o=Math.max(o,5);else return 0;if(r)if(r===A)o=10;else if(r==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$hc)(l.base)},t===R.fsPath||(0,E.$Kj)(t,R.fsPath))o=10;else return 0}return o}else return 0}}e.$At=C}),define(Pe[143],Re([1,0,5,11,29,93,91,128,141,6]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=void 0;class A extends w.$Tc{constructor(l,p,b,r,o,t,n){super(),this.m=this.B(new E.$Ud),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=r,this.h=o,this.c=new R.$_B(l,b,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const b=l+p,r=this.getPositionAt(l),o=this.getPositionAt(b);return new C.$Ts(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const b=this.n(p);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const a=t.length-n.length,c=l.endLineNumber-l.startLineNumber;o=a*c}return r-b+o}getCharacterCountInRange(l,p=0){if(this.j){let b=0;const r=l.startLineNumber,o=l.endLineNumber;for(let t=r;t<=o;t++){const n=this.getLineContent(t),a=t===r?l.startColumn-1:0,c=t===o?l.endColumn-1:n.length;for(let h=a;h<c;h++)T.$cf(n.charCodeAt(h))?(b=b+1,h=h+1):b=b+1}return b+=this.n(p).length*(o-r),b}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=T.$Ze(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=T.$2e(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,b){let r=this.g,o=this.h,t=this.j,n=!0,a=[];for(let m=0;m<l.length;m++){const f=l[m];n&&f._isTracked&&(n=!1);const S=f.range;if(f.text){let N=!0;t||(N=!T.$nf(f.text),t=N),!r&&N&&(r=T.$mf(f.text)),!o&&N&&(o=T.$pf(f.text))}let L="",v=0,y=0,D=0;if(f.text){let N;[v,y,D,N]=(0,$.$tt)(f.text);const O=this.getEOL();N===0||N===(O===`\r
`?2:1)?L=f.text:L=f.text.replace(/\r\n|\r|\n/g,O)}a[m]={sortIndex:m,identifier:f.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:v,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(A.u);let c=!1;for(let m=0,f=a.length-1;m<f;m++){const S=a[m].range.getEndPosition(),L=a[m+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(a=this.s(a));const h=b||p?A._getInverseEditRanges(a):[],i=[];if(p)for(let m=0;m<a.length;m++){const f=a[m],S=h[m];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let v="";L===S.startLineNumber&&(v=this.getLineContent(f.range.startLineNumber),T.$Ze(v)!==-1)||i.push({lineNumber:L,oldContent:v})}}let s=null;if(b){let m=0;s=[];for(let f=0;f<a.length;f++){const S=a[f],L=h[f],v=this.getValueInRange(S.range),y=S.rangeOffset+m;m+=S.text.length-v.length,s[f]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:v,textChange:new g.$ct(S.rangeOffset,v,y,S.text)}}c||s.sort((f,S)=>f.sortIndex-S.sortIndex)}this.g=r,this.h=o,this.j=t;const u=this.t(a);let d=null;if(p&&i.length>0){i.sort((m,f)=>f.lineNumber-m.lineNumber),d=[];for(let m=0,f=i.length;m<f;m++){const S=i[m].lineNumber;if(m>0&&i[m-1].lineNumber===S)continue;const L=i[m].oldContent,v=this.getLineContent(S);v.length===0||v===L||T.$Ze(v)!==-1||d.push(S)}}return this.m.fire(),new M.$dv(s,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const b=l[0].range,r=l[l.length-1].range,o=new C.$Ts(b.startLineNumber,b.startColumn,r.endLineNumber,r.endColumn);let t=b.startLineNumber,n=b.startColumn;const a=[];for(let u=0,d=l.length;u<d;u++){const m=l[u],f=m.range;p=p||m.forceMoveMarkers,a.push(this.getValueInRange(new C.$Ts(t,n,f.startLineNumber,f.startColumn))),m.text.length>0&&a.push(m.text),t=f.endLineNumber,n=f.endColumn}const c=a.join(""),[h,i,s]=(0,$.$tt)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:s,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let b=0;b<l.length;b++){const r=l[b],o=r.range.startLineNumber,t=r.range.startColumn,n=r.range.endLineNumber,a=r.range.endColumn;if(o===n&&t===a&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new C.$Ts(o,t,n,a);p.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,b,r){return this.c.findMatchesLineByLine(l,p,b,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const b=l.startLineNumber,r=l.startColumn,[o,t,n]=(0,$.$tt)(p);let a;if(p.length>0){const c=o+1;c===1?a=new C.$Ts(b,r,b,r+t):a=new C.$Ts(b,r,b+c-1,n+1)}else a=new C.$Ts(b,r,b,r);return a}static _getInverseEditRanges(l){const p=[];let b=0,r=0,o=null;for(let t=0,n=l.length;t<n;t++){const a=l[t];let c,h;o?o.range.endLineNumber===a.range.startLineNumber?(c=b,h=r+(a.range.startColumn-o.range.endColumn)):(c=b+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(c=a.range.startLineNumber,h=a.range.startColumn);let i;if(a.text.length>0){const s=a.eolCount+1;s===1?i=new C.$Ts(c,h,c,h+a.firstLineLength):i=new C.$Ts(c,h,c+s-1,a.lastLineLength+1)}else i=new C.$Ts(c,h,c,h);b=i.endLineNumber,r=i.endColumn,p.push(i),o=a}return p}static u(l,p){const b=C.$Ts.compareRangesUsingEnds(l.range,p.range);return b===0?l.sortIndex-p.sortIndex:b}static w(l,p){const b=C.$Ts.compareRangesUsingEnds(l.range,p.range);return b===0?p.sortIndex-l.sortIndex:-b}}e.$aC=A}),define(Pe[144],Re([1,0,11,91,143]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class M{constructor(g,w,A,k,l,p,b,r,o){this.a=g,this.b=w,this.c=A,this.d=k,this.e=l,this.f=p,this.g=b,this.h=r,this.j=o}k(g){const w=this.c+this.d+this.e,A=this.c+this.e;return w===0?g===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create(g){const w=this.k(g),A=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const b=A[l].buffer.replace(/\r\n|\r|\n/g,w),r=(0,T.$8B)(b);A[l]=new T.$$B(b,r)}const k=new C.$aC(A,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$vf(g)&&(this.b=E.$uf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,T.$9B)(this.e,g);this.a.push(new T.$$B(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$mf(g)),this.k||(this.k=E.$pf(g)))}finish(g=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,T.$8B)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$bC=R}),define(Pe[96],Re([1,0,24,21]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$=e.$o$=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function M(k){for(let l=0,p=k.length;l<p;l+=4){const b=k[l+0],r=k[l+1],o=k[l+2],t=k[l+3];k[l+0]=t,k[l+1]=o,k[l+2]=r,k[l+3]=b}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return T.$D()||M(l),E.$ie.wrap(l)}function $(k){const l=k.buffer;if(T.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function g(k){const l=new Uint32Array(w(k));let p=0;if(l[p++]=k.id,k.type==="full")l[p++]=1,l[p++]=k.data.length,l.set(k.data,p),p+=k.data.length;else{l[p++]=2,l[p++]=k.deltas.length;for(const b of k.deltas)l[p++]=b.start,l[p++]=b.deleteCount,b.data?(l[p++]=b.data.length,l.set(b.data,p),p+=b.data.length):l[p++]=0}return R(l)}e.$o$=g;function w(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(l+=p.data.length)}return l}function A(k){const l=$(k);let p=0;const b=l[p++];if(l[p++]===1){const n=l[p++],a=l.subarray(p,p+n);return p+=n,{id:b,type:"full",data:a}}const o=l[p++],t=[];for(let n=0;n<o;n++){const a=l[p++],c=l[p++],h=l[p++];let i;h>0&&(i=l.subarray(p,p+h),p+=h),t[n]={start:a,deleteCount:c,data:i}}return{id:b,type:"delta",deltas:t}}e.$p$=A}),define(Pe[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}compute(_,$e,Be){return Be}}class l{constructor(_,$e){this.newValue=_,this.didChange=$e}}e.ApplyUpdateResult=l;function p(Y,_){if(typeof Y!="object"||typeof _!="object"||!Y||!_)return new l(_,Y!==_);if(Array.isArray(Y)||Array.isArray(_)){const Be=Array.isArray(Y)&&Array.isArray(_)&&E.$ub(Y,_);return new l(_,!Be)}let $e=!1;for(const Be in _)if(_.hasOwnProperty(Be)){const Qe=p(Y[Be],_[Be]);Qe.didChange&&(Y[Be]=Qe.newValue,$e=!0)}return new l(Y,$e)}class b{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,$e){return p(_,$e)}validate(_){return this.defaultValue}}class r{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,$e,Be){return Be}}function o(Y,_){return typeof Y>"u"?_:Y==="false"?!1:!!Y}e.boolean=o;class t extends r{constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return o(_,this.defaultValue)}}function n(Y,_,$e,Be){if(typeof Y>"u")return _;let Qe=parseInt(Y,10);return isNaN(Qe)?_:(Qe=Math.max($e,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class a extends r{static clampedInt(_,$e,Be,Qe){return n(_,$e,Be,Qe)}constructor(_,$e,Be,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=it),super(_,$e,Be,rt),this.minimum=Qe,this.maximum=it}validate(_){return a.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function c(Y,_,$e,Be){if(typeof Y>"u")return _;const Qe=h.float(Y,_);return h.clamp(Qe,$e,Be)}e.clampedFloat=c;class h extends r{static clamp(_,$e,Be){return _<$e?$e:_>Be?Be:_}static float(_,$e){if(typeof _=="number")return _;if(typeof _>"u")return $e;const Be=parseFloat(_);return isNaN(Be)?$e:Be}constructor(_,$e,Be,Qe,it){typeof it<"u"&&(it.type="number",it.default=Be),super(_,$e,Be,it),this.validationFn=Qe}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class i extends r{static string(_,$e){return typeof _!="string"?$e:_}constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return i.string(_,this.defaultValue)}}function s(Y,_,$e,Be){return typeof Y!="string"?_:Be&&Y in Be?Be[Y]:$e.indexOf(Y)===-1?_:Y}e.stringSet=s;class u extends r{constructor(_,$e,Be,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Be),super(_,$e,Be,it),this.c=Qe}validate(_){return s(_,this.defaultValue,this.c)}}class d extends k{constructor(_,$e,Be,Qe,it,rt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Qe),super(_,$e,Be,Ne),this.c=it,this.d=rt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function m(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,$e,Be){return Be===0?_.accessibilitySupport:Be}}class S extends k{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:$.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function v(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(Y){switch(Y){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function N(Y){switch(Y){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class O extends b{constructor(){super(140)}compute(_,$e,Be){const Qe=["monaco-editor"];return $e.get(39)&&Qe.push($e.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),$e.get(73)==="default"?Qe.push("mouse-default"):$e.get(73)==="copy"&&Qe.push("mouse-copy"),$e.get(110)&&Qe.push("showUnused"),$e.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(_,$e,Be){return Be&&_.emptySelectionClipboard}}class W extends k{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:$.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:$.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":s($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":s($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?U.OFF:_==="true"?U.ON:_:_?U.ON:U.OFF}}e.EditorFontLigatures=U;class P extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?P.OFF:_==="true"?P.TRANSLATE:_:_?P.TRANSLATE:P.OFF}compute(_,$e,Be){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class I extends b{constructor(){super(50)}compute(_,$e,Be){return _.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(_){const $e=h.float(_,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(_,$e,Be){return _.fontInfo.fontSize}}class ae extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(a.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class he extends k{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{multiple:s($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??s($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??s($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??s($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??s($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??s($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class be extends k{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:$.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:a.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var De;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class le extends b{constructor(){super(143)}compute(_,$e,Be){return le.computeLayout($e,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const $e=_.height/_.lineHeight,Be=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,$e-1));const it=(Be+_.viewLineCount+Qe)/(_.pixelRatio*_.height),rt=Math.floor(_.viewLineCount/it);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(_,$e){const Be=_.outerWidth,Qe=_.outerHeight,it=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=$e.stableMinimapLayoutInput,Ne=rt&&_.outerHeight===rt.outerHeight&&_.lineHeight===rt.lineHeight&&_.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&_.pixelRatio===rt.pixelRatio&&_.scrollBeyondLastLine===rt.scrollBeyondLastLine&&_.paddingTop===rt.paddingTop&&_.paddingBottom===rt.paddingBottom&&_.minimap.enabled===rt.minimap.enabled&&_.minimap.side===rt.minimap.side&&_.minimap.size===rt.minimap.size&&_.minimap.showSlider===rt.minimap.showSlider&&_.minimap.renderCharacters===rt.minimap.renderCharacters&&_.minimap.maxColumn===rt.minimap.maxColumn&&_.minimap.scale===rt.minimap.scale&&_.verticalScrollbarWidth===rt.verticalScrollbarWidth&&_.isViewportWrapping===rt.isViewportWrapping,Pt=_.lineHeight,Tt=_.typicalHalfwidthCharacterWidth,Kt=_.scrollBeyondLastLine,Bt=_.minimap.renderCharacters;let yt=it>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Ht=_.minimap.maxColumn,Nt=_.minimap.size,Xt=_.minimap.side,Ut=_.verticalScrollbarWidth,Rt=_.viewLineCount,Ye=_.remainingWidth,Gt=_.isViewportWrapping,Jt=Bt?2:3;let lt=Math.floor(it*Qe);const $t=lt/it;let jt=!1,Vt=!1,Dt=Jt*yt,dt=yt/it,Ct=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Se,desiredRatio:Fe,minimapLineCount:fe}=le.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Kt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:Pt,pixelRatio:it});if(Rt/fe>1)jt=!0,Vt=!0,yt=1,Dt=1,dt=yt/it;else{let Me=!1,ze=yt+1;if(Nt==="fit"){const Xe=Math.ceil((Ft+Rt+Se)*Dt);Gt&&Ne&&Ye<=$e.stableFitRemainingWidth?(Me=!0,ze=$e.stableFitMaxMinimapScale):Me=Xe>lt}if(Nt==="fill"||Me){jt=!0;const Xe=yt;Dt=Math.min(Pt*it,Math.max(1,Math.floor(1/Fe))),Gt&&Ne&&Ye<=$e.stableFitRemainingWidth&&(ze=$e.stableFitMaxMinimapScale),yt=Math.min(ze,Math.max(1,Math.floor(Dt/Jt))),yt>Xe&&(Ct=Math.min(2,yt/Xe)),dt=yt/it/Ct,lt=Math.ceil(Math.max(ft,Ft+Rt+Se)*Dt),Gt?($e.stableMinimapLayoutInput=_,$e.stableFitRemainingWidth=Ye,$e.stableFitMaxMinimapScale=yt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const xt=Math.floor(Ht*dt),kt=Math.min(xt,Math.max(0,Math.floor((Ye-Ut-2)*dt/(Tt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(it*kt);const Mt=qe/it;qe=Math.floor(qe*Ct);const Wt=Bt?1:2,Qt=Xt==="left"?0:Be-kt-Ut;return{renderMinimap:Wt,minimapLeft:Qt,minimapWidth:kt,minimapHeightIsEditorHeight:jt,minimapIsSampling:Vt,minimapScale:yt,minimapLineHeight:Dt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(_,$e){const Be=$e.outerWidth|0,Qe=$e.outerHeight|0,it=$e.lineHeight|0,rt=$e.lineNumbersDigitCount|0,Ne=$e.typicalHalfwidthCharacterWidth,Pt=$e.maxDigitWidth,Tt=$e.pixelRatio,Kt=$e.viewLineCount,Bt=_.get(135),yt=Bt==="inherit"?_.get(134):Bt,Ht=yt==="inherit"?_.get(130):yt,Nt=_.get(133),Xt=$e.isDominatedByLongLines,Ut=_.get(57),Rt=_.get(67).renderType!==0,Ye=_.get(68),Gt=_.get(104),Jt=_.get(83),lt=_.get(72),$t=_.get(102),jt=$t.verticalScrollbarSize,Vt=$t.verticalHasArrows,Dt=$t.arrowSize,dt=$t.horizontalScrollbarSize,Ct=_.get(43),xt=_.get(109)!=="never";let kt=_.get(65);Ct&&xt&&(kt+=16);let qe=0;if(Rt){const _e=Math.max(rt,Ye);qe=Math.round(_e*Pt)}let Mt=0;Ut&&(Mt=it*$e.glyphMarginDecorationLaneCount);let Wt=0,Qt=Wt+Mt,ft=Qt+qe,Ft=ft+kt;const Se=Be-Mt-qe-kt;let Fe=!1,fe=!1,J=-1;yt==="inherit"&&Xt?(Fe=!0,fe=!0):Ht==="on"||Ht==="bounded"?fe=!0:Ht==="wordWrapColumn"&&(J=Nt);const Me=le.c({outerWidth:Be,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:jt,viewLineCount:Kt,remainingWidth:Se,isViewportWrapping:fe},$e.memory||new A);Me.renderMinimap!==0&&Me.minimapLeft===0&&(Wt+=Me.minimapWidth,Qt+=Me.minimapWidth,ft+=Me.minimapWidth,Ft+=Me.minimapWidth);const ze=Se-Me.minimapWidth,Xe=Math.max(1,Math.floor((ze-jt-2)/Ne)),We=Vt?Dt:0;return fe&&(J=Math.max(1,Xe),Ht==="bounded"&&(J=Math.min(J,Nt))),{width:Be,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:kt,contentLeft:Ft,contentWidth:ze,minimap:Me,viewportColumn:Xe,isWordWrapMinified:Fe,isViewportWrapping:fe,wrappingColumn:J,verticalScrollbarWidth:jt,horizontalScrollbarHeight:dt,overviewRuler:{top:We,width:jt,height:Qe-2*We,right:0}}}}e.EditorLayoutInfoComputer=le;class ve extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(_){return s(_,"simple",["simple","advanced"])}compute(_,$e,Be){return $e.get(2)===2?"advanced":Be}}var se;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class we extends k{constructor(){const _={enabled:se.On};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",enum:[se.Off,se.OnCode,se.On],default:_.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:s(_.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class ne extends k{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:$.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:$.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Z extends k{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:$.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:s($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):a.clampedInt(_,this.defaultValue,0,1e3)}compute(_,$e,Be){return Be<0?a.clampedInt(-Be*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ie extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:$.localize(66,null)})}compute(_,$e,Be){return _.fontInfo.lineHeight}}class Ie extends k{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:_.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:$.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:s($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:s($e.side,this.defaultValue.side,["right","left"]),showSlider:s($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt($e.scale,1,1,3),maxColumn:a.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(Y){return Y==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{top:a.clampedInt($e.top,0,0,1e3),bottom:a.clampedInt($e.bottom,0,0,1e3)}}}class ce extends k{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:$.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:$.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class te extends b{constructor(){super(141)}compute(_,$e,Be){return _.pixelRatio}}class Q extends k{constructor(){const _={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(82,null),$.localize(83,null),$.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:_.strings,description:$.localize(85,null)},comments:{anyOf:$e,default:_.comments,description:$.localize(86,null)},other:{anyOf:$e,default:_.other,description:$.localize(87,null)}},default:_,markdownDescription:$.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Tt=_?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!_||typeof _!="object")return this.defaultValue;const{other:$e,comments:Be,strings:Qe}=_,it=["on","inline","off"];let rt,Ne,Pt;return typeof $e=="boolean"?rt=$e?"on":"off":rt=s($e,this.defaultValue.other,it),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=s(Be,this.defaultValue.comments,it),typeof Qe=="boolean"?Pt=Qe?"on":"off":Pt=s(Qe,this.defaultValue.strings,it),{other:rt,comments:Ne,strings:Pt}}}var ee;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class me extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(89,null),$.localize(90,null),$.localize(91,null),$.localize(92,null)],default:"on",description:$.localize(93,null)})}validate(_){let $e=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?($e=4,Be=_):_==="interval"?$e=3:_==="relative"?$e=2:_==="on"?$e=1:$e=0),{renderType:$e,renderFn:Be}}}function pe(Y){const _=Y.get(97);return _==="editable"?Y.get(90):_!=="on"}e.filterValidationDecorations=pe;class Le extends k{constructor(){const _=[],$e={type:"number",description:$.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:$.localize(95,null),format:"color-hex"}}}]},default:_,description:$.localize(96,null)})}validate(_){if(Array.isArray(_)){const $e=[];for(const Be of _)if(typeof Be=="number")$e.push({column:a.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;$e.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return $e.sort((Be,Qe)=>Be.column-Qe.column),$e}return this.defaultValue}}class de extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function ye(Y,_){if(typeof Y!="string")return _;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(97,null),$.localize(98,null),$.localize(99,null)],default:"auto",description:$.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(101,null),$.localize(102,null),$.localize(103,null)],default:"auto",description:$.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:$.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:$.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:$.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:$.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_,Be=a.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ye($e.vertical,this.defaultValue.vertical),horizontal:ye($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:a.clampedInt($e.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt($e.verticalSliderSize,Qe,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends k{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:$.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:$.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:$.localize(115,null)}})}applyUpdate(_,$e){let Be=!1;$e.allowedCharacters&&_&&(T.$yn(_.allowedCharacters,$e.allowedCharacters)||(_={..._,allowedCharacters:$e.allowedCharacters},Be=!0)),$e.allowedLocales&&_&&(T.$yn(_.allowedLocales,$e.allowedLocales)||(_={..._,allowedLocales:$e.allowedLocales},Be=!0));const Qe=super.applyUpdate(_,$e);return Be?new l(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{nonBasicASCII:x($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,$e){if(typeof _!="object"||!_)return $e;const Be={};for(const[Qe,it]of Object.entries(_))it===!0&&(Be[Qe]=!0);return Be}}class H extends k{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:$.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(117,null),$.localize(118,null),$.localize(119,null)],description:$.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:$.localize(121,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:s($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class z extends k{constructor(){const _={enabled:M.$rs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$rs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:$.localize(123,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends k{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:_.bracketPairs,description:$.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(128,null),$.localize(129,null),$.localize(130,null)],default:_.bracketPairsHorizontal,description:$.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:$.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:$.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(134,null),$.localize(135,null),$.localize(136,null)],default:_.highlightActiveIndentation,description:$.localize(137,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{bracketPairs:x($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:x($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Y,_,$e){const Be=$e.indexOf(Y);return Be===-1?_:$e[Be]}class Ee extends k{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(138,null),$.localize(139,null)],default:_.insertMode,description:$.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:$.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:$.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:$.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(144,null),$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:_.selectionMode,markdownDescription:$.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:$.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:$.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:$.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:$.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:$.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertMode:s($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:s($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(187,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(_.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Ke extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(188,null),$.localize(189,null),$.localize(190,null),$.localize(191,null)],description:$.localize(192,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,$e,Be){return $e.get(2)===2?0:Be}}class Ze extends b{constructor(){super(144)}compute(_,$e,Be){const Qe=$e.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class st extends k{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:s($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends k{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(199,null),$.localize(200,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:s($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?at:C.$k?ct:tt,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var vt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(201,null)})),acceptSuggestionOnEnter:je(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(202,null),""],markdownDescription:$.localize(203,null)})),accessibilitySupport:je(new f),accessibilityPageSize:je(new a(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(204,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",$.localize(205,null))),ariaRequired:je(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:je(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingComments:je(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(210,null),$.localize(211,null),""],description:$.localize(212,null)})),autoClosingDelete:je(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(213,null),""],description:$.localize(214,null)})),autoClosingOvertype:je(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(215,null),""],description:$.localize(216,null)})),autoClosingQuotes:je(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(217,null),$.localize(218,null),""],description:$.localize(219,null)})),autoIndent:je(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[$.localize(220,null),$.localize(221,null),$.localize(222,null),$.localize(223,null),$.localize(224,null)],description:$.localize(225,null)})),automaticLayout:je(new t(13,"automaticLayout",!1)),autoSurround:je(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(226,null),$.localize(227,null),$.localize(228,null),""],description:$.localize(229,null)})),bracketPairColorization:je(new z),bracketPairGuides:je(new X),stickyTabStops:je(new t(115,"stickyTabStops",!1,{description:$.localize(230,null)})),codeLens:je(new t(17,"codeLens",!0,{description:$.localize(231,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:$.localize(232,null)})),codeLensFontSize:je(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(233,null)})),colorDecorators:je(new t(20,"colorDecorators",!0,{description:$.localize(234,null)})),colorDecoratorActivatedOn:je(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),colorDecoratorsLimit:je(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(239,null)})),columnSelection:je(new t(22,"columnSelection",!1,{description:$.localize(240,null)})),comments:je(new S),contextmenu:je(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new t(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(241,null)})),cursorBlinking:je(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:$.localize(242,null)})),cursorSmoothCaretAnimation:je(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(243,null),$.localize(244,null),$.localize(245,null)],description:$.localize(246,null)})),cursorStyle:je(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:$.localize(247,null)})),cursorSurroundingLines:je(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(248,null)})),cursorSurroundingLinesStyle:je(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(249,null),$.localize(250,null)],markdownDescription:$.localize(251,null)})),cursorWidth:je(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(252,null)})),disableLayerHinting:je(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new t(34,"domReadOnly",!1)),dragAndDrop:je(new t(35,"dragAndDrop",!0,{description:$.localize(253,null)})),emptySelectionClipboard:je(new G),dropIntoEditor:je(new st),stickyScroll:je(new ne),experimentalWhitespaceRendering:je(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(254,null),$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:$.localize(258,null)})),find:je(new W),fixedOverflowWidgets:je(new t(42,"fixedOverflowWidgets",!1)),folding:je(new t(43,"folding",!0,{description:$.localize(259,null)})),foldingStrategy:je(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(260,null),$.localize(261,null)],description:$.localize(262,null)})),foldingHighlight:je(new t(45,"foldingHighlight",!0,{description:$.localize(263,null)})),foldingImportsByDefault:je(new t(46,"foldingImportsByDefault",!1,{description:$.localize(264,null)})),foldingMaximumRegions:je(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(265,null)})),unfoldOnClickAfterEndOfLine:je(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(266,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(267,null)})),fontInfo:je(new I),fontLigatures2:je(new U),fontSize:je(new K),fontWeight:je(new ae),fontVariations:je(new P),formatOnPaste:je(new t(55,"formatOnPaste",!1,{description:$.localize(268,null)})),formatOnType:je(new t(56,"formatOnType",!1,{description:$.localize(269,null)})),glyphMargin:je(new t(57,"glyphMargin",!0,{description:$.localize(270,null)})),gotoLocation:je(new he),hideCursorInOverviewRuler:je(new t(59,"hideCursorInOverviewRuler",!1,{description:$.localize(271,null)})),hover:je(new be),inDiffEditor:je(new t(61,"inDiffEditor",!1)),letterSpacing:je(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>h.clamp(Y,-5,20),{description:$.localize(272,null)})),lightbulb:je(new we),lineDecorationsWidth:je(new V),lineHeight:je(new ie),lineNumbers:je(new me),lineNumbersMinChars:je(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new t(69,"linkedEditing",!1,{description:$.localize(273,null)})),links:je(new t(70,"links",!0,{description:$.localize(274,null)})),matchBrackets:je(new u(71,"matchBrackets","always",["always","near","never"],{description:$.localize(275,null)})),minimap:je(new Ie),mouseStyle:je(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:$.localize(276,null)})),mouseWheelZoom:je(new t(75,"mouseWheelZoom",!1,{markdownDescription:C.$j?$.localize(277,null):$.localize(278,null)})),multiCursorMergeOverlapping:je(new t(76,"multiCursorMergeOverlapping",!0,{description:$.localize(279,null)})),multiCursorModifier:je(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[$.localize(280,null),$.localize(281,null)],markdownDescription:$.localize(282,null)})),multiCursorPaste:je(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),multiCursorLimit:je(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(286,null)})),occurrencesHighlight:je(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(287,null),$.localize(288,null),$.localize(289,null)],markdownDescription:$.localize(290,null)})),overviewRulerBorder:je(new t(81,"overviewRulerBorder",!0,{description:$.localize(291,null)})),overviewRulerLanes:je(new a(82,"overviewRulerLanes",3,0,3)),padding:je(new Ce),pasteAs:je(new nt),parameterHints:je(new ce),peekWidgetDefaultFocus:je(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(292,null),$.localize(293,null)],description:$.localize(294,null)})),definitionLinkOpensInPeek:je(new t(87,"definitionLinkOpensInPeek",!1,{description:$.localize(295,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(296,null)})),readOnly:je(new t(90,"readOnly",!1)),readOnlyMessage:je(new de),renameOnType:je(new t(92,"renameOnType",!1,{description:$.localize(297,null),markdownDeprecationMessage:$.localize(298,null)})),renderControlCharacters:je(new t(93,"renderControlCharacters",!0,{description:$.localize(299,null),restricted:!0})),renderFinalNewline:je(new u(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(300,null)})),renderLineHighlight:je(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(301,null)],description:$.localize(302,null)})),renderLineHighlightOnlyWhenFocus:je(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(303,null)})),renderValidationDecorations:je(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(304,null),$.localize(305,null),$.localize(306,null),""],description:$.localize(307,null)})),revealHorizontalRightPadding:je(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new t(100,"roundedSelection",!0,{description:$.localize(308,null)})),rulers:je(new Le),scrollbar:je(new F),scrollBeyondLastColumn:je(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(309,null)})),scrollBeyondLastLine:je(new t(104,"scrollBeyondLastLine",!0,{description:$.localize(310,null)})),scrollPredominantAxis:je(new t(105,"scrollPredominantAxis",!0,{description:$.localize(311,null)})),selectionClipboard:je(new t(106,"selectionClipboard",!0,{description:$.localize(312,null),included:C.$k})),selectionHighlight:je(new t(107,"selectionHighlight",!0,{description:$.localize(313,null)})),selectOnLineNumbers:je(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),showUnused:je(new t(110,"showUnused",!0,{description:$.localize(318,null)})),showDeprecated:je(new t(138,"showDeprecated",!0,{description:$.localize(319,null)})),inlayHints:je(new Z),snippetSuggestions:je(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(320,null),$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),smartSelect:je(new Te),smoothScrolling:je(new t(113,"smoothScrolling",!1,{description:$.localize(325,null)})),stopRenderingLineAfter:je(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new Ee),inlineSuggest:je(new H),inlineCompletionsAccessibilityVerbose:je(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(326,null)})),suggestFontSize:je(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new t(120,"suggestOnTriggerCharacters",!0,{description:$.localize(329,null)})),suggestSelection:je(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabCompletion:je(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),tabIndex:je(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new q),unusualLineTerminators:je(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),useShadowDOM:je(new t(126,"useShadowDOM",!0)),useTabStops:je(new t(127,"useTabStops",!0,{description:$.localize(342,null)})),wordBreak:je(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null)],description:$.localize(345,null)})),wordSeparators:je(new i(129,"wordSeparators",R.$ss,{description:$.localize(346,null)})),wordWrap:je(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null),$.localize(350,null)],description:$.localize(351,null)})),wordWrapBreakAfterCharacters:je(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(352,null)})),wordWrapOverride1:je(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new O),defaultColorDecorators:je(new t(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(353,null)})),pixelRatio:je(new te),tabFocusMode:je(new t(142,"tabFocusMode",!1,{markdownDescription:$.localize(354,null)})),layoutInfo:je(new le),wrappingInfo:je(new Ze),wrappingIndent:je(new Ke),wrappingStrategy:je(new ve)}}),define(Pe[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,15,150]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.TokenType=void 0;var C;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const R=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),l=g.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const b=this.c.charCodeAt(A);if(k)k=!1;else if(b===47&&!l){A++;break}else b===91?l=!0:b===92?k=!0:b===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Zi=g}),define(Pe[181],Re([1,0,25,31,152,293]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||R.test(t)}e.$_o=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$ap=w;function A(t){if(!t)return null;const n=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),s=!1);let u=0;if(t.preRelease){const d=$.exec(t.preRelease);if(d){const[,m,f,S]=d;u=Date.UTC(Number(m),Number(f)-1,Number(S))}}return{majorBase:n,majorMustEqual:a,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$bp=A;function k(t,n,a){let c;typeof t=="string"?c=A(w(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof a=="string"?i=A(w(a)):i=a,!c||!i)return!1;const s=c.majorBase,u=c.minorBase,d=c.patchBase;let m=i.majorBase,f=i.minorBase,S=i.patchBase;const L=i.notBefore;let v=i.majorMustEqual,y=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?s>m?!0:s<m?!1:u>f?!0:u<f||h&&h<L?!1:d>=S:(s===1&&m===0&&(!v||!y||!D)&&(m=1,f=0,S=0,v=!0,y=!1,D=!1),s<m?!1:s>m?!v:u<f?!1:u>f?!y:d<S?!1:d>S?!D:!(h&&h<L))}e.$cp=k;function l(t,n,a,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,C.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,C.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,C.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,C.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,C.localize(9,null,"main")]),i;{const d=(0,E.$Gg)(a,c.main);(0,E.$Ag)(d,a)||i.push([T.default.Warning,C.localize(10,null,d.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,C.localize(11,null,"browser")]),i;{const d=(0,E.$Gg)(a,c.browser);(0,E.$Ag)(d,a)||i.push([T.default.Warning,C.localize(12,null,d.path,a.path)])}}if(!M.valid(c.version))return i.push([T.default.Error,C.localize(13,null)]),i;const s=[];if(!p(t,n,c,h,s))for(const d of s)i.push([T.default.Error,d]);return i}e.$dp=l;function p(t,n,a,c,h){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:r(t,n,a.engines.vscode,h)}e.$ep=p;function b(t,n,a){return t==="*"||r(n,a,t)}e.$fp=b;function r(t,n,a,c=[]){const h=A(w(a));if(!h)return c.push(C.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(C.localize(15,null,a)),!1}else if(!h.majorMustEqual)return c.push(C.localize(16,null,a)),!1;return k(t,n,h)?!0:(c.push(C.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let n=0,a=t.length;n<a;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Pe[69],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class E{constructor(C,M=[],R=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$2h=E}),define(Pe[70],Re([1,0,69]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.InstantiationType=void 0;const T=[];var C;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function M($,g,w){g instanceof E.$2h||(g=new E.$2h(g,[],!!w)),T.push([$,g])}e.$Xr=M;function R(){return T}e.$Yr=R}),define(Pe[182],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Bq=E;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(R);$.outgoing.set(g.key,g),g.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),g=this.c(R,$);if(g)return g}}c(M,R){for(const[$,g]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const w=this.c(g,R);if(w)return w;R.delete($)}}}e.$Cq=T}),define(Pe[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$4h=C("instantiationService");function T(R,$,g){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:g}):($[E.DI_DEPENDENCIES]=[{id:R,index:g}],$[E.DI_TARGET]=$)}function C(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(g,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,g,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$5h=C;function M(R){return R}e.$6h=M}),define(Pe[41],Re([1,0,16,2,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.ConfigurationTarget=e.$Ai=e.$zi=e.$yi=void 0,e.$yi=(0,C.$5h)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$zi=M;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$Ai=R;var $;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Bi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$Ci=w;function A(t,n){const a=Object.create(null);for(const c in t)k(a,c,t[c],n);return a}e.$Di=A;function k(t,n,a,c){const h=n.split("."),i=h.pop();let s=t;for(let u=0;u<h.length;u++){const d=h[u];let m=s[d];switch(typeof m){case"undefined":m=s[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(m)}`);return}s=m}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$Ei=k;function l(t,n){const a=n.split(".");p(t,a)}e.$Fi=l;function p(t,n){const a=n.shift();if(n.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[a])}}function b(t,n,a){function c(s,u){let d=s;for(const m of u){if(typeof d!="object"||d===null)return;d=d[m]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?a:i}e.$Gi=b;function r(t,n,a){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Jf(t[c])&&E.$Jf(n[c])?r(t[c],n[c],a):a&&(t[c]=n[c]):t[c]=n[c])})}e.$Hi=r;function o(t){return t.replace(/[\[\]]/g,"")}e.$Ii=o}),define(Pe[35],Re([1,0,21,11,180,4,149,15]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.ContextKeyExprType=e.$1i=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(Z,V){if(g.get(Z)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(Z,V)}e.$1i=w;const A=Object.prototype.hasOwnProperty;var k;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),b=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),a=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new C.$Zi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const Ie=this.D(),Ae=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:C.$Zi.getLexeme(Ie),additionalInfo:Ae}),h.c}return ie}catch(ie){if(ie!==h.c)throw ie;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ie=this.o();V.push(ie)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ie=this.s();V.push(ie)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),m.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,o),ie?.negate()}case 17:return this.z(),N.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ie=this.l();return this.A(1,o),ie}case 17:{const ie=V.lexeme;if(this.z(),this.y(9)){const Ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ae.type!==10)throw this.B("REGEX",Ae);const Ce=Ae.lexeme,ce=Ce.lastIndexOf("/"),te=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let Q;try{Q=new RegExp(Ce.substring(1,ce),te)}catch{throw this.B("REGEX",Ae)}return I.create(ie,Q)}switch(Ae.type){case 10:case 19:{const Ce=[Ae.lexeme];this.z();let ce=this.D(),te=0;for(let Le=0;Le<Ae.lexeme.length;Le++)Ae.lexeme.charCodeAt(Le)===40?te++:Ae.lexeme.charCodeAt(Le)===41&&te--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Le=0;Le<ce.lexeme.length;Le++)ce.lexeme.charCodeAt(Le)===40?te++:Ae.lexeme.charCodeAt(Le)===41&&te--}if(te<0)break;Ce.push(C.$Zi.getLexeme(ce)),this.z(),ce=this.D()}const Q=Ce.join(""),ee=Q.lastIndexOf("/"),me=ee===Q.length-1?void 0:this.w(Q.substring(ee+1));let pe;try{pe=new RegExp(Q.substring(1,ee),me)}catch{throw this.B("REGEX",Ae)}return i.regex(ie,pe)}case 18:{const Ce=Ae.lexeme;this.z();let ce=null;if(!(0,T.$Ie)(Ce)){const te=Ce.indexOf("/"),Q=Ce.lastIndexOf("/");if(te!==Q&&te>=0){const ee=Ce.slice(te+1,Q),me=Ce[Q+1]==="i"?"i":"";try{ce=new RegExp(ee,me)}catch{throw this.B("REGEX",Ae)}}}if(ce===null)throw this.B("REGEX",Ae);return I.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Ae=this.u();return i.notIn(ie,Ae)}switch(this.D().type){case 3:{this.z();const Ae=this.u();if(this.x().type===18)return i.equals(ie,Ae);switch(Ae){case"true":return i.has(ie);case"false":return i.not(ie);default:return i.equals(ie,Ae)}}case 4:{this.z();const Ae=this.u();if(this.x().type===18)return i.notEquals(ie,Ae);switch(Ae){case"true":return i.not(ie);case"false":return i.has(ie);default:return i.notEquals(ie,Ae)}}case 5:return this.z(),U.create(ie,this.u());case 6:return this.z(),P.create(ie,this.u());case 7:return this.z(),G.create(ie,this.u());case 8:return this.z(),W.create(ie,this.u());case 13:return this.z(),i.in(ie,this.u());default:return i.has(ie)}}case 20:throw this.h.push({message:a,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ie){if(this.C(V))return this.z();throw this.B(ie,this.D())}B(V,ie,Ie){const Ae=(0,R.localize)(8,null,V,C.$Zi.getLexeme(ie)),Ce=ie.offset,ce=C.$Zi.getLexeme(ie);return this.h.push({message:Ae,offset:Ce,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$2i=h;class i{static false(){return m.INSTANCE}static true(){return f.INSTANCE}static has(V){return S.create(V)}static equals(V,ie){return L.create(V,ie)}static notEquals(V,ie){return D.create(V,ie)}static regex(V,ie){return I.create(V,ie)}static in(V,ie){return v.create(V,ie)}static notIn(V,ie){return y.create(V,ie)}static not(V){return N.create(V)}static and(...V){return he.create(V,null,!0)}static or(...V){return be.create(V,null,!0)}static greater(V,ie){return G.create(V,ie)}static greaterEquals(V,ie){return W.create(V,ie)}static smaller(V,ie){return U.create(V,ie)}static smallerEquals(V,ie){return P.create(V,ie)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$3i=i;function s(Z){const V=new h({regexParsingWithErrorRecovery:!1});return Z.map(ie=>(V.parse(ie),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$4i=s;function u(Z,V){const ie=Z?Z.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ie&&!Ie?!0:!ie||!Ie?!1:ie.equals(Ie)}e.$5i=u;function d(Z,V){return Z.cmp(V)}class m{static{this.INSTANCE=new m}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$6i=m;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return m.INSTANCE}}e.$7i=f;class S{static create(V,ie=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:m.INSTANCE:new S(V,ie)}constructor(V,ie){this.key=V,this.c=ie,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:le(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:m.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$8i=S;class L{static create(V,ie,Ie=null){if(typeof ie=="boolean")return ie?S.create(V,Ie):N.create(V,Ie);const Ae=g.get(V);return typeof Ae=="boolean"?ie===(Ae?"true":"false")?f.INSTANCE:m.INSTANCE:new L(V,ie,Ie)}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?f.INSTANCE:m.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$9i=L;class v{static create(V,ie){return new v(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ie)?ie.includes(Ie):typeof Ie=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$0i=v;class y{static create(V,ie){return new y(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=11,this.c=v.create(V,ie)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$$i=y;class D{static create(V,ie,Ie=null){if(typeof ie=="boolean")return ie?N.create(V,Ie):S.create(V,Ie);const Ae=g.get(V);return typeof Ae=="boolean"?ie===(Ae?"true":"false")?m.INSTANCE:f.INSTANCE:new D(V,ie,Ie)}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?m.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$_i=D;class N{static create(V,ie=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?m.INSTANCE:f.INSTANCE:new N(V,ie)}constructor(V,ie){this.c=V,this.d=ie,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?m.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$aj=N;function O(Z,V){if(typeof Z=="string"){const ie=parseFloat(Z);isNaN(ie)||(Z=ie)}return typeof Z=="string"||typeof Z=="number"?V(Z):m.INSTANCE}class G{static create(V,ie,Ie=null){return O(ie,Ae=>new G(V,Ae,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$bj=G;class W{static create(V,ie,Ie=null){return O(ie,Ae=>new W(V,Ae,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$cj=W;class U{static create(V,ie,Ie=null){return O(ie,Ae=>new U(V,Ae,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$dj=U;class P{static create(V,ie,Ie=null){return O(ie,Ae=>new P(V,Ae,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$ej=P;class I{static create(V,ie){return new I(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ie=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ie<Ie?-1:ie>Ie?1:0}equals(V){if(V.type===this.type){const ie=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ie===Ie}return!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$fj=I;class K{static create(V){return new K(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new K(this.c.map(V))}negate(){return this.c}}e.$gj=K;function ae(Z){let V=null;for(let ie=0,Ie=Z.length;ie<Ie;ie++){const Ae=Z[ie].substituteConstants();if(Z[ie]!==Ae&&V===null){V=[];for(let Ce=0;Ce<ie;Ce++)V[Ce]=Z[Ce]}V!==null&&(V[ie]=Ae)}return V===null?Z:V}class he{static create(V,ie,Ie){return he.d(V,ie,Ie)}constructor(V,ie){this.expr=V,this.c=ie,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++){const Ae=d(this.expr[ie],V.expr[ie]);if(Ae!==0)return Ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:he.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].evaluate(V))return!1;return!0}static d(V,ie,Ie){const Ae=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return m.INSTANCE;if(ce.type===6){Ae.push(...ce.expr);continue}Ae.push(ce)}if(Ae.length===0&&Ce)return f.INSTANCE;if(Ae.length!==0){if(Ae.length===1)return Ae[0];Ae.sort(d);for(let ce=1;ce<Ae.length;ce++)Ae[ce-1].equals(Ae[ce])&&(Ae.splice(ce,1),ce--);if(Ae.length===1)return Ae[0];for(;Ae.length>1;){const ce=Ae[Ae.length-1];if(ce.type!==9)break;Ae.pop();const te=Ae.pop(),Q=Ae.length===0,ee=be.create(ce.expr.map(me=>he.create([me,te],null,Ie)),null,Q);ee&&(Ae.push(ee),Ae.sort(d))}if(Ae.length===1)return Ae[0];if(Ie){for(let ce=0;ce<Ae.length;ce++)for(let te=ce+1;te<Ae.length;te++)if(Ae[ce].negate().equals(Ae[te]))return m.INSTANCE;if(Ae.length===1)return Ae[0]}return new he(Ae,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new he(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());this.c=be.create(V,this,!0)}return this.c}}e.$hj=he;class be{static create(V,ie,Ie){return be.d(V,ie,Ie)}constructor(V,ie){this.expr=V,this.c=ie,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++){const Ae=d(this.expr[ie],V.expr[ie]);if(Ae!==0)return Ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:be.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(this.expr[ie].evaluate(V))return!0;return!1}static d(V,ie,Ie){let Ae=[],Ce=!1;if(V){for(let ce=0,te=V.length;ce<te;ce++){const Q=V[ce];if(Q){if(Q.type===0){Ce=!0;continue}if(Q.type===1)return f.INSTANCE;if(Q.type===9){Ae=Ae.concat(Q.expr);continue}Ae.push(Q)}}if(Ae.length===0&&Ce)return m.INSTANCE;Ae.sort(d)}if(Ae.length!==0){if(Ae.length===1)return Ae[0];for(let ce=1;ce<Ae.length;ce++)Ae[ce-1].equals(Ae[ce])&&(Ae.splice(ce,1),ce--);if(Ae.length===1)return Ae[0];if(Ie){for(let ce=0;ce<Ae.length;ce++)for(let te=ce+1;te<Ae.length;te++)if(Ae[ce].negate().equals(Ae[te]))return f.INSTANCE;if(Ae.length===1)return Ae[0]}return new be(Ae,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new be(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());for(;V.length>1;){const ie=V.shift(),Ie=V.shift(),Ae=[];for(const Ce of ne(ie))for(const ce of ne(Ie))Ae.push(he.create([Ce,ce],null,!1));V.unshift(be.create(Ae,null,!1))}this.c=be.create(V,this,!0)}return this.c}}e.$ij=be;class De extends S{static{this.d=[]}static all(){return De.d.values()}constructor(V,ie,Ie){super(V,null),this.f=ie,typeof Ie=="object"?De.d.push({...Ie,key:V}):Ie!==!0&&De.d.push({key:V,description:Ie,type:ie!=null?typeof ie:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return L.create(this.key,V)}notEqualsTo(V){return D.create(this.key,V)}}e.$jj=De,e.$kj=(0,M.$5h)("contextKeyService");function le(Z,V){return Z<V?-1:Z>V?1:0}function ve(Z,V,ie,Ie){return Z<ie?-1:Z>ie?1:V<Ie?-1:V>Ie?1:0}function se(Z,V){if(Z.type===0||V.type===1)return!0;if(Z.type===9)return V.type===9?we(Z.expr,V.expr):!1;if(V.type===9){for(const ie of V.expr)if(se(Z,ie))return!0;return!1}if(Z.type===6){if(V.type===6)return we(V.expr,Z.expr);for(const ie of Z.expr)if(se(ie,V))return!0;return!1}return Z.equals(V)}e.$lj=se;function we(Z,V){let ie=0,Ie=0;for(;ie<Z.length&&Ie<V.length;){const Ae=Z[ie].cmp(V[Ie]);if(Ae<0)return!1;Ae===0&&ie++,Ie++}return ie===Z.length}function ne(Z){return Z.type===9?Z.expr:[Z]}}),define(Pe[183],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=void 0,e.$_h=(0,E.$5h)("environmentService"),e.$ai=(0,E.$6h)(e.$_h)}),define(Pe[97],Re([1,0,151,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$xo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=void 0,e.$lo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$mo=new RegExp(e.$lo),e.$no="__web_extension",e.$oo="skipWalkthrough",e.$po="extensionsSync",e.$qo="dependecyOrPackExtensionInstall";function C(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ro=C;function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$so=M;function R(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$to=R;function $(t,n){return n==="web"&&!t.includes("web")}e.$uo=$;function g(t,n,a){return $(n,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.$vo=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$wo=w;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$xo=(0,T.$5h)("extensionGalleryService");var b;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var r;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$yo=o,e.$zo=(0,T.$5h)("extensionManagementService"),e.$Ao="extensionsIdentifiers/disabled",e.$Bo="extensionsIdentifiers/enabled",e.$Co=(0,T.$5h)("IGlobalExtensionEnablementService"),e.$Do=(0,T.$5h)("IExtensionTipsService"),e.$Eo=(0,E.localize)(0,null),e.$Fo={value:e.$Eo,original:"Extensions"},e.$Go=(0,E.localize2)(1,"Preferences")}),define(Pe[42],Re([1,0,50,19,11,16,2,153,4,21,12,39]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileKind=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileOperationResult=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileChangeType=e.$Hk=e.FileOperation=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileSystemProviderErrorCode=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderCapabilities=e.$rk=e.FilePermission=e.FileType=e.$qk=e.$pk=void 0,e.$pk=(0,g.$5h)("fileService");function l(se){return se.create===!0}e.$qk=l;var p;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var b;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function r(se){const we=se;return!!we&&typeof we.onDidChange=="function"}e.$rk=r;var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(se){return!!(se.capabilities&2)}e.$sk=t;function n(se){return!!(se.capabilities&8)}e.$tk=n;function a(se){return!!(se.capabilities&131072)}e.$uk=a;function c(se){return!!(se.capabilities&4)}e.$vk=c;function h(se){return!!(se.capabilities&16)}e.$wk=h;function i(se){return t(se)?!!(se.capabilities&16384):!1}e.$xk=i;function s(se){return t(se)?!!(se.capabilities&32768):!1}e.$yk=s;function u(se){return!!(se.capabilities&65536)}e.$zk=u;function d(se){return!!(se.capabilities&2048)}e.$Ak=d;var m;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class f extends Error{static create(we,ne){const Z=new f(we.toString(),ne);return v(Z,ne),Z}constructor(we,ne){super(we),this.code=ne}}e.$Bk=f;function S(se,we){return f.create(se,we)}e.$Ck=S;function L(se){return se||S((0,$.localize)(0,null),m.Unknown)}e.$Dk=L;function v(se,we){return se.name=we?`${we} (FileSystemError)`:"FileSystemError",se}e.$Ek=v;function y(se){if(!se)return m.Unknown;if(se instanceof f)return se.code;const we=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!we)return m.Unknown;switch(we[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.$Fk=y;function D(se){if(se instanceof P)return se.fileOperationResult;switch(y(se)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 9;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileTooLarge:return 7;default:return 10}}e.$Gk=D;var N;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(we,ne,Z){this.resource=we,this.operation=ne,this.target=Z}isOperation(we){return this.operation===we}}e.$Hk=O;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class W{static{this.a=null}constructor(we,ne){this.c=ne,this.b=void 0,this.d=new k.$V(()=>{const Z=E.$$h.forUris(()=>this.c);return Z.fill(this.rawAdded.map(V=>[V,!0])),Z}),this.f=new k.$V(()=>{const Z=E.$$h.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(V=>[V,!0])),Z}),this.g=new k.$V(()=>{const Z=E.$$h.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(V=>[V,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of we){switch(Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}this.b!==W.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(we,...ne){return this.h(we,{includeChildren:!1},...ne)}affects(we,...ne){return this.h(we,{includeChildren:!0},...ne)}h(we,ne,...Z){if(!we)return!1;const V=Z.length>0;return!!((!V||Z.includes(1))&&(this.d.value.get(we)||ne.includeChildren&&this.d.value.findSuperstr(we))||(!V||Z.includes(0))&&(this.f.value.get(we)||ne.includeChildren&&this.f.value.findSuperstr(we))||(!V||Z.includes(2))&&(this.g.value.findSubstr(we)||ne.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$Ik=W;function U(se,we,ne){return!se||!we||se===we||we.length>se.length?!1:(we.charAt(we.length-1)!==T.sep&&(we+=T.sep),ne?(0,C.$_e)(se,we):se.indexOf(we)===0)}e.$Jk=U;class P extends Error{constructor(we,ne,Z){super(we),this.fileOperationResult=ne,this.options=Z}}e.$Kk=P;class I extends P{constructor(we,ne,Z,V){super(we,ne,V),this.fileOperationResult=ne,this.size=Z}}e.$Lk=I;class K extends P{constructor(we,ne,Z){super(we,2,Z),this.stat=ne}}e.$Mk=K;var ae;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Nk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ok={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Pk="files.associations",e.$Qk="files.exclude",e.$Rk="files.readonlyInclude",e.$Sk="files.readonlyExclude",e.$Tk="files.readonlyFromPermissions";var he;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$Uk="";function be(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Vk=be;async function De(se,we){if(!we.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(ne=>{const Z=we.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(Z.dispose(),ne())})})}e.$Wk=De;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(we){return(0,M.$Lf)(we)||(we=0),we<le.KB?(0,$.localize)(1,null,we.toFixed(0)):we<le.MB?(0,$.localize)(2,null,(we/le.KB).toFixed(2)):we<le.GB?(0,$.localize)(3,null,(we/le.MB).toFixed(2)):we<le.TB?(0,$.localize)(4,null,(we/le.GB).toFixed(2)):(0,$.localize)(5,null,(we/le.TB).toFixed(2))}}e.$Xk=le;function ve(se){const we=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*le.MB:we?10*le.MB:w.$o?50*le.MB:1024*le.MB}e.$Yk=ve}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class E{constructor(...C){this.a=new Map;for(const[M,R]of C)this.set(M,R)}set(C,M){const R=this.a.get(C);return this.a.set(C,M),R}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$3h=E}),define(Pe[184],Re([1,0,13,15,6,69,182,4,71,185]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;const A=!1;class k extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$3h,t=!1,n,a=A){this.f=o,this.g=t,this.h=n,this.i=a,this.o=new Set,this.f.set($.$4h,this),this._globalGraph=a?n?._globalGraph??new R.$Cq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...t){const n=b.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{a=!0,n.stop()}}createInstance(o,...t){let n,a;return o instanceof M.$2h?(n=b.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(t),n)):(n=b.traceCreation(this.i,o),a=this.j(o,t,n)),n.stop(),a}j(o,t=[],n){const a=$._util.getServiceDependencies(o).sort((i,s)=>i.index-s.index),c=[];for(const i of a){const s=this.m(i.id,n);s||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const h=a.length>0?a[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(o,t.concat(c))}k(o,t){if(this.f.get(o)instanceof M.$2h)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof M.$2h?this.q(o,n,t.branch(o,!0)):(t.branch(o,!1),n)}q(o,t,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,n)}finally{this.o.delete(o)}}r(o,t,n){const a=new R.$Cq(i=>i.id.toString());let c=0;const h=[{id:o,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new k(a);for(const s of $._util.getServiceDependencies(i.desc.ctor)){const u=this.l(s.id);if(u||this.u(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),u instanceof M.$2h){const d={id:s.id,desc:u,_trace:i._trace.branch(s.id,!0)};a.insertEdge(i,d),h.push(d)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new k(a);break}for(const{data:s}of i){if(this.l(s.id)instanceof M.$2h){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}a.removeNode(s)}}return this.l(o)}s(o,t,n=[],a,c){if(this.f.get(o)instanceof M.$2h)return this.t(o,t,n,a,c);if(this.h)return this.h.s(o,t,n,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,n=[],a,c){if(a){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const i=new Map,s=new E.$lh(()=>{const u=h.j(t,n,c);for(const[d,m]of i){const f=u[d];if(typeof f=="function")for(const S of m)S.disposable=f.apply(u,S.listener)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=i.get(d);return S||(S=new w.$4c,i.set(d,S)),(v,y,D)=>{if(s.isInitialized)return s.value[d](v,y,D);{const N={listener:[v,y,D],disposable:void 0},O=S.push(N);return(0,C.$Rc)(()=>{O(),N.disposable?.dispose()})}}}if(d in u)return u[d];const m=s.value;let f=m[d];return typeof f!="function"||(f=f.bind(m),u[d]=f),f},set(u,d,m){return s.value[d]=m,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$Dq=l;var p;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(p||(p={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new b(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(o,t){return o?new b(1,t.name):b.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const n=new b(3,o.toString());return this.h.push([o,t,n]),n}stop(){const o=Date.now()-this.g;b.f+=o;let t=!1;function n(c,h){const i=[],s=new Array(c+1).join("	");for(const[u,d,m]of h.h)if(d&&m){t=!0,i.push(`${s}CREATES -> ${u}`);const f=n(c+1,m);f&&i.push(f)}else i.push(`${s}uses -> ${u}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(o>2||t)&&b.all.add(a.join(`
`))}}e.$Eq=b}),define(Pe[14],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.log=e.$pj=e.LogLevel=e.$oj=e.$nj=e.$mj=void 0,e.$mj=(0,l.$5h)("logService"),e.$nj=(0,l.$5h)("loggerService");function p(){return new Date().toISOString()}function b(v){return(0,w.$Lf)(v)}e.$oj=b;var r;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$pj=r.Info;function o(v,y,D){switch(y){case r.Trace:v.trace(D);break;case r.Debug:v.debug(D);break;case r.Info:v.info(D);break;case r.Warning:v.warn(D);break;case r.Error:v.error(D);break;case r.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=o;function t(v,y=!1){let D="";for(let N=0;N<v.length;N++){let O=v[N];if(O instanceof Error&&(O=(0,E.$Pi)(O,y)),typeof O=="object")try{O=JSON.stringify(O)}catch{}D+=(N>0?" ":"")+O}return D}class n extends M.$Tc{constructor(){super(...arguments),this.b=e.$pj,this.c=this.B(new T.$Ud),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==r.Off&&this.b<=y}}e.$rj=n;class a extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...D){this.f(r.Trace)&&this.g(r.Trace,t([y,...D],!0))}debug(y,...D){this.f(r.Debug)&&this.g(r.Debug,t([y,...D]))}info(y,...D){this.f(r.Info)&&this.g(r.Info,t([y,...D]))}warn(y,...D){this.f(r.Warning)&&this.g(r.Warning,t([y,...D]))}error(y,...D){if(this.f(r.Error))if(y instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=y.stack,this.g(r.Error,t(N))}else this.g(r.Error,t([y,...D]))}flush(){}}e.$sj=a;class c extends n{constructor(y=e.$pj){super(),this.setLevel(y),this.g=!$.$i}trace(y,...D){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,y,...D):console.warn(`[main ${p()}]`,y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,y,...D):console.error(`[main ${p()}]`,y,...D))}flush(){}}e.$tj=c;class h extends n{constructor(y=e.$pj,D=!0){super(),this.g=D,this.setLevel(y)}trace(y,...D){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...D):console.log(y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...D):console.log(y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...D):console.log(y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...D):console.log(y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...D):console.error(y,...D))}flush(){}}e.$uj=h;class i extends n{constructor(y,D=e.$pj){super(),this.g=y,this.setLevel(D)}trace(y,...D){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(y),...D])}debug(y,...D){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(y),...D])}info(y,...D){this.f(r.Info)&&this.g.log(r.Info,[this.h(y),...D])}warn(y,...D){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(y),...D])}error(y,...D){this.f(r.Error)&&this.g.log(r.Error,[this.h(y),...D])}h(y){return typeof y=="string"?y:(0,E.$Pi)(y,this.f(r.Trace))}flush(){}}e.$vj=i;class s extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const D of this.g)D.setLevel(y);super.setLevel(y)}trace(y,...D){for(const N of this.g)N.trace(y,...D)}debug(y,...D){for(const N of this.g)N.debug(y,...D)}info(y,...D){for(const N of this.g)N.info(y,...D)}warn(y,...D){for(const N of this.g)N.warn(y,...D)}error(y,...D){for(const N of this.g)N.error(y,...D)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$wj=s;class u extends M.$Tc{constructor(y,D,N){if(super(),this.h=y,this.j=D,this.b=new R.$Ac,this.c=this.B(new T.$Ud),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Ud),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Ud),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(y){return(0,w.$Hf)(y)?[...this.b.values()].find(D=>D.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,D){const N=this.n(y),O=(0,w.$Hf)(y)?y:D?.id??(0,C.$Si)(N.toString()).toString(16);let G=this.b.get(N)?.logger;const W=D?.logLevel==="always"?r.Trace:D?.logLevel;G||(G=this.s(N,W??this.getLogLevel(N)??this.h,{...D,id:O}));const U={logger:G,info:{resource:N,id:O,logLevel:W,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(U.info),this.b.set(N,U),G}n(y){return(0,w.$Hf)(y)?(0,g.$Gg)(this.j,`${y}.log`):y}setLogLevel(y,D){if(A.URI.isUri(y)){const N=y,O=D,G=this.b.get(N);G&&O!==G.info.logLevel&&(G.info.logLevel=O===this.h?void 0:O,G.logger?.setLevel(O),this.b.set(G.info.resource,G),this.f.fire([N,O]))}else{this.h=y;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,D){const N=this.m(y);N&&D!==!N.info.hidden&&(N.info.hidden=!D,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,D]))}getLogLevel(y){let D;return y&&(D=this.b.get(y)?.info.logLevel),D??this.h}registerLogger(y){const D=this.b.get(y.resource);D?D.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const D=this.b.get(y);D&&(D.logger&&D.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$xj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Ud().event}setLevel(y){}getLevel(){return r.Info}trace(y,...D){}debug(y,...D){}info(y,...D){}warn(y,...D){}error(y,...D){}critical(y,...D){}dispose(){}flush(){}}e.$yj=d;class m extends d{}e.$zj=m;function f(v){if(v.verbose)return r.Trace;if(typeof v.logLevel=="string"){const y=L(v.logLevel.toLowerCase());if(y!==void 0)return y}return e.$pj}e.$Aj=f;function S(v){switch(v){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$Bj=S;function L(v){switch(v){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$Cj=L,e.$Dj=new k.$jj("logLevel",S(r.Info))}),define(Pe[186],Re([1,0,6,14]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=void 0;class C extends E.$Tc{constructor(R,$=[]){super(),this.a=new T.$wj([R,...$]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$sO=C}),define(Pe[99],Re([1,0,31,154,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function w(b,r){return r-b}g.compare=w;const A=Object.create(null);A[g.Error]=(0,T.localize)(0,null),A[g.Warning]=(0,T.localize)(1,null),A[g.Info]=(0,T.localize)(2,null);function k(b){return A[b]||""}g.toString=k;function l(b){switch(b){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function p(b){switch(b){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=p}(R||(e.MarkerSeverity=R={}));var $;(function(g){const w="";function A(l){return k(l,!0)}g.makeKey=A;function k(l,p){const b=[w];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(w),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(w),l.severity!==void 0&&l.severity!==null?b.push(R.toString(l.severity)):b.push(w),l.message&&p?b.push(l.message.replace("\xA6","\\\xA6")):b.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(w),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(w),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(w),b.push(w),b.join("\xA6")}g.makeKeyOptionalMessage=k})($||(e.IMarkerData=$={})),e.$zt=(0,C.$5h)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.NotificationsFilter=e.$pv=e.NeverShowAgainScope=e.NotificationPriority=e.$ov=e.Severity=void 0,e.Severity=T.default,e.$ov=(0,C.$5h)("notificationService");var M;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function $(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$pv=$;var g;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class w{constructor(){this.progress=new A,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$qv=w;class A{infinite(){}done(){}total(l){}worked(l){}}e.$rv=A}),define(Pe[188],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=void 0,e.$Ej=(0,E.$5h)("productService"),e.$Fj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,E,T){var C=arguments.length,M=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ge,e,E,T);else for(var $=ge.length-1;$>=0;$--)(R=ge[$])&&(M=(C<3?R(M):C>3?R(e,E,M):R(e,E))||M);return C>3&&M&&Object.defineProperty(e,E,M),M},He=this&&this.__param||function(ge,e){return function(E,T){e(E,T,ge)}};define(Pe[72],Re([1,0,13,20,6,4]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.ProgressLocation=e.$sv=void 0,e.$sv=(0,M.$5h)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$tv=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$uv=$;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$vv=g;let w=class extends C.$Tc{constructor(l,p){super(),this.a=new E.$ph,p.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$wv=w,e.$wv=w=Je([He(1,e.$sv)],w);class A extends C.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Sc)}start(l){this.stop();const p=++this.a,b=new T.$5d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>b.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:b.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$xv=A,e.$yv=(0,M.$5h)("editorProgressService")}),define(Pe[30],Re([1,0,53,16]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class C{constructor(){this.a=new Map}add(R,$){E.ok(T.$Hf(R)),E.ok(T.$Jf($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Gn=new C}),define(Pe[73],Re([1,0,5,30]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0,e.$Hn={JSONContribution:"base.contributions.json"};function C($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Ud,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[C(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;T.$Gn.add(e.$Hn.JSONContribution,R)}),define(Pe[54],Re([1,0,18,5,16,148,41,73,30]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ConfigurationScope=e.$Ln=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$Ln={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Mn={properties:{},patternProperties:{}},e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn="vscode://schemas/settings/resourceLanguage",e.$Tn="vscode://schemas/settings/configurationDefaults";const k=g.$Gn.as($.$Hn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Ud,this.onDidSchemaChange=this.i.event,this.j=new T.$Ud,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Sn,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const u=new Set;this.n(i,s,u),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const s=new Set;this.o(i,s),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const u=new Set;this.o(s,u),this.n(i,!1,u),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const u=[];for(const{overrides:d,source:m}of i)for(const f in d)if(s.add(f),e.$Vn.test(f)){const S=this.a.get(f),L=S?.valuesSources??new Map;if(m)for(const N of Object.keys(d[f]))L.set(N,m);const v={...S?.value||{},...d[f]};this.a.set(f,{source:m,value:v,valuesSources:L});const y=(0,R.$Ii)(f),D={type:"object",default:v,description:M.localize(1,null,y),$ref:e.$Sn,defaultDefaultValue:v,source:C.$Hf(m)?void 0:m,defaultValueSource:m};u.push(...r(f)),this.d[f]=D,this.b.properties[f]=D}else{this.a.set(f,{value:d[f],source:m});const S=this.d[f];S&&(this.w(f,S),this.r(f,S))}this.m(u)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:u,source:d}of i)for(const m in u){const f=this.a.get(m),S=C.$Hf(d)?d:d?.id,L=C.$Hf(f?.source)?f?.source:f?.source?.id;if(S===L)if(s.add(m),this.a.delete(m),e.$Vn.test(m))delete this.d[m],delete this.b.properties[m];else{const v=this.d[m];v&&(this.w(m,v),this.r(m,v))}}this.u()}deltaConfiguration(i){let s=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,u){i.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,s){const u=d=>{if(d.properties)for(const m in d.properties){s.add(m);const f=this.d[m];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[m],this.s(m,d.properties[m])}d.allOf?.forEach(m=>u(m))};for(const d of i){u(d);const m=this.c.indexOf(d);m!==-1&&this.c.splice(m,1)}}p(i,s=!0,u,d,m=3,f){m=C.$Qf(i.scope)?m:i.scope;const S=i.properties;if(S)for(const v in S){const y=S[v];if(s&&a(v,y)){delete S[v];continue}if(y.source=u,y.defaultDefaultValue=S[v].default,this.w(v,y),e.$Vn.test(v)?y.scope=void 0:(y.scope=C.$Qf(y.scope)?m:y.scope,y.restricted=C.$Qf(y.restricted)?!!d?.includes(v):y.restricted),S[v].hasOwnProperty("included")&&!S[v].included){this.f[v]=S[v],delete S[v];continue}else this.d[v]=S[v],S[v].policy?.name&&this.e.set(S[v].policy.name,v);!S[v].deprecationMessage&&S[v].markdownDeprecationMessage&&(S[v].deprecationMessage=S[v].markdownDeprecationMessage),f.add(v)}const L=i.allOf;if(L)for(const v of L)this.p(v,s,u,d,m,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$Mn.properties[i]=s,s.scope){case 1:e.$Nn.properties[i]=s;break;case 2:e.$On.properties[i]=s;break;case 6:e.$Pn.properties[i]=s;break;case 3:e.$Qn.properties[i]=s;break;case 4:e.$Rn.properties[i]=s;break;case 5:e.$Rn.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$Mn.properties[i],s.scope){case 1:delete e.$Nn.properties[i];break;case 2:delete e.$On.properties[i];break;case 6:delete e.$Pn.properties[i];break;case 3:delete e.$Qn.properties[i];break;case 4:case 5:delete e.$Rn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Sn};this.w(s,u),e.$Mn.properties[s]=u,e.$Nn.properties[s]=u,e.$On.properties[s]=u,e.$Pn.properties[s]=u,e.$Qn.properties[s]=u,e.$Rn.properties[s]=u}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Sn};e.$Mn.patternProperties[e.$Un]=i,e.$Nn.patternProperties[e.$Un]=i,e.$On.patternProperties[e.$Un]=i,e.$Pn.patternProperties[e.$Un]=i,e.$Qn.patternProperties[e.$Un]=i,e.$Rn.patternProperties[e.$Un]=i,this.i.fire()}w(i,s){const u=this.a.get(i);let d=u?.value,m=u?.source;C.$Of(d)&&(d=s.defaultDefaultValue,m=void 0),C.$Of(d)&&(d=t(s.type)),s.default=d,s.defaultValueSource=m}}const p="\\[([^\\]]+)\\]",b=new RegExp(p,"g");e.$Un=`^(${p})+$`,e.$Vn=new RegExp(e.$Un);function r(h){const i=[];if(e.$Vn.test(h)){let s=b.exec(h);for(;s?.length;){const u=s[1].trim();u&&i.push(u),s=b.exec(h)}}return(0,E.$Mb)(i)}e.$Wn=r;function o(h){return h.reduce((i,s)=>`${i}[${s}]`,"")}e.$Xn=o;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Yn=t;const n=new l;g.$Gn.add(e.$Ln.Configuration,n);function a(h,i){return h.trim()?e.$Vn.test(h)?M.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Zn=a;function c(){const h=[],i=n.getConfigurationProperties();for(const s of Object.keys(i))h.push([s,i[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$1n=c}),define(Pe[189],Re([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;function p(s){return Object.isFrozen(s)?s:$.$vn(s)}class b{constructor(u={},d=[],m=[],f){this.b=u,this.c=d,this.d=m,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof b)return d;const m=new r("");return m.parseRaw(d),m.configurationModel});this.f=u.reduce((d,m)=>m===d?m:d.merge(m),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,A.$Gi)(this.contents,u):this.contents}inspect(u,d){const m=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,S=d?this.rawConfiguration.override(d).getValue(u):m;return{value:m,override:f,merged:S}}getOverrideValue(u,d){const m=this.i(d);return m?u?(0,A.$Gi)(m,u):m:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const m of this.overrides)m.identifiers.includes(u)&&d.push(...m.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=$.$un(this.contents),m=$.$un(this.overrides),f=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of u)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(d,L.contents);for(const v of L.overrides){const[y]=m.filter(D=>E.$ub(D.identifiers,v.identifiers));y?(this.h(y.contents,v.contents),y.keys.push(...v.keys),y.keys=E.$Mb(y.keys)):m.push($.$un(v))}for(const v of L.keys)f.indexOf(v)===-1&&f.push(v)}return new b(d,f,m,S.every(L=>L instanceof b)?void 0:S)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const m={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[f];const L=d[f];L&&(typeof S=="object"&&typeof L=="object"?(S=$.$un(S),this.h(S,L)):S=L),m[f]=S}return new b(m,this.keys,this.overrides)}h(u,d){for(const m of Object.keys(d)){if(m in u&&g.$Jf(u[m])&&g.$Jf(d[m])){this.h(u[m],d[m]);continue}u[m]=$.$un(d[m])}}i(u){let d=null,m=null;const f=S=>{S&&(m?this.h(m,S):m=$.$un(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===u?d=S.contents:S.identifiers.includes(u)&&f(S.contents);return f(d),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,A.$Fi)(this.contents,u),k.$Vn.test(u)&&this.overrides.splice(this.overrides.findIndex(m=>E.$ub(m.identifiers,(0,k.$Wn)(u))),1))}j(u,d,m){(0,A.$Ei)(this.contents,u,d,f=>console.error(f)),m=m||this.keys.indexOf(u)===-1,m&&this.keys.push(u),k.$Vn.test(u)&&this.overrides.push({identifiers:(0,k.$Wn)(u),keys:Object.keys(this.contents[u]),contents:(0,A.$Di)(this.contents[u],f=>console.error(f))})}}e.$2n=b;class r{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Qf(u)){const m=this.g(u);this.parseRaw(m,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:m,keys:f,overrides:S,restricted:L,hasExcludedProperties:v}=this.h(u,d);this.b=new b(m,f,S,v?[u]:void 0),this.c=L||[]}g(u){let d={},m=null,f=[];const S=[],L=[];function v(D){Array.isArray(f)?f.push(D):m!==null&&(f[m]=D)}const y={onObjectBegin:()=>{const D={};v(D),S.push(f),f=D,m=null},onObjectProperty:D=>{m=D},onObjectEnd:()=>{f=S.pop()},onArrayBegin:()=>{const D=[];v(D),S.push(f),f=D,m=null},onArrayEnd:()=>{f=S.pop()},onLiteralValue:v,onError:(D,N,O)=>{L.push({error:D,offset:N,length:O})}};if(u)try{C.$in(u,y),d=f[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return d}h(u,d){const m=l.$Gn.as(k.$Ln.Configuration).getConfigurationProperties(),f=this.i(u,m,!0,d);u=f.raw;const S=(0,A.$Di)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(u),v=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:S,keys:L,overrides:v,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,m,f){let S=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:S};const L={},v=[];for(const y in u)if(k.$Vn.test(y)&&m){const D=this.i(u[y],d,!1,f);L[y]=D.raw,S=S||D.hasExcludedProperties,v.push(...D.restricted)}else{const D=d[y],N=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&v.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&!(f.skipRestricted&&D?.restricted))?L[y]=u[y]:S=!0}return{raw:L,restricted:v,hasExcludedProperties:S}}j(u,d){const m=[];for(const f of Object.keys(u))if(k.$Vn.test(f)){const S={};for(const L in u[f])S[L]=u[f][L];m.push({identifiers:(0,k.$Wn)(f),keys:Object.keys(S),contents:(0,A.$Di)(S,d)})}return m}}e.$3n=r;class o extends M.$Tc{constructor(u,d,m,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Ud),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(m.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&m.isEqual(S.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$4n=o;class t{constructor(u,d,m,f,S,L,v,y,D,N,O,G,W){this.a=u,this.b=d,this.c=m,this.overrideIdentifiers=f,this.d=S,this.f=L,this.g=v,this.h=y,this.i=D,this.j=N,this.k=O,this.l=G,this.m=W}get value(){return p(this.c)}n(u,d,m){const f=u.inspect(d,m);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,d,m,f,S=new b,L=new b,v=new R.$Ac,y=new b,D=new R.$Ac){this.c=u,this.d=d,this.f=m,this.g=f,this.h=S,this.i=L,this.j=v,this.l=y,this.m=D,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,d,m){return this.p(u,d,m).getValue(u)}updateValue(u,d,m={}){let f;m.resource?(f=this.m.get(m.resource),f||(f=new b,this.m.set(m.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),m.resource||(this.a=null)}inspect(u,d,m){const f=this.p(u,d,m),S=this.t(d.resource,m),L=d.resource?this.m.get(d.resource)||this.l:this.l,v=new Set;for(const y of f.overrides)for(const D of y.identifiers)f.getOverrideValue(u,D)!==void 0&&v.add(D);return new t(u,d,f.getValue(u),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this.i:void 0,S||void 0,L)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const m=[];if(!d){const{added:f,updated:S,removed:L}=h(this.c,u);d=[...f,...S,...L]}for(const f of d)for(const S of(0,k.$Wn)(f)){const L=this.c.getKeysForOverrideIdentifier(S),v=u.getKeysForOverrideIdentifier(S),y=[...v.filter(D=>L.indexOf(D)===-1),...L.filter(D=>v.indexOf(D)===-1),...L.filter(D=>!$.$yn(this.c.override(S).getValue(D),u.override(S).getValue(D)))];m.push([S,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:m}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:m,removed:f}=h(this.d,u),S=[...d,...m,...f];return S.length&&this.updatePolicyConfiguration(u),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.applicationConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateApplicationConfiguration(u),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.localUserConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateLocalUserConfiguration(u),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.remoteUserConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateRemoteUserConfiguration(u),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:m,removed:f,overrides:S}=h(this.workspaceConfiguration,u),L=[...d,...m,...f];return L.length&&this.updateWorkspaceConfiguration(u),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(u,d){const m=this.folderConfigurations.get(u),{added:f,updated:S,removed:L,overrides:v}=h(m,d),y=[...f,...S,...L];return(y.length||!m)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:v}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:m,updated:f,removed:S,overrides:L}=h(d,void 0);return{keys:[...m,...f,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,m){let f=this.q(d,m);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let m=this.r();if(d&&u){const f=d.getFolder(u);f&&(m=this.s(f.uri)||m);const S=this.m.get(u);S&&(m=m.merge(S))}return m}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const m=this.r(),f=this.j.get(u);f?(d=m.merge(f),this.b.set(u,d)):d=m}return d}t(u,d){if(d&&u){const m=d.getFolder(u);if(m)return this.j.get(m.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:m,overrides:f,keys:S}=this.j.get(d);return u.push([d,{contents:m,overrides:f,keys:S}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(m=>u.add(m))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(m=>u.add(m))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.i.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.j.forEach(m=>m.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),m=this.w(u.policy),f=this.w(u.application),S=this.w(u.user),L=this.w(u.workspace),v=u.folders.reduce((y,D)=>(y.set(w.URI.revive(D[0]),this.w(D[1])),y),new R.$Ac);return new n(d,m,f,S,new b,L,v,new b,new R.$Ac)}static w(u){return new b(u.contents,u.keys,u.overrides)}}e.$5n=n;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,d=new Map;for(const f of s)f.keys.forEach(S=>u.add(S)),f.overrides.forEach(([S,L])=>{const v=(0,R.$xc)(d,S,new Set);L.forEach(y=>v.add(y))});const m=[];return d.forEach((f,S)=>m.push([S,[...f.values()]])),{keys:[...u.values()],overrides:m}}e.$6n=a;class c{constructor(u,d,m,f){this.change=u,this.f=d,this.g=m,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of u.keys)this.affectedKeys.add(S);for(const[,S]of u.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,d){const m=this.a+u,f=this.d.indexOf(m);if(f<0)return!1;const S=f+m.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(d){const v=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!$.$yn(v,y)}return!0}}e.$7n=c;function h(s,u){const{added:d,removed:m,updated:f}=i(u?.rawConfiguration,s?.rawConfiguration),S=[],L=s?.getAllOverrideIdentifiers()||[],v=u?.getAllOverrideIdentifiers()||[];if(u){const y=v.filter(D=>!L.includes(D));for(const D of y)S.push([D,u.getKeysForOverrideIdentifier(D)])}if(s){const y=L.filter(D=>!v.includes(D));for(const D of y)S.push([D,s.getKeysForOverrideIdentifier(D)])}if(u&&s){for(const y of L)if(v.includes(y)){const D=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});S.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:d,removed:m,updated:f,overrides:S}}function i(s,u){const d=s?u?s.keys.filter(S=>u.keys.indexOf(S)===-1):[...s.keys]:[],m=u?s?u.keys.filter(S=>s.keys.indexOf(S)===-1):[...u.keys]:[],f=[];if(s&&u){for(const S of u.keys)if(s.keys.indexOf(S)!==-1){const L=(0,A.$Gi)(u.contents,S),v=(0,A.$Gi)(s.contents,S);$.$yn(L,v)||f.push(S)}}return{added:d,removed:m,updated:f}}}),define(Pe[100],Re([1,0,15,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.RemoteAuthorityResolverErrorCode=e.$9k=e.$8k=e.RemoteConnectionType=e.$7k=void 0,e.$7k=(0,T.$5h)("remoteAuthorityResolverService");var C;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class M{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$8k=M;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$9k=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class g extends E.$bb{static isNotAvailable(k){return k instanceof g&&k._code===$.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===$.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===$.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===$.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,l=$.Unknown,p){super(k),this._message=k,this._code=l,this._detail=p,this.isHandled=l===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,g.prototype)}}e.$0k=g;function w(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$$k=w}),define(Pe[55],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0;function T(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$_k=T;function C(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.$al=C;function M(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$bl=M;function R(w){const{host:A,port:k}=g(w);if(typeof k>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:k}}e.$cl=R;function $(w,A){let{host:k,port:l}=g(w);return typeof l>"u"&&(l=A),{host:k,port:l}}e.$dl=$;function g(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=w.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Pe[22],Re([1,0,11,4,55]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.TargetPlatform=e.ExtensionType=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em="extensions.user.cache",e.$fm="extensions.builtin.cache",e.$gm="undefined_publisher",e.$hm=["ui","workspace","web"];function M(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$im=M,e.$jm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const n=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return E.$$e(n,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$km=g;class w{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$lm=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,t){this.c.set(g.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$mm=A;function k(r){return l(r)}e.$nm=k;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$om=l;function p(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$pm=p;function b(r,o){if(o){const t=`onResolveRemoteAuthority:${(0,C.$al)(o)}`;return!!r.activationEvents?.includes(t)}return!1}e.$qm=b,e.$rm=(0,T.$5h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,15,22]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gF=e.$fF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const g of R){const w=this.readActivationEvents(g);w.length>0&&($[T.$km.toKey(g.identifier)]=w)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<$.length;g++)$[g]==="onUri"&&($[g]=`onUri:${T.$km.toKey(R.identifier)}`);if(!R.contributes)return $;for(const g in R.contributes){const w=this.a.get(g);if(!w)continue;const A=R.contributes[g],k=Array.isArray(A)?A:[A];try{w(k,$)}catch(l){(0,E.$1)(l)}}return $}}e.$fF=C,e.$gF=new C}),define(Pe[190],Re([1,0,21,74,33]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=void 0;function M(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,w,A,k,l,p,b,r,o){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=b,t.sessionID=(0,C.$pg)()+Date.now(),t.commitHash=k,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",r&&(t["common.msftInternal"]=r);let n=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=M(w);return c&&(t["common.platformDetail"]=c),t}e.$Ho=R;function $(g){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return g.some(k=>A===k)}e.$Io=$}),define(Pe[191],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=void 0,e.$tl=(0,E.$5h)("telemetryService"),e.$ul=(0,E.$5h)("customEndpointTelemetryService"),e.$vl="telemetry.currentSessionDate",e.$wl="telemetry.firstSessionDate",e.$xl="telemetry.lastSessionDate",e.$yl="telemetry.machineId",e.$zl="telemetry.sqmId",e.$Al="telemetry",e.$Bl="telemetry.telemetryLevel",e.$Cl="telemetry.enableCrashReporter",e.$Dl="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[56],Re([1,0,26,16,5,41,55,190,191]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;class w{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$Jo=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ko=A,e.$Lo=new A;class k{async publicLog(m,f,S){}async publicLogError(m,f,S){}}e.$Mo=k,e.$No="telemetry",e.$Oo="extensionTelemetryLog",e.$Po={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,m){return C.Event.debounce(m.onDidChangeConfiguration,(S,L)=>{const v=S?new Set([...S.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:v}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$Bi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Qo=l;function p(d,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!d.enableTelemetry)}e.$Ro=p;function b(d,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$So=b;function r(d){const m=d.getValue(g.$Bl),f=d.getValue(g.$Cl);if(d.getValue(g.$Dl)===!1||f===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$To=r;function o(d){const m={},f={},S={};a(d,S);for(let L in S){L=L.length>150?L.substr(L.length-149):L;const v=S[L];typeof v=="number"?f[L]=v:typeof v=="boolean"?f[L]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${v.length}`),m[L]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(m[L]=v)}return{properties:m,measurements:f}}e.$Uo=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const m=(0,R.$al)(d);return t.has(m)?m:"other"}e.$Vo=n;function a(d,m,f=0,S){if(d)for(const L of Object.getOwnPropertyNames(d)){const v=d[L],y=S?S+L:L;Array.isArray(v)?m[y]=(0,E.$zn)(v):v instanceof Date?m[y]=v.toISOString():(0,T.$Jf)(v)?f<2?a(v,m,f+1,y+"."):m[y]=(0,E.$zn)(v):m[y]=v}}function c(d,m){const f=d.msftInternalDomains||[],S=m.getValue("telemetry.internalTesting");return(0,$.$Io)(f)||S}e.$Wo=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Xo=h;function i(d,m){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const S=[];for(const D of m)for(;;){const N=D.exec(d);if(!N)break;S.push([N.index,D.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const D=v.exec(d);if(!D)break;const N=S.some(([O,G])=>D.index<G&&O<v.lastIndex);!L.test(D[0])&&!N&&(f+=d.substring(y,D.index)+"<REDACTED: user-file-path>",y=v.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function s(d){if(!d)return d;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,m){return(0,E.$wn)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let S=f.replaceAll("%20"," ");S=i(S,m);for(const L of m)S=S.replace(L,"");return S=s(S),S}})}e.$Yo=u}),define(Pe[192],Re([1,0,11,97,22,21,2,15,74,56]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;function A(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$6e)(u.id,d.id)===0}e.$Zo=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const m=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,m,f)}static parse(d){const m=k.exec(d);return m&&m[1]&&m[2]?new l({id:m[1]},m[2],m[4]||void 0):null}constructor(d,m,f="undefined"){this.version=m,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$1o=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(u){const d=p.exec(u);return d&&d[1]?[o(d[1]),d[2]]:[o(u),void 0]}e.$2o=b;function r(u,d){return`${u}.${d}`}e.$3o=r;function o(u){return u.toLowerCase()}e.$4o=o;function t(u,d){return o(r(u??C.$gm,d))}e.$5o=t;function n(u,d){const m=[],f=S=>{for(const L of m)if(L.some(v=>A(d(v),d(S))))return L;return null};for(const S of u){const L=f(S);L?L.push(S):m.push([S])}return m}e.$6o=n;function a(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$7o=a;function c(u){return{id:new w.$Jo(u.identifier.id),name:new w.$Jo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$8o=c,e.$9o=new C.$km("pprice.better-merge");function h(u,d){const m=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const S=f.shift();if(S&&m.every(L=>!A(L.identifier,{id:S}))){const L=u.filter(v=>A(v.identifier,{id:S}));L.length===1&&(m.push(L[0]),f.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.$0o=h;async function i(u,d){if(!M.$k)return!1;let m;try{m=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,$.$0)(S))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(u,d){const m=await i(u,d),f=(0,T.$to)(m?"alpine":M.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$$o=s}),define(Pe[193],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0;function E(g){return[...g.entries()]}e.$Lr=E;function T(g){return g?[...g.entries()]:[]}e.$Mr=T;function C(g){return new Map(g)}e.$Nr=C;function M(g){return new Map(g??[])}e.$Or=M;function R(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),T(w[1].descriptionMap)])}e.$Pr=R;function $(g){return new Map(g.map(w=>[w[0],{map:C(w[1]),descriptionMap:M(w[2])}]))}e.$Qr=$}),define(Pe[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erb=void 0;class E{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,R=5){const $=M(g=>{const w=typeof g=="string"?g:g.data;let A=this.a.get(C);if(A){A.data.push(w);return}const k=setTimeout(()=>this.flushBuffer(C),R);A={data:[w],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),$.dispose()}},this.a.set(C,A)});return $}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.$Erb=E}),define(Pe[195],Re([1,0,13,90,45,5,16,2,155,73,30]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.IconFontDefinition=e.IconContribution=e.$vw=void 0,e.$vw={IconContribution:"base.contributions.icons"};var k;(function(c){function h(i,s){let u=i.defaults;for(;C.ThemeIcon.isThemeIcon(u);){const d=b.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(c){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(s){const u=d=>(0,R.$Hf)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,R.$Hf)(d.format)&&(0,R.$Hf)(d.location)))return{weight:u(s.weight),style:u(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new M.$Ud,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,s,u){const d=this.b[h];if(d){if(s&&!d.description){d.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return d}const m={id:h,description:s,defaults:i,deprecationMessage:u};this.b[h]=m;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),s&&(f.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const s=this.f[h];return s||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,m)=>d.id.localeCompare(m.id),i=d=>{for(;C.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(m=>!!m.description).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|${C.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of u.filter(m=>!C.ThemeIcon.isThemeIcon(m.defaults)).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|`);return s.join(`
`)}}const b=new p;A.$Gn.add(e.$vw.IconContribution,b);function r(c,h,i,s){return b.registerIcon(c,h,i,s)}e.$ww=r;function o(){return b}e.$xw=o;function t(){const c=(0,T.$9j)();for(const h in c){const i="\\"+c[h].toString(16);b.registerIcon(h,{fontCharacter:i})}}t(),e.$yw="vscode://schemas/icons";const n=A.$Gn.as(w.$Hn.JSONContribution);n.registerSchema(e.$yw,b.getIconSchema());const a=new E.$eh(()=>n.notifySchemaChanged(e.$yw),200);b.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$zw=r("widget-close",T.$$j.close,(0,g.localize)(2,null)),e.$Aw=r("goto-previous-location",T.$$j.arrowUp,(0,g.localize)(3,null)),e.$Bw=r("goto-next-location",T.$$j.arrowDown,(0,g.localize)(4,null)),e.$Cw=C.ThemeIcon.modify(T.$$j.sync,"spin"),e.$Dw=C.ThemeIcon.modify(T.$$j.loading,"spin")}),define(Pe[196],Re([1,0,5,41,4,14]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.ProvidedOnAutoForward=e.$Bv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Av=e.$zv=void 0,e.$zv=(0,C.$5h)("tunnelService"),e.$Av=(0,C.$5h)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})($||(e.TunnelPrivacyId=$={}));function g(o){return!!o.forwardPort}e.$Bv=g;var w;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$Cv=A,e.$Dv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(o){return e.$Dv.indexOf(o)>=0}e.$Ev=k,e.$Fv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(o){return e.$Fv.indexOf(o)>=0}e.$Gv=l;function p(o,t,n,a){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.$Hv=p;class b{constructor(t,n,a){this.remoteAddress=t,this.localAddress=n,this.b=a,this.a=new E.$Ud,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Iv=b;let r=class{constructor(t,n){this.k=t,this.l=n,this.a=new E.$Ud,this.onTunnelOpened=this.a.event,this.b=new E.$Ud,this.onTunnelClosed=this.b.event,this.c=new E.$Ud,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],n=Array.from(this.e.values());for(const a of n){const c=Array.from(a.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,a,c,h){this.q(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:a,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||k(t))&&(t=e.$Dv[0]);const a=this.s(t,n);if(a)return++a.refcount,a.value}openTunnel(t,n,a,c,h,i=!1,s,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${a} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(d,n,a,c,h,i,s,u);return m?m.then(f=>{if(f){if(typeof f=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,a),f}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const a=n.get(t.tunnelRemotePort);a&&(a.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async p(t,n,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const a=this.e.get(t);if(a&&a.has(n)){const c=a.get(n);c.refcount=0,await this.p(t,n,c)}}q(t,n,a){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:a})}async r(t,n){const a=this.e.get(t);if(a){const c=a.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&a.delete(n),a.size===0&&this.e.delete(t)}}s(t,n){const a=[t];k(t)?(a.push(...e.$Dv),a.push(...e.$Fv)):l(t)&&a.push(...e.$Fv);const c=a.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}u(t,n,a,c,h,i,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${a} on local port ${c}.`);const u=a;this.j.add(u);const d=c===void 0?a:c,m={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:a},localAddressPort:c,privacy:i,public:i?i!==$.Private:void 0,protocol:s},S=t.forwardPort(f,m);return S?(this.q(n,a,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),S}};e.$Jv=r,e.$Jv=r=Je([He(0,M.$mj),He(1,T.$yi)],r)}),define(Pe[197],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Kv=void 0,e.$Kv=(0,E.$5h)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[198],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$AK=T;function C(g){if(g.folders.length)return g.folders.every(w=>T(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$BK=C;function M(g){return C(g)?.scheme}e.$CK=M;function R(g){return C(g)?.authority}e.$DK=R;function $(g){return C(g)!==void 0}e.$EK=$}),define(Pe[47],Re([1,0,156,19,50,25,2,4,12]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.WorkbenchState=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0,e.$bi=(0,$.$5h)("contextService");function w(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.uri)}e.$ci=w;function A(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$di=A,e.$ei={id:"ext-dev"},e.$fi={id:"empty-window"};function k(d,m){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:m?e.$ei:e.$fi;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$gi=k;function l(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.configPath)}e.$hi=l;function p(d){const m=d;if(m?.uri)return{id:m.id,uri:R.URI.revive(m.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$ii=p;var b;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function r(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.$ji=r;function o(d){const m=d;return!!(m&&typeof m=="object"&&R.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.$ki=o;class t{constructor(m,f,S,L,v){this.h=m,this.j=S,this.k=L,this.l=v,this.c=C.$$h.forUris(this.l,()=>!0),this.folders=f}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=C.$$h.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$li=t;class n{constructor(m,f){this.raw=f,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.$Gg)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$mi=n;function a(d){return new n({uri:d,index:0,name:(0,M.$Cg)(d)},{uri:d.toString()})}e.$ni=a,e.$oi="code-workspace",e.$pi=`.${e.$oi}`,e.$qi=[{name:(0,E.localize)(0,null),extensions:[e.$oi]}],e.$ri="workspace.json";function c(d,m){return M.$xg.isEqualOrParent(d,m.untitledWorkspacesHome)}e.$si=c;function h(d){let m;return R.URI.isUri(d)?m=d:m=d.configuration,m?.scheme===g.Schemas.tmp}e.$ti=h,e.$ui="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$ui}e.$vi=i;function s(d,m){return!c(d,m)&&!h(d)}e.$wi=s;function u(d){return(typeof d=="string"?(0,T.$oc)(d):(0,M.$Eg)(d))===e.$pi}e.$xi=u}),define(Pe[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class E{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const M=this.c++;return this.b.set(M,C),this.e(),M}get(C,M){return this.b.has(C)?this.b.get(C)[M]:void 0}delete(C){this.b.delete(C),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Sfc=E}),define(Pe[43],Re([1,0,12,25,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$vg($=>{const g=this.b.get($.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos($,g){g===null?this.b.delete($.scheme):this.b.set($.scheme,g)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Vfc=M,e.$Wfc=(0,C.$5h)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0,e.$lN=(0,E.$5h)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,161,14,186,27]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;let R=class extends C.$sO{constructor(g,w,A){const k=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(k,{name:l}))}};e.$3hc=R,e.$3hc=R=Je([He(1,T.$nj),He(2,M.$lN)],R)}),define(Pe[200],Re([1,0,13]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=e.$Egc=void 0;class T{constructor(R,$,g){this.h=new Map,this.a=R,this.b=$,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$eh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const k of w.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let g=this.f[R];return typeof g>"u"&&(g=$),g}update(R,$){this.f[R]=$;const g=this.h.get(R);if(g!==void 0)return g.p;const w=new E.$ph;return this.h.set(R,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Egc=T;class C extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$Fgc=C}),define(Pe[201],Re([1,0,5,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class C{constructor(R){this.c=R,this.a=new E.$Ud,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Ud,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,g,w){const k=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged($.value,g,w);this.b.fire(k)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire($.apiNotebook)}}e.$shc=C}),define(Pe[17],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=e.$8M=void 0,e.$8M=(0,E.$5h)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$9M=T}),define(Pe[202],Re([1,0,22,5]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class C{#e;constructor(R,$){this.b=new T.$Ud,this.onDidChange=this.b.event,this.a=E.$km.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Mgc=C}),define(Pe[57],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=void 0,e.$cgc=(0,E.$5h)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$dgc=T}),define(Pe[203],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kb=e.$9kb=void 0;class T{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function C($,g){if(g.serializeBuffersForPostMessage){const w=new T,k=JSON.stringify($,(p,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b)};if(ArrayBuffer.isView(b)){const r=M(b);if(r)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b.buffer),view:{type:r,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),l=w.buffers.map(p=>{const b=new Uint8Array(p);return E.$ie.wrap(b)});return{message:k,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$9kb=C;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,g){const w=g.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=g.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const b=p,{index:r}=b,o=w[r];if(b.view)switch(b.view.type){case 1:return new Int8Array(o,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse($,A),arrayBuffers:w}}e.$0kb=R}),define(Pe[102],Re([1,0,170,16,2,6,4,30,42,12,40,134,31]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=e.$2E=e.EditorsOrder=e.$1E=e.CloseDirection=e.$ZE=e.$YE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.EditorInputCapabilities=e.$PE=e.SaveReason=e.Verbosity=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=void 0,e.$CE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$DE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$EE="workbench.editor.sidebysideEditor",e.$FE="workbench.editors.textDiffEditor",e.$GE="workbench.editors.binaryResourceDiffEditor";var p;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var b;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function r(ne){const Z=ne;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.$HE=r;function o(ne,Z,V){for(const ie of V.visibleEditorPanes)if(ie.group.id===Z&&ne.matches(ie.input))return ie.getViewState()}e.$IE=o;function t(ne){if(S(ne))return!1;const Z=ne;return C.URI.isUri(Z?.resource)}e.$JE=t;function n(ne){if(S(ne))return!1;const Z=ne;return Z?.original!==void 0&&Z.modified!==void 0}e.$KE=n;function a(ne){if(S(ne))return!1;const Z=ne;return!Z||Z.resources&&!Array.isArray(Z.resources)?!1:!!Z.resources||!!Z.multiDiffSource}e.$LE=a;function c(ne){if(S(ne)||n(ne))return!1;const Z=ne;return Z?.primary!==void 0&&Z.secondary!==void 0}e.$ME=c;function h(ne){if(S(ne))return!1;const Z=ne;return Z?Z.resource===void 0||Z.resource.scheme===w.Schemas.untitled||Z.forceUntitled===!0:!1}e.$NE=h;function i(ne){if(S(ne))return!1;const Z=ne;return C.URI.isUri(Z?.base?.resource)&&C.URI.isUri(Z?.input1?.resource)&&C.URI.isUri(Z?.input2?.resource)&&C.URI.isUri(Z?.result?.resource)}e.$OE=i;var s;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var u;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(Z,V){let ie=this.a.get(Z);return ie||(ie={source:Z,label:V},this.a.set(Z,ie)),ie.source}getSourceLabel(Z){return this.a.get(Z)?.label??Z}}e.$PE=new d;var m;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad",ne[ne.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(m||(e.EditorInputCapabilities=m={}));class f extends M.$Tc{}e.$QE=f;function S(ne){return ne instanceof f}e.$RE=S;function L(ne){const Z=ne;return C.URI.isUri(Z?.preferredResource)}function v(ne){const Z=ne;return S(Z?.primary)&&S(Z?.secondary)}e.$SE=v;function y(ne){const Z=ne;return S(Z?.modified)&&S(Z?.original)}e.$TE=y;function D(ne,Z,V,ie,Ie){return we(ie,[(0,k.$Oi)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Ae={...V,limits:{size:Number.MAX_VALUE}};ne.openEditor(Z,Ae)}}),(0,k.$Oi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$UE=D;function N(ne){return S(ne?.editor)}e.$VE=N;function O(ne){const Z=ne;return N(ne)&&Z?.group!==void 0}e.$WE=O;function G(ne){const Z=ne;return typeof Z?.groupId=="number"&&S(Z.editor)}e.$XE=G;var W;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var U;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_STICKY=11]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=12]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var P;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class I{getOriginalUri(Z,V){if(!Z)return;if(i(Z))return e.$ZE.getOriginalUri(Z.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(Z);if(Ie&&Ae){if(V?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme});Z=V.supportSideBySide===P.PRIMARY?Ie:Ae}}if(n(Z)||a(Z)||c(Z)||i(Z))return;const ie=L(Z)?Z.preferredResource:Z.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}a(Z){return v(Z)||c(Z)?{primary:Z.primary,secondary:Z.secondary}:y(Z)||n(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,V){if(!Z)return;if(i(Z))return e.$ZE.getCanonicalUri(Z.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(Z);if(Ie&&Ae){if(V?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme});Z=V.supportSideBySide===P.PRIMARY?Ie:Ae}}if(n(Z)||a(Z)||c(Z)||i(Z))return;const ie=Z.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}b(Z,V){if(Array.isArray(V)){if(V.some(ie=>Z.scheme===ie))return Z}else if(V===Z.scheme)return Z}}var K;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(K||(e.EditorCloseMethod=K={}));function ae(ne,Z,V,ie){if(!ne.isSticky(Z))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return V===K.MOUSE||V===K.KEYBOARD;case"mouse":return V===K.MOUSE;case"keyboard":return V===K.KEYBOARD}return!1}e.$YE=ae,e.$ZE=new I;var he;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(he||(e.CloseDirection=he={}));class be{constructor(){this.c=new Map,this.d=new Map}start(Z){const V=this.a=Z.get(R.$4h);for(const[ie,Ie]of this.c)this.e(ie,Ie,V);this.c.clear()}e(Z,V,ie){const Ie=ie.createInstance(V);this.d.set(Z,Ie)}registerFileEditorFactory(Z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Z}getFileEditorFactory(){return(0,T.$Sf)(this.b)}registerEditorSerializer(Z,V){if(this.c.has(Z)||this.d.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.a?this.e(Z,V,this.a):this.c.set(Z,V),(0,M.$Rc)(()=>{this.c.delete(Z),this.d.delete(Z)})}getEditorSerializer(Z){return this.d.get(typeof Z=="string"?Z:Z.typeId)}}$.$Gn.add(e.$CE.EditorFactory,new be);async function De(ne,Z,V){return!ne||!ne.length?[]:await Promise.all(ne.map(async ie=>{const Ie=C.URI.revive(ie.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ie);return}if(!await Z.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ie);return}let Ce=ie.exists,ce=ie.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await Z.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ce=!0}catch(Q){V.error(Q),Ce=!1}if(!Ce&&ie.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ie);return}if(ce===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ie);return}const te={...ie.options,pinned:!0};return Ce?{resource:Ie,options:te}:{resource:Ie,options:te,forceUntitled:!0}}))}e.$1E=De;var le;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function ve(ne){const Z=ne;if(!Z)return!1;const V=Z;if(V.modified)return ve(V.modified);const ie=Z;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$2E=ve;function se(ne){return(0,A.$Qi)(ne)}e.$3E=se;function we(ne,Z,V){const ie=(0,A.$Ri)(ne,Z);return ie.forceMessage=V?.forceMessage,ie.forceSeverity=V?.forceSeverity,ie.allowDialog=V?.allowDialog,ie}e.$4E=we}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.$$E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$0E=e.ViewContentGroups=e.$9E=e.$8E=e.ViewContainerLocation=e.Extensions=e.$7E=e.$6E=e.$5E=void 0,e.$5E="views",e.$6E=(0,T.localize)(0,null),e.$7E=(0,k.$ww)("default-view-icon",A.$$j.window,(0,T.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$8E=[0,1,2];function b(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$9E=b;class r extends M.$Tc{constructor(){super(...arguments),this.c=this.B(new E.$Ud),this.onDidRegister=this.c.event,this.f=this.B(new E.$Ud),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,m){const f=this.get(u.id);if(f)return f;const S=u;return S.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,d,[]).push(S),m?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(u){for(const d of this.g.keys()){const m=this.g.get(d),f=m?.indexOf(u);if(f!==-1){m?.splice(f,1),m.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}$.$Gn.add(l.ViewContainersRegistry,new r);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(s,u){const d=s.group??o.More,m=u.group??o.More;return d!==m?d.localeCompare(m):(s.order??5)-(u.order??5)}class n extends M.$Tc{constructor(){super(...arguments),this.c=this.B(new E.$Ud),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Ud),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Ud),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Ud),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:m})=>this.r(d,m)),this.c.fire(u)}deregisterViews(u,d){const m=this.s(u,d);m.length&&this.f.fire({views:m,viewContainer:d})}moveViews(u,d){for(const m of this.m.keys())if(m!==d){const f=this.s(u,m);f.length&&(this.r(f,d),this.g.fire({views:f,from:m,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const m=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,M.$Rc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const m=new Map;for(const[f,S]of d)this.n.add(u,S),m.set(f,(0,M.$Rc)(()=>{this.n.delete(u,S),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,m=>d.push(m)),d.sort(t)}r(u,d){let m=this.m.get(d);m||(m=[],this.m.set(d,m),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));m.push(f)}}s(u,d){const m=this.m.get(d);if(!m)return[];const f=[],S=[];for(const L of m)u.includes(L)?f.push(L):S.push(L);return f.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}$.$Gn.add(l.ViewsRegistry,new n),e.$0E=(0,C.$5h)("viewDescriptorService");var a;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$xn)(this,u),this.d=!!d,this.resolve=async m=>{if(d&&!this.c){const f=await d(m);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$$E=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$_E=i}),define(Pe[205],Re([1,0,2,29,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$3F=e.$2F=void 0;function M(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$Ts.isIRange)}e.$2F=M;function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(M)}e.$3F=R;var $;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.ChatAgentCopyKind=g={})),e.$4F=(0,C.$5h)("IChatService")}),define(Pe[206],Re([1,0,5,13,172]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Ud,this.n=new E.$Ud,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,g,w,A){const k={command:$};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.s("request",k),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const b={type:"response",seq:0,request_seq:k.seq,success:!1,command:$,message:(0,C.localize)(0,null,A,$)};p(b)}},A)}return w&&this.f.set(k.seq,w),k.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,g){return $.type!=="event"||g.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$6g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const g=$,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s($,g){g.type=$,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((g,w)=>$.set(w,g)),await(0,T.$6g)(500),$.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Clb=M}),define(Pe[207],Re([1,0,173,35,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$MH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$LH=e.MemoryRangeType=e.$KH=e.State=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=void 0,e.$HG="workbench.view.debug",e.$IG="workbench.debug.variablesView",e.$JG="workbench.debug.watchExpressionsView",e.$KG="workbench.debug.callStackView",e.$LG="workbench.debug.loadedScriptsView",e.$MG="workbench.debug.breakPointsView",e.$NG="workbench.debug.disassemblyView",e.$OG="workbench.panel.repl",e.$PG="workbench.panel.repl.view",e.$QG=new T.$jj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$RG=new T.$jj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$SG=new T.$jj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$TG="debugUx",e.$UG=new T.$jj(e.$TG,"default",{type:"string",description:E.localize(3,null)}),e.$VG=new T.$jj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$WG=new T.$jj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$XG=new T.$jj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$YG=new T.$jj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$ZG=new T.$jj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$1G=new T.$jj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$2G=new T.$jj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$3G=new T.$jj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$4G=new T.$jj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$5G=new T.$jj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$6G=new T.$jj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$7G=new T.$jj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$8G=new T.$jj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$9G=new T.$jj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$0G=new T.$jj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$$G=new T.$jj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$_G=new T.$jj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$aH=new T.$jj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$bH=new T.$jj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$cH=new T.$jj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$dH=new T.$jj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$eH=new T.$jj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$fH=new T.$jj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$gH=new T.$jj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$hH=new T.$jj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$iH=new T.$jj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$jH=new T.$jj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$kH=new T.$jj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$lH=new T.$jj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$mH=new T.$jj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$nH=new T.$jj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$oH=new T.$jj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$pH=new T.$jj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$qH=new T.$jj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$rH=new T.$jj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$sH=new T.$jj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$tH=new T.$jj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$uH=new T.$jj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$vH=new T.$jj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$wH=new T.$jj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$xH=new T.$jj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$yH=new T.$jj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$zH=new T.$jj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$AH=new T.$jj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$BH=new T.$jj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$CH=new T.$jj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$DH=new T.$jj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$EH=new T.$jj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=l=>E.localize(52,null,l);e.$FH=M,e.$GH="editor.contrib.debug",e.$HH="editor.contrib.breakpoint",e.$IH="debug",e.$JH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(R||(e.State=R={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$KH=$;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$LH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$MH=(0,C.$5h)("debugService");var k;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE",l[l.TRIGGER_POINT=3]="TRIGGER_POINT"})(k||(e.BreakpointWidgetContext=k={}))}),define(Pe[208],Re([1,0,11,2,19,26,12,29,20,18]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=void 0;const A=/{([^}]+)}/g;function k(L,v,y){return L.replace(A,function(D,N){return v&&N.length>0&&N[0]!=="_"?D:y&&y.hasOwnProperty(N)?y[N]:D})}e.$9F=k;function l(L){const v={};for(const y of Object.keys(L))y.startsWith("!")||(v[y]=L[y]);return v}e.$0F=l;function p(L){return L.configuration.request==="attach"&&!b(L)&&(!L.parentSession||p(L.parentSession))}e.$$F=p;function b(L){let v=L.configuration.type;if(v)return v==="vslsShare"&&(v=L.configuration.adapterProxy.configuration.type),(0,E.$$e)(v,"extensionhost")||(0,E.$$e)(v,"pwa-extensionhost")?L:L.parentSession?b(L.parentSession):void 0}e.$_F=b;function r(L){return L.type&&(L.label||L.program||L.runtime)}e.$aG=r;function o(L,v,y){let D,N=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=O.exec(L);){const W=G.index+1,U=W+G[0].length;if(W<=v&&U>=y){D=G[0],N=W;break}}if(D){const W=/\w+/g;let U=null;for(;(U=W.exec(D))&&!(U.index+1+N+U[0].length>=y););U&&(D=D.substring(0,W.lastIndex))}return D?{start:N,end:N+D.length-1}:{start:0,end:0}}e.$bG=o;async function t(L,v,y,D){if(L.evaluatableExpressionProvider.has(v)){const N=L.evaluatableExpressionProvider.ordered(v),O=(0,w.$Hb)(await Promise.all(N.map(async G=>{try{return await G.provideEvaluatableExpression(v,y,D??g.CancellationToken.None)}catch{return}})));if(O.length>0){let G=O[0].expression;const W=O[0].range;return G||(G=v.getLineContent(y.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:G}}}else{const N=v.getLineContent(y.lineNumber),{start:O,end:G}=o(N,y.column,y.column),W=N.substring(O-1,G);return{matchingExpression:W,range:new $.$Ts(y.lineNumber,O,y.lineNumber,O+W.length)}}return null}e.$cG=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(L){return!!(L&&L.match(n))}e.$dG=a;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(a(L.path))return T.URI.parse(L.path);if((0,C.$ic)(L.path))return T.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const v=T.URI.revive(L.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return L.path}function i(L,v){const y=v?c:h,D=(0,M.$un)(L);return u(D,(N,O)=>{N&&O&&(O.path=y(O))}),D}e.$eG=i;function s(L,v){const y=v?c:h,D=(0,M.$un)(L);return u(D,(N,O)=>{!N&&O&&(O.path=y(O))}),D}e.$fG=s;function u(L,v){switch(L.type){case"event":{const y=L;switch(y.event){case"output":v(!1,y.body.source);break;case"loadedSource":v(!1,y.body.source);break;case"breakpoint":v(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=L;switch(y.command){case"setBreakpoints":v(!0,y.arguments.source);break;case"breakpointLocations":v(!0,y.arguments.source);break;case"source":v(!0,y.arguments.source);break;case"gotoTargets":v(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>v(!1,D));break;default:break}break}case"response":{const y=L;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>v(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>v(!1,D));break;case"scopes":y.body.scopes.forEach(D=>v(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>v(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>v(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(N=>v(!1,N.location));break;default:break}break}}}function d(L){return L.filter(v=>!v.presentation?.hidden).sort((v,y)=>v.presentation?y.presentation?v.presentation.group?y.presentation.group?v.presentation.group!==y.presentation.group?v.presentation.group.localeCompare(y.presentation.group):m(v.presentation.order,y.presentation.order):-1:y.presentation.group?1:m(v.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$gG=d;function m(L,v){return typeof L!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:L-v}async function f(L,v){const y=L.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(y!=="none"&&(await v.saveAll(),y==="allEditorsInActiveGroup")){const D=v.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:D.input,groupId:D.group.id})}await L.reloadConfiguration()}e.$hG=f;const S=(L,v)=>!L||!v?L===v:L.name===v.name&&L.path===v.path&&L.sourceReference===v.sourceReference;e.$iG=S}),define(Pe[76],Re([1,0,24,34,67,68,12,19,21,35]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=e.$9I=e.$8I=e.$7I=e.CellStatusbarAlignment=e.$6I=e.$5I=e.$4I=e.NotebookEditorPriority=e.$3I=e.$2I=e.$1I=e.$ZI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$YI=e.$XI=e.$WI=e.$VI=e.CellKind=e.$UI=e.$TI=e.$SI=void 0,e.$SI="workbench.editor.notebook",e.$TI="workbench.editor.notebookTextDiffEditor",e.$UI="workbench.editor.interactive";var A;(function(I){I[I.Markup=1]="Markup",I[I.Code=2]="Code"})(A||(e.CellKind=A={})),e.$VI=["application/json","application/javascript","text/html","image/svg+xml",M.$es.latex,M.$es.markdown,"image/png","image/jpeg",M.$es.text],e.$WI=[M.$es.latex,M.$es.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$es.text],e.$XI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$YI="_notAvailable";var k;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var l;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var b;(function(I){I[I.WithHardKernelDependency=0]="WithHardKernelDependency",I[I.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",I[I.Pure=2]="Pure",I[I.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var r;(function(I){I.Always="always",I.Never="never",I.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var o;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.ChangeCellLanguage=5]="ChangeCellLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",I[I.ChangeCellMime=13]="ChangeCellMime",I[I.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.Move=6]="Move",I[I.OutputItems=7]="OutputItems",I[I.PartialMetadata=8]="PartialMetadata",I[I.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var a;(function(I){I.scheme=R.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${K.join("")}]+`),he=7;function be(ne,Z){const V=Z.toString(he),Ie=`${V.length<K.length?K[V.length-1]:"z"}${V}s${(0,E.$Ce)(E.$ie.fromString(ne.scheme),!0,!0)}`;return ne.with({scheme:I.scheme,fragment:Ie})}I.generate=be;function De(ne){if(ne.scheme!==I.scheme)return;const Z=ne.fragment.indexOf("s");if(Z<0)return;const V=parseInt(ne.fragment.substring(0,Z).replace(ae,""),he),ie=(0,E.$Be)(ne.fragment.substring(Z+1)).toString();if(!isNaN(V))return{handle:V,notebook:ne.with({scheme:ie,fragment:null})}}I.parse=De;function le(ne,Z){return ne.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${ne.scheme!==R.Schemas.file?ne.scheme:""}`})}I.generateCellOutputUri=le;function ve(ne){if(ne.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!Z)return;const V=Z[1]&&Z[1]!==""?Z[1]:void 0,ie=Z[2];return{outputId:V,notebook:ne.with({scheme:ie||R.Schemas.file,fragment:null})}}I.parseCellOutputUri=ve;function se(ne,Z,V){return I.generate(ne,Z).with({scheme:V})}I.generateCellPropertyUri=se;function we(ne,Z){if(ne.scheme===Z)return I.parse(ne.with({scheme:I.scheme}))}I.parseCellPropertyUri=we})(a||(e.CellUri=a={}));const c=I=>g.$i?I.replace(/\//g,"\\"):I;class h{constructor(K=[],ae=e.$VI){this.e=ae,this.d=[...new Set(K)].map(he=>({pattern:he,matches:T.$Lj(c(he))}))}sort(K){const ae=new Map(C.Iterable.map(K,be=>[be,c(be)]));let he=[];for(const{matches:be}of this.d)for(const[De,le]of ae)if(be(le)){he.push(De),ae.delete(De);break}return ae.size&&(he=he.concat([...ae.keys()].sort((be,De)=>this.e.indexOf(be)-this.e.indexOf(De)))),he}prioritize(K,ae){const he=this.f(K);if(he===-1){this.d.unshift({pattern:K,matches:T.$Lj(c(K))});return}const be=new Set(ae.map(le=>this.f(le,he)));be.delete(-1);const De=Array.from(be).sort();this.d.splice(he+1,0,...De.map(le=>this.d[le]));for(let le=De.length-1;le>=0;le--)this.d.splice(De[le],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,ae=this.d.length){const he=c(K);for(let be=0;be<ae;be++)if(this.d[be].matches(he))return be;return-1}}e.$ZI=h;function i(I,K,ae,he=(be,De)=>be===De){const be=[];function De(se,we,ne){if(we===0&&ne.length===0)return;const Z=be[be.length-1];Z&&Z.start+Z.deleteCount===se?(Z.deleteCount+=we,Z.toInsert.push(...ne)):be.push({start:se,deleteCount:we,toInsert:ne})}let le=0,ve=0;for(;;){if(le===I.length){De(le,0,K.slice(ve));break}if(ve===K.length){De(le,I.length-le,[]);break}const se=I[le],we=K[ve];if(he(se,we)){le+=1,ve+=1;continue}ae(we)?(De(le,1,[]),le+=1):(De(le,0,[we]),ve+=1)}return be}e.$1I=i,e.$2I=new w.$jj("notebookEditorCursorAtBoundary","none"),e.$3I=new w.$jj("notebookEditorCursorAtLineBoundary","none");var s;(function(I){I.default="default",I.option="option"})(s||(e.NotebookEditorPriority=s={}));function u(I){const K=I;return!!((typeof K.include=="string"||T.$Mj(K.include))&&(typeof K.exclude=="string"||T.$Mj(K.exclude)))}e.$4I=u;function d(I,K,ae){if(Array.isArray(I.viewType)&&I.viewType.indexOf(K)>=0||I.viewType===K)return!0;if(I.filenamePattern){const he=u(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,be=u(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(T.$Kj(he,(0,$.$nc)(ae.fsPath).toLowerCase()))return!(be&&T.$Kj(be,(0,$.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$5I=d,e.$6I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var m;(function(I){I[I.Left=1]="Left",I[I.Right=2]="Right"})(m||(e.CellStatusbarAlignment=m={}));class f{static{this.d="notebook/"}static create(K){return`${f.d}${K}`}static parse(K){if(K.startsWith(f.d))return K.substring(f.d.length)}}e.$7I=f;function S(I){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(I)}e.$8I=S;const L=new TextDecoder;function v(I){const K=[];let ae=!1;for(const le of I)(K.length===0||ae)&&(K.push(le),ae=!0);let he=N(K);const be=E.$ie.concat(K.map(le=>E.$ie.wrap(le))),De=P(be);return he=he||De.byteLength!==be.byteLength,{data:De,didCompression:he}}e.$9I=v,e.$0I=`${String.fromCharCode(27)}[A`;const y=e.$0I.split("").map(I=>I.charCodeAt(0)),D=10;function N(I){let K=!1;return I.forEach((ae,he)=>{if(he===0||ae.length<e.$0I.length)return;const be=I[he-1],De=ae.subarray(0,e.$0I.length);if(De[0]===y[0]&&De[1]===y[1]&&De[2]===y[2]){const le=be.lastIndexOf(D);if(le===-1)return;K=!0,I[he-1]=be.subarray(0,le),I[he]=ae.subarray(e.$0I.length)}}),K}function O(I){let K=I;do I=K,K=I.replace(/[^\n]\x08/gm,"");while(K.length<I.length);return I}function G(I){for(I=I.replace(/\r+\n/gm,`
`);I.search(/\r[^$]/g)>-1;){const K=I.match(/^(.*)\r+/m)[1];let ae=I.match(/\r+(.*)$/m)[1];ae=ae+K.slice(ae.length,K.length),I=I.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return I}const W="\b".charCodeAt(0),U="\r".charCodeAt(0);function P(I){return!I.buffer.includes(W)&&!I.buffer.includes(U)?I:E.$ie.fromString(G(O(L.decode(I.buffer))))}}),define(Pe[7],Re([1,0,18,15,52,28,68,11,16,2,33,22,42,100,76]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b){"use strict";var r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$WM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$VM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.TestRunProfileKind=e.TestResultState=e.$BM=e.$AM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$zM=e.NotebookVariablesRequestKind=e.$yM=e.$xM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$wM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.ColorThemeKind=e.$qM=e.$pM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$oM=e.DebugConsoleMode=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$iM=e.$hM=e.FileChangeType=e.$gM=e.$fM=e.$eM=e.$dM=e.InlineCompletionTriggerKind=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.ConfigurationTarget=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$SL=e.ViewBadge=e.ProgressLocation=e.$RL=e.$QL=e.TaskScope=e.ShellQuoting=e.$PL=e.$OL=e.$NL=e.TaskPanelKind=e.TaskRevealKind=e.$ML=e.TerminalLocation=e.$LL=e.$KL=e.$JL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$IL=e.$HL=e.$GL=e.$FL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$EL=e.StatusBarAlignment=e.ViewColumn=e.$DL=e.$CL=e.$BL=e.$AL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$zL=e.$yL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.LanguageStatusSeverity=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.CodeActionTriggerKind=e.$mL=e.$lL=e.SymbolTag=e.SymbolKind=e.$kL=e.$jL=e.DocumentHighlightKind=e.$iL=e.$hL=e.$gL=e.$fL=e.DiagnosticSeverity=e.DiagnosticTag=e.$eL=e.$dL=e.FileEditType=e.$cL=e.$bL=e.$aL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const ke=oe.length===1?[]:oe[1];return Reflect.construct(B,ke,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[ke,...Ge]=oe;return Reflect.construct(B,Ge,ke.constructor)}}})}var N;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let G=r=class{static from(...j){let oe=j;return new r(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$6K=G,e.$6K=G=r=Je([D],G);let W=o=class{static Min(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let ke=1;ke<j.length;ke++){const Ge=j[ke];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let ke=1;ke<j.length;ke++){const Ge=j[ke];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(j){if(!j)return!1;if(j instanceof o)return!0;const{line:oe,character:ke}=j;return typeof oe=="number"&&typeof ke=="number"}static of(j){if(j instanceof o)return j;if(this.isPosition(j))return new o(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("line must be non-negative");if(oe<0)throw(0,T.$7)("character must be non-negative");this.c=j,this.e=oe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,oe=0){if(j===null||oe===null)throw(0,T.$7)();let ke;return typeof j>"u"?ke=0:typeof j=="number"?ke=j:(ke=typeof j.lineDelta=="number"?j.lineDelta:0,oe=typeof j.characterDelta=="number"?j.characterDelta:0),ke===0&&oe===0?this:new o(this.line+ke,this.character+oe)}with(j,oe=this.character){if(j===null||oe===null)throw(0,T.$7)();let ke;return typeof j>"u"?ke=this.line:typeof j=="number"?ke=j:(ke=typeof j.line=="number"?j.line:this.line,oe=typeof j.character=="number"?j.character:this.character),ke===this.line&&oe===this.character?this:new o(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$7K=W,e.$7K=W=o=Je([D],W);let U=t=class{static isRange(j){return j instanceof t?!0:j?W.isPosition(j.start)&&W.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,oe,ke,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new W(j,oe),ut=new W(ke,Ge)):W.isPosition(j)&&W.isPosition(oe)&&(xe=W.of(j),ut=W.of(oe)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):W.isPosition(j)?!(W.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const oe=W.Max(j.start,this.c),ke=W.Min(j.end,this.e);if(!oe.isAfter(ke))return new t(oe,ke)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const oe=W.Min(j.start,this.c),ke=W.Max(j.end,this.end);return new t(oe,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,oe=this.end){if(j===null||oe===null)throw(0,T.$7)();let ke;return j?W.isPosition(j)?ke=j:(ke=j.start||this.start,oe=j.end||this.end):ke=this.start,ke.isEqual(this.c)&&oe.isEqual(this.end)?this:new t(ke,oe)}toJSON(){return[this.start,this.end]}};e.$8K=U,e.$8K=U=t=Je([D],U);let P=n=class extends U{static isSelection(j){return j instanceof n?!0:j?U.isRange(j)&&W.isPosition(j.anchor)&&W.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,oe,ke,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new W(j,oe),ut=new W(ke,Ge)):W.isPosition(j)&&W.isPosition(oe)&&(xe=W.of(j),ut=W.of(oe)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$9K=P,e.$9K=P=n=Je([D],P);const I=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class K{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe,ke){if(typeof j!="string"||j.length===0)throw(0,T.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$7)("port");typeof ke<"u"&&I(ke),this.host=j,this.port=Math.round(oe),this.connectionToken=ke}}e.$0K=K;class ae{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe){this.makeConnection=j,this.connectionToken=oe,typeof oe<"u"&&I(oe)}}e.$$K=ae;class he extends Error{static NotAvailable(j,oe){return new he(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(j){return new he(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,oe=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(j),this._message=j,this._code=oe,this._detail=ke,Object.setPrototypeOf(this,he.prototype)}}e.$_K=he;var be;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(be||(e.EndOfLine=be={}));var De;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let le=a=class{static isTextEdit(j){return j instanceof a?!0:j?U.isRange(j)&&typeof j.newText=="string":!1}static replace(j,oe){return new a(j,oe)}static insert(j,oe){return a.replace(new U(j,j),oe)}static delete(j){return a.replace(j,"")}static setEndOfLine(j){const oe=new a(new U(new W(0,0),new W(0,0)),"");return oe.newEol=j,oe}get range(){return this.c}set range(j){if(j&&!U.isRange(j))throw(0,T.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,T.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,T.$7)("newEol");this.f=j}constructor(j,oe){this.c=j,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$aL=le,e.$aL=le=a=Je([D],le);let ve=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?ei.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,oe){return new c(j,oe)}static insertCells(j,oe){return new c(new ei(j,j),oe)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,oe){const ke=new c(new ei(j,j),[]);return ke.newCellMetadata=oe,ke}static updateNotebookMetadata(j){const oe=new c(new ei(0,0),[]);return oe.newNotebookMetadata=j,oe}constructor(j,oe){this.range=j,this.newCells=oe}};e.$bL=ve,e.$bL=ve=c=Je([D],ve);class se{static isSnippetTextEdit(j){return j instanceof se?!0:j?U.isRange(j.range)&&Z.isSnippetString(j.snippet):!1}static replace(j,oe){return new se(j,oe)}static insert(j,oe){return se.replace(new U(j,j),oe)}constructor(j,oe){this.range=j,this.snippet=oe}}e.$cL=se;var we;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,oe,ke,Ge){this.c.push({_type:1,from:j,to:oe,options:ke,metadata:Ge})}createFile(j,oe,ke){this.c.push({_type:1,from:void 0,to:j,options:oe,metadata:ke})}deleteFile(j,oe,ke){this.c.push({_type:1,from:j,to:void 0,options:oe,metadata:ke})}e(j,oe,ke){this.c.push({_type:3,metadata:ke,uri:j,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(j,oe,ke,Ge){const xe=oe.start,ut=oe.end;(xe!==ut||ke.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:ut-xe,cells:ke,metadata:Ge})}g(j,oe,ke,Ge){this.c.push({_type:3,metadata:Ge,uri:j,edit:{editType:3,index:oe,metadata:ke}})}replace(j,oe,ke,Ge){this.c.push({_type:2,uri:j,edit:new le(oe,ke),metadata:Ge})}insert(j,oe,ke,Ge){this.replace(j,new U(oe,oe),ke,Ge)}delete(j,oe,ke){this.replace(j,oe,"",ke)}has(j){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===j.toString())}set(j,oe){if(oe)for(const ke of oe){if(!ke)continue;let Ge,xe;Array.isArray(ke)?(Ge=ke[0],xe=ke[1]):Ge=ke,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(j,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(j,Ge.newNotebookMetadata,xe):this.f(j,Ge.range,Ge.newCells,xe):se.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:j,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Ge,metadata:xe})}else{for(let ke=0;ke<this.c.length;ke++){const Ge=this.c[ke];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===j.toString()&&(this.c[ke]=void 0);break}}(0,E.$Ib)(this.c)}}get(j){const oe=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===j.toString()&&oe.push(ke.edit);return oe}entries(){const j=new M.$Ac;for(const oe of this.c)if(oe._type===2){let ke=j.get(oe.uri);ke||(ke=[oe.uri,[]],j.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$dL=ne,e.$dL=ne=Je([D],ne);let Z=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,oe=this.e++){if(typeof j=="function"){const ke=new h;ke.e=this.e,j(ke),this.e=ke.e,j=ke.value}else j=h.c(j);return this.value+="${",this.value+=oe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,oe=this.e++){const ke=j.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(j,oe){if(typeof oe=="function"){const ke=new h;ke.e=this.e,oe(ke),this.e=ke.e,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$eL=Z,e.$eL=Z=h=Je([D],Z);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ie;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let Ie=i=class{static isLocation(j){return j instanceof i?!0:j?U.isRange(j.range)&&w.URI.isUri(j.uri):!1}constructor(j,oe){if(this.uri=j,oe)if(U.isRange(oe))this.range=U.of(oe);else if(W.isPosition(oe))this.range=new U(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$fL=Ie,e.$fL=Ie=i=Je([D],Ie);let Ae=class{static is(j){return j?typeof j.message=="string"&&j.location&&U.isRange(j.location.range)&&w.URI.isUri(j.location.uri):!1}constructor(j,oe){this.location=j,this.message=oe}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.location.range.isEqual(oe.location.range)&&j.location.uri.toString()===oe.location.uri.toString()}};e.$gL=Ae,e.$gL=Ae=Je([D],Ae);let Ce=class{constructor(j,oe,ke=ie.Error){if(!U.isRange(j))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=j,this.message=oe,this.severity=ke}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.severity===oe.severity&&j.code===oe.code&&j.severity===oe.severity&&j.source===oe.source&&j.range.isEqual(oe.range)&&(0,E.$ub)(j.tags,oe.tags)&&(0,E.$ub)(j.relatedInformation,oe.relatedInformation,Ae.isEqual)}};e.$hL=Ce,e.$hL=Ce=Je([D],Ce);let ce=class{constructor(j,oe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=oe}};e.$iL=ce,e.$iL=ce=Je([D],ce);var te;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let Q=class{constructor(j,oe=te.Text){this.range=j,this.kind=oe}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$jL=Q,e.$jL=Q=Je([D],Q);let ee=class{constructor(j,oe){this.uri=j,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$kL=ee,e.$kL=ee=Je([D],ee);var me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var pe;(function(B){B[B.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Le=s=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,oe,ke,Ge,xe){this.name=j,this.kind=oe,this.containerName=xe,typeof ke=="string"&&(this.containerName=ke),Ge instanceof Ie?this.location=Ge:ke instanceof U&&(this.location=new Ie(Ge,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$lL=Le,e.$lL=Le=s=Je([D],Le);let de=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,oe,ke,Ge,xe){this.name=j,this.detail=oe,this.kind=ke,this.range=Ge,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$mL=de,e.$mL=de=u=Je([D],de);var ye;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ye||(e.CodeActionTriggerKind=ye={}));let F=class{constructor(j,oe){this.title=j,this.kind=oe}};e.$nL=F,e.$nL=F=Je([D],F);let q=class{static{d=this}static{this.c="."}constructor(j){this.value=j}append(j){return new d(this.value?this.value+d.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+d.c)}};e.$oL=q,e.$oL=q=d=Je([D],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let H=class{constructor(j,oe){if(this.range=j,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$pL=H,e.$pL=H=Je([D],H);class z{constructor(j,oe,ke,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$qL=z;class X{constructor(j,oe){this.fromRanges=oe,this.from=j}}e.$rL=X;class x{constructor(j,oe){this.fromRanges=oe,this.to=j}}e.$sL=x;var Ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let Te=class{constructor(j,oe){this.range=j,this.command=oe}get isResolved(){return!!this.command}};e.$tL=Te,e.$tL=Te=Je([D],Te);let Ve=m=class{#e;static isMarkdownString(j){return j instanceof m?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,oe=!1){this.#e=new C.$gk(j,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,oe){return this.#e.appendCodeblock(oe??"",j),this}};e.$uL=Ve,e.$uL=Ve=m=Je([D],Ve);let Ke=class{constructor(j,oe){this.label=j,this.documentation=oe}};e.$vL=Ke,e.$vL=Ke=Je([D],Ke);let Ze=class{constructor(j,oe){this.label=j,this.documentation=oe,this.parameters=[]}};e.$wL=Ze,e.$wL=Ze=Je([D],Ze);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$xL=st,e.$xL=st=Je([D],st);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let at=class{constructor(j){this.value=j}};e.$yL=at,e.$yL=at=Je([D],at);let ct=class{constructor(j,oe,ke){this.position=j,this.label=oe,this.kind=ke}};e.$zL=ct,e.$zL=ct=Je([D],ct);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Y;(function(B){B[B.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let _=class{constructor(j,oe){this.label=j,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$AL=_,e.$AL=_=Je([D],_);let $e=class{constructor(j=[],oe=!1){this.items=j,this.isIncomplete=oe}};e.$BL=$e,e.$BL=$e=Je([D],$e);let Be=class{constructor(j,oe,ke){this.insertText=j,this.range=oe,this.command=ke}};e.$CL=Be,e.$CL=Be=Je([D],Be);let Qe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$DL=Qe,e.$DL=Qe=Je([D],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Ne(B,j){return`${k.$km.toKey(B)}.${j}`}e.$EL=Ne;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Kt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var Bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Ht;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(B){function j(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Nt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Nt||(e.SyntaxTokenType=Nt={})),function(B){function j(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Nt||(e.SyntaxTokenType=Nt={}));let Xt=class{constructor(j,oe){if(oe&&!w.URI.isUri(oe))throw(0,T.$7)("target");if(!U.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.target=oe}};e.$FL=Xt,e.$FL=Xt=Je([D],Xt);let Ut=class{constructor(j,oe,ke,Ge){this.red=j,this.green=oe,this.blue=ke,this.alpha=Ge}};e.$GL=Ut,e.$GL=Ut=Je([D],Ut);let Rt=class{constructor(j,oe){if(oe&&!(oe instanceof Ut))throw(0,T.$7)("color");if(!U.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.color=oe}};e.$HL=Rt,e.$HL=Rt=Je([D],Rt);let Ye=class{constructor(j){if(!j||typeof j!="string")throw(0,T.$7)("label");this.label=j}};e.$IL=Ye,e.$IL=Ye=Je([D],Ye);var Gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(j,oe,ke){if(this.startIndex=j,this.length=oe,this.tooltip=ke,typeof j!="number"||j<0)throw(0,T.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,T.$7)("tooltip")}}e.$JL=$t;class jt{constructor(j){this.uri=j}}e.$KL=jt;class Vt{constructor(j){this.terminalCommand=j}}e.$LL=Vt;var Dt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class dt{constructor(j){if(this.options=j,typeof j!="object")throw(0,T.$7)("options")}}e.$ML=dt;var Ct;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let kt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(j){switch(j){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(j,oe){if(this.label=oe,typeof j!="string"||typeof oe!="string")throw(0,T.$7)("name");this.c=j}get id(){return this.c}};e.$NL=kt,e.$NL=kt=f=Je([D],kt);function qe(B){let j="";for(let oe=0;oe<B.length;oe++)j+=B[oe].replace(/,/g,",,")+",";return j}let Mt=class{constructor(j,oe,ke){if(typeof j!="string")throw(0,T.$7)("process");this.e=[],this.c=j,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ke):this.f=oe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,T.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)j.push(oe);return qe(j)}};e.$OL=Mt,e.$OL=Mt=Je([D],Mt);let Wt=class{constructor(j,oe,ke){if(this.f=[],Array.isArray(oe)){if(!j)throw(0,T.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j,this.f=oe,this.g=ke}else{if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j,this.g=oe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)j.push(typeof oe=="string"?oe:oe.value);return qe(j)}};e.$PL=Wt,e.$PL=Wt=Je([D],Wt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Ft{constructor(j){this.c=j}computeId(){return"customExecution"+(0,A.$pg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$QL=Ft;let Se=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,oe,ke,Ge,xe,ut){this.k=!1,this.l=this.definition=j;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=ke,this.execution=Ge,gt=xe,this.k=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.n=this.name=ke,this.u=this.source=Ge,this.execution=xe,gt=ut):(this.target=oe,this.n=this.name=ke,this.u=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Ft?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,A.$pg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,T.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const oe=this.l.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$RL=Se,e.$RL=Se=S=Je([D],Se);var Fe;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var fe;(function(B){function j(oe){const ke=oe;return(0,g.$Lf)(ke.value)?ke.tooltip&&!(0,g.$Hf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}B.isViewBadge=j})(fe||(e.ViewBadge=fe={}));let J=L=class{static isTreeItem(j,oe){const ke=j;if(ke.checkboxState!==void 0){const Ge=(0,g.$Lf)(ke.checkboxState)?ke.checkboxState:(0,g.$Jf)(ke.checkboxState)&&(0,g.$Lf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,xe=!(0,g.$Lf)(ke.checkboxState)&&(0,g.$Jf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==ze.Checked&&Ge!==ze.Unchecked||xe!==void 0&&!(0,g.$Hf)(xe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(j instanceof L)return!0;if(ke.label!==void 0&&!(0,g.$Hf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,g.$Hf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,g.$Hf)(ke.iconPath)&&!w.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,g.$Hf)(ke.iconPath.id))){const Ge=ke.iconPath;if(!Ge||!(0,g.$Hf)(Ge.light)&&!w.URI.isUri(Ge.light)&&!(0,g.$Hf)(Ge.dark)&&!w.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,g.$Hf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!w.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,g.$Hf)(ke.tooltip)&&!(ke.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Me.None&&ke.collapsibleState>Me.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,g.$Hf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(j,oe=Me.None){this.collapsibleState=oe,w.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$SL=J,e.$SL=J=L=Je([D],J);var Me;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Me||(e.TreeItemCollapsibleState=Me={}));var ze;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(ze||(e.TreeItemCheckboxState=ze={}));let Xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$TL=Xe,e.$TL=Xe=Je([D],Xe);class We extends Xe{}e.$UL=We;class _e extends We{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$VL=_e;class mt{constructor(j,oe,ke,Ge){this.name=j,this.uri=oe,this._itemId=ke,this.c=Ge}data(){return this.c()}}e.$WL=mt;let zt=class{#e=new Map;constructor(j){for(const[oe,ke]of j??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(ke):this.#e.set(this.#t(oe),[ke])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,oe){this.#e.set(this.#t(j),[oe])}forEach(j,oe){for(const[ke,Ge]of this.#e)for(const xe of Ge)j.call(oe,xe,ke,this)}*[Symbol.iterator](){for(const[j,oe]of this.#e)for(const ke of oe)yield[j,ke]}#t(j){return j.toLowerCase()}};e.$XL=zt,e.$XL=zt=Je([D],zt);let Et=class{constructor(j){this.insertText=j}};e.$YL=Et,e.$YL=Et=Je([D],Et);let St=class{constructor(j,oe){this.label=oe,this.insertText=j}};e.$ZL=St,e.$ZL=St=Je([D],St);let wt=class{constructor(j,oe){this.id=j,this.color=oe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$1L=wt,e.$1L=wt=Je([D],wt),wt.File=new wt("file"),wt.Folder=new wt("folder");let gi=class{constructor(j){this.id=j}};e.$2L=gi,e.$2L=gi=Je([D],gi);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Si=class{get base(){return this.c}set base(j){this.c=j,this.e=w.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,oe){if(typeof j!="string"&&(!j||!w.URI.isUri(j)&&!w.URI.isUri(j.uri)))throw(0,T.$7)("base");if(typeof oe!="string")throw(0,T.$7)("pattern");typeof j=="string"?this.baseUri=w.URI.file(j):w.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$3L=Si,e.$3L=Si=Je([D],Si);const Gi=new WeakMap;function It(B,j){Gi.set(B,j)}e.$4L=It;let ri=class{constructor(j,oe,ke,Ge){this.enabled=typeof j=="boolean"?j:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Gi.get(this)??(0,A.$pg)()),this.c}};e.$5L=ri,e.$5L=ri=Je([D],ri);let mi=class extends ri{constructor(j,oe,ke,Ge,xe){if(super(oe,ke,Ge,xe),j===null)throw(0,T.$7)("location");this.location=j}};e.$6L=mi,e.$6L=mi=Je([D],mi);let ci=class extends ri{constructor(j,oe,ke,Ge,xe){super(oe,ke,Ge,xe),this.functionName=j}};e.$7L=ci,e.$7L=ci=Je([D],ci);let Ii=class extends ri{constructor(j,oe,ke,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!oe)throw(0,T.$7)("dataId");this.label=j,this.dataId=oe,this.canPersist=ke}};e.$8L=Ii,e.$8L=Ii=Je([D],Ii);let Ci=class{constructor(j,oe,ke){this.command=j,this.args=oe||[],this.options=ke}};e.$9L=Ci,e.$9L=Ci=Je([D],Ci);let Ot=class{constructor(j,oe){this.port=j,this.host=oe}};e.$0L=Ot,e.$0L=Ot=Je([D],Ot);let $i=class{constructor(j){this.path=j}};e.$$L=$i,e.$$L=$i=Je([D],$i);let Pi=class{constructor(j){this.implementation=j}};e.$_L=Pi,e.$_L=Pi=Je([D],Pi);let ui=class{constructor(j,oe,ke){this.session=j,this.threadId=oe,this.frameId=ke}};e.$aM=ui,e.$aM=ui=Je([D],ui);let li=class{constructor(j,oe){this.session=j,this.threadId=oe}};e.$bM=li,e.$bM=li=Je([D],li);let ht=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$cM=ht,e.$cM=ht=Je([D],ht);var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(j,oe){this.range=j,this.text=oe}};e.$dM=_t,e.$dM=_t=Je([D],_t);let si=class{constructor(j,oe,ke=!0){this.range=j,this.variableName=oe,this.caseSensitiveLookup=ke}};e.$eM=si,e.$eM=si=Je([D],si);let pi=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$fM=pi,e.$fM=pi=Je([D],pi);let Ri=class{constructor(j,oe){this.frameId=j,this.stoppedLocation=oe}};e.$gM=Ri,e.$gM=Ri=Je([D],Ri);var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=v=class extends Error{static FileExists(j){return new v(j,l.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(j){return new v(j,l.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(j){return new v(j,l.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(j){return new v(j,l.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(j,oe=l.FileSystemProviderErrorCode.Unknown,ke){super(w.URI.isUri(j)?j.toString(!0):j),this.code=ke?.name??"Unknown",(0,l.$Ek)(this,oe),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$hM=Ai,e.$hM=Ai=v=Je([D],Ai);let vi=class{constructor(j,oe,ke){this.start=j,this.end=oe,this.kind=ke}};e.$iM=vi,e.$iM=vi=Je([D],vi);var Xi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Zi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Mi{constructor(j,oe=[]){this.tokenTypes=j,this.tokenModifiers=oe}}e.$jM=Mi;function un(B){return typeof B>"u"||(0,g.$If)(B)}class Fi{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let oe=0,ke=j.tokenTypes.length;oe<ke;oe++)this.k.set(j.tokenTypes[oe],oe);for(let oe=0,ke=j.tokenModifiers.length;oe<ke;oe++)this.l.set(j.tokenModifiers[oe],oe)}}push(j,oe,ke,Ge,xe){if(typeof j=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(j,oe,ke,Ge,xe);if(U.isRange(j)&&typeof oe=="string"&&un(ke))return this.n(j,oe,ke);throw(0,T.$7)()}n(j,oe,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=j.start.line,xe=j.start.character,ut=j.end.character-j.start.character,gt=this.k.get(oe);let qt=0;if(ke)for(const Yt of ke){if(!this.l.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Yt);qt|=1<<ii>>>0}this.o(Ge,xe,ut,gt,qt)}o(j,oe,ke,Ge,xe){if(this.f&&(j<this.c||j===this.c&&oe<this.e)){this.f=!1;const qt=this.g.length/5|0;let Yt=0,ii=0;for(let ni=0;ni<qt;ni++){let ai=this.g[5*ni],Hi=this.g[5*ni+1];ai===0?(ai=Yt,Hi+=ii):ai+=Yt,this.g[5*ni]=ai,this.g[5*ni+1]=Hi,Yt=ai,ii=Hi}}let ut=j,gt=oe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=ke,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=j,this.e=oe}static q(j){const oe=[],ke=j.length/5|0;for(let gt=0;gt<ke;gt++)oe[gt]=gt;oe.sort((gt,qt)=>{const Yt=j[5*gt],ii=j[5*qt];if(Yt===ii){const ni=j[5*gt+1],ai=j[5*qt+1];return ni-ai}return Yt-ii});const Ge=new Uint32Array(j.length);let xe=0,ut=0;for(let gt=0;gt<ke;gt++){const qt=5*oe[gt],Yt=j[qt+0],ii=j[qt+1],ni=j[qt+2],ai=j[qt+3],Hi=j[qt+4],In=Yt-xe,Un=In===0?ii-ut:ii,Ki=5*gt;Ge[Ki+0]=In,Ge[Ki+1]=Un,Ge[Ki+2]=ni,Ge[Ki+3]=ai,Ge[Ki+4]=Hi,xe=Yt,ut=ii}return Ge}build(j){return this.f?new oi(new Uint32Array(this.g),j):new oi(Fi.q(this.g),j)}}e.$kM=Fi;class oi{constructor(j,oe){this.resultId=oe,this.data=j}}e.$lM=oi;class ln{constructor(j,oe,ke){this.start=j,this.deleteCount=oe,this.data=ke}}e.$mM=ln;class hn{constructor(j,oe){this.resultId=oe,this.edits=j}}e.$nM=hn;var Yi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let di=class{static{this.Back={iconPath:new wt("arrow-left")}}constructor(){}};e.$oM=di,e.$oM=di=Je([D],di);var xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var wi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(wi||(e.ExtensionKind=wi={}));class en{static validate(j){if(typeof j.badge=="string"){let oe=(0,$.$if)(j.badge,0);if(oe<j.badge.length&&(oe+=(0,$.$if)(j.badge,oe)),j.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!wt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,oe,ke){this.badge=j,this.tooltip=oe,this.color=ke}}e.$pM=en;let Ti=class{constructor(j){this.kind=j}};e.$qM=Ti,e.$qM=Ti=Je([D],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(j){return j instanceof ei?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("start must be positive");if(oe<0)throw(0,T.$7)("end must be positive");j<=oe?(this.c=j,this.e=oe):(this.c=oe,this.e=j)}with(j){let oe=this.c,ke=this.e;return j.start!==void 0&&(oe=j.start),j.end!==void 0&&(ke=j.end),oe===this.c&&ke===this.e?this:new ei(oe,ke)}}e.$rM=ei;class yi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(oe=>yi.isNotebookCellData(oe))}static isNotebookCellData(j){return!0}constructor(j,oe,ke,Ge,xe,ut,gt){this.kind=j,this.value=oe,this.languageId=ke,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,yi.validate(this)}}e.$sM=yi;class dn{constructor(j){this.cells=j}}e.$tM=dn;class Zt{static isNotebookCellOutputItem(j){return j instanceof Zt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const oe={name:j.name,message:j.message,stack:j.stack};return Zt.json(oe,"application/vnd.code.notebook.error")}static stdout(j){return Zt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Zt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,oe="application/octet-stream"){return new Zt(j,oe)}static#e=new TextEncoder;static text(j,oe=R.$es.text){const ke=Zt.#e.encode(String(j));return new Zt(ke,oe)}static json(j,oe="text/x-json"){const ke=JSON.stringify(j,void 0,"	");return Zt.text(ke,oe)}constructor(j,oe){this.data=j,this.mime=oe;const ke=(0,R.$is)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$uM=Zt;class Ei{static isNotebookCellOutput(j){return j instanceof Ei?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,oe=!1){const ke=new Set,Ge=new Set;for(let xe=0;xe<j.length;xe++){const ut=j[xe],gt=(0,R.$is)(ut.mime);if(!ke.has(gt)||(0,b.$8I)(gt)){ke.add(gt);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?j:j.filter((xe,ut)=>!Ge.has(ut))}constructor(j,oe,ke){this.items=Ei.ensureUniqueMimeTypes(j,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,A.$pg)(),this.metadata=oe??ke)}}e.$vM=Ei;var Di;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Di||(e.NotebookCellKind=Di={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Ue;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ue||(e.NotebookCellStatusBarAlignment=Ue={}));var ti;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(j,oe){this.text=j,this.alignment=oe}}e.$wM=tn;var et;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(et||(e.NotebookControllerAffinity=et={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class fn{constructor(j,oe=[]){this.uri=j,this.provides=(0,E.$3b)(oe)}}e.$xM=fn;class gn{constructor(j){this.label=j}}e.$yM=gn;var Ui;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(Ui||(e.NotebookVariablesRequestKind=Ui={}));let ji=class{constructor(j,oe){this.label=j,this.timestamp=oe}};e.$zM=ji,e.$zM=ji=Je([D],ji);var fi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(j,oe){this.ranges=j,this.wordPattern=oe}}e.$AM=mn;class sn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$BM=sn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let zi=class{constructor(j=void 0,oe=void 0,ke=void 0,Ge=!1){this.include=j,this.exclude=oe,this.profile=ke,this.continuous=Ge}};e.$CM=zi,e.$CM=zi=Je([D],zi);let Bi=y=class{static diff(j,oe,ke){const Ge=new y(j);return Ge.expectedOutput=oe,Ge.actualOutput=ke,Ge}constructor(j){this.message=j}};e.$DM=Bi,e.$DM=Bi=y=Je([D],Bi);let Vi=class{constructor(j){this.id=j}};e.$EM=Vi,e.$EM=Vi=Je([D],Vi);class ki{constructor(j,oe){this.covered=j,this.total=oe}}e.$FM=ki;const Wi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class qi{static fromDetails(j,oe){const ke=new ki(0,0),Ge=new ki(0,0),xe=new ki(0,0);for(const gt of oe)if("branches"in gt){ke.total+=1,ke.covered+=gt.executionCount>0?1:0;for(const qt of gt.branches)Ge.total+=1,Ge.covered+=qt.executionCount>0?1:0}else xe.total+=1,xe.covered+=gt.executionCount>0?1:0;const ut=new qi(j,ke,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=oe,ut}constructor(j,oe,ke,Ge){this.uri=j,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Ge,Wi(oe),Wi(ke),Wi(Ge)}}e.$GM=qi;class $n{constructor(j,oe,ke=[]){this.executionCount=j,this.location=oe,this.branches=ke}}e.$HM=$n;class pn{constructor(j,oe){this.executionCount=j,this.location=oe}}e.$IM=pn;class re{constructor(j,oe,ke){this.name=j,this.executionCount=oe,this.location=ke}}e.$JM=re;var ue;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var ot;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class bt{constructor(j,oe,ke,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$KM=bt;class Lt{constructor(j){this.uri=j}}e.$LM=Lt;class cn{constructor(j,oe){this.original=j,this.modified=oe}}e.$MM=cn;class Cn{constructor(j,oe,ke,Ge){this.base=j,this.input1=oe,this.input2=ke,this.result=Ge}}e.$NM=Cn;class Pn{constructor(j,oe){this.uri=j,this.viewType=oe}}e.$OM=Pn;class Rn{constructor(j){this.viewType=j}}e.$PM=Rn;class An{constructor(j,oe){this.uri=j,this.notebookType=oe}}e.$QM=An;class Ln{constructor(j,oe,ke){this.original=j,this.modified=oe,this.notebookType=ke}}e.$RM=Ln;class Mn{constructor(){}}e.$SM=Mn;class Fn{constructor(j,oe){this.uri=j,this.inputBoxUri=oe}}e.$TM=Fn;class Tn{constructor(j){this.providerId=j}}e.$UM=Tn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Nn{constructor(j,oe){this.label=j,this.values=oe}}e.$VM=Nn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(j,oe){this.role=j,this.content=oe}}e.$WM=On;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Pe[103],Re([1,0,53,12,11,294,147,7,18]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.$0M=void 0;const w=new Map;function A(b,r){r?w.set(b,r):w.delete(b)}e.$0M=A;function k(b){return w.get(b)}class l extends M.$kv{constructor(r,o,t,n,a,c,h,i){super(o,t,n,a),this.c=r,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,g.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===T.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,t){return r.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,E.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,E.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,n=o.start.line,a=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<a;h++)c.push(this.f[h]);return c.push(this.f[a].substring(0,o.end.character)),c.join(t)}t(r){let o;if(r instanceof $.$7K?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),t=this.f[o.index].length;return new $.$7K(o.index,Math.min(o.remainder,t))}w(r){if(!(r instanceof $.$8K))throw new Error("Invalid argument");const o=this.x(r.start),t=this.x(r.end);return o===r.start&&t===r.end?r:new $.$8K(o.line,o.character,t.line,t.character)}x(r){if(!(r instanceof $.$7K))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:t}=r,n=!1;if(o<0)o=0,t=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,n=!0;else{const a=this.f[o].length;t<0?(t=0,n=!0):t>a&&(t=a,n=!0)}return n?new $.$7K(o,t):r}y(r,o){const t=this.x(r);if(!o)o=k(this.m);else if((0,C.$Xe)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$ws)(t.character+1,(0,R.$us)(o),this.f[t.line],0);if(n)return new $.$8K(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$$M=l;class p{constructor(r,o,t){this.a=r,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$8K(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$8K(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$_M=p}),define(Pe[209],Re([1,0,7,17,5]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;let M=class{constructor($){this.a=new E.$qM(E.ColorThemeKind.Dark),this.b=new C.$Ud}get activeColorTheme(){return this.a}$onColorThemeChange($){let g;switch($){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$qM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Qhc=M,e.$Qhc=M=Je([He(0,T.$8M)],M)}),define(Pe[210],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$_I=(0,E.$5h)("INotebookExecutionService")}),define(Pe[211],Re([1,0,6,29,144,94]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQb=void 0;class R extends E.$Tc{constructor(g,w,A){super(),this._source=g,this.b=w,this.c=A,this.a=void 0}f(g){const w=g.getLineCount();return new T.$Ts(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new C.$bC;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:A,disposable:k}=w.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new C.$bC;w.acceptChunk(g);const A=w.finish(!0),{textBuffer:k,disposable:l}=A.create(1);return this.B(l),k})),this.a}findInInputs(g){const A=new M.$2B(g,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(g){const A=new M.$2B(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$zQb=R}),define(Pe[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(R,$,g=R.parent){if(R._isRoot)return new C([$]);const w=[R.id];for(let A=g;A&&A.id!==$;A=A.parent)w.push(A.id);return w.push($),new C(w.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new C(R.split("\0"))}static join(R,$){return new C([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:C.isChild(R,$)?2:C.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new C(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new C(this.path,R)}compare(R){if(typeof R=="string")return C.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$VJ=C}),define(Pe[58],Re([1,0,2,92,29,48]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$3J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$2J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$1J=e.$ZJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$YJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$XJ=e.$WJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var $;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var g;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$WJ=[2,4,8,16,32,64];const w=P=>"runId"in P;e.$XJ=w;var A;(function(P){P.serialize=I=>({range:I.range.toJSON(),uri:I.uri.toJSON()}),P.deserialize=(I,K)=>({range:C.$Ts.lift(K.range),uri:I.asCanonicalUri(E.URI.revive(K.uri))})})(A||(e.IRichLocation=A={}));var k;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(P){P.serialize=I=>({message:I.message,type:0,expected:I.expected,actual:I.actual,contextValue:I.contextValue,location:I.location&&A.serialize(I.location)}),P.deserialize=(I,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&A.deserialize(I,K.location)})})(l||(e.ITestErrorMessage=l={}));const p=(P,I)=>`${I?"s":"e"}${P}`;e.$YJ=p;var b;(function(P){P.serialize=I=>({message:I.message,type:1,offset:I.offset,length:I.length,location:I.location&&A.serialize(I.location)}),P.deserialize=(I,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&A.deserialize(I,K.location)})})(b||(e.ITestOutputMessage=b={}));var r;(function(P){P.serialize=I=>I.type===0?l.serialize(I):b.serialize(I),P.deserialize=(I,K)=>K.type===0?l.deserialize(I,K):b.deserialize(I,K)})(r||(e.ITestMessage=r={}));var o;(function(P){P.serializeWithoutMessages=I=>({state:I.state,duration:I.duration,messages:[]}),P.serialize=I=>({state:I.state,duration:I.duration,messages:I.messages.map(r.serialize)}),P.deserialize=(I,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ae=>r.deserialize(I,ae))})})(o||(e.ITestTaskState=o={}));const t="\0",n=(P,I)=>P+t+I;e.$ZJ=n;const a=P=>{const I=P.indexOf(t);return{ctrlId:P.slice(0,I),tagId:P.slice(I+1)}};e.$1J=a;var c;(function(P){P.serialize=I=>({extId:I.extId,label:I.label,tags:I.tags,busy:I.busy,children:void 0,uri:I.uri?.toJSON(),range:I.range?.toJSON()||null,description:I.description,error:I.error,sortText:I.sortText}),P.deserialize=(I,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?I.asCanonicalUri(E.URI.revive(K.uri)):void 0,range:K.range?C.$Ts.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(P){P.serialize=I=>({expand:I.expand,item:c.serialize(I.item)}),P.deserialize=(I,K)=>({controllerId:M.$VJ.root(K.item.extId),expand:K.expand,item:c.deserialize(I,K.item)})})(i||(e.InternalTestItem=i={}));var s;(function(P){P.serialize=I=>{let K;return I.item&&(K={},I.item.label!==void 0&&(K.label=I.item.label),I.item.tags!==void 0&&(K.tags=I.item.tags),I.item.busy!==void 0&&(K.busy=I.item.busy),I.item.uri!==void 0&&(K.uri=I.item.uri?.toJSON()),I.item.range!==void 0&&(K.range=I.item.range?.toJSON()),I.item.description!==void 0&&(K.description=I.item.description),I.item.error!==void 0&&(K.error=I.item.error),I.item.sortText!==void 0&&(K.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:K}},P.deserialize=I=>{let K;return I.item&&(K={},I.item.label!==void 0&&(K.label=I.item.label),I.item.tags!==void 0&&(K.tags=I.item.tags),I.item.busy!==void 0&&(K.busy=I.item.busy),I.item.range!==void 0&&(K.range=I.item.range?C.$Ts.lift(I.item.range):null),I.item.description!==void 0&&(K.description=I.item.description),I.item.error!==void 0&&(K.error=I.item.error),I.item.sortText!==void 0&&(K.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:K}}})(s||(e.ITestItemUpdate=s={}));const u=(P,I)=>{I.expand!==void 0&&(P.expand=I.expand),I.item!==void 0&&(P.item=P.item?Object.assign(P.item,I.item):I.item)};e.$2J=u;var d;(function(P){P.serializeWithoutMessages=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(o.serializeWithoutMessages)}),P.serialize=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(o.serialize)}),P.deserialize=(I,K)=>({...i.deserialize(I,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ae=>o.deserialize(I,ae)),retired:!0})})(d||(e.TestResultItem=d={}));var m;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(I,K)=>{I.covered+=K.covered,I.total+=K.total}})(m||(e.ICoveredCount=m={}));var f;(function(P){P.serialize=I=>({statement:I.statement,branch:I.branch,function:I.function,details:I.details?.map(y.serialize),uri:I.uri.toJSON()}),P.deserialize=(I,K)=>({statement:K.statement,branch:K.branch,function:K.function,details:K.details?.map(y.deserialize),uri:I.asCanonicalUri(E.URI.revive(K.uri))})})(f||(e.IFileCoverage=f={}));function S(P){return{...P,location:P.location?.toJSON()}}function L(P){return P.location=P.location?T.$Ss.isIPosition(P.location)?T.$Ss.lift(P.location):C.$Ts.lift(P.location):void 0,P}e.$3J=3;var v;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(v||(e.DetailType=v={}));var y;(function(P){P.serialize=I=>I.type===0?N.serialize(I):O.serialize(I),P.deserialize=I=>I.type===0?N.deserialize(I):O.deserialize(I)})(y||(e.CoverageDetails=y={}));var D;(function(P){P.serialize=S,P.deserialize=L})(D||(e.IBranchCoverage=D={}));var N;(function(P){P.serialize=S,P.deserialize=L})(N||(e.IFunctionCoverage=N={}));var O;(function(P){P.serialize=I=>({...S(I),branches:I.branches?.map(D.serialize)}),P.deserialize=I=>({...L(I),branches:I.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var G;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var W;(function(P){P.deserialize=(I,K)=>K.op===0?{op:K.op,item:i.deserialize(I,K.item)}:K.op===1?{op:K.op,item:s.deserialize(K.item)}:K.op===2?{op:K.op,uri:I.asCanonicalUri(E.URI.revive(K.uri)),docv:K.docv}:K,P.serialize=I=>I.op===0?{op:I.op,item:i.serialize(I.item)}:I.op===1?{op:I.op,item:s.serialize(I.item)}:I})(W||(e.TestsDiffOp=W={}));class U{constructor(I){this.k=I,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(I){const K=this.v();for(const ae of I)switch(ae.op){case 0:this.l(i.deserialize(this.k,ae.item),K);break;case 1:this.o(s.deserialize(ae.item),K);break;case 3:this.p(ae.itemId,K);break;case 5:this.q(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}K.complete?.()}l(I,K){const ae=M.$VJ.parentId(I.item.extId)?.toString();let he;if(!ae)he=this.w(I),this.g.add(he),this.f.set(I.item.extId,he);else if(this.f.has(ae)){const be=this.f.get(ae);be.children.add(I.item.extId),he=this.w(I,be),this.f.set(I.item.extId,he)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(I)}`);return}return K.add?.(he),I.expand===2&&this.h++,he}o(I,K){const ae=this.f.get(I.extId);if(ae)return I.expand!==void 0&&(ae.expand===2&&this.h--,I.expand===2&&this.h++),(0,e.$2J)(ae,I),K.update?.(ae),ae}p(I,K){const ae=this.f.get(I);if(!ae)return;const he=M.$VJ.parentId(ae.item.extId)?.toString();he?this.f.get(he).children.delete(ae.item.extId):this.g.delete(ae);const be=[[I]];for(;be.length;)for(const De of be.pop()){const le=this.f.get(De);le&&(be.push(le.children),this.f.delete(De),K.remove?.(le,le!==ae),le.expand===2&&this.h--)}}q(I){}updatePendingRoots(I){this.j+=I}v(){return{}}}e.$4J=U}),define(Pe[77],Re([1,0,13,5,6,53,58,48]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(n,a)=>n===a,k=Object.entries({range:(n,a)=>n===a?!0:!n||!a?!1:n.equalsRange(a),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,a)=>!(n.length!==a.length||n.some(c=>!a.includes(c)))}),l=(n,a)=>{let c;for(const[h,i]of k)i(n[h],a[h])||(c?c[h]=a[h]:c={[h]:a[h]});return c};class p extends C.$Tc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new E.$eh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Ud),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(a){this.h=a;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,R.$2J)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,R.$2J)(c.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,c){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(a,c){switch(c.op){case 3:this.O($.$VJ.joinToString(a.fullId,c.id));break;case 0:this.z(c.item,a);break;case 5:for(const h of c.ops)this.w(a,h);break;case 1:this.C(c.new,c.old,a.fullId.toString());break;case 2:this.J(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.y(a.actual.uri);break;default:(0,M.$6c)(c)}}y(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}z(a,c){const h=$.$VJ.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.s.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(a.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(a,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(a)}}),this.I(a,s,c);return}if(s.actual===a){this.H(a,s,c);return}if(s.actual.uri?.toString()!==a.uri?.toString())return this.O(h.toString()),this.z(a,c);const u=this.s.getChildren(s.actual),d=s.actual,m=l(this.s.toITestItem(d),this.s.toITestItem(a));this.s.getApiFor(d).listener=void 0,s.actual=a,s.expand=0,m&&(m.hasOwnProperty("tags")&&(this.C(a.tags,d.tags,h.toString()),delete m.tags),this.w(s,{op:4,update:m})),this.I(a,s,c);for(const[f,S]of u)this.s.getChildren(a).get(S.id)||this.O($.$VJ.joinToString(h,S.id));this.y(s.actual.uri)}C(a,c,h){const i=new Set(c.map(s=>s.id));for(const s of a)i.delete(s.id)||this.D(s);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(s=>(0,R.$ZJ)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(a){const c=this.j.get(a.id);c?c.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$ZJ)(this.s.controllerId,a.id)}}))}F(a){const c=this.j.get(a);c&&!--c.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,R.$ZJ)(this.s.controllerId,a)}))}G(a,c){this.s.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}H(a,c,h){this.G(a,h);const i=this.s.getApiFor(a);i.parent=h?.actual,i.listener=s=>this.w(c,s),this.J(c)}I(a,c,h){this.H(a,c,h);for(const[i,s]of this.s.getChildren(a))this.z(s,c)}J(a){let c;this.h?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.M(a))}L(a,c){if(c<0)return;const h=[];for(const[i,s]of this.s.getChildren(a.actual)){const u=this.expand($.$VJ.joinToString(a.fullId,s.id),c);(0,E.$Rg)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const s=new E.$4g;return s.open(),s}a.expand=2,this.N(a);const c=a.resolveBarrier=new E.$4g,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(a.actual===this.root?void 0:a.actual)}catch(s){h(s)}return(0,E.$Rg)(i)?i.catch(h).then(()=>{c.open(),this.J(a)}):(c.open(),this.J(a)),a.resolveBarrier}N(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}O(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,u]of this.s.getChildren(i.actual))h.push(this.tree.get($.$VJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$XM=p;class b extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$YM=b;class r extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ZM=r;class o extends Error{constructor(a,c,h){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$1M=o;const t=(n,a,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,s){for(const u of h.values())i.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const s=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const m of i){if(!(m instanceof c))throw new r(m.id);const f=a(m).controllerId;if(f!==n.controllerId)throw new o(m.id,f,n.controllerId);if(s.has(m.id))throw new b(m.id);s.set(m.id,m),u.delete(m.id),d.ops.push({op:0,item:m})}for(const m of u.keys())d.ops.push({op:3,id:m});n.listener?.(d),h=s},add(i){if(!(i instanceof c))throw new r(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$2M=t}),define(Pe[104],Re([1,0,77]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0;const T=new WeakMap,C=(R,$)=>{const g={controllerId:$};return T.set(R,g),g};e.$3M=C;const M=R=>{const $=T.get(R);if(!$)throw new E.$ZM(R?.id||"<unknown>");return $};e.$4M=M}),define(Pe[78],Re([1,0,12,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rvb=e.$qvb=e.$pvb=e.$ovb=e.$nvb=void 0,e.$nvb="vscode-cdn.net",e.$ovb=`vscode-resource.${e.$nvb}`,e.$pvb=`'self' https://*.${e.$nvb}`;function C($,g){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(g&&g.authority&&g.isRemote&&$.scheme===E.Schemas.file&&($=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:$.path})),T.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$ovb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$qvb=C;function M($){return $.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$rvb=R}),define(Pe[212],Re([1,0,5,6,78]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class M{constructor($,g,w){this.d=$,this.e=g,this.f=w,this.a=0,this.b=new T.$Sc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,g,w,A,k){let l;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===$){l=a;break}if(!l)throw new Error("not a visible editor");const p=this,b=this.a++,r=new E.$Ud,o=new E.$Ud,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,C.$qvb)(a,p.f)}get cspSource(){return C.$pvb}set options(a){this.b=a,p.d.$setOptions(b,a)}get options(){return this.b}set html(a){this.a=a,p.d.$setHtml(b,a)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(a){return p.d.$postMessage(b,a)}},n=new class{constructor(){this.editor=$,this.line=g,this.height=w,this.webview=t,this.onDidDispose=o.event}dispose(){p.c.has(b)&&(p.c.delete(b),p.d.$disposeEditorInset(b),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,g+1,w,A||{},k.identifier,k.extensionLocation),this.c.set(b,{editor:$,inset:n,onDidReceiveMessage:r}),n}$onDidDispose($){const g=this.c.get($);g&&g.inset.dispose()}$onDidReceiveMessage($,g){this.c.get($)?.onDidReceiveMessage.fire(g)}}e.$agc=M}),define(Pe[213],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.VariableKind=e.$TN=void 0,e.$TN=(0,E.$5h)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class C extends Error{constructor(R,$){super($),this.variable=R}}e.$UN=C}),define(Pe[214],Re([1,0,19,74,16,26,21,95,176,213,11]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,b,r,o){this.h=new Map,this.a=p,this.b=b,this.g=r,o&&(this.c=o.then(t=>this.i(t)))}i(p){if(R.$i){const b=Object.create(null);return Object.keys(p).forEach(r=>{b[r.toLowerCase()]=p[r]}),b}return p}resolveWithEnvironment(p,b,r){return this.l({env:this.i(p),userHome:void 0},b?b.uri:void 0,r)}async resolveAsync(p,b){const r={env:await this.c,userHome:await this.g};return this.l(r,p?p.uri:void 0,b)}async j(p,b,r,o){const t=M.$un(b);R.$i&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):R.$j&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):R.$k&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,r,o)}async resolveAnyAsync(p,b,r){return this.j(p,b,r)}async resolveAnyMap(p,b,r){const o=new Map;return{newConfig:await this.j(p,b,r,o),resolvedVariables:o}}resolveWithInteractionReplace(p,b,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,b,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,b){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,b)}async l(p,b,r,o,t){if(C.$Hf(r))return this.m(p,b,r,o,t);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(p,b,n,o,t)));if(C.$Jf(r)){const n=Object.create(null),a=await Promise.all(Object.keys(r).map(async c=>[await this.m(p,b,c,o,t),await this.l(p,b,r[c],o,t)]));for(const[c,h]of a)n[c]=h;return n}return r}m(p,b,r,o,t){return(0,A.$3e)(r,k.VARIABLE_REGEXP,async(n,a)=>{if(a.includes(k.VARIABLE_LHS))return n;let c=await this.o(p,n,a,b,o);return t?.set(a,c),c!==n&&C.$Hf(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m(p,b,c,o,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,b,r,o,t){let n;const a=r.split(":");a.length>1&&(r=a[0],n=a[1]);const c=s=>{const u=this.a.getFilePath();if(u)return(0,$.$Vv)(u);throw new w.$UN(s,(0,g.localize)(0,null,b))},h=s=>{const u=c(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$Vv)(d)}throw new w.$UN(s,(0,g.localize)(1,null,b,E.$nc(u)))},i=s=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new w.$UN(s,(0,g.localize)(2,null,b,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new w.$UN(s,(0,g.localize)(3,null,b)):new w.$UN(s,(0,g.localize)(4,null,b))};switch(r){case"env":if(n){if(p.env){const s=p.env[R.$i?n.toLowerCase():n];if(C.$Hf(s))return s}return""}throw new w.$UN(w.VariableKind.Env,(0,g.localize)(5,null,b));case"config":if(n){const s=this.a.getConfigurationValue(o,n);if(C.$Qf(s))throw new w.$UN(w.VariableKind.Config,(0,g.localize)(6,null,b,n));if(C.$Jf(s))throw new w.$UN(w.VariableKind.Config,(0,g.localize)(7,null,b,n));return s}throw new w.$UN(w.VariableKind.Config,(0,g.localize)(8,null,b));case"command":return this.p(w.VariableKind.Command,b,n,t,"command");case"input":return this.p(w.VariableKind.Input,b,n,t,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new w.$UN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,b,n));return this.n(s.extensionLocation)}throw new w.$UN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,b));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,$.$Vv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,$.$Vv)(this.n(i(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Vv)(E.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new w.$UN(w.VariableKind.UserHome,(0,g.localize)(11,null,b))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new w.$UN(w.VariableKind.LineNumber,(0,g.localize)(12,null,b))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new w.$UN(w.VariableKind.SelectedText,(0,g.localize)(13,null,b))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?E.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$mc(c(w.VariableKind.RelativeFileDirname));if(o||n){const u=E.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),s);return u.length===0?".":u}return s}case"fileDirname":return E.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$nc(c(w.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$oc(s).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||b}case"execInstallFolder":{const s=this.a.getAppRoot();return s||b}case"pathSeparator":case"/":return E.sep;default:try{const s=n?`${r}:${n}`:r;return this.p(w.VariableKind.Unknown,b,s,t,void 0)}catch{return b}}}}p(p,b,r,o,t){if(r&&o){const n=t===void 0?o[r]:o[t+":"+r];if(typeof n=="string")return n;throw new w.$UN(p,(0,g.localize)(14,null,b))}return b}}e.$9N=k}),define(Pe[105],Re([1,0,4,102]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.OpenEditorContext=e.GroupsOrder=e.$9C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$8C=void 0,e.$8C=(0,E.$5h)("editorGroupsService");var C;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var M;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var g;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(b){const r=b;return(0,T.$RE)(r?.editor)&&(0,T.$RE)(r?.replacement)}e.$9C=w;var A;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(b){const r=b;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$0C=l;function p(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$$C=p}),define(Pe[215],Re([1,0,4,105]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=void 0,e.$_C=(0,E.$5h)("editorService"),e.$aD=-1,e.$bD=-2,e.$cD=-3;function C(M){const R=M;return typeof M=="number"||(0,T.$0C)(R)}e.$dD=C}),define(Pe[216],Re([1,0,4,183]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oK=void 0,e.$oK=(0,E.$6h)(T.$_h)}),define(Pe[106],Re([1,0,22,5,19,6]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=e.$77b=e.$67b=e.$57b=e.$47b=void 0;class R{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$47b=R;class ${static isHostExtension(t,n,a){if(n.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Ud,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(b),this.f=new E.$mm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const a of n)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=r(this.e,n),this.e=this.e.concat(t);const a=$.l(this.e);return this.e=r(this.e,a.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,a)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,u){this.addNode(s),this.addNode(u),this.c.has(s)?this.c.get(s).push(u):this.c.set(s,[u])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,u){const d=n.getArcs(s);for(let m=0;m<d.length;m++)if(!u.has(d[m]))return!1;return!0}getNodes(){return this.e}},a=new E.$mm;for(const s of t)if(a.set(s.identifier,s),s.extensionDependencies)for(const u of s.extensionDependencies)n.addArc(E.$km.toKey(s.identifier),E.$km.toKey(u));const c=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>c.add(s));const h=n.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<h.length;s++){const u=h[s];n.hasOnlyGoodArcs(u,c)&&(h.splice(s,1),s--,c.add(u),i=!0)}}while(i);return h.map(s=>a.get(s))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$57b=$;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$67b=g;class w{constructor(t){this.d=new l,this.c=new $(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$77b=w;class A extends M.$Tc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$87b=A;class k{constructor(t){this.name=t,this.promise=new Promise((n,a)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new k(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const a=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(a),n=!1,this.d=!1,this.e())};t.resolve((0,M.$Rc)(c))}}var p;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(p||(p={}));function b(o,t){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==a)return n-a;const c=C.$gc.basename(o.extensionLocation.path),h=C.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function r(o,t){const n=new E.$lm(t);return o.filter(a=>!n.has(a.identifier))}}),define(Pe[79],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$tm=e.$sm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var M;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(w){const A=E.$ie.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$sm=R;function $(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$tm=$;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[59],Re([1,0,4,5,14,27,79,55,56,26,2,6,164]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=e.$mN=void 0;let p=class extends k.$Tc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Ud),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Ud),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$Oo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(a=>{(0,C.$oj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,a){const c=this.getTelemetryDetails(),h=new b(n,a,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,a){this.f=t,this.g=n,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$al)((0,g.$Vo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((a,c)=>{const h=a.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$mN=p,e.$mN=p=Je([He(0,M.$lN),He(1,C.$nj)],p);class b{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,a,c,h,i,s){this.g=a,this.h=c,this.i=h,this.j=i,this.a=new T.$Ud,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$Yo)(n,[]),this.c&&(n=(0,w.$xn)(n,this.c)),this.b||(n=(0,w.$xn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Yo)(a,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$nN=b;function r(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$oN=r,e.$pN=(0,E.$5h)("IExtHostTelemetry")}),define(Pe[23],Re([1,0,5,2,192,101,22,4]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GF=e.$FF=e.$EF=e.ActivationKind=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.ExtensionHostStartup=e.$yF=e.$xF=e.$wF=e.$vF=void 0,e.$vF=Object.freeze({identifier:new R.$km("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$wF="extensions.webWorker",e.$xF=(0,$.$5h)("extensionService");class g{constructor(h){this.dependency=h}}e.$yF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,s){this.c=h,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$gF.createActivationEventsMap(this.d)}}set(h,i,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],m=[],f=[],S=k(this.d),L=k(i),v=(G,W)=>G.extensionLocation.toString()===W.extensionLocation.toString()||G.isBuiltin===W.isBuiltin||G.isUserBuiltin===W.isUserBuiltin||G.isUnderDevelopment===W.isUnderDevelopment;for(const G of this.d){const W=L.get(G.identifier);if(!W){u.push(G.identifier),S.delete(G.identifier);continue}if(!v(G,W)){u.push(G.identifier),S.delete(G.identifier);continue}}for(const G of i){const W=S.get(G.identifier);if(!W){d.push(G);continue}if(!v(W,G)){u.push(W.identifier),S.delete(W.identifier);continue}}const y=new R.$lm(this.e),D=new R.$lm(s);for(const G of this.e)D.has(G)||m.push(G);for(const G of s)y.has(G)||f.push(G);const N=M.$gF.createActivationEventsMap(d),O={versionId:h,toRemove:u,toAdd:d,addActivationEvents:N,myToRemove:m,myToAdd:f};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:u,myToAdd:d}=h,m=new R.$lm(i),f=new R.$lm(u);for(let S=0;S<this.d.length;S++)m.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)f.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$km.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=M.$gF.readActivationEvents(i);for(const u of s)h.add(u)}return h}}e.$zF=A;function k(c){const h=new R.$mm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$AF=l;function p(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$BF=p;class b{constructor(h,i,s,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=u}}e.$CF=b;class r{constructor(h,i){this.description=h,this.value=i}}e.$DF=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$5o)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$EF=t;function n(c,h){return{identifier:new R.$km((0,C.$3o)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$FF=n;class a{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$GF=a}),define(Pe[217],Re([1,0,15,106,22,23,14,13]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=e.$zgc=e.$ygc=e.$xgc=e.$wgc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,a,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=a,this.activateResolvedTime=c}}e.$wgc=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$xgc=w;class A{constructor(t,n,a,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=a,this.module=c,this.exports=h,this.subscriptions=i}}e.$ygc=A;class k extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$zgc=k;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Agc=l;class p extends A{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(t,n,a,c){this.g=c,this.a=t,this.b=n,this.c=a,this.d=new C.$mm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,a]of this.d)t.push(a.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const a=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(a.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const a=this.a.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this.h([{id:a.identifier,reason:n}])}async h(t){const n=t.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(n.map(a=>a.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(h));return this.c.onExtensionActivationError(t.id,h,new M.$yF(t.id.value)),i}const a=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){a.push(i);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;a.push(this.j({id:s.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),m=this.k(t,n.displayName,[],new p(d));return this.c.onExtensionActivationError(n.identifier,d,new M.$yF(h)),m}return this.k(t,n.displayName,a,null)}k(t,n,a,c){const h=new r(t.id,n,t.reason,a,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$57b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$Bgc=b,e.$Bgc=b=Je([He(3,R.$mj)],b);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,a,c,h,i,s){this.c=t,this.d=n,this.f=a,this.g=c,this.h=h,this.j=i,this.k=s,this.a=new $.$4g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);a.detail=n.value.activationFailedError,this.h=new p(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};r=Je([He(6,R.$mj)],r)}),define(Pe[8],Re([1,0,18,24,127,218,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,215,7,23]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$7M=e.$6M=e.MarkdownString=e.$5M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Se){function Fe(J){const{selectionStartLineNumber:Me,selectionStartColumn:ze,positionLineNumber:Xe,positionColumn:We}=J,_e=new s.$7K(Me-1,ze-1),mt=new s.$7K(Xe-1,We-1);return new s.$9K(_e,mt)}Se.to=Fe;function fe(J){const{anchor:Me,active:ze}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Se.from=fe})(d||(e.Selection=d={}));var m;(function(Se){function Fe(J){if(!J)return;const{start:Me,end:ze}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Se.from=Fe;function fe(J){if(!J)return;const{startLineNumber:Me,startColumn:ze,endLineNumber:Xe,endColumn:We}=J;return new s.$8K(Me-1,ze-1,Xe-1,We-1)}Se.to=fe})(m||(e.Range=m={}));var f;(function(Se){function Fe(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Se.to=Fe})(f||(e.TokenType=f={}));var S;(function(Se){function Fe(J){return new s.$7K(J.lineNumber-1,J.column-1)}Se.to=Fe;function fe(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=fe})(S||(e.Position=S={}));var L;(function(Se){function Fe(Me,ze,Xe){return(0,E.$Hb)((0,E.$3b)(Me).map(We=>fe(We,ze,Xe)))}Se.from=Fe;function fe(Me,ze,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,ze),pattern:Y.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Me,ze){return ze&&typeof Me=="string"?ze.transformOutgoingScheme(Me):Me}})(L||(e.DocumentSelector=L={}));var v;(function(Se){function Fe(J){switch(J){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Se.from=Fe;function fe(J){switch(J){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(v||(e.DiagnosticTag=v={}));var y;(function(Se){function Fe(J){let Me;return J.code&&((0,l.$Hf)(J.code)||(0,l.$Lf)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...m.from(J.range),message:J.message,source:J.source,code:Me,severity:N.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(D.from),tags:Array.isArray(J.tags)?(0,E.$Hb)(J.tags.map(v.from)):void 0}}Se.from=Fe;function fe(J){const Me=new s.$hL(m.to(J),J.message,N.to(J.severity));return Me.source=J.source,Me.code=(0,l.$Hf)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(D.to),Me.tags=J.tags&&(0,E.$Hb)(J.tags.map(v.to)),Me}Se.to=fe})(y||(e.Diagnostic=y={}));var D;(function(Se){function Fe(J){return{...m.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=Fe;function fe(J){return new s.$gL(new s.$fL(J.resource,m.to(J)),J.message)}Se.to=fe})(D||(e.DiagnosticRelatedInformation=D={}));var N;(function(Se){function Fe(J){switch(J){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Se.from=Fe;function fe(J){switch(J){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Se.to=fe})(N||(e.DiagnosticSeverity=N={}));var O;(function(Se){function Fe(J){return typeof J=="number"&&J>=s.ViewColumn.One?J-1:J===s.ViewColumn.Beside?i.$bD:i.$aD}Se.from=Fe;function fe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(O||(e.ViewColumn=O={}));function G(Se){return typeof Se.range<"u"}function W(Se){return Se.length===0?!0:!!G(Se[0])}e.$5M=W;var U;(function(Se){function Fe(We){return We.map(Se.from)}Se.fromMany=Fe;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function J(We){let _e;if(fe(We)){const{language:St,value:wt}=We;_e={value:"```"+St+`
`+wt+"\n```\n"}}else s.$uL.isMarkdownString(We)?_e={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?_e={value:We}:_e={value:""};const mt=Object.create(null);_e.uris=mt;const zt=St=>{try{let wt=p.URI.parse(St,!0);wt=wt.with({query:Me(wt.query,mt)}),mt[St]=wt}catch{}return""},Et=new g.marked.Renderer;return Et.link=zt,Et.image=St=>typeof St=="string"?zt(R.$ok(St).href):"",(0,g.marked)(_e.value,{renderer:Et}),_e}Se.from=J;function Me(We,_e){if(!We)return We;let mt;try{mt=(0,w.$Ah)(We)}catch{}if(!mt)return We;let zt=!1;return mt=(0,k.$wn)(mt,Et=>{if(p.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[St]=Et,zt=!0,St}else return}),zt?JSON.stringify(mt):We}function ze(We){const _e=new s.$uL(We.value,We.supportThemeIcons);return _e.isTrusted=We.isTrusted,_e.supportHtml=We.supportHtml,_e.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,_e}Se.to=ze;function Xe(We){if(We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Xe})(U||(e.MarkdownString=U={}));function P(Se){return W(Se)?Se.map(Fe=>({range:m.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?U.fromMany(Fe.hoverMessage):Fe.hoverMessage?U.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Se.map(Fe=>({range:m.from(Fe)}))}e.$6M=P;function I(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.$7M=I;var K;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?I(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Fe})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var ae;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?I(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?K.from(fe.before):void 0,after:fe.after?K.from(fe.after):void 0}}Se.from=Fe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var he;(function(Se){function Fe(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Fe})(he||(e.DecorationRangeBehavior=he={}));var be;(function(Se){function Fe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?he.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?I(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?K.from(fe.before):void 0,after:fe.after?K.from(fe.after):void 0}}Se.from=Fe})(be||(e.DecorationRenderOptions=be={}));var De;(function(Se){function Fe(J){return{text:J.newText,eol:J.newEol&&tt.from(J.newEol),range:m.from(J.range)}}Se.from=Fe;function fe(J){const Me=new s.$aL(m.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:tt.to(J.eol),Me}Se.to=fe})(De||(e.TextEdit=De={}));var le;(function(Se){function Fe(J,Me){const ze={edits:[]};if(J instanceof s.$dL){const Xe=new $.$Bc;for(const We of J._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Xe.add(We.to);for(const We of J._allEntries())if(We._type===1){let _e;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?_e={type:"base64",value:(0,T.$Ce)(T.$ie.wrap(We.options.contents))}:_e={type:"dataTransferItem",id:We.options.contents._itemId}),ze.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:_e},metadata:We.metadata})}else We._type===2?ze.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Xe.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?ze.edits.push({resource:We.uri,textEdit:{range:m.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Xe.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?ze.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&ze.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Pt.from)}})}return ze}Se.from=Fe;function fe(J){const Me=new s.$dL,ze=new $.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const We=Xe,_e=p.URI.revive(We.resource),mt=m.to(We.textEdit.range),zt=We.textEdit.text,Et=We.textEdit.insertAsSnippet;let St;Et?St=s.$cL.replace(mt,new s.$eL(zt)):St=s.$aL.replace(mt,zt);const wt=ze.get(_e);wt?wt.push(St):ze.set(_e,[St])}else Me.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,We]of ze)Me.set(Xe,We);return Me}Se.to=fe})(le||(e.WorkspaceEdit=le={}));var ve;(function(Se){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function fe(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Se.from=fe;function J(Me){for(const ze in Fe)if(Fe[ze]===Me)return Number(ze);return s.SymbolKind.Property}Se.to=J})(ve||(e.SymbolKind=ve={}));var se;(function(Se){function Fe(J){switch(J){case s.SymbolTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return s.SymbolTag.Deprecated}}Se.to=fe})(se||(e.SymbolTag=se={}));var we;(function(Se){function Fe(J){return{name:J.name,kind:ve.from(J.kind),tags:J.tags&&J.tags.map(se.from),containerName:J.containerName,location:Ie.from(J.location)}}Se.from=Fe;function fe(J){const Me=new s.$lL(J.name,ve.to(J.kind),J.containerName,Ie.to(J.location));return Me.tags=J.tags&&J.tags.map(se.to),Me}Se.to=fe})(we||(e.WorkspaceSymbol=we={}));var ne;(function(Se){function Fe(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:m.from(J.range),selectionRange:m.from(J.selectionRange),kind:ve.from(J.kind),tags:J.tags?.map(se.from)??[]};return J.children&&(Me.children=J.children.map(Fe)),Me}Se.from=Fe;function fe(J){const Me=new s.$mL(J.name,J.detail,ve.to(J.kind),m.to(J.range),m.to(J.selectionRange));return(0,E.$Lb)(J.tags)&&(Me.tags=J.tags.map(se.to)),J.children&&(Me.children=J.children.map(fe)),Me}Se.to=fe})(ne||(e.DocumentSymbol=ne={}));var Z;(function(Se){function Fe(J){const Me=new s.$qL(ve.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),m.to(J.range),m.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,ze){if(Me=Me??J._sessionId,ze=ze??J._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,name:J.name,detail:J.detail,kind:ve.from(J.kind),uri:J.uri,range:m.from(J.range),selectionRange:m.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=fe})(Z||(e.CallHierarchyItem=Z={}));var V;(function(Se){function Fe(fe){return new s.$rL(Z.to(fe.from),fe.fromRanges.map(J=>m.to(J)))}Se.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var ie;(function(Se){function Fe(fe){return new s.$sL(Z.to(fe.to),fe.fromRanges.map(J=>m.to(J)))}Se.to=Fe})(ie||(e.CallHierarchyOutgoingCall=ie={}));var Ie;(function(Se){function Fe(J){return{range:J.range&&m.from(J.range),uri:J.uri}}Se.from=Fe;function fe(J){return new s.$fL(p.URI.revive(J.uri),m.to(J.range))}Se.to=fe})(Ie||(e.location=Ie={}));var Ae;(function(Se){function Fe(J){const Me=J,ze=J;return{originSelectionRange:Me.originSelectionRange?m.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:ze.uri,range:m.from(Me.targetRange?Me.targetRange:ze.range),targetSelectionRange:Me.targetSelectionRange?m.from(Me.targetSelectionRange):void 0}}Se.from=Fe;function fe(J){return{targetUri:p.URI.revive(J.uri),targetRange:m.to(J.range),targetSelectionRange:J.targetSelectionRange?m.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?m.to(J.originSelectionRange):void 0}}Se.to=fe})(Ae||(e.DefinitionLink=Ae={}));var Ce;(function(Se){function Fe(J){return{range:m.from(J.range),contents:U.fromMany(J.contents)}}Se.from=Fe;function fe(J){return new s.$iL(J.contents.map(U.to),m.to(J.range))}Se.to=fe})(Ce||(e.Hover=Ce={}));var ce;(function(Se){function Fe(J){return{range:m.from(J.range),expression:J.expression}}Se.from=Fe;function fe(J){return new s.$cM(m.to(J.range),J.expression)}Se.to=fe})(ce||(e.EvaluatableExpression=ce={}));var te;(function(Se){function Fe(J){if(J instanceof s.$dM)return{type:"text",range:m.from(J.range),text:J.text};if(J instanceof s.$eM)return{type:"variable",range:m.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof s.$fM)return{type:"expression",range:m.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Fe;function fe(J){switch(J.type){case"text":return{range:m.to(J.range),text:J.text};case"variable":return{range:m.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:m.to(J.range),expression:J.expression}}}Se.to=fe})(te||(e.InlineValue=te={}));var Q;(function(Se){function Fe(J){return{frameId:J.frameId,stoppedLocation:m.from(J.stoppedLocation)}}Se.from=Fe;function fe(J){return new s.$gM(J.frameId,m.to(J.stoppedLocation))}Se.to=fe})(Q||(e.InlineValueContext=Q={}));var ee;(function(Se){function Fe(J){return{range:m.from(J.range),kind:J.kind}}Se.from=Fe;function fe(J){return new s.$jL(m.to(J.range),J.kind)}Se.to=fe})(ee||(e.DocumentHighlight=ee={}));var me;(function(Se){function Fe(J){return{uri:J.uri,highlights:J.highlights.map(ee.from)}}Se.from=Fe;function fe(J){return new s.$kL(p.URI.revive(J.uri),J.highlights.map(ee.to))}Se.to=fe})(me||(e.MultiDocumentHighlight=me={}));var pe;(function(Se){function Fe(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Se.to=Fe})(pe||(e.CompletionTriggerKind=pe={}));var Le;(function(Se){function Fe(fe){return{triggerKind:pe.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Fe})(Le||(e.CompletionContext=Le={}));var de;(function(Se){function Fe(J){switch(J){case s.CompletionItemTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return s.CompletionItemTag.Deprecated}}Se.to=fe})(de||(e.CompletionItemTag=de={}));var ye;(function(Se){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(ze){return Fe.get(ze)??9}Se.from=fe;const J=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(ze){return J.get(ze)??s.CompletionItemKind.Property}Se.to=Me})(ye||(e.CompletionItemKind=ye={}));var F;(function(Se){function Fe(fe,J){const Me=new s.$AL(fe.label);return Me.insertText=fe.insertText,Me.kind=ye.to(fe.kind),Me.tags=fe.tags?.map(de.to),Me.detail=fe.detail,Me.documentation=R.$ik(fe.documentation)?U.to(fe.documentation):fe.documentation,Me.sortText=fe.sortText,Me.filterText=fe.filterText,Me.preselect=fe.preselect,Me.commitCharacters=fe.commitCharacters,b.$Ts.isIRange(fe.range)?Me.range=m.to(fe.range):typeof fe.range=="object"&&(Me.range={inserting:m.to(fe.range.insert),replacing:m.to(fe.range.replace)}),Me.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Me.insertText=new s.$eL(fe.insertText):(Me.insertText=fe.insertText,Me.textEdit=Me.range instanceof s.$8K?new s.$aL(Me.range,Me.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Me.additionalTextEdits=fe.additionalTextEdits.map(ze=>De.to(ze))),Me.command=J&&fe.command?J.fromInternal(fe.command):void 0,Me}Se.to=Fe})(F||(e.CompletionItem=F={}));var q;(function(Se){function Fe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:U.fromStrict(J.documentation)}}Se.from=Fe;function fe(J){return{label:J.label,documentation:R.$ik(J.documentation)?U.to(J.documentation):J.documentation}}Se.to=fe})(q||(e.ParameterInformation=q={}));var H;(function(Se){function Fe(J){return{label:J.label,documentation:U.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(q.from):[],activeParameter:J.activeParameter}}Se.from=Fe;function fe(J){return{label:J.label,documentation:R.$ik(J.documentation)?U.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(q.to):[],activeParameter:J.activeParameter}}Se.to=fe})(H||(e.SignatureInformation=H={}));var z;(function(Se){function Fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.from):[]}}Se.from=Fe;function fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.to):[]}}Se.to=fe})(z||(e.SignatureHelp=z={}));var X;(function(Se){function Fe(fe,J){const Me=new s.$zL(S.to(J.position),typeof J.label=="string"?J.label:J.label.map(x.to.bind(void 0,fe)),J.kind&&Ee.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(De.to),Me.tooltip=R.$ik(J.tooltip)?U.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}Se.to=Fe})(X||(e.InlayHint=X={}));var x;(function(Se){function Fe(fe,J){const Me=new s.$yL(J.label);return Me.tooltip=R.$ik(J.tooltip)?U.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(Me.command=fe.fromInternal(J.command)),J.location&&(Me.location=Ie.to(J.location)),Me}Se.to=Fe})(x||(e.InlayHintLabelPart=x={}));var Ee;(function(Se){function Fe(J){return J}Se.from=Fe;function fe(J){return J}Se.to=fe})(Ee||(e.InlayHintKind=Ee={}));var Te;(function(Se){function Fe(J){return{range:m.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=Fe;function fe(J){let Me;if(J.url)try{Me=typeof J.url=="string"?p.URI.parse(J.url,!0):p.URI.revive(J.url)}catch{}return new s.$FL(m.to(J.range),Me)}Se.to=fe})(Te||(e.DocumentLink=Te={}));var Ve;(function(Se){function Fe(J){const Me=new s.$IL(J.label);return J.textEdit&&(Me.textEdit=De.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(ze=>De.to(ze))),Me}Se.to=Fe;function fe(J){return{label:J.label,textEdit:J.textEdit?De.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>De.from(Me)):void 0}}Se.from=fe})(Ve||(e.ColorPresentation=Ve={}));var Ke;(function(Se){function Fe(J){return new s.$GL(J[0],J[1],J[2],J[3])}Se.to=Fe;function fe(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=fe})(Ke||(e.Color=Ke={}));var Ze;(function(Se){function Fe(J){return{range:m.from(J.range)}}Se.from=Fe;function fe(J){return new s.$pL(m.to(J.range))}Se.to=fe})(Ze||(e.SelectionRange=Ze={}));var st;(function(Se){function Fe(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Se.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var nt;(function(Se){function Fe(J){switch(J){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Fe;function fe(J){switch(J){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Se.to=fe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var tt;(function(Se){function Fe(J){if(J===s.EndOfLine.CRLF)return 1;if(J===s.EndOfLine.LF)return 0}Se.from=Fe;function fe(J){if(J===1)return s.EndOfLine.CRLF;if(J===0)return s.EndOfLine.LF}Se.to=fe})(tt||(e.EndOfLine=tt={}));var at;(function(Se){function Fe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Fe})(at||(e.ProgressLocation=at={}));var ct;(function(Se){function Fe(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=je.from(J.kind)),Me}Se.from=Fe;function fe(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=je.to(J.kind)),Me}Se.to=fe})(ct||(e.FoldingRange=ct={}));var je;(function(Se){function Fe(J){if(J)switch(J){case s.FoldingRangeKind.Comment:return r.$Jt.Comment;case s.FoldingRangeKind.Imports:return r.$Jt.Imports;case s.FoldingRangeKind.Region:return r.$Jt.Region}}Se.from=Fe;function fe(J){if(J)switch(J.value){case r.$Jt.Comment.value:return s.FoldingRangeKind.Comment;case r.$Jt.Imports.value:return s.FoldingRangeKind.Imports;case r.$Jt.Region.value:return s.FoldingRangeKind.Region}}Se.to=fe})(je||(e.FoldingRangeKind=je={}));var vt;(function(Se){function Fe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?m.from(fe.selection):void 0,override:typeof fe.override=="boolean"?n.$DE.id:void 0}}Se.from=Fe})(vt||(e.TextEditorOpenOptions=vt={}));var Y;(function(Se){function Fe(ze){return ze instanceof s.$3L?ze.toJSON():typeof ze=="string"?ze:fe(ze)||J(ze)?new s.$3L(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Se.from=Fe;function fe(ze){const Xe=ze;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(ze){const Xe=ze;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(ze){return typeof ze=="string"?ze:new s.$3L(p.URI.revive(ze.baseUri),ze.pattern)}Se.to=Me})(Y||(e.GlobPattern=Y={}));var _;(function(Se){function Fe(fe){if(fe){if(Array.isArray(fe))return fe.map(Fe);if(typeof fe=="string")return fe;{const J=fe;return{language:J.language,scheme:J.scheme,pattern:Y.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=Fe})(_||(e.LanguageSelector=_={}));var $e;(function(Se){function Fe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&p.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Xe=>Xe instanceof s.$8K)))}Se.is=Fe;function fe(J){return{documents:J.documents.map(Me=>Me.map(ze=>({uri:p.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Xe=>m.from(Xe))})))}}Se.from=fe})($e||(e.MappedEditsContext=$e={}));var Be;(function(Se){function Fe(J){return{start:J.start,end:J.end}}Se.from=Fe;function fe(J){return new s.$rM(J.start,J.end)}Se.to=fe})(Be||(e.NotebookRange=Be={}));var Qe;(function(Se){function Fe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=Fe;function fe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=fe})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Se){function Fe(fe){if(fe===a.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===a.NotebookCellExecutionState.Pending)return;if(fe===a.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Fe})(it||(e.NotebookCellExecutionState=it={}));var rt;(function(Se){function Fe(J){switch(J){case s.NotebookCellKind.Markup:return a.CellKind.Markup;case s.NotebookCellKind.Code:default:return a.CellKind.Code}}Se.from=Fe;function fe(J){switch(J){case a.CellKind.Markup:return s.NotebookCellKind.Markup;case a.CellKind.Code:default:return s.NotebookCellKind.Code}}Se.to=fe})(rt||(e.NotebookCellKind=rt={}));var Ne;(function(Se){function Fe(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const ze of J.cells)s.$sM.validate(ze),Me.cells.push(Pt.from(ze));return Me}Se.from=Fe;function fe(J){const Me=new s.$tM(J.cells.map(Pt.to));return(0,l.$Uf)(J.metadata)||(Me.metadata=J.metadata),Me}Se.to=fe})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Se){function Fe(J){return{cellKind:rt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Qe.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Kt.from):[]}}Se.from=Fe;function fe(J){return new s.$sM(rt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Kt.to):void 0,J.metadata,J.internalMetadata?Qe.to(J.internalMetadata):void 0)}Se.to=fe})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Se){function Fe(J){return{mime:J.mime,valueBytes:T.$ie.wrap(J.data)}}Se.from=Fe;function fe(J){return new s.$uM(J.valueBytes.buffer,J.mime)}Se.to=fe})(Tt||(e.NotebookCellOutputItem=Tt={}));var Kt;(function(Se){function Fe(J){return{outputId:J.id,items:J.items.map(Tt.from),metadata:J.metadata}}Se.from=Fe;function fe(J){const Me=J.items.map(Tt.to);return new s.$vM(Me,J.outputId,J.metadata)}Se.to=fe})(Kt||(e.NotebookCellOutput=Kt={}));var Bt;(function(Se){function Fe(Me){return J(Me)?{include:Y.from(Me.include)??void 0,exclude:Y.from(Me.exclude)??void 0}:Y.from(Me)??void 0}Se.from=Fe;function fe(Me){return J(Me)?{include:Y.to(Me.include),exclude:Y.to(Me.exclude)}:Y.to(Me)}Se.to=fe;function J(Me){const ze=Me;return ze?!(0,l.$Qf)(ze.include)&&!(0,l.$Qf)(ze.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var yt;(function(Se){function Fe(fe,J,Me){const ze=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(ze,Me),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Fe})(yt||(e.NotebookStatusBarItem=yt={}));var Ht;(function(Se){function Fe(fe,J,Me){const ze=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:J.toInternal(ze,Me),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(Ht||(e.NotebookKernelSourceAction=Ht={}));var Nt;(function(Se){function Fe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Xt;(function(Se){function Fe(J){return{uri:J.uri,provides:J.provides}}Se.from=Fe;function fe(J){return new s.$xM(p.URI.revive(J.uri),J.provides)}Se.to=fe})(Xt||(e.NotebookRendererScript=Xt={}));var Ut;(function(Se){function Fe(J){return{message:U.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:m.from(J.location.range),uri:J.location.uri}}}Se.from=Fe;function fe(J){const Me=new s.$DM(typeof J.message=="string"?J.message:U.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?Ie.to(J.location):void 0,Me}Se.to=fe})(Ut||(e.TestMessage=Ut={}));var Rt;(function(Se){Se.namespace=h.$ZJ,Se.denamespace=h.$1J})(Rt||(e.TestTag=Rt={}));var Ye;(function(Se){function Fe(J){const Me=(0,t.$4M)(J).controllerId;return{extId:c.$VJ.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:p.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(ze=>Rt.namespace(Me,ze.id)),range:b.$Ts.lift(m.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&U.fromStrict(J.error)||null}}Se.from=Fe;function fe(J){return{parent:void 0,error:void 0,id:c.$VJ.fromString(J.extId).localId,label:J.label,uri:p.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:ze}=Rt.denamespace(Me);return new s.$EM(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:m.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=fe})(Ye||(e.TestItem=Ye={})),function(Se){function Fe(J){return{id:J.id}}Se.from=Fe;function fe(J){return new s.$EM(J.id)}Se.to=fe}(Rt||(e.TestTag=Rt={}));var Gt;(function(Se){const Fe=(J,Me)=>{const ze=[];for(const[We,_e]of Me)c.$VJ.compare(_e.item.extId,We)===2&&(Me.delete(We),ze.push(_e));const Xe={...Ye.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(_e=>_e.type===0).map(Ut.to)})),children:ze.map(We=>Fe(We,Me))};for(const We of Xe.children)We.parent=Xe;return Xe};function fe(J){const Me=[],ze=new Map;for(const Xe of J.items){ze.set(Xe.item.extId,Xe);const We=c.$VJ.root(Xe.item.extId);J.request.targets.some(_e=>_e.controllerId===We&&_e.testIds.includes(Xe.item.extId))&&Me.push(Xe)}return{completedAt:J.completedAt,results:Me.map(Xe=>Fe(Xe,ze))}}Se.to=fe})(Gt||(e.TestResults=Gt={}));var Jt;(function(Se){function Fe(ze){return{covered:ze.covered,total:ze.total}}function fe(ze){return"line"in ze?S.from(ze):m.from(ze)}function J(ze){return"branches"in ze?{count:ze.executionCount,location:fe(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location)})):void 0}:{type:0,name:ze.name,count:ze.executionCount,location:fe(ze.location)}}Se.fromDetailed=J;function Me(ze){return{uri:ze.uri,statement:Fe(ze.statementCoverage),branch:ze.branchCoverage&&Fe(ze.branchCoverage),function:ze.functionCoverage&&Fe(ze.functionCoverage),details:ze.detailedCoverage?.map(J)}}Se.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var lt;(function(Se){function Fe(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Se.to=Fe})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Se){function Fe(J){const Me=new s.$KM(ve.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),m.to(J.range),m.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,ze){if(Me=Me??J._sessionId,ze=ze??J._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,kind:ve.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:m.from(J.range),selectionRange:m.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=fe})($t||(e.TypeHierarchyItem=$t={}));var jt;(function(Se){function Fe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Fe})(jt||(e.ViewBadge=jt={}));var Vt;(function(Se){function Fe(ze,Xe,We){const _e=Xe.fileData;return _e?new s.$VL(new s.$WL(_e.name,p.URI.revive(_e.uri),_e.id,(0,M.$db)(()=>We(_e.id)))):ze===A.$es.uriList&&Xe.uriListData?new s.$UL(Me(Xe.uriListData)):new s.$UL(Xe.asString)}Se.to=Fe;async function fe(ze,Xe){const We=await Xe.asString();if(ze===A.$es.uriList)return{asString:We,fileData:void 0,uriListData:J(We)};const _e=Xe.asFile();return{asString:We,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Se.from=fe;function J(ze){return C.$qt.split(ze).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Me(ze){return C.$qt.create(ze.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(Vt||(e.DataTransferItem=Vt={}));var Dt;(function(Se){function Fe(J,Me){const ze=J.items.map(([Xe,We])=>[Xe,Vt.to(Xe,We,Me)]);return new s.$XL(ze)}Se.toDataTransfer=Fe;async function fe(J){const Me={items:[]},ze=[];for(const[Xe,We]of J)ze.push((async()=>{Me.items.push([Xe,await Vt.from(Xe,We)])})());return await Promise.all(ze),Me}Se.from=fe})(Dt||(e.DataTransfer=Dt={}));var dt;(function(Se){function Fe(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Se.from=Fe})(dt||(e.ChatReplyFollowup=dt={}));var Ct;(function(Se){function Fe(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:dt.from(fe)}Se.from=Fe})(Ct||(e.ChatFollowup=Ct={}));var xt;(function(Se){function Fe(J){const Me=new s.$WM(kt.to(J.role),J.content);return Me.name=J.name,Me}Se.to=Fe;function fe(J){return{role:kt.from(J.role),content:J.content,name:J.name}}Se.from=fe})(xt||(e.ChatMessage=xt={}));var kt;(function(Se){function Fe(J){switch(J){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Se.to=Fe;function fe(J){switch(J){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Se.from=fe})(kt||(e.ChatMessageRole=kt={}));var qe;(function(Se){function Fe(Me){const ze={};for(const Xe of Object.keys(Me))ze[Xe]=Me[Xe].map(Se.to);return ze}Se.objectTo=Fe;function fe(Me){return{level:Mt.to(Me.level),kind:Me.kind,value:(0,w.$Bh)(Me.value),description:Me.description}}Se.to=fe;function J(Me){return{level:Mt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Se.from=J})(qe||(e.ChatVariable=qe={}));var Mt;(function(Se){function Fe(J){switch(J){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Se.to=Fe;function fe(J){switch(J){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Se.from=fe})(Mt||(e.ChatVariableLevel=Mt={}));var Wt;(function(Se){function Fe(fe){switch(fe){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Fe})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Qt;(function(Se){function Fe(fe,J){return"placeholder"in J&&"resolvedContent"in J?{content:J.placeholder,kind:"asyncContent"}:"markdownContent"in J?((0,u.$BF)(fe,"chatAgents2Additions"),{content:U.from(J.markdownContent),kind:"markdownContent"}):"content"in J?"vulnerabilities"in J&&J.vulnerabilities?((0,u.$BF)(fe,"chatAgents2Additions"),{content:J.content,vulnerabilities:J.vulnerabilities,kind:"vulnerability"}):typeof J.content=="string"?{content:J.content,kind:"content"}:((0,u.$BF)(fe,"chatAgents2Additions"),{content:U.from(J.content),kind:"markdownContent"}):"documents"in J?{documents:J.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(ze=>m.from(ze))})),kind:"usedContext"}:"reference"in J?{reference:"uri"in J.reference?{uri:J.reference.uri,range:m.from(J.reference.range)}:J.reference,kind:"reference"}:"inlineReference"in J?{inlineReference:"uri"in J.inlineReference?{uri:J.inlineReference.uri,range:m.from(J.inlineReference.range)}:J.inlineReference,name:J.title,kind:"inlineReference"}:"agentName"in J?((0,u.$BF)(fe,"chatAgents2Additions"),{agentName:J.agentName,command:J.command,kind:"agentDetection"}):"treeData"in J?{treeData:J.treeData,kind:"treeData"}:"message"in J?{content:J.message,kind:"progressMessage"}:void 0}Se.from=Fe})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(Se){function Fe(fe){return{label:fe.label,values:fe.values.map(qe.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(ft||(e.ChatAgentCompletionItem=ft={}));var Ft;(function(Se){function Fe(fe,J,Me){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:J.toInternal(fe,Me)}Se.from=Fe})(Ft||(e.TerminalQuickFix=Ft={}))}),define(Pe[219],Re([1,0,2,15,7,8,185]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class ${constructor(w,A,k,l={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=k,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,k,l)=>{const b={dispose:this.a.push([A,k,w])};return Array.isArray(l)&&l.push(b),b}}async $participateInSave(w,A){const k=E.URI.revive(w);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),b=[];try{for(const r of[...this.a]){if(l)break;const o=this.d.getDocument(k),t=await this.h(r,{document:o,reason:M.TextDocumentSaveReason.to(A)});b.push(t)}}finally{clearTimeout(p)}return b}h([w,A,k],l){const p=this.b.get(w);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,w,A,l).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const r=this.b.get(w);this.b.set(w,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,k,l){const p=[],b=Date.now(),{document:r,reason:o}=l,{version:t}=r,n=Object.freeze({document:r,reason:o,waitUntil(a){if(Object.isFrozen(p))throw(0,T.$8)("waitUntil can not be called async");p.push(Promise.resolve(a))}});try{A.apply(k,[n])}catch(a){return Promise.reject(a)}return Object.freeze(p),new Promise((a,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(h),a(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(a=>{const c={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(i=>i instanceof C.$aL))for(const{newText:i,newEol:s,range:u}of h)c.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:u&&M.Range.from(u),text:i,eol:s&&M.EndOfLine.from(s)}});if(c.edits.length!==0)return t===r.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$8gc=$}),define(Pe[220],Re([1,0,12,2,8,7,76]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=void 0;class ${constructor(k,l,p,b){this.start=k,this.deletedCount=l,this.deletedItems=p,this.items=b}asApiEvent(){return{range:new M.$rM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,p){this.notebook=k,this.h=l,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(b){k.g=b},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,l,p){const b=p.map(C.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===k);if(r&&(l||(r.items.length=0),r.items.push(...b),r.items.length>1&&r.items.every(o=>R.$8I(o.mime)))){const o=new Map,t=[];r.items.forEach(n=>{let a;o.has(n.mime)?a=o.get(n.mime):(a=[],o.set(n.mime,a),t.push(n.mime)),a.push(n.data)}),r.items.length=0,t.forEach(n=>{const a=R.$9I(o.get(n));r.items.push({mime:n,data:a.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$ahc=g;class w{static{this.a=0}constructor(k,l,p,b,r){this.k=k,this.l=l,this.m=p,this.uri=b,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===E.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(r=>r.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,p){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const b={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},r=[];for(const t of k.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,b.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,b.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),r.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),r.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<r.length;t++){const n=r[t],a=o.get(n.cell);if(a===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else b.cellChanges[a]={...b.cellChanges[a],...n}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,p=k.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),k.with({start:l,end:p})}p(k){k=this.o(k);const l=[];for(let p=k.start;p<k.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,p){if(this.j)return;const b=[],r=[],o=[];if(k.reverse().forEach(t=>{const a=t[2].map(i=>{const s=new g(this,this.l,i);return l||r.push(g.asModelAddData(this.apiNotebook,i)),s}),c=new $(t[0],t[1],[],a),h=this.b.splice(t[0],t[1],...a);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);b.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),p)for(const t of b)p.push(t.asApiEvent())}s(k,l,p,b){const r=this.b.splice(k,l);this.b.splice(p,0,...r);const o=[new $(k,l,r.map(t=>t.apiCell),[]),new $(p,0,[],r)];for(const t of o)b.push(t.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,p,b){this.b[k].setOutputItems(l,p,b)}v(k,l){const p=this.b[k];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(k,l){const p=this.b[k];p.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$bhc=w}),define(Pe[221],Re([1,0,5,2,8,7]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class R{constructor(g,w,A,k={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=A,this.f=k,this.a=new E.$Wd}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,A,k)=>{const l=function(b){w.call(A,b)};return l.extension=g,this.a.event(l,void 0,k)}}async $participateInSave(g,w,A){const k=T.URI.revive(g),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(w)},A,async(r,o)=>{const t=Date.now(),n=await await Promise.resolve(r);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$dL?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const b={edits:[]};for(const r of p){const{edits:o}=C.WorkspaceEdit.from(r);b.edits=b.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$rhc=R}),define(Pe[107],Re([1,0,15,8,7]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,g,w,A,k,l){this.id=$,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(g){this.selections=[g]},get selections(){return $.a},set selections(g){if(!Array.isArray(g)||!g.every(C.$rM.isNotebookRange))throw(0,E.$7)("selections");$.a=g,$.g(g)},get visibleRanges(){return $.b},revealRange(g,w){$.f.$tryRevealRange($.id,T.NotebookRange.from(g),w??C.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$chc=M}),define(Pe[222],Re([1,0,5,14,8]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;let M=class{constructor($,g){this.c=$,this.d=g,this.a=new E.$Ud,this.b=new E.$Ud,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,g);const w=this.d.getEditorById($);g.visibleRanges&&w._acceptVisibleRanges(g.visibleRanges.ranges.map(C.NotebookRange.to)),g.selections&&w._acceptSelections(g.selections.selections.map(C.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns($){for(const g in $)this.d.getEditorById(g)._acceptViewColumn(C.ViewColumn.to($[g]))}};e.$thc=M,e.$thc=M=Je([He(0,T.$mj)],M)}),define(Pe[223],Re([1,0,8,72,20,66,15]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class ${constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,p){const b=this.b++,{title:r,location:o,cancellable:t}=l,n={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(b,{location:E.ProgressLocation.from(o),title:r,source:n,cancellable:t},k.isUnderDevelopment?void 0:k.identifier.value).catch(R.$2),this.d(b,p,!!t)}d(k,l,p){let b;p&&(b=new C.$5d,this.c.set(k,b));const r=t=>{this.a.$progressEnd(t),this.c.delete(t),b?.dispose()};let o;try{o=l(new w(this.a,k),p&&b?b.token:C.CancellationToken.None)}catch(t){throw r(k),t}return o.then(t=>r(k),t=>r(k)),o}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$Ahc=$;function g(A,k){return A.message=k.message,typeof k.increment=="number"&&(typeof A.increment=="number"?A.increment+=k.increment:A.increment=k.increment),A}class w extends T.$uv{constructor(k,l){super(p=>this.throttledReport(p)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,M.$yh)(100,(A,k)=>g(A,k),()=>Object.create(null))],w.prototype,"throttledReport",null)}),define(Pe[108],Re([1,0,29,104,48,77,58,8,2]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=e.$hN=void 0;const w=(a,c,h,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(u){if(!h(s,u)){const d=s;s=u,a.listener?.(i(u,d))}}}},A=(a,c)=>a===c,k={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,c)=>!(a.length!==c.length||a.some(h=>!c.find(i=>h.id===i.id)))},l=a=>c=>({op:4,update:a(c)}),p=(a,c)=>({range:(()=>{let h;const i=l(s=>({range:E.$Ts.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){a.listener?.({op:6}),k.range(h,s)||(h=s,a.listener?.(i(s)))}}})(),label:w(a,c,k.label,l(h=>({label:h}))),description:w(a,void 0,k.description,l(h=>({description:h}))),sortText:w(a,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:w(a,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:w(a,!1,k.busy,l(h=>({busy:h}))),error:w(a,void 0,k.error,l(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:w(a,[],k.tags,(h,i)=>({op:1,new:h.map($.TestTag.from),old:i.map($.TestTag.from)}))}),b=a=>{const c=C.$VJ.fromString(a.extId),h=new o(c.controllerId,c.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=$.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(i=>$.TestTag.to({id:(0,R.$1J)(i).tagId})),h},r=a=>{let c;for(const h of a.tests){const i=b(h.item);(0,T.$4M)(i).parent=c,c=i}return c};e.$hN=r;class o{constructor(c,h,i,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$3M)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,M.$2M)(u,T.$4M,o),enumerable:!0,writable:!1},...p(u,i)})}}e.$iN=o;class t extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$jN=t;class n extends M.$XM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:T.$4M,getChildren:s=>s.children,root:new t(c,h),toITestItem:$.TestItem.from})}}e.$kN=n}),define(Pe[109],Re([1,0,53,15,89,8,7]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=void 0;class ${static{this.c=new C.$aN("TextEditorDecorationType")}constructor(l,p,b){const r=$.c.nextId();l.$registerTextEditorDecorationType(p.identifier,r,M.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$cN=$;class g{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let b=null;if(l instanceof R.$7K)b=new R.$8K(l,l);else if(l instanceof R.$8K)b=l;else throw new Error("Unrecognized location");this.l(b,p,!1)}insert(l,p){this.k(),this.l(new R.$8K(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof R.$8K)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,b){const r=this.c.validateRange(l);this.g.push({range:r,text:p,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class w{constructor(l,p,b,r){this.c=l,this.d=p,this._accept(b),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.n(t)},get indentSize(){return o.g},set indentSize(t){o.p(t)},get insertSpaces(){return o.j},set insertSpaces(t){o.s(t)},get cursorStyle(){return o.k},set cursorStyle(t){o.t(t)},get lineNumbers(){return o.l},set lineNumbers(t){o.u(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}n(l){const p=this.m(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}p(l){const p=this.o(l);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const p=this.q(l);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let b=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(b=!0,p.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,b=!0,p.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(b=!0,p.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,b=!0,p.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(b=!0,p.insertSpaces=r):this.j!==r&&(this.j=r,b=!0,p.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,b=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,b=!0,p.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(l,p){p.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$dN=w;class A{constructor(l,p,b,r,o,t,n,a){this.id=l,this.j=p,this.k=b,this.g=!1,this.h=new Set,this.c=o,this.d=new w(this.j,this.id,t,b),this.e=n,this.f=a;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$9K))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$9K)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new g(r.value,i);return h(s),c.m(s)},insertSnippet(h,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>M.Range.from(d));else if(i instanceof R.$7K){const{lineNumber:d,column:m}=M.Position.from(i);u=[{startLineNumber:d,startColumn:m,endLineNumber:d,endColumn:m}]}else if(i instanceof R.$8K)u=[M.Range.from(i)];else{u=[];for(const d of i)if(d instanceof R.$8K)u.push(M.Range.from(d));else{const{lineNumber:m,column:f}=M.Position.from(d);u.push({startLineNumber:m,startColumn:f,endLineNumber:m,endColumn:f})}}return p.$tryInsertSnippet(l,r.value.version,h.value,u,s)},setDecorations(h,i){const s=i.length===0;s&&!c.h.has(h.key)||(s?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(M.$5M(i))return p.$trySetDecorations(l,h.key,M.$6M(i));{const u=new Array(4*i.length);for(let d=0,m=i.length;d<m;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return p.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>p.$tryRevealRange(l,M.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,M.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const b=p.edits.map(o=>o.range);b.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=b.length-1;o<t;o++){const n=b[o].end;if(b[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=p.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,r,{setEndOfLine:typeof p.setEndOfLine=="number"?M.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$eN=A}),define(Pe[224],Re([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,132,23]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;function t(c,h){if((0,A.$Hf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends R.$Tc{constructor(h,i,s){super(),this.f=h,this.g=i,this.h=s,this.a=new Map,this.b=new r.$f8;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(m=>u(m)?this.r(m):m):d})}registerTreeDataProvider(h,i,s){const u=this.createTreeView(h,{treeDataProvider:i},s);return{dispose:()=>u.dispose()}}createTreeView(h,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],m=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,S=this.m(h,i,s),L={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:m,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,L),y={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$BF)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$BF)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(D){(0,p.$ik)(D)&&(0,o.$BF)(s,"treeViewMarkdownMessage"),S.message=D},get title(){return S.title},set title(D){S.title=D},get description(){return S.description},set description(D){S.description=D},get badge(){return S.badge},set badge(D){D!==void 0&&w.ViewBadge.isViewBadge(D)?S.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(S.badge=void 0)},reveal:(D,N)=>S.reveal(D,N),dispose:async()=>{await v,this.a.delete(h),S.dispose()}};return this.B(y),y}$getChildren(h,i){const s=this.a.get(h);return s?s.getChildren(i):Promise.reject(new $.$_E(h))}async $handleDrop(h,i,s,u,d,m,f,S){const L=this.a.get(h);if(!L)return Promise.reject(new $.$_E(h));const v=l.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&S&&await this.j(v,L,S,d,m),L.onDrop(v,u,d)}async j(h,i,s,u,d){const m=this.b.removeDragOperationTransfer(d);if(m)(await m)?.forEach((f,S)=>{f&&h.set(S,f)});else if(d&&i.handleDrag){const f=i.handleDrag(s,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,s,u){const d=this.a.get(h);if(!d)return Promise.reject(new $.$_E(h));const m=await this.j(new w.$XL,d,i,u,s);if(!(!m||u.isCancellationRequested))return l.DataTransfer.from(m)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new $.$_E(h);return i.hasResolve}$resolve(h,i,s){const u=this.a.get(h);if(!u)throw new $.$_E(h);return u.resolveTreeItem(i,s)}$setExpanded(h,i,s){const u=this.a.get(h);if(!u)throw new $.$_E(h);u.setExpanded(i,s)}$setSelectionAndFocus(h,i,s){const u=this.a.get(h);if(!u)throw new $.$_E(h);u.setSelectionAndFocus(i,s)}$setVisible(h,i){const s=this.a.get(h);if(!s){if(!i)return;throw new $.$_E(h)}s.setVisible(i)}$changeCheckboxState(h,i){const s=this.a.get(h);if(!s)throw new $.$_E(h);s.setCheckboxState(i)}m(h,i,s){const u=this.B(new a(h,i,this.f,this.g.converter,this.h,s));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$Thc=n;class a extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Qf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,s,u,d,m){if(super(),this.I=h,this.J=s,this.L=u,this.M=d,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Ud),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Ud),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Ud),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Ud),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Ud),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Ud),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Ud),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$5d,m.contributes&&m.contributes.views)for(const v in m.contributes.views)for(const y of m.contributes.views[v])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let f,S;const L=M.Event.debounce(this.F.event,(v,y)=>(v||(v={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(D=>S=D),this.G=this.G.then(()=>f)),Array.isArray(y.element)?v.elements.push(...y.element):v.elements.push(y.element)),y.message&&(v.message=!0),v),200,!0);this.B(L(({message:v,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=S;return f=null,this.$(y).then(()=>D())})),v&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(i)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const s=(0,A.$Qf)(i.select)?!0:i.select,u=(0,A.$Qf)(i.focus)?!1:i.focus,d=(0,A.$Qf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(m=>this.W(h,m[m.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:m.map(S=>S.item)},{select:s,focus:u,expand:d})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:s,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const s=this.getExtensionElement(h);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,i){const s=!(0,k.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,i,s){const u=[];for(const d of h){const m=this.getExtensionElement(d);m&&u.push(m)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,s){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Xg)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const u=this.m.get(s);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,s,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Xg)(()=>this.f.getParent(h))}W(h,i){const s=this.m.get(h);return s?Promise.resolve(s):(0,g.$Xg)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const m=this.m.get(d);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const s=this.getExtensionElement(h);i=s?this.m.get(s):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new b.$5d(this.Z.token);try{const s=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=(0,k.$Hb)(u||[]),m=await Promise.all((0,k.$Hb)(d).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const f=m.map((S,L)=>S?this.db(d[L],S,s):null);return(0,k.$Hb)(f)}finally{i.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new b.$5d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const i=new Set,s=h.map(d=>this.m.get(d));for(const d of s)if(d&&!i.has(d.item.handle)){let m=d;for(;m&&m.parent&&s.findIndex(f=>m&&m.parent&&f&&f.item.handle===m.parent.item.handle)===-1;){const f=this.j.get(m.parent.item.handle);m=f?this.m.get(f):void 0}m&&!m.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const m=this.j.get(d);if(m){const f=this.m.get(m);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(s=>this.cb(s).then(u=>{u&&(i[s]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,g.$Xg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,s.parent);return this.pb(i,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,s){const u=this.ib(h,i,s);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,s),u}eb(h){return w.$uL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,s,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,s=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:u}}hb(h){if(!w.$SL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,s){this.hb(i);const u=this.B(new R.$Sc),d=this.kb(h,i,s),m=this.lb(i);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:m,iconDark:this.mb(i)||m,themeIcon:this.jb(i),collapsibleState:(0,A.$Qf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$1L?h.iconPath:void 0}kb(h,{id:i,label:s,resourceUri:u},d,m){if(i)return`${a.b}/${i}`;const f=t(s,this.N),S=d?d.item.handle:a.a;let L=f?f.label:u?(0,T.$Dg)(u):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let D,N=0;do{if(D=`${S}/${N}:${L}`,m||!this.j.has(D)||v===D)break;N++}while(N<=y.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$1L))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$1L)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,s,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,i);const d=this.X(u)||[],m=d.filter(f=>f.item.handle===s.item.handle)[0];m&&d.splice(d.indexOf(m),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[225],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[226],Re([1,0,178,15,31,97,73,30,22,225,188,101]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=void 0;const l=$.$Gn.as(R.$Hn.JSONContribution);class p{constructor(h,i,s){this.a=h,this.b=i,this.c=s}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$pF=p;class b{static a(h){const i=new g.$lm;for(let s=0,u=h.length;s<u;s++)i.add(h[s].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new b(i,[]);if(!i||!i.length)return new b([],h);const s=this.a(h),u=this.a(i),d=i.filter(f=>!s.has(f.description.identifier)),m=h.filter(f=>!u.has(f.description.identifier));return new b(d,m)}constructor(h,i){this.added=h,this.removed=i}}e.$qF=b;class r{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=b.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$rF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$sF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$jm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$lo}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$lo}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&k.$gF.register(h.extensionPoint,h.activationEventsGenerator),e.$sF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$sF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$tF=n;const a={ExtensionsRegistry:"ExtensionsRegistry"};$.$Gn.add(a.ExtensionsRegistry,new n),e.$uF=$.$Gn.as(a.ExtensionsRegistry),l.registerSchema(t,e.$sF),l.registerSchema(A.$Fj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[227],Re([1,0,174,16,26,226,35,5]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function p(b,r,o){if(!b)return;const t=T.$Hf(b.type)?b.type:void 0;if(!t||t.length===0){o.error(E.localize(3,null));return}const n=[];if(Array.isArray(b.required))for(const a of b.required)T.$Hf(a)&&n.push(a);return{extensionId:r.value,taskType:t,required:n,properties:b.properties?C.$un(b.properties):{},when:b.when?R.$3i.deserialize(b.when):void 0}}l.from=p})(w||(w={}));const A=M.$uF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const b of l)b.type&&p.push(`onTaskType:${b.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new $.$Ud,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,b)=>{A.setHandler((r,o)=>{this.c=void 0;try{for(const t of o.removed){const n=t.value;for(const a of n)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const t of o.added){const n=t.value;for(const a of n){const c=w.from(a,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const b of this.all()){const r={type:"object",additionalProperties:!1};b.required.length>0&&(r.required=b.required.slice(0)),b.properties!==void 0?r.properties=C.$un(b.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[b.taskType]},p.push(r)}this.c={oneOf:p}}return this.c}}e.$wG=new k}),define(Pe[228],Re([1,0,175,16,25,26,35,227]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$GG=e.JsonSchemaVersion=e.ExecutionEngine=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$AG=e.ShellQuoting=e.$zG=e.$yG=e.$xG=void 0,e.$xG="settings",e.$yG=new R.$jj("taskRunning",!1,E.localize(0,null)),e.$zG={value:E.localize(1,null),original:"Tasks"};var g;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$AG="$customized",function(P){function I(K){if(!K)return P.Strong;switch(K.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=I}(g||(e.ShellQuoting=g={}));var w;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(A||(e.RevealKind=A={})),function(P){function I(K){switch(K.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=I}(A||(e.RevealKind=A={}));var k;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(P){function I(K){switch(K.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=I}(k||(e.RevealProblemKind=k={}));var l;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(l||(e.PanelKind=l={})),function(P){function I(K){switch(K.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=I}(l||(e.PanelKind=l={}));var p;(function(P){P.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var b;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(P){function I(ae){switch(ae.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=I;function K(ae){switch(ae){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=K}(b||(e.RuntimeType=b={}));var r;(function(P){function I(K){return T.$Hf(K)?K:K.value}P.value=I})(r||(e.CommandString=r={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function I(ae){return ae===P.Clean._id||ae===P.Build._id||ae===P.Rebuild._id||ae===P.Test._id}P.is=I;function K(ae){if(ae!==void 0)return T.$Hf(ae)?I(ae)?{_id:ae,isDefault:!1}:void 0:ae}P.from=K})(o||(e.TaskGroup=o={}));var t;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function I(K){switch(K){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=I})(n||(e.TaskSourceKind=n={}));var a;(function(P){P.parallel="parallel",P.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(I,K,ae,he,be,De){this._label="",this._id=I,K&&(this._label=K),ae&&(this.type=ae),this.runOptions=he,this.configurationProperties=be,this._source=De}getDefinition(I){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const I={folder:this.d(),id:this._id};return JSON.stringify(I)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(I,K=!1){if(I===void 0)return!1;if(T.$Hf(I))return I===this._label||I===this.configurationProperties.identifier||K&&I===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===I._key}getQualifiedLabel(){const I=this.getWorkspaceFolder();return I?`${this._label} (${I.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(I){this.c===void 0&&(this.c=[]),I&&(this.c=this.c.concat(I))}get taskLoadMessages(){return this.c}}e.$BG=i;class s extends i{constructor(I,K,ae,he,be,De,le,ve){super(I,ae,void 0,le,ve,K),this.command={},this._source=K,this.hasDefinedMatchers=De,be&&(this.command=be)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(I=!1){if(I&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case b.Shell:K="shell";break;case b.Process:K="process";break;case b.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(I){return I instanceof s}getMapKey(){const I=this._source.config.workspaceFolder;return I?`${I.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$xG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const I=this.d();if(!I)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ae={type:e.$AG,folder:I,id:K};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Dg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(I){return new s(I._id,I._source,I._label,I.type,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$CG=s;class u extends i{constructor(I,K,ae,he,be,De,le){super(I,ae,he,De,le,K),this._source=K,this.configures=be}static is(I){return I instanceof u}f(I){return I}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Dg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$xG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const I=this.d();if(!I)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ae={type:e.$AG,folder:I,id:K};return JSON.stringify(ae)}}e.$DG=u;class d extends i{constructor(I,K,ae,he,be,De,le,ve,se){super(I,ae,he,ve,se,K),this.defines=be,this.hasDefinedMatchers=le,this.command=De,this.icon=se.icon,this.hide=se.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(I){return I instanceof d}getMapKey(){const I=this._source.workspaceFolder;return I?`${this._source.scope.toString()}|${I.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const I={type:"contributed",scope:this._source.scope,id:this._id};return I.folder=this.d(),JSON.stringify(I)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(I){return new d(I._id,I._source,I._label,I.type,I.defines,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$EG=d;class m extends i{constructor(I,K,ae,he,be,De){super(I,ae,he,be,De,K),this._source=K}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(I){return I instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(I){return new m(I._id,I._source,I._label,I.type,I.runOptions,I.configurationProperties)}}e.$FG=m;var f;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(P){P._default=P.Terminal}(f||(e.ExecutionEngine=f={}));var S;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(I){this.c=new Map;for(let K=0;K<I.length;K++)this.c.set(I[K].uri.toString(),K)}compare(I,K){const ae=I.getWorkspaceFolder(),he=K.getWorkspaceFolder();if(ae&&he){let be=this.c.get(ae.uri.toString());be=be===void 0?0:be+1;let De=this.c.get(he.uri.toString());return De=De===void 0?0:De+1,be===De?I._label.localeCompare(K._label):be-De}else return!ae&&he?-1:ae&&!he?1:0}}e.$GG=L;var v;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(v||(e.TaskEventKind=v={}));var y;(function(P){P.SingleRun="singleRun",P.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var N;(function(P){function I(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function K(ve,se,we){return{...I(ve),kind:"start",terminalId:se,resolvedVariables:we}}P.start=K;function ae(ve,se,we){return{...I(ve),kind:"processStarted",terminalId:se,processId:we}}P.processStarted=ae;function he(ve,se,we){return{...I(ve),kind:"processEnded",terminalId:se,exitCode:we}}P.processEnded=he;function be(ve,se,we){return{...I(ve),kind:"terminated",exitReason:we,terminalId:se}}P.terminated=be;function De(ve,se,we){return{...I(se),kind:ve,terminalId:we}}P.general=De;function le(){return{kind:"changed"}}P.changed=le})(N||(e.TaskEvent=N={}));var O;(function(P){function I(ae){const he=Object.keys(ae).sort();let be="";for(const De of he){let le=ae[De];le instanceof Object?le=I(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),be+=De+","+le+","}return be}function K(ae){const be={_key:I(ae),type:ae.taskType};return Object.assign(be,ae),be}P.create=K})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var W;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var U;(function(P){function I(K,ae){const he=$.$wG.get(K.type);if(he===void 0){const ve=M.$un(K);return delete ve._key,O.create(ve)}const be=Object.create(null);be.type=he.taskType;const De=new Set;he.required.forEach(ve=>De.add(ve));const le=he.properties;for(const ve of Object.keys(le)){const se=K[ve];if(se!=null)be[ve]=se;else if(De.has(ve)){const we=le[ve];if(we.default!==void 0)be[ve]=M.$un(we.default);else switch(we.type){case"boolean":be[ve]=!1;break;case"number":case"integer":be[ve]=0;break;case"string":be[ve]="";break;default:ae.error(E.localize(2,null,JSON.stringify(K,void 0,0),ve));return}}}return O.create(be)}P.createTaskIdentifier=I})(U||(e.TaskDefinition=U={}))}),define(Pe[229],Re([1,0,15]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$1)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$97b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$07b=C}),define(Pe[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sv=e.$Rv=e.$Qv=e.$Pv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Pv=E;const T=[];function C($){const g=new E($);return T[g.nid]=g,g}e.$Qv=C;function M($){return T[$].sid}e.$Rv=M;class R{constructor(g){this.value=g}}e.$Sv=R}),define(Pe[3],Re([1,0,49]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.$4K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$3K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var M;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var g;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(o){return o._id=k.a++,o}}e.$3K=k;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var b;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$4K={MainThreadAuthentication:(0,E.$Qv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Qv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Qv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Qv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Qv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Qv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Qv)("MainThreadCommands"),MainThreadComments:(0,E.$Qv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Qv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Qv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Qv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Qv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Qv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Qv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Qv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Qv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Qv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Qv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Qv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Qv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Qv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Qv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Qv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Qv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Qv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Qv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Qv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Qv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Qv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Qv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Qv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Qv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Qv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Qv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Qv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Qv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Qv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Qv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Qv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Qv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Qv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Qv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Qv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Qv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Qv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Qv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Qv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Qv)("MainThreadSCM"),MainThreadSearch:(0,E.$Qv)("MainThreadSearch"),MainThreadShare:(0,E.$Qv)("MainThreadShare"),MainThreadTask:(0,E.$Qv)("MainThreadTask"),MainThreadWindow:(0,E.$Qv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Qv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Qv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Qv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Qv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Qv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Qv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Qv)("MainThreadInteractive"),MainThreadChat:(0,E.$Qv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Qv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Qv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Qv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Qv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Qv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Qv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Qv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Qv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Qv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Qv)("MainThreadIssueReporter")},e.$5K={ExtHostCommands:(0,E.$Qv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Qv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Qv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Qv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Qv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Qv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Qv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Qv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Qv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Qv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Qv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Qv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Qv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Qv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Qv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Qv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Qv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Qv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Qv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Qv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Qv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Qv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Qv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Qv)("ExtHostSCM"),ExtHostSearch:(0,E.$Qv)("ExtHostSearch"),ExtHostTask:(0,E.$Qv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Qv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Qv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Qv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Qv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Qv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Qv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Qv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Qv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Qv)("ExtHostProgress"),ExtHostComments:(0,E.$Qv)("ExtHostComments"),ExtHostSecretState:(0,E.$Qv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Qv)("ExtHostStorage"),ExtHostUrls:(0,E.$Qv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Qv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Qv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Qv)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Qv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Qv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Qv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Qv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Qv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Qv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Qv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Qv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Qv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Qv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Qv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Qv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Qv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Qv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Qv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Qv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Qv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Qv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Qv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Qv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Qv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Qv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Qv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Qv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Qv)("ExtHostIssueReporter")}}),define(Pe[230],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$4K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(R);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation($,g)??[]}getRelatedInformation(R,$,g){return this.c.$getAiRelatedInformation($,g)}registerRelatedInformationProvider(R,$,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,$),new T.$6K(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$Tfc=C}),define(Pe[81],Re([1,0,4,14,3,17]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=e.$Zfc=void 0,e.$Zfc=(0,E.$5h)("IExtHostApiDeprecationService");let R=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(C.$4K.MainThreadTelemetry)}report(g,w,A){const k=this.d(g,w);this.a.has(k)||(this.a.add(k),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$1fc=R,e.$1fc=R=Je([He(0,M.$8M),He(1,T.$mj)],R),e.$2fc=Object.freeze(new class{report($,g,w){}})}),define(Pe[231],Re([1,0,5,3,7,22]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class R{constructor(w){this.b=new Map,this.c=new E.$Ud,this.onDidChangeSessions=this.c.event,this.d=new $,this.f=new $,this.a=w.getProxy(T.$4K.MainThreadAuthentication)}async getSession(w,A,k,l={}){const p=M.$km.toKey(w.identifier),b=[...k].sort().join(" ");return await this.d.getOrCreate(`${p} ${A} ${b}`,async()=>{await this.a.$ensureProvider(A);const r=w.displayName||w.name;return this.a.$getSession(A,k,p,r,l)})}async getSessions(w,A,k){const l=M.$km.toKey(w.identifier),p=[...k].sort().join(" ");return await this.f.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const b=w.displayName||w.name;return this.a.$getSessions(A,k,l,b)})}async removeSession(w,A){const k=this.b.get(w);return k?k.provider.removeSession(A):this.a.$removeSession(w,A)}registerAuthenticationProvider(w,A,k,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:A,provider:k,options:l??{supportsMultipleAccounts:!1}});const p=k.onDidChangeSessions(b=>this.a.$sendDidChangeSessions(w,b));return this.a.$registerAuthenticationProvider(w,A,l?.supportsMultipleAccounts??!1),new C.$6K(()=>{p.dispose(),this.b.delete(w),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,A,k){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this.c.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.$5fc=R;class ${constructor(){this.a=new Map}getOrCreate(w,A){const k=this.a.get(w);if(k)return k;const l=A().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Pe[232],Re([1,0,3,17,8]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;let M=class{constructor($,g){this.a=$.getProxy(E.$4K.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,g,w){const A=C.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$6fc=M,e.$6fc=M=Je([He(0,T.$8M)],M)}),define(Pe[233],Re([1,0,67,6,3,8]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class R{static{this.a=0}constructor(w,A){this.extension=w,this.provider=A,this.handle=R.a++}}class ${static{this.a=0}constructor(w){this.b=new Map,this.c=new Map,this.d=w.getProxy(C.$4K.MainThreadChat)}registerChatProvider(w,A,k){const l=new R(w,k);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,A),(0,T.$Rc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(w,A){const k=E.Iterable.find(this.c.keys(),l=>this.c.get(l)===w)??0;typeof k=="number"&&this.d.$transferChatSession(k,A)}sendInteractiveRequestToProvider(w,A){this.d.$sendRequestToProvider(w,A)}async $prepareChat(w,A){const k=this.b.get(w);if(!k)return;const l=await k.provider.prepareSession(A);if(!l)return;const p=$.a++;return this.c.set(p,l),{id:p,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(w,A){const k=this.b.get(w);if(!k||!k.provider.provideWelcomeMessage)return;const l=await k.provider.provideWelcomeMessage(A);if(l)return l.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(b=>M.ChatReplyFollowup.from(b)):M.MarkdownString.from(p))}async $provideSampleQuestions(w,A){const k=this.b.get(w);if(!k||!k.provider.provideSampleQuestions)return;const l=await k.provider.provideSampleQuestions(A);if(l)return l?.map(p=>M.ChatReplyFollowup.from(p))}$releaseSession(w){this.c.delete(w)}}e.$7fc=$}),define(Pe[234],Re([1,0,13,20,40,5,60,16,2,157,72,3,8,7,205,23]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class o{static{this.a=0}constructor(a,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(k.$4K.MainThreadChatAgents2)}createChatAgent(a,c,h){const i=o.a++,s=new t(a,c,this.d,i,h);return this.b.set(i,s),this.d.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(a,c,h,i,s,u){this.g.delete(c);const d=this.b.get(a);if(!d)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let m=!1;function f(){if(m)throw new Error("Only valid while executing the command")}const S=new E.$ph;u.onCancellationRequested(()=>S.complete()),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const L=i.command?await d.validateSlashCommand(i.command):void 0,v=R.$Qd.create(!1);let y;try{const D=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:L},{history:s.history.map(l.ChatMessage.to)},new A.$uv(N=>{f(),typeof y>"u"&&"content"in N&&(y=v.elapsed());const O=l.ChatResponseProgress.from(d.extension,N);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const G=Promise.all([this.d.$handleProgressChunk(h,O),N.resolvedContent]);(0,E.$Tg)(G,u).then(W=>{if(!W)return;const[U,P]=W,I=l.ChatResponseProgress.from(d.extension,P);if(!I){this.j.error("Unknown progress type: "+JSON.stringify(P));return}this.d.$handleProgressChunk(h,I,U??void 0)})}else this.d.$handleProgressChunk(h,O)}),u);return await(0,E.$Tg)(Promise.resolve(D).then(N=>{if(N){this.g.set(c,N);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,N);const G={firstProgress:y,totalElapsed:v.elapsed()};return{errorDetails:N.errorDetails,timings:G}}else this.g.delete(c)}),u)}catch(D){return this.j.error(D,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,C.$Pi)(D)),responseIsIncomplete:!0}}}finally{m=!0,S.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,c){const h=this.b.get(a);return h?h.provideSlashCommand(c):[]}$provideFollowups(a,c,h){const i=this.b.get(a);if(!i)return Promise.resolve([]);const s=this.g.get(c);return s?i.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(a,c,h,i,s){const u=this.b.get(a);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let m;switch(i){case b.InteractiveSessionVoteDirection.Down:m=p.ChatAgentResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:m=p.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(s?{result:d,kind:m,reportIssue:s}:{result:d,kind:m}))}$acceptAction(a,c,h,i){const s=this.b.get(a);if(!s)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(a,c,h){const i=this.b.get(a);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$9fc=o;class t{constructor(a,c,h,i,s){this.extension=a,this.t=c,this.u=h,this.w=i,this.x=s,this.o=new M.$Ud,this.q=new M.$Ud}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,c){return this.s?await this.s.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Rf)(this.b));const c=this.b.find(h=>h.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this.a)return[];const c=await this.a.provideSlashCommands(a);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,c){if(!this.d)return[];const h=await this.d.provideFollowups(a,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const h=()=>{a||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$1L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(s){i.g=s,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(s){i.h=s,h()},get iconPath(){return i.i},set iconPath(s){i.i=s,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(s){i.a=s,h()},get followupProvider(){return i.d},set followupProvider(s){i.d=s,h()},get isDefault(){return(0,r.$BF)(i.extension,"defaultChatAgent"),i.j},set isDefault(s){(0,r.$BF)(i.extension,"defaultChatAgent"),i.j=s,h()},get helpTextPrefix(){return(0,r.$BF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(s){if((0,r.$BF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=s,h()},get helpTextPostfix(){return(0,r.$BF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(s){if((0,r.$BF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=s,h()},get isSecondary(){return(0,r.$BF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(s){(0,r.$BF)(i.extension,"defaultChatAgent"),i.n=s,h()},get sampleRequest(){return i.m},set sampleRequest(s){i.m=s,h()},get supportIssueReporting(){return(0,r.$BF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(s){(0,r.$BF)(i.extension,"chatAgents2Additions"),i.r=s,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(s){if(i.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,s.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,r.$AF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(a,c,h,i){return this.x(a,c,h,i)}}}),define(Pe[235],Re([1,0,20,6,3,8,72,22,13,5]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class A{constructor(b,r){this.stream=new g.$vh,this.stream=r??new g.$vh;const o=this;this.apiObj={option:b,response:o.stream.asyncIterable}}}class k{constructor(b,r){this.a=new w.$Ud,this.b=new Map,this.c=new g.$vh,this.d=!1;const o=this;this.apiObject={result:b,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){r.cancel()}},b.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(b){if(this.d)return;let r=this.b.get(b.index);r||(this.b.size===0?r=new A(b.index,this.c):r=new A(b.index),this.b.set(b.index,r),this.a.fire(r.apiObj)),r.stream.emitOne(b.part)}}class l{static{this.a=1}constructor(b,r){this.d=r,this.c=new Map,this.e=new Map,this.f=new $.$mm,this.b=b.getProxy(C.$4K.MainThreadChatProvider)}registerProvider(b,r,o,t){const n=l.a++;return this.c.set(n,{extension:b,provider:o}),this.b.$registerProvider(n,r,{extension:b,model:t.name??""}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(b,r,o,t,n){const a=this.c.get(b);if(!a)return;const c=new R.$uv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(M.ChatMessage.to),t,c,n)}allowListExtensionWhile(b,r){this.f.set(b,r),r.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,r){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(r);if(!o)throw new Error(`ChatAccess '${r}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t.f.has(b)},makeRequest(n,a,c){if(!t.f.has(b))throw new Error("Access to chat has been revoked");const h=new E.$5d(c),i=Math.random()*1e6|0,s=t.b.$fetchResponse(b,r,i,n.map(M.ChatMessage.from),a??{},h.token),u=new k(s,h);return t.e.set(i,{res:u}),s.finally(()=>{t.e.delete(i)}),u.apiObject}}}async $handleResponseFragment(b,r){const o=this.e.get(b);o&&o.res.handleFragment(r)}}e.$8fc=l}),define(Pe[236],Re([1,0,6,3,15,8]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$4K.MainThreadChatVariables)}async $resolveVariable(g,w,A){const k=this.b.get(g);if(k)try{const l=await k.resolver.resolve(k.data.name,{message:w},A);if(l)return l.map(M.ChatVariable.from)}catch(l){(0,C.$2)(l)}}registerVariableResolver(g,w,A,k){const l=R.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:A},resolver:k}),this.c.$registerVariable(l,{name:w,description:A}),(0,E.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$0fc=R}),define(Pe[237],Re([1,0,3]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class T{constructor(M){const R=M.getProxy(E.$4K.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$$fc=T}),define(Pe[32],Re([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=void 0;let u=class{#e;#t;#i;constructor(v,y,D){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$4K.MainThreadCommands),this.d=y,this.#i=D,this.#t=v.getProxy(R.$4K.MainThreadTelemetry),this.converter=new d(this,N=>{const O=this.c.get(N);return O?.result===f.Void?O:void 0},y),this.f=[{processArgument(N){return(0,w.$Bh)(N)}},{processArgument(N){return(0,M.$wn)(N,function(O){if(A.$Ts.isIRange(O))return C.Range.to(O);if(k.$Ss.isIPosition(O))return C.Position.to(O);if(A.$Ts.isIRange(O.range)&&l.URI.isUri(O.uri))return C.location.to(O);if(O instanceof t.$ie)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const y=this.registerCommand(!1,v.id,async(...D)=>{const N=v.args.map((G,W)=>{if(!G.validate(D[W]))throw new Error(`Invalid argument '${G.name}' when running '${v.id}', received: ${typeof D[W]=="object"?JSON.stringify(D[W],null,"	"):D[W]} `);return G.convert(D[W])}),O=await this.executeCommand(v.internalId,...N);return v.result.convert(O,D,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$6K(()=>{y.dispose(),this.c.delete(v.id)})}registerCommand(v,y,D,N,O,G){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:N,metadata:O,extension:G}),v&&this.#e.$registerCommand(y),new T.$6K(()=>{this.b.delete(y)&&v&&this.#e.$unregisterCommand(y)})}executeCommand(v,...y){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,y,!0)}async g(v,y,D){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,y,!1);{let N=!1;const O=(0,M.$wn)(y,function(G){if(G instanceof T.$7K)return C.Position.from(G);if(G instanceof T.$8K)return C.Range.from(G);if(G instanceof T.$fL)return C.location.from(G);if(T.$rM.isNotebookRange(G))return C.NotebookRange.from(G);if(G instanceof ArrayBuffer)return N=!0,t.$ie.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return N=!0,t.$ie.wrap(G);if(G instanceof t.$ie)return N=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(v,N?new n.$Sv(O):O,D);return(0,w.$Bh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(v,y,!1);throw G}}}async h(v,y,D){const N=this.b.get(v);if(!N)throw new Error("Unknown command");const{callback:O,thisArg:G,metadata:W}=N;if(W?.args)for(let P=0;P<W.args.length;P++)try{(0,E.$Yf)(y[P],W.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${W.args[P].name}' - ${W.args[P].description}`)}const U=c.$Qd.create();try{return await O.apply(G,y)}catch(P){if(v===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...y);I&&(v=I.command)}if(this.d.error(P,v,N.extension?.identifier),!D)throw P;if(N.extension?.identifier){const I=this.#i.onExtensionError(N.extension.identifier,P);this.d.trace("forwarded error to extension?",I,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Pi)(P)),this.id=v,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,v,U.elapsed())}}j(v,y,D){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new h.$Jo(y),duration:D})}$executeContributedCommand(v,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const D=this.b.get(v);return D?(y=y.map(N=>this.f.reduce((O,G)=>G.processArgument(O,D.extension?.identifier),N)),this.h(v,y,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(y=>(v&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[y,D]of this.b){const{metadata:N}=D;N&&(v[y]=N)}return Promise.resolve(v)}};e.$qN=u,e.$qN=u=Je([He(0,r.$8M),He(1,g.$mj),He(2,i.$pN)],u),e.$rN=(0,b.$5h)("IExtHostCommands");class d{constructor(v,y,D){this.d=v,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,s.$pg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,y){if(!v)return;const D={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return D;const N=this.f(v.command);if(N)D.id=N.internalId,D.arguments=N.args.map((O,G)=>O.convert(v.arguments&&v.arguments[G]));else if((0,$.$Lb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),y.add((0,p.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return D}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const y=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$sN=d;class m{static{this.Uri=new m("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v)}static{this.Position=new m("position","A position in a text document",v=>T.$7K.isPosition(v),C.Position.from)}static{this.Range=new m("range","A range in a text document",v=>T.$8K.isRange(v),C.Range.from)}static{this.Selection=new m("selection","A selection in a text document",v=>T.$9K.isSelection(v),C.Selection.from)}static{this.Number=new m("number","",v=>typeof v=="number",v=>v)}static{this.String=new m("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=m.Arr(m.String)}static Arr(v){return new m(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,y=>Array.isArray(y)&&y.every(D=>v.validate(D)),y=>y.map(D=>v.convert(D)))}static{this.CallHierarchyItem=new m("item","A call hierarchy item",v=>v instanceof T.$qL,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new m("item","A type hierarchy item",v=>v instanceof T.$KM,C.TypeHierarchyItem.from)}static{this.TestItem=new m("testItem","A VS Code TestItem",v=>v instanceof o.$iN,C.TestItem.from)}constructor(v,y,D,N){this.name=v,this.description=y,this.validate=D,this.convert=N}optional(){return new m(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,y){return new m(v??this.name,y??this.description,this.validate,this.convert)}}e.$tN=m;class f{static{this.Void=new f("no result",v=>v)}constructor(v,y){this.description=v,this.convert=y}}e.$uN=f;class S{constructor(v,y,D,N,O){this.id=v,this.internalId=y,this.description=D,this.args=N,this.result=O}}e.$vN=S}),define(Pe[238],Re([1,0,18,12,2,80,96,35,32,8,7]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;const k=[new g.$vN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of DocumentHighlight-instances.",p(w.DocumentHighlight.to))),new g.$vN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$tN.Uri],new g.$uN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,E.$Kb)(r))return;class t extends A.$lL{static to(a){const c=new t(a.name,w.SymbolKind.to(a.kind),a.containerName||"",new A.$fL(o[0],w.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=w.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return r.map(t.to)})),new g.$vN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$tN.Uri,new g.$tN("options","Formatting options",r=>!0,r=>r)],new g.$uN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$vN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$tN.Uri,g.$tN.Range,new g.$tN("options","Formatting options",r=>!0,r=>r)],new g.$uN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$vN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$tN.Uri,g.$tN.Position,new g.$tN("ch","Trigger character",r=>typeof r=="string",r=>r),new g.$tN("options","Formatting options",r=>!0,r=>r)],new g.$uN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$vN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$vN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$vN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$vN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$vN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of Location-instances.",p(w.location.to))),new g.$vN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of Hover-instances.",p(w.Hover.to))),new g.$vN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$tN.Uri,new g.$tN("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.$7K.isPosition(o)),r=>r.map(w.Position.from))],new g.$uN("A promise that resolves to an array of ranges.",r=>r.map(o=>{let t;for(const n of o.reverse())t=new A.$pL(w.Range.to(n),t);return t}))),new g.$vN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$tN.String.with("query","Search string")],new g.$uN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(w.WorkspaceSymbol.to))),new g.$vN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(w.CallHierarchyItem.to))),new g.$vN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$tN.CallHierarchyItem],new g.$uN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(w.CallHierarchyIncomingCall.to))),new g.$vN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$tN.CallHierarchyItem],new g.$uN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(w.CallHierarchyOutgoingCall.to))),new g.$vN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:w.Range.to(r.range),placeholder:r.text}})),new g.$vN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$tN.Uri,g.$tN.Position,g.$tN.String.with("newName","The new symbol name")],new g.$uN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return w.WorkspaceEdit.to(r)}})),new g.$vN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$tN.Uri,g.$tN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$uN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(w.DocumentLink.to))),new g.$vN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$tN.Uri],new g.$uN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$jM(r.tokenTypes,r.tokenModifiers)})),new g.$vN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$tN.Uri],new g.$uN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$p$)(r);if(o.type==="full")return new A.$lM(o.data,void 0)})),new g.$vN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$tN.Uri,g.$tN.Range.optional()],new g.$uN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$jM(r.tokenTypes,r.tokenModifiers)})),new g.$vN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$tN.Uri,g.$tN.Range],new g.$uN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$p$)(r);if(o.type==="full")return new A.$lM(o.data,void 0)})),new g.$vN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$tN.Uri,g.$tN.Position,g.$tN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$tN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$uN("A promise that resolves to a CompletionList-instance.",(r,o,t)=>{if(!r)return new A.$BL([]);const n=r.suggestions.map(a=>w.CompletionItem.to(a,t));return new A.$BL(n,r.incomplete)})),new g.$vN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$tN.Uri,g.$tN.Position,g.$tN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$uN("A promise that resolves to SignatureHelp.",r=>{if(r)return w.SignatureHelp.to(r)})),new g.$vN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$tN.Uri,g.$tN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$uN("A promise that resolves to an array of CodeLens-instances.",(r,o,t)=>p(n=>new A.$tL(w.Range.to(n.range),n.command&&t.fromInternal(n.command)))(r))),new g.$vN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$tN.Uri,new g.$tN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$8K.isRange(r),r=>A.$9K.isSelection(r)?w.Selection.from(r):w.Range.from(r)),g.$tN.String.with("kind","Code action kind to return code actions for").optional(),g.$tN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$uN("A promise that resolves to an array of Command-instances.",(r,o,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const a=new A.$nL(n.title,n.kind?new A.$oL(n.kind):void 0);return n.edit&&(a.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(a.command=t.fromInternal(n.command)),a.isPreferred=n.isPreferred,a}})(r))),new g.$vN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$tN.Uri],new g.$uN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.$HL(w.Range.to(o.range),w.Color.to(o.color))):[])),new g.$vN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$tN("color","The color to show and insert",r=>r instanceof A.$GL,w.Color.from),new g.$tN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:w.Range.from(r.range)}))],new g.$uN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(w.ColorPresentation.to):[])),new g.$vN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$tN.Uri,g.$tN.Range],new g.$uN("A promise that resolves to an array of Inlay objects",(r,o,t)=>r.map(w.InlayHint.to.bind(void 0,t)))),new g.$vN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$tN.Uri],new g.$uN("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(w.FoldingRange.to)})),new g.$vN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$uN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>w.NotebookExclusiveDocumentPattern.to(o))})))),new g.$vN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$tN.Uri,g.$tN.Range,new g.$tN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$8K,r=>w.InlineValueContext.from(r))],new g.$uN("A promise that resolves to an array of InlineValue objects",r=>r.map(w.InlineValue.to))),new g.$vN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$tN("uriOrString","Uri-instance or string (only http/https)",r=>C.URI.isUri(r)||typeof r=="string"&&(0,T.$eg)(r,T.Schemas.http,T.Schemas.https),r=>r),new g.$tN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional(),g.$tN.String.with("label","").optional()],g.$uN.Void),new g.$vN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$tN.Uri.with("resource","Resource to open"),g.$tN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$tN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional()],g.$uN.Void),new g.$vN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$tN.Uri.with("left","Left-hand side resource of the diff editor"),g.$tN.Uri.with("right","Right-hand side resource of the diff editor"),g.$tN.String.with("title","Human readable title for the diff editor").optional(),new g.$tN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)]).optional()],g.$uN.Void),new g.$vN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$tN.String.with("title","Human readable title for the changes editor"),new g.$tN("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[t,n,a]=o;if(!C.URI.isUri(t)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},r=>r)],g.$uN.Void),new g.$vN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$tN.Uri,g.$tN.Position],new g.$uN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$vN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$tN.TypeHierarchyItem],new g.$uN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$vN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$tN.TypeHierarchyItem],new g.$uN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$vN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$tN.TestItem],g.$uN.Void),new g.$vN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$tN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$uN.Void),new g.$vN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$tN.String.with("name","The context key name"),new g.$tN("value","The context key value",()=>!0,r=>r)],g.$uN.Void),new g.$vN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$tN.Uri,g.$tN.StringArray,new g.$tN("MappedEditsContext","Mapped Edits Context",r=>w.MappedEditsContext.is(r),r=>w.MappedEditsContext.from(r))],new g.$uN("A promise that resolves to a workspace edit or null",r=>r?w.WorkspaceEdit.to(r):null))];class l{static register(o){k.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",$.$4i)}}e.$4fc=l;function p(r){return o=>{if(Array.isArray(o))return o.map(r)}}function b(r){if(!Array.isArray(r))return;const o=[];for(const t of r)M.$Ft(t)?o.push(w.DefinitionLink.to(t)):o.push(w.location.to(t));return o}}),define(Pe[239],Re([1,0,13,66,5,6,2,80,22,8,7,3,23]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;function p(b,r,o){const t=b.getProxy(k.$4K.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$mm,r.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const S=this.b.get(f.handle);return S?S.value:f}else if(f&&f.$mid===7){const S=this.b.get(f.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.commentThreadHandle);return L?L.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);return L?f.$mid===8?L.value:{thread:L.value,text:f.text}:f}else if(f&&f.$mid===10){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.commentUniqueId,y=L.getCommentByUniqueId(v);return y||f}else if(f&&f.$mid===11){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.text,y=f.commentUniqueId,D=L.getCommentByUniqueId(y);return D?(typeof D.body=="string"?D.body=v:D.body=new A.$uL(v),D):f}return f}})}createCommentController(f,S,L){const v=n.a++,y=new c(f,v,S,L);this.b.set(y.handle,y);const D=this.c.get(f.identifier)||[];return D.push(y),this.c.set(f.identifier,D),y.value}async $createCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(f,S){this.b.get(f)?.$deleteCommentThread(S)}$provideCommentingRanges(f,S,L){const v=this.b.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const y=o.getDocument(R.URI.revive(S));return(0,E.$Xg)(async()=>{const D=await v.commentingRangeProvider.provideCommentingRanges(y,L);let N;return Array.isArray(D)?N={ranges:D,fileComments:!1}:D?N={ranges:D.ranges||[],fileComments:D.fileComments||!1}:N=D??void 0,N}).then(D=>{let N;return D&&(N={ranges:D.ranges.map(O=>w.Range.from(O)),fileComments:D.fileComments}),N})}$toggleReaction(f,S,L,v,y){const D=this.b.get(f);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,E.$Xg)(()=>{const N=D.getCommentThread(S);if(N){const O=N.getCommentByUniqueId(v.uniqueIdInThread);if(D!==void 0&&O&&D.reactionHandler)return D.reactionHandler(O,s(y))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,S,L,v,y,D,N,O){this.m=S,this.n=L,this.o=v,this.p=y,this.q=D,this.extensionDescription=N,this.r=O,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Ud,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Uc,this.l.value=new M.$Sc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(S,this.handle,this.n,this.o,w.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{t.$deleteCommentThread(S,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Sc);const f=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};f("range")&&(S.range=w.Range.from(this.p)),f("label")&&(S.label=this.label),f("contextValue")&&(S.contextValue=this.contextValue??null),f("comments")&&(S.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),f("collapsibleState")&&(S.collapseState=u(this.g)),f("canReply")&&(S.canReply=this.canReply),f("state")&&(S.state=d(this.h)),f("isTemplate")&&(S.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(f){for(const S of this.k){const L=S[0],v=S[1];if(f===v)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Je([(0,T.$xh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,S,L,v){this.f=f,this.g=S,this.h=L,this.i=v,this.a=new Map,t.$registerCommentController(this.handle,L,v,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(D){y.options=D},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(D){y.commentingRangeProvider=D},get reactionHandler(){return y.reactionHandler},set reactionHandler(D){y.reactionHandler=D},createCommentThread(D,N,O){return y.createCommentThread(D,N,O).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,S,L){S===void 0&&(0,l.$BF)(this.f,"fileComments");const v=new a(this.id,this.handle,void 0,f,S,L,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(f,S){const L=new a(this.id,this.handle,void 0,R.URI.revive(f),w.Range.to(S),[],this.f,!0);return L.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(f,S){const L=this.a.get(f);L&&(L.range=w.Range.to(S))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(m,f,S,L){let v=S.get(f);return v||(v=++m.commentHandle,S.set(f,v)),f.state!==void 0&&(0,l.$BF)(L,"commentsDraftState"),f.reactions?.some(y=>y.reactors!==void 0)&&(0,l.$BF)(L,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:v,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(m){return{label:m.label,iconPath:m.iconPath?w.$7M(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted,reactors:m.reactors&&m.reactors.length>0&&typeof m.reactors[0]!="string"?m.reactors.map(f=>f.name):m.reactors}}function s(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?R.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1,reactors:m.reactors?.map(f=>({name:f}))}}function u(m){if(m!==void 0)switch(m){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(m){if(m!==void 0)switch(m){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$bgc=p}),define(Pe[240],Re([1,0,26,3,27,17]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let R=class{constructor(A,k){this.a=A.getProxy(T.$4K.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,k){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,k,p,arguments)}})}e(A,k,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g(p,this.b)}),this.c&&this.f(A,l,p)}};e.$2hc=R,e.$2hc=R=Je([He(0,M.$8M),He(1,C.$lN)],R);const $=1e5;function g(w,A){const k=[];if(w.length)for(let l=0;l<w.length;l++){let p=w[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const b=p;b.stack?p=b.stack:p=b.toString()}k.push(p)}if(A){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$zn)(k);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Re([1,0,2,3,7,4,17,14,18,11,19,23]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(T.$4K.MainThreadDecorations)}registerFileDecorationProvider(r,o){const t=l.c++;this.f.set(t,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(a);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Oe)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,w.$4e)(u.uri.path,d.uri.path)),s=[];e:for(const u of i){let d;for(const m of u){const f=(0,A.$mc)(m.uri.path);if(d!==f&&(d=f,s.push(m.uri)>=l.d))break e}}this.g.$onDidChange(t,s)});return new C.$6K(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(r,o,t){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:a,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:i,id:s}=h,u=await Promise.resolve(a.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{C.$pM.validate(u),u.badge&&typeof u.badge!="string"&&(0,k.$BF)(c,"codiconDecoration"),n[s]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$4gc=p,e.$4gc=p=l=Je([He(0,R.$8M),He(1,$.$mj)],p),e.$5gc=(0,M.$5h)("IExtHostDecorations")}),define(Pe[241],Re([1,0,158,99,2,3,7,8,5,14,28,43]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0;class p{#e;#t;#i;constructor(o,t,n,a,c,h,i,s){this.d=o,this.e=t,this.f=n,this.g=a,this.h=c,this.c=!1,this.f=Math.max(a,n),this.#i=new A.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let n=[];if(C.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(p.k);for(const i of o){const[s,u]=i;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,n.push(s),this.#i.set(s,[])),u)this.#i.get(s)?.push(...u);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const a=[];let c=0;for(const h of n){let i=[];const s=this.#i.get(h);if(s)if(s.length>this.g){i=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const m of s)if(m.severity===u[d]&&i.push({...$.Diagnostic.from(m),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(u=>({...$.Diagnostic.from(u),modelVersionId:this.h(h)}));if(a.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[n,a]of this)o.call(t,n,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$Xfc=p;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const t=new A.$Ac;for(const n of o)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,n,a){this.j=t,this.k=n,this.l=a,this.g=new Map,this.h=new g.$Yd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(M.$4K.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:n,f:a,h:c,j:h,k:i,l:s}=this,u=new class{$changeMany(f,S){a.$changeMany(f,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,S.length===0?"CLEARING":S)}$clear(f){a.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(n.has(d))}return new class extends p{constructor(){super(t,d,l.e,l.d,f=>s.getDocument(f)?.version,i.extUri,u,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,n=[];for(const a of this.g.values())a.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(o){let t=[];for(const n of this.g.values())n.has(o)&&(t=t.concat(n.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of o)this.n.set(C.URI.revive(t),n.map($.Diagnostic.to))}};e.$Yfc=b,e.$Yfc=b=l=Je([He(1,w.$mj),He(2,k.$Wfc)],b)}),define(Pe[242],Re([1,0,2,3,23]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;class M{constructor($){this.a=$.getProxy(T.$4K.MainThreadDialogs)}showOpenDialog($,g){return g?.allowUIResources&&(0,C.$BF)($,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(g=>g?E.URI.revive(g):void 0)}}e.$6gc=M}),define(Pe[243],Re([1,0,15,2,7,3,12,20,11]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class w{static{this.a=0}constructor(k,l,p){this.d=l,this.e=p,this.b=new Map,this.c=k.getProxy(M.$4K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=w.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,k);let b;if(typeof l.onDidChange=="function"){let r;b=l.onDidChange(async o=>{if(o.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const t=this.$provideTextDocumentContent(p,o).then(async n=>{if(!n&&typeof n!="string")return;const a=this.d.getDocument(o);if(!a)return;const c=(0,g.$Ye)(n);if(!a.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(E.$1).finally(()=>{r===t&&(r=void 0)});r=t})}return new C.$6K(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(k,l){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$7gc=w}),define(Pe[244],Re([1,0,5,6,2,3,103,8,16,26,7]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class k{constructor(p,b){this.a=new E.$Ud,this.b=new E.$Ud,this.c=new E.$Ud,this.d=new E.$Ud,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Sc,this.h=new Map,this.f=p.getProxy(M.$4K.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const b=this.g.getDocument(p);if(b)return b}getDocument(p){const b=this.getDocumentData(p);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return b.document}ensureDocumentData(p){const b=this.g.getDocument(p);if(b)return Promise.resolve(b);let r=this.h.get(p.toString());return r||(r=this.f.$tryOpenDocument(p).then(o=>{this.h.delete(p.toString());const t=C.URI.revive(o);return(0,g.$Sf)(this.g.getDocument(t))},o=>(this.h.delete(p.toString()),Promise.reject(o))),this.h.set(p.toString(),r)),r}createDocumentData(p){return this.f.$tryCreateDocument(p).then(b=>C.URI.revive(b))}$acceptModelLanguageChanged(p,b){const r=C.URI.revive(p),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(b),this.a.fire(o.document)}$acceptModelSaved(p){const b=C.URI.revive(p),r=this.g.getDocument(b);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(p,b){const r=C.URI.revive(p),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(b),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,b,r){const o=C.URI.revive(p),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(r),t.onEvents(b);let n;b.isUndoing?n=A.TextDocumentChangeReason.Undo:b.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$vn)({document:t.document,contentChanges:b.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:n}))}setWordDefinitionFor(p,b){(0,R.$0M)(p,b)}}e.$Ufc=k}),define(Pe[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,14,28,12,67,39]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new T.$Ud,this.e=new T.$Ud,this.f=new T.$Ud,this.g=new T.$Ud,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],s=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=M.URI.revive(u),m=this.c.get(d);m?.unref()&&(this.c.delete(d),h.push(m.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=M.URI.revive(u.uri);let m=this.c.get(d);if(m&&d.scheme!==b.Schemas.vscodeNotebookCell&&d.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);m||(m=new t(new g.$$M(this.h.getProxy($.$4K.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,m),i.push(m.value)),m.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&s.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=M.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const m=this.c.get(d).value,f=new A.$eN(u.id,this.h.getProxy($.$4K.MainThreadTextEditors),this.i,new o.$V(()=>m.document),u.selections.map(k.Selection.to),u.options,u.visibleRanges.map(S=>k.Range.to(S)),typeof u.editorPosition=="number"?k.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Oc)(h),(0,C.$Oc)(s),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$fN=n,e.$fN=n=Je([He(0,w.$8M),He(1,l.$mj)],n),e.$gN=(0,R.$5h)("IExtHostDocumentsAndEditors")}),define(Pe[62],Re([1,0,245,5,16,2,4,3,17,8,7]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,R.$5h)("IExtHostEditorTabs");class k{constructor(o,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$LM(M.URI.revive(this.b.input.uri));case 2:return new A.$MM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$NM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$OM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$PM(this.b.input.viewType);case 4:return new A.$QM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$RM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$SM;case 9:return new A.$TM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$UM(this.b.input.providerId);default:return}}}class l{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return w.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new k(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const t=this.c.find(n=>n.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(o){this.b=new T.$Ud,this.c=new T.$Ud,this.e=[],this.a=o.getProxy($.$4K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,C.$Sf)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,a)=>{const c=Array.isArray(n)?n:[n];return c.length?b(c[0])?this.j(c,a):this.i(c,a):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(o.map(u=>u.groupId)),a=(0,E.$L)(t,n),c=this.e.filter(u=>a.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=o.map(u=>{const d=new l(u,()=>this.d);return a.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const s=(0,C.$Sf)(o.find(u=>u.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(n=>n.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const n=[];for(const a of o){const c=this.g(a);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(o,t){const n=[];for(const a of o){const c=this.h(a);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$vgc=p,e.$vgc=p=Je([He(0,g.$8M)],p);function b(r){return r.tabs!==void 0}}),define(Pe[246],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$4K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(R);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector($,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider($,w),new T.$6K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$9gc=C}),define(Pe[247],Re([1,0,2,3,6,7,8,295,11,24,23,52]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let t,n,a=14,c=14;for(const h of r){let i=t?(0,g.$af)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(a=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(i),c]),o.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new $.$sZ(o)}}provideDocumentLinks(r){this.c();const o=[],t=$.$tZ.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of t){const a=R.DocumentLink.to(n);a.target&&o.push(a)}return o}}class p{constructor(r,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(T.$4K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,t,n={}){if(p.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$BF)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,k.$ik)(n.isReadonly)&&((0,A.$BF)(r,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,c,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(s)});const i=t.onDidChangeFile(s=>{const u=[];for(const d of s){const{uri:m,type:f}=d;if(m.scheme!==o)continue;let S;switch(f){case M.FileChangeType.Changed:S=0;break;case M.FileChangeType.Created:S=1;break;case M.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:m,type:S})}this.a.$onFileSystemChange(a,u)});return(0,C.$Rc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:t,mtime:n,size:a,permissions:c}=r;return{type:o,ctime:t,mtime:n,size:a,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(E.URI.revive(o))).then(t=>p.k(t))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(E.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(E.URI.revive(o))).then(t=>w.$ie.wrap(t))}$writeFile(r,o,t,n){return Promise.resolve(this.l(r).writeFile(E.URI.revive(o),t.buffer,n))}$delete(r,o,t){return Promise.resolve(this.l(r).delete(E.URI.revive(o),t))}$rename(r,o,t,n){return Promise.resolve(this.l(r).rename(E.URI.revive(o),E.URI.revive(t),n))}$copy(r,o,t,n){const a=this.l(r);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(E.URI.revive(o),E.URI.revive(t),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(E.URI.revive(o)))}$watch(r,o,t,n){const a=this.l(r).watch(E.URI.revive(t),n);this.f.set(o,a)}$unwatch(r,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(r,o,t){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(o),t))}$close(r,o){const t=this.l(r);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(r,o,t,n){const a=this.l(r);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$ie.alloc(n);return Promise.resolve(a.read(o,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,o,t,n){const a=this.l(r);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$0gc=p}),define(Pe[63],Re([1,0,3,42,7,24,4,17,43,6,13,25,12]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=void 0;let b=p=class{constructor(o,t){this.b=new Map,this.c=new A.$bh,this.a=o.getProxy(E.$4K.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(a){try{let c;const h=n.b.get(a.scheme);return h?(await n.a.$ensureActivation(a.scheme),c=await h.impl.stat(a)):c=await n.a.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await n.a.$readdir(a)}catch(c){return p.e(c)}},async createDirectory(a){try{const c=n.b.get(a.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(c.impl,c.extUri,a)):await n.a.$mkdir(a)}catch(c){return p.e(c)}},async readFile(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await n.a.$readFile(a)).buffer}catch(c){return p.e(c)}},async writeFile(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(a)),await n.c.queueFor(a).queue(()=>Promise.resolve(h.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(a,M.$ie.wrap(c))}catch(h){return p.e(h)}},async delete(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...c})):await n.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(a,c,h){try{return await n.a.$rename(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},async copy(a,c,h){try{return await n.a.$copy(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async d(o,t,n){const a=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&T.FileType.Directory))throw C.$hM.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Fk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(n)),n=t.dirname(n)}for(let c=a.length-1;c>=0;c--){n=t.joinPath(n,a[c]);try{await o.createDirectory(n)}catch(h){if(T.$Fk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof C.$hM)throw o;if(o instanceof T.$Bk)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$hM.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$hM.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$hM.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$hM.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$hM.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$hM.Unavailable(o.message);default:throw new C.$hM(o.message,o.name)}if(!(o instanceof Error))throw new C.$hM(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw C.$hM.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$hM.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$hM.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$hM.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$hM.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$hM.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$hM.Unavailable(o.message);default:throw new C.$hM(o.message,o.name)}}addFileSystemProvider(o,t,n){return this.b.set(o,{impl:t,extUri:n?.isCaseSensitive?k.$wg:k.$yg,isReadonly:!!n?.isReadonly}),(0,w.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??k.$wg}};e.$jgc=b,e.$jgc=b=p=Je([He(0,$.$8M),He(1,g.$Wfc)],b),e.$kgc=(0,R.$5h)("IExtHostConsumerFileSystem")}),define(Pe[248],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,b,r,o,t,n){this.a=Math.random(),this.b=new E.$Ud,this.c=new E.$Ud,this.d=new E.$Ud,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const a=(0,T.$Lj)(t),c=typeof t=="string",h=n?.correlate,i=o(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const u of s.created){const d=C.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const u of s.changed){const d=C.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const u of s.deleted){const d=C.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$6K.from(this.i(p,r,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,b,r,o,t){const n=$.$6K.from();if(typeof r=="string")return n;const a=p.getProxy(M.$4K.MainThreadFileSystemEventService);let c=!1;return(r.pattern.includes(T.$Hj)||r.pattern.includes(T.$Ij))&&(c=!0),a.$watch(b.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),$.$6K.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(C.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,b,r){this.j=p,this.k=b,this.l=r,this.a=new E.$Ud,this.b=new E.$Ud,this.c=new E.$Ud,this.d=new E.$Ud,this.g=new E.$Wd,this.h=new E.$Wd,this.i=new E.$Wd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,b,r,o){return new w(this.j,p,b,this.a.event,R.GlobPattern.from(r),o)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,b){switch(p){case 2:this.b.fire(Object.freeze({files:b.map(r=>({oldUri:C.URI.revive(r.source),newUri:C.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(r=>C.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(r=>C.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,b){return(r,o,t)=>{const n=function(c){r.call(o,c)};return n.extension=p,b.event(n,void 0,t)}}async $onWillRunFileOperation(p,b,r,o){switch(p){case 2:return await this.n(this.g,{files:b.map(t=>({oldUri:C.URI.revive(t.source),newUri:C.URI.revive(t.target)}))},r,o);case 1:return await this.n(this.i,{files:b.map(t=>C.URI.revive(t.target))},r,o);case 0:case 3:return await this.n(this.h,{files:b.map(t=>C.URI.revive(t.target))},r,o)}}async n(p,b,r,o){const t=new Set,n=[];if(await p.fireAsync(b,o,async(c,h)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof $.$dL&&(n.push([h.extension,s]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const a={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(t)}}}e.$$gc=k}),define(Pe[249],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class w{static{this.a=0}constructor(p,b){this.extension=p,this.provider=b,this.handle=w.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,b,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$4K.MainThreadInlineChat),b.registerApiCommand(new $.$vN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$tN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],$.$uN.Void))}registerProvider(p,b,r){const o=new w(p,b);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??p.displayName??p.name,p.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function",typeof b.provideFollowups=="function",r?.supportReportIssue??!1),(0,E.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(p,b,r,o){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(b)),a=M.Selection.to(r),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:M.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,b,r,o){const t=this.b.get(p);if(!t)return;const n=this.d.get(b.id);if(!n)return;const a={prompt:r.prompt,selection:M.Selection.to(r.selection),wholeRange:M.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,withIntentDetection:r.withIntentDetection};let c=!1;const h={report:async L=>{if(!r.live&&L.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:L.message,edits:L.edits?.map(M.TextEdit.from),editsShouldBeInstant:L.editsShouldBeInstant,slashCommand:L.slashCommand?.command,markdownFragment:R.$uL.isMarkdownString(L.content)?L.content.value:L.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,a,h,o));let s;try{s=await(0,g.$Tg)(i,o)}finally{c=!0}if(!s)return;const u=n.responses.push(s)-1,d={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(!k.h(s))return{...d,id:u,type:"editorEdit",message:M.MarkdownString.from(s.contents),edits:[]};const{edits:m,contents:f}=s,S=f!==void 0?M.MarkdownString.from(f):void 0;return m instanceof R.$dL?{...d,id:u,type:"bulkEdit",edits:M.WorkspaceEdit.from(m),message:S}:{...d,id:u,type:"editorEdit",edits:m.map(M.TextEdit.from),message:S}}async $provideFollowups(p,b,r,o){const t=this.b.get(p),n=this.d.get(b),a=n?.responses[r];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,a,o));return(await(0,g.$Tg)(c,o))?.map(M.ChatReplyFollowup.from)}}$handleFeedback(p,b,r,o){const t=this.b.get(p),n=this.d.get(b),a=n?.responses[r];if(t&&a){const c=M.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,a,c)}}$releaseSession(p,b){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$_gc=k}),define(Pe[250],Re([1,0,2,32]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class C{constructor(R,$,g,w,A){this.a=$,this.b=g,this.c=w;const k=new T.$vN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$tN("showOptions","Show Options",l=>!0,l=>l),new T.$tN("resource","Interactive resource Uri",l=>!0,l=>l),new T.$tN("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$tN("title","Interactive editor title",l=>!0,l=>l)],new T.$uN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,$,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$mhc=C}),define(Pe[251],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class C{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$4K.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData($);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate($);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(R,$){const g=R.identifier.value;return this.a.set(g,$),this.c.$registerIssueUriRequestHandler(g),new T.$6K(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,$){const g=R.identifier.value;return this.b.set(g,$),this.c.$registerIssueDataProvider(g),new T.$6K(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$nhc=C}),define(Pe[252],Re([1,0,6,3]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class C{constructor(R){this.b=0,this.a=R.getProxy(T.$4K.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$ohc=C}),define(Pe[253],Re([1,0,2,26,8,7,80,3,11,29,18,16,296,20,22,6,96,89,75,60,15,13,23,160]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class u{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const H=this.d.getDocument(F),z=await this.e.provideDocumentSymbols(H,q);if(!(0,A.$Kb)(z))return z[0]instanceof M.$mL?z.map(C.DocumentSymbol.from):u.f(z)}static f(F){F=F.slice(0).sort((z,X)=>{let x=z.location.range.start.compareTo(X.location.range.start);return x===0&&(x=X.location.range.end.compareTo(z.location.range.end)),x});const q=[],H=[];for(const z of F){const X={name:z.name||"!!MISSING: name!!",kind:C.SymbolKind.from(z.kind),tags:z.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:z.containerName,range:C.Range.from(z.location.range),selectionRange:C.Range.from(z.location.range),children:[]};for(;;){if(H.length===0){H.push(X),q.push(X);break}const x=H[H.length-1];if(w.$Ts.containsRange(x.range,X.range)&&!w.$Ts.equalsRange(x.range,X.range)){x.children?.push(X),H.push(X);break}H.pop()}}return q}}class d{constructor(F,q,H,z,X,x){this.f=F,this.g=q,this.h=H,this.j=z,this.k=X,this.l=x,this.d=new n.$Sfc("CodeLens"),this.e=new Map}async provideCodeLenses(F,q){const H=this.f.getDocument(F),z=await this.h.provideCodeLenses(H,q);if(!z||q.isCancellationRequested)return;const X=this.d.add(z),x=new r.$Sc;this.e.set(X,x);const Ee={cacheId:X,lenses:[]};for(let Te=0;Te<z.length;Te++)Ee.lenses.push({cacheId:[X,Te],range:C.Range.from(z[Te].range),command:this.g.toInternal(z[Te].command,x)});return Ee}async resolveCodeLens(F,q){const H=F.cacheId&&this.d.get(...F.cacheId);if(!H)return;let z;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?z=H:z=await this.h.resolveCodeLens(H,q),z||(z=H),q.isCancellationRequested)return;const X=F.cacheId&&this.e.get(F.cacheId[0]);if(X){if(!z.command){const x=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,x),this.l.error(x);return}return F.command=this.g.toInternal(z.command,X),F}}releaseCodeLenses(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}}function m(ye){return Array.isArray(ye)?ye.map(C.DefinitionLink.from):ye?[C.DefinitionLink.from(ye)]:[]}class f{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDefinition(z,X,H);return m(x)}}class S{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDeclaration(z,X,H);return m(x)}}class L{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideImplementation(z,X,H);return m(x)}}class v{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideTypeDefinition(z,X,H);return m(x)}}class y{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideHover(z,X,H);if(!(!x||(0,A.$Kb)(x.contents)))return x.range||(x.range=z.getWordRangeAtPosition(X)),x.range||(x.range=new M.$8K(X,X)),C.Hover.from(x)}}class D{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideEvaluatableExpression(z,X,H);if(x)return C.EvaluatableExpression.from(x)}}class N{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,H,z){const X=this.d.getDocument(F),x=await this.e.provideInlineValues(X,C.Range.to(q),C.InlineValueContext.to(H),z);if(Array.isArray(x))return x.map(Ee=>C.InlineValue.from(Ee))}}class O{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDocumentHighlights(z,X,H);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class G{constructor(F,q){this.d=F,this.e=q}async provideMultiDocumentHighlights(F,q,H,z){const X=this.d.getDocument(F),x=H.map(Ve=>this.d.getDocument(Ve)),Ee=C.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(X,Ee,x,z);if(Array.isArray(Te))return Te.map(C.MultiDocumentHighlight.from)}}class W{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,H){const z=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideLinkedEditingRanges(z,X,H);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$Hb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,H,z){const X=this.d.getDocument(F),x=C.Position.to(q),Ee=await this.e.provideReferences(X,x,H,z);if(Array.isArray(Ee))return Ee.map(C.location.from)}}class P{static{this.d=1e3}constructor(F,q,H,z,X,x,Ee){this.g=F,this.h=q,this.j=H,this.k=z,this.l=X,this.m=x,this.n=Ee,this.e=new n.$Sfc("CodeAction"),this.f=new Map}async provideCodeActions(F,q,H,z){const X=this.g.getDocument(F),x=l.$Vs.isISelection(q)?C.Selection.to(q):C.Range.to(q),Ee=[];for(const nt of this.j.getDiagnostics(F))if(x.intersection(nt.range)&&Ee.push(nt)>P.d)break;const Te={diagnostics:Ee,only:H.only?new M.$oL(H.only):void 0,triggerKind:C.CodeActionTriggerKind.to(H.trigger)},Ve=await this.k.provideCodeActions(X,x,Te,z);if(!(0,A.$Lb)(Ve)||z.isCancellationRequested)return;const Ke=this.e.add(Ve),Ze=new r.$Sc;this.f.set(Ke,Ze);const st=[];for(let nt=0;nt<Ve.length;nt++){const tt=Ve[nt];tt&&(P.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Ze)})):(Te.only&&(tt.kind?Te.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[Ke,nt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Ze),diagnostics:tt.diagnostics&&tt.diagnostics.map(C.Diagnostic.from),edit:tt.edit&&C.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,i.$AF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:Ke,actions:st}}async resolveCodeAction(F,q){const[H,z]=F,X=this.e.get(H,z);if(!X||P.o(X))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(X,q)??X;let Ee;x.edit&&(Ee=C.WorkspaceEdit.from(x.edit,void 0));let Te;if(x.command){const Ve=this.f.get(H);Ve&&(Te=this.h.toInternal(x.command,Ve))}return{edit:Ee,command:Te}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class I{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,H,z,X){this.d=F,this.e=q,this.f=H,this.g=z,this.h=X}async prepareDocumentPaste(F,q,H,z){if(!this.f.prepareDocumentPaste)return;const X=this.e.getDocument(F),x=q.map(Ve=>C.Range.to(Ve)),Ee=C.DataTransfer.toDataTransfer(H,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(X,x,Ee,z),z.isCancellationRequested)return;const Te=Array.from(Ee).filter(([,Ve])=>!(Ve instanceof M.$UL));return C.DataTransfer.from(Te)}async providePasteEdits(F,q,H,z,X){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(q),Ee=H.map(Ke=>C.Range.to(Ke)),Te=C.DataTransfer.toDataTransfer(z,async Ke=>(await this.d.$resolvePasteFileData(this.g,F,Ke)).buffer),Ve=await this.f.provideDocumentPasteEdits(x,Ee,Te,X);if(Ve)return{label:Ve.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:I.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class K{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,H){const z=this.d.getDocument(F),X=await this.e.provideDocumentFormattingEdits(z,q,H);if(Array.isArray(X))return X.map(C.TextEdit.from)}}class ae{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,H,z){const X=this.d.getDocument(F),x=C.Range.to(q),Ee=await this.e.provideDocumentRangeFormattingEdits(X,x,H,z);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,H,z){(0,k.$Rf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const X=this.d.getDocument(F),x=q.map(C.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(X,x,H,z);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}}class he{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,H,z,X){const x=this.d.getDocument(F),Ee=C.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(x,Ee,H,z,X);if(Array.isArray(Te))return Te.map(C.TextEdit.from)}}class be{constructor(F,q){this.e=F,this.f=q,this.d=new n.$Sfc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const H=await this.e.provideWorkspaceSymbols(F,q);if(!(0,A.$Lb)(H))return{symbols:[]};const z=this.d.add(H),X={cacheId:z,symbols:[]};for(let x=0;x<H.length;x++){const Ee=H[x];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}X.symbols.push({...C.WorkspaceSymbol.from(Ee),cacheId:[z,x]})}return X}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const H=this.d.get(...F.cacheId);if(H){const z=await this.e.resolveWorkspaceSymbol(H,q);return z&&(0,T.$xn)(F,C.WorkspaceSymbol.from(z),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class De{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,H){this.d=F,this.e=q,this.f=H}async provideRenameEdits(F,q,H,z){const X=this.d.getDocument(F),x=C.Position.to(q);try{const Ee=await this.e.provideRenameEdits(X,x,H,z);return Ee?C.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Te=De.g(Ee);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(F,q,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const z=this.d.getDocument(F),X=C.Position.to(q);try{const x=await this.e.prepareRename(z,X,H);let Ee,Te;if(M.$8K.isRange(x)?(Ee=x,Te=z.getText(x)):(0,k.$Jf)(x)&&(Ee=x.range,Te=x.placeholder),!Ee||!Te)return;if(Ee.start.line>X.line||Ee.end.line<X.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Ee),text:Te}}catch(x){const Ee=De.g(x);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class le{constructor(F,q){this.resultId=F,this.tokens=q}}class ve{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,H){const z=this.f.getDocument(F),X=q!==0?this.d.get(q):null;let x=typeof X?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(z,X.resultId,H):await this.g.provideDocumentSemanticTokens(z,H);return X&&this.d.delete(q),x?(x=ve.h(x),this.o(ve.n(X,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ve.j(F)?ve.k(F)?F:new M.$lM(new Uint32Array(F.data),F.resultId):ve.l(F)?ve.m(F)?F:new M.$nM(F.edits.map(q=>new M.$mM(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!ve.j(q)||!F||!F.tokens)return q;const H=F.tokens,z=H.length,X=q.data,x=X.length;let Ee=0;const Te=Math.min(z,x);for(;Ee<Te&&H[Ee]===X[Ee];)Ee++;if(Ee===z&&Ee===x)return new M.$nM([],q.resultId);let Ve=0;const Ke=Te-Ee;for(;Ve<Ke&&H[z-Ve-1]===X[x-Ve-1];)Ve++;return new M.$nM([{start:Ee,deleteCount:z-Ee-Ve,data:X.subarray(Ee,x-Ve)}],q.resultId)}o(F,q){if(ve.j(F)){const H=this.e++;return this.d.set(H,new le(F.resultId,F.data)),(0,o.$o$)({id:H,type:"full",data:F.data})}if(ve.l(F)){const H=this.e++;return ve.j(q)?this.d.set(H,new le(q.resultId,q.data)):this.d.set(H,new le(F.resultId)),(0,o.$o$)({id:H,type:"delta",deltas:(F.edits||[]).map(z=>({start:z.start,deleteCount:z.deleteCount,data:z.data}))})}return null}}class se{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,H){const z=this.d.getDocument(F),X=await this.e.provideDocumentRangeSemanticTokens(z,C.Range.to(q),H);return X?this.f(X):null}f(F){return(0,o.$o$)({id:0,type:"full",data:F.data})}}class we{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,H,z,X){this.f=F,this.g=q,this.h=H,this.j=z,this.k=X,this.d=new n.$Sfc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,H,z){const X=this.f.getDocument(F),x=C.Position.to(q),Ee=X.getWordRangeAtPosition(x)||new M.$8K(x,x),Te=Ee.with({end:x}),Ve=new a.$Qd,Ke=await this.h.provideCompletionItems(X,x,z,C.CompletionContext.to(H));if(!Ke||z.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new M.$BL(Ke):Ke,st=we.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),nt=new r.$Sc;this.e.set(st,nt);const tt=[],at={x:st,b:tt,a:{replace:C.Range.from(Ee),insert:C.Range.from(Te)},c:Ze.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Ze.items.length;ct++){const je=Ze.items[ct],vt=this.l(je,[st,ct],Te,Ee);tt.push(vt)}return at}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...F);if(!H)return;const z=this.l(H,F),X=await this.h.resolveCompletionItem(H,q);if(!X)return;const x=this.l(X,F);return(z.h!==x.h||z.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(z.n!==x.n||z.o!==x.o||!(0,T.$yn)(z.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...z,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,H,z){const X=this.e.get(q[0]);if(!X)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,X),Ee={x:q,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=F.textEdit.newText):typeof F.insertText=="string"?Ee.h=F.insertText:F.insertText instanceof M.$eL&&(Ee.h=F.insertText.value,Ee.i|=4);let Te;return F.textEdit?Te=F.textEdit.range:F.range&&(Te=F.range),M.$8K.isRange(Te)?Ee.j=C.Range.from(Te):Te&&(!H?.isEqual(Te.inserting)||!z?.isEqual(Te.replacing))&&(Ee.j={insert:C.Range.from(Te.inserting),replace:C.Range.from(Te.replacing)}),Ee}}class ne{async provideInlineCompletions(F,q,H,z){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,H){}handlePartialAccept(F,q,H){}}class Z extends ne{constructor(F,q,H,z){super(),this.f=F,this.g=q,this.h=H,this.j=z,this.d=new V,this.e=(0,i.$AF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$AF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,H,z){const X=this.g.getDocument(F),x=C.Position.to(q),Ee=await this.h.provideInlineCompletionItems(X,x,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:C.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},z);if(!Ee||z.isCancellationRequested)return;const Te=Array.isArray(Ee)?Ee:Ee.items,Ve=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Ke=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:Te}),items:Te.map((nt,tt)=>{let at;nt.command&&(Ze||(Ze=new r.$Sc),at=this.j.toInternal(nt.command,Ze));const ct=nt.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:nt.filterText,range:nt.range?C.Range.from(nt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ve.map(nt=>(Ze||(Ze=new r.$Sc),this.j.toInternal(nt,Ze))),suppressSuggestions:!1,enableForwardStability:Ke}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,H){const z=this.d.get(F)?.items[q];z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(z,H)}handlePartialAccept(F,q,H){const z=this.d.get(F)?.items[q];z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(z,H)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class ie{constructor(F,q){this.e=F,this.f=q,this.d=new n.$Sfc("SignatureHelp")}async provideSignatureHelp(F,q,H,z){const X=this.e.getDocument(F),x=C.Position.to(q),Ee=this.g(H),Te=await this.f.provideSignatureHelp(X,x,z,Ee);if(Te){const Ve=this.d.add([Te]);return{...C.SignatureHelp.from(Te),id:Ve}}}g(F){let q;if(F.activeSignatureHelp){const H=C.SignatureHelp.to(F.activeSignatureHelp),z=this.d.get(F.activeSignatureHelp.id,0);z?(q=z,q.activeSignature=H.activeSignature,q.activeParameter=H.activeParameter):q=H}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class Ie{constructor(F,q,H,z,X){this.f=F,this.g=q,this.h=H,this.j=z,this.k=X,this.d=new n.$Sfc("InlayHints"),this.e=new Map}async provideInlayHints(F,q,H){const z=this.f.getDocument(F),X=C.Range.to(q),x=await this.h.provideInlayHints(z,X,H);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(H.isCancellationRequested)return;const Ee=this.d.add(x);this.e.set(Ee,new r.$Sc);const Te={hints:[],cacheId:Ee};for(let Ve=0;Ve<x.length;Ve++)this.l(x[Ve],X)&&Te.hints.push(this.m(x[Ve],[Ee,Ve]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...F);if(!H)return;const z=await this.h.resolveInlayHint(H,q);if(z&&this.l(z))return this.m(z,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const z={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")z.label=F.label;else{const X=[];z.label=X;for(const x of F.label){if(!x.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:x.value,tooltip:C.MarkdownString.fromStrict(x.tooltip)};M.$fL.isLocation(x.location)&&(Ee.location=C.location.from(x.location)),x.command&&(Ee.command=this.g.toInternal(x.command,H)),X.push(Ee)}}return z}}class Ae{constructor(F,q){this.e=F,this.f=q,this.d=new n.$Sfc("DocumentLink")}async provideLinks(F,q){const H=this.e.getDocument(F),z=await this.f.provideDocumentLinks(H,q);if(!(!Array.isArray(z)||z.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:z.filter(Ae.g).map(C.DocumentLink.from)};{const X=this.d.add(z),x={links:[],cacheId:X};for(let Ee=0;Ee<z.length;Ee++){if(!Ae.g(z[Ee]))continue;const Te=C.DocumentLink.from(z[Ee]);Te.cacheId=[X,Ee],x.links.push(Te)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...F);if(!H)return;const z=await this.f.resolveDocumentLink(H,q);if(!(!z||!Ae.g(z)))return C.DocumentLink.from(z)}releaseLinks(F){this.d.delete(F)}}class Ce{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const H=this.d.getDocument(F),z=await this.e.provideDocumentColors(H,q);return Array.isArray(z)?z.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,q,H){const z=this.d.getDocument(F),X=C.Range.to(q.range),x=C.Color.to(q.color),Ee=await this.e.provideColorPresentations(x,{document:z,range:X},H);if(Array.isArray(Ee))return Ee.map(C.ColorPresentation.from)}}class ce{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,H){const z=this.d.getDocument(F),X=await this.e.provideFoldingRanges(z,q,H);if(Array.isArray(X))return X.map(C.FoldingRange.from)}}class te{constructor(F,q,H){this.d=F,this.e=q,this.f=H}async provideSelectionRanges(F,q,H){const z=this.d.getDocument(F),X=q.map(C.Position.to),x=await this.e.provideSelectionRanges(z,X,H);if(!(0,A.$Lb)(x))return[];if(x.length!==X.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Te=0;Te<X.length;Te++){const Ve=[];Ee.push(Ve);let Ke=X[Te],Ze=x[Te];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(C.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return Ee}}class Q{constructor(F,q){this.f=F,this.g=q,this.d=new t.$aN(""),this.e=new Map}async prepareSession(F,q,H){const z=this.f.getDocument(F),X=C.Position.to(q),x=await this.g.prepareCallHierarchy(z,X,H);if(!x)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(x)?x.map(Te=>this.h(Ee,Te)):[this.h(Ee,x)]}async provideCallsTo(F,q,H){const z=this.j(F,q);if(!z)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyIncomingCalls(z,H);if(X)return X.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(Ee=>C.Range.from(Ee))}))}async provideCallsFrom(F,q,H){const z=this.j(F,q);if(!z)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyOutgoingCalls(z,H);if(X)return X.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(Ee=>C.Range.from(Ee))}))}releaseSession(F){this.e.delete(F)}h(F,q){const H=this.e.get(F),z=C.CallHierarchyItem.from(q,F,H.size.toString(36));return H.set(z._itemId,q),z}j(F,q){return this.e.get(F)?.get(q)}}class ee{constructor(F,q){this.f=F,this.g=q,this.d=new t.$aN(""),this.e=new Map}async prepareSession(F,q,H){const z=this.f.getDocument(F),X=C.Position.to(q),x=await this.g.prepareTypeHierarchy(z,X,H);if(!x)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(x)?x.map(Te=>this.h(Ee,Te)):[this.h(Ee,x)]}async provideSupertypes(F,q,H){const z=this.j(F,q);if(!z)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySupertypes(z,H);if(X)return X.map(x=>this.h(F,x))}async provideSubtypes(F,q,H){const z=this.j(F,q);if(!z)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySubtypes(z,H);if(X)return X.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,q){const H=this.e.get(F),z=C.TypeHierarchyItem.from(q,F,H.size.toString(36));return H.set(z._itemId,q),z}j(F,q){return this.e.get(F)?.get(q)}}class me{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,H,z,X){this.d=F,this.e=q,this.f=H,this.g=z,this.h=X}async provideDocumentOnDropEdits(F,q,H,z,X){const x=this.e.getDocument(q),Ee=C.Position.to(H),Te=C.DataTransfer.toDataTransfer(z,async Ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Ke)).buffer),Ve=await this.f.provideDocumentDropEdits(x,Ee,Te,X);if(Ve)return{label:Ve.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:me.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class pe{constructor(F,q){this.d=F,this.e=q}async provideMappedEdits(F,q,H,z){const X=E.URI.revive(F),x=this.d.getDocument(X),Ee=H.documents.map(Ke=>Ke.map(Ze=>({uri:E.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(st=>C.Range.to(st))}))),Te={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Ve=await this.e.provideMappedEdits(x,q,Te,z);return Ve?C.WorkspaceEdit.from(Ve):null}}class Le{constructor(F,q){this.adapter=F,this.extension=q}}class de{static{this.d=0}constructor(F,q,H,z,X,x,Ee,Te){this.g=q,this.h=H,this.j=z,this.k=X,this.l=x,this.m=Ee,this.n=Te,this.f=new Map,this.e=F.getProxy($.$4K.MainThreadLanguageFeatures)}o(F,q){return C.DocumentSelector.from(F,this.g,q)}p(F){return new M.$6K(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return de.d++}async s(F,q,H,z,X,x=!1){const Ee=this.f.get(F);if(!Ee||!(Ee.adapter instanceof q))return z;const Te=Date.now();x||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ve=H(Ee.adapter,Ee.extension);return Promise.resolve(Ve).catch(Ke=>{(0,c.$4)(Ke)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Ke),this.n.onExtensionError(Ee.extension.identifier,Ke))}).finally(()=>{x||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(X)?(0,h.$Ug)(Ve,X):Ve}t(F,q){const H=this.q();return this.f.set(H,new Le(F,q)),H}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,H,z){const X=this.t(new u(this.h,H),F),x=z&&z.label||de.u(F);return this.e.$registerDocumentSymbolProvider(X,this.o(q,F),x),this.p(X)}$provideDocumentSymbols(F,q,H){return this.s(F,u,z=>z.provideDocumentSymbols(E.URI.revive(q),H),void 0,H)}registerCodeLensProvider(F,q,H){const z=this.q(),X=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(z,new Le(new d(this.h,this.j.converter,H,F,this.n,this.l),F)),this.e.$registerCodeLensSupport(z,this.o(q,F),X);let x=this.p(z);if(X!==void 0){const Ee=H.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(X));x=M.$6K.from(x,Ee)}return x}$provideCodeLenses(F,q,H){return this.s(F,d,z=>z.provideCodeLenses(E.URI.revive(q),H),void 0,H)}$resolveCodeLens(F,q,H){return this.s(F,d,z=>z.resolveCodeLens(q,H),void 0,void 0)}$releaseCodeLenses(F,q){this.s(F,d,H=>Promise.resolve(H.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,H){const z=this.t(new f(this.h,H),F);return this.e.$registerDefinitionSupport(z,this.o(q,F)),this.p(z)}$provideDefinition(F,q,H,z){return this.s(F,f,X=>X.provideDefinition(E.URI.revive(q),H,z),[],z)}registerDeclarationProvider(F,q,H){const z=this.t(new S(this.h,H),F);return this.e.$registerDeclarationSupport(z,this.o(q,F)),this.p(z)}$provideDeclaration(F,q,H,z){return this.s(F,S,X=>X.provideDeclaration(E.URI.revive(q),H,z),[],z)}registerImplementationProvider(F,q,H){const z=this.t(new L(this.h,H),F);return this.e.$registerImplementationSupport(z,this.o(q,F)),this.p(z)}$provideImplementation(F,q,H,z){return this.s(F,L,X=>X.provideImplementation(E.URI.revive(q),H,z),[],z)}registerTypeDefinitionProvider(F,q,H){const z=this.t(new v(this.h,H),F);return this.e.$registerTypeDefinitionSupport(z,this.o(q,F)),this.p(z)}$provideTypeDefinition(F,q,H,z){return this.s(F,v,X=>X.provideTypeDefinition(E.URI.revive(q),H,z),[],z)}registerHoverProvider(F,q,H,z){const X=this.t(new y(this.h,H),F);return this.e.$registerHoverProvider(X,this.o(q,F)),this.p(X)}$provideHover(F,q,H,z){return this.s(F,y,X=>X.provideHover(E.URI.revive(q),H,z),void 0,z)}registerEvaluatableExpressionProvider(F,q,H,z){const X=this.t(new D(this.h,H),F);return this.e.$registerEvaluatableExpressionProvider(X,this.o(q,F)),this.p(X)}$provideEvaluatableExpression(F,q,H,z){return this.s(F,D,X=>X.provideEvaluatableExpression(E.URI.revive(q),H,z),void 0,z)}registerInlineValuesProvider(F,q,H,z){const X=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new N(this.h,H),F);this.e.$registerInlineValuesProvider(x,this.o(q,F),X);let Ee=this.p(x);if(X!==void 0){const Te=H.onDidChangeInlineValues(Ve=>this.e.$emitInlineValuesEvent(X));Ee=M.$6K.from(Ee,Te)}return Ee}$provideInlineValues(F,q,H,z,X){return this.s(F,N,x=>x.provideInlineValues(E.URI.revive(q),H,z,X),void 0,X)}registerDocumentHighlightProvider(F,q,H){const z=this.t(new O(this.h,H),F);return this.e.$registerDocumentHighlightProvider(z,this.o(q,F)),this.p(z)}registerMultiDocumentHighlightProvider(F,q,H){const z=this.t(new G(this.h,H),F);return this.e.$registerMultiDocumentHighlightProvider(z,this.o(q,F)),this.p(z)}$provideDocumentHighlights(F,q,H,z){return this.s(F,O,X=>X.provideDocumentHighlights(E.URI.revive(q),H,z),void 0,z)}$provideMultiDocumentHighlights(F,q,H,z,X){return this.s(F,G,x=>x.provideMultiDocumentHighlights(E.URI.revive(q),H,z.map(Ee=>E.URI.revive(Ee)),X),void 0,X)}registerLinkedEditingRangeProvider(F,q,H){const z=this.t(new W(this.h,H),F);return this.e.$registerLinkedEditingRangeProvider(z,this.o(q,F)),this.p(z)}$provideLinkedEditingRanges(F,q,H,z){return this.s(F,W,async X=>{const x=await X.provideLinkedEditingRanges(E.URI.revive(q),H,z);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?de.w(x.wordPattern):void 0}},void 0,z)}registerReferenceProvider(F,q,H){const z=this.t(new U(this.h,H),F);return this.e.$registerReferenceSupport(z,this.o(q,F)),this.p(z)}$provideReferences(F,q,H,z,X){return this.s(F,U,x=>x.provideReferences(E.URI.revive(q),H,z,X),void 0,X)}registerCodeActionProvider(F,q,H,z){const X=new r.$Sc,x=this.t(new P(this.h,this.j.converter,this.k,H,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(q,F),{providedKinds:z?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:z?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,X)}))},de.u(F),!!H.resolveCodeAction),X.add(this.p(x)),X}$provideCodeActions(F,q,H,z,X){return this.s(F,P,x=>x.provideCodeActions(E.URI.revive(q),H,z,X),void 0,X)}$resolveCodeAction(F,q,H){return this.s(F,P,z=>z.resolveCodeAction(q,H),{},void 0)}$releaseCodeActions(F,q){this.s(F,P,H=>Promise.resolve(H.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,H){const z=this.t(new K(this.h,H),F);return this.e.$registerDocumentFormattingSupport(z,this.o(q,F),F.identifier,F.displayName||F.name),this.p(z)}$provideDocumentFormattingEdits(F,q,H,z){return this.s(F,K,X=>X.provideDocumentFormattingEdits(E.URI.revive(q),H,z),void 0,z)}registerDocumentRangeFormattingEditProvider(F,q,H){const z=typeof H.provideDocumentRangesFormattingEdits=="function",X=this.t(new ae(this.h,H),F);return this.e.$registerRangeFormattingSupport(X,this.o(q,F),F.identifier,F.displayName||F.name,z),this.p(X)}$provideDocumentRangeFormattingEdits(F,q,H,z,X){return this.s(F,ae,x=>x.provideDocumentRangeFormattingEdits(E.URI.revive(q),H,z,X),void 0,X)}$provideDocumentRangesFormattingEdits(F,q,H,z,X){return this.s(F,ae,x=>x.provideDocumentRangesFormattingEdits(E.URI.revive(q),H,z,X),void 0,X)}registerOnTypeFormattingEditProvider(F,q,H,z){const X=this.t(new he(this.h,H),F);return this.e.$registerOnTypeFormattingSupport(X,this.o(q,F),z,F.identifier),this.p(X)}$provideOnTypeFormattingEdits(F,q,H,z,X,x){return this.s(F,he,Ee=>Ee.provideOnTypeFormattingEdits(E.URI.revive(q),H,z,X,x),void 0,x)}registerWorkspaceSymbolProvider(F,q){const H=this.t(new be(q,this.l),F);return this.e.$registerNavigateTypeSupport(H,typeof q.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(F,q,H){return this.s(F,be,z=>z.provideWorkspaceSymbols(q,H),{symbols:[]},H)}$resolveWorkspaceSymbol(F,q,H){return this.s(F,be,z=>z.resolveWorkspaceSymbol(q,H),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.s(F,be,H=>H.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,H){const z=this.t(new De(this.h,H,this.l),F);return this.e.$registerRenameSupport(z,this.o(q,F),De.supportsResolving(H)),this.p(z)}$provideRenameEdits(F,q,H,z,X){return this.s(F,De,x=>x.provideRenameEdits(E.URI.revive(q),H,z,X),void 0,X)}$resolveRenameLocation(F,q,H,z){return this.s(F,De,X=>X.resolveRenameLocation(E.URI.revive(q),H,z),void 0,z)}registerDocumentSemanticTokensProvider(F,q,H,z){const X=this.t(new ve(this.h,H),F),x=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(X,this.o(q,F),z,x);let Ee=this.p(X);if(x){const Te=H.onDidChangeSemanticTokens(Ve=>this.e.$emitDocumentSemanticTokensEvent(x));Ee=M.$6K.from(Ee,Te)}return Ee}$provideDocumentSemanticTokens(F,q,H,z){return this.s(F,ve,X=>X.provideDocumentSemanticTokens(E.URI.revive(q),H,z),null,z)}$releaseDocumentSemanticTokens(F,q){this.s(F,ve,H=>H.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,H,z){const X=this.t(new se(this.h,H),F);return this.e.$registerDocumentRangeSemanticTokensProvider(X,this.o(q,F),z),this.p(X)}$provideDocumentRangeSemanticTokens(F,q,H,z){return this.s(F,se,X=>X.provideDocumentRangeSemanticTokens(E.URI.revive(q),H,z),null,z)}registerCompletionItemProvider(F,q,H,z){const X=this.t(new we(this.h,this.j.converter,H,this.m,F),F);return this.e.$registerCompletionsProvider(X,this.o(q,F),z,we.supportsResolving(H),F.identifier),this.p(X)}$provideCompletionItems(F,q,H,z,X){return this.s(F,we,x=>x.provideCompletionItems(E.URI.revive(q),H,z,X),void 0,X)}$resolveCompletionItem(F,q,H){return this.s(F,we,z=>z.resolveCompletionItem(q,H),void 0,H)}$releaseCompletionItems(F,q){this.s(F,we,H=>H.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,H,z){const X=new Z(F,this.h,H,this.j.converter),x=this.t(X,F);return this.e.$registerInlineCompletionsSupport(x,this.o(q,F),X.supportsHandleEvents,b.$km.toKey(F.identifier.value),z?.yieldTo?.map(Ee=>b.$km.toKey(Ee))||[]),this.p(x)}$provideInlineCompletions(F,q,H,z,X){return this.s(F,ne,x=>x.provideInlineCompletions(E.URI.revive(q),H,z,X),void 0,X)}$handleInlineCompletionDidShow(F,q,H,z){this.s(F,ne,async X=>{X.handleDidShowCompletionItem(q,H,z)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,H,z){this.s(F,ne,async X=>{X.handlePartialAccept(q,H,z)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.s(F,ne,async H=>{H.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,H,z){const X=Array.isArray(z)?{triggerCharacters:z,retriggerCharacters:[]}:z,x=this.t(new ie(this.h,H),F);return this.e.$registerSignatureHelpProvider(x,this.o(q,F),X),this.p(x)}$provideSignatureHelp(F,q,H,z,X){return this.s(F,ie,x=>x.provideSignatureHelp(E.URI.revive(q),H,z,X),void 0,X)}$releaseSignatureHelp(F,q){this.s(F,ie,H=>H.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,H){const z=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,X=this.t(new Ie(this.h,this.j.converter,H,this.l,F),F);this.e.$registerInlayHintsProvider(X,this.o(q,F),typeof H.resolveInlayHint=="function",z,de.u(F));let x=this.p(X);if(z!==void 0){const Ee=H.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(z));x=M.$6K.from(x,Ee)}return x}$provideInlayHints(F,q,H,z){return this.s(F,Ie,X=>X.provideInlayHints(E.URI.revive(q),H,z),void 0,z)}$resolveInlayHint(F,q,H){return this.s(F,Ie,z=>z.resolveInlayHint(q,H),void 0,H)}$releaseInlayHints(F,q){this.s(F,Ie,H=>H.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,H){const z=this.t(new Ae(this.h,H),F);return this.e.$registerDocumentLinkProvider(z,this.o(q,F),typeof H.resolveDocumentLink=="function"),this.p(z)}$provideDocumentLinks(F,q,H){return this.s(F,Ae,z=>z.provideLinks(E.URI.revive(q),H),void 0,H,q.scheme==="output")}$resolveDocumentLink(F,q,H){return this.s(F,Ae,z=>z.resolveLink(q,H),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.s(F,Ae,H=>H.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,H){const z=this.t(new Ce(this.h,H),F);return this.e.$registerDocumentColorProvider(z,this.o(q,F)),this.p(z)}$provideDocumentColors(F,q,H){return this.s(F,Ce,z=>z.provideColors(E.URI.revive(q),H),[],H)}$provideColorPresentations(F,q,H,z){return this.s(F,Ce,X=>X.provideColorPresentations(E.URI.revive(q),H,z),void 0,z)}registerFoldingRangeProvider(F,q,H){const z=this.q(),X=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(z,new Le(new ce(this.h,H),F)),this.e.$registerFoldingRangeProvider(z,this.o(q,F),F.identifier,X);let x=this.p(z);if(X!==void 0){const Ee=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(X));x=M.$6K.from(x,Ee)}return x}$provideFoldingRanges(F,q,H,z){return this.s(F,ce,X=>X.provideFoldingRanges(E.URI.revive(q),H,z),void 0,z)}registerSelectionRangeProvider(F,q,H){const z=this.t(new te(this.h,H,this.l),F);return this.e.$registerSelectionRangeProvider(z,this.o(q,F)),this.p(z)}$provideSelectionRanges(F,q,H,z){return this.s(F,te,X=>X.provideSelectionRanges(E.URI.revive(q),H,z),[],z)}registerCallHierarchyProvider(F,q,H){const z=this.t(new Q(this.h,H),F);return this.e.$registerCallHierarchyProvider(z,this.o(q,F)),this.p(z)}$prepareCallHierarchy(F,q,H,z){return this.s(F,Q,X=>Promise.resolve(X.prepareSession(E.URI.revive(q),H,z)),void 0,z)}$provideCallHierarchyIncomingCalls(F,q,H,z){return this.s(F,Q,X=>X.provideCallsTo(q,H,z),void 0,z)}$provideCallHierarchyOutgoingCalls(F,q,H,z){return this.s(F,Q,X=>X.provideCallsFrom(q,H,z),void 0,z)}$releaseCallHierarchy(F,q){this.s(F,Q,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,H){const z=this.t(new ee(this.h,H),F);return this.e.$registerTypeHierarchyProvider(z,this.o(q,F)),this.p(z)}$prepareTypeHierarchy(F,q,H,z){return this.s(F,ee,X=>Promise.resolve(X.prepareSession(E.URI.revive(q),H,z)),void 0,z)}$provideTypeHierarchySupertypes(F,q,H,z){return this.s(F,ee,X=>X.provideSupertypes(q,H,z),void 0,z)}$provideTypeHierarchySubtypes(F,q,H,z){return this.s(F,ee,X=>X.provideSubtypes(q,H,z),void 0,z)}$releaseTypeHierarchy(F,q){this.s(F,ee,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,H,z){const X=this.q();this.f.set(X,new Le(new me(this.e,this.h,H,X,F),F));const x=(0,i.$AF)(F,"dropMetadata")&&z?me.toInternalProviderId(F.identifier.value,z.id):void 0;return this.e.$registerDocumentOnDropEditProvider(X,this.o(q,F),x,(0,i.$AF)(F,"dropMetadata")?z:void 0),this.p(X)}$provideDocumentOnDropEdits(F,q,H,z,X,x){return this.s(F,me,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(q,E.URI.revive(H),z,X,x)),void 0,void 0)}registerMappedEditsProvider(F,q,H){const z=this.t(new pe(this.h,H),F);return this.e.$registerMappedEditsProvider(z,this.o(q,F)),this.p(z)}$provideMappedEdits(F,q,H,z,X){return this.s(F,pe,x=>Promise.resolve(x.provideMappedEdits(q,H,z,X)),null,X)}registerDocumentPasteEditProvider(F,q,H,z){const X=this.q();this.f.set(X,new Le(new I(this.e,this.h,H,X,F),F));const x=I.toInternalProviderId(F.identifier.value,z.id);return this.e.$registerPasteEditProvider(X,this.o(q,F),x,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:z.copyMimeTypes,pasteMimeTypes:z.pasteMimeTypes}),this.p(X)}$prepareDocumentPaste(F,q,H,z,X){return this.s(F,I,x=>x.prepareDocumentPaste(E.URI.revive(q),H,z,X),void 0,X)}$providePasteEdits(F,q,H,z,X,x){return this.s(F,I,Ee=>Ee.providePasteEdits(q,E.URI.revive(H),z,X,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:de.w(F.decreaseIndentPattern),increaseIndentPattern:de.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?de.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?de.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:de.w(F.beforeText),afterText:F.afterText?de.w(F.afterText):void 0,previousLineText:F.previousLineText?de.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(de.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(q=>M.SyntaxTokenType.toString(q)):void 0}}static D(F){return F.map(de.C)}setLanguageConfiguration(F,q,H){const{wordPattern:z}=H;if(z&&(0,g.$Xe)(z))throw new Error(`Invalid language configuration: wordPattern '${z}' is not allowed to match the empty string.`);z?this.h.setWordDefinitionFor(q,z):this.h.setWordDefinitionFor(q,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const X=this.q(),x={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?de.w(H.wordPattern):void 0,indentationRules:H.indentationRules?de.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?de.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?de.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(X,q,x),this.p(X)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$3fc=de}),define(Pe[254],Re([1,0,3,8,7,31,13,6,23]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class w{constructor(k,l,p,b){this.c=l,this.d=p,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(E.$4K.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const p=this.c.getDocumentData(k);if(!p)throw new Error(`document '${k.toString()}' NOT found`);return p.document}async tokenAtPosition(k,l){const p=k.version,b=T.Position.from(l),r=await this.a.$tokensAtPosition(k.uri,b),o={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new C.$8K(l.line,l.character,l.line,l.character)};if(!r)return o;const t={range:T.Range.to(r.range),type:T.TokenType.to(r.type)};return!t.range.contains(l)||p!==k.version?o:t}createLanguageStatusItem(k,l,p){const b=this.f++,r=this.a,o=this.g,t=`${k.identifier.value}/${l}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(t);const n={selector:p,id:l,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new $.$Sc,h=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,R.$7g)(()=>{c.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?M.default.Error:n.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),r.$removeLanguageStatus(b),o.delete(t)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,h()},get selector(){return n.selector},set selector(s){n.selector=s,h()},get text(){return n.text},set text(s){n.text=s,h()},set text2(s){(0,g.$BF)(k,"languageStatusText"),n.text=s,h()},get text2(){return(0,g.$BF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,h()},get severity(){return n.severity},set severity(s){n.severity=s,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,h()},get command(){return n.command},set command(s){n.command=s,h()},get busy(){return n.busy},set busy(s){n.busy=s,h()}};return h(),i}}e.$phc=w}),define(Pe[82],Re([1,0,21,11,2,4,14,3,27,17]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;let A=class{constructor(l,p,b){this.f=b,this.d=new Map,this.a=p.getProxy($.$4K.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,p){const{message:b,args:r,comment:o}=p;if(this.c)return(0,T.$Ke)(b,r??{});let t=b;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Ke)(n??b,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(b),o=JSON.parse(r);p=l.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${r.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:b})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive(p)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ngc=A,e.$Ngc=A=Je([He(0,g.$lN),He(1,w.$8M),He(2,R.$mj)],A),e.$Ogc=(0,M.$5h)("IExtHostLocalizationService")}),define(Pe[255],Re([1,0,14,3,27,17,2,51]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;let g=class extends E.$xj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,$.$Bh)(p))),this.r=k.getProxy(T.$4K.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,p){return new w(this.r,k,l,p)}};e.$1hc=g,e.$1hc=g=Je([He(0,M.$8M),He(1,C.$lN)],g);class w extends E.$sj{constructor(k,l,p,b){super(b?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const p=[[k,l]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Re([1,0,3,4,6,17,24]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0,e.$Pgc=(0,T.$5h)("IExtHostManagedSockets");let $=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(E.$4K.MainThreadManagedSockets)}setFactory(k,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,p=await this.c.makeConnection(),b=new C.$Sc;return this.d.set(l,new w(l,p,b)),b.add((0,C.$Rc)(()=>this.d.delete(l))),b.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add(p.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),b.dispose()})),b.add(p.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$ie.wrap(r)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Qgc=$,e.$Qgc=$=Je([He(0,M.$8M)],$);class g{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class w extends C.$Tc{constructor(k,l,p){super(),this.socketId=k,this.actual=l,this.B(p)}}}),define(Pe[256],Re([1,0,3,14,23]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;function M($){return $&&$.title}let R=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$4K.MainThreadMessageService)}showMessage(g,w,A,k,l){const p={source:{identifier:g.identifier,label:g.displayName||g.name}};let b;typeof k=="string"||M(k)?b=[k,...l]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,b=l),p.useCustom&&(0,C.$BF)(g,"resolvers");const r=[];let o=!1;for(let t=0;t<b.length;t++){const n=b[t];if(typeof n=="string")r.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:a,isCloseAffordance:c}=n;r.push({title:a,isCloseAffordance:!!c,handle:t}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,n)}return this.a.$showMessage(w,A,p,r).then(t=>{if(typeof t=="number")return b[t]})}};e.$qhc=R,e.$qhc=R=Je([He(1,T.$mj)],R)}),define(Pe[257],Re([1,0,18,13,20,5,6,28,2,22,14,3,32,8,7,78,210,23,49]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0;let a=class{constructor(f,S,L,v,y){this.m=S,this.n=L,this.o=v,this.q=y,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$Ud,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(k.$4K.MainThreadNotebookKernels);const D=new l.$vN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$tN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],l.$uN.Void);this.o.registerApiCommand(D)}createNotebookController(f,S,L,v,y,D){for(const se of this.j.values())if(se.controller.id===S&&w.$km.equals(f.identifier,se.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${f.identifier.value}, ${S}`);const G=()=>console.warn(`NO execute handler from notebook controller '${I.id}' of extension: '${f.identifier}'`);let W=!1;const U=new M.$Ud,P=new M.$Ud,I={id:d(f.identifier,S),notebookType:L,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:v||f.identifier.value,preloads:D?D.map(p.NotebookRendererScript.from):[]};let K=y??G,ae,he;this.a.$addKernel(N,I).catch(se=>{console.log(se),W=!0});let be=0;const De=()=>{if(W)return;const se=++be;Promise.resolve().then(()=>{se===be&&this.a.$updateKernel(N,I)})},le=new $.$Ac,ve={get id(){return S},get notebookType(){return I.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return I.label},set label(se){I.label=se??f.displayName??f.name,De()},get detail(){return I.detail??""},set detail(se){I.detail=se,De()},get description(){return I.description??""},set description(se){I.description=se,De()},get supportedLanguages(){return I.supportedLanguages},set supportedLanguages(se){I.supportedLanguages=se,De()},get supportsExecutionOrder(){return I.supportsExecutionOrder??!1},set supportsExecutionOrder(se){I.supportsExecutionOrder=se,De()},get rendererScripts(){return I.preloads?I.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(se){K=se??G},get interruptHandler(){return ae},set interruptHandler(se){ae=se,I.supportsInterrupt=!!se,De()},set variableProvider(se){(0,t.$BF)(f,"notebookVariableProvider"),he=se,I.hasVariableProvider=!!se,se?.onDidChangeVariables(we=>O.a.$variablesUpdated(we.uri)),De()},get variableProvider(){return he},createNotebookCellExecution(se){if(W)throw new Error("notebook controller is DISPOSED");if(!le.has(se.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return O._createNotebookCellExecution(se,d(f.identifier,this.id))},createNotebookExecution(se){if((0,t.$BF)(f,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!le.has(se.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return O._createNotebookExecution(se,d(f.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${N}], DISPOSED`),W=!0,this.j.delete(N),U.dispose(),P.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(se,we){we===b.NotebookControllerAffinity2.Hidden&&(0,t.$BF)(f,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,se.uri,we)},onDidReceiveMessage:P.event,postMessage(se,we){return(0,t.$BF)(f,"notebookMessaging"),O.a.$postMessage(N,we&&O.n.getIdByEditor(we),se)},asWebviewUri(se){return(0,t.$BF)(f,"notebookMessaging"),(0,r.$qvb)(se,O.m.remote)}};return this.j.set(N,{extensionId:f.identifier,controller:ve,onDidReceiveMessage:P,onDidChangeSelection:U,associatedNotebooks:le}),ve}getIdByController(f){for(const[S,L]of this.j)if(L.controller===f)return d(L.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,S){const L=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const y={dispose:()=>{this.f.delete(L),v.a.$removeKernelDetectionTask(L)}};return this.f.set(L,y),y}registerKernelSourceActionProvider(f,S,L){const v=this.i++,y=typeof L.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,D=this;this.h.set(v,L),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,S);let N;return y!==void 0&&(N=L.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(v),D.a.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(f,S){const L=this.h.get(f);if(L){const v=new R.$Sc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(D=>p.NotebookKernelSourceAction.from(D,this.o.converter,v))}return[]}$acceptNotebookAssociation(f,S,L){const v=this.j.get(f);if(v){const y=this.n.getNotebookDocument(g.URI.revive(S));L?v.associatedNotebooks.set(y.uri,!0):v.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),L),v.onDidChangeSelection.fire({selected:L,notebook:y.apiNotebook})}}async $executeCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S)),D=[];for(const N of L){const O=y.getCell(N);O&&D.push(O.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),D.length),await v.controller.executeHandler.call(v.controller,D,y.apiNotebook,v.controller)}catch(N){this.q.error(`NotebookController[${f}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,y.apiNotebook);else for(const D of L){const N=y.getCell(D);N&&this.b.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const D=this.c.get(y.uri);L.length&&Array.isArray(D)&&D.length&&D.forEach(N=>N.dispose())}}async $provideVariables(f,S,L,v,y,D,N){const O=this.j.get(f);if(!O)return;const G=this.n.getNotebookDocument(g.URI.revive(L)),W=O.controller.variableProvider;if(!W)return;let U;if(v){if(U=this.s[v],!U)return}else this.s={};const P=y==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,I=W.provideVariables(G.apiNotebook,U,P,D,N);for await(const K of I){if(N.isCancellationRequested)return;const ae={id:this.r++,name:K.variable.name,value:K.variable.value,hasNamedChildren:K.hasNamedChildren,indexedChildrenCount:K.indexedChildrenCount};this.s[ae.id]=K.variable,this.a.$receiveVariable(S,ae)}}$acceptKernelMessageFromRenderer(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getEditorById(S);v.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:L}))}$cellExecutionChanged(f,S,L){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(S);if(y){const D=L?p.NotebookCellExecutionState.to(L):b.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:y.apiCell,state:D})}}_createNotebookCellExecution(f,S){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const y=new h(S,v,this.a);this.b.set(v.uri,y);const D=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),D.dispose(),this.b.delete(v.uri))});return y.asApiObject()}_createNotebookExecution(f,S){const L=this.n.getNotebookDocument(f.uri),v=f.getCells().find(N=>{const O=L.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const y=new s(S,L,this.a),D=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),D.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[y,D]),y.asApiObject()}};e.$uhc=a,e.$uhc=a=Je([He(4,A.$mj)],a);var c;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.m=S,this.n=L,this.b=h.a++,this.c=new M.$Ud,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new C.$5d),this.h=new u(10,v=>this.s(v)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const S=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Sv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let S=this.m;if(f&&(S=this.m.notebook.getCellFromApiCell(f)),!S)throw new Error("INVALID cell");return S.handle}y(f){return f.map(S=>{const L=b.$vM.ensureUniqueMimeTypes(S.items,!0);return L===S.items?p.NotebookCellOutput.from(S):p.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(f,S,L){const v=this.w(S),y=this.y((0,E.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:v,append:L,outputs:y})}async C(f,S,L){return f=b.$vM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(L){f.j=L,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(L){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,v){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Sv({runEndTime:v,lastRunSuccess:L}))},clearOutput(L){return f.t(),f.z([],L,!1)},appendOutput(L,v){return f.t(),f.z(L,v,!0)},replaceOutput(L,v){return f.t(),f.z(L,v,!1)},appendOutputItems(L,v){return f.t(),f.C(L,v,!0)},replaceOutputItems(L,v){return f.t(),f.C(L,v,!1)}})}}var i;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(i||(i={}));class s extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.h=S,this.j=L,this.b=s.a++,this.c=new M.$Ud,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new C.$5d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,S){this.f=f,this.g=S,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$ph,this.b=Date.now(),(0,T.$6g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>f.complete())}}function d(m,f){return`${m.value}/${f}`}e.$vhc=d}),define(Pe[258],Re([1,0,5,3,107]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class M{constructor($,g){this.c=g,this.a=new Map,this.b=$.getProxy(T.$4K.MainThreadNotebookRenderers)}$postRendererMessage($,g,w){const A=this.c.getEditorById($);this.a.get(g)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging($,g){if(!$.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,k,l)=>this.d(g).event(A,k,l),postMessage:(A,k)=>{C.$chc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const l=k&&C.$chc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,g,A)}}}d($){let g=this.a.get($);return g||(g=new E.$Ud({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete($)}}),this.a.set($,g),g)}}e.$whc=M}),define(Pe[259],Re([1,0,6,16,2,23,3]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class ${constructor(w){this.b=new Map,this.a=w.getProxy(R.$4K.MainThreadProfileContentHandlers)}registerProfileContentHandler(w,A,k){if((0,M.$BF)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,w.identifier.value),(0,E.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,k,l){const p=this.b.get(w);if(!p)throw new Error(`Unknown handler with id: ${w}`);return p.saveProfile(A,k,l)}async $readProfile(w,A,k){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,T.$Hf)(A)?A:C.URI.revive(A),k)}}e.$zhc=$}),define(Pe[260],Re([1,0,2,3,13,8]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class R{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(T.$4K.MainThreadQuickDiff)}$provideOriginalResource(g,w,A){const k=E.URI.revive(w),l=this.c.get(g);return l?(0,C.$Xg)(()=>l.provideOriginalResource(k,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,A,k){const l=R.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(g,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Bhc=R}),define(Pe[261],Re([1,0,20,5,6,3,2,7,15,18,31,45,23,8]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;function b(r,o,t){const n=r.getProxy(M.$4K.MainThreadQuickOpen);class a{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,v,y=E.CancellationToken.None){this.c=void 0;const D=Promise.resolve(L),N=++this.f,O=n.$show(N,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),G={},W=O.then(()=>G);return Promise.race([W,D]).then(U=>{if(U===G)return;const P=(0,l.$AF)(S,"quickPickItemTooltip");return D.then(I=>{const K=[];for(let ae=0;ae<I.length;ae++){const he=I[ae];if(typeof he=="string")K.push({label:he,handle:ae});else if(he.kind===$.QuickPickItemKind.Separator)K.push({type:"separator",label:he.label});else{he.tooltip&&!P&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const be=he.iconPath?u(he.iconPath):void 0;K.push({label:he.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(he.tooltip):void 0,handle:ae})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=ae=>{v.onDidSelectItem(I[ae])}),n.$setItems(N,K),O.then(ae=>{if(typeof ae=="number")return I[ae];if(Array.isArray(ae))return ae.map(he=>I[he])})})}).then(void 0,U=>{if(!(0,g.$4)(U))return n.$setError(N,U),Promise.reject(U)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=E.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",L).then(void 0,v=>{if(!(0,g.$4)(v))return Promise.reject(v)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let v;switch(L.severity){case $.InputBoxValidationSeverity.Info:v=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=L.message?A.default.Error:A.default.Ignore;break}return{content:L.message,severity:v}}async showWorkspaceFolderPick(S,L=E.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!v)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===v.uri.toString())}createQuickPick(S){const L=new d(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new m(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,v){const y=this.e.get(S);y instanceof d&&y._fireDidTriggerItemButton(L,v)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Ud,this.q=new T.$Ud,this.r=new T.$Ud,this.s=new T.$Ud,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,v)=>{const y=L===$.$oM.Back?-1:v;this.o.set(y,L)}),this.z({buttons:S.map((L,v)=>({...u(L.iconPath),tooltip:L.tooltip,handle:L===$.$oM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const v=S[L];this.u[L]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof $.$1L)return{id:f.id};const S=s(f),L=i(f);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof L=="string"?R.URI.file(L):L}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const S=h(f);let L,v;return"id"in S?v=k.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:v}}class d extends c{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Ud,this.L=[],this.M=new T.$Ud,this.N=new T.$Ud,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const L=(0,l.$AF)(this.O,"quickPickItemTooltip"),v=[];for(let y=0;y<S.length;y++){const D=S[y];if(D.kind===$.QuickPickItemKind.Separator)v.push({type:"separator",label:D.label});else{D.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=D.iconPath?u(D.iconPath):void 0;v.push({handle:y,label:D.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:L?p.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,G)=>({...u(O.iconPath),tooltip:O.tooltip,handle:G}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,w.$Hb)(S.map(v=>this.C.get(v)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,w.$Hb)(S.map(v=>this.C.get(v)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const v=this.C.get(S);if(!v||!v.buttons||!v.buttons.length)return;const y=v.buttons[L];y&&this.N.fire({button:y,item:v})}}class m extends c{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new a(o,t)}e.$Chc=b}),define(Pe[262],Re([1,0,2,5,66,6,13,3,18,138,14,22,45,8,23,12,21]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=void 0;function n(N){return N instanceof E.URI}function a(N,O){return N.scheme===r.Schemas.file&&O.scheme===r.Schemas.file&&o.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function c(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||l.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function h(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(l.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function i(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,W=typeof O.iconPath=="string"?O.iconPath:E.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,w.$Rq)(G,W)}function s(N,O){let G=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(G=i(N,O),G!==0)return G;if(N.light&&O.light)G=i(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(G!==0)return G;if(N.dark&&O.dark)G=i(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return G}function u(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<N.arguments.length;G++){const W=N.arguments[G],U=O.arguments[G];if(W!==U&&!(n(W)&&n(U)&&a(W,U)))return W<U?-1:1}return 0}function d(N,O){let G=(0,w.$Rq)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(N.command&&O.command)G=u(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(G!==0)return G;if(N.decorations&&O.decorations)G=s(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,w.$Rq)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,w.$Rq)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function m(N,O){for(let G=0;G<N.length;G++)if(N[G]!==O[G])return!1;return!0}function f(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?m(N.arguments,O.arguments):N.arguments===O.arguments)}function S(N,O){return(0,g.$ub)(N,O,f)}class L{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,b.$BF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,b.$BF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,b.$BF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,W,U,P){this.k=O,this.l=U,this.m=P,this.d="",this.e=new T.$Ud,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(O,G){(0,b.$BF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Dhc=L;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,W,U,P,I,K){this.q=O,this.s=G,this.t=W,this.u=U,this.v=P,this.multiDiffEditorEnableViewChanges=I,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Ud,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Ud,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const W=this.h.get(O);return W?(0,R.$Xg)(()=>this.s.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(d),W=(0,g.$Db)(this.o,O,d).map(I=>{const K=I.toInsert.map(ae=>{const he=this.e++;this.g.set(he,ae);const be=ae.resourceUri;let De;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const te=new M.$Sc;De=this.s.converter.toInternal(ae.command,te),this.j.set(he,te)}else this.h.set(he,ae.command);const le=(0,b.$AF)(this.w,"scmMultiDiffEditor"),ve=le?ae.multiDiffEditorOriginalUri:void 0,se=le?ae.multiFileDiffEditorModifiedUri:void 0,we=c(ae.decorations),ne=ae.decorations&&c(ae.decorations.light)||we,Z=ae.decorations&&c(ae.decorations.dark)||we,V=[ne,Z],ie=ae.decorations&&ae.decorations.tooltip||"",Ie=ae.decorations&&!!ae.decorations.strikeThrough,Ae=ae.decorations&&!!ae.decorations.faded,Ce=ae.contextValue||"";return{rawResource:[he,be,V,ie,Ie,Ae,Ce,De,ve,se],handle:he}});return{start:I.start,deleteCount:I.deleteCount,toInsert:K}}),U=W.map(({start:I,deleteCount:K,toInsert:ae})=>[I,K,ae.map(he=>he.rawResource)]),P=W.reverse();for(const{start:I,deleteCount:K,toInsert:ae}of P){const he=ae.map(De=>De.handle),be=this.n.splice(I,K,...he);for(const De of be)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=O,U}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,b.$AF)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,b.$BF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,b.$BF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new M.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new M.$Sc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,b.$BF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,b.$BF)(this.x,"scmActionButton"),this.p.value=new M.$Sc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(W=>W.map(U=>this.y.converter.toInternal(U,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new M.$Sc,this.t=O;const G=(O||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,W,U,P,I,K){this.x=O,this.y=U,this.z=P,this.A=I,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Uc,this.m=void 0,this.n=new M.$Uc,this.o=void 0,this.p=new M.$Uc,this.s=new M.$Uc,this.t=void 0,this.u=!1,this.v=new T.$Ud,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=W;const ae=E.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new L(O,G,this.#e,this.w,ae),this.#e.$registerSourceControl(this.w,P,I,K,ae)}createResourceGroup(O,G,W){const U=(0,b.$AF)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,P=new v(this.#e,this.y,this.w,O,G,U,this.x),I=T.Event.once(P.onDidDispose)(()=>this.C.delete(P));return this.C.set(P,I),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const O=[],G=[];for(const[W,U]of this.C){U.dispose();const P=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.D.delete(W),P.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),O.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const I=W._takeResourceStateSnapshot();I.length>0&&G.push([W.handle,I]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&O.push([G.handle,W])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,C.$xh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Je([(0,C.$xh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,W,U){this.l=G,this.m=W,this.n=U,this.g=new Map,this.h=new k.$mm,this.j=new T.$Ud,this.e=O.getProxy($.$4K.MainThreadSCM),this.f=O.getProxy($.$4K.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const I=this.g.get(P.sourceControlHandle);if(!I)return P;const K=I.getResourceGroup(P.groupHandle);return K?K.getResourceState(P.handle):P}else if(P&&P.$mid===4){const I=this.g.get(P.sourceControlHandle);return I?I.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const I=this.g.get(P.handle);return I||P}return P}})}createSourceControl(O,G,W,U){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,W,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const P=t.d++,I=new y(O,this.m,this.e,this.l,G,W,U);this.g.set(P,I);const K=this.h.get(O.identifier)||[];return K.push(I),this.h.set(O.identifier,K),I}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(O,G,W){const U=E.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,U.toString());const P=this.g.get(O);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Xg)(()=>P.quickDiffProvider.provideOriginalResource(U,W)).then(I=>I||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const W=this.g.get(O);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,W,U){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,W);const P=this.g.get(O);if(!P)return Promise.resolve(void 0);const I=P.getResourceGroup(G);return I?I.$executeResourceCommand(W,U):Promise.resolve(void 0)}$validateInput(O,G,W){this.n.trace("ExtHostSCM#$validateInput",O);const U=this.g.get(O);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Xg)(()=>U.inputBox.validateInput(G,W)).then(P=>{if(!P)return Promise.resolve(void 0);const I=p.MarkdownString.fromStrict(P.message);return I?Promise.resolve([I,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,G,W){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(G,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,G,W,U){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,U)??void 0}async $provideHistoryItems(O,G,W,U){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,W,U))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemChanges(O,G,W,U){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,W,U)??void 0}};e.$Ehc=D,e.$Ehc=D=t=Je([He(3,A.$mj)],D)}),define(Pe[84],Re([1,0,3,5,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=void 0;class M{constructor($){this.b=new T.$Ud,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$4K.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,g){return this.a.$getPassword($,g)}store($,g,w){return this.a.$setPassword($,g,w)}delete($,g){return this.a.$deletePassword($,g)}}e.$Kgc=M,e.$Lgc=(0,C.$5h)("IExtHostSecretState")}),define(Pe[263],Re([1,0,3,8,2]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class M{static{this.a=0}constructor($,g){this.d=g,this.c=new Map,this.b=$.getProxy(E.$4K.MainThreadShare)}async $provideShare($,g,w){return await this.c.get($)?.provideShare({selection:T.Range.to(g.selection),resourceUri:C.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider($,g){const w=M.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,T.DocumentSelector.from($,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Fhc=M}),define(Pe[264],Re([1,0,20,6,3]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(C.$4K.MainThreadSpeech)}async $createSpeechToTextSession($,g){const w=this.c.get($);if(!w)return;const A=new T.$Sc,k=new E.$5d;this.d.set(g,k);const l=A.add(w.provideSpeechToTextSession(k.token));A.add(l.onDidChange(p=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,p)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,g,w){const A=M.a++;return this.c.set(A,w),this.b.$registerProvider(A,g,{extension:$,displayName:$.value}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Ghc=M}),define(Pe[265],Re([1,0,7,3,163,6,8,16]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=e.$Hhc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$2L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$2L("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,b,r,o,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Sc,this.#e=l,this.#t=p,o&&r){this.c=(0,E.$EL)(r.identifier,o);const a=b.get(this.c);a&&(t=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(g.a++);this.e=r,this.f=o,this.g=t,this.h=this.u(n)}u(l){if((0,$.$Lf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=g.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,r,this.r?.internal,b,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Hhc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new E.$6K(()=>{const b=this.b.indexOf(p);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(T.$4K.MainThreadStatusBar),this.b=p,this.c=new w(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,b,r){return new g(this.a,this.b,this.e,l,p,b,r)}setStatusBarMessage(l,p){const b=this.c.setMessage(l);let r;return typeof p=="number"?r=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new E.$6K(()=>{b.dispose(),clearTimeout(r)})}}e.$Ihc=A}),define(Pe[85],Re([1,0,3,5,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=void 0;class M{constructor($,g){this.c=g,this.b=new T.$Ud,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$4K.MainThreadStorage)}registerExtensionStorageKeysToSync($,g){this.a.$registerExtensionStorageKeysToSync($,g)}async initializeExtensionStorage($,g,w){const A=await this.a.$initializeExtensionStorage($,g);let k;return A&&(k=this.d($,g,A)),k||w}setValue($,g,w){return this.a.$setValue($,g,w)}$acceptValue($,g,w){const A=this.d($,g,w);A&&this.b.fire({shared:$,key:g,value:A})}d($,g,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${$}): ${A}`)}}}e.$Cgc=M,e.$Dgc=(0,C.$5h)("IExtHostStorage")}),define(Pe[86],Re([1,0,4,27,14,63,2]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=void 0,e.$lgc=(0,E.$5h)("IExtensionStoragePaths");let $=class{constructor(w,A,k){this.d=A,this.f=k,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return R.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(w){if(this.c)return R.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return R.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$mgc=$,e.$mgc=$=Je([He(0,T.$lN),He(1,C.$mj),He(2,M.$kgc)],$)}),define(Pe[64],Re([1,0,5,3,4,2,17,6,7,165,15,193,20,33,194,45,13,8,32]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=e.$Igc=e.$Hgc=e.$Ggc=void 0,e.$Ggc=(0,C.$5h)("IExtHostTerminalService");class a{constructor(v,y,D,N){this.l=v,this._id=y,this.m=D,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(G,W=!0){O.q(),O.l.$sendText(O._id,G,W)},show(G){O.q(),O.l.$show(O._id,G)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??y?.cwd??void 0,env:v.env??void 0,icon:m(v.iconPath)??void 0,color:r.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(v.location,y?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,y,D,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:N,color:r.ThemeColor.isThemeColor(O)?O.id:void 0,location:y?.location||this.o(v,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,y){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in v?{viewColumn:t.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,y){this.h=Object.freeze({code:v,reason:y})}setDimensions(v,y){return v===this.d&&y===this.g||v===0||y===0?!1:(this.d=v,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(y=>{y!==v&&(this.b=Promise.resolve(v))})}}e.$Hgc=a;class c{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new E.$Ud,this.onProcessData=this.a.event,this.b=new E.$Ud,this.d=new E.$Ud,this.onDidChangeProperty=this.d.event,this.f=new E.$Ud,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,y){this.g.setDimensions?.({columns:v,rows:y})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends $.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Ud,this.onDidCloseTerminal=this.H.event,this.I=new E.$Ud,this.onDidOpenTerminal=this.I.event,this.J=new E.$Ud,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Ud,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Ud,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Ud,this.onDidChangeShell=this.N.event,this.O=new E.$Ud({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Ud({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(T.$4K.MainThreadTerminalService),this.y=new b.$Erb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:N=>{const O=G=>{const W=G;return this.W(W.instanceId)?.value};switch(N?.$mid){case 15:return O(N);default:{if(Array.isArray(N))for(let G=0;G<N.length&&N[G].$mid===15;G++)N[G]=O(N[G]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,y){const D=new a(this.a,(0,p.$pg)(),v,v.name),N=new c(v.pty);return D.createExtensionTerminal(v.location,y,this.R(v,y).resolvedExtHostIdentifier,m(v.iconPath),f(v.color)).then(O=>{const G=this.S(O,N);this.h[O]=G}),this.f.push(D),D.value}R(v,y){if(y=y||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const D=v.location.parentTerminal;if(D){const N=this.f.find(O=>O.value===D);N&&(y.resolvedExtHostIdentifier=N._id)}}else v.location&&typeof v.location!="object"?y.location=v.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(v,y){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const N=new c(y),O=this.S(v,N);this.h[v]=O}async $acceptActiveTerminalChanged(v){const y=this.b;if(v===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.W(v);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,y){const D=this.W(v);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(v,y,D){const N=this.W(v);N&&N.setDimensions(y,D)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(v,y){const D=this.W(v);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(v,y,D){this.g.get(v)?.resize(y,D)}async $acceptTerminalTitleChange(v,y){const D=this.W(v);D&&(D.name=y)}async $acceptTerminalClosed(v,y,D){const N=this.Y(this.f,v);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(y,D),this.H.fire(O.value)}}$acceptTerminalOpened(v,y,D,N){if(y){const W=this.Y(this.f,y);if(W!==null){this.f[W]._id=v,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:M.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},G=new a(this.a,v,O,D);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(v,y){this.W(v)?._setProcessId(y)}async $startExtensionTerminal(v,y){const D=this.W(v);if(!D)return{message:(0,w.localize)(0,null,v)};D.isOpen||await new Promise(O=>{const G=this.onDidOpenTerminal(async W=>{W===D.value&&(G.dispose(),O())})});const N=this.g.get(v);N?N.startSendingEvents(y):this.j[v]={initialDimensions:y}}S(v,y){const D=new $.$Sc;D.add(y.onProcessReady(O=>this.a.$sendProcessReady(v,O.pid,O.cwd,O.windowsPty))),D.add(y.onDidChangeProperty(O=>this.a.$sendProcessProperty(v,O))),this.y.startBuffering(v,y.onProcessData),D.add(y.onProcessExit(O=>this.U(v,O))),this.g.set(v,y);const N=this.j[v];return N&&y instanceof c&&(y.startSendingEvents(N.initialDimensions),delete this.j[v]),D}$acceptProcessAckDataEvent(v,y){this.g.get(v)?.acknowledgeDataEvent(y)}$acceptProcessInput(v,y){this.g.get(v)?.input(y)}$acceptTerminalInteraction(v){const y=this.W(v);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(v,y){this.W(v)?.setSelection(y)}$acceptProcessResize(v,y,D){try{this.g.get(v)?.resize(y,D)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(v,y){this.g.get(v)?.shutdown(y)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(y=>this.a.$sendProcessProperty(v,{type:"cwd",value:y}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new g.$6K(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,v.identifier.value),new g.$6K(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(v,y,D){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,D),this.a.$registerQuickFixProvider(v,y),new g.$6K(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,y){const D=new l.$5d().token;if(D.isCancellationRequested)return;const N=this.D.get(v);if(!N)return;const O=await N.provideTerminalQuickFixes(y,D);if(O===null||Array.isArray(O)&&O.length===0)return;const G=new $.$Sc;if(this.w.value=G,!Array.isArray(O))return O?t.TerminalQuickFix.from(O,this.Q.converter,G):void 0;const W=[];for(const U of O){const P=t.TerminalQuickFix.from(U,this.Q.converter,G);P&&W.push(P)}return W}async $createContributedProfileTerminal(v,y){const D=new l.$5d().token;let N=await this.C.get(v)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,y);return}this.createTerminalFromOptions(N.options,y)}}async $provideLinks(v,y){const D=this.W(v);if(!D)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const O=new l.$5d;this.G.set(v,O);const G=[],W={terminal:D.value,line:y},U=[];for(const K of this.z)U.push(o.Promises.withAsyncBody(async ae=>{O.token.onCancellationRequested(()=>ae({provider:K,links:[]}));const he=await K.provideTerminalLinks(W,O.token)||[];O.token.isCancellationRequested||ae({provider:K,links:he})}));const P=await Promise.all(U);if(O.token.isCancellationRequested)return[];const I=new Map;for(const K of P)K&&K.links.length>0&&G.push(...K.links.map(ae=>{const he={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return I.set(he.id,{provider:K.provider,link:ae}),he}));return this.F.set(v,I),G}$activateLink(v,y){const D=this.F.get(v)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(v,y){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const D=this.h[v];D&&(D.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,y)}W(v){return this.X(this.f,v)}X(v,y){const D=this.Y(v,y);return D!==null?v[D]:null}Y(v,y){const D=v.findIndex(N=>N._id===y);return D===-1?null:D}getEnvironmentVariableCollection(v){let y=this.n.get(v.identifier.value);return y||(y=new s,this.$(v.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(v,y){const D=(0,k.$Lr)(y.map),N=(0,k.$Mr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(v,y.persistent,D.length===0?void 0:D,N)}$initEnvironmentVariableCollections(v){v.forEach(y=>{const D=y[0],N=new s(y[1]);this.$(D,N)})}$acceptDefaultProfile(v,y){const D=this.s;this.s=v,this.u=y,D?.path!==v.path&&this.N.fire(v.path)}$(v,y){this.n.set(v,y),y.onDidChangeCollection(()=>{this.Z(v,y)})}};e.$Igc=i,e.$Igc=i=Je([He(1,n.$rN),He(2,R.$8M)],i);class s{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Ud,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const y=this.h(v);let D=this.a.get(y);return D||(D=new u(this,v),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:N})}append(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:N})}prepend(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:N})}f(v,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(v,y.scope),N=this.map.get(D),O=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==y.value||N.type!==y.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const G=this.g(v,y.scope),W={variable:v,...y,options:O};this.map.set(G,W),this.d.fire()}}get(v,y){const D=this.g(v,y),N=this.map.get(D);return N?S(N):void 0}g(v,y){const D=this.h(y);return D.length?`${v}:::${D}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const y=new Map;for(const[D,N]of this.map)this.h(N.scope)===this.h(v)&&y.set(N.variable,S(N));return y}delete(v,y){const D=this.g(v,y);this.map.delete(D),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(y);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,y){const D=this.h(y),N=this.descriptionMap.get(D);if(!N||N.description!==v){let O;typeof v=="string"?O=v:O=v?.value.split(`

`)[0];const G={description:O,scope:y};this.descriptionMap.set(D,G),this.d.fire()}}getDescription(v){const y=this.h(v);return this.descriptionMap.get(y)?.description}k(v){const y=this.h(v);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,y){this.b=v,this.d=y,this.a=new E.$Ud}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,y,D){this.b.replace(v,y,D,this.d)}append(v,y,D){this.b.append(v,y,D,this.d)}prepend(v,y,D){this.b.prepend(v,y,D,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,y){this.b.getVariableMap(this.d).forEach((D,N)=>v.call(y,N,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(v,y){super(!1,v,y)}createTerminal(v,y,D){throw new A.$_}createTerminalFromOptions(v,y){throw new A.$_}};e.$Jgc=d,e.$Jgc=d=Je([He(0,n.$rN),He(1,R.$8M)],d);function m(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function f(L){return r.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const v={...L};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Pe[266],Re([1,0,13,24,20,5,218,98,6,26,16,33,14,3,17,108,8,7,48,77,58,23]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=e.$Nhc=e.$Mhc=void 0;let i=class extends g.$Tc{constructor(U,P,I,K){super(),this.w=K,this.f=this.B(new M.$Ud),this.g=new Map,this.s=this.B(new M.$Ud),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(p.$4K.MainThreadTesting),this.m=new D(this.h),this.j=new m(this.h,P),I.registerArgumentProcessor({processArgument:ae=>{switch(ae?.$mid){case 16:{const he=ae,be=he.tests[he.tests.length-1].item.extId;return this.g.get(n.$VJ.root(be))?.collection.tree.get(be)?.actual??(0,r.$hN)(ae)}case 18:{const{extId:he,message:be}=ae;return{test:this.g.get(n.$VJ.root(he))?.collection.tree.get(he)?.actual,message:o.TestMessage.to(be)}}default:return ae}}}),I.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ae=await I.executeCommand("_testing.getExplorerSelection"),he=be=>{const De=this.g.get(n.$VJ.root(be));if(De)return n.$VJ.isRoot(be)?De.controller:De.collection.tree.get(be)?.actual};return{include:ae?.include.map(he).filter(A.$Pf)||[],exclude:ae?.exclude.map(he).filter(A.$Pf)||[]}})}createTestController(U,P,I,K){if(this.g.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const ae=new g.$Sc,he=ae.add(new r.$kN(P,I,this.w));he.root.label=I;const be=new Map,De=new Set,le=this.h,ve={items:he.root.children,get label(){return I},set label(we){I=we,he.root.label=we,le.$updateController(P,{label:I})},get refreshHandler(){return K},set refreshHandler(we){K=we,le.$updateController(P,{canRefresh:!!we})},get id(){return P},createRunProfile:(we,ne,Z,V,ie,Ie)=>{let Ae=(0,$.$Si)(we);for(;be.has(Ae);)Ae++;return new O(this.h,be,U,De,this.s.event,P,Ae,we,ne,Z,V,ie,Ie)},createTestItem(we,ne,Z){return new r.$iN(P,we,ne,Z)},createTestRun:(we,ne,Z=!0)=>this.j.createTestRun(U,P,he,we,ne,Z),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const ne=we instanceof Array?we:[we];this.h.$markTestRetired(ne.map(Z=>n.$VJ.fromExtHostTestItem(Z,P).toString()))}},set resolveHandler(we){he.resolveHandler=we},get resolveHandler(){return he.resolveHandler},dispose:()=>{ae.dispose()}};le.$registerTestController(P,I,!!K),ae.add((0,g.$Rc)(()=>le.$unregisterTestController(P)));const se={controller:ve,collection:he,profiles:be,extension:U,activeProfiles:De};return this.g.set(P,se),ae.add((0,g.$Rc)(()=>this.g.delete(P))),ae.add(he.onDidGenerateDiff(we=>le.$publishDiff(P,we.map(c.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,P=C.CancellationToken.None){const I=f(U);if(!I)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const K=this.g.get(I.controllerId);if(!K)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ae=>n.$VJ.fromExtHostTestItem(ae,K.collection.root.id).toString())??[K.collection.root.id],profileGroup:G[I.kind],profileId:I.profileId,controllerId:I.controllerId}],exclude:U.exclude?.map(ae=>ae.id)},P)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,P,I){return await this.j.getCoverageReport(U,P)?.provideFileCoverage(I)??[]}async $resolveFileCoverage(U,P,I,K){return await this.j.getCoverageReport(U,P)?.resolveFileCoverage(I,K)??[]}$configureRunProfile(U,P){this.g.get(U)?.profiles.get(P)?.configureHandler?.()}$setDefaultRunProfiles(U){const P=new Map;for(const[I,K]of Object.entries(U)){const ae=this.g.get(I);if(!ae)continue;const he=new Map,be=K.filter(le=>!ae.activeProfiles.has(le)),De=[...ae.activeProfiles].filter(le=>!K.includes(le));for(const le of be)he.set(le,!0),ae.activeProfiles.add(le);for(const le of De)he.set(le,!1),ae.activeProfiles.delete(le);he.size&&P.set(I,he)}this.s.fire(P)}async $refreshTests(U,P){await this.g.get(U)?.controller.refreshHandler?.(P)}$publishTestResults(U){this.results=Object.freeze(U.map(P=>(0,w.$vn)(o.TestResults.to(P))).concat(this.results).sort((P,I)=>I.completedAt-P.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,P){const I=this.g.get(n.$VJ.fromString(U).controllerId)?.collection;I&&(await I.expand(U,P<0?1/0:P),I.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(P=>c.TestsDiffOp.deserialize({asCanonicalUri:I=>I},P)))}async $runControllerTests(U,P){return Promise.all(U.map(I=>this.y(I,!1,P)))}async $startContinuousRun(U,P){const I=new C.$5d(P),K=await Promise.all(U.map(ae=>this.y(ae,!0,I.token)));return!P.isCancellationRequested&&!K.some(ae=>ae.error)&&await new Promise(ae=>P.onCancellationRequested(ae)),I.dispose(!0),K}async y(U,P,I){const K=this.g.get(U.controllerId);if(!K)return{};const{collection:ae,profiles:he,extension:be}=K,De=he.get(U.profileId);if(!De)return{};const le=U.testIds.map(ne=>ae.tree.get(ne)).filter(A.$Pf),ve=U.excludeExtIds.map(ne=>K.collection.tree.get(ne)).filter(A.$Pf).filter(ne=>le.some(Z=>Z.fullId.compare(ne.fullId)===2));if(!le.length)return{};const se=new t.$CM(le.some(ne=>ne.actual instanceof r.$jN)?void 0:le.map(ne=>ne.actual),ve.map(ne=>ne.actual),De,P),we=(0,c.$XJ)(U)&&this.j.prepareForMainThreadTestRun(se,S.fromInternal(U,K.collection),be,I);try{return await De.runHandler(se,I),{}}catch(ne){return{error:String(ne)}}finally{we&&(we.hasRunningTasks&&!I.isCancellationRequested&&await M.Event.toPromise(we.onEnd),we.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Mhc=i,e.$Mhc=i=Je([He(0,b.$8M),He(1,l.$mj)],i);const s=1e4;var u;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(u||(u={}));class d extends g.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,P,I,K,ae){super(),this.s=U,this.w=P,this.y=I,this.z=K,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new M.$Ud),this.m=this.B(new M.$Ud),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new C.$5d(ae));const he=this.B(new E.$eh(()=>this.C(),s));this.B(this.h.token.onCancellationRequested(()=>he.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const P=this.s.id,I=this.s.controllerId,K=(0,k.$pg)(),ae=this.y,he=this.m;let be;const De=we=>(ne,...Z)=>{if(ve){this.z.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.F(ne),we(ne,...Z))},le=(we,ne)=>{const Z=ne instanceof Array?ne.map(o.TestMessage.from):[o.TestMessage.from(ne)];if(we.uri&&we.range){const V={range:o.Range.from(we.range),uri:we.uri};for(const ie of Z)ie.location=ie.location||V}this.w.$appendTestMessagesInRun(P,K,n.$VJ.fromExtHostTestItem(we,I).toString(),Z)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return be?.provider},set coverageProvider(we){(0,h.$BF)(ae,"testCoverage"),be=we&&new L(we),he.fire({taskId:K,runId:P,coverage:be})},enqueued:De(we=>{this.w.$updateTestStateInRun(P,K,n.$VJ.fromExtHostTestItem(we,I).toString(),1)}),skipped:De(we=>{this.w.$updateTestStateInRun(P,K,n.$VJ.fromExtHostTestItem(we,I).toString(),5)}),started:De(we=>{this.w.$updateTestStateInRun(P,K,n.$VJ.fromExtHostTestItem(we,I).toString(),2)}),errored:De((we,ne,Z)=>{le(we,ne),this.w.$updateTestStateInRun(P,K,n.$VJ.fromExtHostTestItem(we,I).toString(),6,Z)}),failed:De((we,ne,Z)=>{le(we,ne),this.w.$updateTestStateInRun(P,K,n.$VJ.fromExtHostTestItem(we,I).toString(),4,Z)}),passed:De((we,ne)=>{this.w.$updateTestStateInRun(P,K,n.$VJ.fromExtHostTestItem(we,this.s.controllerId).toString(),3,ne)}),appendOutput:(we,ne,Z)=>{ve||(Z&&(this.s.isIncluded(Z)?this.F(Z):Z=void 0),this.w.$appendOutputToRun(P,K,T.$ie.fromString(we),ne&&o.location.from(ne),Z&&n.$VJ.fromExtHostTestItem(Z,I).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(P,K),this.f.delete(K),this.f.size||this.D())}};return this.f.set(K,{run:se}),this.w.$startedTestRunTask(P,{id:K,name:U,running:!0}),se}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof r.$iN))throw new a.$ZM(U.id);if(this.g.has(n.$VJ.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const P=[],I=this.s.colllection.root;for(;;){const K=o.TestItem.from(U);if(P.unshift(K),this.g.has(K.extId)||(this.g.add(K.extId),U===I))break;U=U.parent||I}this.w.$addTestsToRun(this.s.controllerId,this.s.id,P)}dispose(){this.D(),super.dispose()}}class m{get trackers(){return this.c.values()}constructor(U,P){this.g=U,this.h=P,this.c=new Map,this.f=[]}getCoverageReport(U,P){return this.f.find(I=>I.runId===U)?.coverage.get(P)}prepareForMainThreadTestRun(U,P,I,K){return this.j(U,P,I,K)}cancelRunById(U){for(const P of this.c.values())if(P.id===U){P.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,P,I,K,ae,he){const be=this.c.get(K);if(be)return be.createRun(ae);const De=S.fromPublic(P,I,K,he),le=f(K);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!K.continuous,profile:le&&{group:G[le.kind],id:le.profileId},exclude:K.exclude?.map(se=>n.$VJ.fromExtHostTestItem(se,I.root.id).toString())??[],id:De.id,include:K.include?.map(se=>n.$VJ.fromExtHostTestItem(se,I.root.id).toString())??[I.root.id],persist:he});const ve=this.j(K,De,U);return M.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(De.id),ve.dispose()}),ve.createRun(ae)}j(U,P,I,K){const ae=new d(P,this.g,I,this.h,K);this.c.set(U,ae);let he;const be=ae.onDidCoverage(({runId:De,taskId:le,coverage:ve})=>{he||(he={runId:De,coverage:new Map},this.f.unshift(he),this.f.length>c.$3J&&this.f.pop()),he.coverage.set(le,ve),this.g.$signalCoverageAvailable(De,le,!!ve)});return M.Event.once(ae.onEnd)(()=>{this.c.delete(U),be.dispose()}),ae}}e.$Nhc=m;const f=W=>{if(W.profile){if(!(W.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class S{static fromPublic(U,P,I,K){return new S(U,(0,k.$pg)(),I.include?.map(ae=>n.$VJ.fromExtHostTestItem(ae,U).toString())??[U],I.exclude?.map(ae=>n.$VJ.fromExtHostTestItem(ae,U).toString())??[],K,P)}static fromInternal(U,P){return new S(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,P)}constructor(U,P,I,K,ae,he){this.controllerId=U,this.id=P,this.isPersisted=ae,this.colllection=he,this.c=I.map(be=>be+"\0"),this.f=K.map(be=>be+"\0")}isIncluded(U){const P=n.$VJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const I of this.f)if(P===I||P.startsWith(I))return!1;for(const I of this.c)if(P===I||P.startsWith(I))return!0;return!1}}e.$Ohc=S;class L{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(o.TestCoverage.fromFile)??[]}catch(P){throw this.c=void 0,P}}async resolveFileCoverage(U,P){const I=await this.c;let K=I?.[U];return!this.provider||!I||!K?[]:(K.detailedCoverage||(K=I[U]=await this.provider.resolveFileCoverage?.(K,P)??K),K.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,o.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const P=n.$VJ.parentId(U.item.extId);if(P&&this.h.has(P.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:P,g:I}=this;return{get added(){return[...U].map(K=>K.revived)},get updated(){return[...P].map(K=>K.revived)},get removed(){return[...I].map(K=>K.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends c.$4J{constructor(){super(...arguments),this.s=new M.$Ud,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,P){return{...U,revived:o.TestItem.toPlain(U.item),depth:P?P.depth+1:0,children:new Set}}v(){return new v(this.s)}}class D{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(P=>P.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new y({asCanonicalUri:P=>P});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const N=(W,U,P,I)=>{P?Object.assign(P,I):U.$updateTestRunConfig(W.controllerId,W.profileId,I)};class O{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,N(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,N(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#i.add(this.profileId):this.#i.delete(this.profileId),N(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,N(this,this.#e,this.#n,{tag:U?o.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,N(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return(0,h.$BF)(this.#t,"testingActiveProfile"),M.Event.chain(this.#o,U=>U.map(P=>P.get(this.controllerId)?.get(this.profileId)).filter(A.$Pf))}constructor(U,P,I,K,ae,he,be,De,le,ve,se=!1,we=void 0,ne=!1){this.controllerId=he,this.profileId=be,this.f=De,this.kind=le,this.runHandler=ve,this._tag=we,this.g=ne,this.#e=U,this.#r=P,this.#t=I,this.#i=K,this.#o=ae,P.set(be,this);const Z=G[le];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${le}`);se&&K.add(be),this.#n={profileId:be,controllerId:he,tag:we?o.TestTag.namespace(this.controllerId,we.id):null,label:De,group:Z,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:ne},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Phc=O;const G={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Pe[267],Re([1,0,18,5,3,109,8,7]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class g{constructor(A,k){this.i=k,this.a=new T.$Ud,this.b=new T.$Ud,this.c=new T.$Ud,this.d=new T.$Ud,this.f=new T.$Ud,this.g=new T.$Ud,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(C.$4K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const k=this.i.allEditors();return A?k:k.map(l=>l.value)}async showTextDocument(A,k,l){let p;typeof k=="number"?p={position:R.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?p={position:R.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?R.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:p={preserveFocus:!1};const b=await this.h.$tryShowTextDocument(A.uri,p),r=b&&this.i.getEditor(b);if(r)return r.value;throw b?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new M.$cN(this.h,A,k).value}$acceptEditorPropertiesChanged(A,k){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const p=k.selections.selections.map(R.Selection.to);l._acceptSelections(p)}if(k.visibleRanges){const p=E.$Hb(k.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(p)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:R.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const p=$.TextEditorSelectionChangeKind.fromValue(k.selections.source),b=k.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:b,kind:p})}if(k.visibleRanges){const p=E.$Hb(k.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(A){for(const k in A){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const p=R.ViewColumn.to(A[k]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this.d.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$_fc=g}),define(Pe[268],Re([1,0,2,4,3,6,7,8,22,16]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,T.$5h)("IExtHostTimeline");class A{constructor(p,b){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$4K.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&g.$km.equals(o,this.b.get(r.source)?.extension)){const t=r.uri===void 0?void 0:E.URI.revive(r.uri);return this.c.get(r.source)?.get(k(t))?.get(r.handle)}else return;return r}})}async $getTimeline(p,b,r,o){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(b),r,o)}registerTimelineProvider(p,b,r,o){const t=new M.$Sc,n=this.d(b.id,o,t).bind(this);let a;b.onDidChange&&(a=b.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:b.id}),this));const c=this.c;return this.f({...b,scheme:p,onDidChange:void 0,async provideTimeline(h,i,s){i?.resetCache&&(t.clear(),c.get(b.id)?.clear());const u=await b.provideTimeline(h,i,s);if(u==null)return;const d=n(h,i);return{...u,source:b.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(b.id)?.clear();a?.dispose(),t.dispose()}},r)}d(p,b,r){return(o,t)=>{let n;if(t?.cacheResults){let a=this.c.get(p);a===void 0&&(a=new Map,this.c.set(p,a));const c=k(o);n=a.get(c),n===void 0&&(n=new Map,a.set(c,n))}return a=>{const{iconPath:c,...h}=a,i=`${p}|${a.id??a.timestamp}`;n?.set(i,a);let s,u,d;a.iconPath&&(c instanceof R.$1L?d={id:c.id,color:c.color}:E.URI.isUri(c)?(s=c,u=c):{light:s,dark:u}=c);let m;return R.$uL.isMarkdownString(h.tooltip)?m=$.MarkdownString.from(h.tooltip):(0,w.$Hf)(h.tooltip)?m=h.tooltip:R.$uL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=$.MarkdownString.from(h.detail)):(0,w.$Hf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=h.detail),{...h,id:h.id??void 0,handle:i,source:p,command:a.command?b.toInternal(a.command,r):void 0,icon:s,iconDark:u,themeIcon:d,tooltip:m,accessibilityInformation:a.accessibilityInformation}}}}f(p,b){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:b}),(0,M.$Rc)(()=>{for(const o of this.c.values())o.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$Shc=A;function k(l){return l?.toString()}}),define(Pe[87],Re([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jyb=e.$iyb=e.TunnelDtoConverter=void 0;class p extends g.$Iv{}var b;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function n(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=n})(b||(e.TunnelDtoConverter=b={})),e.$iyb=(0,R.$5h)("IExtHostTunnelService");let r=class extends C.$Tc{constructor(t,n,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Ud,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$4K.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const a=await this.a.$openTunnel(n,t.displayName);if(a){const c=new p(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const a=this.u();return this.r.set(a,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,a),new l.$6K(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,n,a,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(n.map(async m=>{let f;try{f=await d.provider.providePortAttributes({port:m,pid:a,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(m,a,c,h)}return{providedAttributes:f,port:m}})))}const s=i.filter(u=>!!u.providedAttributes);return s.length>0?s.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$5d().token)??void 0;const a=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const a=t.tunnelFactory??(n?this.w(n):void 0);if(a){this.b=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const a=this.g.get(t.host);a.has(t.port)&&(n&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),b.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),a=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.$jyb=r,e.$jyb=r=Je([He(0,k.$8M),He(1,A.$lN),He(2,$.$mj)],r)}),define(Pe[269],Re([1,0,6,12,2,3]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(M.$4K.MainThreadUriOpeners)}registerExternalUriOpener(g,w,A,k){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=k.schemes.find(p=>!R.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,k.schemes,g,k.label),(0,E.$Rc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const l=C.URI.revive(w);return k.canOpenExternalUri(l,A)}async $openUri(g,w,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(C.URI.revive(w.resolvedUri),{sourceUri:C.URI.revive(w.sourceUri)},A)}}e.$Uhc=R}),define(Pe[270],Re([1,0,3,2,6,15,22]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class ${static{this.a=0}constructor(w){this.c=new R.$lm,this.d=new Map,this.b=w.getProxy(E.$4K.MainThreadUrls)}registerUriHandler(w,A){const k=w.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=$.a++;return this.c.add(k),this.d.set(l,A),this.b.$registerUriHandler(l,k,w.displayName||w.name),(0,C.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,A){const k=this.d.get(w);if(!k)return Promise.resolve(void 0);try{k.handleUri(T.URI.revive(A))}catch(l){(0,M.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$Vhc=$}),define(Pe[65],Re([1,0,5,6,12,26,2,181,203,78,3]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=e.$qgc=e.$pgc=e.$ogc=e.$ngc=void 0;class k{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(c,h,i,s,u,d,m){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Ud,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Ud,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=s,this.#n=u,this.#r=d,this.#l=l(d),this.#d=p(d),this.#i=m}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$qvb)(c,this.#o)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$pvb}return w.$pvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),M.$yn(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#n,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$9kb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,w.$qvb)(L,{isRemote:h,authority:i}).toString();return`${u}${v}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,w.$qvb)(L,{isRemote:h,authority:i}).toString();return`${u}${v}${S}`})}}e.$ngc=k;function l(a){try{const c=(0,$.$bp)((0,$.$ap)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$ogc=l;function p(a){try{const c=(0,$.$bp)((0,$.$ap)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class b extends T.$Tc{constructor(c,h,i,s,u){super(),this.c=h,this.f=i,this.g=s,this.h=u,this.b=new Map,this.a=c.getProxy(A.$4K.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const s=this.j(c);if(s){const{message:u}=(0,g.$0kb)(h,i.value);s._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const s=new k(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,s);const u=s._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$pgc=b;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.$qgc=r;function o(a,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(a,c)}}e.$rgc=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>R.URI.from(c))}}function n(a,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Pe[271],Re([1,0,20,98,6,12,25,2,8,65,75,3,7]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class p{constructor(s,u){this.document=s,this.b=u,this.a=1,this.c=new A.$Sfc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,u){await this.f(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.f(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,R.$Gg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const u=this.c.get(s,0);if(!u)throw new Error("No edit found");return u}}class b{constructor(){this.a=new Map}get(s,u){return this.a.get(this.b(s,u))}add(s,u,d){const m=this.b(s,u.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const f=new p(u,d);return this.a.set(m,f),f}delete(s,u){const d=this.b(s,u.uri);this.a.delete(d)}b(s,u){return`${s}@@@${u}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(s,u,d){return this.b(0,s,u,d)}addCustomProvider(s,u,d){return this.b(1,s,u,d)}get(s){return this.a.get(s)}b(s,u,d,m){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:s,extension:d,provider:m}),new l.$6K(()=>this.a.delete(u))}}class t{constructor(s,u,d,m,f){this.d=u,this.f=d,this.g=m,this.h=f,this.b=new o,this.c=new b,this.a=s.getProxy(k.$4K.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,d,m){const f=new C.$Sc;return a(d)?(f.add(this.b.addTextProvider(u,s,d)),this.a.$registerTextEditorProvider((0,w.$qgc)(s),u,m.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$ogc)(s))):(f.add(this.b.addCustomProvider(u,s,d)),n(d)&&f.add(d.onDidChangeCustomDocument(S=>{const L=this.i(u,S.document.uri);if(c(S)){const v=L.addEdit(S);this.a.$onDidEdit(S.document.uri,u,v,S.label)}else this.a.$onContentChange(S.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$qgc)(s),u,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,w.$ogc)(s))),l.$6K.from(f,new l.$6K(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,d,m,f){const S=this.b.get(u);if(!S)throw new Error(`No provider found for '${u}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${u}'`);const L=$.URI.revive(s),v=await S.provider.openCustomDocument(L,{backupId:d,untitledDocumentData:m?.buffer},f);let y;return n(S.provider)&&this.f&&(y=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(u,v,y),{editable:n(S.provider)}}async $disposeCustomDocument(s,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const m=$.URI.revive(s),{document:f}=this.i(u,m);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(s,u,d,m,f,S){const L=this.b.get(d);if(!L)throw new Error(`No provider found for '${d}'`);const v=g.ViewColumn.to(f),y=this.g.createNewWebview(u,m.contentOptions,L.extension),D=this.h.createNewWebviewPanel(u,d,m.title,v,m.options,y,m.active),N=$.URI.revive(s);switch(L.type){case 1:{const{document:O}=this.i(d,N);return L.provider.resolveCustomEditor(O,D,S)}case 0:{const O=this.d.getDocument(N);return L.provider.resolveCustomTextEditor(O,D,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,d){this.i(u,s).disposeEdits(d)}async $onMoveCustomEditor(s,u,d){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const S=$.URI.revive(u),L=this.d.getDocument(S);await m.provider.moveCustomTextEditor(L,f,E.CancellationToken.None)}async $undo(s,u,d,m){return this.i(u,s).undo(d,m)}async $redo(s,u,d,m){return this.i(u,s).redo(d,m)}async $revert(s,u,d){const m=this.i(u,s);await this.j(u).revertCustomDocument(m.document,d),m.disposeBackup()}async $onSave(s,u,d){const m=this.i(u,s);await this.j(u).saveCustomDocument(m.document,d),m.disposeBackup()}async $onSaveAs(s,u,d,m){const f=this.i(u,s);return this.j(u).saveCustomDocumentAs(f.document,$.URI.revive(d),m)}async $backup(s,u,d){const m=this.i(u,s),S=await this.j(u).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},d);return m.updateBackup(S),S.id}i(s,u){const d=this.c.get(s,$.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$tgc=t;function n(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const s=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Si)(s)+""}}),define(Pe[272],Re([1,0,5,6,2,33,8,65,3,7]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class A extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(b,r,o,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Ud),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Ud),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=r,this.#o=o,this.#i=t.viewType,this.#n=t.panelOptions,this.#s=t.viewColumn,this.#r=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(b){this.c(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,C.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(b){this.#l||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#u=b.active,this.#c=b.visible,this.#s=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:R.ViewColumn.from(b),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends T.$Tc{static c(){return(0,M.$pg)()}constructor(b,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=b.getProxy(g.$4K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,r,o,t,n={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:R.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,$.$ogc)(b),i=k.c();this.f.$createWebviewPanel((0,$.$qgc)(b),i,r,{title:o,panelOptions:l(n),webviewOptions:(0,$.$rgc)(b,this.m,n),serializeBuffersForPostMessage:h},c);const s=this.j.createNewWebview(i,n,b);return this.createNewWebviewPanel(i,r,o,a,n,s,!0)}$onDidChangeWebviewPanelViewStates(b){const r=Object.keys(b);r.sort((o,t)=>{const n=b[o],a=b[t];return n.active?1:a.active?-1:+n.visible-+a.visible});for(const o of r){const t=this.getWebviewPanel(o);if(!t)continue;const n=b[o];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:b}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,$.$ogc)(b)}),new w.$6K(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(b,r,o,t){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:a,extension:c}=n,h=this.j.createNewWebview(b,o.webviewOptions,c),i=this.createNewWebviewPanel(b,r,o.title,t,o.panelOptions,h,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(b,r,o,t,n,a,c){const h=new A(b,this.f,a,{viewType:r,title:o,viewColumn:t,panelOptions:n,active:c});return this.g.set(b,h),h}getWebviewPanel(b){return this.g.get(b)}}e.$sgc=k;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[273],Re([1,0,5,6,65,8,3,7]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class g extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(k,l,p,b,r,o){super(),this.#n=!1,this.#u=this.B(new E.$Ud),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Ud),this.onDidDispose=this.#l.event,this.#i=p,this.#a=b,this.#e=k,this.#t=l,this.#o=r,this.#r=o}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#n||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#n)throw new Error("Webview is disposed")}}class w{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$4K.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,p,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,C.$qgc)(k),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$ogc)(k)}),new $.$6K(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,p,b,r){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=o,a=this.d.createNewWebview(k,{},n),c=new g(k,this.a,l,p,a,!0);this.c.set(k,c),await t.resolveWebviewView(c,{state:b},r)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$Whc=w}),define(Pe[111],Re([1,0,5,3,2,12,11,4,17,23]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const b=this.d;return{get focused(){return b.focused},get active(){return(0,w.$BF)(p,"windowActivity"),b.active}}}constructor(p){this.c=new E.$Ud,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(T.$4K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:r})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,b){b!==this.d[p]&&(this.d={...this.d,[p]:b},this.c.fire(this.d))}openUri(p,b){let r;if(typeof p=="string"){r=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Ie)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,r,b)}async asExternalUri(p,b){if((0,R.$Ie)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(p,b);return C.URI.from(r)}};e.$Xhc=k,e.$Xhc=k=A=Je([He(0,g.$8M)],k),e.$Yhc=(0,$.$5h)("IExtHostWindow")}),define(Pe[274],Re([1,0,240,27,17]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;let M=class extends E.$2hc{constructor($,g){super($,g)}f($,g,w){g.apply(console,w)}};e.$$jc=M,e.$$jc=M=Je([He(0,C.$8M),He(1,T.$lN)],M)}),define(Pe[275],Re([1,0,13,24,20,15,5,6,139,229,49]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.ResponsiveState=e.RequestInitiator=e.$_7b=e.$$7b=void 0;function l(D,N){try{return JSON.stringify(D,N)}catch{return"null"}}const p="$$ref$$",b={[p]:-1};class r{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function o(D,N=null,O=!1){const G=[];return{jsonString:(O?l:JSON.stringify)(D,(U,P)=>{if(typeof P>"u")return b;if(typeof P=="object"){if(P instanceof T.$ie){const I=G.push(P)-1;return{[p]:I}}if(N)return N(U,P)}return P}),referencedBuffers:G}}e.$$7b=o;function t(D,N,O){return JSON.parse(D,(G,W)=>{if(W){const U=W[p];if(typeof U=="number")return N[U];if(O&&W.$mid===1)return O.transformIncoming(W)}return W})}e.$_7b=t;function n(D,N){return JSON.stringify(D,N)}function a(D){return D?(N,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends $.$Tc{static{k=s}static{this.a=3*1e3}constructor(N,O=null,G=null){super(),this[k]=!0,this.b=this.B(new R.$Ud),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=G,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,U=A.$Pv.count;W<U;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$eh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,g.$6m)(N,this.g):N}getProxy(N){const{nid:O,sid:G}=N;return this.s[O]||(this.s[O]=this.J(O,G)),this.s[O]}J(N,O){const G={get:(W,U)=>(typeof U=="string"&&!W[U]&&U.charCodeAt(0)===36&&(W[U]=(...P)=>this.U(N,U,P)),U===u?O:W[U])};return new Proxy(Object.create(null),G)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,G=N.length;O<G;O++){const W=N[O];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,G=f.read(N,0),W=G.readUInt8(),U=G.readUInt32();switch(W){case 1:case 2:{let{rpcId:P,method:I,args:K}=L.deserializeRequestJSONArgs(G);this.g&&(K=(0,g.$6m)(K,this.g)),this.M(O,U,P,I,K,W===2);break}case 3:case 4:{let{rpcId:P,method:I,args:K}=L.deserializeRequestMixedArgs(G);this.g&&(K=(0,g.$6m)(K,this.g)),this.M(O,U,P,I,K,W===4);break}case 5:{this.f?.logIncoming(O,U,0,"ack"),this.G(U);break}case 6:{this.N(O,U);break}case 7:{this.O(O,U,void 0);break}case 9:{let P=L.deserializeReplyOKJSON(G);this.g&&(P=(0,g.$6m)(P,this.g)),this.O(O,U,P);break}case 10:{const P=L.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(O,U,P);break}case 8:{const P=L.deserializeReplyOKVSBuffer(G);this.O(O,U,P);break}case 11:{let P=L.deserializeReplyErrError(G);this.g&&(P=(0,g.$6m)(P,this.g)),this.P(O,U,P);break}case 12:{this.P(O,U,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,G,W,U,P){this.f?.logIncoming(N,O,1,`receiveRequest ${(0,A.$Rv)(G)}.${W}(`,U);const I=String(O);let K,ae;if(P){const be=new C.$5d;U.push(be.token),K=this.Q(G,W,U),ae=()=>be.cancel()}else K=this.Q(G,W,U),ae=i;this.u[I]=ae;const he=L.serializeAcknowledged(O);this.f?.logOutgoing(he.byteLength,O,1,"ack"),this.c.send(he),K.then(be=>{delete this.u[I];const De=L.serializeReplyOK(O,be,this.h);this.f?.logOutgoing(De.byteLength,O,1,"reply:",be),this.c.send(De)},be=>{delete this.u[I];const De=L.serializeReplyErr(O,be);this.f?.logOutgoing(De.byteLength,O,1,"replyErr:",be),this.c.send(De)})}N(N,O){this.f?.logIncoming(N,O,1,"receiveCancel");const G=String(O);this.u[G]?.()}O(N,O,G){this.f?.logIncoming(N,O,0,"receiveReply:",G);const W=String(O);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W],U.resolveOk(G)}P(N,O,G){this.f?.logIncoming(N,O,0,"receiveReplyErr:",G);const W=String(O);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W];let P;G&&(G.$isError?(P=new Error,P.name=G.name,P.message=G.message,P.stack=G.stack):P=G),U.resolveErr(P)}Q(N,O,G){try{return Promise.resolve(this.S(N,O,G))}catch(W){return Promise.reject(W)}}S(N,O,G){const W=this.m[N];if(!W)throw new Error("Unknown actor "+(0,A.$Rv)(N));const U=W[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Rv)(N));return U.apply(W,G)}U(N,O,G){if(this.j)return new w.$07b;let W=null;if(G.length>0&&C.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(M.$6());const U=L.serializeRequestArguments(G,this.h),P=++this.t,I=String(P),K=new w.$97b,ae=new $.$Sc;W&&ae.add(W.onCancellationRequested(()=>{const be=L.serializeCancel(P);this.f?.logOutgoing(be.byteLength,P,0,"cancel"),this.c.send(L.serializeCancel(P))})),this.w[I]=new m(K,ae),this.F(P);const he=L.serializeRequest(P,N,O,U,!!W);return this.f?.logOutgoing(he.byteLength,P,0,`request: ${(0,A.$Rv)(N)}.${O}(`,G),this.c.send(he),K}}e.$a8b=d;class m{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class f{static alloc(N,O,G){const W=new f(T.$ie.alloc(G+1+4),0);return W.writeUInt8(N),W.writeUInt32(O),W}static read(N,O){return new f(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let G=0,W=N.length;G<W;G++){const U=N[G];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let P=0;P<U.buffers.length;++P)O+=this.sizeVSBuffer(U.buffers[P]);break;case 4:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,G=N.length;O<G;O++){const W=N[O];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let U=0;U<W.buffers.length;++U)this.writeBuffer(W.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let G=0;G<N;G++)switch(this.readUInt8()){case 1:O[G]=this.readLongString();break;case 2:O[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),P=this.readLongString(),I=[];for(let K=0;K<U;++K)I.push(this.readVSBuffer());O[G]=new A.$Sv(t(P,I,null));break}case 4:O[G]=void 0;break}return O}}var S;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(S||(S={}));class L{static a(N){for(let O=0,G=N.length;O<G;O++)if(N[O]instanceof T.$ie||N[O]instanceof A.$Sv||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const G=[];for(let W=0,U=N.length;W<U;W++){const P=N[W];if(P instanceof T.$ie)G[W]={type:2,value:P};else if(typeof P>"u")G[W]={type:4};else if(P instanceof A.$Sv){const{jsonString:I,referencedBuffers:K}=o(P.value,O);G[W]={type:3,value:T.$ie.fromString(I),buffers:K}}else G[W]={type:1,value:T.$ie.fromString(n(P,O))}}return{type:1,args:G}}return{type:0,args:n(N,O)}}static serializeRequest(N,O,G,W,U){switch(W.type){case 0:return this.b(N,O,G,W.args,U);case 1:return this.c(N,O,G,W.args,U)}}static b(N,O,G,W,U){const P=T.$ie.fromString(G),I=T.$ie.fromString(W);let K=0;K+=f.sizeUInt8(),K+=f.sizeShortString(P),K+=f.sizeLongString(I);const ae=f.alloc(U?2:1,N,K);return ae.writeUInt8(O),ae.writeShortString(P),ae.writeLongString(I),ae.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),G=N.readShortString(),W=N.readLongString();return{rpcId:O,method:G,args:JSON.parse(W)}}static c(N,O,G,W,U){const P=T.$ie.fromString(G);let I=0;I+=f.sizeUInt8(),I+=f.sizeShortString(P),I+=f.sizeMixedArray(W);const K=f.alloc(U?4:3,N,I);return K.writeUInt8(O),K.writeShortString(P),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),G=N.readShortString(),W=N.readMixedArray(),U=new Array(W.length);for(let P=0,I=W.length;P<I;P++){const K=W[P];typeof K=="string"?U[P]=JSON.parse(K):U[P]=K}return{rpcId:O,method:G,args:U}}static serializeAcknowledged(N){return f.alloc(5,N,0).buffer}static serializeCancel(N){return f.alloc(6,N,0).buffer}static serializeReplyOK(N,O,G){if(typeof O>"u")return this.d(N);if(O instanceof T.$ie)return this.e(N,O);if(O instanceof A.$Sv){const{jsonString:W,referencedBuffers:U}=o(O.value,G,!0);return this.g(N,W,U)}else return this.f(N,l(O,G))}static d(N){return f.alloc(7,N,0).buffer}static e(N,O){let G=0;G+=f.sizeVSBuffer(O);const W=f.alloc(8,N,G);return W.writeVSBuffer(O),W.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const G=T.$ie.fromString(O);let W=0;W+=f.sizeLongString(G);const U=f.alloc(9,N,W);return U.writeLongString(G),U.buffer}static g(N,O,G){const W=T.$ie.fromString(O);let U=0;U+=f.sizeUInt32,U+=f.sizeLongString(W);for(const I of G)U+=f.sizeVSBuffer(I);const P=f.alloc(10,N,U);P.writeUInt32(G.length),P.writeLongString(W);for(const I of G)P.writeBuffer(I);return P.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const G=N.readUInt32(),W=N.readLongString(),U=[];for(let P=0;P<G;++P)U.push(N.readVSBuffer());return new A.$Sv(t(W,U,O))}static serializeReplyErr(N,O){const G=O?l(M.$3(O),null):void 0;if(typeof G!="string")return this.h(N);const W=T.$ie.fromString(G);let U=0;U+=f.sizeLongString(W);const P=f.alloc(11,N,U);return P.writeLongString(W),P.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return f.alloc(12,N,0).buffer}}var v;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[276],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const g=$.data;Object.defineProperties(globalThis,{postMessage:{value(w,A){g.postMessage(w,A)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${R}'))`,w=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(w),k=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:k.port2,url:A,options:$};M(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(b){k.port1.onmessage=b}},onmessageerror:{get(){return k.port1.onmessageerror},set(b){k.port1.onmessageerror=b}}}),k.port1.addEventListener("messageerror",b=>{const r=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(r)}),k.port1.addEventListener("message",b=>{const r=new MessageEvent("message",{data:b.data});this.dispatchEvent(r)}),k.port1.start()}}e.$akc=T}),define(Pe[277],Re([1,0,5,30,35,4]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nK=e.$mK=e.OutputChannelUpdateMode=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=void 0,e.$cK="text/x-code-output",e.$dK="output",e.$eK="Log",e.$fK="text/x-code-log-output",e.$gK="log",e.$hK="workbench.panel.output",e.$iK=new C.$jj("inOutput",!1),e.$jK=new C.$jj("activeLogOutput",!1),e.$kK=new C.$jj("outputView.scrollLock",!1),e.$lK=(0,M.$5h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$mK={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Ud,this.onDidRegisterChannel=this.b.event,this.c=new E.$Ud,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$Gn.add(e.$mK.OutputChannels,new $),e.$nK=new C.$jj("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,22,14,277,63,27,43,136,24,16,42,5,6]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=void 0;class t extends R.$sj{get disposed(){return this.n}constructor(h,i,s,u,d){super(),this.id=h,this.name=i,this.r=s,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ie.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let a=class{constructor(h,i,s,u,d,m){this.i=i,this.j=s,this.k=u,this.l=d,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$4K.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.$vm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(h,i,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,p.$Hf)(i)?i:void 0;if((0,p.$Hf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const f=this.i.environment.extensionLogLevel?.find(([L])=>M.$km.equals(s.identifier,L))?.[1];f&&(m=(0,R.$Cj)(f));const S=u?this.o(h,m,s):this.n(h,d,s);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),u?this.r(h,m??this.m.getLevel(),S):this.q(h,S)}async n(h,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,s.identifier.value);return new t(f,h,m,this.a,s)}async o(h,i,s){const u=await this.p(s),d=h.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(u,`${d}.log`),f=`${s.identifier.value}.${d}`,S=this.l.createLogger(m,{id:f,name:h,logLevel:i,extensionId:s.identifier.value});return new n(f,h,S,this.a,s)}p(h){let i=this.d.get(h.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(u){if((0,b.$Fk)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}return s})())}return i}q(h,i){let s=!1;const u=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(m=>m.append(d))},appendLine(d){u(),i.then(m=>m.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(m=>m.replace(d))},show(d,m){u(),i.then(f=>f.show(d,m))},hide(){u(),i.then(d=>d.hide())},dispose(){s=!0,i.then(d=>d.dispose())}}}r(h,i,s){const u=new o.$Sc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},m=u.add(new r.$Ud);function f(S){i=S,m.fire(S)}return s.then(S=>{u.add(S),S.logLevel!==i&&f(S.logLevel),u.add(S.onDidChangeLogLevel(L=>f(L)))}),{...this.q(h,s),get logLevel(){return i},onDidChangeLogLevel:m.event,trace(S,...L){d(),s.then(v=>v.trace(S,...L))},debug(S,...L){d(),s.then(v=>v.debug(S,...L))},info(S,...L){d(),s.then(v=>v.info(S,...L))},warn(S,...L){d(),s.then(v=>v.warn(S,...L))},error(S,...L){d(),s.then(v=>v.error(S,...L))},dispose(){u.dispose()}}}};e.$xhc=a,e.$xhc=a=Je([He(0,C.$8M),He(1,w.$lN),He(2,g.$kgc),He(3,A.$Wfc),He(4,R.$nj),He(5,R.$mj)],a),e.$yhc=(0,T.$5h)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,13]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=void 0,e.$Km=(0,E.$5h)("remoteAgentService"),e.$Lm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const g=await C.getRoundTripTime();if(g===void 0)return;M=Math.min(M,g/2),await(0,T.$6g)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,g)=>$+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,g)=>$+g,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[278],Re([1,0,169,54,30,47,41,6,5,113,21,26]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=void 0,e.$QH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$RH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$SH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$TH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Ud,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new l;C.$Gn.add(e.$TH.ConfigurationMigration,p);let b=class extends $.$Tc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(a=>this.g(a,t?.uri))])}async g(t,n){const a=this.a.inspect(t.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const s=[];for(const d of a.overrideIdentifiers??[]){const m=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of m??[]){let S=s.find(([[L,v]])=>L===f[0]&&(0,k.$yn)(v.value,f[1].value));S||s.push(S=[f,[]]),S[1].push(d)}}const u=await this.h(t,{resource:n},h,a);for(const d of u??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,m],f])=>this.a.updateValue(d,m.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,a,c){const h=d=>i(this.a.inspect(d,n)),i=d=>{const m=d[a];return n.overrideIdentifier?m?.override:m?.value},s=c?i(c):h(t.key);if(s===void 0)return;const u=await t.migrateFn(s,h);return Array.isArray(u)?u:[[t.key,u]]}};e.$UH=b,e.$UH=b=Je([He(0,R.$yi),He(1,M.$bi)],b);let r=class extends $.$Tc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;C.$Gn.as(T.$Ln.Configuration).registerConfiguration({...e.$SH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$VH=r,e.$VH=r=Je([He(0,w.$Km)],r)}),define(Pe[279],Re([1,0,34,12,19,25,177,278,54,4,30]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdb=e.$adb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$_cb=e.$$cb=void 0,e.$$cb=(0,w.$5h)("editorResolverService"),e.$_cb="workbench.editorAssociations";const k=A.$Gn.as(g.$Ln.Configuration),l={...$.$RH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var b;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function r(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$adb=r;function o(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(C.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$Dg)(n);return E.$Kj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$bdb=o}),define(Pe[280],Re([1,0,46,12,19,21,25,2,4,198,47,216,113]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=void 0,e.$FK=(0,g.$5h)("pathService");let b=p=class{constructor(o,t,n,a){this.d=o,this.e=t,this.f=n,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,n)}h(o,t,n){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,E.$5f)(n??(0,R.$Dg)(o),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,w.$CK)(t.getWorkspace());if(n)return n;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?C.$fc:C.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$GK=b,e.$GK=b=p=Je([He(1,l.$Km),He(2,k.$oK),He(3,A.$bi)],b)}),define(Pe[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$iJ=e.$hJ=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$hJ=E;class T{constructor(R,$,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(g,w)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$iJ=T;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[44],Re([1,0,18,34,26,46,11,4,19,15,114,13]),function(ge,e,E,T,C,M,R,$,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.SearchErrorCode=e.$xJ=e.$wJ=e.SearchSortOrder=e.ViewMode=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.SearchCompletionExitCode=e.$rJ=e.$qJ=e.$pJ=e.QueryType=e.SearchProviderType=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$jJ="workbench.view.search",e.$kJ="workbench.panel.search",e.$lJ="workbench.view.search",e.$mJ="search-result",e.$nJ="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",b=(l.length+p.length+5)*2;e.$oJ=(0,$.$5h)("searchService");var r;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(r||(e.SearchProviderType=r={}));var o;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(o||(e.QueryType=o={}));function t(le){return!!le.preview}e.$pJ=t;function n(le){return!!le.resource}e.$qJ=n;function a(le){return!!le.message}e.$rJ=a;var c;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$sJ=h;class i{constructor(ve,se,we,ne){this.ranges=se,this.webviewIndex=ne;const Z=Array.isArray(se)?se:[se];if(we&&we.matchLines===1&&s(Z)){ve=(0,R.$Af)(ve,we.matchLines);let V="",ie=0,Ie=0;const Ae=Math.floor(we.charsPerLine/5),Ce=[];for(const ce of Z){const te=Math.max(ce.startColumn-Ae,0),Q=ce.startColumn+we.charsPerLine;if(te>Ie+Ae+b){const ee=l+(te-Ie)+p;V+=ee+ve.slice(te,Q),ie+=te-(Ie+ee.length)}else V+=ve.slice(Ie,Q);Ce.push(new d(0,ce.startColumn-ie,ce.endColumn-ie)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,E.$2b)(se,ie=>new u(ie.startLineNumber-V,ie.startColumn,ie.endLineNumber-V,ie.endColumn))}}}}e.$tJ=i;function s(le){const ve=le[0].startLineNumber;for(const se of le)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class u{constructor(ve,se,we,ne){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=we,this.endColumn=ne}}e.$uJ=u;class d extends u{constructor(ve,se,we){super(ve,se,ve,we)}}e.$vJ=d;var m;(function(le){le.List="list",le.Tree="tree"})(m||(e.ViewMode=m={}));var f;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function S(le,ve=!0){const se=le&&le.files&&le.files.exclude,we=ve&&le&&le.search&&le.search.exclude;if(!se&&!we)return;if(!se||!we)return se||we;let ne=Object.create(null);return ne=C.$xn(ne,C.$un(se)),ne=C.$xn(ne,C.$un(we),!0),ne}e.$wJ=S;function L(le,ve){return le.excludePattern&&T.$Kj(le.excludePattern,ve)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&T.$Kj(le.includePattern,ve)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(se=>{const we=se.folder.fsPath;if(M.$7f(ve,we)){const ne=g.$lc(we,ve);return!se.includePattern||!!T.$Kj(se.includePattern,ne)}else return!1}):!1:!0}e.$xJ=L;var v;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class y extends Error{constructor(ve,se){super(ve),this.code=se}}e.$yJ=y;function D(le){const ve=le.message;if((0,w.$4)(le))return new y(ve,v.canceled);try{const se=JSON.parse(ve);return new y(se.message,se.code)}catch{return new y(ve,v.other)}}e.$zJ=D;function N(le){const ve={message:le.message,code:le.code};return new Error(JSON.stringify(ve))}e.$AJ=N;function O(le){return le.type==="error"?!0:le.type==="success"}e.$BJ=O;function G(le){return le.type==="success"}e.$CJ=G;function W(le){return!!le.path}e.$DJ=W;function U(le,ve){const se=le.searchPath?le.searchPath:le.relativePath;return(0,R.$xf)(se,ve)}e.$EJ=U;class P{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$FJ=P;function I(le,ve){const se={...le||{},...ve||{}};return Object.keys(se).filter(we=>{const ne=se[we];return typeof ne=="boolean"&&ne})}e.$GJ=I;class K{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=T.$Lj(this.a);let we=ve.includePattern;se.includePattern&&(we?we={...we,...se.includePattern}:we=se.includePattern),we&&(this.c=T.$Lj(we))}matchesExcludesSync(ve,se,we){return!!(this.b&&this.b(ve,se,we))}includedInQuerySync(ve,se,we){return!(this.b&&this.b(ve,se,we)||this.c&&!this.c(ve,se,we))}includedInQuery(ve,se,we){const ne=this.b(ve,se,we),Z=()=>this.c?!!this.c(ve,se,we):!0;return(0,k.$Rg)(ne)?ne.then(V=>V?!1:Z()):Z()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$HJ=K;function ae(le){for(const ve in le)if(typeof le[ve]!="boolean")return!0;return!1}function he(le){if(!le)return;let ve;return se=>(ve||(ve=(le()||Promise.resolve([])).then(we=>we?De(we):{})),ve.then(we=>!!we[se]))}e.$IJ=he;function be(le){if(!le)return;let ve;return se=>{if(!ve){const we=le();ve=we?De(we):{}}return!!ve[se]}}e.$JJ=be;function De(le){const ve={};for(const se of le)ve[se]=!0;return ve}}),define(Pe[36],Re([1,0,18,13,20,5,6,50,12,122,25,11,2,168,4,14,187,47,43,27,17,8,7,57,44,3,51]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0;function f(G,W,U){return new A.$vg(P=>y(P,U)).isEqual(G,W)}function S(G,W,U){return f(G.uri,W.uri,U)?0:(0,k.$4e)(G.uri.toString(),W.uri.toString())}function L(G,W,U){return G.index!==W.index?G.index<W.index?-1:1:f(G.uri,W.uri,U)?(0,k.$4e)(G.name,W.name):(0,k.$4e)(G.uri.toString(),W.uri.toString())}function v(G,W,U,P){const I=G.slice(0).sort((ae,he)=>U(ae,he,P)),K=W.slice(0).sort((ae,he)=>U(ae,he,P));return(0,E.$Eb)(I,K,(ae,he)=>U(ae,he,P))}function y(G,W){const U=W.getCapabilities(G.scheme);return!(U&&U&1024)}class D extends t.$li{static toExtHostWorkspace(W,U,P,I){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:ae,folders:he,configuration:be,transient:De,isUntitled:le}=W,ve=[],se=U;U?he.forEach((V,ie)=>{const Ie=l.URI.revive(V.uri),Ae=D.o(P||U,Ie,I);Ae?(Ae.name=V.name,Ae.index=V.index,ve.push(Ae)):ve.push({uri:Ie,name:V.name,index:ie})}):ve.push(...he.map(({uri:V,name:ie,index:Ie})=>({uri:l.URI.revive(V),name:ie,index:Ie}))),ve.sort((V,ie)=>V.index<ie.index?-1:1);const we=new D(K,ae,ve,!!De,be?l.URI.revive(be):null,!!le,V=>y(V,I)),{added:ne,removed:Z}=v(se?se.workspaceFolders:[],we.workspaceFolders,S,I);return{workspace:we,added:ne,removed:Z}}static o(W,U,P){for(let I=0;I<W.folders.length;I++){const K=W.workspaceFolders[I];if(f(K.uri,U,P))return K}}constructor(W,U,P,I,K,ae,he){super(W,P.map(be=>new t.$mi(be)),I,K,he),this.t=U,this.u=ae,this.q=[],this.s=$.$$h.forUris(he),P.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,U){return U&&this.s.get(W)&&(W=(0,A.$Fg)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let N=class{constructor(W,U,P,I,K){this.c=new M.$Ud,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Ud,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Wd,this.B=new Map,this.h=I,this.s=P,this.t=K,this.j=new w.$8l,this.k=new T.$4g,this.o=W.getProxy(d.$4K.MainThreadWorkspace),this.q=W.getProxy(d.$4K.MainThreadMessageService);const ae=U.workspace;this.l=ae?new D(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,he=>y(he,P)):void 0}$initializeWorkspace(W,U){this.v=U,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Dg)((0,A.$Fg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,P,...I){const K=[];if(Array.isArray(I)&&I.forEach(le=>{l.URI.isUri(le.uri)&&!K.some(ve=>f(ve.uri,le.uri,this.s))&&K.push({uri:le.uri,name:le.name||(0,A.$Cg)(le.uri)})}),this.n||[U,P].some(le=>typeof le!="number"||le<0)||P===0&&K.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(U+P>ae.length)return!1;const he=ae.slice(0);he.splice(U,P,...K.map(le=>({uri:le.uri,name:le.name||(0,A.$Cg)(le.uri),index:void 0})));for(let le=0;le<he.length;le++){const ve=he[le];if(he.some((se,we)=>we!==le&&f(ve.uri,se.uri,this.s)))return!1}he.forEach((le,ve)=>le.index=ve);const{added:be,removed:De}=v(ae,he,L,this.s);if(be.length===0&&De.length===0)return!1;if(this.o){const le=W.displayName||W.name;this.o.$updateWorkspaceFolders(le,U,P,K).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,p.localize)(0,null,le,ve.toString()),se,[])})}return this.y(he),!0}getWorkspaceFolder(W,U){if(this.x)return this.x.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let P,I="";if(typeof W=="string"?(P=l.URI.file(W),I=W):typeof W<"u"&&(P=W,I=W.fsPath),!P)return I;const K=this.getWorkspaceFolder(P,!0);if(!K)return I;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ae=(0,A.$Ig)(K.uri,P);return U&&K.name&&(ae=`${K.name}/${ae}`),ae}y(W){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:P,removed:I}=D.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:I}))}findFiles(W,U,P,I,K=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${I.value}, entryPoint: findFiles`);let ae;if(U===null?ae=!1:U&&(typeof U=="string"?ae=U:ae=U.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:be}=O(h.GlobPattern.from(W));return this.o.$startFileSearch(he??null,be??null,ae??null,P??null,K).then(De=>Array.isArray(De)?De.map(le=>l.URI.revive(le)):[])}async findTextInFiles(W,U,P,I,K=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${I.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),he=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:be,folder:De}=O(h.GlobPattern.from(U.include)),le=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:he,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:be,excludePattern:le},se=!1;if(this.u[ae]=we=>{if(se)return;const ne=l.URI.revive(we.resource);we.results.forEach(Z=>{const V=(0,m.$Bh)(Z);(0,u.$pJ)(V)?P({uri:ne,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,ie=>new i.$8K(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,E.$2b)(V.ranges,ie=>new i.$8K(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):P({uri:ne,text:V.text,lineNumber:V.lineNumber})})},K.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(W,De??null,ve,ae,K);return delete this.u[ae],we||{}}catch(we){throw delete this.u[ae],we}}$handleTextSearchResult(W,U){this.u[U]?.(W)}async save(W){const U=await this.o.$save(W,{saveAs:!1});return l.URI.revive(U)}async saveAs(W){const U=await this.o.$save(W,{saveAs:!0});return l.URI.revive(U)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,U){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,U);const P=this.t.transformOutgoingScheme(W),I=this.z++;return this.o.$registerEditSessionIdentityProvider(I,P),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(I)})}async $getEditSessionIdentifier(W,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const P=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const I=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!I),!I)return;const K=await I.provideEditSessionIdentity(P,U);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,U,P,I){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ae=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ae),!ae)return;const he=await ae.provideEditSessionIdentityMatch?.(U,P,I);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(W){return(U,P,I)=>{const K=function(he){U.call(P,he)};return K.extension=W,this.A.event(K,void 0,I)}}async $onWillCreateEditSessionIdentity(W,U,P){const I=await this.resolveWorkspaceFolder(l.URI.revive(W));if(I===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:I},U,async(K,ae)=>{const he=Date.now();await Promise.resolve(K),Date.now()-he>P&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(W,U){if(this.B.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.B.set(W,U);const P=this.t.transformOutgoingScheme(W),I=this.z++;return this.o.$registerCanonicalUriProvider(I,P),(0,R.$Rc)(()=>{this.B.delete(W),this.o.$unregisterCanonicalUriProvider(I)})}async provideCanonicalUri(W,U,P){const I=this.B.get(W.scheme);if(!I)return;const K=await I.provideCanonicalUri?.(l.URI.revive(W),U,P);if(K)return K}async $provideCanonicalUri(W,U,P){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:U},P)}};e.$egc=N,e.$egc=N=Je([He(0,c.$8M),He(1,a.$lN),He(2,n.$Wfc),He(3,r.$mj),He(4,s.$cgc)],N),e.$fgc=(0,b.$5h)("IExtHostWorkspace");function O(G){let W,U;return G&&(typeof G=="string"?W=G:(W=G.pattern,U=l.URI.revive(G.baseUri))),{includePattern:W,folder:U}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,54,16,13,4,17,14,2]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=e.$ggc=void 0;function r(s,u){if(u){const d=u.split(".");let m=s;for(let f=0;m&&f<d.length;f++)m=m[d[f]];return m}}function o(s){return s instanceof b.URI}function t(s){return s&&s.uri instanceof b.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof b.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(o(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(u,d,m){this.a=u.getProxy(M.$4K.MainThreadConfiguration),this.c=d,this.b=m,this.d=new A.$4g,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(u,d))}};e.$ggc=h,e.$ggc=h=Je([He(0,l.$8M),He(1,C.$fgc),He(2,p.$mj)],h);class i{constructor(u,d,m,f){this.a=new T.$Ud,this.b=u,this.f=f,this.c=d,this.e=$.$5n.parse(m),this.d=this.k(m.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const m={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$5n.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,m))}getConfiguration(u,d,m){const f=c(d)||{},S=this.g(u?r(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,m?.identifier);function L(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(y){return typeof r(S,y)<"u"},get:(y,D)=>{this.h(u?`${u}.${y}`:y,f,m?.identifier);let N=r(S,y);if(typeof N>"u")N=D;else{let O;const G=(W,U)=>{if((0,w.$Jf)(W)){let P;const I=()=>{O=O||(0,E.$un)(S),P=P||r(O,U)};return new Proxy(W,{get:(K,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return I(),()=>P;if(O)return P=P||r(O,U),P[ae];const he=K[ae];return typeof ae=="string"?G(he,`${U}.${ae}`):he},set:(K,ae,he)=>(I(),P&&(P[ae]=he),!0),deleteProperty:(K,ae)=>(I(),P&&delete P[ae],!0),defineProperty:(K,ae,he)=>(I(),P&&Object.defineProperty(P,ae,he),!0)})}return Array.isArray(W)?(0,E.$un)(W):W};N=G(N,y)}return N},update:(y,D,N,O)=>{y=u?`${u}.${y}`:y;const G=L(N);return D!==void 0?this.b.$updateConfigurationOption(G,y,D,f,O):this.b.$removeConfigurationOption(G,y,f,O)},inspect:y=>{y=u?`${u}.${y}`:y;const D=this.e.inspect(y,f,this.c.workspace);if(D)return{key:y,defaultValue:(0,E.$un)(D.policy?.value??D.default?.value),globalValue:(0,E.$un)(D.user?.value??D.application?.value),workspaceValue:(0,E.$un)(D.workspace?.value),workspaceFolderValue:(0,E.$un)(D.workspaceFolder?.value),defaultLanguageValue:(0,E.$un)(D.default?.override),globalLanguageValue:(0,E.$un)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,E.$un)(D.workspace?.override),workspaceFolderLanguageValue:(0,E.$un)(D.workspaceFolder?.override),languageIds:(0,E.$un)(D.overrideIdentifiers)}}};return typeof S=="object"&&(0,E.$xn)(v,S,!1),Object.freeze(v)}g(u){const d=m=>(0,w.$Jf)(m)?new Proxy(m,{get:(f,S)=>d(f[S]),set:(f,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(f,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(f,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return d(u)}h(u,d,m){const f=g.$Vn.test(u)?4:this.d.get(u),S=m?`[${m.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const m=new $.$7n(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,S)=>m.affectsConfiguration(f,c(S))})}k(u){return u.reduce((d,m)=>(d.set(m[0],m[1]),d),new Map)}}e.$hgc=i,e.$igc=(0,k.$5h)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,13,5,3,7,36,61,37,20,64,17,27,4,12,21,14,81,228,15]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=e.$Jhc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function W(P){if(P!=null)return P}G.from=W;function U(P){if(P!=null)return P}G.to=U})(h||(h={}));var i;(function(G){function W(P){if(P!=null)return P}G.from=W;function U(P){if(P!=null)return P}G.to=U})(i||(i={}));var s;(function(G){function W(P){if(P!=null)return P}G.from=W;function U(P){if(P!=null)return P}G.to=U})(s||(s={}));var u;(function(G){function W(I){if(I){const K=I;return K&&!!K.process}else return!1}G.is=W;function U(I){if(I==null)return;const K={process:I.process,args:I.args};return I.options&&(K.options=s.from(I.options)),K}G.from=U;function P(I){if(I!=null)return new R.$OL(I.process,I.args,I.options)}G.to=P})(u||(u={}));var d;(function(G){function W(P){if(P!=null)return P}G.from=W;function U(P){if(P!=null)return P}G.to=U})(d||(d={}));var m;(function(G){function W(I){if(I){const K=I;return K&&(!!K.commandLine||!!K.command)}else return!1}G.is=W;function U(I){if(I==null)return;const K={};return I.commandLine!==void 0?K.commandLine=I.commandLine:(K.command=I.command,K.args=I.args),I.options&&(K.options=d.from(I.options)),K}G.from=U;function P(I){if(!(I==null||I.command===void 0&&I.commandLine===void 0))return I.commandLine?new R.$PL(I.commandLine,I.options):new R.$PL(I.command,I.args?I.args:[],I.options)}G.to=P})(m||(m={}));var f;(function(G){function W(I){if(I){const K=I;return K&&K.customExecution==="customExecution"}else return!1}G.is=W;function U(I){return{customExecution:"customExecution"}}G.from=U;function P(I,K){return K.get(I)}G.to=P})(f||(e.CustomExecutionDTO=f={}));var S;(function(G){function W(U,P){let I;return U.scope!==void 0&&typeof U.scope!="number"?I=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?I=P.workspaceFile:I=a.$xG),{id:U._id,workspaceFolder:I}}G.from=W})(S||(e.TaskHandleDTO=S={}));var L;(function(G){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=W})(L||(L={}));var v;(function(G){function W(I,K){if(I==null)return[];const ae=[];for(const he of I){const be=U(he,K);be&&ae.push(be)}return ae}G.fromMany=W;function U(I,K){if(I==null)return;let ae;I.execution instanceof R.$OL?ae=u.from(I.execution):I.execution instanceof R.$PL?ae=m.from(I.execution):I.execution&&I.execution instanceof R.$QL&&(ae=f.from(I.execution));const he=h.from(I.definition);let be;return I.scope?typeof I.scope=="number"?be=I.scope:be=I.scope.uri:be=R.TaskScope.Workspace,!he||!be?void 0:{_id:I._id,definition:he,name:I.name,source:{extensionId:K.identifier.value,label:I.source,scope:be},execution:ae,isBackground:I.isBackground,group:L.from(I.group),presentationOptions:i.from(I.presentationOptions),problemMatchers:I.problemMatchers,hasDefinedMatchers:I.hasDefinedMatchers,runOptions:I.runOptions?I.runOptions:{reevaluateOnRerun:!0},detail:I.detail}}G.from=U;async function P(I,K,ae){if(I==null)return;let he;u.is(I.execution)?he=u.to(I.execution):m.is(I.execution)?he=m.to(I.execution):f.is(I.execution)&&(he=f.to(I._id,ae));const be=h.to(I.definition);let De;if(I.source&&(I.source.scope!==void 0?typeof I.source.scope=="number"?De=I.source.scope:De=await K.resolveWorkspaceFolder(E.URI.revive(I.source.scope)):De=R.TaskScope.Workspace),!be||!De)return;const le=new R.$RL(be,De,I.name,I.source.label,he,I.problemMatchers);return I.isBackground!==void 0&&(le.isBackground=I.isBackground),I.group!==void 0&&(le.group=R.$NL.from(I.group._id),le.group&&I.group.isDefault&&(le.group=new R.$NL(le.group.id,le.group.label),I.group.isDefault===!0&&(le.group.isDefault=I.group.isDefault))),I.presentationOptions&&(le.presentationOptions=i.to(I.presentationOptions)),I._id&&(le._id=I._id),I.detail&&(le.detail=I.detail),le}G.to=P})(v||(e.TaskDTO=v={}));var y;(function(G){function W(P){return P}G.from=W;function U(P){if(P)return Object.assign(Object.create(null),P)}G.to=U})(y||(y={}));class D{#e;constructor(W,U,P){this._id=U,this.a=P,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let N=class{constructor(W,U,P,I,K,ae,he,be){this.q=new C.$Ud,this.r=new C.$Ud,this.s=new C.$Ud,this.u=new C.$Ud,this.a=W.getProxy(M.$4K.MainThreadTask),this.b=P,this.c=I,this.d=K,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=he,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,P){if(!P)return new R.$6K(()=>{});const I=this.x();return this.j.set(I,{type:U,provider:P,extension:W}),this.a.$registerTaskProvider(I,U),new R.$6K(()=>{this.j.delete(I),this.a.$unregisterTaskProvider(I)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(y.from(W)).then(async U=>{const P=[];for(const I of U){const K=await v.to(I,this.b,this.m);K&&P.push(K)}return P})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,P){const I=this.m.get(W.id);I&&(this.o.set(W.id,I),this.e.attachPtyToTerminal(U,await I.callback(P))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const U=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.z(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const U=await this.z(W.id);this.u.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const P=this.j.get(W);if(!P)return Promise.reject(new Error("no handler found"));const I=[],K=(0,T.$Xg)(()=>P.provider.provideTasks(A.CancellationToken.None)).then(ae=>this.v(U,I,P,ae));return new Promise(ae=>{K.then(he=>{Promise.all(I).then(()=>{ae(he)})})})}async $resolveTask(W,U){const P=this.j.get(W);if(!P)return Promise.reject(new Error("no handler found"));if(U.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${P.type}].`);const I=await v.to(U,this.b,this.m);if(!I)throw new Error("Unexpected: Task cannot be resolved.");const K=await P.provider.resolveTask(I,A.CancellationToken.None);if(!K)return;this.A(K,P);const ae=v.from(K,P.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==I.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ae.execution)&&await this.y(ae,K,!0),await this.w(ae)}x(){return this.h++}async y(W,U,P){const I=await this.a.$createTaskId(W);!P&&!this.m.has(I)&&(this.n.add(I),this.o.set(I,U.execution)),this.m.set(I,U.execution)}async z(W,U){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const P=this.l.get(W.id);if(P)return P;let I;return U?I=Promise.resolve(new D(this,W.id,U)):I=v.to(W.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new D(this,W.id,K)}),this.l.set(W.id,I),I.then(K=>(this.k.set(W.id,K),K))}A(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const P=this.n.values();let I=P.next();for(;!I.done;)!this.o.has(I.value)&&this.p!==I.value&&(this.m.delete(I.value),this.n.delete(I.value)),I=P.next()}};e.$Jhc=N,e.$Jhc=N=Je([He(0,l.$8M),He(1,p.$lN),He(2,$.$fgc),He(3,g.$gN),He(4,w.$igc),He(5,k.$Ggc),He(6,t.$mj),He(7,n.$Zfc)],N);let O=class extends N{constructor(W,U,P,I,K,ae,he,be){super(W,U,P,I,K,ae,he,be),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const P=v.from(U,W);if(P===void 0)throw new Error("Task is not valid");if(f.is(P.execution))await this.y(P,U,!1);else throw new c.$_;const I=await this.z(await this.a.$getTaskExecution(P),U);return this.a.$executeTask(P).catch(K=>{throw new Error(K)}),I}v(W,U,P,I){const K=[];if(I)for(const ae of I){if(this.A(ae,P),!ae.definition||!W[ae.definition.type]){const be=ae.source?ae.source:"No task source";this.f.warn(`The task [${be}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const he=v.from(ae,P.extension);he&&f.is(he.execution)?(K.push(he),U.push(this.y(he,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:P.extension}}async w(W){if(f.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,P){}};e.$Khc=O,e.$Khc=O=Je([He(0,l.$8M),He(1,p.$lN),He(2,$.$fgc),He(3,g.$gN),He(4,w.$igc),He(5,k.$Ggc),He(6,t.$mj),He(7,n.$Zfc)],O),e.$Lhc=(0,b.$5h)("IExtHostTask")}),define(Pe[281],Re([1,0,44,29]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RJ=e.$QJ=e.$PJ=void 0;function C(R){return"cellResults"in R}e.$PJ=C,e.$QJ="rawCell#";function M(R,$){let g=-1;const w=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(w.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(l=>{const p=[],b=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=b;o<=r;o++)p.push($.getLineContent(o));return new E.$tJ(p.join(`
`)+`
`,l.map(o=>new T.$Ts(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$RJ=M}),define(Pe[282],Re([1,0,162,24,5,6,28,11,16,2,42,75,3,32,8,7,49,220,107,26,12,211,281,279]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,f,S,L,v,y){this.q=S,this.r=L,this.s=v,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new C.$Ud,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Ud,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Ud,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Ud,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Sfc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(l.$4K.MainThreadNotebook),this.c=m.getProxy(l.$4K.MainThreadNotebookDocuments),this.d=m.getProxy(l.$4K.MainThreadNotebookEditors),this.i=f.converter,f.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const N=D.notebookEditor?.notebookUri,O=D.cell.handle,W=this.g.get(N)?.getCell(O);if(W)return W.apiCell}if(D&&D.$mid===14){const N=D.uri,O=this.g.get(N);if(O)return O.apiNotebook}return D}}),u.B(f)}getEditorById(m){const f=this.h.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return f}getIdByEditor(m){for(const[f,S]of this.h)if(S.apiEditor===m)return f}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,f){const S=this.g.get(m);if(!S&&!f)throw new Error(`NO notebook document for '${m}'`);return S}static u(m,f){if(!f)return;const S=f.filenamePattern.map(L=>b.NotebookExclusiveDocumentPattern.from(L)).filter(L=>L!==void 0);if(f.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:S,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,S){const L=u.a++,v=typeof S.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(L,S),this.b.$registerNotebookCellStatusBarItemProvider(L,v,f);let y;return v!==void 0&&(y=S.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(v))),new r.$6K(()=>{this.f.delete(L),this.b.$unregisterNotebookCellStatusBarItemProvider(L,v),y?.dispose()})}async createNotebookDocument(m){const f=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&b.NotebookData.from(m.content)});return w.URI.revive(f)}async openNotebookDocument(m){const f=this.g.get(m);if(f)return f.apiNotebook;const S=await this.c.$tryOpenNotebook(m),L=this.g.get(w.URI.revive(S));return(0,g.$Sf)(L?.apiNotebook)}async showNotebookDocument(m,f){w.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let S;typeof f=="object"?S={position:b.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(b.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const L=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,S),v=L&&this.h.get(L)?.apiEditor;if(v)return v;throw L?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,S,L){const v=this.f.get(m),y=w.URI.revive(f),D=this.g.get(y);if(!D||!v)return;const N=D.getCellFromIndex(S);if(!N)return;const O=await v.provideCellStatusBarItems(N.apiCell,L);if(!O)return;const G=new M.$Sc,W=this.p.add([G]),P=(Array.isArray(O)?O:[O]).map(I=>b.NotebookStatusBarItem.from(I,this.i,G));return{cacheId:W,items:P}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,f,S,L,v){if((0,$.$Ie)(f))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:f,serializer:S,options:L}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},f,b.NotebookDocumentContentOptions.from(L),u.u(m,v)),(0,M.$Rc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.deserializeNotebook(f.buffer,S);return new o.$Sv(b.NotebookData.from(v))}async $notebookToData(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.serializeNotebook(b.NotebookData.to(f.value),S);return T.$ie.wrap(v)}async $saveNotebook(m,f,S,L,v){const y=w.URI.revive(f),D=this.x.get(m);if(!D)throw new Error("NO serializer found");const N=this.g.get(y);if(!N)throw new Error("Document NOT found");if(N.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$Kk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,L);const O={metadata:(0,a.$Cn)(N.apiNotebook.metadata,I=>!(D.options?.transientDocumentMetadata??{})[I]),cells:[]};for(const I of N.apiNotebook.getCells()){const K=new r.$sM(I.kind,I.document.getText(),I.document.languageId,I.mime,D.options?.transientOutputs?[]:[...I.outputs],I.metadata,I.executionSummary);K.metadata=(0,a.$Cn)(I.metadata,ae=>!(D.options?.transientCellMetadata??{})[ae]),O.cells.push(K)}const G=await D.serializer.serializeNotebook(O,v);await this.s.value.writeFile(y,G);const W=this.s.getFileSystemProviderExtUri(y.scheme),U=await this.s.value.stat(y);return{name:W.basename(y),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$Vk({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(m,f,S,L,v){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const D=new R.$Bc;await(async(U,P,I)=>{await Promise.all(U.map(async K=>await Promise.all(K.filenamePatterns.map(ae=>{const he={_reason:I._reason,folderQueries:I.folderQueries,includePattern:I.includePattern,excludePattern:I.excludePattern,maxResults:I.maxResults,type:1,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(he,P,be=>{be.forEach(De=>{D.has(De)||L.some(ve=>K.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,s.$bdb)(se,De)))||D.add(De)})})}))))})(S,v,f);const O=new R.$Ac;let G=!1;const W=Array.from(D).map(async U=>{const P=[];try{if(v.isCancellationRequested)return;if(f.maxResults&&[...O.values()].reduce((he,be)=>he+be.cellResults.length,0)>f.maxResults){G=!0;return}const I=[],K=this.g.get(U);if(K)K.apiNotebook.getCells().forEach(be=>I.push({input:be.document.getText(),outputs:be.outputs.flatMap(De=>De.items.map(le=>le.data.toString()))}));else{const he=await this.s.value.readFile(U),be=T.$ie.fromString(he.toString()),De=await y.deserializeNotebook(be.buffer,v);if(v.isCancellationRequested)return;b.NotebookData.from(De).cells.forEach(ve=>I.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map(we=>we.valueBytes.toString()))}))}if(v.isCancellationRequested)return;I.forEach((he,be)=>{const De=f.contentPattern.pattern,le=new h.$zQb(he.input,void 0,he.outputs),ve=le.findInInputs(De),se=le.findInOutputs(De),we=se.flatMap(ne=>(0,i.$RJ)(ne.matches,ne.textBuffer)).map((ne,Z)=>(ne.webviewIndex=Z,ne));if(ve.length>0||se.length>0){const ne={index:be,contentResults:(0,i.$RJ)(ve,le.inputTextBuffer),webviewResults:we};P.push(ne)}});const ae={resource:U,cellResults:P};O.set(U,ae);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...O.values()]}}async y(m,f){const S=await this.s.value.stat(m);if(typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==A.$Uk&&typeof S.mtime=="number"&&typeof S.size=="number"&&f.mtime<S.mtime&&f.etag!==A.$Vk({mtime:f.mtime,size:S.size}))throw new A.$Kk((0,E.localize)(1,null),3,f)}z(m){return m.scheme===c.Schemas.file?m.fsPath:m.toString()}A(m,f,S){if(this.h.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const L=new n.$chc(f,this.d,m,S.visibleRanges.map(b.NotebookRange.to),S.selections.map(b.NotebookRange.to),typeof S.viewColumn=="number"?b.ViewColumn.to(S.viewColumn):void 0);this.h.set(f,L)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const S of m.value.removedDocuments){const L=w.URI.revive(S),v=this.g.get(L);v&&(v.dispose(),this.g.delete(L),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(v.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===L.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const S=[];for(const L of m.value.addedDocuments){const v=w.URI.revive(L.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const y=new t.$bhc(this.c,this.q,this.r,v,L);S.push(...L.cells.map(D=>t.$ahc.asModelAddData(y.apiNotebook,D))),this.g.get(v)?.dispose(),this.g.set(v,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const S of m.value.addedEditors){if(this.h.has(S.id))return;const L=w.URI.revive(S.documentUri),v=this.g.get(L);v&&this.A(v,S.id,S)}const f=[];if(m.value.removedEditors)for(const S of m.value.removedEditors){const L=this.h.get(S);L&&(this.h.delete(S),this.k?.id===L.id&&(this.k=void 0),f.push(L))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(L=>this.h.get(L)).filter(L=>!!L);const S=new Set;this.l.forEach(L=>S.add(L.id));for(const L of this.h.values()){const v=S.has(L.id);L._acceptVisibility(v)}this.l=[...this.h.values()].map(L=>L).filter(L=>L.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const f=p.$tN.String.with("notebookType","A notebook type"),S=new p.$vN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new p.$tN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$ie.wrap(v))],new p.$uN("Notebook Data",v=>b.NotebookData.to(v.value))),L=new p.$vN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new p.$tN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new o.$Sv(b.NotebookData.from(v)))],new p.$uN("Bytes",v=>v.buffer));m.registerApiCommand(S),m.registerApiCommand(L)}}e.$lhc=u}),define(Pe[283],Re([1,0,19,20,40,34,25,60,44]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class w{constructor(l,p,b){this.k=l,this.l=p,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$Lj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$Lj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((b,r)=>{const o=t=>{this.f++,l(t)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),a=E.$nc(n);this.j&&this.j(n,a)||this.v(o,{base:t,basename:a})}),Promise.all(p.map(t=>this.p(t,o))).then(t=>{b({limitHit:this.e,stats:t[0]||void 0})},t=>{r(new Error((0,C.$Pi)(t)))})})}async p(l,p){const b=new T.$5d,r=this.q(l),o=this.r(),t=new g.$HJ(this.k,l),n=!t.hasSiblingExcludeClauses();let a;try{this.h.add(b),a=$.$Qd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,b.token),h=a.elapsed(),i=$.$Qd.create();return this.g&&!this.e||(c&&c.forEach(s=>{const u=E.$gc.relative(l.folder.path,s.path);if(n){const d=E.$nc(s.path);this.v(p,{base:l.folder,relativePath:u,basename:d});return}this.s(o,l.folder,u,p)}),this.g&&!this.e)?null:(this.u(o,t,p),{providerTime:h,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const p=(0,g.$GJ)(this.k.includePattern,l.includePattern),b=(0,g.$GJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,b,r){if(b===this.a){const t=E.$nc(this.a);this.v(r,{base:p,relativePath:this.a,basename:t})}function o(t){const n=E.$nc(t),a=E.$mc(t);let c=l[a];c||(c=l[a]=[],o(a)),c.push({base:p,relativePath:t,basename:n})}o(b)}u({rootEntries:l,pathToEntries:p},b,r){const o=this,t=this.a;function n(a){const c=(0,g.$JJ)(()=>a.map(h=>h.basename));for(let h=0,i=a.length;h<i;h++){const s=a[h],{relativePath:u,basename:d}=s;if(b.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const m=p[u];if(m)n(m);else{if(u===t)continue;o.v(r,s)}if(o.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,b,r){const o=this.c(l.cacheKey),t=new w(l,p,o&&o.token);let n=0;const a=c=>{n+=c.length,b(c.map(h=>this.d(h)))};return this.e(t,A.a,a,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$5d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Gg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,b,r){const o=r.onCancellationRequested(()=>{l.cancel()}),t=a=>{a&&(n.push(a),p>0&&n.length>=p&&(b(n),n=[]))};let n=[];return l.search(t).then(a=>(n.length&&b(n),o.dispose(),a),a=>(n.length&&b(n),o.dispose(),Promise.reject(a)))}}e.$dhc=A}),define(Pe[284],Re([1,0,18,245,34,95,28,12,19,25,11,16,2,94,179,41,14,47,105,280,44]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.$HK=void 0;let h=class{constructor(y,D,N,O,G){this.a=y,this.b=D,this.c=N,this.d=O,this.e=G}text(y,D,N={}){y=this.f(y,N);const O=this.a.getValue(),G=D&&D.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(D?.map(t.$ni),N),type:2,contentPattern:y,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:O.search.usePCRE2||G||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(y,D){const N=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const O={...y,wordSeparators:N.editor.wordSeparators};return this.j(y,D)&&(O.isCaseSensitive=!0),this.k(y)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(y,D){return y?(y=Array.isArray(y)?y.map(m):m(y),D?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const N=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),G=y.length>1,W=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(I=>this.q(I,D,O)):y.map(I=>this.r(I,D,O,G))).filter(I=>!!I),U={_reason:D._reason,folderQueries:W,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:N.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const I=E.$Hb(E.$Rb(this.c.groups.map(he=>he.editors.map(be=>be.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(I));const K=I.filter(he=>(0,c.$xJ)(U,he.fsPath)),ae=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...U,...ae}}const P=D.extraFileResources&&D.extraFileResources.filter(I=>(0,c.$xJ)(U,I.fsPath));return U.extraFileResources=P&&P.length?P:void 0,U}i(y){const D=[],N=new R.$Ac,O={};let G=!1;return y.forEach(W=>{if(W.scheme===$.Schemas.walkThrough)return;if((0,w.$Kg)(W)){const P=this.b.getWorkspaceFolder(W)?.uri??W.with({path:g.$mc(W.fsPath)});let I=N.get(P);I||(G=!0,I={folder:P,includePattern:{}},D.push(I),N.set(P,I));const K=g.$lc(P.fsPath,W.fsPath);(0,k.$Sf)(I.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(G=!0,O[W.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(A.$yf(y.pattern,!0))return!0}else if(A.$yf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,p.$3B)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=ae=>g.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),O=(Array.isArray(y)?y:u(y)).map(ae=>{const he=this.e.resolvedUserHome;return he?(0,M.$Xv)(ae,he.scheme===$.Schemas.file?he.fsPath:he.path):ae}),G=T.$K(O,ae=>D(ae)?"searchPaths":"exprSegments"),W=(G.exprSegments||[]).map(ae=>A.$Te(ae,"/")).map(ae=>A.$Te(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),d(ae))),U={},P=this.m(G.searchPaths||[]);P&&P.length&&(U.searchPaths=P);const I=E.$Rb(W),K=s(...I);return K&&(U.pattern=K),U}l(y,D){return D.disregardExcludeSettings?void 0:(0,c.$wJ)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(O=>{let{pathPortion:G,globPortion:W}=i(O);return W&&(W=f(W)),this.n(G).flatMap(P=>this.o(P,W))}),N=new Map;return D.forEach(O=>{const G=O.searchPath.toString(),W=N.get(G);W?O.pattern&&(W.pattern=W.pattern||{},W.pattern[O.pattern]=!0):N.set(G,{searchPath:O.searchPath,pattern:O.pattern?s(O.pattern):void 0})}),Array.from(N.values())}n(y){if(g.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==$.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=m(y),y.startsWith("../")||y===".."){const O=g.$gc.resolve(D.path,y);return[{searchPath:D.with({path:O})}]}const N=f(y);return[{searchPath:D,pattern:N}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(G=>{const W=D.match(new RegExp(`^${A.$Ne(G.name)}(?:/(.*)|$)`));return W?{match:W,folder:G}:null}).filter(k.$Pf);if(O.length)return O.map(G=>{const W=G.match[1];return{searchPath:G.folder.uri,pattern:W&&f(W)}});{const G=y.match(/\.[\/\\](.+)[\/\\]?/),W=G?G[1]:y,U=b.localize(0,null,W);throw new Error(U)}}}}o(y,D){const N=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,O=[{searchPath:y.searchPath,pattern:N}];return N&&!N.endsWith("**")&&O.push({searchPath:y.searchPath,pattern:N+"/**"}),O}q(y,D,N){const O=this.r((0,t.$ni)(y.searchPath),D,N,!1);return O?{...O,includePattern:y.pattern}:null}r(y,D,N,O){let G;const W=l.URI.isUri(y)?y:y.uri;if(N.searchPaths){const ae=N.searchPaths.filter(he=>(0,w.$zg)(he.searchPath,W))[0];if(ae&&!ae.pattern)return null;ae&&(G=ae.pattern)}const U=this.a.getValue({resource:W}),I={...this.l(U,D)||{},...G||{}},K=l.URI.isUri(y)?(0,w.$Dg)(y):y.name;return{folder:W,folderName:O?K:void 0,excludePattern:Object.keys(I).length>0?I:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!U.search.followSymlinks}}};e.$HK=h,e.$HK=h=Je([He(0,r.$yi),He(1,t.$bi),He(2,n.$8C),He(3,o.$mj),He(4,a.$FK)],h);function i(v){const y=v.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,N=v.substr(0,D).match(/[/|\\][^/\\]*$/);if(N){let O=v.substr(0,N.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((N.index||0)+1)}}}return{pathPortion:v}}function s(...v){return v.length?v.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function u(v){return C.$Jj(v,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(v){return[`**/${v}/**`,`**/${v}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function m(v){return v.replace(/\\/g,"/")}function f(v){return m(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(v){return v.replace(/([?*[\]])/g,"[$1]")}function L(v,y){v=E.$Mb(v,O=>O.toString());const D=[],N=y.getWorkspace();return v&&v.forEach(O=>{let G;if(y.getWorkbenchState()===2)G=(0,w.$Ig)(N.folders[0].uri,O),G&&G!=="."&&(G="./"+G);else{const W=y.getWorkspaceFolder(O);if(W){const U=W.name;if(N.folders.filter(I=>I.name===U).length===1){const I=(0,w.$Ig)(W.uri,O);I===""?G=`./${W.name}`:G=`./${W.name}/${I}`}else G=O.fsPath}}G&&D.push(S(G))}),D}e.$IK=L}),define(Pe[285],Re([1,0,25,2,20,15,4,284,44,47]),function(ge,e,E,T,C,M,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsb=e.$ksb=void 0;const A=7e3;function k(r,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],a=[];for(const d of t)if(/^workspaceContains:/.test(d)){const m=d.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||r.forceUsingSearch?a.push(m):n.push(m)}if(n.length===0&&a.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,m)=>{c=d}),i=d=>c({activationEvent:d}),s=Promise.all(n.map(d=>l(r,d,i))).then(()=>{}),u=p(r,o.identifier,a,i);return Promise.all([s,u]).then(()=>{c(void 0)}),h}e.$ksb=k;async function l(r,o,t){for(const n of r.folders)if(await r.exists(E.$Gg(T.URI.revive(n),o))){t(`workspaceContains:${o}`);return}}async function p(r,o,t,n){if(t.length===0)return Promise.resolve(void 0);const a=new C.$5d,c=r.checkExists(r.folders,t,a.token),h=setTimeout(async()=>{a.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(s){M.$4(s)||M.$1(s)}a.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function b(r,o,t,n){const a=r.get(R.$4h),c=r.get(g.$oJ),i=a.createInstance($.$HK).file(o.map(s=>(0,w.$ni)(T.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(s=>!!s.limitHit,s=>M.$4(s)?!1:Promise.reject(s))}e.$lsb=b}),define(Pe[38],Re([1,0,159,19,88,25,13,6,50,2,14,3,37,217,85,36,23,106,15,22,24,200,7,100,4,27,86,17,71,87,64,5,285,84,202,12,82,60,21,83]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y,D,N,O,G,W,U,P,I){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0,e.$Rgc=(0,u.$5h)("IHostUtils");let ae=K=class extends $.$Tc{constructor(Z,V,ie,Ie,Ae,Ce,ce,te,Q,ee,me,pe){super(),this.X=pe,this.a=this.B(new y.$Ud),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ie,this.f=ce,this.j=Ie,this.m=Ae,this.s=Ce,this.t=Q,this.u=ee,this.w=me,this.y=this.g.getProxy(k.$4K.MainThreadWorkspace),this.z=this.g.getProxy(k.$4K.MainThreadTelemetry),this.C=this.g.getProxy(k.$4K.MainThreadExtensionService),this.D=new R.$4g,this.F=new R.$4g,this.G=new R.$4g,this.H=new R.$4g,this.I=new we(this.f.extensions.activationEvents),this.L=new t.$57b(this.I,this.f.extensions.allExtensions);const Le=new a.$lm(this.f.extensions.myExtensions);this.J=new t.$57b(this.I,ve(this.L,Le)),P.$t&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new b.$Cgc(this.g,this.s),this.N=new N.$Kgc(this.g),this.O=te,this.h=Z.createChild(new S.$3h([b.$Dgc,this.M],[N.$Lgc,this.N])),this.P=this.B(new p.$Bgc(this.J,this.L,{onExtensionActivationError:(de,ye,F)=>{this.C.$onExtensionActivationError(de,n.$3(ye),F)},actualActivateExtension:async(de,ye)=>{if(t.$57b.isHostExtension(de,this.J,this.L))return await this.C.$activateExtension(de,ye),new p.$Agc;const F=this.J.getExtensionDescription(de);return this.db(F,ye)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Z){n.$1(Z)}}async Y(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.cb(Ae))}catch{}await Promise.all(Z)}terminate(Z,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ie=this.Y();Promise.race([(0,R.$6g)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const V=await this.C.$getExtension(Z);return V&&{...V,identifier:new a.$km(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(Z,V){return this.P.activateByEvent(Z,V)}$(Z,V){return this.P.activateById(Z,V)}activateByIdWithErrors(Z,V){return this.$(Z,V).then(()=>{const ie=this.P.getActivatedExtension(Z);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async ab(Z){if(Z.scheme===G.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(Z.fsPath);return w.URI.file(V)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Z=>new se(Z))),this.Q}async bb(Z){const V=g.$$h.forUris(ie=>M.$xg.ignorePathCasing(ie));return await Promise.all(Z.map(async ie=>{if(this.ub(ie)){const Ie=await this.ab(ie.extensionLocation);V.set(Ie,ie)}})),V}cb(Z){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return V;const ie=this.P.getActivatedExtension(Z);if(!ie)return V;try{typeof ie.module.deactivate=="function"&&(V=Promise.resolve(ie.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(Ie)}try{(0,$.$Oc)(ie.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this.s.error(Ie)}return V}async db(Z,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.fb(Z,V).then(ie=>{const Ie=ie.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(Z,V,"success",Ie),ie},ie=>{throw this.eb(Z,V,"failure"),ie})}eb(Z,V,ie,Ie){const Ae=be(Z,V);this.z.$publicLog2("extensionActivationTimes",{...Ae,...Ie||{},outcome:ie})}fb(Z,V){const ie=be(Z,V);this.z.$publicLog2("activatePlugin",ie);const Ie=this.ub(Z);if(!Ie)return Promise.resolve(new p.$zgc(p.$wgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Z.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Ae=new p.$xgc(V.startup);return Promise.all([this.vb(Z,(0,M.$Gg)(Z.extensionLocation,Ie),Ae),this.gb(Z)]).then(Ce=>(C.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),K.hb(this.s,Z.identifier,Ce[0],Ce[1],Ae))).then(Ce=>(C.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),Ce))}gb(Z){const V=new h.$Fgc(Z,this.M),ie=new h.$Egc(Z.identifier.value,!1,this.M),Ie=new O.$Mgc(Z,this.N),Ae=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([V.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const ce=this;let te,Q;const ee=(0,o.$AF)(Z,"ipc")?this.f.messagePorts?.get(a.$km.toKey(Z.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ie,secrets:Ie,subscriptions:[],get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(me){return T.$jc(Z.extensionLocation.fsPath,me)},get storagePath(){return ce.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Z).fsPath},get logPath(){return T.$jc(ce.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return w.URI.joinPath(ce.f.logsLocation,Z.identifier.value)},get storageUri(){return ce.O.workspaceValue(Z)},get globalStorageUri(){return ce.O.globalValue(Z)},get extensionMode(){return Ae},get extension(){return te===void 0&&(te=new le(ce,Z.identifier,Z,Ce,!1)),te},get extensionRuntime(){return(0,o.$BF)(Z,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!Q){if(!ee)return;const me=y.Event.buffer(y.Event.fromDOMEventEmitter(ee,"message",pe=>pe.data));ee.start(),Q={onDidReceiveMessage:me,postMessage:ee.postMessage.bind(ee)}}return Q}})})}static hb(Z,V,ie,Ie,Ae){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(Z,V,ie,Ie,Ae).then(Ce=>new p.$ygc(!1,null,Ae.build(),ie,Ce,Ie.subscriptions))}static ib(Z,V,ie,Ie,Ae){if(typeof ie.activate=="function")try{Ae.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ie.activate.apply(Ce,[Ie]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(ce).then(te=>(Ae.activateResolveStop(),te))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ie)}jb(Z,V){this.$(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:V}).then(void 0,ie=>{this.s.error(ie)})}kb(Z,V=0){const Ie=Date.now();(0,P.$B)(()=>{for(let Ae=V;Ae<Z.length;Ae+=1){const Ce=Z[Ae];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(Z,Ae);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Z=>{const V=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(V)this.kb(ie);else for(const Ie of ie)if(Ie.activationEvents)for(const Ae of Ie.activationEvents)Ae==="onStartupFinished"&&this.jb(Ie,Ae)})}mb(){const Z=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(V),Ie=this.pb(),Ae=Promise.all([Ie,Z,ie]).then(()=>{});return Promise.race([Ae,(0,R.$6g)(1e4)]).then(()=>{this.lb()}),Ae}nb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(Z,V))).then(()=>{})}async ob(Z,V){if(this.isActivated(V.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:Z.map(Ce=>Ce.uri),forceUsingSearch:ie||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,te)=>this.y.$checkExists(Ce,ce,te)},Ae=await(0,D.$ksb)(Ie,V);if(Ae)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Ae.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Z){throw console.error(Z),Z}}async qb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:V}=this.f.environment;if(!Z||!V)throw new Error(E.localize(0,null));const ie=await this.vb(null,V,new p.$xgc(!1));if(!ie||typeof ie.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Ae)=>{const Ce=(Q,ee)=>{Q?(P.$t&&this.s.error("Test runner called back with error",Q),Ae(Q)):(P.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ce=(0,M.$ug)(V),te=ie.run(ce,Ce);te&&te.then&&te.then(()=>{P.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{P.$t&&this.s.error("Test runner finished with error",Q),Ae(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$6g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,V){return this.R[Z]=V,(0,$.$Rc)(()=>{delete this.R[Z]})}async getRemoteExecServer(Z){const{resolver:V}=await this.sb(Z);return V?.resolveExecServer?.(Z,{resolveAttempt:0})}async sb(Z){const V=Z.indexOf("+");if(V===-1)throw new i.$_K("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Z.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(Z,V){const ie=U.$Qd.create(!1),Ie=()=>`[resolveAuthority(${(0,s.$$k)(Z)},${V})][${ie.elapsed()}ms] `,Ae=H=>this.s.info(`${Ie()}${H}`),Ce=H=>this.s.warn(`${Ie()}${H}`),ce=(H,z=void 0)=>this.s.error(`${Ie()}${H}`,z),te=H=>{if(H instanceof i.$_K)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},Q=async H=>{Ae(`activating resolver for ${H}...`);const{resolver:z,authorityPrefix:X}=await this.sb(H);if(!z)throw ce(`no resolver for ${X}`),new i.$_K(`No remote extension installed to resolve ${X}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:z,authorityPrefix:X,remoteAuthority:H}},ee=Z.split(/@|%40/g).reverse();Ae(`activating remote resolvers ${ee.join(" -> ")}`);let me;try{me=await Promise.all(ee.map(Q)).catch(async H=>{if(!(H instanceof i.$_K)||H._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Ce(`resolving nested authorities failed: ${H.message}`),[await Q(Z)]})}catch(H){return te(H)}const pe=new R.$dh;pe.cancelAndSet(()=>Ae("waiting..."),1e3);let Le,de;for(const[H,{authorityPrefix:z,resolver:X,remoteAuthority:x}]of me.entries())try{if(H===me.length-1)Ae("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${z}`),Le=await X.resolve(x,{resolveAttempt:V,execServer:de}),C.mark(`code/extHost/didResolveAuthorityOK/${z}`),Ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,i.$$K.isManagedResolvedAuthority(Le)?Le:void 0));else{if(Ae(`invoking resolveExecServer() for ${x}`),C.mark(`code/extHost/willResolveExecServer/${z}`),de=await X.resolveExecServer?.(x,{resolveAttempt:V,execServer:de}),!de)throw new i.$_K(`Exec server was not available for ${x}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${z}`)}}catch(Ee){return C.mark(`code/extHost/didResolveAuthorityError/${z}`),ce("returned an error",Ee),pe.dispose(),te(Ee)}pe.dispose();const ye={environmentTunnels:Le.environmentTunnels,features:Le.tunnelFeatures?{elevation:Le.tunnelFeatures.elevation,privacyOptions:Le.tunnelFeatures.privacyOptions,protocol:Le.tunnelFeatures.protocol===void 0?!0:Le.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Le.extensionHostEnv,isTrusted:Le.isTrusted,authenticationSession:Le.authenticationSessionForInitializingExtensions?{id:Le.authenticationSessionForInitializingExtensions.id,providerId:Le.authenticationSessionForInitializingExtensions.providerId}:void 0};Ae(`returned ${i.$$K.isManagedResolvedAuthority(Le)?"managed authority":`${Le.host}:${Le.port}`}`);let q;if(i.$$K.isManagedResolvedAuthority(Le)){const H=V;this.X.setFactory(H,Le.makeConnection),q={authority:Z,connectTo:new s.$8k(H),connectionToken:Le.connectionToken}}else q={authority:Z,connectTo:new s.$9k(Le.host,Le.port),connectionToken:Le.connectionToken};return{type:"ok",value:{authority:q,options:F,tunnelInformation:ye}}}async $getCanonicalURI(Z,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$$k)(Z)})`);const{resolver:ie}=await this.sb(Z);if(!ie)return null;const Ie=w.URI.revive(V);if(typeof ie.getCanonicalURI>"u")return Ie;const Ae=await(0,R.$Xg)(()=>ie.getCanonicalURI(Ie));return Ae||Ie}$startExtensionHost(Z){Z.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ie}=he(this.I,this.L,this.J,Z);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),P.$t&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(Z,V){return V===1?this.D.wait().then(ie=>this.Z(Z,!1)):this.G.wait().then(ie=>this.Z(Z,!1))}async $activate(Z,V){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.$(Z,V),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(Ce=>Ce.extensionLocation=w.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ie}=he(this.I,this.L,this.J,Z),Ie=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),P.$t&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const V=c.$ie.alloc(Z),ie=Math.random()%256;for(let Ie=0;Ie<Z;Ie++)V.writeUInt8(ie,Ie);return V}async $updateRemoteConnectionData(Z){this.W=Z,this.a.fire()}};e.$Sgc=ae,e.$Sgc=ae=K=Je([He(0,u.$4h),He(1,e.$Rgc),He(2,f.$8M),He(3,r.$fgc),He(4,l.$igc),He(5,A.$mj),He(6,d.$lN),He(7,m.$lgc),He(8,L.$iyb),He(9,v.$Ggc),He(10,W.$Ogc),He(11,I.$Pgc)],ae);function he(ne,Z,V,ie){ne.addActivationEvents(ie.addActivationEvents);const Ie=new t.$57b(ne,Z.getAllExtensionDescriptions());Ie.deltaExtensions(ie.toAdd,ie.toRemove);const Ae=new a.$lm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ie.myToRemove)Ae.delete(ce);for(const ce of ie.myToAdd)Ae.add(ce);const Ce=ve(Ie,Ae);return{globalRegistry:Ie,myExtensions:Ce}}function be(ne,Z){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function De(ne){return ne.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$Tgc=(0,u.$5h)("IExtHostExtensionService");class le{#e;#t;#i;constructor(Z,V,ie,Ie,Ae){this.#e=Z,this.#t=V,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=T.$hc((0,M.$ug)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ugc=le;function ve(ne,Z){return ne.getAllExtensionDescriptions().filter(V=>Z.has(V.identifier))}class se{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$Vgc=se;class we{constructor(Z){this.a=new a.$mm,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const V of Object.keys(Z))this.a.set(V,Z[V])}}}),define(Pe[286],Re([1,0,88,2,3,37,23,22,17,27,4,38,14,11]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;let r=class{constructor(c,h,i,s,u,d,m){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.h=d,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$4hc=r,e.$4hc=r=Je([He(2,A.$4h),He(3,M.$igc),He(4,k.$Tgc),He(5,w.$lN),He(6,l.$mj)],r);let o=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&b.a.size){const h=(0,p.$Ne)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,s,u]=h,d=b.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};o=b=Je([He(0,w.$lN)],o);class t{constructor(c,h,i,s,u){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.nodeModuleName="vscode",this.a=new $.$mm}load(c,h){const i=this.d.findSubstr(h);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((u,d)=>s+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$vF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(C.$4K.MainThreadTelemetry);const s=i.getProxy(C.$4K.MainThreadWindow);this.c=(u,d)=>{const m=T.URI.parse(u);return d?this.g(u,d):m.scheme==="http"||m.scheme==="https"?s.$openUri(m,u,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?s.$openUri(m,u,{}):this.g(u,d)}}load(c,h,i){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([He(2,g.$8M)],n)}),define(Pe[116],Re([1,0,39,6,19,74,4,61,62,38,7,36,214,37]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0,e.$Wgc=(0,R.$5h)("IExtHostVariableResolverProvider");class b extends l.$9N{constructor(t,n,a,c,h,i,s){function u(){if(a){const d=a.activeEditor();if(d)return d.document.uri;const m=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof A.$MM||m.input instanceof A.$RM)return m.input.modified;if(m.input instanceof A.$LM||m.input instanceof A.$QM||m.input instanceof A.$OM)return m.input.uri}}}super({getFolderUri:d=>{const m=i.folders.filter(f=>f.name===d);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,m)=>h.getConfiguration(void 0,d).get(m),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return C.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=u();if(d){const m=n.getWorkspaceFolder(d);if(m)return C.$hc(m.uri.fsPath)}}},getSelectedText:()=>{if(a){const d=a.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(a){const d=a.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let r=class extends T.$Tc{constructor(t,n,a,c,h){super(),this.b=t,this.c=n,this.g=a,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xgc=r,e.$Xgc=r=Je([He(0,w.$Tgc),He(1,k.$fgc),He(2,$.$gN),He(3,p.$igc),He(4,g.$ugc)],r)}),define(Pe[117],Re([1,0,13,5,2,4,3,62,38,17,7,36,206,208,37,116]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=e.$2gc=e.$1gc=e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,M.$5h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,u,d,m,f,S){this.E=u,this.F=d,this.G=m,this.H=f,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Ud,this.n=new T.$Ud,this.o=new T.$Ud,this.u=new T.$Ud,this.k=s.getProxy(R.$4K.MainThreadDebugService),this.y=new T.$Ud,this.A=new T.$Ud,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.J(L)}),this.J(L)})}asDebugSourceUri(s,u){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let m=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(m+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),m+=`${f}ref=${d.sourceReference}`,C.URI.parse(m)}else{if(d.path)return C.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const u=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const m=d.contributes.debuggers;if(m&&m.length>0)for(const f of m)(0,p.$aG)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(u=>s.push(u)),s}addBreakpoints(s){const u=s.filter(f=>{const S=f.id;return this.w.has(S)?!1:(this.w.set(S,f),!0)});this.U(u,[],[]);const d=[],m=new Map;for(const f of u)if(f instanceof A.$6L){let S=m.get(f.location.uri.toString());S||(S={type:"sourceMulti",uri:f.location.uri,lines:[]},m.set(f.location.uri.toString(),S),d.push(S)),S.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$7L&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const u=s.filter(S=>this.w.delete(S.id));this.U([],u,[]);const d=u.filter(S=>S instanceof A.$6L).map(S=>S.id),m=u.filter(S=>S instanceof A.$7L).map(S=>S.id),f=u.filter(S=>S instanceof A.$8L).map(S=>S.id);return this.k.$unregisterBreakpoints(d,m,f)}startDebugging(s,u,d){return this.k.$startDebugging(s?s.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,u,d){if(!u)return new A.$6K(()=>{});const m=this.d++;return this.f.push({type:s,handle:m,provider:u}),this.k.$registerDebugConfigurationProvider(s,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,m),new A.$6K(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(s,u,d){if(!d)return new A.$6K(()=>{});if(!this.Q(s,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:u,handle:m,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,m),new A.$6K(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(s,u){if(!u)return new A.$6K(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:u}),new A.$6K(()=>{this.j=this.j.filter(m=>m.factory!==u)})}async $runInTerminal(s,u){return Promise.resolve(void 0)}async $substituteVariables(s,u){let d;const m=await this.W(s);return m&&(d={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(s,u){if(s.type==="implementation")return new c(s.implementation)}L(){}async $startDASession(s,u){const d=this,m=await this.V(u);return this.S(this.N(m.type),m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const S=this.M(f),L=this.K(S,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const v=L;return this.B.set(s,v),this.R(m).then(y=>(y&&this.C.set(s,y),v.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const N=D,O={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const G=await this.D.sign(N.arguments.value);O.body={signature:G},v.sendResponse(O)}else throw new Error("no signer")}catch(G){O.success=!1,O.message=G.message,v.sendResponse(O)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(D),D=(0,p.$fG)(D,!0),d.k.$acceptDAMessage(s,D)}),v.onError(D=>{y&&y.onError&&y.onError(D),this.k.$acceptDAError(s,D.name,D.message,D.stack)}),v.onExit(D=>{y&&y.onExit&&y.onExit(D??void 0,void 0),this.k.$acceptDAExit(s,D??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),v.startSession()))})}$sendDAMessage(s,u){u=(0,p.$eG)(u,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(s)?.sendMessage(u)}$stopDASession(s){const u=this.C.get(s);this.C.delete(s),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const u=[],d=[],m=[];if(s.added)for(const f of s.added){const S=f.id;if(S&&!this.w.has(S)){let L;if(f.type==="function")L=new A.$7L(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.$8L(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const v=C.URI.revive(f.uri);L=new A.$6L(new A.$fL(v,new A.$7K(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$4L)(L,S),this.w.set(S,L),u.push(L)}}if(s.removed)for(const f of s.removed){const S=this.w.get(f);S&&(this.w.delete(f),d.push(S))}if(s.changed){for(const f of s.changed)if(f.id){const S=this.w.get(f.id);if(S){if(S instanceof A.$7L&&f.type==="function"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(S instanceof A.$6L&&f.type==="source"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.$fL(C.URI.revive(f.uri),new A.$7K(f.line,f.character))}m.push(S)}}}this.U(u,d,m)}async $acceptStackFrameFocus(s){let u;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?u=new A.$bM(d,s.threadId):u=new A.$aM(d,s.threadId,s.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(s,u,d){return(0,E.$Xg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return m.provideDebugConfigurations(f,d)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(s,u,d,m){return(0,E.$Xg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(u);return f.resolveDebugConfiguration(S,d,m)})}$resolveDebugConfigurationWithSubstitutedVariables(s,u,d,m){return(0,E.$Xg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(S,d,m)})}async $provideDebugAdapter(s,u){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(u);return this.S(d,m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const u=await this.V(s);this.m.fire(u)}async $acceptDebugSessionTerminated(s){const u=await this.V(s);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,u){(await this.V(s))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(s,u){const m={session:await this.V(s),event:u.event,body:u.body};this.u.fire(m)}M(s){if(s instanceof A.$9L)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$0L)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$$L)return{type:"pipeServer",path:s.path};if(s instanceof A.$_L)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const u=this.h.filter(d=>d.type===s);if(u.length>0)return u[0].factory}O(s){const u=this.h.filter(d=>d.handle===s);if(u.length>0)return u[0].factory}P(s){const u=this.f.filter(d=>d.handle===s);if(u.length>0)return u[0].provider}Q(s,u){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const m of d)if(m.label&&m.type&&m.type===u)return!0}}return!1}R(s){const d=s.configuration.type,m=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Xg)(()=>f.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(m).then(f=>{const S=f.filter(L=>!!L);if(S.length>0)return new a(S)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.$0L(d));if(s){const f=await this.F.getExtensionRegistry();return(0,E.$Xg)(()=>s.createDebugAdapterDescriptor(u,this.T(u,f))).then(S=>{if(S)return S})}const m=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,m))}T(s,u){}U(s,u,d){(s.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:u,changed:d}))}async V(s){if(s)if(typeof s=="string"){const u=this.l.get(s);if(u)return u}else{let u=this.l.get(s.id);if(!u){const d=await this.W(s.folderUri),m=s.parent?this.l.get(s.parent):void 0;u=new t(this.k,s.id,s.type,s.name,d,s.configuration,m),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(s){if(s){const u=C.URI.revive(s);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$Zgc=o,e.$Zgc=o=Je([He(0,w.$8M),He(1,k.$fgc),He(2,g.$Tgc),He(3,b.$igc),He(4,$.$ugc),He(5,r.$Wgc)],o);class t{constructor(s,u,d,m,f,S,L){this.d=s,this.f=u,this.g=d,this.h=m,this.i=f,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,u){return this.d.$customDebugAdapterRequest(this.f,s,u)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$1gc=t;class n{constructor(s){this.value=Object.freeze({append(u){s.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$2gc=n;class a{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(u=>u.onError?u.onError(s):void 0)}onExit(s,u){this.d.forEach(d=>d.onExit?d.onExit(s,u):void 0)}}class c extends l.$Clb{constructor(s){super(),this.h=s,s.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(s,u,d,m,f,S){super(s,u,d,m,f,S)}};e.$3gc=h,e.$3gc=h=Je([He(0,w.$8M),He(1,k.$fgc),He(2,g.$Tgc),He(3,b.$igc),He(4,$.$ugc),He(5,r.$Wgc)],h)}),define(Pe[287],Re([1,0,15,88,2,3,275,14,70,71,27,184,17,57,38,59]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get($.$mj),i=a.get(l.$8M).getProxy(M.$4K.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{c.error(s);const u=E.$3(s);i.$onUnexpectedError(u)})}static async installFullHandler(a){const c=a.get($.$mj),h=a.get(l.$8M),i=a.get(b.$Tgc),s=a.get(r.$pN),u=h.getProxy(M.$4K.MainThreadExtensionService),d=h.getProxy(M.$4K.MainThreadErrors),m=await i.getExtensionPathIndex(),f=new WeakMap;function S(y,D){if(f.has(y))return f.get(y).stack;let N="",O,G;for(const U of D)N+=`
	at ${U.toString()}`,G=U.getFileName(),!O&&G&&(O=m.findSubstr(C.URI.file(G)));const W=`${y.name||"Error"}: ${y.message||""}${N}`;return f.set(y,{extensionIdentifier:O?.identifier,stack:W}),W}const L=Symbol("prepareStackTrace wrapped");let v=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(y){if(y===S||!y||y[L]){v=y||S;return}v=function(D,N){return S(D,N),y.call(Error,D,N)},Object.assign(v,{[L]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const D=E.$3(y),N=f.get(y);if(!N?.extensionIdentifier){d.$onUnexpectedError(D);return}u.$onExtensionRuntimeError(N.extensionIdentifier,D);const O=s.onExtensionError(N.extensionIdentifier,y);c.trace("forwarded error to extension?",O,N)})}}e.$5hc=o;class t{constructor(a,c,h,i,s){this.a=h,this.b=new R.$a8b(a,null,i),c=t.e(c,this.b);const u=new w.$3h(...(0,g.$Yr)());u.set(A.$lN,{_serviceBrand:void 0,...c,messagePorts:s}),u.set(l.$8M,new l.$9M(this.b)),u.set(p.$cgc,new p.$dgc(i)),u.set(b.$Rgc,h);const d=new k.$Dq(u,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(m=>m.get($.$mj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(m=>m.get(b.$Tgc)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this.b.getProxy(M.$4K.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=C.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(i=>C.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=C.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.$6hc=t}),define(Pe[288],Re([1,0,18,13,20,40,12,19,25,2,44]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=e.$fhc=e.$ehc=void 0;class k{constructor(n,a,c,h){this.d=n,this.e=a,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,a){const c=this.d.folderQueries||[],h=new C.$5d(a);return new Promise((i,s)=>{this.a=new p(n);let u=!1;const d=(m,f)=>{if(!u&&!this.b){const S=this.h(m);r(m)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),m=this.j(m,this.d.maxResults-this.c));const L=this.h(m);this.c+=L,(L>0||!r(m))&&this.a.add(m,f)}};Promise.all(c.map((m,f)=>this.k(m,S=>d(S,f),h.token))).then(m=>{h.dispose(),this.a.flush();const f=m.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(m.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},m=>{h.dispose();const f=(0,M.$Pi)(m);s(new Error(f))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,a){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,a),preview:{matches:h.slice(0,a),text:n.preview.text},uri:n.uri}}async k(n,a,c){const h=new A.$HJ(this.d,n),i=[],s={report:m=>{if(!this.l(m))return;const f=n.folder.scheme===R.Schemas.file?(0,A.$IJ)(()=>this.f.readdir(g.$Fg(m.uri))):void 0,S=g.$Ig(n.folder,m.uri);if(S){const L=h.includedInQuery(S,$.$nc(S),f);(0,T.$Rg)(L)?i.push(L.then(v=>{v&&a(m)})):L&&a(m)}}},u=this.n(n),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,s,c);return i.length&&await Promise.all(i),d}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const a=(0,A.$GJ)(this.d.includePattern,n.includePattern),c=(0,A.$GJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:a,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$ehc=k;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(n,a){this.d&&(this.b!==a||!g.$zg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:n.uri,results:[]}),this.d.results.push(b(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$fhc=p;function b(t){return r(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function r(t){return!!t.preview}e.$ghc=r;class o{static{this.a=4e3}static{this.b=50}constructor(n,a){this.g=n,this.h=a,this.c=0,this.d=[],this.e=0}addItem(n,a){n&&this.j(n,a)}addItems(n,a){n&&this.k(n,a)}j(n,a){this.d.push(n),this.e+=a,this.l()}k(n,a){this.d=this.d.concat(n),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$hhc=o}),define(Pe[118],Re([1,0,6,3,4,283,17,57,14,2,288]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=void 0,e.$ihc=(0,C.$5h)("IExtHostSearch");let k=class{constructor(r,o,t){this.k=r,this.l=o,this.n=t,this.c=this.k.getProxy(T.$4K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$dhc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(r)),(0,E.$Rc)(()=>{this.g.delete(r),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(r,o){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(r)),(0,E.$Rc)(()=>{this.i.delete(r),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(r,o,t,n){const a=l(t),c=this.h.get(r);if(c)return this.j.fileSearch(a,c,h=>{this.c.$handleFileMatch(r,o,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,t){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,t,n){const a=this.e.get(r);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const c=l(t);return this.q(c,a).search(i=>this.c.$handleTextMatch(r,o,i),n)}$enableExtensionHostSearch(){}q(r,o){return new A.$ehc(r,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$jhc=k,e.$jhc=k=Je([He(0,R.$8M),He(1,$.$cgc),He(2,g.$mj)],k);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(r=>w.URI.revive(r))}}e.$khc=l;function p(b){return{...b,folder:w.URI.revive(b.folder)}}}),define(Pe[289],Re([1,0,20,15,5,6,12,31,2,146,142,130,93,22,42,14,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,117,110,241,242,243,219,244,61,62,246,38,247,63,248,43,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,112,259,223,260,261,17,262,118,84,263,264,265,85,86,115,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,111,36,207,79,23,114]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m,f,S,L,v,y,D,N,O,G,W,U,P,I,K,ae,he,be,De,le,ve,se,we,ne,Z,V,ie,Ie,Ae,Ce,ce,te,Q,ee,me,pe,Le,de,ye,F,q,H,z,X,x,Ee,Te,Ve,Ke,Ze,st,nt,tt,at,ct,je,vt,Y,_,$e,Be,Qe,it,rt,Ne,Pt,Tt,Kt,Bt,yt,Ht,Nt,Xt,Ut,Rt,Ye,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;function Jt(lt){const $t=lt.get(Z.$lN),jt=lt.get(ne.$Wfc),Vt=lt.get(se.$kgc),Dt=lt.get(le.$Tgc),dt=lt.get(Xt.$fgc),Ct=lt.get(je.$pN),xt=lt.get(N.$igc),kt=lt.get(Tt.$cgc),qe=lt.get(Ee.$8M),Mt=lt.get(tt.$Dgc),Wt=lt.get(at.$lgc),Qt=lt.get(r.$nj),ft=lt.get(r.$mj),Ft=lt.get(it.$iyb),Se=lt.get(i.$Zfc),Fe=lt.get(Nt.$Yhc),fe=lt.get(Ke.$Lgc),J=lt.get(be.$ugc),Me=lt.get(Q.$Pgc);qe.set(a.$5K.ExtHostFileSystemInfo,jt),qe.set(a.$5K.ExtHostLogLevelServiceShape,Qt),qe.set(a.$5K.ExtHostWorkspace,dt),qe.set(a.$5K.ExtHostConfiguration,xt),qe.set(a.$5K.ExtHostExtensionService,Dt),qe.set(a.$5K.ExtHostStorage,Mt),qe.set(a.$5K.ExtHostTunnelService,Ft),qe.set(a.$5K.ExtHostWindow,Fe),qe.set(a.$5K.ExtHostSecretState,fe),qe.set(a.$5K.ExtHostTelemetry,Ct),qe.set(a.$5K.ExtHostEditorTabs,J),qe.set(a.$5K.ExtHostManagedSockets,Me);const ze=qe.set(a.$5K.ExtHostDecorations,lt.get(W.$5gc)),Xe=qe.set(a.$5K.ExtHostDocumentsAndEditors,lt.get(he.$gN)),We=qe.set(a.$5K.ExtHostCommands,lt.get(y.$rN)),_e=qe.set(a.$5K.ExtHostTerminalService,lt.get(vt.$Ggc)),mt=qe.set(a.$5K.ExtHostDebugService,lt.get(G.$Ygc)),zt=qe.set(a.$5K.ExtHostSearch,lt.get(Ve.$ihc)),Et=qe.set(a.$5K.ExtHostTask,lt.get(ct.$Lhc)),St=qe.set(a.$5K.ExtHostOutputService,lt.get(q.$yhc)),wt=qe.set(a.$5K.ExtHostLocalization,lt.get(te.$Ogc)),gi=qe.set(a.$5K.ExtHostUrls,new Kt.$Vhc(qe)),At=qe.set(a.$5K.ExtHostDocuments,new ae.$Ufc(qe,Xe)),Si=qe.set(a.$5K.ExtHostDocumentContentProviders,new I.$7gc(qe,Xe,ft)),Gi=qe.set(a.$5K.ExtHostDocumentSaveParticipant,new K.$8gc(ft,At,qe.getProxy(a.$4K.MainThreadBulkEdits))),It=qe.set(a.$5K.ExtHostNotebook,new me.$lhc(qe,We,Xe,At,Vt,zt)),ri=qe.set(a.$5K.ExtHostNotebookDocuments,new Le.$shc(It)),mi=qe.set(a.$5K.ExtHostNotebookEditors,new de.$thc(ft,It)),ci=qe.set(a.$5K.ExtHostNotebookKernels,new ye.$uhc(qe,$t,It,We,ft)),Ii=qe.set(a.$5K.ExtHostNotebookRenderers,new F.$whc(qe,It)),Ci=qe.set(a.$5K.ExtHostNotebookDocumentSaveParticipant,new pe.$rhc(ft,It,qe.getProxy(a.$4K.MainThreadBulkEdits))),Ot=qe.set(a.$5K.ExtHostEditors,new _.$_fc(qe,Xe)),$i=qe.set(a.$5K.ExtHostTreeViews,new Qe.$Thc(qe.getProxy(a.$4K.MainThreadTreeViews),We,ft)),Pi=qe.set(a.$5K.ExtHostEditorInsets,new v.$agc(qe.getProxy(a.$4K.MainThreadEditorInsets),Ot,$t.remote)),ui=qe.set(a.$5K.ExtHostDiagnostics,new U.$Yfc(qe,ft,jt,Xe)),li=qe.set(a.$5K.ExtHostLanguages,new ce.$phc(qe,At,We.converter,kt)),ht=qe.set(a.$5K.ExtHostLanguageFeatures,new Ce.$3fc(qe,kt,At,We,ui,ft,Se,Ct)),Ji=qe.set(a.$5K.ExtHostFileSystem,new ve.$0gc(qe,ht)),_t=qe.set(a.$5K.ExtHostFileSystemEventService,new we.$$gc(qe,ft,Xe)),si=qe.set(a.$5K.ExtHostQuickOpen,(0,x.$Chc)(qe,dt,We)),pi=qe.set(a.$5K.ExtHostSCM,new Te.$Ehc(qe,We,At,ft)),Ri=qe.set(a.$5K.ExtHostQuickDiff,new X.$Bhc(qe,kt)),Qi=qe.set(a.$5K.ExtHostShare,new Ze.$Fhc(qe,kt)),Ai=qe.set(a.$5K.ExtHostComments,(0,D.$bgc)(qe,We,At)),vi=qe.set(a.$5K.ExtHostProgress,new z.$Ahc(qe.getProxy(a.$4K.MainThreadProgress))),Xi=qe.set(a.$5K.ExtHostLabelService,new Ae.$ohc(qe)),Li=qe.set(a.$5K.ExtHostTheming,new $e.$Qhc(qe)),hi=qe.set(a.$5K.ExtHostAuthentication,new s.$5fc(qe)),Zi=qe.set(a.$5K.ExtHostTimeline,new Be.$Shc(qe,We)),bi=qe.set(a.$5K.ExtHostWebviews,new Bt.$pgc(qe,$t.remote,dt,ft,Se)),Mi=qe.set(a.$5K.ExtHostWebviewPanels,new yt.$sgc(qe,bi,dt)),un=qe.set(a.$5K.ExtHostCustomEditors,new O.$tgc(qe,At,Wt,bi,Mi)),Fi=qe.set(a.$5K.ExtHostWebviewViews,new Ht.$Whc(qe,bi)),oi=qe.set(a.$5K.ExtHostTesting,new Y.$Mhc(qe,ft,We,Xe)),ln=qe.set(a.$5K.ExtHostUriOpeners,new Pt.$Uhc(qe)),hn=qe.set(a.$5K.ExtHostProfileContentHandlers,new H.$zhc(qe));qe.set(a.$5K.ExtHostInteractive,new ie.$mhc(qe,It,Xe,We,ft));const Yi=qe.set(a.$5K.ExtHostInlineChat,new V.$_gc(qe,We,At,ft)),di=qe.set(a.$5K.ExtHostChatProvider,new f.$8fc(qe,ft)),xi=qe.set(a.$5K.ExtHostChatAgents2,new m.$9fc(qe,di,ft)),_i=qe.set(a.$5K.ExtHostChatVariables,new S.$0fc(qe)),wi=qe.set(a.$5K.ExtHostChat,new d.$7fc(qe)),en=qe.set(a.$5K.ExtHostAiRelatedInformation,new c.$Tfc(qe)),Ti=qe.set(a.$5K.ExtHostAiEmbeddingVector,new De.$9gc(qe)),Ni=qe.set(a.$5K.ExtHostIssueReporter,new Ie.$nhc(qe)),ei=qe.set(a.$5K.ExtHostStatusBar,new nt.$Ihc(qe,We.converter)),yi=qe.set(a.$5K.ExtHostSpeech,new st.$Ghc(qe)),dn=Object.values(a.$5K);qe.assertRegistered(dn);const Zt=new u.$6fc(qe,Xe),Ei=new L.$$fc(qe),Di=new ee.$qhc(qe,ft),Oi=new P.$6gc(qe);return h.$4fc.register(We),function(Ue,ti,tn){function et(re){return(ue,Oe,ot)=>{const bt=re(Lt=>{try{ue.call(Oe,Lt)}catch(cn){T.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event`,{cause:cn})),Ct.onExtensionError(Ue.identifier,cn)}});return ot?.push(bt),bt}}const pt=function(){let re=!Ue.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ue();else{const bt=ot;typeof bt.scheme>"u"&&ue(),typeof bt.exclusive=="boolean"&&(0,Ye.$BF)(Ue,"documentFiltersExclusive")}return ot}}(),fn={getSession(re,ue,Oe){return hi.getSession(Ue,re,ue,Oe)},getSessions(re,ue){return(0,Ye.$BF)(Ue,"authGetSessions"),hi.getSessions(Ue,re,ue)},async hasSession(re,ue){return(0,Ye.$BF)(Ue,"authSession"),!!await hi.getSession(Ue,re,ue,{silent:!0})},get onDidChangeSessions(){return et(hi.onDidChangeSessions)},registerAuthenticationProvider(re,ue,Oe,ot){return hi.registerAuthenticationProvider(re,ue,Oe,ot)}},gn={registerCommand(re,ue,Oe){return We.registerCommand(!0,re,ue,Oe,void 0,Ue)},registerTextEditorCommand(re,ue,Oe){return We.registerCommand(!0,re,(...ot)=>{const bt=Ot.getActiveTextEditor();if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return bt.edit(Lt=>{ue.apply(Oe,[bt,Lt,...ot])}).then(Lt=>{Lt||ft.warn("Edits from command "+re+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+re,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ye.$BF)(Ue,"diffCommand"),We.registerCommand(!0,re,async(...ot)=>{const bt=Xe.activeEditor(!0);if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(bt.id);ue.apply(Oe,[Lt,...ot])},void 0,void 0,Ue)),executeCommand(re,...ue){return We.executeCommand(re,...ue)},getCommands(re=!1){return We.getCommands(re)}},Ui={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return et(_e.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$BF)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$BF)(Ue,"telemetry"),et(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,je.$oN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return je.$nN.validateSender(re),Ct.instantiateLogger(Ue,re,ue)},openExternal(re,ue){return Fe.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return gi.createAppUri(re);try{return await Fe.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(ue){if((0,R.$dg)(re,R.Schemas.http)||(0,R.$dg)(re,R.Schemas.https))return re;throw ue}},get remoteName(){return(0,o.$al)($t.remote.authority)},get remoteAuthority(){return(0,Ye.$BF)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return et(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Ye.$BF)(Ue,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Ue,re)},registerIssueDataProvider(re){return(0,Ye.$BF)(Ue,"handleIssueUri"),Ni.registerIssueDataProvider(Ue,re)},get appQuality(){return(0,Ye.$BF)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,Ye.$BF)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ui);const ji={createTestController(re,ue,Oe){return oi.createTestController(Ue,re,ue,Oe)},createTestObserver(){return(0,Ye.$BF)(Ue,"testObserver"),oi.createTestObserver()},runTests(re){return(0,Ye.$BF)(Ue,"testObserver"),oi.runTests(re)},get onDidChangeTestResults(){return(0,Ye.$BF)(Ue,"testObserver"),et(oi.onResultsChanged)},get testResults(){return(0,Ye.$BF)(Ue,"testObserver"),oi.results}},fi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,nn={getExtension(re,ue){(0,Ye.$AF)(Ue,"extensionsAny")||(ue=!1);const Oe=ti.mine.getExtensionDescription(re);if(Oe)return new le.$Ugc(Dt,Ue.identifier,Oe,fi,!1);if(ue){const ot=ti.all.getExtensionDescription(re);if(ot)return new le.$Ugc(Dt,Ue.identifier,ot,fi,!0)}},get all(){const re=[];for(const ue of ti.mine.getAllExtensionDescriptions())re.push(new le.$Ugc(Dt,Ue.identifier,ue,fi,!1));return re},get allAcrossExtensionHosts(){(0,Ye.$BF)(Ue,"extensionsAny");const re=new p.$lm(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const ot=!re.has(Oe.identifier);ue.push(new le.$Ugc(Dt,Ue.identifier,Oe,fi,ot))}return ue},get onDidChange(){return(0,Ye.$AF)(Ue,"extensionsAny")?et(C.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):et(ti.mine.onDidChange)}},rn={createDiagnosticCollection(re){return ui.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return et(ui.onDidChangeDiagnostics)},getDiagnostics:re=>ui.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,ue){return li.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,A.$At)(rt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return ht.registerCodeActionProvider(Ue,pt(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ye.$BF)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,pt(re),ue,Oe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(Ue,pt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(Ue,pt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(Ue,pt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(Ue,pt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(Ue,pt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(Ue,pt(re),ue,Ue.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(Ue,pt(re),ue,Ue.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(Ue,pt(re),ue,Ue.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(Ue,pt(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return ht.registerMultiDocumentHighlightProvider(Ue,pt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(Ue,pt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(Ue,pt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(Ue,pt(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return ht.registerDocumentSymbolProvider(Ue,pt(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(Ue,pt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(Ue,pt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...ot){return ht.registerOnTypeFormattingEditProvider(Ue,pt(re),ue,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentSemanticTokensProvider(Ue,pt(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(Ue,pt(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...ot){return typeof Oe=="object"?ht.registerSignatureHelpProvider(Ue,pt(re),ue,Oe):ht.registerSignatureHelpProvider(Ue,pt(re),ue,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(re,ue,...Oe){return ht.registerCompletionItemProvider(Ue,pt(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ye.$BF)(Ue,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$BF)(Ue,"inlineCompletionsAdditions"),Oe&&(0,Ye.$BF)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,pt(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(Ue,pt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(Ue,pt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(Ue,pt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(Ue,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(Ue,re,ue)},registerTypeHierarchyProvider(re,ue){return ht.registerTypeHierarchyProvider(Ue,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(Ue,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ye.$BF)(Ue,"tokenInformation"),li.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return ht.registerInlayHintsProvider(Ue,re,ue)},createLanguageStatusItem(re,ue){return li.createLanguageStatusItem(Ue,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return ht.registerDocumentOnDropEditProvider(Ue,re,ue,(0,Ye.$AF)(Ue,"dropMetadata")?Oe:void 0)}},mn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const ot=await(g.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,ue,Oe)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,ue,Oe){return et(Ot.onDidChangeActiveTextEditor)(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return et(Ot.onDidChangeVisibleTextEditors)(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return et(Ot.onDidChangeTextEditorSelection)(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return et(Ot.onDidChangeTextEditorOptions)(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return et(Ot.onDidChangeTextEditorVisibleRanges)(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return et(Ot.onDidChangeTextEditorViewColumn)(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return et(_e.onDidCloseTerminal)(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return et(_e.onDidOpenTerminal)(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return et(_e.onDidChangeActiveTerminal)(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ye.$BF)(Ue,"terminalDimensions"),et(_e.onDidChangeTerminalDimensions)(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return et(_e.onDidChangeTerminalState)(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ye.$BF)(Ue,"terminalDataWriteEvent"),et(_e.onDidWriteTerminalData)(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ye.$BF)(Ue,"terminalExecuteCommandEvent"),et(_e.onDidExecuteTerminalCommand)(re,ue,Oe)},get state(){return Fe.getState(Ue)},onDidChangeWindowState(re,ue,Oe){return et(Fe.onDidChangeWindowState)(re,ue,Oe)},showInformationMessage(re,...ue){return Di.showMessage(Ue,$.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return Di.showMessage(Ue,$.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return Di.showMessage(Ue,$.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return si.showQuickPick(Ue,re,ue,Oe)},showWorkspaceFolderPick(re){return si.showWorkspaceFolderPick(re)},showInputBox(re,ue){return si.showInput(re,ue)},showOpenDialog(re){return Oi.showOpenDialog(Ue,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let ot,bt,Lt;return typeof re=="string"?(ot=re,bt=ue,Lt=Oe):(bt=re,Lt=ue),ei.createStatusBarEntry(Ue,ot,bt,Lt)},setStatusBarMessage(re,ue){return ei.setStatusBarMessage(re,ue)},withScmProgress(re){return Se.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),vi.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(ot){}}))},withProgress(re,ue){return vi.withProgress(Ue,re,ue)},createOutputChannel(re,ue){return St.createOutputChannel(re,ue,Ue)},createWebviewPanel(re,ue,Oe,ot){return Mi.createWebviewPanel(Ue,re,ue,Oe,ot)},createWebviewTextEditorInset(re,ue,Oe,ot){return(0,Ye.$BF)(Ue,"editorInsets"),Pi.createWebviewEditorInset(re,ue,Oe,ot,Ue)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(Ue,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ye.$BF)(Ue,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,Ue.identifier.value,ue)},registerTreeDataProvider(re,ue){return $i.registerTreeDataProvider(re,ue,Ue)},createTreeView(re,ue){return $i.createTreeView(re,ue,Ue)},registerWebviewPanelSerializer:(re,ue)=>Mi.registerWebviewPanelSerializer(Ue,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>un.registerCustomEditorProvider(Ue,re,ue,Oe),registerFileDecorationProvider(re){return ze.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return gi.registerUriHandler(Ue,re)},createQuickPick(){return si.createQuickPick(Ue)},createInputBox(){return si.createInputBox(Ue)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return et(Li.onDidChangeActiveColorTheme)(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Fi.registerWebviewViewProvider(Ue,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return et(It.onDidChangeActiveNotebookEditor)(re,ue,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,ue,Oe){return et(mi.onDidChangeNotebookEditorSelection)(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return et(mi.onDidChangeNotebookEditorVisibleRanges)(re,ue,Oe)},showNotebookDocument(re,ue){return It.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ye.$BF)(Ue,"externalUriOpener"),ln.registerExternalUriOpener(Ue.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ye.$BF)(Ue,"profileContentHandlers"),hn.registerProfileContentHandler(Ue,re,ue)},registerQuickDiffProvider(re,ue,Oe,ot){return(0,Ye.$BF)(Ue,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),ue,Oe,ot)},get tabGroups(){return J.tabGroups},registerShareProvider(re,ue){return(0,Ye.$BF)(Ue,"shareProvider"),Qi.registerShareProvider(pt(re),ue)}},sn={get rootPath(){return Se.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>dt.updateWorkspaceFolders(Ue,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return et(dt.onDidChangeWorkspace)(re,ue,Oe)},asRelativePath:(re,ue)=>dt.getRelativePath(re,ue),findFiles:(re,ue,Oe,ot)=>dt.findFiles(re,ue,Oe,Ue.identifier,ot),findTextInFiles:(re,ue,Oe,ot)=>{(0,Ye.$BF)(Ue,"findTextInFiles");let bt,Lt;return typeof ue=="object"?(bt=ue,Lt=Oe):(bt={},Lt=ue,ot=Oe),dt.findTextInFiles(re,bt||{},Lt,Ue.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,ue){return Zt.applyWorkspaceEdit(re,Ue,ue)},createFileSystemWatcher:(re,ue,Oe,ot)=>{let bt;return typeof ue=="boolean"?bt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,Ye.$BF)(Ue,"createFileSystemWatcher"),bt={...ue,correlate:!0}),_t.createFileSystemWatcher(dt,Ue,re,bt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>At.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(re,ue,Oe)=>et(At.onDidAddDocument)(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>et(At.onDidRemoveDocument)(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>et(At.onDidChangeDocument)(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>et(At.onDidSaveDocument)(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>et(Gi.getOnWillSaveTextDocumentEvent(Ue))(re,ue,Oe),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await It.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await It.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return et(ri.onDidSaveNotebookDocument)(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return et(ri.onDidChangeNotebookDocument)(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return et(Ci.getOnWillSaveNotebookDocumentEvent(Ue))(re,ue,Oe)},get onDidOpenNotebookDocument(){return et(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,ue,Oe,ot){return It.registerNotebookSerializer(Ue,re,ue,Oe,(0,Ye.$AF)(Ue,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>et(tn.onDidChangeConfiguration)(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,tn.getConfiguration(re,ue,Ue)},registerTextDocumentContentProvider(re,ue){return Si.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Se.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ue,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,M.$Qc)(Ji.registerFileSystemProvider(Ue,re,ue,Oe),Vt.addFileSystemProvider(re,ue,Oe))},get fs(){return Vt.value},registerFileSearchProvider:(re,ue)=>((0,Ye.$BF)(Ue,"fileSearchProvider"),zt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ye.$BF)(Ue,"textSearchProvider"),zt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ye.$BF)(Ue,"resolvers"),Dt.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ye.$BF)(Ue,"resolvers"),Xi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ye.$BF)(Ue,"resolvers"),Dt.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>et(_t.onDidCreateFile)(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>et(_t.onDidDeleteFile)(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>et(_t.onDidRenameFile)(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>et(_t.getOnWillCreateFileEvent(Ue))(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>et(_t.getOnWillDeleteFileEvent(Ue))(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>et(_t.getOnWillRenameFileEvent(Ue))(re,ue,Oe),openTunnel:re=>((0,Ye.$BF)(Ue,"tunnels"),Ft.openTunnel(Ue,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$BF)(Ue,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ye.$BF)(Ue,"tunnels"),et(Ft.onDidChangeTunnels)(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ye.$BF)(Ue,"portsAttributes"),Ft.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ye.$BF)(Ue,"tunnelFactory"),Ft.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ye.$BF)(Ue,"timeline"),Zi.registerTimelineProvider(re,ue,Ue.identifier,We.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ye.$BF)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>et(dt.onDidGrantWorkspaceTrust)(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ye.$BF)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ye.$BF)(Ue,"editSessionIdentityProvider"),et(dt.getOnWillCreateEditSessionIdentityEvent(Ue))(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ye.$BF)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ye.$BF)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(re,ue,Oe))},on={get inputBox(){return Se.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Ue)},createSourceControl(re,ue,Oe){return pi.createSourceControl(Ue,re,ue,Oe)}},an={createCommentController(re,ue){return Ai.createCommentController(Ue,re,ue)}},zi={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return et(mt.onDidStartDebugSession)(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return et(mt.onDidTerminateDebugSession)(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return et(mt.onDidChangeActiveDebugSession)(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return et(mt.onDidReceiveDebugSessionCustomEvent)(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return et(mt.onDidChangeBreakpoints)(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ye.$BF)(Ue,"debugFocus"),et(mt.onDidChangeStackFrameFocus)(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return mt.registerDebugConfigurationProvider(re,ue,Oe||Ut.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return mt.registerDebugAdapterDescriptorFactory(Ue,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return mt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(re,ue,{parentSession:Oe}):mt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return mt.asDebugSourceUri(re,ue)}},Bi={registerTaskProvider:(re,ue)=>Et.registerTaskProvider(Ue,re,ue),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(Ue,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,ue,Oe)=>et(Et.onDidStartTask)(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>et(Et.onDidEndTask)(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>et(Et.onDidStartTaskProcess)(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>et(Et.onDidEndTaskProcess)(re,ue,Oe)},Vi={createNotebookController(re,ue,Oe,ot,bt){return ci.createNotebookController(Ue,re,ue,Oe,ot,(0,Ye.$AF)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>It.registerNotebookCellStatusBarItemProvider(Ue,re,ue),createRendererMessaging(re){return Ii.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,Ye.$BF)(Ue,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,ue){return(0,Ye.$BF)(Ue,"notebookKernelSource"),ci.registerKernelSourceActionProvider(Ue,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ye.$BF)(Ue,"notebookCellExecutionState"),et(ci.onDidChangeNotebookCellExecutionState)(re,ue,Oe)}},ki={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return wt.getMessage(Ue.identifier.value,{message:ue,args:Oe})}return wt.getMessage(Ue.identifier.value,re[0])},get bundle(){return wt.getBundle(Ue.identifier.value)},get uri(){return wt.getBundleUri(Ue.identifier.value)}},Wi={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ye.$BF)(Ue,"interactive"),Yi.registerProvider(Ue,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ye.$BF)(Ue,"interactive"),wi.registerChatProvider(Ue,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ye.$BF)(Ue,"interactive"),wi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Ye.$BF)(Ue,"interactive"),wi.transferChatSession(re,ue)}},qi={getRelatedInformation(re,ue){return(0,Ye.$BF)(Ue,"aiRelatedInformation"),en.getRelatedInformation(Ue,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ye.$BF)(Ue,"aiRelatedInformation"),en.registerRelatedInformationProvider(Ue,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ye.$BF)(Ue,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Ue,re,ue)}},$n={registerChatResponseProvider(re,ue,Oe){return(0,Ye.$BF)(Ue,"chatProvider"),di.registerProvider(Ue.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ye.$BF)(Ue,"chatRequestAccess"),di.requestChatResponseProvider(Ue.identifier,re)},registerVariable(re,ue,Oe){return(0,Ye.$BF)(Ue,"chatVariables"),_i.registerVariableResolver(Ue,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ye.$BF)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,re,ue)},createChatAgent(re,ue){return(0,Ye.$BF)(Ue,"chatAgents2"),xi.createChatAgent(Ue,re,ue)}},pn={registerSpeechProvider(re,ue){return(0,Ye.$BF)(Ue,"speech"),yi.registerProvider(Ue.identifier,re,ue)}};return{version:$t.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:zi,env:Ui,extensions:nn,interactive:Wi,l10n:ki,languages:rn,notebooks:Vi,scm:on,speech:pn,tasks:Bi,tests:ji,window:mn,workspace:sn,Breakpoint:Ne.$5L,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$WM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$VM,CallHierarchyIncomingCall:Ne.$rL,CallHierarchyItem:Ne.$qL,CallHierarchyOutgoingCall:Ne.$sL,CancellationError:T.$5,CancellationTokenSource:E.$5d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$nL,CodeActionKind:Ne.$oL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$tL,Color:Ne.$GL,ColorInformation:Ne.$HL,ColorPresentation:Ne.$IL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$AL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$BL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$QL,DebugAdapterExecutable:Ne.$9L,DebugAdapterInlineImplementation:Ne.$_L,DebugAdapterNamedPipeServer:Ne.$$L,DebugAdapterServer:Ne.$0L,DebugConfigurationProviderTriggerKind:Ut.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$hL,DiagnosticRelatedInformation:Ne.$gL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$6K,DocumentHighlight:Ne.$jL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$kL,DocumentLink:Ne.$FL,DocumentSymbol:Ne.$mL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$cM,InlineValueText:Ne.$dM,InlineValueVariableLookup:Ne.$eM,InlineValueEvaluatableExpression:Ne.$fM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:C.$Ud,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$pM,FileDecoration2:Ne.$pM,FileSystemError:Ne.$hM,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Ne.$iM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$7L,InlineCompletionItem:Ne.$CL,InlineCompletionList:Ne.$DL,Hover:Ne.$iL,IndentAction:k.IndentAction,Location:Ne.$fL,MarkdownString:Ne.$uL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$vL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$7K,ProcessExecution:Ne.$OL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$oM,Range:Ne.$8K,RelativePattern:Ne.$3L,Selection:Ne.$9K,SelectionRange:Ne.$pL,SemanticTokens:Ne.$lM,SemanticTokensBuilder:Ne.$kM,SemanticTokensEdit:Ne.$mM,SemanticTokensEdits:Ne.$nM,SemanticTokensLegend:Ne.$jM,ShellExecution:Ne.$PL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$xL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$wL,SnippetString:Ne.$eL,SourceBreakpoint:Ne.$6L,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$lL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$RL,TaskGroup:Ne.$NL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$JL,TerminalQuickFixTerminalCommand:Ne.$LL,TerminalQuickFixOpener:Ne.$KL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$ML,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$aL,SnippetTextEdit:Ne.$cL,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$2L,ThemeIcon:Ne.$1L,TreeItem:Ne.$SL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$KM,UIKind:Rt.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$dL,DocumentDropEdit:Ne.$YL,DocumentPasteEdit:Ne.$ZL,InlayHint:Ne.$zL,InlayHintLabelPart:Ne.$yL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$_K,ResolvedAuthority:Ne.$0K,ManagedResolvedAuthority:Ne.$$K,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$zM,NotebookRange:Ne.$rM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$sM,NotebookData:Ne.$tM,NotebookRendererScript:Ne.$xM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$vM,NotebookCellOutputItem:Ne.$uM,NotebookCellStatusBarItem:Ne.$wM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$bL,NotebookKernelSourceAction:Ne.$yM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$BM,LinkedEditingRanges:Ne.$AM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$CM,TestMessage:Ne.$DM,TestMessage2:Ne.$DM,TestTag:Ne.$EM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Ne.$XL,DataTransferItem:Ne.$TL,CoveredCount:Ne.$FM,FileCoverage:Ne.$GM,StatementCoverage:Ne.$HM,BranchCoverage:Ne.$IM,FunctionCoverage:Ne.$JM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$LM,TabInputTextDiff:Ne.$MM,TabInputTextMerge:Ne.$NM,TabInputCustom:Ne.$OM,TabInputNotebook:Ne.$QM,TabInputNotebookDiff:Ne.$RM,TabInputWebview:Ne.$PM,TabInputTerminal:Ne.$SM,TabInputInteractiveWindow:Ne.$TM,TabInputChat:Ne.$UM,TelemetryTrustedValue:t.$Jo,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$aM,ThreadFocus:Ne.$bM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$Zhc=Jt}),define(Pe[290],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,255,14,116,82,83]),function(ge,e,E,T,C,M,R,$,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Xr)(d.$Ogc,d.$Ngc,1),(0,E.$Xr)(s.$nj,i.$1hc,1),(0,E.$Xr)(r.$Zfc,r.$1fc,1),(0,E.$Xr)($.$rN,$.$qN,0),(0,E.$Xr)(R.$igc,R.$ggc,0),(0,E.$Xr)(t.$kgc,t.$jgc,0),(0,E.$Xr)(k.$Ygc,k.$3gc,0),(0,E.$Xr)(M.$5gc,M.$4gc,0),(0,E.$Xr)(g.$gN,g.$fN,0),(0,E.$Xr)(m.$Pgc,m.$Qgc,0),(0,E.$Xr)(n.$Wfc,n.$Vfc,0),(0,E.$Xr)(T.$yhc,T.$xhc,1),(0,E.$Xr)(l.$ihc,l.$jhc,0),(0,E.$Xr)(p.$Dgc,p.$Cgc,0),(0,E.$Xr)(A.$Lhc,A.$Khc,0),(0,E.$Xr)(w.$Ggc,w.$Jgc,0),(0,E.$Xr)(b.$iyb,b.$jyb,0),(0,E.$Xr)(o.$Yhc,o.$Xhc,0),(0,E.$Xr)(C.$fgc,C.$egc,0),(0,E.$Xr)(a.$Lgc,a.$Kgc,0),(0,E.$Xr)(c.$pN,c.$mN,0),(0,E.$Xr)(h.$ugc,h.$vgc,0),(0,E.$Xr)(u.$Wgc,u.$Xgc,0)}),define(Pe[291],Re([1,0,289,38,2,286,7,13,274]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class w extends M.$4hc{j(){}getModule(p,b){for(const r of this.b){const o=r(p);if(o){p=o;break}}if(this.a.has(p))return this.a.get(p).load(p,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$Sgc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$$jc);const p=this.h.invokeFunction(E.$Zhc);this.r=this.h.createInstance(w,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,b,r){b=b.with({path:k(b.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=C.URI.revive(await this.C.$asBrowserUri(b)),n=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const a=await n.text(),c=`${b.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(m){throw console.error(o?`Loading code for extension ${o} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${b.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}p&&await this.w.initializeLocalizedMessages(p);const s={},u={exports:s},d=m=>{const f=this.r.getModule(m,b);if(f===void 0)throw new Error(`Cannot load module '${m}'`);return f};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(u,s,d),u.exports!==s?u.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+p;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,$.$6g)(10)}}e.$_jc=A;function k(l,p){return l.endsWith(p)?l:l+p}}),define(Pe[292],Re([1,0,69,70,14,38,199,86,291]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Xr)(C.$mj,new E.$2h(R.$3hc,[!0],!0)),(0,T.$Xr)(M.$Tgc,g.$_jc,0),(0,T.$Xr)($.$lgc,$.$mgc,0)}),define(Pe[297],Re([1,0,24,5,79,287,276,19,88,12,2,290,292]),function(ge,e,E,T,C,M,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const b=fetch.bind(self);function r(i){self.fetch=async function(s,u){return s instanceof Request||p(String(s))&&(s=(await i(A.URI.parse(String(s)))).toString(!0)),b(s,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,u,d,m,f){(async()=>(p(u.toString())&&(u=(await i(A.URI.parse(u.toString()))).toString(!0)),super.open(s,u,d??!0,m,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,u){if(/^file:/i.test(s.toString()))s=w.$ng.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const m=`(${function(v){function y(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const D=fetch.bind(self);self.fetch=function(O,G){return O instanceof Request?D(O,G):D(y(O),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,G,W,U,P){return super.open(O,y(G),W??!0,U,P)}};const N=importScripts.bind(self);self.importScripts=(...O)=>{N(...O.map(y))},N(v)}.toString()}('${s}'))`;u=u||{},u.name=u.name||$.$nc(s.toString());const f=new Blob([m],{type:"application/javascript"}),S=URL.createObjectURL(f);return new i(S,u)}}else self.Worker=class extends R.$akc{constructor(i,s){super(l,i,{name:$.$nc(i.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(i){k()}};class t{constructor(){const s=new MessageChannel,u=new T.$Ud;let d=!1;l(s.port2,[s.port2]),s.port1.onmessage=m=>{const{data:f}=m;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const S=E.$ie.wrap(new Uint8Array(f,0,f.byteLength));if((0,C.$tm)(S,2)){d=!0,a("received terminate message from renderer");return}u.fire(S)},this.protocol={onMessage:u.event,send:m=>{if(!d){const f=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(s=>{const u=i.onMessage(d=>{u.dispose();const m=JSON.parse(d.toString());i.send((0,C.$sm)(0)),s({protocol:i,initData:m})});i.send((0,C.$sm)(1))})}let a=i=>k();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&n(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new M.$6hc(u.protocol,u.initData,o,null,s.data);r(m=>d.asBrowserUri(m)),a=m=>d.terminate(m)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a45edfc415d19852fa3c3e1cd255a02de9e016d2/core/vs/workbench/api/worker/extensionHostWorker.js.map
